#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1160
#define LARGE_STATE_COUNT 166
#define SYMBOL_COUNT 148
#define ALIAS_COUNT 4
#define TOKEN_COUNT 67
#define EXTERNAL_TOKEN_COUNT 15
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 6

enum {
  sym__backslash_escape = 1,
  sym_entity_reference = 2,
  sym_numeric_character_reference = 3,
  anon_sym_LBRACK = 4,
  anon_sym_RBRACK = 5,
  anon_sym_LT = 6,
  anon_sym_GT = 7,
  anon_sym_BANG = 8,
  anon_sym_DQUOTE = 9,
  anon_sym_POUND = 10,
  anon_sym_DOLLAR = 11,
  anon_sym_PERCENT = 12,
  anon_sym_AMP = 13,
  anon_sym_SQUOTE = 14,
  anon_sym_STAR = 15,
  anon_sym_PLUS = 16,
  anon_sym_COMMA = 17,
  anon_sym_DASH = 18,
  anon_sym_DOT = 19,
  anon_sym_SLASH = 20,
  anon_sym_COLON = 21,
  anon_sym_SEMI = 22,
  anon_sym_EQ = 23,
  anon_sym_QMARK = 24,
  anon_sym_AT = 25,
  anon_sym_BSLASH = 26,
  anon_sym_CARET = 27,
  anon_sym__ = 28,
  anon_sym_BQUOTE = 29,
  anon_sym_LBRACE = 30,
  anon_sym_PIPE = 31,
  anon_sym_RBRACE = 32,
  anon_sym_TILDE = 33,
  anon_sym_LPAREN = 34,
  anon_sym_RPAREN = 35,
  sym__newline_token = 36,
  sym_uri_autolink = 37,
  sym_email_autolink = 38,
  sym__attribute_name = 39,
  aux_sym__attribute_value_token1 = 40,
  anon_sym_LT_BANG_DASH_DASH = 41,
  anon_sym_DASH_DASH_GT = 42,
  anon_sym_LT_QMARK = 43,
  anon_sym_QMARK_GT = 44,
  aux_sym__declaration_token1 = 45,
  anon_sym_LT_BANG_LBRACKCDATA_LBRACK = 46,
  anon_sym_RBRACK_RBRACK_GT = 47,
  sym__whitespace_ge_2 = 48,
  aux_sym__whitespace_token1 = 49,
  sym__word_no_digit = 50,
  sym__digits = 51,
  sym__error = 52,
  sym__trigger_error = 53,
  sym__code_span_start = 54,
  sym__code_span_close = 55,
  sym__emphasis_open_star = 56,
  sym__emphasis_open_underscore = 57,
  sym__emphasis_close_star = 58,
  sym__emphasis_close_underscore = 59,
  sym__last_token_whitespace = 60,
  sym__last_token_punctuation = 61,
  sym__strikethrough_open = 62,
  sym__strikethrough_close = 63,
  sym__latex_span_start = 64,
  sym__latex_span_close = 65,
  sym__unclosed_span = 66,
  sym_inline = 67,
  sym_backslash_escape = 68,
  sym_link_label = 69,
  sym_link_destination = 70,
  sym__link_destination_parenthesis = 71,
  sym__text_no_angle = 72,
  sym_link_title = 73,
  sym_code_span = 74,
  sym_latex_block = 75,
  sym__link_text = 76,
  sym__link_text_non_empty = 77,
  sym_shortcut_link = 78,
  sym_full_reference_link = 79,
  sym_collapsed_reference_link = 80,
  sym_inline_link = 81,
  sym_image = 82,
  sym__image_inline_link = 83,
  sym__image_shortcut_link = 84,
  sym__image_full_reference_link = 85,
  sym__image_collapsed_reference_link = 86,
  sym__image_description = 87,
  sym__image_description_non_empty = 88,
  sym__html_tag = 89,
  sym__open_tag = 90,
  sym__closing_tag = 91,
  sym__tag_name = 92,
  sym__attribute = 93,
  sym__attribute_value = 94,
  sym__html_comment = 95,
  sym__processing_instruction = 96,
  sym__declaration = 97,
  sym__cdata_section = 98,
  sym_hard_line_break = 99,
  sym__whitespace = 100,
  sym__word = 101,
  sym__soft_line_break = 102,
  sym__inline_base = 103,
  sym__text_base = 104,
  sym__text_inline_no_link = 105,
  sym__inline_element = 106,
  aux_sym__inline = 107,
  sym__inline_element_no_star = 108,
  aux_sym__inline_no_star = 109,
  sym__inline_element_no_underscore = 110,
  aux_sym__inline_no_underscore = 111,
  sym__inline_element_no_tilde = 112,
  aux_sym__inline_no_tilde = 113,
  sym__strikethrough = 114,
  sym__emphasis_star = 115,
  sym__strong_emphasis_star = 116,
  sym__emphasis_underscore = 117,
  sym__strong_emphasis_underscore = 118,
  sym__inline_element_no_link = 119,
  aux_sym__inline_no_link = 120,
  sym__inline_element_no_star_no_link = 121,
  aux_sym__inline_no_star_no_link = 122,
  sym__inline_element_no_underscore_no_link = 123,
  aux_sym__inline_no_underscore_no_link = 124,
  sym__inline_element_no_tilde_no_link = 125,
  aux_sym__inline_no_tilde_no_link = 126,
  sym__strikethrough_no_link = 127,
  sym__emphasis_star_no_link = 128,
  sym__strong_emphasis_star_no_link = 129,
  sym__emphasis_underscore_no_link = 130,
  sym__strong_emphasis_underscore_no_link = 131,
  aux_sym_link_label_repeat1 = 132,
  aux_sym_link_destination_repeat1 = 133,
  aux_sym_link_destination_repeat2 = 134,
  aux_sym_link_title_repeat1 = 135,
  aux_sym_link_title_repeat2 = 136,
  aux_sym_link_title_repeat3 = 137,
  aux_sym_code_span_repeat1 = 138,
  aux_sym_inline_link_repeat1 = 139,
  aux_sym__open_tag_repeat1 = 140,
  aux_sym__tag_name_repeat1 = 141,
  aux_sym__attribute_value_repeat1 = 142,
  aux_sym__attribute_value_repeat2 = 143,
  aux_sym__html_comment_repeat1 = 144,
  aux_sym__processing_instruction_repeat1 = 145,
  aux_sym__declaration_repeat1 = 146,
  aux_sym__inline_base_repeat1 = 147,
  alias_sym_emphasis = 148,
  alias_sym_html_tag = 149,
  alias_sym_image_description = 150,
  alias_sym_link_text = 151,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__backslash_escape] = "_backslash_escape",
  [sym_entity_reference] = "entity_reference",
  [sym_numeric_character_reference] = "numeric_character_reference",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_BANG] = "!",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_PERCENT] = "%",
  [anon_sym_AMP] = "&",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_STAR] = "*",
  [anon_sym_PLUS] = "+",
  [anon_sym_COMMA] = ",",
  [anon_sym_DASH] = "-",
  [anon_sym_DOT] = ".",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_QMARK] = "\?",
  [anon_sym_AT] = "@",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_CARET] = "^",
  [anon_sym__] = "_",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LBRACE] = "{",
  [anon_sym_PIPE] = "|",
  [anon_sym_RBRACE] = "}",
  [anon_sym_TILDE] = "~",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [sym__newline_token] = "_newline_token",
  [sym_uri_autolink] = "uri_autolink",
  [sym_email_autolink] = "email_autolink",
  [sym__attribute_name] = "_attribute_name",
  [aux_sym__attribute_value_token1] = "_attribute_value_token1",
  [anon_sym_LT_BANG_DASH_DASH] = "<!--",
  [anon_sym_DASH_DASH_GT] = "-->",
  [anon_sym_LT_QMARK] = "<\?",
  [anon_sym_QMARK_GT] = "\?>",
  [aux_sym__declaration_token1] = "_declaration_token1",
  [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = "<![CDATA[",
  [anon_sym_RBRACK_RBRACK_GT] = "]]>",
  [sym__whitespace_ge_2] = "_whitespace_ge_2",
  [aux_sym__whitespace_token1] = "_whitespace_token1",
  [sym__word_no_digit] = "_word_no_digit",
  [sym__digits] = "_digits",
  [sym__error] = "_error",
  [sym__trigger_error] = "_trigger_error",
  [sym__code_span_start] = "code_span_delimiter",
  [sym__code_span_close] = "code_span_delimiter",
  [sym__emphasis_open_star] = "_emphasis_open_star",
  [sym__emphasis_open_underscore] = "_emphasis_open_underscore",
  [sym__emphasis_close_star] = "emphasis_delimiter",
  [sym__emphasis_close_underscore] = "emphasis_delimiter",
  [sym__last_token_whitespace] = "_last_token_whitespace",
  [sym__last_token_punctuation] = "_last_token_punctuation",
  [sym__strikethrough_open] = "_strikethrough_open",
  [sym__strikethrough_close] = "emphasis_delimiter",
  [sym__latex_span_start] = "latex_span_delimiter",
  [sym__latex_span_close] = "latex_span_delimiter",
  [sym__unclosed_span] = "_unclosed_span",
  [sym_inline] = "inline",
  [sym_backslash_escape] = "backslash_escape",
  [sym_link_label] = "link_label",
  [sym_link_destination] = "link_destination",
  [sym__link_destination_parenthesis] = "_link_destination_parenthesis",
  [sym__text_no_angle] = "_text_no_angle",
  [sym_link_title] = "link_title",
  [sym_code_span] = "code_span",
  [sym_latex_block] = "latex_block",
  [sym__link_text] = "_link_text",
  [sym__link_text_non_empty] = "_link_text_non_empty",
  [sym_shortcut_link] = "shortcut_link",
  [sym_full_reference_link] = "full_reference_link",
  [sym_collapsed_reference_link] = "collapsed_reference_link",
  [sym_inline_link] = "inline_link",
  [sym_image] = "image",
  [sym__image_inline_link] = "_image_inline_link",
  [sym__image_shortcut_link] = "_image_shortcut_link",
  [sym__image_full_reference_link] = "_image_full_reference_link",
  [sym__image_collapsed_reference_link] = "_image_collapsed_reference_link",
  [sym__image_description] = "_image_description",
  [sym__image_description_non_empty] = "_image_description_non_empty",
  [sym__html_tag] = "_html_tag",
  [sym__open_tag] = "_open_tag",
  [sym__closing_tag] = "_closing_tag",
  [sym__tag_name] = "_tag_name",
  [sym__attribute] = "_attribute",
  [sym__attribute_value] = "_attribute_value",
  [sym__html_comment] = "_html_comment",
  [sym__processing_instruction] = "_processing_instruction",
  [sym__declaration] = "_declaration",
  [sym__cdata_section] = "_cdata_section",
  [sym_hard_line_break] = "hard_line_break",
  [sym__whitespace] = "_whitespace",
  [sym__word] = "_word",
  [sym__soft_line_break] = "_soft_line_break",
  [sym__inline_base] = "_inline_base",
  [sym__text_base] = "_text_base",
  [sym__text_inline_no_link] = "_text_inline_no_link",
  [sym__inline_element] = "_inline_element",
  [aux_sym__inline] = "_inline",
  [sym__inline_element_no_star] = "_inline_element_no_star",
  [aux_sym__inline_no_star] = "_inline_no_star",
  [sym__inline_element_no_underscore] = "_inline_element_no_underscore",
  [aux_sym__inline_no_underscore] = "_inline_no_underscore",
  [sym__inline_element_no_tilde] = "_inline_element_no_tilde",
  [aux_sym__inline_no_tilde] = "_inline_no_tilde",
  [sym__strikethrough] = "strikethrough",
  [sym__emphasis_star] = "_emphasis_star",
  [sym__strong_emphasis_star] = "strong_emphasis",
  [sym__emphasis_underscore] = "_emphasis_underscore",
  [sym__strong_emphasis_underscore] = "strong_emphasis",
  [sym__inline_element_no_link] = "_inline_element_no_link",
  [aux_sym__inline_no_link] = "_inline_no_link",
  [sym__inline_element_no_star_no_link] = "_inline_element_no_star_no_link",
  [aux_sym__inline_no_star_no_link] = "_inline_no_star_no_link",
  [sym__inline_element_no_underscore_no_link] = "_inline_element_no_underscore_no_link",
  [aux_sym__inline_no_underscore_no_link] = "_inline_no_underscore_no_link",
  [sym__inline_element_no_tilde_no_link] = "_inline_element_no_tilde_no_link",
  [aux_sym__inline_no_tilde_no_link] = "_inline_no_tilde_no_link",
  [sym__strikethrough_no_link] = "strikethrough",
  [sym__emphasis_star_no_link] = "_emphasis_star_no_link",
  [sym__strong_emphasis_star_no_link] = "strong_emphasis",
  [sym__emphasis_underscore_no_link] = "_emphasis_underscore_no_link",
  [sym__strong_emphasis_underscore_no_link] = "strong_emphasis",
  [aux_sym_link_label_repeat1] = "link_label_repeat1",
  [aux_sym_link_destination_repeat1] = "link_destination_repeat1",
  [aux_sym_link_destination_repeat2] = "link_destination_repeat2",
  [aux_sym_link_title_repeat1] = "link_title_repeat1",
  [aux_sym_link_title_repeat2] = "link_title_repeat2",
  [aux_sym_link_title_repeat3] = "link_title_repeat3",
  [aux_sym_code_span_repeat1] = "code_span_repeat1",
  [aux_sym_inline_link_repeat1] = "inline_link_repeat1",
  [aux_sym__open_tag_repeat1] = "_open_tag_repeat1",
  [aux_sym__tag_name_repeat1] = "_tag_name_repeat1",
  [aux_sym__attribute_value_repeat1] = "_attribute_value_repeat1",
  [aux_sym__attribute_value_repeat2] = "_attribute_value_repeat2",
  [aux_sym__html_comment_repeat1] = "_html_comment_repeat1",
  [aux_sym__processing_instruction_repeat1] = "_processing_instruction_repeat1",
  [aux_sym__declaration_repeat1] = "_declaration_repeat1",
  [aux_sym__inline_base_repeat1] = "_inline_base_repeat1",
  [alias_sym_emphasis] = "emphasis",
  [alias_sym_html_tag] = "html_tag",
  [alias_sym_image_description] = "image_description",
  [alias_sym_link_text] = "link_text",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__backslash_escape] = sym__backslash_escape,
  [sym_entity_reference] = sym_entity_reference,
  [sym_numeric_character_reference] = sym_numeric_character_reference,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym__] = anon_sym__,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [sym__newline_token] = sym__newline_token,
  [sym_uri_autolink] = sym_uri_autolink,
  [sym_email_autolink] = sym_email_autolink,
  [sym__attribute_name] = sym__attribute_name,
  [aux_sym__attribute_value_token1] = aux_sym__attribute_value_token1,
  [anon_sym_LT_BANG_DASH_DASH] = anon_sym_LT_BANG_DASH_DASH,
  [anon_sym_DASH_DASH_GT] = anon_sym_DASH_DASH_GT,
  [anon_sym_LT_QMARK] = anon_sym_LT_QMARK,
  [anon_sym_QMARK_GT] = anon_sym_QMARK_GT,
  [aux_sym__declaration_token1] = aux_sym__declaration_token1,
  [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
  [anon_sym_RBRACK_RBRACK_GT] = anon_sym_RBRACK_RBRACK_GT,
  [sym__whitespace_ge_2] = sym__whitespace_ge_2,
  [aux_sym__whitespace_token1] = aux_sym__whitespace_token1,
  [sym__word_no_digit] = sym__word_no_digit,
  [sym__digits] = sym__digits,
  [sym__error] = sym__error,
  [sym__trigger_error] = sym__trigger_error,
  [sym__code_span_start] = sym__code_span_start,
  [sym__code_span_close] = sym__code_span_start,
  [sym__emphasis_open_star] = sym__emphasis_open_star,
  [sym__emphasis_open_underscore] = sym__emphasis_open_underscore,
  [sym__emphasis_close_star] = sym__emphasis_close_star,
  [sym__emphasis_close_underscore] = sym__emphasis_close_star,
  [sym__last_token_whitespace] = sym__last_token_whitespace,
  [sym__last_token_punctuation] = sym__last_token_punctuation,
  [sym__strikethrough_open] = sym__strikethrough_open,
  [sym__strikethrough_close] = sym__emphasis_close_star,
  [sym__latex_span_start] = sym__latex_span_start,
  [sym__latex_span_close] = sym__latex_span_start,
  [sym__unclosed_span] = sym__unclosed_span,
  [sym_inline] = sym_inline,
  [sym_backslash_escape] = sym_backslash_escape,
  [sym_link_label] = sym_link_label,
  [sym_link_destination] = sym_link_destination,
  [sym__link_destination_parenthesis] = sym__link_destination_parenthesis,
  [sym__text_no_angle] = sym__text_no_angle,
  [sym_link_title] = sym_link_title,
  [sym_code_span] = sym_code_span,
  [sym_latex_block] = sym_latex_block,
  [sym__link_text] = sym__link_text,
  [sym__link_text_non_empty] = sym__link_text_non_empty,
  [sym_shortcut_link] = sym_shortcut_link,
  [sym_full_reference_link] = sym_full_reference_link,
  [sym_collapsed_reference_link] = sym_collapsed_reference_link,
  [sym_inline_link] = sym_inline_link,
  [sym_image] = sym_image,
  [sym__image_inline_link] = sym__image_inline_link,
  [sym__image_shortcut_link] = sym__image_shortcut_link,
  [sym__image_full_reference_link] = sym__image_full_reference_link,
  [sym__image_collapsed_reference_link] = sym__image_collapsed_reference_link,
  [sym__image_description] = sym__image_description,
  [sym__image_description_non_empty] = sym__image_description_non_empty,
  [sym__html_tag] = sym__html_tag,
  [sym__open_tag] = sym__open_tag,
  [sym__closing_tag] = sym__closing_tag,
  [sym__tag_name] = sym__tag_name,
  [sym__attribute] = sym__attribute,
  [sym__attribute_value] = sym__attribute_value,
  [sym__html_comment] = sym__html_comment,
  [sym__processing_instruction] = sym__processing_instruction,
  [sym__declaration] = sym__declaration,
  [sym__cdata_section] = sym__cdata_section,
  [sym_hard_line_break] = sym_hard_line_break,
  [sym__whitespace] = sym__whitespace,
  [sym__word] = sym__word,
  [sym__soft_line_break] = sym__soft_line_break,
  [sym__inline_base] = sym__inline_base,
  [sym__text_base] = sym__text_base,
  [sym__text_inline_no_link] = sym__text_inline_no_link,
  [sym__inline_element] = sym__inline_element,
  [aux_sym__inline] = aux_sym__inline,
  [sym__inline_element_no_star] = sym__inline_element_no_star,
  [aux_sym__inline_no_star] = aux_sym__inline_no_star,
  [sym__inline_element_no_underscore] = sym__inline_element_no_underscore,
  [aux_sym__inline_no_underscore] = aux_sym__inline_no_underscore,
  [sym__inline_element_no_tilde] = sym__inline_element_no_tilde,
  [aux_sym__inline_no_tilde] = aux_sym__inline_no_tilde,
  [sym__strikethrough] = sym__strikethrough,
  [sym__emphasis_star] = sym__emphasis_star,
  [sym__strong_emphasis_star] = sym__strong_emphasis_star,
  [sym__emphasis_underscore] = sym__emphasis_underscore,
  [sym__strong_emphasis_underscore] = sym__strong_emphasis_star,
  [sym__inline_element_no_link] = sym__inline_element_no_link,
  [aux_sym__inline_no_link] = aux_sym__inline_no_link,
  [sym__inline_element_no_star_no_link] = sym__inline_element_no_star_no_link,
  [aux_sym__inline_no_star_no_link] = aux_sym__inline_no_star_no_link,
  [sym__inline_element_no_underscore_no_link] = sym__inline_element_no_underscore_no_link,
  [aux_sym__inline_no_underscore_no_link] = aux_sym__inline_no_underscore_no_link,
  [sym__inline_element_no_tilde_no_link] = sym__inline_element_no_tilde_no_link,
  [aux_sym__inline_no_tilde_no_link] = aux_sym__inline_no_tilde_no_link,
  [sym__strikethrough_no_link] = sym__strikethrough,
  [sym__emphasis_star_no_link] = sym__emphasis_star_no_link,
  [sym__strong_emphasis_star_no_link] = sym__strong_emphasis_star,
  [sym__emphasis_underscore_no_link] = sym__emphasis_underscore_no_link,
  [sym__strong_emphasis_underscore_no_link] = sym__strong_emphasis_star,
  [aux_sym_link_label_repeat1] = aux_sym_link_label_repeat1,
  [aux_sym_link_destination_repeat1] = aux_sym_link_destination_repeat1,
  [aux_sym_link_destination_repeat2] = aux_sym_link_destination_repeat2,
  [aux_sym_link_title_repeat1] = aux_sym_link_title_repeat1,
  [aux_sym_link_title_repeat2] = aux_sym_link_title_repeat2,
  [aux_sym_link_title_repeat3] = aux_sym_link_title_repeat3,
  [aux_sym_code_span_repeat1] = aux_sym_code_span_repeat1,
  [aux_sym_inline_link_repeat1] = aux_sym_inline_link_repeat1,
  [aux_sym__open_tag_repeat1] = aux_sym__open_tag_repeat1,
  [aux_sym__tag_name_repeat1] = aux_sym__tag_name_repeat1,
  [aux_sym__attribute_value_repeat1] = aux_sym__attribute_value_repeat1,
  [aux_sym__attribute_value_repeat2] = aux_sym__attribute_value_repeat2,
  [aux_sym__html_comment_repeat1] = aux_sym__html_comment_repeat1,
  [aux_sym__processing_instruction_repeat1] = aux_sym__processing_instruction_repeat1,
  [aux_sym__declaration_repeat1] = aux_sym__declaration_repeat1,
  [aux_sym__inline_base_repeat1] = aux_sym__inline_base_repeat1,
  [alias_sym_emphasis] = alias_sym_emphasis,
  [alias_sym_html_tag] = alias_sym_html_tag,
  [alias_sym_image_description] = alias_sym_image_description,
  [alias_sym_link_text] = alias_sym_link_text,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__backslash_escape] = {
    .visible = false,
    .named = true,
  },
  [sym_entity_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_numeric_character_reference] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym__newline_token] = {
    .visible = false,
    .named = true,
  },
  [sym_uri_autolink] = {
    .visible = true,
    .named = true,
  },
  [sym_email_autolink] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_name] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__attribute_value_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LT_BANG_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__declaration_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__whitespace_ge_2] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__whitespace_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__word_no_digit] = {
    .visible = false,
    .named = true,
  },
  [sym__digits] = {
    .visible = false,
    .named = true,
  },
  [sym__error] = {
    .visible = false,
    .named = true,
  },
  [sym__trigger_error] = {
    .visible = false,
    .named = true,
  },
  [sym__code_span_start] = {
    .visible = true,
    .named = true,
  },
  [sym__code_span_close] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_open_star] = {
    .visible = false,
    .named = true,
  },
  [sym__emphasis_open_underscore] = {
    .visible = false,
    .named = true,
  },
  [sym__emphasis_close_star] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_close_underscore] = {
    .visible = true,
    .named = true,
  },
  [sym__last_token_whitespace] = {
    .visible = false,
    .named = true,
  },
  [sym__last_token_punctuation] = {
    .visible = false,
    .named = true,
  },
  [sym__strikethrough_open] = {
    .visible = false,
    .named = true,
  },
  [sym__strikethrough_close] = {
    .visible = true,
    .named = true,
  },
  [sym__latex_span_start] = {
    .visible = true,
    .named = true,
  },
  [sym__latex_span_close] = {
    .visible = true,
    .named = true,
  },
  [sym__unclosed_span] = {
    .visible = false,
    .named = true,
  },
  [sym_inline] = {
    .visible = true,
    .named = true,
  },
  [sym_backslash_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_link_label] = {
    .visible = true,
    .named = true,
  },
  [sym_link_destination] = {
    .visible = true,
    .named = true,
  },
  [sym__link_destination_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__text_no_angle] = {
    .visible = false,
    .named = true,
  },
  [sym_link_title] = {
    .visible = true,
    .named = true,
  },
  [sym_code_span] = {
    .visible = true,
    .named = true,
  },
  [sym_latex_block] = {
    .visible = true,
    .named = true,
  },
  [sym__link_text] = {
    .visible = false,
    .named = true,
  },
  [sym__link_text_non_empty] = {
    .visible = false,
    .named = true,
  },
  [sym_shortcut_link] = {
    .visible = true,
    .named = true,
  },
  [sym_full_reference_link] = {
    .visible = true,
    .named = true,
  },
  [sym_collapsed_reference_link] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_link] = {
    .visible = true,
    .named = true,
  },
  [sym_image] = {
    .visible = true,
    .named = true,
  },
  [sym__image_inline_link] = {
    .visible = false,
    .named = true,
  },
  [sym__image_shortcut_link] = {
    .visible = false,
    .named = true,
  },
  [sym__image_full_reference_link] = {
    .visible = false,
    .named = true,
  },
  [sym__image_collapsed_reference_link] = {
    .visible = false,
    .named = true,
  },
  [sym__image_description] = {
    .visible = false,
    .named = true,
  },
  [sym__image_description_non_empty] = {
    .visible = false,
    .named = true,
  },
  [sym__html_tag] = {
    .visible = false,
    .named = true,
  },
  [sym__open_tag] = {
    .visible = false,
    .named = true,
  },
  [sym__closing_tag] = {
    .visible = false,
    .named = true,
  },
  [sym__tag_name] = {
    .visible = false,
    .named = true,
  },
  [sym__attribute] = {
    .visible = false,
    .named = true,
  },
  [sym__attribute_value] = {
    .visible = false,
    .named = true,
  },
  [sym__html_comment] = {
    .visible = false,
    .named = true,
  },
  [sym__processing_instruction] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__cdata_section] = {
    .visible = false,
    .named = true,
  },
  [sym_hard_line_break] = {
    .visible = true,
    .named = true,
  },
  [sym__whitespace] = {
    .visible = false,
    .named = true,
  },
  [sym__word] = {
    .visible = false,
    .named = true,
  },
  [sym__soft_line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__inline_base] = {
    .visible = false,
    .named = true,
  },
  [sym__text_base] = {
    .visible = false,
    .named = true,
  },
  [sym__text_inline_no_link] = {
    .visible = false,
    .named = true,
  },
  [sym__inline_element] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_star] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_star] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_underscore] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_underscore] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_tilde] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_tilde] = {
    .visible = false,
    .named = false,
  },
  [sym__strikethrough] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_star] = {
    .visible = false,
    .named = true,
  },
  [sym__strong_emphasis_star] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_underscore] = {
    .visible = false,
    .named = true,
  },
  [sym__strong_emphasis_underscore] = {
    .visible = true,
    .named = true,
  },
  [sym__inline_element_no_link] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_link] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_star_no_link] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_star_no_link] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_underscore_no_link] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_underscore_no_link] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_tilde_no_link] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_tilde_no_link] = {
    .visible = false,
    .named = false,
  },
  [sym__strikethrough_no_link] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_star_no_link] = {
    .visible = false,
    .named = true,
  },
  [sym__strong_emphasis_star_no_link] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_underscore_no_link] = {
    .visible = false,
    .named = true,
  },
  [sym__strong_emphasis_underscore_no_link] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_link_label_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_destination_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_destination_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_title_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_title_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_title_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_code_span_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inline_link_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__open_tag_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__tag_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attribute_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attribute_value_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__html_comment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__processing_instruction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__inline_base_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_emphasis] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_html_tag] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_image_description] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_link_text] = {
    .visible = true,
    .named = true,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_html_tag,
  },
  [2] = {
    [0] = alias_sym_emphasis,
  },
  [3] = {
    [0] = sym__emphasis_close_star,
  },
  [4] = {
    [1] = alias_sym_link_text,
  },
  [5] = {
    [2] = alias_sym_image_description,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__html_tag, 2,
    sym__html_tag,
    alias_sym_html_tag,
  aux_sym__inline, 2,
    aux_sym__inline,
    alias_sym_image_description,
  sym__emphasis_star, 2,
    sym__emphasis_star,
    alias_sym_emphasis,
  sym__emphasis_underscore, 2,
    sym__emphasis_underscore,
    alias_sym_emphasis,
  aux_sym__inline_no_link, 2,
    aux_sym__inline_no_link,
    alias_sym_link_text,
  sym__emphasis_star_no_link, 2,
    sym__emphasis_star_no_link,
    alias_sym_emphasis,
  sym__emphasis_underscore_no_link, 2,
    sym__emphasis_underscore_no_link,
    alias_sym_emphasis,
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2201);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2208);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2184);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 1:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0 &&
          lookahead != '[') ADVANCE(2240);
      END_STATE();
    case 2:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 3:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2201);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 4:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2201);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 5:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2208);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 6:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2184);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 7:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 8:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2208);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 9:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2184);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 10:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 11:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead != 0 &&
          (lookahead < '<' || '>' < lookahead) &&
          lookahead != '`') ADVANCE(2226);
      END_STATE();
    case 12:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == ':' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2225);
      END_STATE();
    case 13:
      if (lookahead == '-') ADVANCE(14);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '[') ADVANCE(424);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(2233);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('.' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          lookahead == '?' ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 14:
      if (lookahead == '-') ADVANCE(2228);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('.' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 15:
      if (lookahead == '-') ADVANCE(137);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(136);
      END_STATE();
    case 16:
      if (lookahead == '-') ADVANCE(17);
      if (lookahead == '[') ADVANCE(424);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(2234);
      END_STATE();
    case 17:
      if (lookahead == '-') ADVANCE(2227);
      END_STATE();
    case 18:
      if (lookahead == '-') ADVANCE(2173);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 19:
      if (lookahead == '-') ADVANCE(2173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 20:
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(22);
      END_STATE();
    case 21:
      if (lookahead == '-') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == '-') ADVANCE(19);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(18);
      END_STATE();
    case 23:
      if (lookahead == '-') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(18);
      END_STATE();
    case 24:
      if (lookahead == '-') ADVANCE(27);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(26);
      END_STATE();
    case 25:
      if (lookahead == '-') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == '-') ADVANCE(21);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(20);
      END_STATE();
    case 27:
      if (lookahead == '-') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(20);
      END_STATE();
    case 28:
      if (lookahead == '-') ADVANCE(31);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(30);
      END_STATE();
    case 29:
      if (lookahead == '-') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == '-') ADVANCE(25);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(24);
      END_STATE();
    case 31:
      if (lookahead == '-') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(24);
      END_STATE();
    case 32:
      if (lookahead == '-') ADVANCE(35);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(34);
      END_STATE();
    case 33:
      if (lookahead == '-') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == '-') ADVANCE(29);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 35:
      if (lookahead == '-') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 36:
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(38);
      END_STATE();
    case 37:
      if (lookahead == '-') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(32);
      END_STATE();
    case 39:
      if (lookahead == '-') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(32);
      END_STATE();
    case 40:
      if (lookahead == '-') ADVANCE(43);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(42);
      END_STATE();
    case 41:
      if (lookahead == '-') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == '-') ADVANCE(37);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 43:
      if (lookahead == '-') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 44:
      if (lookahead == '-') ADVANCE(47);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(46);
      END_STATE();
    case 45:
      if (lookahead == '-') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(40);
      END_STATE();
    case 47:
      if (lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(40);
      END_STATE();
    case 48:
      if (lookahead == '-') ADVANCE(51);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      END_STATE();
    case 49:
      if (lookahead == '-') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(44);
      END_STATE();
    case 51:
      if (lookahead == '-') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(44);
      END_STATE();
    case 52:
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      END_STATE();
    case 53:
      if (lookahead == '-') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == '-') ADVANCE(49);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(48);
      END_STATE();
    case 55:
      if (lookahead == '-') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(48);
      END_STATE();
    case 56:
      if (lookahead == '-') ADVANCE(59);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(58);
      END_STATE();
    case 57:
      if (lookahead == '-') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == '-') ADVANCE(53);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(52);
      END_STATE();
    case 59:
      if (lookahead == '-') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(52);
      END_STATE();
    case 60:
      if (lookahead == '-') ADVANCE(63);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(62);
      END_STATE();
    case 61:
      if (lookahead == '-') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(62);
      END_STATE();
    case 62:
      if (lookahead == '-') ADVANCE(57);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      END_STATE();
    case 63:
      if (lookahead == '-') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      END_STATE();
    case 64:
      if (lookahead == '-') ADVANCE(67);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(66);
      END_STATE();
    case 65:
      if (lookahead == '-') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == '-') ADVANCE(61);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(60);
      END_STATE();
    case 67:
      if (lookahead == '-') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(60);
      END_STATE();
    case 68:
      if (lookahead == '-') ADVANCE(71);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(70);
      END_STATE();
    case 69:
      if (lookahead == '-') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(70);
      END_STATE();
    case 70:
      if (lookahead == '-') ADVANCE(65);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(64);
      END_STATE();
    case 71:
      if (lookahead == '-') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(64);
      END_STATE();
    case 72:
      if (lookahead == '-') ADVANCE(75);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(74);
      END_STATE();
    case 73:
      if (lookahead == '-') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(74);
      END_STATE();
    case 74:
      if (lookahead == '-') ADVANCE(69);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 75:
      if (lookahead == '-') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 76:
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 77:
      if (lookahead == '-') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead == '-') ADVANCE(73);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(72);
      END_STATE();
    case 79:
      if (lookahead == '-') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(72);
      END_STATE();
    case 80:
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(82);
      END_STATE();
    case 81:
      if (lookahead == '-') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(82);
      END_STATE();
    case 82:
      if (lookahead == '-') ADVANCE(77);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(76);
      END_STATE();
    case 83:
      if (lookahead == '-') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(76);
      END_STATE();
    case 84:
      if (lookahead == '-') ADVANCE(87);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(86);
      END_STATE();
    case 85:
      if (lookahead == '-') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(86);
      END_STATE();
    case 86:
      if (lookahead == '-') ADVANCE(81);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(80);
      END_STATE();
    case 87:
      if (lookahead == '-') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(80);
      END_STATE();
    case 88:
      if (lookahead == '-') ADVANCE(91);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(90);
      END_STATE();
    case 89:
      if (lookahead == '-') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(90);
      END_STATE();
    case 90:
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(84);
      END_STATE();
    case 91:
      if (lookahead == '-') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(84);
      END_STATE();
    case 92:
      if (lookahead == '-') ADVANCE(95);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(94);
      END_STATE();
    case 93:
      if (lookahead == '-') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(94);
      END_STATE();
    case 94:
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(88);
      END_STATE();
    case 95:
      if (lookahead == '-') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(88);
      END_STATE();
    case 96:
      if (lookahead == '-') ADVANCE(99);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      END_STATE();
    case 97:
      if (lookahead == '-') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 99:
      if (lookahead == '-') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 100:
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(102);
      END_STATE();
    case 101:
      if (lookahead == '-') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 103:
      if (lookahead == '-') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 104:
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(106);
      END_STATE();
    case 105:
      if (lookahead == '-') ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(100);
      END_STATE();
    case 107:
      if (lookahead == '-') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(100);
      END_STATE();
    case 108:
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 109:
      if (lookahead == '-') ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 110:
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 111:
      if (lookahead == '-') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 112:
      if (lookahead == '-') ADVANCE(115);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(114);
      END_STATE();
    case 113:
      if (lookahead == '-') ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(114);
      END_STATE();
    case 114:
      if (lookahead == '-') ADVANCE(109);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      END_STATE();
    case 115:
      if (lookahead == '-') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      END_STATE();
    case 116:
      if (lookahead == '-') ADVANCE(119);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(118);
      END_STATE();
    case 117:
      if (lookahead == '-') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == '-') ADVANCE(113);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(112);
      END_STATE();
    case 119:
      if (lookahead == '-') ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(112);
      END_STATE();
    case 120:
      if (lookahead == '-') ADVANCE(123);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 121:
      if (lookahead == '-') ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 122:
      if (lookahead == '-') ADVANCE(117);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(116);
      END_STATE();
    case 123:
      if (lookahead == '-') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(116);
      END_STATE();
    case 124:
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 125:
      if (lookahead == '-') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 126:
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 127:
      if (lookahead == '-') ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 128:
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 129:
      if (lookahead == '-') ADVANCE(131);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == '-') ADVANCE(125);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(124);
      END_STATE();
    case 131:
      if (lookahead == '-') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(124);
      END_STATE();
    case 132:
      if (lookahead == '-') ADVANCE(135);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(134);
      END_STATE();
    case 133:
      if (lookahead == '-') ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(134);
      END_STATE();
    case 134:
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 135:
      if (lookahead == '-') ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 136:
      if (lookahead == '-') ADVANCE(133);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(132);
      END_STATE();
    case 137:
      if (lookahead == '-') ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(132);
      END_STATE();
    case 138:
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      END_STATE();
    case 139:
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 140:
      if (lookahead == '1') ADVANCE(2147);
      if (lookahead == '3') ADVANCE(143);
      END_STATE();
    case 141:
      if (lookahead == '1') ADVANCE(2162);
      if (lookahead == ';') ADVANCE(2180);
      END_STATE();
    case 142:
      if (lookahead == '1') ADVANCE(2169);
      if (lookahead == '2') ADVANCE(2148);
      if (lookahead == '3') ADVANCE(2165);
      if (lookahead == '4') ADVANCE(145);
      if (lookahead == '5') ADVANCE(2149);
      if (lookahead == '7') ADVANCE(146);
      END_STATE();
    case 143:
      if (lookahead == '4') ADVANCE(148);
      END_STATE();
    case 144:
      if (lookahead == '4') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(1659);
      END_STATE();
    case 145:
      if (lookahead == '5') ADVANCE(148);
      END_STATE();
    case 146:
      if (lookahead == '8') ADVANCE(148);
      END_STATE();
    case 147:
      if (lookahead == ':') ADVANCE(381);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == '=' ||
          lookahead == '?' ||
          ('^' <= lookahead && lookahead <= '`') ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(383);
      if (lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(147);
      END_STATE();
    case 148:
      if (lookahead == ';') ADVANCE(2180);
      END_STATE();
    case 149:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'A') ADVANCE(585);
      if (lookahead == 'B') ADVANCE(575);
      if (lookahead == 'E') ADVANCE(271);
      if (lookahead == 'H') ADVANCE(538);
      if (lookahead == 'a') ADVANCE(810);
      if (lookahead == 'b') ADVANCE(576);
      if (lookahead == 'c') ADVANCE(602);
      if (lookahead == 'd') ADVANCE(794);
      if (lookahead == 'e') ADVANCE(268);
      if (lookahead == 'f') ADVANCE(1252);
      if (lookahead == 'g') ADVANCE(163);
      if (lookahead == 'h') ADVANCE(620);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'l') ADVANCE(197);
      if (lookahead == 'm') ADVANCE(1235);
      if (lookahead == 'n') ADVANCE(457);
      if (lookahead == 'o') ADVANCE(546);
      if (lookahead == 'p') ADVANCE(624);
      if (lookahead == 'r') ADVANCE(579);
      if (lookahead == 's') ADVANCE(526);
      if (lookahead == 't') ADVANCE(223);
      if (lookahead == 'u') ADVANCE(1769);
      if (lookahead == 'v') ADVANCE(1062);
      END_STATE();
    case 150:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1753);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'q') ADVANCE(2070);
      if (lookahead == 's') ADVANCE(967);
      if (lookahead == 'x') ADVANCE(1294);
      END_STATE();
    case 151:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'A') ADVANCE(1872);
      END_STATE();
    case 152:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'V') ADVANCE(1063);
      END_STATE();
    case 153:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      END_STATE();
    case 154:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'D') ADVANCE(1643);
      END_STATE();
    case 155:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 156:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'L') ADVANCE(1065);
      END_STATE();
    case 157:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'R') ADVANCE(1316);
      END_STATE();
    case 158:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'U') ADVANCE(1687);
      END_STATE();
    case 159:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'C') ADVANCE(1654);
      if (lookahead == 'D') ADVANCE(1628);
      if (lookahead == 'E') ADVANCE(1363);
      if (lookahead == 'G') ADVANCE(1888);
      if (lookahead == 'H') ADVANCE(2081);
      if (lookahead == 'L') ADVANCE(1037);
      if (lookahead == 'N') ADVANCE(1004);
      if (lookahead == 'P') ADVANCE(1849);
      if (lookahead == 'R') ADVANCE(1038);
      if (lookahead == 'S') ADVANCE(1732);
      if (lookahead == 'T') ADVANCE(1241);
      if (lookahead == 'V') ADVANCE(1077);
      END_STATE();
    case 160:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'C') ADVANCE(564);
      END_STATE();
    case 161:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 162:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'D') ADVANCE(438);
      END_STATE();
    case 163:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      END_STATE();
    case 164:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'c') ADVANCE(2059);
      if (lookahead == 'e') ADVANCE(222);
      if (lookahead == 'i') ADVANCE(1490);
      if (lookahead == 'n') ADVANCE(456);
      if (lookahead == 'o') ADVANCE(873);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 'u') ADVANCE(1800);
      END_STATE();
    case 165:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(233);
      if (lookahead == 'm') ADVANCE(2066);
      if (lookahead == 'n') ADVANCE(2150);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 'r') ADVANCE(575);
      if (lookahead == 's') ADVANCE(1017);
      END_STATE();
    case 166:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'v') ADVANCE(2166);
      END_STATE();
    case 167:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 168:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'i') ADVANCE(872);
      if (lookahead == 'o') ADVANCE(1894);
      if (lookahead == 'p') ADVANCE(1820);
      END_STATE();
    case 169:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(287);
      if (lookahead == 'a') ADVANCE(812);
      if (lookahead == 'b') ADVANCE(1740);
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(288);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(271);
      if (lookahead == 'i') ADVANCE(1475);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'l') ADVANCE(363);
      if (lookahead == 'n') ADVANCE(457);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'r') ADVANCE(529);
      if (lookahead == 's') ADVANCE(780);
      if (lookahead == 't') ADVANCE(224);
      if (lookahead == 'v') ADVANCE(1062);
      END_STATE();
    case 170:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 171:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'F') ADVANCE(2088);
      if (lookahead == 'G') ADVANCE(1881);
      if (lookahead == 'L') ADVANCE(963);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 172:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'F') ADVANCE(2088);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 173:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'G') ADVANCE(1881);
      if (lookahead == 'L') ADVANCE(963);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 174:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'S') ADVANCE(1449);
      END_STATE();
    case 175:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 176:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'G') ADVANCE(148);
      END_STATE();
    case 177:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'H') ADVANCE(148);
      END_STATE();
    case 178:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'I') ADVANCE(1571);
      if (lookahead == 'S') ADVANCE(2052);
      if (lookahead == 'U') ADVANCE(1552);
      END_STATE();
    case 179:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(811);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'e') ADVANCE(1094);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(248);
      if (lookahead == 'm') ADVANCE(1234);
      if (lookahead == 'o') ADVANCE(1519);
      if (lookahead == 's') ADVANCE(777);
      END_STATE();
    case 180:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'T' ||
          lookahead == 'g' ||
          lookahead == 't') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1491);
      if (lookahead == 'b') ADVANCE(1740);
      if (lookahead == 'c') ADVANCE(971);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'r') ADVANCE(989);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 181:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'L') ADVANCE(963);
      END_STATE();
    case 182:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'N') ADVANCE(148);
      END_STATE();
    case 183:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'P') ADVANCE(148);
      END_STATE();
    case 184:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'P') ADVANCE(1439);
      END_STATE();
    case 185:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'T') ADVANCE(148);
      END_STATE();
    case 186:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 187:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'Y') ADVANCE(148);
      END_STATE();
    case 188:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(775);
      if (lookahead == 'p') ADVANCE(1405);
      END_STATE();
    case 189:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1126);
      if (lookahead == 'o') ADVANCE(2004);
      END_STATE();
    case 190:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(2170);
      END_STATE();
    case 191:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 192:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1741);
      END_STATE();
    case 193:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(783);
      if (lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 194:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(293);
      if (lookahead == 's') ADVANCE(1247);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 195:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'b') ADVANCE(267);
      if (lookahead == 'c' ||
          lookahead == 'w') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(1894);
      if (lookahead == 'h') ADVANCE(1330);
      if (lookahead == 'l') ADVANCE(1668);
      if (lookahead == 'p') ADVANCE(1349);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(1349);
      END_STATE();
    case 196:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(841);
      if (lookahead == 'b' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'd') ADVANCE(2160);
      if (lookahead == 'm') ADVANCE(297);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(2112);
      END_STATE();
    case 197:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'c') ADVANCE(1640);
      if (lookahead == 'h') ADVANCE(639);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 198:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'd') ADVANCE(263);
      if (lookahead == 'i') ADVANCE(1128);
      if (lookahead == 'o') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(1404);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 199:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1894);
      END_STATE();
    case 200:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1905);
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'd') ADVANCE(1596);
      END_STATE();
    case 201:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1349);
      END_STATE();
    case 202:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 203:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1354);
      if (lookahead == 'c') ADVANCE(1949);
      if (lookahead == 'g') ADVANCE(148);
      END_STATE();
    case 204:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1494);
      if (lookahead == 'b') ADVANCE(1863);
      if (lookahead == 'c') ADVANCE(568);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 205:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1494);
      if (lookahead == 'd' ||
          lookahead == 'v') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1404);
      END_STATE();
    case 206:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(834);
      END_STATE();
    case 207:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1789);
      if (lookahead == 'c') ADVANCE(1181);
      if (lookahead == 'o') ADVANCE(1828);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 208:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1373);
      END_STATE();
    case 209:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1757);
      if (lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 210:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1703);
      if (lookahead == 'c') ADVANCE(2079);
      if (lookahead == 'e') ADVANCE(1723);
      if (lookahead == 'n') ADVANCE(661);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 211:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1254);
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 212:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1448);
      if (lookahead == 's') ADVANCE(1349);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 213:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(1589);
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'f') ADVANCE(306);
      END_STATE();
    case 214:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(148);
      if (lookahead == 'd') ADVANCE(343);
      END_STATE();
    case 215:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(148);
      if (lookahead == 'h') ADVANCE(1941);
      END_STATE();
    case 216:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(192);
      END_STATE();
    case 217:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(192);
      if (lookahead == 'd') ADVANCE(148);
      END_STATE();
    case 218:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(267);
      if (lookahead == 'f') ADVANCE(1894);
      if (lookahead == 'h') ADVANCE(1330);
      if (lookahead == 'l') ADVANCE(1668);
      if (lookahead == 'p') ADVANCE(1349);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(1349);
      END_STATE();
    case 219:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'e') ADVANCE(1723);
      END_STATE();
    case 220:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(1816);
      if (lookahead == 'c') ADVANCE(568);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'o') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 221:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(148);
      END_STATE();
    case 222:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(210);
      END_STATE();
    case 223:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(754);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'h') ADVANCE(1790);
      if (lookahead == 'i') ADVANCE(1488);
      if (lookahead == 'l') ADVANCE(575);
      if (lookahead == 'q') ADVANCE(2071);
      if (lookahead == 'r') ADVANCE(498);
      END_STATE();
    case 224:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(754);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'l') ADVANCE(497);
      if (lookahead == 'q') ADVANCE(2071);
      if (lookahead == 'r') ADVANCE(563);
      END_STATE();
    case 225:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(250);
      END_STATE();
    case 226:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(753);
      if (lookahead == 'd') ADVANCE(1633);
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 227:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(753);
      if (lookahead == 'd') ADVANCE(1634);
      if (lookahead == 'g') ADVANCE(258);
      if (lookahead == 's') ADVANCE(660);
      END_STATE();
    case 228:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(591);
      if (lookahead == 'e') ADVANCE(1159);
      if (lookahead == 'l') ADVANCE(646);
      if (lookahead == 'p') ADVANCE(1801);
      END_STATE();
    case 229:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'w') ADVANCE(148);
      END_STATE();
    case 230:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(2059);
      if (lookahead == 'e') ADVANCE(225);
      END_STATE();
    case 231:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(2059);
      if (lookahead == 'e' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 232:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(681);
      if (lookahead == 'f') ADVANCE(1269);
      if (lookahead == 'o') ADVANCE(867);
      if (lookahead == 't') ADVANCE(228);
      END_STATE();
    case 233:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1589);
      END_STATE();
    case 234:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(313);
      if (lookahead == 'g') ADVANCE(163);
      if (lookahead == 'l') ADVANCE(163);
      if (lookahead == 'n') ADVANCE(917);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 'r') ADVANCE(575);
      END_STATE();
    case 235:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(148);
      END_STATE();
    case 236:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(917);
      END_STATE();
    case 237:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1582);
      if (lookahead == 'l') ADVANCE(977);
      if (lookahead == 'r') ADVANCE(1277);
      END_STATE();
    case 238:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1582);
      if (lookahead == 'l') ADVANCE(977);
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 239:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1582);
      if (lookahead == 'l') ADVANCE(1070);
      if (lookahead == 'q') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1320);
      END_STATE();
    case 240:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1254);
      END_STATE();
    case 241:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 242:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(917);
      if (lookahead == 'm') ADVANCE(1924);
      if (lookahead == 'r') ADVANCE(1978);
      if (lookahead == 's') ADVANCE(1691);
      if (lookahead == 'z') ADVANCE(575);
      END_STATE();
    case 243:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1005);
      END_STATE();
    case 244:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1741);
      END_STATE();
    case 245:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1724);
      if (lookahead == 'm') ADVANCE(1306);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 's') ADVANCE(1738);
      END_STATE();
    case 246:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1949);
      END_STATE();
    case 247:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1152);
      END_STATE();
    case 248:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1097);
      END_STATE();
    case 249:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 250:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1723);
      END_STATE();
    case 251:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1723);
      if (lookahead == 'l') ADVANCE(937);
      END_STATE();
    case 252:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 253:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(843);
      if (lookahead == 'i') ADVANCE(1478);
      if (lookahead == 'o') ADVANCE(896);
      END_STATE();
    case 254:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 255:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1728);
      END_STATE();
    case 256:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1728);
      if (lookahead == 'n') ADVANCE(982);
      END_STATE();
    case 257:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(590);
      END_STATE();
    case 258:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1894);
      END_STATE();
    case 259:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1925);
      END_STATE();
    case 260:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1549);
      if (lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 261:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1826);
      if (lookahead == 's') ADVANCE(952);
      END_STATE();
    case 262:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1782);
      if (lookahead == 's') ADVANCE(1668);
      END_STATE();
    case 263:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1792);
      if (lookahead == 'f' ||
          lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 264:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1781);
      END_STATE();
    case 265:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 266:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1578);
      if (lookahead == 'y') ADVANCE(323);
      END_STATE();
    case 267:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(1894);
      END_STATE();
    case 268:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(1954);
      if (lookahead == 'g') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(314);
      if (lookahead == 's') ADVANCE(227);
      END_STATE();
    case 269:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(1495);
      if (lookahead == 'l') ADVANCE(938);
      END_STATE();
    case 270:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(1979);
      if (lookahead == 'q') ADVANCE(314);
      if (lookahead == 's') ADVANCE(322);
      END_STATE();
    case 271:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'g') ADVANCE(148);
      END_STATE();
    case 272:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'g') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(1970);
      if (lookahead == 'm') ADVANCE(1702);
      END_STATE();
    case 273:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'g') ADVANCE(1949);
      END_STATE();
    case 274:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'g') ADVANCE(917);
      END_STATE();
    case 275:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'h') ADVANCE(148);
      END_STATE();
    case 276:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'h') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(1620);
      END_STATE();
    case 277:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'h') ADVANCE(1579);
      END_STATE();
    case 278:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1227);
      if (lookahead == 'n') ADVANCE(1109);
      if (lookahead == 'o') ADVANCE(1970);
      END_STATE();
    case 279:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(891);
      if (lookahead == 'o') ADVANCE(1511);
      END_STATE();
    case 280:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 281:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1529);
      if (lookahead == 'p') ADVANCE(643);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 282:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(2008);
      END_STATE();
    case 283:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(856);
      END_STATE();
    case 284:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1503);
      if (lookahead == 'n') ADVANCE(1237);
      END_STATE();
    case 285:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1431);
      END_STATE();
    case 286:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1568);
      if (lookahead == 'l') ADVANCE(148);
      if (lookahead == 's') ADVANCE(233);
      END_STATE();
    case 287:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 288:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(314);
      if (lookahead == 's') ADVANCE(226);
      END_STATE();
    case 289:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(1949);
      END_STATE();
    case 290:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(1620);
      END_STATE();
    case 291:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(1620);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 292:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(2011);
      if (lookahead == 'm') ADVANCE(564);
      END_STATE();
    case 293:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(1390);
      END_STATE();
    case 294:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 295:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'm') ADVANCE(262);
      END_STATE();
    case 296:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'm') ADVANCE(597);
      END_STATE();
    case 297:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 298:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'n') ADVANCE(616);
      END_STATE();
    case 299:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 300:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(318);
      END_STATE();
    case 301:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(287);
      END_STATE();
    case 302:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(1087);
      END_STATE();
    case 303:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(2117);
      END_STATE();
    case 304:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(2107);
      END_STATE();
    case 305:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(841);
      END_STATE();
    case 306:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(1795);
      END_STATE();
    case 307:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(2024);
      END_STATE();
    case 308:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(1534);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 309:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(1559);
      END_STATE();
    case 310:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 311:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(284);
      END_STATE();
    case 312:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'p') ADVANCE(1820);
      END_STATE();
    case 313:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(148);
      END_STATE();
    case 314:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1434);
      END_STATE();
    case 315:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(314);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 316:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(313);
      END_STATE();
    case 317:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(2070);
      END_STATE();
    case 318:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 319:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'r') ADVANCE(556);
      if (lookahead == 's') ADVANCE(233);
      END_STATE();
    case 320:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'r') ADVANCE(1262);
      END_STATE();
    case 321:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'r') ADVANCE(1240);
      END_STATE();
    case 322:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 323:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(1741);
      END_STATE();
    case 324:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(235);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 325:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 326:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(2139);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 327:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(1454);
      END_STATE();
    case 328:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(1349);
      END_STATE();
    case 329:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(2012);
      END_STATE();
    case 330:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(952);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 331:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(1007);
      END_STATE();
    case 332:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(2074);
      END_STATE();
    case 333:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 334:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 335:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(1579);
      END_STATE();
    case 336:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 337:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(725);
      END_STATE();
    case 338:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(1349);
      END_STATE();
    case 339:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(823);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 340:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(670);
      END_STATE();
    case 341:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(1603);
      END_STATE();
    case 342:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(1262);
      END_STATE();
    case 343:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 344:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'u') ADVANCE(1232);
      END_STATE();
    case 345:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 346:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'v') ADVANCE(2166);
      END_STATE();
    case 347:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'v') ADVANCE(714);
      END_STATE();
    case 348:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'v') ADVANCE(1019);
      END_STATE();
    case 349:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(841);
      if (lookahead == 'i') ADVANCE(872);
      if (lookahead == 'o') ADVANCE(1894);
      if (lookahead == 'p') ADVANCE(1814);
      END_STATE();
    case 350:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 'c') ADVANCE(251);
      if (lookahead == 'f') ADVANCE(1557);
      if (lookahead == 'm') ADVANCE(1213);
      if (lookahead == 's') ADVANCE(841);
      END_STATE();
    case 351:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1020);
      END_STATE();
    case 352:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'v') ADVANCE(148);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 's') ADVANCE(345);
      END_STATE();
    case 353:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'y') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1669);
      if (lookahead == 'c') ADVANCE(2059);
      if (lookahead == 'e') ADVANCE(240);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'n') ADVANCE(456);
      if (lookahead == 'p') ADVANCE(1664);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 354:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a' ||
          lookahead == 'h') ADVANCE(148);
      END_STATE();
    case 355:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b' ||
          lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 356:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c' ||
          lookahead == 'w') ADVANCE(148);
      END_STATE();
    case 357:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e' ||
          lookahead == 'g') ADVANCE(148);
      END_STATE();
    case 358:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e' ||
          lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 359:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f' ||
          lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 360:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(917);
      END_STATE();
    case 361:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e' ||
          lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 362:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e' ||
          lookahead == 'f') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(2007);
      END_STATE();
    case 363:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'a' ||
          lookahead == 'j') ADVANCE(148);
      END_STATE();
    case 364:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'd' ||
          lookahead == 'y') ADVANCE(148);
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'u') ADVANCE(1985);
      END_STATE();
    case 365:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'D' ||
          lookahead == 'U' ||
          lookahead == 'd' ||
          lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 366:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'H' ||
          lookahead == 'L' ||
          lookahead == 'R' ||
          lookahead == 'h' ||
          lookahead == 'l' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 367:
      if (lookahead == ';') ADVANCE(2181);
      END_STATE();
    case 368:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(369);
      END_STATE();
    case 369:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(367);
      END_STATE();
    case 370:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(368);
      END_STATE();
    case 371:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(370);
      END_STATE();
    case 372:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(371);
      END_STATE();
    case 373:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(372);
      END_STATE();
    case 374:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(367);
      END_STATE();
    case 375:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(374);
      END_STATE();
    case 376:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(375);
      END_STATE();
    case 377:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(376);
      END_STATE();
    case 378:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(377);
      END_STATE();
    case 379:
      if (lookahead == '>') ADVANCE(2229);
      END_STATE();
    case 380:
      if (lookahead == '>') ADVANCE(2236);
      END_STATE();
    case 381:
      if (lookahead == '>') ADVANCE(2223);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '<') ADVANCE(381);
      END_STATE();
    case 382:
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == '=' ||
          lookahead == '?' ||
          ('^' <= lookahead && lookahead <= '`') ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(383);
      if (lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(147);
      END_STATE();
    case 383:
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 384:
      if (lookahead == 'A') ADVANCE(502);
      if (lookahead == 'a') ADVANCE(816);
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1368);
      if (lookahead == 'o') ADVANCE(1674);
      if (lookahead == 's') ADVANCE(790);
      if (lookahead == 'u') ADVANCE(1467);
      END_STATE();
    case 385:
      if (lookahead == 'A') ADVANCE(585);
      if (lookahead == 'B') ADVANCE(575);
      if (lookahead == 'H') ADVANCE(538);
      if (lookahead == 'a') ADVANCE(763);
      if (lookahead == 'b') ADVANCE(576);
      if (lookahead == 'c') ADVANCE(602);
      if (lookahead == 'd') ADVANCE(793);
      if (lookahead == 'e') ADVANCE(203);
      if (lookahead == 'f') ADVANCE(1252);
      if (lookahead == 'h') ADVANCE(621);
      if (lookahead == 'i') ADVANCE(1142);
      if (lookahead == 'l') ADVANCE(581);
      if (lookahead == 'm') ADVANCE(1652);
      if (lookahead == 'n') ADVANCE(1468);
      if (lookahead == 'o') ADVANCE(547);
      if (lookahead == 'p') ADVANCE(628);
      if (lookahead == 'r') ADVANCE(575);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 't') ADVANCE(1208);
      if (lookahead == 'u') ADVANCE(1394);
      if (lookahead == 'x') ADVANCE(148);
      END_STATE();
    case 386:
      if (lookahead == 'A') ADVANCE(520);
      END_STATE();
    case 387:
      if (lookahead == 'A') ADVANCE(745);
      if (lookahead == 'I') ADVANCE(745);
      if (lookahead == 'U') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(1476);
      END_STATE();
    case 388:
      if (lookahead == 'A') ADVANCE(441);
      END_STATE();
    case 389:
      if (lookahead == 'A') ADVANCE(1566);
      if (lookahead == 'C') ADVANCE(1079);
      if (lookahead == 'D') ADVANCE(1584);
      if (lookahead == 'F') ADVANCE(1393);
      if (lookahead == 'R') ADVANCE(1315);
      if (lookahead == 'T') ADVANCE(1024);
      if (lookahead == 'U') ADVANCE(1682);
      if (lookahead == 'V') ADVANCE(1058);
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 390:
      if (lookahead == 'A') ADVANCE(511);
      END_STATE();
    case 391:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'B') ADVANCE(631);
      if (lookahead == 'D') ADVANCE(571);
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'd') ADVANCE(571);
      if (lookahead == 'e') ADVANCE(930);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(2007);
      if (lookahead == 'n') ADVANCE(1923);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(1810);
      if (lookahead == 'r') ADVANCE(2007);
      if (lookahead == 's') ADVANCE(792);
      if (lookahead == 'z') ADVANCE(1255);
      END_STATE();
    case 392:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'd') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(270);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(321);
      END_STATE();
    case 393:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'H') ADVANCE(538);
      if (lookahead == 'a') ADVANCE(1125);
      if (lookahead == 'b') ADVANCE(1346);
      if (lookahead == 'c') ADVANCE(607);
      if (lookahead == 'd') ADVANCE(189);
      if (lookahead == 'e') ADVANCE(272);
      if (lookahead == 'f') ADVANCE(1253);
      if (lookahead == 'h') ADVANCE(614);
      if (lookahead == 'i') ADVANCE(586);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'l') ADVANCE(759);
      if (lookahead == 'o') ADVANCE(1397);
      if (lookahead == 'r') ADVANCE(721);
      if (lookahead == 's') ADVANCE(761);
      if (lookahead == 't') ADVANCE(871);
      if (lookahead == 'u') ADVANCE(580);
      if (lookahead == 'w') ADVANCE(589);
      if (lookahead == 'z') ADVANCE(750);
      END_STATE();
    case 394:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'H') ADVANCE(538);
      if (lookahead == 'a') ADVANCE(804);
      if (lookahead == 'b') ADVANCE(1763);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(577);
      if (lookahead == 'f') ADVANCE(1253);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'h') ADVANCE(615);
      if (lookahead == 'l') ADVANCE(852);
      if (lookahead == 'm') ADVANCE(191);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(686);
      if (lookahead == 'r') ADVANCE(851);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(868);
      if (lookahead == 'u') ADVANCE(582);
      if (lookahead == 'w') ADVANCE(589);
      END_STATE();
    case 395:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1268);
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'e') ADVANCE(668);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'k') ADVANCE(1895);
      if (lookahead == 'o') ADVANCE(583);
      if (lookahead == 's') ADVANCE(782);
      if (lookahead == 'y') ADVANCE(723);
      END_STATE();
    case 396:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1760);
      END_STATE();
    case 397:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'p') ADVANCE(538);
      END_STATE();
    case 398:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1753);
      if (lookahead == 'c') ADVANCE(333);
      if (lookahead == 'm') ADVANCE(1214);
      if (lookahead == 's') ADVANCE(2113);
      if (lookahead == 't') ADVANCE(1462);
      if (lookahead == 'x') ADVANCE(1949);
      END_STATE();
    case 399:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1753);
      if (lookahead == 'n') ADVANCE(2113);
      END_STATE();
    case 400:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1753);
      if (lookahead == 'n') ADVANCE(966);
      END_STATE();
    case 401:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1852);
      if (lookahead == 'i') ADVANCE(1145);
      if (lookahead == 't') ADVANCE(1835);
      END_STATE();
    case 402:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 't') ADVANCE(320);
      END_STATE();
    case 403:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 't') ADVANCE(1830);
      END_STATE();
    case 404:
      if (lookahead == 'A') ADVANCE(1875);
      if (lookahead == 'D') ADVANCE(1643);
      if (lookahead == 'E') ADVANCE(1734);
      if (lookahead == 'T') ADVANCE(1009);
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'd') ADVANCE(1650);
      if (lookahead == 'p') ADVANCE(1018);
      if (lookahead == 's') ADVANCE(1231);
      END_STATE();
    case 405:
      if (lookahead == 'A') ADVANCE(809);
      END_STATE();
    case 406:
      if (lookahead == 'A') ADVANCE(809);
      if (lookahead == 'D') ADVANCE(1587);
      if (lookahead == 'G') ADVANCE(1793);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 407:
      if (lookahead == 'A') ADVANCE(1391);
      END_STATE();
    case 408:
      if (lookahead == 'A') ADVANCE(1567);
      if (lookahead == 'C') ADVANCE(1079);
      if (lookahead == 'D') ADVANCE(1584);
      if (lookahead == 'F') ADVANCE(1393);
      if (lookahead == 'T') ADVANCE(1024);
      if (lookahead == 'U') ADVANCE(1682);
      if (lookahead == 'V') ADVANCE(1058);
      if (lookahead == 'a') ADVANCE(1872);
      END_STATE();
    case 409:
      if (lookahead == 'A') ADVANCE(1872);
      END_STATE();
    case 410:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'D') ADVANCE(1643);
      END_STATE();
    case 411:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'R') ADVANCE(1316);
      END_STATE();
    case 412:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'R') ADVANCE(1316);
      if (lookahead == 'T') ADVANCE(994);
      END_STATE();
    case 413:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'T') ADVANCE(994);
      END_STATE();
    case 414:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'V') ADVANCE(1063);
      END_STATE();
    case 415:
      if (lookahead == 'A') ADVANCE(1876);
      if (lookahead == 'B') ADVANCE(1740);
      if (lookahead == 'L') ADVANCE(1056);
      if (lookahead == 'R') ADVANCE(1314);
      if (lookahead == 'T') ADVANCE(1009);
      if (lookahead == 'a') ADVANCE(1872);
      END_STATE();
    case 416:
      if (lookahead == 'B') ADVANCE(541);
      if (lookahead == 'P') ADVANCE(689);
      END_STATE();
    case 417:
      if (lookahead == 'B') ADVANCE(575);
      if (lookahead == 'E') ADVANCE(176);
      if (lookahead == 'a') ADVANCE(813);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'e') ADVANCE(348);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1579);
      if (lookahead == 'i') ADVANCE(1123);
      if (lookahead == 'o') ADVANCE(1677);
      if (lookahead == 'r') ADVANCE(1308);
      if (lookahead == 's') ADVANCE(776);
      if (lookahead == 'u') ADVANCE(1384);
      END_STATE();
    case 418:
      if (lookahead == 'B') ADVANCE(538);
      END_STATE();
    case 419:
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'L') ADVANCE(1263);
      if (lookahead == 'S') ADVANCE(1051);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 420:
      if (lookahead == 'B') ADVANCE(1873);
      END_STATE();
    case 421:
      if (lookahead == 'B') ADVANCE(1865);
      if (lookahead == 'n') ADVANCE(422);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(159);
      END_STATE();
    case 422:
      if (lookahead == 'B') ADVANCE(1870);
      END_STATE();
    case 423:
      if (lookahead == 'C') ADVANCE(475);
      if (lookahead == 'c') ADVANCE(2129);
      END_STATE();
    case 424:
      if (lookahead == 'C') ADVANCE(444);
      END_STATE();
    case 425:
      if (lookahead == 'C') ADVANCE(564);
      END_STATE();
    case 426:
      if (lookahead == 'C') ADVANCE(1644);
      if (lookahead == 'T') ADVANCE(1295);
      END_STATE();
    case 427:
      if (lookahead == 'C') ADVANCE(1321);
      END_STATE();
    case 428:
      if (lookahead == 'C') ADVANCE(1416);
      END_STATE();
    case 429:
      if (lookahead == 'C') ADVANCE(2078);
      END_STATE();
    case 430:
      if (lookahead == 'C') ADVANCE(1660);
      END_STATE();
    case 431:
      if (lookahead == 'C') ADVANCE(1660);
      if (lookahead == 'D') ADVANCE(1586);
      if (lookahead == 'L') ADVANCE(1068);
      if (lookahead == 'R') ADVANCE(1318);
      if (lookahead == 'U') ADVANCE(1683);
      if (lookahead == 'V') ADVANCE(1077);
      END_STATE();
    case 432:
      if (lookahead == 'D') ADVANCE(1589);
      END_STATE();
    case 433:
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'M') ADVANCE(1306);
      if (lookahead == 'P') ADVANCE(1439);
      if (lookahead == 'T') ADVANCE(1295);
      END_STATE();
    case 434:
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'a') ADVANCE(1760);
      END_STATE();
    case 435:
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'o') ADVANCE(1949);
      END_STATE();
    case 436:
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 437:
      if (lookahead == 'D') ADVANCE(307);
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'S') ADVANCE(745);
      if (lookahead == 'Z') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(1127);
      if (lookahead == 'c') ADVANCE(607);
      if (lookahead == 'e') ADVANCE(1350);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(550);
      if (lookahead == 'o') ADVANCE(1675);
      if (lookahead == 's') ADVANCE(790);
      END_STATE();
    case 438:
      if (lookahead == 'D') ADVANCE(148);
      END_STATE();
    case 439:
      if (lookahead == 'D') ADVANCE(435);
      if (lookahead == 'a') ADVANCE(807);
      if (lookahead == 'c') ADVANCE(605);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(436);
      if (lookahead == 'g') ADVANCE(319);
      if (lookahead == 'l') ADVANCE(286);
      if (lookahead == 'm') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(1112);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(618);
      if (lookahead == 'q') ADVANCE(800);
      if (lookahead == 'r') ADVANCE(434);
      if (lookahead == 's') ADVANCE(770);
      if (lookahead == 't') ADVANCE(354);
      if (lookahead == 'u') ADVANCE(1456);
      if (lookahead == 'x') ADVANCE(828);
      END_STATE();
    case 440:
      if (lookahead == 'D') ADVANCE(432);
      if (lookahead == 'a') ADVANCE(755);
      if (lookahead == 'c') ADVANCE(1645);
      if (lookahead == 'd') ADVANCE(571);
      if (lookahead == 'e') ADVANCE(653);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1579);
      if (lookahead == 'i') ADVANCE(844);
      if (lookahead == 'l') ADVANCE(808);
      if (lookahead == 'n') ADVANCE(1699);
      if (lookahead == 'o') ADVANCE(908);
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 's') ADVANCE(789);
      if (lookahead == 'u') ADVANCE(292);
      END_STATE();
    case 441:
      if (lookahead == 'D') ADVANCE(455);
      END_STATE();
    case 442:
      if (lookahead == 'D') ADVANCE(2167);
      if (lookahead == 'H') ADVANCE(365);
      if (lookahead == 'U') ADVANCE(2167);
      if (lookahead == 'V') ADVANCE(366);
      if (lookahead == 'b') ADVANCE(1594);
      if (lookahead == 'd') ADVANCE(2167);
      if (lookahead == 'h') ADVANCE(365);
      if (lookahead == 'm') ADVANCE(1306);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 't') ADVANCE(1295);
      if (lookahead == 'u') ADVANCE(2167);
      if (lookahead == 'v') ADVANCE(366);
      END_STATE();
    case 443:
      if (lookahead == 'D') ADVANCE(745);
      END_STATE();
    case 444:
      if (lookahead == 'D') ADVANCE(390);
      END_STATE();
    case 445:
      if (lookahead == 'D') ADVANCE(571);
      if (lookahead == 'H') ADVANCE(575);
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'd') ADVANCE(571);
      if (lookahead == 'g') ADVANCE(2157);
      if (lookahead == 'i') ADVANCE(1513);
      if (lookahead == 'l') ADVANCE(402);
      if (lookahead == 'r') ADVANCE(403);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 446:
      if (lookahead == 'D') ADVANCE(571);
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'd') ADVANCE(574);
      if (lookahead == 'e') ADVANCE(920);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'v') ADVANCE(888);
      END_STATE();
    case 447:
      if (lookahead == 'D') ADVANCE(571);
      if (lookahead == 'd') ADVANCE(571);
      END_STATE();
    case 448:
      if (lookahead == 'D') ADVANCE(1643);
      if (lookahead == 'L') ADVANCE(1065);
      if (lookahead == 'R') ADVANCE(1316);
      if (lookahead == 'U') ADVANCE(1687);
      END_STATE();
    case 449:
      if (lookahead == 'D') ADVANCE(1245);
      END_STATE();
    case 450:
      if (lookahead == 'D') ADVANCE(1011);
      END_STATE();
    case 451:
      if (lookahead == 'D') ADVANCE(1651);
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 452:
      if (lookahead == 'D') ADVANCE(1655);
      if (lookahead == 'T') ADVANCE(1030);
      if (lookahead == 'V') ADVANCE(1058);
      END_STATE();
    case 453:
      if (lookahead == 'D') ADVANCE(1665);
      if (lookahead == 'Q') ADVANCE(2089);
      END_STATE();
    case 454:
      if (lookahead == 'E') ADVANCE(1389);
      if (lookahead == 'M') ADVANCE(183);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'b') ADVANCE(1740);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'l') ADVANCE(1670);
      if (lookahead == 'm') ADVANCE(533);
      if (lookahead == 'n') ADVANCE(872);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(1695);
      if (lookahead == 'r') ADVANCE(1236);
      if (lookahead == 's') ADVANCE(787);
      if (lookahead == 't') ADVANCE(1283);
      if (lookahead == 'u') ADVANCE(1455);
      END_STATE();
    case 455:
      if (lookahead == 'E') ADVANCE(148);
      END_STATE();
    case 456:
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 457:
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1686);
      if (lookahead == 'e') ADVANCE(316);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 458:
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'e') ADVANCE(315);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(318);
      END_STATE();
    case 459:
      if (lookahead == 'E') ADVANCE(1362);
      if (lookahead == 'U') ADVANCE(1718);
      END_STATE();
    case 460:
      if (lookahead == 'E') ADVANCE(745);
      if (lookahead == 'J') ADVANCE(1395);
      if (lookahead == 'O') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'm') ADVANCE(188);
      if (lookahead == 'n') ADVANCE(1977);
      if (lookahead == 'o') ADVANCE(1130);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(1309);
      if (lookahead == 'u') ADVANCE(1338);
      END_STATE();
    case 461:
      if (lookahead == 'E') ADVANCE(1361);
      END_STATE();
    case 462:
      if (lookahead == 'E') ADVANCE(1395);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(743);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'm') ADVANCE(535);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(981);
      if (lookahead == 'r') ADVANCE(148);
      if (lookahead == 's') ADVANCE(784);
      if (lookahead == 't') ADVANCE(1230);
      if (lookahead == 'u') ADVANCE(1455);
      if (lookahead == 'v') ADVANCE(996);
      END_STATE();
    case 463:
      if (lookahead == 'E') ADVANCE(1734);
      END_STATE();
    case 464:
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 465:
      if (lookahead == 'E') ADVANCE(1736);
      if (lookahead == 'F') ADVANCE(2088);
      if (lookahead == 'G') ADVANCE(1881);
      if (lookahead == 'L') ADVANCE(963);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 466:
      if (lookahead == 'E') ADVANCE(1737);
      if (lookahead == 'F') ADVANCE(2088);
      if (lookahead == 'G') ADVANCE(1881);
      if (lookahead == 'L') ADVANCE(963);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 467:
      if (lookahead == 'F') ADVANCE(510);
      END_STATE();
    case 468:
      if (lookahead == 'F') ADVANCE(2082);
      END_STATE();
    case 469:
      if (lookahead == 'G') ADVANCE(148);
      END_STATE();
    case 470:
      if (lookahead == 'G') ADVANCE(1113);
      if (lookahead == 'L') ADVANCE(1044);
      if (lookahead == 'R') ADVANCE(1308);
      if (lookahead == 'V') ADVANCE(447);
      if (lookahead == 'a') ADVANCE(727);
      if (lookahead == 'b') ADVANCE(1896);
      if (lookahead == 'c') ADVANCE(558);
      if (lookahead == 'd') ADVANCE(571);
      if (lookahead == 'e') ADVANCE(150);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(458);
      if (lookahead == 'h') ADVANCE(397);
      if (lookahead == 'i') ADVANCE(324);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'l') ADVANCE(392);
      if (lookahead == 'm') ADVANCE(1213);
      if (lookahead == 'o') ADVANCE(311);
      if (lookahead == 'p') ADVANCE(626);
      if (lookahead == 'r') ADVANCE(401);
      if (lookahead == 's') ADVANCE(762);
      if (lookahead == 't') ADVANCE(1133);
      if (lookahead == 'u') ADVANCE(295);
      if (lookahead == 'v') ADVANCE(445);
      if (lookahead == 'w') ADVANCE(400);
      END_STATE();
    case 471:
      if (lookahead == 'G') ADVANCE(1881);
      END_STATE();
    case 472:
      if (lookahead == 'G') ADVANCE(1890);
      if (lookahead == 'L') ADVANCE(1046);
      END_STATE();
    case 473:
      if (lookahead == 'H') ADVANCE(423);
      if (lookahead == 'O') ADVANCE(467);
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'c') ADVANCE(202);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1646);
      if (lookahead == 'i') ADVANCE(1131);
      if (lookahead == 'm') ADVANCE(651);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'q') ADVANCE(1767);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(538);
      if (lookahead == 'u') ADVANCE(711);
      END_STATE();
    case 474:
      if (lookahead == 'H') ADVANCE(495);
      if (lookahead == 'R') ADVANCE(388);
      if (lookahead == 'S') ADVANCE(479);
      if (lookahead == 'a') ADVANCE(2154);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(951);
      if (lookahead == 'i') ADVANCE(1377);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'r') ADVANCE(1288);
      if (lookahead == 's') ADVANCE(790);
      END_STATE();
    case 475:
      if (lookahead == 'H') ADVANCE(745);
      END_STATE();
    case 476:
      if (lookahead == 'H') ADVANCE(745);
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(1692);
      if (lookahead == 'c') ADVANCE(972);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 477:
      if (lookahead == 'H') ADVANCE(745);
      if (lookahead == 'O') ADVANCE(496);
      if (lookahead == 'a') ADVANCE(815);
      if (lookahead == 'c') ADVANCE(603);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(905);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1214);
      if (lookahead == 'i') ADVANCE(1788);
      if (lookahead == 'l') ADVANCE(1593);
      if (lookahead == 'o') ADVANCE(1433);
      if (lookahead == 'r') ADVANCE(1595);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(1678);
      END_STATE();
    case 478:
      if (lookahead == 'H') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'c') ADVANCE(607);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1798);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 479:
      if (lookahead == 'H') ADVANCE(745);
      if (lookahead == 'c') ADVANCE(2129);
      END_STATE();
    case 480:
      if (lookahead == 'H') ADVANCE(2090);
      END_STATE();
    case 481:
      if (lookahead == 'I') ADVANCE(148);
      END_STATE();
    case 482:
      if (lookahead == 'I') ADVANCE(1489);
      END_STATE();
    case 483:
      if (lookahead == 'I') ADVANCE(1556);
      END_STATE();
    case 484:
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'e') ADVANCE(1134);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(421);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(1283);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 485:
      if (lookahead == 'L') ADVANCE(963);
      END_STATE();
    case 486:
      if (lookahead == 'L') ADVANCE(1263);
      END_STATE();
    case 487:
      if (lookahead == 'L') ADVANCE(1061);
      if (lookahead == 'R') ADVANCE(1316);
      END_STATE();
    case 488:
      if (lookahead == 'L') ADVANCE(1061);
      if (lookahead == 'R') ADVANCE(1316);
      if (lookahead == 'l') ADVANCE(1043);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 489:
      if (lookahead == 'L') ADVANCE(1065);
      if (lookahead == 'R') ADVANCE(1316);
      END_STATE();
    case 490:
      if (lookahead == 'M') ADVANCE(1047);
      if (lookahead == 'T') ADVANCE(1196);
      if (lookahead == 'V') ADVANCE(1035);
      END_STATE();
    case 491:
      if (lookahead == 'M') ADVANCE(1306);
      END_STATE();
    case 492:
      if (lookahead == 'N') ADVANCE(1589);
      if (lookahead == 'a') ADVANCE(799);
      if (lookahead == 'b') ADVANCE(1784);
      if (lookahead == 'c') ADVANCE(1610);
      if (lookahead == 'd') ADVANCE(1730);
      if (lookahead == 'e') ADVANCE(864);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1114);
      if (lookahead == 'k') ADVANCE(669);
      if (lookahead == 'l') ADVANCE(551);
      if (lookahead == 'n') ADVANCE(929);
      if (lookahead == 'o') ADVANCE(1676);
      if (lookahead == 'p') ADVANCE(1811);
      if (lookahead == 'r') ADVANCE(927);
      if (lookahead == 's') ADVANCE(771);
      if (lookahead == 'u') ADVANCE(1396);
      END_STATE();
    case 493:
      if (lookahead == 'N') ADVANCE(469);
      if (lookahead == 'T') ADVANCE(177);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(606);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'l') ADVANCE(1048);
      if (lookahead == 'm') ADVANCE(536);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(1945);
      if (lookahead == 'q') ADVANCE(2042);
      if (lookahead == 's') ADVANCE(779);
      if (lookahead == 't') ADVANCE(524);
      if (lookahead == 'u') ADVANCE(1455);
      if (lookahead == 'x') ADVANCE(1239);
      END_STATE();
    case 494:
      if (lookahead == 'O') ADVANCE(185);
      END_STATE();
    case 495:
      if (lookahead == 'O') ADVANCE(501);
      END_STATE();
    case 496:
      if (lookahead == 'P') ADVANCE(187);
      END_STATE();
    case 497:
      if (lookahead == 'P') ADVANCE(538);
      END_STATE();
    case 498:
      if (lookahead == 'P') ADVANCE(538);
      if (lookahead == 'i') ADVANCE(361);
      END_STATE();
    case 499:
      if (lookahead == 'P') ADVANCE(1439);
      END_STATE();
    case 500:
      if (lookahead == 'Q') ADVANCE(2089);
      END_STATE();
    case 501:
      if (lookahead == 'R') ADVANCE(182);
      END_STATE();
    case 502:
      if (lookahead == 'R') ADVANCE(443);
      END_STATE();
    case 503:
      if (lookahead == 'R') ADVANCE(1319);
      if (lookahead == 'T') ADVANCE(1030);
      if (lookahead == 'V') ADVANCE(1058);
      END_STATE();
    case 504:
      if (lookahead == 'S') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(806);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(572);
      if (lookahead == 'e') ADVANCE(1395);
      if (lookahead == 'f') ADVANCE(842);
      if (lookahead == 'g') ADVANCE(1621);
      if (lookahead == 'h') ADVANCE(718);
      if (lookahead == 'i') ADVANCE(1507);
      if (lookahead == 'l') ADVANCE(578);
      if (lookahead == 'm') ADVANCE(534);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(539);
      if (lookahead == 'r') ADVANCE(198);
      if (lookahead == 's') ADVANCE(785);
      if (lookahead == 't') ADVANCE(1278);
      if (lookahead == 'u') ADVANCE(1455);
      if (lookahead == 'v') ADVANCE(716);
      END_STATE();
    case 505:
      if (lookahead == 'S') ADVANCE(1493);
      END_STATE();
    case 506:
      if (lookahead == 'S') ADVANCE(1493);
      if (lookahead == 'V') ADVANCE(1033);
      END_STATE();
    case 507:
      if (lookahead == 'S') ADVANCE(1711);
      END_STATE();
    case 508:
      if (lookahead == 'S') ADVANCE(2052);
      END_STATE();
    case 509:
      if (lookahead == 'S') ADVANCE(1738);
      END_STATE();
    case 510:
      if (lookahead == 'T') ADVANCE(745);
      END_STATE();
    case 511:
      if (lookahead == 'T') ADVANCE(386);
      END_STATE();
    case 512:
      if (lookahead == 'T') ADVANCE(1210);
      END_STATE();
    case 513:
      if (lookahead == 'T') ADVANCE(1191);
      END_STATE();
    case 514:
      if (lookahead == 'T') ADVANCE(1030);
      if (lookahead == 'V') ADVANCE(1058);
      END_STATE();
    case 515:
      if (lookahead == 'T') ADVANCE(1892);
      END_STATE();
    case 516:
      if (lookahead == 'U') ADVANCE(494);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 517:
      if (lookahead == 'V') ADVANCE(1077);
      END_STATE();
    case 518:
      if (lookahead == 'V') ADVANCE(1063);
      END_STATE();
    case 519:
      if (lookahead == 'W') ADVANCE(1265);
      END_STATE();
    case 520:
      if (lookahead == '[') ADVANCE(2235);
      END_STATE();
    case 521:
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'b') ADVANCE(1740);
      if (lookahead == 'c') ADVANCE(364);
      if (lookahead == 'e') ADVANCE(1389);
      if (lookahead == 'f') ADVANCE(318);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'l') ADVANCE(928);
      if (lookahead == 'm') ADVANCE(193);
      if (lookahead == 'n') ADVANCE(876);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(349);
      if (lookahead == 'r') ADVANCE(1236);
      if (lookahead == 's') ADVANCE(788);
      if (lookahead == 't') ADVANCE(1283);
      if (lookahead == 'u') ADVANCE(1455);
      if (lookahead == 'w') ADVANCE(824);
      END_STATE();
    case 522:
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(280);
      if (lookahead == 'e') ADVANCE(752);
      if (lookahead == 'f') ADVANCE(2158);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'i') ADVANCE(278);
      if (lookahead == 'j') ADVANCE(1395);
      if (lookahead == 'm') ADVANCE(530);
      if (lookahead == 'n') ADVANCE(232);
      if (lookahead == 'o') ADVANCE(749);
      if (lookahead == 'p') ADVANCE(1801);
      if (lookahead == 'q') ADVANCE(2057);
      if (lookahead == 's') ADVANCE(781);
      if (lookahead == 't') ADVANCE(285);
      if (lookahead == 'u') ADVANCE(1338);
      END_STATE();
    case 523:
      if (lookahead == 'a') ADVANCE(795);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(830);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'r') ADVANCE(926);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(1466);
      END_STATE();
    case 524:
      if (lookahead == 'a') ADVANCE(148);
      END_STATE();
    case 525:
      if (lookahead == 'a') ADVANCE(318);
      END_STATE();
    case 526:
      if (lookahead == 'a') ADVANCE(1730);
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(148);
      if (lookahead == 'i') ADVANCE(1460);
      if (lookahead == 'q') ADVANCE(710);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 527:
      if (lookahead == 'a') ADVANCE(1730);
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(710);
      END_STATE();
    case 528:
      if (lookahead == 'a') ADVANCE(814);
      if (lookahead == 'c') ADVANCE(553);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(898);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(747);
      if (lookahead == 'i') ADVANCE(1745);
      if (lookahead == 'l') ADVANCE(2047);
      if (lookahead == 'o') ADVANCE(1443);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(791);
      if (lookahead == 't') ADVANCE(867);
      if (lookahead == 'u') ADVANCE(915);
      if (lookahead == 'w') ADVANCE(824);
      if (lookahead == 'y') ADVANCE(1386);
      END_STATE();
    case 529:
      if (lookahead == 'a') ADVANCE(2104);
      END_STATE();
    case 530:
      if (lookahead == 'a') ADVANCE(774);
      if (lookahead == 'o') ADVANCE(1087);
      if (lookahead == 'p') ADVANCE(916);
      END_STATE();
    case 531:
      if (lookahead == 'a') ADVANCE(1403);
      if (lookahead == 'e') ADVANCE(1716);
      if (lookahead == 'i') ADVANCE(874);
      if (lookahead == 't') ADVANCE(252);
      END_STATE();
    case 532:
      if (lookahead == 'a') ADVANCE(359);
      END_STATE();
    case 533:
      if (lookahead == 'a') ADVANCE(769);
      END_STATE();
    case 534:
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'e') ADVANCE(1122);
      if (lookahead == 'i') ADVANCE(836);
      END_STATE();
    case 535:
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'e') ADVANCE(1122);
      if (lookahead == 'i') ADVANCE(835);
      END_STATE();
    case 536:
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'p') ADVANCE(1976);
      END_STATE();
    case 537:
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'p') ADVANCE(1984);
      if (lookahead == 's') ADVANCE(1681);
      END_STATE();
    case 538:
      if (lookahead == 'a') ADVANCE(1741);
      END_STATE();
    case 539:
      if (lookahead == 'a') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(1789);
      if (lookahead == 'l') ADVANCE(2056);
      END_STATE();
    case 540:
      if (lookahead == 'a') ADVANCE(1741);
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(2056);
      END_STATE();
    case 541:
      if (lookahead == 'a') ADVANCE(1741);
      if (lookahead == 'r') ADVANCE(619);
      END_STATE();
    case 542:
      if (lookahead == 'a') ADVANCE(805);
      if (lookahead == 'b') ADVANCE(1763);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(743);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'm') ADVANCE(533);
      if (lookahead == 'n') ADVANCE(886);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(404);
      if (lookahead == 'r') ADVANCE(1251);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(1309);
      if (lookahead == 'u') ADVANCE(1455);
      END_STATE();
    case 543:
      if (lookahead == 'a') ADVANCE(1507);
      END_STATE();
    case 544:
      if (lookahead == 'a') ADVANCE(345);
      END_STATE();
    case 545:
      if (lookahead == 'a') ADVANCE(1866);
      if (lookahead == 'b') ADVANCE(1795);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1444);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(958);
      if (lookahead == 'i') ADVANCE(1432);
      if (lookahead == 'o') ADVANCE(949);
      if (lookahead == 'p') ADVANCE(1811);
      if (lookahead == 'r') ADVANCE(656);
      if (lookahead == 's') ADVANCE(760);
      if (lookahead == 'w') ADVANCE(1218);
      END_STATE();
    case 546:
      if (lookahead == 'a') ADVANCE(1517);
      if (lookahead == 'b') ADVANCE(1795);
      if (lookahead == 'n') ADVANCE(1120);
      if (lookahead == 'o') ADVANCE(1717);
      if (lookahead == 'p') ADVANCE(540);
      if (lookahead == 't') ADVANCE(1295);
      if (lookahead == 'w') ADVANCE(588);
      if (lookahead == 'z') ADVANCE(260);
      END_STATE();
    case 547:
      if (lookahead == 'a') ADVANCE(1517);
      if (lookahead == 'b') ADVANCE(1795);
      if (lookahead == 'p') ADVANCE(540);
      if (lookahead == 't') ADVANCE(1295);
      END_STATE();
    case 548:
      if (lookahead == 'a') ADVANCE(1949);
      END_STATE();
    case 549:
      if (lookahead == 'a') ADVANCE(1949);
      if (lookahead == 'l') ADVANCE(1243);
      if (lookahead == 't') ADVANCE(1523);
      END_STATE();
    case 550:
      if (lookahead == 'a') ADVANCE(858);
      if (lookahead == 'f') ADVANCE(1098);
      END_STATE();
    case 551:
      if (lookahead == 'a') ADVANCE(825);
      if (lookahead == 'k') ADVANCE(140);
      if (lookahead == 'o') ADVANCE(818);
      END_STATE();
    case 552:
      if (lookahead == 'a') ADVANCE(235);
      END_STATE();
    case 553:
      if (lookahead == 'a') ADVANCE(1693);
      if (lookahead == 'e') ADVANCE(897);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'u') ADVANCE(1701);
      END_STATE();
    case 554:
      if (lookahead == 'a') ADVANCE(909);
      END_STATE();
    case 555:
      if (lookahead == 'a') ADVANCE(326);
      END_STATE();
    case 556:
      if (lookahead == 'a') ADVANCE(2102);
      END_STATE();
    case 557:
      if (lookahead == 'a') ADVANCE(765);
      if (lookahead == 'o') ADVANCE(2117);
      END_STATE();
    case 558:
      if (lookahead == 'a') ADVANCE(1669);
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'o') ADVANCE(1530);
      if (lookahead == 'u') ADVANCE(1668);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 559:
      if (lookahead == 'a') ADVANCE(333);
      END_STATE();
    case 560:
      if (lookahead == 'a') ADVANCE(764);
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'e') ADVANCE(297);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(745);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(751);
      END_STATE();
    case 561:
      if (lookahead == 'a') ADVANCE(1791);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1214);
      if (lookahead == 'i') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(2051);
      if (lookahead == 'o') ADVANCE(1279);
      if (lookahead == 'r') ADVANCE(253);
      if (lookahead == 's') ADVANCE(778);
      END_STATE();
    case 562:
      if (lookahead == 'a') ADVANCE(1692);
      END_STATE();
    case 563:
      if (lookahead == 'a') ADVANCE(1704);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1725);
      if (lookahead == 'l') ADVANCE(963);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 564:
      if (lookahead == 'a') ADVANCE(1668);
      END_STATE();
    case 565:
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(893);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1547);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 566:
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 567:
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 568:
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 569:
      if (lookahead == 'a') ADVANCE(1111);
      END_STATE();
    case 570:
      if (lookahead == 'a') ADVANCE(1451);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(1481);
      if (lookahead == 'f') ADVANCE(1276);
      if (lookahead == 'i') ADVANCE(1395);
      if (lookahead == 'j') ADVANCE(1395);
      if (lookahead == 'l') ADVANCE(549);
      if (lookahead == 'n') ADVANCE(1581);
      if (lookahead == 'o') ADVANCE(1672);
      if (lookahead == 'p') ADVANCE(659);
      if (lookahead == 'r') ADVANCE(557);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 571:
      if (lookahead == 'a') ADVANCE(1915);
      END_STATE();
    case 572:
      if (lookahead == 'a') ADVANCE(1915);
      if (lookahead == 'b') ADVANCE(1429);
      if (lookahead == 'i') ADVANCE(2099);
      if (lookahead == 'o') ADVANCE(1949);
      if (lookahead == 's') ADVANCE(1631);
      END_STATE();
    case 573:
      if (lookahead == 'a') ADVANCE(1330);
      END_STATE();
    case 574:
      if (lookahead == 'a') ADVANCE(1918);
      END_STATE();
    case 575:
      if (lookahead == 'a') ADVANCE(1760);
      END_STATE();
    case 576:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'b') ADVANCE(1795);
      if (lookahead == 'r') ADVANCE(609);
      END_STATE();
    case 577:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'b') ADVANCE(1429);
      if (lookahead == 'h') ADVANCE(538);
      END_STATE();
    case 578:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'c') ADVANCE(1225);
      if (lookahead == 'i') ADVANCE(1529);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 579:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'c') ADVANCE(1640);
      if (lookahead == 'h') ADVANCE(640);
      if (lookahead == 'm') ADVANCE(148);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 580:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'h') ADVANCE(538);
      END_STATE();
    case 581:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'h') ADVANCE(538);
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 582:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'm') ADVANCE(287);
      END_STATE();
    case 583:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'm') ADVANCE(1991);
      if (lookahead == 'o') ADVANCE(1333);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'r') ADVANCE(716);
      END_STATE();
    case 584:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'o') ADVANCE(1920);
      END_STATE();
    case 585:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'r') ADVANCE(1741);
      if (lookahead == 't') ADVANCE(670);
      END_STATE();
    case 586:
      if (lookahead == 'a') ADVANCE(1458);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'g') ADVANCE(652);
      if (lookahead == 's') ADVANCE(1258);
      if (lookahead == 'v') ADVANCE(279);
      END_STATE();
    case 587:
      if (lookahead == 'a') ADVANCE(2140);
      END_STATE();
    case 588:
      if (lookahead == 'a') ADVANCE(1905);
      if (lookahead == 'b') ADVANCE(538);
      END_STATE();
    case 589:
      if (lookahead == 'a') ADVANCE(1528);
      END_STATE();
    case 590:
      if (lookahead == 'a') ADVANCE(1988);
      END_STATE();
    case 591:
      if (lookahead == 'a') ADVANCE(1349);
      END_STATE();
    case 592:
      if (lookahead == 'a') ADVANCE(1747);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(1748);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1228);
      if (lookahead == 'i') ADVANCE(339);
      if (lookahead == 'l') ADVANCE(608);
      if (lookahead == 'm') ADVANCE(148);
      if (lookahead == 'o') ADVANCE(1289);
      if (lookahead == 'r') ADVANCE(164);
      if (lookahead == 's') ADVANCE(778);
      if (lookahead == 'u') ADVANCE(1527);
      END_STATE();
    case 593:
      if (lookahead == 'a') ADVANCE(1982);
      if (lookahead == 'e') ADVANCE(1929);
      if (lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 594:
      if (lookahead == 'a') ADVANCE(1173);
      END_STATE();
    case 595:
      if (lookahead == 'a') ADVANCE(1347);
      END_STATE();
    case 596:
      if (lookahead == 'a') ADVANCE(1372);
      if (lookahead == 'l') ADVANCE(1263);
      if (lookahead == 's') ADVANCE(2076);
      END_STATE();
    case 597:
      if (lookahead == 'a') ADVANCE(1795);
      END_STATE();
    case 598:
      if (lookahead == 'a') ADVANCE(1908);
      END_STATE();
    case 599:
      if (lookahead == 'a') ADVANCE(1495);
      END_STATE();
    case 600:
      if (lookahead == 'a') ADVANCE(753);
      END_STATE();
    case 601:
      if (lookahead == 'a') ADVANCE(1529);
      END_STATE();
    case 602:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'e') ADVANCE(913);
      if (lookahead == 'u') ADVANCE(709);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 603:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'e') ADVANCE(897);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'o') ADVANCE(1557);
      END_STATE();
    case 604:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 605:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'o') ADVANCE(1379);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 606:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 607:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 608:
      if (lookahead == 'a') ADVANCE(1501);
      if (lookahead == 'u') ADVANCE(1899);
      END_STATE();
    case 609:
      if (lookahead == 'a') ADVANCE(767);
      if (lookahead == 'k') ADVANCE(921);
      END_STATE();
    case 610:
      if (lookahead == 'a') ADVANCE(1690);
      if (lookahead == 'u') ADVANCE(1690);
      END_STATE();
    case 611:
      if (lookahead == 'a') ADVANCE(878);
      END_STATE();
    case 612:
      if (lookahead == 'a') ADVANCE(1366);
      END_STATE();
    case 613:
      if (lookahead == 'a') ADVANCE(1366);
      if (lookahead == 'i') ADVANCE(1411);
      END_STATE();
    case 614:
      if (lookahead == 'a') ADVANCE(1750);
      END_STATE();
    case 615:
      if (lookahead == 'a') ADVANCE(1750);
      if (lookahead == 'b') ADVANCE(1380);
      END_STATE();
    case 616:
      if (lookahead == 'a') ADVANCE(1385);
      END_STATE();
    case 617:
      if (lookahead == 'a') ADVANCE(1385);
      if (lookahead == 'e') ADVANCE(1905);
      if (lookahead == 'i') ADVANCE(2101);
      END_STATE();
    case 618:
      if (lookahead == 'a') ADVANCE(1785);
      if (lookahead == 'l') ADVANCE(2056);
      if (lookahead == 's') ADVANCE(1221);
      END_STATE();
    case 619:
      if (lookahead == 'a') ADVANCE(768);
      END_STATE();
    case 620:
      if (lookahead == 'a') ADVANCE(1780);
      if (lookahead == 'b') ADVANCE(1380);
      END_STATE();
    case 621:
      if (lookahead == 'a') ADVANCE(1780);
      if (lookahead == 'o') ADVANCE(345);
      END_STATE();
    case 622:
      if (lookahead == 'a') ADVANCE(1712);
      END_STATE();
    case 623:
      if (lookahead == 'a') ADVANCE(853);
      END_STATE();
    case 624:
      if (lookahead == 'a') ADVANCE(1778);
      END_STATE();
    case 625:
      if (lookahead == 'a') ADVANCE(1378);
      END_STATE();
    case 626:
      if (lookahead == 'a') ADVANCE(1770);
      if (lookahead == 'o') ADVANCE(1445);
      if (lookahead == 'r') ADVANCE(230);
      END_STATE();
    case 627:
      if (lookahead == 'a') ADVANCE(1376);
      END_STATE();
    case 628:
      if (lookahead == 'a') ADVANCE(1765);
      if (lookahead == 'p') ADVANCE(1664);
      END_STATE();
    case 629:
      if (lookahead == 'a') ADVANCE(1751);
      if (lookahead == 'r') ADVANCE(700);
      END_STATE();
    case 630:
      if (lookahead == 'a') ADVANCE(1356);
      END_STATE();
    case 631:
      if (lookahead == 'a') ADVANCE(1764);
      END_STATE();
    case 632:
      if (lookahead == 'a') ADVANCE(1364);
      END_STATE();
    case 633:
      if (lookahead == 'a') ADVANCE(1351);
      END_STATE();
    case 634:
      if (lookahead == 'a') ADVANCE(1357);
      END_STATE();
    case 635:
      if (lookahead == 'a') ADVANCE(1352);
      END_STATE();
    case 636:
      if (lookahead == 'a') ADVANCE(1818);
      END_STATE();
    case 637:
      if (lookahead == 'a') ADVANCE(1370);
      END_STATE();
    case 638:
      if (lookahead == 'a') ADVANCE(1358);
      END_STATE();
    case 639:
      if (lookahead == 'a') ADVANCE(1739);
      END_STATE();
    case 640:
      if (lookahead == 'a') ADVANCE(1768);
      END_STATE();
    case 641:
      if (lookahead == 'a') ADVANCE(1744);
      END_STATE();
    case 642:
      if (lookahead == 'a') ADVANCE(1822);
      END_STATE();
    case 643:
      if (lookahead == 'a') ADVANCE(1766);
      END_STATE();
    case 644:
      if (lookahead == 'a') ADVANCE(2006);
      END_STATE();
    case 645:
      if (lookahead == 'a') ADVANCE(1833);
      END_STATE();
    case 646:
      if (lookahead == 'a') ADVANCE(1806);
      END_STATE();
    case 647:
      if (lookahead == 'a') ADVANCE(1797);
      END_STATE();
    case 648:
      if (lookahead == 'a') ADVANCE(1803);
      END_STATE();
    case 649:
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'b') ADVANCE(1730);
      if (lookahead == 'c') ADVANCE(353);
      if (lookahead == 'd') ADVANCE(1618);
      if (lookahead == 'e') ADVANCE(398);
      if (lookahead == 'f') ADVANCE(1761);
      if (lookahead == 'h') ADVANCE(207);
      if (lookahead == 'i') ADVANCE(1150);
      if (lookahead == 'l') ADVANCE(575);
      if (lookahead == 'm') ADVANCE(531);
      if (lookahead == 'o') ADVANCE(1095);
      if (lookahead == 'p') ADVANCE(554);
      if (lookahead == 'q') ADVANCE(797);
      if (lookahead == 'r') ADVANCE(575);
      if (lookahead == 's') ADVANCE(772);
      if (lookahead == 't') ADVANCE(629);
      if (lookahead == 'u') ADVANCE(712);
      if (lookahead == 'w') ADVANCE(399);
      if (lookahead == 'z') ADVANCE(1389);
      END_STATE();
    case 650:
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'c') ADVANCE(607);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1054);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(745);
      if (lookahead == 'i') ADVANCE(1144);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'w') ADVANCE(1329);
      END_STATE();
    case 651:
      if (lookahead == 'a') ADVANCE(1401);
      END_STATE();
    case 652:
      if (lookahead == 'a') ADVANCE(1470);
      END_STATE();
    case 653:
      if (lookahead == 'a') ADVANCE(1927);
      END_STATE();
    case 654:
      if (lookahead == 'a') ADVANCE(1696);
      if (lookahead == 'c') ADVANCE(972);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1805);
      if (lookahead == 'h') ADVANCE(745);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 655:
      if (lookahead == 'a') ADVANCE(847);
      END_STATE();
    case 656:
      if (lookahead == 'a') ADVANCE(894);
      if (lookahead == 'i') ADVANCE(701);
      if (lookahead == 'p') ADVANCE(956);
      END_STATE();
    case 657:
      if (lookahead == 'a') ADVANCE(1854);
      END_STATE();
    case 658:
      if (lookahead == 'a') ADVANCE(2003);
      END_STATE();
    case 659:
      if (lookahead == 'a') ADVANCE(1821);
      END_STATE();
    case 660:
      if (lookahead == 'a') ADVANCE(1703);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1726);
      if (lookahead == 'g') ADVANCE(1969);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 661:
      if (lookahead == 'a') ADVANCE(1703);
      if (lookahead == 'e') ADVANCE(1729);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 662:
      if (lookahead == 'a') ADVANCE(1703);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 663:
      if (lookahead == 'a') ADVANCE(833);
      END_STATE();
    case 664:
      if (lookahead == 'a') ADVANCE(1855);
      if (lookahead == 'l') ADVANCE(2131);
      if (lookahead == 'r') ADVANCE(925);
      if (lookahead == 'v') ADVANCE(1074);
      END_STATE();
    case 665:
      if (lookahead == 'a') ADVANCE(1540);
      END_STATE();
    case 666:
      if (lookahead == 'a') ADVANCE(1391);
      if (lookahead == 'k') ADVANCE(345);
      END_STATE();
    case 667:
      if (lookahead == 'a') ADVANCE(2013);
      END_STATE();
    case 668:
      if (lookahead == 'a') ADVANCE(1867);
      if (lookahead == 'l') ADVANCE(1406);
      if (lookahead == 'r') ADVANCE(817);
      END_STATE();
    case 669:
      if (lookahead == 'a') ADVANCE(1817);
      END_STATE();
    case 670:
      if (lookahead == 'a') ADVANCE(1254);
      END_STATE();
    case 671:
      if (lookahead == 'a') ADVANCE(1254);
      if (lookahead == 'i') ADVANCE(1591);
      END_STATE();
    case 672:
      if (lookahead == 'a') ADVANCE(2067);
      END_STATE();
    case 673:
      if (lookahead == 'a') ADVANCE(1413);
      END_STATE();
    case 674:
      if (lookahead == 'a') ADVANCE(1858);
      END_STATE();
    case 675:
      if (lookahead == 'a') ADVANCE(2069);
      END_STATE();
    case 676:
      if (lookahead == 'a') ADVANCE(2021);
      END_STATE();
    case 677:
      if (lookahead == 'a') ADVANCE(1541);
      END_STATE();
    case 678:
      if (lookahead == 'a') ADVANCE(1860);
      END_STATE();
    case 679:
      if (lookahead == 'a') ADVANCE(1398);
      END_STATE();
    case 680:
      if (lookahead == 'a') ADVANCE(1850);
      END_STATE();
    case 681:
      if (lookahead == 'a') ADVANCE(1809);
      END_STATE();
    case 682:
      if (lookahead == 'a') ADVANCE(1856);
      END_STATE();
    case 683:
      if (lookahead == 'a') ADVANCE(1857);
      END_STATE();
    case 684:
      if (lookahead == 'a') ADVANCE(1448);
      END_STATE();
    case 685:
      if (lookahead == 'a') ADVANCE(1872);
      END_STATE();
    case 686:
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'd') ADVANCE(1650);
      if (lookahead == 'h') ADVANCE(642);
      if (lookahead == 'l') ADVANCE(2056);
      if (lookahead == 's') ADVANCE(1223);
      if (lookahead == 'u') ADVANCE(1722);
      END_STATE();
    case 687:
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'd') ADVANCE(1666);
      if (lookahead == 'h') ADVANCE(642);
      END_STATE();
    case 688:
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 689:
      if (lookahead == 'a') ADVANCE(1883);
      END_STATE();
    case 690:
      if (lookahead == 'a') ADVANCE(2029);
      END_STATE();
    case 691:
      if (lookahead == 'a') ADVANCE(1877);
      if (lookahead == 'h') ADVANCE(702);
      if (lookahead == 'l') ADVANCE(1066);
      if (lookahead == 'r') ADVANCE(1323);
      if (lookahead == 's') ADVANCE(1733);
      if (lookahead == 't') ADVANCE(1211);
      END_STATE();
    case 692:
      if (lookahead == 'a') ADVANCE(1877);
      if (lookahead == 'h') ADVANCE(702);
      if (lookahead == 'l') ADVANCE(1086);
      if (lookahead == 'r') ADVANCE(1317);
      if (lookahead == 't') ADVANCE(1211);
      END_STATE();
    case 693:
      if (lookahead == 'a') ADVANCE(2031);
      END_STATE();
    case 694:
      if (lookahead == 'a') ADVANCE(1878);
      END_STATE();
    case 695:
      if (lookahead == 'a') ADVANCE(1878);
      if (lookahead == 'd') ADVANCE(2163);
      END_STATE();
    case 696:
      if (lookahead == 'a') ADVANCE(1879);
      END_STATE();
    case 697:
      if (lookahead == 'a') ADVANCE(1879);
      if (lookahead == 'h') ADVANCE(704);
      END_STATE();
    case 698:
      if (lookahead == 'a') ADVANCE(2033);
      END_STATE();
    case 699:
      if (lookahead == 'a') ADVANCE(1880);
      if (lookahead == 'h') ADVANCE(704);
      if (lookahead == 's') ADVANCE(1733);
      END_STATE();
    case 700:
      if (lookahead == 'a') ADVANCE(1313);
      if (lookahead == 'n') ADVANCE(1894);
      END_STATE();
    case 701:
      if (lookahead == 'a') ADVANCE(1562);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'm') ADVANCE(1306);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 's') ADVANCE(709);
      if (lookahead == 't') ADVANCE(1291);
      END_STATE();
    case 702:
      if (lookahead == 'a') ADVANCE(1885);
      END_STATE();
    case 703:
      if (lookahead == 'a') ADVANCE(1569);
      END_STATE();
    case 704:
      if (lookahead == 'a') ADVANCE(1887);
      END_STATE();
    case 705:
      if (lookahead == 'a') ADVANCE(1570);
      END_STATE();
    case 706:
      if (lookahead == 'a') ADVANCE(1572);
      END_STATE();
    case 707:
      if (lookahead == 'a') ADVANCE(1573);
      END_STATE();
    case 708:
      if (lookahead == 'a') ADVANCE(1574);
      END_STATE();
    case 709:
      if (lookahead == 'b') ADVANCE(148);
      END_STATE();
    case 710:
      if (lookahead == 'b') ADVANCE(148);
      if (lookahead == 'u') ADVANCE(1580);
      END_STATE();
    case 711:
      if (lookahead == 'b') ADVANCE(331);
      if (lookahead == 'c') ADVANCE(855);
      if (lookahead == 'm') ADVANCE(148);
      if (lookahead == 'p') ADVANCE(261);
      END_STATE();
    case 712:
      if (lookahead == 'b') ADVANCE(165);
      if (lookahead == 'c') ADVANCE(766);
      if (lookahead == 'm') ADVANCE(148);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'p') ADVANCE(2168);
      END_STATE();
    case 713:
      if (lookahead == 'b') ADVANCE(351);
      if (lookahead == 'c') ADVANCE(822);
      if (lookahead == 'p') ADVANCE(351);
      END_STATE();
    case 714:
      if (lookahead == 'b') ADVANCE(235);
      END_STATE();
    case 715:
      if (lookahead == 'b') ADVANCE(243);
      if (lookahead == 'p') ADVANCE(243);
      END_STATE();
    case 716:
      if (lookahead == 'b') ADVANCE(538);
      END_STATE();
    case 717:
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'g') ADVANCE(960);
      END_STATE();
    case 718:
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 719:
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 720:
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 't') ADVANCE(283);
      if (lookahead == 'y') ADVANCE(512);
      END_STATE();
    case 721:
      if (lookahead == 'b') ADVANCE(1345);
      if (lookahead == 'c') ADVANCE(1639);
      END_STATE();
    case 722:
      if (lookahead == 'b') ADVANCE(241);
      if (lookahead == 'p') ADVANCE(241);
      END_STATE();
    case 723:
      if (lookahead == 'b') ADVANCE(2085);
      if (lookahead == 'p') ADVANCE(1206);
      END_STATE();
    case 724:
      if (lookahead == 'b') ADVANCE(882);
      END_STATE();
    case 725:
      if (lookahead == 'b') ADVANCE(1795);
      END_STATE();
    case 726:
      if (lookahead == 'b') ADVANCE(917);
      if (lookahead == 'p') ADVANCE(917);
      END_STATE();
    case 727:
      if (lookahead == 'b') ADVANCE(1359);
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'p') ADVANCE(168);
      if (lookahead == 't') ADVANCE(2075);
      END_STATE();
    case 728:
      if (lookahead == 'b') ADVANCE(1900);
      END_STATE();
    case 729:
      if (lookahead == 'b') ADVANCE(525);
      END_STATE();
    case 730:
      if (lookahead == 'b') ADVANCE(1069);
      END_STATE();
    case 731:
      if (lookahead == 'b') ADVANCE(1502);
      if (lookahead == 'p') ADVANCE(1502);
      END_STATE();
    case 732:
      if (lookahead == 'b') ADVANCE(1944);
      if (lookahead == 'c') ADVANCE(854);
      if (lookahead == 'p') ADVANCE(1021);
      END_STATE();
    case 733:
      if (lookahead == 'b') ADVANCE(1944);
      if (lookahead == 'p') ADVANCE(1021);
      END_STATE();
    case 734:
      if (lookahead == 'b') ADVANCE(1415);
      END_STATE();
    case 735:
      if (lookahead == 'b') ADVANCE(1418);
      END_STATE();
    case 736:
      if (lookahead == 'b') ADVANCE(1861);
      END_STATE();
    case 737:
      if (lookahead == 'b') ADVANCE(1421);
      END_STATE();
    case 738:
      if (lookahead == 'b') ADVANCE(1422);
      END_STATE();
    case 739:
      if (lookahead == 'b') ADVANCE(1436);
      END_STATE();
    case 740:
      if (lookahead == 'b') ADVANCE(648);
      END_STATE();
    case 741:
      if (lookahead == 'b') ADVANCE(1427);
      END_STATE();
    case 742:
      if (lookahead == 'b') ADVANCE(1428);
      END_STATE();
    case 743:
      if (lookahead == 'b') ADVANCE(1429);
      END_STATE();
    case 744:
      if (lookahead == 'b') ADVANCE(1947);
      if (lookahead == 'p') ADVANCE(1947);
      END_STATE();
    case 745:
      if (lookahead == 'c') ADVANCE(2129);
      END_STATE();
    case 746:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(2104);
      END_STATE();
    case 747:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(827);
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 748:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1440);
      if (lookahead == 'o') ADVANCE(1673);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 749:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'g') ADVANCE(1620);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 750:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'i') ADVANCE(1144);
      END_STATE();
    case 751:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'm') ADVANCE(287);
      END_STATE();
    case 752:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'x') ADVANCE(756);
      END_STATE();
    case 753:
      if (lookahead == 'c') ADVANCE(148);
      END_STATE();
    case 754:
      if (lookahead == 'c') ADVANCE(148);
      if (lookahead == 'i') ADVANCE(1741);
      END_STATE();
    case 755:
      if (lookahead == 'c') ADVANCE(318);
      if (lookahead == 'l') ADVANCE(922);
      if (lookahead == 'p') ADVANCE(329);
      if (lookahead == 'r') ADVANCE(1342);
      END_STATE();
    case 756:
      if (lookahead == 'c') ADVANCE(287);
      END_STATE();
    case 757:
      if (lookahead == 'c') ADVANCE(566);
      if (lookahead == 'd') ADVANCE(2007);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(396);
      if (lookahead == 'i') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(396);
      if (lookahead == 'm') ADVANCE(564);
      if (lookahead == 'n') ADVANCE(1250);
      if (lookahead == 'o') ADVANCE(869);
      if (lookahead == 'r') ADVANCE(396);
      if (lookahead == 's') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(1700);
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(957);
      END_STATE();
    case 758:
      if (lookahead == 'c') ADVANCE(566);
      if (lookahead == 'o') ADVANCE(870);
      if (lookahead == 's') ADVANCE(1735);
      if (lookahead == 't') ADVANCE(1891);
      if (lookahead == 'u') ADVANCE(1699);
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(957);
      END_STATE();
    case 759:
      if (lookahead == 'c') ADVANCE(1639);
      END_STATE();
    case 760:
      if (lookahead == 'c') ADVANCE(2161);
      if (lookahead == 'h') ADVANCE(745);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 761:
      if (lookahead == 'c') ADVANCE(2161);
      if (lookahead == 'o') ADVANCE(1349);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 762:
      if (lookahead == 'c') ADVANCE(231);
      if (lookahead == 'h') ADVANCE(1657);
      if (lookahead == 'i') ADVANCE(1471);
      if (lookahead == 'm') ADVANCE(1213);
      if (lookahead == 'p') ADVANCE(538);
      if (lookahead == 'q') ADVANCE(1928);
      if (lookahead == 'u') ADVANCE(713);
      END_STATE();
    case 763:
      if (lookahead == 'c') ADVANCE(923);
      if (lookahead == 'd') ADVANCE(1260);
      if (lookahead == 'e') ADVANCE(1472);
      if (lookahead == 'n') ADVANCE(1121);
      if (lookahead == 'q') ADVANCE(2045);
      if (lookahead == 'r') ADVANCE(1754);
      if (lookahead == 't') ADVANCE(671);
      END_STATE();
    case 764:
      if (lookahead == 'c') ADVANCE(2054);
      END_STATE();
    case 765:
      if (lookahead == 'c') ADVANCE(142);
      if (lookahead == 's') ADVANCE(1349);
      END_STATE();
    case 766:
      if (lookahead == 'c') ADVANCE(210);
      END_STATE();
    case 767:
      if (lookahead == 'c') ADVANCE(2156);
      END_STATE();
    case 768:
      if (lookahead == 'c') ADVANCE(918);
      END_STATE();
    case 769:
      if (lookahead == 'c') ADVANCE(1741);
      END_STATE();
    case 770:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'i') ADVANCE(1454);
      END_STATE();
    case 771:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(1463);
      if (lookahead == 'i') ADVANCE(1464);
      if (lookahead == 'o') ADVANCE(1353);
      END_STATE();
    case 772:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(1997);
      if (lookahead == 'm') ADVANCE(1303);
      if (lookahead == 't') ADVANCE(641);
      END_STATE();
    case 773:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(1774);
      END_STATE();
    case 774:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(919);
      if (lookahead == 't') ADVANCE(1174);
      END_STATE();
    case 775:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1273);
      END_STATE();
    case 776:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(148);
      END_STATE();
    case 777:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(148);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 778:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 779:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1454);
      END_STATE();
    case 780:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1459);
      END_STATE();
    case 781:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1500);
      END_STATE();
    case 782:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(571);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 783:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(1111);
      END_STATE();
    case 784:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(598);
      END_STATE();
    case 785:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(598);
      if (lookahead == 'o') ADVANCE(1349);
      END_STATE();
    case 786:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'q') ADVANCE(838);
      END_STATE();
    case 787:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(1256);
      END_STATE();
    case 788:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 't') ADVANCE(148);
      if (lookahead == 'y') ADVANCE(1479);
      END_STATE();
    case 789:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 't') ADVANCE(1709);
      END_STATE();
    case 790:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 791:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'u') ADVANCE(722);
      END_STATE();
    case 792:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'u') ADVANCE(731);
      END_STATE();
    case 793:
      if (lookahead == 'c') ADVANCE(524);
      if (lookahead == 'l') ADVANCE(903);
      if (lookahead == 'q') ADVANCE(2065);
      if (lookahead == 's') ADVANCE(1174);
      END_STATE();
    case 794:
      if (lookahead == 'c') ADVANCE(524);
      if (lookahead == 'q') ADVANCE(2065);
      if (lookahead == 'r') ADVANCE(904);
      if (lookahead == 's') ADVANCE(1174);
      END_STATE();
    case 795:
      if (lookahead == 'c') ADVANCE(1341);
      if (lookahead == 'r') ADVANCE(2100);
      END_STATE();
    case 796:
      if (lookahead == 'c') ADVANCE(1507);
      if (lookahead == 'i') ADVANCE(1578);
      if (lookahead == 'm') ADVANCE(1254);
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 't') ADVANCE(1010);
      END_STATE();
    case 797:
      if (lookahead == 'c') ADVANCE(610);
      if (lookahead == 's') ADVANCE(2046);
      if (lookahead == 'u') ADVANCE(209);
      END_STATE();
    case 798:
      if (lookahead == 'c') ADVANCE(1949);
      END_STATE();
    case 799:
      if (lookahead == 'c') ADVANCE(1332);
      if (lookahead == 'r') ADVANCE(2103);
      END_STATE();
    case 800:
      if (lookahead == 'c') ADVANCE(1281);
      if (lookahead == 's') ADVANCE(1248);
      if (lookahead == 'u') ADVANCE(617);
      if (lookahead == 'v') ADVANCE(1716);
      END_STATE();
    case 801:
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'e') ADVANCE(877);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(257);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 802:
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'e') ADVANCE(906);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 803:
      if (lookahead == 'c') ADVANCE(2053);
      END_STATE();
    case 804:
      if (lookahead == 'c') ADVANCE(2053);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 805:
      if (lookahead == 'c') ADVANCE(2053);
      if (lookahead == 'r') ADVANCE(1777);
      END_STATE();
    case 806:
      if (lookahead == 'c') ADVANCE(2053);
      if (lookahead == 's') ADVANCE(1949);
      END_STATE();
    case 807:
      if (lookahead == 'c') ADVANCE(2053);
      if (lookahead == 's') ADVANCE(2003);
      END_STATE();
    case 808:
      if (lookahead == 'c') ADVANCE(1668);
      if (lookahead == 'd') ADVANCE(1741);
      END_STATE();
    case 809:
      if (lookahead == 'c') ADVANCE(2086);
      END_STATE();
    case 810:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'e') ADVANCE(1472);
      if (lookahead == 'g') ADVANCE(1859);
      if (lookahead == 'm') ADVANCE(724);
      if (lookahead == 'n') ADVANCE(1119);
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(2045);
      if (lookahead == 'r') ADVANCE(1752);
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 811:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'm') ADVANCE(724);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'p') ADVANCE(1438);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 812:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'm') ADVANCE(1482);
      if (lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 813:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'r') ADVANCE(1787);
      END_STATE();
    case 814:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'p') ADVANCE(204);
      if (lookahead == 'r') ADVANCE(953);
      END_STATE();
    case 815:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'p') ADVANCE(282);
      if (lookahead == 'y') ADVANCE(1399);
      END_STATE();
    case 816:
      if (lookahead == 'c') ADVANCE(980);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 817:
      if (lookahead == 'c') ADVANCE(1620);
      END_STATE();
    case 818:
      if (lookahead == 'c') ADVANCE(1330);
      END_STATE();
    case 819:
      if (lookahead == 'c') ADVANCE(1339);
      END_STATE();
    case 820:
      if (lookahead == 'c') ADVANCE(1339);
      if (lookahead == 's') ADVANCE(954);
      END_STATE();
    case 821:
      if (lookahead == 'c') ADVANCE(1331);
      if (lookahead == 'n') ADVANCE(507);
      END_STATE();
    case 822:
      if (lookahead == 'c') ADVANCE(250);
      END_STATE();
    case 823:
      if (lookahead == 'c') ADVANCE(1207);
      END_STATE();
    case 824:
      if (lookahead == 'c') ADVANCE(1600);
      if (lookahead == 'i') ADVANCE(1507);
      END_STATE();
    case 825:
      if (lookahead == 'c') ADVANCE(1334);
      if (lookahead == 'n') ADVANCE(1330);
      END_STATE();
    case 826:
      if (lookahead == 'c') ADVANCE(564);
      END_STATE();
    case 827:
      if (lookahead == 'c') ADVANCE(1335);
      END_STATE();
    case 828:
      if (lookahead == 'c') ADVANCE(1349);
      if (lookahead == 'i') ADVANCE(1905);
      if (lookahead == 'p') ADVANCE(1049);
      END_STATE();
    case 829:
      if (lookahead == 'c') ADVANCE(1344);
      if (lookahead == 'n') ADVANCE(1914);
      END_STATE();
    case 830:
      if (lookahead == 'c') ADVANCE(672);
      if (lookahead == 'r') ADVANCE(1532);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 831:
      if (lookahead == 'c') ADVANCE(1336);
      if (lookahead == 'k') ADVANCE(2099);
      END_STATE();
    case 832:
      if (lookahead == 'c') ADVANCE(753);
      END_STATE();
    case 833:
      if (lookahead == 'c') ADVANCE(917);
      END_STATE();
    case 834:
      if (lookahead == 'c') ADVANCE(1188);
      END_STATE();
    case 835:
      if (lookahead == 'c') ADVANCE(1794);
      END_STATE();
    case 836:
      if (lookahead == 'c') ADVANCE(1794);
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'n') ADVANCE(2056);
      END_STATE();
    case 837:
      if (lookahead == 'c') ADVANCE(1914);
      END_STATE();
    case 838:
      if (lookahead == 'c') ADVANCE(2049);
      END_STATE();
    case 839:
      if (lookahead == 'c') ADVANCE(1948);
      END_STATE();
    case 840:
      if (lookahead == 'c') ADVANCE(591);
      END_STATE();
    case 841:
      if (lookahead == 'c') ADVANCE(1224);
      END_STATE();
    case 842:
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 843:
      if (lookahead == 'c') ADVANCE(1057);
      END_STATE();
    case 844:
      if (lookahead == 'c') ADVANCE(1783);
      if (lookahead == 'd') ADVANCE(200);
      if (lookahead == 'n') ADVANCE(2064);
      END_STATE();
    case 845:
      if (lookahead == 'c') ADVANCE(2035);
      END_STATE();
    case 846:
      if (lookahead == 'c') ADVANCE(2022);
      END_STATE();
    case 847:
      if (lookahead == 'c') ADVANCE(1053);
      END_STATE();
    case 848:
      if (lookahead == 'c') ADVANCE(2006);
      END_STATE();
    case 849:
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'm') ADVANCE(590);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(773);
      if (lookahead == 'u') ADVANCE(1337);
      END_STATE();
    case 850:
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(773);
      if (lookahead == 'u') ADVANCE(1337);
      END_STATE();
    case 851:
      if (lookahead == 'c') ADVANCE(1641);
      if (lookahead == 'i') ADVANCE(1516);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 852:
      if (lookahead == 'c') ADVANCE(1641);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 853:
      if (lookahead == 'c') ADVANCE(1343);
      END_STATE();
    case 854:
      if (lookahead == 'c') ADVANCE(1023);
      END_STATE();
    case 855:
      if (lookahead == 'c') ADVANCE(1023);
      if (lookahead == 'h') ADVANCE(513);
      END_STATE();
    case 856:
      if (lookahead == 'c') ADVANCE(630);
      END_STATE();
    case 857:
      if (lookahead == 'c') ADVANCE(1414);
      END_STATE();
    case 858:
      if (lookahead == 'c') ADVANCE(1838);
      if (lookahead == 'm') ADVANCE(1626);
      END_STATE();
    case 859:
      if (lookahead == 'c') ADVANCE(634);
      END_STATE();
    case 860:
      if (lookahead == 'c') ADVANCE(2021);
      END_STATE();
    case 861:
      if (lookahead == 'c') ADVANCE(1609);
      if (lookahead == 'e') ADVANCE(1667);
      if (lookahead == 'p') ADVANCE(1811);
      if (lookahead == 's') ADVANCE(1266);
      END_STATE();
    case 862:
      if (lookahead == 'c') ADVANCE(1398);
      END_STATE();
    case 863:
      if (lookahead == 'c') ADVANCE(637);
      END_STATE();
    case 864:
      if (lookahead == 'c') ADVANCE(675);
      if (lookahead == 'm') ADVANCE(1702);
      if (lookahead == 'p') ADVANCE(1909);
      if (lookahead == 'r') ADVANCE(1555);
      if (lookahead == 't') ADVANCE(2152);
      END_STATE();
    case 865:
      if (lookahead == 'c') ADVANCE(682);
      END_STATE();
    case 866:
      if (lookahead == 'c') ADVANCE(1081);
      END_STATE();
    case 867:
      if (lookahead == 'd') ADVANCE(1589);
      END_STATE();
    case 868:
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'i') ADVANCE(1431);
      if (lookahead == 'r') ADVANCE(1220);
      END_STATE();
    case 869:
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'p') ADVANCE(1088);
      if (lookahead == 't') ADVANCE(1291);
      END_STATE();
    case 870:
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 't') ADVANCE(1295);
      END_STATE();
    case 871:
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'r') ADVANCE(1220);
      END_STATE();
    case 872:
      if (lookahead == 'd') ADVANCE(148);
      END_STATE();
    case 873:
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(596);
      if (lookahead == 'p') ADVANCE(335);
      END_STATE();
    case 874:
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(917);
      END_STATE();
    case 875:
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'u') ADVANCE(287);
      END_STATE();
    case 876:
      if (lookahead == 'd') ADVANCE(205);
      if (lookahead == 'g') ADVANCE(242);
      END_STATE();
    case 877:
      if (lookahead == 'd') ADVANCE(717);
      if (lookahead == 'i') ADVANCE(1012);
      END_STATE();
    case 878:
      if (lookahead == 'd') ADVANCE(1435);
      END_STATE();
    case 879:
      if (lookahead == 'd') ADVANCE(506);
      END_STATE();
    case 880:
      if (lookahead == 'd') ADVANCE(482);
      END_STATE();
    case 881:
      if (lookahead == 'd') ADVANCE(472);
      END_STATE();
    case 882:
      if (lookahead == 'd') ADVANCE(524);
      END_STATE();
    case 883:
      if (lookahead == 'd') ADVANCE(745);
      if (lookahead == 'r') ADVANCE(229);
      END_STATE();
    case 884:
      if (lookahead == 'd') ADVANCE(274);
      END_STATE();
    case 885:
      if (lookahead == 'd') ADVANCE(190);
      END_STATE();
    case 886:
      if (lookahead == 'd') ADVANCE(996);
      if (lookahead == 'i') ADVANCE(1624);
      END_STATE();
    case 887:
      if (lookahead == 'd') ADVANCE(241);
      END_STATE();
    case 888:
      if (lookahead == 'd') ADVANCE(571);
      END_STATE();
    case 889:
      if (lookahead == 'd') ADVANCE(589);
      END_STATE();
    case 890:
      if (lookahead == 'd') ADVANCE(332);
      END_STATE();
    case 891:
      if (lookahead == 'd') ADVANCE(254);
      END_STATE();
    case 892:
      if (lookahead == 'd') ADVANCE(1257);
      END_STATE();
    case 893:
      if (lookahead == 'd') ADVANCE(1257);
      if (lookahead == 'l') ADVANCE(1447);
      END_STATE();
    case 894:
      if (lookahead == 'd') ADVANCE(917);
      END_STATE();
    case 895:
      if (lookahead == 'd') ADVANCE(2061);
      END_STATE();
    case 896:
      if (lookahead == 'd') ADVANCE(2061);
      if (lookahead == 'p') ADVANCE(1663);
      END_STATE();
    case 897:
      if (lookahead == 'd') ADVANCE(1215);
      END_STATE();
    case 898:
      if (lookahead == 'd') ADVANCE(1215);
      if (lookahead == 'm') ADVANCE(1702);
      if (lookahead == 'n') ADVANCE(336);
      END_STATE();
    case 899:
      if (lookahead == 'd') ADVANCE(1940);
      if (lookahead == 'u') ADVANCE(1184);
      END_STATE();
    case 900:
      if (lookahead == 'd') ADVANCE(931);
      END_STATE();
    case 901:
      if (lookahead == 'd') ADVANCE(1903);
      END_STATE();
    case 902:
      if (lookahead == 'd') ADVANCE(1996);
      END_STATE();
    case 903:
      if (lookahead == 'd') ADVANCE(1184);
      END_STATE();
    case 904:
      if (lookahead == 'd') ADVANCE(1184);
      if (lookahead == 'u') ADVANCE(1940);
      END_STATE();
    case 905:
      if (lookahead == 'd') ADVANCE(1290);
      if (lookahead == 'n') ADVANCE(2025);
      END_STATE();
    case 906:
      if (lookahead == 'd') ADVANCE(1136);
      END_STATE();
    case 907:
      if (lookahead == 'd') ADVANCE(1582);
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 908:
      if (lookahead == 'd') ADVANCE(1001);
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 909:
      if (lookahead == 'd') ADVANCE(997);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 910:
      if (lookahead == 'd') ADVANCE(1014);
      END_STATE();
    case 911:
      if (lookahead == 'd') ADVANCE(1605);
      END_STATE();
    case 912:
      if (lookahead == 'd') ADVANCE(1254);
      END_STATE();
    case 913:
      if (lookahead == 'd') ADVANCE(1254);
      if (lookahead == 'i') ADVANCE(1349);
      END_STATE();
    case 914:
      if (lookahead == 'd') ADVANCE(1016);
      END_STATE();
    case 915:
      if (lookahead == 'd') ADVANCE(636);
      if (lookahead == 'e') ADVANCE(1684);
      if (lookahead == 'l') ADVANCE(657);
      if (lookahead == 'p') ADVANCE(220);
      if (lookahead == 'r') ADVANCE(664);
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(916);
      END_STATE();
    case 916:
      if (lookahead == 'e') ADVANCE(872);
      END_STATE();
    case 917:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 918:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'k') ADVANCE(952);
      END_STATE();
    case 919:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(1263);
      if (lookahead == 'p') ADVANCE(643);
      END_STATE();
    case 920:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(720);
      END_STATE();
    case 921:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1355);
      END_STATE();
    case 922:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 't') ADVANCE(259);
      END_STATE();
    case 923:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'u') ADVANCE(1998);
      END_STATE();
    case 924:
      if (lookahead == 'e') ADVANCE(432);
      END_STATE();
    case 925:
      if (lookahead == 'e') ADVANCE(297);
      END_STATE();
    case 926:
      if (lookahead == 'e') ADVANCE(2104);
      END_STATE();
    case 927:
      if (lookahead == 'e') ADVANCE(2104);
      if (lookahead == 'v') ADVANCE(729);
      END_STATE();
    case 928:
      if (lookahead == 'e') ADVANCE(1096);
      if (lookahead == 'p') ADVANCE(1177);
      END_STATE();
    case 929:
      if (lookahead == 'e') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(1949);
      END_STATE();
    case 930:
      if (lookahead == 'e') ADVANCE(219);
      if (lookahead == 'l') ADVANCE(1406);
      if (lookahead == 'r') ADVANCE(719);
      END_STATE();
    case 931:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 932:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 933:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 934:
      if (lookahead == 'e') ADVANCE(433);
      END_STATE();
    case 935:
      if (lookahead == 'e') ADVANCE(431);
      END_STATE();
    case 936:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 937:
      if (lookahead == 'e') ADVANCE(695);
      END_STATE();
    case 938:
      if (lookahead == 'e') ADVANCE(1485);
      END_STATE();
    case 939:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 940:
      if (lookahead == 'e') ADVANCE(459);
      END_STATE();
    case 941:
      if (lookahead == 'e') ADVANCE(490);
      END_STATE();
    case 942:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 943:
      if (lookahead == 'e') ADVANCE(426);
      END_STATE();
    case 944:
      if (lookahead == 'e') ADVANCE(518);
      END_STATE();
    case 945:
      if (lookahead == 'e') ADVANCE(155);
      END_STATE();
    case 946:
      if (lookahead == 'e') ADVANCE(237);
      END_STATE();
    case 947:
      if (lookahead == 'e') ADVANCE(500);
      END_STATE();
    case 948:
      if (lookahead == 'e') ADVANCE(1741);
      END_STATE();
    case 949:
      if (lookahead == 'e') ADVANCE(524);
      if (lookahead == 'p') ADVANCE(213);
      if (lookahead == 's') ADVANCE(524);
      END_STATE();
    case 950:
      if (lookahead == 'e') ADVANCE(1507);
      END_STATE();
    case 951:
      if (lookahead == 'e') ADVANCE(1827);
      if (lookahead == 'i') ADVANCE(821);
      END_STATE();
    case 952:
      if (lookahead == 'e') ADVANCE(1949);
      END_STATE();
    case 953:
      if (lookahead == 'e') ADVANCE(1949);
      if (lookahead == 'o') ADVANCE(1495);
      END_STATE();
    case 954:
      if (lookahead == 'e') ADVANCE(429);
      END_STATE();
    case 955:
      if (lookahead == 'e') ADVANCE(420);
      END_STATE();
    case 956:
      if (lookahead == 'e') ADVANCE(2145);
      END_STATE();
    case 957:
      if (lookahead == 'e') ADVANCE(906);
      END_STATE();
    case 958:
      if (lookahead == 'e') ADVANCE(1843);
      if (lookahead == 'i') ADVANCE(829);
      if (lookahead == 'k') ADVANCE(567);
      if (lookahead == 'o') ADVANCE(1743);
      END_STATE();
    case 959:
      if (lookahead == 'e') ADVANCE(1097);
      END_STATE();
    case 960:
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 961:
      if (lookahead == 'e') ADVANCE(461);
      END_STATE();
    case 962:
      if (lookahead == 'e') ADVANCE(508);
      END_STATE();
    case 963:
      if (lookahead == 'e') ADVANCE(1920);
      END_STATE();
    case 964:
      if (lookahead == 'e') ADVANCE(1723);
      END_STATE();
    case 965:
      if (lookahead == 'e') ADVANCE(907);
      END_STATE();
    case 966:
      if (lookahead == 'e') ADVANCE(538);
      END_STATE();
    case 967:
      if (lookahead == 'e') ADVANCE(538);
      if (lookahead == 'i') ADVANCE(1454);
      END_STATE();
    case 968:
      if (lookahead == 'e') ADVANCE(450);
      END_STATE();
    case 969:
      if (lookahead == 'e') ADVANCE(1101);
      END_STATE();
    case 970:
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 971:
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 972:
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 973:
      if (lookahead == 'e') ADVANCE(2141);
      END_STATE();
    case 974:
      if (lookahead == 'e') ADVANCE(405);
      END_STATE();
    case 975:
      if (lookahead == 'e') ADVANCE(1727);
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(957);
      END_STATE();
    case 976:
      if (lookahead == 'e') ADVANCE(430);
      END_STATE();
    case 977:
      if (lookahead == 'e') ADVANCE(1092);
      END_STATE();
    case 978:
      if (lookahead == 'e') ADVANCE(325);
      END_STATE();
    case 979:
      if (lookahead == 'e') ADVANCE(1729);
      END_STATE();
    case 980:
      if (lookahead == 'e') ADVANCE(1330);
      END_STATE();
    case 981:
      if (lookahead == 'e') ADVANCE(1508);
      END_STATE();
    case 982:
      if (lookahead == 'e') ADVANCE(1728);
      END_STATE();
    case 983:
      if (lookahead == 'e') ADVANCE(1970);
      END_STATE();
    case 984:
      if (lookahead == 'e') ADVANCE(1894);
      END_STATE();
    case 985:
      if (lookahead == 'e') ADVANCE(1905);
      END_STATE();
    case 986:
      if (lookahead == 'e') ADVANCE(1988);
      END_STATE();
    case 987:
      if (lookahead == 'e') ADVANCE(1349);
      END_STATE();
    case 988:
      if (lookahead == 'e') ADVANCE(879);
      END_STATE();
    case 989:
      if (lookahead == 'e') ADVANCE(690);
      END_STATE();
    case 990:
      if (lookahead == 'e') ADVANCE(881);
      END_STATE();
    case 991:
      if (lookahead == 'e') ADVANCE(1495);
      END_STATE();
    case 992:
      if (lookahead == 'e') ADVANCE(753);
      END_STATE();
    case 993:
      if (lookahead == 'e') ADVANCE(884);
      END_STATE();
    case 994:
      if (lookahead == 'e') ADVANCE(917);
      END_STATE();
    case 995:
      if (lookahead == 'e') ADVANCE(901);
      END_STATE();
    case 996:
      if (lookahead == 'e') ADVANCE(1749);
      END_STATE();
    case 997:
      if (lookahead == 'e') ADVANCE(1900);
      END_STATE();
    case 998:
      if (lookahead == 'e') ADVANCE(1667);
      if (lookahead == 'k') ADVANCE(562);
      if (lookahead == 'n') ADVANCE(1635);
      if (lookahead == 'p') ADVANCE(1183);
      if (lookahead == 'r') ADVANCE(277);
      if (lookahead == 's') ADVANCE(1229);
      if (lookahead == 't') ADVANCE(1200);
      END_STATE();
    case 999:
      if (lookahead == 'e') ADVANCE(1667);
      if (lookahead == 'p') ADVANCE(1182);
      END_STATE();
    case 1000:
      if (lookahead == 'e') ADVANCE(1911);
      END_STATE();
    case 1001:
      if (lookahead == 'e') ADVANCE(1385);
      END_STATE();
    case 1002:
      if (lookahead == 'e') ADVANCE(860);
      END_STATE();
    case 1003:
      if (lookahead == 'e') ADVANCE(1549);
      END_STATE();
    case 1004:
      if (lookahead == 'e') ADVANCE(1942);
      END_STATE();
    case 1005:
      if (lookahead == 'e') ADVANCE(1994);
      END_STATE();
    case 1006:
      if (lookahead == 'e') ADVANCE(1913);
      END_STATE();
    case 1007:
      if (lookahead == 'e') ADVANCE(1972);
      END_STATE();
    case 1008:
      if (lookahead == 'e') ADVANCE(573);
      END_STATE();
    case 1009:
      if (lookahead == 'e') ADVANCE(932);
      END_STATE();
    case 1010:
      if (lookahead == 'e') ADVANCE(1521);
      END_STATE();
    case 1011:
      if (lookahead == 'e') ADVANCE(1412);
      END_STATE();
    case 1012:
      if (lookahead == 'e') ADVANCE(1789);
      END_STATE();
    case 1013:
      if (lookahead == 'e') ADVANCE(611);
      END_STATE();
    case 1014:
      if (lookahead == 'e') ADVANCE(1903);
      END_STATE();
    case 1015:
      if (lookahead == 'e') ADVANCE(595);
      END_STATE();
    case 1016:
      if (lookahead == 'e') ADVANCE(1904);
      END_STATE();
    case 1017:
      if (lookahead == 'e') ADVANCE(1959);
      if (lookahead == 'i') ADVANCE(1454);
      if (lookahead == 'u') ADVANCE(2153);
      END_STATE();
    case 1018:
      if (lookahead == 'e') ADVANCE(1755);
      END_STATE();
    case 1019:
      if (lookahead == 'e') ADVANCE(1862);
      END_STATE();
    case 1020:
      if (lookahead == 'e') ADVANCE(1995);
      END_STATE();
    case 1021:
      if (lookahead == 'e') ADVANCE(1826);
      END_STATE();
    case 1022:
      if (lookahead == 'e') ADVANCE(2002);
      END_STATE();
    case 1023:
      if (lookahead == 'e') ADVANCE(995);
      END_STATE();
    case 1024:
      if (lookahead == 'e') ADVANCE(939);
      if (lookahead == 'r') ADVANCE(1326);
      END_STATE();
    case 1025:
      if (lookahead == 'e') ADVANCE(1742);
      END_STATE();
    case 1026:
      if (lookahead == 'e') ADVANCE(1836);
      if (lookahead == 'i') ADVANCE(1507);
      END_STATE();
    case 1027:
      if (lookahead == 'e') ADVANCE(1786);
      END_STATE();
    case 1028:
      if (lookahead == 'e') ADVANCE(1864);
      END_STATE();
    case 1029:
      if (lookahead == 'e') ADVANCE(1884);
      END_STATE();
    case 1030:
      if (lookahead == 'e') ADVANCE(944);
      END_STATE();
    case 1031:
      if (lookahead == 'e') ADVANCE(1799);
      END_STATE();
    case 1032:
      if (lookahead == 'e') ADVANCE(1071);
      END_STATE();
    case 1033:
      if (lookahead == 'e') ADVANCE(1796);
      END_STATE();
    case 1034:
      if (lookahead == 'e') ADVANCE(1759);
      END_STATE();
    case 1035:
      if (lookahead == 'e') ADVANCE(1804);
      END_STATE();
    case 1036:
      if (lookahead == 'e') ADVANCE(1762);
      END_STATE();
    case 1037:
      if (lookahead == 'e') ADVANCE(1102);
      END_STATE();
    case 1038:
      if (lookahead == 'e') ADVANCE(2106);
      if (lookahead == 'i') ADVANCE(1149);
      END_STATE();
    case 1039:
      if (lookahead == 'e') ADVANCE(1419);
      END_STATE();
    case 1040:
      if (lookahead == 'e') ADVANCE(517);
      END_STATE();
    case 1041:
      if (lookahead == 'e') ADVANCE(889);
      END_STATE();
    case 1042:
      if (lookahead == 'e') ADVANCE(669);
      if (lookahead == 'w') ADVANCE(669);
      END_STATE();
    case 1043:
      if (lookahead == 'e') ADVANCE(1099);
      END_STATE();
    case 1044:
      if (lookahead == 'e') ADVANCE(1099);
      if (lookahead == 'l') ADVANCE(148);
      if (lookahead == 't') ADVANCE(345);
      END_STATE();
    case 1045:
      if (lookahead == 'e') ADVANCE(991);
      END_STATE();
    case 1046:
      if (lookahead == 'e') ADVANCE(1931);
      END_STATE();
    case 1047:
      if (lookahead == 'e') ADVANCE(892);
      END_STATE();
    case 1048:
      if (lookahead == 'e') ADVANCE(1484);
      END_STATE();
    case 1049:
      if (lookahead == 'e') ADVANCE(845);
      if (lookahead == 'o') ADVANCE(1565);
      END_STATE();
    case 1050:
      if (lookahead == 'e') ADVANCE(658);
      END_STATE();
    case 1051:
      if (lookahead == 'e') ADVANCE(1720);
      END_STATE();
    case 1052:
      if (lookahead == 'e') ADVANCE(1824);
      END_STATE();
    case 1053:
      if (lookahead == 'e') ADVANCE(2017);
      END_STATE();
    case 1054:
      if (lookahead == 'e') ADVANCE(2017);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1055:
      if (lookahead == 'e') ADVANCE(740);
      END_STATE();
    case 1056:
      if (lookahead == 'e') ADVANCE(1103);
      END_STATE();
    case 1057:
      if (lookahead == 'e') ADVANCE(910);
      END_STATE();
    case 1058:
      if (lookahead == 'e') ADVANCE(846);
      END_STATE();
    case 1059:
      if (lookahead == 'e') ADVANCE(1921);
      END_STATE();
    case 1060:
      if (lookahead == 'e') ADVANCE(1707);
      END_STATE();
    case 1061:
      if (lookahead == 'e') ADVANCE(1104);
      END_STATE();
    case 1062:
      if (lookahead == 'e') ADVANCE(1823);
      if (lookahead == 'n') ADVANCE(455);
      END_STATE();
    case 1063:
      if (lookahead == 'e') ADVANCE(848);
      END_STATE();
    case 1064:
      if (lookahead == 'e') ADVANCE(1575);
      END_STATE();
    case 1065:
      if (lookahead == 'e') ADVANCE(1105);
      END_STATE();
    case 1066:
      if (lookahead == 'e') ADVANCE(1106);
      END_STATE();
    case 1067:
      if (lookahead == 'e') ADVANCE(1558);
      END_STATE();
    case 1068:
      if (lookahead == 'e') ADVANCE(1107);
      if (lookahead == 'o') ADVANCE(1535);
      END_STATE();
    case 1069:
      if (lookahead == 'e') ADVANCE(1842);
      END_STATE();
    case 1070:
      if (lookahead == 'e') ADVANCE(1100);
      END_STATE();
    case 1071:
      if (lookahead == 'e') ADVANCE(2036);
      END_STATE();
    case 1072:
      if (lookahead == 'e') ADVANCE(1889);
      END_STATE();
    case 1073:
      if (lookahead == 'e') ADVANCE(1543);
      END_STATE();
    case 1074:
      if (lookahead == 'e') ADVANCE(694);
      END_STATE();
    case 1075:
      if (lookahead == 'e') ADVANCE(1453);
      END_STATE();
    case 1076:
      if (lookahead == 'e') ADVANCE(1151);
      END_STATE();
    case 1077:
      if (lookahead == 'e') ADVANCE(1886);
      END_STATE();
    case 1078:
      if (lookahead == 'e') ADVANCE(2023);
      END_STATE();
    case 1079:
      if (lookahead == 'e') ADVANCE(1302);
      END_STATE();
    case 1080:
      if (lookahead == 'e') ADVANCE(1869);
      END_STATE();
    case 1081:
      if (lookahead == 'e') ADVANCE(914);
      END_STATE();
    case 1082:
      if (lookahead == 'e') ADVANCE(693);
      END_STATE();
    case 1083:
      if (lookahead == 'e') ADVANCE(1518);
      END_STATE();
    case 1084:
      if (lookahead == 'e') ADVANCE(698);
      END_STATE();
    case 1085:
      if (lookahead == 'e') ADVANCE(866);
      END_STATE();
    case 1086:
      if (lookahead == 'e') ADVANCE(1110);
      END_STATE();
    case 1087:
      if (lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 1088:
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(2056);
      END_STATE();
    case 1089:
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1615);
      END_STATE();
    case 1090:
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(148);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 1091:
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1507);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(1811);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(593);
      END_STATE();
    case 1092:
      if (lookahead == 'f') ADVANCE(1949);
      END_STATE();
    case 1093:
      if (lookahead == 'f') ADVANCE(1098);
      END_STATE();
    case 1094:
      if (lookahead == 'f') ADVANCE(1952);
      if (lookahead == 's') ADVANCE(1897);
      END_STATE();
    case 1095:
      if (lookahead == 'f') ADVANCE(1975);
      if (lookahead == 'l') ADVANCE(216);
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 1096:
      if (lookahead == 'f') ADVANCE(1916);
      if (lookahead == 'p') ADVANCE(1174);
      END_STATE();
    case 1097:
      if (lookahead == 'f') ADVANCE(2040);
      END_STATE();
    case 1098:
      if (lookahead == 'f') ADVANCE(1072);
      END_STATE();
    case 1099:
      if (lookahead == 'f') ADVANCE(1979);
      END_STATE();
    case 1100:
      if (lookahead == 'f') ADVANCE(1994);
      END_STATE();
    case 1101:
      if (lookahead == 'f') ADVANCE(1659);
      END_STATE();
    case 1102:
      if (lookahead == 'f') ADVANCE(1986);
      if (lookahead == 's') ADVANCE(1902);
      END_STATE();
    case 1103:
      if (lookahead == 'f') ADVANCE(1961);
      END_STATE();
    case 1104:
      if (lookahead == 'f') ADVANCE(1963);
      END_STATE();
    case 1105:
      if (lookahead == 'f') ADVANCE(1981);
      END_STATE();
    case 1106:
      if (lookahead == 'f') ADVANCE(2019);
      END_STATE();
    case 1107:
      if (lookahead == 'f') ADVANCE(1967);
      END_STATE();
    case 1108:
      if (lookahead == 'f') ADVANCE(1619);
      END_STATE();
    case 1109:
      if (lookahead == 'f') ADVANCE(1258);
      END_STATE();
    case 1110:
      if (lookahead == 'f') ADVANCE(2039);
      END_STATE();
    case 1111:
      if (lookahead == 'g') ADVANCE(148);
      END_STATE();
    case 1112:
      if (lookahead == 'g') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1668);
      END_STATE();
    case 1113:
      if (lookahead == 'g') ADVANCE(148);
      if (lookahead == 't') ADVANCE(345);
      END_STATE();
    case 1114:
      if (lookahead == 'g') ADVANCE(758);
      END_STATE();
    case 1115:
      if (lookahead == 'g') ADVANCE(233);
      END_STATE();
    case 1116:
      if (lookahead == 'g') ADVANCE(233);
      if (lookahead == 'i') ADVANCE(1507);
      END_STATE();
    case 1117:
      if (lookahead == 'g') ADVANCE(488);
      END_STATE();
    case 1118:
      if (lookahead == 'g') ADVANCE(507);
      END_STATE();
    case 1119:
      if (lookahead == 'g') ADVANCE(236);
      END_STATE();
    case 1120:
      if (lookahead == 'g') ADVANCE(1452);
      END_STATE();
    case 1121:
      if (lookahead == 'g') ADVANCE(360);
      END_STATE();
    case 1122:
      if (lookahead == 'g') ADVANCE(524);
      END_STATE();
    case 1123:
      if (lookahead == 'g') ADVANCE(1190);
      END_STATE();
    case 1124:
      if (lookahead == 'g') ADVANCE(2144);
      END_STATE();
    case 1125:
      if (lookahead == 'g') ADVANCE(1137);
      if (lookahead == 'l') ADVANCE(986);
      if (lookahead == 'r') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(1178);
      END_STATE();
    case 1126:
      if (lookahead == 'g') ADVANCE(1137);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 1127:
      if (lookahead == 'g') ADVANCE(1137);
      if (lookahead == 'r') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(1180);
      END_STATE();
    case 1128:
      if (lookahead == 'g') ADVANCE(1581);
      END_STATE();
    case 1129:
      if (lookahead == 'g') ADVANCE(1620);
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 1130:
      if (lookahead == 'g') ADVANCE(1620);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1131:
      if (lookahead == 'g') ADVANCE(1461);
      END_STATE();
    case 1132:
      if (lookahead == 'g') ADVANCE(1179);
      END_STATE();
    case 1133:
      if (lookahead == 'g') ADVANCE(1349);
      if (lookahead == 'i') ADVANCE(1381);
      if (lookahead == 'l') ADVANCE(1111);
      if (lookahead == 'r') ADVANCE(1322);
      END_STATE();
    case 1134:
      if (lookahead == 'g') ADVANCE(667);
      if (lookahead == 's') ADVANCE(2005);
      if (lookahead == 'w') ADVANCE(486);
      END_STATE();
    case 1135:
      if (lookahead == 'g') ADVANCE(1495);
      END_STATE();
    case 1136:
      if (lookahead == 'g') ADVANCE(917);
      END_STATE();
    case 1137:
      if (lookahead == 'g') ADVANCE(948);
      END_STATE();
    case 1138:
      if (lookahead == 'g') ADVANCE(952);
      END_STATE();
    case 1139:
      if (lookahead == 'g') ADVANCE(1868);
      END_STATE();
    case 1140:
      if (lookahead == 'g') ADVANCE(1868);
      if (lookahead == 'i') ADVANCE(1507);
      if (lookahead == 't') ADVANCE(1649);
      END_STATE();
    case 1141:
      if (lookahead == 'g') ADVANCE(1766);
      END_STATE();
    case 1142:
      if (lookahead == 'g') ADVANCE(1193);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 's') ADVANCE(1292);
      END_STATE();
    case 1143:
      if (lookahead == 'g') ADVANCE(911);
      END_STATE();
    case 1144:
      if (lookahead == 'g') ADVANCE(1775);
      END_STATE();
    case 1145:
      if (lookahead == 'g') ADVANCE(1189);
      END_STATE();
    case 1146:
      if (lookahead == 'g') ADVANCE(1969);
      END_STATE();
    case 1147:
      if (lookahead == 'g') ADVANCE(1969);
      if (lookahead == 'l') ADVANCE(963);
      END_STATE();
    case 1148:
      if (lookahead == 'g') ADVANCE(1969);
      if (lookahead == 'q') ADVANCE(1146);
      END_STATE();
    case 1149:
      if (lookahead == 'g') ADVANCE(1194);
      END_STATE();
    case 1150:
      if (lookahead == 'g') ADVANCE(1487);
      if (lookahead == 'm') ADVANCE(234);
      END_STATE();
    case 1151:
      if (lookahead == 'g') ADVANCE(1819);
      END_STATE();
    case 1152:
      if (lookahead == 'g') ADVANCE(1819);
      if (lookahead == 'r') ADVANCE(1936);
      END_STATE();
    case 1153:
      if (lookahead == 'g') ADVANCE(1195);
      END_STATE();
    case 1154:
      if (lookahead == 'g') ADVANCE(1197);
      END_STATE();
    case 1155:
      if (lookahead == 'g') ADVANCE(1198);
      END_STATE();
    case 1156:
      if (lookahead == 'g') ADVANCE(1199);
      END_STATE();
    case 1157:
      if (lookahead == 'g') ADVANCE(1398);
      END_STATE();
    case 1158:
      if (lookahead == 'g') ADVANCE(1201);
      END_STATE();
    case 1159:
      if (lookahead == 'g') ADVANCE(1031);
      if (lookahead == 'r') ADVANCE(840);
      END_STATE();
    case 1160:
      if (lookahead == 'g') ADVANCE(1202);
      END_STATE();
    case 1161:
      if (lookahead == 'g') ADVANCE(1203);
      END_STATE();
    case 1162:
      if (lookahead == 'g') ADVANCE(1420);
      END_STATE();
    case 1163:
      if (lookahead == 'g') ADVANCE(1192);
      END_STATE();
    case 1164:
      if (lookahead == 'g') ADVANCE(1422);
      END_STATE();
    case 1165:
      if (lookahead == 'g') ADVANCE(1423);
      END_STATE();
    case 1166:
      if (lookahead == 'g') ADVANCE(1424);
      END_STATE();
    case 1167:
      if (lookahead == 'g') ADVANCE(1437);
      END_STATE();
    case 1168:
      if (lookahead == 'g') ADVANCE(1425);
      END_STATE();
    case 1169:
      if (lookahead == 'g') ADVANCE(1426);
      END_STATE();
    case 1170:
      if (lookahead == 'g') ADVANCE(487);
      END_STATE();
    case 1171:
      if (lookahead == 'g') ADVANCE(685);
      END_STATE();
    case 1172:
      if (lookahead == 'g') ADVANCE(1212);
      END_STATE();
    case 1173:
      if (lookahead == 'h') ADVANCE(872);
      END_STATE();
    case 1174:
      if (lookahead == 'h') ADVANCE(148);
      END_STATE();
    case 1175:
      if (lookahead == 'h') ADVANCE(287);
      END_STATE();
    case 1176:
      if (lookahead == 'h') ADVANCE(507);
      END_STATE();
    case 1177:
      if (lookahead == 'h') ADVANCE(524);
      END_STATE();
    case 1178:
      if (lookahead == 'h') ADVANCE(345);
      END_STATE();
    case 1179:
      if (lookahead == 'h') ADVANCE(1949);
      END_STATE();
    case 1180:
      if (lookahead == 'h') ADVANCE(2099);
      END_STATE();
    case 1181:
      if (lookahead == 'h') ADVANCE(745);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1182:
      if (lookahead == 'h') ADVANCE(1214);
      END_STATE();
    case 1183:
      if (lookahead == 'h') ADVANCE(1214);
      if (lookahead == 'i') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1648);
      END_STATE();
    case 1184:
      if (lookahead == 'h') ADVANCE(538);
      END_STATE();
    case 1185:
      if (lookahead == 'h') ADVANCE(1668);
      END_STATE();
    case 1186:
      if (lookahead == 'h') ADVANCE(1330);
      END_STATE();
    case 1187:
      if (lookahead == 'h') ADVANCE(1330);
      if (lookahead == 'r') ADVANCE(304);
      END_STATE();
    case 1188:
      if (lookahead == 'h') ADVANCE(917);
      END_STATE();
    case 1189:
      if (lookahead == 'h') ADVANCE(2040);
      END_STATE();
    case 1190:
      if (lookahead == 'h') ADVANCE(1956);
      END_STATE();
    case 1191:
      if (lookahead == 'h') ADVANCE(548);
      END_STATE();
    case 1192:
      if (lookahead == 'h') ADVANCE(1994);
      END_STATE();
    case 1193:
      if (lookahead == 'h') ADVANCE(1958);
      END_STATE();
    case 1194:
      if (lookahead == 'h') ADVANCE(1986);
      END_STATE();
    case 1195:
      if (lookahead == 'h') ADVANCE(1971);
      END_STATE();
    case 1196:
      if (lookahead == 'h') ADVANCE(1217);
      END_STATE();
    case 1197:
      if (lookahead == 'h') ADVANCE(1962);
      END_STATE();
    case 1198:
      if (lookahead == 'h') ADVANCE(1964);
      END_STATE();
    case 1199:
      if (lookahead == 'h') ADVANCE(1981);
      END_STATE();
    case 1200:
      if (lookahead == 'h') ADVANCE(983);
      if (lookahead == 'r') ADVANCE(1325);
      END_STATE();
    case 1201:
      if (lookahead == 'h') ADVANCE(1966);
      END_STATE();
    case 1202:
      if (lookahead == 'h') ADVANCE(1968);
      END_STATE();
    case 1203:
      if (lookahead == 'h') ADVANCE(1965);
      END_STATE();
    case 1204:
      if (lookahead == 'h') ADVANCE(1059);
      END_STATE();
    case 1205:
      if (lookahead == 'h') ADVANCE(1251);
      END_STATE();
    case 1206:
      if (lookahead == 'h') ADVANCE(991);
      END_STATE();
    case 1207:
      if (lookahead == 'h') ADVANCE(1108);
      END_STATE();
    case 1208:
      if (lookahead == 'h') ADVANCE(1790);
      if (lookahead == 'i') ADVANCE(1488);
      if (lookahead == 'r') ADVANCE(1222);
      END_STATE();
    case 1209:
      if (lookahead == 'h') ADVANCE(1013);
      END_STATE();
    case 1210:
      if (lookahead == 'h') ADVANCE(1275);
      END_STATE();
    case 1211:
      if (lookahead == 'h') ADVANCE(1871);
      END_STATE();
    case 1212:
      if (lookahead == 'h') ADVANCE(2039);
      END_STATE();
    case 1213:
      if (lookahead == 'i') ADVANCE(872);
      END_STATE();
    case 1214:
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 1215:
      if (lookahead == 'i') ADVANCE(287);
      END_STATE();
    case 1216:
      if (lookahead == 'i') ADVANCE(271);
      END_STATE();
    case 1217:
      if (lookahead == 'i') ADVANCE(821);
      END_STATE();
    case 1218:
      if (lookahead == 'i') ADVANCE(2127);
      if (lookahead == 'o') ADVANCE(1209);
      END_STATE();
    case 1219:
      if (lookahead == 'i') ADVANCE(2143);
      END_STATE();
    case 1220:
      if (lookahead == 'i') ADVANCE(265);
      END_STATE();
    case 1221:
      if (lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 1222:
      if (lookahead == 'i') ADVANCE(362);
      END_STATE();
    case 1223:
      if (lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 1224:
      if (lookahead == 'i') ADVANCE(1741);
      END_STATE();
    case 1225:
      if (lookahead == 'i') ADVANCE(1741);
      if (lookahead == 'r') ADVANCE(1595);
      END_STATE();
    case 1226:
      if (lookahead == 'i') ADVANCE(1507);
      END_STATE();
    case 1227:
      if (lookahead == 'i') ADVANCE(1507);
      if (lookahead == 'n') ADVANCE(1949);
      END_STATE();
    case 1228:
      if (lookahead == 'i') ADVANCE(345);
      if (lookahead == 'm') ADVANCE(1486);
      if (lookahead == 'o') ADVANCE(1529);
      END_STATE();
    case 1229:
      if (lookahead == 'i') ADVANCE(1131);
      if (lookahead == 'u') ADVANCE(744);
      END_STATE();
    case 1230:
      if (lookahead == 'i') ADVANCE(1382);
      END_STATE();
    case 1231:
      if (lookahead == 'i') ADVANCE(290);
      END_STATE();
    case 1232:
      if (lookahead == 'i') ADVANCE(1949);
      END_STATE();
    case 1233:
      if (lookahead == 'i') ADVANCE(2099);
      END_STATE();
    case 1234:
      if (lookahead == 'i') ADVANCE(867);
      END_STATE();
    case 1235:
      if (lookahead == 'i') ADVANCE(867);
      if (lookahead == 'o') ADVANCE(2083);
      END_STATE();
    case 1236:
      if (lookahead == 'i') ADVANCE(1496);
      END_STATE();
    case 1237:
      if (lookahead == 'i') ADVANCE(346);
      END_STATE();
    case 1238:
      if (lookahead == 'i') ADVANCE(1943);
      END_STATE();
    case 1239:
      if (lookahead == 'i') ADVANCE(1943);
      if (lookahead == 'p') ADVANCE(1623);
      END_STATE();
    case 1240:
      if (lookahead == 'i') ADVANCE(241);
      END_STATE();
    case 1241:
      if (lookahead == 'i') ADVANCE(1377);
      END_STATE();
    case 1242:
      if (lookahead == 'i') ADVANCE(1668);
      END_STATE();
    case 1243:
      if (lookahead == 'i') ADVANCE(1111);
      END_STATE();
    case 1244:
      if (lookahead == 'i') ADVANCE(1111);
      if (lookahead == 'l') ADVANCE(1243);
      END_STATE();
    case 1245:
      if (lookahead == 'i') ADVANCE(1093);
      END_STATE();
    case 1246:
      if (lookahead == 'i') ADVANCE(1454);
      END_STATE();
    case 1247:
      if (lookahead == 'i') ADVANCE(1454);
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 1248:
      if (lookahead == 'i') ADVANCE(1454);
      if (lookahead == 'l') ADVANCE(665);
      END_STATE();
    case 1249:
      if (lookahead == 'i') ADVANCE(1620);
      END_STATE();
    case 1250:
      if (lookahead == 'i') ADVANCE(1894);
      END_STATE();
    case 1251:
      if (lookahead == 'i') ADVANCE(1516);
      END_STATE();
    case 1252:
      if (lookahead == 'i') ADVANCE(1919);
      if (lookahead == 'l') ADVANCE(1629);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 1253:
      if (lookahead == 'i') ADVANCE(1919);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 1254:
      if (lookahead == 'i') ADVANCE(1349);
      END_STATE();
    case 1255:
      if (lookahead == 'i') ADVANCE(1124);
      END_STATE();
    case 1256:
      if (lookahead == 'i') ADVANCE(1135);
      END_STATE();
    case 1257:
      if (lookahead == 'i') ADVANCE(2060);
      END_STATE();
    case 1258:
      if (lookahead == 'i') ADVANCE(1495);
      END_STATE();
    case 1259:
      if (lookahead == 'i') ADVANCE(1379);
      END_STATE();
    case 1260:
      if (lookahead == 'i') ADVANCE(753);
      END_STATE();
    case 1261:
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1262:
      if (lookahead == 'i') ADVANCE(917);
      END_STATE();
    case 1263:
      if (lookahead == 'i') ADVANCE(1529);
      END_STATE();
    case 1264:
      if (lookahead == 'i') ADVANCE(679);
      END_STATE();
    case 1265:
      if (lookahead == 'i') ADVANCE(902);
      END_STATE();
    case 1266:
      if (lookahead == 'i') ADVANCE(1473);
      END_STATE();
    case 1267:
      if (lookahead == 'i') ADVANCE(1171);
      END_STATE();
    case 1268:
      if (lookahead == 'i') ADVANCE(1815);
      if (lookahead == 'l') ADVANCE(1087);
      if (lookahead == 'm') ADVANCE(1270);
      if (lookahead == 'r') ADVANCE(883);
      END_STATE();
    case 1269:
      if (lookahead == 'i') ADVANCE(1520);
      END_STATE();
    case 1270:
      if (lookahead == 'i') ADVANCE(1365);
      END_STATE();
    case 1271:
      if (lookahead == 'i') ADVANCE(984);
      END_STATE();
    case 1272:
      if (lookahead == 'i') ADVANCE(2055);
      END_STATE();
    case 1273:
      if (lookahead == 'i') ADVANCE(1560);
      END_STATE();
    case 1274:
      if (lookahead == 'i') ADVANCE(1553);
      END_STATE();
    case 1275:
      if (lookahead == 'i') ADVANCE(1498);
      END_STATE();
    case 1276:
      if (lookahead == 'i') ADVANCE(1395);
      if (lookahead == 'l') ADVANCE(1244);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 1277:
      if (lookahead == 'i') ADVANCE(1132);
      END_STATE();
    case 1278:
      if (lookahead == 'i') ADVANCE(1383);
      END_STATE();
    case 1279:
      if (lookahead == 'i') ADVANCE(1531);
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 1280:
      if (lookahead == 'i') ADVANCE(1808);
      END_STATE();
    case 1281:
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'o') ADVANCE(1379);
      END_STATE();
    case 1282:
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1283:
      if (lookahead == 'i') ADVANCE(1381);
      END_STATE();
    case 1284:
      if (lookahead == 'i') ADVANCE(736);
      END_STATE();
    case 1285:
      if (lookahead == 'i') ADVANCE(627);
      END_STATE();
    case 1286:
      if (lookahead == 'i') ADVANCE(1934);
      END_STATE();
    case 1287:
      if (lookahead == 'i') ADVANCE(2105);
      END_STATE();
    case 1288:
      if (lookahead == 'i') ADVANCE(1714);
      END_STATE();
    case 1289:
      if (lookahead == 'i') ADVANCE(1539);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'u') ADVANCE(1510);
      END_STATE();
    case 1290:
      if (lookahead == 'i') ADVANCE(1400);
      END_STATE();
    case 1291:
      if (lookahead == 'i') ADVANCE(1478);
      END_STATE();
    case 1292:
      if (lookahead == 'i') ADVANCE(1533);
      END_STATE();
    case 1293:
      if (lookahead == 'i') ADVANCE(1938);
      END_STATE();
    case 1294:
      if (lookahead == 'i') ADVANCE(1933);
      END_STATE();
    case 1295:
      if (lookahead == 'i') ADVANCE(1488);
      END_STATE();
    case 1296:
      if (lookahead == 'i') ADVANCE(1474);
      END_STATE();
    case 1297:
      if (lookahead == 'i') ADVANCE(2014);
      END_STATE();
    case 1298:
      if (lookahead == 'i') ADVANCE(1411);
      END_STATE();
    case 1299:
      if (lookahead == 'i') ADVANCE(1537);
      END_STATE();
    case 1300:
      if (lookahead == 'i') ADVANCE(1028);
      END_STATE();
    case 1301:
      if (lookahead == 'i') ADVANCE(635);
      END_STATE();
    case 1302:
      if (lookahead == 'i') ADVANCE(1430);
      END_STATE();
    case 1303:
      if (lookahead == 'i') ADVANCE(1398);
      END_STATE();
    case 1304:
      if (lookahead == 'i') ADVANCE(1637);
      END_STATE();
    case 1305:
      if (lookahead == 'i') ADVANCE(1616);
      END_STATE();
    case 1306:
      if (lookahead == 'i') ADVANCE(1554);
      END_STATE();
    case 1307:
      if (lookahead == 'i') ADVANCE(1554);
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 1308:
      if (lookahead == 'i') ADVANCE(1145);
      END_STATE();
    case 1309:
      if (lookahead == 'i') ADVANCE(1431);
      END_STATE();
    case 1310:
      if (lookahead == 'i') ADVANCE(859);
      END_STATE();
    case 1311:
      if (lookahead == 'i') ADVANCE(863);
      END_STATE();
    case 1312:
      if (lookahead == 'i') ADVANCE(737);
      END_STATE();
    case 1313:
      if (lookahead == 'i') ADVANCE(1153);
      END_STATE();
    case 1314:
      if (lookahead == 'i') ADVANCE(1154);
      END_STATE();
    case 1315:
      if (lookahead == 'i') ADVANCE(1155);
      END_STATE();
    case 1316:
      if (lookahead == 'i') ADVANCE(1156);
      END_STATE();
    case 1317:
      if (lookahead == 'i') ADVANCE(1158);
      END_STATE();
    case 1318:
      if (lookahead == 'i') ADVANCE(1160);
      END_STATE();
    case 1319:
      if (lookahead == 'i') ADVANCE(1161);
      END_STATE();
    case 1320:
      if (lookahead == 'i') ADVANCE(1163);
      END_STATE();
    case 1321:
      if (lookahead == 'i') ADVANCE(1882);
      END_STATE();
    case 1322:
      if (lookahead == 'i') ADVANCE(703);
      END_STATE();
    case 1323:
      if (lookahead == 'i') ADVANCE(1172);
      END_STATE();
    case 1324:
      if (lookahead == 'i') ADVANCE(705);
      END_STATE();
    case 1325:
      if (lookahead == 'i') ADVANCE(706);
      END_STATE();
    case 1326:
      if (lookahead == 'i') ADVANCE(707);
      END_STATE();
    case 1327:
      if (lookahead == 'i') ADVANCE(708);
      END_STATE();
    case 1328:
      if (lookahead == 'j') ADVANCE(148);
      END_STATE();
    case 1329:
      if (lookahead == 'j') ADVANCE(148);
      if (lookahead == 'n') ADVANCE(1328);
      END_STATE();
    case 1330:
      if (lookahead == 'k') ADVANCE(148);
      END_STATE();
    case 1331:
      if (lookahead == 'k') ADVANCE(507);
      END_STATE();
    case 1332:
      if (lookahead == 'k') ADVANCE(861);
      END_STATE();
    case 1333:
      if (lookahead == 'k') ADVANCE(1435);
      END_STATE();
    case 1334:
      if (lookahead == 'k') ADVANCE(1408);
      END_STATE();
    case 1335:
      if (lookahead == 'k') ADVANCE(296);
      END_STATE();
    case 1336:
      if (lookahead == 'k') ADVANCE(275);
      END_STATE();
    case 1337:
      if (lookahead == 'k') ADVANCE(745);
      END_STATE();
    case 1338:
      if (lookahead == 'k') ADVANCE(745);
      if (lookahead == 'm') ADVANCE(287);
      END_STATE();
    case 1339:
      if (lookahead == 'k') ADVANCE(2121);
      END_STATE();
    case 1340:
      if (lookahead == 'k') ADVANCE(337);
      END_STATE();
    case 1341:
      if (lookahead == 'k') ADVANCE(1930);
      END_STATE();
    case 1342:
      if (lookahead == 'k') ADVANCE(948);
      END_STATE();
    case 1343:
      if (lookahead == 'k') ADVANCE(952);
      END_STATE();
    case 1344:
      if (lookahead == 'k') ADVANCE(662);
      END_STATE();
    case 1345:
      if (lookahead == 'k') ADVANCE(669);
      END_STATE();
    case 1346:
      if (lookahead == 'k') ADVANCE(669);
      if (lookahead == 'l') ADVANCE(600);
      END_STATE();
    case 1347:
      if (lookahead == 'k') ADVANCE(1299);
      END_STATE();
    case 1348:
      if (lookahead == 'l') ADVANCE(872);
      END_STATE();
    case 1349:
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 1350:
      if (lookahead == 'l') ADVANCE(334);
      END_STATE();
    case 1351:
      if (lookahead == 'l') ADVANCE(486);
      END_STATE();
    case 1352:
      if (lookahead == 'l') ADVANCE(455);
      END_STATE();
    case 1353:
      if (lookahead == 'l') ADVANCE(215);
      END_STATE();
    case 1354:
      if (lookahead == 'l') ADVANCE(281);
      END_STATE();
    case 1355:
      if (lookahead == 'l') ADVANCE(2155);
      END_STATE();
    case 1356:
      if (lookahead == 'l') ADVANCE(419);
      END_STATE();
    case 1357:
      if (lookahead == 'l') ADVANCE(406);
      END_STATE();
    case 1358:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 1359:
      if (lookahead == 'l') ADVANCE(524);
      END_STATE();
    case 1360:
      if (lookahead == 'l') ADVANCE(2133);
      END_STATE();
    case 1361:
      if (lookahead == 'l') ADVANCE(1048);
      END_STATE();
    case 1362:
      if (lookahead == 'l') ADVANCE(1048);
      if (lookahead == 'q') ADVANCE(2073);
      END_STATE();
    case 1363:
      if (lookahead == 'l') ADVANCE(1048);
      if (lookahead == 'q') ADVANCE(2072);
      if (lookahead == 'x') ADVANCE(1238);
      END_STATE();
    case 1364:
      if (lookahead == 'l') ADVANCE(471);
      END_STATE();
    case 1365:
      if (lookahead == 'l') ADVANCE(1949);
      END_STATE();
    case 1366:
      if (lookahead == 'l') ADVANCE(186);
      END_STATE();
    case 1367:
      if (lookahead == 'l') ADVANCE(464);
      END_STATE();
    case 1368:
      if (lookahead == 'l') ADVANCE(730);
      END_STATE();
    case 1369:
      if (lookahead == 'l') ADVANCE(427);
      END_STATE();
    case 1370:
      if (lookahead == 'l') ADVANCE(418);
      END_STATE();
    case 1371:
      if (lookahead == 'l') ADVANCE(509);
      END_STATE();
    case 1372:
      if (lookahead == 'l') ADVANCE(538);
      END_STATE();
    case 1373:
      if (lookahead == 'l') ADVANCE(322);
      END_STATE();
    case 1374:
      if (lookahead == 'l') ADVANCE(571);
      END_STATE();
    case 1375:
      if (lookahead == 'l') ADVANCE(246);
      END_STATE();
    case 1376:
      if (lookahead == 'l') ADVANCE(438);
      END_STATE();
    case 1377:
      if (lookahead == 'l') ADVANCE(900);
      END_STATE();
    case 1378:
      if (lookahead == 'l') ADVANCE(449);
      END_STATE();
    case 1379:
      if (lookahead == 'l') ADVANCE(1620);
      END_STATE();
    case 1380:
      if (lookahead == 'l') ADVANCE(1330);
      END_STATE();
    case 1381:
      if (lookahead == 'l') ADVANCE(887);
      END_STATE();
    case 1382:
      if (lookahead == 'l') ADVANCE(887);
      if (lookahead == 'm') ADVANCE(984);
      END_STATE();
    case 1383:
      if (lookahead == 'l') ADVANCE(887);
      if (lookahead == 'm') ADVANCE(1006);
      END_STATE();
    case 1384:
      if (lookahead == 'l') ADVANCE(968);
      END_STATE();
    case 1385:
      if (lookahead == 'l') ADVANCE(1894);
      END_STATE();
    case 1386:
      if (lookahead == 'l') ADVANCE(839);
      END_STATE();
    case 1387:
      if (lookahead == 'l') ADVANCE(1250);
      END_STATE();
    case 1388:
      if (lookahead == 'l') ADVANCE(2132);
      END_STATE();
    case 1389:
      if (lookahead == 'l') ADVANCE(1216);
      END_STATE();
    case 1390:
      if (lookahead == 'l') ADVANCE(987);
      END_STATE();
    case 1391:
      if (lookahead == 'l') ADVANCE(1349);
      END_STATE();
    case 1392:
      if (lookahead == 'l') ADVANCE(2142);
      END_STATE();
    case 1393:
      if (lookahead == 'l') ADVANCE(1629);
      END_STATE();
    case 1394:
      if (lookahead == 'l') ADVANCE(2080);
      END_STATE();
    case 1395:
      if (lookahead == 'l') ADVANCE(1243);
      END_STATE();
    case 1396:
      if (lookahead == 'l') ADVANCE(1375);
      if (lookahead == 'm') ADVANCE(1680);
      END_STATE();
    case 1397:
      if (lookahead == 'l') ADVANCE(1372);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(245);
      if (lookahead == 'u') ADVANCE(735);
      if (lookahead == 'w') ADVANCE(1499);
      END_STATE();
    case 1398:
      if (lookahead == 'l') ADVANCE(917);
      END_STATE();
    case 1399:
      if (lookahead == 'l') ADVANCE(973);
      END_STATE();
    case 1400:
      if (lookahead == 'l') ADVANCE(1359);
      END_STATE();
    case 1401:
      if (lookahead == 'l') ADVANCE(1369);
      END_STATE();
    case 1402:
      if (lookahead == 'l') ADVANCE(988);
      END_STATE();
    case 1403:
      if (lookahead == 'l') ADVANCE(1450);
      if (lookahead == 's') ADVANCE(1185);
      END_STATE();
    case 1404:
      if (lookahead == 'l') ADVANCE(1647);
      END_STATE();
    case 1405:
      if (lookahead == 'l') ADVANCE(1271);
      END_STATE();
    case 1406:
      if (lookahead == 'l') ADVANCE(1242);
      END_STATE();
    case 1407:
      if (lookahead == 'l') ADVANCE(1367);
      END_STATE();
    case 1408:
      if (lookahead == 'l') ADVANCE(1598);
      if (lookahead == 's') ADVANCE(1738);
      if (lookahead == 't') ADVANCE(1893);
      END_STATE();
    case 1409:
      if (lookahead == 'l') ADVANCE(963);
      END_STATE();
    case 1410:
      if (lookahead == 'l') ADVANCE(963);
      if (lookahead == 'q') ADVANCE(1409);
      END_STATE();
    case 1411:
      if (lookahead == 'l') ADVANCE(1284);
      END_STATE();
    case 1412:
      if (lookahead == 'l') ADVANCE(587);
      END_STATE();
    case 1413:
      if (lookahead == 'l') ADVANCE(1371);
      END_STATE();
    case 1414:
      if (lookahead == 'l') ADVANCE(934);
      END_STATE();
    case 1415:
      if (lookahead == 'l') ADVANCE(935);
      END_STATE();
    case 1416:
      if (lookahead == 'l') ADVANCE(1632);
      END_STATE();
    case 1417:
      if (lookahead == 'l') ADVANCE(924);
      END_STATE();
    case 1418:
      if (lookahead == 'l') ADVANCE(1055);
      END_STATE();
    case 1419:
      if (lookahead == 'l') ADVANCE(977);
      if (lookahead == 'r') ADVANCE(1277);
      END_STATE();
    case 1420:
      if (lookahead == 'l') ADVANCE(942);
      END_STATE();
    case 1421:
      if (lookahead == 'l') ADVANCE(943);
      END_STATE();
    case 1422:
      if (lookahead == 'l') ADVANCE(955);
      END_STATE();
    case 1423:
      if (lookahead == 'l') ADVANCE(1075);
      END_STATE();
    case 1424:
      if (lookahead == 'l') ADVANCE(965);
      END_STATE();
    case 1425:
      if (lookahead == 'l') ADVANCE(945);
      END_STATE();
    case 1426:
      if (lookahead == 'l') ADVANCE(946);
      END_STATE();
    case 1427:
      if (lookahead == 'l') ADVANCE(947);
      END_STATE();
    case 1428:
      if (lookahead == 'l') ADVANCE(974);
      END_STATE();
    case 1429:
      if (lookahead == 'l') ADVANCE(600);
      END_STATE();
    case 1430:
      if (lookahead == 'l') ADVANCE(1251);
      END_STATE();
    case 1431:
      if (lookahead == 'l') ADVANCE(894);
      END_STATE();
    case 1432:
      if (lookahead == 'l') ADVANCE(894);
      if (lookahead == 'm') ADVANCE(978);
      if (lookahead == 'n') ADVANCE(1949);
      END_STATE();
    case 1433:
      if (lookahead == 'l') ADVANCE(1622);
      if (lookahead == 'n') ADVANCE(1140);
      if (lookahead == 'p') ADVANCE(1089);
      if (lookahead == 'u') ADVANCE(1561);
      END_STATE();
    case 1434:
      if (lookahead == 'l') ADVANCE(543);
      END_STATE();
    case 1435:
      if (lookahead == 'l') ADVANCE(959);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 1436:
      if (lookahead == 'l') ADVANCE(1040);
      END_STATE();
    case 1437:
      if (lookahead == 'l') ADVANCE(1039);
      END_STATE();
    case 1438:
      if (lookahead == 'l') ADVANCE(655);
      END_STATE();
    case 1439:
      if (lookahead == 'l') ADVANCE(2056);
      END_STATE();
    case 1440:
      if (lookahead == 'l') ADVANCE(1402);
      END_STATE();
    case 1441:
      if (lookahead == 'l') ADVANCE(601);
      END_STATE();
    case 1442:
      if (lookahead == 'l') ADVANCE(1292);
      END_STATE();
    case 1443:
      if (lookahead == 'l') ADVANCE(1627);
      if (lookahead == 'm') ADVANCE(1483);
      if (lookahead == 'n') ADVANCE(1116);
      if (lookahead == 'p') ADVANCE(266);
      END_STATE();
    case 1444:
      if (lookahead == 'l') ADVANCE(1840);
      END_STATE();
    case 1445:
      if (lookahead == 'l') ADVANCE(1226);
      END_STATE();
    case 1446:
      if (lookahead == 'l') ADVANCE(1387);
      END_STATE();
    case 1447:
      if (lookahead == 'l') ADVANCE(1274);
      END_STATE();
    case 1448:
      if (lookahead == 'l') ADVANCE(1390);
      END_STATE();
    case 1449:
      if (lookahead == 'l') ADVANCE(677);
      END_STATE();
    case 1450:
      if (lookahead == 'l') ADVANCE(1946);
      END_STATE();
    case 1451:
      if (lookahead == 'l') ADVANCE(1442);
      END_STATE();
    case 1452:
      if (lookahead == 'l') ADVANCE(1043);
      if (lookahead == 'm') ADVANCE(622);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 1453:
      if (lookahead == 'l') ADVANCE(1070);
      if (lookahead == 'r') ADVANCE(1320);
      END_STATE();
    case 1454:
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 1455:
      if (lookahead == 'm') ADVANCE(287);
      END_STATE();
    case 1456:
      if (lookahead == 'm') ADVANCE(287);
      if (lookahead == 'r') ADVANCE(1579);
      END_STATE();
    case 1457:
      if (lookahead == 'm') ADVANCE(507);
      END_STATE();
    case 1458:
      if (lookahead == 'm') ADVANCE(308);
      END_STATE();
    case 1459:
      if (lookahead == 'm') ADVANCE(358);
      END_STATE();
    case 1460:
      if (lookahead == 'm') ADVANCE(357);
      END_STATE();
    case 1461:
      if (lookahead == 'm') ADVANCE(524);
      END_STATE();
    case 1462:
      if (lookahead == 'm') ADVANCE(1307);
      END_STATE();
    case 1463:
      if (lookahead == 'm') ADVANCE(1214);
      END_STATE();
    case 1464:
      if (lookahead == 'm') ADVANCE(241);
      END_STATE();
    case 1465:
      if (lookahead == 'm') ADVANCE(1668);
      END_STATE();
    case 1466:
      if (lookahead == 'm') ADVANCE(1698);
      END_STATE();
    case 1467:
      if (lookahead == 'm') ADVANCE(1679);
      END_STATE();
    case 1468:
      if (lookahead == 'm') ADVANCE(1213);
      END_STATE();
    case 1469:
      if (lookahead == 'm') ADVANCE(1213);
      if (lookahead == 'p') ADVANCE(674);
      END_STATE();
    case 1470:
      if (lookahead == 'm') ADVANCE(1461);
      END_STATE();
    case 1471:
      if (lookahead == 'm') ADVANCE(249);
      END_STATE();
    case 1472:
      if (lookahead == 'm') ADVANCE(1702);
      END_STATE();
    case 1473:
      if (lookahead == 'm') ADVANCE(250);
      END_STATE();
    case 1474:
      if (lookahead == 'm') ADVANCE(564);
      END_STATE();
    case 1475:
      if (lookahead == 'm') ADVANCE(987);
      END_STATE();
    case 1476:
      if (lookahead == 'm') ADVANCE(1349);
      END_STATE();
    case 1477:
      if (lookahead == 'm') ADVANCE(1495);
      END_STATE();
    case 1478:
      if (lookahead == 'm') ADVANCE(917);
      END_STATE();
    case 1479:
      if (lookahead == 'm') ADVANCE(1694);
      END_STATE();
    case 1480:
      if (lookahead == 'm') ADVANCE(1689);
      END_STATE();
    case 1481:
      if (lookahead == 'm') ADVANCE(679);
      END_STATE();
    case 1482:
      if (lookahead == 'm') ADVANCE(552);
      END_STATE();
    case 1483:
      if (lookahead == 'm') ADVANCE(559);
      if (lookahead == 'p') ADVANCE(269);
      END_STATE();
    case 1484:
      if (lookahead == 'm') ADVANCE(950);
      END_STATE();
    case 1485:
      if (lookahead == 'm') ADVANCE(950);
      if (lookahead == 'x') ADVANCE(984);
      END_STATE();
    case 1486:
      if (lookahead == 'm') ADVANCE(548);
      END_STATE();
    case 1487:
      if (lookahead == 'm') ADVANCE(532);
      END_STATE();
    case 1488:
      if (lookahead == 'm') ADVANCE(984);
      END_STATE();
    case 1489:
      if (lookahead == 'm') ADVANCE(1710);
      END_STATE();
    case 1490:
      if (lookahead == 'm') ADVANCE(970);
      END_STATE();
    case 1491:
      if (lookahead == 'm') ADVANCE(1482);
      END_STATE();
    case 1492:
      if (lookahead == 'm') ADVANCE(1306);
      END_STATE();
    case 1493:
      if (lookahead == 'm') ADVANCE(673);
      END_STATE();
    case 1494:
      if (lookahead == 'n') ADVANCE(872);
      END_STATE();
    case 1495:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 1496:
      if (lookahead == 'n') ADVANCE(271);
      END_STATE();
    case 1497:
      if (lookahead == 'n') ADVANCE(415);
      END_STATE();
    case 1498:
      if (lookahead == 'n') ADVANCE(507);
      END_STATE();
    case 1499:
      if (lookahead == 'n') ADVANCE(687);
      END_STATE();
    case 1500:
      if (lookahead == 'n') ADVANCE(352);
      END_STATE();
    case 1501:
      if (lookahead == 'n') ADVANCE(831);
      END_STATE();
    case 1502:
      if (lookahead == 'n') ADVANCE(2150);
      END_STATE();
    case 1503:
      if (lookahead == 'n') ADVANCE(166);
      END_STATE();
    case 1504:
      if (lookahead == 'n') ADVANCE(514);
      END_STATE();
    case 1505:
      if (lookahead == 'n') ADVANCE(518);
      END_STATE();
    case 1506:
      if (lookahead == 'n') ADVANCE(184);
      END_STATE();
    case 1507:
      if (lookahead == 'n') ADVANCE(1949);
      END_STATE();
    case 1508:
      if (lookahead == 'n') ADVANCE(429);
      END_STATE();
    case 1509:
      if (lookahead == 'n') ADVANCE(480);
      END_STATE();
    case 1510:
      if (lookahead == 'n') ADVANCE(235);
      END_STATE();
    case 1511:
      if (lookahead == 'n') ADVANCE(2126);
      END_STATE();
    case 1512:
      if (lookahead == 'n') ADVANCE(409);
      END_STATE();
    case 1513:
      if (lookahead == 'n') ADVANCE(1109);
      END_STATE();
    case 1514:
      if (lookahead == 'n') ADVANCE(907);
      END_STATE();
    case 1515:
      if (lookahead == 'n') ADVANCE(241);
      END_STATE();
    case 1516:
      if (lookahead == 'n') ADVANCE(1111);
      END_STATE();
    case 1517:
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 1518:
      if (lookahead == 'n') ADVANCE(2009);
      END_STATE();
    case 1519:
      if (lookahead == 'n') ADVANCE(1117);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'w') ADVANCE(1018);
      END_STATE();
    case 1520:
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 1521:
      if (lookahead == 'n') ADVANCE(1330);
      END_STATE();
    case 1522:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 1523:
      if (lookahead == 'n') ADVANCE(1894);
      END_STATE();
    case 1524:
      if (lookahead == 'n') ADVANCE(880);
      END_STATE();
    case 1525:
      if (lookahead == 'n') ADVANCE(244);
      END_STATE();
    case 1526:
      if (lookahead == 'n') ADVANCE(1141);
      if (lookahead == 'r') ADVANCE(998);
      END_STATE();
    case 1527:
      if (lookahead == 'n') ADVANCE(837);
      END_STATE();
    case 1528:
      if (lookahead == 'n') ADVANCE(1157);
      END_STATE();
    case 1529:
      if (lookahead == 'n') ADVANCE(917);
      END_STATE();
    case 1530:
      if (lookahead == 'n') ADVANCE(1115);
      END_STATE();
    case 1531:
      if (lookahead == 'n') ADVANCE(865);
      END_STATE();
    case 1532:
      if (lookahead == 'n') ADVANCE(1625);
      END_STATE();
    case 1533:
      if (lookahead == 'n') ADVANCE(1143);
      END_STATE();
    case 1534:
      if (lookahead == 'n') ADVANCE(890);
      END_STATE();
    case 1535:
      if (lookahead == 'n') ADVANCE(1170);
      END_STATE();
    case 1536:
      if (lookahead == 'n') ADVANCE(948);
      END_STATE();
    case 1537:
      if (lookahead == 'n') ADVANCE(1118);
      END_STATE();
    case 1538:
      if (lookahead == 'n') ADVANCE(860);
      END_STATE();
    case 1539:
      if (lookahead == 'n') ADVANCE(2027);
      END_STATE();
    case 1540:
      if (lookahead == 'n') ADVANCE(1960);
      END_STATE();
    case 1541:
      if (lookahead == 'n') ADVANCE(1974);
      END_STATE();
    case 1542:
      if (lookahead == 'n') ADVANCE(1999);
      END_STATE();
    case 1543:
      if (lookahead == 'n') ADVANCE(2001);
      END_STATE();
    case 1544:
      if (lookahead == 'n') ADVANCE(979);
      END_STATE();
    case 1545:
      if (lookahead == 'n') ADVANCE(982);
      END_STATE();
    case 1546:
      if (lookahead == 'n') ADVANCE(1419);
      END_STATE();
    case 1547:
      if (lookahead == 'n') ADVANCE(2058);
      END_STATE();
    case 1548:
      if (lookahead == 'n') ADVANCE(201);
      END_STATE();
    case 1549:
      if (lookahead == 'n') ADVANCE(1136);
      END_STATE();
    case 1550:
      if (lookahead == 'n') ADVANCE(1139);
      END_STATE();
    case 1551:
      if (lookahead == 'n') ADVANCE(1064);
      END_STATE();
    case 1552:
      if (lookahead == 'n') ADVANCE(1249);
      END_STATE();
    case 1553:
      if (lookahead == 'n') ADVANCE(2017);
      END_STATE();
    case 1554:
      if (lookahead == 'n') ADVANCE(2056);
      END_STATE();
    case 1555:
      if (lookahead == 'n') ADVANCE(1630);
      END_STATE();
    case 1556:
      if (lookahead == 'n') ADVANCE(2018);
      END_STATE();
    case 1557:
      if (lookahead == 'n') ADVANCE(1226);
      END_STATE();
    case 1558:
      if (lookahead == 'n') ADVANCE(2016);
      END_STATE();
    case 1559:
      if (lookahead == 'n') ADVANCE(2036);
      END_STATE();
    case 1560:
      if (lookahead == 'n') ADVANCE(647);
      END_STATE();
    case 1561:
      if (lookahead == 'n') ADVANCE(2028);
      END_STATE();
    case 1562:
      if (lookahead == 'n') ADVANCE(1162);
      END_STATE();
    case 1563:
      if (lookahead == 'n') ADVANCE(2026);
      END_STATE();
    case 1564:
      if (lookahead == 'n') ADVANCE(1305);
      END_STATE();
    case 1565:
      if (lookahead == 'n') ADVANCE(1067);
      END_STATE();
    case 1566:
      if (lookahead == 'n') ADVANCE(1164);
      if (lookahead == 'r') ADVANCE(1844);
      END_STATE();
    case 1567:
      if (lookahead == 'n') ADVANCE(1164);
      if (lookahead == 'r') ADVANCE(1848);
      END_STATE();
    case 1568:
      if (lookahead == 'n') ADVANCE(2030);
      END_STATE();
    case 1569:
      if (lookahead == 'n') ADVANCE(1165);
      END_STATE();
    case 1570:
      if (lookahead == 'n') ADVANCE(1166);
      END_STATE();
    case 1571:
      if (lookahead == 'n') ADVANCE(2032);
      END_STATE();
    case 1572:
      if (lookahead == 'n') ADVANCE(1167);
      END_STATE();
    case 1573:
      if (lookahead == 'n') ADVANCE(1168);
      END_STATE();
    case 1574:
      if (lookahead == 'n') ADVANCE(1169);
      END_STATE();
    case 1575:
      if (lookahead == 'n') ADVANCE(2037);
      END_STATE();
    case 1576:
      if (lookahead == 'n') ADVANCE(696);
      END_STATE();
    case 1577:
      if (lookahead == 'n') ADVANCE(685);
      END_STATE();
    case 1578:
      if (lookahead == 'o') ADVANCE(872);
      END_STATE();
    case 1579:
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 1580:
      if (lookahead == 'o') ADVANCE(318);
      END_STATE();
    case 1581:
      if (lookahead == 'o') ADVANCE(1087);
      END_STATE();
    case 1582:
      if (lookahead == 'o') ADVANCE(2117);
      END_STATE();
    case 1583:
      if (lookahead == 'o') ADVANCE(519);
      END_STATE();
    case 1584:
      if (lookahead == 'o') ADVANCE(2097);
      END_STATE();
    case 1585:
      if (lookahead == 'o') ADVANCE(238);
      END_STATE();
    case 1586:
      if (lookahead == 'o') ADVANCE(1951);
      END_STATE();
    case 1587:
      if (lookahead == 'o') ADVANCE(1950);
      END_STATE();
    case 1588:
      if (lookahead == 'o') ADVANCE(1741);
      END_STATE();
    case 1589:
      if (lookahead == 'o') ADVANCE(1949);
      END_STATE();
    case 1590:
      if (lookahead == 'o') ADVANCE(1949);
      if (lookahead == 's') ADVANCE(2050);
      END_STATE();
    case 1591:
      if (lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 1592:
      if (lookahead == 'o') ADVANCE(2128);
      END_STATE();
    case 1593:
      if (lookahead == 'o') ADVANCE(820);
      END_STATE();
    case 1594:
      if (lookahead == 'o') ADVANCE(2126);
      END_STATE();
    case 1595:
      if (lookahead == 'o') ADVANCE(1920);
      END_STATE();
    case 1596:
      if (lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 1597:
      if (lookahead == 'o') ADVANCE(2107);
      END_STATE();
    case 1598:
      if (lookahead == 'o') ADVANCE(2146);
      END_STATE();
    case 1599:
      if (lookahead == 'o') ADVANCE(1668);
      END_STATE();
    case 1600:
      if (lookahead == 'o') ADVANCE(1557);
      END_STATE();
    case 1601:
      if (lookahead == 'o') ADVANCE(2108);
      END_STATE();
    case 1602:
      if (lookahead == 'o') ADVANCE(2109);
      END_STATE();
    case 1603:
      if (lookahead == 'o') ADVANCE(1454);
      END_STATE();
    case 1604:
      if (lookahead == 'o') ADVANCE(1330);
      END_STATE();
    case 1605:
      if (lookahead == 'o') ADVANCE(2004);
      END_STATE();
    case 1606:
      if (lookahead == 'o') ADVANCE(2110);
      END_STATE();
    case 1607:
      if (lookahead == 'o') ADVANCE(2122);
      END_STATE();
    case 1608:
      if (lookahead == 'o') ADVANCE(1894);
      END_STATE();
    case 1609:
      if (lookahead == 'o') ADVANCE(1516);
      END_STATE();
    case 1610:
      if (lookahead == 'o') ADVANCE(1516);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1611:
      if (lookahead == 'o') ADVANCE(2123);
      END_STATE();
    case 1612:
      if (lookahead == 'o') ADVANCE(2116);
      END_STATE();
    case 1613:
      if (lookahead == 'o') ADVANCE(2111);
      END_STATE();
    case 1614:
      if (lookahead == 'o') ADVANCE(1349);
      if (lookahead == 'u') ADVANCE(709);
      END_STATE();
    case 1615:
      if (lookahead == 'o') ADVANCE(895);
      END_STATE();
    case 1616:
      if (lookahead == 'o') ADVANCE(1523);
      END_STATE();
    case 1617:
      if (lookahead == 'o') ADVANCE(2114);
      END_STATE();
    case 1618:
      if (lookahead == 'o') ADVANCE(1955);
      END_STATE();
    case 1619:
      if (lookahead == 'o') ADVANCE(1795);
      END_STATE();
    case 1620:
      if (lookahead == 'o') ADVANCE(1495);
      END_STATE();
    case 1621:
      if (lookahead == 'o') ADVANCE(1495);
      if (lookahead == 'r') ADVANCE(556);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 1622:
      if (lookahead == 'o') ADVANCE(1515);
      END_STATE();
    case 1623:
      if (lookahead == 'o') ADVANCE(1551);
      END_STATE();
    case 1624:
      if (lookahead == 'o') ADVANCE(1506);
      END_STATE();
    case 1625:
      if (lookahead == 'o') ADVANCE(2093);
      END_STATE();
    case 1626:
      if (lookahead == 'o') ADVANCE(1494);
      END_STATE();
    case 1627:
      if (lookahead == 'o') ADVANCE(1522);
      END_STATE();
    case 1628:
      if (lookahead == 'o') ADVANCE(2095);
      END_STATE();
    case 1629:
      if (lookahead == 'o') ADVANCE(1588);
      END_STATE();
    case 1630:
      if (lookahead == 'o') ADVANCE(2041);
      END_STATE();
    case 1631:
      if (lookahead == 'o') ADVANCE(1348);
      END_STATE();
    case 1632:
      if (lookahead == 'o') ADVANCE(819);
      END_STATE();
    case 1633:
      if (lookahead == 'o') ADVANCE(1990);
      END_STATE();
    case 1634:
      if (lookahead == 'o') ADVANCE(1992);
      END_STATE();
    case 1635:
      if (lookahead == 'o') ADVANCE(2034);
      END_STATE();
    case 1636:
      if (lookahead == 'o') ADVANCE(1546);
      END_STATE();
    case 1637:
      if (lookahead == 'o') ADVANCE(1548);
      END_STATE();
    case 1638:
      if (lookahead == 'o') ADVANCE(1514);
      END_STATE();
    case 1639:
      if (lookahead == 'o') ADVANCE(1807);
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 1640:
      if (lookahead == 'o') ADVANCE(1832);
      END_STATE();
    case 1641:
      if (lookahead == 'o') ADVANCE(1834);
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 1642:
      if (lookahead == 'o') ADVANCE(1758);
      END_STATE();
    case 1643:
      if (lookahead == 'o') ADVANCE(2118);
      END_STATE();
    case 1644:
      if (lookahead == 'o') ADVANCE(1470);
      END_STATE();
    case 1645:
      if (lookahead == 'o') ADVANCE(1470);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1646:
      if (lookahead == 'o') ADVANCE(1813);
      END_STATE();
    case 1647:
      if (lookahead == 'o') ADVANCE(1697);
      END_STATE();
    case 1648:
      if (lookahead == 'o') ADVANCE(1708);
      END_STATE();
    case 1649:
      if (lookahead == 'o') ADVANCE(2077);
      END_STATE();
    case 1650:
      if (lookahead == 'o') ADVANCE(2124);
      END_STATE();
    case 1651:
      if (lookahead == 'o') ADVANCE(2119);
      END_STATE();
    case 1652:
      if (lookahead == 'o') ADVANCE(2083);
      END_STATE();
    case 1653:
      if (lookahead == 'o') ADVANCE(1998);
      END_STATE();
    case 1654:
      if (lookahead == 'o') ADVANCE(1550);
      if (lookahead == 'u') ADVANCE(1688);
      END_STATE();
    case 1655:
      if (lookahead == 'o') ADVANCE(2120);
      END_STATE();
    case 1656:
      if (lookahead == 'o') ADVANCE(1563);
      END_STATE();
    case 1657:
      if (lookahead == 'o') ADVANCE(1828);
      END_STATE();
    case 1658:
      if (lookahead == 'o') ADVANCE(1636);
      END_STATE();
    case 1659:
      if (lookahead == 'o') ADVANCE(1809);
      END_STATE();
    case 1660:
      if (lookahead == 'o') ADVANCE(1542);
      END_STATE();
    case 1661:
      if (lookahead == 'o') ADVANCE(1616);
      END_STATE();
    case 1662:
      if (lookahead == 'o') ADVANCE(1638);
      END_STATE();
    case 1663:
      if (lookahead == 'o') ADVANCE(1874);
      END_STATE();
    case 1664:
      if (lookahead == 'o') ADVANCE(1445);
      END_STATE();
    case 1665:
      if (lookahead == 'o') ADVANCE(2098);
      END_STATE();
    case 1666:
      if (lookahead == 'o') ADVANCE(2125);
      END_STATE();
    case 1667:
      if (lookahead == 'p') ADVANCE(1945);
      END_STATE();
    case 1668:
      if (lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 1669:
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1620);
      END_STATE();
    case 1670:
      if (lookahead == 'p') ADVANCE(1177);
      END_STATE();
    case 1671:
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 1672:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'r') ADVANCE(666);
      END_STATE();
    case 1673:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'r') ADVANCE(407);
      if (lookahead == 'u') ADVANCE(1825);
      END_STATE();
    case 1674:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'r') ADVANCE(1219);
      END_STATE();
    case 1675:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(161);
      if (lookahead == 'u') ADVANCE(734);
      if (lookahead == 'w') ADVANCE(1497);
      END_STATE();
    case 1676:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(341);
      if (lookahead == 'w') ADVANCE(2010);
      if (lookahead == 'x') ADVANCE(442);
      END_STATE();
    case 1677:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'u') ADVANCE(1524);
      END_STATE();
    case 1678:
      if (lookahead == 'p') ADVANCE(160);
      END_STATE();
    case 1679:
      if (lookahead == 'p') ADVANCE(451);
      END_STATE();
    case 1680:
      if (lookahead == 'p') ADVANCE(167);
      END_STATE();
    case 1681:
      if (lookahead == 'p') ADVANCE(141);
      END_STATE();
    case 1682:
      if (lookahead == 'p') ADVANCE(452);
      END_STATE();
    case 1683:
      if (lookahead == 'p') ADVANCE(410);
      END_STATE();
    case 1684:
      if (lookahead == 'p') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(753);
      END_STATE();
    case 1685:
      if (lookahead == 'p') ADVANCE(524);
      END_STATE();
    case 1686:
      if (lookahead == 'p') ADVANCE(312);
      END_STATE();
    case 1687:
      if (lookahead == 'p') ADVANCE(409);
      END_STATE();
    case 1688:
      if (lookahead == 'p') ADVANCE(425);
      END_STATE();
    case 1689:
      if (lookahead == 'p') ADVANCE(241);
      END_STATE();
    case 1690:
      if (lookahead == 'p') ADVANCE(322);
      END_STATE();
    case 1691:
      if (lookahead == 'p') ADVANCE(1174);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 1692:
      if (lookahead == 'p') ADVANCE(1685);
      END_STATE();
    case 1693:
      if (lookahead == 'p') ADVANCE(1894);
      if (lookahead == 'r') ADVANCE(1620);
      END_STATE();
    case 1694:
      if (lookahead == 'p') ADVANCE(250);
      END_STATE();
    case 1695:
      if (lookahead == 'p') ADVANCE(1360);
      END_STATE();
    case 1696:
      if (lookahead == 'p') ADVANCE(1705);
      END_STATE();
    case 1697:
      if (lookahead == 'p') ADVANCE(917);
      END_STATE();
    case 1698:
      if (lookahead == 'p') ADVANCE(964);
      END_STATE();
    case 1699:
      if (lookahead == 'p') ADVANCE(1439);
      END_STATE();
    case 1700:
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 1701:
      if (lookahead == 'p') ADVANCE(1917);
      END_STATE();
    case 1702:
      if (lookahead == 'p') ADVANCE(1989);
      END_STATE();
    case 1703:
      if (lookahead == 'p') ADVANCE(1715);
      END_STATE();
    case 1704:
      if (lookahead == 'p') ADVANCE(1715);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 1705:
      if (lookahead == 'p') ADVANCE(544);
      END_STATE();
    case 1706:
      if (lookahead == 'p') ADVANCE(1658);
      END_STATE();
    case 1707:
      if (lookahead == 'p') ADVANCE(1441);
      END_STATE();
    case 1708:
      if (lookahead == 'p') ADVANCE(1980);
      END_STATE();
    case 1709:
      if (lookahead == 'p') ADVANCE(1608);
      END_STATE();
    case 1710:
      if (lookahead == 'p') ADVANCE(1405);
      END_STATE();
    case 1711:
      if (lookahead == 'p') ADVANCE(663);
      END_STATE();
    case 1712:
      if (lookahead == 'p') ADVANCE(1935);
      END_STATE();
    case 1713:
      if (lookahead == 'p') ADVANCE(1840);
      if (lookahead == 's') ADVANCE(2068);
      END_STATE();
    case 1714:
      if (lookahead == 'p') ADVANCE(1417);
      END_STATE();
    case 1715:
      if (lookahead == 'p') ADVANCE(1820);
      END_STATE();
    case 1716:
      if (lookahead == 'p') ADVANCE(645);
      END_STATE();
    case 1717:
      if (lookahead == 'p') ADVANCE(694);
      END_STATE();
    case 1718:
      if (lookahead == 'p') ADVANCE(463);
      END_STATE();
    case 1719:
      if (lookahead == 'p') ADVANCE(1662);
      END_STATE();
    case 1720:
      if (lookahead == 'p') ADVANCE(678);
      END_STATE();
    case 1721:
      if (lookahead == 'p') ADVANCE(1661);
      END_STATE();
    case 1722:
      if (lookahead == 'p') ADVANCE(696);
      END_STATE();
    case 1723:
      if (lookahead == 'q') ADVANCE(148);
      END_STATE();
    case 1724:
      if (lookahead == 'q') ADVANCE(233);
      END_STATE();
    case 1725:
      if (lookahead == 'q') ADVANCE(1410);
      END_STATE();
    case 1726:
      if (lookahead == 'q') ADVANCE(1148);
      END_STATE();
    case 1727:
      if (lookahead == 'q') ADVANCE(1713);
      END_STATE();
    case 1728:
      if (lookahead == 'q') ADVANCE(313);
      END_STATE();
    case 1729:
      if (lookahead == 'q') ADVANCE(1723);
      END_STATE();
    case 1730:
      if (lookahead == 'q') ADVANCE(2044);
      END_STATE();
    case 1731:
      if (lookahead == 'q') ADVANCE(2063);
      END_STATE();
    case 1732:
      if (lookahead == 'q') ADVANCE(2096);
      if (lookahead == 'u') ADVANCE(732);
      END_STATE();
    case 1733:
      if (lookahead == 'q') ADVANCE(2084);
      END_STATE();
    case 1734:
      if (lookahead == 'q') ADVANCE(2073);
      END_STATE();
    case 1735:
      if (lookahead == 'q') ADVANCE(838);
      if (lookahead == 't') ADVANCE(538);
      END_STATE();
    case 1736:
      if (lookahead == 'q') ADVANCE(2087);
      END_STATE();
    case 1737:
      if (lookahead == 'q') ADVANCE(2091);
      END_STATE();
    case 1738:
      if (lookahead == 'q') ADVANCE(2094);
      END_STATE();
    case 1739:
      if (lookahead == 'r') ADVANCE(872);
      END_STATE();
    case 1740:
      if (lookahead == 'r') ADVANCE(926);
      END_STATE();
    case 1741:
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 1742:
      if (lookahead == 'r') ADVANCE(432);
      END_STATE();
    case 1743:
      if (lookahead == 'r') ADVANCE(297);
      END_STATE();
    case 1744:
      if (lookahead == 'r') ADVANCE(1087);
      END_STATE();
    case 1745:
      if (lookahead == 'r') ADVANCE(350);
      END_STATE();
    case 1746:
      if (lookahead == 'r') ADVANCE(310);
      END_STATE();
    case 1747:
      if (lookahead == 'r') ADVANCE(194);
      END_STATE();
    case 1748:
      if (lookahead == 'r') ADVANCE(796);
      END_STATE();
    case 1749:
      if (lookahead == 'r') ADVANCE(416);
      END_STATE();
    case 1750:
      if (lookahead == 'r') ADVANCE(2159);
      END_STATE();
    case 1751:
      if (lookahead == 'r') ADVANCE(265);
      END_STATE();
    case 1752:
      if (lookahead == 'r') ADVANCE(218);
      END_STATE();
    case 1753:
      if (lookahead == 'r') ADVANCE(1187);
      END_STATE();
    case 1754:
      if (lookahead == 'r') ADVANCE(195);
      END_STATE();
    case 1755:
      if (lookahead == 'r') ADVANCE(489);
      END_STATE();
    case 1756:
      if (lookahead == 'r') ADVANCE(356);
      END_STATE();
    case 1757:
      if (lookahead == 'r') ADVANCE(2164);
      END_STATE();
    case 1758:
      if (lookahead == 'r') ADVANCE(153);
      END_STATE();
    case 1759:
      if (lookahead == 'r') ADVANCE(171);
      END_STATE();
    case 1760:
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 1761:
      if (lookahead == 'r') ADVANCE(303);
      END_STATE();
    case 1762:
      if (lookahead == 'r') ADVANCE(471);
      END_STATE();
    case 1763:
      if (lookahead == 'r') ADVANCE(746);
      END_STATE();
    case 1764:
      if (lookahead == 'r') ADVANCE(345);
      END_STATE();
    case 1765:
      if (lookahead == 'r') ADVANCE(273);
      END_STATE();
    case 1766:
      if (lookahead == 'r') ADVANCE(1949);
      END_STATE();
    case 1767:
      if (lookahead == 'r') ADVANCE(1949);
      if (lookahead == 'u') ADVANCE(680);
      END_STATE();
    case 1768:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 1769:
      if (lookahead == 'r') ADVANCE(899);
      END_STATE();
    case 1770:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 1771:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 1772:
      if (lookahead == 'r') ADVANCE(208);
      END_STATE();
    case 1773:
      if (lookahead == 'r') ADVANCE(483);
      END_STATE();
    case 1774:
      if (lookahead == 'r') ADVANCE(745);
      END_STATE();
    case 1775:
      if (lookahead == 'r') ADVANCE(575);
      END_STATE();
    case 1776:
      if (lookahead == 'r') ADVANCE(1214);
      END_STATE();
    case 1777:
      if (lookahead == 'r') ADVANCE(305);
      END_STATE();
    case 1778:
      if (lookahead == 'r') ADVANCE(289);
      END_STATE();
    case 1779:
      if (lookahead == 'r') ADVANCE(294);
      END_STATE();
    case 1780:
      if (lookahead == 'r') ADVANCE(875);
      END_STATE();
    case 1781:
      if (lookahead == 'r') ADVANCE(867);
      END_STATE();
    case 1782:
      if (lookahead == 'r') ADVANCE(1579);
      END_STATE();
    case 1783:
      if (lookahead == 'r') ADVANCE(299);
      END_STATE();
    case 1784:
      if (lookahead == 'r') ADVANCE(1340);
      END_STATE();
    case 1785:
      if (lookahead == 'r') ADVANCE(328);
      END_STATE();
    case 1786:
      if (lookahead == 'r') ADVANCE(428);
      END_STATE();
    case 1787:
      if (lookahead == 'r') ADVANCE(338);
      END_STATE();
    case 1788:
      if (lookahead == 'r') ADVANCE(857);
      END_STATE();
    case 1789:
      if (lookahead == 'r') ADVANCE(1668);
      END_STATE();
    case 1790:
      if (lookahead == 'r') ADVANCE(994);
      END_STATE();
    case 1791:
      if (lookahead == 'r') ADVANCE(2009);
      END_STATE();
    case 1792:
      if (lookahead == 'r') ADVANCE(302);
      END_STATE();
    case 1793:
      if (lookahead == 'r') ADVANCE(529);
      END_STATE();
    case 1794:
      if (lookahead == 'r') ADVANCE(1620);
      END_STATE();
    case 1795:
      if (lookahead == 'r') ADVANCE(1330);
      END_STATE();
    case 1796:
      if (lookahead == 'r') ADVANCE(2136);
      END_STATE();
    case 1797:
      if (lookahead == 'r') ADVANCE(2138);
      END_STATE();
    case 1798:
      if (lookahead == 'r') ADVANCE(1583);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1799:
      if (lookahead == 'r') ADVANCE(1894);
      END_STATE();
    case 1800:
      if (lookahead == 'r') ADVANCE(987);
      END_STATE();
    case 1801:
      if (lookahead == 'r') ADVANCE(1578);
      END_STATE();
    case 1802:
      if (lookahead == 'r') ADVANCE(556);
      END_STATE();
    case 1803:
      if (lookahead == 'r') ADVANCE(2115);
      END_STATE();
    case 1804:
      if (lookahead == 'r') ADVANCE(2137);
      END_STATE();
    case 1805:
      if (lookahead == 'r') ADVANCE(1045);
      END_STATE();
    case 1806:
      if (lookahead == 'r') ADVANCE(1186);
      END_STATE();
    case 1807:
      if (lookahead == 'r') ADVANCE(1495);
      END_STATE();
    case 1808:
      if (lookahead == 'r') ADVANCE(753);
      END_STATE();
    case 1809:
      if (lookahead == 'r') ADVANCE(917);
      END_STATE();
    case 1810:
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 1811:
      if (lookahead == 'r') ADVANCE(1291);
      END_STATE();
    case 1812:
      if (lookahead == 'r') ADVANCE(1604);
      END_STATE();
    case 1813:
      if (lookahead == 'r') ADVANCE(1957);
      END_STATE();
    case 1814:
      if (lookahead == 'r') ADVANCE(1592);
      END_STATE();
    case 1815:
      if (lookahead == 'r') ADVANCE(1914);
      END_STATE();
    case 1816:
      if (lookahead == 'r') ADVANCE(826);
      END_STATE();
    case 1817:
      if (lookahead == 'r') ADVANCE(1597);
      END_STATE();
    case 1818:
      if (lookahead == 'r') ADVANCE(1750);
      END_STATE();
    case 1819:
      if (lookahead == 'r') ADVANCE(591);
      END_STATE();
    case 1820:
      if (lookahead == 'r') ADVANCE(1594);
      END_STATE();
    case 1821:
      if (lookahead == 'r') ADVANCE(2027);
      END_STATE();
    case 1822:
      if (lookahead == 'r') ADVANCE(1706);
      END_STATE();
    case 1823:
      if (lookahead == 'r') ADVANCE(2020);
      END_STATE();
    case 1824:
      if (lookahead == 'r') ADVANCE(1936);
      END_STATE();
    case 1825:
      if (lookahead == 'r') ADVANCE(1300);
      END_STATE();
    case 1826:
      if (lookahead == 'r') ADVANCE(1944);
      END_STATE();
    case 1827:
      if (lookahead == 'r') ADVANCE(969);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1828:
      if (lookahead == 'r') ADVANCE(1973);
      END_STATE();
    case 1829:
      if (lookahead == 'r') ADVANCE(594);
      END_STATE();
    case 1830:
      if (lookahead == 'r') ADVANCE(1262);
      END_STATE();
    case 1831:
      if (lookahead == 'r') ADVANCE(1601);
      END_STATE();
    case 1832:
      if (lookahead == 'r') ADVANCE(1536);
      END_STATE();
    case 1833:
      if (lookahead == 'r') ADVANCE(1922);
      END_STATE();
    case 1834:
      if (lookahead == 'r') ADVANCE(1525);
      END_STATE();
    case 1835:
      if (lookahead == 'r') ADVANCE(1240);
      END_STATE();
    case 1836:
      if (lookahead == 'r') ADVANCE(1564);
      END_STATE();
    case 1837:
      if (lookahead == 'r') ADVANCE(1388);
      END_STATE();
    case 1838:
      if (lookahead == 'r') ADVANCE(1297);
      END_STATE();
    case 1839:
      if (lookahead == 'r') ADVANCE(1392);
      END_STATE();
    case 1840:
      if (lookahead == 'r') ADVANCE(992);
      END_STATE();
    case 1841:
      if (lookahead == 'r') ADVANCE(1602);
      END_STATE();
    case 1842:
      if (lookahead == 'r') ADVANCE(1953);
      END_STATE();
    case 1843:
      if (lookahead == 'r') ADVANCE(933);
      if (lookahead == 't') ADVANCE(555);
      END_STATE();
    case 1844:
      if (lookahead == 'r') ADVANCE(1606);
      END_STATE();
    case 1845:
      if (lookahead == 'r') ADVANCE(1607);
      END_STATE();
    case 1846:
      if (lookahead == 'r') ADVANCE(1611);
      END_STATE();
    case 1847:
      if (lookahead == 'r') ADVANCE(1612);
      END_STATE();
    case 1848:
      if (lookahead == 'r') ADVANCE(1613);
      END_STATE();
    case 1849:
      if (lookahead == 'r') ADVANCE(1085);
      END_STATE();
    case 1850:
      if (lookahead == 'r') ADVANCE(936);
      END_STATE();
    case 1851:
      if (lookahead == 'r') ADVANCE(1617);
      END_STATE();
    case 1852:
      if (lookahead == 'r') ADVANCE(1756);
      END_STATE();
    case 1853:
      if (lookahead == 'r') ADVANCE(1041);
      END_STATE();
    case 1854:
      if (lookahead == 'r') ADVANCE(1746);
      END_STATE();
    case 1855:
      if (lookahead == 'r') ADVANCE(1779);
      END_STATE();
    case 1856:
      if (lookahead == 'r') ADVANCE(1060);
      END_STATE();
    case 1857:
      if (lookahead == 'r') ADVANCE(962);
      END_STATE();
    case 1858:
      if (lookahead == 'r') ADVANCE(684);
      END_STATE();
    case 1859:
      if (lookahead == 'r') ADVANCE(599);
      END_STATE();
    case 1860:
      if (lookahead == 'r') ADVANCE(644);
      END_STATE();
    case 1861:
      if (lookahead == 'r') ADVANCE(1272);
      END_STATE();
    case 1862:
      if (lookahead == 'r') ADVANCE(1937);
      END_STATE();
    case 1863:
      if (lookahead == 'r') ADVANCE(838);
      END_STATE();
    case 1864:
      if (lookahead == 'r') ADVANCE(2017);
      END_STATE();
    case 1865:
      if (lookahead == 'r') ADVANCE(1008);
      END_STATE();
    case 1866:
      if (lookahead == 'r') ADVANCE(1138);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 1867:
      if (lookahead == 'r') ADVANCE(2000);
      END_STATE();
    case 1868:
      if (lookahead == 'r') ADVANCE(2062);
      END_STATE();
    case 1869:
      if (lookahead == 'r') ADVANCE(1939);
      END_STATE();
    case 1870:
      if (lookahead == 'r') ADVANCE(1015);
      END_STATE();
    case 1871:
      if (lookahead == 'r') ADVANCE(1032);
      END_STATE();
    case 1872:
      if (lookahead == 'r') ADVANCE(1817);
      END_STATE();
    case 1873:
      if (lookahead == 'r') ADVANCE(623);
      END_STATE();
    case 1874:
      if (lookahead == 'r') ADVANCE(2015);
      END_STATE();
    case 1875:
      if (lookahead == 'r') ADVANCE(1831);
      END_STATE();
    case 1876:
      if (lookahead == 'r') ADVANCE(1841);
      END_STATE();
    case 1877:
      if (lookahead == 'r') ADVANCE(1845);
      END_STATE();
    case 1878:
      if (lookahead == 'r') ADVANCE(1846);
      END_STATE();
    case 1879:
      if (lookahead == 'r') ADVANCE(1847);
      END_STATE();
    case 1880:
      if (lookahead == 'r') ADVANCE(1851);
      END_STATE();
    case 1881:
      if (lookahead == 'r') ADVANCE(1050);
      END_STATE();
    case 1882:
      if (lookahead == 'r') ADVANCE(862);
      END_STATE();
    case 1883:
      if (lookahead == 'r') ADVANCE(1073);
      END_STATE();
    case 1884:
      if (lookahead == 'r') ADVANCE(466);
      END_STATE();
    case 1885:
      if (lookahead == 'r') ADVANCE(1719);
      END_STATE();
    case 1886:
      if (lookahead == 'r') ADVANCE(2038);
      END_STATE();
    case 1887:
      if (lookahead == 'r') ADVANCE(1721);
      END_STATE();
    case 1888:
      if (lookahead == 'r') ADVANCE(1082);
      END_STATE();
    case 1889:
      if (lookahead == 'r') ADVANCE(1083);
      END_STATE();
    case 1890:
      if (lookahead == 'r') ADVANCE(1084);
      END_STATE();
    case 1891:
      if (lookahead == 'r') ADVANCE(1324);
      END_STATE();
    case 1892:
      if (lookahead == 'r') ADVANCE(1326);
      END_STATE();
    case 1893:
      if (lookahead == 'r') ADVANCE(1327);
      END_STATE();
    case 1894:
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 1895:
      if (lookahead == 's') ADVANCE(1042);
      END_STATE();
    case 1896:
      if (lookahead == 's') ADVANCE(310);
      if (lookahead == 'u') ADVANCE(1480);
      END_STATE();
    case 1897:
      if (lookahead == 's') ADVANCE(465);
      END_STATE();
    case 1898:
      if (lookahead == 's') ADVANCE(491);
      END_STATE();
    case 1899:
      if (lookahead == 's') ADVANCE(196);
      END_STATE();
    case 1900:
      if (lookahead == 's') ADVANCE(344);
      END_STATE();
    case 1901:
      if (lookahead == 's') ADVANCE(214);
      END_STATE();
    case 1902:
      if (lookahead == 's') ADVANCE(173);
      END_STATE();
    case 1903:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 1904:
      if (lookahead == 's') ADVANCE(174);
      END_STATE();
    case 1905:
      if (lookahead == 's') ADVANCE(1949);
      END_STATE();
    case 1906:
      if (lookahead == 's') ADVANCE(485);
      END_STATE();
    case 1907:
      if (lookahead == 's') ADVANCE(1614);
      END_STATE();
    case 1908:
      if (lookahead == 's') ADVANCE(275);
      END_STATE();
    case 1909:
      if (lookahead == 's') ADVANCE(1214);
      END_STATE();
    case 1910:
      if (lookahead == 's') ADVANCE(499);
      END_STATE();
    case 1911:
      if (lookahead == 's') ADVANCE(333);
      END_STATE();
    case 1912:
      if (lookahead == 's') ADVANCE(241);
      END_STATE();
    case 1913:
      if (lookahead == 's') ADVANCE(199);
      END_STATE();
    case 1914:
      if (lookahead == 's') ADVANCE(1668);
      END_STATE();
    case 1915:
      if (lookahead == 's') ADVANCE(1174);
      END_STATE();
    case 1916:
      if (lookahead == 's') ADVANCE(2139);
      END_STATE();
    case 1917:
      if (lookahead == 's') ADVANCE(327);
      END_STATE();
    case 1918:
      if (lookahead == 's') ADVANCE(1175);
      END_STATE();
    case 1919:
      if (lookahead == 's') ADVANCE(1179);
      END_STATE();
    case 1920:
      if (lookahead == 's') ADVANCE(1894);
      END_STATE();
    case 1921:
      if (lookahead == 's') ADVANCE(1250);
      END_STATE();
    case 1922:
      if (lookahead == 's') ADVANCE(1349);
      END_STATE();
    case 1923:
      if (lookahead == 's') ADVANCE(2043);
      END_STATE();
    case 1924:
      if (lookahead == 's') ADVANCE(885);
      END_STATE();
    case 1925:
      if (lookahead == 's') ADVANCE(917);
      END_STATE();
    case 1926:
      if (lookahead == 's') ADVANCE(964);
      END_STATE();
    case 1927:
      if (lookahead == 's') ADVANCE(2092);
      END_STATE();
    case 1928:
      if (lookahead == 's') ADVANCE(2048);
      END_STATE();
    case 1929:
      if (lookahead == 's') ADVANCE(1994);
      END_STATE();
    case 1930:
      if (lookahead == 's') ADVANCE(1374);
      END_STATE();
    case 1931:
      if (lookahead == 's') ADVANCE(1906);
      END_STATE();
    case 1932:
      if (lookahead == 's') ADVANCE(1983);
      END_STATE();
    case 1933:
      if (lookahead == 's') ADVANCE(1987);
      END_STATE();
    case 1934:
      if (lookahead == 's') ADVANCE(1312);
      END_STATE();
    case 1935:
      if (lookahead == 's') ADVANCE(1980);
      END_STATE();
    case 1936:
      if (lookahead == 's') ADVANCE(1002);
      END_STATE();
    case 1937:
      if (lookahead == 's') ADVANCE(940);
      END_STATE();
    case 1938:
      if (lookahead == 's') ADVANCE(976);
      END_STATE();
    case 1939:
      if (lookahead == 's') ADVANCE(961);
      END_STATE();
    case 1940:
      if (lookahead == 's') ADVANCE(1184);
      END_STATE();
    case 1941:
      if (lookahead == 's') ADVANCE(2050);
      END_STATE();
    case 1942:
      if (lookahead == 's') ADVANCE(2005);
      END_STATE();
    case 1943:
      if (lookahead == 's') ADVANCE(1993);
      END_STATE();
    case 1944:
      if (lookahead == 's') ADVANCE(1007);
      END_STATE();
    case 1945:
      if (lookahead == 's') ADVANCE(1259);
      END_STATE();
    case 1946:
      if (lookahead == 's') ADVANCE(1022);
      END_STATE();
    case 1947:
      if (lookahead == 's') ADVANCE(1078);
      END_STATE();
    case 1948:
      if (lookahead == 't') ADVANCE(2129);
      END_STATE();
    case 1949:
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 1950:
      if (lookahead == 't') ADVANCE(148);
      if (lookahead == 'u') ADVANCE(742);
      END_STATE();
    case 1951:
      if (lookahead == 't') ADVANCE(148);
      if (lookahead == 'w') ADVANCE(1512);
      END_STATE();
    case 1952:
      if (lookahead == 't') ADVANCE(389);
      END_STATE();
    case 1953:
      if (lookahead == 't') ADVANCE(507);
      END_STATE();
    case 1954:
      if (lookahead == 't') ADVANCE(692);
      END_STATE();
    case 1955:
      if (lookahead == 't') ADVANCE(355);
      END_STATE();
    case 1956:
      if (lookahead == 't') ADVANCE(408);
      END_STATE();
    case 1957:
      if (lookahead == 't') ADVANCE(448);
      END_STATE();
    case 1958:
      if (lookahead == 't') ADVANCE(691);
      END_STATE();
    case 1959:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 1960:
      if (lookahead == 't') ADVANCE(1147);
      END_STATE();
    case 1961:
      if (lookahead == 't') ADVANCE(503);
      END_STATE();
    case 1962:
      if (lookahead == 't') ADVANCE(514);
      END_STATE();
    case 1963:
      if (lookahead == 't') ADVANCE(411);
      END_STATE();
    case 1964:
      if (lookahead == 't') ADVANCE(414);
      END_STATE();
    case 1965:
      if (lookahead == 't') ADVANCE(518);
      END_STATE();
    case 1966:
      if (lookahead == 't') ADVANCE(699);
      END_STATE();
    case 1967:
      if (lookahead == 't') ADVANCE(412);
      END_STATE();
    case 1968:
      if (lookahead == 't') ADVANCE(413);
      END_STATE();
    case 1969:
      if (lookahead == 't') ADVANCE(1741);
      END_STATE();
    case 1970:
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1971:
      if (lookahead == 't') ADVANCE(999);
      END_STATE();
    case 1972:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 1973:
      if (lookahead == 't') ADVANCE(1469);
      END_STATE();
    case 1974:
      if (lookahead == 't') ADVANCE(464);
      END_STATE();
    case 1975:
      if (lookahead == 't') ADVANCE(745);
      END_STATE();
    case 1976:
      if (lookahead == 't') ADVANCE(2130);
      END_STATE();
    case 1977:
      if (lookahead == 't') ADVANCE(247);
      if (lookahead == 'v') ADVANCE(1286);
      END_STATE();
    case 1978:
      if (lookahead == 't') ADVANCE(347);
      END_STATE();
    case 1979:
      if (lookahead == 't') ADVANCE(688);
      END_STATE();
    case 1980:
      if (lookahead == 't') ADVANCE(1579);
      END_STATE();
    case 1981:
      if (lookahead == 't') ADVANCE(409);
      END_STATE();
    case 1982:
      if (lookahead == 't') ADVANCE(1026);
      END_STATE();
    case 1983:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 1984:
      if (lookahead == 't') ADVANCE(2134);
      END_STATE();
    case 1985:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 1986:
      if (lookahead == 't') ADVANCE(515);
      END_STATE();
    case 1987:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 1988:
      if (lookahead == 't') ADVANCE(1174);
      END_STATE();
    case 1989:
      if (lookahead == 't') ADVANCE(2135);
      END_STATE();
    case 1990:
      if (lookahead == 't') ADVANCE(301);
      END_STATE();
    case 1991:
      if (lookahead == 't') ADVANCE(1179);
      END_STATE();
    case 1992:
      if (lookahead == 't') ADVANCE(300);
      END_STATE();
    case 1993:
      if (lookahead == 't') ADVANCE(1894);
      END_STATE();
    case 1994:
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 1995:
      if (lookahead == 't') ADVANCE(255);
      END_STATE();
    case 1996:
      if (lookahead == 't') ADVANCE(1176);
      END_STATE();
    case 1997:
      if (lookahead == 't') ADVANCE(1477);
      END_STATE();
    case 1998:
      if (lookahead == 't') ADVANCE(917);
      END_STATE();
    case 1999:
      if (lookahead == 't') ADVANCE(1649);
      END_STATE();
    case 2000:
      if (lookahead == 't') ADVANCE(1900);
      END_STATE();
    case 2001:
      if (lookahead == 't') ADVANCE(1204);
      END_STATE();
    case 2002:
      if (lookahead == 't') ADVANCE(1492);
      END_STATE();
    case 2003:
      if (lookahead == 't') ADVANCE(948);
      END_STATE();
    case 2004:
      if (lookahead == 't') ADVANCE(1926);
      END_STATE();
    case 2005:
      if (lookahead == 't') ADVANCE(990);
      END_STATE();
    case 2006:
      if (lookahead == 't') ADVANCE(1588);
      END_STATE();
    case 2007:
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 2008:
      if (lookahead == 't') ADVANCE(625);
      END_STATE();
    case 2009:
      if (lookahead == 't') ADVANCE(1285);
      END_STATE();
    case 2010:
      if (lookahead == 't') ADVANCE(1262);
      END_STATE();
    case 2011:
      if (lookahead == 't') ADVANCE(1296);
      END_STATE();
    case 2012:
      if (lookahead == 't') ADVANCE(1585);
      END_STATE();
    case 2013:
      if (lookahead == 't') ADVANCE(1287);
      END_STATE();
    case 2014:
      if (lookahead == 't') ADVANCE(1310);
      END_STATE();
    case 2015:
      if (lookahead == 't') ADVANCE(1304);
      END_STATE();
    case 2016:
      if (lookahead == 't') ADVANCE(1264);
      END_STATE();
    case 2017:
      if (lookahead == 't') ADVANCE(1744);
      END_STATE();
    case 2018:
      if (lookahead == 't') ADVANCE(1076);
      END_STATE();
    case 2019:
      if (lookahead == 't') ADVANCE(697);
      END_STATE();
    case 2020:
      if (lookahead == 't') ADVANCE(1544);
      END_STATE();
    case 2021:
      if (lookahead == 't') ADVANCE(1249);
      END_STATE();
    case 2022:
      if (lookahead == 't') ADVANCE(1642);
      END_STATE();
    case 2023:
      if (lookahead == 't') ADVANCE(1545);
      END_STATE();
    case 2024:
      if (lookahead == 't') ADVANCE(1829);
      END_STATE();
    case 2025:
      if (lookahead == 't') ADVANCE(1025);
      END_STATE();
    case 2026:
      if (lookahead == 't') ADVANCE(633);
      END_STATE();
    case 2027:
      if (lookahead == 't') ADVANCE(1226);
      END_STATE();
    case 2028:
      if (lookahead == 't') ADVANCE(1027);
      END_STATE();
    case 2029:
      if (lookahead == 't') ADVANCE(1029);
      END_STATE();
    case 2030:
      if (lookahead == 't') ADVANCE(1031);
      END_STATE();
    case 2031:
      if (lookahead == 't') ADVANCE(1034);
      END_STATE();
    case 2032:
      if (lookahead == 't') ADVANCE(1052);
      END_STATE();
    case 2033:
      if (lookahead == 't') ADVANCE(1036);
      END_STATE();
    case 2034:
      if (lookahead == 't') ADVANCE(1205);
      END_STATE();
    case 2035:
      if (lookahead == 't') ADVANCE(676);
      END_STATE();
    case 2036:
      if (lookahead == 't') ADVANCE(1295);
      END_STATE();
    case 2037:
      if (lookahead == 't') ADVANCE(1301);
      END_STATE();
    case 2038:
      if (lookahead == 't') ADVANCE(1311);
      END_STATE();
    case 2039:
      if (lookahead == 't') ADVANCE(696);
      END_STATE();
    case 2040:
      if (lookahead == 't') ADVANCE(685);
      END_STATE();
    case 2041:
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 2042:
      if (lookahead == 'u') ADVANCE(613);
      END_STATE();
    case 2043:
      if (lookahead == 'u') ADVANCE(2153);
      END_STATE();
    case 2044:
      if (lookahead == 'u') ADVANCE(1579);
      END_STATE();
    case 2045:
      if (lookahead == 'u') ADVANCE(299);
      END_STATE();
    case 2046:
      if (lookahead == 'u') ADVANCE(715);
      END_STATE();
    case 2047:
      if (lookahead == 'u') ADVANCE(728);
      END_STATE();
    case 2048:
      if (lookahead == 'u') ADVANCE(726);
      END_STATE();
    case 2049:
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 2050:
      if (lookahead == 'u') ADVANCE(709);
      END_STATE();
    case 2051:
      if (lookahead == 'u') ADVANCE(1898);
      END_STATE();
    case 2052:
      if (lookahead == 'u') ADVANCE(733);
      END_STATE();
    case 2053:
      if (lookahead == 'u') ADVANCE(1985);
      END_STATE();
    case 2054:
      if (lookahead == 'u') ADVANCE(1985);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 2055:
      if (lookahead == 'u') ADVANCE(1454);
      END_STATE();
    case 2056:
      if (lookahead == 'u') ADVANCE(1894);
      END_STATE();
    case 2057:
      if (lookahead == 'u') ADVANCE(1000);
      END_STATE();
    case 2058:
      if (lookahead == 'u') ADVANCE(1910);
      END_STATE();
    case 2059:
      if (lookahead == 'u') ADVANCE(917);
      END_STATE();
    case 2060:
      if (lookahead == 'u') ADVANCE(1457);
      END_STATE();
    case 2061:
      if (lookahead == 'u') ADVANCE(798);
      END_STATE();
    case 2062:
      if (lookahead == 'u') ADVANCE(950);
      END_STATE();
    case 2063:
      if (lookahead == 'u') ADVANCE(591);
      END_STATE();
    case 2064:
      if (lookahead == 'u') ADVANCE(1901);
      END_STATE();
    case 2065:
      if (lookahead == 'u') ADVANCE(1580);
      END_STATE();
    case 2066:
      if (lookahead == 'u') ADVANCE(1365);
      END_STATE();
    case 2067:
      if (lookahead == 'u') ADVANCE(1925);
      END_STATE();
    case 2068:
      if (lookahead == 'u') ADVANCE(832);
      END_STATE();
    case 2069:
      if (lookahead == 'u') ADVANCE(1912);
      END_STATE();
    case 2070:
      if (lookahead == 'u') ADVANCE(1233);
      END_STATE();
    case 2071:
      if (lookahead == 'u') ADVANCE(985);
      END_STATE();
    case 2072:
      if (lookahead == 'u') ADVANCE(612);
      END_STATE();
    case 2073:
      if (lookahead == 'u') ADVANCE(1298);
      END_STATE();
    case 2074:
      if (lookahead == 'u') ADVANCE(1232);
      END_STATE();
    case 2075:
      if (lookahead == 'u') ADVANCE(1772);
      END_STATE();
    case 2076:
      if (lookahead == 'u') ADVANCE(1744);
      END_STATE();
    case 2077:
      if (lookahead == 'u') ADVANCE(1773);
      END_STATE();
    case 2078:
      if (lookahead == 'u') ADVANCE(1837);
      END_STATE();
    case 2079:
      if (lookahead == 'u') ADVANCE(1839);
      END_STATE();
    case 2080:
      if (lookahead == 'u') ADVANCE(1184);
      END_STATE();
    case 2081:
      if (lookahead == 'u') ADVANCE(1467);
      END_STATE();
    case 2082:
      if (lookahead == 'u') ADVANCE(1538);
      END_STATE();
    case 2083:
      if (lookahead == 'u') ADVANCE(1932);
      END_STATE();
    case 2084:
      if (lookahead == 'u') ADVANCE(1267);
      END_STATE();
    case 2085:
      if (lookahead == 'u') ADVANCE(1391);
      END_STATE();
    case 2086:
      if (lookahead == 'u') ADVANCE(1998);
      END_STATE();
    case 2087:
      if (lookahead == 'u') ADVANCE(632);
      END_STATE();
    case 2088:
      if (lookahead == 'u') ADVANCE(1407);
      END_STATE();
    case 2089:
      if (lookahead == 'u') ADVANCE(1653);
      END_STATE();
    case 2090:
      if (lookahead == 'u') ADVANCE(1465);
      END_STATE();
    case 2091:
      if (lookahead == 'u') ADVANCE(638);
      END_STATE();
    case 2092:
      if (lookahead == 'u') ADVANCE(1853);
      END_STATE();
    case 2093:
      if (lookahead == 'u') ADVANCE(1446);
      END_STATE();
    case 2094:
      if (lookahead == 'u') ADVANCE(681);
      END_STATE();
    case 2095:
      if (lookahead == 'u') ADVANCE(739);
      END_STATE();
    case 2096:
      if (lookahead == 'u') ADVANCE(683);
      END_STATE();
    case 2097:
      if (lookahead == 'u') ADVANCE(738);
      if (lookahead == 'w') ADVANCE(1504);
      END_STATE();
    case 2098:
      if (lookahead == 'u') ADVANCE(741);
      END_STATE();
    case 2099:
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 2100:
      if (lookahead == 'v') ADVANCE(148);
      if (lookahead == 'w') ADVANCE(916);
      END_STATE();
    case 2101:
      if (lookahead == 'v') ADVANCE(162);
      END_STATE();
    case 2102:
      if (lookahead == 'v') ADVANCE(241);
      END_STATE();
    case 2103:
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(993);
      END_STATE();
    case 2104:
      if (lookahead == 'v') ADVANCE(917);
      END_STATE();
    case 2105:
      if (lookahead == 'v') ADVANCE(941);
      END_STATE();
    case 2106:
      if (lookahead == 'v') ADVANCE(1080);
      END_STATE();
    case 2107:
      if (lookahead == 'w') ADVANCE(148);
      END_STATE();
    case 2108:
      if (lookahead == 'w') ADVANCE(154);
      END_STATE();
    case 2109:
      if (lookahead == 'w') ADVANCE(158);
      END_STATE();
    case 2110:
      if (lookahead == 'w') ADVANCE(157);
      END_STATE();
    case 2111:
      if (lookahead == 'w') ADVANCE(156);
      END_STATE();
    case 2112:
      if (lookahead == 'w') ADVANCE(1579);
      END_STATE();
    case 2113:
      if (lookahead == 'w') ADVANCE(538);
      END_STATE();
    case 2114:
      if (lookahead == 'w') ADVANCE(322);
      END_STATE();
    case 2115:
      if (lookahead == 'w') ADVANCE(957);
      END_STATE();
    case 2116:
      if (lookahead == 'w') ADVANCE(1894);
      END_STATE();
    case 2117:
      if (lookahead == 'w') ADVANCE(1495);
      END_STATE();
    case 2118:
      if (lookahead == 'w') ADVANCE(1512);
      END_STATE();
    case 2119:
      if (lookahead == 'w') ADVANCE(1509);
      END_STATE();
    case 2120:
      if (lookahead == 'w') ADVANCE(1505);
      END_STATE();
    case 2121:
      if (lookahead == 'w') ADVANCE(1293);
      END_STATE();
    case 2122:
      if (lookahead == 'w') ADVANCE(340);
      END_STATE();
    case 2123:
      if (lookahead == 'w') ADVANCE(1419);
      END_STATE();
    case 2124:
      if (lookahead == 'w') ADVANCE(1577);
      END_STATE();
    case 2125:
      if (lookahead == 'w') ADVANCE(1576);
      END_STATE();
    case 2126:
      if (lookahead == 'x') ADVANCE(148);
      END_STATE();
    case 2127:
      if (lookahead == 'x') ADVANCE(1949);
      END_STATE();
    case 2128:
      if (lookahead == 'x') ADVANCE(250);
      END_STATE();
    case 2129:
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 2130:
      if (lookahead == 'y') ADVANCE(506);
      END_STATE();
    case 2131:
      if (lookahead == 'y') ADVANCE(975);
      END_STATE();
    case 2132:
      if (lookahead == 'y') ADVANCE(453);
      END_STATE();
    case 2133:
      if (lookahead == 'y') ADVANCE(468);
      END_STATE();
    case 2134:
      if (lookahead == 'y') ADVANCE(330);
      END_STATE();
    case 2135:
      if (lookahead == 'y') ADVANCE(2099);
      END_STATE();
    case 2136:
      if (lookahead == 'y') ADVANCE(505);
      END_STATE();
    case 2137:
      if (lookahead == 'y') ADVANCE(512);
      END_STATE();
    case 2138:
      if (lookahead == 'y') ADVANCE(481);
      END_STATE();
    case 2139:
      if (lookahead == 'y') ADVANCE(1454);
      END_STATE();
    case 2140:
      if (lookahead == 'y') ADVANCE(916);
      END_STATE();
    case 2141:
      if (lookahead == 'y') ADVANCE(1894);
      END_STATE();
    case 2142:
      if (lookahead == 'y') ADVANCE(964);
      END_STATE();
    case 2143:
      if (lookahead == 'z') ADVANCE(1656);
      END_STATE();
    case 2144:
      if (lookahead == 'z') ADVANCE(569);
      END_STATE();
    case 2145:
      if (lookahead == 'z') ADVANCE(1272);
      END_STATE();
    case 2146:
      if (lookahead == 'z') ADVANCE(1003);
      END_STATE();
    case 2147:
      if (lookahead == '2' ||
          lookahead == '4') ADVANCE(148);
      END_STATE();
    case 2148:
      if (lookahead == '3' ||
          lookahead == '5') ADVANCE(148);
      END_STATE();
    case 2149:
      if (lookahead == '6' ||
          lookahead == '8') ADVANCE(148);
      END_STATE();
    case 2150:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 2151:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(2171);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(373);
      END_STATE();
    case 2152:
      if (lookahead == 'a' ||
          lookahead == 'h') ADVANCE(148);
      if (lookahead == 'w') ADVANCE(1045);
      END_STATE();
    case 2153:
      if (lookahead == 'b' ||
          lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 2154:
      if (lookahead == 'b' ||
          lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 2155:
      if (lookahead == 'd' ||
          lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 2156:
      if (lookahead == 'e' ||
          lookahead == 'k') ADVANCE(148);
      END_STATE();
    case 2157:
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(148);
      END_STATE();
    case 2158:
      if (lookahead == 'f' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 2159:
      if (lookahead == 'l' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 2160:
      if (lookahead == 'o' ||
          lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 2161:
      if (lookahead == 'r' ||
          lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 2162:
      if (lookahead == '3' ||
          lookahead == '4') ADVANCE(148);
      END_STATE();
    case 2163:
      if (lookahead == 'R' ||
          lookahead == 'S') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1905);
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'd') ADVANCE(571);
      END_STATE();
    case 2164:
      if (lookahead == 'e' ||
          lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 2165:
      if (lookahead == '4' ||
          lookahead == '5' ||
          lookahead == '8') ADVANCE(148);
      if (lookahead == ';') ADVANCE(2180);
      END_STATE();
    case 2166:
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(148);
      END_STATE();
    case 2167:
      if (lookahead == 'L' ||
          lookahead == 'R' ||
          lookahead == 'l' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 2168:
      if (('1' <= lookahead && lookahead <= '3') ||
          lookahead == 'E') ADVANCE(148);
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1590);
      if (lookahead == 'e') ADVANCE(233);
      if (lookahead == 'h') ADVANCE(1907);
      if (lookahead == 'l') ADVANCE(575);
      if (lookahead == 'm') ADVANCE(2066);
      if (lookahead == 'n') ADVANCE(2150);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 's') ADVANCE(1017);
      END_STATE();
    case 2169:
      if (('2' <= lookahead && lookahead <= '6') ||
          lookahead == '8') ADVANCE(148);
      if (lookahead == ';') ADVANCE(2180);
      END_STATE();
    case 2170:
      if (('a' <= lookahead && lookahead <= 'h')) ADVANCE(148);
      END_STATE();
    case 2171:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(378);
      END_STATE();
    case 2172:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(15);
      END_STATE();
    case 2173:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 2174:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2201);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 2175:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2208);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 2176:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2184);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 2177:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 2178:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2179:
      ACCEPT_TOKEN(sym__backslash_escape);
      END_STATE();
    case 2180:
      ACCEPT_TOKEN(sym_entity_reference);
      END_STATE();
    case 2181:
      ACCEPT_TOKEN(sym_numeric_character_reference);
      END_STATE();
    case 2182:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 2183:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 2184:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']') ADVANCE(380);
      END_STATE();
    case 2185:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 2186:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(13);
      if (lookahead == '?') ADVANCE(2231);
      if (('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('^' <= lookahead && lookahead <= '`') ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(383);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(382);
      END_STATE();
    case 2187:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(16);
      if (lookahead == '?') ADVANCE(2230);
      END_STATE();
    case 2188:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 2189:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 2190:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 2191:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 2192:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 2193:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 2194:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 2195:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '#') ADVANCE(2151);
      if (lookahead == 'A') ADVANCE(454);
      if (lookahead == 'B') ADVANCE(523);
      if (lookahead == 'C') ADVANCE(477);
      if (lookahead == 'D') ADVANCE(437);
      if (lookahead == 'E') ADVANCE(493);
      if (lookahead == 'F') ADVANCE(748);
      if (lookahead == 'G') ADVANCE(180);
      if (lookahead == 'H') ADVANCE(384);
      if (lookahead == 'I') ADVANCE(460);
      if (lookahead == 'J') ADVANCE(850);
      if (lookahead == 'K') ADVANCE(476);
      if (lookahead == 'L') ADVANCE(179);
      if (lookahead == 'M') ADVANCE(565);
      if (lookahead == 'N') ADVANCE(484);
      if (lookahead == 'O') ADVANCE(462);
      if (lookahead == 'P') ADVANCE(561);
      if (lookahead == 'Q') ADVANCE(516);
      if (lookahead == 'R') ADVANCE(417);
      if (lookahead == 'S') ADVANCE(473);
      if (lookahead == 'T') ADVANCE(474);
      if (lookahead == 'U') ADVANCE(542);
      if (lookahead == 'V') ADVANCE(446);
      if (lookahead == 'W') ADVANCE(802);
      if (lookahead == 'X') ADVANCE(1090);
      if (lookahead == 'Y') ADVANCE(387);
      if (lookahead == 'Z') ADVANCE(478);
      if (lookahead == 'a') ADVANCE(521);
      if (lookahead == 'b') ADVANCE(492);
      if (lookahead == 'c') ADVANCE(528);
      if (lookahead == 'd') ADVANCE(393);
      if (lookahead == 'e') ADVANCE(439);
      if (lookahead == 'f') ADVANCE(570);
      if (lookahead == 'g') ADVANCE(169);
      if (lookahead == 'h') ADVANCE(395);
      if (lookahead == 'i') ADVANCE(522);
      if (lookahead == 'j') ADVANCE(849);
      if (lookahead == 'k') ADVANCE(654);
      if (lookahead == 'l') ADVANCE(149);
      if (lookahead == 'm') ADVANCE(440);
      if (lookahead == 'n') ADVANCE(470);
      if (lookahead == 'o') ADVANCE(504);
      if (lookahead == 'p') ADVANCE(592);
      if (lookahead == 'q') ADVANCE(1091);
      if (lookahead == 'r') ADVANCE(385);
      if (lookahead == 's') ADVANCE(649);
      if (lookahead == 't') ADVANCE(545);
      if (lookahead == 'u') ADVANCE(394);
      if (lookahead == 'v') ADVANCE(391);
      if (lookahead == 'w') ADVANCE(801);
      if (lookahead == 'x') ADVANCE(757);
      if (lookahead == 'y') ADVANCE(560);
      if (lookahead == 'z') ADVANCE(650);
      END_STATE();
    case 2196:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 2197:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 2198:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 2199:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 2200:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 2201:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(379);
      END_STATE();
    case 2202:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 2203:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 2204:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 2205:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 2206:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 2207:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 2208:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '>') ADVANCE(2232);
      END_STATE();
    case 2209:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 2210:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 2211:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (('!' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '@') ||
          ('[' <= lookahead && lookahead <= '`') ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(2179);
      END_STATE();
    case 2212:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 2213:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2214:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 2215:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 2216:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 2217:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 2218:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 2219:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 2220:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 2221:
      ACCEPT_TOKEN(sym__newline_token);
      END_STATE();
    case 2222:
      ACCEPT_TOKEN(sym__newline_token);
      if (lookahead == '\n') ADVANCE(2221);
      END_STATE();
    case 2223:
      ACCEPT_TOKEN(sym_uri_autolink);
      END_STATE();
    case 2224:
      ACCEPT_TOKEN(sym_email_autolink);
      END_STATE();
    case 2225:
      ACCEPT_TOKEN(sym__attribute_name);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= ':') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2225);
      END_STATE();
    case 2226:
      ACCEPT_TOKEN(aux_sym__attribute_value_token1);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          (lookahead < '<' || '>' < lookahead) &&
          lookahead != '`') ADVANCE(2226);
      END_STATE();
    case 2227:
      ACCEPT_TOKEN(anon_sym_LT_BANG_DASH_DASH);
      END_STATE();
    case 2228:
      ACCEPT_TOKEN(anon_sym_LT_BANG_DASH_DASH);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 2229:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_GT);
      END_STATE();
    case 2230:
      ACCEPT_TOKEN(anon_sym_LT_QMARK);
      END_STATE();
    case 2231:
      ACCEPT_TOKEN(anon_sym_LT_QMARK);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 2232:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      END_STATE();
    case 2233:
      ACCEPT_TOKEN(aux_sym__declaration_token1);
      if (lookahead == '@') ADVANCE(2172);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(2233);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          lookahead == '?' ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 2234:
      ACCEPT_TOKEN(aux_sym__declaration_token1);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(2234);
      END_STATE();
    case 2235:
      ACCEPT_TOKEN(anon_sym_LT_BANG_LBRACKCDATA_LBRACK);
      END_STATE();
    case 2236:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK_GT);
      END_STATE();
    case 2237:
      ACCEPT_TOKEN(sym__whitespace_ge_2);
      END_STATE();
    case 2238:
      ACCEPT_TOKEN(sym__whitespace_ge_2);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2238);
      END_STATE();
    case 2239:
      ACCEPT_TOKEN(aux_sym__whitespace_token1);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2238);
      END_STATE();
    case 2240:
      ACCEPT_TOKEN(sym__word_no_digit);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(2240);
      END_STATE();
    case 2241:
      ACCEPT_TOKEN(sym__digits);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 2177, .external_lex_state = 2},
  [2] = {.lex_state = 2177, .external_lex_state = 3},
  [3] = {.lex_state = 2177, .external_lex_state = 4},
  [4] = {.lex_state = 2177, .external_lex_state = 4},
  [5] = {.lex_state = 2177, .external_lex_state = 5},
  [6] = {.lex_state = 2177, .external_lex_state = 4},
  [7] = {.lex_state = 2177, .external_lex_state = 3},
  [8] = {.lex_state = 2177, .external_lex_state = 6},
  [9] = {.lex_state = 2177, .external_lex_state = 6},
  [10] = {.lex_state = 2177, .external_lex_state = 5},
  [11] = {.lex_state = 2177, .external_lex_state = 7},
  [12] = {.lex_state = 2177, .external_lex_state = 8},
  [13] = {.lex_state = 2177, .external_lex_state = 9},
  [14] = {.lex_state = 2177, .external_lex_state = 9},
  [15] = {.lex_state = 2177, .external_lex_state = 7},
  [16] = {.lex_state = 2177, .external_lex_state = 9},
  [17] = {.lex_state = 2177, .external_lex_state = 8},
  [18] = {.lex_state = 2177, .external_lex_state = 7},
  [19] = {.lex_state = 2177, .external_lex_state = 9},
  [20] = {.lex_state = 2177, .external_lex_state = 8},
  [21] = {.lex_state = 2177, .external_lex_state = 7},
  [22] = {.lex_state = 2177, .external_lex_state = 8},
  [23] = {.lex_state = 2177, .external_lex_state = 8},
  [24] = {.lex_state = 2177, .external_lex_state = 7},
  [25] = {.lex_state = 2177, .external_lex_state = 8},
  [26] = {.lex_state = 2177, .external_lex_state = 9},
  [27] = {.lex_state = 2177, .external_lex_state = 9},
  [28] = {.lex_state = 2177, .external_lex_state = 4},
  [29] = {.lex_state = 2177, .external_lex_state = 4},
  [30] = {.lex_state = 2177, .external_lex_state = 4},
  [31] = {.lex_state = 2177, .external_lex_state = 10},
  [32] = {.lex_state = 2177, .external_lex_state = 8},
  [33] = {.lex_state = 2177, .external_lex_state = 7},
  [34] = {.lex_state = 2177, .external_lex_state = 8},
  [35] = {.lex_state = 2177, .external_lex_state = 9},
  [36] = {.lex_state = 2177, .external_lex_state = 4},
  [37] = {.lex_state = 2177, .external_lex_state = 7},
  [38] = {.lex_state = 2177, .external_lex_state = 9},
  [39] = {.lex_state = 2177, .external_lex_state = 9},
  [40] = {.lex_state = 2177, .external_lex_state = 7},
  [41] = {.lex_state = 2177, .external_lex_state = 9},
  [42] = {.lex_state = 2177, .external_lex_state = 7},
  [43] = {.lex_state = 2177, .external_lex_state = 7},
  [44] = {.lex_state = 2177, .external_lex_state = 4},
  [45] = {.lex_state = 2177, .external_lex_state = 7},
  [46] = {.lex_state = 2177, .external_lex_state = 4},
  [47] = {.lex_state = 2177, .external_lex_state = 8},
  [48] = {.lex_state = 2177, .external_lex_state = 10},
  [49] = {.lex_state = 2177, .external_lex_state = 8},
  [50] = {.lex_state = 2177, .external_lex_state = 9},
  [51] = {.lex_state = 2177, .external_lex_state = 8},
  [52] = {.lex_state = 2177, .external_lex_state = 10},
  [53] = {.lex_state = 2177, .external_lex_state = 10},
  [54] = {.lex_state = 2177, .external_lex_state = 10},
  [55] = {.lex_state = 2177, .external_lex_state = 10},
  [56] = {.lex_state = 2177, .external_lex_state = 10},
  [57] = {.lex_state = 2177, .external_lex_state = 10},
  [58] = {.lex_state = 2177, .external_lex_state = 10},
  [59] = {.lex_state = 2177, .external_lex_state = 10},
  [60] = {.lex_state = 2177, .external_lex_state = 10},
  [61] = {.lex_state = 2177, .external_lex_state = 10},
  [62] = {.lex_state = 2177, .external_lex_state = 10},
  [63] = {.lex_state = 2177, .external_lex_state = 10},
  [64] = {.lex_state = 2177, .external_lex_state = 10},
  [65] = {.lex_state = 2177, .external_lex_state = 10},
  [66] = {.lex_state = 2177, .external_lex_state = 10},
  [67] = {.lex_state = 2177, .external_lex_state = 10},
  [68] = {.lex_state = 2177, .external_lex_state = 10},
  [69] = {.lex_state = 2177, .external_lex_state = 10},
  [70] = {.lex_state = 2177, .external_lex_state = 10},
  [71] = {.lex_state = 2177, .external_lex_state = 10},
  [72] = {.lex_state = 2177, .external_lex_state = 10},
  [73] = {.lex_state = 2177, .external_lex_state = 10},
  [74] = {.lex_state = 2177, .external_lex_state = 10},
  [75] = {.lex_state = 2177, .external_lex_state = 10},
  [76] = {.lex_state = 2177, .external_lex_state = 10},
  [77] = {.lex_state = 2177, .external_lex_state = 10},
  [78] = {.lex_state = 2177, .external_lex_state = 10},
  [79] = {.lex_state = 2177, .external_lex_state = 10},
  [80] = {.lex_state = 2177, .external_lex_state = 10},
  [81] = {.lex_state = 2177, .external_lex_state = 10},
  [82] = {.lex_state = 2177, .external_lex_state = 10},
  [83] = {.lex_state = 2177, .external_lex_state = 10},
  [84] = {.lex_state = 2177, .external_lex_state = 10},
  [85] = {.lex_state = 2177, .external_lex_state = 10},
  [86] = {.lex_state = 2177, .external_lex_state = 6},
  [87] = {.lex_state = 2177, .external_lex_state = 5},
  [88] = {.lex_state = 2177, .external_lex_state = 3},
  [89] = {.lex_state = 2177, .external_lex_state = 4},
  [90] = {.lex_state = 2177, .external_lex_state = 4},
  [91] = {.lex_state = 2177, .external_lex_state = 5},
  [92] = {.lex_state = 2177, .external_lex_state = 3},
  [93] = {.lex_state = 2177, .external_lex_state = 4},
  [94] = {.lex_state = 2177, .external_lex_state = 4},
  [95] = {.lex_state = 2177, .external_lex_state = 4},
  [96] = {.lex_state = 2177, .external_lex_state = 3},
  [97] = {.lex_state = 2177, .external_lex_state = 6},
  [98] = {.lex_state = 2177, .external_lex_state = 5},
  [99] = {.lex_state = 2177, .external_lex_state = 6},
  [100] = {.lex_state = 2177, .external_lex_state = 10},
  [101] = {.lex_state = 2177, .external_lex_state = 9},
  [102] = {.lex_state = 2177, .external_lex_state = 7},
  [103] = {.lex_state = 2177, .external_lex_state = 7},
  [104] = {.lex_state = 2177, .external_lex_state = 8},
  [105] = {.lex_state = 2177, .external_lex_state = 9},
  [106] = {.lex_state = 2177, .external_lex_state = 10},
  [107] = {.lex_state = 2177, .external_lex_state = 7},
  [108] = {.lex_state = 2177, .external_lex_state = 9},
  [109] = {.lex_state = 2177, .external_lex_state = 9},
  [110] = {.lex_state = 2177, .external_lex_state = 8},
  [111] = {.lex_state = 2177, .external_lex_state = 8},
  [112] = {.lex_state = 2177, .external_lex_state = 7},
  [113] = {.lex_state = 2177, .external_lex_state = 9},
  [114] = {.lex_state = 2177, .external_lex_state = 10},
  [115] = {.lex_state = 2177, .external_lex_state = 9},
  [116] = {.lex_state = 2177, .external_lex_state = 8},
  [117] = {.lex_state = 2177, .external_lex_state = 8},
  [118] = {.lex_state = 2177, .external_lex_state = 9},
  [119] = {.lex_state = 2177, .external_lex_state = 7},
  [120] = {.lex_state = 2177, .external_lex_state = 9},
  [121] = {.lex_state = 2177, .external_lex_state = 4},
  [122] = {.lex_state = 2177, .external_lex_state = 8},
  [123] = {.lex_state = 2177, .external_lex_state = 7},
  [124] = {.lex_state = 2177, .external_lex_state = 9},
  [125] = {.lex_state = 2177, .external_lex_state = 7},
  [126] = {.lex_state = 2177, .external_lex_state = 4},
  [127] = {.lex_state = 2177, .external_lex_state = 7},
  [128] = {.lex_state = 2177, .external_lex_state = 8},
  [129] = {.lex_state = 2177, .external_lex_state = 8},
  [130] = {.lex_state = 2177, .external_lex_state = 8},
  [131] = {.lex_state = 2177, .external_lex_state = 10},
  [132] = {.lex_state = 2177, .external_lex_state = 10},
  [133] = {.lex_state = 2177, .external_lex_state = 4},
  [134] = {.lex_state = 2177, .external_lex_state = 10},
  [135] = {.lex_state = 2177, .external_lex_state = 7},
  [136] = {.lex_state = 2177, .external_lex_state = 10},
  [137] = {.lex_state = 2177, .external_lex_state = 10},
  [138] = {.lex_state = 2177, .external_lex_state = 10},
  [139] = {.lex_state = 2177, .external_lex_state = 10},
  [140] = {.lex_state = 2177, .external_lex_state = 10},
  [141] = {.lex_state = 2177, .external_lex_state = 10},
  [142] = {.lex_state = 2177, .external_lex_state = 10},
  [143] = {.lex_state = 2177, .external_lex_state = 10},
  [144] = {.lex_state = 2177, .external_lex_state = 10},
  [145] = {.lex_state = 2177, .external_lex_state = 10},
  [146] = {.lex_state = 2177, .external_lex_state = 10},
  [147] = {.lex_state = 2177, .external_lex_state = 10},
  [148] = {.lex_state = 2177, .external_lex_state = 10},
  [149] = {.lex_state = 2177, .external_lex_state = 7},
  [150] = {.lex_state = 2177, .external_lex_state = 9},
  [151] = {.lex_state = 2177, .external_lex_state = 7},
  [152] = {.lex_state = 2177, .external_lex_state = 8},
  [153] = {.lex_state = 2177, .external_lex_state = 8},
  [154] = {.lex_state = 2177, .external_lex_state = 9},
  [155] = {.lex_state = 2177, .external_lex_state = 10},
  [156] = {.lex_state = 2177, .external_lex_state = 10},
  [157] = {.lex_state = 2177, .external_lex_state = 10},
  [158] = {.lex_state = 2177, .external_lex_state = 9},
  [159] = {.lex_state = 2177, .external_lex_state = 8},
  [160] = {.lex_state = 2177, .external_lex_state = 10},
  [161] = {.lex_state = 2177, .external_lex_state = 9},
  [162] = {.lex_state = 2177, .external_lex_state = 10},
  [163] = {.lex_state = 2177, .external_lex_state = 7},
  [164] = {.lex_state = 2177, .external_lex_state = 8},
  [165] = {.lex_state = 2177, .external_lex_state = 7},
  [166] = {.lex_state = 2176, .external_lex_state = 8},
  [167] = {.lex_state = 2175, .external_lex_state = 8},
  [168] = {.lex_state = 2175, .external_lex_state = 8},
  [169] = {.lex_state = 2175, .external_lex_state = 9},
  [170] = {.lex_state = 2175, .external_lex_state = 7},
  [171] = {.lex_state = 2176, .external_lex_state = 9},
  [172] = {.lex_state = 2176, .external_lex_state = 7},
  [173] = {.lex_state = 2175, .external_lex_state = 9},
  [174] = {.lex_state = 2176, .external_lex_state = 7},
  [175] = {.lex_state = 2175, .external_lex_state = 10},
  [176] = {.lex_state = 2176, .external_lex_state = 8},
  [177] = {.lex_state = 2176, .external_lex_state = 9},
  [178] = {.lex_state = 2176, .external_lex_state = 10},
  [179] = {.lex_state = 2175, .external_lex_state = 7},
  [180] = {.lex_state = 2174, .external_lex_state = 8},
  [181] = {.lex_state = 2174, .external_lex_state = 7},
  [182] = {.lex_state = 2174, .external_lex_state = 8},
  [183] = {.lex_state = 2174, .external_lex_state = 10},
  [184] = {.lex_state = 2175, .external_lex_state = 10},
  [185] = {.lex_state = 2174, .external_lex_state = 9},
  [186] = {.lex_state = 2175, .external_lex_state = 10},
  [187] = {.lex_state = 2174, .external_lex_state = 7},
  [188] = {.lex_state = 2176, .external_lex_state = 10},
  [189] = {.lex_state = 2174, .external_lex_state = 9},
  [190] = {.lex_state = 2176, .external_lex_state = 10},
  [191] = {.lex_state = 2174, .external_lex_state = 10},
  [192] = {.lex_state = 2174, .external_lex_state = 10},
  [193] = {.lex_state = 2177, .external_lex_state = 11},
  [194] = {.lex_state = 2177, .external_lex_state = 3},
  [195] = {.lex_state = 2177, .external_lex_state = 6},
  [196] = {.lex_state = 2177, .external_lex_state = 12},
  [197] = {.lex_state = 2177, .external_lex_state = 6},
  [198] = {.lex_state = 2177, .external_lex_state = 7},
  [199] = {.lex_state = 2177, .external_lex_state = 4},
  [200] = {.lex_state = 2177, .external_lex_state = 9},
  [201] = {.lex_state = 2177, .external_lex_state = 4},
  [202] = {.lex_state = 2177, .external_lex_state = 5},
  [203] = {.lex_state = 2177, .external_lex_state = 13},
  [204] = {.lex_state = 2177, .external_lex_state = 8},
  [205] = {.lex_state = 2177, .external_lex_state = 10},
  [206] = {.lex_state = 2177, .external_lex_state = 5},
  [207] = {.lex_state = 2177, .external_lex_state = 2},
  [208] = {.lex_state = 2177, .external_lex_state = 3},
  [209] = {.lex_state = 7, .external_lex_state = 14},
  [210] = {.lex_state = 2177, .external_lex_state = 5},
  [211] = {.lex_state = 2177, .external_lex_state = 6},
  [212] = {.lex_state = 2177, .external_lex_state = 6},
  [213] = {.lex_state = 2177, .external_lex_state = 3},
  [214] = {.lex_state = 2177, .external_lex_state = 10},
  [215] = {.lex_state = 7, .external_lex_state = 15},
  [216] = {.lex_state = 2177, .external_lex_state = 12},
  [217] = {.lex_state = 2177, .external_lex_state = 12},
  [218] = {.lex_state = 7, .external_lex_state = 15},
  [219] = {.lex_state = 2177, .external_lex_state = 3},
  [220] = {.lex_state = 7, .external_lex_state = 15},
  [221] = {.lex_state = 7, .external_lex_state = 14},
  [222] = {.lex_state = 7, .external_lex_state = 15},
  [223] = {.lex_state = 2177, .external_lex_state = 3},
  [224] = {.lex_state = 7, .external_lex_state = 14},
  [225] = {.lex_state = 2177, .external_lex_state = 3},
  [226] = {.lex_state = 2177, .external_lex_state = 6},
  [227] = {.lex_state = 2177, .external_lex_state = 2},
  [228] = {.lex_state = 7, .external_lex_state = 15},
  [229] = {.lex_state = 7, .external_lex_state = 15},
  [230] = {.lex_state = 2177, .external_lex_state = 6},
  [231] = {.lex_state = 7, .external_lex_state = 14},
  [232] = {.lex_state = 2177, .external_lex_state = 5},
  [233] = {.lex_state = 7, .external_lex_state = 14},
  [234] = {.lex_state = 2177, .external_lex_state = 11},
  [235] = {.lex_state = 7, .external_lex_state = 15},
  [236] = {.lex_state = 7, .external_lex_state = 14},
  [237] = {.lex_state = 7, .external_lex_state = 14},
  [238] = {.lex_state = 2177, .external_lex_state = 4},
  [239] = {.lex_state = 7, .external_lex_state = 14},
  [240] = {.lex_state = 2177, .external_lex_state = 6},
  [241] = {.lex_state = 2177, .external_lex_state = 2},
  [242] = {.lex_state = 2177, .external_lex_state = 11},
  [243] = {.lex_state = 2177, .external_lex_state = 5},
  [244] = {.lex_state = 2177, .external_lex_state = 4},
  [245] = {.lex_state = 2177, .external_lex_state = 5},
  [246] = {.lex_state = 2177, .external_lex_state = 4},
  [247] = {.lex_state = 2177, .external_lex_state = 5},
  [248] = {.lex_state = 2177, .external_lex_state = 13},
  [249] = {.lex_state = 2177, .external_lex_state = 3},
  [250] = {.lex_state = 7, .external_lex_state = 14},
  [251] = {.lex_state = 7, .external_lex_state = 14},
  [252] = {.lex_state = 2177, .external_lex_state = 2},
  [253] = {.lex_state = 2177, .external_lex_state = 4},
  [254] = {.lex_state = 2177, .external_lex_state = 4},
  [255] = {.lex_state = 7, .external_lex_state = 15},
  [256] = {.lex_state = 7, .external_lex_state = 15},
  [257] = {.lex_state = 7, .external_lex_state = 14},
  [258] = {.lex_state = 2177, .external_lex_state = 4},
  [259] = {.lex_state = 2177, .external_lex_state = 13},
  [260] = {.lex_state = 7, .external_lex_state = 15},
  [261] = {.lex_state = 7, .external_lex_state = 15},
  [262] = {.lex_state = 2177, .external_lex_state = 8},
  [263] = {.lex_state = 2177, .external_lex_state = 9},
  [264] = {.lex_state = 2177, .external_lex_state = 10},
  [265] = {.lex_state = 2177, .external_lex_state = 10},
  [266] = {.lex_state = 2177, .external_lex_state = 10},
  [267] = {.lex_state = 2177, .external_lex_state = 10},
  [268] = {.lex_state = 2177, .external_lex_state = 8},
  [269] = {.lex_state = 1, .external_lex_state = 16},
  [270] = {.lex_state = 2177, .external_lex_state = 5},
  [271] = {.lex_state = 2177, .external_lex_state = 7},
  [272] = {.lex_state = 2177, .external_lex_state = 10},
  [273] = {.lex_state = 1, .external_lex_state = 16},
  [274] = {.lex_state = 2177, .external_lex_state = 10},
  [275] = {.lex_state = 2177, .external_lex_state = 10},
  [276] = {.lex_state = 2177, .external_lex_state = 10},
  [277] = {.lex_state = 2177, .external_lex_state = 10},
  [278] = {.lex_state = 2177, .external_lex_state = 10},
  [279] = {.lex_state = 2177, .external_lex_state = 2},
  [280] = {.lex_state = 2177, .external_lex_state = 10},
  [281] = {.lex_state = 2177, .external_lex_state = 10},
  [282] = {.lex_state = 2177, .external_lex_state = 7},
  [283] = {.lex_state = 2177, .external_lex_state = 10},
  [284] = {.lex_state = 2177, .external_lex_state = 7},
  [285] = {.lex_state = 2177, .external_lex_state = 2},
  [286] = {.lex_state = 2177, .external_lex_state = 3},
  [287] = {.lex_state = 2177, .external_lex_state = 10},
  [288] = {.lex_state = 1, .external_lex_state = 16},
  [289] = {.lex_state = 2177, .external_lex_state = 4},
  [290] = {.lex_state = 2177, .external_lex_state = 8},
  [291] = {.lex_state = 2177, .external_lex_state = 8},
  [292] = {.lex_state = 2177, .external_lex_state = 9},
  [293] = {.lex_state = 2177, .external_lex_state = 10},
  [294] = {.lex_state = 2177, .external_lex_state = 10},
  [295] = {.lex_state = 2177, .external_lex_state = 10},
  [296] = {.lex_state = 2177, .external_lex_state = 10},
  [297] = {.lex_state = 2177, .external_lex_state = 10},
  [298] = {.lex_state = 2177, .external_lex_state = 10},
  [299] = {.lex_state = 2177, .external_lex_state = 10},
  [300] = {.lex_state = 1, .external_lex_state = 16},
  [301] = {.lex_state = 2177, .external_lex_state = 10},
  [302] = {.lex_state = 1, .external_lex_state = 16},
  [303] = {.lex_state = 2177, .external_lex_state = 10},
  [304] = {.lex_state = 2177, .external_lex_state = 4},
  [305] = {.lex_state = 1, .external_lex_state = 16},
  [306] = {.lex_state = 2177, .external_lex_state = 10},
  [307] = {.lex_state = 2177, .external_lex_state = 10},
  [308] = {.lex_state = 2177, .external_lex_state = 10},
  [309] = {.lex_state = 2177, .external_lex_state = 10},
  [310] = {.lex_state = 2177, .external_lex_state = 10},
  [311] = {.lex_state = 2177, .external_lex_state = 10},
  [312] = {.lex_state = 2177, .external_lex_state = 8},
  [313] = {.lex_state = 1, .external_lex_state = 16},
  [314] = {.lex_state = 2177, .external_lex_state = 7},
  [315] = {.lex_state = 2177, .external_lex_state = 10},
  [316] = {.lex_state = 2177, .external_lex_state = 10},
  [317] = {.lex_state = 2177, .external_lex_state = 7},
  [318] = {.lex_state = 2177, .external_lex_state = 10},
  [319] = {.lex_state = 2177, .external_lex_state = 6},
  [320] = {.lex_state = 2177, .external_lex_state = 8},
  [321] = {.lex_state = 2177, .external_lex_state = 9},
  [322] = {.lex_state = 2177, .external_lex_state = 9},
  [323] = {.lex_state = 2177, .external_lex_state = 9},
  [324] = {.lex_state = 2177, .external_lex_state = 9},
  [325] = {.lex_state = 2177, .external_lex_state = 9},
  [326] = {.lex_state = 2177, .external_lex_state = 10},
  [327] = {.lex_state = 2177, .external_lex_state = 10},
  [328] = {.lex_state = 1, .external_lex_state = 16},
  [329] = {.lex_state = 2177, .external_lex_state = 9},
  [330] = {.lex_state = 2177, .external_lex_state = 9},
  [331] = {.lex_state = 2177, .external_lex_state = 7},
  [332] = {.lex_state = 2177, .external_lex_state = 4},
  [333] = {.lex_state = 2177, .external_lex_state = 4},
  [334] = {.lex_state = 2177, .external_lex_state = 9},
  [335] = {.lex_state = 2177, .external_lex_state = 9},
  [336] = {.lex_state = 1, .external_lex_state = 16},
  [337] = {.lex_state = 1, .external_lex_state = 16},
  [338] = {.lex_state = 2177, .external_lex_state = 9},
  [339] = {.lex_state = 2177, .external_lex_state = 9},
  [340] = {.lex_state = 2177, .external_lex_state = 9},
  [341] = {.lex_state = 2177, .external_lex_state = 9},
  [342] = {.lex_state = 2177, .external_lex_state = 9},
  [343] = {.lex_state = 2177, .external_lex_state = 10},
  [344] = {.lex_state = 2177, .external_lex_state = 9},
  [345] = {.lex_state = 2177, .external_lex_state = 7},
  [346] = {.lex_state = 2177, .external_lex_state = 7},
  [347] = {.lex_state = 2177, .external_lex_state = 7},
  [348] = {.lex_state = 2177, .external_lex_state = 7},
  [349] = {.lex_state = 1, .external_lex_state = 16},
  [350] = {.lex_state = 2177, .external_lex_state = 9},
  [351] = {.lex_state = 2177, .external_lex_state = 9},
  [352] = {.lex_state = 2177, .external_lex_state = 9},
  [353] = {.lex_state = 2177, .external_lex_state = 7},
  [354] = {.lex_state = 2177, .external_lex_state = 7},
  [355] = {.lex_state = 2177, .external_lex_state = 9},
  [356] = {.lex_state = 2177, .external_lex_state = 9},
  [357] = {.lex_state = 2177, .external_lex_state = 7},
  [358] = {.lex_state = 2177, .external_lex_state = 10},
  [359] = {.lex_state = 2177, .external_lex_state = 9},
  [360] = {.lex_state = 2177, .external_lex_state = 10},
  [361] = {.lex_state = 1, .external_lex_state = 16},
  [362] = {.lex_state = 2177, .external_lex_state = 10},
  [363] = {.lex_state = 2177, .external_lex_state = 10},
  [364] = {.lex_state = 2177, .external_lex_state = 7},
  [365] = {.lex_state = 2177, .external_lex_state = 7},
  [366] = {.lex_state = 2177, .external_lex_state = 7},
  [367] = {.lex_state = 2177, .external_lex_state = 10},
  [368] = {.lex_state = 2177, .external_lex_state = 7},
  [369] = {.lex_state = 2177, .external_lex_state = 10},
  [370] = {.lex_state = 2177, .external_lex_state = 7},
  [371] = {.lex_state = 2177, .external_lex_state = 7},
  [372] = {.lex_state = 2177, .external_lex_state = 7},
  [373] = {.lex_state = 2177, .external_lex_state = 7},
  [374] = {.lex_state = 2177, .external_lex_state = 7},
  [375] = {.lex_state = 2177, .external_lex_state = 7},
  [376] = {.lex_state = 2177, .external_lex_state = 7},
  [377] = {.lex_state = 2177, .external_lex_state = 8},
  [378] = {.lex_state = 2177, .external_lex_state = 10},
  [379] = {.lex_state = 2177, .external_lex_state = 10},
  [380] = {.lex_state = 2177, .external_lex_state = 10},
  [381] = {.lex_state = 1, .external_lex_state = 16},
  [382] = {.lex_state = 2177, .external_lex_state = 4},
  [383] = {.lex_state = 1, .external_lex_state = 16},
  [384] = {.lex_state = 2177, .external_lex_state = 7},
  [385] = {.lex_state = 2177, .external_lex_state = 7},
  [386] = {.lex_state = 2177, .external_lex_state = 7},
  [387] = {.lex_state = 2177, .external_lex_state = 7},
  [388] = {.lex_state = 2177, .external_lex_state = 7},
  [389] = {.lex_state = 2177, .external_lex_state = 7},
  [390] = {.lex_state = 2177, .external_lex_state = 7},
  [391] = {.lex_state = 2177, .external_lex_state = 9},
  [392] = {.lex_state = 2177, .external_lex_state = 10},
  [393] = {.lex_state = 2177, .external_lex_state = 9},
  [394] = {.lex_state = 2177, .external_lex_state = 9},
  [395] = {.lex_state = 2177, .external_lex_state = 9},
  [396] = {.lex_state = 2177, .external_lex_state = 9},
  [397] = {.lex_state = 2177, .external_lex_state = 10},
  [398] = {.lex_state = 2177, .external_lex_state = 9},
  [399] = {.lex_state = 2177, .external_lex_state = 9},
  [400] = {.lex_state = 2177, .external_lex_state = 8},
  [401] = {.lex_state = 2177, .external_lex_state = 8},
  [402] = {.lex_state = 2177, .external_lex_state = 7},
  [403] = {.lex_state = 2177, .external_lex_state = 7},
  [404] = {.lex_state = 2177, .external_lex_state = 7},
  [405] = {.lex_state = 2177, .external_lex_state = 9},
  [406] = {.lex_state = 2177, .external_lex_state = 9},
  [407] = {.lex_state = 2177, .external_lex_state = 8},
  [408] = {.lex_state = 2177, .external_lex_state = 8},
  [409] = {.lex_state = 2177, .external_lex_state = 8},
  [410] = {.lex_state = 2177, .external_lex_state = 7},
  [411] = {.lex_state = 2177, .external_lex_state = 7},
  [412] = {.lex_state = 2177, .external_lex_state = 7},
  [413] = {.lex_state = 2177, .external_lex_state = 8},
  [414] = {.lex_state = 2177, .external_lex_state = 10},
  [415] = {.lex_state = 2177, .external_lex_state = 7},
  [416] = {.lex_state = 2177, .external_lex_state = 7},
  [417] = {.lex_state = 2177, .external_lex_state = 7},
  [418] = {.lex_state = 2177, .external_lex_state = 7},
  [419] = {.lex_state = 2177, .external_lex_state = 7},
  [420] = {.lex_state = 2177, .external_lex_state = 7},
  [421] = {.lex_state = 2177, .external_lex_state = 8},
  [422] = {.lex_state = 2177, .external_lex_state = 10},
  [423] = {.lex_state = 2177, .external_lex_state = 10},
  [424] = {.lex_state = 2177, .external_lex_state = 9},
  [425] = {.lex_state = 2177, .external_lex_state = 9},
  [426] = {.lex_state = 2177, .external_lex_state = 10},
  [427] = {.lex_state = 2177, .external_lex_state = 10},
  [428] = {.lex_state = 2177, .external_lex_state = 9},
  [429] = {.lex_state = 2177, .external_lex_state = 10},
  [430] = {.lex_state = 2177, .external_lex_state = 8},
  [431] = {.lex_state = 2177, .external_lex_state = 8},
  [432] = {.lex_state = 2177, .external_lex_state = 10},
  [433] = {.lex_state = 2177, .external_lex_state = 8},
  [434] = {.lex_state = 2177, .external_lex_state = 8},
  [435] = {.lex_state = 2177, .external_lex_state = 8},
  [436] = {.lex_state = 2177, .external_lex_state = 8},
  [437] = {.lex_state = 2177, .external_lex_state = 7},
  [438] = {.lex_state = 2177, .external_lex_state = 8},
  [439] = {.lex_state = 2177, .external_lex_state = 8},
  [440] = {.lex_state = 2177, .external_lex_state = 8},
  [441] = {.lex_state = 2177, .external_lex_state = 7},
  [442] = {.lex_state = 2177, .external_lex_state = 8},
  [443] = {.lex_state = 2177, .external_lex_state = 7},
  [444] = {.lex_state = 2177, .external_lex_state = 7},
  [445] = {.lex_state = 2177, .external_lex_state = 7},
  [446] = {.lex_state = 2177, .external_lex_state = 7},
  [447] = {.lex_state = 2177, .external_lex_state = 7},
  [448] = {.lex_state = 2177, .external_lex_state = 8},
  [449] = {.lex_state = 2177, .external_lex_state = 8},
  [450] = {.lex_state = 2177, .external_lex_state = 8},
  [451] = {.lex_state = 2177, .external_lex_state = 8},
  [452] = {.lex_state = 2177, .external_lex_state = 8},
  [453] = {.lex_state = 2177, .external_lex_state = 8},
  [454] = {.lex_state = 2177, .external_lex_state = 8},
  [455] = {.lex_state = 2177, .external_lex_state = 8},
  [456] = {.lex_state = 2177, .external_lex_state = 8},
  [457] = {.lex_state = 2177, .external_lex_state = 8},
  [458] = {.lex_state = 2177, .external_lex_state = 8},
  [459] = {.lex_state = 2177, .external_lex_state = 7},
  [460] = {.lex_state = 2177, .external_lex_state = 7},
  [461] = {.lex_state = 2177, .external_lex_state = 7},
  [462] = {.lex_state = 2177, .external_lex_state = 7},
  [463] = {.lex_state = 2177, .external_lex_state = 7},
  [464] = {.lex_state = 2177, .external_lex_state = 8},
  [465] = {.lex_state = 2177, .external_lex_state = 8},
  [466] = {.lex_state = 2177, .external_lex_state = 8},
  [467] = {.lex_state = 2177, .external_lex_state = 8},
  [468] = {.lex_state = 2177, .external_lex_state = 8},
  [469] = {.lex_state = 2177, .external_lex_state = 8},
  [470] = {.lex_state = 2177, .external_lex_state = 8},
  [471] = {.lex_state = 2177, .external_lex_state = 7},
  [472] = {.lex_state = 2177, .external_lex_state = 7},
  [473] = {.lex_state = 2177, .external_lex_state = 10},
  [474] = {.lex_state = 1, .external_lex_state = 16},
  [475] = {.lex_state = 2177, .external_lex_state = 7},
  [476] = {.lex_state = 2177, .external_lex_state = 7},
  [477] = {.lex_state = 2177, .external_lex_state = 8},
  [478] = {.lex_state = 2177, .external_lex_state = 8},
  [479] = {.lex_state = 2177, .external_lex_state = 8},
  [480] = {.lex_state = 2177, .external_lex_state = 7},
  [481] = {.lex_state = 2177, .external_lex_state = 7},
  [482] = {.lex_state = 2177, .external_lex_state = 7},
  [483] = {.lex_state = 2177, .external_lex_state = 8},
  [484] = {.lex_state = 2177, .external_lex_state = 8},
  [485] = {.lex_state = 2177, .external_lex_state = 7},
  [486] = {.lex_state = 2177, .external_lex_state = 7},
  [487] = {.lex_state = 2177, .external_lex_state = 8},
  [488] = {.lex_state = 2177, .external_lex_state = 8},
  [489] = {.lex_state = 2177, .external_lex_state = 8},
  [490] = {.lex_state = 2177, .external_lex_state = 8},
  [491] = {.lex_state = 2177, .external_lex_state = 8},
  [492] = {.lex_state = 2177, .external_lex_state = 8},
  [493] = {.lex_state = 2177, .external_lex_state = 9},
  [494] = {.lex_state = 2177, .external_lex_state = 10},
  [495] = {.lex_state = 2177, .external_lex_state = 10},
  [496] = {.lex_state = 2177, .external_lex_state = 10},
  [497] = {.lex_state = 2177, .external_lex_state = 10},
  [498] = {.lex_state = 2177, .external_lex_state = 10},
  [499] = {.lex_state = 2177, .external_lex_state = 4},
  [500] = {.lex_state = 2177, .external_lex_state = 10},
  [501] = {.lex_state = 1, .external_lex_state = 16},
  [502] = {.lex_state = 2177, .external_lex_state = 9},
  [503] = {.lex_state = 2177, .external_lex_state = 9},
  [504] = {.lex_state = 2177, .external_lex_state = 9},
  [505] = {.lex_state = 2177, .external_lex_state = 9},
  [506] = {.lex_state = 2177, .external_lex_state = 8},
  [507] = {.lex_state = 2177, .external_lex_state = 9},
  [508] = {.lex_state = 2177, .external_lex_state = 9},
  [509] = {.lex_state = 2177, .external_lex_state = 8},
  [510] = {.lex_state = 2177, .external_lex_state = 9},
  [511] = {.lex_state = 2177, .external_lex_state = 8},
  [512] = {.lex_state = 2177, .external_lex_state = 8},
  [513] = {.lex_state = 2177, .external_lex_state = 8},
  [514] = {.lex_state = 2177, .external_lex_state = 8},
  [515] = {.lex_state = 2177, .external_lex_state = 8},
  [516] = {.lex_state = 2177, .external_lex_state = 9},
  [517] = {.lex_state = 2177, .external_lex_state = 9},
  [518] = {.lex_state = 2177, .external_lex_state = 9},
  [519] = {.lex_state = 2177, .external_lex_state = 9},
  [520] = {.lex_state = 2177, .external_lex_state = 9},
  [521] = {.lex_state = 2177, .external_lex_state = 9},
  [522] = {.lex_state = 2177, .external_lex_state = 9},
  [523] = {.lex_state = 2177, .external_lex_state = 9},
  [524] = {.lex_state = 2177, .external_lex_state = 9},
  [525] = {.lex_state = 2177, .external_lex_state = 9},
  [526] = {.lex_state = 2177, .external_lex_state = 8},
  [527] = {.lex_state = 2177, .external_lex_state = 8},
  [528] = {.lex_state = 2177, .external_lex_state = 8},
  [529] = {.lex_state = 2177, .external_lex_state = 8},
  [530] = {.lex_state = 2177, .external_lex_state = 9},
  [531] = {.lex_state = 2177, .external_lex_state = 9},
  [532] = {.lex_state = 2177, .external_lex_state = 9},
  [533] = {.lex_state = 2177, .external_lex_state = 9},
  [534] = {.lex_state = 2177, .external_lex_state = 9},
  [535] = {.lex_state = 2177, .external_lex_state = 9},
  [536] = {.lex_state = 2177, .external_lex_state = 10},
  [537] = {.lex_state = 2177, .external_lex_state = 10},
  [538] = {.lex_state = 2177, .external_lex_state = 8},
  [539] = {.lex_state = 2177, .external_lex_state = 10},
  [540] = {.lex_state = 2177, .external_lex_state = 9},
  [541] = {.lex_state = 2177, .external_lex_state = 7},
  [542] = {.lex_state = 2177, .external_lex_state = 10},
  [543] = {.lex_state = 2177, .external_lex_state = 10},
  [544] = {.lex_state = 2177, .external_lex_state = 10},
  [545] = {.lex_state = 2177, .external_lex_state = 10},
  [546] = {.lex_state = 2177, .external_lex_state = 10},
  [547] = {.lex_state = 2177, .external_lex_state = 10},
  [548] = {.lex_state = 2177, .external_lex_state = 10},
  [549] = {.lex_state = 2177, .external_lex_state = 10},
  [550] = {.lex_state = 2177, .external_lex_state = 10},
  [551] = {.lex_state = 2177, .external_lex_state = 10},
  [552] = {.lex_state = 2177, .external_lex_state = 10},
  [553] = {.lex_state = 2177, .external_lex_state = 10},
  [554] = {.lex_state = 2177, .external_lex_state = 10},
  [555] = {.lex_state = 2177, .external_lex_state = 10},
  [556] = {.lex_state = 2177, .external_lex_state = 10},
  [557] = {.lex_state = 2177, .external_lex_state = 10},
  [558] = {.lex_state = 2177, .external_lex_state = 10},
  [559] = {.lex_state = 2177, .external_lex_state = 10},
  [560] = {.lex_state = 2177, .external_lex_state = 10},
  [561] = {.lex_state = 2177, .external_lex_state = 10},
  [562] = {.lex_state = 2177, .external_lex_state = 10},
  [563] = {.lex_state = 2177, .external_lex_state = 10},
  [564] = {.lex_state = 2177, .external_lex_state = 10},
  [565] = {.lex_state = 2177, .external_lex_state = 10},
  [566] = {.lex_state = 2177, .external_lex_state = 10},
  [567] = {.lex_state = 2177, .external_lex_state = 10},
  [568] = {.lex_state = 2177, .external_lex_state = 10},
  [569] = {.lex_state = 2177, .external_lex_state = 10},
  [570] = {.lex_state = 2177, .external_lex_state = 10},
  [571] = {.lex_state = 2177, .external_lex_state = 10},
  [572] = {.lex_state = 2177, .external_lex_state = 10},
  [573] = {.lex_state = 2177, .external_lex_state = 10},
  [574] = {.lex_state = 2177, .external_lex_state = 10},
  [575] = {.lex_state = 2177, .external_lex_state = 10},
  [576] = {.lex_state = 2177, .external_lex_state = 10},
  [577] = {.lex_state = 2177, .external_lex_state = 10},
  [578] = {.lex_state = 2177, .external_lex_state = 10},
  [579] = {.lex_state = 2177, .external_lex_state = 10},
  [580] = {.lex_state = 2177, .external_lex_state = 10},
  [581] = {.lex_state = 2177, .external_lex_state = 10},
  [582] = {.lex_state = 2177, .external_lex_state = 10},
  [583] = {.lex_state = 2177, .external_lex_state = 10},
  [584] = {.lex_state = 2177, .external_lex_state = 10},
  [585] = {.lex_state = 2177, .external_lex_state = 10},
  [586] = {.lex_state = 2177, .external_lex_state = 10},
  [587] = {.lex_state = 2177, .external_lex_state = 10},
  [588] = {.lex_state = 2177, .external_lex_state = 10},
  [589] = {.lex_state = 2177, .external_lex_state = 10},
  [590] = {.lex_state = 2177, .external_lex_state = 10},
  [591] = {.lex_state = 2177, .external_lex_state = 10},
  [592] = {.lex_state = 2177, .external_lex_state = 10},
  [593] = {.lex_state = 2177, .external_lex_state = 10},
  [594] = {.lex_state = 2177, .external_lex_state = 10},
  [595] = {.lex_state = 2177, .external_lex_state = 10},
  [596] = {.lex_state = 2177, .external_lex_state = 10},
  [597] = {.lex_state = 2177, .external_lex_state = 10},
  [598] = {.lex_state = 2177, .external_lex_state = 10},
  [599] = {.lex_state = 2177, .external_lex_state = 10},
  [600] = {.lex_state = 2177, .external_lex_state = 9},
  [601] = {.lex_state = 2177, .external_lex_state = 10},
  [602] = {.lex_state = 2177, .external_lex_state = 7},
  [603] = {.lex_state = 2177, .external_lex_state = 8},
  [604] = {.lex_state = 2177, .external_lex_state = 10},
  [605] = {.lex_state = 2177, .external_lex_state = 10},
  [606] = {.lex_state = 2177, .external_lex_state = 10},
  [607] = {.lex_state = 2177, .external_lex_state = 8},
  [608] = {.lex_state = 2177, .external_lex_state = 7},
  [609] = {.lex_state = 2177, .external_lex_state = 7},
  [610] = {.lex_state = 2177, .external_lex_state = 7},
  [611] = {.lex_state = 2177, .external_lex_state = 7},
  [612] = {.lex_state = 2177, .external_lex_state = 10},
  [613] = {.lex_state = 2177, .external_lex_state = 7},
  [614] = {.lex_state = 2177, .external_lex_state = 7},
  [615] = {.lex_state = 2177, .external_lex_state = 7},
  [616] = {.lex_state = 2177, .external_lex_state = 7},
  [617] = {.lex_state = 2177, .external_lex_state = 7},
  [618] = {.lex_state = 2177, .external_lex_state = 8},
  [619] = {.lex_state = 2177, .external_lex_state = 10},
  [620] = {.lex_state = 2177, .external_lex_state = 10},
  [621] = {.lex_state = 2177, .external_lex_state = 10},
  [622] = {.lex_state = 2177, .external_lex_state = 9},
  [623] = {.lex_state = 2177, .external_lex_state = 9},
  [624] = {.lex_state = 2177, .external_lex_state = 9},
  [625] = {.lex_state = 2177, .external_lex_state = 10},
  [626] = {.lex_state = 2177, .external_lex_state = 8},
  [627] = {.lex_state = 2177, .external_lex_state = 8},
  [628] = {.lex_state = 2177, .external_lex_state = 7},
  [629] = {.lex_state = 2177, .external_lex_state = 9},
  [630] = {.lex_state = 2177, .external_lex_state = 9},
  [631] = {.lex_state = 2177, .external_lex_state = 9},
  [632] = {.lex_state = 2177, .external_lex_state = 10},
  [633] = {.lex_state = 2177, .external_lex_state = 8},
  [634] = {.lex_state = 2177, .external_lex_state = 8},
  [635] = {.lex_state = 2177, .external_lex_state = 9},
  [636] = {.lex_state = 2177, .external_lex_state = 8},
  [637] = {.lex_state = 2177, .external_lex_state = 8},
  [638] = {.lex_state = 2177, .external_lex_state = 9},
  [639] = {.lex_state = 2177, .external_lex_state = 8},
  [640] = {.lex_state = 2177, .external_lex_state = 8},
  [641] = {.lex_state = 2177, .external_lex_state = 8},
  [642] = {.lex_state = 2177, .external_lex_state = 8},
  [643] = {.lex_state = 2177, .external_lex_state = 7},
  [644] = {.lex_state = 2177, .external_lex_state = 7},
  [645] = {.lex_state = 2},
  [646] = {.lex_state = 2},
  [647] = {.lex_state = 2},
  [648] = {.lex_state = 2},
  [649] = {.lex_state = 2},
  [650] = {.lex_state = 2},
  [651] = {.lex_state = 2},
  [652] = {.lex_state = 2},
  [653] = {.lex_state = 2, .external_lex_state = 17},
  [654] = {.lex_state = 2},
  [655] = {.lex_state = 2},
  [656] = {.lex_state = 2},
  [657] = {.lex_state = 2},
  [658] = {.lex_state = 2},
  [659] = {.lex_state = 2},
  [660] = {.lex_state = 2},
  [661] = {.lex_state = 2},
  [662] = {.lex_state = 2},
  [663] = {.lex_state = 2},
  [664] = {.lex_state = 2},
  [665] = {.lex_state = 2},
  [666] = {.lex_state = 2, .external_lex_state = 17},
  [667] = {.lex_state = 1, .external_lex_state = 18},
  [668] = {.lex_state = 6, .external_lex_state = 15},
  [669] = {.lex_state = 1, .external_lex_state = 19},
  [670] = {.lex_state = 2},
  [671] = {.lex_state = 6, .external_lex_state = 14},
  [672] = {.lex_state = 5, .external_lex_state = 14},
  [673] = {.lex_state = 5, .external_lex_state = 15},
  [674] = {.lex_state = 1, .external_lex_state = 18},
  [675] = {.lex_state = 1, .external_lex_state = 16},
  [676] = {.lex_state = 1, .external_lex_state = 16},
  [677] = {.lex_state = 3, .external_lex_state = 14},
  [678] = {.lex_state = 1, .external_lex_state = 16},
  [679] = {.lex_state = 1, .external_lex_state = 16},
  [680] = {.lex_state = 3, .external_lex_state = 15},
  [681] = {.lex_state = 2},
  [682] = {.lex_state = 2, .external_lex_state = 17},
  [683] = {.lex_state = 2},
  [684] = {.lex_state = 2},
  [685] = {.lex_state = 2, .external_lex_state = 17},
  [686] = {.lex_state = 2, .external_lex_state = 17},
  [687] = {.lex_state = 2},
  [688] = {.lex_state = 2},
  [689] = {.lex_state = 2},
  [690] = {.lex_state = 7, .external_lex_state = 20},
  [691] = {.lex_state = 2},
  [692] = {.lex_state = 2},
  [693] = {.lex_state = 7, .external_lex_state = 15},
  [694] = {.lex_state = 2},
  [695] = {.lex_state = 2},
  [696] = {.lex_state = 2},
  [697] = {.lex_state = 2},
  [698] = {.lex_state = 2},
  [699] = {.lex_state = 2},
  [700] = {.lex_state = 7, .external_lex_state = 21},
  [701] = {.lex_state = 7, .external_lex_state = 14},
  [702] = {.lex_state = 4, .external_lex_state = 17},
  [703] = {.lex_state = 4, .external_lex_state = 17},
  [704] = {.lex_state = 7, .external_lex_state = 20},
  [705] = {.lex_state = 7, .external_lex_state = 22},
  [706] = {.lex_state = 7, .external_lex_state = 21},
  [707] = {.lex_state = 7, .external_lex_state = 22},
  [708] = {.lex_state = 4, .external_lex_state = 17},
  [709] = {.lex_state = 4, .external_lex_state = 17},
  [710] = {.lex_state = 2177},
  [711] = {.lex_state = 4, .external_lex_state = 17},
  [712] = {.lex_state = 4, .external_lex_state = 17},
  [713] = {.lex_state = 4, .external_lex_state = 17},
  [714] = {.lex_state = 4, .external_lex_state = 17},
  [715] = {.lex_state = 4, .external_lex_state = 17},
  [716] = {.lex_state = 4, .external_lex_state = 17},
  [717] = {.lex_state = 2},
  [718] = {.lex_state = 4, .external_lex_state = 17},
  [719] = {.lex_state = 4, .external_lex_state = 17},
  [720] = {.lex_state = 2177},
  [721] = {.lex_state = 2177},
  [722] = {.lex_state = 4, .external_lex_state = 17},
  [723] = {.lex_state = 4, .external_lex_state = 17},
  [724] = {.lex_state = 7, .external_lex_state = 23},
  [725] = {.lex_state = 7, .external_lex_state = 23},
  [726] = {.lex_state = 8},
  [727] = {.lex_state = 4},
  [728] = {.lex_state = 7, .external_lex_state = 15},
  [729] = {.lex_state = 7, .external_lex_state = 15},
  [730] = {.lex_state = 7, .external_lex_state = 15},
  [731] = {.lex_state = 7, .external_lex_state = 15},
  [732] = {.lex_state = 7, .external_lex_state = 15},
  [733] = {.lex_state = 7, .external_lex_state = 15},
  [734] = {.lex_state = 7, .external_lex_state = 15},
  [735] = {.lex_state = 7, .external_lex_state = 15},
  [736] = {.lex_state = 7, .external_lex_state = 15},
  [737] = {.lex_state = 7, .external_lex_state = 15},
  [738] = {.lex_state = 7, .external_lex_state = 15},
  [739] = {.lex_state = 7, .external_lex_state = 15},
  [740] = {.lex_state = 7, .external_lex_state = 15},
  [741] = {.lex_state = 7, .external_lex_state = 15},
  [742] = {.lex_state = 7, .external_lex_state = 15},
  [743] = {.lex_state = 7, .external_lex_state = 15},
  [744] = {.lex_state = 7, .external_lex_state = 15},
  [745] = {.lex_state = 7, .external_lex_state = 15},
  [746] = {.lex_state = 7, .external_lex_state = 15},
  [747] = {.lex_state = 4},
  [748] = {.lex_state = 4},
  [749] = {.lex_state = 4},
  [750] = {.lex_state = 4},
  [751] = {.lex_state = 4},
  [752] = {.lex_state = 4},
  [753] = {.lex_state = 9},
  [754] = {.lex_state = 8},
  [755] = {.lex_state = 4},
  [756] = {.lex_state = 7, .external_lex_state = 15},
  [757] = {.lex_state = 4},
  [758] = {.lex_state = 4},
  [759] = {.lex_state = 4},
  [760] = {.lex_state = 4},
  [761] = {.lex_state = 4},
  [762] = {.lex_state = 4},
  [763] = {.lex_state = 4},
  [764] = {.lex_state = 8},
  [765] = {.lex_state = 9},
  [766] = {.lex_state = 4},
  [767] = {.lex_state = 9},
  [768] = {.lex_state = 4},
  [769] = {.lex_state = 4},
  [770] = {.lex_state = 4},
  [771] = {.lex_state = 4},
  [772] = {.lex_state = 4},
  [773] = {.lex_state = 4},
  [774] = {.lex_state = 8},
  [775] = {.lex_state = 4},
  [776] = {.lex_state = 4},
  [777] = {.lex_state = 9},
  [778] = {.lex_state = 7, .external_lex_state = 15},
  [779] = {.lex_state = 7, .external_lex_state = 14},
  [780] = {.lex_state = 4},
  [781] = {.lex_state = 4},
  [782] = {.lex_state = 4},
  [783] = {.lex_state = 7, .external_lex_state = 14},
  [784] = {.lex_state = 7, .external_lex_state = 14},
  [785] = {.lex_state = 7, .external_lex_state = 14},
  [786] = {.lex_state = 7, .external_lex_state = 14},
  [787] = {.lex_state = 8},
  [788] = {.lex_state = 7, .external_lex_state = 14},
  [789] = {.lex_state = 7, .external_lex_state = 14},
  [790] = {.lex_state = 9},
  [791] = {.lex_state = 7, .external_lex_state = 14},
  [792] = {.lex_state = 4},
  [793] = {.lex_state = 8},
  [794] = {.lex_state = 4},
  [795] = {.lex_state = 9},
  [796] = {.lex_state = 7, .external_lex_state = 14},
  [797] = {.lex_state = 7, .external_lex_state = 14},
  [798] = {.lex_state = 7, .external_lex_state = 14},
  [799] = {.lex_state = 9},
  [800] = {.lex_state = 7, .external_lex_state = 14},
  [801] = {.lex_state = 4},
  [802] = {.lex_state = 7, .external_lex_state = 14},
  [803] = {.lex_state = 7, .external_lex_state = 14},
  [804] = {.lex_state = 7, .external_lex_state = 14},
  [805] = {.lex_state = 7, .external_lex_state = 14},
  [806] = {.lex_state = 7, .external_lex_state = 14},
  [807] = {.lex_state = 4},
  [808] = {.lex_state = 4},
  [809] = {.lex_state = 8},
  [810] = {.lex_state = 9},
  [811] = {.lex_state = 4},
  [812] = {.lex_state = 7, .external_lex_state = 14},
  [813] = {.lex_state = 4},
  [814] = {.lex_state = 4},
  [815] = {.lex_state = 7, .external_lex_state = 14},
  [816] = {.lex_state = 4},
  [817] = {.lex_state = 7, .external_lex_state = 14},
  [818] = {.lex_state = 4},
  [819] = {.lex_state = 4},
  [820] = {.lex_state = 7, .external_lex_state = 14},
  [821] = {.lex_state = 4},
  [822] = {.lex_state = 4},
  [823] = {.lex_state = 4},
  [824] = {.lex_state = 8},
  [825] = {.lex_state = 4},
  [826] = {.lex_state = 4},
  [827] = {.lex_state = 10},
  [828] = {.lex_state = 10},
  [829] = {.lex_state = 2, .external_lex_state = 17},
  [830] = {.lex_state = 2},
  [831] = {.lex_state = 10},
  [832] = {.lex_state = 10},
  [833] = {.lex_state = 10},
  [834] = {.lex_state = 10},
  [835] = {.lex_state = 10},
  [836] = {.lex_state = 10},
  [837] = {.lex_state = 10},
  [838] = {.lex_state = 2},
  [839] = {.lex_state = 2, .external_lex_state = 17},
  [840] = {.lex_state = 10},
  [841] = {.lex_state = 2, .external_lex_state = 17},
  [842] = {.lex_state = 10},
  [843] = {.lex_state = 2},
  [844] = {.lex_state = 2, .external_lex_state = 17},
  [845] = {.lex_state = 2, .external_lex_state = 17},
  [846] = {.lex_state = 10},
  [847] = {.lex_state = 10},
  [848] = {.lex_state = 10},
  [849] = {.lex_state = 2, .external_lex_state = 17},
  [850] = {.lex_state = 2, .external_lex_state = 24},
  [851] = {.lex_state = 10},
  [852] = {.lex_state = 2},
  [853] = {.lex_state = 10},
  [854] = {.lex_state = 10},
  [855] = {.lex_state = 10},
  [856] = {.lex_state = 2, .external_lex_state = 17},
  [857] = {.lex_state = 10},
  [858] = {.lex_state = 10},
  [859] = {.lex_state = 2, .external_lex_state = 24},
  [860] = {.lex_state = 10},
  [861] = {.lex_state = 2},
  [862] = {.lex_state = 2},
  [863] = {.lex_state = 2},
  [864] = {.lex_state = 2},
  [865] = {.lex_state = 2},
  [866] = {.lex_state = 2},
  [867] = {.lex_state = 2},
  [868] = {.lex_state = 2},
  [869] = {.lex_state = 2},
  [870] = {.lex_state = 2},
  [871] = {.lex_state = 2},
  [872] = {.lex_state = 2},
  [873] = {.lex_state = 2, .external_lex_state = 17},
  [874] = {.lex_state = 2},
  [875] = {.lex_state = 2},
  [876] = {.lex_state = 2},
  [877] = {.lex_state = 2},
  [878] = {.lex_state = 2},
  [879] = {.lex_state = 2},
  [880] = {.lex_state = 2},
  [881] = {.lex_state = 2},
  [882] = {.lex_state = 8, .external_lex_state = 17},
  [883] = {.lex_state = 4, .external_lex_state = 17},
  [884] = {.lex_state = 2177, .external_lex_state = 17},
  [885] = {.lex_state = 9, .external_lex_state = 17},
  [886] = {.lex_state = 8, .external_lex_state = 24},
  [887] = {.lex_state = 9, .external_lex_state = 24},
  [888] = {.lex_state = 8, .external_lex_state = 24},
  [889] = {.lex_state = 4, .external_lex_state = 17},
  [890] = {.lex_state = 9, .external_lex_state = 24},
  [891] = {.lex_state = 4, .external_lex_state = 24},
  [892] = {.lex_state = 4, .external_lex_state = 24},
  [893] = {.lex_state = 4},
  [894] = {.lex_state = 8},
  [895] = {.lex_state = 8},
  [896] = {.lex_state = 10, .external_lex_state = 17},
  [897] = {.lex_state = 4},
  [898] = {.lex_state = 9},
  [899] = {.lex_state = 2177},
  [900] = {.lex_state = 4},
  [901] = {.lex_state = 10, .external_lex_state = 17},
  [902] = {.lex_state = 9},
  [903] = {.lex_state = 9},
  [904] = {.lex_state = 4},
  [905] = {.lex_state = 8},
  [906] = {.lex_state = 10, .external_lex_state = 17},
  [907] = {.lex_state = 4},
  [908] = {.lex_state = 10, .external_lex_state = 24},
  [909] = {.lex_state = 10, .external_lex_state = 24},
  [910] = {.lex_state = 10},
  [911] = {.lex_state = 10},
  [912] = {.lex_state = 10},
  [913] = {.lex_state = 10},
  [914] = {.lex_state = 10},
  [915] = {.lex_state = 10},
  [916] = {.lex_state = 10},
  [917] = {.lex_state = 10},
  [918] = {.lex_state = 10},
  [919] = {.lex_state = 10},
  [920] = {.lex_state = 10},
  [921] = {.lex_state = 10},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 0},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0},
  [935] = {.lex_state = 0},
  [936] = {.lex_state = 0},
  [937] = {.lex_state = 0},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 0},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0},
  [944] = {.lex_state = 0},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 11},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 11},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 11},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 11},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 12},
  [963] = {.lex_state = 12},
  [964] = {.lex_state = 2177},
  [965] = {.lex_state = 12},
  [966] = {.lex_state = 12},
  [967] = {.lex_state = 12},
  [968] = {.lex_state = 12},
  [969] = {.lex_state = 12},
  [970] = {.lex_state = 12},
  [971] = {.lex_state = 2177},
  [972] = {.lex_state = 12},
  [973] = {.lex_state = 12},
  [974] = {.lex_state = 12},
  [975] = {.lex_state = 11},
  [976] = {.lex_state = 12},
  [977] = {.lex_state = 12},
  [978] = {.lex_state = 12},
  [979] = {.lex_state = 2177},
  [980] = {.lex_state = 12},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 12, .external_lex_state = 24},
  [988] = {.lex_state = 0},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 11, .external_lex_state = 24},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 11, .external_lex_state = 24},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 12},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 12, .external_lex_state = 24},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 12},
  [1103] = {.lex_state = 11},
  [1104] = {.lex_state = 12},
  [1105] = {.lex_state = 11},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0, .external_lex_state = 25},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0, .external_lex_state = 26},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0, .external_lex_state = 26},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0, .external_lex_state = 26},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0, .external_lex_state = 26},
  [1159] = {.lex_state = 0},
};

enum {
  ts_external_token__error = 0,
  ts_external_token__trigger_error = 1,
  ts_external_token__code_span_start = 2,
  ts_external_token__code_span_close = 3,
  ts_external_token__emphasis_open_star = 4,
  ts_external_token__emphasis_open_underscore = 5,
  ts_external_token__emphasis_close_star = 6,
  ts_external_token__emphasis_close_underscore = 7,
  ts_external_token__last_token_whitespace = 8,
  ts_external_token__last_token_punctuation = 9,
  ts_external_token__strikethrough_open = 10,
  ts_external_token__strikethrough_close = 11,
  ts_external_token__latex_span_start = 12,
  ts_external_token__latex_span_close = 13,
  ts_external_token__unclosed_span = 14,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__error] = sym__error,
  [ts_external_token__trigger_error] = sym__trigger_error,
  [ts_external_token__code_span_start] = sym__code_span_start,
  [ts_external_token__code_span_close] = sym__code_span_close,
  [ts_external_token__emphasis_open_star] = sym__emphasis_open_star,
  [ts_external_token__emphasis_open_underscore] = sym__emphasis_open_underscore,
  [ts_external_token__emphasis_close_star] = sym__emphasis_close_star,
  [ts_external_token__emphasis_close_underscore] = sym__emphasis_close_underscore,
  [ts_external_token__last_token_whitespace] = sym__last_token_whitespace,
  [ts_external_token__last_token_punctuation] = sym__last_token_punctuation,
  [ts_external_token__strikethrough_open] = sym__strikethrough_open,
  [ts_external_token__strikethrough_close] = sym__strikethrough_close,
  [ts_external_token__latex_span_start] = sym__latex_span_start,
  [ts_external_token__latex_span_close] = sym__latex_span_close,
  [ts_external_token__unclosed_span] = sym__unclosed_span,
};

static const bool ts_external_scanner_states[27][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__error] = true,
    [ts_external_token__trigger_error] = true,
    [ts_external_token__code_span_start] = true,
    [ts_external_token__code_span_close] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_star] = true,
    [ts_external_token__emphasis_close_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__strikethrough_close] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__latex_span_close] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [2] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [3] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_underscore] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [4] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [5] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__strikethrough_close] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [6] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_star] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [7] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_star] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [8] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_underscore] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [9] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__strikethrough_close] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [10] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [11] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [12] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_star] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [13] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__strikethrough_close] = true,
    [ts_external_token__latex_span_start] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [14] = {
    [ts_external_token__code_span_close] = true,
  },
  [15] = {
    [ts_external_token__latex_span_close] = true,
  },
  [16] = {
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [17] = {
    [ts_external_token__last_token_punctuation] = true,
  },
  [18] = {
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [19] = {
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__unclosed_span] = true,
  },
  [20] = {
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__latex_span_close] = true,
  },
  [21] = {
    [ts_external_token__code_span_close] = true,
    [ts_external_token__last_token_punctuation] = true,
  },
  [22] = {
    [ts_external_token__code_span_close] = true,
    [ts_external_token__last_token_whitespace] = true,
  },
  [23] = {
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__latex_span_close] = true,
  },
  [24] = {
    [ts_external_token__last_token_whitespace] = true,
  },
  [25] = {
    [ts_external_token__trigger_error] = true,
    [ts_external_token__last_token_whitespace] = true,
  },
  [26] = {
    [ts_external_token__trigger_error] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__backslash_escape] = ACTIONS(1),
    [sym_entity_reference] = ACTIONS(1),
    [sym_numeric_character_reference] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym__newline_token] = ACTIONS(1),
    [sym_uri_autolink] = ACTIONS(1),
    [sym_email_autolink] = ACTIONS(1),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1),
    [anon_sym_DASH_DASH_GT] = ACTIONS(1),
    [anon_sym_LT_QMARK] = ACTIONS(1),
    [anon_sym_QMARK_GT] = ACTIONS(1),
    [aux_sym__declaration_token1] = ACTIONS(1),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK_GT] = ACTIONS(1),
    [sym__whitespace_ge_2] = ACTIONS(1),
    [aux_sym__whitespace_token1] = ACTIONS(1),
    [sym__word_no_digit] = ACTIONS(1),
    [sym__digits] = ACTIONS(1),
    [sym__error] = ACTIONS(1),
    [sym__trigger_error] = ACTIONS(1),
    [sym__code_span_start] = ACTIONS(1),
    [sym__code_span_close] = ACTIONS(1),
    [sym__emphasis_open_star] = ACTIONS(1),
    [sym__emphasis_open_underscore] = ACTIONS(1),
    [sym__emphasis_close_star] = ACTIONS(1),
    [sym__emphasis_close_underscore] = ACTIONS(1),
    [sym__last_token_whitespace] = ACTIONS(1),
    [sym__last_token_punctuation] = ACTIONS(1),
    [sym__strikethrough_open] = ACTIONS(1),
    [sym__strikethrough_close] = ACTIONS(1),
    [sym__latex_span_start] = ACTIONS(1),
    [sym__latex_span_close] = ACTIONS(1),
    [sym__unclosed_span] = ACTIONS(1),
  },
  [1] = {
    [sym_inline] = STATE(1140),
    [sym_backslash_escape] = STATE(155),
    [sym_code_span] = STATE(155),
    [sym_latex_block] = STATE(155),
    [sym__link_text] = STATE(1120),
    [sym__link_text_non_empty] = STATE(265),
    [sym_shortcut_link] = STATE(275),
    [sym_full_reference_link] = STATE(275),
    [sym_collapsed_reference_link] = STATE(275),
    [sym_inline_link] = STATE(275),
    [sym_image] = STATE(155),
    [sym__image_inline_link] = STATE(266),
    [sym__image_shortcut_link] = STATE(266),
    [sym__image_full_reference_link] = STATE(266),
    [sym__image_collapsed_reference_link] = STATE(266),
    [sym__image_description] = STATE(1124),
    [sym__image_description_non_empty] = STATE(267),
    [sym__html_tag] = STATE(272),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(155),
    [sym__whitespace] = STATE(155),
    [sym__word] = STATE(155),
    [sym__soft_line_break] = STATE(155),
    [sym__inline_base] = STATE(275),
    [sym__text_base] = STATE(155),
    [sym__inline_element] = STATE(275),
    [aux_sym__inline] = STATE(31),
    [sym__strikethrough] = STATE(275),
    [sym__emphasis_star] = STATE(280),
    [sym__strong_emphasis_star] = STATE(275),
    [sym__emphasis_underscore] = STATE(280),
    [sym__strong_emphasis_underscore] = STATE(275),
    [aux_sym__inline_base_repeat1] = STATE(155),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(5),
    [sym_numeric_character_reference] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(9),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(5),
    [sym_email_autolink] = ACTIONS(5),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(5),
    [sym__digits] = ACTIONS(5),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(37),
    [sym__emphasis_open_underscore] = ACTIONS(39),
    [sym__last_token_whitespace] = ACTIONS(41),
    [sym__strikethrough_open] = ACTIONS(43),
    [sym__latex_span_start] = ACTIONS(45),
    [sym__unclosed_span] = ACTIONS(5),
  },
  [2] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(19),
    [sym_full_reference_link] = STATE(19),
    [sym_collapsed_reference_link] = STATE(19),
    [sym_inline_link] = STATE(19),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(19),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(19),
    [aux_sym__inline_no_tilde] = STATE(19),
    [sym__strikethrough] = STATE(19),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(19),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(19),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(47),
    [sym_entity_reference] = ACTIONS(50),
    [sym_numeric_character_reference] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_RBRACK] = ACTIONS(56),
    [anon_sym_LT] = ACTIONS(59),
    [anon_sym_GT] = ACTIONS(62),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(62),
    [anon_sym_POUND] = ACTIONS(62),
    [anon_sym_DOLLAR] = ACTIONS(62),
    [anon_sym_PERCENT] = ACTIONS(62),
    [anon_sym_AMP] = ACTIONS(68),
    [anon_sym_SQUOTE] = ACTIONS(62),
    [anon_sym_STAR] = ACTIONS(62),
    [anon_sym_PLUS] = ACTIONS(62),
    [anon_sym_COMMA] = ACTIONS(62),
    [anon_sym_DASH] = ACTIONS(62),
    [anon_sym_DOT] = ACTIONS(62),
    [anon_sym_SLASH] = ACTIONS(62),
    [anon_sym_COLON] = ACTIONS(62),
    [anon_sym_SEMI] = ACTIONS(62),
    [anon_sym_EQ] = ACTIONS(62),
    [anon_sym_QMARK] = ACTIONS(62),
    [anon_sym_AT] = ACTIONS(62),
    [anon_sym_BSLASH] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(62),
    [anon_sym__] = ACTIONS(62),
    [anon_sym_BQUOTE] = ACTIONS(62),
    [anon_sym_LBRACE] = ACTIONS(62),
    [anon_sym_PIPE] = ACTIONS(62),
    [anon_sym_RBRACE] = ACTIONS(62),
    [anon_sym_TILDE] = ACTIONS(62),
    [anon_sym_LPAREN] = ACTIONS(62),
    [anon_sym_RPAREN] = ACTIONS(62),
    [sym__newline_token] = ACTIONS(74),
    [sym_uri_autolink] = ACTIONS(50),
    [sym_email_autolink] = ACTIONS(50),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(77),
    [anon_sym_LT_QMARK] = ACTIONS(80),
    [aux_sym__declaration_token1] = ACTIONS(83),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(86),
    [sym__whitespace_ge_2] = ACTIONS(89),
    [aux_sym__whitespace_token1] = ACTIONS(92),
    [sym__word_no_digit] = ACTIONS(50),
    [sym__digits] = ACTIONS(50),
    [sym__code_span_start] = ACTIONS(95),
    [sym__emphasis_open_star] = ACTIONS(98),
    [sym__emphasis_open_underscore] = ACTIONS(101),
    [sym__emphasis_close_underscore] = ACTIONS(104),
    [sym__last_token_punctuation] = ACTIONS(106),
    [sym__strikethrough_open] = ACTIONS(108),
    [sym__latex_span_start] = ACTIONS(111),
    [sym__unclosed_span] = ACTIONS(50),
  },
  [3] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(42),
    [sym_full_reference_link] = STATE(42),
    [sym_collapsed_reference_link] = STATE(42),
    [sym_inline_link] = STATE(42),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(42),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(42),
    [aux_sym__inline_no_star] = STATE(42),
    [sym__strikethrough] = STATE(42),
    [sym__emphasis_star] = STATE(282),
    [sym__strong_emphasis_star] = STATE(42),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(42),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [ts_builtin_sym_end] = ACTIONS(114),
    [sym__backslash_escape] = ACTIONS(116),
    [sym_entity_reference] = ACTIONS(119),
    [sym_numeric_character_reference] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(122),
    [anon_sym_RBRACK] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(128),
    [anon_sym_GT] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(134),
    [anon_sym_DQUOTE] = ACTIONS(131),
    [anon_sym_POUND] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_DOT] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(131),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_BSLASH] = ACTIONS(140),
    [anon_sym_CARET] = ACTIONS(131),
    [anon_sym__] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(131),
    [sym__newline_token] = ACTIONS(143),
    [sym_uri_autolink] = ACTIONS(119),
    [sym_email_autolink] = ACTIONS(119),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(146),
    [anon_sym_LT_QMARK] = ACTIONS(149),
    [aux_sym__declaration_token1] = ACTIONS(152),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(155),
    [sym__whitespace_ge_2] = ACTIONS(158),
    [aux_sym__whitespace_token1] = ACTIONS(161),
    [sym__word_no_digit] = ACTIONS(119),
    [sym__digits] = ACTIONS(119),
    [sym__code_span_start] = ACTIONS(164),
    [sym__emphasis_open_star] = ACTIONS(167),
    [sym__emphasis_open_underscore] = ACTIONS(170),
    [sym__last_token_punctuation] = ACTIONS(173),
    [sym__strikethrough_open] = ACTIONS(175),
    [sym__latex_span_start] = ACTIONS(178),
    [sym__unclosed_span] = ACTIONS(119),
  },
  [4] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(49),
    [sym_full_reference_link] = STATE(49),
    [sym_collapsed_reference_link] = STATE(49),
    [sym_inline_link] = STATE(49),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(49),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(49),
    [aux_sym__inline_no_underscore] = STATE(49),
    [sym__strikethrough] = STATE(49),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(49),
    [sym__emphasis_underscore] = STATE(291),
    [sym__strong_emphasis_underscore] = STATE(49),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [ts_builtin_sym_end] = ACTIONS(114),
    [sym__backslash_escape] = ACTIONS(181),
    [sym_entity_reference] = ACTIONS(184),
    [sym_numeric_character_reference] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_RBRACK] = ACTIONS(190),
    [anon_sym_LT] = ACTIONS(193),
    [anon_sym_GT] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_POUND] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(196),
    [anon_sym_PERCENT] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(202),
    [anon_sym_SQUOTE] = ACTIONS(196),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_COMMA] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_DOT] = ACTIONS(196),
    [anon_sym_SLASH] = ACTIONS(196),
    [anon_sym_COLON] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(196),
    [anon_sym_EQ] = ACTIONS(196),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_AT] = ACTIONS(196),
    [anon_sym_BSLASH] = ACTIONS(205),
    [anon_sym_CARET] = ACTIONS(196),
    [anon_sym__] = ACTIONS(196),
    [anon_sym_BQUOTE] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(196),
    [anon_sym_PIPE] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(196),
    [anon_sym_TILDE] = ACTIONS(196),
    [anon_sym_LPAREN] = ACTIONS(196),
    [anon_sym_RPAREN] = ACTIONS(196),
    [sym__newline_token] = ACTIONS(208),
    [sym_uri_autolink] = ACTIONS(184),
    [sym_email_autolink] = ACTIONS(184),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(211),
    [anon_sym_LT_QMARK] = ACTIONS(214),
    [aux_sym__declaration_token1] = ACTIONS(217),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(220),
    [sym__whitespace_ge_2] = ACTIONS(223),
    [aux_sym__whitespace_token1] = ACTIONS(226),
    [sym__word_no_digit] = ACTIONS(184),
    [sym__digits] = ACTIONS(184),
    [sym__code_span_start] = ACTIONS(229),
    [sym__emphasis_open_star] = ACTIONS(232),
    [sym__emphasis_open_underscore] = ACTIONS(235),
    [sym__last_token_punctuation] = ACTIONS(238),
    [sym__strikethrough_open] = ACTIONS(240),
    [sym__latex_span_start] = ACTIONS(243),
    [sym__unclosed_span] = ACTIONS(184),
  },
  [5] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(47),
    [sym_full_reference_link] = STATE(47),
    [sym_collapsed_reference_link] = STATE(47),
    [sym_inline_link] = STATE(47),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(47),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(47),
    [aux_sym__inline_no_underscore] = STATE(47),
    [sym__strikethrough] = STATE(47),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(47),
    [sym__emphasis_underscore] = STATE(268),
    [sym__strong_emphasis_underscore] = STATE(47),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(246),
    [sym_entity_reference] = ACTIONS(249),
    [sym_numeric_character_reference] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(252),
    [anon_sym_RBRACK] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(261),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_DQUOTE] = ACTIONS(261),
    [anon_sym_POUND] = ACTIONS(261),
    [anon_sym_DOLLAR] = ACTIONS(261),
    [anon_sym_PERCENT] = ACTIONS(261),
    [anon_sym_AMP] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(261),
    [anon_sym_STAR] = ACTIONS(261),
    [anon_sym_PLUS] = ACTIONS(261),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym_DASH] = ACTIONS(261),
    [anon_sym_DOT] = ACTIONS(261),
    [anon_sym_SLASH] = ACTIONS(261),
    [anon_sym_COLON] = ACTIONS(261),
    [anon_sym_SEMI] = ACTIONS(261),
    [anon_sym_EQ] = ACTIONS(261),
    [anon_sym_QMARK] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [anon_sym_BSLASH] = ACTIONS(270),
    [anon_sym_CARET] = ACTIONS(261),
    [anon_sym__] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(261),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_TILDE] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_RPAREN] = ACTIONS(261),
    [sym__newline_token] = ACTIONS(273),
    [sym_uri_autolink] = ACTIONS(249),
    [sym_email_autolink] = ACTIONS(249),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(276),
    [anon_sym_LT_QMARK] = ACTIONS(279),
    [aux_sym__declaration_token1] = ACTIONS(282),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(285),
    [sym__whitespace_ge_2] = ACTIONS(288),
    [aux_sym__whitespace_token1] = ACTIONS(291),
    [sym__word_no_digit] = ACTIONS(249),
    [sym__digits] = ACTIONS(249),
    [sym__code_span_start] = ACTIONS(294),
    [sym__emphasis_open_star] = ACTIONS(297),
    [sym__emphasis_open_underscore] = ACTIONS(300),
    [sym__last_token_punctuation] = ACTIONS(303),
    [sym__strikethrough_open] = ACTIONS(305),
    [sym__strikethrough_close] = ACTIONS(308),
    [sym__latex_span_start] = ACTIONS(310),
    [sym__unclosed_span] = ACTIONS(249),
  },
  [6] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(41),
    [sym_full_reference_link] = STATE(41),
    [sym_collapsed_reference_link] = STATE(41),
    [sym_inline_link] = STATE(41),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(41),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(41),
    [aux_sym__inline_no_tilde] = STATE(41),
    [sym__strikethrough] = STATE(41),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(41),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(41),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [ts_builtin_sym_end] = ACTIONS(114),
    [sym__backslash_escape] = ACTIONS(313),
    [sym_entity_reference] = ACTIONS(316),
    [sym_numeric_character_reference] = ACTIONS(316),
    [anon_sym_LBRACK] = ACTIONS(319),
    [anon_sym_RBRACK] = ACTIONS(322),
    [anon_sym_LT] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(328),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(328),
    [anon_sym_POUND] = ACTIONS(328),
    [anon_sym_DOLLAR] = ACTIONS(328),
    [anon_sym_PERCENT] = ACTIONS(328),
    [anon_sym_AMP] = ACTIONS(334),
    [anon_sym_SQUOTE] = ACTIONS(328),
    [anon_sym_STAR] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(328),
    [anon_sym_COMMA] = ACTIONS(328),
    [anon_sym_DASH] = ACTIONS(328),
    [anon_sym_DOT] = ACTIONS(328),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_COLON] = ACTIONS(328),
    [anon_sym_SEMI] = ACTIONS(328),
    [anon_sym_EQ] = ACTIONS(328),
    [anon_sym_QMARK] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(328),
    [anon_sym_BSLASH] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(328),
    [anon_sym__] = ACTIONS(328),
    [anon_sym_BQUOTE] = ACTIONS(328),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_PIPE] = ACTIONS(328),
    [anon_sym_RBRACE] = ACTIONS(328),
    [anon_sym_TILDE] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(328),
    [anon_sym_RPAREN] = ACTIONS(328),
    [sym__newline_token] = ACTIONS(340),
    [sym_uri_autolink] = ACTIONS(316),
    [sym_email_autolink] = ACTIONS(316),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(343),
    [anon_sym_LT_QMARK] = ACTIONS(346),
    [aux_sym__declaration_token1] = ACTIONS(349),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(352),
    [sym__whitespace_ge_2] = ACTIONS(355),
    [aux_sym__whitespace_token1] = ACTIONS(358),
    [sym__word_no_digit] = ACTIONS(316),
    [sym__digits] = ACTIONS(316),
    [sym__code_span_start] = ACTIONS(361),
    [sym__emphasis_open_star] = ACTIONS(364),
    [sym__emphasis_open_underscore] = ACTIONS(367),
    [sym__last_token_punctuation] = ACTIONS(370),
    [sym__strikethrough_open] = ACTIONS(372),
    [sym__latex_span_start] = ACTIONS(375),
    [sym__unclosed_span] = ACTIONS(316),
  },
  [7] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(24),
    [sym_full_reference_link] = STATE(24),
    [sym_collapsed_reference_link] = STATE(24),
    [sym_inline_link] = STATE(24),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(24),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(24),
    [aux_sym__inline_no_star] = STATE(24),
    [sym__strikethrough] = STATE(24),
    [sym__emphasis_star] = STATE(314),
    [sym__strong_emphasis_star] = STATE(24),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(24),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(378),
    [sym_entity_reference] = ACTIONS(381),
    [sym_numeric_character_reference] = ACTIONS(381),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(387),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_GT] = ACTIONS(393),
    [anon_sym_BANG] = ACTIONS(396),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_POUND] = ACTIONS(393),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_PERCENT] = ACTIONS(393),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(393),
    [anon_sym_STAR] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(393),
    [anon_sym_COMMA] = ACTIONS(393),
    [anon_sym_DASH] = ACTIONS(393),
    [anon_sym_DOT] = ACTIONS(393),
    [anon_sym_SLASH] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(393),
    [anon_sym_AT] = ACTIONS(393),
    [anon_sym_BSLASH] = ACTIONS(402),
    [anon_sym_CARET] = ACTIONS(393),
    [anon_sym__] = ACTIONS(393),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_PIPE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_LPAREN] = ACTIONS(393),
    [anon_sym_RPAREN] = ACTIONS(393),
    [sym__newline_token] = ACTIONS(405),
    [sym_uri_autolink] = ACTIONS(381),
    [sym_email_autolink] = ACTIONS(381),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(408),
    [anon_sym_LT_QMARK] = ACTIONS(411),
    [aux_sym__declaration_token1] = ACTIONS(414),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(417),
    [sym__whitespace_ge_2] = ACTIONS(420),
    [aux_sym__whitespace_token1] = ACTIONS(423),
    [sym__word_no_digit] = ACTIONS(381),
    [sym__digits] = ACTIONS(381),
    [sym__code_span_start] = ACTIONS(426),
    [sym__emphasis_open_star] = ACTIONS(429),
    [sym__emphasis_open_underscore] = ACTIONS(432),
    [sym__emphasis_close_underscore] = ACTIONS(104),
    [sym__last_token_punctuation] = ACTIONS(435),
    [sym__strikethrough_open] = ACTIONS(437),
    [sym__latex_span_start] = ACTIONS(440),
    [sym__unclosed_span] = ACTIONS(381),
  },
  [8] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(38),
    [sym_full_reference_link] = STATE(38),
    [sym_collapsed_reference_link] = STATE(38),
    [sym_inline_link] = STATE(38),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(38),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(38),
    [aux_sym__inline_no_tilde] = STATE(38),
    [sym__strikethrough] = STATE(38),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(38),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(38),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(443),
    [sym_entity_reference] = ACTIONS(446),
    [sym_numeric_character_reference] = ACTIONS(446),
    [anon_sym_LBRACK] = ACTIONS(449),
    [anon_sym_RBRACK] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(455),
    [anon_sym_GT] = ACTIONS(458),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(458),
    [anon_sym_POUND] = ACTIONS(458),
    [anon_sym_DOLLAR] = ACTIONS(458),
    [anon_sym_PERCENT] = ACTIONS(458),
    [anon_sym_AMP] = ACTIONS(464),
    [anon_sym_SQUOTE] = ACTIONS(458),
    [anon_sym_STAR] = ACTIONS(458),
    [anon_sym_PLUS] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(458),
    [anon_sym_DOT] = ACTIONS(458),
    [anon_sym_SLASH] = ACTIONS(458),
    [anon_sym_COLON] = ACTIONS(458),
    [anon_sym_SEMI] = ACTIONS(458),
    [anon_sym_EQ] = ACTIONS(458),
    [anon_sym_QMARK] = ACTIONS(458),
    [anon_sym_AT] = ACTIONS(458),
    [anon_sym_BSLASH] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(458),
    [anon_sym__] = ACTIONS(458),
    [anon_sym_BQUOTE] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(458),
    [anon_sym_PIPE] = ACTIONS(458),
    [anon_sym_RBRACE] = ACTIONS(458),
    [anon_sym_TILDE] = ACTIONS(458),
    [anon_sym_LPAREN] = ACTIONS(458),
    [anon_sym_RPAREN] = ACTIONS(458),
    [sym__newline_token] = ACTIONS(470),
    [sym_uri_autolink] = ACTIONS(446),
    [sym_email_autolink] = ACTIONS(446),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(473),
    [anon_sym_LT_QMARK] = ACTIONS(476),
    [aux_sym__declaration_token1] = ACTIONS(479),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(482),
    [sym__whitespace_ge_2] = ACTIONS(485),
    [aux_sym__whitespace_token1] = ACTIONS(488),
    [sym__word_no_digit] = ACTIONS(446),
    [sym__digits] = ACTIONS(446),
    [sym__code_span_start] = ACTIONS(491),
    [sym__emphasis_open_star] = ACTIONS(494),
    [sym__emphasis_open_underscore] = ACTIONS(497),
    [sym__emphasis_close_star] = ACTIONS(500),
    [sym__last_token_punctuation] = ACTIONS(502),
    [sym__strikethrough_open] = ACTIONS(504),
    [sym__latex_span_start] = ACTIONS(507),
    [sym__unclosed_span] = ACTIONS(446),
  },
  [9] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(12),
    [sym_full_reference_link] = STATE(12),
    [sym_collapsed_reference_link] = STATE(12),
    [sym_inline_link] = STATE(12),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(12),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(12),
    [aux_sym__inline_no_underscore] = STATE(12),
    [sym__strikethrough] = STATE(12),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(12),
    [sym__emphasis_underscore] = STATE(408),
    [sym__strong_emphasis_underscore] = STATE(12),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(510),
    [sym_entity_reference] = ACTIONS(513),
    [sym_numeric_character_reference] = ACTIONS(513),
    [anon_sym_LBRACK] = ACTIONS(516),
    [anon_sym_RBRACK] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(522),
    [anon_sym_GT] = ACTIONS(525),
    [anon_sym_BANG] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(525),
    [anon_sym_POUND] = ACTIONS(525),
    [anon_sym_DOLLAR] = ACTIONS(525),
    [anon_sym_PERCENT] = ACTIONS(525),
    [anon_sym_AMP] = ACTIONS(531),
    [anon_sym_SQUOTE] = ACTIONS(525),
    [anon_sym_STAR] = ACTIONS(525),
    [anon_sym_PLUS] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_DASH] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(525),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_COLON] = ACTIONS(525),
    [anon_sym_SEMI] = ACTIONS(525),
    [anon_sym_EQ] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(525),
    [anon_sym_AT] = ACTIONS(525),
    [anon_sym_BSLASH] = ACTIONS(534),
    [anon_sym_CARET] = ACTIONS(525),
    [anon_sym__] = ACTIONS(525),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_PIPE] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(525),
    [sym__newline_token] = ACTIONS(537),
    [sym_uri_autolink] = ACTIONS(513),
    [sym_email_autolink] = ACTIONS(513),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(540),
    [anon_sym_LT_QMARK] = ACTIONS(543),
    [aux_sym__declaration_token1] = ACTIONS(546),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(549),
    [sym__whitespace_ge_2] = ACTIONS(552),
    [aux_sym__whitespace_token1] = ACTIONS(555),
    [sym__word_no_digit] = ACTIONS(513),
    [sym__digits] = ACTIONS(513),
    [sym__code_span_start] = ACTIONS(558),
    [sym__emphasis_open_star] = ACTIONS(561),
    [sym__emphasis_open_underscore] = ACTIONS(564),
    [sym__emphasis_close_star] = ACTIONS(500),
    [sym__last_token_punctuation] = ACTIONS(567),
    [sym__strikethrough_open] = ACTIONS(569),
    [sym__latex_span_start] = ACTIONS(572),
    [sym__unclosed_span] = ACTIONS(513),
  },
  [10] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(45),
    [sym_full_reference_link] = STATE(45),
    [sym_collapsed_reference_link] = STATE(45),
    [sym_inline_link] = STATE(45),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(45),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(45),
    [aux_sym__inline_no_star] = STATE(45),
    [sym__strikethrough] = STATE(45),
    [sym__emphasis_star] = STATE(271),
    [sym__strong_emphasis_star] = STATE(45),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(45),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(575),
    [sym_entity_reference] = ACTIONS(578),
    [sym_numeric_character_reference] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(581),
    [anon_sym_RBRACK] = ACTIONS(584),
    [anon_sym_LT] = ACTIONS(587),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_BANG] = ACTIONS(593),
    [anon_sym_DQUOTE] = ACTIONS(590),
    [anon_sym_POUND] = ACTIONS(590),
    [anon_sym_DOLLAR] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_AMP] = ACTIONS(596),
    [anon_sym_SQUOTE] = ACTIONS(590),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_COMMA] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_SEMI] = ACTIONS(590),
    [anon_sym_EQ] = ACTIONS(590),
    [anon_sym_QMARK] = ACTIONS(590),
    [anon_sym_AT] = ACTIONS(590),
    [anon_sym_BSLASH] = ACTIONS(599),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym__] = ACTIONS(590),
    [anon_sym_BQUOTE] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(590),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_RBRACE] = ACTIONS(590),
    [anon_sym_TILDE] = ACTIONS(590),
    [anon_sym_LPAREN] = ACTIONS(590),
    [anon_sym_RPAREN] = ACTIONS(590),
    [sym__newline_token] = ACTIONS(602),
    [sym_uri_autolink] = ACTIONS(578),
    [sym_email_autolink] = ACTIONS(578),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(605),
    [anon_sym_LT_QMARK] = ACTIONS(608),
    [aux_sym__declaration_token1] = ACTIONS(611),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(614),
    [sym__whitespace_ge_2] = ACTIONS(617),
    [aux_sym__whitespace_token1] = ACTIONS(620),
    [sym__word_no_digit] = ACTIONS(578),
    [sym__digits] = ACTIONS(578),
    [sym__code_span_start] = ACTIONS(623),
    [sym__emphasis_open_star] = ACTIONS(626),
    [sym__emphasis_open_underscore] = ACTIONS(629),
    [sym__last_token_punctuation] = ACTIONS(632),
    [sym__strikethrough_open] = ACTIONS(634),
    [sym__strikethrough_close] = ACTIONS(308),
    [sym__latex_span_start] = ACTIONS(637),
    [sym__unclosed_span] = ACTIONS(578),
  },
  [11] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(678),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [12] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(722),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [13] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(768),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [14] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(772),
    [sym_entity_reference] = ACTIONS(775),
    [sym_numeric_character_reference] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(778),
    [anon_sym_RBRACK] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(784),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_POUND] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_PERCENT] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(787),
    [anon_sym_STAR] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_COMMA] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(787),
    [anon_sym_COLON] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(787),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AT] = ACTIONS(787),
    [anon_sym_BSLASH] = ACTIONS(796),
    [anon_sym_CARET] = ACTIONS(787),
    [anon_sym__] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(787),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_RPAREN] = ACTIONS(787),
    [sym__newline_token] = ACTIONS(799),
    [sym_uri_autolink] = ACTIONS(775),
    [sym_email_autolink] = ACTIONS(775),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(802),
    [anon_sym_LT_QMARK] = ACTIONS(805),
    [aux_sym__declaration_token1] = ACTIONS(808),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(811),
    [sym__whitespace_ge_2] = ACTIONS(814),
    [aux_sym__whitespace_token1] = ACTIONS(817),
    [sym__word_no_digit] = ACTIONS(775),
    [sym__digits] = ACTIONS(775),
    [sym__code_span_start] = ACTIONS(820),
    [sym__emphasis_open_star] = ACTIONS(823),
    [sym__emphasis_open_underscore] = ACTIONS(826),
    [sym__strikethrough_open] = ACTIONS(829),
    [sym__strikethrough_close] = ACTIONS(832),
    [sym__latex_span_start] = ACTIONS(834),
    [sym__unclosed_span] = ACTIONS(775),
  },
  [15] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(837),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [16] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(839),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [17] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(841),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [18] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(843),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [19] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(845),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [20] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(847),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [21] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(849),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [22] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(851),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [23] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(853),
    [sym_entity_reference] = ACTIONS(856),
    [sym_numeric_character_reference] = ACTIONS(856),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_RBRACK] = ACTIONS(862),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_GT] = ACTIONS(868),
    [anon_sym_BANG] = ACTIONS(871),
    [anon_sym_DQUOTE] = ACTIONS(868),
    [anon_sym_POUND] = ACTIONS(868),
    [anon_sym_DOLLAR] = ACTIONS(868),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_AMP] = ACTIONS(874),
    [anon_sym_SQUOTE] = ACTIONS(868),
    [anon_sym_STAR] = ACTIONS(868),
    [anon_sym_PLUS] = ACTIONS(868),
    [anon_sym_COMMA] = ACTIONS(868),
    [anon_sym_DASH] = ACTIONS(868),
    [anon_sym_DOT] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(868),
    [anon_sym_COLON] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_EQ] = ACTIONS(868),
    [anon_sym_QMARK] = ACTIONS(868),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_BSLASH] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(868),
    [anon_sym__] = ACTIONS(868),
    [anon_sym_BQUOTE] = ACTIONS(868),
    [anon_sym_LBRACE] = ACTIONS(868),
    [anon_sym_PIPE] = ACTIONS(868),
    [anon_sym_RBRACE] = ACTIONS(868),
    [anon_sym_TILDE] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(868),
    [anon_sym_RPAREN] = ACTIONS(868),
    [sym__newline_token] = ACTIONS(880),
    [sym_uri_autolink] = ACTIONS(856),
    [sym_email_autolink] = ACTIONS(856),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(883),
    [anon_sym_LT_QMARK] = ACTIONS(886),
    [aux_sym__declaration_token1] = ACTIONS(889),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(892),
    [sym__whitespace_ge_2] = ACTIONS(895),
    [aux_sym__whitespace_token1] = ACTIONS(898),
    [sym__word_no_digit] = ACTIONS(856),
    [sym__digits] = ACTIONS(856),
    [sym__code_span_start] = ACTIONS(901),
    [sym__emphasis_open_star] = ACTIONS(904),
    [sym__emphasis_open_underscore] = ACTIONS(907),
    [sym__emphasis_close_underscore] = ACTIONS(910),
    [sym__strikethrough_open] = ACTIONS(912),
    [sym__latex_span_start] = ACTIONS(915),
    [sym__unclosed_span] = ACTIONS(856),
  },
  [24] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(918),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [25] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(920),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [26] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(922),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [27] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(924),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [28] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(21),
    [sym_full_reference_link] = STATE(21),
    [sym_collapsed_reference_link] = STATE(21),
    [sym_inline_link] = STATE(21),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(21),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(21),
    [aux_sym__inline_no_star] = STATE(21),
    [sym__strikethrough] = STATE(21),
    [sym__emphasis_star] = STATE(317),
    [sym__strong_emphasis_star] = STATE(21),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(21),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(116),
    [sym_entity_reference] = ACTIONS(119),
    [sym_numeric_character_reference] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(122),
    [anon_sym_RBRACK] = ACTIONS(125),
    [anon_sym_LT] = ACTIONS(128),
    [anon_sym_GT] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(134),
    [anon_sym_DQUOTE] = ACTIONS(131),
    [anon_sym_POUND] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_PLUS] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_DOT] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(131),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_BSLASH] = ACTIONS(140),
    [anon_sym_CARET] = ACTIONS(131),
    [anon_sym__] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(131),
    [sym__newline_token] = ACTIONS(143),
    [sym_uri_autolink] = ACTIONS(119),
    [sym_email_autolink] = ACTIONS(119),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(146),
    [anon_sym_LT_QMARK] = ACTIONS(149),
    [aux_sym__declaration_token1] = ACTIONS(152),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(155),
    [sym__whitespace_ge_2] = ACTIONS(158),
    [aux_sym__whitespace_token1] = ACTIONS(161),
    [sym__word_no_digit] = ACTIONS(119),
    [sym__digits] = ACTIONS(119),
    [sym__code_span_start] = ACTIONS(164),
    [sym__emphasis_open_star] = ACTIONS(167),
    [sym__emphasis_open_underscore] = ACTIONS(170),
    [sym__last_token_punctuation] = ACTIONS(926),
    [sym__strikethrough_open] = ACTIONS(175),
    [sym__latex_span_start] = ACTIONS(178),
    [sym__unclosed_span] = ACTIONS(119),
  },
  [29] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(25),
    [sym_full_reference_link] = STATE(25),
    [sym_collapsed_reference_link] = STATE(25),
    [sym_inline_link] = STATE(25),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(25),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(25),
    [aux_sym__inline_no_underscore] = STATE(25),
    [sym__strikethrough] = STATE(25),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(25),
    [sym__emphasis_underscore] = STATE(320),
    [sym__strong_emphasis_underscore] = STATE(25),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(181),
    [sym_entity_reference] = ACTIONS(184),
    [sym_numeric_character_reference] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_RBRACK] = ACTIONS(190),
    [anon_sym_LT] = ACTIONS(193),
    [anon_sym_GT] = ACTIONS(196),
    [anon_sym_BANG] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(196),
    [anon_sym_POUND] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(196),
    [anon_sym_PERCENT] = ACTIONS(196),
    [anon_sym_AMP] = ACTIONS(202),
    [anon_sym_SQUOTE] = ACTIONS(196),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_COMMA] = ACTIONS(196),
    [anon_sym_DASH] = ACTIONS(196),
    [anon_sym_DOT] = ACTIONS(196),
    [anon_sym_SLASH] = ACTIONS(196),
    [anon_sym_COLON] = ACTIONS(196),
    [anon_sym_SEMI] = ACTIONS(196),
    [anon_sym_EQ] = ACTIONS(196),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_AT] = ACTIONS(196),
    [anon_sym_BSLASH] = ACTIONS(205),
    [anon_sym_CARET] = ACTIONS(196),
    [anon_sym__] = ACTIONS(196),
    [anon_sym_BQUOTE] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(196),
    [anon_sym_PIPE] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(196),
    [anon_sym_TILDE] = ACTIONS(196),
    [anon_sym_LPAREN] = ACTIONS(196),
    [anon_sym_RPAREN] = ACTIONS(196),
    [sym__newline_token] = ACTIONS(208),
    [sym_uri_autolink] = ACTIONS(184),
    [sym_email_autolink] = ACTIONS(184),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(211),
    [anon_sym_LT_QMARK] = ACTIONS(214),
    [aux_sym__declaration_token1] = ACTIONS(217),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(220),
    [sym__whitespace_ge_2] = ACTIONS(223),
    [aux_sym__whitespace_token1] = ACTIONS(226),
    [sym__word_no_digit] = ACTIONS(184),
    [sym__digits] = ACTIONS(184),
    [sym__code_span_start] = ACTIONS(229),
    [sym__emphasis_open_star] = ACTIONS(232),
    [sym__emphasis_open_underscore] = ACTIONS(235),
    [sym__last_token_punctuation] = ACTIONS(928),
    [sym__strikethrough_open] = ACTIONS(240),
    [sym__latex_span_start] = ACTIONS(243),
    [sym__unclosed_span] = ACTIONS(184),
  },
  [30] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(27),
    [sym_full_reference_link] = STATE(27),
    [sym_collapsed_reference_link] = STATE(27),
    [sym_inline_link] = STATE(27),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(27),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(27),
    [aux_sym__inline_no_tilde] = STATE(27),
    [sym__strikethrough] = STATE(27),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(27),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(27),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(313),
    [sym_entity_reference] = ACTIONS(316),
    [sym_numeric_character_reference] = ACTIONS(316),
    [anon_sym_LBRACK] = ACTIONS(319),
    [anon_sym_RBRACK] = ACTIONS(322),
    [anon_sym_LT] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(328),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(328),
    [anon_sym_POUND] = ACTIONS(328),
    [anon_sym_DOLLAR] = ACTIONS(328),
    [anon_sym_PERCENT] = ACTIONS(328),
    [anon_sym_AMP] = ACTIONS(334),
    [anon_sym_SQUOTE] = ACTIONS(328),
    [anon_sym_STAR] = ACTIONS(328),
    [anon_sym_PLUS] = ACTIONS(328),
    [anon_sym_COMMA] = ACTIONS(328),
    [anon_sym_DASH] = ACTIONS(328),
    [anon_sym_DOT] = ACTIONS(328),
    [anon_sym_SLASH] = ACTIONS(328),
    [anon_sym_COLON] = ACTIONS(328),
    [anon_sym_SEMI] = ACTIONS(328),
    [anon_sym_EQ] = ACTIONS(328),
    [anon_sym_QMARK] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(328),
    [anon_sym_BSLASH] = ACTIONS(337),
    [anon_sym_CARET] = ACTIONS(328),
    [anon_sym__] = ACTIONS(328),
    [anon_sym_BQUOTE] = ACTIONS(328),
    [anon_sym_LBRACE] = ACTIONS(328),
    [anon_sym_PIPE] = ACTIONS(328),
    [anon_sym_RBRACE] = ACTIONS(328),
    [anon_sym_TILDE] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(328),
    [anon_sym_RPAREN] = ACTIONS(328),
    [sym__newline_token] = ACTIONS(340),
    [sym_uri_autolink] = ACTIONS(316),
    [sym_email_autolink] = ACTIONS(316),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(343),
    [anon_sym_LT_QMARK] = ACTIONS(346),
    [aux_sym__declaration_token1] = ACTIONS(349),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(352),
    [sym__whitespace_ge_2] = ACTIONS(355),
    [aux_sym__whitespace_token1] = ACTIONS(358),
    [sym__word_no_digit] = ACTIONS(316),
    [sym__digits] = ACTIONS(316),
    [sym__code_span_start] = ACTIONS(361),
    [sym__emphasis_open_star] = ACTIONS(364),
    [sym__emphasis_open_underscore] = ACTIONS(367),
    [sym__last_token_punctuation] = ACTIONS(930),
    [sym__strikethrough_open] = ACTIONS(372),
    [sym__latex_span_start] = ACTIONS(375),
    [sym__unclosed_span] = ACTIONS(316),
  },
  [31] = {
    [sym_backslash_escape] = STATE(155),
    [sym_code_span] = STATE(155),
    [sym_latex_block] = STATE(155),
    [sym__link_text] = STATE(1120),
    [sym__link_text_non_empty] = STATE(265),
    [sym_shortcut_link] = STATE(275),
    [sym_full_reference_link] = STATE(275),
    [sym_collapsed_reference_link] = STATE(275),
    [sym_inline_link] = STATE(275),
    [sym_image] = STATE(155),
    [sym__image_inline_link] = STATE(266),
    [sym__image_shortcut_link] = STATE(266),
    [sym__image_full_reference_link] = STATE(266),
    [sym__image_collapsed_reference_link] = STATE(266),
    [sym__image_description] = STATE(1124),
    [sym__image_description_non_empty] = STATE(267),
    [sym__html_tag] = STATE(272),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(155),
    [sym__whitespace] = STATE(155),
    [sym__word] = STATE(155),
    [sym__soft_line_break] = STATE(155),
    [sym__inline_base] = STATE(275),
    [sym__text_base] = STATE(155),
    [sym__inline_element] = STATE(275),
    [aux_sym__inline] = STATE(48),
    [sym__strikethrough] = STATE(275),
    [sym__emphasis_star] = STATE(280),
    [sym__strong_emphasis_star] = STATE(275),
    [sym__emphasis_underscore] = STATE(280),
    [sym__strong_emphasis_underscore] = STATE(275),
    [aux_sym__inline_base_repeat1] = STATE(155),
    [ts_builtin_sym_end] = ACTIONS(932),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(5),
    [sym_numeric_character_reference] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(9),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(5),
    [sym_email_autolink] = ACTIONS(5),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(5),
    [sym__digits] = ACTIONS(5),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(37),
    [sym__emphasis_open_underscore] = ACTIONS(39),
    [sym__strikethrough_open] = ACTIONS(43),
    [sym__latex_span_start] = ACTIONS(45),
    [sym__unclosed_span] = ACTIONS(5),
  },
  [32] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(934),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [33] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(936),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [34] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(938),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [35] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(940),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [36] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(410),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__last_token_punctuation] = ACTIONS(942),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [37] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(944),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [38] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(946),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [39] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(948),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [40] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(950),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [41] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(952),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [42] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(954),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [43] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(956),
    [sym_entity_reference] = ACTIONS(959),
    [sym_numeric_character_reference] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_RBRACK] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(968),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(971),
    [anon_sym_POUND] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(971),
    [anon_sym_PERCENT] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_SQUOTE] = ACTIONS(971),
    [anon_sym_STAR] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_COMMA] = ACTIONS(971),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_DOT] = ACTIONS(971),
    [anon_sym_SLASH] = ACTIONS(971),
    [anon_sym_COLON] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(971),
    [anon_sym_EQ] = ACTIONS(971),
    [anon_sym_QMARK] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(971),
    [anon_sym_BSLASH] = ACTIONS(980),
    [anon_sym_CARET] = ACTIONS(971),
    [anon_sym__] = ACTIONS(971),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(971),
    [anon_sym_RPAREN] = ACTIONS(971),
    [sym__newline_token] = ACTIONS(983),
    [sym_uri_autolink] = ACTIONS(959),
    [sym_email_autolink] = ACTIONS(959),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(986),
    [anon_sym_LT_QMARK] = ACTIONS(989),
    [aux_sym__declaration_token1] = ACTIONS(992),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(995),
    [sym__whitespace_ge_2] = ACTIONS(998),
    [aux_sym__whitespace_token1] = ACTIONS(1001),
    [sym__word_no_digit] = ACTIONS(959),
    [sym__digits] = ACTIONS(959),
    [sym__code_span_start] = ACTIONS(1004),
    [sym__emphasis_open_star] = ACTIONS(1007),
    [sym__emphasis_open_underscore] = ACTIONS(1010),
    [sym__emphasis_close_star] = ACTIONS(1013),
    [sym__strikethrough_open] = ACTIONS(1015),
    [sym__latex_span_start] = ACTIONS(1018),
    [sym__unclosed_span] = ACTIONS(959),
  },
  [44] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(26),
    [sym_full_reference_link] = STATE(26),
    [sym_collapsed_reference_link] = STATE(26),
    [sym_inline_link] = STATE(26),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(26),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(26),
    [aux_sym__inline_no_tilde] = STATE(26),
    [sym__strikethrough] = STATE(26),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(26),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(26),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__last_token_punctuation] = ACTIONS(1021),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [45] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__emphasis_close_star] = ACTIONS(1023),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [46] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(20),
    [sym_full_reference_link] = STATE(20),
    [sym_collapsed_reference_link] = STATE(20),
    [sym_inline_link] = STATE(20),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(20),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(20),
    [aux_sym__inline_no_underscore] = STATE(20),
    [sym__strikethrough] = STATE(20),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(20),
    [sym__emphasis_underscore] = STATE(312),
    [sym__strong_emphasis_underscore] = STATE(20),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__last_token_punctuation] = ACTIONS(1025),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [47] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(1027),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [48] = {
    [sym_backslash_escape] = STATE(155),
    [sym_code_span] = STATE(155),
    [sym_latex_block] = STATE(155),
    [sym__link_text] = STATE(1120),
    [sym__link_text_non_empty] = STATE(265),
    [sym_shortcut_link] = STATE(275),
    [sym_full_reference_link] = STATE(275),
    [sym_collapsed_reference_link] = STATE(275),
    [sym_inline_link] = STATE(275),
    [sym_image] = STATE(155),
    [sym__image_inline_link] = STATE(266),
    [sym__image_shortcut_link] = STATE(266),
    [sym__image_full_reference_link] = STATE(266),
    [sym__image_collapsed_reference_link] = STATE(266),
    [sym__image_description] = STATE(1124),
    [sym__image_description_non_empty] = STATE(267),
    [sym__html_tag] = STATE(272),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(155),
    [sym__whitespace] = STATE(155),
    [sym__word] = STATE(155),
    [sym__soft_line_break] = STATE(155),
    [sym__inline_base] = STATE(275),
    [sym__text_base] = STATE(155),
    [sym__inline_element] = STATE(275),
    [aux_sym__inline] = STATE(48),
    [sym__strikethrough] = STATE(275),
    [sym__emphasis_star] = STATE(280),
    [sym__strong_emphasis_star] = STATE(275),
    [sym__emphasis_underscore] = STATE(280),
    [sym__strong_emphasis_underscore] = STATE(275),
    [aux_sym__inline_base_repeat1] = STATE(155),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym__backslash_escape] = ACTIONS(1031),
    [sym_entity_reference] = ACTIONS(1034),
    [sym_numeric_character_reference] = ACTIONS(1034),
    [anon_sym_LBRACK] = ACTIONS(1037),
    [anon_sym_RBRACK] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [anon_sym_POUND] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1046),
    [anon_sym_PERCENT] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1052),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_PLUS] = ACTIONS(1046),
    [anon_sym_COMMA] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1046),
    [anon_sym_DOT] = ACTIONS(1046),
    [anon_sym_SLASH] = ACTIONS(1046),
    [anon_sym_COLON] = ACTIONS(1046),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_EQ] = ACTIONS(1046),
    [anon_sym_QMARK] = ACTIONS(1046),
    [anon_sym_AT] = ACTIONS(1046),
    [anon_sym_BSLASH] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1046),
    [anon_sym__] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_LPAREN] = ACTIONS(1046),
    [anon_sym_RPAREN] = ACTIONS(1046),
    [sym__newline_token] = ACTIONS(1058),
    [sym_uri_autolink] = ACTIONS(1034),
    [sym_email_autolink] = ACTIONS(1034),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1061),
    [anon_sym_LT_QMARK] = ACTIONS(1064),
    [aux_sym__declaration_token1] = ACTIONS(1067),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1070),
    [sym__whitespace_ge_2] = ACTIONS(1073),
    [aux_sym__whitespace_token1] = ACTIONS(1076),
    [sym__word_no_digit] = ACTIONS(1034),
    [sym__digits] = ACTIONS(1034),
    [sym__code_span_start] = ACTIONS(1079),
    [sym__emphasis_open_star] = ACTIONS(1082),
    [sym__emphasis_open_underscore] = ACTIONS(1085),
    [sym__strikethrough_open] = ACTIONS(1088),
    [sym__latex_span_start] = ACTIONS(1091),
    [sym__unclosed_span] = ACTIONS(1034),
  },
  [49] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(1094),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [50] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(14),
    [aux_sym__inline_no_tilde] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__strikethrough_close] = ACTIONS(1096),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [51] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(23),
    [aux_sym__inline_no_underscore] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__emphasis_close_underscore] = ACTIONS(1098),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [52] = {
    [sym_backslash_escape] = STATE(155),
    [sym_code_span] = STATE(155),
    [sym_latex_block] = STATE(155),
    [sym__link_text] = STATE(1120),
    [sym__link_text_non_empty] = STATE(265),
    [sym_shortcut_link] = STATE(275),
    [sym_full_reference_link] = STATE(275),
    [sym_collapsed_reference_link] = STATE(275),
    [sym_inline_link] = STATE(275),
    [sym_image] = STATE(155),
    [sym__image_inline_link] = STATE(266),
    [sym__image_shortcut_link] = STATE(266),
    [sym__image_full_reference_link] = STATE(266),
    [sym__image_collapsed_reference_link] = STATE(266),
    [sym__image_description] = STATE(1124),
    [sym__image_description_non_empty] = STATE(267),
    [sym__html_tag] = STATE(272),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(155),
    [sym__whitespace] = STATE(155),
    [sym__word] = STATE(155),
    [sym__soft_line_break] = STATE(155),
    [sym__inline_base] = STATE(275),
    [sym__text_base] = STATE(155),
    [sym__inline_element] = STATE(275),
    [aux_sym__inline] = STATE(48),
    [sym__strikethrough] = STATE(275),
    [sym__emphasis_star] = STATE(280),
    [sym__strong_emphasis_star] = STATE(275),
    [sym__emphasis_underscore] = STATE(280),
    [sym__strong_emphasis_underscore] = STATE(275),
    [aux_sym__inline_base_repeat1] = STATE(155),
    [ts_builtin_sym_end] = ACTIONS(1100),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(5),
    [sym_numeric_character_reference] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(9),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(5),
    [sym_email_autolink] = ACTIONS(5),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(5),
    [sym__digits] = ACTIONS(5),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(37),
    [sym__emphasis_open_underscore] = ACTIONS(39),
    [sym__strikethrough_open] = ACTIONS(43),
    [sym__latex_span_start] = ACTIONS(45),
    [sym__unclosed_span] = ACTIONS(5),
  },
  [53] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(61),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1108),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [54] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(37),
    [sym_full_reference_link] = STATE(37),
    [sym_collapsed_reference_link] = STATE(37),
    [sym_inline_link] = STATE(37),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(37),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(37),
    [aux_sym__inline_no_star] = STATE(37),
    [sym__strikethrough] = STATE(37),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(37),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(37),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [55] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(32),
    [sym_full_reference_link] = STATE(32),
    [sym_collapsed_reference_link] = STATE(32),
    [sym_inline_link] = STATE(32),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(32),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(32),
    [aux_sym__inline_no_underscore] = STATE(32),
    [sym__strikethrough] = STATE(32),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(32),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(32),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [56] = {
    [sym_backslash_escape] = STATE(155),
    [sym_code_span] = STATE(155),
    [sym_latex_block] = STATE(155),
    [sym__link_text] = STATE(1120),
    [sym__link_text_non_empty] = STATE(265),
    [sym_shortcut_link] = STATE(275),
    [sym_full_reference_link] = STATE(275),
    [sym_collapsed_reference_link] = STATE(275),
    [sym_inline_link] = STATE(275),
    [sym_image] = STATE(155),
    [sym__image_inline_link] = STATE(266),
    [sym__image_shortcut_link] = STATE(266),
    [sym__image_full_reference_link] = STATE(266),
    [sym__image_collapsed_reference_link] = STATE(266),
    [sym__image_description] = STATE(1124),
    [sym__image_description_non_empty] = STATE(267),
    [sym__html_tag] = STATE(272),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(155),
    [sym__whitespace] = STATE(155),
    [sym__word] = STATE(155),
    [sym__soft_line_break] = STATE(155),
    [sym__inline_base] = STATE(275),
    [sym__text_base] = STATE(155),
    [sym__inline_element] = STATE(275),
    [aux_sym__inline] = STATE(52),
    [sym__strikethrough] = STATE(275),
    [sym__emphasis_star] = STATE(280),
    [sym__strong_emphasis_star] = STATE(275),
    [sym__emphasis_underscore] = STATE(280),
    [sym__strong_emphasis_underscore] = STATE(275),
    [aux_sym__inline_base_repeat1] = STATE(155),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(5),
    [sym_numeric_character_reference] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(9),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(5),
    [sym_email_autolink] = ACTIONS(5),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(5),
    [sym__digits] = ACTIONS(5),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(37),
    [sym__emphasis_open_underscore] = ACTIONS(39),
    [sym__strikethrough_open] = ACTIONS(43),
    [sym__latex_span_start] = ACTIONS(45),
    [sym__unclosed_span] = ACTIONS(5),
  },
  [57] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(39),
    [sym_full_reference_link] = STATE(39),
    [sym_collapsed_reference_link] = STATE(39),
    [sym_inline_link] = STATE(39),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(39),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(39),
    [aux_sym__inline_no_tilde] = STATE(39),
    [sym__strikethrough] = STATE(39),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(39),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(39),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [58] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(22),
    [sym_full_reference_link] = STATE(22),
    [sym_collapsed_reference_link] = STATE(22),
    [sym_inline_link] = STATE(22),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(22),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(22),
    [aux_sym__inline_no_underscore] = STATE(22),
    [sym__strikethrough] = STATE(22),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(22),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(22),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [59] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(61),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [60] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(61),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [61] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(61),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1148),
    [sym_entity_reference] = ACTIONS(1151),
    [sym_numeric_character_reference] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1154),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1160),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1166),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_POUND] = ACTIONS(1163),
    [anon_sym_DOLLAR] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_EQ] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AT] = ACTIONS(1163),
    [anon_sym_BSLASH] = ACTIONS(1172),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym__] = ACTIONS(1163),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [sym__newline_token] = ACTIONS(1175),
    [sym_uri_autolink] = ACTIONS(1151),
    [sym_email_autolink] = ACTIONS(1151),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1178),
    [anon_sym_LT_QMARK] = ACTIONS(1181),
    [aux_sym__declaration_token1] = ACTIONS(1184),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1187),
    [sym__whitespace_ge_2] = ACTIONS(1190),
    [aux_sym__whitespace_token1] = ACTIONS(1193),
    [sym__word_no_digit] = ACTIONS(1151),
    [sym__digits] = ACTIONS(1151),
    [sym__code_span_start] = ACTIONS(1196),
    [sym__emphasis_open_star] = ACTIONS(1199),
    [sym__emphasis_open_underscore] = ACTIONS(1202),
    [sym__strikethrough_open] = ACTIONS(1205),
    [sym__latex_span_start] = ACTIONS(1208),
    [sym__unclosed_span] = ACTIONS(1151),
  },
  [62] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(61),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [63] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(13),
    [sym_full_reference_link] = STATE(13),
    [sym_collapsed_reference_link] = STATE(13),
    [sym_inline_link] = STATE(13),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(13),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(13),
    [aux_sym__inline_no_tilde] = STATE(13),
    [sym__strikethrough] = STATE(13),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(13),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(13),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [64] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(15),
    [sym_full_reference_link] = STATE(15),
    [sym_collapsed_reference_link] = STATE(15),
    [sym_inline_link] = STATE(15),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(15),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(15),
    [aux_sym__inline_no_star] = STATE(15),
    [sym__strikethrough] = STATE(15),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(15),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(15),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [65] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(85),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [66] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(61),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1215),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [67] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(40),
    [sym_full_reference_link] = STATE(40),
    [sym_collapsed_reference_link] = STATE(40),
    [sym_inline_link] = STATE(40),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(40),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(40),
    [aux_sym__inline_no_star] = STATE(40),
    [sym__strikethrough] = STATE(40),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(40),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(40),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [68] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(51),
    [sym_full_reference_link] = STATE(51),
    [sym_collapsed_reference_link] = STATE(51),
    [sym_inline_link] = STATE(51),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(51),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(51),
    [aux_sym__inline_no_underscore] = STATE(51),
    [sym__strikethrough] = STATE(51),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(51),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(51),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [69] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(62),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [70] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(50),
    [sym_full_reference_link] = STATE(50),
    [sym_collapsed_reference_link] = STATE(50),
    [sym_inline_link] = STATE(50),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(50),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(50),
    [aux_sym__inline_no_tilde] = STATE(50),
    [sym__strikethrough] = STATE(50),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(50),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(50),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [71] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(53),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [72] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(18),
    [sym_full_reference_link] = STATE(18),
    [sym_collapsed_reference_link] = STATE(18),
    [sym_inline_link] = STATE(18),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(18),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(18),
    [aux_sym__inline_no_star] = STATE(18),
    [sym__strikethrough] = STATE(18),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(18),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(18),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [73] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(17),
    [sym_full_reference_link] = STATE(17),
    [sym_collapsed_reference_link] = STATE(17),
    [sym_inline_link] = STATE(17),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(17),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(17),
    [aux_sym__inline_no_underscore] = STATE(17),
    [sym__strikethrough] = STATE(17),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(17),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(17),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [74] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(35),
    [sym_full_reference_link] = STATE(35),
    [sym_collapsed_reference_link] = STATE(35),
    [sym_inline_link] = STATE(35),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(35),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(35),
    [aux_sym__inline_no_tilde] = STATE(35),
    [sym__strikethrough] = STATE(35),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(35),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(35),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [75] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym_latex_block] = STATE(153),
    [sym__link_text] = STATE(1115),
    [sym__link_text_non_empty] = STATE(433),
    [sym_shortcut_link] = STATE(34),
    [sym_full_reference_link] = STATE(34),
    [sym_collapsed_reference_link] = STATE(34),
    [sym_inline_link] = STATE(34),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(34),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(34),
    [aux_sym__inline_no_underscore] = STATE(34),
    [sym__strikethrough] = STATE(34),
    [sym__emphasis_star] = STATE(290),
    [sym__strong_emphasis_star] = STATE(34),
    [sym__emphasis_underscore] = STATE(290),
    [sym__strong_emphasis_underscore] = STATE(34),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(686),
    [sym_numeric_character_reference] = ACTIONS(686),
    [anon_sym_LBRACK] = ACTIONS(688),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(686),
    [sym_email_autolink] = ACTIONS(686),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(686),
    [sym__digits] = ACTIONS(686),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(718),
    [sym__emphasis_open_underscore] = ACTIONS(720),
    [sym__strikethrough_open] = ACTIONS(724),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(686),
  },
  [76] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym_latex_block] = STATE(149),
    [sym__link_text] = STATE(1118),
    [sym__link_text_non_empty] = STATE(345),
    [sym_shortcut_link] = STATE(33),
    [sym_full_reference_link] = STATE(33),
    [sym_collapsed_reference_link] = STATE(33),
    [sym_inline_link] = STATE(33),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(33),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_star] = STATE(33),
    [aux_sym__inline_no_star] = STATE(33),
    [sym__strikethrough] = STATE(33),
    [sym__emphasis_star] = STATE(284),
    [sym__strong_emphasis_star] = STATE(33),
    [sym__emphasis_underscore] = STATE(284),
    [sym__strong_emphasis_underscore] = STATE(33),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(642),
    [sym_numeric_character_reference] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(642),
    [sym_email_autolink] = ACTIONS(642),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(642),
    [sym__digits] = ACTIONS(642),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(674),
    [sym__emphasis_open_underscore] = ACTIONS(676),
    [sym__strikethrough_open] = ACTIONS(680),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(642),
  },
  [77] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(79),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [78] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_latex_block] = STATE(154),
    [sym__link_text] = STATE(1116),
    [sym__link_text_non_empty] = STATE(502),
    [sym_shortcut_link] = STATE(16),
    [sym_full_reference_link] = STATE(16),
    [sym_collapsed_reference_link] = STATE(16),
    [sym_inline_link] = STATE(16),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__inline_base] = STATE(16),
    [sym__text_base] = STATE(154),
    [sym__inline_element_no_tilde] = STATE(16),
    [aux_sym__inline_no_tilde] = STATE(16),
    [sym__strikethrough] = STATE(16),
    [sym__emphasis_star] = STATE(292),
    [sym__strong_emphasis_star] = STATE(16),
    [sym__emphasis_underscore] = STATE(292),
    [sym__strong_emphasis_underscore] = STATE(16),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(730),
    [sym_numeric_character_reference] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(730),
    [sym_email_autolink] = ACTIONS(730),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(730),
    [sym__digits] = ACTIONS(730),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(762),
    [sym__emphasis_open_underscore] = ACTIONS(764),
    [sym__strikethrough_open] = ACTIONS(766),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(730),
  },
  [79] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(61),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [80] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(59),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [81] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(61),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1219),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [82] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(81),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [83] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(60),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [84] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(66),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [85] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym_latex_block] = STATE(157),
    [sym__link_text] = STATE(1122),
    [sym__link_text_non_empty] = STATE(592),
    [sym_shortcut_link] = STATE(585),
    [sym_full_reference_link] = STATE(585),
    [sym_collapsed_reference_link] = STATE(585),
    [sym_inline_link] = STATE(585),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(585),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(585),
    [aux_sym__inline] = STATE(61),
    [sym__strikethrough] = STATE(585),
    [sym__emphasis_star] = STATE(589),
    [sym__strong_emphasis_star] = STATE(585),
    [sym__emphasis_underscore] = STATE(589),
    [sym__strong_emphasis_underscore] = STATE(585),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(1104),
    [sym_numeric_character_reference] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_RBRACK] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(1104),
    [sym_email_autolink] = ACTIONS(1104),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(1104),
    [sym__digits] = ACTIONS(1104),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(1136),
    [sym__emphasis_open_underscore] = ACTIONS(1138),
    [sym__strikethrough_open] = ACTIONS(1140),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(1104),
  },
  [86] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(114),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1223),
    [sym_entity_reference] = ACTIONS(1226),
    [sym_numeric_character_reference] = ACTIONS(1226),
    [anon_sym_LBRACK] = ACTIONS(500),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1232),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_POUND] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_COLON] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1235),
    [anon_sym_BSLASH] = ACTIONS(1244),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym__] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [sym__newline_token] = ACTIONS(1247),
    [sym_uri_autolink] = ACTIONS(1226),
    [sym_email_autolink] = ACTIONS(1226),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1250),
    [anon_sym_LT_QMARK] = ACTIONS(1253),
    [aux_sym__declaration_token1] = ACTIONS(1256),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1259),
    [sym__whitespace_ge_2] = ACTIONS(1262),
    [aux_sym__whitespace_token1] = ACTIONS(1265),
    [sym__word_no_digit] = ACTIONS(1226),
    [sym__digits] = ACTIONS(1226),
    [sym__code_span_start] = ACTIONS(1268),
    [sym__emphasis_open_star] = ACTIONS(1271),
    [sym__emphasis_open_underscore] = ACTIONS(1274),
    [sym__emphasis_close_star] = ACTIONS(500),
    [sym__last_token_punctuation] = ACTIONS(1277),
    [sym__strikethrough_open] = ACTIONS(1279),
    [sym__latex_span_start] = ACTIONS(1282),
    [sym__unclosed_span] = ACTIONS(1226),
  },
  [87] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(131),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1285),
    [sym_entity_reference] = ACTIONS(1288),
    [sym_numeric_character_reference] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_RBRACK] = ACTIONS(1291),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_GT] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1297),
    [anon_sym_POUND] = ACTIONS(1297),
    [anon_sym_DOLLAR] = ACTIONS(1297),
    [anon_sym_PERCENT] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_COMMA] = ACTIONS(1297),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_DOT] = ACTIONS(1297),
    [anon_sym_SLASH] = ACTIONS(1297),
    [anon_sym_COLON] = ACTIONS(1297),
    [anon_sym_SEMI] = ACTIONS(1297),
    [anon_sym_EQ] = ACTIONS(1297),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_AT] = ACTIONS(1297),
    [anon_sym_BSLASH] = ACTIONS(1306),
    [anon_sym_CARET] = ACTIONS(1297),
    [anon_sym__] = ACTIONS(1297),
    [anon_sym_BQUOTE] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_PIPE] = ACTIONS(1297),
    [anon_sym_RBRACE] = ACTIONS(1297),
    [anon_sym_TILDE] = ACTIONS(1297),
    [anon_sym_LPAREN] = ACTIONS(1297),
    [anon_sym_RPAREN] = ACTIONS(1297),
    [sym__newline_token] = ACTIONS(1309),
    [sym_uri_autolink] = ACTIONS(1288),
    [sym_email_autolink] = ACTIONS(1288),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1312),
    [anon_sym_LT_QMARK] = ACTIONS(1315),
    [aux_sym__declaration_token1] = ACTIONS(1318),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1321),
    [sym__whitespace_ge_2] = ACTIONS(1324),
    [aux_sym__whitespace_token1] = ACTIONS(1327),
    [sym__word_no_digit] = ACTIONS(1288),
    [sym__digits] = ACTIONS(1288),
    [sym__code_span_start] = ACTIONS(1330),
    [sym__emphasis_open_star] = ACTIONS(1333),
    [sym__emphasis_open_underscore] = ACTIONS(1336),
    [sym__last_token_punctuation] = ACTIONS(1339),
    [sym__strikethrough_open] = ACTIONS(1341),
    [sym__strikethrough_close] = ACTIONS(308),
    [sym__latex_span_start] = ACTIONS(1344),
    [sym__unclosed_span] = ACTIONS(1288),
  },
  [88] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(132),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1347),
    [sym_entity_reference] = ACTIONS(1350),
    [sym_numeric_character_reference] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(104),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1356),
    [anon_sym_GT] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1362),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [anon_sym_POUND] = ACTIONS(1359),
    [anon_sym_DOLLAR] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym_EQ] = ACTIONS(1359),
    [anon_sym_QMARK] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1359),
    [anon_sym_BSLASH] = ACTIONS(1368),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym__] = ACTIONS(1359),
    [anon_sym_BQUOTE] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_RBRACE] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_RPAREN] = ACTIONS(1359),
    [sym__newline_token] = ACTIONS(1371),
    [sym_uri_autolink] = ACTIONS(1350),
    [sym_email_autolink] = ACTIONS(1350),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1374),
    [anon_sym_LT_QMARK] = ACTIONS(1377),
    [aux_sym__declaration_token1] = ACTIONS(1380),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1383),
    [sym__whitespace_ge_2] = ACTIONS(1386),
    [aux_sym__whitespace_token1] = ACTIONS(1389),
    [sym__word_no_digit] = ACTIONS(1350),
    [sym__digits] = ACTIONS(1350),
    [sym__code_span_start] = ACTIONS(1392),
    [sym__emphasis_open_star] = ACTIONS(1395),
    [sym__emphasis_open_underscore] = ACTIONS(1398),
    [sym__emphasis_close_underscore] = ACTIONS(104),
    [sym__last_token_punctuation] = ACTIONS(1401),
    [sym__strikethrough_open] = ACTIONS(1403),
    [sym__latex_span_start] = ACTIONS(1406),
    [sym__unclosed_span] = ACTIONS(1350),
  },
  [89] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(106),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [ts_builtin_sym_end] = ACTIONS(114),
    [sym__backslash_escape] = ACTIONS(1409),
    [sym_entity_reference] = ACTIONS(1412),
    [sym_numeric_character_reference] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(114),
    [anon_sym_RBRACK] = ACTIONS(1415),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1421),
    [anon_sym_POUND] = ACTIONS(1421),
    [anon_sym_DOLLAR] = ACTIONS(1421),
    [anon_sym_PERCENT] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_COMMA] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_DOT] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_EQ] = ACTIONS(1421),
    [anon_sym_QMARK] = ACTIONS(1421),
    [anon_sym_AT] = ACTIONS(1421),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_CARET] = ACTIONS(1421),
    [anon_sym__] = ACTIONS(1421),
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(1421),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_RPAREN] = ACTIONS(1421),
    [sym__newline_token] = ACTIONS(1433),
    [sym_uri_autolink] = ACTIONS(1412),
    [sym_email_autolink] = ACTIONS(1412),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1436),
    [anon_sym_LT_QMARK] = ACTIONS(1439),
    [aux_sym__declaration_token1] = ACTIONS(1442),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1445),
    [sym__whitespace_ge_2] = ACTIONS(1448),
    [aux_sym__whitespace_token1] = ACTIONS(1451),
    [sym__word_no_digit] = ACTIONS(1412),
    [sym__digits] = ACTIONS(1412),
    [sym__code_span_start] = ACTIONS(1454),
    [sym__emphasis_open_star] = ACTIONS(1457),
    [sym__emphasis_open_underscore] = ACTIONS(1460),
    [sym__last_token_punctuation] = ACTIONS(1463),
    [sym__strikethrough_open] = ACTIONS(1465),
    [sym__latex_span_start] = ACTIONS(1468),
    [sym__unclosed_span] = ACTIONS(1412),
  },
  [90] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(100),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1409),
    [sym_entity_reference] = ACTIONS(1412),
    [sym_numeric_character_reference] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(114),
    [anon_sym_RBRACK] = ACTIONS(1415),
    [anon_sym_LT] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1421),
    [anon_sym_POUND] = ACTIONS(1421),
    [anon_sym_DOLLAR] = ACTIONS(1421),
    [anon_sym_PERCENT] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_COMMA] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_DOT] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_EQ] = ACTIONS(1421),
    [anon_sym_QMARK] = ACTIONS(1421),
    [anon_sym_AT] = ACTIONS(1421),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_CARET] = ACTIONS(1421),
    [anon_sym__] = ACTIONS(1421),
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(1421),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_TILDE] = ACTIONS(1421),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_RPAREN] = ACTIONS(1421),
    [sym__newline_token] = ACTIONS(1433),
    [sym_uri_autolink] = ACTIONS(1412),
    [sym_email_autolink] = ACTIONS(1412),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1436),
    [anon_sym_LT_QMARK] = ACTIONS(1439),
    [aux_sym__declaration_token1] = ACTIONS(1442),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1445),
    [sym__whitespace_ge_2] = ACTIONS(1448),
    [aux_sym__whitespace_token1] = ACTIONS(1451),
    [sym__word_no_digit] = ACTIONS(1412),
    [sym__digits] = ACTIONS(1412),
    [sym__code_span_start] = ACTIONS(1454),
    [sym__emphasis_open_star] = ACTIONS(1457),
    [sym__emphasis_open_underscore] = ACTIONS(1460),
    [sym__last_token_punctuation] = ACTIONS(1471),
    [sym__strikethrough_open] = ACTIONS(1465),
    [sym__latex_span_start] = ACTIONS(1468),
    [sym__unclosed_span] = ACTIONS(1412),
  },
  [91] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(116),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(116),
    [aux_sym__inline_no_underscore_no_link] = STATE(116),
    [sym__strikethrough_no_link] = STATE(116),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(116),
    [sym__emphasis_underscore_no_link] = STATE(618),
    [sym__strong_emphasis_underscore_no_link] = STATE(116),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(1473),
    [sym_entity_reference] = ACTIONS(1476),
    [sym_numeric_character_reference] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1485),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [anon_sym_POUND] = ACTIONS(1482),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_PERCENT] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_DOT] = ACTIONS(1482),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_COLON] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1482),
    [anon_sym_EQ] = ACTIONS(1482),
    [anon_sym_QMARK] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [anon_sym_BSLASH] = ACTIONS(1491),
    [anon_sym_CARET] = ACTIONS(1482),
    [anon_sym__] = ACTIONS(1482),
    [anon_sym_BQUOTE] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1482),
    [anon_sym_RBRACE] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1482),
    [anon_sym_RPAREN] = ACTIONS(1482),
    [sym__newline_token] = ACTIONS(1494),
    [sym_uri_autolink] = ACTIONS(1476),
    [sym_email_autolink] = ACTIONS(1476),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1497),
    [anon_sym_LT_QMARK] = ACTIONS(1500),
    [aux_sym__declaration_token1] = ACTIONS(1503),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1506),
    [sym__whitespace_ge_2] = ACTIONS(1509),
    [aux_sym__whitespace_token1] = ACTIONS(1512),
    [sym__word_no_digit] = ACTIONS(1476),
    [sym__digits] = ACTIONS(1476),
    [sym__code_span_start] = ACTIONS(1515),
    [sym__emphasis_open_star] = ACTIONS(1518),
    [sym__emphasis_open_underscore] = ACTIONS(1521),
    [sym__last_token_punctuation] = ACTIONS(1524),
    [sym__strikethrough_open] = ACTIONS(1526),
    [sym__strikethrough_close] = ACTIONS(1529),
    [sym__latex_span_start] = ACTIONS(1531),
    [sym__unclosed_span] = ACTIONS(1476),
  },
  [92] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(119),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(119),
    [aux_sym__inline_no_star_no_link] = STATE(119),
    [sym__strikethrough_no_link] = STATE(119),
    [sym__emphasis_star_no_link] = STATE(614),
    [sym__strong_emphasis_star_no_link] = STATE(119),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(119),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(1534),
    [sym_entity_reference] = ACTIONS(1537),
    [sym_numeric_character_reference] = ACTIONS(1537),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_DQUOTE] = ACTIONS(1543),
    [anon_sym_POUND] = ACTIONS(1543),
    [anon_sym_DOLLAR] = ACTIONS(1543),
    [anon_sym_PERCENT] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1549),
    [anon_sym_SQUOTE] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1543),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_COMMA] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_SLASH] = ACTIONS(1543),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym_EQ] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(1543),
    [anon_sym_AT] = ACTIONS(1543),
    [anon_sym_BSLASH] = ACTIONS(1552),
    [anon_sym_CARET] = ACTIONS(1543),
    [anon_sym__] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1543),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_RBRACE] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1543),
    [anon_sym_LPAREN] = ACTIONS(1543),
    [anon_sym_RPAREN] = ACTIONS(1543),
    [sym__newline_token] = ACTIONS(1555),
    [sym_uri_autolink] = ACTIONS(1537),
    [sym_email_autolink] = ACTIONS(1537),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1558),
    [anon_sym_LT_QMARK] = ACTIONS(1561),
    [aux_sym__declaration_token1] = ACTIONS(1564),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1567),
    [sym__whitespace_ge_2] = ACTIONS(1570),
    [aux_sym__whitespace_token1] = ACTIONS(1573),
    [sym__word_no_digit] = ACTIONS(1537),
    [sym__digits] = ACTIONS(1537),
    [sym__code_span_start] = ACTIONS(1576),
    [sym__emphasis_open_star] = ACTIONS(1579),
    [sym__emphasis_open_underscore] = ACTIONS(1582),
    [sym__emphasis_close_underscore] = ACTIONS(1585),
    [sym__last_token_punctuation] = ACTIONS(1587),
    [sym__strikethrough_open] = ACTIONS(1589),
    [sym__latex_span_start] = ACTIONS(1592),
    [sym__unclosed_span] = ACTIONS(1537),
  },
  [93] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(123),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(123),
    [aux_sym__inline_no_star_no_link] = STATE(123),
    [sym__strikethrough_no_link] = STATE(123),
    [sym__emphasis_star_no_link] = STATE(644),
    [sym__strong_emphasis_star_no_link] = STATE(123),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(123),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(1595),
    [sym_entity_reference] = ACTIONS(1598),
    [sym_numeric_character_reference] = ACTIONS(1598),
    [anon_sym_RBRACK] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(1603),
    [anon_sym_GT] = ACTIONS(1606),
    [anon_sym_BANG] = ACTIONS(1609),
    [anon_sym_DQUOTE] = ACTIONS(1606),
    [anon_sym_POUND] = ACTIONS(1606),
    [anon_sym_DOLLAR] = ACTIONS(1606),
    [anon_sym_PERCENT] = ACTIONS(1606),
    [anon_sym_AMP] = ACTIONS(1612),
    [anon_sym_SQUOTE] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1606),
    [anon_sym_COMMA] = ACTIONS(1606),
    [anon_sym_DASH] = ACTIONS(1606),
    [anon_sym_DOT] = ACTIONS(1606),
    [anon_sym_SLASH] = ACTIONS(1606),
    [anon_sym_COLON] = ACTIONS(1606),
    [anon_sym_SEMI] = ACTIONS(1606),
    [anon_sym_EQ] = ACTIONS(1606),
    [anon_sym_QMARK] = ACTIONS(1606),
    [anon_sym_AT] = ACTIONS(1606),
    [anon_sym_BSLASH] = ACTIONS(1615),
    [anon_sym_CARET] = ACTIONS(1606),
    [anon_sym__] = ACTIONS(1606),
    [anon_sym_BQUOTE] = ACTIONS(1606),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_PIPE] = ACTIONS(1606),
    [anon_sym_RBRACE] = ACTIONS(1606),
    [anon_sym_TILDE] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_RPAREN] = ACTIONS(1606),
    [sym__newline_token] = ACTIONS(1618),
    [sym_uri_autolink] = ACTIONS(1598),
    [sym_email_autolink] = ACTIONS(1598),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1621),
    [anon_sym_LT_QMARK] = ACTIONS(1624),
    [aux_sym__declaration_token1] = ACTIONS(1627),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1630),
    [sym__whitespace_ge_2] = ACTIONS(1633),
    [aux_sym__whitespace_token1] = ACTIONS(1636),
    [sym__word_no_digit] = ACTIONS(1598),
    [sym__digits] = ACTIONS(1598),
    [sym__code_span_start] = ACTIONS(1639),
    [sym__emphasis_open_star] = ACTIONS(1642),
    [sym__emphasis_open_underscore] = ACTIONS(1645),
    [sym__last_token_punctuation] = ACTIONS(1648),
    [sym__strikethrough_open] = ACTIONS(1650),
    [sym__latex_span_start] = ACTIONS(1653),
    [sym__unclosed_span] = ACTIONS(1598),
  },
  [94] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(128),
    [aux_sym__inline_no_underscore_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(627),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(1656),
    [sym_entity_reference] = ACTIONS(1659),
    [sym_numeric_character_reference] = ACTIONS(1659),
    [anon_sym_RBRACK] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(1662),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_BANG] = ACTIONS(1668),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_POUND] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_PERCENT] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(1665),
    [anon_sym_STAR] = ACTIONS(1665),
    [anon_sym_PLUS] = ACTIONS(1665),
    [anon_sym_COMMA] = ACTIONS(1665),
    [anon_sym_DASH] = ACTIONS(1665),
    [anon_sym_DOT] = ACTIONS(1665),
    [anon_sym_SLASH] = ACTIONS(1665),
    [anon_sym_COLON] = ACTIONS(1665),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_QMARK] = ACTIONS(1665),
    [anon_sym_AT] = ACTIONS(1665),
    [anon_sym_BSLASH] = ACTIONS(1674),
    [anon_sym_CARET] = ACTIONS(1665),
    [anon_sym__] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_RBRACE] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1665),
    [anon_sym_LPAREN] = ACTIONS(1665),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [sym__newline_token] = ACTIONS(1677),
    [sym_uri_autolink] = ACTIONS(1659),
    [sym_email_autolink] = ACTIONS(1659),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1680),
    [anon_sym_LT_QMARK] = ACTIONS(1683),
    [aux_sym__declaration_token1] = ACTIONS(1686),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1689),
    [sym__whitespace_ge_2] = ACTIONS(1692),
    [aux_sym__whitespace_token1] = ACTIONS(1695),
    [sym__word_no_digit] = ACTIONS(1659),
    [sym__digits] = ACTIONS(1659),
    [sym__code_span_start] = ACTIONS(1698),
    [sym__emphasis_open_star] = ACTIONS(1701),
    [sym__emphasis_open_underscore] = ACTIONS(1704),
    [sym__last_token_punctuation] = ACTIONS(1707),
    [sym__strikethrough_open] = ACTIONS(1709),
    [sym__latex_span_start] = ACTIONS(1712),
    [sym__unclosed_span] = ACTIONS(1659),
  },
  [95] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(101),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(101),
    [aux_sym__inline_no_tilde_no_link] = STATE(101),
    [sym__strikethrough_no_link] = STATE(101),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(101),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(101),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(1715),
    [sym_entity_reference] = ACTIONS(1718),
    [sym_numeric_character_reference] = ACTIONS(1718),
    [anon_sym_RBRACK] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_DQUOTE] = ACTIONS(1724),
    [anon_sym_POUND] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1724),
    [anon_sym_PERCENT] = ACTIONS(1724),
    [anon_sym_AMP] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1724),
    [anon_sym_STAR] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(1724),
    [anon_sym_COMMA] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1724),
    [anon_sym_DOT] = ACTIONS(1724),
    [anon_sym_SLASH] = ACTIONS(1724),
    [anon_sym_COLON] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1724),
    [anon_sym_EQ] = ACTIONS(1724),
    [anon_sym_QMARK] = ACTIONS(1724),
    [anon_sym_AT] = ACTIONS(1724),
    [anon_sym_BSLASH] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1724),
    [anon_sym__] = ACTIONS(1724),
    [anon_sym_BQUOTE] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1724),
    [anon_sym_PIPE] = ACTIONS(1724),
    [anon_sym_RBRACE] = ACTIONS(1724),
    [anon_sym_TILDE] = ACTIONS(1724),
    [anon_sym_LPAREN] = ACTIONS(1724),
    [anon_sym_RPAREN] = ACTIONS(1724),
    [sym__newline_token] = ACTIONS(1736),
    [sym_uri_autolink] = ACTIONS(1718),
    [sym_email_autolink] = ACTIONS(1718),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1739),
    [anon_sym_LT_QMARK] = ACTIONS(1742),
    [aux_sym__declaration_token1] = ACTIONS(1745),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1748),
    [sym__whitespace_ge_2] = ACTIONS(1751),
    [aux_sym__whitespace_token1] = ACTIONS(1754),
    [sym__word_no_digit] = ACTIONS(1718),
    [sym__digits] = ACTIONS(1718),
    [sym__code_span_start] = ACTIONS(1757),
    [sym__emphasis_open_star] = ACTIONS(1760),
    [sym__emphasis_open_underscore] = ACTIONS(1763),
    [sym__last_token_punctuation] = ACTIONS(1766),
    [sym__strikethrough_open] = ACTIONS(1768),
    [sym__latex_span_start] = ACTIONS(1771),
    [sym__unclosed_span] = ACTIONS(1718),
  },
  [96] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(115),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(115),
    [aux_sym__inline_no_tilde_no_link] = STATE(115),
    [sym__strikethrough_no_link] = STATE(115),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(115),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(115),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(1774),
    [sym_entity_reference] = ACTIONS(1777),
    [sym_numeric_character_reference] = ACTIONS(1777),
    [anon_sym_LT] = ACTIONS(1780),
    [anon_sym_GT] = ACTIONS(1783),
    [anon_sym_BANG] = ACTIONS(1786),
    [anon_sym_DQUOTE] = ACTIONS(1783),
    [anon_sym_POUND] = ACTIONS(1783),
    [anon_sym_DOLLAR] = ACTIONS(1783),
    [anon_sym_PERCENT] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_SQUOTE] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_DOT] = ACTIONS(1783),
    [anon_sym_SLASH] = ACTIONS(1783),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_AT] = ACTIONS(1783),
    [anon_sym_BSLASH] = ACTIONS(1792),
    [anon_sym_CARET] = ACTIONS(1783),
    [anon_sym__] = ACTIONS(1783),
    [anon_sym_BQUOTE] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1783),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_RPAREN] = ACTIONS(1783),
    [sym__newline_token] = ACTIONS(1795),
    [sym_uri_autolink] = ACTIONS(1777),
    [sym_email_autolink] = ACTIONS(1777),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1798),
    [anon_sym_LT_QMARK] = ACTIONS(1801),
    [aux_sym__declaration_token1] = ACTIONS(1804),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1807),
    [sym__whitespace_ge_2] = ACTIONS(1810),
    [aux_sym__whitespace_token1] = ACTIONS(1813),
    [sym__word_no_digit] = ACTIONS(1777),
    [sym__digits] = ACTIONS(1777),
    [sym__code_span_start] = ACTIONS(1816),
    [sym__emphasis_open_star] = ACTIONS(1819),
    [sym__emphasis_open_underscore] = ACTIONS(1822),
    [sym__emphasis_close_underscore] = ACTIONS(1585),
    [sym__last_token_punctuation] = ACTIONS(1825),
    [sym__strikethrough_open] = ACTIONS(1827),
    [sym__latex_span_start] = ACTIONS(1830),
    [sym__unclosed_span] = ACTIONS(1777),
  },
  [97] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(122),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(122),
    [aux_sym__inline_no_underscore_no_link] = STATE(122),
    [sym__strikethrough_no_link] = STATE(122),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(122),
    [sym__emphasis_underscore_no_link] = STATE(633),
    [sym__strong_emphasis_underscore_no_link] = STATE(122),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(1833),
    [sym_entity_reference] = ACTIONS(1836),
    [sym_numeric_character_reference] = ACTIONS(1836),
    [anon_sym_LT] = ACTIONS(1839),
    [anon_sym_GT] = ACTIONS(1842),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_POUND] = ACTIONS(1842),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [anon_sym_PERCENT] = ACTIONS(1842),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_SQUOTE] = ACTIONS(1842),
    [anon_sym_STAR] = ACTIONS(1842),
    [anon_sym_PLUS] = ACTIONS(1842),
    [anon_sym_COMMA] = ACTIONS(1842),
    [anon_sym_DASH] = ACTIONS(1842),
    [anon_sym_DOT] = ACTIONS(1842),
    [anon_sym_SLASH] = ACTIONS(1842),
    [anon_sym_COLON] = ACTIONS(1842),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_EQ] = ACTIONS(1842),
    [anon_sym_QMARK] = ACTIONS(1842),
    [anon_sym_AT] = ACTIONS(1842),
    [anon_sym_BSLASH] = ACTIONS(1851),
    [anon_sym_CARET] = ACTIONS(1842),
    [anon_sym__] = ACTIONS(1842),
    [anon_sym_BQUOTE] = ACTIONS(1842),
    [anon_sym_LBRACE] = ACTIONS(1842),
    [anon_sym_PIPE] = ACTIONS(1842),
    [anon_sym_RBRACE] = ACTIONS(1842),
    [anon_sym_TILDE] = ACTIONS(1842),
    [anon_sym_LPAREN] = ACTIONS(1842),
    [anon_sym_RPAREN] = ACTIONS(1842),
    [sym__newline_token] = ACTIONS(1854),
    [sym_uri_autolink] = ACTIONS(1836),
    [sym_email_autolink] = ACTIONS(1836),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1857),
    [anon_sym_LT_QMARK] = ACTIONS(1860),
    [aux_sym__declaration_token1] = ACTIONS(1863),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1866),
    [sym__whitespace_ge_2] = ACTIONS(1869),
    [aux_sym__whitespace_token1] = ACTIONS(1872),
    [sym__word_no_digit] = ACTIONS(1836),
    [sym__digits] = ACTIONS(1836),
    [sym__code_span_start] = ACTIONS(1875),
    [sym__emphasis_open_star] = ACTIONS(1878),
    [sym__emphasis_open_underscore] = ACTIONS(1881),
    [sym__emphasis_close_star] = ACTIONS(1884),
    [sym__last_token_punctuation] = ACTIONS(1886),
    [sym__strikethrough_open] = ACTIONS(1888),
    [sym__latex_span_start] = ACTIONS(1891),
    [sym__unclosed_span] = ACTIONS(1836),
  },
  [98] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(107),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(107),
    [aux_sym__inline_no_star_no_link] = STATE(107),
    [sym__strikethrough_no_link] = STATE(107),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(107),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(107),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(1894),
    [sym_entity_reference] = ACTIONS(1897),
    [sym_numeric_character_reference] = ACTIONS(1897),
    [anon_sym_LT] = ACTIONS(1900),
    [anon_sym_GT] = ACTIONS(1903),
    [anon_sym_BANG] = ACTIONS(1906),
    [anon_sym_DQUOTE] = ACTIONS(1903),
    [anon_sym_POUND] = ACTIONS(1903),
    [anon_sym_DOLLAR] = ACTIONS(1903),
    [anon_sym_PERCENT] = ACTIONS(1903),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1903),
    [anon_sym_STAR] = ACTIONS(1903),
    [anon_sym_PLUS] = ACTIONS(1903),
    [anon_sym_COMMA] = ACTIONS(1903),
    [anon_sym_DASH] = ACTIONS(1903),
    [anon_sym_DOT] = ACTIONS(1903),
    [anon_sym_SLASH] = ACTIONS(1903),
    [anon_sym_COLON] = ACTIONS(1903),
    [anon_sym_SEMI] = ACTIONS(1903),
    [anon_sym_EQ] = ACTIONS(1903),
    [anon_sym_QMARK] = ACTIONS(1903),
    [anon_sym_AT] = ACTIONS(1903),
    [anon_sym_BSLASH] = ACTIONS(1912),
    [anon_sym_CARET] = ACTIONS(1903),
    [anon_sym__] = ACTIONS(1903),
    [anon_sym_BQUOTE] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1903),
    [anon_sym_PIPE] = ACTIONS(1903),
    [anon_sym_RBRACE] = ACTIONS(1903),
    [anon_sym_TILDE] = ACTIONS(1903),
    [anon_sym_LPAREN] = ACTIONS(1903),
    [anon_sym_RPAREN] = ACTIONS(1903),
    [sym__newline_token] = ACTIONS(1915),
    [sym_uri_autolink] = ACTIONS(1897),
    [sym_email_autolink] = ACTIONS(1897),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1918),
    [anon_sym_LT_QMARK] = ACTIONS(1921),
    [aux_sym__declaration_token1] = ACTIONS(1924),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1927),
    [sym__whitespace_ge_2] = ACTIONS(1930),
    [aux_sym__whitespace_token1] = ACTIONS(1933),
    [sym__word_no_digit] = ACTIONS(1897),
    [sym__digits] = ACTIONS(1897),
    [sym__code_span_start] = ACTIONS(1936),
    [sym__emphasis_open_star] = ACTIONS(1939),
    [sym__emphasis_open_underscore] = ACTIONS(1942),
    [sym__last_token_punctuation] = ACTIONS(1945),
    [sym__strikethrough_open] = ACTIONS(1947),
    [sym__strikethrough_close] = ACTIONS(1529),
    [sym__latex_span_start] = ACTIONS(1950),
    [sym__unclosed_span] = ACTIONS(1897),
  },
  [99] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(124),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(124),
    [aux_sym__inline_no_tilde_no_link] = STATE(124),
    [sym__strikethrough_no_link] = STATE(124),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(124),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(124),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(1953),
    [sym_entity_reference] = ACTIONS(1956),
    [sym_numeric_character_reference] = ACTIONS(1956),
    [anon_sym_LT] = ACTIONS(1959),
    [anon_sym_GT] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_DQUOTE] = ACTIONS(1962),
    [anon_sym_POUND] = ACTIONS(1962),
    [anon_sym_DOLLAR] = ACTIONS(1962),
    [anon_sym_PERCENT] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_SQUOTE] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(1962),
    [anon_sym_PLUS] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_DASH] = ACTIONS(1962),
    [anon_sym_DOT] = ACTIONS(1962),
    [anon_sym_SLASH] = ACTIONS(1962),
    [anon_sym_COLON] = ACTIONS(1962),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1962),
    [anon_sym_QMARK] = ACTIONS(1962),
    [anon_sym_AT] = ACTIONS(1962),
    [anon_sym_BSLASH] = ACTIONS(1971),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym__] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LBRACE] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1962),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [anon_sym_TILDE] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [sym__newline_token] = ACTIONS(1974),
    [sym_uri_autolink] = ACTIONS(1956),
    [sym_email_autolink] = ACTIONS(1956),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1977),
    [anon_sym_LT_QMARK] = ACTIONS(1980),
    [aux_sym__declaration_token1] = ACTIONS(1983),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1986),
    [sym__whitespace_ge_2] = ACTIONS(1989),
    [aux_sym__whitespace_token1] = ACTIONS(1992),
    [sym__word_no_digit] = ACTIONS(1956),
    [sym__digits] = ACTIONS(1956),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1998),
    [sym__emphasis_open_underscore] = ACTIONS(2001),
    [sym__emphasis_close_star] = ACTIONS(1884),
    [sym__last_token_punctuation] = ACTIONS(2004),
    [sym__strikethrough_open] = ACTIONS(2006),
    [sym__latex_span_start] = ACTIONS(2009),
    [sym__unclosed_span] = ACTIONS(1956),
  },
  [100] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(134),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(2012),
    [sym_numeric_character_reference] = ACTIONS(2012),
    [anon_sym_RBRACK] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(2012),
    [sym_email_autolink] = ACTIONS(2012),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2018),
    [anon_sym_LT_QMARK] = ACTIONS(2020),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2022),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(2012),
    [sym__digits] = ACTIONS(2012),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(2024),
    [sym__emphasis_open_underscore] = ACTIONS(2026),
    [sym__strikethrough_open] = ACTIONS(2028),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(2012),
  },
  [101] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__strikethrough_close] = ACTIONS(2046),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [102] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(102),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(102),
    [aux_sym__inline_no_star_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(102),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(102),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(102),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(2048),
    [sym_entity_reference] = ACTIONS(2051),
    [sym_numeric_character_reference] = ACTIONS(2051),
    [anon_sym_LT] = ACTIONS(2054),
    [anon_sym_GT] = ACTIONS(2057),
    [anon_sym_BANG] = ACTIONS(2060),
    [anon_sym_DQUOTE] = ACTIONS(2057),
    [anon_sym_POUND] = ACTIONS(2057),
    [anon_sym_DOLLAR] = ACTIONS(2057),
    [anon_sym_PERCENT] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2063),
    [anon_sym_SQUOTE] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(2057),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_DOT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2057),
    [anon_sym_COLON] = ACTIONS(2057),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_EQ] = ACTIONS(2057),
    [anon_sym_QMARK] = ACTIONS(2057),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_BSLASH] = ACTIONS(2066),
    [anon_sym_CARET] = ACTIONS(2057),
    [anon_sym__] = ACTIONS(2057),
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_PIPE] = ACTIONS(2057),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2057),
    [anon_sym_LPAREN] = ACTIONS(2057),
    [anon_sym_RPAREN] = ACTIONS(2057),
    [sym__newline_token] = ACTIONS(2069),
    [sym_uri_autolink] = ACTIONS(2051),
    [sym_email_autolink] = ACTIONS(2051),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2072),
    [anon_sym_LT_QMARK] = ACTIONS(2075),
    [aux_sym__declaration_token1] = ACTIONS(2078),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2081),
    [sym__whitespace_ge_2] = ACTIONS(2084),
    [aux_sym__whitespace_token1] = ACTIONS(2087),
    [sym__word_no_digit] = ACTIONS(2051),
    [sym__digits] = ACTIONS(2051),
    [sym__code_span_start] = ACTIONS(2090),
    [sym__emphasis_open_star] = ACTIONS(2093),
    [sym__emphasis_open_underscore] = ACTIONS(2096),
    [sym__emphasis_close_star] = ACTIONS(2099),
    [sym__strikethrough_open] = ACTIONS(2101),
    [sym__latex_span_start] = ACTIONS(2104),
    [sym__unclosed_span] = ACTIONS(2051),
  },
  [103] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(102),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(102),
    [aux_sym__inline_no_star_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(102),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(102),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(102),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__emphasis_close_star] = ACTIONS(2121),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [104] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(129),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(129),
    [aux_sym__inline_no_underscore_no_link] = STATE(129),
    [sym__strikethrough_no_link] = STATE(129),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(129),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(129),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__emphasis_close_underscore] = ACTIONS(2139),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [105] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__strikethrough_close] = ACTIONS(2143),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [106] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(134),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(2012),
    [sym_numeric_character_reference] = ACTIONS(2012),
    [anon_sym_RBRACK] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(2012),
    [sym_email_autolink] = ACTIONS(2012),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2018),
    [anon_sym_LT_QMARK] = ACTIONS(2020),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2022),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(2012),
    [sym__digits] = ACTIONS(2012),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(2024),
    [sym__emphasis_open_underscore] = ACTIONS(2026),
    [sym__strikethrough_open] = ACTIONS(2028),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(2012),
  },
  [107] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(102),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(102),
    [aux_sym__inline_no_star_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(102),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(102),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(102),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__emphasis_close_star] = ACTIONS(2147),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [108] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__strikethrough_close] = ACTIONS(2149),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [109] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__strikethrough_close] = ACTIONS(2151),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [110] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(129),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(129),
    [aux_sym__inline_no_underscore_no_link] = STATE(129),
    [sym__strikethrough_no_link] = STATE(129),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(129),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(129),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__emphasis_close_underscore] = ACTIONS(2153),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [111] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(129),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(129),
    [aux_sym__inline_no_underscore_no_link] = STATE(129),
    [sym__strikethrough_no_link] = STATE(129),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(129),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(129),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__emphasis_close_underscore] = ACTIONS(2155),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [112] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(102),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(102),
    [aux_sym__inline_no_star_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(102),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(102),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(102),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__emphasis_close_star] = ACTIONS(2157),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [113] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(2159),
    [sym_entity_reference] = ACTIONS(2162),
    [sym_numeric_character_reference] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2165),
    [anon_sym_GT] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(2171),
    [anon_sym_DQUOTE] = ACTIONS(2168),
    [anon_sym_POUND] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2168),
    [anon_sym_PERCENT] = ACTIONS(2168),
    [anon_sym_AMP] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_COMMA] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_DOT] = ACTIONS(2168),
    [anon_sym_SLASH] = ACTIONS(2168),
    [anon_sym_COLON] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(2168),
    [anon_sym_AT] = ACTIONS(2168),
    [anon_sym_BSLASH] = ACTIONS(2177),
    [anon_sym_CARET] = ACTIONS(2168),
    [anon_sym__] = ACTIONS(2168),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_RBRACE] = ACTIONS(2168),
    [anon_sym_TILDE] = ACTIONS(2168),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [sym__newline_token] = ACTIONS(2180),
    [sym_uri_autolink] = ACTIONS(2162),
    [sym_email_autolink] = ACTIONS(2162),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2183),
    [anon_sym_LT_QMARK] = ACTIONS(2186),
    [aux_sym__declaration_token1] = ACTIONS(2189),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2192),
    [sym__whitespace_ge_2] = ACTIONS(2195),
    [aux_sym__whitespace_token1] = ACTIONS(2198),
    [sym__word_no_digit] = ACTIONS(2162),
    [sym__digits] = ACTIONS(2162),
    [sym__code_span_start] = ACTIONS(2201),
    [sym__emphasis_open_star] = ACTIONS(2204),
    [sym__emphasis_open_underscore] = ACTIONS(2207),
    [sym__strikethrough_open] = ACTIONS(2210),
    [sym__strikethrough_close] = ACTIONS(2213),
    [sym__latex_span_start] = ACTIONS(2215),
    [sym__unclosed_span] = ACTIONS(2162),
  },
  [114] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(134),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(2012),
    [sym_numeric_character_reference] = ACTIONS(2012),
    [anon_sym_RBRACK] = ACTIONS(2218),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(2012),
    [sym_email_autolink] = ACTIONS(2012),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2018),
    [anon_sym_LT_QMARK] = ACTIONS(2020),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2022),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(2012),
    [sym__digits] = ACTIONS(2012),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(2024),
    [sym__emphasis_open_underscore] = ACTIONS(2026),
    [sym__strikethrough_open] = ACTIONS(2028),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(2012),
  },
  [115] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__strikethrough_close] = ACTIONS(2220),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [116] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(129),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(129),
    [aux_sym__inline_no_underscore_no_link] = STATE(129),
    [sym__strikethrough_no_link] = STATE(129),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(129),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(129),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__emphasis_close_underscore] = ACTIONS(2222),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [117] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(129),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(129),
    [aux_sym__inline_no_underscore_no_link] = STATE(129),
    [sym__strikethrough_no_link] = STATE(129),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(129),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(129),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__emphasis_close_underscore] = ACTIONS(2224),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [118] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__strikethrough_close] = ACTIONS(2226),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [119] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(102),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(102),
    [aux_sym__inline_no_star_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(102),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(102),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(102),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__emphasis_close_star] = ACTIONS(2228),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [120] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__strikethrough_close] = ACTIONS(2230),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [121] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(135),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(135),
    [aux_sym__inline_no_star_no_link] = STATE(135),
    [sym__strikethrough_no_link] = STATE(135),
    [sym__emphasis_star_no_link] = STATE(602),
    [sym__strong_emphasis_star_no_link] = STATE(135),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(135),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__last_token_punctuation] = ACTIONS(2232),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [122] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(129),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(129),
    [aux_sym__inline_no_underscore_no_link] = STATE(129),
    [sym__strikethrough_no_link] = STATE(129),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(129),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(129),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__emphasis_close_underscore] = ACTIONS(2234),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [123] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(102),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(102),
    [aux_sym__inline_no_star_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(102),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(102),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(102),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__emphasis_close_star] = ACTIONS(2236),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [124] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__strikethrough_close] = ACTIONS(2238),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [125] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(102),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(102),
    [aux_sym__inline_no_star_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(102),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(102),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(102),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__emphasis_close_star] = ACTIONS(2240),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [126] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(117),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(117),
    [aux_sym__inline_no_underscore_no_link] = STATE(117),
    [sym__strikethrough_no_link] = STATE(117),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(117),
    [sym__emphasis_underscore_no_link] = STATE(607),
    [sym__strong_emphasis_underscore_no_link] = STATE(117),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__last_token_punctuation] = ACTIONS(2242),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [127] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(102),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(102),
    [aux_sym__inline_no_star_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(102),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(102),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(102),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__emphasis_close_star] = ACTIONS(2244),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [128] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(129),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(129),
    [aux_sym__inline_no_underscore_no_link] = STATE(129),
    [sym__strikethrough_no_link] = STATE(129),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(129),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(129),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__emphasis_close_underscore] = ACTIONS(2246),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [129] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(129),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(129),
    [aux_sym__inline_no_underscore_no_link] = STATE(129),
    [sym__strikethrough_no_link] = STATE(129),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(129),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(129),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(2248),
    [sym_entity_reference] = ACTIONS(2251),
    [sym_numeric_character_reference] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2257),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2257),
    [anon_sym_POUND] = ACTIONS(2257),
    [anon_sym_DOLLAR] = ACTIONS(2257),
    [anon_sym_PERCENT] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2263),
    [anon_sym_SQUOTE] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_PLUS] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2257),
    [anon_sym_DASH] = ACTIONS(2257),
    [anon_sym_DOT] = ACTIONS(2257),
    [anon_sym_SLASH] = ACTIONS(2257),
    [anon_sym_COLON] = ACTIONS(2257),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_EQ] = ACTIONS(2257),
    [anon_sym_QMARK] = ACTIONS(2257),
    [anon_sym_AT] = ACTIONS(2257),
    [anon_sym_BSLASH] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(2257),
    [anon_sym__] = ACTIONS(2257),
    [anon_sym_BQUOTE] = ACTIONS(2257),
    [anon_sym_LBRACE] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(2257),
    [anon_sym_RBRACE] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_LPAREN] = ACTIONS(2257),
    [anon_sym_RPAREN] = ACTIONS(2257),
    [sym__newline_token] = ACTIONS(2269),
    [sym_uri_autolink] = ACTIONS(2251),
    [sym_email_autolink] = ACTIONS(2251),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2272),
    [anon_sym_LT_QMARK] = ACTIONS(2275),
    [aux_sym__declaration_token1] = ACTIONS(2278),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2281),
    [sym__whitespace_ge_2] = ACTIONS(2284),
    [aux_sym__whitespace_token1] = ACTIONS(2287),
    [sym__word_no_digit] = ACTIONS(2251),
    [sym__digits] = ACTIONS(2251),
    [sym__code_span_start] = ACTIONS(2290),
    [sym__emphasis_open_star] = ACTIONS(2293),
    [sym__emphasis_open_underscore] = ACTIONS(2296),
    [sym__emphasis_close_underscore] = ACTIONS(2299),
    [sym__strikethrough_open] = ACTIONS(2301),
    [sym__latex_span_start] = ACTIONS(2304),
    [sym__unclosed_span] = ACTIONS(2251),
  },
  [130] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(129),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(129),
    [aux_sym__inline_no_underscore_no_link] = STATE(129),
    [sym__strikethrough_no_link] = STATE(129),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(129),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(129),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__emphasis_close_underscore] = ACTIONS(2307),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [131] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(134),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(2012),
    [sym_numeric_character_reference] = ACTIONS(2012),
    [anon_sym_RBRACK] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(2012),
    [sym_email_autolink] = ACTIONS(2012),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2018),
    [anon_sym_LT_QMARK] = ACTIONS(2020),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2022),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(2012),
    [sym__digits] = ACTIONS(2012),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(2024),
    [sym__emphasis_open_underscore] = ACTIONS(2026),
    [sym__strikethrough_open] = ACTIONS(2028),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(2012),
  },
  [132] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(134),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(2012),
    [sym_numeric_character_reference] = ACTIONS(2012),
    [anon_sym_RBRACK] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(2012),
    [sym_email_autolink] = ACTIONS(2012),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2018),
    [anon_sym_LT_QMARK] = ACTIONS(2020),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2022),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(2012),
    [sym__digits] = ACTIONS(2012),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(2024),
    [sym__emphasis_open_underscore] = ACTIONS(2026),
    [sym__strikethrough_open] = ACTIONS(2028),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(2012),
  },
  [133] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(118),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(118),
    [aux_sym__inline_no_tilde_no_link] = STATE(118),
    [sym__strikethrough_no_link] = STATE(118),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(118),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(118),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__last_token_punctuation] = ACTIONS(2313),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [134] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_latex_block] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(621),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_link] = STATE(621),
    [aux_sym__inline_no_link] = STATE(134),
    [sym__strikethrough_no_link] = STATE(621),
    [sym__emphasis_star_no_link] = STATE(625),
    [sym__strong_emphasis_star_no_link] = STATE(621),
    [sym__emphasis_underscore_no_link] = STATE(625),
    [sym__strong_emphasis_underscore_no_link] = STATE(621),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(2315),
    [sym_entity_reference] = ACTIONS(2318),
    [sym_numeric_character_reference] = ACTIONS(2318),
    [anon_sym_RBRACK] = ACTIONS(2321),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2326),
    [anon_sym_BANG] = ACTIONS(2329),
    [anon_sym_DQUOTE] = ACTIONS(2326),
    [anon_sym_POUND] = ACTIONS(2326),
    [anon_sym_DOLLAR] = ACTIONS(2326),
    [anon_sym_PERCENT] = ACTIONS(2326),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_COMMA] = ACTIONS(2326),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_DOT] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2326),
    [anon_sym_COLON] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2326),
    [anon_sym_EQ] = ACTIONS(2326),
    [anon_sym_QMARK] = ACTIONS(2326),
    [anon_sym_AT] = ACTIONS(2326),
    [anon_sym_BSLASH] = ACTIONS(2335),
    [anon_sym_CARET] = ACTIONS(2326),
    [anon_sym__] = ACTIONS(2326),
    [anon_sym_BQUOTE] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_PIPE] = ACTIONS(2326),
    [anon_sym_RBRACE] = ACTIONS(2326),
    [anon_sym_TILDE] = ACTIONS(2326),
    [anon_sym_LPAREN] = ACTIONS(2326),
    [anon_sym_RPAREN] = ACTIONS(2326),
    [sym__newline_token] = ACTIONS(2338),
    [sym_uri_autolink] = ACTIONS(2318),
    [sym_email_autolink] = ACTIONS(2318),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2341),
    [anon_sym_LT_QMARK] = ACTIONS(2344),
    [aux_sym__declaration_token1] = ACTIONS(2347),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2350),
    [sym__whitespace_ge_2] = ACTIONS(2353),
    [aux_sym__whitespace_token1] = ACTIONS(2356),
    [sym__word_no_digit] = ACTIONS(2318),
    [sym__digits] = ACTIONS(2318),
    [sym__code_span_start] = ACTIONS(2359),
    [sym__emphasis_open_star] = ACTIONS(2362),
    [sym__emphasis_open_underscore] = ACTIONS(2365),
    [sym__strikethrough_open] = ACTIONS(2368),
    [sym__latex_span_start] = ACTIONS(2371),
    [sym__unclosed_span] = ACTIONS(2318),
  },
  [135] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(102),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(102),
    [aux_sym__inline_no_star_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(102),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(102),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(102),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__emphasis_close_star] = ACTIONS(2374),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [136] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(105),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(105),
    [aux_sym__inline_no_tilde_no_link] = STATE(105),
    [sym__strikethrough_no_link] = STATE(105),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(105),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(105),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [137] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(110),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(110),
    [aux_sym__inline_no_underscore_no_link] = STATE(110),
    [sym__strikethrough_no_link] = STATE(110),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(110),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(110),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [138] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(120),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(120),
    [aux_sym__inline_no_tilde_no_link] = STATE(120),
    [sym__strikethrough_no_link] = STATE(120),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(120),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(120),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [139] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(108),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(108),
    [aux_sym__inline_no_tilde_no_link] = STATE(108),
    [sym__strikethrough_no_link] = STATE(108),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(108),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(108),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [140] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(130),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(130),
    [aux_sym__inline_no_underscore_no_link] = STATE(130),
    [sym__strikethrough_no_link] = STATE(130),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(130),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(130),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [141] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(111),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(111),
    [aux_sym__inline_no_underscore_no_link] = STATE(111),
    [sym__strikethrough_no_link] = STATE(111),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(111),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(111),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [142] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(112),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(112),
    [aux_sym__inline_no_star_no_link] = STATE(112),
    [sym__strikethrough_no_link] = STATE(112),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(112),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(112),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [143] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_latex_block] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__inline_base] = STATE(109),
    [sym__text_base] = STATE(158),
    [sym__inline_element_no_tilde_no_link] = STATE(109),
    [aux_sym__inline_no_tilde_no_link] = STATE(109),
    [sym__strikethrough_no_link] = STATE(109),
    [sym__emphasis_star_no_link] = STATE(635),
    [sym__strong_emphasis_star_no_link] = STATE(109),
    [sym__emphasis_underscore_no_link] = STATE(635),
    [sym__strong_emphasis_underscore_no_link] = STATE(109),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2030),
    [sym_numeric_character_reference] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2030),
    [sym_email_autolink] = ACTIONS(2030),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2030),
    [sym__digits] = ACTIONS(2030),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2040),
    [sym__emphasis_open_underscore] = ACTIONS(2042),
    [sym__strikethrough_open] = ACTIONS(2044),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2030),
  },
  [144] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(125),
    [aux_sym__inline_no_star_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [145] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(103),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(103),
    [aux_sym__inline_no_star_no_link] = STATE(103),
    [sym__strikethrough_no_link] = STATE(103),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(103),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(103),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [146] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_latex_block] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__inline_base] = STATE(104),
    [sym__text_base] = STATE(164),
    [sym__inline_element_no_underscore_no_link] = STATE(104),
    [aux_sym__inline_no_underscore_no_link] = STATE(104),
    [sym__strikethrough_no_link] = STATE(104),
    [sym__emphasis_star_no_link] = STATE(642),
    [sym__strong_emphasis_star_no_link] = STATE(104),
    [sym__emphasis_underscore_no_link] = STATE(642),
    [sym__strong_emphasis_underscore_no_link] = STATE(104),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2125),
    [sym_numeric_character_reference] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2125),
    [sym_email_autolink] = ACTIONS(2125),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2125),
    [sym__digits] = ACTIONS(2125),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2135),
    [sym__emphasis_open_underscore] = ACTIONS(2137),
    [sym__strikethrough_open] = ACTIONS(2141),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2125),
  },
  [147] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_latex_block] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__inline_base] = STATE(127),
    [sym__text_base] = STATE(163),
    [sym__inline_element_no_star_no_link] = STATE(127),
    [aux_sym__inline_no_star_no_link] = STATE(127),
    [sym__strikethrough_no_link] = STATE(127),
    [sym__emphasis_star_no_link] = STATE(643),
    [sym__strong_emphasis_star_no_link] = STATE(127),
    [sym__emphasis_underscore_no_link] = STATE(643),
    [sym__strong_emphasis_underscore_no_link] = STATE(127),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2107),
    [sym_numeric_character_reference] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2107),
    [sym_email_autolink] = ACTIONS(2107),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2107),
    [sym__digits] = ACTIONS(2107),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2117),
    [sym__emphasis_open_underscore] = ACTIONS(2119),
    [sym__strikethrough_open] = ACTIONS(2123),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2107),
  },
  [148] = {
    [sym_backslash_escape] = STATE(148),
    [sym_code_span] = STATE(148),
    [sym_latex_block] = STATE(148),
    [sym_image] = STATE(148),
    [sym__image_inline_link] = STATE(266),
    [sym__image_shortcut_link] = STATE(266),
    [sym__image_full_reference_link] = STATE(266),
    [sym__image_collapsed_reference_link] = STATE(266),
    [sym__image_description] = STATE(1124),
    [sym__image_description_non_empty] = STATE(267),
    [sym__html_tag] = STATE(272),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(148),
    [sym__whitespace] = STATE(148),
    [sym__word] = STATE(148),
    [sym__soft_line_break] = STATE(148),
    [sym__text_base] = STATE(148),
    [aux_sym__inline_base_repeat1] = STATE(148),
    [ts_builtin_sym_end] = ACTIONS(2376),
    [sym__backslash_escape] = ACTIONS(2378),
    [sym_entity_reference] = ACTIONS(2381),
    [sym_numeric_character_reference] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_RBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_GT] = ACTIONS(2387),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2387),
    [anon_sym_POUND] = ACTIONS(2387),
    [anon_sym_DOLLAR] = ACTIONS(2387),
    [anon_sym_PERCENT] = ACTIONS(2387),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_SQUOTE] = ACTIONS(2387),
    [anon_sym_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2387),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_DASH] = ACTIONS(2387),
    [anon_sym_DOT] = ACTIONS(2387),
    [anon_sym_SLASH] = ACTIONS(2387),
    [anon_sym_COLON] = ACTIONS(2387),
    [anon_sym_SEMI] = ACTIONS(2387),
    [anon_sym_EQ] = ACTIONS(2387),
    [anon_sym_QMARK] = ACTIONS(2387),
    [anon_sym_AT] = ACTIONS(2387),
    [anon_sym_BSLASH] = ACTIONS(2396),
    [anon_sym_CARET] = ACTIONS(2387),
    [anon_sym__] = ACTIONS(2387),
    [anon_sym_BQUOTE] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2387),
    [anon_sym_PIPE] = ACTIONS(2387),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_TILDE] = ACTIONS(2387),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [sym__newline_token] = ACTIONS(2399),
    [sym_uri_autolink] = ACTIONS(2381),
    [sym_email_autolink] = ACTIONS(2381),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2402),
    [anon_sym_LT_QMARK] = ACTIONS(2405),
    [aux_sym__declaration_token1] = ACTIONS(2408),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2411),
    [sym__whitespace_ge_2] = ACTIONS(2414),
    [aux_sym__whitespace_token1] = ACTIONS(2417),
    [sym__word_no_digit] = ACTIONS(2381),
    [sym__digits] = ACTIONS(2381),
    [sym__code_span_start] = ACTIONS(2420),
    [sym__emphasis_open_star] = ACTIONS(2376),
    [sym__emphasis_open_underscore] = ACTIONS(2376),
    [sym__strikethrough_open] = ACTIONS(2376),
    [sym__latex_span_start] = ACTIONS(2423),
    [sym__unclosed_span] = ACTIONS(2381),
  },
  [149] = {
    [sym_backslash_escape] = STATE(151),
    [sym_code_span] = STATE(151),
    [sym_latex_block] = STATE(151),
    [sym_image] = STATE(151),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(151),
    [sym__whitespace] = STATE(151),
    [sym__word] = STATE(151),
    [sym__soft_line_break] = STATE(151),
    [sym__text_base] = STATE(151),
    [aux_sym__inline_base_repeat1] = STATE(151),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2426),
    [sym_numeric_character_reference] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2426),
    [sym_email_autolink] = ACTIONS(2426),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(660),
    [anon_sym_LT_QMARK] = ACTIONS(662),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(666),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2426),
    [sym__digits] = ACTIONS(2426),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2428),
    [sym__emphasis_open_underscore] = ACTIONS(2428),
    [sym__emphasis_close_star] = ACTIONS(2428),
    [sym__strikethrough_open] = ACTIONS(2428),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2426),
  },
  [150] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym_latex_block] = STATE(150),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__text_base] = STATE(150),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(2430),
    [sym_entity_reference] = ACTIONS(2433),
    [sym_numeric_character_reference] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_RBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2439),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [anon_sym_POUND] = ACTIONS(2439),
    [anon_sym_DOLLAR] = ACTIONS(2439),
    [anon_sym_PERCENT] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2439),
    [anon_sym_PLUS] = ACTIONS(2439),
    [anon_sym_COMMA] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2439),
    [anon_sym_DOT] = ACTIONS(2439),
    [anon_sym_SLASH] = ACTIONS(2439),
    [anon_sym_COLON] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym_EQ] = ACTIONS(2439),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_AT] = ACTIONS(2439),
    [anon_sym_BSLASH] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym__] = ACTIONS(2439),
    [anon_sym_BQUOTE] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_PIPE] = ACTIONS(2439),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_RPAREN] = ACTIONS(2439),
    [sym__newline_token] = ACTIONS(2451),
    [sym_uri_autolink] = ACTIONS(2433),
    [sym_email_autolink] = ACTIONS(2433),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2454),
    [anon_sym_LT_QMARK] = ACTIONS(2457),
    [aux_sym__declaration_token1] = ACTIONS(2460),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2463),
    [sym__whitespace_ge_2] = ACTIONS(2466),
    [aux_sym__whitespace_token1] = ACTIONS(2469),
    [sym__word_no_digit] = ACTIONS(2433),
    [sym__digits] = ACTIONS(2433),
    [sym__code_span_start] = ACTIONS(2472),
    [sym__emphasis_open_star] = ACTIONS(2376),
    [sym__emphasis_open_underscore] = ACTIONS(2376),
    [sym__strikethrough_open] = ACTIONS(2376),
    [sym__strikethrough_close] = ACTIONS(2376),
    [sym__latex_span_start] = ACTIONS(2475),
    [sym__unclosed_span] = ACTIONS(2433),
  },
  [151] = {
    [sym_backslash_escape] = STATE(151),
    [sym_code_span] = STATE(151),
    [sym_latex_block] = STATE(151),
    [sym_image] = STATE(151),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(347),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(151),
    [sym__whitespace] = STATE(151),
    [sym__word] = STATE(151),
    [sym__soft_line_break] = STATE(151),
    [sym__text_base] = STATE(151),
    [aux_sym__inline_base_repeat1] = STATE(151),
    [sym__backslash_escape] = ACTIONS(2478),
    [sym_entity_reference] = ACTIONS(2481),
    [sym_numeric_character_reference] = ACTIONS(2481),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_RBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2487),
    [anon_sym_POUND] = ACTIONS(2487),
    [anon_sym_DOLLAR] = ACTIONS(2487),
    [anon_sym_PERCENT] = ACTIONS(2487),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_SQUOTE] = ACTIONS(2487),
    [anon_sym_STAR] = ACTIONS(2487),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_SLASH] = ACTIONS(2487),
    [anon_sym_COLON] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_QMARK] = ACTIONS(2487),
    [anon_sym_AT] = ACTIONS(2487),
    [anon_sym_BSLASH] = ACTIONS(2496),
    [anon_sym_CARET] = ACTIONS(2487),
    [anon_sym__] = ACTIONS(2487),
    [anon_sym_BQUOTE] = ACTIONS(2487),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_RBRACE] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_RPAREN] = ACTIONS(2487),
    [sym__newline_token] = ACTIONS(2499),
    [sym_uri_autolink] = ACTIONS(2481),
    [sym_email_autolink] = ACTIONS(2481),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2502),
    [anon_sym_LT_QMARK] = ACTIONS(2505),
    [aux_sym__declaration_token1] = ACTIONS(2508),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2511),
    [sym__whitespace_ge_2] = ACTIONS(2514),
    [aux_sym__whitespace_token1] = ACTIONS(2517),
    [sym__word_no_digit] = ACTIONS(2481),
    [sym__digits] = ACTIONS(2481),
    [sym__code_span_start] = ACTIONS(2520),
    [sym__emphasis_open_star] = ACTIONS(2376),
    [sym__emphasis_open_underscore] = ACTIONS(2376),
    [sym__emphasis_close_star] = ACTIONS(2376),
    [sym__strikethrough_open] = ACTIONS(2376),
    [sym__latex_span_start] = ACTIONS(2523),
    [sym__unclosed_span] = ACTIONS(2481),
  },
  [152] = {
    [sym_backslash_escape] = STATE(152),
    [sym_code_span] = STATE(152),
    [sym_latex_block] = STATE(152),
    [sym_image] = STATE(152),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(152),
    [sym__whitespace] = STATE(152),
    [sym__word] = STATE(152),
    [sym__soft_line_break] = STATE(152),
    [sym__text_base] = STATE(152),
    [aux_sym__inline_base_repeat1] = STATE(152),
    [sym__backslash_escape] = ACTIONS(2526),
    [sym_entity_reference] = ACTIONS(2529),
    [sym_numeric_character_reference] = ACTIONS(2529),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_RBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2532),
    [anon_sym_GT] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(2535),
    [anon_sym_POUND] = ACTIONS(2535),
    [anon_sym_DOLLAR] = ACTIONS(2535),
    [anon_sym_PERCENT] = ACTIONS(2535),
    [anon_sym_AMP] = ACTIONS(2541),
    [anon_sym_SQUOTE] = ACTIONS(2535),
    [anon_sym_STAR] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_DOT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_COLON] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(2535),
    [anon_sym_QMARK] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2535),
    [anon_sym_BSLASH] = ACTIONS(2544),
    [anon_sym_CARET] = ACTIONS(2535),
    [anon_sym__] = ACTIONS(2535),
    [anon_sym_BQUOTE] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2535),
    [anon_sym_PIPE] = ACTIONS(2535),
    [anon_sym_RBRACE] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_RPAREN] = ACTIONS(2535),
    [sym__newline_token] = ACTIONS(2547),
    [sym_uri_autolink] = ACTIONS(2529),
    [sym_email_autolink] = ACTIONS(2529),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2550),
    [anon_sym_LT_QMARK] = ACTIONS(2553),
    [aux_sym__declaration_token1] = ACTIONS(2556),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2559),
    [sym__whitespace_ge_2] = ACTIONS(2562),
    [aux_sym__whitespace_token1] = ACTIONS(2565),
    [sym__word_no_digit] = ACTIONS(2529),
    [sym__digits] = ACTIONS(2529),
    [sym__code_span_start] = ACTIONS(2568),
    [sym__emphasis_open_star] = ACTIONS(2376),
    [sym__emphasis_open_underscore] = ACTIONS(2376),
    [sym__emphasis_close_underscore] = ACTIONS(2376),
    [sym__strikethrough_open] = ACTIONS(2376),
    [sym__latex_span_start] = ACTIONS(2571),
    [sym__unclosed_span] = ACTIONS(2529),
  },
  [153] = {
    [sym_backslash_escape] = STATE(152),
    [sym_code_span] = STATE(152),
    [sym_latex_block] = STATE(152),
    [sym_image] = STATE(152),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(435),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(152),
    [sym__whitespace] = STATE(152),
    [sym__word] = STATE(152),
    [sym__soft_line_break] = STATE(152),
    [sym__text_base] = STATE(152),
    [aux_sym__inline_base_repeat1] = STATE(152),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2574),
    [sym_numeric_character_reference] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2574),
    [sym_email_autolink] = ACTIONS(2574),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(704),
    [anon_sym_LT_QMARK] = ACTIONS(706),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(710),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2574),
    [sym__digits] = ACTIONS(2574),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2428),
    [sym__emphasis_open_underscore] = ACTIONS(2428),
    [sym__emphasis_close_underscore] = ACTIONS(2428),
    [sym__strikethrough_open] = ACTIONS(2428),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2574),
  },
  [154] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym_latex_block] = STATE(150),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(504),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__text_base] = STATE(150),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2576),
    [sym_numeric_character_reference] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2576),
    [sym_email_autolink] = ACTIONS(2576),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(748),
    [anon_sym_LT_QMARK] = ACTIONS(750),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(754),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2576),
    [sym__digits] = ACTIONS(2576),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2428),
    [sym__emphasis_open_underscore] = ACTIONS(2428),
    [sym__strikethrough_open] = ACTIONS(2428),
    [sym__strikethrough_close] = ACTIONS(2428),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2576),
  },
  [155] = {
    [sym_backslash_escape] = STATE(148),
    [sym_code_span] = STATE(148),
    [sym_latex_block] = STATE(148),
    [sym_image] = STATE(148),
    [sym__image_inline_link] = STATE(266),
    [sym__image_shortcut_link] = STATE(266),
    [sym__image_full_reference_link] = STATE(266),
    [sym__image_collapsed_reference_link] = STATE(266),
    [sym__image_description] = STATE(1124),
    [sym__image_description_non_empty] = STATE(267),
    [sym__html_tag] = STATE(272),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(148),
    [sym__whitespace] = STATE(148),
    [sym__word] = STATE(148),
    [sym__soft_line_break] = STATE(148),
    [sym__text_base] = STATE(148),
    [aux_sym__inline_base_repeat1] = STATE(148),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(2578),
    [sym_numeric_character_reference] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(2578),
    [sym_email_autolink] = ACTIONS(2578),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(2578),
    [sym__digits] = ACTIONS(2578),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(2428),
    [sym__emphasis_open_underscore] = ACTIONS(2428),
    [sym__strikethrough_open] = ACTIONS(2428),
    [sym__latex_span_start] = ACTIONS(45),
    [sym__unclosed_span] = ACTIONS(2578),
  },
  [156] = {
    [sym_backslash_escape] = STATE(156),
    [sym_code_span] = STATE(156),
    [sym_latex_block] = STATE(156),
    [sym_image] = STATE(156),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(156),
    [sym__whitespace] = STATE(156),
    [sym__word] = STATE(156),
    [sym__soft_line_break] = STATE(156),
    [sym__text_base] = STATE(156),
    [aux_sym__inline_base_repeat1] = STATE(156),
    [sym__backslash_escape] = ACTIONS(2580),
    [sym_entity_reference] = ACTIONS(2583),
    [sym_numeric_character_reference] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_RBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_DQUOTE] = ACTIONS(2589),
    [anon_sym_POUND] = ACTIONS(2589),
    [anon_sym_DOLLAR] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2589),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_BSLASH] = ACTIONS(2598),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym__] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_TILDE] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2589),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [sym__newline_token] = ACTIONS(2601),
    [sym_uri_autolink] = ACTIONS(2583),
    [sym_email_autolink] = ACTIONS(2583),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2604),
    [anon_sym_LT_QMARK] = ACTIONS(2607),
    [aux_sym__declaration_token1] = ACTIONS(2610),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2613),
    [sym__whitespace_ge_2] = ACTIONS(2616),
    [aux_sym__whitespace_token1] = ACTIONS(2619),
    [sym__word_no_digit] = ACTIONS(2583),
    [sym__digits] = ACTIONS(2583),
    [sym__code_span_start] = ACTIONS(2622),
    [sym__emphasis_open_star] = ACTIONS(2376),
    [sym__emphasis_open_underscore] = ACTIONS(2376),
    [sym__strikethrough_open] = ACTIONS(2376),
    [sym__latex_span_start] = ACTIONS(2625),
    [sym__unclosed_span] = ACTIONS(2583),
  },
  [157] = {
    [sym_backslash_escape] = STATE(156),
    [sym_code_span] = STATE(156),
    [sym_latex_block] = STATE(156),
    [sym_image] = STATE(156),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(539),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(156),
    [sym__whitespace] = STATE(156),
    [sym__word] = STATE(156),
    [sym__soft_line_break] = STATE(156),
    [sym__text_base] = STATE(156),
    [aux_sym__inline_base_repeat1] = STATE(156),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(2628),
    [sym_numeric_character_reference] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(2628),
    [sym_email_autolink] = ACTIONS(2628),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1122),
    [anon_sym_LT_QMARK] = ACTIONS(1124),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1128),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(2628),
    [sym__digits] = ACTIONS(2628),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(2428),
    [sym__emphasis_open_underscore] = ACTIONS(2428),
    [sym__strikethrough_open] = ACTIONS(2428),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(2628),
  },
  [158] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_latex_block] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__text_base] = STATE(161),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(728),
    [sym_entity_reference] = ACTIONS(2630),
    [sym_numeric_character_reference] = ACTIONS(2630),
    [anon_sym_LT] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(738),
    [anon_sym_DOLLAR] = ACTIONS(738),
    [anon_sym_PERCENT] = ACTIONS(738),
    [anon_sym_AMP] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_DOT] = ACTIONS(738),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_COLON] = ACTIONS(738),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(738),
    [anon_sym_QMARK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_BSLASH] = ACTIONS(744),
    [anon_sym_CARET] = ACTIONS(738),
    [anon_sym__] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(738),
    [anon_sym_RPAREN] = ACTIONS(738),
    [sym__newline_token] = ACTIONS(746),
    [sym_uri_autolink] = ACTIONS(2630),
    [sym_email_autolink] = ACTIONS(2630),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2034),
    [anon_sym_LT_QMARK] = ACTIONS(2036),
    [aux_sym__declaration_token1] = ACTIONS(752),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2038),
    [sym__whitespace_ge_2] = ACTIONS(756),
    [aux_sym__whitespace_token1] = ACTIONS(758),
    [sym__word_no_digit] = ACTIONS(2630),
    [sym__digits] = ACTIONS(2630),
    [sym__code_span_start] = ACTIONS(760),
    [sym__emphasis_open_star] = ACTIONS(2428),
    [sym__emphasis_open_underscore] = ACTIONS(2428),
    [sym__strikethrough_open] = ACTIONS(2428),
    [sym__strikethrough_close] = ACTIONS(2428),
    [sym__latex_span_start] = ACTIONS(770),
    [sym__unclosed_span] = ACTIONS(2630),
  },
  [159] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_latex_block] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__text_base] = STATE(159),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(2526),
    [sym_entity_reference] = ACTIONS(2632),
    [sym_numeric_character_reference] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2532),
    [anon_sym_GT] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_DQUOTE] = ACTIONS(2535),
    [anon_sym_POUND] = ACTIONS(2535),
    [anon_sym_DOLLAR] = ACTIONS(2535),
    [anon_sym_PERCENT] = ACTIONS(2535),
    [anon_sym_AMP] = ACTIONS(2541),
    [anon_sym_SQUOTE] = ACTIONS(2535),
    [anon_sym_STAR] = ACTIONS(2535),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_DOT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [anon_sym_COLON] = ACTIONS(2535),
    [anon_sym_SEMI] = ACTIONS(2535),
    [anon_sym_EQ] = ACTIONS(2535),
    [anon_sym_QMARK] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(2535),
    [anon_sym_BSLASH] = ACTIONS(2544),
    [anon_sym_CARET] = ACTIONS(2535),
    [anon_sym__] = ACTIONS(2535),
    [anon_sym_BQUOTE] = ACTIONS(2535),
    [anon_sym_LBRACE] = ACTIONS(2535),
    [anon_sym_PIPE] = ACTIONS(2535),
    [anon_sym_RBRACE] = ACTIONS(2535),
    [anon_sym_TILDE] = ACTIONS(2535),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_RPAREN] = ACTIONS(2535),
    [sym__newline_token] = ACTIONS(2547),
    [sym_uri_autolink] = ACTIONS(2632),
    [sym_email_autolink] = ACTIONS(2632),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2638),
    [anon_sym_LT_QMARK] = ACTIONS(2641),
    [aux_sym__declaration_token1] = ACTIONS(2556),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2644),
    [sym__whitespace_ge_2] = ACTIONS(2562),
    [aux_sym__whitespace_token1] = ACTIONS(2565),
    [sym__word_no_digit] = ACTIONS(2632),
    [sym__digits] = ACTIONS(2632),
    [sym__code_span_start] = ACTIONS(2568),
    [sym__emphasis_open_star] = ACTIONS(2376),
    [sym__emphasis_open_underscore] = ACTIONS(2376),
    [sym__emphasis_close_underscore] = ACTIONS(2376),
    [sym__strikethrough_open] = ACTIONS(2376),
    [sym__latex_span_start] = ACTIONS(2571),
    [sym__unclosed_span] = ACTIONS(2632),
  },
  [160] = {
    [sym_backslash_escape] = STATE(162),
    [sym_code_span] = STATE(162),
    [sym_latex_block] = STATE(162),
    [sym_image] = STATE(162),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(162),
    [sym__whitespace] = STATE(162),
    [sym__word] = STATE(162),
    [sym__soft_line_break] = STATE(162),
    [sym__text_base] = STATE(162),
    [aux_sym__inline_base_repeat1] = STATE(162),
    [sym__backslash_escape] = ACTIONS(1102),
    [sym_entity_reference] = ACTIONS(2647),
    [sym_numeric_character_reference] = ACTIONS(2647),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_BANG] = ACTIONS(2016),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1112),
    [anon_sym_DOLLAR] = ACTIONS(1112),
    [anon_sym_PERCENT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_COMMA] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_DOT] = ACTIONS(1112),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1112),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1112),
    [anon_sym_QMARK] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_BSLASH] = ACTIONS(1118),
    [anon_sym_CARET] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
    [anon_sym_BQUOTE] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1112),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [sym__newline_token] = ACTIONS(1120),
    [sym_uri_autolink] = ACTIONS(2647),
    [sym_email_autolink] = ACTIONS(2647),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2018),
    [anon_sym_LT_QMARK] = ACTIONS(2020),
    [aux_sym__declaration_token1] = ACTIONS(1126),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2022),
    [sym__whitespace_ge_2] = ACTIONS(1130),
    [aux_sym__whitespace_token1] = ACTIONS(1132),
    [sym__word_no_digit] = ACTIONS(2647),
    [sym__digits] = ACTIONS(2647),
    [sym__code_span_start] = ACTIONS(1134),
    [sym__emphasis_open_star] = ACTIONS(2428),
    [sym__emphasis_open_underscore] = ACTIONS(2428),
    [sym__strikethrough_open] = ACTIONS(2428),
    [sym__latex_span_start] = ACTIONS(1142),
    [sym__unclosed_span] = ACTIONS(2647),
  },
  [161] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_latex_block] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(503),
    [sym__image_shortcut_link] = STATE(503),
    [sym__image_full_reference_link] = STATE(503),
    [sym__image_collapsed_reference_link] = STATE(503),
    [sym__image_description] = STATE(1117),
    [sym__image_description_non_empty] = STATE(540),
    [sym__html_tag] = STATE(505),
    [sym__open_tag] = STATE(359),
    [sym__closing_tag] = STATE(359),
    [sym__html_comment] = STATE(359),
    [sym__processing_instruction] = STATE(359),
    [sym__declaration] = STATE(359),
    [sym__cdata_section] = STATE(359),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__text_base] = STATE(161),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(2430),
    [sym_entity_reference] = ACTIONS(2649),
    [sym_numeric_character_reference] = ACTIONS(2649),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2439),
    [anon_sym_BANG] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [anon_sym_POUND] = ACTIONS(2439),
    [anon_sym_DOLLAR] = ACTIONS(2439),
    [anon_sym_PERCENT] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2439),
    [anon_sym_PLUS] = ACTIONS(2439),
    [anon_sym_COMMA] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2439),
    [anon_sym_DOT] = ACTIONS(2439),
    [anon_sym_SLASH] = ACTIONS(2439),
    [anon_sym_COLON] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym_EQ] = ACTIONS(2439),
    [anon_sym_QMARK] = ACTIONS(2439),
    [anon_sym_AT] = ACTIONS(2439),
    [anon_sym_BSLASH] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym__] = ACTIONS(2439),
    [anon_sym_BQUOTE] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_PIPE] = ACTIONS(2439),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_RPAREN] = ACTIONS(2439),
    [sym__newline_token] = ACTIONS(2451),
    [sym_uri_autolink] = ACTIONS(2649),
    [sym_email_autolink] = ACTIONS(2649),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2655),
    [anon_sym_LT_QMARK] = ACTIONS(2658),
    [aux_sym__declaration_token1] = ACTIONS(2460),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2661),
    [sym__whitespace_ge_2] = ACTIONS(2466),
    [aux_sym__whitespace_token1] = ACTIONS(2469),
    [sym__word_no_digit] = ACTIONS(2649),
    [sym__digits] = ACTIONS(2649),
    [sym__code_span_start] = ACTIONS(2472),
    [sym__emphasis_open_star] = ACTIONS(2376),
    [sym__emphasis_open_underscore] = ACTIONS(2376),
    [sym__strikethrough_open] = ACTIONS(2376),
    [sym__strikethrough_close] = ACTIONS(2376),
    [sym__latex_span_start] = ACTIONS(2475),
    [sym__unclosed_span] = ACTIONS(2649),
  },
  [162] = {
    [sym_backslash_escape] = STATE(162),
    [sym_code_span] = STATE(162),
    [sym_latex_block] = STATE(162),
    [sym_image] = STATE(162),
    [sym__image_inline_link] = STATE(593),
    [sym__image_shortcut_link] = STATE(593),
    [sym__image_full_reference_link] = STATE(593),
    [sym__image_collapsed_reference_link] = STATE(593),
    [sym__image_description] = STATE(1121),
    [sym__image_description_non_empty] = STATE(594),
    [sym__html_tag] = STATE(595),
    [sym__open_tag] = STATE(551),
    [sym__closing_tag] = STATE(551),
    [sym__html_comment] = STATE(551),
    [sym__processing_instruction] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__cdata_section] = STATE(551),
    [sym_hard_line_break] = STATE(162),
    [sym__whitespace] = STATE(162),
    [sym__word] = STATE(162),
    [sym__soft_line_break] = STATE(162),
    [sym__text_base] = STATE(162),
    [aux_sym__inline_base_repeat1] = STATE(162),
    [sym__backslash_escape] = ACTIONS(2580),
    [sym_entity_reference] = ACTIONS(2664),
    [sym_numeric_character_reference] = ACTIONS(2664),
    [anon_sym_RBRACK] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_GT] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2589),
    [anon_sym_POUND] = ACTIONS(2589),
    [anon_sym_DOLLAR] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_AMP] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(2589),
    [anon_sym_SLASH] = ACTIONS(2589),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_EQ] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_BSLASH] = ACTIONS(2598),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym__] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_PIPE] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_TILDE] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2589),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [sym__newline_token] = ACTIONS(2601),
    [sym_uri_autolink] = ACTIONS(2664),
    [sym_email_autolink] = ACTIONS(2664),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2670),
    [anon_sym_LT_QMARK] = ACTIONS(2673),
    [aux_sym__declaration_token1] = ACTIONS(2610),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2676),
    [sym__whitespace_ge_2] = ACTIONS(2616),
    [aux_sym__whitespace_token1] = ACTIONS(2619),
    [sym__word_no_digit] = ACTIONS(2664),
    [sym__digits] = ACTIONS(2664),
    [sym__code_span_start] = ACTIONS(2622),
    [sym__emphasis_open_star] = ACTIONS(2376),
    [sym__emphasis_open_underscore] = ACTIONS(2376),
    [sym__strikethrough_open] = ACTIONS(2376),
    [sym__latex_span_start] = ACTIONS(2625),
    [sym__unclosed_span] = ACTIONS(2664),
  },
  [163] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_latex_block] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__text_base] = STATE(165),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(640),
    [sym_entity_reference] = ACTIONS(2679),
    [sym_numeric_character_reference] = ACTIONS(2679),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(650),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_BSLASH] = ACTIONS(656),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym__] = ACTIONS(650),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym__newline_token] = ACTIONS(658),
    [sym_uri_autolink] = ACTIONS(2679),
    [sym_email_autolink] = ACTIONS(2679),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_QMARK] = ACTIONS(2113),
    [aux_sym__declaration_token1] = ACTIONS(664),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2115),
    [sym__whitespace_ge_2] = ACTIONS(668),
    [aux_sym__whitespace_token1] = ACTIONS(670),
    [sym__word_no_digit] = ACTIONS(2679),
    [sym__digits] = ACTIONS(2679),
    [sym__code_span_start] = ACTIONS(672),
    [sym__emphasis_open_star] = ACTIONS(2428),
    [sym__emphasis_open_underscore] = ACTIONS(2428),
    [sym__emphasis_close_star] = ACTIONS(2428),
    [sym__strikethrough_open] = ACTIONS(2428),
    [sym__latex_span_start] = ACTIONS(682),
    [sym__unclosed_span] = ACTIONS(2679),
  },
  [164] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_latex_block] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(434),
    [sym__image_shortcut_link] = STATE(434),
    [sym__image_full_reference_link] = STATE(434),
    [sym__image_collapsed_reference_link] = STATE(434),
    [sym__image_description] = STATE(1119),
    [sym__image_description_non_empty] = STATE(538),
    [sym__html_tag] = STATE(436),
    [sym__open_tag] = STATE(506),
    [sym__closing_tag] = STATE(506),
    [sym__html_comment] = STATE(506),
    [sym__processing_instruction] = STATE(506),
    [sym__declaration] = STATE(506),
    [sym__cdata_section] = STATE(506),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__text_base] = STATE(159),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(684),
    [sym_entity_reference] = ACTIONS(2681),
    [sym_numeric_character_reference] = ACTIONS(2681),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_DOLLAR] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_SQUOTE] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_DOT] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_COLON] = ACTIONS(694),
    [anon_sym_SEMI] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_QMARK] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(694),
    [anon_sym_BSLASH] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_BQUOTE] = ACTIONS(694),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [sym__newline_token] = ACTIONS(702),
    [sym_uri_autolink] = ACTIONS(2681),
    [sym_email_autolink] = ACTIONS(2681),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2129),
    [anon_sym_LT_QMARK] = ACTIONS(2131),
    [aux_sym__declaration_token1] = ACTIONS(708),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2133),
    [sym__whitespace_ge_2] = ACTIONS(712),
    [aux_sym__whitespace_token1] = ACTIONS(714),
    [sym__word_no_digit] = ACTIONS(2681),
    [sym__digits] = ACTIONS(2681),
    [sym__code_span_start] = ACTIONS(716),
    [sym__emphasis_open_star] = ACTIONS(2428),
    [sym__emphasis_open_underscore] = ACTIONS(2428),
    [sym__emphasis_close_underscore] = ACTIONS(2428),
    [sym__strikethrough_open] = ACTIONS(2428),
    [sym__latex_span_start] = ACTIONS(726),
    [sym__unclosed_span] = ACTIONS(2681),
  },
  [165] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_latex_block] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(346),
    [sym__image_shortcut_link] = STATE(346),
    [sym__image_full_reference_link] = STATE(346),
    [sym__image_collapsed_reference_link] = STATE(346),
    [sym__image_description] = STATE(1123),
    [sym__image_description_non_empty] = STATE(541),
    [sym__html_tag] = STATE(348),
    [sym__open_tag] = STATE(437),
    [sym__closing_tag] = STATE(437),
    [sym__html_comment] = STATE(437),
    [sym__processing_instruction] = STATE(437),
    [sym__declaration] = STATE(437),
    [sym__cdata_section] = STATE(437),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__text_base] = STATE(165),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(2478),
    [sym_entity_reference] = ACTIONS(2683),
    [sym_numeric_character_reference] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_GT] = ACTIONS(2487),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2487),
    [anon_sym_POUND] = ACTIONS(2487),
    [anon_sym_DOLLAR] = ACTIONS(2487),
    [anon_sym_PERCENT] = ACTIONS(2487),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_SQUOTE] = ACTIONS(2487),
    [anon_sym_STAR] = ACTIONS(2487),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_DOT] = ACTIONS(2487),
    [anon_sym_SLASH] = ACTIONS(2487),
    [anon_sym_COLON] = ACTIONS(2487),
    [anon_sym_SEMI] = ACTIONS(2487),
    [anon_sym_EQ] = ACTIONS(2487),
    [anon_sym_QMARK] = ACTIONS(2487),
    [anon_sym_AT] = ACTIONS(2487),
    [anon_sym_BSLASH] = ACTIONS(2496),
    [anon_sym_CARET] = ACTIONS(2487),
    [anon_sym__] = ACTIONS(2487),
    [anon_sym_BQUOTE] = ACTIONS(2487),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_PIPE] = ACTIONS(2487),
    [anon_sym_RBRACE] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [anon_sym_RPAREN] = ACTIONS(2487),
    [sym__newline_token] = ACTIONS(2499),
    [sym_uri_autolink] = ACTIONS(2683),
    [sym_email_autolink] = ACTIONS(2683),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2689),
    [anon_sym_LT_QMARK] = ACTIONS(2692),
    [aux_sym__declaration_token1] = ACTIONS(2508),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2695),
    [sym__whitespace_ge_2] = ACTIONS(2514),
    [aux_sym__whitespace_token1] = ACTIONS(2517),
    [sym__word_no_digit] = ACTIONS(2683),
    [sym__digits] = ACTIONS(2683),
    [sym__code_span_start] = ACTIONS(2520),
    [sym__emphasis_open_star] = ACTIONS(2376),
    [sym__emphasis_open_underscore] = ACTIONS(2376),
    [sym__emphasis_close_star] = ACTIONS(2376),
    [sym__strikethrough_open] = ACTIONS(2376),
    [sym__latex_span_start] = ACTIONS(2523),
    [sym__unclosed_span] = ACTIONS(2683),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 12,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2715), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2723), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2704), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    STATE(753), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [83] = 10,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2735), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2743), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2729), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(754), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [162] = 11,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2735), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2743), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2746), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2729), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(754), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 26,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [243] = 11,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2748), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2746), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2750), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2729), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(764), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 26,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [324] = 11,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2753), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2746), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2755), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2729), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(726), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 26,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [405] = 10,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2758), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2760), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2704), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(765), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [484] = 10,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2763), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2765), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2704), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(767), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [563] = 10,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2748), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2750), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2729), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(764), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [642] = 12,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2763), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2765), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2704), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    STATE(767), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [725] = 10,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2768), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2770), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2729), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(774), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [804] = 10,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2715), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2723), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2704), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(753), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [883] = 12,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2758), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2760), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2704), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    STATE(765), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [966] = 10,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2773), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2775), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2704), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(777), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1045] = 10,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2753), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2755), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2729), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(726), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1124] = 11,
    ACTIONS(2784), 1,
      anon_sym_DASH,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2790), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2798), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2781), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(755), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 14,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2778), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1204] = 11,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2807), 1,
      anon_sym_DASH,
    ACTIONS(2810), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2812), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2804), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(769), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 14,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2801), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1284] = 12,
    ACTIONS(2784), 1,
      anon_sym_DASH,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2790), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2798), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2815), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2781), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(755), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 14,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2778), 25,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1366] = 11,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2823), 1,
      anon_sym_DASH,
    ACTIONS(2826), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2828), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2820), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(772), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 14,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2817), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1446] = 11,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2746), 1,
      anon_sym_LBRACK,
    ACTIONS(2831), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2833), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2729), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(824), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 27,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1526] = 11,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2842), 1,
      anon_sym_DASH,
    ACTIONS(2845), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2847), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2839), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(763), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 14,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2836), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1606] = 10,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2831), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2833), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2729), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(824), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1684] = 12,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2807), 1,
      anon_sym_DASH,
    ACTIONS(2810), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2812), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2850), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2804), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(769), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 14,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2801), 25,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1766] = 10,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2852), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2854), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2704), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(810), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1844] = 12,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2842), 1,
      anon_sym_DASH,
    ACTIONS(2845), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2847), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2857), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2839), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(763), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 14,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2836), 25,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1926] = 11,
    ACTIONS(2700), 1,
      anon_sym_LBRACK,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2852), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2854), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2704), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(810), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2006] = 12,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2859), 1,
      anon_sym_LBRACK,
    ACTIONS(2867), 1,
      anon_sym_DASH,
    ACTIONS(2870), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2872), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2864), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(825), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2861), 26,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2087] = 11,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2867), 1,
      anon_sym_DASH,
    ACTIONS(2870), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2872), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2713), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2864), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(825), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 13,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2861), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2166] = 5,
    ACTIONS(702), 1,
      sym__newline_token,
    ACTIONS(2879), 1,
      sym__last_token_whitespace,
    STATE(442), 1,
      sym__soft_line_break,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [2232] = 6,
    ACTIONS(2881), 1,
      anon_sym_SLASH,
    ACTIONS(2884), 1,
      sym__word_no_digit,
    ACTIONS(2887), 1,
      sym__last_token_punctuation,
    STATE(943), 1,
      sym__tag_name,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [2300] = 6,
    ACTIONS(2884), 1,
      sym__word_no_digit,
    ACTIONS(2889), 1,
      anon_sym_SLASH,
    ACTIONS(2892), 1,
      sym__last_token_punctuation,
    STATE(945), 1,
      sym__tag_name,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [2368] = 5,
    ACTIONS(658), 1,
      sym__newline_token,
    ACTIONS(2894), 1,
      sym__last_token_whitespace,
    STATE(357), 1,
      sym__soft_line_break,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [2434] = 5,
    ACTIONS(658), 1,
      sym__newline_token,
    ACTIONS(2892), 1,
      sym__last_token_punctuation,
    STATE(357), 1,
      sym__soft_line_break,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [2500] = 6,
    ACTIONS(2896), 1,
      sym__newline_token,
    ACTIONS(2899), 1,
      sym__whitespace_ge_2,
    ACTIONS(2902), 1,
      aux_sym__whitespace_token1,
    STATE(860), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2713), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [2568] = 6,
    ACTIONS(2884), 1,
      sym__word_no_digit,
    ACTIONS(2905), 1,
      anon_sym_SLASH,
    ACTIONS(2908), 1,
      sym__last_token_punctuation,
    STATE(946), 1,
      sym__tag_name,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [2636] = 6,
    ACTIONS(2896), 1,
      sym__newline_token,
    ACTIONS(2899), 1,
      sym__whitespace_ge_2,
    ACTIONS(2902), 1,
      aux_sym__whitespace_token1,
    STATE(857), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2713), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [2704] = 5,
    ACTIONS(21), 1,
      sym__newline_token,
    ACTIONS(2908), 1,
      sym__last_token_punctuation,
    STATE(299), 1,
      sym__soft_line_break,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [2770] = 6,
    ACTIONS(2884), 1,
      sym__word_no_digit,
    ACTIONS(2910), 1,
      anon_sym_SLASH,
    ACTIONS(2913), 1,
      sym__last_token_punctuation,
    STATE(955), 1,
      sym__tag_name,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [2838] = 5,
    ACTIONS(746), 1,
      sym__newline_token,
    ACTIONS(2915), 1,
      sym__last_token_whitespace,
    STATE(510), 1,
      sym__soft_line_break,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [2904] = 6,
    ACTIONS(2896), 1,
      sym__newline_token,
    ACTIONS(2899), 1,
      sym__whitespace_ge_2,
    ACTIONS(2902), 1,
      aux_sym__whitespace_token1,
    STATE(836), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2713), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [2972] = 6,
    ACTIONS(2896), 1,
      sym__newline_token,
    ACTIONS(2899), 1,
      sym__whitespace_ge_2,
    ACTIONS(2902), 1,
      aux_sym__whitespace_token1,
    STATE(858), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2713), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [3040] = 5,
    ACTIONS(746), 1,
      sym__newline_token,
    ACTIONS(2913), 1,
      sym__last_token_punctuation,
    STATE(510), 1,
      sym__soft_line_break,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3106] = 5,
    ACTIONS(21), 1,
      sym__newline_token,
    ACTIONS(2917), 1,
      sym__last_token_whitespace,
    STATE(299), 1,
      sym__soft_line_break,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3172] = 5,
    ACTIONS(702), 1,
      sym__newline_token,
    ACTIONS(2887), 1,
      sym__last_token_punctuation,
    STATE(442), 1,
      sym__soft_line_break,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3238] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2939), 1,
      sym__code_span_close,
    ACTIONS(2919), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(250), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3319] = 4,
    ACTIONS(114), 1,
      anon_sym_RBRACK,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(2943), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2941), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3382] = 3,
    ACTIONS(2892), 1,
      sym__last_token_punctuation,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3443] = 4,
    ACTIONS(2892), 1,
      sym__last_token_punctuation,
    ACTIONS(2945), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3506] = 4,
    ACTIONS(2887), 1,
      sym__last_token_punctuation,
    ACTIONS(2948), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3569] = 6,
    ACTIONS(2896), 1,
      sym__newline_token,
    ACTIONS(2899), 1,
      sym__whitespace_ge_2,
    ACTIONS(2902), 1,
      aux_sym__whitespace_token1,
    STATE(840), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2713), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2698), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [3636] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2971), 1,
      sym__latex_span_close,
    ACTIONS(2951), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(228), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3717] = 3,
    ACTIONS(2977), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3778] = 3,
    ACTIONS(2894), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3839] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2981), 1,
      sym__latex_span_close,
    ACTIONS(2979), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(255), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3920] = 3,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(2943), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2941), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3981] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2983), 1,
      sym__latex_span_close,
    ACTIONS(2951), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(228), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4062] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2987), 1,
      sym__code_span_close,
    ACTIONS(2985), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(224), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4143] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2991), 1,
      sym__latex_span_close,
    ACTIONS(2989), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(235), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4224] = 4,
    ACTIONS(114), 1,
      anon_sym_RBRACK,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(2943), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2941), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4287] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2993), 1,
      sym__code_span_close,
    ACTIONS(2919), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(250), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4368] = 3,
    ACTIONS(2887), 1,
      sym__last_token_punctuation,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4429] = 4,
    ACTIONS(114), 1,
      anon_sym_RBRACK,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(2943), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2941), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4492] = 3,
    ACTIONS(2917), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4553] = 13,
    ACTIONS(2998), 1,
      anon_sym_LT,
    ACTIONS(3004), 1,
      sym__newline_token,
    ACTIONS(3007), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(3010), 1,
      anon_sym_LT_QMARK,
    ACTIONS(3013), 1,
      aux_sym__declaration_token1,
    ACTIONS(3016), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(3019), 1,
      sym__whitespace_ge_2,
    ACTIONS(3022), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 1,
      sym__latex_span_close,
    ACTIONS(2995), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(228), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(3001), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4634] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3029), 1,
      sym__latex_span_close,
    ACTIONS(3027), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(220), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4715] = 3,
    ACTIONS(1277), 1,
      sym__last_token_punctuation,
    ACTIONS(3031), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(500), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4776] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3035), 1,
      sym__code_span_close,
    ACTIONS(3033), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(209), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4857] = 4,
    ACTIONS(2913), 1,
      sym__last_token_punctuation,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4920] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3040), 1,
      sym__code_span_close,
    ACTIONS(2919), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(250), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5001] = 3,
    ACTIONS(3042), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5062] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3044), 1,
      sym__latex_span_close,
    ACTIONS(2951), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(228), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5143] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3046), 1,
      sym__code_span_close,
    ACTIONS(2919), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(250), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5224] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3050), 1,
      sym__code_span_close,
    ACTIONS(3048), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(236), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5305] = 6,
    ACTIONS(2884), 1,
      sym__word_no_digit,
    ACTIONS(3052), 1,
      anon_sym_SLASH,
    ACTIONS(3055), 1,
      sym__last_token_punctuation,
    STATE(961), 1,
      sym__tag_name,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [5372] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3059), 1,
      sym__code_span_close,
    ACTIONS(3057), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(233), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5453] = 3,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(2943), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2941), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5514] = 3,
    ACTIONS(3061), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5575] = 3,
    ACTIONS(2879), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5636] = 3,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(2943), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2941), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5697] = 3,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(2943), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2941), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5758] = 3,
    ACTIONS(2913), 1,
      sym__last_token_punctuation,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5819] = 5,
    ACTIONS(1120), 1,
      sym__newline_token,
    ACTIONS(3055), 1,
      sym__last_token_punctuation,
    STATE(596), 1,
      sym__soft_line_break,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5884] = 3,
    ACTIONS(1339), 1,
      sym__last_token_punctuation,
    ACTIONS(3063), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(308), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5945] = 3,
    ACTIONS(3065), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6006] = 3,
    ACTIONS(1401), 1,
      sym__last_token_punctuation,
    ACTIONS(3067), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(104), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6067] = 13,
    ACTIONS(3025), 1,
      sym__code_span_close,
    ACTIONS(3072), 1,
      anon_sym_LT,
    ACTIONS(3078), 1,
      sym__newline_token,
    ACTIONS(3081), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(3084), 1,
      anon_sym_LT_QMARK,
    ACTIONS(3087), 1,
      aux_sym__declaration_token1,
    ACTIONS(3090), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(3093), 1,
      sym__whitespace_ge_2,
    ACTIONS(3096), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3069), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(250), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(3075), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [6148] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3101), 1,
      sym__code_span_close,
    ACTIONS(3099), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(257), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [6229] = 5,
    ACTIONS(1120), 1,
      sym__newline_token,
    ACTIONS(3103), 1,
      sym__last_token_whitespace,
    STATE(596), 1,
      sym__soft_line_break,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6294] = 4,
    ACTIONS(2908), 1,
      sym__last_token_punctuation,
    ACTIONS(3105), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6357] = 3,
    ACTIONS(2908), 1,
      sym__last_token_punctuation,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6418] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3108), 1,
      sym__latex_span_close,
    ACTIONS(2951), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(228), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [6499] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3112), 1,
      sym__latex_span_close,
    ACTIONS(3110), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(261), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [6580] = 13,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2925), 1,
      sym__newline_token,
    ACTIONS(2927), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2929), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2931), 1,
      aux_sym__declaration_token1,
    ACTIONS(2933), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2935), 1,
      sym__whitespace_ge_2,
    ACTIONS(2937), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3114), 1,
      sym__code_span_close,
    ACTIONS(2919), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(250), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(820), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2923), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [6661] = 3,
    ACTIONS(1463), 1,
      sym__last_token_punctuation,
    ACTIONS(3116), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(114), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6722] = 3,
    ACTIONS(2915), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6783] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3120), 1,
      sym__latex_span_close,
    ACTIONS(3118), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(215), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [6864] = 13,
    ACTIONS(2953), 1,
      anon_sym_LT,
    ACTIONS(2957), 1,
      sym__newline_token,
    ACTIONS(2959), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2961), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2963), 1,
      aux_sym__declaration_token1,
    ACTIONS(2965), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2967), 1,
      sym__whitespace_ge_2,
    ACTIONS(2969), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3122), 1,
      sym__latex_span_close,
    ACTIONS(2951), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(228), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(778), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2955), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [6945] = 2,
    ACTIONS(3126), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3124), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7003] = 2,
    ACTIONS(3130), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3128), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7061] = 2,
    ACTIONS(3134), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3132), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7119] = 3,
    ACTIONS(3138), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3136), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7179] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7237] = 3,
    ACTIONS(3149), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3152), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7297] = 3,
    ACTIONS(3158), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7357] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3165), 1,
      anon_sym_RBRACK,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(300), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3163), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [7429] = 4,
    ACTIONS(2913), 1,
      sym__last_token_punctuation,
    ACTIONS(3177), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7491] = 3,
    ACTIONS(3183), 1,
      sym__emphasis_close_star,
    ACTIONS(3181), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3179), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7551] = 2,
    ACTIONS(3188), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3186), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7609] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3190), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(300), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3163), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [7681] = 2,
    ACTIONS(3194), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3192), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7739] = 2,
    ACTIONS(3198), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3196), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7797] = 2,
    ACTIONS(3202), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3200), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7855] = 2,
    ACTIONS(3206), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3204), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7913] = 2,
    ACTIONS(3210), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3208), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7971] = 3,
    ACTIONS(3103), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8031] = 2,
    ACTIONS(3214), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3212), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8089] = 2,
    ACTIONS(3218), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3216), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8147] = 3,
    ACTIONS(3220), 1,
      sym__emphasis_close_star,
    ACTIONS(3181), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3179), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8207] = 2,
    ACTIONS(3225), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3223), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8265] = 2,
    ACTIONS(3181), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3179), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8323] = 3,
    ACTIONS(3227), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8383] = 4,
    ACTIONS(2887), 1,
      sym__last_token_punctuation,
    ACTIONS(3229), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8445] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8503] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3237), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(337), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3235), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [8575] = 3,
    ACTIONS(3055), 1,
      sym__last_token_punctuation,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8635] = 2,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8693] = 3,
    ACTIONS(3239), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8753] = 2,
    ACTIONS(3244), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3242), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8811] = 2,
    ACTIONS(3248), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3246), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8869] = 2,
    ACTIONS(3252), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3250), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8927] = 2,
    ACTIONS(3256), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3254), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8985] = 2,
    ACTIONS(3260), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3258), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9043] = 2,
    ACTIONS(3264), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3262), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9101] = 2,
    ACTIONS(3268), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3266), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9159] = 2,
    ACTIONS(3272), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3270), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9217] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3274), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(337), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3235), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [9289] = 2,
    ACTIONS(3278), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9347] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3282), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(288), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3280), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [9419] = 2,
    ACTIONS(3130), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3128), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9477] = 4,
    ACTIONS(3055), 1,
      sym__last_token_punctuation,
    ACTIONS(3284), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9539] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3287), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(288), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3280), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [9611] = 2,
    ACTIONS(3291), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3289), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9669] = 2,
    ACTIONS(3295), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3293), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9727] = 2,
    ACTIONS(3299), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3297), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9785] = 2,
    ACTIONS(3303), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3301), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9843] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9901] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9959] = 3,
    ACTIONS(3313), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10019] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3318), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(474), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3316), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [10091] = 3,
    ACTIONS(3320), 1,
      sym__emphasis_close_star,
    ACTIONS(3181), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3179), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10151] = 2,
    ACTIONS(3325), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3323), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10209] = 2,
    ACTIONS(3329), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3327), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10267] = 3,
    ACTIONS(3331), 1,
      sym__emphasis_close_star,
    ACTIONS(3181), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3179), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10327] = 2,
    ACTIONS(3336), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3334), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10385] = 4,
    ACTIONS(2892), 1,
      sym__last_token_punctuation,
    ACTIONS(3338), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10447] = 3,
    ACTIONS(3340), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10507] = 2,
    ACTIONS(3264), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3262), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10565] = 2,
    ACTIONS(3260), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3258), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10623] = 2,
    ACTIONS(3202), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3200), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10681] = 2,
    ACTIONS(3206), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3204), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10739] = 2,
    ACTIONS(3210), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3208), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10797] = 2,
    ACTIONS(3345), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3343), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10855] = 2,
    ACTIONS(3349), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3347), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10913] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3353), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(361), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3351), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [10985] = 2,
    ACTIONS(3357), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3355), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11043] = 2,
    ACTIONS(3361), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3359), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11101] = 2,
    ACTIONS(3365), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3363), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11159] = 3,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(2943), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2941), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11219] = 3,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(3116), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(114), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11279] = 2,
    ACTIONS(3369), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3367), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11337] = 2,
    ACTIONS(3373), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3371), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11395] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3375), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(361), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3351), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [11467] = 9,
    ACTIONS(3377), 1,
      sym__backslash_escape,
    ACTIONS(3383), 1,
      anon_sym_RBRACK,
    ACTIONS(3391), 1,
      sym__newline_token,
    ACTIONS(3394), 1,
      sym__whitespace_ge_2,
    ACTIONS(3397), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3385), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(337), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3380), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3388), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [11539] = 2,
    ACTIONS(3126), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3124), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11597] = 2,
    ACTIONS(3402), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3400), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11655] = 2,
    ACTIONS(3406), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3404), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11713] = 2,
    ACTIONS(3410), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3408), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11771] = 2,
    ACTIONS(3414), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3412), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11829] = 2,
    ACTIONS(3365), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3363), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11887] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11945] = 3,
    ACTIONS(3138), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3136), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12005] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12063] = 3,
    ACTIONS(3149), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3152), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12123] = 2,
    ACTIONS(3188), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3186), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12181] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3416), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(337), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3235), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [12253] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12311] = 2,
    ACTIONS(3299), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3297), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12369] = 2,
    ACTIONS(3295), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3293), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12427] = 2,
    ACTIONS(3218), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3216), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12485] = 2,
    ACTIONS(3248), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3246), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12543] = 2,
    ACTIONS(3278), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12601] = 2,
    ACTIONS(3256), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3254), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12659] = 2,
    ACTIONS(3272), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3270), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12717] = 2,
    ACTIONS(3357), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3355), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12775] = 2,
    ACTIONS(3194), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3192), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12833] = 2,
    ACTIONS(3420), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3418), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12891] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3422), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(337), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3235), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [12963] = 2,
    ACTIONS(3426), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3424), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13021] = 2,
    ACTIONS(3361), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3359), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13079] = 2,
    ACTIONS(3325), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3323), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13137] = 2,
    ACTIONS(3420), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3418), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13195] = 2,
    ACTIONS(3430), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3428), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13253] = 2,
    ACTIONS(3434), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3432), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13311] = 2,
    ACTIONS(3426), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3424), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13369] = 2,
    ACTIONS(3438), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3436), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13427] = 2,
    ACTIONS(3434), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3432), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13485] = 2,
    ACTIONS(3438), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3436), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13543] = 2,
    ACTIONS(3442), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3440), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13601] = 2,
    ACTIONS(3446), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3444), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13659] = 2,
    ACTIONS(3450), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3448), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13717] = 2,
    ACTIONS(3454), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3452), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13775] = 2,
    ACTIONS(3458), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3456), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13833] = 2,
    ACTIONS(3462), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3460), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13891] = 2,
    ACTIONS(3369), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3367), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13949] = 2,
    ACTIONS(3442), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3440), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14007] = 2,
    ACTIONS(3446), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3444), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14065] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3466), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(349), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3464), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [14137] = 4,
    ACTIONS(3055), 1,
      sym__last_token_punctuation,
    ACTIONS(3468), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14199] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3470), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(349), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3464), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [14271] = 2,
    ACTIONS(3474), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3472), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14329] = 2,
    ACTIONS(3478), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3476), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14387] = 2,
    ACTIONS(3482), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3480), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14445] = 2,
    ACTIONS(3486), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3484), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14503] = 2,
    ACTIONS(3490), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3488), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14561] = 2,
    ACTIONS(3494), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3492), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14619] = 2,
    ACTIONS(3498), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3496), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14677] = 2,
    ACTIONS(3502), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3500), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14735] = 2,
    ACTIONS(3450), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3448), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14793] = 2,
    ACTIONS(3349), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3347), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14851] = 2,
    ACTIONS(3345), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3343), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14909] = 2,
    ACTIONS(3336), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3334), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14967] = 2,
    ACTIONS(3329), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3327), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15025] = 2,
    ACTIONS(3373), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3371), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15083] = 2,
    ACTIONS(3291), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3289), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15141] = 2,
    ACTIONS(3498), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3496), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15199] = 2,
    ACTIONS(3264), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3262), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15257] = 2,
    ACTIONS(3260), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3258), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15315] = 2,
    ACTIONS(3134), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3132), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15373] = 2,
    ACTIONS(3303), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3301), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15431] = 2,
    ACTIONS(3268), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3266), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15489] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15547] = 2,
    ACTIONS(3225), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3223), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15605] = 2,
    ACTIONS(3202), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3200), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15663] = 3,
    ACTIONS(3504), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15723] = 2,
    ACTIONS(3206), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3204), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15781] = 3,
    ACTIONS(3507), 1,
      sym__emphasis_close_star,
    ACTIONS(3181), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3179), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15841] = 2,
    ACTIONS(3225), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3223), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15899] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15957] = 2,
    ACTIONS(3210), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3208), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16015] = 2,
    ACTIONS(3498), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3496), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16073] = 2,
    ACTIONS(3130), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3128), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16131] = 2,
    ACTIONS(3291), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3289), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16189] = 2,
    ACTIONS(3329), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3327), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16247] = 2,
    ACTIONS(3336), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3334), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16305] = 2,
    ACTIONS(3345), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3343), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16363] = 2,
    ACTIONS(3349), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3347), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16421] = 2,
    ACTIONS(3365), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3363), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16479] = 2,
    ACTIONS(3494), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3492), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16537] = 2,
    ACTIONS(3490), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3488), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16595] = 2,
    ACTIONS(3268), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3266), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16653] = 2,
    ACTIONS(3303), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3301), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16711] = 2,
    ACTIONS(3486), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3484), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16769] = 2,
    ACTIONS(3482), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3480), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16827] = 2,
    ACTIONS(3134), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3132), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16885] = 2,
    ACTIONS(3478), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3476), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16943] = 2,
    ACTIONS(3357), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3355), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17001] = 2,
    ACTIONS(3361), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3359), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17059] = 2,
    ACTIONS(3454), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3452), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17117] = 3,
    ACTIONS(3138), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3136), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17177] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17235] = 3,
    ACTIONS(3149), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3152), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17295] = 2,
    ACTIONS(3188), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3186), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17353] = 2,
    ACTIONS(3194), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3192), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17411] = 2,
    ACTIONS(3369), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3367), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17469] = 2,
    ACTIONS(3218), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3216), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17527] = 2,
    ACTIONS(3248), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3246), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17585] = 2,
    ACTIONS(3256), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3254), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17643] = 2,
    ACTIONS(3272), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3270), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17701] = 2,
    ACTIONS(3278), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17759] = 2,
    ACTIONS(3295), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3293), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17817] = 2,
    ACTIONS(3299), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3297), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17875] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17933] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17991] = 2,
    ACTIONS(3325), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3323), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18049] = 2,
    ACTIONS(3420), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3418), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18107] = 2,
    ACTIONS(3373), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3371), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18165] = 2,
    ACTIONS(3426), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3424), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18223] = 2,
    ACTIONS(3434), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3432), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18281] = 2,
    ACTIONS(3438), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3436), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18339] = 2,
    ACTIONS(3442), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3440), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18397] = 2,
    ACTIONS(3446), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3444), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18455] = 2,
    ACTIONS(3450), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3448), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18513] = 2,
    ACTIONS(3454), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3452), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18571] = 2,
    ACTIONS(3458), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3456), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18629] = 2,
    ACTIONS(3414), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3412), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18687] = 2,
    ACTIONS(3410), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3408), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18745] = 2,
    ACTIONS(3406), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3404), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18803] = 2,
    ACTIONS(3402), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3400), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18861] = 2,
    ACTIONS(3126), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3124), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18919] = 2,
    ACTIONS(3474), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3472), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18977] = 2,
    ACTIONS(3478), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3476), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19035] = 2,
    ACTIONS(3482), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3480), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19093] = 2,
    ACTIONS(3486), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3484), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19151] = 2,
    ACTIONS(3490), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3488), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19209] = 2,
    ACTIONS(3494), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3492), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19267] = 2,
    ACTIONS(3498), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3496), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19325] = 2,
    ACTIONS(3373), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3371), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19383] = 2,
    ACTIONS(3369), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3367), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19441] = 2,
    ACTIONS(3458), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3456), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19499] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3510), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(337), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3235), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [19571] = 2,
    ACTIONS(3361), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3359), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19629] = 2,
    ACTIONS(3357), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3355), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19687] = 2,
    ACTIONS(3134), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3132), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19745] = 2,
    ACTIONS(3303), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3301), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19803] = 2,
    ACTIONS(3268), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3266), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19861] = 2,
    ACTIONS(3210), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3208), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19919] = 2,
    ACTIONS(3206), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3204), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19977] = 2,
    ACTIONS(3202), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3200), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20035] = 2,
    ACTIONS(3225), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3223), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20093] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20151] = 2,
    ACTIONS(3260), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3258), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20209] = 2,
    ACTIONS(3264), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3262), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20267] = 2,
    ACTIONS(3130), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3128), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20325] = 2,
    ACTIONS(3291), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3289), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20383] = 2,
    ACTIONS(3329), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3327), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20441] = 2,
    ACTIONS(3336), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3334), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20499] = 2,
    ACTIONS(3345), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3343), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20557] = 2,
    ACTIONS(3349), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3347), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20615] = 2,
    ACTIONS(3365), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3363), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20673] = 2,
    ACTIONS(3474), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3472), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20731] = 2,
    ACTIONS(3126), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3124), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20789] = 2,
    ACTIONS(3402), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3400), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20847] = 2,
    ACTIONS(3406), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3404), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20905] = 2,
    ACTIONS(3410), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3408), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20963] = 4,
    ACTIONS(1471), 1,
      sym__last_token_punctuation,
    ACTIONS(3512), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3116), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(114), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21025] = 2,
    ACTIONS(3414), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3412), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21083] = 9,
    ACTIONS(3161), 1,
      sym__backslash_escape,
    ACTIONS(3171), 1,
      sym__newline_token,
    ACTIONS(3173), 1,
      sym__whitespace_ge_2,
    ACTIONS(3175), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3514), 1,
      anon_sym_RBRACK,
    ACTIONS(3167), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(474), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(3316), 11,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3169), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [21155] = 3,
    ACTIONS(3138), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3136), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21215] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21273] = 3,
    ACTIONS(3149), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3152), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21333] = 2,
    ACTIONS(3188), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3186), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21391] = 2,
    ACTIONS(3194), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3192), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21449] = 2,
    ACTIONS(3218), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3216), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21507] = 2,
    ACTIONS(3248), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3246), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21565] = 2,
    ACTIONS(3256), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3254), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21623] = 2,
    ACTIONS(3272), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3270), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21681] = 2,
    ACTIONS(3278), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21739] = 2,
    ACTIONS(3295), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3293), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21797] = 2,
    ACTIONS(3299), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3297), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21855] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21913] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21971] = 2,
    ACTIONS(3325), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3323), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22029] = 2,
    ACTIONS(3420), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3418), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22087] = 2,
    ACTIONS(3426), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3424), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22145] = 2,
    ACTIONS(3434), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3432), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22203] = 2,
    ACTIONS(3438), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3436), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22261] = 2,
    ACTIONS(3442), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3440), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22319] = 2,
    ACTIONS(3446), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3444), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22377] = 2,
    ACTIONS(3450), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3448), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22435] = 2,
    ACTIONS(3454), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3452), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22493] = 2,
    ACTIONS(3458), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3456), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22551] = 2,
    ACTIONS(3414), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3412), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22609] = 2,
    ACTIONS(3410), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3408), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22667] = 2,
    ACTIONS(3406), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3404), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22725] = 2,
    ACTIONS(3402), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3400), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22783] = 2,
    ACTIONS(3474), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3472), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22841] = 2,
    ACTIONS(3478), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3476), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22899] = 2,
    ACTIONS(3482), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3480), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22957] = 2,
    ACTIONS(3486), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3484), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23015] = 2,
    ACTIONS(3490), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3488), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23073] = 2,
    ACTIONS(3494), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3492), 46,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23131] = 2,
    ACTIONS(3325), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3323), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23188] = 2,
    ACTIONS(3303), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3301), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23245] = 4,
    ACTIONS(3149), 1,
      anon_sym_LPAREN,
    ACTIONS(3516), 1,
      anon_sym_LBRACK,
    ACTIONS(3152), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23306] = 3,
    ACTIONS(3149), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3152), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23365] = 4,
    ACTIONS(3149), 1,
      anon_sym_LPAREN,
    ACTIONS(3516), 1,
      anon_sym_LBRACK,
    ACTIONS(3152), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23426] = 4,
    ACTIONS(3149), 1,
      anon_sym_LPAREN,
    ACTIONS(3516), 1,
      anon_sym_LBRACK,
    ACTIONS(3152), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23487] = 2,
    ACTIONS(3349), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3347), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23544] = 2,
    ACTIONS(3345), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3343), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23601] = 2,
    ACTIONS(3336), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3334), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23658] = 2,
    ACTIONS(3329), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3327), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23715] = 2,
    ACTIONS(3291), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3289), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23772] = 2,
    ACTIONS(3130), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3128), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23829] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23886] = 2,
    ACTIONS(3225), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3223), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23943] = 2,
    ACTIONS(3268), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3266), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24000] = 2,
    ACTIONS(3194), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3192), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24057] = 2,
    ACTIONS(3134), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3132), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24114] = 2,
    ACTIONS(3256), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3254), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24171] = 2,
    ACTIONS(3278), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24228] = 2,
    ACTIONS(3498), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3496), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24285] = 2,
    ACTIONS(3494), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3492), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24342] = 2,
    ACTIONS(3264), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3262), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24399] = 2,
    ACTIONS(3260), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3258), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24456] = 2,
    ACTIONS(3490), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3488), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24513] = 2,
    ACTIONS(3486), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3484), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24570] = 2,
    ACTIONS(3202), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3200), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24627] = 2,
    ACTIONS(3482), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3480), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24684] = 2,
    ACTIONS(3206), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3204), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24741] = 2,
    ACTIONS(3478), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3476), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24798] = 2,
    ACTIONS(3474), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3472), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24855] = 2,
    ACTIONS(3295), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3293), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24912] = 2,
    ACTIONS(3299), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3297), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24969] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25026] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25083] = 2,
    ACTIONS(3458), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3456), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25140] = 2,
    ACTIONS(3454), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3452), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25197] = 2,
    ACTIONS(3450), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3448), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25254] = 2,
    ACTIONS(3446), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3444), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25311] = 2,
    ACTIONS(3442), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3440), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25368] = 2,
    ACTIONS(3438), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3436), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25425] = 2,
    ACTIONS(3210), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3208), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25482] = 2,
    ACTIONS(3357), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3355), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25539] = 2,
    ACTIONS(3434), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3432), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25596] = 2,
    ACTIONS(3426), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3424), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25653] = 2,
    ACTIONS(3365), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3363), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25710] = 2,
    ACTIONS(3361), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3359), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25767] = 2,
    ACTIONS(3414), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3412), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25824] = 2,
    ACTIONS(3420), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3418), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25881] = 2,
    ACTIONS(3410), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3408), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25938] = 2,
    ACTIONS(3198), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3196), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25995] = 2,
    ACTIONS(3369), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3367), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26052] = 2,
    ACTIONS(3373), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3371), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26109] = 2,
    ACTIONS(3126), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3124), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26166] = 2,
    ACTIONS(3214), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3212), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26223] = 2,
    ACTIONS(3252), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3250), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26280] = 2,
    ACTIONS(3406), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3404), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26337] = 3,
    ACTIONS(3138), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3136), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26396] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26453] = 4,
    ACTIONS(3149), 1,
      anon_sym_LPAREN,
    ACTIONS(3516), 1,
      anon_sym_LBRACK,
    ACTIONS(3152), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26514] = 2,
    ACTIONS(3188), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3186), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26571] = 2,
    ACTIONS(3272), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3270), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26628] = 2,
    ACTIONS(3402), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3400), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26685] = 2,
    ACTIONS(3218), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3216), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26742] = 2,
    ACTIONS(3248), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3246), 45,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26799] = 2,
    ACTIONS(3520), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3518), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26855] = 2,
    ACTIONS(3524), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3522), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26911] = 3,
    ACTIONS(3530), 1,
      sym__emphasis_close_star,
    ACTIONS(3528), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3526), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26969] = 2,
    ACTIONS(3534), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3532), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27025] = 2,
    ACTIONS(3538), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3536), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27081] = 2,
    ACTIONS(3534), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3532), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27137] = 2,
    ACTIONS(3542), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3540), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27193] = 3,
    ACTIONS(3548), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3546), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3544), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27251] = 2,
    ACTIONS(3552), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3550), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27307] = 2,
    ACTIONS(3520), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3518), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27363] = 2,
    ACTIONS(3556), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3554), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27419] = 2,
    ACTIONS(3560), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3558), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27475] = 2,
    ACTIONS(3560), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3558), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27531] = 3,
    ACTIONS(3562), 1,
      sym__emphasis_close_star,
    ACTIONS(3528), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3526), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27589] = 3,
    ACTIONS(3564), 1,
      sym__emphasis_close_star,
    ACTIONS(3528), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3526), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27647] = 2,
    ACTIONS(3542), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3540), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27703] = 2,
    ACTIONS(3534), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3532), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27759] = 2,
    ACTIONS(3538), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3536), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27815] = 3,
    ACTIONS(3566), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3546), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3544), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27873] = 2,
    ACTIONS(3520), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3518), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27929] = 2,
    ACTIONS(3552), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3550), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27985] = 2,
    ACTIONS(3570), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3568), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28041] = 2,
    ACTIONS(3538), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3536), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28097] = 2,
    ACTIONS(3534), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3532), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28153] = 2,
    ACTIONS(3542), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3540), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28209] = 2,
    ACTIONS(3574), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3572), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28265] = 2,
    ACTIONS(3538), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3536), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28321] = 3,
    ACTIONS(3576), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3546), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3544), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28379] = 2,
    ACTIONS(3524), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3522), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28435] = 2,
    ACTIONS(3560), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3558), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28491] = 2,
    ACTIONS(3556), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3554), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28547] = 2,
    ACTIONS(3524), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3522), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28603] = 2,
    ACTIONS(3556), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3554), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28659] = 3,
    ACTIONS(3578), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3546), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3544), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28717] = 2,
    ACTIONS(3542), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3540), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28773] = 2,
    ACTIONS(3582), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3580), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28829] = 2,
    ACTIONS(3560), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3558), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28885] = 2,
    ACTIONS(3552), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3550), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28941] = 2,
    ACTIONS(3552), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3550), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [28997] = 2,
    ACTIONS(3556), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3554), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29053] = 2,
    ACTIONS(3524), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3522), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29109] = 2,
    ACTIONS(3520), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3518), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29165] = 2,
    ACTIONS(3546), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3544), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29221] = 2,
    ACTIONS(3528), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3526), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29277] = 3,
    ACTIONS(3584), 1,
      sym__emphasis_close_star,
    ACTIONS(3528), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3526), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__latex_span_start,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29335] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3602), 1,
      anon_sym_RPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    STATE(1047), 1,
      sym_link_destination,
    STATE(1049), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(656), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29416] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3610), 1,
      anon_sym_RPAREN,
    STATE(996), 1,
      sym_link_destination,
    STATE(997), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29497] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3612), 1,
      anon_sym_RPAREN,
    STATE(1082), 1,
      sym_link_title,
    STATE(1091), 1,
      sym_link_destination,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29578] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3614), 1,
      anon_sym_RPAREN,
    STATE(1100), 1,
      sym_link_title,
    STATE(1101), 1,
      sym_link_destination,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29659] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3616), 1,
      anon_sym_RPAREN,
    STATE(1000), 1,
      sym_link_destination,
    STATE(1001), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29740] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3618), 1,
      anon_sym_RPAREN,
    STATE(1050), 1,
      sym_link_destination,
    STATE(1070), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(646), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29821] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3620), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_link_title,
    STATE(1027), 1,
      sym_link_destination,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(663), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29902] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3622), 1,
      anon_sym_RPAREN,
    STATE(1023), 1,
      sym_link_title,
    STATE(1024), 1,
      sym_link_destination,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(664), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29983] = 15,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3628), 1,
      anon_sym_DQUOTE,
    ACTIONS(3632), 1,
      anon_sym_LPAREN,
    ACTIONS(3634), 1,
      anon_sym_RPAREN,
    ACTIONS(3637), 1,
      sym__newline_token,
    ACTIONS(3640), 1,
      sym__whitespace_ge_2,
    ACTIONS(3643), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3646), 1,
      sym__last_token_punctuation,
    STATE(843), 1,
      sym__soft_line_break,
    ACTIONS(3630), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(684), 2,
      sym__whitespace,
      aux_sym_link_title_repeat1,
    STATE(695), 2,
      sym__link_destination_parenthesis,
      aux_sym_link_destination_repeat2,
    STATE(868), 2,
      sym_backslash_escape,
      sym__word,
    ACTIONS(3624), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3626), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30062] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3648), 1,
      anon_sym_RPAREN,
    STATE(1055), 1,
      sym_link_destination,
    STATE(1056), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30143] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3650), 1,
      anon_sym_RPAREN,
    STATE(1033), 1,
      sym_link_destination,
    STATE(1037), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(661), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30224] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3652), 1,
      anon_sym_RPAREN,
    STATE(1094), 1,
      sym_link_title,
    STATE(1096), 1,
      sym_link_destination,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30305] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3654), 1,
      anon_sym_RPAREN,
    STATE(1045), 1,
      sym_link_destination,
    STATE(1046), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(662), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30386] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3656), 1,
      anon_sym_RPAREN,
    STATE(1040), 1,
      sym_link_destination,
    STATE(1041), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(647), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30467] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3658), 1,
      anon_sym_RPAREN,
    STATE(1042), 1,
      sym_link_destination,
    STATE(1043), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(654), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30548] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3660), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_link_destination,
    STATE(1032), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(648), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30629] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3662), 1,
      anon_sym_RPAREN,
    STATE(1075), 1,
      sym_link_destination,
    STATE(1083), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30710] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3664), 1,
      anon_sym_RPAREN,
    STATE(1059), 1,
      sym_link_destination,
    STATE(1060), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30791] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3666), 1,
      anon_sym_RPAREN,
    STATE(986), 1,
      sym_link_destination,
    STATE(992), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30872] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3668), 1,
      anon_sym_RPAREN,
    STATE(1008), 1,
      sym_link_destination,
    STATE(1016), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30953] = 16,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3592), 1,
      anon_sym_LT,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    ACTIONS(3598), 1,
      anon_sym_SQUOTE,
    ACTIONS(3600), 1,
      anon_sym_LPAREN,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3670), 1,
      anon_sym_RPAREN,
    STATE(984), 1,
      sym_link_destination,
    STATE(985), 1,
      sym_link_title,
    ACTIONS(3596), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(649), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(699), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3588), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3590), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [31034] = 15,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3628), 1,
      anon_sym_SQUOTE,
    ACTIONS(3637), 1,
      sym__newline_token,
    ACTIONS(3640), 1,
      sym__whitespace_ge_2,
    ACTIONS(3643), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3646), 1,
      sym__last_token_punctuation,
    ACTIONS(3678), 1,
      anon_sym_LPAREN,
    ACTIONS(3680), 1,
      anon_sym_RPAREN,
    STATE(838), 1,
      sym__soft_line_break,
    ACTIONS(3676), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(688), 2,
      sym__whitespace,
      aux_sym_link_title_repeat2,
    STATE(695), 2,
      sym__link_destination_parenthesis,
      aux_sym_link_destination_repeat2,
    STATE(878), 2,
      sym_backslash_escape,
      sym__word,
    ACTIONS(3672), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3674), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [31113] = 3,
    ACTIONS(3683), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 42,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31167] = 9,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3685), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2704), 2,
      anon_sym_RBRACK,
      anon_sym_LT,
    ACTIONS(3687), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(790), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 5,
      sym__latex_span_close,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 30,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31233] = 3,
    ACTIONS(3690), 1,
      sym__last_token_punctuation,
    ACTIONS(2713), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 42,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31287] = 13,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3698), 1,
      anon_sym_LPAREN,
    ACTIONS(3700), 1,
      anon_sym_RPAREN,
    STATE(867), 1,
      sym__soft_line_break,
    ACTIONS(3696), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(696), 2,
      sym__whitespace,
      aux_sym_link_title_repeat3,
    STATE(830), 2,
      sym__link_destination_parenthesis,
      aux_sym_link_destination_repeat2,
    STATE(865), 2,
      sym_backslash_escape,
      sym__word,
    ACTIONS(3692), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3694), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [31361] = 9,
    ACTIONS(2710), 1,
      sym__newline_token,
    ACTIONS(2717), 1,
      sym__whitespace_ge_2,
    ACTIONS(2720), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3702), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2704), 2,
      anon_sym_RBRACK,
      anon_sym_LT,
    ACTIONS(3704), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(795), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 5,
      sym__code_span_close,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2707), 30,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31427] = 9,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3707), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2729), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3709), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(793), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 5,
      sym__code_span_close,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 30,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31493] = 9,
    ACTIONS(2732), 1,
      sym__newline_token,
    ACTIONS(2737), 1,
      sym__whitespace_ge_2,
    ACTIONS(2740), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3712), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2729), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3714), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(787), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2698), 5,
      sym__latex_span_close,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2726), 30,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31559] = 3,
    ACTIONS(3717), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 42,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31613] = 2,
    ACTIONS(3278), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 42,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31664] = 2,
    ACTIONS(3311), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 42,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31715] = 10,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3722), 1,
      anon_sym_LT,
    ACTIONS(3725), 1,
      anon_sym_DASH,
    ACTIONS(3728), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3730), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(792), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 6,
      sym__code_span_close,
      anon_sym_GT,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(3719), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31782] = 2,
    ACTIONS(3365), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3363), 42,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31833] = 2,
    ACTIONS(3256), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3254), 42,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__unclosed_span,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31884] = 10,
    ACTIONS(2787), 1,
      sym__newline_token,
    ACTIONS(2792), 1,
      sym__whitespace_ge_2,
    ACTIONS(2795), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3736), 1,
      anon_sym_LT,
    ACTIONS(3739), 1,
      anon_sym_DASH,
    ACTIONS(3742), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3744), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(782), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2698), 6,
      sym__latex_span_close,
      anon_sym_GT,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(3733), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31951] = 10,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3751), 1,
      anon_sym_DQUOTE,
    STATE(843), 1,
      sym__soft_line_break,
    ACTIONS(3753), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3747), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(684), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat1,
    ACTIONS(3749), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32017] = 10,
    ACTIONS(3755), 1,
      sym__backslash_escape,
    ACTIONS(3767), 1,
      anon_sym_LPAREN,
    ACTIONS(3770), 1,
      anon_sym_RPAREN,
    ACTIONS(3775), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3777), 1,
      sym__last_token_punctuation,
    ACTIONS(3764), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3773), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3758), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(830), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3761), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [32083] = 10,
    ACTIONS(3779), 1,
      sym__backslash_escape,
    ACTIONS(3788), 1,
      anon_sym_DQUOTE,
    ACTIONS(3793), 1,
      sym__newline_token,
    ACTIONS(3796), 1,
      sym__whitespace_ge_2,
    ACTIONS(3799), 1,
      aux_sym__whitespace_token1,
    STATE(843), 1,
      sym__soft_line_break,
    ACTIONS(3790), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3782), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(683), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat1,
    ACTIONS(3785), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32149] = 10,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3804), 1,
      anon_sym_DQUOTE,
    STATE(843), 1,
      sym__soft_line_break,
    ACTIONS(3753), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3802), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(683), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat1,
    ACTIONS(3749), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32215] = 9,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3646), 1,
      sym__last_token_punctuation,
    ACTIONS(3698), 1,
      anon_sym_LPAREN,
    ACTIONS(3814), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3810), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3812), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3806), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(695), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3808), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [32279] = 10,
    ACTIONS(3816), 1,
      sym__backslash_escape,
    ACTIONS(3828), 1,
      anon_sym_LPAREN,
    ACTIONS(3831), 1,
      anon_sym_RPAREN,
    ACTIONS(3836), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3838), 1,
      sym__last_token_punctuation,
    ACTIONS(3825), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3834), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3819), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(830), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3822), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [32345] = 10,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3751), 1,
      anon_sym_SQUOTE,
    STATE(838), 1,
      sym__soft_line_break,
    ACTIONS(3844), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3840), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(688), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat2,
    ACTIONS(3842), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32411] = 10,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3804), 1,
      anon_sym_SQUOTE,
    STATE(838), 1,
      sym__soft_line_break,
    ACTIONS(3844), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3846), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(689), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat2,
    ACTIONS(3842), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32477] = 10,
    ACTIONS(3848), 1,
      sym__backslash_escape,
    ACTIONS(3860), 1,
      anon_sym_SQUOTE,
    ACTIONS(3862), 1,
      sym__newline_token,
    ACTIONS(3865), 1,
      sym__whitespace_ge_2,
    ACTIONS(3868), 1,
      aux_sym__whitespace_token1,
    STATE(838), 1,
      sym__soft_line_break,
    ACTIONS(3857), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3851), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(689), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat2,
    ACTIONS(3854), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32543] = 6,
    ACTIONS(2884), 1,
      sym__word_no_digit,
    ACTIONS(3871), 1,
      anon_sym_SLASH,
    ACTIONS(3874), 1,
      sym__last_token_punctuation,
    STATE(958), 1,
      sym__tag_name,
    ACTIONS(2713), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 38,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [32600] = 8,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3698), 1,
      anon_sym_LPAREN,
    ACTIONS(3880), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3810), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3878), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3876), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(692), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3808), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [32661] = 8,
    ACTIONS(3882), 1,
      sym__backslash_escape,
    ACTIONS(3894), 1,
      anon_sym_LPAREN,
    ACTIONS(3899), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3891), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3897), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3885), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(692), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3888), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [32722] = 6,
    ACTIONS(2713), 1,
      anon_sym_LT,
    ACTIONS(2896), 1,
      sym__newline_token,
    ACTIONS(2899), 1,
      sym__whitespace_ge_2,
    ACTIONS(2902), 1,
      aux_sym__whitespace_token1,
    STATE(848), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2698), 38,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [32779] = 8,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3698), 1,
      anon_sym_LPAREN,
    ACTIONS(3905), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3810), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3903), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3901), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(691), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3808), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [32840] = 8,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3698), 1,
      anon_sym_LPAREN,
    ACTIONS(3905), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3810), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3903), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3876), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(692), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3808), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [32901] = 10,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3804), 1,
      anon_sym_RPAREN,
    STATE(867), 1,
      sym__soft_line_break,
    ACTIONS(3911), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3907), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(698), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat3,
    ACTIONS(3909), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [32966] = 10,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3604), 1,
      sym__newline_token,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3751), 1,
      anon_sym_RPAREN,
    STATE(867), 1,
      sym__soft_line_break,
    ACTIONS(3911), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3913), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(696), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat3,
    ACTIONS(3909), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [33031] = 10,
    ACTIONS(3915), 1,
      sym__backslash_escape,
    ACTIONS(3927), 1,
      anon_sym_RPAREN,
    ACTIONS(3929), 1,
      sym__newline_token,
    ACTIONS(3932), 1,
      sym__whitespace_ge_2,
    ACTIONS(3935), 1,
      aux_sym__whitespace_token1,
    STATE(867), 1,
      sym__soft_line_break,
    ACTIONS(3924), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3918), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(698), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat3,
    ACTIONS(3921), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [33096] = 8,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3698), 1,
      anon_sym_LPAREN,
    ACTIONS(3814), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3810), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3812), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3806), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(695), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3808), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [33157] = 6,
    ACTIONS(2884), 1,
      sym__word_no_digit,
    ACTIONS(3938), 1,
      anon_sym_SLASH,
    ACTIONS(3941), 1,
      sym__last_token_punctuation,
    STATE(952), 1,
      sym__tag_name,
    ACTIONS(2713), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 38,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [33214] = 6,
    ACTIONS(2713), 1,
      anon_sym_LT,
    ACTIONS(2896), 1,
      sym__newline_token,
    ACTIONS(2899), 1,
      sym__whitespace_ge_2,
    ACTIONS(2902), 1,
      aux_sym__whitespace_token1,
    STATE(846), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2698), 38,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [33271] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3949), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3957), 1,
      sym__last_token_punctuation,
    ACTIONS(3955), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(771), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33333] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3959), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3963), 1,
      sym__last_token_punctuation,
    ACTIONS(3961), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(773), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33395] = 3,
    ACTIONS(3874), 1,
      sym__last_token_punctuation,
    ACTIONS(2713), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [33445] = 3,
    ACTIONS(3965), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [33495] = 3,
    ACTIONS(3941), 1,
      sym__last_token_punctuation,
    ACTIONS(2713), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2698), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [33545] = 3,
    ACTIONS(3967), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [33595] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3969), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3973), 1,
      sym__last_token_punctuation,
    ACTIONS(3971), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(750), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33657] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3975), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3979), 1,
      sym__last_token_punctuation,
    ACTIONS(3977), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(811), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33719] = 8,
    ACTIONS(3981), 1,
      sym__backslash_escape,
    ACTIONS(3990), 1,
      anon_sym_GT,
    ACTIONS(3995), 1,
      sym__whitespace_ge_2,
    ACTIONS(3998), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3992), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3984), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(710), 5,
      sym_backslash_escape,
      sym__text_no_angle,
      sym__whitespace,
      sym__word,
      aux_sym_link_destination_repeat1,
    ACTIONS(3987), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33779] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4001), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4005), 1,
      sym__last_token_punctuation,
    ACTIONS(4003), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(801), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33841] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4007), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4011), 1,
      sym__last_token_punctuation,
    ACTIONS(4009), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(823), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33903] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4013), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4017), 1,
      sym__last_token_punctuation,
    ACTIONS(4015), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(768), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33965] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4019), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4023), 1,
      sym__last_token_punctuation,
    ACTIONS(4021), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(727), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34027] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4025), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4029), 1,
      sym__last_token_punctuation,
    ACTIONS(4027), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(775), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34089] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4031), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4035), 1,
      sym__last_token_punctuation,
    ACTIONS(4033), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(814), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34151] = 6,
    ACTIONS(4041), 1,
      sym__newline_token,
    ACTIONS(4044), 1,
      sym__whitespace_ge_2,
    ACTIONS(4047), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4039), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(717), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(4037), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__word_no_digit,
      sym__digits,
  [34207] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4050), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4054), 1,
      sym__last_token_punctuation,
    ACTIONS(4052), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(822), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34269] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4056), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4060), 1,
      sym__last_token_punctuation,
    ACTIONS(4058), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(761), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34331] = 8,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4066), 1,
      anon_sym_GT,
    ACTIONS(4068), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4062), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(721), 5,
      sym_backslash_escape,
      sym__text_no_angle,
      sym__whitespace,
      sym__word,
      aux_sym_link_destination_repeat1,
    ACTIONS(4064), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34391] = 8,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3606), 1,
      sym__whitespace_ge_2,
    ACTIONS(3608), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4072), 1,
      anon_sym_GT,
    ACTIONS(4068), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4070), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(710), 5,
      sym_backslash_escape,
      sym__text_no_angle,
      sym__whitespace,
      sym__word,
      aux_sym_link_destination_repeat1,
    ACTIONS(4064), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34451] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4074), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4078), 1,
      sym__last_token_punctuation,
    ACTIONS(4076), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(749), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34513] = 9,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4080), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4084), 1,
      sym__last_token_punctuation,
    ACTIONS(4082), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(760), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34575] = 3,
    ACTIONS(4086), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [34625] = 3,
    ACTIONS(4088), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [34675] = 8,
    ACTIONS(4090), 1,
      anon_sym_QMARK,
    ACTIONS(4092), 1,
      sym__newline_token,
    ACTIONS(4094), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4096), 1,
      sym__whitespace_ge_2,
    ACTIONS(4098), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4100), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(809), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2746), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34734] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4050), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34793] = 2,
    ACTIONS(3278), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [34840] = 2,
    ACTIONS(3295), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3293), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [34887] = 2,
    ACTIONS(3299), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3297), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [34934] = 2,
    ACTIONS(3307), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [34981] = 2,
    ACTIONS(3311), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35028] = 2,
    ACTIONS(3414), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3412), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35075] = 2,
    ACTIONS(3410), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3408), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35122] = 2,
    ACTIONS(3406), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3404), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35169] = 2,
    ACTIONS(3402), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3400), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35216] = 2,
    ACTIONS(3126), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3124), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35263] = 2,
    ACTIONS(3373), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3371), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35310] = 2,
    ACTIONS(3369), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3367), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35357] = 2,
    ACTIONS(3361), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3359), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35404] = 2,
    ACTIONS(3357), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3355), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35451] = 2,
    ACTIONS(3210), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3208), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35498] = 2,
    ACTIONS(3206), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3204), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35545] = 2,
    ACTIONS(3202), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3200), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35592] = 2,
    ACTIONS(3260), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3258), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35639] = 2,
    ACTIONS(3264), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3262), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35686] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4104), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35745] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4106), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4108), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(747), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35804] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4106), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35863] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4074), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35922] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4074), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4076), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(749), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35981] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4110), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36040] = 8,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(4112), 1,
      sym__newline_token,
    ACTIONS(4114), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(4116), 1,
      sym__whitespace_ge_2,
    ACTIONS(4118), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4120), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2700), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36099] = 8,
    ACTIONS(4090), 1,
      anon_sym_QMARK,
    ACTIONS(4092), 1,
      sym__newline_token,
    ACTIONS(4096), 1,
      sym__whitespace_ge_2,
    ACTIONS(4098), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4122), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4100), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(809), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2746), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36158] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3969), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3971), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(750), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36217] = 2,
    ACTIONS(3256), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3254), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [36264] = 8,
    ACTIONS(4127), 1,
      anon_sym_DASH,
    ACTIONS(4130), 1,
      sym__newline_token,
    ACTIONS(4133), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4135), 1,
      sym__whitespace_ge_2,
    ACTIONS(4138), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4141), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(4124), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36323] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4144), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36382] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4146), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4148), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(758), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36441] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4146), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36500] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4080), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36559] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4080), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4082), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(760), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36618] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3949), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3955), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(771), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36677] = 8,
    ACTIONS(4090), 1,
      anon_sym_QMARK,
    ACTIONS(4092), 1,
      sym__newline_token,
    ACTIONS(4096), 1,
      sym__whitespace_ge_2,
    ACTIONS(4098), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4150), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4100), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(809), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2746), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36736] = 8,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(4112), 1,
      sym__newline_token,
    ACTIONS(4116), 1,
      sym__whitespace_ge_2,
    ACTIONS(4118), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4152), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(4120), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2700), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36795] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4154), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4156), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(752), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36854] = 8,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(4112), 1,
      sym__newline_token,
    ACTIONS(4116), 1,
      sym__whitespace_ge_2,
    ACTIONS(4118), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4158), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(4120), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2700), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36913] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3959), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36972] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4056), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4058), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(761), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37031] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4025), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4027), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(775), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37090] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4025), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37149] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4013), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4015), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(768), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37208] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4154), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37267] = 8,
    ACTIONS(4090), 1,
      anon_sym_QMARK,
    ACTIONS(4092), 1,
      sym__newline_token,
    ACTIONS(4096), 1,
      sym__whitespace_ge_2,
    ACTIONS(4098), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4160), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4100), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(809), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2746), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37326] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4162), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37385] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4162), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4164), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(780), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37444] = 8,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(4112), 1,
      sym__newline_token,
    ACTIONS(4116), 1,
      sym__whitespace_ge_2,
    ACTIONS(4118), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4166), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(4120), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2700), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37503] = 2,
    ACTIONS(3194), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3192), 40,
      sym__latex_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37550] = 2,
    ACTIONS(3210), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3208), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37597] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4168), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37656] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3959), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3961), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(773), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37715] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4001), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4003), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(801), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37774] = 2,
    ACTIONS(3264), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3262), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37821] = 2,
    ACTIONS(3260), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3258), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37868] = 2,
    ACTIONS(3202), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3200), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37915] = 2,
    ACTIONS(3206), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3204), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37962] = 8,
    ACTIONS(4090), 1,
      anon_sym_QMARK,
    ACTIONS(4092), 1,
      sym__newline_token,
    ACTIONS(4096), 1,
      sym__whitespace_ge_2,
    ACTIONS(4098), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4170), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4100), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(809), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2746), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [38021] = 2,
    ACTIONS(3357), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3355), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38068] = 2,
    ACTIONS(3361), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3359), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38115] = 8,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(4112), 1,
      sym__newline_token,
    ACTIONS(4116), 1,
      sym__whitespace_ge_2,
    ACTIONS(4118), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4172), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(4120), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2700), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [38174] = 2,
    ACTIONS(3369), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3367), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38221] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4031), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4033), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(814), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [38280] = 8,
    ACTIONS(4090), 1,
      anon_sym_QMARK,
    ACTIONS(4092), 1,
      sym__newline_token,
    ACTIONS(4096), 1,
      sym__whitespace_ge_2,
    ACTIONS(4098), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4174), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4100), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(809), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2746), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [38339] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4007), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4009), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(823), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [38398] = 8,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(4112), 1,
      sym__newline_token,
    ACTIONS(4116), 1,
      sym__whitespace_ge_2,
    ACTIONS(4118), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4176), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(4120), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2700), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [38457] = 2,
    ACTIONS(3373), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3371), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38504] = 2,
    ACTIONS(3126), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3124), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38551] = 2,
    ACTIONS(3402), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3400), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38598] = 8,
    ACTIONS(4181), 1,
      anon_sym_RBRACK,
    ACTIONS(4184), 1,
      sym__newline_token,
    ACTIONS(4187), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(4189), 1,
      sym__whitespace_ge_2,
    ACTIONS(4192), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4195), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(4178), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [38657] = 2,
    ACTIONS(3406), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3404), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38704] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4007), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [38763] = 2,
    ACTIONS(3410), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3408), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38810] = 2,
    ACTIONS(3414), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3412), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38857] = 2,
    ACTIONS(3311), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38904] = 2,
    ACTIONS(3307), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38951] = 2,
    ACTIONS(3299), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3297), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38998] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4050), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4052), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(822), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39057] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4198), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39116] = 8,
    ACTIONS(4187), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4203), 1,
      anon_sym_QMARK,
    ACTIONS(4206), 1,
      sym__newline_token,
    ACTIONS(4209), 1,
      sym__whitespace_ge_2,
    ACTIONS(4212), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4215), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(809), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(4200), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39175] = 8,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    ACTIONS(4112), 1,
      sym__newline_token,
    ACTIONS(4116), 1,
      sym__whitespace_ge_2,
    ACTIONS(4118), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4218), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(4120), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2700), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39234] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4220), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39293] = 2,
    ACTIONS(3295), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3293), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39340] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3975), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3977), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(811), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39399] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3975), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39458] = 2,
    ACTIONS(3278), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39505] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4220), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4222), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(826), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39564] = 2,
    ACTIONS(3256), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3254), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39611] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4224), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4226), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(808), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39670] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4228), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39729] = 2,
    ACTIONS(3194), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3192), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39776] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4230), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4232), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(819), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39835] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4230), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39894] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4224), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [39953] = 8,
    ACTIONS(4090), 1,
      anon_sym_QMARK,
    ACTIONS(4092), 1,
      sym__newline_token,
    ACTIONS(4096), 1,
      sym__whitespace_ge_2,
    ACTIONS(4098), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4234), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4100), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(809), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2746), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40012] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4019), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4021), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(727), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40071] = 8,
    ACTIONS(3945), 1,
      anon_sym_DASH,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4236), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(4102), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(757), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3943), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40130] = 7,
    ACTIONS(4240), 1,
      anon_sym_DQUOTE,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4248), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(853), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat2,
    ACTIONS(4238), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40186] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4252), 1,
      anon_sym_GT,
    ACTIONS(4254), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(855), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40242] = 6,
    ACTIONS(4262), 1,
      anon_sym_LPAREN,
    ACTIONS(4266), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4268), 1,
      sym__last_token_punctuation,
    ACTIONS(4259), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4264), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4256), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__word_no_digit,
      sym__digits,
  [40296] = 7,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3698), 1,
      anon_sym_LPAREN,
    ACTIONS(4270), 1,
      anon_sym_RPAREN,
    ACTIONS(3810), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3876), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(692), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3808), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [40352] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4272), 1,
      anon_sym_GT,
    ACTIONS(4254), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(855), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40408] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4274), 1,
      anon_sym_GT,
    ACTIONS(4254), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(855), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40464] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4276), 1,
      anon_sym_GT,
    ACTIONS(4254), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(855), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40520] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4278), 1,
      anon_sym_GT,
    ACTIONS(4254), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(855), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40576] = 7,
    ACTIONS(4283), 1,
      anon_sym_SQUOTE,
    ACTIONS(4285), 1,
      sym__newline_token,
    ACTIONS(4288), 1,
      sym__whitespace_ge_2,
    ACTIONS(4291), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4294), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(835), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat1,
    ACTIONS(4280), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40632] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4297), 1,
      anon_sym_GT,
    ACTIONS(4299), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(831), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40688] = 7,
    ACTIONS(4304), 1,
      anon_sym_DQUOTE,
    ACTIONS(4306), 1,
      sym__newline_token,
    ACTIONS(4309), 1,
      sym__whitespace_ge_2,
    ACTIONS(4312), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4315), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(837), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat2,
    ACTIONS(4301), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40744] = 4,
    ACTIONS(4318), 1,
      sym__newline_token,
    STATE(1143), 1,
      sym__soft_line_break,
    ACTIONS(3836), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3834), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40794] = 3,
    ACTIONS(3838), 1,
      sym__last_token_punctuation,
    ACTIONS(3836), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3834), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40842] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4321), 1,
      anon_sym_GT,
    ACTIONS(4323), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(834), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40898] = 3,
    ACTIONS(4331), 1,
      sym__last_token_punctuation,
    ACTIONS(4328), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4325), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40946] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4333), 1,
      anon_sym_GT,
    ACTIONS(4254), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(855), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41002] = 4,
    ACTIONS(4335), 1,
      sym__newline_token,
    STATE(1136), 1,
      sym__soft_line_break,
    ACTIONS(3775), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3773), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [41052] = 3,
    ACTIONS(3777), 1,
      sym__last_token_punctuation,
    ACTIONS(3775), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3773), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [41100] = 5,
    ACTIONS(4343), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4346), 1,
      sym__last_token_punctuation,
    ACTIONS(4338), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4340), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4262), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      sym__word_no_digit,
      sym__digits,
  [41152] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4348), 1,
      anon_sym_GT,
    ACTIONS(4350), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(832), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41208] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4352), 1,
      anon_sym_GT,
    ACTIONS(4254), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(855), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41264] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4354), 1,
      anon_sym_GT,
    ACTIONS(4356), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(842), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41320] = 3,
    ACTIONS(4364), 1,
      sym__last_token_punctuation,
    ACTIONS(4361), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4358), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [41368] = 3,
    ACTIONS(4366), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [41416] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4370), 1,
      anon_sym_SQUOTE,
    ACTIONS(4372), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(835), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat1,
    ACTIONS(4368), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41472] = 7,
    ACTIONS(3586), 1,
      sym__backslash_escape,
    ACTIONS(3698), 1,
      anon_sym_LPAREN,
    ACTIONS(4376), 1,
      anon_sym_RPAREN,
    ACTIONS(3810), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4374), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(830), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3808), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [41528] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4370), 1,
      anon_sym_DQUOTE,
    ACTIONS(4378), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(837), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat2,
    ACTIONS(4238), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41584] = 7,
    ACTIONS(4240), 1,
      anon_sym_SQUOTE,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4380), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(851), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat1,
    ACTIONS(4368), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41640] = 7,
    ACTIONS(4385), 1,
      anon_sym_GT,
    ACTIONS(4387), 1,
      sym__newline_token,
    ACTIONS(4390), 1,
      sym__whitespace_ge_2,
    ACTIONS(4393), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4396), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(855), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4382), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41696] = 3,
    ACTIONS(4346), 1,
      sym__last_token_punctuation,
    ACTIONS(4338), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4262), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [41744] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4399), 1,
      anon_sym_GT,
    ACTIONS(4401), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(828), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41800] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4403), 1,
      anon_sym_GT,
    ACTIONS(4405), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(833), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41856] = 3,
    ACTIONS(4407), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [41904] = 7,
    ACTIONS(4242), 1,
      sym__newline_token,
    ACTIONS(4244), 1,
      sym__whitespace_ge_2,
    ACTIONS(4246), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4409), 1,
      anon_sym_GT,
    ACTIONS(4411), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(847), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4250), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [41960] = 2,
    ACTIONS(4413), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3860), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42005] = 2,
    ACTIONS(4415), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3788), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42050] = 2,
    ACTIONS(3365), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3363), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42095] = 2,
    ACTIONS(4419), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4417), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42140] = 5,
    ACTIONS(4262), 1,
      anon_sym_LPAREN,
    ACTIONS(4266), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4259), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4264), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4256), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__word_no_digit,
      sym__digits,
  [42191] = 4,
    ACTIONS(4428), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4423), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4425), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4421), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      sym__word_no_digit,
      sym__digits,
  [42240] = 4,
    ACTIONS(4431), 1,
      sym__newline_token,
    STATE(1158), 1,
      sym__soft_line_break,
    ACTIONS(4266), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4264), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42289] = 2,
    ACTIONS(4361), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4358), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42334] = 5,
    ACTIONS(3897), 1,
      anon_sym_LPAREN,
    ACTIONS(4440), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3927), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4437), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4434), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__word_no_digit,
      sym__digits,
  [42385] = 2,
    ACTIONS(3899), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3897), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42430] = 2,
    ACTIONS(4423), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4421), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42475] = 2,
    ACTIONS(4444), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4442), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42520] = 3,
    ACTIONS(4446), 1,
      sym__last_token_punctuation,
    ACTIONS(4266), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4264), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42567] = 2,
    ACTIONS(4450), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4448), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42612] = 2,
    ACTIONS(3311), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42657] = 2,
    ACTIONS(4455), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4452), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42702] = 2,
    ACTIONS(3278), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42747] = 2,
    ACTIONS(4328), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4325), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42792] = 2,
    ACTIONS(4461), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4458), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42837] = 2,
    ACTIONS(4440), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3927), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42881] = 2,
    ACTIONS(4466), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4464), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42925] = 3,
    ACTIONS(4472), 1,
      sym__last_token_punctuation,
    ACTIONS(4470), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(4468), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [42971] = 3,
    ACTIONS(4476), 1,
      sym__last_token_punctuation,
    ACTIONS(4474), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(4133), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43017] = 3,
    ACTIONS(4482), 1,
      sym__last_token_punctuation,
    ACTIONS(4480), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4478), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43063] = 3,
    ACTIONS(4484), 1,
      sym__last_token_punctuation,
    ACTIONS(4470), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(4468), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43109] = 3,
    ACTIONS(4486), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43155] = 3,
    ACTIONS(4488), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43201] = 3,
    ACTIONS(4490), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43247] = 3,
    ACTIONS(4496), 1,
      sym__last_token_punctuation,
    ACTIONS(4494), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(4492), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43293] = 3,
    ACTIONS(4498), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43339] = 3,
    ACTIONS(4500), 1,
      sym__last_token_whitespace,
    ACTIONS(2877), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(2875), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43385] = 3,
    ACTIONS(4502), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(2973), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43431] = 6,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4496), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(907), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(4504), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [43483] = 2,
    ACTIONS(3278), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43526] = 2,
    ACTIONS(3311), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43569] = 3,
    ACTIONS(4508), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4510), 1,
      sym__last_token_punctuation,
    ACTIONS(4506), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43614] = 2,
    ACTIONS(3278), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43657] = 2,
    ACTIONS(4512), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(4187), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43700] = 2,
    ACTIONS(4516), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4514), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43743] = 2,
    ACTIONS(3311), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43786] = 3,
    ACTIONS(4520), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4522), 1,
      sym__last_token_punctuation,
    ACTIONS(4518), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43831] = 2,
    ACTIONS(3278), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43874] = 2,
    ACTIONS(3311), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43917] = 2,
    ACTIONS(4526), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(4524), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [43960] = 2,
    ACTIONS(4512), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(4187), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44003] = 3,
    ACTIONS(4530), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4532), 1,
      sym__last_token_punctuation,
    ACTIONS(4528), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44048] = 2,
    ACTIONS(4474), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(4133), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44091] = 3,
    ACTIONS(2877), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4534), 1,
      sym__last_token_whitespace,
    ACTIONS(2875), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44136] = 3,
    ACTIONS(2975), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4536), 1,
      sym__last_token_whitespace,
    ACTIONS(2973), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44181] = 2,
    ACTIONS(4538), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4304), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44223] = 2,
    ACTIONS(4540), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4283), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44265] = 2,
    ACTIONS(3311), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44307] = 2,
    ACTIONS(3278), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44349] = 2,
    ACTIONS(4542), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4385), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [44391] = 1,
    ACTIONS(4544), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [44425] = 1,
    ACTIONS(4546), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [44459] = 1,
    ACTIONS(4548), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [44493] = 1,
    ACTIONS(4550), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [44527] = 1,
    ACTIONS(4552), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [44561] = 1,
    ACTIONS(4554), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [44595] = 1,
    ACTIONS(4556), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [44629] = 5,
    ACTIONS(4558), 1,
      sym__newline_token,
    ACTIONS(4561), 1,
      sym__whitespace_ge_2,
    ACTIONS(4564), 1,
      aux_sym__whitespace_token1,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(4037), 6,
      anon_sym_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [44652] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
    STATE(1003), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44682] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4575), 1,
      anon_sym_RPAREN,
    STATE(1039), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44712] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4577), 1,
      anon_sym_RPAREN,
    STATE(1085), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44742] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4579), 1,
      anon_sym_RPAREN,
    STATE(1018), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44772] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4581), 1,
      anon_sym_RPAREN,
    STATE(1025), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44802] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
    STATE(988), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44832] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4585), 1,
      anon_sym_RPAREN,
    STATE(1072), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44862] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4587), 1,
      anon_sym_RPAREN,
    STATE(1089), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44892] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4589), 1,
      anon_sym_RPAREN,
    STATE(1021), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44922] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4591), 1,
      anon_sym_RPAREN,
    STATE(1028), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44952] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4593), 1,
      anon_sym_RPAREN,
    STATE(1086), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44982] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4595), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45012] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4597), 1,
      anon_sym_RPAREN,
    STATE(1078), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45042] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4599), 1,
      anon_sym_RPAREN,
    STATE(1066), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45072] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4601), 1,
      anon_sym_RPAREN,
    STATE(1004), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45102] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4603), 1,
      anon_sym_RPAREN,
    STATE(981), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45132] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4605), 1,
      anon_sym_RPAREN,
    STATE(982), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45162] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_RPAREN,
    STATE(1011), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45192] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4609), 1,
      anon_sym_RPAREN,
    STATE(1013), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45222] = 9,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_DQUOTE,
    ACTIONS(4569), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_LPAREN,
    ACTIONS(4611), 1,
      anon_sym_RPAREN,
    STATE(1067), 1,
      sym_link_title,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45252] = 7,
    ACTIONS(4613), 1,
      anon_sym_GT,
    ACTIONS(4615), 1,
      anon_sym_SLASH,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    STATE(944), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(963), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45277] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4623), 1,
      anon_sym_GT,
    ACTIONS(4625), 1,
      anon_sym_SLASH,
    STATE(956), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(972), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45302] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4627), 1,
      anon_sym_GT,
    ACTIONS(4629), 1,
      anon_sym_SLASH,
    STATE(949), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(976), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45327] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4631), 1,
      anon_sym_GT,
    ACTIONS(4633), 1,
      anon_sym_SLASH,
    STATE(950), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(977), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45352] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4635), 1,
      anon_sym_GT,
    ACTIONS(4637), 1,
      anon_sym_SLASH,
    STATE(956), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(970), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45377] = 8,
    ACTIONS(4639), 1,
      anon_sym_DQUOTE,
    ACTIONS(4641), 1,
      anon_sym_SQUOTE,
    ACTIONS(4643), 1,
      sym__newline_token,
    ACTIONS(4645), 1,
      aux_sym__attribute_value_token1,
    ACTIONS(4647), 1,
      sym__whitespace_ge_2,
    ACTIONS(4649), 1,
      aux_sym__whitespace_token1,
    STATE(1110), 1,
      sym__attribute_value,
    STATE(975), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45404] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4651), 1,
      anon_sym_GT,
    ACTIONS(4653), 1,
      anon_sym_SLASH,
    STATE(956), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(980), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45429] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4655), 1,
      anon_sym_GT,
    ACTIONS(4657), 1,
      anon_sym_SLASH,
    STATE(956), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(968), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45454] = 8,
    ACTIONS(4639), 1,
      anon_sym_DQUOTE,
    ACTIONS(4641), 1,
      anon_sym_SQUOTE,
    ACTIONS(4643), 1,
      sym__newline_token,
    ACTIONS(4647), 1,
      sym__whitespace_ge_2,
    ACTIONS(4649), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4659), 1,
      aux_sym__attribute_value_token1,
    STATE(1106), 1,
      sym__attribute_value,
    STATE(948), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45481] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4661), 1,
      anon_sym_GT,
    ACTIONS(4663), 1,
      anon_sym_SLASH,
    STATE(954), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(962), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45506] = 8,
    ACTIONS(4639), 1,
      anon_sym_DQUOTE,
    ACTIONS(4641), 1,
      anon_sym_SQUOTE,
    ACTIONS(4643), 1,
      sym__newline_token,
    ACTIONS(4647), 1,
      sym__whitespace_ge_2,
    ACTIONS(4649), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4659), 1,
      aux_sym__attribute_value_token1,
    STATE(1106), 1,
      sym__attribute_value,
    STATE(975), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45533] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4665), 1,
      anon_sym_GT,
    ACTIONS(4667), 1,
      anon_sym_SLASH,
    STATE(956), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(973), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45558] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4669), 1,
      anon_sym_GT,
    ACTIONS(4671), 1,
      anon_sym_SLASH,
    STATE(947), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(978), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45583] = 6,
    ACTIONS(4675), 1,
      sym__newline_token,
    ACTIONS(4678), 1,
      sym__whitespace_ge_2,
    ACTIONS(4681), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4673), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    STATE(956), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(1029), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45606] = 8,
    ACTIONS(4639), 1,
      anon_sym_DQUOTE,
    ACTIONS(4641), 1,
      anon_sym_SQUOTE,
    ACTIONS(4643), 1,
      sym__newline_token,
    ACTIONS(4647), 1,
      sym__whitespace_ge_2,
    ACTIONS(4649), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4684), 1,
      aux_sym__attribute_value_token1,
    STATE(1107), 1,
      sym__attribute_value,
    STATE(953), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45633] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4686), 1,
      anon_sym_GT,
    ACTIONS(4688), 1,
      anon_sym_SLASH,
    STATE(960), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(967), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45658] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4690), 1,
      anon_sym_GT,
    ACTIONS(4692), 1,
      anon_sym_SLASH,
    STATE(956), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(974), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45683] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4694), 1,
      anon_sym_GT,
    ACTIONS(4696), 1,
      anon_sym_SLASH,
    STATE(956), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(966), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45708] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4698), 1,
      anon_sym_GT,
    ACTIONS(4700), 1,
      anon_sym_SLASH,
    STATE(959), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(969), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45733] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4665), 1,
      anon_sym_GT,
    ACTIONS(4667), 1,
      anon_sym_SLASH,
    ACTIONS(4702), 1,
      sym__attribute_name,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45757] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4623), 1,
      anon_sym_GT,
    ACTIONS(4625), 1,
      anon_sym_SLASH,
    ACTIONS(4702), 1,
      sym__attribute_name,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45781] = 4,
    ACTIONS(4708), 1,
      aux_sym__whitespace_token1,
    STATE(979), 1,
      aux_sym__tag_name_repeat1,
    ACTIONS(4706), 3,
      anon_sym_DASH,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(4704), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [45799] = 5,
    ACTIONS(4710), 1,
      sym__newline_token,
    ACTIONS(4713), 1,
      sym__whitespace_ge_2,
    ACTIONS(4716), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4037), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__attribute_name,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45819] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4702), 1,
      sym__attribute_name,
    ACTIONS(4719), 1,
      anon_sym_GT,
    ACTIONS(4721), 1,
      anon_sym_SLASH,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45843] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4694), 1,
      anon_sym_GT,
    ACTIONS(4696), 1,
      anon_sym_SLASH,
    ACTIONS(4702), 1,
      sym__attribute_name,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45867] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4702), 1,
      sym__attribute_name,
    ACTIONS(4723), 1,
      anon_sym_GT,
    ACTIONS(4725), 1,
      anon_sym_SLASH,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45891] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4690), 1,
      anon_sym_GT,
    ACTIONS(4692), 1,
      anon_sym_SLASH,
    ACTIONS(4702), 1,
      sym__attribute_name,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45915] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4702), 1,
      sym__attribute_name,
    ACTIONS(4727), 1,
      anon_sym_GT,
    ACTIONS(4729), 1,
      anon_sym_SLASH,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45939] = 4,
    ACTIONS(4736), 1,
      aux_sym__whitespace_token1,
    STATE(971), 1,
      aux_sym__tag_name_repeat1,
    ACTIONS(4733), 3,
      anon_sym_DASH,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(4731), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [45957] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4702), 1,
      sym__attribute_name,
    ACTIONS(4738), 1,
      anon_sym_GT,
    ACTIONS(4740), 1,
      anon_sym_SLASH,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [45981] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4702), 1,
      sym__attribute_name,
    ACTIONS(4742), 1,
      anon_sym_GT,
    ACTIONS(4744), 1,
      anon_sym_SLASH,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46005] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4702), 1,
      sym__attribute_name,
    ACTIONS(4746), 1,
      anon_sym_GT,
    ACTIONS(4748), 1,
      anon_sym_SLASH,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46029] = 5,
    ACTIONS(4750), 1,
      sym__newline_token,
    ACTIONS(4753), 1,
      sym__whitespace_ge_2,
    ACTIONS(4756), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4037), 3,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      aux_sym__attribute_value_token1,
    STATE(975), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46049] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4651), 1,
      anon_sym_GT,
    ACTIONS(4653), 1,
      anon_sym_SLASH,
    ACTIONS(4702), 1,
      sym__attribute_name,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46073] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4655), 1,
      anon_sym_GT,
    ACTIONS(4657), 1,
      anon_sym_SLASH,
    ACTIONS(4702), 1,
      sym__attribute_name,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46097] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4635), 1,
      anon_sym_GT,
    ACTIONS(4637), 1,
      anon_sym_SLASH,
    ACTIONS(4702), 1,
      sym__attribute_name,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46121] = 4,
    ACTIONS(4763), 1,
      aux_sym__whitespace_token1,
    STATE(971), 1,
      aux_sym__tag_name_repeat1,
    ACTIONS(4761), 3,
      anon_sym_DASH,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(4759), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [46139] = 7,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4702), 1,
      sym__attribute_name,
    ACTIONS(4765), 1,
      anon_sym_GT,
    ACTIONS(4767), 1,
      anon_sym_SLASH,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46163] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4609), 1,
      anon_sym_RPAREN,
    STATE(1012), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46181] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4769), 1,
      anon_sym_RPAREN,
    STATE(1073), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46199] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4589), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46217] = 5,
    ACTIONS(3616), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(938), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46235] = 5,
    ACTIONS(3616), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(999), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46253] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
    STATE(926), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46271] = 3,
    ACTIONS(2877), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4771), 1,
      sym__last_token_whitespace,
    ACTIONS(2875), 5,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__attribute_name,
      sym__whitespace_ge_2,
  [46285] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4579), 1,
      anon_sym_RPAREN,
    STATE(1017), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46303] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4579), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46321] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4773), 1,
      anon_sym_GT,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46339] = 3,
    ACTIONS(2877), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4775), 1,
      sym__last_token_whitespace,
    ACTIONS(2875), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__newline_token,
      aux_sym__attribute_value_token1,
      sym__whitespace_ge_2,
  [46353] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
    STATE(989), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46371] = 3,
    ACTIONS(2975), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4777), 1,
      sym__last_token_whitespace,
    ACTIONS(2973), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__newline_token,
      aux_sym__attribute_value_token1,
      sym__whitespace_ge_2,
  [46385] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4779), 1,
      anon_sym_GT,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46403] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4601), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46421] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4601), 1,
      anon_sym_RPAREN,
    STATE(940), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46439] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4601), 1,
      anon_sym_RPAREN,
    STATE(1006), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46457] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46475] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4603), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46493] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4603), 1,
      anon_sym_RPAREN,
    STATE(941), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46511] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4603), 1,
      anon_sym_RPAREN,
    STATE(1009), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46529] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4781), 1,
      anon_sym_GT,
    STATE(1061), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46547] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4577), 1,
      anon_sym_RPAREN,
    STATE(1092), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46565] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4607), 1,
      anon_sym_RPAREN,
    STATE(1010), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46583] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46601] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4607), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46619] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4577), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46637] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
    STATE(925), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46655] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4609), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46673] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4783), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46691] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4783), 1,
      anon_sym_RPAREN,
    STATE(1014), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46709] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4785), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46727] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4785), 1,
      anon_sym_RPAREN,
    STATE(1015), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46745] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4787), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46763] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4789), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46781] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
    STATE(1007), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46799] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4791), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46817] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4791), 1,
      anon_sym_RPAREN,
    STATE(1084), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46835] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4793), 1,
      anon_sym_GT,
    STATE(1057), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46853] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4575), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46871] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4591), 1,
      anon_sym_RPAREN,
    STATE(1034), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46889] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4591), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46907] = 5,
    ACTIONS(3668), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(998), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46925] = 5,
    ACTIONS(3668), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(923), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46943] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4575), 1,
      anon_sym_RPAREN,
    STATE(1038), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46961] = 5,
    ACTIONS(3666), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(1005), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46979] = 5,
    ACTIONS(3666), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(928), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [46997] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4795), 1,
      anon_sym_RPAREN,
    STATE(1044), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47015] = 5,
    ACTIONS(4617), 1,
      sym__newline_token,
    ACTIONS(4619), 1,
      sym__whitespace_ge_2,
    ACTIONS(4621), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4702), 1,
      sym__attribute_name,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47033] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4797), 1,
      anon_sym_GT,
    STATE(994), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47051] = 5,
    ACTIONS(3614), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(930), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47069] = 5,
    ACTIONS(3614), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(1098), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47087] = 5,
    ACTIONS(3662), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(931), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47105] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4795), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47123] = 3,
    ACTIONS(2975), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4799), 1,
      sym__last_token_whitespace,
    ACTIONS(2973), 5,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__attribute_name,
      sym__whitespace_ge_2,
  [47137] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4801), 1,
      anon_sym_GT,
    STATE(1048), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47155] = 5,
    ACTIONS(3662), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(983), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47173] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4803), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47191] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4803), 1,
      anon_sym_RPAREN,
    STATE(1051), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47209] = 5,
    ACTIONS(3612), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(927), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47227] = 5,
    ACTIONS(3612), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(1093), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47245] = 5,
    ACTIONS(3648), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(934), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47263] = 5,
    ACTIONS(3648), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(1054), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47281] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4805), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47299] = 5,
    ACTIONS(3664), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(936), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47317] = 5,
    ACTIONS(3664), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(1058), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47335] = 5,
    ACTIONS(3652), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(933), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47353] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4807), 1,
      anon_sym_GT,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47371] = 5,
    ACTIONS(3652), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(1099), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47389] = 5,
    ACTIONS(3610), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(937), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47407] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4809), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47425] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4811), 1,
      anon_sym_EQ,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47443] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4813), 1,
      anon_sym_GT,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47461] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4595), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47479] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4595), 1,
      anon_sym_RPAREN,
    STATE(939), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47497] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4595), 1,
      anon_sym_RPAREN,
    STATE(1065), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47515] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4815), 1,
      anon_sym_GT,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47533] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4599), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47551] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4599), 1,
      anon_sym_RPAREN,
    STATE(929), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47569] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4599), 1,
      anon_sym_RPAREN,
    STATE(1068), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47587] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4817), 1,
      anon_sym_GT,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47605] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4819), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47623] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4605), 1,
      anon_sym_RPAREN,
    STATE(1069), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47641] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4821), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47659] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4605), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47677] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4585), 1,
      anon_sym_RPAREN,
    STATE(1071), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47695] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4823), 1,
      anon_sym_RPAREN,
    STATE(1062), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47713] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4585), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47731] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4769), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47749] = 5,
    ACTIONS(3610), 1,
      anon_sym_RPAREN,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    STATE(995), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47767] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4825), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47785] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4825), 1,
      anon_sym_RPAREN,
    STATE(1074), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47803] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4827), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47821] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4829), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47839] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4589), 1,
      anon_sym_RPAREN,
    STATE(932), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47857] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4831), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47875] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4823), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47893] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4833), 1,
      anon_sym_RPAREN,
    STATE(1064), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47911] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4833), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47929] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4611), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47947] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4835), 1,
      anon_sym_GT,
    STATE(1090), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47965] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4581), 1,
      anon_sym_RPAREN,
    STATE(1020), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [47983] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4589), 1,
      anon_sym_RPAREN,
    STATE(1022), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48001] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4837), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48019] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4839), 1,
      anon_sym_RPAREN,
    STATE(1076), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48037] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4611), 1,
      anon_sym_RPAREN,
    STATE(1077), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48055] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4597), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48073] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4841), 1,
      anon_sym_EQ,
    STATE(1052), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48091] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4597), 1,
      anon_sym_RPAREN,
    STATE(1079), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48109] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4843), 1,
      anon_sym_GT,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48127] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4581), 1,
      anon_sym_RPAREN,
    STATE(924), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48145] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4839), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48163] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4581), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48181] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4593), 1,
      anon_sym_RPAREN,
    STATE(1080), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48199] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4845), 1,
      anon_sym_GT,
    STATE(990), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48217] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4593), 1,
      anon_sym_RPAREN,
    STATE(942), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48235] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4847), 1,
      anon_sym_GT,
    STATE(1053), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48253] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4587), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48271] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4593), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48289] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4587), 1,
      anon_sym_RPAREN,
    STATE(1087), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48307] = 5,
    ACTIONS(3947), 1,
      sym__newline_token,
    ACTIONS(3951), 1,
      sym__whitespace_ge_2,
    ACTIONS(3953), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4587), 1,
      anon_sym_RPAREN,
    STATE(935), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [48325] = 2,
    ACTIONS(3278), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 5,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__attribute_name,
      sym__whitespace_ge_2,
  [48336] = 2,
    ACTIONS(3311), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__newline_token,
      aux_sym__attribute_value_token1,
      sym__whitespace_ge_2,
  [48347] = 2,
    ACTIONS(3311), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 5,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__attribute_name,
      sym__whitespace_ge_2,
  [48358] = 2,
    ACTIONS(3278), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3276), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__newline_token,
      aux_sym__attribute_value_token1,
      sym__whitespace_ge_2,
  [48369] = 2,
    ACTIONS(4851), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4849), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [48379] = 2,
    ACTIONS(4855), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4853), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [48389] = 2,
    ACTIONS(4859), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4857), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [48399] = 2,
    ACTIONS(4863), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4861), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [48409] = 2,
    ACTIONS(4867), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4865), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [48419] = 2,
    ACTIONS(3905), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3903), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
  [48428] = 2,
    ACTIONS(4871), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4869), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
  [48437] = 2,
    ACTIONS(3880), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3878), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
  [48446] = 2,
    ACTIONS(4875), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4873), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
  [48455] = 3,
    ACTIONS(4877), 1,
      anon_sym_LBRACK,
    ACTIONS(4879), 1,
      anon_sym_LPAREN,
    STATE(448), 1,
      sym_link_label,
  [48465] = 3,
    ACTIONS(4881), 1,
      anon_sym_LBRACK,
    ACTIONS(4883), 1,
      anon_sym_LPAREN,
    STATE(516), 1,
      sym_link_label,
  [48475] = 3,
    ACTIONS(4885), 1,
      anon_sym_LBRACK,
    ACTIONS(4887), 1,
      anon_sym_LPAREN,
    STATE(517), 1,
      sym_link_label,
  [48485] = 3,
    ACTIONS(4889), 1,
      anon_sym_LBRACK,
    ACTIONS(4891), 1,
      anon_sym_LPAREN,
    STATE(364), 1,
      sym_link_label,
  [48495] = 3,
    ACTIONS(4893), 1,
      anon_sym_LBRACK,
    ACTIONS(4895), 1,
      anon_sym_LPAREN,
    STATE(449), 1,
      sym_link_label,
  [48505] = 3,
    ACTIONS(4897), 1,
      anon_sym_LBRACK,
    ACTIONS(4899), 1,
      anon_sym_LPAREN,
    STATE(315), 1,
      sym_link_label,
  [48515] = 3,
    ACTIONS(4901), 1,
      anon_sym_LBRACK,
    ACTIONS(4903), 1,
      anon_sym_LPAREN,
    STATE(583), 1,
      sym_link_label,
  [48525] = 3,
    ACTIONS(4905), 1,
      anon_sym_LBRACK,
    ACTIONS(4907), 1,
      anon_sym_LPAREN,
    STATE(536), 1,
      sym_link_label,
  [48535] = 3,
    ACTIONS(4909), 1,
      anon_sym_LBRACK,
    ACTIONS(4911), 1,
      anon_sym_LPAREN,
    STATE(365), 1,
      sym_link_label,
  [48545] = 3,
    ACTIONS(4913), 1,
      anon_sym_LBRACK,
    ACTIONS(4915), 1,
      anon_sym_LPAREN,
    STATE(360), 1,
      sym_link_label,
  [48555] = 2,
    ACTIONS(4917), 1,
      sym__word_no_digit,
    STATE(1002), 1,
      sym__tag_name,
  [48562] = 2,
    ACTIONS(4917), 1,
      sym__word_no_digit,
    STATE(1019), 1,
      sym__tag_name,
  [48569] = 2,
    ACTIONS(4917), 1,
      sym__word_no_digit,
    STATE(1095), 1,
      sym__tag_name,
  [48576] = 2,
    ACTIONS(4917), 1,
      sym__word_no_digit,
    STATE(1097), 1,
      sym__tag_name,
  [48583] = 2,
    ACTIONS(2973), 1,
      sym__trigger_error,
    ACTIONS(4919), 1,
      sym__last_token_whitespace,
  [48590] = 2,
    ACTIONS(4917), 1,
      sym__word_no_digit,
    STATE(1036), 1,
      sym__tag_name,
  [48597] = 2,
    ACTIONS(4917), 1,
      sym__word_no_digit,
    STATE(1081), 1,
      sym__tag_name,
  [48604] = 2,
    ACTIONS(4917), 1,
      sym__word_no_digit,
    STATE(1030), 1,
      sym__tag_name,
  [48611] = 1,
    ACTIONS(4921), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [48616] = 1,
    ACTIONS(4727), 1,
      anon_sym_GT,
  [48620] = 1,
    ACTIONS(4923), 1,
      anon_sym_GT,
  [48624] = 1,
    ACTIONS(4925), 1,
      sym__trigger_error,
  [48628] = 1,
    ACTIONS(4655), 1,
      anon_sym_GT,
  [48632] = 1,
    ACTIONS(4623), 1,
      anon_sym_GT,
  [48636] = 1,
    ACTIONS(4927), 1,
      anon_sym_GT,
  [48640] = 1,
    ACTIONS(4929), 1,
      ts_builtin_sym_end,
  [48644] = 1,
    ACTIONS(4665), 1,
      anon_sym_GT,
  [48648] = 1,
    ACTIONS(4651), 1,
      anon_sym_GT,
  [48652] = 1,
    ACTIONS(4931), 1,
      sym__trigger_error,
  [48656] = 1,
    ACTIONS(4933), 1,
      anon_sym_GT,
  [48660] = 1,
    ACTIONS(3276), 1,
      sym__trigger_error,
  [48664] = 1,
    ACTIONS(4738), 1,
      anon_sym_GT,
  [48668] = 1,
    ACTIONS(4635), 1,
      anon_sym_GT,
  [48672] = 1,
    ACTIONS(4765), 1,
      anon_sym_GT,
  [48676] = 1,
    ACTIONS(4935), 1,
      anon_sym_GT,
  [48680] = 1,
    ACTIONS(4723), 1,
      anon_sym_GT,
  [48684] = 1,
    ACTIONS(4746), 1,
      anon_sym_GT,
  [48688] = 1,
    ACTIONS(4937), 1,
      anon_sym_GT,
  [48692] = 1,
    ACTIONS(4742), 1,
      anon_sym_GT,
  [48696] = 1,
    ACTIONS(4694), 1,
      anon_sym_GT,
  [48700] = 1,
    ACTIONS(4719), 1,
      anon_sym_GT,
  [48704] = 1,
    ACTIONS(4939), 1,
      anon_sym_GT,
  [48708] = 1,
    ACTIONS(4941), 1,
      anon_sym_GT,
  [48712] = 1,
    ACTIONS(4943), 1,
      sym__trigger_error,
  [48716] = 1,
    ACTIONS(4690), 1,
      anon_sym_GT,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(166)] = 0,
  [SMALL_STATE(167)] = 83,
  [SMALL_STATE(168)] = 162,
  [SMALL_STATE(169)] = 243,
  [SMALL_STATE(170)] = 324,
  [SMALL_STATE(171)] = 405,
  [SMALL_STATE(172)] = 484,
  [SMALL_STATE(173)] = 563,
  [SMALL_STATE(174)] = 642,
  [SMALL_STATE(175)] = 725,
  [SMALL_STATE(176)] = 804,
  [SMALL_STATE(177)] = 883,
  [SMALL_STATE(178)] = 966,
  [SMALL_STATE(179)] = 1045,
  [SMALL_STATE(180)] = 1124,
  [SMALL_STATE(181)] = 1204,
  [SMALL_STATE(182)] = 1284,
  [SMALL_STATE(183)] = 1366,
  [SMALL_STATE(184)] = 1446,
  [SMALL_STATE(185)] = 1526,
  [SMALL_STATE(186)] = 1606,
  [SMALL_STATE(187)] = 1684,
  [SMALL_STATE(188)] = 1766,
  [SMALL_STATE(189)] = 1844,
  [SMALL_STATE(190)] = 1926,
  [SMALL_STATE(191)] = 2006,
  [SMALL_STATE(192)] = 2087,
  [SMALL_STATE(193)] = 2166,
  [SMALL_STATE(194)] = 2232,
  [SMALL_STATE(195)] = 2300,
  [SMALL_STATE(196)] = 2368,
  [SMALL_STATE(197)] = 2434,
  [SMALL_STATE(198)] = 2500,
  [SMALL_STATE(199)] = 2568,
  [SMALL_STATE(200)] = 2636,
  [SMALL_STATE(201)] = 2704,
  [SMALL_STATE(202)] = 2770,
  [SMALL_STATE(203)] = 2838,
  [SMALL_STATE(204)] = 2904,
  [SMALL_STATE(205)] = 2972,
  [SMALL_STATE(206)] = 3040,
  [SMALL_STATE(207)] = 3106,
  [SMALL_STATE(208)] = 3172,
  [SMALL_STATE(209)] = 3238,
  [SMALL_STATE(210)] = 3319,
  [SMALL_STATE(211)] = 3382,
  [SMALL_STATE(212)] = 3443,
  [SMALL_STATE(213)] = 3506,
  [SMALL_STATE(214)] = 3569,
  [SMALL_STATE(215)] = 3636,
  [SMALL_STATE(216)] = 3717,
  [SMALL_STATE(217)] = 3778,
  [SMALL_STATE(218)] = 3839,
  [SMALL_STATE(219)] = 3920,
  [SMALL_STATE(220)] = 3981,
  [SMALL_STATE(221)] = 4062,
  [SMALL_STATE(222)] = 4143,
  [SMALL_STATE(223)] = 4224,
  [SMALL_STATE(224)] = 4287,
  [SMALL_STATE(225)] = 4368,
  [SMALL_STATE(226)] = 4429,
  [SMALL_STATE(227)] = 4492,
  [SMALL_STATE(228)] = 4553,
  [SMALL_STATE(229)] = 4634,
  [SMALL_STATE(230)] = 4715,
  [SMALL_STATE(231)] = 4776,
  [SMALL_STATE(232)] = 4857,
  [SMALL_STATE(233)] = 4920,
  [SMALL_STATE(234)] = 5001,
  [SMALL_STATE(235)] = 5062,
  [SMALL_STATE(236)] = 5143,
  [SMALL_STATE(237)] = 5224,
  [SMALL_STATE(238)] = 5305,
  [SMALL_STATE(239)] = 5372,
  [SMALL_STATE(240)] = 5453,
  [SMALL_STATE(241)] = 5514,
  [SMALL_STATE(242)] = 5575,
  [SMALL_STATE(243)] = 5636,
  [SMALL_STATE(244)] = 5697,
  [SMALL_STATE(245)] = 5758,
  [SMALL_STATE(246)] = 5819,
  [SMALL_STATE(247)] = 5884,
  [SMALL_STATE(248)] = 5945,
  [SMALL_STATE(249)] = 6006,
  [SMALL_STATE(250)] = 6067,
  [SMALL_STATE(251)] = 6148,
  [SMALL_STATE(252)] = 6229,
  [SMALL_STATE(253)] = 6294,
  [SMALL_STATE(254)] = 6357,
  [SMALL_STATE(255)] = 6418,
  [SMALL_STATE(256)] = 6499,
  [SMALL_STATE(257)] = 6580,
  [SMALL_STATE(258)] = 6661,
  [SMALL_STATE(259)] = 6722,
  [SMALL_STATE(260)] = 6783,
  [SMALL_STATE(261)] = 6864,
  [SMALL_STATE(262)] = 6945,
  [SMALL_STATE(263)] = 7003,
  [SMALL_STATE(264)] = 7061,
  [SMALL_STATE(265)] = 7119,
  [SMALL_STATE(266)] = 7179,
  [SMALL_STATE(267)] = 7237,
  [SMALL_STATE(268)] = 7297,
  [SMALL_STATE(269)] = 7357,
  [SMALL_STATE(270)] = 7429,
  [SMALL_STATE(271)] = 7491,
  [SMALL_STATE(272)] = 7551,
  [SMALL_STATE(273)] = 7609,
  [SMALL_STATE(274)] = 7681,
  [SMALL_STATE(275)] = 7739,
  [SMALL_STATE(276)] = 7797,
  [SMALL_STATE(277)] = 7855,
  [SMALL_STATE(278)] = 7913,
  [SMALL_STATE(279)] = 7971,
  [SMALL_STATE(280)] = 8031,
  [SMALL_STATE(281)] = 8089,
  [SMALL_STATE(282)] = 8147,
  [SMALL_STATE(283)] = 8207,
  [SMALL_STATE(284)] = 8265,
  [SMALL_STATE(285)] = 8323,
  [SMALL_STATE(286)] = 8383,
  [SMALL_STATE(287)] = 8445,
  [SMALL_STATE(288)] = 8503,
  [SMALL_STATE(289)] = 8575,
  [SMALL_STATE(290)] = 8635,
  [SMALL_STATE(291)] = 8693,
  [SMALL_STATE(292)] = 8753,
  [SMALL_STATE(293)] = 8811,
  [SMALL_STATE(294)] = 8869,
  [SMALL_STATE(295)] = 8927,
  [SMALL_STATE(296)] = 8985,
  [SMALL_STATE(297)] = 9043,
  [SMALL_STATE(298)] = 9101,
  [SMALL_STATE(299)] = 9159,
  [SMALL_STATE(300)] = 9217,
  [SMALL_STATE(301)] = 9289,
  [SMALL_STATE(302)] = 9347,
  [SMALL_STATE(303)] = 9419,
  [SMALL_STATE(304)] = 9477,
  [SMALL_STATE(305)] = 9539,
  [SMALL_STATE(306)] = 9611,
  [SMALL_STATE(307)] = 9669,
  [SMALL_STATE(308)] = 9727,
  [SMALL_STATE(309)] = 9785,
  [SMALL_STATE(310)] = 9843,
  [SMALL_STATE(311)] = 9901,
  [SMALL_STATE(312)] = 9959,
  [SMALL_STATE(313)] = 10019,
  [SMALL_STATE(314)] = 10091,
  [SMALL_STATE(315)] = 10151,
  [SMALL_STATE(316)] = 10209,
  [SMALL_STATE(317)] = 10267,
  [SMALL_STATE(318)] = 10327,
  [SMALL_STATE(319)] = 10385,
  [SMALL_STATE(320)] = 10447,
  [SMALL_STATE(321)] = 10507,
  [SMALL_STATE(322)] = 10565,
  [SMALL_STATE(323)] = 10623,
  [SMALL_STATE(324)] = 10681,
  [SMALL_STATE(325)] = 10739,
  [SMALL_STATE(326)] = 10797,
  [SMALL_STATE(327)] = 10855,
  [SMALL_STATE(328)] = 10913,
  [SMALL_STATE(329)] = 10985,
  [SMALL_STATE(330)] = 11043,
  [SMALL_STATE(331)] = 11101,
  [SMALL_STATE(332)] = 11159,
  [SMALL_STATE(333)] = 11219,
  [SMALL_STATE(334)] = 11279,
  [SMALL_STATE(335)] = 11337,
  [SMALL_STATE(336)] = 11395,
  [SMALL_STATE(337)] = 11467,
  [SMALL_STATE(338)] = 11539,
  [SMALL_STATE(339)] = 11597,
  [SMALL_STATE(340)] = 11655,
  [SMALL_STATE(341)] = 11713,
  [SMALL_STATE(342)] = 11771,
  [SMALL_STATE(343)] = 11829,
  [SMALL_STATE(344)] = 11887,
  [SMALL_STATE(345)] = 11945,
  [SMALL_STATE(346)] = 12005,
  [SMALL_STATE(347)] = 12063,
  [SMALL_STATE(348)] = 12123,
  [SMALL_STATE(349)] = 12181,
  [SMALL_STATE(350)] = 12253,
  [SMALL_STATE(351)] = 12311,
  [SMALL_STATE(352)] = 12369,
  [SMALL_STATE(353)] = 12427,
  [SMALL_STATE(354)] = 12485,
  [SMALL_STATE(355)] = 12543,
  [SMALL_STATE(356)] = 12601,
  [SMALL_STATE(357)] = 12659,
  [SMALL_STATE(358)] = 12717,
  [SMALL_STATE(359)] = 12775,
  [SMALL_STATE(360)] = 12833,
  [SMALL_STATE(361)] = 12891,
  [SMALL_STATE(362)] = 12963,
  [SMALL_STATE(363)] = 13021,
  [SMALL_STATE(364)] = 13079,
  [SMALL_STATE(365)] = 13137,
  [SMALL_STATE(366)] = 13195,
  [SMALL_STATE(367)] = 13253,
  [SMALL_STATE(368)] = 13311,
  [SMALL_STATE(369)] = 13369,
  [SMALL_STATE(370)] = 13427,
  [SMALL_STATE(371)] = 13485,
  [SMALL_STATE(372)] = 13543,
  [SMALL_STATE(373)] = 13601,
  [SMALL_STATE(374)] = 13659,
  [SMALL_STATE(375)] = 13717,
  [SMALL_STATE(376)] = 13775,
  [SMALL_STATE(377)] = 13833,
  [SMALL_STATE(378)] = 13891,
  [SMALL_STATE(379)] = 13949,
  [SMALL_STATE(380)] = 14007,
  [SMALL_STATE(381)] = 14065,
  [SMALL_STATE(382)] = 14137,
  [SMALL_STATE(383)] = 14199,
  [SMALL_STATE(384)] = 14271,
  [SMALL_STATE(385)] = 14329,
  [SMALL_STATE(386)] = 14387,
  [SMALL_STATE(387)] = 14445,
  [SMALL_STATE(388)] = 14503,
  [SMALL_STATE(389)] = 14561,
  [SMALL_STATE(390)] = 14619,
  [SMALL_STATE(391)] = 14677,
  [SMALL_STATE(392)] = 14735,
  [SMALL_STATE(393)] = 14793,
  [SMALL_STATE(394)] = 14851,
  [SMALL_STATE(395)] = 14909,
  [SMALL_STATE(396)] = 14967,
  [SMALL_STATE(397)] = 15025,
  [SMALL_STATE(398)] = 15083,
  [SMALL_STATE(399)] = 15141,
  [SMALL_STATE(400)] = 15199,
  [SMALL_STATE(401)] = 15257,
  [SMALL_STATE(402)] = 15315,
  [SMALL_STATE(403)] = 15373,
  [SMALL_STATE(404)] = 15431,
  [SMALL_STATE(405)] = 15489,
  [SMALL_STATE(406)] = 15547,
  [SMALL_STATE(407)] = 15605,
  [SMALL_STATE(408)] = 15663,
  [SMALL_STATE(409)] = 15723,
  [SMALL_STATE(410)] = 15781,
  [SMALL_STATE(411)] = 15841,
  [SMALL_STATE(412)] = 15899,
  [SMALL_STATE(413)] = 15957,
  [SMALL_STATE(414)] = 16015,
  [SMALL_STATE(415)] = 16073,
  [SMALL_STATE(416)] = 16131,
  [SMALL_STATE(417)] = 16189,
  [SMALL_STATE(418)] = 16247,
  [SMALL_STATE(419)] = 16305,
  [SMALL_STATE(420)] = 16363,
  [SMALL_STATE(421)] = 16421,
  [SMALL_STATE(422)] = 16479,
  [SMALL_STATE(423)] = 16537,
  [SMALL_STATE(424)] = 16595,
  [SMALL_STATE(425)] = 16653,
  [SMALL_STATE(426)] = 16711,
  [SMALL_STATE(427)] = 16769,
  [SMALL_STATE(428)] = 16827,
  [SMALL_STATE(429)] = 16885,
  [SMALL_STATE(430)] = 16943,
  [SMALL_STATE(431)] = 17001,
  [SMALL_STATE(432)] = 17059,
  [SMALL_STATE(433)] = 17117,
  [SMALL_STATE(434)] = 17177,
  [SMALL_STATE(435)] = 17235,
  [SMALL_STATE(436)] = 17295,
  [SMALL_STATE(437)] = 17353,
  [SMALL_STATE(438)] = 17411,
  [SMALL_STATE(439)] = 17469,
  [SMALL_STATE(440)] = 17527,
  [SMALL_STATE(441)] = 17585,
  [SMALL_STATE(442)] = 17643,
  [SMALL_STATE(443)] = 17701,
  [SMALL_STATE(444)] = 17759,
  [SMALL_STATE(445)] = 17817,
  [SMALL_STATE(446)] = 17875,
  [SMALL_STATE(447)] = 17933,
  [SMALL_STATE(448)] = 17991,
  [SMALL_STATE(449)] = 18049,
  [SMALL_STATE(450)] = 18107,
  [SMALL_STATE(451)] = 18165,
  [SMALL_STATE(452)] = 18223,
  [SMALL_STATE(453)] = 18281,
  [SMALL_STATE(454)] = 18339,
  [SMALL_STATE(455)] = 18397,
  [SMALL_STATE(456)] = 18455,
  [SMALL_STATE(457)] = 18513,
  [SMALL_STATE(458)] = 18571,
  [SMALL_STATE(459)] = 18629,
  [SMALL_STATE(460)] = 18687,
  [SMALL_STATE(461)] = 18745,
  [SMALL_STATE(462)] = 18803,
  [SMALL_STATE(463)] = 18861,
  [SMALL_STATE(464)] = 18919,
  [SMALL_STATE(465)] = 18977,
  [SMALL_STATE(466)] = 19035,
  [SMALL_STATE(467)] = 19093,
  [SMALL_STATE(468)] = 19151,
  [SMALL_STATE(469)] = 19209,
  [SMALL_STATE(470)] = 19267,
  [SMALL_STATE(471)] = 19325,
  [SMALL_STATE(472)] = 19383,
  [SMALL_STATE(473)] = 19441,
  [SMALL_STATE(474)] = 19499,
  [SMALL_STATE(475)] = 19571,
  [SMALL_STATE(476)] = 19629,
  [SMALL_STATE(477)] = 19687,
  [SMALL_STATE(478)] = 19745,
  [SMALL_STATE(479)] = 19803,
  [SMALL_STATE(480)] = 19861,
  [SMALL_STATE(481)] = 19919,
  [SMALL_STATE(482)] = 19977,
  [SMALL_STATE(483)] = 20035,
  [SMALL_STATE(484)] = 20093,
  [SMALL_STATE(485)] = 20151,
  [SMALL_STATE(486)] = 20209,
  [SMALL_STATE(487)] = 20267,
  [SMALL_STATE(488)] = 20325,
  [SMALL_STATE(489)] = 20383,
  [SMALL_STATE(490)] = 20441,
  [SMALL_STATE(491)] = 20499,
  [SMALL_STATE(492)] = 20557,
  [SMALL_STATE(493)] = 20615,
  [SMALL_STATE(494)] = 20673,
  [SMALL_STATE(495)] = 20731,
  [SMALL_STATE(496)] = 20789,
  [SMALL_STATE(497)] = 20847,
  [SMALL_STATE(498)] = 20905,
  [SMALL_STATE(499)] = 20963,
  [SMALL_STATE(500)] = 21025,
  [SMALL_STATE(501)] = 21083,
  [SMALL_STATE(502)] = 21155,
  [SMALL_STATE(503)] = 21215,
  [SMALL_STATE(504)] = 21273,
  [SMALL_STATE(505)] = 21333,
  [SMALL_STATE(506)] = 21391,
  [SMALL_STATE(507)] = 21449,
  [SMALL_STATE(508)] = 21507,
  [SMALL_STATE(509)] = 21565,
  [SMALL_STATE(510)] = 21623,
  [SMALL_STATE(511)] = 21681,
  [SMALL_STATE(512)] = 21739,
  [SMALL_STATE(513)] = 21797,
  [SMALL_STATE(514)] = 21855,
  [SMALL_STATE(515)] = 21913,
  [SMALL_STATE(516)] = 21971,
  [SMALL_STATE(517)] = 22029,
  [SMALL_STATE(518)] = 22087,
  [SMALL_STATE(519)] = 22145,
  [SMALL_STATE(520)] = 22203,
  [SMALL_STATE(521)] = 22261,
  [SMALL_STATE(522)] = 22319,
  [SMALL_STATE(523)] = 22377,
  [SMALL_STATE(524)] = 22435,
  [SMALL_STATE(525)] = 22493,
  [SMALL_STATE(526)] = 22551,
  [SMALL_STATE(527)] = 22609,
  [SMALL_STATE(528)] = 22667,
  [SMALL_STATE(529)] = 22725,
  [SMALL_STATE(530)] = 22783,
  [SMALL_STATE(531)] = 22841,
  [SMALL_STATE(532)] = 22899,
  [SMALL_STATE(533)] = 22957,
  [SMALL_STATE(534)] = 23015,
  [SMALL_STATE(535)] = 23073,
  [SMALL_STATE(536)] = 23131,
  [SMALL_STATE(537)] = 23188,
  [SMALL_STATE(538)] = 23245,
  [SMALL_STATE(539)] = 23306,
  [SMALL_STATE(540)] = 23365,
  [SMALL_STATE(541)] = 23426,
  [SMALL_STATE(542)] = 23487,
  [SMALL_STATE(543)] = 23544,
  [SMALL_STATE(544)] = 23601,
  [SMALL_STATE(545)] = 23658,
  [SMALL_STATE(546)] = 23715,
  [SMALL_STATE(547)] = 23772,
  [SMALL_STATE(548)] = 23829,
  [SMALL_STATE(549)] = 23886,
  [SMALL_STATE(550)] = 23943,
  [SMALL_STATE(551)] = 24000,
  [SMALL_STATE(552)] = 24057,
  [SMALL_STATE(553)] = 24114,
  [SMALL_STATE(554)] = 24171,
  [SMALL_STATE(555)] = 24228,
  [SMALL_STATE(556)] = 24285,
  [SMALL_STATE(557)] = 24342,
  [SMALL_STATE(558)] = 24399,
  [SMALL_STATE(559)] = 24456,
  [SMALL_STATE(560)] = 24513,
  [SMALL_STATE(561)] = 24570,
  [SMALL_STATE(562)] = 24627,
  [SMALL_STATE(563)] = 24684,
  [SMALL_STATE(564)] = 24741,
  [SMALL_STATE(565)] = 24798,
  [SMALL_STATE(566)] = 24855,
  [SMALL_STATE(567)] = 24912,
  [SMALL_STATE(568)] = 24969,
  [SMALL_STATE(569)] = 25026,
  [SMALL_STATE(570)] = 25083,
  [SMALL_STATE(571)] = 25140,
  [SMALL_STATE(572)] = 25197,
  [SMALL_STATE(573)] = 25254,
  [SMALL_STATE(574)] = 25311,
  [SMALL_STATE(575)] = 25368,
  [SMALL_STATE(576)] = 25425,
  [SMALL_STATE(577)] = 25482,
  [SMALL_STATE(578)] = 25539,
  [SMALL_STATE(579)] = 25596,
  [SMALL_STATE(580)] = 25653,
  [SMALL_STATE(581)] = 25710,
  [SMALL_STATE(582)] = 25767,
  [SMALL_STATE(583)] = 25824,
  [SMALL_STATE(584)] = 25881,
  [SMALL_STATE(585)] = 25938,
  [SMALL_STATE(586)] = 25995,
  [SMALL_STATE(587)] = 26052,
  [SMALL_STATE(588)] = 26109,
  [SMALL_STATE(589)] = 26166,
  [SMALL_STATE(590)] = 26223,
  [SMALL_STATE(591)] = 26280,
  [SMALL_STATE(592)] = 26337,
  [SMALL_STATE(593)] = 26396,
  [SMALL_STATE(594)] = 26453,
  [SMALL_STATE(595)] = 26514,
  [SMALL_STATE(596)] = 26571,
  [SMALL_STATE(597)] = 26628,
  [SMALL_STATE(598)] = 26685,
  [SMALL_STATE(599)] = 26742,
  [SMALL_STATE(600)] = 26799,
  [SMALL_STATE(601)] = 26855,
  [SMALL_STATE(602)] = 26911,
  [SMALL_STATE(603)] = 26969,
  [SMALL_STATE(604)] = 27025,
  [SMALL_STATE(605)] = 27081,
  [SMALL_STATE(606)] = 27137,
  [SMALL_STATE(607)] = 27193,
  [SMALL_STATE(608)] = 27251,
  [SMALL_STATE(609)] = 27307,
  [SMALL_STATE(610)] = 27363,
  [SMALL_STATE(611)] = 27419,
  [SMALL_STATE(612)] = 27475,
  [SMALL_STATE(613)] = 27531,
  [SMALL_STATE(614)] = 27589,
  [SMALL_STATE(615)] = 27647,
  [SMALL_STATE(616)] = 27703,
  [SMALL_STATE(617)] = 27759,
  [SMALL_STATE(618)] = 27815,
  [SMALL_STATE(619)] = 27873,
  [SMALL_STATE(620)] = 27929,
  [SMALL_STATE(621)] = 27985,
  [SMALL_STATE(622)] = 28041,
  [SMALL_STATE(623)] = 28097,
  [SMALL_STATE(624)] = 28153,
  [SMALL_STATE(625)] = 28209,
  [SMALL_STATE(626)] = 28265,
  [SMALL_STATE(627)] = 28321,
  [SMALL_STATE(628)] = 28379,
  [SMALL_STATE(629)] = 28435,
  [SMALL_STATE(630)] = 28491,
  [SMALL_STATE(631)] = 28547,
  [SMALL_STATE(632)] = 28603,
  [SMALL_STATE(633)] = 28659,
  [SMALL_STATE(634)] = 28717,
  [SMALL_STATE(635)] = 28773,
  [SMALL_STATE(636)] = 28829,
  [SMALL_STATE(637)] = 28885,
  [SMALL_STATE(638)] = 28941,
  [SMALL_STATE(639)] = 28997,
  [SMALL_STATE(640)] = 29053,
  [SMALL_STATE(641)] = 29109,
  [SMALL_STATE(642)] = 29165,
  [SMALL_STATE(643)] = 29221,
  [SMALL_STATE(644)] = 29277,
  [SMALL_STATE(645)] = 29335,
  [SMALL_STATE(646)] = 29416,
  [SMALL_STATE(647)] = 29497,
  [SMALL_STATE(648)] = 29578,
  [SMALL_STATE(649)] = 29659,
  [SMALL_STATE(650)] = 29740,
  [SMALL_STATE(651)] = 29821,
  [SMALL_STATE(652)] = 29902,
  [SMALL_STATE(653)] = 29983,
  [SMALL_STATE(654)] = 30062,
  [SMALL_STATE(655)] = 30143,
  [SMALL_STATE(656)] = 30224,
  [SMALL_STATE(657)] = 30305,
  [SMALL_STATE(658)] = 30386,
  [SMALL_STATE(659)] = 30467,
  [SMALL_STATE(660)] = 30548,
  [SMALL_STATE(661)] = 30629,
  [SMALL_STATE(662)] = 30710,
  [SMALL_STATE(663)] = 30791,
  [SMALL_STATE(664)] = 30872,
  [SMALL_STATE(665)] = 30953,
  [SMALL_STATE(666)] = 31034,
  [SMALL_STATE(667)] = 31113,
  [SMALL_STATE(668)] = 31167,
  [SMALL_STATE(669)] = 31233,
  [SMALL_STATE(670)] = 31287,
  [SMALL_STATE(671)] = 31361,
  [SMALL_STATE(672)] = 31427,
  [SMALL_STATE(673)] = 31493,
  [SMALL_STATE(674)] = 31559,
  [SMALL_STATE(675)] = 31613,
  [SMALL_STATE(676)] = 31664,
  [SMALL_STATE(677)] = 31715,
  [SMALL_STATE(678)] = 31782,
  [SMALL_STATE(679)] = 31833,
  [SMALL_STATE(680)] = 31884,
  [SMALL_STATE(681)] = 31951,
  [SMALL_STATE(682)] = 32017,
  [SMALL_STATE(683)] = 32083,
  [SMALL_STATE(684)] = 32149,
  [SMALL_STATE(685)] = 32215,
  [SMALL_STATE(686)] = 32279,
  [SMALL_STATE(687)] = 32345,
  [SMALL_STATE(688)] = 32411,
  [SMALL_STATE(689)] = 32477,
  [SMALL_STATE(690)] = 32543,
  [SMALL_STATE(691)] = 32600,
  [SMALL_STATE(692)] = 32661,
  [SMALL_STATE(693)] = 32722,
  [SMALL_STATE(694)] = 32779,
  [SMALL_STATE(695)] = 32840,
  [SMALL_STATE(696)] = 32901,
  [SMALL_STATE(697)] = 32966,
  [SMALL_STATE(698)] = 33031,
  [SMALL_STATE(699)] = 33096,
  [SMALL_STATE(700)] = 33157,
  [SMALL_STATE(701)] = 33214,
  [SMALL_STATE(702)] = 33271,
  [SMALL_STATE(703)] = 33333,
  [SMALL_STATE(704)] = 33395,
  [SMALL_STATE(705)] = 33445,
  [SMALL_STATE(706)] = 33495,
  [SMALL_STATE(707)] = 33545,
  [SMALL_STATE(708)] = 33595,
  [SMALL_STATE(709)] = 33657,
  [SMALL_STATE(710)] = 33719,
  [SMALL_STATE(711)] = 33779,
  [SMALL_STATE(712)] = 33841,
  [SMALL_STATE(713)] = 33903,
  [SMALL_STATE(714)] = 33965,
  [SMALL_STATE(715)] = 34027,
  [SMALL_STATE(716)] = 34089,
  [SMALL_STATE(717)] = 34151,
  [SMALL_STATE(718)] = 34207,
  [SMALL_STATE(719)] = 34269,
  [SMALL_STATE(720)] = 34331,
  [SMALL_STATE(721)] = 34391,
  [SMALL_STATE(722)] = 34451,
  [SMALL_STATE(723)] = 34513,
  [SMALL_STATE(724)] = 34575,
  [SMALL_STATE(725)] = 34625,
  [SMALL_STATE(726)] = 34675,
  [SMALL_STATE(727)] = 34734,
  [SMALL_STATE(728)] = 34793,
  [SMALL_STATE(729)] = 34840,
  [SMALL_STATE(730)] = 34887,
  [SMALL_STATE(731)] = 34934,
  [SMALL_STATE(732)] = 34981,
  [SMALL_STATE(733)] = 35028,
  [SMALL_STATE(734)] = 35075,
  [SMALL_STATE(735)] = 35122,
  [SMALL_STATE(736)] = 35169,
  [SMALL_STATE(737)] = 35216,
  [SMALL_STATE(738)] = 35263,
  [SMALL_STATE(739)] = 35310,
  [SMALL_STATE(740)] = 35357,
  [SMALL_STATE(741)] = 35404,
  [SMALL_STATE(742)] = 35451,
  [SMALL_STATE(743)] = 35498,
  [SMALL_STATE(744)] = 35545,
  [SMALL_STATE(745)] = 35592,
  [SMALL_STATE(746)] = 35639,
  [SMALL_STATE(747)] = 35686,
  [SMALL_STATE(748)] = 35745,
  [SMALL_STATE(749)] = 35804,
  [SMALL_STATE(750)] = 35863,
  [SMALL_STATE(751)] = 35922,
  [SMALL_STATE(752)] = 35981,
  [SMALL_STATE(753)] = 36040,
  [SMALL_STATE(754)] = 36099,
  [SMALL_STATE(755)] = 36158,
  [SMALL_STATE(756)] = 36217,
  [SMALL_STATE(757)] = 36264,
  [SMALL_STATE(758)] = 36323,
  [SMALL_STATE(759)] = 36382,
  [SMALL_STATE(760)] = 36441,
  [SMALL_STATE(761)] = 36500,
  [SMALL_STATE(762)] = 36559,
  [SMALL_STATE(763)] = 36618,
  [SMALL_STATE(764)] = 36677,
  [SMALL_STATE(765)] = 36736,
  [SMALL_STATE(766)] = 36795,
  [SMALL_STATE(767)] = 36854,
  [SMALL_STATE(768)] = 36913,
  [SMALL_STATE(769)] = 36972,
  [SMALL_STATE(770)] = 37031,
  [SMALL_STATE(771)] = 37090,
  [SMALL_STATE(772)] = 37149,
  [SMALL_STATE(773)] = 37208,
  [SMALL_STATE(774)] = 37267,
  [SMALL_STATE(775)] = 37326,
  [SMALL_STATE(776)] = 37385,
  [SMALL_STATE(777)] = 37444,
  [SMALL_STATE(778)] = 37503,
  [SMALL_STATE(779)] = 37550,
  [SMALL_STATE(780)] = 37597,
  [SMALL_STATE(781)] = 37656,
  [SMALL_STATE(782)] = 37715,
  [SMALL_STATE(783)] = 37774,
  [SMALL_STATE(784)] = 37821,
  [SMALL_STATE(785)] = 37868,
  [SMALL_STATE(786)] = 37915,
  [SMALL_STATE(787)] = 37962,
  [SMALL_STATE(788)] = 38021,
  [SMALL_STATE(789)] = 38068,
  [SMALL_STATE(790)] = 38115,
  [SMALL_STATE(791)] = 38174,
  [SMALL_STATE(792)] = 38221,
  [SMALL_STATE(793)] = 38280,
  [SMALL_STATE(794)] = 38339,
  [SMALL_STATE(795)] = 38398,
  [SMALL_STATE(796)] = 38457,
  [SMALL_STATE(797)] = 38504,
  [SMALL_STATE(798)] = 38551,
  [SMALL_STATE(799)] = 38598,
  [SMALL_STATE(800)] = 38657,
  [SMALL_STATE(801)] = 38704,
  [SMALL_STATE(802)] = 38763,
  [SMALL_STATE(803)] = 38810,
  [SMALL_STATE(804)] = 38857,
  [SMALL_STATE(805)] = 38904,
  [SMALL_STATE(806)] = 38951,
  [SMALL_STATE(807)] = 38998,
  [SMALL_STATE(808)] = 39057,
  [SMALL_STATE(809)] = 39116,
  [SMALL_STATE(810)] = 39175,
  [SMALL_STATE(811)] = 39234,
  [SMALL_STATE(812)] = 39293,
  [SMALL_STATE(813)] = 39340,
  [SMALL_STATE(814)] = 39399,
  [SMALL_STATE(815)] = 39458,
  [SMALL_STATE(816)] = 39505,
  [SMALL_STATE(817)] = 39564,
  [SMALL_STATE(818)] = 39611,
  [SMALL_STATE(819)] = 39670,
  [SMALL_STATE(820)] = 39729,
  [SMALL_STATE(821)] = 39776,
  [SMALL_STATE(822)] = 39835,
  [SMALL_STATE(823)] = 39894,
  [SMALL_STATE(824)] = 39953,
  [SMALL_STATE(825)] = 40012,
  [SMALL_STATE(826)] = 40071,
  [SMALL_STATE(827)] = 40130,
  [SMALL_STATE(828)] = 40186,
  [SMALL_STATE(829)] = 40242,
  [SMALL_STATE(830)] = 40296,
  [SMALL_STATE(831)] = 40352,
  [SMALL_STATE(832)] = 40408,
  [SMALL_STATE(833)] = 40464,
  [SMALL_STATE(834)] = 40520,
  [SMALL_STATE(835)] = 40576,
  [SMALL_STATE(836)] = 40632,
  [SMALL_STATE(837)] = 40688,
  [SMALL_STATE(838)] = 40744,
  [SMALL_STATE(839)] = 40794,
  [SMALL_STATE(840)] = 40842,
  [SMALL_STATE(841)] = 40898,
  [SMALL_STATE(842)] = 40946,
  [SMALL_STATE(843)] = 41002,
  [SMALL_STATE(844)] = 41052,
  [SMALL_STATE(845)] = 41100,
  [SMALL_STATE(846)] = 41152,
  [SMALL_STATE(847)] = 41208,
  [SMALL_STATE(848)] = 41264,
  [SMALL_STATE(849)] = 41320,
  [SMALL_STATE(850)] = 41368,
  [SMALL_STATE(851)] = 41416,
  [SMALL_STATE(852)] = 41472,
  [SMALL_STATE(853)] = 41528,
  [SMALL_STATE(854)] = 41584,
  [SMALL_STATE(855)] = 41640,
  [SMALL_STATE(856)] = 41696,
  [SMALL_STATE(857)] = 41744,
  [SMALL_STATE(858)] = 41800,
  [SMALL_STATE(859)] = 41856,
  [SMALL_STATE(860)] = 41904,
  [SMALL_STATE(861)] = 41960,
  [SMALL_STATE(862)] = 42005,
  [SMALL_STATE(863)] = 42050,
  [SMALL_STATE(864)] = 42095,
  [SMALL_STATE(865)] = 42140,
  [SMALL_STATE(866)] = 42191,
  [SMALL_STATE(867)] = 42240,
  [SMALL_STATE(868)] = 42289,
  [SMALL_STATE(869)] = 42334,
  [SMALL_STATE(870)] = 42385,
  [SMALL_STATE(871)] = 42430,
  [SMALL_STATE(872)] = 42475,
  [SMALL_STATE(873)] = 42520,
  [SMALL_STATE(874)] = 42567,
  [SMALL_STATE(875)] = 42612,
  [SMALL_STATE(876)] = 42657,
  [SMALL_STATE(877)] = 42702,
  [SMALL_STATE(878)] = 42747,
  [SMALL_STATE(879)] = 42792,
  [SMALL_STATE(880)] = 42837,
  [SMALL_STATE(881)] = 42881,
  [SMALL_STATE(882)] = 42925,
  [SMALL_STATE(883)] = 42971,
  [SMALL_STATE(884)] = 43017,
  [SMALL_STATE(885)] = 43063,
  [SMALL_STATE(886)] = 43109,
  [SMALL_STATE(887)] = 43155,
  [SMALL_STATE(888)] = 43201,
  [SMALL_STATE(889)] = 43247,
  [SMALL_STATE(890)] = 43293,
  [SMALL_STATE(891)] = 43339,
  [SMALL_STATE(892)] = 43385,
  [SMALL_STATE(893)] = 43431,
  [SMALL_STATE(894)] = 43483,
  [SMALL_STATE(895)] = 43526,
  [SMALL_STATE(896)] = 43569,
  [SMALL_STATE(897)] = 43614,
  [SMALL_STATE(898)] = 43657,
  [SMALL_STATE(899)] = 43700,
  [SMALL_STATE(900)] = 43743,
  [SMALL_STATE(901)] = 43786,
  [SMALL_STATE(902)] = 43831,
  [SMALL_STATE(903)] = 43874,
  [SMALL_STATE(904)] = 43917,
  [SMALL_STATE(905)] = 43960,
  [SMALL_STATE(906)] = 44003,
  [SMALL_STATE(907)] = 44048,
  [SMALL_STATE(908)] = 44091,
  [SMALL_STATE(909)] = 44136,
  [SMALL_STATE(910)] = 44181,
  [SMALL_STATE(911)] = 44223,
  [SMALL_STATE(912)] = 44265,
  [SMALL_STATE(913)] = 44307,
  [SMALL_STATE(914)] = 44349,
  [SMALL_STATE(915)] = 44391,
  [SMALL_STATE(916)] = 44425,
  [SMALL_STATE(917)] = 44459,
  [SMALL_STATE(918)] = 44493,
  [SMALL_STATE(919)] = 44527,
  [SMALL_STATE(920)] = 44561,
  [SMALL_STATE(921)] = 44595,
  [SMALL_STATE(922)] = 44629,
  [SMALL_STATE(923)] = 44652,
  [SMALL_STATE(924)] = 44682,
  [SMALL_STATE(925)] = 44712,
  [SMALL_STATE(926)] = 44742,
  [SMALL_STATE(927)] = 44772,
  [SMALL_STATE(928)] = 44802,
  [SMALL_STATE(929)] = 44832,
  [SMALL_STATE(930)] = 44862,
  [SMALL_STATE(931)] = 44892,
  [SMALL_STATE(932)] = 44922,
  [SMALL_STATE(933)] = 44952,
  [SMALL_STATE(934)] = 44982,
  [SMALL_STATE(935)] = 45012,
  [SMALL_STATE(936)] = 45042,
  [SMALL_STATE(937)] = 45072,
  [SMALL_STATE(938)] = 45102,
  [SMALL_STATE(939)] = 45132,
  [SMALL_STATE(940)] = 45162,
  [SMALL_STATE(941)] = 45192,
  [SMALL_STATE(942)] = 45222,
  [SMALL_STATE(943)] = 45252,
  [SMALL_STATE(944)] = 45277,
  [SMALL_STATE(945)] = 45302,
  [SMALL_STATE(946)] = 45327,
  [SMALL_STATE(947)] = 45352,
  [SMALL_STATE(948)] = 45377,
  [SMALL_STATE(949)] = 45404,
  [SMALL_STATE(950)] = 45429,
  [SMALL_STATE(951)] = 45454,
  [SMALL_STATE(952)] = 45481,
  [SMALL_STATE(953)] = 45506,
  [SMALL_STATE(954)] = 45533,
  [SMALL_STATE(955)] = 45558,
  [SMALL_STATE(956)] = 45583,
  [SMALL_STATE(957)] = 45606,
  [SMALL_STATE(958)] = 45633,
  [SMALL_STATE(959)] = 45658,
  [SMALL_STATE(960)] = 45683,
  [SMALL_STATE(961)] = 45708,
  [SMALL_STATE(962)] = 45733,
  [SMALL_STATE(963)] = 45757,
  [SMALL_STATE(964)] = 45781,
  [SMALL_STATE(965)] = 45799,
  [SMALL_STATE(966)] = 45819,
  [SMALL_STATE(967)] = 45843,
  [SMALL_STATE(968)] = 45867,
  [SMALL_STATE(969)] = 45891,
  [SMALL_STATE(970)] = 45915,
  [SMALL_STATE(971)] = 45939,
  [SMALL_STATE(972)] = 45957,
  [SMALL_STATE(973)] = 45981,
  [SMALL_STATE(974)] = 46005,
  [SMALL_STATE(975)] = 46029,
  [SMALL_STATE(976)] = 46049,
  [SMALL_STATE(977)] = 46073,
  [SMALL_STATE(978)] = 46097,
  [SMALL_STATE(979)] = 46121,
  [SMALL_STATE(980)] = 46139,
  [SMALL_STATE(981)] = 46163,
  [SMALL_STATE(982)] = 46181,
  [SMALL_STATE(983)] = 46199,
  [SMALL_STATE(984)] = 46217,
  [SMALL_STATE(985)] = 46235,
  [SMALL_STATE(986)] = 46253,
  [SMALL_STATE(987)] = 46271,
  [SMALL_STATE(988)] = 46285,
  [SMALL_STATE(989)] = 46303,
  [SMALL_STATE(990)] = 46321,
  [SMALL_STATE(991)] = 46339,
  [SMALL_STATE(992)] = 46353,
  [SMALL_STATE(993)] = 46371,
  [SMALL_STATE(994)] = 46385,
  [SMALL_STATE(995)] = 46403,
  [SMALL_STATE(996)] = 46421,
  [SMALL_STATE(997)] = 46439,
  [SMALL_STATE(998)] = 46457,
  [SMALL_STATE(999)] = 46475,
  [SMALL_STATE(1000)] = 46493,
  [SMALL_STATE(1001)] = 46511,
  [SMALL_STATE(1002)] = 46529,
  [SMALL_STATE(1003)] = 46547,
  [SMALL_STATE(1004)] = 46565,
  [SMALL_STATE(1005)] = 46583,
  [SMALL_STATE(1006)] = 46601,
  [SMALL_STATE(1007)] = 46619,
  [SMALL_STATE(1008)] = 46637,
  [SMALL_STATE(1009)] = 46655,
  [SMALL_STATE(1010)] = 46673,
  [SMALL_STATE(1011)] = 46691,
  [SMALL_STATE(1012)] = 46709,
  [SMALL_STATE(1013)] = 46727,
  [SMALL_STATE(1014)] = 46745,
  [SMALL_STATE(1015)] = 46763,
  [SMALL_STATE(1016)] = 46781,
  [SMALL_STATE(1017)] = 46799,
  [SMALL_STATE(1018)] = 46817,
  [SMALL_STATE(1019)] = 46835,
  [SMALL_STATE(1020)] = 46853,
  [SMALL_STATE(1021)] = 46871,
  [SMALL_STATE(1022)] = 46889,
  [SMALL_STATE(1023)] = 46907,
  [SMALL_STATE(1024)] = 46925,
  [SMALL_STATE(1025)] = 46943,
  [SMALL_STATE(1026)] = 46961,
  [SMALL_STATE(1027)] = 46979,
  [SMALL_STATE(1028)] = 46997,
  [SMALL_STATE(1029)] = 47015,
  [SMALL_STATE(1030)] = 47033,
  [SMALL_STATE(1031)] = 47051,
  [SMALL_STATE(1032)] = 47069,
  [SMALL_STATE(1033)] = 47087,
  [SMALL_STATE(1034)] = 47105,
  [SMALL_STATE(1035)] = 47123,
  [SMALL_STATE(1036)] = 47137,
  [SMALL_STATE(1037)] = 47155,
  [SMALL_STATE(1038)] = 47173,
  [SMALL_STATE(1039)] = 47191,
  [SMALL_STATE(1040)] = 47209,
  [SMALL_STATE(1041)] = 47227,
  [SMALL_STATE(1042)] = 47245,
  [SMALL_STATE(1043)] = 47263,
  [SMALL_STATE(1044)] = 47281,
  [SMALL_STATE(1045)] = 47299,
  [SMALL_STATE(1046)] = 47317,
  [SMALL_STATE(1047)] = 47335,
  [SMALL_STATE(1048)] = 47353,
  [SMALL_STATE(1049)] = 47371,
  [SMALL_STATE(1050)] = 47389,
  [SMALL_STATE(1051)] = 47407,
  [SMALL_STATE(1052)] = 47425,
  [SMALL_STATE(1053)] = 47443,
  [SMALL_STATE(1054)] = 47461,
  [SMALL_STATE(1055)] = 47479,
  [SMALL_STATE(1056)] = 47497,
  [SMALL_STATE(1057)] = 47515,
  [SMALL_STATE(1058)] = 47533,
  [SMALL_STATE(1059)] = 47551,
  [SMALL_STATE(1060)] = 47569,
  [SMALL_STATE(1061)] = 47587,
  [SMALL_STATE(1062)] = 47605,
  [SMALL_STATE(1063)] = 47623,
  [SMALL_STATE(1064)] = 47641,
  [SMALL_STATE(1065)] = 47659,
  [SMALL_STATE(1066)] = 47677,
  [SMALL_STATE(1067)] = 47695,
  [SMALL_STATE(1068)] = 47713,
  [SMALL_STATE(1069)] = 47731,
  [SMALL_STATE(1070)] = 47749,
  [SMALL_STATE(1071)] = 47767,
  [SMALL_STATE(1072)] = 47785,
  [SMALL_STATE(1073)] = 47803,
  [SMALL_STATE(1074)] = 47821,
  [SMALL_STATE(1075)] = 47839,
  [SMALL_STATE(1076)] = 47857,
  [SMALL_STATE(1077)] = 47875,
  [SMALL_STATE(1078)] = 47893,
  [SMALL_STATE(1079)] = 47911,
  [SMALL_STATE(1080)] = 47929,
  [SMALL_STATE(1081)] = 47947,
  [SMALL_STATE(1082)] = 47965,
  [SMALL_STATE(1083)] = 47983,
  [SMALL_STATE(1084)] = 48001,
  [SMALL_STATE(1085)] = 48019,
  [SMALL_STATE(1086)] = 48037,
  [SMALL_STATE(1087)] = 48055,
  [SMALL_STATE(1088)] = 48073,
  [SMALL_STATE(1089)] = 48091,
  [SMALL_STATE(1090)] = 48109,
  [SMALL_STATE(1091)] = 48127,
  [SMALL_STATE(1092)] = 48145,
  [SMALL_STATE(1093)] = 48163,
  [SMALL_STATE(1094)] = 48181,
  [SMALL_STATE(1095)] = 48199,
  [SMALL_STATE(1096)] = 48217,
  [SMALL_STATE(1097)] = 48235,
  [SMALL_STATE(1098)] = 48253,
  [SMALL_STATE(1099)] = 48271,
  [SMALL_STATE(1100)] = 48289,
  [SMALL_STATE(1101)] = 48307,
  [SMALL_STATE(1102)] = 48325,
  [SMALL_STATE(1103)] = 48336,
  [SMALL_STATE(1104)] = 48347,
  [SMALL_STATE(1105)] = 48358,
  [SMALL_STATE(1106)] = 48369,
  [SMALL_STATE(1107)] = 48379,
  [SMALL_STATE(1108)] = 48389,
  [SMALL_STATE(1109)] = 48399,
  [SMALL_STATE(1110)] = 48409,
  [SMALL_STATE(1111)] = 48419,
  [SMALL_STATE(1112)] = 48428,
  [SMALL_STATE(1113)] = 48437,
  [SMALL_STATE(1114)] = 48446,
  [SMALL_STATE(1115)] = 48455,
  [SMALL_STATE(1116)] = 48465,
  [SMALL_STATE(1117)] = 48475,
  [SMALL_STATE(1118)] = 48485,
  [SMALL_STATE(1119)] = 48495,
  [SMALL_STATE(1120)] = 48505,
  [SMALL_STATE(1121)] = 48515,
  [SMALL_STATE(1122)] = 48525,
  [SMALL_STATE(1123)] = 48535,
  [SMALL_STATE(1124)] = 48545,
  [SMALL_STATE(1125)] = 48555,
  [SMALL_STATE(1126)] = 48562,
  [SMALL_STATE(1127)] = 48569,
  [SMALL_STATE(1128)] = 48576,
  [SMALL_STATE(1129)] = 48583,
  [SMALL_STATE(1130)] = 48590,
  [SMALL_STATE(1131)] = 48597,
  [SMALL_STATE(1132)] = 48604,
  [SMALL_STATE(1133)] = 48611,
  [SMALL_STATE(1134)] = 48616,
  [SMALL_STATE(1135)] = 48620,
  [SMALL_STATE(1136)] = 48624,
  [SMALL_STATE(1137)] = 48628,
  [SMALL_STATE(1138)] = 48632,
  [SMALL_STATE(1139)] = 48636,
  [SMALL_STATE(1140)] = 48640,
  [SMALL_STATE(1141)] = 48644,
  [SMALL_STATE(1142)] = 48648,
  [SMALL_STATE(1143)] = 48652,
  [SMALL_STATE(1144)] = 48656,
  [SMALL_STATE(1145)] = 48660,
  [SMALL_STATE(1146)] = 48664,
  [SMALL_STATE(1147)] = 48668,
  [SMALL_STATE(1148)] = 48672,
  [SMALL_STATE(1149)] = 48676,
  [SMALL_STATE(1150)] = 48680,
  [SMALL_STATE(1151)] = 48684,
  [SMALL_STATE(1152)] = 48688,
  [SMALL_STATE(1153)] = 48692,
  [SMALL_STATE(1154)] = 48696,
  [SMALL_STATE(1155)] = 48700,
  [SMALL_STATE(1156)] = 48704,
  [SMALL_STATE(1157)] = 48708,
  [SMALL_STATE(1158)] = 48712,
  [SMALL_STATE(1159)] = 48716,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [47] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(493),
  [50] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(154),
  [53] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(87),
  [56] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(247),
  [59] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(202),
  [62] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(245),
  [65] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(232),
  [68] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(245),
  [71] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(206),
  [74] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(248),
  [77] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(185),
  [80] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(173),
  [83] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(200),
  [86] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(171),
  [89] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(203),
  [92] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(259),
  [95] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(251),
  [98] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(10),
  [101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(5),
  [104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1),
  [106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(44),
  [111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(256),
  [114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 1),
  [116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(331),
  [119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(149),
  [122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(86),
  [125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(230),
  [128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(195),
  [131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(211),
  [134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(212),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(211),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(197),
  [143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(216),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(181),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(179),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(198),
  [155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(172),
  [158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(196),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(217),
  [164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(239),
  [167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(36),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(9),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(8),
  [178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(218),
  [181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(421),
  [184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(153),
  [187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(88),
  [190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(249),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(194),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(225),
  [199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(213),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(225),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(208),
  [208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(234),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(180),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(167),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(204),
  [220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(176),
  [223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(193),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(242),
  [229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(221),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(7),
  [235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(46),
  [238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(2),
  [243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(222),
  [246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(421),
  [249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(153),
  [252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(88),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(249),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(194),
  [261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(225),
  [264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(213),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(225),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(208),
  [273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(234),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(180),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(167),
  [282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(204),
  [285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(176),
  [288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(193),
  [291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(242),
  [294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(221),
  [297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(7),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(46),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(2),
  [308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1),
  [310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(222),
  [313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(493),
  [316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(154),
  [319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(87),
  [322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(247),
  [325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(202),
  [328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(245),
  [331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(232),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(245),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(206),
  [340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(248),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(185),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(173),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(200),
  [352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(171),
  [355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(203),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(259),
  [361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(251),
  [364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(10),
  [367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(5),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(44),
  [375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(256),
  [378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(331),
  [381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(149),
  [384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(86),
  [387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(230),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(195),
  [393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(211),
  [396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(212),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(211),
  [402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(197),
  [405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(216),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(181),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(179),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(198),
  [417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(172),
  [420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(196),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(217),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(239),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(36),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(9),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(8),
  [440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(218),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(493),
  [446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(154),
  [449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(87),
  [452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(247),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(202),
  [458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(245),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(232),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(245),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(206),
  [470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(248),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(185),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(173),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(200),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(171),
  [485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(203),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(259),
  [491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(251),
  [494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(10),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(5),
  [500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(44),
  [507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(256),
  [510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(421),
  [513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(153),
  [516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(88),
  [519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(249),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(194),
  [525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(225),
  [528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(213),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(225),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(208),
  [537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(234),
  [540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(180),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(167),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(204),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(176),
  [552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(193),
  [555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(242),
  [558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(221),
  [561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(7),
  [564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(46),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(2),
  [572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(222),
  [575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(331),
  [578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(149),
  [581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(86),
  [584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(230),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(195),
  [590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(211),
  [593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(212),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(211),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(197),
  [602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(216),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(181),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(179),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(198),
  [614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(172),
  [617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(196),
  [620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(217),
  [623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(239),
  [626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(36),
  [629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(9),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(8),
  [637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(218),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(493),
  [775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(154),
  [778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(87),
  [781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(247),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(202),
  [787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(245),
  [790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(232),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(245),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(206),
  [799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(248),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(185),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(173),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(200),
  [811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(171),
  [814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(203),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(259),
  [820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(251),
  [823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(10),
  [826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(5),
  [829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(44),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2),
  [834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(256),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(421),
  [856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(153),
  [859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(88),
  [862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(249),
  [865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(194),
  [868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(225),
  [871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(213),
  [874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(225),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(208),
  [880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(234),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(180),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(167),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(204),
  [892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(176),
  [895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(193),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(242),
  [901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(221),
  [904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(7),
  [907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(46),
  [910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2),
  [912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(2),
  [915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(222),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline, 1),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(331),
  [959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(149),
  [962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(86),
  [965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(230),
  [968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(195),
  [971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(211),
  [974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(212),
  [977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(211),
  [980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(197),
  [983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(216),
  [986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(181),
  [989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(179),
  [992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(198),
  [995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(172),
  [998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(196),
  [1001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(217),
  [1004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(239),
  [1007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(36),
  [1010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(9),
  [1013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2),
  [1015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(8),
  [1018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(218),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline, 2),
  [1031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(343),
  [1034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(155),
  [1037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(89),
  [1040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(258),
  [1043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(199),
  [1046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(254),
  [1049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(253),
  [1052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(254),
  [1055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(201),
  [1058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(241),
  [1061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(183),
  [1064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(175),
  [1067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(205),
  [1070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(178),
  [1073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(207),
  [1076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(227),
  [1079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(237),
  [1082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(3),
  [1085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(4),
  [1088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(6),
  [1091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(260),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline, 2),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(580),
  [1151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(157),
  [1154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(90),
  [1157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(333),
  [1160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(238),
  [1163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(289),
  [1166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(304),
  [1169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(289),
  [1172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(246),
  [1175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(285),
  [1178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(192),
  [1181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(186),
  [1184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(214),
  [1187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(188),
  [1190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(252),
  [1193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(279),
  [1196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(231),
  [1199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(28),
  [1202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(29),
  [1205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(30),
  [1208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(229),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(580),
  [1226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(160),
  [1229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(1133),
  [1232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(238),
  [1235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(289),
  [1238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(382),
  [1241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(289),
  [1244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(246),
  [1247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(285),
  [1250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(191),
  [1253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(184),
  [1256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(214),
  [1259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(190),
  [1262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(252),
  [1265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(279),
  [1268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(231),
  [1271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(93),
  [1274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(94),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(95),
  [1282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(229),
  [1285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(580),
  [1288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(160),
  [1291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(1133),
  [1294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(238),
  [1297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(289),
  [1300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(382),
  [1303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(289),
  [1306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(246),
  [1309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(285),
  [1312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(191),
  [1315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(184),
  [1318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(214),
  [1321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(190),
  [1324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(252),
  [1327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(279),
  [1330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(231),
  [1333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(93),
  [1336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(94),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(95),
  [1344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(229),
  [1347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(580),
  [1350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(160),
  [1353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(1133),
  [1356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(238),
  [1359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(289),
  [1362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(382),
  [1365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(289),
  [1368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(246),
  [1371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(285),
  [1374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(191),
  [1377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(184),
  [1380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(214),
  [1383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(190),
  [1386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(252),
  [1389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(279),
  [1392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(231),
  [1395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(93),
  [1398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(94),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(95),
  [1406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(229),
  [1409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(580),
  [1412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(160),
  [1415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(1133),
  [1418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(238),
  [1421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(289),
  [1424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(382),
  [1427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(289),
  [1430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(246),
  [1433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(285),
  [1436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(191),
  [1439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(184),
  [1442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(214),
  [1445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(190),
  [1448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(252),
  [1451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(279),
  [1454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(231),
  [1457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(93),
  [1460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(94),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(95),
  [1468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(229),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [1473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(421),
  [1476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(164),
  [1479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(194),
  [1482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(225),
  [1485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(286),
  [1488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(225),
  [1491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(208),
  [1494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(234),
  [1497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(182),
  [1500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(168),
  [1503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(204),
  [1506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(166),
  [1509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(193),
  [1512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(242),
  [1515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(221),
  [1518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(92),
  [1521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(126),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(96),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1),
  [1531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(222),
  [1534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(331),
  [1537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(163),
  [1540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(195),
  [1543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(211),
  [1546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(319),
  [1549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(211),
  [1552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(197),
  [1555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(216),
  [1558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(187),
  [1561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(170),
  [1564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(198),
  [1567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(174),
  [1570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(196),
  [1573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(217),
  [1576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(239),
  [1579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(121),
  [1582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(97),
  [1585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(99),
  [1592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(218),
  [1595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(331),
  [1598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(163),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1),
  [1603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(195),
  [1606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(211),
  [1609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(319),
  [1612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(211),
  [1615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(197),
  [1618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(216),
  [1621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(187),
  [1624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(170),
  [1627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(198),
  [1630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(174),
  [1633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(196),
  [1636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(217),
  [1639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(239),
  [1642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(121),
  [1645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(97),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(99),
  [1653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(218),
  [1656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(421),
  [1659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(164),
  [1662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(194),
  [1665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(225),
  [1668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(286),
  [1671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(225),
  [1674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(208),
  [1677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(234),
  [1680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(182),
  [1683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(168),
  [1686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(204),
  [1689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(166),
  [1692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(193),
  [1695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(242),
  [1698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(221),
  [1701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(92),
  [1704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(126),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(96),
  [1712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(222),
  [1715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(493),
  [1718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(158),
  [1721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(202),
  [1724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(245),
  [1727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(270),
  [1730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(245),
  [1733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(206),
  [1736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(248),
  [1739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(189),
  [1742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(169),
  [1745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(200),
  [1748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(177),
  [1751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(203),
  [1754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(259),
  [1757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(251),
  [1760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(98),
  [1763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(91),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(133),
  [1771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(256),
  [1774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(493),
  [1777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(158),
  [1780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(202),
  [1783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(245),
  [1786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(270),
  [1789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(245),
  [1792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(206),
  [1795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(248),
  [1798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(189),
  [1801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(169),
  [1804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(200),
  [1807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(177),
  [1810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(203),
  [1813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(259),
  [1816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(251),
  [1819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(98),
  [1822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(91),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(133),
  [1830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(256),
  [1833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(421),
  [1836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(164),
  [1839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(194),
  [1842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(225),
  [1845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(286),
  [1848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(225),
  [1851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(208),
  [1854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(234),
  [1857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(182),
  [1860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(168),
  [1863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(204),
  [1866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(166),
  [1869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(193),
  [1872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(242),
  [1875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(221),
  [1878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(92),
  [1881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(126),
  [1884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(96),
  [1891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(222),
  [1894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(331),
  [1897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(163),
  [1900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(195),
  [1903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(211),
  [1906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(319),
  [1909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(211),
  [1912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(197),
  [1915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(216),
  [1918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(187),
  [1921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(170),
  [1924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(198),
  [1927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(174),
  [1930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(196),
  [1933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(217),
  [1936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(239),
  [1939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(121),
  [1942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(97),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(99),
  [1950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(218),
  [1953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(493),
  [1956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(158),
  [1959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(202),
  [1962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(245),
  [1965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(270),
  [1968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(245),
  [1971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(206),
  [1974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(248),
  [1977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(189),
  [1980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(169),
  [1983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(200),
  [1986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(177),
  [1989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(203),
  [1992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(259),
  [1995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(251),
  [1998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(98),
  [2001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(91),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(133),
  [2009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(256),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [2036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(331),
  [2051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(163),
  [2054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(195),
  [2057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(211),
  [2060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(319),
  [2063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(211),
  [2066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(197),
  [2069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(216),
  [2072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(187),
  [2075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(170),
  [2078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(198),
  [2081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(174),
  [2084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(196),
  [2087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(217),
  [2090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(239),
  [2093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(121),
  [2096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(97),
  [2099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2),
  [2101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(99),
  [2104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(218),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(493),
  [2162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(158),
  [2165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(202),
  [2168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(245),
  [2171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(270),
  [2174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(245),
  [2177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(206),
  [2180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(248),
  [2183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(189),
  [2186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(169),
  [2189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(200),
  [2192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(177),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(203),
  [2198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(259),
  [2201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(251),
  [2204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(98),
  [2207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(91),
  [2210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(133),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2),
  [2215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(256),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(421),
  [2251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(164),
  [2254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(194),
  [2257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(225),
  [2260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(286),
  [2263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(225),
  [2266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(208),
  [2269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(234),
  [2272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(182),
  [2275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(168),
  [2278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(204),
  [2281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(166),
  [2284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(193),
  [2287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(242),
  [2290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(221),
  [2293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(92),
  [2296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(126),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2),
  [2301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(96),
  [2304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(222),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(580),
  [2318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(160),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2),
  [2323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(238),
  [2326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(289),
  [2329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(382),
  [2332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(289),
  [2335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(246),
  [2338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(285),
  [2341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(191),
  [2344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(184),
  [2347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(214),
  [2350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(190),
  [2353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(252),
  [2356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(279),
  [2359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(231),
  [2362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(93),
  [2365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(94),
  [2368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(95),
  [2371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(229),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2),
  [2378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(343),
  [2381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(148),
  [2384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(199),
  [2387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(254),
  [2390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(253),
  [2393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(254),
  [2396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(201),
  [2399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(241),
  [2402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(183),
  [2405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(175),
  [2408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(205),
  [2411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(178),
  [2414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(207),
  [2417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(227),
  [2420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(237),
  [2423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(260),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_base, 1),
  [2430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(493),
  [2433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(150),
  [2436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(202),
  [2439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(245),
  [2442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(232),
  [2445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(245),
  [2448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(206),
  [2451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(248),
  [2454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(185),
  [2457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(173),
  [2460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(200),
  [2463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(171),
  [2466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(203),
  [2469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(259),
  [2472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(251),
  [2475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(256),
  [2478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(331),
  [2481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(151),
  [2484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(195),
  [2487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(211),
  [2490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(212),
  [2493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(211),
  [2496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(197),
  [2499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(216),
  [2502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(181),
  [2505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(179),
  [2508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(198),
  [2511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(172),
  [2514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(196),
  [2517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(217),
  [2520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(239),
  [2523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(218),
  [2526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(421),
  [2529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(152),
  [2532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(194),
  [2535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(225),
  [2538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(213),
  [2541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(225),
  [2544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(208),
  [2547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(234),
  [2550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(180),
  [2553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(167),
  [2556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(204),
  [2559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(176),
  [2562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(193),
  [2565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(242),
  [2568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(221),
  [2571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(222),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(580),
  [2583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(156),
  [2586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(238),
  [2589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(289),
  [2592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(304),
  [2595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(289),
  [2598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(246),
  [2601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(285),
  [2604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(192),
  [2607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(186),
  [2610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(214),
  [2613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(188),
  [2616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(252),
  [2619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(279),
  [2622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(231),
  [2625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(229),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(159),
  [2635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(286),
  [2638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(182),
  [2641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(168),
  [2644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(166),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(161),
  [2652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(270),
  [2655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(189),
  [2658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(169),
  [2661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(177),
  [2664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(162),
  [2667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(382),
  [2670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(191),
  [2673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(184),
  [2676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(190),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [2683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(165),
  [2686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(319),
  [2689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(187),
  [2692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(170),
  [2695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(174),
  [2698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_base, 1),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [2704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(885),
  [2707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(885),
  [2710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(887),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_base, 1),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(890),
  [2720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(890),
  [2723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(753),
  [2726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(882),
  [2729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(882),
  [2732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(888),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(886),
  [2740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(886),
  [2743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(754),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(764),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(726),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(765),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [2765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(767),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(774),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [2775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(777),
  [2778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(708),
  [2781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(708),
  [2784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(915),
  [2787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(892),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [2792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(891),
  [2795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(891),
  [2798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(755),
  [2801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(719),
  [2804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(719),
  [2807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(921),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [2812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(769),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(713),
  [2820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(713),
  [2823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(916),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(772),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(824),
  [2836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(702),
  [2839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(702),
  [2842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(918),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [2847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(763),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [2854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(810),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(714),
  [2864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(714),
  [2867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(919),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(825),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__whitespace, 1),
  [2877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__whitespace, 1),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1127),
  [2884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(964),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1132),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(909),
  [2899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(908),
  [2902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(908),
  [2905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1125),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1130),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_description_non_empty, 4, .production_id = 5),
  [2943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_description_non_empty, 4, .production_id = 5),
  [2945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(71),
  [2948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(80),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__soft_line_break, 1),
  [2975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__soft_line_break, 1),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(228),
  [2998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(690),
  [3001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(704),
  [3004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(725),
  [3007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(680),
  [3010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(673),
  [3013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(693),
  [3016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(668),
  [3019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(724),
  [3022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(724),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [3031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [3037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(65),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1128),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1),
  [3069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(250),
  [3072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(700),
  [3075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(706),
  [3078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(705),
  [3081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(677),
  [3084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(672),
  [3087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(701),
  [3090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(671),
  [3093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(707),
  [3096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(707),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(77),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [3116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 1),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cdata_section, 3, .dynamic_precedence = 100),
  [3126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cdata_section, 3, .dynamic_precedence = 100),
  [3128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 6, .dynamic_precedence = 10),
  [3130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 6, .dynamic_precedence = 10),
  [3132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_label, 3),
  [3134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_label, 3),
  [3136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shortcut_link, 1, .dynamic_precedence = 10),
  [3138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__link_text, 1, .dynamic_precedence = 10), REDUCE(sym_shortcut_link, 1, .dynamic_precedence = 10),
  [3141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shortcut_link, 1, .dynamic_precedence = 10),
  [3143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_image, 1),
  [3145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_image, 1),
  [3147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_shortcut_link, 1, .dynamic_precedence = 30),
  [3149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_shortcut_link, 1, .dynamic_precedence = 30), REDUCE(sym__image_description, 1, .dynamic_precedence = 30),
  [3152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_shortcut_link, 1, .dynamic_precedence = 30),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2),
  [3158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(522),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [3179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2),
  [3181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2),
  [3183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(520),
  [3186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1, .production_id = 1),
  [3188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 1, .production_id = 1),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_tag, 1),
  [3194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_tag, 1),
  [3196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline, 1),
  [3198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__inline, 1),
  [3200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 5, .dynamic_precedence = 100),
  [3202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 5, .dynamic_precedence = 100),
  [3204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__open_tag, 5, .dynamic_precedence = 100),
  [3206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__open_tag, 5, .dynamic_precedence = 100),
  [3208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closing_tag, 5, .dynamic_precedence = 100),
  [3210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closing_tag, 5, .dynamic_precedence = 100),
  [3212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 1, .production_id = 2),
  [3214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 1, .production_id = 2),
  [3216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_span, 2),
  [3218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_span, 2),
  [3220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(369),
  [3223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 5, .dynamic_precedence = 10),
  [3225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 5, .dynamic_precedence = 10),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 5, .dynamic_precedence = 10),
  [3233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 5, .dynamic_precedence = 10),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [3239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(380),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1, .production_id = 2),
  [3244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1, .production_id = 2),
  [3246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_latex_block, 2),
  [3248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_latex_block, 2),
  [3250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 2),
  [3252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 2),
  [3254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_base, 2),
  [3256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_base, 2),
  [3258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__open_tag, 6, .dynamic_precedence = 100),
  [3260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__open_tag, 6, .dynamic_precedence = 100),
  [3262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 6, .dynamic_precedence = 100),
  [3264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 6, .dynamic_precedence = 100),
  [3266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 4, .dynamic_precedence = 10),
  [3268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 4, .dynamic_precedence = 10),
  [3270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hard_line_break, 2),
  [3272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hard_line_break, 2),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [3276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__soft_line_break, 2),
  [3278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__soft_line_break, 2),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [3284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(69),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [3289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 6, .dynamic_precedence = 10),
  [3291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 6, .dynamic_precedence = 10),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 2, .dynamic_precedence = 100),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 2, .dynamic_precedence = 100),
  [3297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__processing_instruction, 2, .dynamic_precedence = 100),
  [3299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__processing_instruction, 2, .dynamic_precedence = 100),
  [3301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 4, .dynamic_precedence = 10),
  [3303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 4, .dynamic_precedence = 10),
  [3305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cdata_section, 2, .dynamic_precedence = 100),
  [3307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cdata_section, 2, .dynamic_precedence = 100),
  [3309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__whitespace, 2),
  [3311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__whitespace, 2),
  [3313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(455),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(453),
  [3323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_reference_link, 2, .dynamic_precedence = 20),
  [3325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_reference_link, 2, .dynamic_precedence = 20),
  [3327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 7, .dynamic_precedence = 10),
  [3329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 7, .dynamic_precedence = 10),
  [3331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(575),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 7, .dynamic_precedence = 10),
  [3336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 7, .dynamic_precedence = 10),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [3340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(573),
  [3343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 8, .dynamic_precedence = 10),
  [3345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 8, .dynamic_precedence = 10),
  [3347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 8, .dynamic_precedence = 10),
  [3349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 8, .dynamic_precedence = 10),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 4, .dynamic_precedence = 100),
  [3357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 4, .dynamic_precedence = 100),
  [3359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 4, .dynamic_precedence = 100),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 4, .dynamic_precedence = 100),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_backslash_escape, 1),
  [3365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_backslash_escape, 1),
  [3367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__open_tag, 4, .dynamic_precedence = 100),
  [3369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__open_tag, 4, .dynamic_precedence = 100),
  [3371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closing_tag, 4, .dynamic_precedence = 100),
  [3373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closing_tag, 4, .dynamic_precedence = 100),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [3377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(678),
  [3380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(337),
  [3383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2),
  [3385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(669),
  [3388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(669),
  [3391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(667),
  [3394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(674),
  [3397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(674),
  [3400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 3, .dynamic_precedence = 100),
  [3402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 3, .dynamic_precedence = 100),
  [3404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__processing_instruction, 3, .dynamic_precedence = 100),
  [3406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__processing_instruction, 3, .dynamic_precedence = 100),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 3, .dynamic_precedence = 100),
  [3410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 3, .dynamic_precedence = 100),
  [3412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__open_tag, 3, .dynamic_precedence = 100),
  [3414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__open_tag, 3, .dynamic_precedence = 100),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_full_reference_link, 2, .dynamic_precedence = 10),
  [3420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_full_reference_link, 2, .dynamic_precedence = 10),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [3424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_span, 3),
  [3426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_span, 3),
  [3428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star, 2),
  [3430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_star, 2),
  [3432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_star, 3, .dynamic_precedence = 1, .production_id = 3),
  [3434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_star, 3, .dynamic_precedence = 1, .production_id = 3),
  [3436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strong_emphasis_star, 3, .dynamic_precedence = 2, .production_id = 3),
  [3438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strong_emphasis_star, 3, .dynamic_precedence = 2, .production_id = 3),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_underscore, 3, .dynamic_precedence = 1, .production_id = 3),
  [3442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_underscore, 3, .dynamic_precedence = 1, .production_id = 3),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strong_emphasis_underscore, 3, .dynamic_precedence = 2, .production_id = 3),
  [3446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strong_emphasis_underscore, 3, .dynamic_precedence = 2, .production_id = 3),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strikethrough, 3, .dynamic_precedence = 1, .production_id = 3),
  [3450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strikethrough, 3, .dynamic_precedence = 1, .production_id = 3),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_latex_block, 3),
  [3454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_latex_block, 3),
  [3456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_text_non_empty, 3, .production_id = 4),
  [3458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__link_text_non_empty, 3, .production_id = 4),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 2),
  [3462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 2),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_collapsed_reference_link, 3, .dynamic_precedence = 10),
  [3474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_collapsed_reference_link, 3, .dynamic_precedence = 10),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 3, .dynamic_precedence = 10),
  [3478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 3, .dynamic_precedence = 10),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_collapsed_reference_link, 3, .dynamic_precedence = 10),
  [3482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_collapsed_reference_link, 3, .dynamic_precedence = 10),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 3, .dynamic_precedence = 10),
  [3486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 3, .dynamic_precedence = 10),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_star, 4, .dynamic_precedence = 1, .production_id = 3),
  [3490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_star, 4, .dynamic_precedence = 1, .production_id = 3),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_underscore, 4, .dynamic_precedence = 1, .production_id = 3),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_underscore, 4, .dynamic_precedence = 1, .production_id = 3),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strikethrough, 4, .dynamic_precedence = 1, .production_id = 3),
  [3498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strikethrough, 4, .dynamic_precedence = 1, .production_id = 3),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 2),
  [3502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 2),
  [3504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(373),
  [3507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(371),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_description, 3, .dynamic_precedence = 30),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [3516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_description, 1, .dynamic_precedence = 30),
  [3518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strong_emphasis_star_no_link, 3, .dynamic_precedence = 2, .production_id = 3),
  [3520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strong_emphasis_star_no_link, 3, .dynamic_precedence = 2, .production_id = 3),
  [3522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_underscore_no_link, 3, .dynamic_precedence = 1, .production_id = 3),
  [3524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_underscore_no_link, 3, .dynamic_precedence = 1, .production_id = 3),
  [3526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1, .production_id = 2),
  [3528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1, .production_id = 2),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [3532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_underscore_no_link, 4, .dynamic_precedence = 1, .production_id = 3),
  [3534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_underscore_no_link, 4, .dynamic_precedence = 1, .production_id = 3),
  [3536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strikethrough_no_link, 4, .dynamic_precedence = 1, .production_id = 3),
  [3538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strikethrough_no_link, 4, .dynamic_precedence = 1, .production_id = 3),
  [3540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_star_no_link, 4, .dynamic_precedence = 1, .production_id = 3),
  [3542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_star_no_link, 4, .dynamic_precedence = 1, .production_id = 3),
  [3544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1, .production_id = 2),
  [3546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1, .production_id = 2),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [3550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_star_no_link, 3, .dynamic_precedence = 1, .production_id = 3),
  [3552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_star_no_link, 3, .dynamic_precedence = 1, .production_id = 3),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strong_emphasis_underscore_no_link, 3, .dynamic_precedence = 2, .production_id = 3),
  [3556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strong_emphasis_underscore_no_link, 3, .dynamic_precedence = 2, .production_id = 3),
  [3558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strikethrough_no_link, 3, .dynamic_precedence = 1, .production_id = 3),
  [3560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strikethrough_no_link, 3, .dynamic_precedence = 1, .production_id = 3),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [3568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 1),
  [3570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 1),
  [3572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1, .production_id = 2),
  [3574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1, .production_id = 2),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [3580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1, .production_id = 2),
  [3582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1, .production_id = 2),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [3596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [3634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(844),
  [3637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(850),
  [3640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(859),
  [3643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(859),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [3680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(839),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [3687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(790),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [3704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(795),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [3709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(793),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(787),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(716),
  [3722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(716),
  [3725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(920),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [3730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(792),
  [3733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(711),
  [3736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(711),
  [3739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(917),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [3744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(782),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [3753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [3755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(863),
  [3758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(830),
  [3761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(856),
  [3764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(856),
  [3767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(852),
  [3770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(871),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1),
  [3775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 1),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [3779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(863),
  [3782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(683),
  [3785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(844),
  [3788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2),
  [3790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(844),
  [3793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(850),
  [3796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(859),
  [3799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(859),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [3812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10),
  [3814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10),
  [3816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(863),
  [3819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(830),
  [3822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(856),
  [3825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(856),
  [3828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(852),
  [3831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(871),
  [3834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1),
  [3836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 1),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [3848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(863),
  [3851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(689),
  [3854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(839),
  [3857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(839),
  [3860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2),
  [3862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(850),
  [3865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(859),
  [3868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(859),
  [3871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1131),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [3878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_destination, 3, .dynamic_precedence = 10),
  [3880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_destination, 3, .dynamic_precedence = 10),
  [3882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(863),
  [3885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(692),
  [3888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(856),
  [3891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(856),
  [3894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(852),
  [3897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2),
  [3899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [3903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_destination, 2, .dynamic_precedence = 10),
  [3905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_destination, 2, .dynamic_precedence = 10),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(863),
  [3918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(698),
  [3921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(873),
  [3924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(873),
  [3927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2),
  [3929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(850),
  [3932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(859),
  [3935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(859),
  [3938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1126),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [3981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(863),
  [3984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(710),
  [3987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(884),
  [3990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2),
  [3992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(884),
  [3995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(859),
  [3998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(859),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2),
  [4039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2),
  [4041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(850),
  [4044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(859),
  [4047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(859),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [4118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [4124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(889),
  [4127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(893),
  [4130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(892),
  [4133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2),
  [4135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(891),
  [4138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(891),
  [4141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(757),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [4178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(885),
  [4181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(885),
  [4184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(887),
  [4187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2),
  [4189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(890),
  [4192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(890),
  [4195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(799),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [4200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(882),
  [4203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(882),
  [4206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(888),
  [4209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(886),
  [4212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(886),
  [4215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(809),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat3, 1),
  [4259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat3, 1),
  [4262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1),
  [4264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 1),
  [4266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 1),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [4280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(906),
  [4283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2),
  [4285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(909),
  [4288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(908),
  [4291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(908),
  [4294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(835),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [4301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(901),
  [4304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2),
  [4306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(909),
  [4309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(908),
  [4312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(908),
  [4315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(837),
  [4318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT_REPEAT(1129),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat2, 1),
  [4328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat2, 1),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [4335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT_REPEAT(1129),
  [4338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1),
  [4340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(sym_link_title, 2),
  [4343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(sym_link_title, 2),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat1, 1),
  [4361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat1, 1),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [4382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(896),
  [4385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2),
  [4387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(909),
  [4390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(908),
  [4393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(908),
  [4396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(855),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [4413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 2),
  [4415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 2),
  [4417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_destination_parenthesis, 3),
  [4419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__link_destination_parenthesis, 3),
  [4421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_destination_parenthesis, 2),
  [4423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__link_destination_parenthesis, 2),
  [4425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__link_destination_parenthesis, 2), REDUCE(sym_link_title, 2),
  [4428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__link_destination_parenthesis, 2), REDUCE(sym_link_title, 2),
  [4431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 1), SHIFT_REPEAT(1129),
  [4434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat3, 2),
  [4437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat3, 2),
  [4440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 2),
  [4442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 3),
  [4444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 3),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [4448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 3),
  [4450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 3),
  [4452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat1, 2),
  [4455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat1, 2),
  [4458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat2, 2),
  [4461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat2, 2),
  [4464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 3),
  [4466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 3),
  [4468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 1),
  [4470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 1),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 2),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [4478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_no_angle, 1),
  [4480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_no_angle, 1),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [4492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 1),
  [4494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 1),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [4506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 1),
  [4508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 1),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [4512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2),
  [4514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_no_angle, 2),
  [4516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_no_angle, 2),
  [4518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 1),
  [4520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat2, 1),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [4524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 3),
  [4526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 3),
  [4528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 1),
  [4530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat1, 1),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [4538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat2, 2),
  [4540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat1, 2),
  [4542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(892),
  [4561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(891),
  [4564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(891),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [4649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [4673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__open_tag_repeat1, 2),
  [4675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__open_tag_repeat1, 2), SHIFT_REPEAT(1035),
  [4678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__open_tag_repeat1, 2), SHIFT_REPEAT(987),
  [4681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__open_tag_repeat1, 2), SHIFT_REPEAT(987),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [4704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tag_name, 1),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [4708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tag_name, 1),
  [4710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(1035),
  [4713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(987),
  [4716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(987),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [4731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tag_name_repeat1, 2),
  [4733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tag_name_repeat1, 2), SHIFT_REPEAT(971),
  [4736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__tag_name_repeat1, 2),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [4750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(993),
  [4753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(991),
  [4756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(991),
  [4759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tag_name, 2),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [4763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tag_name, 2),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [4849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute, 5),
  [4851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute, 5),
  [4853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute, 4),
  [4855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute, 4),
  [4857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_value, 2),
  [4859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_value, 2),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_value, 3),
  [4863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_value, 3),
  [4865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute, 6),
  [4867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute, 6),
  [4869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_title, 2),
  [4871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_title, 2),
  [4873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_title, 3),
  [4875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_title, 3),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [4921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_text, 2, .dynamic_precedence = 10),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4929] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_markdown_inline_external_scanner_create(void);
void tree_sitter_markdown_inline_external_scanner_destroy(void *);
bool tree_sitter_markdown_inline_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_markdown_inline_external_scanner_serialize(void *, char *);
void tree_sitter_markdown_inline_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_markdown_inline(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_markdown_inline_external_scanner_create,
      tree_sitter_markdown_inline_external_scanner_destroy,
      tree_sitter_markdown_inline_external_scanner_scan,
      tree_sitter_markdown_inline_external_scanner_serialize,
      tree_sitter_markdown_inline_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
