#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1516
#define LARGE_STATE_COUNT 507
#define SYMBOL_COUNT 320
#define ALIAS_COUNT 3
#define TOKEN_COUNT 177
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 25
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 85

enum {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  anon_sym_LF = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  aux_sym_preproc_if_token2 = 10,
  aux_sym_preproc_ifdef_token1 = 11,
  aux_sym_preproc_ifdef_token2 = 12,
  aux_sym_preproc_else_token1 = 13,
  aux_sym_preproc_elif_token1 = 14,
  sym_preproc_directive = 15,
  sym_preproc_arg = 16,
  anon_sym_LPAREN2 = 17,
  anon_sym_defined = 18,
  anon_sym_BANG = 19,
  anon_sym_TILDE = 20,
  anon_sym_DASH = 21,
  anon_sym_PLUS = 22,
  anon_sym_STAR = 23,
  anon_sym_SLASH = 24,
  anon_sym_PERCENT = 25,
  anon_sym_PIPE_PIPE = 26,
  anon_sym_AMP_AMP = 27,
  anon_sym_PIPE = 28,
  anon_sym_CARET = 29,
  anon_sym_AMP = 30,
  anon_sym_EQ_EQ = 31,
  anon_sym_BANG_EQ = 32,
  anon_sym_GT = 33,
  anon_sym_GT_EQ = 34,
  anon_sym_LT_EQ = 35,
  anon_sym_LT = 36,
  anon_sym_LT_LT = 37,
  anon_sym_GT_GT = 38,
  anon_sym_SEMI = 39,
  anon_sym_typedef = 40,
  anon_sym_kernel = 41,
  anon_sym___kernel = 42,
  anon_sym_global = 43,
  anon_sym___global = 44,
  anon_sym_local = 45,
  anon_sym___local = 46,
  anon_sym_constant = 47,
  anon_sym___constant = 48,
  anon_sym_private = 49,
  anon_sym___private = 50,
  anon_sym_generic = 51,
  anon_sym___generic = 52,
  anon_sym_read_only = 53,
  anon_sym___read_only = 54,
  anon_sym_write_only = 55,
  anon_sym___write_only = 56,
  anon_sym_read_write = 57,
  anon_sym___read_write = 58,
  anon_sym_extern = 59,
  anon_sym___attribute__ = 60,
  anon_sym_COLON_COLON = 61,
  anon_sym_LBRACK_LBRACK = 62,
  anon_sym_RBRACK_RBRACK = 63,
  anon_sym___declspec = 64,
  anon_sym___based = 65,
  anon_sym___cdecl = 66,
  anon_sym___clrcall = 67,
  anon_sym___stdcall = 68,
  anon_sym___fastcall = 69,
  anon_sym___thiscall = 70,
  anon_sym___vectorcall = 71,
  sym_ms_restrict_modifier = 72,
  sym_ms_unsigned_ptr_modifier = 73,
  sym_ms_signed_ptr_modifier = 74,
  anon_sym__unaligned = 75,
  anon_sym___unaligned = 76,
  anon_sym_LBRACE = 77,
  anon_sym_RBRACE = 78,
  anon_sym_LBRACK = 79,
  anon_sym_RBRACK = 80,
  anon_sym_EQ = 81,
  anon_sym_static = 82,
  anon_sym_auto = 83,
  anon_sym_register = 84,
  anon_sym_inline = 85,
  anon_sym_const = 86,
  anon_sym_volatile = 87,
  anon_sym_restrict = 88,
  anon_sym__Atomic = 89,
  anon_sym_pipe = 90,
  anon_sym_signed = 91,
  anon_sym_unsigned = 92,
  anon_sym_long = 93,
  anon_sym_short = 94,
  anon_sym_bool = 95,
  anon_sym_char = 96,
  anon_sym_uchar = 97,
  anon_sym_ushort = 98,
  anon_sym_int = 99,
  anon_sym_uint = 100,
  anon_sym_ulong = 101,
  anon_sym_float = 102,
  anon_sym_double = 103,
  anon_sym_half = 104,
  anon_sym_size_t = 105,
  anon_sym_ptrdiff_t = 106,
  anon_sym_intptr_t = 107,
  anon_sym_uintptr_t = 108,
  anon_sym_void = 109,
  sym_vector_type = 110,
  anon_sym_image2d_t = 111,
  anon_sym_image3d_t = 112,
  anon_sym_image2d_array_t = 113,
  anon_sym_image1d_t = 114,
  anon_sym_image1d_buffer_t = 115,
  anon_sym_image1d_array_t = 116,
  anon_sym_image2d_depth_t = 117,
  anon_sym_image2d_array_depth_t = 118,
  anon_sym_sampler_t = 119,
  anon_sym_queue_t = 120,
  anon_sym_ndrange_t = 121,
  anon_sym_clk_event_t = 122,
  anon_sym_reserve_id_t = 123,
  anon_sym_event_t = 124,
  anon_sym_cl_mem_fence_flags = 125,
  anon_sym_enum = 126,
  anon_sym_struct = 127,
  anon_sym_union = 128,
  anon_sym_COLON = 129,
  anon_sym_if = 130,
  anon_sym_else = 131,
  anon_sym_switch = 132,
  anon_sym_case = 133,
  anon_sym_default = 134,
  anon_sym_while = 135,
  anon_sym_do = 136,
  anon_sym_for = 137,
  anon_sym_return = 138,
  anon_sym_break = 139,
  anon_sym_continue = 140,
  anon_sym_goto = 141,
  anon_sym_QMARK = 142,
  anon_sym_STAR_EQ = 143,
  anon_sym_SLASH_EQ = 144,
  anon_sym_PERCENT_EQ = 145,
  anon_sym_PLUS_EQ = 146,
  anon_sym_DASH_EQ = 147,
  anon_sym_LT_LT_EQ = 148,
  anon_sym_GT_GT_EQ = 149,
  anon_sym_AMP_EQ = 150,
  anon_sym_CARET_EQ = 151,
  anon_sym_PIPE_EQ = 152,
  anon_sym_DASH_DASH = 153,
  anon_sym_PLUS_PLUS = 154,
  anon_sym_sizeof = 155,
  anon_sym_DOT = 156,
  anon_sym_DASH_GT = 157,
  sym_number_literal = 158,
  anon_sym_L_SQUOTE = 159,
  anon_sym_u_SQUOTE = 160,
  anon_sym_U_SQUOTE = 161,
  anon_sym_u8_SQUOTE = 162,
  anon_sym_SQUOTE = 163,
  aux_sym_char_literal_token1 = 164,
  anon_sym_L_DQUOTE = 165,
  anon_sym_u_DQUOTE = 166,
  anon_sym_U_DQUOTE = 167,
  anon_sym_u8_DQUOTE = 168,
  anon_sym_DQUOTE = 169,
  aux_sym_string_literal_token1 = 170,
  sym_escape_sequence = 171,
  sym_system_lib_string = 172,
  sym_true = 173,
  sym_false = 174,
  sym_null = 175,
  sym_comment = 176,
  sym_translation_unit = 177,
  sym_preproc_include = 178,
  sym_preproc_def = 179,
  sym_preproc_function_def = 180,
  sym_preproc_params = 181,
  sym_preproc_call = 182,
  sym_preproc_if = 183,
  sym_preproc_ifdef = 184,
  sym_preproc_else = 185,
  sym_preproc_elif = 186,
  sym_preproc_if_in_field_declaration_list = 187,
  sym_preproc_ifdef_in_field_declaration_list = 188,
  sym_preproc_else_in_field_declaration_list = 189,
  sym_preproc_elif_in_field_declaration_list = 190,
  sym__preproc_expression = 191,
  sym_preproc_parenthesized_expression = 192,
  sym_preproc_defined = 193,
  sym_preproc_unary_expression = 194,
  sym_preproc_call_expression = 195,
  sym_preproc_argument_list = 196,
  sym_preproc_binary_expression = 197,
  sym_function_definition = 198,
  sym_declaration = 199,
  sym_type_definition = 200,
  sym_function_qualifier = 201,
  sym_address_space_qualifier = 202,
  sym_access_qualifier = 203,
  sym__declaration_modifiers = 204,
  sym__declaration_specifiers = 205,
  sym_linkage_specification = 206,
  sym_attribute_specifier = 207,
  sym_attribute = 208,
  sym_attribute_declaration = 209,
  sym_ms_declspec_modifier = 210,
  sym_ms_based_modifier = 211,
  sym_ms_call_modifier = 212,
  sym_ms_unaligned_ptr_modifier = 213,
  sym_ms_pointer_modifier = 214,
  sym_declaration_list = 215,
  sym__declarator = 216,
  sym__field_declarator = 217,
  sym__type_declarator = 218,
  sym__abstract_declarator = 219,
  sym_parenthesized_declarator = 220,
  sym_parenthesized_field_declarator = 221,
  sym_parenthesized_type_declarator = 222,
  sym_abstract_parenthesized_declarator = 223,
  sym_attributed_declarator = 224,
  sym_attributed_field_declarator = 225,
  sym_attributed_type_declarator = 226,
  sym_pointer_declarator = 227,
  sym_pointer_field_declarator = 228,
  sym_pointer_type_declarator = 229,
  sym_abstract_pointer_declarator = 230,
  sym_function_declarator = 231,
  sym_function_field_declarator = 232,
  sym_function_type_declarator = 233,
  sym_abstract_function_declarator = 234,
  sym_array_declarator = 235,
  sym_array_field_declarator = 236,
  sym_array_type_declarator = 237,
  sym_abstract_array_declarator = 238,
  sym_init_declarator = 239,
  sym_compound_statement = 240,
  sym_storage_class_specifier = 241,
  sym_type_qualifier = 242,
  sym__type_specifier = 243,
  sym_sized_type_specifier = 244,
  sym_scalar_type = 245,
  sym_other_builtin_type = 246,
  sym_enum_specifier = 247,
  sym_enumerator_list = 248,
  sym_struct_specifier = 249,
  sym_union_specifier = 250,
  sym_field_declaration_list = 251,
  sym__field_declaration_list_item = 252,
  sym_field_declaration = 253,
  sym_bitfield_clause = 254,
  sym_enumerator = 255,
  sym_variadic_parameter = 256,
  sym_parameter_list = 257,
  sym_parameter_declaration = 258,
  sym_attributed_statement = 259,
  sym_labeled_statement = 260,
  sym_expression_statement = 261,
  sym_if_statement = 262,
  sym_switch_statement = 263,
  sym_case_statement = 264,
  sym_while_statement = 265,
  sym_do_statement = 266,
  sym_for_statement = 267,
  sym_return_statement = 268,
  sym_break_statement = 269,
  sym_continue_statement = 270,
  sym_goto_statement = 271,
  sym__expression = 272,
  sym_comma_expression = 273,
  sym_conditional_expression = 274,
  sym_assignment_expression = 275,
  sym_pointer_expression = 276,
  sym_unary_expression = 277,
  sym_binary_expression = 278,
  sym_update_expression = 279,
  sym_cast_expression = 280,
  sym_type_descriptor = 281,
  sym_sizeof_expression = 282,
  sym_subscript_expression = 283,
  sym_call_expression = 284,
  sym_argument_list = 285,
  sym_field_expression = 286,
  sym_compound_literal_expression = 287,
  sym_parenthesized_expression = 288,
  sym_initializer_list = 289,
  sym_initializer_pair = 290,
  sym_subscript_designator = 291,
  sym_field_designator = 292,
  sym_char_literal = 293,
  sym_concatenated_string = 294,
  sym_string_literal = 295,
  sym__empty_declaration = 296,
  sym_macro_type_specifier = 297,
  aux_sym_translation_unit_repeat1 = 298,
  aux_sym_preproc_params_repeat1 = 299,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 300,
  aux_sym_preproc_argument_list_repeat1 = 301,
  aux_sym_declaration_repeat1 = 302,
  aux_sym_type_definition_repeat1 = 303,
  aux_sym_type_definition_repeat2 = 304,
  aux_sym__declaration_specifiers_repeat1 = 305,
  aux_sym_attribute_declaration_repeat1 = 306,
  aux_sym_attributed_declarator_repeat1 = 307,
  aux_sym_pointer_declarator_repeat1 = 308,
  aux_sym_function_declarator_repeat1 = 309,
  aux_sym_sized_type_specifier_repeat1 = 310,
  aux_sym_enumerator_list_repeat1 = 311,
  aux_sym_field_declaration_repeat1 = 312,
  aux_sym_parameter_list_repeat1 = 313,
  aux_sym_case_statement_repeat1 = 314,
  aux_sym_argument_list_repeat1 = 315,
  aux_sym_initializer_list_repeat1 = 316,
  aux_sym_initializer_pair_repeat1 = 317,
  aux_sym_concatenated_string_repeat1 = 318,
  aux_sym_string_literal_repeat1 = 319,
  alias_sym_field_identifier = 320,
  alias_sym_statement_identifier = 321,
  alias_sym_type_identifier = 322,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [sym_preproc_directive] = "preproc_directive",
  [sym_preproc_arg] = "preproc_arg",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym_typedef] = "typedef",
  [anon_sym_kernel] = "kernel",
  [anon_sym___kernel] = "__kernel",
  [anon_sym_global] = "global",
  [anon_sym___global] = "__global",
  [anon_sym_local] = "local",
  [anon_sym___local] = "__local",
  [anon_sym_constant] = "constant",
  [anon_sym___constant] = "__constant",
  [anon_sym_private] = "private",
  [anon_sym___private] = "__private",
  [anon_sym_generic] = "generic",
  [anon_sym___generic] = "__generic",
  [anon_sym_read_only] = "read_only",
  [anon_sym___read_only] = "__read_only",
  [anon_sym_write_only] = "write_only",
  [anon_sym___write_only] = "__write_only",
  [anon_sym_read_write] = "read_write",
  [anon_sym___read_write] = "__read_write",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_auto] = "auto",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym_const] = "const",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym_pipe] = "pipe",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_bool] = "bool",
  [anon_sym_char] = "char",
  [anon_sym_uchar] = "uchar",
  [anon_sym_ushort] = "ushort",
  [anon_sym_int] = "int",
  [anon_sym_uint] = "uint",
  [anon_sym_ulong] = "ulong",
  [anon_sym_float] = "float",
  [anon_sym_double] = "double",
  [anon_sym_half] = "half",
  [anon_sym_size_t] = "size_t",
  [anon_sym_ptrdiff_t] = "ptrdiff_t",
  [anon_sym_intptr_t] = "intptr_t",
  [anon_sym_uintptr_t] = "uintptr_t",
  [anon_sym_void] = "void",
  [sym_vector_type] = "vector_type",
  [anon_sym_image2d_t] = "image2d_t",
  [anon_sym_image3d_t] = "image3d_t",
  [anon_sym_image2d_array_t] = "image2d_array_t",
  [anon_sym_image1d_t] = "image1d_t",
  [anon_sym_image1d_buffer_t] = "image1d_buffer_t",
  [anon_sym_image1d_array_t] = "image1d_array_t",
  [anon_sym_image2d_depth_t] = "image2d_depth_t",
  [anon_sym_image2d_array_depth_t] = "image2d_array_depth_t",
  [anon_sym_sampler_t] = "sampler_t",
  [anon_sym_queue_t] = "queue_t",
  [anon_sym_ndrange_t] = "ndrange_t",
  [anon_sym_clk_event_t] = "clk_event_t",
  [anon_sym_reserve_id_t] = "reserve_id_t",
  [anon_sym_event_t] = "event_t",
  [anon_sym_cl_mem_fence_flags] = "cl_mem_fence_flags",
  [anon_sym_enum] = "enum",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "char_literal_token1",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_literal_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_comment] = "comment",
  [sym_translation_unit] = "translation_unit",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym_function_qualifier] = "function_qualifier",
  [sym_address_space_qualifier] = "address_space_qualifier",
  [sym_access_qualifier] = "access_qualifier",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym__type_specifier] = "_type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_scalar_type] = "scalar_type",
  [sym_other_builtin_type] = "other_builtin_type",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym__expression] = "_expression",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym_type_definition_repeat2] = "type_definition_repeat2",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_function_declarator_repeat1] = "function_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [sym_preproc_directive] = sym_preproc_directive,
  [sym_preproc_arg] = sym_preproc_arg,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_kernel] = anon_sym_kernel,
  [anon_sym___kernel] = anon_sym___kernel,
  [anon_sym_global] = anon_sym_global,
  [anon_sym___global] = anon_sym___global,
  [anon_sym_local] = anon_sym_local,
  [anon_sym___local] = anon_sym___local,
  [anon_sym_constant] = anon_sym_constant,
  [anon_sym___constant] = anon_sym___constant,
  [anon_sym_private] = anon_sym_private,
  [anon_sym___private] = anon_sym___private,
  [anon_sym_generic] = anon_sym_generic,
  [anon_sym___generic] = anon_sym___generic,
  [anon_sym_read_only] = anon_sym_read_only,
  [anon_sym___read_only] = anon_sym___read_only,
  [anon_sym_write_only] = anon_sym_write_only,
  [anon_sym___write_only] = anon_sym___write_only,
  [anon_sym_read_write] = anon_sym_read_write,
  [anon_sym___read_write] = anon_sym___read_write,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_auto] = anon_sym_auto,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym_pipe] = anon_sym_pipe,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_char] = anon_sym_char,
  [anon_sym_uchar] = anon_sym_uchar,
  [anon_sym_ushort] = anon_sym_ushort,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_uint] = anon_sym_uint,
  [anon_sym_ulong] = anon_sym_ulong,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_double] = anon_sym_double,
  [anon_sym_half] = anon_sym_half,
  [anon_sym_size_t] = anon_sym_size_t,
  [anon_sym_ptrdiff_t] = anon_sym_ptrdiff_t,
  [anon_sym_intptr_t] = anon_sym_intptr_t,
  [anon_sym_uintptr_t] = anon_sym_uintptr_t,
  [anon_sym_void] = anon_sym_void,
  [sym_vector_type] = sym_vector_type,
  [anon_sym_image2d_t] = anon_sym_image2d_t,
  [anon_sym_image3d_t] = anon_sym_image3d_t,
  [anon_sym_image2d_array_t] = anon_sym_image2d_array_t,
  [anon_sym_image1d_t] = anon_sym_image1d_t,
  [anon_sym_image1d_buffer_t] = anon_sym_image1d_buffer_t,
  [anon_sym_image1d_array_t] = anon_sym_image1d_array_t,
  [anon_sym_image2d_depth_t] = anon_sym_image2d_depth_t,
  [anon_sym_image2d_array_depth_t] = anon_sym_image2d_array_depth_t,
  [anon_sym_sampler_t] = anon_sym_sampler_t,
  [anon_sym_queue_t] = anon_sym_queue_t,
  [anon_sym_ndrange_t] = anon_sym_ndrange_t,
  [anon_sym_clk_event_t] = anon_sym_clk_event_t,
  [anon_sym_reserve_id_t] = anon_sym_reserve_id_t,
  [anon_sym_event_t] = anon_sym_event_t,
  [anon_sym_cl_mem_fence_flags] = anon_sym_cl_mem_fence_flags,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_comment] = sym_comment,
  [sym_translation_unit] = sym_translation_unit,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym_function_qualifier] = sym_function_qualifier,
  [sym_address_space_qualifier] = sym_address_space_qualifier,
  [sym_access_qualifier] = sym_access_qualifier,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym__type_specifier] = sym__type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_scalar_type] = sym_scalar_type,
  [sym_other_builtin_type] = sym_other_builtin_type,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym__expression] = sym__expression,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_macro_type_specifier] = sym_macro_type_specifier,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym_type_definition_repeat2] = aux_sym_type_definition_repeat2,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_function_declarator_repeat1] = aux_sym_function_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_kernel] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___kernel] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___constant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_read_only] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___read_only] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_write_only] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___write_only] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_read_write] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___read_write] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_auto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pipe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uchar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ushort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ulong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_half] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_size_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ptrdiff_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_intptr_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uintptr_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [sym_vector_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_image2d_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image3d_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image2d_array_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image1d_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image1d_buffer_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image1d_array_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image2d_depth_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_image2d_array_depth_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sampler_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_queue_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ndrange_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_clk_event_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_reserve_id_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cl_mem_fence_flags] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_function_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_address_space_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_access_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scalar_type] = {
    .visible = true,
    .named = true,
  },
  [sym_other_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_body = 4,
  field_condition = 5,
  field_consequence = 6,
  field_declarator = 7,
  field_designator = 8,
  field_directive = 9,
  field_field = 10,
  field_function = 11,
  field_index = 12,
  field_initializer = 13,
  field_label = 14,
  field_left = 15,
  field_name = 16,
  field_operator = 17,
  field_parameters = 18,
  field_path = 19,
  field_prefix = 20,
  field_right = 21,
  field_size = 22,
  field_type = 23,
  field_update = 24,
  field_value = 25,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_declarator] = "declarator",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_field] = "field",
  [field_function] = "function",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_label] = "label",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_prefix] = "prefix",
  [field_right] = "right",
  [field_size] = "size",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 1},
  [8] = {.index = 7, .length = 1},
  [9] = {.index = 8, .length = 2},
  [10] = {.index = 10, .length = 2},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 12, .length = 1},
  [13] = {.index = 13, .length = 1},
  [14] = {.index = 5, .length = 1},
  [15] = {.index = 14, .length = 2},
  [16] = {.index = 16, .length = 2},
  [17] = {.index = 18, .length = 1},
  [18] = {.index = 19, .length = 2},
  [19] = {.index = 21, .length = 2},
  [20] = {.index = 23, .length = 1},
  [21] = {.index = 24, .length = 1},
  [22] = {.index = 25, .length = 2},
  [23] = {.index = 27, .length = 2},
  [24] = {.index = 29, .length = 1},
  [25] = {.index = 30, .length = 3},
  [26] = {.index = 33, .length = 1},
  [27] = {.index = 34, .length = 1},
  [28] = {.index = 35, .length = 2},
  [29] = {.index = 37, .length = 3},
  [30] = {.index = 40, .length = 2},
  [31] = {.index = 42, .length = 2},
  [32] = {.index = 44, .length = 3},
  [33] = {.index = 47, .length = 2},
  [34] = {.index = 49, .length = 2},
  [35] = {.index = 51, .length = 1},
  [36] = {.index = 52, .length = 2},
  [37] = {.index = 54, .length = 1},
  [38] = {.index = 55, .length = 2},
  [39] = {.index = 57, .length = 2},
  [40] = {.index = 59, .length = 2},
  [41] = {.index = 61, .length = 2},
  [43] = {.index = 63, .length = 2},
  [44] = {.index = 65, .length = 1},
  [45] = {.index = 66, .length = 2},
  [46] = {.index = 68, .length = 1},
  [47] = {.index = 69, .length = 1},
  [48] = {.index = 70, .length = 2},
  [49] = {.index = 72, .length = 3},
  [50] = {.index = 75, .length = 2},
  [51] = {.index = 77, .length = 3},
  [52] = {.index = 80, .length = 2},
  [53] = {.index = 82, .length = 3},
  [54] = {.index = 85, .length = 2},
  [55] = {.index = 87, .length = 2},
  [56] = {.index = 89, .length = 1},
  [57] = {.index = 90, .length = 2},
  [58] = {.index = 92, .length = 3},
  [59] = {.index = 95, .length = 2},
  [60] = {.index = 97, .length = 2},
  [61] = {.index = 99, .length = 3},
  [62] = {.index = 102, .length = 2},
  [63] = {.index = 104, .length = 1},
  [64] = {.index = 105, .length = 2},
  [65] = {.index = 107, .length = 3},
  [66] = {.index = 110, .length = 2},
  [67] = {.index = 112, .length = 1},
  [69] = {.index = 113, .length = 3},
  [70] = {.index = 116, .length = 1},
  [71] = {.index = 117, .length = 2},
  [72] = {.index = 119, .length = 1},
  [73] = {.index = 120, .length = 2},
  [74] = {.index = 122, .length = 2},
  [75] = {.index = 124, .length = 2},
  [76] = {.index = 126, .length = 2},
  [77] = {.index = 128, .length = 3},
  [78] = {.index = 131, .length = 3},
  [79] = {.index = 134, .length = 2},
  [80] = {.index = 136, .length = 3},
  [81] = {.index = 139, .length = 4},
  [82] = {.index = 143, .length = 3},
  [83] = {.index = 146, .length = 3},
  [84] = {.index = 149, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_name, 0},
  [5] =
    {field_name, 1},
  [6] =
    {field_body, 1},
  [7] =
    {field_value, 1},
  [8] =
    {field_argument, 0},
    {field_operator, 1},
  [10] =
    {field_arguments, 1},
    {field_function, 0},
  [12] =
    {field_type, 1},
  [13] =
    {field_path, 1},
  [14] =
    {field_argument, 1},
    {field_directive, 0},
  [16] =
    {field_declarator, 1},
    {field_type, 0},
  [18] =
    {field_parameters, 0},
  [19] =
    {field_body, 2},
    {field_value, 1},
  [21] =
    {field_body, 2},
    {field_name, 1},
  [23] =
    {field_name, 2},
  [24] =
    {field_body, 2},
  [25] =
    {field_condition, 1},
    {field_consequence, 2},
  [27] =
    {field_body, 2},
    {field_condition, 1},
  [29] =
    {field_label, 1},
  [30] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [33] =
    {field_label, 0},
  [34] =
    {field_declarator, 1},
  [35] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [37] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [40] =
    {field_declarator, 0},
    {field_parameters, 1},
  [42] =
    {field_left, 0},
    {field_right, 2},
  [44] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [47] =
    {field_name, 1},
    {field_value, 2},
  [49] =
    {field_name, 1},
    {field_parameters, 2},
  [51] =
    {field_condition, 1},
  [52] =
    {field_alternative, 2},
    {field_name, 1},
  [54] =
    {field_type, 0, .inherited = true},
  [55] =
    {field_declarator, 2},
    {field_type, 0},
  [57] =
    {field_type, 1},
    {field_value, 3},
  [59] =
    {field_declarator, 2},
    {field_type, 1},
  [61] =
    {field_name, 2},
    {field_prefix, 0},
  [63] =
    {field_body, 3},
    {field_name, 2},
  [65] =
    {field_type, 2},
  [66] =
    {field_name, 0},
    {field_type, 2},
  [68] =
    {field_declarator, 2},
  [69] =
    {field_declarator, 0},
  [70] =
    {field_declarator, 0},
    {field_value, 2},
  [72] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [75] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [77] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [80] =
    {field_argument, 0},
    {field_index, 2},
  [82] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [85] =
    {field_alternative, 3},
    {field_condition, 1},
  [87] =
    {field_alternative, 3},
    {field_name, 1},
  [89] =
    {field_size, 1},
  [90] =
    {field_declarator, 3},
    {field_type, 1},
  [92] =
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 1},
  [95] =
    {field_declarator, 3},
    {field_type, 2},
  [97] =
    {field_name, 0},
    {field_value, 2},
  [99] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [102] =
    {field_body, 1},
    {field_condition, 3},
  [104] =
    {field_declarator, 3},
  [105] =
    {field_declarator, 0},
    {field_size, 2},
  [107] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [110] =
    {field_alternative, 4},
    {field_condition, 1},
  [112] =
    {field_size, 2},
  [113] =
    {field_declarator, 3},
    {field_declarator, 4, .inherited = true},
    {field_type, 2},
  [116] =
    {field_body, 5},
  [117] =
    {field_body, 5},
    {field_initializer, 2},
  [119] =
    {field_declarator, 4},
  [120] =
    {field_declarator, 0},
    {field_size, 3},
  [122] =
    {field_designator, 0},
    {field_value, 2},
  [124] =
    {field_body, 6},
    {field_update, 4},
  [126] =
    {field_body, 6},
    {field_condition, 3},
  [128] =
    {field_body, 6},
    {field_initializer, 2},
    {field_update, 4},
  [131] =
    {field_body, 6},
    {field_condition, 3},
    {field_initializer, 2},
  [134] =
    {field_body, 6},
    {field_initializer, 2},
  [136] =
    {field_body, 7},
    {field_condition, 3},
    {field_update, 5},
  [139] =
    {field_body, 7},
    {field_condition, 3},
    {field_initializer, 2},
    {field_update, 5},
  [143] =
    {field_body, 7},
    {field_initializer, 2},
    {field_update, 5},
  [146] =
    {field_body, 7},
    {field_condition, 4},
    {field_initializer, 2},
  [149] =
    {field_body, 8},
    {field_condition, 4},
    {field_initializer, 2},
    {field_update, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [6] = {
    [1] = alias_sym_type_identifier,
  },
  [12] = {
    [1] = alias_sym_type_identifier,
  },
  [19] = {
    [1] = alias_sym_type_identifier,
  },
  [20] = {
    [2] = alias_sym_type_identifier,
  },
  [24] = {
    [1] = alias_sym_statement_identifier,
  },
  [26] = {
    [0] = alias_sym_statement_identifier,
  },
  [32] = {
    [2] = alias_sym_field_identifier,
  },
  [42] = {
    [0] = alias_sym_field_identifier,
  },
  [43] = {
    [2] = alias_sym_type_identifier,
  },
  [68] = {
    [1] = alias_sym_field_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 4,
  [7] = 3,
  [8] = 5,
  [9] = 5,
  [10] = 10,
  [11] = 11,
  [12] = 3,
  [13] = 4,
  [14] = 10,
  [15] = 4,
  [16] = 3,
  [17] = 10,
  [18] = 5,
  [19] = 10,
  [20] = 20,
  [21] = 20,
  [22] = 22,
  [23] = 23,
  [24] = 20,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 26,
  [29] = 20,
  [30] = 26,
  [31] = 31,
  [32] = 25,
  [33] = 33,
  [34] = 27,
  [35] = 26,
  [36] = 25,
  [37] = 33,
  [38] = 27,
  [39] = 25,
  [40] = 27,
  [41] = 33,
  [42] = 33,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 47,
  [49] = 44,
  [50] = 45,
  [51] = 47,
  [52] = 46,
  [53] = 44,
  [54] = 43,
  [55] = 43,
  [56] = 43,
  [57] = 45,
  [58] = 46,
  [59] = 47,
  [60] = 45,
  [61] = 44,
  [62] = 46,
  [63] = 63,
  [64] = 63,
  [65] = 63,
  [66] = 63,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 71,
  [125] = 83,
  [126] = 70,
  [127] = 81,
  [128] = 100,
  [129] = 68,
  [130] = 79,
  [131] = 85,
  [132] = 86,
  [133] = 93,
  [134] = 95,
  [135] = 78,
  [136] = 77,
  [137] = 83,
  [138] = 102,
  [139] = 98,
  [140] = 96,
  [141] = 68,
  [142] = 97,
  [143] = 84,
  [144] = 69,
  [145] = 73,
  [146] = 70,
  [147] = 87,
  [148] = 73,
  [149] = 76,
  [150] = 75,
  [151] = 99,
  [152] = 67,
  [153] = 80,
  [154] = 81,
  [155] = 75,
  [156] = 101,
  [157] = 82,
  [158] = 74,
  [159] = 72,
  [160] = 88,
  [161] = 89,
  [162] = 90,
  [163] = 91,
  [164] = 92,
  [165] = 94,
  [166] = 100,
  [167] = 71,
  [168] = 84,
  [169] = 72,
  [170] = 74,
  [171] = 87,
  [172] = 101,
  [173] = 99,
  [174] = 97,
  [175] = 98,
  [176] = 102,
  [177] = 69,
  [178] = 96,
  [179] = 67,
  [180] = 95,
  [181] = 76,
  [182] = 93,
  [183] = 68,
  [184] = 86,
  [185] = 77,
  [186] = 84,
  [187] = 85,
  [188] = 100,
  [189] = 79,
  [190] = 78,
  [191] = 69,
  [192] = 77,
  [193] = 76,
  [194] = 67,
  [195] = 74,
  [196] = 72,
  [197] = 71,
  [198] = 87,
  [199] = 97,
  [200] = 98,
  [201] = 102,
  [202] = 70,
  [203] = 83,
  [204] = 78,
  [205] = 73,
  [206] = 75,
  [207] = 79,
  [208] = 85,
  [209] = 86,
  [210] = 93,
  [211] = 95,
  [212] = 80,
  [213] = 99,
  [214] = 101,
  [215] = 80,
  [216] = 81,
  [217] = 94,
  [218] = 82,
  [219] = 88,
  [220] = 92,
  [221] = 96,
  [222] = 89,
  [223] = 90,
  [224] = 82,
  [225] = 91,
  [226] = 91,
  [227] = 92,
  [228] = 88,
  [229] = 94,
  [230] = 89,
  [231] = 90,
  [232] = 115,
  [233] = 113,
  [234] = 104,
  [235] = 107,
  [236] = 108,
  [237] = 105,
  [238] = 109,
  [239] = 118,
  [240] = 121,
  [241] = 120,
  [242] = 120,
  [243] = 105,
  [244] = 106,
  [245] = 107,
  [246] = 108,
  [247] = 112,
  [248] = 114,
  [249] = 103,
  [250] = 116,
  [251] = 117,
  [252] = 112,
  [253] = 111,
  [254] = 112,
  [255] = 113,
  [256] = 114,
  [257] = 117,
  [258] = 119,
  [259] = 104,
  [260] = 103,
  [261] = 106,
  [262] = 108,
  [263] = 116,
  [264] = 111,
  [265] = 120,
  [266] = 115,
  [267] = 117,
  [268] = 119,
  [269] = 113,
  [270] = 114,
  [271] = 122,
  [272] = 103,
  [273] = 122,
  [274] = 116,
  [275] = 123,
  [276] = 123,
  [277] = 121,
  [278] = 119,
  [279] = 104,
  [280] = 122,
  [281] = 110,
  [282] = 107,
  [283] = 106,
  [284] = 110,
  [285] = 123,
  [286] = 121,
  [287] = 115,
  [288] = 118,
  [289] = 110,
  [290] = 109,
  [291] = 111,
  [292] = 105,
  [293] = 109,
  [294] = 118,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 298,
  [301] = 301,
  [302] = 302,
  [303] = 299,
  [304] = 302,
  [305] = 301,
  [306] = 302,
  [307] = 307,
  [308] = 301,
  [309] = 299,
  [310] = 298,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 313,
  [318] = 318,
  [319] = 313,
  [320] = 318,
  [321] = 314,
  [322] = 322,
  [323] = 323,
  [324] = 323,
  [325] = 323,
  [326] = 323,
  [327] = 327,
  [328] = 327,
  [329] = 327,
  [330] = 330,
  [331] = 330,
  [332] = 327,
  [333] = 330,
  [334] = 330,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 337,
  [339] = 337,
  [340] = 337,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 115,
  [351] = 351,
  [352] = 352,
  [353] = 296,
  [354] = 109,
  [355] = 113,
  [356] = 118,
  [357] = 121,
  [358] = 295,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 110,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 362,
  [376] = 372,
  [377] = 371,
  [378] = 378,
  [379] = 369,
  [380] = 368,
  [381] = 378,
  [382] = 365,
  [383] = 113,
  [384] = 378,
  [385] = 363,
  [386] = 352,
  [387] = 362,
  [388] = 360,
  [389] = 372,
  [390] = 109,
  [391] = 118,
  [392] = 359,
  [393] = 361,
  [394] = 378,
  [395] = 347,
  [396] = 348,
  [397] = 347,
  [398] = 115,
  [399] = 360,
  [400] = 110,
  [401] = 352,
  [402] = 363,
  [403] = 361,
  [404] = 365,
  [405] = 368,
  [406] = 359,
  [407] = 369,
  [408] = 371,
  [409] = 113,
  [410] = 348,
  [411] = 109,
  [412] = 366,
  [413] = 118,
  [414] = 115,
  [415] = 121,
  [416] = 121,
  [417] = 110,
  [418] = 366,
  [419] = 349,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 421,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 420,
  [433] = 422,
  [434] = 425,
  [435] = 435,
  [436] = 436,
  [437] = 426,
  [438] = 438,
  [439] = 429,
  [440] = 436,
  [441] = 430,
  [442] = 435,
  [443] = 443,
  [444] = 444,
  [445] = 420,
  [446] = 423,
  [447] = 444,
  [448] = 422,
  [449] = 443,
  [450] = 444,
  [451] = 451,
  [452] = 451,
  [453] = 443,
  [454] = 424,
  [455] = 455,
  [456] = 430,
  [457] = 429,
  [458] = 458,
  [459] = 443,
  [460] = 422,
  [461] = 458,
  [462] = 430,
  [463] = 425,
  [464] = 451,
  [465] = 435,
  [466] = 431,
  [467] = 455,
  [468] = 429,
  [469] = 425,
  [470] = 444,
  [471] = 423,
  [472] = 436,
  [473] = 424,
  [474] = 426,
  [475] = 438,
  [476] = 438,
  [477] = 438,
  [478] = 426,
  [479] = 436,
  [480] = 455,
  [481] = 435,
  [482] = 420,
  [483] = 424,
  [484] = 423,
  [485] = 458,
  [486] = 431,
  [487] = 421,
  [488] = 428,
  [489] = 428,
  [490] = 428,
  [491] = 455,
  [492] = 431,
  [493] = 421,
  [494] = 458,
  [495] = 451,
  [496] = 496,
  [497] = 496,
  [498] = 496,
  [499] = 496,
  [500] = 496,
  [501] = 496,
  [502] = 496,
  [503] = 496,
  [504] = 504,
  [505] = 505,
  [506] = 349,
  [507] = 349,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 510,
  [512] = 512,
  [513] = 513,
  [514] = 512,
  [515] = 512,
  [516] = 516,
  [517] = 513,
  [518] = 513,
  [519] = 513,
  [520] = 512,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 346,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 373,
  [545] = 374,
  [546] = 546,
  [547] = 546,
  [548] = 546,
  [549] = 546,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 550,
  [554] = 554,
  [555] = 550,
  [556] = 551,
  [557] = 557,
  [558] = 554,
  [559] = 551,
  [560] = 560,
  [561] = 552,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 562,
  [566] = 552,
  [567] = 560,
  [568] = 563,
  [569] = 557,
  [570] = 552,
  [571] = 571,
  [572] = 564,
  [573] = 560,
  [574] = 560,
  [575] = 563,
  [576] = 576,
  [577] = 571,
  [578] = 564,
  [579] = 551,
  [580] = 557,
  [581] = 571,
  [582] = 582,
  [583] = 550,
  [584] = 554,
  [585] = 562,
  [586] = 563,
  [587] = 557,
  [588] = 576,
  [589] = 576,
  [590] = 590,
  [591] = 576,
  [592] = 562,
  [593] = 554,
  [594] = 571,
  [595] = 564,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 602,
  [604] = 599,
  [605] = 504,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 617,
  [622] = 613,
  [623] = 623,
  [624] = 620,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 614,
  [634] = 634,
  [635] = 630,
  [636] = 627,
  [637] = 626,
  [638] = 638,
  [639] = 631,
  [640] = 640,
  [641] = 641,
  [642] = 625,
  [643] = 617,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 620,
  [648] = 648,
  [649] = 613,
  [650] = 641,
  [651] = 618,
  [652] = 632,
  [653] = 625,
  [654] = 640,
  [655] = 655,
  [656] = 623,
  [657] = 623,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 630,
  [667] = 627,
  [668] = 626,
  [669] = 631,
  [670] = 625,
  [671] = 617,
  [672] = 620,
  [673] = 613,
  [674] = 618,
  [675] = 632,
  [676] = 619,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 641,
  [683] = 640,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 623,
  [693] = 693,
  [694] = 694,
  [695] = 619,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 619,
  [700] = 627,
  [701] = 631,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 664,
  [706] = 632,
  [707] = 707,
  [708] = 640,
  [709] = 664,
  [710] = 641,
  [711] = 626,
  [712] = 712,
  [713] = 630,
  [714] = 614,
  [715] = 715,
  [716] = 661,
  [717] = 618,
  [718] = 718,
  [719] = 664,
  [720] = 720,
  [721] = 634,
  [722] = 614,
  [723] = 644,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 296,
  [748] = 748,
  [749] = 748,
  [750] = 596,
  [751] = 295,
  [752] = 748,
  [753] = 748,
  [754] = 648,
  [755] = 696,
  [756] = 712,
  [757] = 689,
  [758] = 663,
  [759] = 681,
  [760] = 685,
  [761] = 687,
  [762] = 690,
  [763] = 686,
  [764] = 720,
  [765] = 691,
  [766] = 693,
  [767] = 703,
  [768] = 768,
  [769] = 707,
  [770] = 697,
  [771] = 694,
  [772] = 678,
  [773] = 644,
  [774] = 688,
  [775] = 715,
  [776] = 776,
  [777] = 522,
  [778] = 691,
  [779] = 690,
  [780] = 694,
  [781] = 346,
  [782] = 689,
  [783] = 696,
  [784] = 681,
  [785] = 508,
  [786] = 693,
  [787] = 687,
  [788] = 685,
  [789] = 697,
  [790] = 707,
  [791] = 663,
  [792] = 509,
  [793] = 793,
  [794] = 793,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 798,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 805,
  [811] = 811,
  [812] = 797,
  [813] = 813,
  [814] = 799,
  [815] = 811,
  [816] = 805,
  [817] = 800,
  [818] = 808,
  [819] = 798,
  [820] = 813,
  [821] = 808,
  [822] = 809,
  [823] = 804,
  [824] = 809,
  [825] = 799,
  [826] = 797,
  [827] = 800,
  [828] = 828,
  [829] = 798,
  [830] = 801,
  [831] = 802,
  [832] = 832,
  [833] = 803,
  [834] = 834,
  [835] = 813,
  [836] = 805,
  [837] = 837,
  [838] = 808,
  [839] = 804,
  [840] = 797,
  [841] = 809,
  [842] = 800,
  [843] = 804,
  [844] = 803,
  [845] = 803,
  [846] = 802,
  [847] = 802,
  [848] = 801,
  [849] = 801,
  [850] = 799,
  [851] = 813,
  [852] = 852,
  [853] = 689,
  [854] = 693,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 852,
  [859] = 691,
  [860] = 860,
  [861] = 861,
  [862] = 690,
  [863] = 687,
  [864] = 864,
  [865] = 685,
  [866] = 681,
  [867] = 867,
  [868] = 663,
  [869] = 852,
  [870] = 856,
  [871] = 871,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 856,
  [876] = 876,
  [877] = 856,
  [878] = 694,
  [879] = 879,
  [880] = 880,
  [881] = 852,
  [882] = 707,
  [883] = 883,
  [884] = 697,
  [885] = 696,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 898,
  [900] = 900,
  [901] = 900,
  [902] = 902,
  [903] = 902,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 907,
  [912] = 907,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 908,
  [918] = 918,
  [919] = 913,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 907,
  [927] = 921,
  [928] = 928,
  [929] = 929,
  [930] = 930,
  [931] = 908,
  [932] = 932,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 939,
  [943] = 943,
  [944] = 941,
  [945] = 945,
  [946] = 946,
  [947] = 940,
  [948] = 936,
  [949] = 949,
  [950] = 935,
  [951] = 951,
  [952] = 718,
  [953] = 934,
  [954] = 933,
  [955] = 955,
  [956] = 932,
  [957] = 930,
  [958] = 929,
  [959] = 959,
  [960] = 905,
  [961] = 961,
  [962] = 955,
  [963] = 925,
  [964] = 945,
  [965] = 910,
  [966] = 909,
  [967] = 923,
  [968] = 968,
  [969] = 961,
  [970] = 922,
  [971] = 924,
  [972] = 943,
  [973] = 973,
  [974] = 961,
  [975] = 914,
  [976] = 938,
  [977] = 951,
  [978] = 915,
  [979] = 959,
  [980] = 961,
  [981] = 946,
  [982] = 718,
  [983] = 983,
  [984] = 973,
  [985] = 937,
  [986] = 973,
  [987] = 928,
  [988] = 918,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1005,
  [1007] = 1005,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1010,
  [1013] = 1013,
  [1014] = 1011,
  [1015] = 1013,
  [1016] = 1010,
  [1017] = 1013,
  [1018] = 1011,
  [1019] = 1013,
  [1020] = 1020,
  [1021] = 1010,
  [1022] = 1011,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 629,
  [1030] = 1028,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 698,
  [1034] = 680,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1032,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1028,
  [1042] = 1042,
  [1043] = 1031,
  [1044] = 1044,
  [1045] = 616,
  [1046] = 1032,
  [1047] = 1028,
  [1048] = 1023,
  [1049] = 1032,
  [1050] = 1023,
  [1051] = 1031,
  [1052] = 1052,
  [1053] = 1031,
  [1054] = 615,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1056,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1056,
  [1061] = 1056,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 743,
  [1069] = 742,
  [1070] = 745,
  [1071] = 726,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 724,
  [1077] = 733,
  [1078] = 730,
  [1079] = 746,
  [1080] = 1080,
  [1081] = 740,
  [1082] = 728,
  [1083] = 744,
  [1084] = 1080,
  [1085] = 1080,
  [1086] = 1074,
  [1087] = 1074,
  [1088] = 729,
  [1089] = 1089,
  [1090] = 738,
  [1091] = 732,
  [1092] = 737,
  [1093] = 1072,
  [1094] = 1074,
  [1095] = 1072,
  [1096] = 1080,
  [1097] = 1097,
  [1098] = 739,
  [1099] = 1072,
  [1100] = 1100,
  [1101] = 741,
  [1102] = 727,
  [1103] = 731,
  [1104] = 736,
  [1105] = 734,
  [1106] = 1106,
  [1107] = 725,
  [1108] = 735,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1111,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1111,
  [1120] = 1120,
  [1121] = 1111,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1147,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1146,
  [1151] = 1146,
  [1152] = 1152,
  [1153] = 1144,
  [1154] = 1147,
  [1155] = 1155,
  [1156] = 1156,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1164,
  [1171] = 1164,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1164,
  [1179] = 1179,
  [1180] = 1164,
  [1181] = 1181,
  [1182] = 1173,
  [1183] = 1167,
  [1184] = 1167,
  [1185] = 1164,
  [1186] = 1186,
  [1187] = 1175,
  [1188] = 1175,
  [1189] = 1164,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1190,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1192,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1207,
  [1209] = 1209,
  [1210] = 1202,
  [1211] = 1197,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1190,
  [1215] = 1204,
  [1216] = 1203,
  [1217] = 1194,
  [1218] = 1196,
  [1219] = 1219,
  [1220] = 1213,
  [1221] = 1221,
  [1222] = 1212,
  [1223] = 1223,
  [1224] = 1219,
  [1225] = 1225,
  [1226] = 1203,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1202,
  [1230] = 1230,
  [1231] = 1207,
  [1232] = 1219,
  [1233] = 1233,
  [1234] = 1204,
  [1235] = 1192,
  [1236] = 1236,
  [1237] = 1206,
  [1238] = 1221,
  [1239] = 1204,
  [1240] = 1199,
  [1241] = 1241,
  [1242] = 1242,
  [1243] = 1196,
  [1244] = 1203,
  [1245] = 1196,
  [1246] = 1192,
  [1247] = 1247,
  [1248] = 1200,
  [1249] = 1190,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1202,
  [1253] = 1253,
  [1254] = 1241,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1272,
  [1273] = 1263,
  [1274] = 1268,
  [1275] = 1275,
  [1276] = 1261,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1275,
  [1280] = 1278,
  [1281] = 1263,
  [1282] = 1269,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1272,
  [1286] = 1286,
  [1287] = 1275,
  [1288] = 1288,
  [1289] = 1275,
  [1290] = 1269,
  [1291] = 1263,
  [1292] = 1275,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1267,
  [1297] = 1286,
  [1298] = 1286,
  [1299] = 1261,
  [1300] = 1286,
  [1301] = 1301,
  [1302] = 1267,
  [1303] = 1275,
  [1304] = 1271,
  [1305] = 1305,
  [1306] = 1261,
  [1307] = 1269,
  [1308] = 1308,
  [1309] = 1271,
  [1310] = 1272,
  [1311] = 1268,
  [1312] = 1272,
  [1313] = 1313,
  [1314] = 1268,
  [1315] = 1272,
  [1316] = 1272,
  [1317] = 1275,
  [1318] = 1272,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1330,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1332,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1338,
  [1341] = 1325,
  [1342] = 1321,
  [1343] = 1328,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1338,
  [1347] = 1325,
  [1348] = 1348,
  [1349] = 1328,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1338,
  [1353] = 1325,
  [1354] = 1354,
  [1355] = 1328,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1334,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1337,
  [1363] = 1325,
  [1364] = 1364,
  [1365] = 1339,
  [1366] = 1334,
  [1367] = 1332,
  [1368] = 1368,
  [1369] = 1330,
  [1370] = 1319,
  [1371] = 1329,
  [1372] = 1322,
  [1373] = 1373,
  [1374] = 1351,
  [1375] = 1375,
  [1376] = 1326,
  [1377] = 1323,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1320,
  [1382] = 1382,
  [1383] = 1348,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1339,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1335,
  [1390] = 1331,
  [1391] = 1328,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1350,
  [1395] = 1345,
  [1396] = 1393,
  [1397] = 1397,
  [1398] = 1326,
  [1399] = 1399,
  [1400] = 1337,
  [1401] = 1375,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1321,
  [1405] = 1397,
  [1406] = 1325,
  [1407] = 1407,
  [1408] = 1323,
  [1409] = 1388,
  [1410] = 1350,
  [1411] = 1345,
  [1412] = 1412,
  [1413] = 1378,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1416,
  [1418] = 1418,
  [1419] = 1338,
  [1420] = 1344,
  [1421] = 1357,
  [1422] = 1358,
  [1423] = 1324,
  [1424] = 1356,
  [1425] = 1360,
  [1426] = 1392,
  [1427] = 1338,
  [1428] = 1364,
  [1429] = 1361,
  [1430] = 1379,
  [1431] = 1337,
  [1432] = 1319,
  [1433] = 1433,
  [1434] = 1334,
  [1435] = 1435,
  [1436] = 1332,
  [1437] = 1392,
  [1438] = 1438,
  [1439] = 1330,
  [1440] = 1329,
  [1441] = 1322,
  [1442] = 1393,
  [1443] = 1399,
  [1444] = 1351,
  [1445] = 1375,
  [1446] = 374,
  [1447] = 1320,
  [1448] = 1397,
  [1449] = 1326,
  [1450] = 1357,
  [1451] = 1358,
  [1452] = 1323,
  [1453] = 1378,
  [1454] = 1379,
  [1455] = 1364,
  [1456] = 1320,
  [1457] = 1348,
  [1458] = 1384,
  [1459] = 1339,
  [1460] = 1331,
  [1461] = 1461,
  [1462] = 1344,
  [1463] = 1324,
  [1464] = 1328,
  [1465] = 1399,
  [1466] = 1399,
  [1467] = 1375,
  [1468] = 1348,
  [1469] = 1385,
  [1470] = 1397,
  [1471] = 1357,
  [1472] = 1357,
  [1473] = 1357,
  [1474] = 1393,
  [1475] = 1384,
  [1476] = 1476,
  [1477] = 1415,
  [1478] = 1321,
  [1479] = 1364,
  [1480] = 1356,
  [1481] = 1325,
  [1482] = 1416,
  [1483] = 1360,
  [1484] = 1403,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1388,
  [1488] = 1350,
  [1489] = 1433,
  [1490] = 1345,
  [1491] = 1416,
  [1492] = 1361,
  [1493] = 1418,
  [1494] = 1338,
  [1495] = 1403,
  [1496] = 1344,
  [1497] = 1324,
  [1498] = 373,
  [1499] = 1433,
  [1500] = 1356,
  [1501] = 1360,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1403,
  [1505] = 1361,
  [1506] = 1328,
  [1507] = 1433,
  [1508] = 1508,
  [1509] = 1461,
  [1510] = 1485,
  [1511] = 1358,
  [1512] = 1331,
  [1513] = 1485,
  [1514] = 1357,
  [1515] = 1485,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(84);
      if (lookahead == '!') ADVANCE(140);
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '%') ADVANCE(157);
      if (lookahead == '&') ADVANCE(166);
      if (lookahead == '\'') ADVANCE(228);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '+') ADVANCE(148);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(206);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead == '0') ADVANCE(213);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '<') ADVANCE(173);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(169);
      if (lookahead == '?') ADVANCE(192);
      if (lookahead == 'L') ADVANCE(249);
      if (lookahead == 'U') ADVANCE(251);
      if (lookahead == '[') ADVANCE(186);
      if (lookahead == '\\') SKIP(79)
      if (lookahead == ']') ADVANCE(187);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == 'u') ADVANCE(253);
      if (lookahead == '{') ADVANCE(183);
      if (lookahead == '|') ADVANCE(160);
      if (lookahead == '}') ADVANCE(184);
      if (lookahead == '~') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(82)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(28)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(28)
      if (lookahead == '\r') SKIP(1)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(29)
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(29)
      if (lookahead == '\r') SKIP(3)
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(33)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(33)
      if (lookahead == '\r') SKIP(5)
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(32)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(32)
      if (lookahead == '\r') SKIP(7)
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(34)
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(34)
      if (lookahead == '\r') SKIP(9)
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(27)
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(27)
      if (lookahead == '\r') SKIP(11)
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(31)
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(31)
      if (lookahead == '\r') SKIP(13)
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(17)
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(17)
      if (lookahead == '\r') SKIP(15)
      END_STATE();
    case 17:
      if (lookahead == '\n') ADVANCE(86);
      if (lookahead == '!') ADVANCE(46);
      if (lookahead == '%') ADVANCE(156);
      if (lookahead == '&') ADVANCE(165);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(154);
      if (lookahead == '<') ADVANCE(174);
      if (lookahead == '=') ADVANCE(47);
      if (lookahead == '>') ADVANCE(170);
      if (lookahead == '\\') SKIP(16)
      if (lookahead == '^') ADVANCE(162);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(30)
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(30)
      if (lookahead == '\r') SKIP(18)
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(35)
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(35)
      if (lookahead == '\r') SKIP(20)
      END_STATE();
    case 22:
      if (lookahead == '\n') ADVANCE(87);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '\\') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(128);
      if (lookahead != 0) ADVANCE(132);
      END_STATE();
    case 23:
      if (lookahead == '\n') ADVANCE(87);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '\\') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(128);
      if (lookahead != 0) ADVANCE(132);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(36)
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(241);
      if (lookahead != 0) ADVANCE(242);
      END_STATE();
    case 25:
      if (lookahead == '\n') ADVANCE(244);
      if (lookahead == '\r') ADVANCE(243);
      if (lookahead == 'U') ADVANCE(76);
      if (lookahead == 'u') ADVANCE(72);
      if (lookahead == 'x') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      if (lookahead != 0) ADVANCE(243);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(44)
      if (lookahead == '/') ADVANCE(231);
      if (lookahead == '\\') ADVANCE(230);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(229);
      END_STATE();
    case 27:
      if (lookahead == '!') ADVANCE(140);
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '#') ADVANCE(59);
      if (lookahead == '%') ADVANCE(157);
      if (lookahead == '&') ADVANCE(166);
      if (lookahead == '\'') ADVANCE(228);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '+') ADVANCE(148);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(207);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead == '0') ADVANCE(213);
      if (lookahead == ':') ADVANCE(190);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '<') ADVANCE(173);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(169);
      if (lookahead == '?') ADVANCE(192);
      if (lookahead == 'L') ADVANCE(249);
      if (lookahead == 'U') ADVANCE(251);
      if (lookahead == '[') ADVANCE(185);
      if (lookahead == '\\') SKIP(12)
      if (lookahead == ']') ADVANCE(187);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == 'u') ADVANCE(253);
      if (lookahead == '{') ADVANCE(183);
      if (lookahead == '|') ADVANCE(160);
      if (lookahead == '}') ADVANCE(184);
      if (lookahead == '~') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(27)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 28:
      if (lookahead == '!') ADVANCE(139);
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '&') ADVANCE(164);
      if (lookahead == '\'') ADVANCE(228);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == '0') ADVANCE(213);
      if (lookahead == ':') ADVANCE(45);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == 'L') ADVANCE(249);
      if (lookahead == 'U') ADVANCE(251);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == ']') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(253);
      if (lookahead == '{') ADVANCE(183);
      if (lookahead == '~') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(28)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 29:
      if (lookahead == '!') ADVANCE(139);
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '&') ADVANCE(164);
      if (lookahead == '\'') ADVANCE(228);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == '0') ADVANCE(213);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == 'L') ADVANCE(249);
      if (lookahead == 'U') ADVANCE(251);
      if (lookahead == '[') ADVANCE(50);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == 'u') ADVANCE(253);
      if (lookahead == '{') ADVANCE(183);
      if (lookahead == '~') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(29)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 30:
      if (lookahead == '!') ADVANCE(139);
      if (lookahead == '\'') ADVANCE(228);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '+') ADVANCE(151);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == '0') ADVANCE(213);
      if (lookahead == 'L') ADVANCE(257);
      if (lookahead == 'U') ADVANCE(258);
      if (lookahead == '\\') SKIP(19)
      if (lookahead == 'u') ADVANCE(259);
      if (lookahead == '~') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(30)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 31:
      if (lookahead == '!') ADVANCE(46);
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '%') ADVANCE(157);
      if (lookahead == '&') ADVANCE(166);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '+') ADVANCE(150);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(205);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead == ':') ADVANCE(190);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '<') ADVANCE(173);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(169);
      if (lookahead == '?') ADVANCE(192);
      if (lookahead == 'L') ADVANCE(250);
      if (lookahead == 'U') ADVANCE(252);
      if (lookahead == '[') ADVANCE(186);
      if (lookahead == '\\') SKIP(14)
      if (lookahead == ']') ADVANCE(187);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == 'u') ADVANCE(254);
      if (lookahead == '|') ADVANCE(160);
      if (lookahead == '}') ADVANCE(184);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(31)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 32:
      if (lookahead == '!') ADVANCE(46);
      if (lookahead == '#') ADVANCE(57);
      if (lookahead == '%') ADVANCE(157);
      if (lookahead == '&') ADVANCE(166);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '+') ADVANCE(150);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(205);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead == ':') ADVANCE(190);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '<') ADVANCE(173);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(169);
      if (lookahead == '?') ADVANCE(192);
      if (lookahead == '[') ADVANCE(186);
      if (lookahead == '\\') SKIP(8)
      if (lookahead == ']') ADVANCE(187);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == '{') ADVANCE(183);
      if (lookahead == '|') ADVANCE(160);
      if (lookahead == '}') ADVANCE(184);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(32)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 33:
      if (lookahead == '!') ADVANCE(46);
      if (lookahead == '#') ADVANCE(53);
      if (lookahead == '%') ADVANCE(156);
      if (lookahead == '&') ADVANCE(165);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(42);
      if (lookahead == '/') ADVANCE(154);
      if (lookahead == ':') ADVANCE(190);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '<') ADVANCE(174);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(170);
      if (lookahead == '[') ADVANCE(186);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == '^') ADVANCE(162);
      if (lookahead == '{') ADVANCE(183);
      if (lookahead == '|') ADVANCE(161);
      if (lookahead == '}') ADVANCE(184);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(33)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 34:
      if (lookahead == '!') ADVANCE(46);
      if (lookahead == '#') ADVANCE(55);
      if (lookahead == '%') ADVANCE(157);
      if (lookahead == '&') ADVANCE(166);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '+') ADVANCE(150);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(145);
      if (lookahead == '.') ADVANCE(205);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead == ':') ADVANCE(190);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '<') ADVANCE(173);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(169);
      if (lookahead == '?') ADVANCE(192);
      if (lookahead == '[') ADVANCE(186);
      if (lookahead == '\\') SKIP(10)
      if (lookahead == ']') ADVANCE(51);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == '|') ADVANCE(160);
      if (lookahead == '}') ADVANCE(184);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(34)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 35:
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == '<') ADVANCE(48);
      if (lookahead == 'L') ADVANCE(250);
      if (lookahead == 'U') ADVANCE(252);
      if (lookahead == '\\') SKIP(21)
      if (lookahead == 'u') ADVANCE(254);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(35)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 36:
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(36)
      END_STATE();
    case 37:
      if (lookahead == '*') ADVANCE(39);
      if (lookahead == '/') ADVANCE(264);
      END_STATE();
    case 38:
      if (lookahead == '*') ADVANCE(38);
      if (lookahead == '/') ADVANCE(262);
      if (lookahead != 0) ADVANCE(39);
      END_STATE();
    case 39:
      if (lookahead == '*') ADVANCE(38);
      if (lookahead != 0) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '0') ADVANCE(211);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(212);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(220);
      END_STATE();
    case 41:
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '0') ADVANCE(214);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 42:
      if (lookahead == '.') ADVANCE(43);
      END_STATE();
    case 43:
      if (lookahead == '.') ADVANCE(90);
      END_STATE();
    case 44:
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(44)
      END_STATE();
    case 45:
      if (lookahead == ':') ADVANCE(180);
      END_STATE();
    case 46:
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 47:
      if (lookahead == '=') ADVANCE(167);
      END_STATE();
    case 48:
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '\\') ADVANCE(49);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(48);
      END_STATE();
    case 49:
      if (lookahead == '>') ADVANCE(248);
      if (lookahead == '\\') ADVANCE(49);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(48);
      END_STATE();
    case 50:
      if (lookahead == '[') ADVANCE(181);
      END_STATE();
    case 51:
      if (lookahead == ']') ADVANCE(182);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'e') ADVANCE(120);
      if (lookahead == 'i') ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(52);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 53:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'e') ADVANCE(120);
      if (lookahead == 'i') ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(53);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 54:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'e') ADVANCE(122);
      if (lookahead == 'i') ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(54);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 55:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'e') ADVANCE(122);
      if (lookahead == 'i') ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(55);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 56:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'i') ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(56);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 57:
      if (lookahead == 'd') ADVANCE(104);
      if (lookahead == 'i') ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(57);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 58:
      if (lookahead == 'd') ADVANCE(61);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(62);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(59);
      END_STATE();
    case 60:
      if (lookahead == 'f') ADVANCE(94);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(60);
      END_STATE();
    case 62:
      if (lookahead == 'n') ADVANCE(58);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(212);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(220);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(217);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(220);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(210);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(243);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(70);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(71);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(72);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 77:
      if (lookahead != 0 &&
          lookahead != '\r') ADVANCE(264);
      if (lookahead == '\r') ADVANCE(266);
      END_STATE();
    case 78:
      if (eof) ADVANCE(84);
      if (lookahead == '\n') SKIP(82)
      END_STATE();
    case 79:
      if (eof) ADVANCE(84);
      if (lookahead == '\n') SKIP(82)
      if (lookahead == '\r') SKIP(78)
      END_STATE();
    case 80:
      if (eof) ADVANCE(84);
      if (lookahead == '\n') SKIP(83)
      END_STATE();
    case 81:
      if (eof) ADVANCE(84);
      if (lookahead == '\n') SKIP(83)
      if (lookahead == '\r') SKIP(80)
      END_STATE();
    case 82:
      if (eof) ADVANCE(84);
      if (lookahead == '!') ADVANCE(140);
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '#') ADVANCE(52);
      if (lookahead == '%') ADVANCE(157);
      if (lookahead == '&') ADVANCE(166);
      if (lookahead == '\'') ADVANCE(228);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '+') ADVANCE(148);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '.') ADVANCE(206);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead == '0') ADVANCE(213);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '<') ADVANCE(173);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(169);
      if (lookahead == '?') ADVANCE(192);
      if (lookahead == 'L') ADVANCE(249);
      if (lookahead == 'U') ADVANCE(251);
      if (lookahead == '[') ADVANCE(186);
      if (lookahead == '\\') SKIP(79)
      if (lookahead == ']') ADVANCE(187);
      if (lookahead == '^') ADVANCE(163);
      if (lookahead == 'u') ADVANCE(253);
      if (lookahead == '{') ADVANCE(183);
      if (lookahead == '|') ADVANCE(160);
      if (lookahead == '}') ADVANCE(184);
      if (lookahead == '~') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(82)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 83:
      if (eof) ADVANCE(84);
      if (lookahead == '!') ADVANCE(139);
      if (lookahead == '"') ADVANCE(237);
      if (lookahead == '#') ADVANCE(56);
      if (lookahead == '&') ADVANCE(164);
      if (lookahead == '\'') ADVANCE(228);
      if (lookahead == '(') ADVANCE(138);
      if (lookahead == ')') ADVANCE(92);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '.') ADVANCE(207);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == '0') ADVANCE(213);
      if (lookahead == ':') ADVANCE(190);
      if (lookahead == ';') ADVANCE(179);
      if (lookahead == '=') ADVANCE(188);
      if (lookahead == 'L') ADVANCE(249);
      if (lookahead == 'U') ADVANCE(251);
      if (lookahead == '[') ADVANCE(186);
      if (lookahead == '\\') SKIP(81)
      if (lookahead == ']') ADVANCE(187);
      if (lookahead == 'u') ADVANCE(253);
      if (lookahead == '{') ADVANCE(183);
      if (lookahead == '}') ADVANCE(184);
      if (lookahead == '~') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(83)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(128);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(108);
      if (lookahead == 'n') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(93);
      if (lookahead == 'n') ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(113);
      if (lookahead == 's') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(118);
      if (lookahead == 'n') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(39);
      if (lookahead == '*') ADVANCE(126);
      if (lookahead == '/') ADVANCE(262);
      if (lookahead == '\\') ADVANCE(133);
      if (lookahead != 0) ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(39);
      if (lookahead == '*') ADVANCE(126);
      if (lookahead == '\\') ADVANCE(133);
      if (lookahead != 0) ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(87);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '\\') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(128);
      if (lookahead != 0) ADVANCE(132);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(128);
      if (lookahead == '\r') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(134);
      if (lookahead != 0) ADVANCE(132);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(128);
      if (lookahead == '\\') ADVANCE(134);
      if (lookahead != 0) ADVANCE(132);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(127);
      if (lookahead == '/') ADVANCE(265);
      if (lookahead == '\\') ADVANCE(134);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\\') ADVANCE(134);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '*' &&
          lookahead != '\\') ADVANCE(127);
      if (lookahead == '\r') ADVANCE(136);
      if (lookahead == '*') ADVANCE(126);
      if (lookahead == '\\') ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(132);
      if (lookahead == '\r') ADVANCE(137);
      if (lookahead == '\\') ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\r' &&
          lookahead != '\\') ADVANCE(265);
      if (lookahead == '\r') ADVANCE(267);
      if (lookahead == '\\') ADVANCE(263);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '\\') ADVANCE(127);
      if (lookahead == '*') ADVANCE(126);
      if (lookahead == '\\') ADVANCE(133);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(134);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(203);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '0') ADVANCE(213);
      if (lookahead == '=') ADVANCE(197);
      if (lookahead == '>') ADVANCE(208);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(203);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '0') ADVANCE(213);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(203);
      if (lookahead == '=') ADVANCE(197);
      if (lookahead == '>') ADVANCE(208);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '0') ADVANCE(213);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(204);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '0') ADVANCE(213);
      if (lookahead == '=') ADVANCE(196);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(204);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '0') ADVANCE(213);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(204);
      if (lookahead == '=') ADVANCE(196);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '0') ADVANCE(213);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(193);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(39);
      if (lookahead == '/') ADVANCE(264);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(39);
      if (lookahead == '/') ADVANCE(264);
      if (lookahead == '=') ADVANCE(194);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(195);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(202);
      if (lookahead == '|') ADVANCE(158);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(158);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(201);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(159);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(159);
      if (lookahead == '=') ADVANCE(200);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(171);
      if (lookahead == '>') ADVANCE(178);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(171);
      if (lookahead == '>') ADVANCE(177);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(176);
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(175);
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(198);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(199);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(181);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(167);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(180);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(64);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(68);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(210);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(210);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(220);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'b') ADVANCE(219);
      if (lookahead == 'x') ADVANCE(67);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(218);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(222);
      if (('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(220);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(212);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(220);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(218);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(222);
      if (('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(220);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(212);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(63);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'b') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(40);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(63);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'b') ADVANCE(63);
      if (lookahead == 'x') ADVANCE(67);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(63);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(66);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(217);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(68);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(216);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(217);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(66);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(217);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(216);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(217);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(67);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(220);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(68);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(218);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(220);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(67);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(220);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(218);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(222);
      if (('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(220);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(212);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(67);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(220);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(218);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(220);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(217);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(216);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'D') ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(217);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(210);
      if (lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(210);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'F' ||
          lookahead == 'L' ||
          lookahead == 'U' ||
          lookahead == 'f' ||
          lookahead == 'l' ||
          lookahead == 'u') ADVANCE(223);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(244);
      if (lookahead == '\r') ADVANCE(243);
      if (lookahead == 'U') ADVANCE(76);
      if (lookahead == 'u') ADVANCE(72);
      if (lookahead == 'x') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      if (lookahead != 0) ADVANCE(243);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(39);
      if (lookahead == '/') ADVANCE(264);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(25);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(240);
      if (lookahead == '/') ADVANCE(242);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(242);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(239);
      if (lookahead == '/') ADVANCE(242);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(240);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(239);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(240);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(241);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(242);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(242);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(25);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(243);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(245);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '\\') ADVANCE(49);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(48);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(233);
      if (lookahead == '\'') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(235);
      if (lookahead == '\'') ADVANCE(226);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(235);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(234);
      if (lookahead == '\'') ADVANCE(225);
      if (lookahead == '8') ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(234);
      if (lookahead == '8') ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(236);
      if (lookahead == '\'') ADVANCE(227);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(236);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(226);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(225);
      if (lookahead == '8') ADVANCE(260);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(227);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(261);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(265);
      if (lookahead == '\\') ADVANCE(135);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(265);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(264);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(135);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(265);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(264);
      if (lookahead == '\\') ADVANCE(77);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(265);
      if (lookahead == '\\') ADVANCE(135);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'h') ADVANCE(13);
      if (lookahead == 'i') ADVANCE(14);
      if (lookahead == 'k') ADVANCE(15);
      if (lookahead == 'l') ADVANCE(16);
      if (lookahead == 'n') ADVANCE(17);
      if (lookahead == 'p') ADVANCE(18);
      if (lookahead == 'q') ADVANCE(19);
      if (lookahead == 'r') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      if (lookahead == 't') ADVANCE(22);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'v') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(26);
      END_STATE();
    case 2:
      if (lookahead == 'U') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'R') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(29)
      END_STATE();
    case 5:
      if (lookahead == 'A') ADVANCE(30);
      if (lookahead == '_') ADVANCE(31);
      if (lookahead == 'u') ADVANCE(32);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(34);
      if (lookahead == 'r') ADVANCE(35);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'h') ADVANCE(37);
      if (lookahead == 'l') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(43);
      if (lookahead == 'v') ADVANCE(44);
      if (lookahead == 'x') ADVANCE(45);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(46);
      if (lookahead == 'l') ADVANCE(47);
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(49);
      if (lookahead == 'l') ADVANCE(50);
      if (lookahead == 'o') ADVANCE(51);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 14:
      if (lookahead == 'f') ADVANCE(53);
      if (lookahead == 'm') ADVANCE(54);
      if (lookahead == 'n') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(57);
      END_STATE();
    case 17:
      if (lookahead == 'd') ADVANCE(58);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(59);
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 19:
      if (lookahead == 'u') ADVANCE(62);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(64);
      if (lookahead == 'h') ADVANCE(65);
      if (lookahead == 'i') ADVANCE(66);
      if (lookahead == 't') ADVANCE(67);
      if (lookahead == 'w') ADVANCE(68);
      END_STATE();
    case 22:
      if (lookahead == 'r') ADVANCE(69);
      if (lookahead == 'y') ADVANCE(70);
      END_STATE();
    case 23:
      if (lookahead == 'c') ADVANCE(71);
      if (lookahead == 'i') ADVANCE(72);
      if (lookahead == 'l') ADVANCE(73);
      if (lookahead == 'n') ADVANCE(74);
      if (lookahead == 's') ADVANCE(75);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 25:
      if (lookahead == 'h') ADVANCE(77);
      if (lookahead == 'r') ADVANCE(78);
      END_STATE();
    case 26:
      if (lookahead == 'L') ADVANCE(79);
      END_STATE();
    case 27:
      if (lookahead == 'L') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 'U') ADVANCE(81);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 30:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(83);
      if (lookahead == 'b') ADVANCE(84);
      if (lookahead == 'c') ADVANCE(85);
      if (lookahead == 'd') ADVANCE(86);
      if (lookahead == 'f') ADVANCE(87);
      if (lookahead == 'g') ADVANCE(88);
      if (lookahead == 'k') ADVANCE(89);
      if (lookahead == 'l') ADVANCE(90);
      if (lookahead == 'p') ADVANCE(91);
      if (lookahead == 'r') ADVANCE(92);
      if (lookahead == 's') ADVANCE(93);
      if (lookahead == 't') ADVANCE(94);
      if (lookahead == 'u') ADVANCE(95);
      if (lookahead == 'v') ADVANCE(96);
      if (lookahead == 'w') ADVANCE(97);
      END_STATE();
    case 32:
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 34:
      if (lookahead == 'o') ADVANCE(100);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(101);
      END_STATE();
    case 36:
      if (lookahead == 's') ADVANCE(102);
      END_STATE();
    case 37:
      if (lookahead == 'a') ADVANCE(103);
      END_STATE();
    case 38:
      if (lookahead == '_') ADVANCE(104);
      if (lookahead == 'k') ADVANCE(105);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(106);
      END_STATE();
    case 40:
      if (lookahead == 'f') ADVANCE(107);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(108);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(109);
      END_STATE();
    case 43:
      if (lookahead == 'u') ADVANCE(110);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 46:
      if (lookahead == 'l') ADVANCE(113);
      END_STATE();
    case 47:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 48:
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 49:
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 50:
      if (lookahead == 'o') ADVANCE(117);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(120);
      END_STATE();
    case 55:
      if (lookahead == 'l') ADVANCE(121);
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 56:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 57:
      if (lookahead == 'c') ADVANCE(124);
      if (lookahead == 'n') ADVANCE(125);
      END_STATE();
    case 58:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(127);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(129);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(131);
      if (lookahead == 'g') ADVANCE(132);
      if (lookahead == 's') ADVANCE(133);
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 64:
      if (lookahead == 'm') ADVANCE(135);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(136);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(137);
      if (lookahead == 'z') ADVANCE(138);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(139);
      if (lookahead == 'r') ADVANCE(140);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(141);
      END_STATE();
    case 69:
      if (lookahead == 'u') ADVANCE(142);
      END_STATE();
    case 70:
      if (lookahead == 'p') ADVANCE(143);
      END_STATE();
    case 71:
      if (lookahead == 'h') ADVANCE(144);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(145);
      END_STATE();
    case 73:
      if (lookahead == 'o') ADVANCE(146);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(147);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 75:
      if (lookahead == 'h') ADVANCE(149);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(150);
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(152);
      END_STATE();
    case 78:
      if (lookahead == 'i') ADVANCE(153);
      END_STATE();
    case 79:
      if (lookahead == 'S') ADVANCE(154);
      END_STATE();
    case 80:
      if (lookahead == 'L') ADVANCE(155);
      END_STATE();
    case 81:
      if (lookahead == 'E') ADVANCE(156);
      END_STATE();
    case 82:
      if (lookahead == 'o') ADVANCE(157);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(158);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(159);
      END_STATE();
    case 85:
      if (lookahead == 'd') ADVANCE(160);
      if (lookahead == 'l') ADVANCE(161);
      if (lookahead == 'o') ADVANCE(162);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(164);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(165);
      if (lookahead == 'l') ADVANCE(166);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 90:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 91:
      if (lookahead == 'r') ADVANCE(169);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 93:
      if (lookahead == 'p') ADVANCE(171);
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 94:
      if (lookahead == 'h') ADVANCE(173);
      END_STATE();
    case 95:
      if (lookahead == 'n') ADVANCE(174);
      if (lookahead == 'p') ADVANCE(175);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(177);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(178);
      END_STATE();
    case 99:
      if (lookahead == 'o') ADVANCE(179);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(180);
      END_STATE();
    case 101:
      if (lookahead == 'a') ADVANCE(181);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 104:
      if (lookahead == 'm') ADVANCE(184);
      END_STATE();
    case 105:
      if (lookahead == '_') ADVANCE(185);
      END_STATE();
    case 106:
      if (lookahead == 's') ADVANCE(186);
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 107:
      if (lookahead == 'a') ADVANCE(188);
      if (lookahead == 'i') ADVANCE(189);
      END_STATE();
    case 108:
      if (lookahead == 'b') ADVANCE(190);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 110:
      if (lookahead == 'm') ADVANCE(192);
      END_STATE();
    case 111:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 113:
      if (lookahead == 's') ADVANCE(195);
      END_STATE();
    case 114:
      if (lookahead == 'a') ADVANCE(196);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 117:
      if (lookahead == 'b') ADVANCE(198);
      END_STATE();
    case 118:
      if (lookahead == 'o') ADVANCE(199);
      END_STATE();
    case 119:
      if (lookahead == 'f') ADVANCE(200);
      END_STATE();
    case 120:
      if (lookahead == 'g') ADVANCE(201);
      END_STATE();
    case 121:
      if (lookahead == 'i') ADVANCE(202);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == '1') ADVANCE(203);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      if (lookahead == 'p') ADVANCE(205);
      END_STATE();
    case 123:
      if (lookahead == 'n') ADVANCE(206);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(207);
      END_STATE();
    case 125:
      if (lookahead == 'g') ADVANCE(208);
      END_STATE();
    case 126:
      if (lookahead == 'a') ADVANCE(209);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 128:
      if (lookahead == 'v') ADVANCE(211);
      END_STATE();
    case 129:
      if (lookahead == 'd') ADVANCE(212);
      END_STATE();
    case 130:
      if (lookahead == 'u') ADVANCE(213);
      END_STATE();
    case 131:
      if (lookahead == 'd') ADVANCE(214);
      END_STATE();
    case 132:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(216);
      if (lookahead == 't') ADVANCE(217);
      END_STATE();
    case 134:
      if (lookahead == 'u') ADVANCE(218);
      END_STATE();
    case 135:
      if (lookahead == 'p') ADVANCE(219);
      END_STATE();
    case 136:
      if (lookahead == 'r') ADVANCE(220);
      END_STATE();
    case 137:
      if (lookahead == 'n') ADVANCE(221);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(223);
      END_STATE();
    case 140:
      if (lookahead == 'u') ADVANCE(224);
      END_STATE();
    case 141:
      if (lookahead == 't') ADVANCE(225);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 144:
      if (lookahead == 'a') ADVANCE(227);
      END_STATE();
    case 145:
      if (lookahead == 't') ADVANCE(228);
      END_STATE();
    case 146:
      if (lookahead == 'n') ADVANCE(229);
      END_STATE();
    case 147:
      if (lookahead == 'o') ADVANCE(230);
      END_STATE();
    case 148:
      if (lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 149:
      if (lookahead == 'o') ADVANCE(232);
      END_STATE();
    case 150:
      if (lookahead == 'd') ADVANCE(233);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(234);
      END_STATE();
    case 152:
      if (lookahead == 'l') ADVANCE(235);
      END_STATE();
    case 153:
      if (lookahead == 't') ADVANCE(236);
      END_STATE();
    case 154:
      if (lookahead == 'E') ADVANCE(237);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 157:
      if (lookahead == 'm') ADVANCE(238);
      END_STATE();
    case 158:
      if (lookahead == 't') ADVANCE(239);
      END_STATE();
    case 159:
      if (lookahead == 's') ADVANCE(240);
      END_STATE();
    case 160:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 161:
      if (lookahead == 'r') ADVANCE(242);
      END_STATE();
    case 162:
      if (lookahead == 'n') ADVANCE(243);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(244);
      END_STATE();
    case 164:
      if (lookahead == 's') ADVANCE(245);
      END_STATE();
    case 165:
      if (lookahead == 'n') ADVANCE(246);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(247);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(248);
      END_STATE();
    case 168:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(250);
      END_STATE();
    case 170:
      if (lookahead == 'a') ADVANCE(251);
      if (lookahead == 's') ADVANCE(252);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(253);
      END_STATE();
    case 172:
      if (lookahead == 'd') ADVANCE(254);
      END_STATE();
    case 173:
      if (lookahead == 'i') ADVANCE(255);
      END_STATE();
    case 174:
      if (lookahead == 'a') ADVANCE(256);
      END_STATE();
    case 175:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 176:
      if (lookahead == 'c') ADVANCE(258);
      END_STATE();
    case 177:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 178:
      if (lookahead == 'l') ADVANCE(260);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_auto);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 181:
      if (lookahead == 'k') ADVANCE(261);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_char);
      if (lookahead == '1') ADVANCE(262);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 185:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 186:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 187:
      if (lookahead == 'i') ADVANCE(266);
      END_STATE();
    case 188:
      if (lookahead == 'u') ADVANCE(267);
      END_STATE();
    case 189:
      if (lookahead == 'n') ADVANCE(268);
      END_STATE();
    case 190:
      if (lookahead == 'l') ADVANCE(269);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 193:
      if (lookahead == 't') ADVANCE(270);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(271);
      END_STATE();
    case 195:
      if (lookahead == 'e') ADVANCE(237);
      END_STATE();
    case 196:
      if (lookahead == 't') ADVANCE(272);
      END_STATE();
    case 197:
      if (lookahead == 'r') ADVANCE(273);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(274);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_half);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 202:
      if (lookahead == 'n') ADVANCE(276);
      END_STATE();
    case 203:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_vector_type);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 206:
      if (lookahead == 'e') ADVANCE(278);
      END_STATE();
    case 207:
      if (lookahead == 'l') ADVANCE(279);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_long);
      if (lookahead == '1') ADVANCE(280);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      END_STATE();
    case 209:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_pipe);
      END_STATE();
    case 211:
      if (lookahead == 'a') ADVANCE(282);
      END_STATE();
    case 212:
      if (lookahead == 'i') ADVANCE(283);
      END_STATE();
    case 213:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 214:
      if (lookahead == '_') ADVANCE(285);
      END_STATE();
    case 215:
      if (lookahead == 's') ADVANCE(286);
      END_STATE();
    case 216:
      if (lookahead == 'r') ADVANCE(287);
      END_STATE();
    case 217:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 218:
      if (lookahead == 'r') ADVANCE(289);
      END_STATE();
    case 219:
      if (lookahead == 'l') ADVANCE(290);
      END_STATE();
    case 220:
      if (lookahead == 't') ADVANCE(291);
      END_STATE();
    case 221:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 222:
      if (lookahead == '_') ADVANCE(293);
      if (lookahead == 'o') ADVANCE(294);
      END_STATE();
    case 223:
      if (lookahead == 'i') ADVANCE(295);
      END_STATE();
    case 224:
      if (lookahead == 'c') ADVANCE(296);
      END_STATE();
    case 225:
      if (lookahead == 'c') ADVANCE(297);
      END_STATE();
    case 226:
      if (lookahead == 'd') ADVANCE(298);
      END_STATE();
    case 227:
      if (lookahead == 'r') ADVANCE(299);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_uint);
      if (lookahead == '1') ADVANCE(300);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      if (lookahead == 'p') ADVANCE(301);
      END_STATE();
    case 229:
      if (lookahead == 'g') ADVANCE(302);
      END_STATE();
    case 230:
      if (lookahead == 'n') ADVANCE(303);
      END_STATE();
    case 231:
      if (lookahead == 'g') ADVANCE(304);
      END_STATE();
    case 232:
      if (lookahead == 'r') ADVANCE(305);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 234:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 235:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 236:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 238:
      if (lookahead == 'i') ADVANCE(309);
      END_STATE();
    case 239:
      if (lookahead == 'r') ADVANCE(310);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(311);
      END_STATE();
    case 241:
      if (lookahead == 'c') ADVANCE(312);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(313);
      END_STATE();
    case 243:
      if (lookahead == 's') ADVANCE(314);
      END_STATE();
    case 244:
      if (lookahead == 'l') ADVANCE(315);
      END_STATE();
    case 245:
      if (lookahead == 't') ADVANCE(316);
      END_STATE();
    case 246:
      if (lookahead == 'e') ADVANCE(317);
      END_STATE();
    case 247:
      if (lookahead == 'b') ADVANCE(318);
      END_STATE();
    case 248:
      if (lookahead == 'n') ADVANCE(319);
      END_STATE();
    case 249:
      if (lookahead == 'a') ADVANCE(320);
      END_STATE();
    case 250:
      if (lookahead == 'v') ADVANCE(321);
      END_STATE();
    case 251:
      if (lookahead == 'd') ADVANCE(322);
      END_STATE();
    case 252:
      if (lookahead == 't') ADVANCE(323);
      END_STATE();
    case 253:
      if (lookahead == 'r') ADVANCE(324);
      END_STATE();
    case 254:
      if (lookahead == 'c') ADVANCE(325);
      END_STATE();
    case 255:
      if (lookahead == 's') ADVANCE(326);
      END_STATE();
    case 256:
      if (lookahead == 'l') ADVANCE(327);
      END_STATE();
    case 257:
      if (lookahead == 'r') ADVANCE(328);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(329);
      END_STATE();
    case 259:
      if (lookahead == 't') ADVANCE(330);
      END_STATE();
    case 260:
      if (lookahead == 'i') ADVANCE(331);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 262:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 263:
      if (lookahead == 'm') ADVANCE(332);
      END_STATE();
    case 264:
      if (lookahead == 'v') ADVANCE(333);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'a') ADVANCE(334);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(335);
      END_STATE();
    case 267:
      if (lookahead == 'l') ADVANCE(336);
      END_STATE();
    case 268:
      if (lookahead == 'e') ADVANCE(337);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(338);
      END_STATE();
    case 270:
      if (lookahead == '_') ADVANCE(339);
      END_STATE();
    case 271:
      if (lookahead == 'n') ADVANCE(340);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_float);
      if (lookahead == '1') ADVANCE(341);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      END_STATE();
    case 273:
      if (lookahead == 'i') ADVANCE(342);
      END_STATE();
    case 274:
      if (lookahead == 'l') ADVANCE(343);
      END_STATE();
    case 275:
      if (lookahead == '1') ADVANCE(344);
      if (lookahead == '2') ADVANCE(345);
      if (lookahead == '3') ADVANCE(346);
      END_STATE();
    case 276:
      if (lookahead == 'e') ADVANCE(347);
      END_STATE();
    case 277:
      if (lookahead == 'r') ADVANCE(348);
      END_STATE();
    case 278:
      if (lookahead == 'l') ADVANCE(349);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 280:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 281:
      if (lookahead == 'g') ADVANCE(350);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(351);
      END_STATE();
    case 283:
      if (lookahead == 'f') ADVANCE(352);
      END_STATE();
    case 284:
      if (lookahead == '_') ADVANCE(353);
      END_STATE();
    case 285:
      if (lookahead == 'o') ADVANCE(354);
      if (lookahead == 'w') ADVANCE(355);
      END_STATE();
    case 286:
      if (lookahead == 't') ADVANCE(356);
      END_STATE();
    case 287:
      if (lookahead == 'v') ADVANCE(357);
      END_STATE();
    case 288:
      if (lookahead == 'i') ADVANCE(358);
      END_STATE();
    case 289:
      if (lookahead == 'n') ADVANCE(359);
      END_STATE();
    case 290:
      if (lookahead == 'e') ADVANCE(360);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_short);
      if (lookahead == '1') ADVANCE(361);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      END_STATE();
    case 292:
      if (lookahead == 'd') ADVANCE(362);
      END_STATE();
    case 293:
      if (lookahead == 't') ADVANCE(363);
      END_STATE();
    case 294:
      if (lookahead == 'f') ADVANCE(364);
      END_STATE();
    case 295:
      if (lookahead == 'c') ADVANCE(365);
      END_STATE();
    case 296:
      if (lookahead == 't') ADVANCE(366);
      END_STATE();
    case 297:
      if (lookahead == 'h') ADVANCE(367);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(368);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_uchar);
      if (lookahead == '1') ADVANCE(369);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      END_STATE();
    case 300:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 301:
      if (lookahead == 't') ADVANCE(370);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_ulong);
      if (lookahead == '1') ADVANCE(371);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 304:
      if (lookahead == 'n') ADVANCE(372);
      END_STATE();
    case 305:
      if (lookahead == 't') ADVANCE(373);
      END_STATE();
    case 306:
      if (lookahead == 'i') ADVANCE(374);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 308:
      if (lookahead == '_') ADVANCE(375);
      END_STATE();
    case 309:
      if (lookahead == 'c') ADVANCE(376);
      END_STATE();
    case 310:
      if (lookahead == 'i') ADVANCE(377);
      END_STATE();
    case 311:
      if (lookahead == 'd') ADVANCE(378);
      END_STATE();
    case 312:
      if (lookahead == 'l') ADVANCE(379);
      END_STATE();
    case 313:
      if (lookahead == 'a') ADVANCE(380);
      END_STATE();
    case 314:
      if (lookahead == 't') ADVANCE(381);
      END_STATE();
    case 315:
      if (lookahead == 's') ADVANCE(382);
      END_STATE();
    case 316:
      if (lookahead == 'c') ADVANCE(383);
      END_STATE();
    case 317:
      if (lookahead == 'r') ADVANCE(384);
      END_STATE();
    case 318:
      if (lookahead == 'a') ADVANCE(385);
      END_STATE();
    case 319:
      if (lookahead == 'e') ADVANCE(386);
      END_STATE();
    case 320:
      if (lookahead == 'l') ADVANCE(387);
      END_STATE();
    case 321:
      if (lookahead == 'a') ADVANCE(388);
      END_STATE();
    case 322:
      if (lookahead == '_') ADVANCE(389);
      END_STATE();
    case 323:
      if (lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 325:
      if (lookahead == 'a') ADVANCE(391);
      END_STATE();
    case 326:
      if (lookahead == 'c') ADVANCE(392);
      END_STATE();
    case 327:
      if (lookahead == 'i') ADVANCE(393);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 329:
      if (lookahead == 'o') ADVANCE(394);
      END_STATE();
    case 330:
      if (lookahead == 'e') ADVANCE(395);
      END_STATE();
    case 331:
      if (lookahead == 'g') ADVANCE(396);
      END_STATE();
    case 332:
      if (lookahead == '_') ADVANCE(397);
      END_STATE();
    case 333:
      if (lookahead == 'e') ADVANCE(398);
      END_STATE();
    case 334:
      if (lookahead == 'n') ADVANCE(399);
      END_STATE();
    case 335:
      if (lookahead == 'u') ADVANCE(400);
      END_STATE();
    case 336:
      if (lookahead == 't') ADVANCE(401);
      END_STATE();
    case 337:
      if (lookahead == 'd') ADVANCE(402);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_double);
      if (lookahead == '1') ADVANCE(403);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      END_STATE();
    case 339:
      if (lookahead == 't') ADVANCE(404);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 341:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 342:
      if (lookahead == 'c') ADVANCE(405);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 344:
      if (lookahead == 'd') ADVANCE(406);
      END_STATE();
    case 345:
      if (lookahead == 'd') ADVANCE(407);
      END_STATE();
    case 346:
      if (lookahead == 'd') ADVANCE(408);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 348:
      if (lookahead == '_') ADVANCE(409);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_kernel);
      END_STATE();
    case 350:
      if (lookahead == 'e') ADVANCE(410);
      END_STATE();
    case 351:
      if (lookahead == 'e') ADVANCE(411);
      END_STATE();
    case 352:
      if (lookahead == 'f') ADVANCE(412);
      END_STATE();
    case 353:
      if (lookahead == 't') ADVANCE(413);
      END_STATE();
    case 354:
      if (lookahead == 'n') ADVANCE(414);
      END_STATE();
    case 355:
      if (lookahead == 'r') ADVANCE(415);
      END_STATE();
    case 356:
      if (lookahead == 'e') ADVANCE(416);
      END_STATE();
    case 357:
      if (lookahead == 'e') ADVANCE(417);
      END_STATE();
    case 358:
      if (lookahead == 'c') ADVANCE(418);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 360:
      if (lookahead == 'r') ADVANCE(419);
      END_STATE();
    case 361:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_size_t);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 368:
      if (lookahead == 'f') ADVANCE(420);
      END_STATE();
    case 369:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 370:
      if (lookahead == 'r') ADVANCE(421);
      END_STATE();
    case 371:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 372:
      if (lookahead == 'e') ADVANCE(422);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_ushort);
      if (lookahead == '1') ADVANCE(423);
      if (('2' <= lookahead && lookahead <= '4') ||
          lookahead == '8') ADVANCE(204);
      END_STATE();
    case 374:
      if (lookahead == 'l') ADVANCE(424);
      END_STATE();
    case 375:
      if (lookahead == 'o') ADVANCE(425);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 377:
      if (lookahead == 'b') ADVANCE(426);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 380:
      if (lookahead == 'l') ADVANCE(427);
      END_STATE();
    case 381:
      if (lookahead == 'a') ADVANCE(428);
      END_STATE();
    case 382:
      if (lookahead == 'p') ADVANCE(429);
      END_STATE();
    case 383:
      if (lookahead == 'a') ADVANCE(430);
      END_STATE();
    case 384:
      if (lookahead == 'i') ADVANCE(431);
      END_STATE();
    case 385:
      if (lookahead == 'l') ADVANCE(432);
      END_STATE();
    case 386:
      if (lookahead == 'l') ADVANCE(433);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym___local);
      END_STATE();
    case 388:
      if (lookahead == 't') ADVANCE(434);
      END_STATE();
    case 389:
      if (lookahead == 'o') ADVANCE(435);
      if (lookahead == 'w') ADVANCE(436);
      END_STATE();
    case 390:
      if (lookahead == 'i') ADVANCE(437);
      END_STATE();
    case 391:
      if (lookahead == 'l') ADVANCE(438);
      END_STATE();
    case 392:
      if (lookahead == 'a') ADVANCE(439);
      END_STATE();
    case 393:
      if (lookahead == 'g') ADVANCE(440);
      END_STATE();
    case 394:
      if (lookahead == 'r') ADVANCE(441);
      END_STATE();
    case 395:
      if (lookahead == '_') ADVANCE(442);
      END_STATE();
    case 396:
      if (lookahead == 'n') ADVANCE(443);
      END_STATE();
    case 397:
      if (lookahead == 'f') ADVANCE(444);
      END_STATE();
    case 398:
      if (lookahead == 'n') ADVANCE(445);
      END_STATE();
    case 399:
      if (lookahead == 't') ADVANCE(446);
      END_STATE();
    case 400:
      if (lookahead == 'e') ADVANCE(447);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 403:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_event_t);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_generic);
      END_STATE();
    case 406:
      if (lookahead == '_') ADVANCE(448);
      END_STATE();
    case 407:
      if (lookahead == '_') ADVANCE(449);
      END_STATE();
    case 408:
      if (lookahead == '_') ADVANCE(450);
      END_STATE();
    case 409:
      if (lookahead == 't') ADVANCE(451);
      END_STATE();
    case 410:
      if (lookahead == '_') ADVANCE(452);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 412:
      if (lookahead == '_') ADVANCE(453);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_queue_t);
      END_STATE();
    case 414:
      if (lookahead == 'l') ADVANCE(454);
      END_STATE();
    case 415:
      if (lookahead == 'i') ADVANCE(455);
      END_STATE();
    case 416:
      if (lookahead == 'r') ADVANCE(456);
      END_STATE();
    case 417:
      if (lookahead == '_') ADVANCE(457);
      END_STATE();
    case 418:
      if (lookahead == 't') ADVANCE(458);
      END_STATE();
    case 419:
      if (lookahead == '_') ADVANCE(459);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 421:
      if (lookahead == '_') ADVANCE(460);
      END_STATE();
    case 422:
      if (lookahead == 'd') ADVANCE(461);
      END_STATE();
    case 423:
      if (lookahead == '6') ADVANCE(204);
      END_STATE();
    case 424:
      if (lookahead == 'e') ADVANCE(462);
      END_STATE();
    case 425:
      if (lookahead == 'n') ADVANCE(463);
      END_STATE();
    case 426:
      if (lookahead == 'u') ADVANCE(464);
      END_STATE();
    case 427:
      if (lookahead == 'l') ADVANCE(465);
      END_STATE();
    case 428:
      if (lookahead == 'n') ADVANCE(466);
      END_STATE();
    case 429:
      if (lookahead == 'e') ADVANCE(467);
      END_STATE();
    case 430:
      if (lookahead == 'l') ADVANCE(468);
      END_STATE();
    case 431:
      if (lookahead == 'c') ADVANCE(469);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym___global);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym___kernel);
      END_STATE();
    case 434:
      if (lookahead == 'e') ADVANCE(470);
      END_STATE();
    case 435:
      if (lookahead == 'n') ADVANCE(471);
      END_STATE();
    case 436:
      if (lookahead == 'r') ADVANCE(472);
      END_STATE();
    case 437:
      if (lookahead == 'c') ADVANCE(473);
      END_STATE();
    case 438:
      if (lookahead == 'l') ADVANCE(474);
      END_STATE();
    case 439:
      if (lookahead == 'l') ADVANCE(475);
      END_STATE();
    case 440:
      if (lookahead == 'n') ADVANCE(476);
      END_STATE();
    case 441:
      if (lookahead == 'c') ADVANCE(477);
      END_STATE();
    case 442:
      if (lookahead == 'o') ADVANCE(478);
      END_STATE();
    case 443:
      if (lookahead == 'e') ADVANCE(479);
      END_STATE();
    case 444:
      if (lookahead == 'e') ADVANCE(480);
      END_STATE();
    case 445:
      if (lookahead == 't') ADVANCE(481);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_constant);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 448:
      if (lookahead == 'a') ADVANCE(482);
      if (lookahead == 'b') ADVANCE(483);
      if (lookahead == 't') ADVANCE(484);
      END_STATE();
    case 449:
      if (lookahead == 'a') ADVANCE(485);
      if (lookahead == 'd') ADVANCE(486);
      if (lookahead == 't') ADVANCE(487);
      END_STATE();
    case 450:
      if (lookahead == 't') ADVANCE(488);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_intptr_t);
      END_STATE();
    case 452:
      if (lookahead == 't') ADVANCE(489);
      END_STATE();
    case 453:
      if (lookahead == 't') ADVANCE(490);
      END_STATE();
    case 454:
      if (lookahead == 'y') ADVANCE(491);
      END_STATE();
    case 455:
      if (lookahead == 't') ADVANCE(492);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 457:
      if (lookahead == 'i') ADVANCE(493);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 459:
      if (lookahead == 't') ADVANCE(494);
      END_STATE();
    case 460:
      if (lookahead == 't') ADVANCE(495);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 463:
      if (lookahead == 'l') ADVANCE(496);
      END_STATE();
    case 464:
      if (lookahead == 't') ADVANCE(497);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 466:
      if (lookahead == 't') ADVANCE(498);
      END_STATE();
    case 467:
      if (lookahead == 'c') ADVANCE(499);
      END_STATE();
    case 468:
      if (lookahead == 'l') ADVANCE(500);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym___generic);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym___private);
      END_STATE();
    case 471:
      if (lookahead == 'l') ADVANCE(501);
      END_STATE();
    case 472:
      if (lookahead == 'i') ADVANCE(502);
      END_STATE();
    case 473:
      if (lookahead == 't') ADVANCE(503);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 475:
      if (lookahead == 'l') ADVANCE(504);
      END_STATE();
    case 476:
      if (lookahead == 'e') ADVANCE(505);
      END_STATE();
    case 477:
      if (lookahead == 'a') ADVANCE(506);
      END_STATE();
    case 478:
      if (lookahead == 'n') ADVANCE(507);
      END_STATE();
    case 479:
      if (lookahead == 'd') ADVANCE(508);
      END_STATE();
    case 480:
      if (lookahead == 'n') ADVANCE(509);
      END_STATE();
    case 481:
      if (lookahead == '_') ADVANCE(510);
      END_STATE();
    case 482:
      if (lookahead == 'r') ADVANCE(511);
      END_STATE();
    case 483:
      if (lookahead == 'u') ADVANCE(512);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_image1d_t);
      END_STATE();
    case 485:
      if (lookahead == 'r') ADVANCE(513);
      END_STATE();
    case 486:
      if (lookahead == 'e') ADVANCE(514);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_image2d_t);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_image3d_t);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_ndrange_t);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_ptrdiff_t);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_read_only);
      END_STATE();
    case 492:
      if (lookahead == 'e') ADVANCE(515);
      END_STATE();
    case 493:
      if (lookahead == 'd') ADVANCE(516);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_sampler_t);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_uintptr_t);
      END_STATE();
    case 496:
      if (lookahead == 'y') ADVANCE(517);
      END_STATE();
    case 497:
      if (lookahead == 'e') ADVANCE(518);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym___constant);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 501:
      if (lookahead == 'y') ADVANCE(519);
      END_STATE();
    case 502:
      if (lookahead == 't') ADVANCE(520);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 505:
      if (lookahead == 'd') ADVANCE(521);
      END_STATE();
    case 506:
      if (lookahead == 'l') ADVANCE(522);
      END_STATE();
    case 507:
      if (lookahead == 'l') ADVANCE(523);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 509:
      if (lookahead == 'c') ADVANCE(524);
      END_STATE();
    case 510:
      if (lookahead == 't') ADVANCE(525);
      END_STATE();
    case 511:
      if (lookahead == 'r') ADVANCE(526);
      END_STATE();
    case 512:
      if (lookahead == 'f') ADVANCE(527);
      END_STATE();
    case 513:
      if (lookahead == 'r') ADVANCE(528);
      END_STATE();
    case 514:
      if (lookahead == 'p') ADVANCE(529);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_read_write);
      END_STATE();
    case 516:
      if (lookahead == '_') ADVANCE(530);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_write_only);
      END_STATE();
    case 518:
      if (lookahead == '_') ADVANCE(531);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym___read_only);
      END_STATE();
    case 520:
      if (lookahead == 'e') ADVANCE(532);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 522:
      if (lookahead == 'l') ADVANCE(533);
      END_STATE();
    case 523:
      if (lookahead == 'y') ADVANCE(534);
      END_STATE();
    case 524:
      if (lookahead == 'e') ADVANCE(535);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_clk_event_t);
      END_STATE();
    case 526:
      if (lookahead == 'a') ADVANCE(536);
      END_STATE();
    case 527:
      if (lookahead == 'f') ADVANCE(537);
      END_STATE();
    case 528:
      if (lookahead == 'a') ADVANCE(538);
      END_STATE();
    case 529:
      if (lookahead == 't') ADVANCE(539);
      END_STATE();
    case 530:
      if (lookahead == 't') ADVANCE(540);
      END_STATE();
    case 531:
      if (lookahead == '_') ADVANCE(541);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym___read_write);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym___write_only);
      END_STATE();
    case 535:
      if (lookahead == '_') ADVANCE(542);
      END_STATE();
    case 536:
      if (lookahead == 'y') ADVANCE(543);
      END_STATE();
    case 537:
      if (lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 538:
      if (lookahead == 'y') ADVANCE(545);
      END_STATE();
    case 539:
      if (lookahead == 'h') ADVANCE(546);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_reserve_id_t);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 542:
      if (lookahead == 'f') ADVANCE(547);
      END_STATE();
    case 543:
      if (lookahead == '_') ADVANCE(548);
      END_STATE();
    case 544:
      if (lookahead == 'r') ADVANCE(549);
      END_STATE();
    case 545:
      if (lookahead == '_') ADVANCE(550);
      END_STATE();
    case 546:
      if (lookahead == '_') ADVANCE(551);
      END_STATE();
    case 547:
      if (lookahead == 'l') ADVANCE(552);
      END_STATE();
    case 548:
      if (lookahead == 't') ADVANCE(553);
      END_STATE();
    case 549:
      if (lookahead == '_') ADVANCE(554);
      END_STATE();
    case 550:
      if (lookahead == 'd') ADVANCE(555);
      if (lookahead == 't') ADVANCE(556);
      END_STATE();
    case 551:
      if (lookahead == 't') ADVANCE(557);
      END_STATE();
    case 552:
      if (lookahead == 'a') ADVANCE(558);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_image1d_array_t);
      END_STATE();
    case 554:
      if (lookahead == 't') ADVANCE(559);
      END_STATE();
    case 555:
      if (lookahead == 'e') ADVANCE(560);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_image2d_array_t);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(anon_sym_image2d_depth_t);
      END_STATE();
    case 558:
      if (lookahead == 'g') ADVANCE(561);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_image1d_buffer_t);
      END_STATE();
    case 560:
      if (lookahead == 'p') ADVANCE(562);
      END_STATE();
    case 561:
      if (lookahead == 's') ADVANCE(563);
      END_STATE();
    case 562:
      if (lookahead == 't') ADVANCE(564);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_cl_mem_fence_flags);
      END_STATE();
    case 564:
      if (lookahead == 'h') ADVANCE(565);
      END_STATE();
    case 565:
      if (lookahead == '_') ADVANCE(566);
      END_STATE();
    case 566:
      if (lookahead == 't') ADVANCE(567);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_image2d_array_depth_t);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 83},
  [2] = {.lex_state = 28},
  [3] = {.lex_state = 28},
  [4] = {.lex_state = 28},
  [5] = {.lex_state = 28},
  [6] = {.lex_state = 28},
  [7] = {.lex_state = 28},
  [8] = {.lex_state = 28},
  [9] = {.lex_state = 28},
  [10] = {.lex_state = 28},
  [11] = {.lex_state = 28},
  [12] = {.lex_state = 28},
  [13] = {.lex_state = 28},
  [14] = {.lex_state = 28},
  [15] = {.lex_state = 28},
  [16] = {.lex_state = 28},
  [17] = {.lex_state = 28},
  [18] = {.lex_state = 28},
  [19] = {.lex_state = 28},
  [20] = {.lex_state = 28},
  [21] = {.lex_state = 83},
  [22] = {.lex_state = 29},
  [23] = {.lex_state = 29},
  [24] = {.lex_state = 29},
  [25] = {.lex_state = 83},
  [26] = {.lex_state = 83},
  [27] = {.lex_state = 83},
  [28] = {.lex_state = 83},
  [29] = {.lex_state = 83},
  [30] = {.lex_state = 83},
  [31] = {.lex_state = 83},
  [32] = {.lex_state = 83},
  [33] = {.lex_state = 83},
  [34] = {.lex_state = 83},
  [35] = {.lex_state = 83},
  [36] = {.lex_state = 83},
  [37] = {.lex_state = 83},
  [38] = {.lex_state = 83},
  [39] = {.lex_state = 83},
  [40] = {.lex_state = 83},
  [41] = {.lex_state = 83},
  [42] = {.lex_state = 83},
  [43] = {.lex_state = 28},
  [44] = {.lex_state = 28},
  [45] = {.lex_state = 28},
  [46] = {.lex_state = 28},
  [47] = {.lex_state = 28},
  [48] = {.lex_state = 29},
  [49] = {.lex_state = 83},
  [50] = {.lex_state = 29},
  [51] = {.lex_state = 83},
  [52] = {.lex_state = 29},
  [53] = {.lex_state = 29},
  [54] = {.lex_state = 83},
  [55] = {.lex_state = 29},
  [56] = {.lex_state = 83},
  [57] = {.lex_state = 83},
  [58] = {.lex_state = 83},
  [59] = {.lex_state = 83},
  [60] = {.lex_state = 83},
  [61] = {.lex_state = 83},
  [62] = {.lex_state = 83},
  [63] = {.lex_state = 83},
  [64] = {.lex_state = 83},
  [65] = {.lex_state = 83},
  [66] = {.lex_state = 83},
  [67] = {.lex_state = 28},
  [68] = {.lex_state = 28},
  [69] = {.lex_state = 28},
  [70] = {.lex_state = 28},
  [71] = {.lex_state = 28},
  [72] = {.lex_state = 28},
  [73] = {.lex_state = 28},
  [74] = {.lex_state = 28},
  [75] = {.lex_state = 28},
  [76] = {.lex_state = 28},
  [77] = {.lex_state = 28},
  [78] = {.lex_state = 28},
  [79] = {.lex_state = 28},
  [80] = {.lex_state = 28},
  [81] = {.lex_state = 28},
  [82] = {.lex_state = 28},
  [83] = {.lex_state = 28},
  [84] = {.lex_state = 28},
  [85] = {.lex_state = 28},
  [86] = {.lex_state = 28},
  [87] = {.lex_state = 28},
  [88] = {.lex_state = 28},
  [89] = {.lex_state = 28},
  [90] = {.lex_state = 28},
  [91] = {.lex_state = 28},
  [92] = {.lex_state = 28},
  [93] = {.lex_state = 28},
  [94] = {.lex_state = 28},
  [95] = {.lex_state = 28},
  [96] = {.lex_state = 28},
  [97] = {.lex_state = 28},
  [98] = {.lex_state = 28},
  [99] = {.lex_state = 28},
  [100] = {.lex_state = 28},
  [101] = {.lex_state = 28},
  [102] = {.lex_state = 28},
  [103] = {.lex_state = 28},
  [104] = {.lex_state = 28},
  [105] = {.lex_state = 28},
  [106] = {.lex_state = 28},
  [107] = {.lex_state = 28},
  [108] = {.lex_state = 28},
  [109] = {.lex_state = 28},
  [110] = {.lex_state = 28},
  [111] = {.lex_state = 28},
  [112] = {.lex_state = 28},
  [113] = {.lex_state = 28},
  [114] = {.lex_state = 28},
  [115] = {.lex_state = 28},
  [116] = {.lex_state = 28},
  [117] = {.lex_state = 28},
  [118] = {.lex_state = 28},
  [119] = {.lex_state = 28},
  [120] = {.lex_state = 28},
  [121] = {.lex_state = 28},
  [122] = {.lex_state = 28},
  [123] = {.lex_state = 28},
  [124] = {.lex_state = 83},
  [125] = {.lex_state = 83},
  [126] = {.lex_state = 83},
  [127] = {.lex_state = 83},
  [128] = {.lex_state = 83},
  [129] = {.lex_state = 83},
  [130] = {.lex_state = 83},
  [131] = {.lex_state = 83},
  [132] = {.lex_state = 83},
  [133] = {.lex_state = 83},
  [134] = {.lex_state = 83},
  [135] = {.lex_state = 83},
  [136] = {.lex_state = 83},
  [137] = {.lex_state = 83},
  [138] = {.lex_state = 83},
  [139] = {.lex_state = 83},
  [140] = {.lex_state = 29},
  [141] = {.lex_state = 29},
  [142] = {.lex_state = 83},
  [143] = {.lex_state = 29},
  [144] = {.lex_state = 29},
  [145] = {.lex_state = 83},
  [146] = {.lex_state = 29},
  [147] = {.lex_state = 83},
  [148] = {.lex_state = 29},
  [149] = {.lex_state = 83},
  [150] = {.lex_state = 29},
  [151] = {.lex_state = 83},
  [152] = {.lex_state = 83},
  [153] = {.lex_state = 29},
  [154] = {.lex_state = 29},
  [155] = {.lex_state = 83},
  [156] = {.lex_state = 83},
  [157] = {.lex_state = 29},
  [158] = {.lex_state = 83},
  [159] = {.lex_state = 83},
  [160] = {.lex_state = 29},
  [161] = {.lex_state = 29},
  [162] = {.lex_state = 29},
  [163] = {.lex_state = 29},
  [164] = {.lex_state = 29},
  [165] = {.lex_state = 29},
  [166] = {.lex_state = 29},
  [167] = {.lex_state = 83},
  [168] = {.lex_state = 83},
  [169] = {.lex_state = 83},
  [170] = {.lex_state = 83},
  [171] = {.lex_state = 83},
  [172] = {.lex_state = 29},
  [173] = {.lex_state = 29},
  [174] = {.lex_state = 83},
  [175] = {.lex_state = 83},
  [176] = {.lex_state = 83},
  [177] = {.lex_state = 83},
  [178] = {.lex_state = 83},
  [179] = {.lex_state = 83},
  [180] = {.lex_state = 29},
  [181] = {.lex_state = 83},
  [182] = {.lex_state = 29},
  [183] = {.lex_state = 83},
  [184] = {.lex_state = 29},
  [185] = {.lex_state = 83},
  [186] = {.lex_state = 83},
  [187] = {.lex_state = 29},
  [188] = {.lex_state = 83},
  [189] = {.lex_state = 29},
  [190] = {.lex_state = 29},
  [191] = {.lex_state = 83},
  [192] = {.lex_state = 29},
  [193] = {.lex_state = 29},
  [194] = {.lex_state = 29},
  [195] = {.lex_state = 29},
  [196] = {.lex_state = 29},
  [197] = {.lex_state = 29},
  [198] = {.lex_state = 29},
  [199] = {.lex_state = 29},
  [200] = {.lex_state = 29},
  [201] = {.lex_state = 29},
  [202] = {.lex_state = 83},
  [203] = {.lex_state = 29},
  [204] = {.lex_state = 83},
  [205] = {.lex_state = 83},
  [206] = {.lex_state = 83},
  [207] = {.lex_state = 83},
  [208] = {.lex_state = 83},
  [209] = {.lex_state = 83},
  [210] = {.lex_state = 83},
  [211] = {.lex_state = 83},
  [212] = {.lex_state = 83},
  [213] = {.lex_state = 83},
  [214] = {.lex_state = 83},
  [215] = {.lex_state = 83},
  [216] = {.lex_state = 83},
  [217] = {.lex_state = 83},
  [218] = {.lex_state = 83},
  [219] = {.lex_state = 83},
  [220] = {.lex_state = 83},
  [221] = {.lex_state = 83},
  [222] = {.lex_state = 83},
  [223] = {.lex_state = 83},
  [224] = {.lex_state = 83},
  [225] = {.lex_state = 83},
  [226] = {.lex_state = 83},
  [227] = {.lex_state = 83},
  [228] = {.lex_state = 83},
  [229] = {.lex_state = 83},
  [230] = {.lex_state = 83},
  [231] = {.lex_state = 83},
  [232] = {.lex_state = 83},
  [233] = {.lex_state = 29},
  [234] = {.lex_state = 83},
  [235] = {.lex_state = 83},
  [236] = {.lex_state = 83},
  [237] = {.lex_state = 83},
  [238] = {.lex_state = 83},
  [239] = {.lex_state = 83},
  [240] = {.lex_state = 83},
  [241] = {.lex_state = 29},
  [242] = {.lex_state = 83},
  [243] = {.lex_state = 29},
  [244] = {.lex_state = 29},
  [245] = {.lex_state = 29},
  [246] = {.lex_state = 29},
  [247] = {.lex_state = 29},
  [248] = {.lex_state = 29},
  [249] = {.lex_state = 29},
  [250] = {.lex_state = 29},
  [251] = {.lex_state = 83},
  [252] = {.lex_state = 83},
  [253] = {.lex_state = 29},
  [254] = {.lex_state = 83},
  [255] = {.lex_state = 83},
  [256] = {.lex_state = 83},
  [257] = {.lex_state = 29},
  [258] = {.lex_state = 29},
  [259] = {.lex_state = 29},
  [260] = {.lex_state = 83},
  [261] = {.lex_state = 83},
  [262] = {.lex_state = 83},
  [263] = {.lex_state = 83},
  [264] = {.lex_state = 83},
  [265] = {.lex_state = 83},
  [266] = {.lex_state = 83},
  [267] = {.lex_state = 83},
  [268] = {.lex_state = 83},
  [269] = {.lex_state = 83},
  [270] = {.lex_state = 83},
  [271] = {.lex_state = 29},
  [272] = {.lex_state = 83},
  [273] = {.lex_state = 83},
  [274] = {.lex_state = 83},
  [275] = {.lex_state = 29},
  [276] = {.lex_state = 83},
  [277] = {.lex_state = 83},
  [278] = {.lex_state = 83},
  [279] = {.lex_state = 83},
  [280] = {.lex_state = 83},
  [281] = {.lex_state = 83},
  [282] = {.lex_state = 83},
  [283] = {.lex_state = 83},
  [284] = {.lex_state = 29},
  [285] = {.lex_state = 83},
  [286] = {.lex_state = 29},
  [287] = {.lex_state = 29},
  [288] = {.lex_state = 29},
  [289] = {.lex_state = 83},
  [290] = {.lex_state = 29},
  [291] = {.lex_state = 83},
  [292] = {.lex_state = 83},
  [293] = {.lex_state = 83},
  [294] = {.lex_state = 83},
  [295] = {.lex_state = 83},
  [296] = {.lex_state = 83},
  [297] = {.lex_state = 33},
  [298] = {.lex_state = 33},
  [299] = {.lex_state = 33},
  [300] = {.lex_state = 33},
  [301] = {.lex_state = 33},
  [302] = {.lex_state = 33},
  [303] = {.lex_state = 33},
  [304] = {.lex_state = 33},
  [305] = {.lex_state = 33},
  [306] = {.lex_state = 33},
  [307] = {.lex_state = 33},
  [308] = {.lex_state = 33},
  [309] = {.lex_state = 33},
  [310] = {.lex_state = 33},
  [311] = {.lex_state = 33},
  [312] = {.lex_state = 83},
  [313] = {.lex_state = 33},
  [314] = {.lex_state = 32},
  [315] = {.lex_state = 34},
  [316] = {.lex_state = 34},
  [317] = {.lex_state = 32},
  [318] = {.lex_state = 32},
  [319] = {.lex_state = 34},
  [320] = {.lex_state = 32},
  [321] = {.lex_state = 32},
  [322] = {.lex_state = 33},
  [323] = {.lex_state = 33},
  [324] = {.lex_state = 33},
  [325] = {.lex_state = 33},
  [326] = {.lex_state = 33},
  [327] = {.lex_state = 83},
  [328] = {.lex_state = 83},
  [329] = {.lex_state = 83},
  [330] = {.lex_state = 83},
  [331] = {.lex_state = 83},
  [332] = {.lex_state = 83},
  [333] = {.lex_state = 83},
  [334] = {.lex_state = 83},
  [335] = {.lex_state = 33},
  [336] = {.lex_state = 33},
  [337] = {.lex_state = 33},
  [338] = {.lex_state = 33},
  [339] = {.lex_state = 33},
  [340] = {.lex_state = 33},
  [341] = {.lex_state = 33},
  [342] = {.lex_state = 33},
  [343] = {.lex_state = 33},
  [344] = {.lex_state = 33},
  [345] = {.lex_state = 33},
  [346] = {.lex_state = 33},
  [347] = {.lex_state = 33},
  [348] = {.lex_state = 33},
  [349] = {.lex_state = 27},
  [350] = {.lex_state = 33},
  [351] = {.lex_state = 33},
  [352] = {.lex_state = 33},
  [353] = {.lex_state = 33},
  [354] = {.lex_state = 33},
  [355] = {.lex_state = 33},
  [356] = {.lex_state = 33},
  [357] = {.lex_state = 33},
  [358] = {.lex_state = 33},
  [359] = {.lex_state = 33},
  [360] = {.lex_state = 33},
  [361] = {.lex_state = 33},
  [362] = {.lex_state = 33},
  [363] = {.lex_state = 33},
  [364] = {.lex_state = 33},
  [365] = {.lex_state = 33},
  [366] = {.lex_state = 33},
  [367] = {.lex_state = 33},
  [368] = {.lex_state = 33},
  [369] = {.lex_state = 33},
  [370] = {.lex_state = 33},
  [371] = {.lex_state = 33},
  [372] = {.lex_state = 33},
  [373] = {.lex_state = 33},
  [374] = {.lex_state = 33},
  [375] = {.lex_state = 34},
  [376] = {.lex_state = 32},
  [377] = {.lex_state = 32},
  [378] = {.lex_state = 31},
  [379] = {.lex_state = 32},
  [380] = {.lex_state = 32},
  [381] = {.lex_state = 31},
  [382] = {.lex_state = 32},
  [383] = {.lex_state = 32},
  [384] = {.lex_state = 31},
  [385] = {.lex_state = 32},
  [386] = {.lex_state = 32},
  [387] = {.lex_state = 32},
  [388] = {.lex_state = 32},
  [389] = {.lex_state = 34},
  [390] = {.lex_state = 32},
  [391] = {.lex_state = 32},
  [392] = {.lex_state = 34},
  [393] = {.lex_state = 34},
  [394] = {.lex_state = 31},
  [395] = {.lex_state = 34},
  [396] = {.lex_state = 32},
  [397] = {.lex_state = 32},
  [398] = {.lex_state = 34},
  [399] = {.lex_state = 34},
  [400] = {.lex_state = 32},
  [401] = {.lex_state = 34},
  [402] = {.lex_state = 34},
  [403] = {.lex_state = 32},
  [404] = {.lex_state = 34},
  [405] = {.lex_state = 34},
  [406] = {.lex_state = 32},
  [407] = {.lex_state = 34},
  [408] = {.lex_state = 34},
  [409] = {.lex_state = 34},
  [410] = {.lex_state = 34},
  [411] = {.lex_state = 34},
  [412] = {.lex_state = 32},
  [413] = {.lex_state = 34},
  [414] = {.lex_state = 32},
  [415] = {.lex_state = 34},
  [416] = {.lex_state = 32},
  [417] = {.lex_state = 34},
  [418] = {.lex_state = 34},
  [419] = {.lex_state = 27},
  [420] = {.lex_state = 83},
  [421] = {.lex_state = 83},
  [422] = {.lex_state = 83},
  [423] = {.lex_state = 83},
  [424] = {.lex_state = 83},
  [425] = {.lex_state = 83},
  [426] = {.lex_state = 83},
  [427] = {.lex_state = 83},
  [428] = {.lex_state = 83},
  [429] = {.lex_state = 83},
  [430] = {.lex_state = 83},
  [431] = {.lex_state = 83},
  [432] = {.lex_state = 83},
  [433] = {.lex_state = 83},
  [434] = {.lex_state = 83},
  [435] = {.lex_state = 83},
  [436] = {.lex_state = 83},
  [437] = {.lex_state = 83},
  [438] = {.lex_state = 83},
  [439] = {.lex_state = 83},
  [440] = {.lex_state = 83},
  [441] = {.lex_state = 83},
  [442] = {.lex_state = 83},
  [443] = {.lex_state = 83},
  [444] = {.lex_state = 83},
  [445] = {.lex_state = 83},
  [446] = {.lex_state = 83},
  [447] = {.lex_state = 83},
  [448] = {.lex_state = 83},
  [449] = {.lex_state = 83},
  [450] = {.lex_state = 83},
  [451] = {.lex_state = 83},
  [452] = {.lex_state = 83},
  [453] = {.lex_state = 83},
  [454] = {.lex_state = 83},
  [455] = {.lex_state = 83},
  [456] = {.lex_state = 83},
  [457] = {.lex_state = 83},
  [458] = {.lex_state = 83},
  [459] = {.lex_state = 83},
  [460] = {.lex_state = 83},
  [461] = {.lex_state = 83},
  [462] = {.lex_state = 83},
  [463] = {.lex_state = 83},
  [464] = {.lex_state = 83},
  [465] = {.lex_state = 83},
  [466] = {.lex_state = 83},
  [467] = {.lex_state = 83},
  [468] = {.lex_state = 83},
  [469] = {.lex_state = 83},
  [470] = {.lex_state = 83},
  [471] = {.lex_state = 83},
  [472] = {.lex_state = 83},
  [473] = {.lex_state = 83},
  [474] = {.lex_state = 83},
  [475] = {.lex_state = 83},
  [476] = {.lex_state = 83},
  [477] = {.lex_state = 83},
  [478] = {.lex_state = 83},
  [479] = {.lex_state = 83},
  [480] = {.lex_state = 83},
  [481] = {.lex_state = 83},
  [482] = {.lex_state = 83},
  [483] = {.lex_state = 83},
  [484] = {.lex_state = 83},
  [485] = {.lex_state = 83},
  [486] = {.lex_state = 83},
  [487] = {.lex_state = 83},
  [488] = {.lex_state = 83},
  [489] = {.lex_state = 83},
  [490] = {.lex_state = 83},
  [491] = {.lex_state = 83},
  [492] = {.lex_state = 83},
  [493] = {.lex_state = 83},
  [494] = {.lex_state = 83},
  [495] = {.lex_state = 83},
  [496] = {.lex_state = 32},
  [497] = {.lex_state = 32},
  [498] = {.lex_state = 32},
  [499] = {.lex_state = 32},
  [500] = {.lex_state = 32},
  [501] = {.lex_state = 32},
  [502] = {.lex_state = 32},
  [503] = {.lex_state = 32},
  [504] = {.lex_state = 32},
  [505] = {.lex_state = 33},
  [506] = {.lex_state = 27},
  [507] = {.lex_state = 27},
  [508] = {.lex_state = 33},
  [509] = {.lex_state = 33},
  [510] = {.lex_state = 33},
  [511] = {.lex_state = 33},
  [512] = {.lex_state = 33},
  [513] = {.lex_state = 33},
  [514] = {.lex_state = 33},
  [515] = {.lex_state = 33},
  [516] = {.lex_state = 33},
  [517] = {.lex_state = 33},
  [518] = {.lex_state = 33},
  [519] = {.lex_state = 33},
  [520] = {.lex_state = 33},
  [521] = {.lex_state = 83},
  [522] = {.lex_state = 33},
  [523] = {.lex_state = 83},
  [524] = {.lex_state = 83},
  [525] = {.lex_state = 83},
  [526] = {.lex_state = 33},
  [527] = {.lex_state = 83},
  [528] = {.lex_state = 83},
  [529] = {.lex_state = 83},
  [530] = {.lex_state = 83},
  [531] = {.lex_state = 33},
  [532] = {.lex_state = 83},
  [533] = {.lex_state = 83},
  [534] = {.lex_state = 83},
  [535] = {.lex_state = 83},
  [536] = {.lex_state = 33},
  [537] = {.lex_state = 83},
  [538] = {.lex_state = 33},
  [539] = {.lex_state = 33},
  [540] = {.lex_state = 83},
  [541] = {.lex_state = 31},
  [542] = {.lex_state = 31},
  [543] = {.lex_state = 31},
  [544] = {.lex_state = 31},
  [545] = {.lex_state = 31},
  [546] = {.lex_state = 33},
  [547] = {.lex_state = 33},
  [548] = {.lex_state = 33},
  [549] = {.lex_state = 33},
  [550] = {.lex_state = 83},
  [551] = {.lex_state = 83},
  [552] = {.lex_state = 83},
  [553] = {.lex_state = 83},
  [554] = {.lex_state = 83},
  [555] = {.lex_state = 83},
  [556] = {.lex_state = 83},
  [557] = {.lex_state = 83},
  [558] = {.lex_state = 83},
  [559] = {.lex_state = 83},
  [560] = {.lex_state = 83},
  [561] = {.lex_state = 83},
  [562] = {.lex_state = 83},
  [563] = {.lex_state = 83},
  [564] = {.lex_state = 83},
  [565] = {.lex_state = 83},
  [566] = {.lex_state = 83},
  [567] = {.lex_state = 83},
  [568] = {.lex_state = 83},
  [569] = {.lex_state = 83},
  [570] = {.lex_state = 83},
  [571] = {.lex_state = 83},
  [572] = {.lex_state = 83},
  [573] = {.lex_state = 83},
  [574] = {.lex_state = 83},
  [575] = {.lex_state = 83},
  [576] = {.lex_state = 83},
  [577] = {.lex_state = 83},
  [578] = {.lex_state = 83},
  [579] = {.lex_state = 83},
  [580] = {.lex_state = 83},
  [581] = {.lex_state = 83},
  [582] = {.lex_state = 83},
  [583] = {.lex_state = 83},
  [584] = {.lex_state = 83},
  [585] = {.lex_state = 83},
  [586] = {.lex_state = 83},
  [587] = {.lex_state = 83},
  [588] = {.lex_state = 83},
  [589] = {.lex_state = 83},
  [590] = {.lex_state = 83},
  [591] = {.lex_state = 83},
  [592] = {.lex_state = 83},
  [593] = {.lex_state = 83},
  [594] = {.lex_state = 83},
  [595] = {.lex_state = 83},
  [596] = {.lex_state = 32},
  [597] = {.lex_state = 83},
  [598] = {.lex_state = 83},
  [599] = {.lex_state = 83},
  [600] = {.lex_state = 83},
  [601] = {.lex_state = 83},
  [602] = {.lex_state = 83},
  [603] = {.lex_state = 83},
  [604] = {.lex_state = 83},
  [605] = {.lex_state = 32},
  [606] = {.lex_state = 83},
  [607] = {.lex_state = 83},
  [608] = {.lex_state = 83},
  [609] = {.lex_state = 83},
  [610] = {.lex_state = 83},
  [611] = {.lex_state = 83},
  [612] = {.lex_state = 83},
  [613] = {.lex_state = 83},
  [614] = {.lex_state = 83},
  [615] = {.lex_state = 33},
  [616] = {.lex_state = 33},
  [617] = {.lex_state = 83},
  [618] = {.lex_state = 83},
  [619] = {.lex_state = 83},
  [620] = {.lex_state = 83},
  [621] = {.lex_state = 83},
  [622] = {.lex_state = 83},
  [623] = {.lex_state = 83},
  [624] = {.lex_state = 83},
  [625] = {.lex_state = 83},
  [626] = {.lex_state = 83},
  [627] = {.lex_state = 83},
  [628] = {.lex_state = 32},
  [629] = {.lex_state = 33},
  [630] = {.lex_state = 83},
  [631] = {.lex_state = 83},
  [632] = {.lex_state = 83},
  [633] = {.lex_state = 83},
  [634] = {.lex_state = 83},
  [635] = {.lex_state = 83},
  [636] = {.lex_state = 83},
  [637] = {.lex_state = 83},
  [638] = {.lex_state = 32},
  [639] = {.lex_state = 83},
  [640] = {.lex_state = 83},
  [641] = {.lex_state = 83},
  [642] = {.lex_state = 83},
  [643] = {.lex_state = 83},
  [644] = {.lex_state = 32},
  [645] = {.lex_state = 83},
  [646] = {.lex_state = 32},
  [647] = {.lex_state = 83},
  [648] = {.lex_state = 32},
  [649] = {.lex_state = 83},
  [650] = {.lex_state = 83},
  [651] = {.lex_state = 83},
  [652] = {.lex_state = 83},
  [653] = {.lex_state = 83},
  [654] = {.lex_state = 83},
  [655] = {.lex_state = 83},
  [656] = {.lex_state = 83},
  [657] = {.lex_state = 83},
  [658] = {.lex_state = 32},
  [659] = {.lex_state = 32},
  [660] = {.lex_state = 32},
  [661] = {.lex_state = 83},
  [662] = {.lex_state = 32},
  [663] = {.lex_state = 32},
  [664] = {.lex_state = 83},
  [665] = {.lex_state = 32},
  [666] = {.lex_state = 83},
  [667] = {.lex_state = 83},
  [668] = {.lex_state = 83},
  [669] = {.lex_state = 83},
  [670] = {.lex_state = 83},
  [671] = {.lex_state = 83},
  [672] = {.lex_state = 83},
  [673] = {.lex_state = 83},
  [674] = {.lex_state = 83},
  [675] = {.lex_state = 83},
  [676] = {.lex_state = 83},
  [677] = {.lex_state = 83},
  [678] = {.lex_state = 34},
  [679] = {.lex_state = 83},
  [680] = {.lex_state = 33},
  [681] = {.lex_state = 32},
  [682] = {.lex_state = 83},
  [683] = {.lex_state = 83},
  [684] = {.lex_state = 32},
  [685] = {.lex_state = 32},
  [686] = {.lex_state = 32},
  [687] = {.lex_state = 32},
  [688] = {.lex_state = 34},
  [689] = {.lex_state = 32},
  [690] = {.lex_state = 32},
  [691] = {.lex_state = 32},
  [692] = {.lex_state = 83},
  [693] = {.lex_state = 32},
  [694] = {.lex_state = 32},
  [695] = {.lex_state = 83},
  [696] = {.lex_state = 32},
  [697] = {.lex_state = 32},
  [698] = {.lex_state = 33},
  [699] = {.lex_state = 83},
  [700] = {.lex_state = 83},
  [701] = {.lex_state = 83},
  [702] = {.lex_state = 83},
  [703] = {.lex_state = 32},
  [704] = {.lex_state = 32},
  [705] = {.lex_state = 83},
  [706] = {.lex_state = 83},
  [707] = {.lex_state = 32},
  [708] = {.lex_state = 83},
  [709] = {.lex_state = 83},
  [710] = {.lex_state = 83},
  [711] = {.lex_state = 83},
  [712] = {.lex_state = 32},
  [713] = {.lex_state = 83},
  [714] = {.lex_state = 83},
  [715] = {.lex_state = 34},
  [716] = {.lex_state = 83},
  [717] = {.lex_state = 83},
  [718] = {.lex_state = 32},
  [719] = {.lex_state = 83},
  [720] = {.lex_state = 32},
  [721] = {.lex_state = 83},
  [722] = {.lex_state = 83},
  [723] = {.lex_state = 32},
  [724] = {.lex_state = 33},
  [725] = {.lex_state = 33},
  [726] = {.lex_state = 33},
  [727] = {.lex_state = 33},
  [728] = {.lex_state = 33},
  [729] = {.lex_state = 33},
  [730] = {.lex_state = 33},
  [731] = {.lex_state = 33},
  [732] = {.lex_state = 33},
  [733] = {.lex_state = 33},
  [734] = {.lex_state = 33},
  [735] = {.lex_state = 33},
  [736] = {.lex_state = 33},
  [737] = {.lex_state = 33},
  [738] = {.lex_state = 33},
  [739] = {.lex_state = 33},
  [740] = {.lex_state = 33},
  [741] = {.lex_state = 33},
  [742] = {.lex_state = 33},
  [743] = {.lex_state = 33},
  [744] = {.lex_state = 33},
  [745] = {.lex_state = 33},
  [746] = {.lex_state = 33},
  [747] = {.lex_state = 83},
  [748] = {.lex_state = 32},
  [749] = {.lex_state = 32},
  [750] = {.lex_state = 83},
  [751] = {.lex_state = 83},
  [752] = {.lex_state = 32},
  [753] = {.lex_state = 32},
  [754] = {.lex_state = 32},
  [755] = {.lex_state = 32},
  [756] = {.lex_state = 32},
  [757] = {.lex_state = 32},
  [758] = {.lex_state = 32},
  [759] = {.lex_state = 32},
  [760] = {.lex_state = 32},
  [761] = {.lex_state = 32},
  [762] = {.lex_state = 32},
  [763] = {.lex_state = 32},
  [764] = {.lex_state = 32},
  [765] = {.lex_state = 32},
  [766] = {.lex_state = 32},
  [767] = {.lex_state = 32},
  [768] = {.lex_state = 33},
  [769] = {.lex_state = 32},
  [770] = {.lex_state = 32},
  [771] = {.lex_state = 32},
  [772] = {.lex_state = 32},
  [773] = {.lex_state = 32},
  [774] = {.lex_state = 32},
  [775] = {.lex_state = 32},
  [776] = {.lex_state = 33},
  [777] = {.lex_state = 83},
  [778] = {.lex_state = 32},
  [779] = {.lex_state = 32},
  [780] = {.lex_state = 32},
  [781] = {.lex_state = 83},
  [782] = {.lex_state = 32},
  [783] = {.lex_state = 32},
  [784] = {.lex_state = 32},
  [785] = {.lex_state = 33},
  [786] = {.lex_state = 32},
  [787] = {.lex_state = 32},
  [788] = {.lex_state = 32},
  [789] = {.lex_state = 32},
  [790] = {.lex_state = 32},
  [791] = {.lex_state = 32},
  [792] = {.lex_state = 33},
  [793] = {.lex_state = 32},
  [794] = {.lex_state = 32},
  [795] = {.lex_state = 32},
  [796] = {.lex_state = 32},
  [797] = {.lex_state = 32},
  [798] = {.lex_state = 32},
  [799] = {.lex_state = 32},
  [800] = {.lex_state = 32},
  [801] = {.lex_state = 32},
  [802] = {.lex_state = 32},
  [803] = {.lex_state = 32},
  [804] = {.lex_state = 32},
  [805] = {.lex_state = 32},
  [806] = {.lex_state = 32},
  [807] = {.lex_state = 32},
  [808] = {.lex_state = 32},
  [809] = {.lex_state = 32},
  [810] = {.lex_state = 32},
  [811] = {.lex_state = 32},
  [812] = {.lex_state = 32},
  [813] = {.lex_state = 32},
  [814] = {.lex_state = 32},
  [815] = {.lex_state = 32},
  [816] = {.lex_state = 32},
  [817] = {.lex_state = 32},
  [818] = {.lex_state = 32},
  [819] = {.lex_state = 32},
  [820] = {.lex_state = 32},
  [821] = {.lex_state = 32},
  [822] = {.lex_state = 32},
  [823] = {.lex_state = 32},
  [824] = {.lex_state = 32},
  [825] = {.lex_state = 32},
  [826] = {.lex_state = 32},
  [827] = {.lex_state = 32},
  [828] = {.lex_state = 32},
  [829] = {.lex_state = 32},
  [830] = {.lex_state = 32},
  [831] = {.lex_state = 32},
  [832] = {.lex_state = 32},
  [833] = {.lex_state = 32},
  [834] = {.lex_state = 32},
  [835] = {.lex_state = 32},
  [836] = {.lex_state = 32},
  [837] = {.lex_state = 32},
  [838] = {.lex_state = 32},
  [839] = {.lex_state = 32},
  [840] = {.lex_state = 32},
  [841] = {.lex_state = 32},
  [842] = {.lex_state = 32},
  [843] = {.lex_state = 32},
  [844] = {.lex_state = 32},
  [845] = {.lex_state = 32},
  [846] = {.lex_state = 32},
  [847] = {.lex_state = 32},
  [848] = {.lex_state = 32},
  [849] = {.lex_state = 32},
  [850] = {.lex_state = 32},
  [851] = {.lex_state = 32},
  [852] = {.lex_state = 32},
  [853] = {.lex_state = 32},
  [854] = {.lex_state = 32},
  [855] = {.lex_state = 32},
  [856] = {.lex_state = 32},
  [857] = {.lex_state = 32},
  [858] = {.lex_state = 32},
  [859] = {.lex_state = 32},
  [860] = {.lex_state = 32},
  [861] = {.lex_state = 32},
  [862] = {.lex_state = 32},
  [863] = {.lex_state = 32},
  [864] = {.lex_state = 32},
  [865] = {.lex_state = 32},
  [866] = {.lex_state = 32},
  [867] = {.lex_state = 32},
  [868] = {.lex_state = 32},
  [869] = {.lex_state = 32},
  [870] = {.lex_state = 32},
  [871] = {.lex_state = 32},
  [872] = {.lex_state = 32},
  [873] = {.lex_state = 32},
  [874] = {.lex_state = 32},
  [875] = {.lex_state = 32},
  [876] = {.lex_state = 32},
  [877] = {.lex_state = 32},
  [878] = {.lex_state = 32},
  [879] = {.lex_state = 33},
  [880] = {.lex_state = 32},
  [881] = {.lex_state = 32},
  [882] = {.lex_state = 32},
  [883] = {.lex_state = 32},
  [884] = {.lex_state = 32},
  [885] = {.lex_state = 32},
  [886] = {.lex_state = 33},
  [887] = {.lex_state = 33},
  [888] = {.lex_state = 33},
  [889] = {.lex_state = 33},
  [890] = {.lex_state = 33},
  [891] = {.lex_state = 33},
  [892] = {.lex_state = 33},
  [893] = {.lex_state = 33},
  [894] = {.lex_state = 33},
  [895] = {.lex_state = 33},
  [896] = {.lex_state = 33},
  [897] = {.lex_state = 33},
  [898] = {.lex_state = 33},
  [899] = {.lex_state = 17},
  [900] = {.lex_state = 30},
  [901] = {.lex_state = 30},
  [902] = {.lex_state = 33},
  [903] = {.lex_state = 33},
  [904] = {.lex_state = 30},
  [905] = {.lex_state = 33},
  [906] = {.lex_state = 33},
  [907] = {.lex_state = 30},
  [908] = {.lex_state = 30},
  [909] = {.lex_state = 33},
  [910] = {.lex_state = 33},
  [911] = {.lex_state = 30},
  [912] = {.lex_state = 30},
  [913] = {.lex_state = 30},
  [914] = {.lex_state = 33},
  [915] = {.lex_state = 33},
  [916] = {.lex_state = 30},
  [917] = {.lex_state = 30},
  [918] = {.lex_state = 33},
  [919] = {.lex_state = 30},
  [920] = {.lex_state = 33},
  [921] = {.lex_state = 30},
  [922] = {.lex_state = 33},
  [923] = {.lex_state = 33},
  [924] = {.lex_state = 33},
  [925] = {.lex_state = 33},
  [926] = {.lex_state = 30},
  [927] = {.lex_state = 30},
  [928] = {.lex_state = 33},
  [929] = {.lex_state = 30},
  [930] = {.lex_state = 30},
  [931] = {.lex_state = 30},
  [932] = {.lex_state = 30},
  [933] = {.lex_state = 30},
  [934] = {.lex_state = 30},
  [935] = {.lex_state = 30},
  [936] = {.lex_state = 30},
  [937] = {.lex_state = 33},
  [938] = {.lex_state = 33},
  [939] = {.lex_state = 30},
  [940] = {.lex_state = 30},
  [941] = {.lex_state = 30},
  [942] = {.lex_state = 30},
  [943] = {.lex_state = 33},
  [944] = {.lex_state = 30},
  [945] = {.lex_state = 33},
  [946] = {.lex_state = 33},
  [947] = {.lex_state = 30},
  [948] = {.lex_state = 30},
  [949] = {.lex_state = 30},
  [950] = {.lex_state = 30},
  [951] = {.lex_state = 33},
  [952] = {.lex_state = 33},
  [953] = {.lex_state = 30},
  [954] = {.lex_state = 30},
  [955] = {.lex_state = 33},
  [956] = {.lex_state = 30},
  [957] = {.lex_state = 30},
  [958] = {.lex_state = 30},
  [959] = {.lex_state = 33},
  [960] = {.lex_state = 17},
  [961] = {.lex_state = 17},
  [962] = {.lex_state = 17},
  [963] = {.lex_state = 17},
  [964] = {.lex_state = 17},
  [965] = {.lex_state = 17},
  [966] = {.lex_state = 17},
  [967] = {.lex_state = 17},
  [968] = {.lex_state = 17},
  [969] = {.lex_state = 17},
  [970] = {.lex_state = 17},
  [971] = {.lex_state = 17},
  [972] = {.lex_state = 17},
  [973] = {.lex_state = 17},
  [974] = {.lex_state = 17},
  [975] = {.lex_state = 17},
  [976] = {.lex_state = 17},
  [977] = {.lex_state = 17},
  [978] = {.lex_state = 17},
  [979] = {.lex_state = 33},
  [980] = {.lex_state = 17},
  [981] = {.lex_state = 17},
  [982] = {.lex_state = 17},
  [983] = {.lex_state = 17},
  [984] = {.lex_state = 17},
  [985] = {.lex_state = 17},
  [986] = {.lex_state = 17},
  [987] = {.lex_state = 17},
  [988] = {.lex_state = 17},
  [989] = {.lex_state = 33},
  [990] = {.lex_state = 33},
  [991] = {.lex_state = 33},
  [992] = {.lex_state = 33},
  [993] = {.lex_state = 33},
  [994] = {.lex_state = 33},
  [995] = {.lex_state = 33},
  [996] = {.lex_state = 33},
  [997] = {.lex_state = 33},
  [998] = {.lex_state = 33},
  [999] = {.lex_state = 33},
  [1000] = {.lex_state = 33},
  [1001] = {.lex_state = 33},
  [1002] = {.lex_state = 33},
  [1003] = {.lex_state = 33},
  [1004] = {.lex_state = 33},
  [1005] = {.lex_state = 33},
  [1006] = {.lex_state = 33},
  [1007] = {.lex_state = 33},
  [1008] = {.lex_state = 33},
  [1009] = {.lex_state = 33},
  [1010] = {.lex_state = 33},
  [1011] = {.lex_state = 33},
  [1012] = {.lex_state = 33},
  [1013] = {.lex_state = 83},
  [1014] = {.lex_state = 33},
  [1015] = {.lex_state = 83},
  [1016] = {.lex_state = 33},
  [1017] = {.lex_state = 83},
  [1018] = {.lex_state = 33},
  [1019] = {.lex_state = 83},
  [1020] = {.lex_state = 33},
  [1021] = {.lex_state = 33},
  [1022] = {.lex_state = 33},
  [1023] = {.lex_state = 83},
  [1024] = {.lex_state = 83},
  [1025] = {.lex_state = 33},
  [1026] = {.lex_state = 33},
  [1027] = {.lex_state = 83},
  [1028] = {.lex_state = 33},
  [1029] = {.lex_state = 33},
  [1030] = {.lex_state = 33},
  [1031] = {.lex_state = 33},
  [1032] = {.lex_state = 33},
  [1033] = {.lex_state = 33},
  [1034] = {.lex_state = 33},
  [1035] = {.lex_state = 83},
  [1036] = {.lex_state = 33},
  [1037] = {.lex_state = 33},
  [1038] = {.lex_state = 33},
  [1039] = {.lex_state = 83},
  [1040] = {.lex_state = 33},
  [1041] = {.lex_state = 33},
  [1042] = {.lex_state = 33},
  [1043] = {.lex_state = 33},
  [1044] = {.lex_state = 83},
  [1045] = {.lex_state = 33},
  [1046] = {.lex_state = 33},
  [1047] = {.lex_state = 33},
  [1048] = {.lex_state = 83},
  [1049] = {.lex_state = 33},
  [1050] = {.lex_state = 83},
  [1051] = {.lex_state = 33},
  [1052] = {.lex_state = 33},
  [1053] = {.lex_state = 33},
  [1054] = {.lex_state = 33},
  [1055] = {.lex_state = 33},
  [1056] = {.lex_state = 83},
  [1057] = {.lex_state = 83},
  [1058] = {.lex_state = 83},
  [1059] = {.lex_state = 83},
  [1060] = {.lex_state = 83},
  [1061] = {.lex_state = 83},
  [1062] = {.lex_state = 33},
  [1063] = {.lex_state = 83},
  [1064] = {.lex_state = 33},
  [1065] = {.lex_state = 33},
  [1066] = {.lex_state = 83},
  [1067] = {.lex_state = 83},
  [1068] = {.lex_state = 33},
  [1069] = {.lex_state = 33},
  [1070] = {.lex_state = 33},
  [1071] = {.lex_state = 33},
  [1072] = {.lex_state = 83},
  [1073] = {.lex_state = 83},
  [1074] = {.lex_state = 83},
  [1075] = {.lex_state = 83},
  [1076] = {.lex_state = 33},
  [1077] = {.lex_state = 33},
  [1078] = {.lex_state = 33},
  [1079] = {.lex_state = 33},
  [1080] = {.lex_state = 35},
  [1081] = {.lex_state = 33},
  [1082] = {.lex_state = 33},
  [1083] = {.lex_state = 33},
  [1084] = {.lex_state = 35},
  [1085] = {.lex_state = 35},
  [1086] = {.lex_state = 83},
  [1087] = {.lex_state = 83},
  [1088] = {.lex_state = 33},
  [1089] = {.lex_state = 83},
  [1090] = {.lex_state = 33},
  [1091] = {.lex_state = 33},
  [1092] = {.lex_state = 33},
  [1093] = {.lex_state = 83},
  [1094] = {.lex_state = 83},
  [1095] = {.lex_state = 83},
  [1096] = {.lex_state = 35},
  [1097] = {.lex_state = 83},
  [1098] = {.lex_state = 33},
  [1099] = {.lex_state = 83},
  [1100] = {.lex_state = 83},
  [1101] = {.lex_state = 33},
  [1102] = {.lex_state = 33},
  [1103] = {.lex_state = 33},
  [1104] = {.lex_state = 33},
  [1105] = {.lex_state = 33},
  [1106] = {.lex_state = 83},
  [1107] = {.lex_state = 33},
  [1108] = {.lex_state = 33},
  [1109] = {.lex_state = 83},
  [1110] = {.lex_state = 83},
  [1111] = {.lex_state = 83},
  [1112] = {.lex_state = 83},
  [1113] = {.lex_state = 83},
  [1114] = {.lex_state = 83},
  [1115] = {.lex_state = 83},
  [1116] = {.lex_state = 83},
  [1117] = {.lex_state = 83},
  [1118] = {.lex_state = 83},
  [1119] = {.lex_state = 83},
  [1120] = {.lex_state = 83},
  [1121] = {.lex_state = 83},
  [1122] = {.lex_state = 83},
  [1123] = {.lex_state = 83},
  [1124] = {.lex_state = 83},
  [1125] = {.lex_state = 83},
  [1126] = {.lex_state = 83},
  [1127] = {.lex_state = 83},
  [1128] = {.lex_state = 83},
  [1129] = {.lex_state = 83},
  [1130] = {.lex_state = 83},
  [1131] = {.lex_state = 83},
  [1132] = {.lex_state = 83},
  [1133] = {.lex_state = 83},
  [1134] = {.lex_state = 83},
  [1135] = {.lex_state = 83},
  [1136] = {.lex_state = 83},
  [1137] = {.lex_state = 83},
  [1138] = {.lex_state = 83},
  [1139] = {.lex_state = 83},
  [1140] = {.lex_state = 83},
  [1141] = {.lex_state = 83},
  [1142] = {.lex_state = 83},
  [1143] = {.lex_state = 83},
  [1144] = {.lex_state = 33},
  [1145] = {.lex_state = 28},
  [1146] = {.lex_state = 83},
  [1147] = {.lex_state = 33},
  [1148] = {.lex_state = 83},
  [1149] = {.lex_state = 83},
  [1150] = {.lex_state = 83},
  [1151] = {.lex_state = 83},
  [1152] = {.lex_state = 83},
  [1153] = {.lex_state = 33},
  [1154] = {.lex_state = 33},
  [1155] = {.lex_state = 83},
  [1156] = {.lex_state = 83},
  [1157] = {.lex_state = 83},
  [1158] = {.lex_state = 83},
  [1159] = {.lex_state = 83},
  [1160] = {.lex_state = 83},
  [1161] = {.lex_state = 83},
  [1162] = {.lex_state = 83},
  [1163] = {.lex_state = 83},
  [1164] = {.lex_state = 22},
  [1165] = {.lex_state = 24},
  [1166] = {.lex_state = 83},
  [1167] = {.lex_state = 24},
  [1168] = {.lex_state = 83},
  [1169] = {.lex_state = 83},
  [1170] = {.lex_state = 22},
  [1171] = {.lex_state = 22},
  [1172] = {.lex_state = 83},
  [1173] = {.lex_state = 33},
  [1174] = {.lex_state = 83},
  [1175] = {.lex_state = 24},
  [1176] = {.lex_state = 83},
  [1177] = {.lex_state = 83},
  [1178] = {.lex_state = 22},
  [1179] = {.lex_state = 83},
  [1180] = {.lex_state = 22},
  [1181] = {.lex_state = 28},
  [1182] = {.lex_state = 33},
  [1183] = {.lex_state = 24},
  [1184] = {.lex_state = 24},
  [1185] = {.lex_state = 22},
  [1186] = {.lex_state = 83},
  [1187] = {.lex_state = 24},
  [1188] = {.lex_state = 24},
  [1189] = {.lex_state = 22},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 33},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 17},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 28},
  [1208] = {.lex_state = 28},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 33},
  [1213] = {.lex_state = 33},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 17},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 33},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 28},
  [1220] = {.lex_state = 33},
  [1221] = {.lex_state = 33},
  [1222] = {.lex_state = 33},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 28},
  [1225] = {.lex_state = 83},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 28},
  [1231] = {.lex_state = 28},
  [1232] = {.lex_state = 28},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 17},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 33},
  [1239] = {.lex_state = 17},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 33},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 83},
  [1254] = {.lex_state = 33},
  [1255] = {.lex_state = 33},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 33},
  [1258] = {.lex_state = 23},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 83},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 83},
  [1264] = {.lex_state = 28},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 26},
  [1268] = {.lex_state = 83},
  [1269] = {.lex_state = 83},
  [1270] = {.lex_state = 23},
  [1271] = {.lex_state = 33},
  [1272] = {.lex_state = 23},
  [1273] = {.lex_state = 83},
  [1274] = {.lex_state = 83},
  [1275] = {.lex_state = 23},
  [1276] = {.lex_state = 83},
  [1277] = {.lex_state = 83},
  [1278] = {.lex_state = 33},
  [1279] = {.lex_state = 23},
  [1280] = {.lex_state = 33},
  [1281] = {.lex_state = 83},
  [1282] = {.lex_state = 83},
  [1283] = {.lex_state = 28},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 23},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 23},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 23},
  [1290] = {.lex_state = 83},
  [1291] = {.lex_state = 83},
  [1292] = {.lex_state = 23},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 28},
  [1295] = {.lex_state = 33},
  [1296] = {.lex_state = 26},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 83},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 83},
  [1302] = {.lex_state = 26},
  [1303] = {.lex_state = 23},
  [1304] = {.lex_state = 33},
  [1305] = {.lex_state = 33},
  [1306] = {.lex_state = 83},
  [1307] = {.lex_state = 83},
  [1308] = {.lex_state = 23},
  [1309] = {.lex_state = 33},
  [1310] = {.lex_state = 23},
  [1311] = {.lex_state = 83},
  [1312] = {.lex_state = 23},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 83},
  [1315] = {.lex_state = 23},
  [1316] = {.lex_state = 23},
  [1317] = {.lex_state = 23},
  [1318] = {.lex_state = 23},
  [1319] = {.lex_state = 27},
  [1320] = {.lex_state = 27},
  [1321] = {.lex_state = 27},
  [1322] = {.lex_state = 27},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 17},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 27},
  [1328] = {.lex_state = 17},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 27},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 0},
  [1335] = {.lex_state = 33},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 17},
  [1339] = {.lex_state = 27},
  [1340] = {.lex_state = 17},
  [1341] = {.lex_state = 17},
  [1342] = {.lex_state = 27},
  [1343] = {.lex_state = 17},
  [1344] = {.lex_state = 17},
  [1345] = {.lex_state = 0},
  [1346] = {.lex_state = 17},
  [1347] = {.lex_state = 17},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 17},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 27},
  [1352] = {.lex_state = 17},
  [1353] = {.lex_state = 17},
  [1354] = {.lex_state = 0},
  [1355] = {.lex_state = 17},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 33},
  [1358] = {.lex_state = 33},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 83},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 17},
  [1364] = {.lex_state = 33},
  [1365] = {.lex_state = 27},
  [1366] = {.lex_state = 0},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 27},
  [1369] = {.lex_state = 0},
  [1370] = {.lex_state = 27},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 27},
  [1373] = {.lex_state = 33},
  [1374] = {.lex_state = 27},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 0},
  [1377] = {.lex_state = 0},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 27},
  [1380] = {.lex_state = 0},
  [1381] = {.lex_state = 27},
  [1382] = {.lex_state = 0},
  [1383] = {.lex_state = 0},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 0},
  [1386] = {.lex_state = 27},
  [1387] = {.lex_state = 33},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 33},
  [1390] = {.lex_state = 27},
  [1391] = {.lex_state = 17},
  [1392] = {.lex_state = 33},
  [1393] = {.lex_state = 0},
  [1394] = {.lex_state = 0},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 0},
  [1400] = {.lex_state = 0},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 27},
  [1403] = {.lex_state = 33},
  [1404] = {.lex_state = 27},
  [1405] = {.lex_state = 0},
  [1406] = {.lex_state = 17},
  [1407] = {.lex_state = 27},
  [1408] = {.lex_state = 0},
  [1409] = {.lex_state = 0},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 0},
  [1412] = {.lex_state = 33},
  [1413] = {.lex_state = 0},
  [1414] = {.lex_state = 0},
  [1415] = {.lex_state = 0},
  [1416] = {.lex_state = 0},
  [1417] = {.lex_state = 0},
  [1418] = {.lex_state = 0},
  [1419] = {.lex_state = 17},
  [1420] = {.lex_state = 17},
  [1421] = {.lex_state = 33},
  [1422] = {.lex_state = 33},
  [1423] = {.lex_state = 0},
  [1424] = {.lex_state = 0},
  [1425] = {.lex_state = 0},
  [1426] = {.lex_state = 33},
  [1427] = {.lex_state = 17},
  [1428] = {.lex_state = 33},
  [1429] = {.lex_state = 83},
  [1430] = {.lex_state = 27},
  [1431] = {.lex_state = 0},
  [1432] = {.lex_state = 27},
  [1433] = {.lex_state = 0},
  [1434] = {.lex_state = 0},
  [1435] = {.lex_state = 33},
  [1436] = {.lex_state = 0},
  [1437] = {.lex_state = 33},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 0},
  [1440] = {.lex_state = 0},
  [1441] = {.lex_state = 27},
  [1442] = {.lex_state = 0},
  [1443] = {.lex_state = 0},
  [1444] = {.lex_state = 27},
  [1445] = {.lex_state = 0},
  [1446] = {.lex_state = 17},
  [1447] = {.lex_state = 27},
  [1448] = {.lex_state = 0},
  [1449] = {.lex_state = 0},
  [1450] = {.lex_state = 33},
  [1451] = {.lex_state = 33},
  [1452] = {.lex_state = 0},
  [1453] = {.lex_state = 0},
  [1454] = {.lex_state = 27},
  [1455] = {.lex_state = 33},
  [1456] = {.lex_state = 27},
  [1457] = {.lex_state = 0},
  [1458] = {.lex_state = 0},
  [1459] = {.lex_state = 27},
  [1460] = {.lex_state = 27},
  [1461] = {.lex_state = 0},
  [1462] = {.lex_state = 17},
  [1463] = {.lex_state = 0},
  [1464] = {.lex_state = 17},
  [1465] = {.lex_state = 0},
  [1466] = {.lex_state = 0},
  [1467] = {.lex_state = 0},
  [1468] = {.lex_state = 0},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 0},
  [1471] = {.lex_state = 33},
  [1472] = {.lex_state = 33},
  [1473] = {.lex_state = 33},
  [1474] = {.lex_state = 0},
  [1475] = {.lex_state = 0},
  [1476] = {.lex_state = 0},
  [1477] = {.lex_state = 0},
  [1478] = {.lex_state = 27},
  [1479] = {.lex_state = 33},
  [1480] = {.lex_state = 0},
  [1481] = {.lex_state = 17},
  [1482] = {.lex_state = 0},
  [1483] = {.lex_state = 0},
  [1484] = {.lex_state = 33},
  [1485] = {.lex_state = 83},
  [1486] = {.lex_state = 0},
  [1487] = {.lex_state = 0},
  [1488] = {.lex_state = 0},
  [1489] = {.lex_state = 0},
  [1490] = {.lex_state = 0},
  [1491] = {.lex_state = 0},
  [1492] = {.lex_state = 83},
  [1493] = {.lex_state = 0},
  [1494] = {.lex_state = 17},
  [1495] = {.lex_state = 33},
  [1496] = {.lex_state = 17},
  [1497] = {.lex_state = 0},
  [1498] = {.lex_state = 17},
  [1499] = {.lex_state = 0},
  [1500] = {.lex_state = 0},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 0},
  [1503] = {.lex_state = 83},
  [1504] = {.lex_state = 33},
  [1505] = {.lex_state = 83},
  [1506] = {.lex_state = 17},
  [1507] = {.lex_state = 0},
  [1508] = {.lex_state = 83},
  [1509] = {.lex_state = 0},
  [1510] = {.lex_state = 83},
  [1511] = {.lex_state = 33},
  [1512] = {.lex_state = 27},
  [1513] = {.lex_state = 83},
  [1514] = {.lex_state = 33},
  [1515] = {.lex_state = 83},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_kernel] = ACTIONS(1),
    [anon_sym___kernel] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym___global] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym___local] = ACTIONS(1),
    [anon_sym_constant] = ACTIONS(1),
    [anon_sym___constant] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym___private] = ACTIONS(1),
    [anon_sym_generic] = ACTIONS(1),
    [anon_sym___generic] = ACTIONS(1),
    [anon_sym_read_only] = ACTIONS(1),
    [anon_sym___read_only] = ACTIONS(1),
    [anon_sym_write_only] = ACTIONS(1),
    [anon_sym___write_only] = ACTIONS(1),
    [anon_sym_read_write] = ACTIONS(1),
    [anon_sym___read_write] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_auto] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym_pipe] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_uchar] = ACTIONS(1),
    [anon_sym_ushort] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_uint] = ACTIONS(1),
    [anon_sym_ulong] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_half] = ACTIONS(1),
    [anon_sym_size_t] = ACTIONS(1),
    [anon_sym_ptrdiff_t] = ACTIONS(1),
    [anon_sym_intptr_t] = ACTIONS(1),
    [anon_sym_uintptr_t] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [sym_vector_type] = ACTIONS(1),
    [anon_sym_image2d_t] = ACTIONS(1),
    [anon_sym_image3d_t] = ACTIONS(1),
    [anon_sym_image2d_array_t] = ACTIONS(1),
    [anon_sym_image1d_t] = ACTIONS(1),
    [anon_sym_image1d_buffer_t] = ACTIONS(1),
    [anon_sym_image1d_array_t] = ACTIONS(1),
    [anon_sym_image2d_depth_t] = ACTIONS(1),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1),
    [anon_sym_sampler_t] = ACTIONS(1),
    [anon_sym_queue_t] = ACTIONS(1),
    [anon_sym_ndrange_t] = ACTIONS(1),
    [anon_sym_clk_event_t] = ACTIONS(1),
    [anon_sym_reserve_id_t] = ACTIONS(1),
    [anon_sym_event_t] = ACTIONS(1),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_translation_unit] = STATE(1476),
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1022),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(338),
    [sym_compound_statement] = STATE(31),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(546),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(31),
    [sym_labeled_statement] = STATE(31),
    [sym_expression_statement] = STATE(31),
    [sym_if_statement] = STATE(31),
    [sym_switch_statement] = STATE(31),
    [sym_case_statement] = STATE(31),
    [sym_while_statement] = STATE(31),
    [sym_do_statement] = STATE(31),
    [sym_for_statement] = STATE(31),
    [sym_return_statement] = STATE(31),
    [sym_break_statement] = STATE(31),
    [sym_continue_statement] = STATE(31),
    [sym_goto_statement] = STATE(31),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(31),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(31),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(37),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_preproc_include] = STATE(11),
    [sym_preproc_def] = STATE(11),
    [sym_preproc_function_def] = STATE(11),
    [sym_preproc_call] = STATE(11),
    [sym_preproc_if] = STATE(11),
    [sym_preproc_ifdef] = STATE(11),
    [sym_preproc_else] = STATE(1327),
    [sym_preproc_elif] = STATE(1327),
    [sym_function_definition] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_type_definition] = STATE(11),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(11),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(11),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_case_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_goto_statement] = STATE(11),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(11),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(11),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(109),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1459),
    [sym_preproc_elif] = STATE(1459),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(149),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1381),
    [sym_preproc_elif] = STATE(1381),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(151),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_preproc_include] = STATE(13),
    [sym_preproc_def] = STATE(13),
    [sym_preproc_function_def] = STATE(13),
    [sym_preproc_call] = STATE(13),
    [sym_preproc_if] = STATE(13),
    [sym_preproc_ifdef] = STATE(13),
    [sym_preproc_else] = STATE(1512),
    [sym_preproc_elif] = STATE(1512),
    [sym_function_definition] = STATE(13),
    [sym_declaration] = STATE(13),
    [sym_type_definition] = STATE(13),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(13),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(13),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_case_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_goto_statement] = STATE(13),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(13),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(13),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(153),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1320),
    [sym_preproc_elif] = STATE(1320),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(155),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1339),
    [sym_preproc_elif] = STATE(1339),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(157),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_preproc_include] = STATE(6),
    [sym_preproc_def] = STATE(6),
    [sym_preproc_function_def] = STATE(6),
    [sym_preproc_call] = STATE(6),
    [sym_preproc_if] = STATE(6),
    [sym_preproc_ifdef] = STATE(6),
    [sym_preproc_else] = STATE(1331),
    [sym_preproc_elif] = STATE(1331),
    [sym_function_definition] = STATE(6),
    [sym_declaration] = STATE(6),
    [sym_type_definition] = STATE(6),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(6),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(6),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_case_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_goto_statement] = STATE(6),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(6),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(6),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_preproc_include] = STATE(15),
    [sym_preproc_def] = STATE(15),
    [sym_preproc_function_def] = STATE(15),
    [sym_preproc_call] = STATE(15),
    [sym_preproc_if] = STATE(15),
    [sym_preproc_ifdef] = STATE(15),
    [sym_preproc_else] = STATE(1460),
    [sym_preproc_elif] = STATE(1460),
    [sym_function_definition] = STATE(15),
    [sym_declaration] = STATE(15),
    [sym_type_definition] = STATE(15),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(15),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(15),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_case_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_goto_statement] = STATE(15),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(15),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(15),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(161),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_preproc_include] = STATE(7),
    [sym_preproc_def] = STATE(7),
    [sym_preproc_function_def] = STATE(7),
    [sym_preproc_call] = STATE(7),
    [sym_preproc_if] = STATE(7),
    [sym_preproc_ifdef] = STATE(7),
    [sym_preproc_else] = STATE(1342),
    [sym_preproc_elif] = STATE(1342),
    [sym_function_definition] = STATE(7),
    [sym_declaration] = STATE(7),
    [sym_type_definition] = STATE(7),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(7),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(7),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_case_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_goto_statement] = STATE(7),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(7),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(7),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1368),
    [sym_preproc_elif] = STATE(1368),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(165),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1365),
    [sym_preproc_elif] = STATE(1365),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1447),
    [sym_preproc_elif] = STATE(1447),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(1404),
    [sym_preproc_elif] = STATE(1404),
    [sym_function_definition] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(16),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_case_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_goto_statement] = STATE(16),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(16),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1456),
    [sym_preproc_elif] = STATE(1456),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(1386),
    [sym_preproc_elif] = STATE(1386),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(175),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_preproc_include] = STATE(12),
    [sym_preproc_def] = STATE(12),
    [sym_preproc_function_def] = STATE(12),
    [sym_preproc_call] = STATE(12),
    [sym_preproc_if] = STATE(12),
    [sym_preproc_ifdef] = STATE(12),
    [sym_preproc_else] = STATE(1321),
    [sym_preproc_elif] = STATE(1321),
    [sym_function_definition] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_type_definition] = STATE(12),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(12),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(12),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_case_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_goto_statement] = STATE(12),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(12),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(12),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_preproc_include] = STATE(4),
    [sym_preproc_def] = STATE(4),
    [sym_preproc_function_def] = STATE(4),
    [sym_preproc_call] = STATE(4),
    [sym_preproc_if] = STATE(4),
    [sym_preproc_ifdef] = STATE(4),
    [sym_preproc_else] = STATE(1390),
    [sym_preproc_elif] = STATE(1390),
    [sym_function_definition] = STATE(4),
    [sym_declaration] = STATE(4),
    [sym_type_definition] = STATE(4),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(4),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(4),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(4),
    [sym_labeled_statement] = STATE(4),
    [sym_expression_statement] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_switch_statement] = STATE(4),
    [sym_case_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_do_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_break_statement] = STATE(4),
    [sym_continue_statement] = STATE(4),
    [sym_goto_statement] = STATE(4),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(4),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(4),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_preproc_include] = STATE(3),
    [sym_preproc_def] = STATE(3),
    [sym_preproc_function_def] = STATE(3),
    [sym_preproc_call] = STATE(3),
    [sym_preproc_if] = STATE(3),
    [sym_preproc_ifdef] = STATE(3),
    [sym_preproc_else] = STATE(1478),
    [sym_preproc_elif] = STATE(1478),
    [sym_function_definition] = STATE(3),
    [sym_declaration] = STATE(3),
    [sym_type_definition] = STATE(3),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(3),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(3),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(3),
    [sym_labeled_statement] = STATE(3),
    [sym_expression_statement] = STATE(3),
    [sym_if_statement] = STATE(3),
    [sym_switch_statement] = STATE(3),
    [sym_case_statement] = STATE(3),
    [sym_while_statement] = STATE(3),
    [sym_do_statement] = STATE(3),
    [sym_for_statement] = STATE(3),
    [sym_return_statement] = STATE(3),
    [sym_break_statement] = STATE(3),
    [sym_continue_statement] = STATE(3),
    [sym_goto_statement] = STATE(3),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(3),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(3),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(101),
    [aux_sym_preproc_include_token1] = ACTIONS(103),
    [aux_sym_preproc_def_token1] = ACTIONS(105),
    [aux_sym_preproc_if_token1] = ACTIONS(107),
    [aux_sym_preproc_if_token2] = ACTIONS(181),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(111),
    [aux_sym_preproc_else_token1] = ACTIONS(113),
    [aux_sym_preproc_elif_token1] = ACTIONS(115),
    [sym_preproc_directive] = ACTIONS(117),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(123),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_compound_statement] = STATE(20),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(549),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_case_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_goto_statement] = STATE(20),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(20),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(183),
    [aux_sym_preproc_include_token1] = ACTIONS(186),
    [aux_sym_preproc_def_token1] = ACTIONS(189),
    [aux_sym_preproc_if_token1] = ACTIONS(192),
    [aux_sym_preproc_if_token2] = ACTIONS(195),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(197),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(197),
    [aux_sym_preproc_else_token1] = ACTIONS(195),
    [aux_sym_preproc_elif_token1] = ACTIONS(195),
    [sym_preproc_directive] = ACTIONS(200),
    [anon_sym_LPAREN2] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(206),
    [anon_sym_TILDE] = ACTIONS(206),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_STAR] = ACTIONS(212),
    [anon_sym_AMP] = ACTIONS(212),
    [anon_sym_SEMI] = ACTIONS(215),
    [anon_sym_typedef] = ACTIONS(218),
    [anon_sym_kernel] = ACTIONS(221),
    [anon_sym___kernel] = ACTIONS(221),
    [anon_sym_global] = ACTIONS(224),
    [anon_sym___global] = ACTIONS(224),
    [anon_sym_local] = ACTIONS(224),
    [anon_sym___local] = ACTIONS(224),
    [anon_sym_constant] = ACTIONS(224),
    [anon_sym___constant] = ACTIONS(224),
    [anon_sym_private] = ACTIONS(224),
    [anon_sym___private] = ACTIONS(224),
    [anon_sym_generic] = ACTIONS(224),
    [anon_sym___generic] = ACTIONS(224),
    [anon_sym_read_only] = ACTIONS(227),
    [anon_sym___read_only] = ACTIONS(227),
    [anon_sym_write_only] = ACTIONS(227),
    [anon_sym___write_only] = ACTIONS(227),
    [anon_sym_read_write] = ACTIONS(227),
    [anon_sym___read_write] = ACTIONS(227),
    [anon_sym_extern] = ACTIONS(230),
    [anon_sym___attribute__] = ACTIONS(233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(236),
    [anon_sym___declspec] = ACTIONS(239),
    [anon_sym___cdecl] = ACTIONS(242),
    [anon_sym___clrcall] = ACTIONS(242),
    [anon_sym___stdcall] = ACTIONS(242),
    [anon_sym___fastcall] = ACTIONS(242),
    [anon_sym___thiscall] = ACTIONS(242),
    [anon_sym___vectorcall] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_auto] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_pipe] = ACTIONS(251),
    [anon_sym_signed] = ACTIONS(254),
    [anon_sym_unsigned] = ACTIONS(254),
    [anon_sym_long] = ACTIONS(254),
    [anon_sym_short] = ACTIONS(254),
    [anon_sym_bool] = ACTIONS(257),
    [anon_sym_char] = ACTIONS(257),
    [anon_sym_uchar] = ACTIONS(257),
    [anon_sym_ushort] = ACTIONS(257),
    [anon_sym_int] = ACTIONS(257),
    [anon_sym_uint] = ACTIONS(257),
    [anon_sym_ulong] = ACTIONS(257),
    [anon_sym_float] = ACTIONS(257),
    [anon_sym_double] = ACTIONS(257),
    [anon_sym_half] = ACTIONS(257),
    [anon_sym_size_t] = ACTIONS(257),
    [anon_sym_ptrdiff_t] = ACTIONS(257),
    [anon_sym_intptr_t] = ACTIONS(257),
    [anon_sym_uintptr_t] = ACTIONS(257),
    [anon_sym_void] = ACTIONS(257),
    [sym_vector_type] = ACTIONS(260),
    [anon_sym_image2d_t] = ACTIONS(263),
    [anon_sym_image3d_t] = ACTIONS(263),
    [anon_sym_image2d_array_t] = ACTIONS(263),
    [anon_sym_image1d_t] = ACTIONS(263),
    [anon_sym_image1d_buffer_t] = ACTIONS(263),
    [anon_sym_image1d_array_t] = ACTIONS(263),
    [anon_sym_image2d_depth_t] = ACTIONS(263),
    [anon_sym_image2d_array_depth_t] = ACTIONS(263),
    [anon_sym_sampler_t] = ACTIONS(263),
    [anon_sym_queue_t] = ACTIONS(263),
    [anon_sym_ndrange_t] = ACTIONS(263),
    [anon_sym_clk_event_t] = ACTIONS(263),
    [anon_sym_reserve_id_t] = ACTIONS(263),
    [anon_sym_event_t] = ACTIONS(263),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(266),
    [anon_sym_struct] = ACTIONS(269),
    [anon_sym_union] = ACTIONS(272),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_switch] = ACTIONS(278),
    [anon_sym_case] = ACTIONS(281),
    [anon_sym_default] = ACTIONS(284),
    [anon_sym_while] = ACTIONS(287),
    [anon_sym_do] = ACTIONS(290),
    [anon_sym_for] = ACTIONS(293),
    [anon_sym_return] = ACTIONS(296),
    [anon_sym_break] = ACTIONS(299),
    [anon_sym_continue] = ACTIONS(302),
    [anon_sym_goto] = ACTIONS(305),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_sizeof] = ACTIONS(311),
    [sym_number_literal] = ACTIONS(314),
    [anon_sym_L_SQUOTE] = ACTIONS(317),
    [anon_sym_u_SQUOTE] = ACTIONS(317),
    [anon_sym_U_SQUOTE] = ACTIONS(317),
    [anon_sym_u8_SQUOTE] = ACTIONS(317),
    [anon_sym_SQUOTE] = ACTIONS(317),
    [anon_sym_L_DQUOTE] = ACTIONS(320),
    [anon_sym_u_DQUOTE] = ACTIONS(320),
    [anon_sym_U_DQUOTE] = ACTIONS(320),
    [anon_sym_u8_DQUOTE] = ACTIONS(320),
    [anon_sym_DQUOTE] = ACTIONS(320),
    [sym_true] = ACTIONS(323),
    [sym_false] = ACTIONS(323),
    [sym_null] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_preproc_include] = STATE(21),
    [sym_preproc_def] = STATE(21),
    [sym_preproc_function_def] = STATE(21),
    [sym_preproc_call] = STATE(21),
    [sym_preproc_if] = STATE(21),
    [sym_preproc_ifdef] = STATE(21),
    [sym_function_definition] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_type_definition] = STATE(21),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1022),
    [sym_linkage_specification] = STATE(21),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(338),
    [sym_compound_statement] = STATE(21),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(546),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_case_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_goto_statement] = STATE(21),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(21),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(21),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(326),
    [sym_identifier] = ACTIONS(328),
    [aux_sym_preproc_include_token1] = ACTIONS(331),
    [aux_sym_preproc_def_token1] = ACTIONS(334),
    [aux_sym_preproc_if_token1] = ACTIONS(337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(340),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(340),
    [sym_preproc_directive] = ACTIONS(343),
    [anon_sym_LPAREN2] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(206),
    [anon_sym_TILDE] = ACTIONS(206),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_STAR] = ACTIONS(212),
    [anon_sym_AMP] = ACTIONS(212),
    [anon_sym_SEMI] = ACTIONS(346),
    [anon_sym_typedef] = ACTIONS(349),
    [anon_sym_kernel] = ACTIONS(221),
    [anon_sym___kernel] = ACTIONS(221),
    [anon_sym_global] = ACTIONS(224),
    [anon_sym___global] = ACTIONS(224),
    [anon_sym_local] = ACTIONS(224),
    [anon_sym___local] = ACTIONS(224),
    [anon_sym_constant] = ACTIONS(224),
    [anon_sym___constant] = ACTIONS(224),
    [anon_sym_private] = ACTIONS(224),
    [anon_sym___private] = ACTIONS(224),
    [anon_sym_generic] = ACTIONS(224),
    [anon_sym___generic] = ACTIONS(224),
    [anon_sym_read_only] = ACTIONS(227),
    [anon_sym___read_only] = ACTIONS(227),
    [anon_sym_write_only] = ACTIONS(227),
    [anon_sym___write_only] = ACTIONS(227),
    [anon_sym_read_write] = ACTIONS(227),
    [anon_sym___read_write] = ACTIONS(227),
    [anon_sym_extern] = ACTIONS(352),
    [anon_sym___attribute__] = ACTIONS(233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(236),
    [anon_sym___declspec] = ACTIONS(239),
    [anon_sym___cdecl] = ACTIONS(242),
    [anon_sym___clrcall] = ACTIONS(242),
    [anon_sym___stdcall] = ACTIONS(242),
    [anon_sym___fastcall] = ACTIONS(242),
    [anon_sym___thiscall] = ACTIONS(242),
    [anon_sym___vectorcall] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_auto] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_pipe] = ACTIONS(251),
    [anon_sym_signed] = ACTIONS(254),
    [anon_sym_unsigned] = ACTIONS(254),
    [anon_sym_long] = ACTIONS(254),
    [anon_sym_short] = ACTIONS(254),
    [anon_sym_bool] = ACTIONS(257),
    [anon_sym_char] = ACTIONS(257),
    [anon_sym_uchar] = ACTIONS(257),
    [anon_sym_ushort] = ACTIONS(257),
    [anon_sym_int] = ACTIONS(257),
    [anon_sym_uint] = ACTIONS(257),
    [anon_sym_ulong] = ACTIONS(257),
    [anon_sym_float] = ACTIONS(257),
    [anon_sym_double] = ACTIONS(257),
    [anon_sym_half] = ACTIONS(257),
    [anon_sym_size_t] = ACTIONS(257),
    [anon_sym_ptrdiff_t] = ACTIONS(257),
    [anon_sym_intptr_t] = ACTIONS(257),
    [anon_sym_uintptr_t] = ACTIONS(257),
    [anon_sym_void] = ACTIONS(257),
    [sym_vector_type] = ACTIONS(260),
    [anon_sym_image2d_t] = ACTIONS(263),
    [anon_sym_image3d_t] = ACTIONS(263),
    [anon_sym_image2d_array_t] = ACTIONS(263),
    [anon_sym_image1d_t] = ACTIONS(263),
    [anon_sym_image1d_buffer_t] = ACTIONS(263),
    [anon_sym_image1d_array_t] = ACTIONS(263),
    [anon_sym_image2d_depth_t] = ACTIONS(263),
    [anon_sym_image2d_array_depth_t] = ACTIONS(263),
    [anon_sym_sampler_t] = ACTIONS(263),
    [anon_sym_queue_t] = ACTIONS(263),
    [anon_sym_ndrange_t] = ACTIONS(263),
    [anon_sym_clk_event_t] = ACTIONS(263),
    [anon_sym_reserve_id_t] = ACTIONS(263),
    [anon_sym_event_t] = ACTIONS(263),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(266),
    [anon_sym_struct] = ACTIONS(269),
    [anon_sym_union] = ACTIONS(272),
    [anon_sym_if] = ACTIONS(358),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_case] = ACTIONS(364),
    [anon_sym_default] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(370),
    [anon_sym_do] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(376),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_break] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(385),
    [anon_sym_goto] = ACTIONS(388),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_sizeof] = ACTIONS(311),
    [sym_number_literal] = ACTIONS(314),
    [anon_sym_L_SQUOTE] = ACTIONS(317),
    [anon_sym_u_SQUOTE] = ACTIONS(317),
    [anon_sym_U_SQUOTE] = ACTIONS(317),
    [anon_sym_u8_SQUOTE] = ACTIONS(317),
    [anon_sym_SQUOTE] = ACTIONS(317),
    [anon_sym_L_DQUOTE] = ACTIONS(320),
    [anon_sym_u_DQUOTE] = ACTIONS(320),
    [anon_sym_U_DQUOTE] = ACTIONS(320),
    [anon_sym_u8_DQUOTE] = ACTIONS(320),
    [anon_sym_DQUOTE] = ACTIONS(320),
    [sym_true] = ACTIONS(323),
    [sym_false] = ACTIONS(323),
    [sym_null] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_preproc_include] = STATE(23),
    [sym_preproc_def] = STATE(23),
    [sym_preproc_function_def] = STATE(23),
    [sym_preproc_call] = STATE(23),
    [sym_preproc_if] = STATE(23),
    [sym_preproc_ifdef] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_type_definition] = STATE(23),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1014),
    [sym_linkage_specification] = STATE(23),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(337),
    [sym_compound_statement] = STATE(23),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(548),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_goto_statement] = STATE(23),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(23),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(23),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(391),
    [aux_sym_preproc_include_token1] = ACTIONS(393),
    [aux_sym_preproc_def_token1] = ACTIONS(395),
    [aux_sym_preproc_if_token1] = ACTIONS(397),
    [aux_sym_preproc_if_token2] = ACTIONS(399),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(401),
    [sym_preproc_directive] = ACTIONS(403),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_typedef] = ACTIONS(407),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(409),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1014),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(337),
    [sym_compound_statement] = STATE(24),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(548),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_goto_statement] = STATE(24),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(391),
    [aux_sym_preproc_include_token1] = ACTIONS(393),
    [aux_sym_preproc_def_token1] = ACTIONS(395),
    [aux_sym_preproc_if_token1] = ACTIONS(397),
    [aux_sym_preproc_if_token2] = ACTIONS(435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(401),
    [sym_preproc_directive] = ACTIONS(403),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_typedef] = ACTIONS(407),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(409),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1014),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(337),
    [sym_compound_statement] = STATE(24),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(548),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_case_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_goto_statement] = STATE(24),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(24),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(437),
    [aux_sym_preproc_include_token1] = ACTIONS(440),
    [aux_sym_preproc_def_token1] = ACTIONS(443),
    [aux_sym_preproc_if_token1] = ACTIONS(446),
    [aux_sym_preproc_if_token2] = ACTIONS(195),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(449),
    [sym_preproc_directive] = ACTIONS(452),
    [anon_sym_LPAREN2] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(206),
    [anon_sym_TILDE] = ACTIONS(206),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_STAR] = ACTIONS(212),
    [anon_sym_AMP] = ACTIONS(212),
    [anon_sym_SEMI] = ACTIONS(455),
    [anon_sym_typedef] = ACTIONS(458),
    [anon_sym_kernel] = ACTIONS(221),
    [anon_sym___kernel] = ACTIONS(221),
    [anon_sym_global] = ACTIONS(224),
    [anon_sym___global] = ACTIONS(224),
    [anon_sym_local] = ACTIONS(224),
    [anon_sym___local] = ACTIONS(224),
    [anon_sym_constant] = ACTIONS(224),
    [anon_sym___constant] = ACTIONS(224),
    [anon_sym_private] = ACTIONS(224),
    [anon_sym___private] = ACTIONS(224),
    [anon_sym_generic] = ACTIONS(224),
    [anon_sym___generic] = ACTIONS(224),
    [anon_sym_read_only] = ACTIONS(227),
    [anon_sym___read_only] = ACTIONS(227),
    [anon_sym_write_only] = ACTIONS(227),
    [anon_sym___write_only] = ACTIONS(227),
    [anon_sym_read_write] = ACTIONS(227),
    [anon_sym___read_write] = ACTIONS(227),
    [anon_sym_extern] = ACTIONS(461),
    [anon_sym___attribute__] = ACTIONS(233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(236),
    [anon_sym___declspec] = ACTIONS(239),
    [anon_sym___cdecl] = ACTIONS(242),
    [anon_sym___clrcall] = ACTIONS(242),
    [anon_sym___stdcall] = ACTIONS(242),
    [anon_sym___fastcall] = ACTIONS(242),
    [anon_sym___thiscall] = ACTIONS(242),
    [anon_sym___vectorcall] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_auto] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_pipe] = ACTIONS(251),
    [anon_sym_signed] = ACTIONS(254),
    [anon_sym_unsigned] = ACTIONS(254),
    [anon_sym_long] = ACTIONS(254),
    [anon_sym_short] = ACTIONS(254),
    [anon_sym_bool] = ACTIONS(257),
    [anon_sym_char] = ACTIONS(257),
    [anon_sym_uchar] = ACTIONS(257),
    [anon_sym_ushort] = ACTIONS(257),
    [anon_sym_int] = ACTIONS(257),
    [anon_sym_uint] = ACTIONS(257),
    [anon_sym_ulong] = ACTIONS(257),
    [anon_sym_float] = ACTIONS(257),
    [anon_sym_double] = ACTIONS(257),
    [anon_sym_half] = ACTIONS(257),
    [anon_sym_size_t] = ACTIONS(257),
    [anon_sym_ptrdiff_t] = ACTIONS(257),
    [anon_sym_intptr_t] = ACTIONS(257),
    [anon_sym_uintptr_t] = ACTIONS(257),
    [anon_sym_void] = ACTIONS(257),
    [sym_vector_type] = ACTIONS(260),
    [anon_sym_image2d_t] = ACTIONS(263),
    [anon_sym_image3d_t] = ACTIONS(263),
    [anon_sym_image2d_array_t] = ACTIONS(263),
    [anon_sym_image1d_t] = ACTIONS(263),
    [anon_sym_image1d_buffer_t] = ACTIONS(263),
    [anon_sym_image1d_array_t] = ACTIONS(263),
    [anon_sym_image2d_depth_t] = ACTIONS(263),
    [anon_sym_image2d_array_depth_t] = ACTIONS(263),
    [anon_sym_sampler_t] = ACTIONS(263),
    [anon_sym_queue_t] = ACTIONS(263),
    [anon_sym_ndrange_t] = ACTIONS(263),
    [anon_sym_clk_event_t] = ACTIONS(263),
    [anon_sym_reserve_id_t] = ACTIONS(263),
    [anon_sym_event_t] = ACTIONS(263),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(266),
    [anon_sym_struct] = ACTIONS(269),
    [anon_sym_union] = ACTIONS(272),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_switch] = ACTIONS(470),
    [anon_sym_case] = ACTIONS(473),
    [anon_sym_default] = ACTIONS(476),
    [anon_sym_while] = ACTIONS(479),
    [anon_sym_do] = ACTIONS(482),
    [anon_sym_for] = ACTIONS(485),
    [anon_sym_return] = ACTIONS(488),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_continue] = ACTIONS(494),
    [anon_sym_goto] = ACTIONS(497),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_sizeof] = ACTIONS(311),
    [sym_number_literal] = ACTIONS(314),
    [anon_sym_L_SQUOTE] = ACTIONS(317),
    [anon_sym_u_SQUOTE] = ACTIONS(317),
    [anon_sym_U_SQUOTE] = ACTIONS(317),
    [anon_sym_u8_SQUOTE] = ACTIONS(317),
    [anon_sym_SQUOTE] = ACTIONS(317),
    [anon_sym_L_DQUOTE] = ACTIONS(320),
    [anon_sym_u_DQUOTE] = ACTIONS(320),
    [anon_sym_U_DQUOTE] = ACTIONS(320),
    [anon_sym_u8_DQUOTE] = ACTIONS(320),
    [anon_sym_DQUOTE] = ACTIONS(320),
    [sym_true] = ACTIONS(323),
    [sym_false] = ACTIONS(323),
    [sym_null] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(520),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(544),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(36),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(36),
    [sym_labeled_statement] = STATE(36),
    [sym_expression_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_switch_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_do_statement] = STATE(36),
    [sym_for_statement] = STATE(36),
    [sym_return_statement] = STATE(36),
    [sym_break_statement] = STATE(36),
    [sym_continue_statement] = STATE(36),
    [sym_goto_statement] = STATE(36),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(36),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(548),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(550),
    [aux_sym_preproc_include_token1] = ACTIONS(553),
    [aux_sym_preproc_def_token1] = ACTIONS(556),
    [aux_sym_preproc_if_token1] = ACTIONS(559),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(562),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(562),
    [sym_preproc_directive] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(206),
    [anon_sym_TILDE] = ACTIONS(206),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_STAR] = ACTIONS(212),
    [anon_sym_AMP] = ACTIONS(212),
    [anon_sym_SEMI] = ACTIONS(568),
    [anon_sym_typedef] = ACTIONS(571),
    [anon_sym_kernel] = ACTIONS(221),
    [anon_sym___kernel] = ACTIONS(221),
    [anon_sym_global] = ACTIONS(224),
    [anon_sym___global] = ACTIONS(224),
    [anon_sym_local] = ACTIONS(224),
    [anon_sym___local] = ACTIONS(224),
    [anon_sym_constant] = ACTIONS(224),
    [anon_sym___constant] = ACTIONS(224),
    [anon_sym_private] = ACTIONS(224),
    [anon_sym___private] = ACTIONS(224),
    [anon_sym_generic] = ACTIONS(224),
    [anon_sym___generic] = ACTIONS(224),
    [anon_sym_read_only] = ACTIONS(227),
    [anon_sym___read_only] = ACTIONS(227),
    [anon_sym_write_only] = ACTIONS(227),
    [anon_sym___write_only] = ACTIONS(227),
    [anon_sym_read_write] = ACTIONS(227),
    [anon_sym___read_write] = ACTIONS(227),
    [anon_sym_extern] = ACTIONS(574),
    [anon_sym___attribute__] = ACTIONS(233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(236),
    [anon_sym___declspec] = ACTIONS(239),
    [anon_sym___cdecl] = ACTIONS(242),
    [anon_sym___clrcall] = ACTIONS(242),
    [anon_sym___stdcall] = ACTIONS(242),
    [anon_sym___fastcall] = ACTIONS(242),
    [anon_sym___thiscall] = ACTIONS(242),
    [anon_sym___vectorcall] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(577),
    [anon_sym_RBRACE] = ACTIONS(326),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_auto] = ACTIONS(248),
    [anon_sym_register] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_const] = ACTIONS(251),
    [anon_sym_volatile] = ACTIONS(251),
    [anon_sym_restrict] = ACTIONS(251),
    [anon_sym__Atomic] = ACTIONS(251),
    [anon_sym_pipe] = ACTIONS(251),
    [anon_sym_signed] = ACTIONS(254),
    [anon_sym_unsigned] = ACTIONS(254),
    [anon_sym_long] = ACTIONS(254),
    [anon_sym_short] = ACTIONS(254),
    [anon_sym_bool] = ACTIONS(257),
    [anon_sym_char] = ACTIONS(257),
    [anon_sym_uchar] = ACTIONS(257),
    [anon_sym_ushort] = ACTIONS(257),
    [anon_sym_int] = ACTIONS(257),
    [anon_sym_uint] = ACTIONS(257),
    [anon_sym_ulong] = ACTIONS(257),
    [anon_sym_float] = ACTIONS(257),
    [anon_sym_double] = ACTIONS(257),
    [anon_sym_half] = ACTIONS(257),
    [anon_sym_size_t] = ACTIONS(257),
    [anon_sym_ptrdiff_t] = ACTIONS(257),
    [anon_sym_intptr_t] = ACTIONS(257),
    [anon_sym_uintptr_t] = ACTIONS(257),
    [anon_sym_void] = ACTIONS(257),
    [sym_vector_type] = ACTIONS(260),
    [anon_sym_image2d_t] = ACTIONS(263),
    [anon_sym_image3d_t] = ACTIONS(263),
    [anon_sym_image2d_array_t] = ACTIONS(263),
    [anon_sym_image1d_t] = ACTIONS(263),
    [anon_sym_image1d_buffer_t] = ACTIONS(263),
    [anon_sym_image1d_array_t] = ACTIONS(263),
    [anon_sym_image2d_depth_t] = ACTIONS(263),
    [anon_sym_image2d_array_depth_t] = ACTIONS(263),
    [anon_sym_sampler_t] = ACTIONS(263),
    [anon_sym_queue_t] = ACTIONS(263),
    [anon_sym_ndrange_t] = ACTIONS(263),
    [anon_sym_clk_event_t] = ACTIONS(263),
    [anon_sym_reserve_id_t] = ACTIONS(263),
    [anon_sym_event_t] = ACTIONS(263),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(266),
    [anon_sym_struct] = ACTIONS(269),
    [anon_sym_union] = ACTIONS(272),
    [anon_sym_if] = ACTIONS(580),
    [anon_sym_switch] = ACTIONS(583),
    [anon_sym_case] = ACTIONS(586),
    [anon_sym_default] = ACTIONS(589),
    [anon_sym_while] = ACTIONS(592),
    [anon_sym_do] = ACTIONS(595),
    [anon_sym_for] = ACTIONS(598),
    [anon_sym_return] = ACTIONS(601),
    [anon_sym_break] = ACTIONS(604),
    [anon_sym_continue] = ACTIONS(607),
    [anon_sym_goto] = ACTIONS(610),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_sizeof] = ACTIONS(311),
    [sym_number_literal] = ACTIONS(314),
    [anon_sym_L_SQUOTE] = ACTIONS(317),
    [anon_sym_u_SQUOTE] = ACTIONS(317),
    [anon_sym_U_SQUOTE] = ACTIONS(317),
    [anon_sym_u8_SQUOTE] = ACTIONS(317),
    [anon_sym_SQUOTE] = ACTIONS(317),
    [anon_sym_L_DQUOTE] = ACTIONS(320),
    [anon_sym_u_DQUOTE] = ACTIONS(320),
    [anon_sym_U_DQUOTE] = ACTIONS(320),
    [anon_sym_u8_DQUOTE] = ACTIONS(320),
    [anon_sym_DQUOTE] = ACTIONS(320),
    [sym_true] = ACTIONS(323),
    [sym_false] = ACTIONS(323),
    [sym_null] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(613),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_preproc_include] = STATE(21),
    [sym_preproc_def] = STATE(21),
    [sym_preproc_function_def] = STATE(21),
    [sym_preproc_call] = STATE(21),
    [sym_preproc_if] = STATE(21),
    [sym_preproc_ifdef] = STATE(21),
    [sym_function_definition] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_type_definition] = STATE(21),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1022),
    [sym_linkage_specification] = STATE(21),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(338),
    [sym_compound_statement] = STATE(21),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(546),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_case_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_goto_statement] = STATE(21),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(21),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(21),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(37),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(30),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_case_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_goto_statement] = STATE(30),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(30),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(39),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(39),
    [sym_labeled_statement] = STATE(39),
    [sym_expression_statement] = STATE(39),
    [sym_if_statement] = STATE(39),
    [sym_switch_statement] = STATE(39),
    [sym_case_statement] = STATE(39),
    [sym_while_statement] = STATE(39),
    [sym_do_statement] = STATE(39),
    [sym_for_statement] = STATE(39),
    [sym_return_statement] = STATE(39),
    [sym_break_statement] = STATE(39),
    [sym_continue_statement] = STATE(39),
    [sym_goto_statement] = STATE(39),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(39),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(35),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(35),
    [sym_labeled_statement] = STATE(35),
    [sym_expression_statement] = STATE(35),
    [sym_if_statement] = STATE(35),
    [sym_switch_statement] = STATE(35),
    [sym_case_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_do_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_return_statement] = STATE(35),
    [sym_break_statement] = STATE(35),
    [sym_continue_statement] = STATE(35),
    [sym_goto_statement] = STATE(35),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(35),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(32),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_case_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_goto_statement] = STATE(32),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(32),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(32),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(629),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(29),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_preproc_include] = STATE(25),
    [sym_preproc_def] = STATE(25),
    [sym_preproc_function_def] = STATE(25),
    [sym_preproc_call] = STATE(25),
    [sym_preproc_if] = STATE(25),
    [sym_preproc_ifdef] = STATE(25),
    [sym_function_definition] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_type_definition] = STATE(25),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(25),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(25),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_case_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_goto_statement] = STATE(25),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(25),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(25),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_function_definition] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(28),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_case_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_goto_statement] = STATE(28),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(28),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_preproc_include] = STATE(26),
    [sym_preproc_def] = STATE(26),
    [sym_preproc_function_def] = STATE(26),
    [sym_preproc_call] = STATE(26),
    [sym_preproc_if] = STATE(26),
    [sym_preproc_ifdef] = STATE(26),
    [sym_function_definition] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_type_definition] = STATE(26),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_linkage_specification] = STATE(26),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_compound_statement] = STATE(26),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(547),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(26),
    [sym_labeled_statement] = STATE(26),
    [sym_expression_statement] = STATE(26),
    [sym_if_statement] = STATE(26),
    [sym_switch_statement] = STATE(26),
    [sym_case_statement] = STATE(26),
    [sym_while_statement] = STATE(26),
    [sym_do_statement] = STATE(26),
    [sym_for_statement] = STATE(26),
    [sym_return_statement] = STATE(26),
    [sym_break_statement] = STATE(26),
    [sym_continue_statement] = STATE(26),
    [sym_goto_statement] = STATE(26),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym__empty_declaration] = STATE(26),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_translation_unit_repeat1] = STATE(26),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(500),
    [aux_sym_preproc_include_token1] = ACTIONS(502),
    [aux_sym_preproc_def_token1] = ACTIONS(504),
    [aux_sym_preproc_if_token1] = ACTIONS(506),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(508),
    [sym_preproc_directive] = ACTIONS(510),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(516),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(637),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_declaration] = STATE(47),
    [sym_type_definition] = STATE(47),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1016),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(47),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(47),
    [sym_labeled_statement] = STATE(47),
    [sym_expression_statement] = STATE(47),
    [sym_if_statement] = STATE(47),
    [sym_switch_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_do_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_return_statement] = STATE(47),
    [sym_break_statement] = STATE(47),
    [sym_continue_statement] = STATE(47),
    [sym_goto_statement] = STATE(47),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(47),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(641),
    [aux_sym_preproc_def_token1] = ACTIONS(641),
    [aux_sym_preproc_if_token1] = ACTIONS(641),
    [aux_sym_preproc_if_token2] = ACTIONS(641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(641),
    [aux_sym_preproc_else_token1] = ACTIONS(641),
    [aux_sym_preproc_elif_token1] = ACTIONS(641),
    [sym_preproc_directive] = ACTIONS(641),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(641),
    [anon_sym___clrcall] = ACTIONS(641),
    [anon_sym___stdcall] = ACTIONS(641),
    [anon_sym___fastcall] = ACTIONS(641),
    [anon_sym___thiscall] = ACTIONS(641),
    [anon_sym___vectorcall] = ACTIONS(641),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_else] = ACTIONS(641),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(641),
    [anon_sym_default] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1016),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(44),
    [sym_identifier] = ACTIONS(643),
    [aux_sym_preproc_include_token1] = ACTIONS(646),
    [aux_sym_preproc_def_token1] = ACTIONS(646),
    [aux_sym_preproc_if_token1] = ACTIONS(646),
    [aux_sym_preproc_if_token2] = ACTIONS(646),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(646),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(646),
    [aux_sym_preproc_else_token1] = ACTIONS(646),
    [aux_sym_preproc_elif_token1] = ACTIONS(646),
    [sym_preproc_directive] = ACTIONS(646),
    [anon_sym_LPAREN2] = ACTIONS(648),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_SEMI] = ACTIONS(660),
    [anon_sym_typedef] = ACTIONS(663),
    [anon_sym_kernel] = ACTIONS(666),
    [anon_sym___kernel] = ACTIONS(666),
    [anon_sym_global] = ACTIONS(669),
    [anon_sym___global] = ACTIONS(669),
    [anon_sym_local] = ACTIONS(669),
    [anon_sym___local] = ACTIONS(669),
    [anon_sym_constant] = ACTIONS(669),
    [anon_sym___constant] = ACTIONS(669),
    [anon_sym_private] = ACTIONS(669),
    [anon_sym___private] = ACTIONS(669),
    [anon_sym_generic] = ACTIONS(669),
    [anon_sym___generic] = ACTIONS(669),
    [anon_sym_read_only] = ACTIONS(672),
    [anon_sym___read_only] = ACTIONS(672),
    [anon_sym_write_only] = ACTIONS(672),
    [anon_sym___write_only] = ACTIONS(672),
    [anon_sym_read_write] = ACTIONS(672),
    [anon_sym___read_write] = ACTIONS(672),
    [anon_sym_extern] = ACTIONS(675),
    [anon_sym___attribute__] = ACTIONS(678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(681),
    [anon_sym___declspec] = ACTIONS(684),
    [anon_sym___cdecl] = ACTIONS(646),
    [anon_sym___clrcall] = ACTIONS(646),
    [anon_sym___stdcall] = ACTIONS(646),
    [anon_sym___fastcall] = ACTIONS(646),
    [anon_sym___thiscall] = ACTIONS(646),
    [anon_sym___vectorcall] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(687),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_auto] = ACTIONS(675),
    [anon_sym_register] = ACTIONS(675),
    [anon_sym_inline] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(690),
    [anon_sym_volatile] = ACTIONS(690),
    [anon_sym_restrict] = ACTIONS(690),
    [anon_sym__Atomic] = ACTIONS(690),
    [anon_sym_pipe] = ACTIONS(690),
    [anon_sym_signed] = ACTIONS(693),
    [anon_sym_unsigned] = ACTIONS(693),
    [anon_sym_long] = ACTIONS(693),
    [anon_sym_short] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(696),
    [anon_sym_char] = ACTIONS(696),
    [anon_sym_uchar] = ACTIONS(696),
    [anon_sym_ushort] = ACTIONS(696),
    [anon_sym_int] = ACTIONS(696),
    [anon_sym_uint] = ACTIONS(696),
    [anon_sym_ulong] = ACTIONS(696),
    [anon_sym_float] = ACTIONS(696),
    [anon_sym_double] = ACTIONS(696),
    [anon_sym_half] = ACTIONS(696),
    [anon_sym_size_t] = ACTIONS(696),
    [anon_sym_ptrdiff_t] = ACTIONS(696),
    [anon_sym_intptr_t] = ACTIONS(696),
    [anon_sym_uintptr_t] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(696),
    [sym_vector_type] = ACTIONS(699),
    [anon_sym_image2d_t] = ACTIONS(702),
    [anon_sym_image3d_t] = ACTIONS(702),
    [anon_sym_image2d_array_t] = ACTIONS(702),
    [anon_sym_image1d_t] = ACTIONS(702),
    [anon_sym_image1d_buffer_t] = ACTIONS(702),
    [anon_sym_image1d_array_t] = ACTIONS(702),
    [anon_sym_image2d_depth_t] = ACTIONS(702),
    [anon_sym_image2d_array_depth_t] = ACTIONS(702),
    [anon_sym_sampler_t] = ACTIONS(702),
    [anon_sym_queue_t] = ACTIONS(702),
    [anon_sym_ndrange_t] = ACTIONS(702),
    [anon_sym_clk_event_t] = ACTIONS(702),
    [anon_sym_reserve_id_t] = ACTIONS(702),
    [anon_sym_event_t] = ACTIONS(702),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(702),
    [anon_sym_enum] = ACTIONS(705),
    [anon_sym_struct] = ACTIONS(708),
    [anon_sym_union] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(646),
    [anon_sym_default] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(720),
    [anon_sym_do] = ACTIONS(723),
    [anon_sym_for] = ACTIONS(726),
    [anon_sym_return] = ACTIONS(729),
    [anon_sym_break] = ACTIONS(732),
    [anon_sym_continue] = ACTIONS(735),
    [anon_sym_goto] = ACTIONS(738),
    [anon_sym_DASH_DASH] = ACTIONS(741),
    [anon_sym_PLUS_PLUS] = ACTIONS(741),
    [anon_sym_sizeof] = ACTIONS(744),
    [sym_number_literal] = ACTIONS(747),
    [anon_sym_L_SQUOTE] = ACTIONS(750),
    [anon_sym_u_SQUOTE] = ACTIONS(750),
    [anon_sym_U_SQUOTE] = ACTIONS(750),
    [anon_sym_u8_SQUOTE] = ACTIONS(750),
    [anon_sym_SQUOTE] = ACTIONS(750),
    [anon_sym_L_DQUOTE] = ACTIONS(753),
    [anon_sym_u_DQUOTE] = ACTIONS(753),
    [anon_sym_U_DQUOTE] = ACTIONS(753),
    [anon_sym_u8_DQUOTE] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(753),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1016),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(46),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(46),
    [sym_labeled_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(759),
    [aux_sym_preproc_def_token1] = ACTIONS(759),
    [aux_sym_preproc_if_token1] = ACTIONS(759),
    [aux_sym_preproc_if_token2] = ACTIONS(759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(759),
    [aux_sym_preproc_else_token1] = ACTIONS(759),
    [aux_sym_preproc_elif_token1] = ACTIONS(759),
    [sym_preproc_directive] = ACTIONS(759),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(759),
    [anon_sym___clrcall] = ACTIONS(759),
    [anon_sym___stdcall] = ACTIONS(759),
    [anon_sym___fastcall] = ACTIONS(759),
    [anon_sym___thiscall] = ACTIONS(759),
    [anon_sym___vectorcall] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_else] = ACTIONS(759),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(759),
    [anon_sym_default] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1016),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(44),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(761),
    [aux_sym_preproc_def_token1] = ACTIONS(761),
    [aux_sym_preproc_if_token1] = ACTIONS(761),
    [aux_sym_preproc_if_token2] = ACTIONS(761),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(761),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(761),
    [aux_sym_preproc_else_token1] = ACTIONS(761),
    [aux_sym_preproc_elif_token1] = ACTIONS(761),
    [sym_preproc_directive] = ACTIONS(761),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(761),
    [anon_sym___clrcall] = ACTIONS(761),
    [anon_sym___stdcall] = ACTIONS(761),
    [anon_sym___fastcall] = ACTIONS(761),
    [anon_sym___thiscall] = ACTIONS(761),
    [anon_sym___vectorcall] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_else] = ACTIONS(761),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(761),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1016),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(44),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(763),
    [aux_sym_preproc_def_token1] = ACTIONS(763),
    [aux_sym_preproc_if_token1] = ACTIONS(763),
    [aux_sym_preproc_if_token2] = ACTIONS(763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(763),
    [aux_sym_preproc_else_token1] = ACTIONS(763),
    [aux_sym_preproc_elif_token1] = ACTIONS(763),
    [sym_preproc_directive] = ACTIONS(763),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_typedef] = ACTIONS(121),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(763),
    [anon_sym___clrcall] = ACTIONS(763),
    [anon_sym___stdcall] = ACTIONS(763),
    [anon_sym___fastcall] = ACTIONS(763),
    [anon_sym___thiscall] = ACTIONS(763),
    [anon_sym___vectorcall] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_else] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(763),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1012),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(53),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_goto_statement] = STATE(53),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(53),
    [sym_identifier] = ACTIONS(765),
    [aux_sym_preproc_include_token1] = ACTIONS(763),
    [aux_sym_preproc_def_token1] = ACTIONS(763),
    [aux_sym_preproc_if_token1] = ACTIONS(763),
    [aux_sym_preproc_if_token2] = ACTIONS(763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(763),
    [sym_preproc_directive] = ACTIONS(763),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_typedef] = ACTIONS(407),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(763),
    [anon_sym___clrcall] = ACTIONS(763),
    [anon_sym___stdcall] = ACTIONS(763),
    [anon_sym___fastcall] = ACTIONS(763),
    [anon_sym___thiscall] = ACTIONS(763),
    [anon_sym___vectorcall] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(763),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1010),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(49),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(49),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(769),
    [aux_sym_preproc_include_token1] = ACTIONS(646),
    [aux_sym_preproc_def_token1] = ACTIONS(646),
    [aux_sym_preproc_if_token1] = ACTIONS(646),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(646),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(646),
    [sym_preproc_directive] = ACTIONS(646),
    [anon_sym_LPAREN2] = ACTIONS(648),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_SEMI] = ACTIONS(772),
    [anon_sym_typedef] = ACTIONS(775),
    [anon_sym_kernel] = ACTIONS(666),
    [anon_sym___kernel] = ACTIONS(666),
    [anon_sym_global] = ACTIONS(669),
    [anon_sym___global] = ACTIONS(669),
    [anon_sym_local] = ACTIONS(669),
    [anon_sym___local] = ACTIONS(669),
    [anon_sym_constant] = ACTIONS(669),
    [anon_sym___constant] = ACTIONS(669),
    [anon_sym_private] = ACTIONS(669),
    [anon_sym___private] = ACTIONS(669),
    [anon_sym_generic] = ACTIONS(669),
    [anon_sym___generic] = ACTIONS(669),
    [anon_sym_read_only] = ACTIONS(672),
    [anon_sym___read_only] = ACTIONS(672),
    [anon_sym_write_only] = ACTIONS(672),
    [anon_sym___write_only] = ACTIONS(672),
    [anon_sym_read_write] = ACTIONS(672),
    [anon_sym___read_write] = ACTIONS(672),
    [anon_sym_extern] = ACTIONS(675),
    [anon_sym___attribute__] = ACTIONS(678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(681),
    [anon_sym___declspec] = ACTIONS(684),
    [anon_sym___cdecl] = ACTIONS(646),
    [anon_sym___clrcall] = ACTIONS(646),
    [anon_sym___stdcall] = ACTIONS(646),
    [anon_sym___fastcall] = ACTIONS(646),
    [anon_sym___thiscall] = ACTIONS(646),
    [anon_sym___vectorcall] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(778),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_auto] = ACTIONS(675),
    [anon_sym_register] = ACTIONS(675),
    [anon_sym_inline] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(690),
    [anon_sym_volatile] = ACTIONS(690),
    [anon_sym_restrict] = ACTIONS(690),
    [anon_sym__Atomic] = ACTIONS(690),
    [anon_sym_pipe] = ACTIONS(690),
    [anon_sym_signed] = ACTIONS(693),
    [anon_sym_unsigned] = ACTIONS(693),
    [anon_sym_long] = ACTIONS(693),
    [anon_sym_short] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(696),
    [anon_sym_char] = ACTIONS(696),
    [anon_sym_uchar] = ACTIONS(696),
    [anon_sym_ushort] = ACTIONS(696),
    [anon_sym_int] = ACTIONS(696),
    [anon_sym_uint] = ACTIONS(696),
    [anon_sym_ulong] = ACTIONS(696),
    [anon_sym_float] = ACTIONS(696),
    [anon_sym_double] = ACTIONS(696),
    [anon_sym_half] = ACTIONS(696),
    [anon_sym_size_t] = ACTIONS(696),
    [anon_sym_ptrdiff_t] = ACTIONS(696),
    [anon_sym_intptr_t] = ACTIONS(696),
    [anon_sym_uintptr_t] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(696),
    [sym_vector_type] = ACTIONS(699),
    [anon_sym_image2d_t] = ACTIONS(702),
    [anon_sym_image3d_t] = ACTIONS(702),
    [anon_sym_image2d_array_t] = ACTIONS(702),
    [anon_sym_image1d_t] = ACTIONS(702),
    [anon_sym_image1d_buffer_t] = ACTIONS(702),
    [anon_sym_image1d_array_t] = ACTIONS(702),
    [anon_sym_image2d_depth_t] = ACTIONS(702),
    [anon_sym_image2d_array_depth_t] = ACTIONS(702),
    [anon_sym_sampler_t] = ACTIONS(702),
    [anon_sym_queue_t] = ACTIONS(702),
    [anon_sym_ndrange_t] = ACTIONS(702),
    [anon_sym_clk_event_t] = ACTIONS(702),
    [anon_sym_reserve_id_t] = ACTIONS(702),
    [anon_sym_event_t] = ACTIONS(702),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(702),
    [anon_sym_enum] = ACTIONS(705),
    [anon_sym_struct] = ACTIONS(708),
    [anon_sym_union] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(781),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_case] = ACTIONS(646),
    [anon_sym_default] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(787),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_return] = ACTIONS(796),
    [anon_sym_break] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(802),
    [anon_sym_goto] = ACTIONS(805),
    [anon_sym_DASH_DASH] = ACTIONS(741),
    [anon_sym_PLUS_PLUS] = ACTIONS(741),
    [anon_sym_sizeof] = ACTIONS(744),
    [sym_number_literal] = ACTIONS(747),
    [anon_sym_L_SQUOTE] = ACTIONS(750),
    [anon_sym_u_SQUOTE] = ACTIONS(750),
    [anon_sym_U_SQUOTE] = ACTIONS(750),
    [anon_sym_u8_SQUOTE] = ACTIONS(750),
    [anon_sym_SQUOTE] = ACTIONS(750),
    [anon_sym_L_DQUOTE] = ACTIONS(753),
    [anon_sym_u_DQUOTE] = ACTIONS(753),
    [anon_sym_U_DQUOTE] = ACTIONS(753),
    [anon_sym_u8_DQUOTE] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(753),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1012),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(765),
    [aux_sym_preproc_include_token1] = ACTIONS(759),
    [aux_sym_preproc_def_token1] = ACTIONS(759),
    [aux_sym_preproc_if_token1] = ACTIONS(759),
    [aux_sym_preproc_if_token2] = ACTIONS(759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(759),
    [sym_preproc_directive] = ACTIONS(759),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_typedef] = ACTIONS(407),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(759),
    [anon_sym___clrcall] = ACTIONS(759),
    [anon_sym___stdcall] = ACTIONS(759),
    [anon_sym___fastcall] = ACTIONS(759),
    [anon_sym___thiscall] = ACTIONS(759),
    [anon_sym___vectorcall] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(759),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(759),
    [anon_sym_default] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1010),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(49),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(49),
    [ts_builtin_sym_end] = ACTIONS(808),
    [sym_identifier] = ACTIONS(810),
    [aux_sym_preproc_include_token1] = ACTIONS(763),
    [aux_sym_preproc_def_token1] = ACTIONS(763),
    [aux_sym_preproc_if_token1] = ACTIONS(763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(763),
    [sym_preproc_directive] = ACTIONS(763),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(763),
    [anon_sym___clrcall] = ACTIONS(763),
    [anon_sym___stdcall] = ACTIONS(763),
    [anon_sym___fastcall] = ACTIONS(763),
    [anon_sym___thiscall] = ACTIONS(763),
    [anon_sym___vectorcall] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(763),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1012),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(53),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_goto_statement] = STATE(53),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(53),
    [sym_identifier] = ACTIONS(765),
    [aux_sym_preproc_include_token1] = ACTIONS(761),
    [aux_sym_preproc_def_token1] = ACTIONS(761),
    [aux_sym_preproc_if_token1] = ACTIONS(761),
    [aux_sym_preproc_if_token2] = ACTIONS(761),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(761),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(761),
    [sym_preproc_directive] = ACTIONS(761),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_typedef] = ACTIONS(407),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(761),
    [anon_sym___clrcall] = ACTIONS(761),
    [anon_sym___stdcall] = ACTIONS(761),
    [anon_sym___fastcall] = ACTIONS(761),
    [anon_sym___thiscall] = ACTIONS(761),
    [anon_sym___vectorcall] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(761),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(761),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1012),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(53),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_goto_statement] = STATE(53),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(53),
    [sym_identifier] = ACTIONS(812),
    [aux_sym_preproc_include_token1] = ACTIONS(646),
    [aux_sym_preproc_def_token1] = ACTIONS(646),
    [aux_sym_preproc_if_token1] = ACTIONS(646),
    [aux_sym_preproc_if_token2] = ACTIONS(646),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(646),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(646),
    [sym_preproc_directive] = ACTIONS(646),
    [anon_sym_LPAREN2] = ACTIONS(648),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_typedef] = ACTIONS(818),
    [anon_sym_kernel] = ACTIONS(666),
    [anon_sym___kernel] = ACTIONS(666),
    [anon_sym_global] = ACTIONS(669),
    [anon_sym___global] = ACTIONS(669),
    [anon_sym_local] = ACTIONS(669),
    [anon_sym___local] = ACTIONS(669),
    [anon_sym_constant] = ACTIONS(669),
    [anon_sym___constant] = ACTIONS(669),
    [anon_sym_private] = ACTIONS(669),
    [anon_sym___private] = ACTIONS(669),
    [anon_sym_generic] = ACTIONS(669),
    [anon_sym___generic] = ACTIONS(669),
    [anon_sym_read_only] = ACTIONS(672),
    [anon_sym___read_only] = ACTIONS(672),
    [anon_sym_write_only] = ACTIONS(672),
    [anon_sym___write_only] = ACTIONS(672),
    [anon_sym_read_write] = ACTIONS(672),
    [anon_sym___read_write] = ACTIONS(672),
    [anon_sym_extern] = ACTIONS(675),
    [anon_sym___attribute__] = ACTIONS(678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(681),
    [anon_sym___declspec] = ACTIONS(684),
    [anon_sym___cdecl] = ACTIONS(646),
    [anon_sym___clrcall] = ACTIONS(646),
    [anon_sym___stdcall] = ACTIONS(646),
    [anon_sym___fastcall] = ACTIONS(646),
    [anon_sym___thiscall] = ACTIONS(646),
    [anon_sym___vectorcall] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_auto] = ACTIONS(675),
    [anon_sym_register] = ACTIONS(675),
    [anon_sym_inline] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(690),
    [anon_sym_volatile] = ACTIONS(690),
    [anon_sym_restrict] = ACTIONS(690),
    [anon_sym__Atomic] = ACTIONS(690),
    [anon_sym_pipe] = ACTIONS(690),
    [anon_sym_signed] = ACTIONS(693),
    [anon_sym_unsigned] = ACTIONS(693),
    [anon_sym_long] = ACTIONS(693),
    [anon_sym_short] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(696),
    [anon_sym_char] = ACTIONS(696),
    [anon_sym_uchar] = ACTIONS(696),
    [anon_sym_ushort] = ACTIONS(696),
    [anon_sym_int] = ACTIONS(696),
    [anon_sym_uint] = ACTIONS(696),
    [anon_sym_ulong] = ACTIONS(696),
    [anon_sym_float] = ACTIONS(696),
    [anon_sym_double] = ACTIONS(696),
    [anon_sym_half] = ACTIONS(696),
    [anon_sym_size_t] = ACTIONS(696),
    [anon_sym_ptrdiff_t] = ACTIONS(696),
    [anon_sym_intptr_t] = ACTIONS(696),
    [anon_sym_uintptr_t] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(696),
    [sym_vector_type] = ACTIONS(699),
    [anon_sym_image2d_t] = ACTIONS(702),
    [anon_sym_image3d_t] = ACTIONS(702),
    [anon_sym_image2d_array_t] = ACTIONS(702),
    [anon_sym_image1d_t] = ACTIONS(702),
    [anon_sym_image1d_buffer_t] = ACTIONS(702),
    [anon_sym_image1d_array_t] = ACTIONS(702),
    [anon_sym_image2d_depth_t] = ACTIONS(702),
    [anon_sym_image2d_array_depth_t] = ACTIONS(702),
    [anon_sym_sampler_t] = ACTIONS(702),
    [anon_sym_queue_t] = ACTIONS(702),
    [anon_sym_ndrange_t] = ACTIONS(702),
    [anon_sym_clk_event_t] = ACTIONS(702),
    [anon_sym_reserve_id_t] = ACTIONS(702),
    [anon_sym_event_t] = ACTIONS(702),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(702),
    [anon_sym_enum] = ACTIONS(705),
    [anon_sym_struct] = ACTIONS(708),
    [anon_sym_union] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(824),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(827),
    [anon_sym_case] = ACTIONS(646),
    [anon_sym_default] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(830),
    [anon_sym_do] = ACTIONS(833),
    [anon_sym_for] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(839),
    [anon_sym_break] = ACTIONS(842),
    [anon_sym_continue] = ACTIONS(845),
    [anon_sym_goto] = ACTIONS(848),
    [anon_sym_DASH_DASH] = ACTIONS(741),
    [anon_sym_PLUS_PLUS] = ACTIONS(741),
    [anon_sym_sizeof] = ACTIONS(744),
    [sym_number_literal] = ACTIONS(747),
    [anon_sym_L_SQUOTE] = ACTIONS(750),
    [anon_sym_u_SQUOTE] = ACTIONS(750),
    [anon_sym_U_SQUOTE] = ACTIONS(750),
    [anon_sym_u8_SQUOTE] = ACTIONS(750),
    [anon_sym_SQUOTE] = ACTIONS(750),
    [anon_sym_L_DQUOTE] = ACTIONS(753),
    [anon_sym_u_DQUOTE] = ACTIONS(753),
    [anon_sym_U_DQUOTE] = ACTIONS(753),
    [anon_sym_u8_DQUOTE] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(753),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1021),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(59),
    [sym_identifier] = ACTIONS(851),
    [aux_sym_preproc_include_token1] = ACTIONS(641),
    [aux_sym_preproc_def_token1] = ACTIONS(641),
    [aux_sym_preproc_if_token1] = ACTIONS(641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(641),
    [sym_preproc_directive] = ACTIONS(641),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(641),
    [anon_sym___clrcall] = ACTIONS(641),
    [anon_sym___stdcall] = ACTIONS(641),
    [anon_sym___fastcall] = ACTIONS(641),
    [anon_sym___thiscall] = ACTIONS(641),
    [anon_sym___vectorcall] = ACTIONS(641),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_else] = ACTIONS(641),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(641),
    [anon_sym_default] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_declaration] = STATE(48),
    [sym_type_definition] = STATE(48),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1012),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(48),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(48),
    [sym_labeled_statement] = STATE(48),
    [sym_expression_statement] = STATE(48),
    [sym_if_statement] = STATE(48),
    [sym_switch_statement] = STATE(48),
    [sym_while_statement] = STATE(48),
    [sym_do_statement] = STATE(48),
    [sym_for_statement] = STATE(48),
    [sym_return_statement] = STATE(48),
    [sym_break_statement] = STATE(48),
    [sym_continue_statement] = STATE(48),
    [sym_goto_statement] = STATE(48),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(765),
    [aux_sym_preproc_include_token1] = ACTIONS(641),
    [aux_sym_preproc_def_token1] = ACTIONS(641),
    [aux_sym_preproc_if_token1] = ACTIONS(641),
    [aux_sym_preproc_if_token2] = ACTIONS(641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(641),
    [sym_preproc_directive] = ACTIONS(641),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_typedef] = ACTIONS(407),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(641),
    [anon_sym___clrcall] = ACTIONS(641),
    [anon_sym___stdcall] = ACTIONS(641),
    [anon_sym___fastcall] = ACTIONS(641),
    [anon_sym___thiscall] = ACTIONS(641),
    [anon_sym___vectorcall] = ACTIONS(641),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(641),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(641),
    [anon_sym_default] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_declaration] = STATE(51),
    [sym_type_definition] = STATE(51),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1010),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(51),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(51),
    [sym_labeled_statement] = STATE(51),
    [sym_expression_statement] = STATE(51),
    [sym_if_statement] = STATE(51),
    [sym_switch_statement] = STATE(51),
    [sym_while_statement] = STATE(51),
    [sym_do_statement] = STATE(51),
    [sym_for_statement] = STATE(51),
    [sym_return_statement] = STATE(51),
    [sym_break_statement] = STATE(51),
    [sym_continue_statement] = STATE(51),
    [sym_goto_statement] = STATE(51),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(51),
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_identifier] = ACTIONS(810),
    [aux_sym_preproc_include_token1] = ACTIONS(641),
    [aux_sym_preproc_def_token1] = ACTIONS(641),
    [aux_sym_preproc_if_token1] = ACTIONS(641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(641),
    [sym_preproc_directive] = ACTIONS(641),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(641),
    [anon_sym___clrcall] = ACTIONS(641),
    [anon_sym___stdcall] = ACTIONS(641),
    [anon_sym___fastcall] = ACTIONS(641),
    [anon_sym___thiscall] = ACTIONS(641),
    [anon_sym___vectorcall] = ACTIONS(641),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(641),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(641),
    [anon_sym_default] = ACTIONS(641),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1010),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(62),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(62),
    [sym_labeled_statement] = STATE(62),
    [sym_expression_statement] = STATE(62),
    [sym_if_statement] = STATE(62),
    [sym_switch_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_do_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_return_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_continue_statement] = STATE(62),
    [sym_goto_statement] = STATE(62),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(62),
    [ts_builtin_sym_end] = ACTIONS(855),
    [sym_identifier] = ACTIONS(810),
    [aux_sym_preproc_include_token1] = ACTIONS(759),
    [aux_sym_preproc_def_token1] = ACTIONS(759),
    [aux_sym_preproc_if_token1] = ACTIONS(759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(759),
    [sym_preproc_directive] = ACTIONS(759),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(759),
    [anon_sym___clrcall] = ACTIONS(759),
    [anon_sym___stdcall] = ACTIONS(759),
    [anon_sym___fastcall] = ACTIONS(759),
    [anon_sym___thiscall] = ACTIONS(759),
    [anon_sym___vectorcall] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(759),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(759),
    [anon_sym_default] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1021),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(61),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(851),
    [aux_sym_preproc_include_token1] = ACTIONS(761),
    [aux_sym_preproc_def_token1] = ACTIONS(761),
    [aux_sym_preproc_if_token1] = ACTIONS(761),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(761),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(761),
    [sym_preproc_directive] = ACTIONS(761),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(761),
    [anon_sym___clrcall] = ACTIONS(761),
    [anon_sym___stdcall] = ACTIONS(761),
    [anon_sym___fastcall] = ACTIONS(761),
    [anon_sym___thiscall] = ACTIONS(761),
    [anon_sym___vectorcall] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_else] = ACTIONS(761),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(761),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1021),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(61),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(851),
    [aux_sym_preproc_include_token1] = ACTIONS(763),
    [aux_sym_preproc_def_token1] = ACTIONS(763),
    [aux_sym_preproc_if_token1] = ACTIONS(763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(763),
    [sym_preproc_directive] = ACTIONS(763),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(763),
    [anon_sym___clrcall] = ACTIONS(763),
    [anon_sym___stdcall] = ACTIONS(763),
    [anon_sym___fastcall] = ACTIONS(763),
    [anon_sym___thiscall] = ACTIONS(763),
    [anon_sym___vectorcall] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(808),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_else] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(763),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_declaration] = STATE(58),
    [sym_type_definition] = STATE(58),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1021),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(58),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(58),
    [sym_labeled_statement] = STATE(58),
    [sym_expression_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym_switch_statement] = STATE(58),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_return_statement] = STATE(58),
    [sym_break_statement] = STATE(58),
    [sym_continue_statement] = STATE(58),
    [sym_goto_statement] = STATE(58),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(58),
    [sym_identifier] = ACTIONS(851),
    [aux_sym_preproc_include_token1] = ACTIONS(759),
    [aux_sym_preproc_def_token1] = ACTIONS(759),
    [aux_sym_preproc_if_token1] = ACTIONS(759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(759),
    [sym_preproc_directive] = ACTIONS(759),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(514),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(759),
    [anon_sym___clrcall] = ACTIONS(759),
    [anon_sym___stdcall] = ACTIONS(759),
    [anon_sym___fastcall] = ACTIONS(759),
    [anon_sym___thiscall] = ACTIONS(759),
    [anon_sym___vectorcall] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_else] = ACTIONS(759),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(759),
    [anon_sym_default] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1021),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(61),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(61),
    [sym_labeled_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(859),
    [aux_sym_preproc_include_token1] = ACTIONS(646),
    [aux_sym_preproc_def_token1] = ACTIONS(646),
    [aux_sym_preproc_if_token1] = ACTIONS(646),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(646),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(646),
    [sym_preproc_directive] = ACTIONS(646),
    [anon_sym_LPAREN2] = ACTIONS(648),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_AMP] = ACTIONS(657),
    [anon_sym_SEMI] = ACTIONS(862),
    [anon_sym_typedef] = ACTIONS(865),
    [anon_sym_kernel] = ACTIONS(666),
    [anon_sym___kernel] = ACTIONS(666),
    [anon_sym_global] = ACTIONS(669),
    [anon_sym___global] = ACTIONS(669),
    [anon_sym_local] = ACTIONS(669),
    [anon_sym___local] = ACTIONS(669),
    [anon_sym_constant] = ACTIONS(669),
    [anon_sym___constant] = ACTIONS(669),
    [anon_sym_private] = ACTIONS(669),
    [anon_sym___private] = ACTIONS(669),
    [anon_sym_generic] = ACTIONS(669),
    [anon_sym___generic] = ACTIONS(669),
    [anon_sym_read_only] = ACTIONS(672),
    [anon_sym___read_only] = ACTIONS(672),
    [anon_sym_write_only] = ACTIONS(672),
    [anon_sym___write_only] = ACTIONS(672),
    [anon_sym_read_write] = ACTIONS(672),
    [anon_sym___read_write] = ACTIONS(672),
    [anon_sym_extern] = ACTIONS(675),
    [anon_sym___attribute__] = ACTIONS(678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(681),
    [anon_sym___declspec] = ACTIONS(684),
    [anon_sym___cdecl] = ACTIONS(646),
    [anon_sym___clrcall] = ACTIONS(646),
    [anon_sym___stdcall] = ACTIONS(646),
    [anon_sym___fastcall] = ACTIONS(646),
    [anon_sym___thiscall] = ACTIONS(646),
    [anon_sym___vectorcall] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(868),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_auto] = ACTIONS(675),
    [anon_sym_register] = ACTIONS(675),
    [anon_sym_inline] = ACTIONS(675),
    [anon_sym_const] = ACTIONS(690),
    [anon_sym_volatile] = ACTIONS(690),
    [anon_sym_restrict] = ACTIONS(690),
    [anon_sym__Atomic] = ACTIONS(690),
    [anon_sym_pipe] = ACTIONS(690),
    [anon_sym_signed] = ACTIONS(693),
    [anon_sym_unsigned] = ACTIONS(693),
    [anon_sym_long] = ACTIONS(693),
    [anon_sym_short] = ACTIONS(693),
    [anon_sym_bool] = ACTIONS(696),
    [anon_sym_char] = ACTIONS(696),
    [anon_sym_uchar] = ACTIONS(696),
    [anon_sym_ushort] = ACTIONS(696),
    [anon_sym_int] = ACTIONS(696),
    [anon_sym_uint] = ACTIONS(696),
    [anon_sym_ulong] = ACTIONS(696),
    [anon_sym_float] = ACTIONS(696),
    [anon_sym_double] = ACTIONS(696),
    [anon_sym_half] = ACTIONS(696),
    [anon_sym_size_t] = ACTIONS(696),
    [anon_sym_ptrdiff_t] = ACTIONS(696),
    [anon_sym_intptr_t] = ACTIONS(696),
    [anon_sym_uintptr_t] = ACTIONS(696),
    [anon_sym_void] = ACTIONS(696),
    [sym_vector_type] = ACTIONS(699),
    [anon_sym_image2d_t] = ACTIONS(702),
    [anon_sym_image3d_t] = ACTIONS(702),
    [anon_sym_image2d_array_t] = ACTIONS(702),
    [anon_sym_image1d_t] = ACTIONS(702),
    [anon_sym_image1d_buffer_t] = ACTIONS(702),
    [anon_sym_image1d_array_t] = ACTIONS(702),
    [anon_sym_image2d_depth_t] = ACTIONS(702),
    [anon_sym_image2d_array_depth_t] = ACTIONS(702),
    [anon_sym_sampler_t] = ACTIONS(702),
    [anon_sym_queue_t] = ACTIONS(702),
    [anon_sym_ndrange_t] = ACTIONS(702),
    [anon_sym_clk_event_t] = ACTIONS(702),
    [anon_sym_reserve_id_t] = ACTIONS(702),
    [anon_sym_event_t] = ACTIONS(702),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(702),
    [anon_sym_enum] = ACTIONS(705),
    [anon_sym_struct] = ACTIONS(708),
    [anon_sym_union] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_switch] = ACTIONS(874),
    [anon_sym_case] = ACTIONS(646),
    [anon_sym_default] = ACTIONS(646),
    [anon_sym_while] = ACTIONS(877),
    [anon_sym_do] = ACTIONS(880),
    [anon_sym_for] = ACTIONS(883),
    [anon_sym_return] = ACTIONS(886),
    [anon_sym_break] = ACTIONS(889),
    [anon_sym_continue] = ACTIONS(892),
    [anon_sym_goto] = ACTIONS(895),
    [anon_sym_DASH_DASH] = ACTIONS(741),
    [anon_sym_PLUS_PLUS] = ACTIONS(741),
    [anon_sym_sizeof] = ACTIONS(744),
    [sym_number_literal] = ACTIONS(747),
    [anon_sym_L_SQUOTE] = ACTIONS(750),
    [anon_sym_u_SQUOTE] = ACTIONS(750),
    [anon_sym_U_SQUOTE] = ACTIONS(750),
    [anon_sym_u8_SQUOTE] = ACTIONS(750),
    [anon_sym_SQUOTE] = ACTIONS(750),
    [anon_sym_L_DQUOTE] = ACTIONS(753),
    [anon_sym_u_DQUOTE] = ACTIONS(753),
    [anon_sym_U_DQUOTE] = ACTIONS(753),
    [anon_sym_u8_DQUOTE] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(753),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1010),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(312),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_compound_statement] = STATE(49),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_attributed_statement] = STATE(49),
    [sym_labeled_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_switch_statement] = STATE(49),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [aux_sym_case_statement_repeat1] = STATE(49),
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym_identifier] = ACTIONS(810),
    [aux_sym_preproc_include_token1] = ACTIONS(761),
    [aux_sym_preproc_def_token1] = ACTIONS(761),
    [aux_sym_preproc_if_token1] = ACTIONS(761),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(761),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(761),
    [sym_preproc_directive] = ACTIONS(761),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_typedef] = ACTIONS(29),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(761),
    [anon_sym___clrcall] = ACTIONS(761),
    [anon_sym___stdcall] = ACTIONS(761),
    [anon_sym___fastcall] = ACTIONS(761),
    [anon_sym___thiscall] = ACTIONS(761),
    [anon_sym___vectorcall] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(761),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(761),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_declaration] = STATE(551),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1010),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__expression] = STATE(816),
    [sym_comma_expression] = STATE(1499),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(898),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_declaration] = STATE(559),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1010),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__expression] = STATE(805),
    [sym_comma_expression] = STATE(1433),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(898),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(904),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_declaration] = STATE(579),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1010),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__expression] = STATE(810),
    [sym_comma_expression] = STATE(1507),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(898),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(906),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_declaration] = STATE(556),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1010),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__expression] = STATE(836),
    [sym_comma_expression] = STATE(1489),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(898),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(908),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token2] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [aux_sym_preproc_else_token1] = ACTIONS(910),
    [aux_sym_preproc_elif_token1] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_kernel] = ACTIONS(910),
    [anon_sym___kernel] = ACTIONS(910),
    [anon_sym_global] = ACTIONS(910),
    [anon_sym___global] = ACTIONS(910),
    [anon_sym_local] = ACTIONS(910),
    [anon_sym___local] = ACTIONS(910),
    [anon_sym_constant] = ACTIONS(910),
    [anon_sym___constant] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym___private] = ACTIONS(910),
    [anon_sym_generic] = ACTIONS(910),
    [anon_sym___generic] = ACTIONS(910),
    [anon_sym_read_only] = ACTIONS(910),
    [anon_sym___read_only] = ACTIONS(910),
    [anon_sym_write_only] = ACTIONS(910),
    [anon_sym___write_only] = ACTIONS(910),
    [anon_sym_read_write] = ACTIONS(910),
    [anon_sym___read_write] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(912),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_pipe] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [anon_sym_bool] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_uchar] = ACTIONS(910),
    [anon_sym_ushort] = ACTIONS(910),
    [anon_sym_int] = ACTIONS(910),
    [anon_sym_uint] = ACTIONS(910),
    [anon_sym_ulong] = ACTIONS(910),
    [anon_sym_float] = ACTIONS(910),
    [anon_sym_double] = ACTIONS(910),
    [anon_sym_half] = ACTIONS(910),
    [anon_sym_size_t] = ACTIONS(910),
    [anon_sym_ptrdiff_t] = ACTIONS(910),
    [anon_sym_intptr_t] = ACTIONS(910),
    [anon_sym_uintptr_t] = ACTIONS(910),
    [anon_sym_void] = ACTIONS(910),
    [sym_vector_type] = ACTIONS(910),
    [anon_sym_image2d_t] = ACTIONS(910),
    [anon_sym_image3d_t] = ACTIONS(910),
    [anon_sym_image2d_array_t] = ACTIONS(910),
    [anon_sym_image1d_t] = ACTIONS(910),
    [anon_sym_image1d_buffer_t] = ACTIONS(910),
    [anon_sym_image1d_array_t] = ACTIONS(910),
    [anon_sym_image2d_depth_t] = ACTIONS(910),
    [anon_sym_image2d_array_depth_t] = ACTIONS(910),
    [anon_sym_sampler_t] = ACTIONS(910),
    [anon_sym_queue_t] = ACTIONS(910),
    [anon_sym_ndrange_t] = ACTIONS(910),
    [anon_sym_clk_event_t] = ACTIONS(910),
    [anon_sym_reserve_id_t] = ACTIONS(910),
    [anon_sym_event_t] = ACTIONS(910),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_identifier] = ACTIONS(914),
    [aux_sym_preproc_include_token1] = ACTIONS(914),
    [aux_sym_preproc_def_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token2] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(914),
    [aux_sym_preproc_else_token1] = ACTIONS(914),
    [aux_sym_preproc_elif_token1] = ACTIONS(914),
    [sym_preproc_directive] = ACTIONS(914),
    [anon_sym_LPAREN2] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(916),
    [anon_sym_AMP] = ACTIONS(916),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_typedef] = ACTIONS(914),
    [anon_sym_kernel] = ACTIONS(914),
    [anon_sym___kernel] = ACTIONS(914),
    [anon_sym_global] = ACTIONS(914),
    [anon_sym___global] = ACTIONS(914),
    [anon_sym_local] = ACTIONS(914),
    [anon_sym___local] = ACTIONS(914),
    [anon_sym_constant] = ACTIONS(914),
    [anon_sym___constant] = ACTIONS(914),
    [anon_sym_private] = ACTIONS(914),
    [anon_sym___private] = ACTIONS(914),
    [anon_sym_generic] = ACTIONS(914),
    [anon_sym___generic] = ACTIONS(914),
    [anon_sym_read_only] = ACTIONS(914),
    [anon_sym___read_only] = ACTIONS(914),
    [anon_sym_write_only] = ACTIONS(914),
    [anon_sym___write_only] = ACTIONS(914),
    [anon_sym_read_write] = ACTIONS(914),
    [anon_sym___read_write] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym___attribute__] = ACTIONS(914),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(916),
    [anon_sym___declspec] = ACTIONS(914),
    [anon_sym___cdecl] = ACTIONS(914),
    [anon_sym___clrcall] = ACTIONS(914),
    [anon_sym___stdcall] = ACTIONS(914),
    [anon_sym___fastcall] = ACTIONS(914),
    [anon_sym___thiscall] = ACTIONS(914),
    [anon_sym___vectorcall] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_auto] = ACTIONS(914),
    [anon_sym_register] = ACTIONS(914),
    [anon_sym_inline] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_restrict] = ACTIONS(914),
    [anon_sym__Atomic] = ACTIONS(914),
    [anon_sym_pipe] = ACTIONS(914),
    [anon_sym_signed] = ACTIONS(914),
    [anon_sym_unsigned] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [anon_sym_bool] = ACTIONS(914),
    [anon_sym_char] = ACTIONS(914),
    [anon_sym_uchar] = ACTIONS(914),
    [anon_sym_ushort] = ACTIONS(914),
    [anon_sym_int] = ACTIONS(914),
    [anon_sym_uint] = ACTIONS(914),
    [anon_sym_ulong] = ACTIONS(914),
    [anon_sym_float] = ACTIONS(914),
    [anon_sym_double] = ACTIONS(914),
    [anon_sym_half] = ACTIONS(914),
    [anon_sym_size_t] = ACTIONS(914),
    [anon_sym_ptrdiff_t] = ACTIONS(914),
    [anon_sym_intptr_t] = ACTIONS(914),
    [anon_sym_uintptr_t] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(914),
    [sym_vector_type] = ACTIONS(914),
    [anon_sym_image2d_t] = ACTIONS(914),
    [anon_sym_image3d_t] = ACTIONS(914),
    [anon_sym_image2d_array_t] = ACTIONS(914),
    [anon_sym_image1d_t] = ACTIONS(914),
    [anon_sym_image1d_buffer_t] = ACTIONS(914),
    [anon_sym_image1d_array_t] = ACTIONS(914),
    [anon_sym_image2d_depth_t] = ACTIONS(914),
    [anon_sym_image2d_array_depth_t] = ACTIONS(914),
    [anon_sym_sampler_t] = ACTIONS(914),
    [anon_sym_queue_t] = ACTIONS(914),
    [anon_sym_ndrange_t] = ACTIONS(914),
    [anon_sym_clk_event_t] = ACTIONS(914),
    [anon_sym_reserve_id_t] = ACTIONS(914),
    [anon_sym_event_t] = ACTIONS(914),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_goto] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_sizeof] = ACTIONS(914),
    [sym_number_literal] = ACTIONS(916),
    [anon_sym_L_SQUOTE] = ACTIONS(916),
    [anon_sym_u_SQUOTE] = ACTIONS(916),
    [anon_sym_U_SQUOTE] = ACTIONS(916),
    [anon_sym_u8_SQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [anon_sym_L_DQUOTE] = ACTIONS(916),
    [anon_sym_u_DQUOTE] = ACTIONS(916),
    [anon_sym_U_DQUOTE] = ACTIONS(916),
    [anon_sym_u8_DQUOTE] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_null] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_identifier] = ACTIONS(918),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token2] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [aux_sym_preproc_else_token1] = ACTIONS(918),
    [aux_sym_preproc_elif_token1] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(920),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(918),
    [anon_sym_kernel] = ACTIONS(918),
    [anon_sym___kernel] = ACTIONS(918),
    [anon_sym_global] = ACTIONS(918),
    [anon_sym___global] = ACTIONS(918),
    [anon_sym_local] = ACTIONS(918),
    [anon_sym___local] = ACTIONS(918),
    [anon_sym_constant] = ACTIONS(918),
    [anon_sym___constant] = ACTIONS(918),
    [anon_sym_private] = ACTIONS(918),
    [anon_sym___private] = ACTIONS(918),
    [anon_sym_generic] = ACTIONS(918),
    [anon_sym___generic] = ACTIONS(918),
    [anon_sym_read_only] = ACTIONS(918),
    [anon_sym___read_only] = ACTIONS(918),
    [anon_sym_write_only] = ACTIONS(918),
    [anon_sym___write_only] = ACTIONS(918),
    [anon_sym_read_write] = ACTIONS(918),
    [anon_sym___read_write] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym___attribute__] = ACTIONS(918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(920),
    [anon_sym___declspec] = ACTIONS(918),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_auto] = ACTIONS(918),
    [anon_sym_register] = ACTIONS(918),
    [anon_sym_inline] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_restrict] = ACTIONS(918),
    [anon_sym__Atomic] = ACTIONS(918),
    [anon_sym_pipe] = ACTIONS(918),
    [anon_sym_signed] = ACTIONS(918),
    [anon_sym_unsigned] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [anon_sym_bool] = ACTIONS(918),
    [anon_sym_char] = ACTIONS(918),
    [anon_sym_uchar] = ACTIONS(918),
    [anon_sym_ushort] = ACTIONS(918),
    [anon_sym_int] = ACTIONS(918),
    [anon_sym_uint] = ACTIONS(918),
    [anon_sym_ulong] = ACTIONS(918),
    [anon_sym_float] = ACTIONS(918),
    [anon_sym_double] = ACTIONS(918),
    [anon_sym_half] = ACTIONS(918),
    [anon_sym_size_t] = ACTIONS(918),
    [anon_sym_ptrdiff_t] = ACTIONS(918),
    [anon_sym_intptr_t] = ACTIONS(918),
    [anon_sym_uintptr_t] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(918),
    [sym_vector_type] = ACTIONS(918),
    [anon_sym_image2d_t] = ACTIONS(918),
    [anon_sym_image3d_t] = ACTIONS(918),
    [anon_sym_image2d_array_t] = ACTIONS(918),
    [anon_sym_image1d_t] = ACTIONS(918),
    [anon_sym_image1d_buffer_t] = ACTIONS(918),
    [anon_sym_image1d_array_t] = ACTIONS(918),
    [anon_sym_image2d_depth_t] = ACTIONS(918),
    [anon_sym_image2d_array_depth_t] = ACTIONS(918),
    [anon_sym_sampler_t] = ACTIONS(918),
    [anon_sym_queue_t] = ACTIONS(918),
    [anon_sym_ndrange_t] = ACTIONS(918),
    [anon_sym_clk_event_t] = ACTIONS(918),
    [anon_sym_reserve_id_t] = ACTIONS(918),
    [anon_sym_event_t] = ACTIONS(918),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_union] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_sizeof] = ACTIONS(918),
    [sym_number_literal] = ACTIONS(920),
    [anon_sym_L_SQUOTE] = ACTIONS(920),
    [anon_sym_u_SQUOTE] = ACTIONS(920),
    [anon_sym_U_SQUOTE] = ACTIONS(920),
    [anon_sym_u8_SQUOTE] = ACTIONS(920),
    [anon_sym_SQUOTE] = ACTIONS(920),
    [anon_sym_L_DQUOTE] = ACTIONS(920),
    [anon_sym_u_DQUOTE] = ACTIONS(920),
    [anon_sym_U_DQUOTE] = ACTIONS(920),
    [anon_sym_u8_DQUOTE] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_null] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_identifier] = ACTIONS(922),
    [aux_sym_preproc_include_token1] = ACTIONS(922),
    [aux_sym_preproc_def_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token2] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(922),
    [aux_sym_preproc_else_token1] = ACTIONS(922),
    [aux_sym_preproc_elif_token1] = ACTIONS(922),
    [sym_preproc_directive] = ACTIONS(922),
    [anon_sym_LPAREN2] = ACTIONS(924),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_typedef] = ACTIONS(922),
    [anon_sym_kernel] = ACTIONS(922),
    [anon_sym___kernel] = ACTIONS(922),
    [anon_sym_global] = ACTIONS(922),
    [anon_sym___global] = ACTIONS(922),
    [anon_sym_local] = ACTIONS(922),
    [anon_sym___local] = ACTIONS(922),
    [anon_sym_constant] = ACTIONS(922),
    [anon_sym___constant] = ACTIONS(922),
    [anon_sym_private] = ACTIONS(922),
    [anon_sym___private] = ACTIONS(922),
    [anon_sym_generic] = ACTIONS(922),
    [anon_sym___generic] = ACTIONS(922),
    [anon_sym_read_only] = ACTIONS(922),
    [anon_sym___read_only] = ACTIONS(922),
    [anon_sym_write_only] = ACTIONS(922),
    [anon_sym___write_only] = ACTIONS(922),
    [anon_sym_read_write] = ACTIONS(922),
    [anon_sym___read_write] = ACTIONS(922),
    [anon_sym_extern] = ACTIONS(922),
    [anon_sym___attribute__] = ACTIONS(922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(924),
    [anon_sym___declspec] = ACTIONS(922),
    [anon_sym___cdecl] = ACTIONS(922),
    [anon_sym___clrcall] = ACTIONS(922),
    [anon_sym___stdcall] = ACTIONS(922),
    [anon_sym___fastcall] = ACTIONS(922),
    [anon_sym___thiscall] = ACTIONS(922),
    [anon_sym___vectorcall] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_auto] = ACTIONS(922),
    [anon_sym_register] = ACTIONS(922),
    [anon_sym_inline] = ACTIONS(922),
    [anon_sym_const] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_restrict] = ACTIONS(922),
    [anon_sym__Atomic] = ACTIONS(922),
    [anon_sym_pipe] = ACTIONS(922),
    [anon_sym_signed] = ACTIONS(922),
    [anon_sym_unsigned] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [anon_sym_bool] = ACTIONS(922),
    [anon_sym_char] = ACTIONS(922),
    [anon_sym_uchar] = ACTIONS(922),
    [anon_sym_ushort] = ACTIONS(922),
    [anon_sym_int] = ACTIONS(922),
    [anon_sym_uint] = ACTIONS(922),
    [anon_sym_ulong] = ACTIONS(922),
    [anon_sym_float] = ACTIONS(922),
    [anon_sym_double] = ACTIONS(922),
    [anon_sym_half] = ACTIONS(922),
    [anon_sym_size_t] = ACTIONS(922),
    [anon_sym_ptrdiff_t] = ACTIONS(922),
    [anon_sym_intptr_t] = ACTIONS(922),
    [anon_sym_uintptr_t] = ACTIONS(922),
    [anon_sym_void] = ACTIONS(922),
    [sym_vector_type] = ACTIONS(922),
    [anon_sym_image2d_t] = ACTIONS(922),
    [anon_sym_image3d_t] = ACTIONS(922),
    [anon_sym_image2d_array_t] = ACTIONS(922),
    [anon_sym_image1d_t] = ACTIONS(922),
    [anon_sym_image1d_buffer_t] = ACTIONS(922),
    [anon_sym_image1d_array_t] = ACTIONS(922),
    [anon_sym_image2d_depth_t] = ACTIONS(922),
    [anon_sym_image2d_array_depth_t] = ACTIONS(922),
    [anon_sym_sampler_t] = ACTIONS(922),
    [anon_sym_queue_t] = ACTIONS(922),
    [anon_sym_ndrange_t] = ACTIONS(922),
    [anon_sym_clk_event_t] = ACTIONS(922),
    [anon_sym_reserve_id_t] = ACTIONS(922),
    [anon_sym_event_t] = ACTIONS(922),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_struct] = ACTIONS(922),
    [anon_sym_union] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_goto] = ACTIONS(922),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_sizeof] = ACTIONS(922),
    [sym_number_literal] = ACTIONS(924),
    [anon_sym_L_SQUOTE] = ACTIONS(924),
    [anon_sym_u_SQUOTE] = ACTIONS(924),
    [anon_sym_U_SQUOTE] = ACTIONS(924),
    [anon_sym_u8_SQUOTE] = ACTIONS(924),
    [anon_sym_SQUOTE] = ACTIONS(924),
    [anon_sym_L_DQUOTE] = ACTIONS(924),
    [anon_sym_u_DQUOTE] = ACTIONS(924),
    [anon_sym_U_DQUOTE] = ACTIONS(924),
    [anon_sym_u8_DQUOTE] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(924),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_null] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_identifier] = ACTIONS(926),
    [aux_sym_preproc_include_token1] = ACTIONS(926),
    [aux_sym_preproc_def_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token2] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(926),
    [aux_sym_preproc_else_token1] = ACTIONS(926),
    [aux_sym_preproc_elif_token1] = ACTIONS(926),
    [sym_preproc_directive] = ACTIONS(926),
    [anon_sym_LPAREN2] = ACTIONS(928),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(926),
    [anon_sym_kernel] = ACTIONS(926),
    [anon_sym___kernel] = ACTIONS(926),
    [anon_sym_global] = ACTIONS(926),
    [anon_sym___global] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym___local] = ACTIONS(926),
    [anon_sym_constant] = ACTIONS(926),
    [anon_sym___constant] = ACTIONS(926),
    [anon_sym_private] = ACTIONS(926),
    [anon_sym___private] = ACTIONS(926),
    [anon_sym_generic] = ACTIONS(926),
    [anon_sym___generic] = ACTIONS(926),
    [anon_sym_read_only] = ACTIONS(926),
    [anon_sym___read_only] = ACTIONS(926),
    [anon_sym_write_only] = ACTIONS(926),
    [anon_sym___write_only] = ACTIONS(926),
    [anon_sym_read_write] = ACTIONS(926),
    [anon_sym___read_write] = ACTIONS(926),
    [anon_sym_extern] = ACTIONS(926),
    [anon_sym___attribute__] = ACTIONS(926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(928),
    [anon_sym___declspec] = ACTIONS(926),
    [anon_sym___cdecl] = ACTIONS(926),
    [anon_sym___clrcall] = ACTIONS(926),
    [anon_sym___stdcall] = ACTIONS(926),
    [anon_sym___fastcall] = ACTIONS(926),
    [anon_sym___thiscall] = ACTIONS(926),
    [anon_sym___vectorcall] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_auto] = ACTIONS(926),
    [anon_sym_register] = ACTIONS(926),
    [anon_sym_inline] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_restrict] = ACTIONS(926),
    [anon_sym__Atomic] = ACTIONS(926),
    [anon_sym_pipe] = ACTIONS(926),
    [anon_sym_signed] = ACTIONS(926),
    [anon_sym_unsigned] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [anon_sym_bool] = ACTIONS(926),
    [anon_sym_char] = ACTIONS(926),
    [anon_sym_uchar] = ACTIONS(926),
    [anon_sym_ushort] = ACTIONS(926),
    [anon_sym_int] = ACTIONS(926),
    [anon_sym_uint] = ACTIONS(926),
    [anon_sym_ulong] = ACTIONS(926),
    [anon_sym_float] = ACTIONS(926),
    [anon_sym_double] = ACTIONS(926),
    [anon_sym_half] = ACTIONS(926),
    [anon_sym_size_t] = ACTIONS(926),
    [anon_sym_ptrdiff_t] = ACTIONS(926),
    [anon_sym_intptr_t] = ACTIONS(926),
    [anon_sym_uintptr_t] = ACTIONS(926),
    [anon_sym_void] = ACTIONS(926),
    [sym_vector_type] = ACTIONS(926),
    [anon_sym_image2d_t] = ACTIONS(926),
    [anon_sym_image3d_t] = ACTIONS(926),
    [anon_sym_image2d_array_t] = ACTIONS(926),
    [anon_sym_image1d_t] = ACTIONS(926),
    [anon_sym_image1d_buffer_t] = ACTIONS(926),
    [anon_sym_image1d_array_t] = ACTIONS(926),
    [anon_sym_image2d_depth_t] = ACTIONS(926),
    [anon_sym_image2d_array_depth_t] = ACTIONS(926),
    [anon_sym_sampler_t] = ACTIONS(926),
    [anon_sym_queue_t] = ACTIONS(926),
    [anon_sym_ndrange_t] = ACTIONS(926),
    [anon_sym_clk_event_t] = ACTIONS(926),
    [anon_sym_reserve_id_t] = ACTIONS(926),
    [anon_sym_event_t] = ACTIONS(926),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_struct] = ACTIONS(926),
    [anon_sym_union] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(926),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_goto] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_sizeof] = ACTIONS(926),
    [sym_number_literal] = ACTIONS(928),
    [anon_sym_L_SQUOTE] = ACTIONS(928),
    [anon_sym_u_SQUOTE] = ACTIONS(928),
    [anon_sym_U_SQUOTE] = ACTIONS(928),
    [anon_sym_u8_SQUOTE] = ACTIONS(928),
    [anon_sym_SQUOTE] = ACTIONS(928),
    [anon_sym_L_DQUOTE] = ACTIONS(928),
    [anon_sym_u_DQUOTE] = ACTIONS(928),
    [anon_sym_U_DQUOTE] = ACTIONS(928),
    [anon_sym_u8_DQUOTE] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_null] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_identifier] = ACTIONS(930),
    [aux_sym_preproc_include_token1] = ACTIONS(930),
    [aux_sym_preproc_def_token1] = ACTIONS(930),
    [aux_sym_preproc_if_token1] = ACTIONS(930),
    [aux_sym_preproc_if_token2] = ACTIONS(930),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(930),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(930),
    [aux_sym_preproc_else_token1] = ACTIONS(930),
    [aux_sym_preproc_elif_token1] = ACTIONS(930),
    [sym_preproc_directive] = ACTIONS(930),
    [anon_sym_LPAREN2] = ACTIONS(932),
    [anon_sym_BANG] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_STAR] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_typedef] = ACTIONS(930),
    [anon_sym_kernel] = ACTIONS(930),
    [anon_sym___kernel] = ACTIONS(930),
    [anon_sym_global] = ACTIONS(930),
    [anon_sym___global] = ACTIONS(930),
    [anon_sym_local] = ACTIONS(930),
    [anon_sym___local] = ACTIONS(930),
    [anon_sym_constant] = ACTIONS(930),
    [anon_sym___constant] = ACTIONS(930),
    [anon_sym_private] = ACTIONS(930),
    [anon_sym___private] = ACTIONS(930),
    [anon_sym_generic] = ACTIONS(930),
    [anon_sym___generic] = ACTIONS(930),
    [anon_sym_read_only] = ACTIONS(930),
    [anon_sym___read_only] = ACTIONS(930),
    [anon_sym_write_only] = ACTIONS(930),
    [anon_sym___write_only] = ACTIONS(930),
    [anon_sym_read_write] = ACTIONS(930),
    [anon_sym___read_write] = ACTIONS(930),
    [anon_sym_extern] = ACTIONS(930),
    [anon_sym___attribute__] = ACTIONS(930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(932),
    [anon_sym___declspec] = ACTIONS(930),
    [anon_sym___cdecl] = ACTIONS(930),
    [anon_sym___clrcall] = ACTIONS(930),
    [anon_sym___stdcall] = ACTIONS(930),
    [anon_sym___fastcall] = ACTIONS(930),
    [anon_sym___thiscall] = ACTIONS(930),
    [anon_sym___vectorcall] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_static] = ACTIONS(930),
    [anon_sym_auto] = ACTIONS(930),
    [anon_sym_register] = ACTIONS(930),
    [anon_sym_inline] = ACTIONS(930),
    [anon_sym_const] = ACTIONS(930),
    [anon_sym_volatile] = ACTIONS(930),
    [anon_sym_restrict] = ACTIONS(930),
    [anon_sym__Atomic] = ACTIONS(930),
    [anon_sym_pipe] = ACTIONS(930),
    [anon_sym_signed] = ACTIONS(930),
    [anon_sym_unsigned] = ACTIONS(930),
    [anon_sym_long] = ACTIONS(930),
    [anon_sym_short] = ACTIONS(930),
    [anon_sym_bool] = ACTIONS(930),
    [anon_sym_char] = ACTIONS(930),
    [anon_sym_uchar] = ACTIONS(930),
    [anon_sym_ushort] = ACTIONS(930),
    [anon_sym_int] = ACTIONS(930),
    [anon_sym_uint] = ACTIONS(930),
    [anon_sym_ulong] = ACTIONS(930),
    [anon_sym_float] = ACTIONS(930),
    [anon_sym_double] = ACTIONS(930),
    [anon_sym_half] = ACTIONS(930),
    [anon_sym_size_t] = ACTIONS(930),
    [anon_sym_ptrdiff_t] = ACTIONS(930),
    [anon_sym_intptr_t] = ACTIONS(930),
    [anon_sym_uintptr_t] = ACTIONS(930),
    [anon_sym_void] = ACTIONS(930),
    [sym_vector_type] = ACTIONS(930),
    [anon_sym_image2d_t] = ACTIONS(930),
    [anon_sym_image3d_t] = ACTIONS(930),
    [anon_sym_image2d_array_t] = ACTIONS(930),
    [anon_sym_image1d_t] = ACTIONS(930),
    [anon_sym_image1d_buffer_t] = ACTIONS(930),
    [anon_sym_image1d_array_t] = ACTIONS(930),
    [anon_sym_image2d_depth_t] = ACTIONS(930),
    [anon_sym_image2d_array_depth_t] = ACTIONS(930),
    [anon_sym_sampler_t] = ACTIONS(930),
    [anon_sym_queue_t] = ACTIONS(930),
    [anon_sym_ndrange_t] = ACTIONS(930),
    [anon_sym_clk_event_t] = ACTIONS(930),
    [anon_sym_reserve_id_t] = ACTIONS(930),
    [anon_sym_event_t] = ACTIONS(930),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(930),
    [anon_sym_enum] = ACTIONS(930),
    [anon_sym_struct] = ACTIONS(930),
    [anon_sym_union] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_else] = ACTIONS(930),
    [anon_sym_switch] = ACTIONS(930),
    [anon_sym_case] = ACTIONS(930),
    [anon_sym_default] = ACTIONS(930),
    [anon_sym_while] = ACTIONS(930),
    [anon_sym_do] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(930),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_break] = ACTIONS(930),
    [anon_sym_continue] = ACTIONS(930),
    [anon_sym_goto] = ACTIONS(930),
    [anon_sym_DASH_DASH] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_sizeof] = ACTIONS(930),
    [sym_number_literal] = ACTIONS(932),
    [anon_sym_L_SQUOTE] = ACTIONS(932),
    [anon_sym_u_SQUOTE] = ACTIONS(932),
    [anon_sym_U_SQUOTE] = ACTIONS(932),
    [anon_sym_u8_SQUOTE] = ACTIONS(932),
    [anon_sym_SQUOTE] = ACTIONS(932),
    [anon_sym_L_DQUOTE] = ACTIONS(932),
    [anon_sym_u_DQUOTE] = ACTIONS(932),
    [anon_sym_U_DQUOTE] = ACTIONS(932),
    [anon_sym_u8_DQUOTE] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_true] = ACTIONS(930),
    [sym_false] = ACTIONS(930),
    [sym_null] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_identifier] = ACTIONS(934),
    [aux_sym_preproc_include_token1] = ACTIONS(934),
    [aux_sym_preproc_def_token1] = ACTIONS(934),
    [aux_sym_preproc_if_token1] = ACTIONS(934),
    [aux_sym_preproc_if_token2] = ACTIONS(934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(934),
    [aux_sym_preproc_else_token1] = ACTIONS(934),
    [aux_sym_preproc_elif_token1] = ACTIONS(934),
    [sym_preproc_directive] = ACTIONS(934),
    [anon_sym_LPAREN2] = ACTIONS(936),
    [anon_sym_BANG] = ACTIONS(936),
    [anon_sym_TILDE] = ACTIONS(936),
    [anon_sym_DASH] = ACTIONS(934),
    [anon_sym_PLUS] = ACTIONS(934),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_AMP] = ACTIONS(936),
    [anon_sym_SEMI] = ACTIONS(936),
    [anon_sym_typedef] = ACTIONS(934),
    [anon_sym_kernel] = ACTIONS(934),
    [anon_sym___kernel] = ACTIONS(934),
    [anon_sym_global] = ACTIONS(934),
    [anon_sym___global] = ACTIONS(934),
    [anon_sym_local] = ACTIONS(934),
    [anon_sym___local] = ACTIONS(934),
    [anon_sym_constant] = ACTIONS(934),
    [anon_sym___constant] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym___private] = ACTIONS(934),
    [anon_sym_generic] = ACTIONS(934),
    [anon_sym___generic] = ACTIONS(934),
    [anon_sym_read_only] = ACTIONS(934),
    [anon_sym___read_only] = ACTIONS(934),
    [anon_sym_write_only] = ACTIONS(934),
    [anon_sym___write_only] = ACTIONS(934),
    [anon_sym_read_write] = ACTIONS(934),
    [anon_sym___read_write] = ACTIONS(934),
    [anon_sym_extern] = ACTIONS(934),
    [anon_sym___attribute__] = ACTIONS(934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(936),
    [anon_sym___declspec] = ACTIONS(934),
    [anon_sym___cdecl] = ACTIONS(934),
    [anon_sym___clrcall] = ACTIONS(934),
    [anon_sym___stdcall] = ACTIONS(934),
    [anon_sym___fastcall] = ACTIONS(934),
    [anon_sym___thiscall] = ACTIONS(934),
    [anon_sym___vectorcall] = ACTIONS(934),
    [anon_sym_LBRACE] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_auto] = ACTIONS(934),
    [anon_sym_register] = ACTIONS(934),
    [anon_sym_inline] = ACTIONS(934),
    [anon_sym_const] = ACTIONS(934),
    [anon_sym_volatile] = ACTIONS(934),
    [anon_sym_restrict] = ACTIONS(934),
    [anon_sym__Atomic] = ACTIONS(934),
    [anon_sym_pipe] = ACTIONS(934),
    [anon_sym_signed] = ACTIONS(934),
    [anon_sym_unsigned] = ACTIONS(934),
    [anon_sym_long] = ACTIONS(934),
    [anon_sym_short] = ACTIONS(934),
    [anon_sym_bool] = ACTIONS(934),
    [anon_sym_char] = ACTIONS(934),
    [anon_sym_uchar] = ACTIONS(934),
    [anon_sym_ushort] = ACTIONS(934),
    [anon_sym_int] = ACTIONS(934),
    [anon_sym_uint] = ACTIONS(934),
    [anon_sym_ulong] = ACTIONS(934),
    [anon_sym_float] = ACTIONS(934),
    [anon_sym_double] = ACTIONS(934),
    [anon_sym_half] = ACTIONS(934),
    [anon_sym_size_t] = ACTIONS(934),
    [anon_sym_ptrdiff_t] = ACTIONS(934),
    [anon_sym_intptr_t] = ACTIONS(934),
    [anon_sym_uintptr_t] = ACTIONS(934),
    [anon_sym_void] = ACTIONS(934),
    [sym_vector_type] = ACTIONS(934),
    [anon_sym_image2d_t] = ACTIONS(934),
    [anon_sym_image3d_t] = ACTIONS(934),
    [anon_sym_image2d_array_t] = ACTIONS(934),
    [anon_sym_image1d_t] = ACTIONS(934),
    [anon_sym_image1d_buffer_t] = ACTIONS(934),
    [anon_sym_image1d_array_t] = ACTIONS(934),
    [anon_sym_image2d_depth_t] = ACTIONS(934),
    [anon_sym_image2d_array_depth_t] = ACTIONS(934),
    [anon_sym_sampler_t] = ACTIONS(934),
    [anon_sym_queue_t] = ACTIONS(934),
    [anon_sym_ndrange_t] = ACTIONS(934),
    [anon_sym_clk_event_t] = ACTIONS(934),
    [anon_sym_reserve_id_t] = ACTIONS(934),
    [anon_sym_event_t] = ACTIONS(934),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(934),
    [anon_sym_enum] = ACTIONS(934),
    [anon_sym_struct] = ACTIONS(934),
    [anon_sym_union] = ACTIONS(934),
    [anon_sym_if] = ACTIONS(934),
    [anon_sym_else] = ACTIONS(934),
    [anon_sym_switch] = ACTIONS(934),
    [anon_sym_case] = ACTIONS(934),
    [anon_sym_default] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(934),
    [anon_sym_do] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(934),
    [anon_sym_return] = ACTIONS(934),
    [anon_sym_break] = ACTIONS(934),
    [anon_sym_continue] = ACTIONS(934),
    [anon_sym_goto] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(936),
    [anon_sym_PLUS_PLUS] = ACTIONS(936),
    [anon_sym_sizeof] = ACTIONS(934),
    [sym_number_literal] = ACTIONS(936),
    [anon_sym_L_SQUOTE] = ACTIONS(936),
    [anon_sym_u_SQUOTE] = ACTIONS(936),
    [anon_sym_U_SQUOTE] = ACTIONS(936),
    [anon_sym_u8_SQUOTE] = ACTIONS(936),
    [anon_sym_SQUOTE] = ACTIONS(936),
    [anon_sym_L_DQUOTE] = ACTIONS(936),
    [anon_sym_u_DQUOTE] = ACTIONS(936),
    [anon_sym_U_DQUOTE] = ACTIONS(936),
    [anon_sym_u8_DQUOTE] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(936),
    [sym_true] = ACTIONS(934),
    [sym_false] = ACTIONS(934),
    [sym_null] = ACTIONS(934),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_identifier] = ACTIONS(938),
    [aux_sym_preproc_include_token1] = ACTIONS(938),
    [aux_sym_preproc_def_token1] = ACTIONS(938),
    [aux_sym_preproc_if_token1] = ACTIONS(938),
    [aux_sym_preproc_if_token2] = ACTIONS(938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(938),
    [aux_sym_preproc_else_token1] = ACTIONS(938),
    [aux_sym_preproc_elif_token1] = ACTIONS(938),
    [sym_preproc_directive] = ACTIONS(938),
    [anon_sym_LPAREN2] = ACTIONS(940),
    [anon_sym_BANG] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_DASH] = ACTIONS(938),
    [anon_sym_PLUS] = ACTIONS(938),
    [anon_sym_STAR] = ACTIONS(940),
    [anon_sym_AMP] = ACTIONS(940),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_typedef] = ACTIONS(938),
    [anon_sym_kernel] = ACTIONS(938),
    [anon_sym___kernel] = ACTIONS(938),
    [anon_sym_global] = ACTIONS(938),
    [anon_sym___global] = ACTIONS(938),
    [anon_sym_local] = ACTIONS(938),
    [anon_sym___local] = ACTIONS(938),
    [anon_sym_constant] = ACTIONS(938),
    [anon_sym___constant] = ACTIONS(938),
    [anon_sym_private] = ACTIONS(938),
    [anon_sym___private] = ACTIONS(938),
    [anon_sym_generic] = ACTIONS(938),
    [anon_sym___generic] = ACTIONS(938),
    [anon_sym_read_only] = ACTIONS(938),
    [anon_sym___read_only] = ACTIONS(938),
    [anon_sym_write_only] = ACTIONS(938),
    [anon_sym___write_only] = ACTIONS(938),
    [anon_sym_read_write] = ACTIONS(938),
    [anon_sym___read_write] = ACTIONS(938),
    [anon_sym_extern] = ACTIONS(938),
    [anon_sym___attribute__] = ACTIONS(938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(940),
    [anon_sym___declspec] = ACTIONS(938),
    [anon_sym___cdecl] = ACTIONS(938),
    [anon_sym___clrcall] = ACTIONS(938),
    [anon_sym___stdcall] = ACTIONS(938),
    [anon_sym___fastcall] = ACTIONS(938),
    [anon_sym___thiscall] = ACTIONS(938),
    [anon_sym___vectorcall] = ACTIONS(938),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_static] = ACTIONS(938),
    [anon_sym_auto] = ACTIONS(938),
    [anon_sym_register] = ACTIONS(938),
    [anon_sym_inline] = ACTIONS(938),
    [anon_sym_const] = ACTIONS(938),
    [anon_sym_volatile] = ACTIONS(938),
    [anon_sym_restrict] = ACTIONS(938),
    [anon_sym__Atomic] = ACTIONS(938),
    [anon_sym_pipe] = ACTIONS(938),
    [anon_sym_signed] = ACTIONS(938),
    [anon_sym_unsigned] = ACTIONS(938),
    [anon_sym_long] = ACTIONS(938),
    [anon_sym_short] = ACTIONS(938),
    [anon_sym_bool] = ACTIONS(938),
    [anon_sym_char] = ACTIONS(938),
    [anon_sym_uchar] = ACTIONS(938),
    [anon_sym_ushort] = ACTIONS(938),
    [anon_sym_int] = ACTIONS(938),
    [anon_sym_uint] = ACTIONS(938),
    [anon_sym_ulong] = ACTIONS(938),
    [anon_sym_float] = ACTIONS(938),
    [anon_sym_double] = ACTIONS(938),
    [anon_sym_half] = ACTIONS(938),
    [anon_sym_size_t] = ACTIONS(938),
    [anon_sym_ptrdiff_t] = ACTIONS(938),
    [anon_sym_intptr_t] = ACTIONS(938),
    [anon_sym_uintptr_t] = ACTIONS(938),
    [anon_sym_void] = ACTIONS(938),
    [sym_vector_type] = ACTIONS(938),
    [anon_sym_image2d_t] = ACTIONS(938),
    [anon_sym_image3d_t] = ACTIONS(938),
    [anon_sym_image2d_array_t] = ACTIONS(938),
    [anon_sym_image1d_t] = ACTIONS(938),
    [anon_sym_image1d_buffer_t] = ACTIONS(938),
    [anon_sym_image1d_array_t] = ACTIONS(938),
    [anon_sym_image2d_depth_t] = ACTIONS(938),
    [anon_sym_image2d_array_depth_t] = ACTIONS(938),
    [anon_sym_sampler_t] = ACTIONS(938),
    [anon_sym_queue_t] = ACTIONS(938),
    [anon_sym_ndrange_t] = ACTIONS(938),
    [anon_sym_clk_event_t] = ACTIONS(938),
    [anon_sym_reserve_id_t] = ACTIONS(938),
    [anon_sym_event_t] = ACTIONS(938),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(938),
    [anon_sym_enum] = ACTIONS(938),
    [anon_sym_struct] = ACTIONS(938),
    [anon_sym_union] = ACTIONS(938),
    [anon_sym_if] = ACTIONS(938),
    [anon_sym_else] = ACTIONS(938),
    [anon_sym_switch] = ACTIONS(938),
    [anon_sym_case] = ACTIONS(938),
    [anon_sym_default] = ACTIONS(938),
    [anon_sym_while] = ACTIONS(938),
    [anon_sym_do] = ACTIONS(938),
    [anon_sym_for] = ACTIONS(938),
    [anon_sym_return] = ACTIONS(938),
    [anon_sym_break] = ACTIONS(938),
    [anon_sym_continue] = ACTIONS(938),
    [anon_sym_goto] = ACTIONS(938),
    [anon_sym_DASH_DASH] = ACTIONS(940),
    [anon_sym_PLUS_PLUS] = ACTIONS(940),
    [anon_sym_sizeof] = ACTIONS(938),
    [sym_number_literal] = ACTIONS(940),
    [anon_sym_L_SQUOTE] = ACTIONS(940),
    [anon_sym_u_SQUOTE] = ACTIONS(940),
    [anon_sym_U_SQUOTE] = ACTIONS(940),
    [anon_sym_u8_SQUOTE] = ACTIONS(940),
    [anon_sym_SQUOTE] = ACTIONS(940),
    [anon_sym_L_DQUOTE] = ACTIONS(940),
    [anon_sym_u_DQUOTE] = ACTIONS(940),
    [anon_sym_U_DQUOTE] = ACTIONS(940),
    [anon_sym_u8_DQUOTE] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(940),
    [sym_true] = ACTIONS(938),
    [sym_false] = ACTIONS(938),
    [sym_null] = ACTIONS(938),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_identifier] = ACTIONS(942),
    [aux_sym_preproc_include_token1] = ACTIONS(942),
    [aux_sym_preproc_def_token1] = ACTIONS(942),
    [aux_sym_preproc_if_token1] = ACTIONS(942),
    [aux_sym_preproc_if_token2] = ACTIONS(942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(942),
    [aux_sym_preproc_else_token1] = ACTIONS(942),
    [aux_sym_preproc_elif_token1] = ACTIONS(942),
    [sym_preproc_directive] = ACTIONS(942),
    [anon_sym_LPAREN2] = ACTIONS(944),
    [anon_sym_BANG] = ACTIONS(944),
    [anon_sym_TILDE] = ACTIONS(944),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_STAR] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_typedef] = ACTIONS(942),
    [anon_sym_kernel] = ACTIONS(942),
    [anon_sym___kernel] = ACTIONS(942),
    [anon_sym_global] = ACTIONS(942),
    [anon_sym___global] = ACTIONS(942),
    [anon_sym_local] = ACTIONS(942),
    [anon_sym___local] = ACTIONS(942),
    [anon_sym_constant] = ACTIONS(942),
    [anon_sym___constant] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym___private] = ACTIONS(942),
    [anon_sym_generic] = ACTIONS(942),
    [anon_sym___generic] = ACTIONS(942),
    [anon_sym_read_only] = ACTIONS(942),
    [anon_sym___read_only] = ACTIONS(942),
    [anon_sym_write_only] = ACTIONS(942),
    [anon_sym___write_only] = ACTIONS(942),
    [anon_sym_read_write] = ACTIONS(942),
    [anon_sym___read_write] = ACTIONS(942),
    [anon_sym_extern] = ACTIONS(942),
    [anon_sym___attribute__] = ACTIONS(942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(944),
    [anon_sym___declspec] = ACTIONS(942),
    [anon_sym___cdecl] = ACTIONS(942),
    [anon_sym___clrcall] = ACTIONS(942),
    [anon_sym___stdcall] = ACTIONS(942),
    [anon_sym___fastcall] = ACTIONS(942),
    [anon_sym___thiscall] = ACTIONS(942),
    [anon_sym___vectorcall] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_auto] = ACTIONS(942),
    [anon_sym_register] = ACTIONS(942),
    [anon_sym_inline] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_volatile] = ACTIONS(942),
    [anon_sym_restrict] = ACTIONS(942),
    [anon_sym__Atomic] = ACTIONS(942),
    [anon_sym_pipe] = ACTIONS(942),
    [anon_sym_signed] = ACTIONS(942),
    [anon_sym_unsigned] = ACTIONS(942),
    [anon_sym_long] = ACTIONS(942),
    [anon_sym_short] = ACTIONS(942),
    [anon_sym_bool] = ACTIONS(942),
    [anon_sym_char] = ACTIONS(942),
    [anon_sym_uchar] = ACTIONS(942),
    [anon_sym_ushort] = ACTIONS(942),
    [anon_sym_int] = ACTIONS(942),
    [anon_sym_uint] = ACTIONS(942),
    [anon_sym_ulong] = ACTIONS(942),
    [anon_sym_float] = ACTIONS(942),
    [anon_sym_double] = ACTIONS(942),
    [anon_sym_half] = ACTIONS(942),
    [anon_sym_size_t] = ACTIONS(942),
    [anon_sym_ptrdiff_t] = ACTIONS(942),
    [anon_sym_intptr_t] = ACTIONS(942),
    [anon_sym_uintptr_t] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(942),
    [sym_vector_type] = ACTIONS(942),
    [anon_sym_image2d_t] = ACTIONS(942),
    [anon_sym_image3d_t] = ACTIONS(942),
    [anon_sym_image2d_array_t] = ACTIONS(942),
    [anon_sym_image1d_t] = ACTIONS(942),
    [anon_sym_image1d_buffer_t] = ACTIONS(942),
    [anon_sym_image1d_array_t] = ACTIONS(942),
    [anon_sym_image2d_depth_t] = ACTIONS(942),
    [anon_sym_image2d_array_depth_t] = ACTIONS(942),
    [anon_sym_sampler_t] = ACTIONS(942),
    [anon_sym_queue_t] = ACTIONS(942),
    [anon_sym_ndrange_t] = ACTIONS(942),
    [anon_sym_clk_event_t] = ACTIONS(942),
    [anon_sym_reserve_id_t] = ACTIONS(942),
    [anon_sym_event_t] = ACTIONS(942),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_struct] = ACTIONS(942),
    [anon_sym_union] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_else] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(942),
    [anon_sym_case] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_do] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_goto] = ACTIONS(942),
    [anon_sym_DASH_DASH] = ACTIONS(944),
    [anon_sym_PLUS_PLUS] = ACTIONS(944),
    [anon_sym_sizeof] = ACTIONS(942),
    [sym_number_literal] = ACTIONS(944),
    [anon_sym_L_SQUOTE] = ACTIONS(944),
    [anon_sym_u_SQUOTE] = ACTIONS(944),
    [anon_sym_U_SQUOTE] = ACTIONS(944),
    [anon_sym_u8_SQUOTE] = ACTIONS(944),
    [anon_sym_SQUOTE] = ACTIONS(944),
    [anon_sym_L_DQUOTE] = ACTIONS(944),
    [anon_sym_u_DQUOTE] = ACTIONS(944),
    [anon_sym_U_DQUOTE] = ACTIONS(944),
    [anon_sym_u8_DQUOTE] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(944),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_null] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_identifier] = ACTIONS(946),
    [aux_sym_preproc_include_token1] = ACTIONS(946),
    [aux_sym_preproc_def_token1] = ACTIONS(946),
    [aux_sym_preproc_if_token1] = ACTIONS(946),
    [aux_sym_preproc_if_token2] = ACTIONS(946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(946),
    [aux_sym_preproc_else_token1] = ACTIONS(946),
    [aux_sym_preproc_elif_token1] = ACTIONS(946),
    [sym_preproc_directive] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(948),
    [anon_sym_AMP] = ACTIONS(948),
    [anon_sym_SEMI] = ACTIONS(948),
    [anon_sym_typedef] = ACTIONS(946),
    [anon_sym_kernel] = ACTIONS(946),
    [anon_sym___kernel] = ACTIONS(946),
    [anon_sym_global] = ACTIONS(946),
    [anon_sym___global] = ACTIONS(946),
    [anon_sym_local] = ACTIONS(946),
    [anon_sym___local] = ACTIONS(946),
    [anon_sym_constant] = ACTIONS(946),
    [anon_sym___constant] = ACTIONS(946),
    [anon_sym_private] = ACTIONS(946),
    [anon_sym___private] = ACTIONS(946),
    [anon_sym_generic] = ACTIONS(946),
    [anon_sym___generic] = ACTIONS(946),
    [anon_sym_read_only] = ACTIONS(946),
    [anon_sym___read_only] = ACTIONS(946),
    [anon_sym_write_only] = ACTIONS(946),
    [anon_sym___write_only] = ACTIONS(946),
    [anon_sym_read_write] = ACTIONS(946),
    [anon_sym___read_write] = ACTIONS(946),
    [anon_sym_extern] = ACTIONS(946),
    [anon_sym___attribute__] = ACTIONS(946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(948),
    [anon_sym___declspec] = ACTIONS(946),
    [anon_sym___cdecl] = ACTIONS(946),
    [anon_sym___clrcall] = ACTIONS(946),
    [anon_sym___stdcall] = ACTIONS(946),
    [anon_sym___fastcall] = ACTIONS(946),
    [anon_sym___thiscall] = ACTIONS(946),
    [anon_sym___vectorcall] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_auto] = ACTIONS(946),
    [anon_sym_register] = ACTIONS(946),
    [anon_sym_inline] = ACTIONS(946),
    [anon_sym_const] = ACTIONS(946),
    [anon_sym_volatile] = ACTIONS(946),
    [anon_sym_restrict] = ACTIONS(946),
    [anon_sym__Atomic] = ACTIONS(946),
    [anon_sym_pipe] = ACTIONS(946),
    [anon_sym_signed] = ACTIONS(946),
    [anon_sym_unsigned] = ACTIONS(946),
    [anon_sym_long] = ACTIONS(946),
    [anon_sym_short] = ACTIONS(946),
    [anon_sym_bool] = ACTIONS(946),
    [anon_sym_char] = ACTIONS(946),
    [anon_sym_uchar] = ACTIONS(946),
    [anon_sym_ushort] = ACTIONS(946),
    [anon_sym_int] = ACTIONS(946),
    [anon_sym_uint] = ACTIONS(946),
    [anon_sym_ulong] = ACTIONS(946),
    [anon_sym_float] = ACTIONS(946),
    [anon_sym_double] = ACTIONS(946),
    [anon_sym_half] = ACTIONS(946),
    [anon_sym_size_t] = ACTIONS(946),
    [anon_sym_ptrdiff_t] = ACTIONS(946),
    [anon_sym_intptr_t] = ACTIONS(946),
    [anon_sym_uintptr_t] = ACTIONS(946),
    [anon_sym_void] = ACTIONS(946),
    [sym_vector_type] = ACTIONS(946),
    [anon_sym_image2d_t] = ACTIONS(946),
    [anon_sym_image3d_t] = ACTIONS(946),
    [anon_sym_image2d_array_t] = ACTIONS(946),
    [anon_sym_image1d_t] = ACTIONS(946),
    [anon_sym_image1d_buffer_t] = ACTIONS(946),
    [anon_sym_image1d_array_t] = ACTIONS(946),
    [anon_sym_image2d_depth_t] = ACTIONS(946),
    [anon_sym_image2d_array_depth_t] = ACTIONS(946),
    [anon_sym_sampler_t] = ACTIONS(946),
    [anon_sym_queue_t] = ACTIONS(946),
    [anon_sym_ndrange_t] = ACTIONS(946),
    [anon_sym_clk_event_t] = ACTIONS(946),
    [anon_sym_reserve_id_t] = ACTIONS(946),
    [anon_sym_event_t] = ACTIONS(946),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_struct] = ACTIONS(946),
    [anon_sym_union] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(946),
    [anon_sym_default] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_break] = ACTIONS(946),
    [anon_sym_continue] = ACTIONS(946),
    [anon_sym_goto] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(948),
    [anon_sym_sizeof] = ACTIONS(946),
    [sym_number_literal] = ACTIONS(948),
    [anon_sym_L_SQUOTE] = ACTIONS(948),
    [anon_sym_u_SQUOTE] = ACTIONS(948),
    [anon_sym_U_SQUOTE] = ACTIONS(948),
    [anon_sym_u8_SQUOTE] = ACTIONS(948),
    [anon_sym_SQUOTE] = ACTIONS(948),
    [anon_sym_L_DQUOTE] = ACTIONS(948),
    [anon_sym_u_DQUOTE] = ACTIONS(948),
    [anon_sym_U_DQUOTE] = ACTIONS(948),
    [anon_sym_u8_DQUOTE] = ACTIONS(948),
    [anon_sym_DQUOTE] = ACTIONS(948),
    [sym_true] = ACTIONS(946),
    [sym_false] = ACTIONS(946),
    [sym_null] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_identifier] = ACTIONS(950),
    [aux_sym_preproc_include_token1] = ACTIONS(950),
    [aux_sym_preproc_def_token1] = ACTIONS(950),
    [aux_sym_preproc_if_token1] = ACTIONS(950),
    [aux_sym_preproc_if_token2] = ACTIONS(950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(950),
    [aux_sym_preproc_else_token1] = ACTIONS(950),
    [aux_sym_preproc_elif_token1] = ACTIONS(950),
    [sym_preproc_directive] = ACTIONS(950),
    [anon_sym_LPAREN2] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(952),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(952),
    [anon_sym_AMP] = ACTIONS(952),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_typedef] = ACTIONS(950),
    [anon_sym_kernel] = ACTIONS(950),
    [anon_sym___kernel] = ACTIONS(950),
    [anon_sym_global] = ACTIONS(950),
    [anon_sym___global] = ACTIONS(950),
    [anon_sym_local] = ACTIONS(950),
    [anon_sym___local] = ACTIONS(950),
    [anon_sym_constant] = ACTIONS(950),
    [anon_sym___constant] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym___private] = ACTIONS(950),
    [anon_sym_generic] = ACTIONS(950),
    [anon_sym___generic] = ACTIONS(950),
    [anon_sym_read_only] = ACTIONS(950),
    [anon_sym___read_only] = ACTIONS(950),
    [anon_sym_write_only] = ACTIONS(950),
    [anon_sym___write_only] = ACTIONS(950),
    [anon_sym_read_write] = ACTIONS(950),
    [anon_sym___read_write] = ACTIONS(950),
    [anon_sym_extern] = ACTIONS(950),
    [anon_sym___attribute__] = ACTIONS(950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(952),
    [anon_sym___declspec] = ACTIONS(950),
    [anon_sym___cdecl] = ACTIONS(950),
    [anon_sym___clrcall] = ACTIONS(950),
    [anon_sym___stdcall] = ACTIONS(950),
    [anon_sym___fastcall] = ACTIONS(950),
    [anon_sym___thiscall] = ACTIONS(950),
    [anon_sym___vectorcall] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(952),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_auto] = ACTIONS(950),
    [anon_sym_register] = ACTIONS(950),
    [anon_sym_inline] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(950),
    [anon_sym_volatile] = ACTIONS(950),
    [anon_sym_restrict] = ACTIONS(950),
    [anon_sym__Atomic] = ACTIONS(950),
    [anon_sym_pipe] = ACTIONS(950),
    [anon_sym_signed] = ACTIONS(950),
    [anon_sym_unsigned] = ACTIONS(950),
    [anon_sym_long] = ACTIONS(950),
    [anon_sym_short] = ACTIONS(950),
    [anon_sym_bool] = ACTIONS(950),
    [anon_sym_char] = ACTIONS(950),
    [anon_sym_uchar] = ACTIONS(950),
    [anon_sym_ushort] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(950),
    [anon_sym_uint] = ACTIONS(950),
    [anon_sym_ulong] = ACTIONS(950),
    [anon_sym_float] = ACTIONS(950),
    [anon_sym_double] = ACTIONS(950),
    [anon_sym_half] = ACTIONS(950),
    [anon_sym_size_t] = ACTIONS(950),
    [anon_sym_ptrdiff_t] = ACTIONS(950),
    [anon_sym_intptr_t] = ACTIONS(950),
    [anon_sym_uintptr_t] = ACTIONS(950),
    [anon_sym_void] = ACTIONS(950),
    [sym_vector_type] = ACTIONS(950),
    [anon_sym_image2d_t] = ACTIONS(950),
    [anon_sym_image3d_t] = ACTIONS(950),
    [anon_sym_image2d_array_t] = ACTIONS(950),
    [anon_sym_image1d_t] = ACTIONS(950),
    [anon_sym_image1d_buffer_t] = ACTIONS(950),
    [anon_sym_image1d_array_t] = ACTIONS(950),
    [anon_sym_image2d_depth_t] = ACTIONS(950),
    [anon_sym_image2d_array_depth_t] = ACTIONS(950),
    [anon_sym_sampler_t] = ACTIONS(950),
    [anon_sym_queue_t] = ACTIONS(950),
    [anon_sym_ndrange_t] = ACTIONS(950),
    [anon_sym_clk_event_t] = ACTIONS(950),
    [anon_sym_reserve_id_t] = ACTIONS(950),
    [anon_sym_event_t] = ACTIONS(950),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_struct] = ACTIONS(950),
    [anon_sym_union] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(950),
    [anon_sym_else] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(950),
    [anon_sym_case] = ACTIONS(950),
    [anon_sym_default] = ACTIONS(950),
    [anon_sym_while] = ACTIONS(950),
    [anon_sym_do] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(950),
    [anon_sym_return] = ACTIONS(950),
    [anon_sym_break] = ACTIONS(950),
    [anon_sym_continue] = ACTIONS(950),
    [anon_sym_goto] = ACTIONS(950),
    [anon_sym_DASH_DASH] = ACTIONS(952),
    [anon_sym_PLUS_PLUS] = ACTIONS(952),
    [anon_sym_sizeof] = ACTIONS(950),
    [sym_number_literal] = ACTIONS(952),
    [anon_sym_L_SQUOTE] = ACTIONS(952),
    [anon_sym_u_SQUOTE] = ACTIONS(952),
    [anon_sym_U_SQUOTE] = ACTIONS(952),
    [anon_sym_u8_SQUOTE] = ACTIONS(952),
    [anon_sym_SQUOTE] = ACTIONS(952),
    [anon_sym_L_DQUOTE] = ACTIONS(952),
    [anon_sym_u_DQUOTE] = ACTIONS(952),
    [anon_sym_U_DQUOTE] = ACTIONS(952),
    [anon_sym_u8_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(952),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_null] = ACTIONS(950),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_identifier] = ACTIONS(954),
    [aux_sym_preproc_include_token1] = ACTIONS(954),
    [aux_sym_preproc_def_token1] = ACTIONS(954),
    [aux_sym_preproc_if_token1] = ACTIONS(954),
    [aux_sym_preproc_if_token2] = ACTIONS(954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(954),
    [aux_sym_preproc_else_token1] = ACTIONS(954),
    [aux_sym_preproc_elif_token1] = ACTIONS(954),
    [sym_preproc_directive] = ACTIONS(954),
    [anon_sym_LPAREN2] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_STAR] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(956),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_typedef] = ACTIONS(954),
    [anon_sym_kernel] = ACTIONS(954),
    [anon_sym___kernel] = ACTIONS(954),
    [anon_sym_global] = ACTIONS(954),
    [anon_sym___global] = ACTIONS(954),
    [anon_sym_local] = ACTIONS(954),
    [anon_sym___local] = ACTIONS(954),
    [anon_sym_constant] = ACTIONS(954),
    [anon_sym___constant] = ACTIONS(954),
    [anon_sym_private] = ACTIONS(954),
    [anon_sym___private] = ACTIONS(954),
    [anon_sym_generic] = ACTIONS(954),
    [anon_sym___generic] = ACTIONS(954),
    [anon_sym_read_only] = ACTIONS(954),
    [anon_sym___read_only] = ACTIONS(954),
    [anon_sym_write_only] = ACTIONS(954),
    [anon_sym___write_only] = ACTIONS(954),
    [anon_sym_read_write] = ACTIONS(954),
    [anon_sym___read_write] = ACTIONS(954),
    [anon_sym_extern] = ACTIONS(954),
    [anon_sym___attribute__] = ACTIONS(954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(956),
    [anon_sym___declspec] = ACTIONS(954),
    [anon_sym___cdecl] = ACTIONS(954),
    [anon_sym___clrcall] = ACTIONS(954),
    [anon_sym___stdcall] = ACTIONS(954),
    [anon_sym___fastcall] = ACTIONS(954),
    [anon_sym___thiscall] = ACTIONS(954),
    [anon_sym___vectorcall] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(954),
    [anon_sym_auto] = ACTIONS(954),
    [anon_sym_register] = ACTIONS(954),
    [anon_sym_inline] = ACTIONS(954),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym_pipe] = ACTIONS(954),
    [anon_sym_signed] = ACTIONS(954),
    [anon_sym_unsigned] = ACTIONS(954),
    [anon_sym_long] = ACTIONS(954),
    [anon_sym_short] = ACTIONS(954),
    [anon_sym_bool] = ACTIONS(954),
    [anon_sym_char] = ACTIONS(954),
    [anon_sym_uchar] = ACTIONS(954),
    [anon_sym_ushort] = ACTIONS(954),
    [anon_sym_int] = ACTIONS(954),
    [anon_sym_uint] = ACTIONS(954),
    [anon_sym_ulong] = ACTIONS(954),
    [anon_sym_float] = ACTIONS(954),
    [anon_sym_double] = ACTIONS(954),
    [anon_sym_half] = ACTIONS(954),
    [anon_sym_size_t] = ACTIONS(954),
    [anon_sym_ptrdiff_t] = ACTIONS(954),
    [anon_sym_intptr_t] = ACTIONS(954),
    [anon_sym_uintptr_t] = ACTIONS(954),
    [anon_sym_void] = ACTIONS(954),
    [sym_vector_type] = ACTIONS(954),
    [anon_sym_image2d_t] = ACTIONS(954),
    [anon_sym_image3d_t] = ACTIONS(954),
    [anon_sym_image2d_array_t] = ACTIONS(954),
    [anon_sym_image1d_t] = ACTIONS(954),
    [anon_sym_image1d_buffer_t] = ACTIONS(954),
    [anon_sym_image1d_array_t] = ACTIONS(954),
    [anon_sym_image2d_depth_t] = ACTIONS(954),
    [anon_sym_image2d_array_depth_t] = ACTIONS(954),
    [anon_sym_sampler_t] = ACTIONS(954),
    [anon_sym_queue_t] = ACTIONS(954),
    [anon_sym_ndrange_t] = ACTIONS(954),
    [anon_sym_clk_event_t] = ACTIONS(954),
    [anon_sym_reserve_id_t] = ACTIONS(954),
    [anon_sym_event_t] = ACTIONS(954),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(954),
    [anon_sym_enum] = ACTIONS(954),
    [anon_sym_struct] = ACTIONS(954),
    [anon_sym_union] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_else] = ACTIONS(954),
    [anon_sym_switch] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(954),
    [anon_sym_default] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(954),
    [anon_sym_do] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_break] = ACTIONS(954),
    [anon_sym_continue] = ACTIONS(954),
    [anon_sym_goto] = ACTIONS(954),
    [anon_sym_DASH_DASH] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(956),
    [anon_sym_sizeof] = ACTIONS(954),
    [sym_number_literal] = ACTIONS(956),
    [anon_sym_L_SQUOTE] = ACTIONS(956),
    [anon_sym_u_SQUOTE] = ACTIONS(956),
    [anon_sym_U_SQUOTE] = ACTIONS(956),
    [anon_sym_u8_SQUOTE] = ACTIONS(956),
    [anon_sym_SQUOTE] = ACTIONS(956),
    [anon_sym_L_DQUOTE] = ACTIONS(956),
    [anon_sym_u_DQUOTE] = ACTIONS(956),
    [anon_sym_U_DQUOTE] = ACTIONS(956),
    [anon_sym_u8_DQUOTE] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(956),
    [sym_true] = ACTIONS(954),
    [sym_false] = ACTIONS(954),
    [sym_null] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_identifier] = ACTIONS(958),
    [aux_sym_preproc_include_token1] = ACTIONS(958),
    [aux_sym_preproc_def_token1] = ACTIONS(958),
    [aux_sym_preproc_if_token1] = ACTIONS(958),
    [aux_sym_preproc_if_token2] = ACTIONS(958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(958),
    [aux_sym_preproc_else_token1] = ACTIONS(958),
    [aux_sym_preproc_elif_token1] = ACTIONS(958),
    [sym_preproc_directive] = ACTIONS(958),
    [anon_sym_LPAREN2] = ACTIONS(960),
    [anon_sym_BANG] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(960),
    [anon_sym_AMP] = ACTIONS(960),
    [anon_sym_SEMI] = ACTIONS(960),
    [anon_sym_typedef] = ACTIONS(958),
    [anon_sym_kernel] = ACTIONS(958),
    [anon_sym___kernel] = ACTIONS(958),
    [anon_sym_global] = ACTIONS(958),
    [anon_sym___global] = ACTIONS(958),
    [anon_sym_local] = ACTIONS(958),
    [anon_sym___local] = ACTIONS(958),
    [anon_sym_constant] = ACTIONS(958),
    [anon_sym___constant] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym___private] = ACTIONS(958),
    [anon_sym_generic] = ACTIONS(958),
    [anon_sym___generic] = ACTIONS(958),
    [anon_sym_read_only] = ACTIONS(958),
    [anon_sym___read_only] = ACTIONS(958),
    [anon_sym_write_only] = ACTIONS(958),
    [anon_sym___write_only] = ACTIONS(958),
    [anon_sym_read_write] = ACTIONS(958),
    [anon_sym___read_write] = ACTIONS(958),
    [anon_sym_extern] = ACTIONS(958),
    [anon_sym___attribute__] = ACTIONS(958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(960),
    [anon_sym___declspec] = ACTIONS(958),
    [anon_sym___cdecl] = ACTIONS(958),
    [anon_sym___clrcall] = ACTIONS(958),
    [anon_sym___stdcall] = ACTIONS(958),
    [anon_sym___fastcall] = ACTIONS(958),
    [anon_sym___thiscall] = ACTIONS(958),
    [anon_sym___vectorcall] = ACTIONS(958),
    [anon_sym_LBRACE] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_auto] = ACTIONS(958),
    [anon_sym_register] = ACTIONS(958),
    [anon_sym_inline] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_volatile] = ACTIONS(958),
    [anon_sym_restrict] = ACTIONS(958),
    [anon_sym__Atomic] = ACTIONS(958),
    [anon_sym_pipe] = ACTIONS(958),
    [anon_sym_signed] = ACTIONS(958),
    [anon_sym_unsigned] = ACTIONS(958),
    [anon_sym_long] = ACTIONS(958),
    [anon_sym_short] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(958),
    [anon_sym_char] = ACTIONS(958),
    [anon_sym_uchar] = ACTIONS(958),
    [anon_sym_ushort] = ACTIONS(958),
    [anon_sym_int] = ACTIONS(958),
    [anon_sym_uint] = ACTIONS(958),
    [anon_sym_ulong] = ACTIONS(958),
    [anon_sym_float] = ACTIONS(958),
    [anon_sym_double] = ACTIONS(958),
    [anon_sym_half] = ACTIONS(958),
    [anon_sym_size_t] = ACTIONS(958),
    [anon_sym_ptrdiff_t] = ACTIONS(958),
    [anon_sym_intptr_t] = ACTIONS(958),
    [anon_sym_uintptr_t] = ACTIONS(958),
    [anon_sym_void] = ACTIONS(958),
    [sym_vector_type] = ACTIONS(958),
    [anon_sym_image2d_t] = ACTIONS(958),
    [anon_sym_image3d_t] = ACTIONS(958),
    [anon_sym_image2d_array_t] = ACTIONS(958),
    [anon_sym_image1d_t] = ACTIONS(958),
    [anon_sym_image1d_buffer_t] = ACTIONS(958),
    [anon_sym_image1d_array_t] = ACTIONS(958),
    [anon_sym_image2d_depth_t] = ACTIONS(958),
    [anon_sym_image2d_array_depth_t] = ACTIONS(958),
    [anon_sym_sampler_t] = ACTIONS(958),
    [anon_sym_queue_t] = ACTIONS(958),
    [anon_sym_ndrange_t] = ACTIONS(958),
    [anon_sym_clk_event_t] = ACTIONS(958),
    [anon_sym_reserve_id_t] = ACTIONS(958),
    [anon_sym_event_t] = ACTIONS(958),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_union] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(958),
    [anon_sym_case] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_do] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_goto] = ACTIONS(958),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_sizeof] = ACTIONS(958),
    [sym_number_literal] = ACTIONS(960),
    [anon_sym_L_SQUOTE] = ACTIONS(960),
    [anon_sym_u_SQUOTE] = ACTIONS(960),
    [anon_sym_U_SQUOTE] = ACTIONS(960),
    [anon_sym_u8_SQUOTE] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(960),
    [anon_sym_L_DQUOTE] = ACTIONS(960),
    [anon_sym_u_DQUOTE] = ACTIONS(960),
    [anon_sym_U_DQUOTE] = ACTIONS(960),
    [anon_sym_u8_DQUOTE] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(960),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_identifier] = ACTIONS(962),
    [aux_sym_preproc_include_token1] = ACTIONS(962),
    [aux_sym_preproc_def_token1] = ACTIONS(962),
    [aux_sym_preproc_if_token1] = ACTIONS(962),
    [aux_sym_preproc_if_token2] = ACTIONS(962),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(962),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(962),
    [aux_sym_preproc_else_token1] = ACTIONS(962),
    [aux_sym_preproc_elif_token1] = ACTIONS(962),
    [sym_preproc_directive] = ACTIONS(962),
    [anon_sym_LPAREN2] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(962),
    [anon_sym_PLUS] = ACTIONS(962),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_AMP] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(964),
    [anon_sym_typedef] = ACTIONS(962),
    [anon_sym_kernel] = ACTIONS(962),
    [anon_sym___kernel] = ACTIONS(962),
    [anon_sym_global] = ACTIONS(962),
    [anon_sym___global] = ACTIONS(962),
    [anon_sym_local] = ACTIONS(962),
    [anon_sym___local] = ACTIONS(962),
    [anon_sym_constant] = ACTIONS(962),
    [anon_sym___constant] = ACTIONS(962),
    [anon_sym_private] = ACTIONS(962),
    [anon_sym___private] = ACTIONS(962),
    [anon_sym_generic] = ACTIONS(962),
    [anon_sym___generic] = ACTIONS(962),
    [anon_sym_read_only] = ACTIONS(962),
    [anon_sym___read_only] = ACTIONS(962),
    [anon_sym_write_only] = ACTIONS(962),
    [anon_sym___write_only] = ACTIONS(962),
    [anon_sym_read_write] = ACTIONS(962),
    [anon_sym___read_write] = ACTIONS(962),
    [anon_sym_extern] = ACTIONS(962),
    [anon_sym___attribute__] = ACTIONS(962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(964),
    [anon_sym___declspec] = ACTIONS(962),
    [anon_sym___cdecl] = ACTIONS(962),
    [anon_sym___clrcall] = ACTIONS(962),
    [anon_sym___stdcall] = ACTIONS(962),
    [anon_sym___fastcall] = ACTIONS(962),
    [anon_sym___thiscall] = ACTIONS(962),
    [anon_sym___vectorcall] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_static] = ACTIONS(962),
    [anon_sym_auto] = ACTIONS(962),
    [anon_sym_register] = ACTIONS(962),
    [anon_sym_inline] = ACTIONS(962),
    [anon_sym_const] = ACTIONS(962),
    [anon_sym_volatile] = ACTIONS(962),
    [anon_sym_restrict] = ACTIONS(962),
    [anon_sym__Atomic] = ACTIONS(962),
    [anon_sym_pipe] = ACTIONS(962),
    [anon_sym_signed] = ACTIONS(962),
    [anon_sym_unsigned] = ACTIONS(962),
    [anon_sym_long] = ACTIONS(962),
    [anon_sym_short] = ACTIONS(962),
    [anon_sym_bool] = ACTIONS(962),
    [anon_sym_char] = ACTIONS(962),
    [anon_sym_uchar] = ACTIONS(962),
    [anon_sym_ushort] = ACTIONS(962),
    [anon_sym_int] = ACTIONS(962),
    [anon_sym_uint] = ACTIONS(962),
    [anon_sym_ulong] = ACTIONS(962),
    [anon_sym_float] = ACTIONS(962),
    [anon_sym_double] = ACTIONS(962),
    [anon_sym_half] = ACTIONS(962),
    [anon_sym_size_t] = ACTIONS(962),
    [anon_sym_ptrdiff_t] = ACTIONS(962),
    [anon_sym_intptr_t] = ACTIONS(962),
    [anon_sym_uintptr_t] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(962),
    [sym_vector_type] = ACTIONS(962),
    [anon_sym_image2d_t] = ACTIONS(962),
    [anon_sym_image3d_t] = ACTIONS(962),
    [anon_sym_image2d_array_t] = ACTIONS(962),
    [anon_sym_image1d_t] = ACTIONS(962),
    [anon_sym_image1d_buffer_t] = ACTIONS(962),
    [anon_sym_image1d_array_t] = ACTIONS(962),
    [anon_sym_image2d_depth_t] = ACTIONS(962),
    [anon_sym_image2d_array_depth_t] = ACTIONS(962),
    [anon_sym_sampler_t] = ACTIONS(962),
    [anon_sym_queue_t] = ACTIONS(962),
    [anon_sym_ndrange_t] = ACTIONS(962),
    [anon_sym_clk_event_t] = ACTIONS(962),
    [anon_sym_reserve_id_t] = ACTIONS(962),
    [anon_sym_event_t] = ACTIONS(962),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(962),
    [anon_sym_enum] = ACTIONS(962),
    [anon_sym_struct] = ACTIONS(962),
    [anon_sym_union] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(962),
    [anon_sym_switch] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(962),
    [anon_sym_default] = ACTIONS(962),
    [anon_sym_while] = ACTIONS(962),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_for] = ACTIONS(962),
    [anon_sym_return] = ACTIONS(962),
    [anon_sym_break] = ACTIONS(962),
    [anon_sym_continue] = ACTIONS(962),
    [anon_sym_goto] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(964),
    [anon_sym_sizeof] = ACTIONS(962),
    [sym_number_literal] = ACTIONS(964),
    [anon_sym_L_SQUOTE] = ACTIONS(964),
    [anon_sym_u_SQUOTE] = ACTIONS(964),
    [anon_sym_U_SQUOTE] = ACTIONS(964),
    [anon_sym_u8_SQUOTE] = ACTIONS(964),
    [anon_sym_SQUOTE] = ACTIONS(964),
    [anon_sym_L_DQUOTE] = ACTIONS(964),
    [anon_sym_u_DQUOTE] = ACTIONS(964),
    [anon_sym_U_DQUOTE] = ACTIONS(964),
    [anon_sym_u8_DQUOTE] = ACTIONS(964),
    [anon_sym_DQUOTE] = ACTIONS(964),
    [sym_true] = ACTIONS(962),
    [sym_false] = ACTIONS(962),
    [sym_null] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_identifier] = ACTIONS(966),
    [aux_sym_preproc_include_token1] = ACTIONS(966),
    [aux_sym_preproc_def_token1] = ACTIONS(966),
    [aux_sym_preproc_if_token1] = ACTIONS(966),
    [aux_sym_preproc_if_token2] = ACTIONS(966),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(966),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(966),
    [aux_sym_preproc_else_token1] = ACTIONS(966),
    [aux_sym_preproc_elif_token1] = ACTIONS(966),
    [sym_preproc_directive] = ACTIONS(966),
    [anon_sym_LPAREN2] = ACTIONS(968),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_DASH] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(966),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_AMP] = ACTIONS(968),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_typedef] = ACTIONS(966),
    [anon_sym_kernel] = ACTIONS(966),
    [anon_sym___kernel] = ACTIONS(966),
    [anon_sym_global] = ACTIONS(966),
    [anon_sym___global] = ACTIONS(966),
    [anon_sym_local] = ACTIONS(966),
    [anon_sym___local] = ACTIONS(966),
    [anon_sym_constant] = ACTIONS(966),
    [anon_sym___constant] = ACTIONS(966),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym___private] = ACTIONS(966),
    [anon_sym_generic] = ACTIONS(966),
    [anon_sym___generic] = ACTIONS(966),
    [anon_sym_read_only] = ACTIONS(966),
    [anon_sym___read_only] = ACTIONS(966),
    [anon_sym_write_only] = ACTIONS(966),
    [anon_sym___write_only] = ACTIONS(966),
    [anon_sym_read_write] = ACTIONS(966),
    [anon_sym___read_write] = ACTIONS(966),
    [anon_sym_extern] = ACTIONS(966),
    [anon_sym___attribute__] = ACTIONS(966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(968),
    [anon_sym___declspec] = ACTIONS(966),
    [anon_sym___cdecl] = ACTIONS(966),
    [anon_sym___clrcall] = ACTIONS(966),
    [anon_sym___stdcall] = ACTIONS(966),
    [anon_sym___fastcall] = ACTIONS(966),
    [anon_sym___thiscall] = ACTIONS(966),
    [anon_sym___vectorcall] = ACTIONS(966),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(966),
    [anon_sym_auto] = ACTIONS(966),
    [anon_sym_register] = ACTIONS(966),
    [anon_sym_inline] = ACTIONS(966),
    [anon_sym_const] = ACTIONS(966),
    [anon_sym_volatile] = ACTIONS(966),
    [anon_sym_restrict] = ACTIONS(966),
    [anon_sym__Atomic] = ACTIONS(966),
    [anon_sym_pipe] = ACTIONS(966),
    [anon_sym_signed] = ACTIONS(966),
    [anon_sym_unsigned] = ACTIONS(966),
    [anon_sym_long] = ACTIONS(966),
    [anon_sym_short] = ACTIONS(966),
    [anon_sym_bool] = ACTIONS(966),
    [anon_sym_char] = ACTIONS(966),
    [anon_sym_uchar] = ACTIONS(966),
    [anon_sym_ushort] = ACTIONS(966),
    [anon_sym_int] = ACTIONS(966),
    [anon_sym_uint] = ACTIONS(966),
    [anon_sym_ulong] = ACTIONS(966),
    [anon_sym_float] = ACTIONS(966),
    [anon_sym_double] = ACTIONS(966),
    [anon_sym_half] = ACTIONS(966),
    [anon_sym_size_t] = ACTIONS(966),
    [anon_sym_ptrdiff_t] = ACTIONS(966),
    [anon_sym_intptr_t] = ACTIONS(966),
    [anon_sym_uintptr_t] = ACTIONS(966),
    [anon_sym_void] = ACTIONS(966),
    [sym_vector_type] = ACTIONS(966),
    [anon_sym_image2d_t] = ACTIONS(966),
    [anon_sym_image3d_t] = ACTIONS(966),
    [anon_sym_image2d_array_t] = ACTIONS(966),
    [anon_sym_image1d_t] = ACTIONS(966),
    [anon_sym_image1d_buffer_t] = ACTIONS(966),
    [anon_sym_image1d_array_t] = ACTIONS(966),
    [anon_sym_image2d_depth_t] = ACTIONS(966),
    [anon_sym_image2d_array_depth_t] = ACTIONS(966),
    [anon_sym_sampler_t] = ACTIONS(966),
    [anon_sym_queue_t] = ACTIONS(966),
    [anon_sym_ndrange_t] = ACTIONS(966),
    [anon_sym_clk_event_t] = ACTIONS(966),
    [anon_sym_reserve_id_t] = ACTIONS(966),
    [anon_sym_event_t] = ACTIONS(966),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(966),
    [anon_sym_enum] = ACTIONS(966),
    [anon_sym_struct] = ACTIONS(966),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_else] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(966),
    [anon_sym_case] = ACTIONS(966),
    [anon_sym_default] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_do] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_goto] = ACTIONS(966),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_sizeof] = ACTIONS(966),
    [sym_number_literal] = ACTIONS(968),
    [anon_sym_L_SQUOTE] = ACTIONS(968),
    [anon_sym_u_SQUOTE] = ACTIONS(968),
    [anon_sym_U_SQUOTE] = ACTIONS(968),
    [anon_sym_u8_SQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [anon_sym_L_DQUOTE] = ACTIONS(968),
    [anon_sym_u_DQUOTE] = ACTIONS(968),
    [anon_sym_U_DQUOTE] = ACTIONS(968),
    [anon_sym_u8_DQUOTE] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_null] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_identifier] = ACTIONS(972),
    [aux_sym_preproc_include_token1] = ACTIONS(972),
    [aux_sym_preproc_def_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token2] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(972),
    [aux_sym_preproc_else_token1] = ACTIONS(972),
    [aux_sym_preproc_elif_token1] = ACTIONS(972),
    [sym_preproc_directive] = ACTIONS(972),
    [anon_sym_LPAREN2] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(972),
    [anon_sym_kernel] = ACTIONS(972),
    [anon_sym___kernel] = ACTIONS(972),
    [anon_sym_global] = ACTIONS(972),
    [anon_sym___global] = ACTIONS(972),
    [anon_sym_local] = ACTIONS(972),
    [anon_sym___local] = ACTIONS(972),
    [anon_sym_constant] = ACTIONS(972),
    [anon_sym___constant] = ACTIONS(972),
    [anon_sym_private] = ACTIONS(972),
    [anon_sym___private] = ACTIONS(972),
    [anon_sym_generic] = ACTIONS(972),
    [anon_sym___generic] = ACTIONS(972),
    [anon_sym_read_only] = ACTIONS(972),
    [anon_sym___read_only] = ACTIONS(972),
    [anon_sym_write_only] = ACTIONS(972),
    [anon_sym___write_only] = ACTIONS(972),
    [anon_sym_read_write] = ACTIONS(972),
    [anon_sym___read_write] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym___attribute__] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(974),
    [anon_sym___declspec] = ACTIONS(972),
    [anon_sym___cdecl] = ACTIONS(972),
    [anon_sym___clrcall] = ACTIONS(972),
    [anon_sym___stdcall] = ACTIONS(972),
    [anon_sym___fastcall] = ACTIONS(972),
    [anon_sym___thiscall] = ACTIONS(972),
    [anon_sym___vectorcall] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_auto] = ACTIONS(972),
    [anon_sym_register] = ACTIONS(972),
    [anon_sym_inline] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_volatile] = ACTIONS(972),
    [anon_sym_restrict] = ACTIONS(972),
    [anon_sym__Atomic] = ACTIONS(972),
    [anon_sym_pipe] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(972),
    [anon_sym_unsigned] = ACTIONS(972),
    [anon_sym_long] = ACTIONS(972),
    [anon_sym_short] = ACTIONS(972),
    [anon_sym_bool] = ACTIONS(972),
    [anon_sym_char] = ACTIONS(972),
    [anon_sym_uchar] = ACTIONS(972),
    [anon_sym_ushort] = ACTIONS(972),
    [anon_sym_int] = ACTIONS(972),
    [anon_sym_uint] = ACTIONS(972),
    [anon_sym_ulong] = ACTIONS(972),
    [anon_sym_float] = ACTIONS(972),
    [anon_sym_double] = ACTIONS(972),
    [anon_sym_half] = ACTIONS(972),
    [anon_sym_size_t] = ACTIONS(972),
    [anon_sym_ptrdiff_t] = ACTIONS(972),
    [anon_sym_intptr_t] = ACTIONS(972),
    [anon_sym_uintptr_t] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(972),
    [sym_vector_type] = ACTIONS(972),
    [anon_sym_image2d_t] = ACTIONS(972),
    [anon_sym_image3d_t] = ACTIONS(972),
    [anon_sym_image2d_array_t] = ACTIONS(972),
    [anon_sym_image1d_t] = ACTIONS(972),
    [anon_sym_image1d_buffer_t] = ACTIONS(972),
    [anon_sym_image1d_array_t] = ACTIONS(972),
    [anon_sym_image2d_depth_t] = ACTIONS(972),
    [anon_sym_image2d_array_depth_t] = ACTIONS(972),
    [anon_sym_sampler_t] = ACTIONS(972),
    [anon_sym_queue_t] = ACTIONS(972),
    [anon_sym_ndrange_t] = ACTIONS(972),
    [anon_sym_clk_event_t] = ACTIONS(972),
    [anon_sym_reserve_id_t] = ACTIONS(972),
    [anon_sym_event_t] = ACTIONS(972),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_goto] = ACTIONS(972),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_sizeof] = ACTIONS(972),
    [sym_number_literal] = ACTIONS(974),
    [anon_sym_L_SQUOTE] = ACTIONS(974),
    [anon_sym_u_SQUOTE] = ACTIONS(974),
    [anon_sym_U_SQUOTE] = ACTIONS(974),
    [anon_sym_u8_SQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [anon_sym_L_DQUOTE] = ACTIONS(974),
    [anon_sym_u_DQUOTE] = ACTIONS(974),
    [anon_sym_U_DQUOTE] = ACTIONS(974),
    [anon_sym_u8_DQUOTE] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_null] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(976),
    [aux_sym_preproc_def_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token2] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(976),
    [aux_sym_preproc_else_token1] = ACTIONS(976),
    [aux_sym_preproc_elif_token1] = ACTIONS(976),
    [sym_preproc_directive] = ACTIONS(976),
    [anon_sym_LPAREN2] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_AMP] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_typedef] = ACTIONS(976),
    [anon_sym_kernel] = ACTIONS(976),
    [anon_sym___kernel] = ACTIONS(976),
    [anon_sym_global] = ACTIONS(976),
    [anon_sym___global] = ACTIONS(976),
    [anon_sym_local] = ACTIONS(976),
    [anon_sym___local] = ACTIONS(976),
    [anon_sym_constant] = ACTIONS(976),
    [anon_sym___constant] = ACTIONS(976),
    [anon_sym_private] = ACTIONS(976),
    [anon_sym___private] = ACTIONS(976),
    [anon_sym_generic] = ACTIONS(976),
    [anon_sym___generic] = ACTIONS(976),
    [anon_sym_read_only] = ACTIONS(976),
    [anon_sym___read_only] = ACTIONS(976),
    [anon_sym_write_only] = ACTIONS(976),
    [anon_sym___write_only] = ACTIONS(976),
    [anon_sym_read_write] = ACTIONS(976),
    [anon_sym___read_write] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym___attribute__] = ACTIONS(976),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(978),
    [anon_sym___declspec] = ACTIONS(976),
    [anon_sym___cdecl] = ACTIONS(976),
    [anon_sym___clrcall] = ACTIONS(976),
    [anon_sym___stdcall] = ACTIONS(976),
    [anon_sym___fastcall] = ACTIONS(976),
    [anon_sym___thiscall] = ACTIONS(976),
    [anon_sym___vectorcall] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_auto] = ACTIONS(976),
    [anon_sym_register] = ACTIONS(976),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_volatile] = ACTIONS(976),
    [anon_sym_restrict] = ACTIONS(976),
    [anon_sym__Atomic] = ACTIONS(976),
    [anon_sym_pipe] = ACTIONS(976),
    [anon_sym_signed] = ACTIONS(976),
    [anon_sym_unsigned] = ACTIONS(976),
    [anon_sym_long] = ACTIONS(976),
    [anon_sym_short] = ACTIONS(976),
    [anon_sym_bool] = ACTIONS(976),
    [anon_sym_char] = ACTIONS(976),
    [anon_sym_uchar] = ACTIONS(976),
    [anon_sym_ushort] = ACTIONS(976),
    [anon_sym_int] = ACTIONS(976),
    [anon_sym_uint] = ACTIONS(976),
    [anon_sym_ulong] = ACTIONS(976),
    [anon_sym_float] = ACTIONS(976),
    [anon_sym_double] = ACTIONS(976),
    [anon_sym_half] = ACTIONS(976),
    [anon_sym_size_t] = ACTIONS(976),
    [anon_sym_ptrdiff_t] = ACTIONS(976),
    [anon_sym_intptr_t] = ACTIONS(976),
    [anon_sym_uintptr_t] = ACTIONS(976),
    [anon_sym_void] = ACTIONS(976),
    [sym_vector_type] = ACTIONS(976),
    [anon_sym_image2d_t] = ACTIONS(976),
    [anon_sym_image3d_t] = ACTIONS(976),
    [anon_sym_image2d_array_t] = ACTIONS(976),
    [anon_sym_image1d_t] = ACTIONS(976),
    [anon_sym_image1d_buffer_t] = ACTIONS(976),
    [anon_sym_image1d_array_t] = ACTIONS(976),
    [anon_sym_image2d_depth_t] = ACTIONS(976),
    [anon_sym_image2d_array_depth_t] = ACTIONS(976),
    [anon_sym_sampler_t] = ACTIONS(976),
    [anon_sym_queue_t] = ACTIONS(976),
    [anon_sym_ndrange_t] = ACTIONS(976),
    [anon_sym_clk_event_t] = ACTIONS(976),
    [anon_sym_reserve_id_t] = ACTIONS(976),
    [anon_sym_event_t] = ACTIONS(976),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_struct] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_goto] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(978),
    [anon_sym_sizeof] = ACTIONS(976),
    [sym_number_literal] = ACTIONS(978),
    [anon_sym_L_SQUOTE] = ACTIONS(978),
    [anon_sym_u_SQUOTE] = ACTIONS(978),
    [anon_sym_U_SQUOTE] = ACTIONS(978),
    [anon_sym_u8_SQUOTE] = ACTIONS(978),
    [anon_sym_SQUOTE] = ACTIONS(978),
    [anon_sym_L_DQUOTE] = ACTIONS(978),
    [anon_sym_u_DQUOTE] = ACTIONS(978),
    [anon_sym_U_DQUOTE] = ACTIONS(978),
    [anon_sym_u8_DQUOTE] = ACTIONS(978),
    [anon_sym_DQUOTE] = ACTIONS(978),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_identifier] = ACTIONS(980),
    [aux_sym_preproc_include_token1] = ACTIONS(980),
    [aux_sym_preproc_def_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token2] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(980),
    [aux_sym_preproc_else_token1] = ACTIONS(980),
    [aux_sym_preproc_elif_token1] = ACTIONS(980),
    [sym_preproc_directive] = ACTIONS(980),
    [anon_sym_LPAREN2] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(982),
    [anon_sym_SEMI] = ACTIONS(982),
    [anon_sym_typedef] = ACTIONS(980),
    [anon_sym_kernel] = ACTIONS(980),
    [anon_sym___kernel] = ACTIONS(980),
    [anon_sym_global] = ACTIONS(980),
    [anon_sym___global] = ACTIONS(980),
    [anon_sym_local] = ACTIONS(980),
    [anon_sym___local] = ACTIONS(980),
    [anon_sym_constant] = ACTIONS(980),
    [anon_sym___constant] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym___private] = ACTIONS(980),
    [anon_sym_generic] = ACTIONS(980),
    [anon_sym___generic] = ACTIONS(980),
    [anon_sym_read_only] = ACTIONS(980),
    [anon_sym___read_only] = ACTIONS(980),
    [anon_sym_write_only] = ACTIONS(980),
    [anon_sym___write_only] = ACTIONS(980),
    [anon_sym_read_write] = ACTIONS(980),
    [anon_sym___read_write] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym___attribute__] = ACTIONS(980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(982),
    [anon_sym___declspec] = ACTIONS(980),
    [anon_sym___cdecl] = ACTIONS(980),
    [anon_sym___clrcall] = ACTIONS(980),
    [anon_sym___stdcall] = ACTIONS(980),
    [anon_sym___fastcall] = ACTIONS(980),
    [anon_sym___thiscall] = ACTIONS(980),
    [anon_sym___vectorcall] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_auto] = ACTIONS(980),
    [anon_sym_register] = ACTIONS(980),
    [anon_sym_inline] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_volatile] = ACTIONS(980),
    [anon_sym_restrict] = ACTIONS(980),
    [anon_sym__Atomic] = ACTIONS(980),
    [anon_sym_pipe] = ACTIONS(980),
    [anon_sym_signed] = ACTIONS(980),
    [anon_sym_unsigned] = ACTIONS(980),
    [anon_sym_long] = ACTIONS(980),
    [anon_sym_short] = ACTIONS(980),
    [anon_sym_bool] = ACTIONS(980),
    [anon_sym_char] = ACTIONS(980),
    [anon_sym_uchar] = ACTIONS(980),
    [anon_sym_ushort] = ACTIONS(980),
    [anon_sym_int] = ACTIONS(980),
    [anon_sym_uint] = ACTIONS(980),
    [anon_sym_ulong] = ACTIONS(980),
    [anon_sym_float] = ACTIONS(980),
    [anon_sym_double] = ACTIONS(980),
    [anon_sym_half] = ACTIONS(980),
    [anon_sym_size_t] = ACTIONS(980),
    [anon_sym_ptrdiff_t] = ACTIONS(980),
    [anon_sym_intptr_t] = ACTIONS(980),
    [anon_sym_uintptr_t] = ACTIONS(980),
    [anon_sym_void] = ACTIONS(980),
    [sym_vector_type] = ACTIONS(980),
    [anon_sym_image2d_t] = ACTIONS(980),
    [anon_sym_image3d_t] = ACTIONS(980),
    [anon_sym_image2d_array_t] = ACTIONS(980),
    [anon_sym_image1d_t] = ACTIONS(980),
    [anon_sym_image1d_buffer_t] = ACTIONS(980),
    [anon_sym_image1d_array_t] = ACTIONS(980),
    [anon_sym_image2d_depth_t] = ACTIONS(980),
    [anon_sym_image2d_array_depth_t] = ACTIONS(980),
    [anon_sym_sampler_t] = ACTIONS(980),
    [anon_sym_queue_t] = ACTIONS(980),
    [anon_sym_ndrange_t] = ACTIONS(980),
    [anon_sym_clk_event_t] = ACTIONS(980),
    [anon_sym_reserve_id_t] = ACTIONS(980),
    [anon_sym_event_t] = ACTIONS(980),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_struct] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(980),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_do] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_goto] = ACTIONS(980),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_sizeof] = ACTIONS(980),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_L_SQUOTE] = ACTIONS(982),
    [anon_sym_u_SQUOTE] = ACTIONS(982),
    [anon_sym_U_SQUOTE] = ACTIONS(982),
    [anon_sym_u8_SQUOTE] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(982),
    [anon_sym_L_DQUOTE] = ACTIONS(982),
    [anon_sym_u_DQUOTE] = ACTIONS(982),
    [anon_sym_U_DQUOTE] = ACTIONS(982),
    [anon_sym_u8_DQUOTE] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_null] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token2] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [aux_sym_preproc_else_token1] = ACTIONS(984),
    [aux_sym_preproc_elif_token1] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_kernel] = ACTIONS(984),
    [anon_sym___kernel] = ACTIONS(984),
    [anon_sym_global] = ACTIONS(984),
    [anon_sym___global] = ACTIONS(984),
    [anon_sym_local] = ACTIONS(984),
    [anon_sym___local] = ACTIONS(984),
    [anon_sym_constant] = ACTIONS(984),
    [anon_sym___constant] = ACTIONS(984),
    [anon_sym_private] = ACTIONS(984),
    [anon_sym___private] = ACTIONS(984),
    [anon_sym_generic] = ACTIONS(984),
    [anon_sym___generic] = ACTIONS(984),
    [anon_sym_read_only] = ACTIONS(984),
    [anon_sym___read_only] = ACTIONS(984),
    [anon_sym_write_only] = ACTIONS(984),
    [anon_sym___write_only] = ACTIONS(984),
    [anon_sym_read_write] = ACTIONS(984),
    [anon_sym___read_write] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(986),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_pipe] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [anon_sym_bool] = ACTIONS(984),
    [anon_sym_char] = ACTIONS(984),
    [anon_sym_uchar] = ACTIONS(984),
    [anon_sym_ushort] = ACTIONS(984),
    [anon_sym_int] = ACTIONS(984),
    [anon_sym_uint] = ACTIONS(984),
    [anon_sym_ulong] = ACTIONS(984),
    [anon_sym_float] = ACTIONS(984),
    [anon_sym_double] = ACTIONS(984),
    [anon_sym_half] = ACTIONS(984),
    [anon_sym_size_t] = ACTIONS(984),
    [anon_sym_ptrdiff_t] = ACTIONS(984),
    [anon_sym_intptr_t] = ACTIONS(984),
    [anon_sym_uintptr_t] = ACTIONS(984),
    [anon_sym_void] = ACTIONS(984),
    [sym_vector_type] = ACTIONS(984),
    [anon_sym_image2d_t] = ACTIONS(984),
    [anon_sym_image3d_t] = ACTIONS(984),
    [anon_sym_image2d_array_t] = ACTIONS(984),
    [anon_sym_image1d_t] = ACTIONS(984),
    [anon_sym_image1d_buffer_t] = ACTIONS(984),
    [anon_sym_image1d_array_t] = ACTIONS(984),
    [anon_sym_image2d_depth_t] = ACTIONS(984),
    [anon_sym_image2d_array_depth_t] = ACTIONS(984),
    [anon_sym_sampler_t] = ACTIONS(984),
    [anon_sym_queue_t] = ACTIONS(984),
    [anon_sym_ndrange_t] = ACTIONS(984),
    [anon_sym_clk_event_t] = ACTIONS(984),
    [anon_sym_reserve_id_t] = ACTIONS(984),
    [anon_sym_event_t] = ACTIONS(984),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_identifier] = ACTIONS(988),
    [aux_sym_preproc_include_token1] = ACTIONS(988),
    [aux_sym_preproc_def_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token2] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(988),
    [aux_sym_preproc_else_token1] = ACTIONS(988),
    [aux_sym_preproc_elif_token1] = ACTIONS(988),
    [sym_preproc_directive] = ACTIONS(988),
    [anon_sym_LPAREN2] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_typedef] = ACTIONS(988),
    [anon_sym_kernel] = ACTIONS(988),
    [anon_sym___kernel] = ACTIONS(988),
    [anon_sym_global] = ACTIONS(988),
    [anon_sym___global] = ACTIONS(988),
    [anon_sym_local] = ACTIONS(988),
    [anon_sym___local] = ACTIONS(988),
    [anon_sym_constant] = ACTIONS(988),
    [anon_sym___constant] = ACTIONS(988),
    [anon_sym_private] = ACTIONS(988),
    [anon_sym___private] = ACTIONS(988),
    [anon_sym_generic] = ACTIONS(988),
    [anon_sym___generic] = ACTIONS(988),
    [anon_sym_read_only] = ACTIONS(988),
    [anon_sym___read_only] = ACTIONS(988),
    [anon_sym_write_only] = ACTIONS(988),
    [anon_sym___write_only] = ACTIONS(988),
    [anon_sym_read_write] = ACTIONS(988),
    [anon_sym___read_write] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym___attribute__] = ACTIONS(988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(990),
    [anon_sym___declspec] = ACTIONS(988),
    [anon_sym___cdecl] = ACTIONS(988),
    [anon_sym___clrcall] = ACTIONS(988),
    [anon_sym___stdcall] = ACTIONS(988),
    [anon_sym___fastcall] = ACTIONS(988),
    [anon_sym___thiscall] = ACTIONS(988),
    [anon_sym___vectorcall] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_auto] = ACTIONS(988),
    [anon_sym_register] = ACTIONS(988),
    [anon_sym_inline] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_volatile] = ACTIONS(988),
    [anon_sym_restrict] = ACTIONS(988),
    [anon_sym__Atomic] = ACTIONS(988),
    [anon_sym_pipe] = ACTIONS(988),
    [anon_sym_signed] = ACTIONS(988),
    [anon_sym_unsigned] = ACTIONS(988),
    [anon_sym_long] = ACTIONS(988),
    [anon_sym_short] = ACTIONS(988),
    [anon_sym_bool] = ACTIONS(988),
    [anon_sym_char] = ACTIONS(988),
    [anon_sym_uchar] = ACTIONS(988),
    [anon_sym_ushort] = ACTIONS(988),
    [anon_sym_int] = ACTIONS(988),
    [anon_sym_uint] = ACTIONS(988),
    [anon_sym_ulong] = ACTIONS(988),
    [anon_sym_float] = ACTIONS(988),
    [anon_sym_double] = ACTIONS(988),
    [anon_sym_half] = ACTIONS(988),
    [anon_sym_size_t] = ACTIONS(988),
    [anon_sym_ptrdiff_t] = ACTIONS(988),
    [anon_sym_intptr_t] = ACTIONS(988),
    [anon_sym_uintptr_t] = ACTIONS(988),
    [anon_sym_void] = ACTIONS(988),
    [sym_vector_type] = ACTIONS(988),
    [anon_sym_image2d_t] = ACTIONS(988),
    [anon_sym_image3d_t] = ACTIONS(988),
    [anon_sym_image2d_array_t] = ACTIONS(988),
    [anon_sym_image1d_t] = ACTIONS(988),
    [anon_sym_image1d_buffer_t] = ACTIONS(988),
    [anon_sym_image1d_array_t] = ACTIONS(988),
    [anon_sym_image2d_depth_t] = ACTIONS(988),
    [anon_sym_image2d_array_depth_t] = ACTIONS(988),
    [anon_sym_sampler_t] = ACTIONS(988),
    [anon_sym_queue_t] = ACTIONS(988),
    [anon_sym_ndrange_t] = ACTIONS(988),
    [anon_sym_clk_event_t] = ACTIONS(988),
    [anon_sym_reserve_id_t] = ACTIONS(988),
    [anon_sym_event_t] = ACTIONS(988),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_struct] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_goto] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(990),
    [anon_sym_PLUS_PLUS] = ACTIONS(990),
    [anon_sym_sizeof] = ACTIONS(988),
    [sym_number_literal] = ACTIONS(990),
    [anon_sym_L_SQUOTE] = ACTIONS(990),
    [anon_sym_u_SQUOTE] = ACTIONS(990),
    [anon_sym_U_SQUOTE] = ACTIONS(990),
    [anon_sym_u8_SQUOTE] = ACTIONS(990),
    [anon_sym_SQUOTE] = ACTIONS(990),
    [anon_sym_L_DQUOTE] = ACTIONS(990),
    [anon_sym_u_DQUOTE] = ACTIONS(990),
    [anon_sym_U_DQUOTE] = ACTIONS(990),
    [anon_sym_u8_DQUOTE] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_identifier] = ACTIONS(992),
    [aux_sym_preproc_include_token1] = ACTIONS(992),
    [aux_sym_preproc_def_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token2] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(992),
    [aux_sym_preproc_else_token1] = ACTIONS(992),
    [aux_sym_preproc_elif_token1] = ACTIONS(992),
    [sym_preproc_directive] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_typedef] = ACTIONS(992),
    [anon_sym_kernel] = ACTIONS(992),
    [anon_sym___kernel] = ACTIONS(992),
    [anon_sym_global] = ACTIONS(992),
    [anon_sym___global] = ACTIONS(992),
    [anon_sym_local] = ACTIONS(992),
    [anon_sym___local] = ACTIONS(992),
    [anon_sym_constant] = ACTIONS(992),
    [anon_sym___constant] = ACTIONS(992),
    [anon_sym_private] = ACTIONS(992),
    [anon_sym___private] = ACTIONS(992),
    [anon_sym_generic] = ACTIONS(992),
    [anon_sym___generic] = ACTIONS(992),
    [anon_sym_read_only] = ACTIONS(992),
    [anon_sym___read_only] = ACTIONS(992),
    [anon_sym_write_only] = ACTIONS(992),
    [anon_sym___write_only] = ACTIONS(992),
    [anon_sym_read_write] = ACTIONS(992),
    [anon_sym___read_write] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym___attribute__] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(994),
    [anon_sym___declspec] = ACTIONS(992),
    [anon_sym___cdecl] = ACTIONS(992),
    [anon_sym___clrcall] = ACTIONS(992),
    [anon_sym___stdcall] = ACTIONS(992),
    [anon_sym___fastcall] = ACTIONS(992),
    [anon_sym___thiscall] = ACTIONS(992),
    [anon_sym___vectorcall] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_auto] = ACTIONS(992),
    [anon_sym_register] = ACTIONS(992),
    [anon_sym_inline] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_volatile] = ACTIONS(992),
    [anon_sym_restrict] = ACTIONS(992),
    [anon_sym__Atomic] = ACTIONS(992),
    [anon_sym_pipe] = ACTIONS(992),
    [anon_sym_signed] = ACTIONS(992),
    [anon_sym_unsigned] = ACTIONS(992),
    [anon_sym_long] = ACTIONS(992),
    [anon_sym_short] = ACTIONS(992),
    [anon_sym_bool] = ACTIONS(992),
    [anon_sym_char] = ACTIONS(992),
    [anon_sym_uchar] = ACTIONS(992),
    [anon_sym_ushort] = ACTIONS(992),
    [anon_sym_int] = ACTIONS(992),
    [anon_sym_uint] = ACTIONS(992),
    [anon_sym_ulong] = ACTIONS(992),
    [anon_sym_float] = ACTIONS(992),
    [anon_sym_double] = ACTIONS(992),
    [anon_sym_half] = ACTIONS(992),
    [anon_sym_size_t] = ACTIONS(992),
    [anon_sym_ptrdiff_t] = ACTIONS(992),
    [anon_sym_intptr_t] = ACTIONS(992),
    [anon_sym_uintptr_t] = ACTIONS(992),
    [anon_sym_void] = ACTIONS(992),
    [sym_vector_type] = ACTIONS(992),
    [anon_sym_image2d_t] = ACTIONS(992),
    [anon_sym_image3d_t] = ACTIONS(992),
    [anon_sym_image2d_array_t] = ACTIONS(992),
    [anon_sym_image1d_t] = ACTIONS(992),
    [anon_sym_image1d_buffer_t] = ACTIONS(992),
    [anon_sym_image1d_array_t] = ACTIONS(992),
    [anon_sym_image2d_depth_t] = ACTIONS(992),
    [anon_sym_image2d_array_depth_t] = ACTIONS(992),
    [anon_sym_sampler_t] = ACTIONS(992),
    [anon_sym_queue_t] = ACTIONS(992),
    [anon_sym_ndrange_t] = ACTIONS(992),
    [anon_sym_clk_event_t] = ACTIONS(992),
    [anon_sym_reserve_id_t] = ACTIONS(992),
    [anon_sym_event_t] = ACTIONS(992),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_switch] = ACTIONS(992),
    [anon_sym_case] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_goto] = ACTIONS(992),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_sizeof] = ACTIONS(992),
    [sym_number_literal] = ACTIONS(994),
    [anon_sym_L_SQUOTE] = ACTIONS(994),
    [anon_sym_u_SQUOTE] = ACTIONS(994),
    [anon_sym_U_SQUOTE] = ACTIONS(994),
    [anon_sym_u8_SQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [anon_sym_L_DQUOTE] = ACTIONS(994),
    [anon_sym_u_DQUOTE] = ACTIONS(994),
    [anon_sym_U_DQUOTE] = ACTIONS(994),
    [anon_sym_u8_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_null] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_identifier] = ACTIONS(996),
    [aux_sym_preproc_include_token1] = ACTIONS(996),
    [aux_sym_preproc_def_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token2] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(996),
    [aux_sym_preproc_else_token1] = ACTIONS(996),
    [aux_sym_preproc_elif_token1] = ACTIONS(996),
    [sym_preproc_directive] = ACTIONS(996),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_typedef] = ACTIONS(996),
    [anon_sym_kernel] = ACTIONS(996),
    [anon_sym___kernel] = ACTIONS(996),
    [anon_sym_global] = ACTIONS(996),
    [anon_sym___global] = ACTIONS(996),
    [anon_sym_local] = ACTIONS(996),
    [anon_sym___local] = ACTIONS(996),
    [anon_sym_constant] = ACTIONS(996),
    [anon_sym___constant] = ACTIONS(996),
    [anon_sym_private] = ACTIONS(996),
    [anon_sym___private] = ACTIONS(996),
    [anon_sym_generic] = ACTIONS(996),
    [anon_sym___generic] = ACTIONS(996),
    [anon_sym_read_only] = ACTIONS(996),
    [anon_sym___read_only] = ACTIONS(996),
    [anon_sym_write_only] = ACTIONS(996),
    [anon_sym___write_only] = ACTIONS(996),
    [anon_sym_read_write] = ACTIONS(996),
    [anon_sym___read_write] = ACTIONS(996),
    [anon_sym_extern] = ACTIONS(996),
    [anon_sym___attribute__] = ACTIONS(996),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(998),
    [anon_sym___declspec] = ACTIONS(996),
    [anon_sym___cdecl] = ACTIONS(996),
    [anon_sym___clrcall] = ACTIONS(996),
    [anon_sym___stdcall] = ACTIONS(996),
    [anon_sym___fastcall] = ACTIONS(996),
    [anon_sym___thiscall] = ACTIONS(996),
    [anon_sym___vectorcall] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_auto] = ACTIONS(996),
    [anon_sym_register] = ACTIONS(996),
    [anon_sym_inline] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_volatile] = ACTIONS(996),
    [anon_sym_restrict] = ACTIONS(996),
    [anon_sym__Atomic] = ACTIONS(996),
    [anon_sym_pipe] = ACTIONS(996),
    [anon_sym_signed] = ACTIONS(996),
    [anon_sym_unsigned] = ACTIONS(996),
    [anon_sym_long] = ACTIONS(996),
    [anon_sym_short] = ACTIONS(996),
    [anon_sym_bool] = ACTIONS(996),
    [anon_sym_char] = ACTIONS(996),
    [anon_sym_uchar] = ACTIONS(996),
    [anon_sym_ushort] = ACTIONS(996),
    [anon_sym_int] = ACTIONS(996),
    [anon_sym_uint] = ACTIONS(996),
    [anon_sym_ulong] = ACTIONS(996),
    [anon_sym_float] = ACTIONS(996),
    [anon_sym_double] = ACTIONS(996),
    [anon_sym_half] = ACTIONS(996),
    [anon_sym_size_t] = ACTIONS(996),
    [anon_sym_ptrdiff_t] = ACTIONS(996),
    [anon_sym_intptr_t] = ACTIONS(996),
    [anon_sym_uintptr_t] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(996),
    [sym_vector_type] = ACTIONS(996),
    [anon_sym_image2d_t] = ACTIONS(996),
    [anon_sym_image3d_t] = ACTIONS(996),
    [anon_sym_image2d_array_t] = ACTIONS(996),
    [anon_sym_image1d_t] = ACTIONS(996),
    [anon_sym_image1d_buffer_t] = ACTIONS(996),
    [anon_sym_image1d_array_t] = ACTIONS(996),
    [anon_sym_image2d_depth_t] = ACTIONS(996),
    [anon_sym_image2d_array_depth_t] = ACTIONS(996),
    [anon_sym_sampler_t] = ACTIONS(996),
    [anon_sym_queue_t] = ACTIONS(996),
    [anon_sym_ndrange_t] = ACTIONS(996),
    [anon_sym_clk_event_t] = ACTIONS(996),
    [anon_sym_reserve_id_t] = ACTIONS(996),
    [anon_sym_event_t] = ACTIONS(996),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_struct] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_goto] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(996),
    [sym_number_literal] = ACTIONS(998),
    [anon_sym_L_SQUOTE] = ACTIONS(998),
    [anon_sym_u_SQUOTE] = ACTIONS(998),
    [anon_sym_U_SQUOTE] = ACTIONS(998),
    [anon_sym_u8_SQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_L_DQUOTE] = ACTIONS(998),
    [anon_sym_u_DQUOTE] = ACTIONS(998),
    [anon_sym_U_DQUOTE] = ACTIONS(998),
    [anon_sym_u8_DQUOTE] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_identifier] = ACTIONS(1000),
    [aux_sym_preproc_include_token1] = ACTIONS(1000),
    [aux_sym_preproc_def_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token2] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1000),
    [aux_sym_preproc_else_token1] = ACTIONS(1000),
    [aux_sym_preproc_elif_token1] = ACTIONS(1000),
    [sym_preproc_directive] = ACTIONS(1000),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_typedef] = ACTIONS(1000),
    [anon_sym_kernel] = ACTIONS(1000),
    [anon_sym___kernel] = ACTIONS(1000),
    [anon_sym_global] = ACTIONS(1000),
    [anon_sym___global] = ACTIONS(1000),
    [anon_sym_local] = ACTIONS(1000),
    [anon_sym___local] = ACTIONS(1000),
    [anon_sym_constant] = ACTIONS(1000),
    [anon_sym___constant] = ACTIONS(1000),
    [anon_sym_private] = ACTIONS(1000),
    [anon_sym___private] = ACTIONS(1000),
    [anon_sym_generic] = ACTIONS(1000),
    [anon_sym___generic] = ACTIONS(1000),
    [anon_sym_read_only] = ACTIONS(1000),
    [anon_sym___read_only] = ACTIONS(1000),
    [anon_sym_write_only] = ACTIONS(1000),
    [anon_sym___write_only] = ACTIONS(1000),
    [anon_sym_read_write] = ACTIONS(1000),
    [anon_sym___read_write] = ACTIONS(1000),
    [anon_sym_extern] = ACTIONS(1000),
    [anon_sym___attribute__] = ACTIONS(1000),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1002),
    [anon_sym___declspec] = ACTIONS(1000),
    [anon_sym___cdecl] = ACTIONS(1000),
    [anon_sym___clrcall] = ACTIONS(1000),
    [anon_sym___stdcall] = ACTIONS(1000),
    [anon_sym___fastcall] = ACTIONS(1000),
    [anon_sym___thiscall] = ACTIONS(1000),
    [anon_sym___vectorcall] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_auto] = ACTIONS(1000),
    [anon_sym_register] = ACTIONS(1000),
    [anon_sym_inline] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_volatile] = ACTIONS(1000),
    [anon_sym_restrict] = ACTIONS(1000),
    [anon_sym__Atomic] = ACTIONS(1000),
    [anon_sym_pipe] = ACTIONS(1000),
    [anon_sym_signed] = ACTIONS(1000),
    [anon_sym_unsigned] = ACTIONS(1000),
    [anon_sym_long] = ACTIONS(1000),
    [anon_sym_short] = ACTIONS(1000),
    [anon_sym_bool] = ACTIONS(1000),
    [anon_sym_char] = ACTIONS(1000),
    [anon_sym_uchar] = ACTIONS(1000),
    [anon_sym_ushort] = ACTIONS(1000),
    [anon_sym_int] = ACTIONS(1000),
    [anon_sym_uint] = ACTIONS(1000),
    [anon_sym_ulong] = ACTIONS(1000),
    [anon_sym_float] = ACTIONS(1000),
    [anon_sym_double] = ACTIONS(1000),
    [anon_sym_half] = ACTIONS(1000),
    [anon_sym_size_t] = ACTIONS(1000),
    [anon_sym_ptrdiff_t] = ACTIONS(1000),
    [anon_sym_intptr_t] = ACTIONS(1000),
    [anon_sym_uintptr_t] = ACTIONS(1000),
    [anon_sym_void] = ACTIONS(1000),
    [sym_vector_type] = ACTIONS(1000),
    [anon_sym_image2d_t] = ACTIONS(1000),
    [anon_sym_image3d_t] = ACTIONS(1000),
    [anon_sym_image2d_array_t] = ACTIONS(1000),
    [anon_sym_image1d_t] = ACTIONS(1000),
    [anon_sym_image1d_buffer_t] = ACTIONS(1000),
    [anon_sym_image1d_array_t] = ACTIONS(1000),
    [anon_sym_image2d_depth_t] = ACTIONS(1000),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1000),
    [anon_sym_sampler_t] = ACTIONS(1000),
    [anon_sym_queue_t] = ACTIONS(1000),
    [anon_sym_ndrange_t] = ACTIONS(1000),
    [anon_sym_clk_event_t] = ACTIONS(1000),
    [anon_sym_reserve_id_t] = ACTIONS(1000),
    [anon_sym_event_t] = ACTIONS(1000),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_struct] = ACTIONS(1000),
    [anon_sym_union] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_goto] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1002),
    [anon_sym_L_SQUOTE] = ACTIONS(1002),
    [anon_sym_u_SQUOTE] = ACTIONS(1002),
    [anon_sym_U_SQUOTE] = ACTIONS(1002),
    [anon_sym_u8_SQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_L_DQUOTE] = ACTIONS(1002),
    [anon_sym_u_DQUOTE] = ACTIONS(1002),
    [anon_sym_U_DQUOTE] = ACTIONS(1002),
    [anon_sym_u8_DQUOTE] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_identifier] = ACTIONS(1004),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token2] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [aux_sym_preproc_else_token1] = ACTIONS(1004),
    [aux_sym_preproc_elif_token1] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1006),
    [anon_sym_AMP] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [anon_sym_typedef] = ACTIONS(1004),
    [anon_sym_kernel] = ACTIONS(1004),
    [anon_sym___kernel] = ACTIONS(1004),
    [anon_sym_global] = ACTIONS(1004),
    [anon_sym___global] = ACTIONS(1004),
    [anon_sym_local] = ACTIONS(1004),
    [anon_sym___local] = ACTIONS(1004),
    [anon_sym_constant] = ACTIONS(1004),
    [anon_sym___constant] = ACTIONS(1004),
    [anon_sym_private] = ACTIONS(1004),
    [anon_sym___private] = ACTIONS(1004),
    [anon_sym_generic] = ACTIONS(1004),
    [anon_sym___generic] = ACTIONS(1004),
    [anon_sym_read_only] = ACTIONS(1004),
    [anon_sym___read_only] = ACTIONS(1004),
    [anon_sym_write_only] = ACTIONS(1004),
    [anon_sym___write_only] = ACTIONS(1004),
    [anon_sym_read_write] = ACTIONS(1004),
    [anon_sym___read_write] = ACTIONS(1004),
    [anon_sym_extern] = ACTIONS(1004),
    [anon_sym___attribute__] = ACTIONS(1004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1006),
    [anon_sym___declspec] = ACTIONS(1004),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_auto] = ACTIONS(1004),
    [anon_sym_register] = ACTIONS(1004),
    [anon_sym_inline] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_volatile] = ACTIONS(1004),
    [anon_sym_restrict] = ACTIONS(1004),
    [anon_sym__Atomic] = ACTIONS(1004),
    [anon_sym_pipe] = ACTIONS(1004),
    [anon_sym_signed] = ACTIONS(1004),
    [anon_sym_unsigned] = ACTIONS(1004),
    [anon_sym_long] = ACTIONS(1004),
    [anon_sym_short] = ACTIONS(1004),
    [anon_sym_bool] = ACTIONS(1004),
    [anon_sym_char] = ACTIONS(1004),
    [anon_sym_uchar] = ACTIONS(1004),
    [anon_sym_ushort] = ACTIONS(1004),
    [anon_sym_int] = ACTIONS(1004),
    [anon_sym_uint] = ACTIONS(1004),
    [anon_sym_ulong] = ACTIONS(1004),
    [anon_sym_float] = ACTIONS(1004),
    [anon_sym_double] = ACTIONS(1004),
    [anon_sym_half] = ACTIONS(1004),
    [anon_sym_size_t] = ACTIONS(1004),
    [anon_sym_ptrdiff_t] = ACTIONS(1004),
    [anon_sym_intptr_t] = ACTIONS(1004),
    [anon_sym_uintptr_t] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(1004),
    [sym_vector_type] = ACTIONS(1004),
    [anon_sym_image2d_t] = ACTIONS(1004),
    [anon_sym_image3d_t] = ACTIONS(1004),
    [anon_sym_image2d_array_t] = ACTIONS(1004),
    [anon_sym_image1d_t] = ACTIONS(1004),
    [anon_sym_image1d_buffer_t] = ACTIONS(1004),
    [anon_sym_image1d_array_t] = ACTIONS(1004),
    [anon_sym_image2d_depth_t] = ACTIONS(1004),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1004),
    [anon_sym_sampler_t] = ACTIONS(1004),
    [anon_sym_queue_t] = ACTIONS(1004),
    [anon_sym_ndrange_t] = ACTIONS(1004),
    [anon_sym_clk_event_t] = ACTIONS(1004),
    [anon_sym_reserve_id_t] = ACTIONS(1004),
    [anon_sym_event_t] = ACTIONS(1004),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1004),
    [anon_sym_enum] = ACTIONS(1004),
    [anon_sym_struct] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1004),
    [anon_sym_do] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_return] = ACTIONS(1004),
    [anon_sym_break] = ACTIONS(1004),
    [anon_sym_continue] = ACTIONS(1004),
    [anon_sym_goto] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_sizeof] = ACTIONS(1004),
    [sym_number_literal] = ACTIONS(1006),
    [anon_sym_L_SQUOTE] = ACTIONS(1006),
    [anon_sym_u_SQUOTE] = ACTIONS(1006),
    [anon_sym_U_SQUOTE] = ACTIONS(1006),
    [anon_sym_u8_SQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_L_DQUOTE] = ACTIONS(1006),
    [anon_sym_u_DQUOTE] = ACTIONS(1006),
    [anon_sym_U_DQUOTE] = ACTIONS(1006),
    [anon_sym_u8_DQUOTE] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1006),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_identifier] = ACTIONS(1008),
    [aux_sym_preproc_include_token1] = ACTIONS(1008),
    [aux_sym_preproc_def_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token2] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1008),
    [aux_sym_preproc_else_token1] = ACTIONS(1008),
    [aux_sym_preproc_elif_token1] = ACTIONS(1008),
    [sym_preproc_directive] = ACTIONS(1008),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_typedef] = ACTIONS(1008),
    [anon_sym_kernel] = ACTIONS(1008),
    [anon_sym___kernel] = ACTIONS(1008),
    [anon_sym_global] = ACTIONS(1008),
    [anon_sym___global] = ACTIONS(1008),
    [anon_sym_local] = ACTIONS(1008),
    [anon_sym___local] = ACTIONS(1008),
    [anon_sym_constant] = ACTIONS(1008),
    [anon_sym___constant] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym___private] = ACTIONS(1008),
    [anon_sym_generic] = ACTIONS(1008),
    [anon_sym___generic] = ACTIONS(1008),
    [anon_sym_read_only] = ACTIONS(1008),
    [anon_sym___read_only] = ACTIONS(1008),
    [anon_sym_write_only] = ACTIONS(1008),
    [anon_sym___write_only] = ACTIONS(1008),
    [anon_sym_read_write] = ACTIONS(1008),
    [anon_sym___read_write] = ACTIONS(1008),
    [anon_sym_extern] = ACTIONS(1008),
    [anon_sym___attribute__] = ACTIONS(1008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1010),
    [anon_sym___declspec] = ACTIONS(1008),
    [anon_sym___cdecl] = ACTIONS(1008),
    [anon_sym___clrcall] = ACTIONS(1008),
    [anon_sym___stdcall] = ACTIONS(1008),
    [anon_sym___fastcall] = ACTIONS(1008),
    [anon_sym___thiscall] = ACTIONS(1008),
    [anon_sym___vectorcall] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_auto] = ACTIONS(1008),
    [anon_sym_register] = ACTIONS(1008),
    [anon_sym_inline] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_volatile] = ACTIONS(1008),
    [anon_sym_restrict] = ACTIONS(1008),
    [anon_sym__Atomic] = ACTIONS(1008),
    [anon_sym_pipe] = ACTIONS(1008),
    [anon_sym_signed] = ACTIONS(1008),
    [anon_sym_unsigned] = ACTIONS(1008),
    [anon_sym_long] = ACTIONS(1008),
    [anon_sym_short] = ACTIONS(1008),
    [anon_sym_bool] = ACTIONS(1008),
    [anon_sym_char] = ACTIONS(1008),
    [anon_sym_uchar] = ACTIONS(1008),
    [anon_sym_ushort] = ACTIONS(1008),
    [anon_sym_int] = ACTIONS(1008),
    [anon_sym_uint] = ACTIONS(1008),
    [anon_sym_ulong] = ACTIONS(1008),
    [anon_sym_float] = ACTIONS(1008),
    [anon_sym_double] = ACTIONS(1008),
    [anon_sym_half] = ACTIONS(1008),
    [anon_sym_size_t] = ACTIONS(1008),
    [anon_sym_ptrdiff_t] = ACTIONS(1008),
    [anon_sym_intptr_t] = ACTIONS(1008),
    [anon_sym_uintptr_t] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1008),
    [sym_vector_type] = ACTIONS(1008),
    [anon_sym_image2d_t] = ACTIONS(1008),
    [anon_sym_image3d_t] = ACTIONS(1008),
    [anon_sym_image2d_array_t] = ACTIONS(1008),
    [anon_sym_image1d_t] = ACTIONS(1008),
    [anon_sym_image1d_buffer_t] = ACTIONS(1008),
    [anon_sym_image1d_array_t] = ACTIONS(1008),
    [anon_sym_image2d_depth_t] = ACTIONS(1008),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1008),
    [anon_sym_sampler_t] = ACTIONS(1008),
    [anon_sym_queue_t] = ACTIONS(1008),
    [anon_sym_ndrange_t] = ACTIONS(1008),
    [anon_sym_clk_event_t] = ACTIONS(1008),
    [anon_sym_reserve_id_t] = ACTIONS(1008),
    [anon_sym_event_t] = ACTIONS(1008),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_struct] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_goto] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_sizeof] = ACTIONS(1008),
    [sym_number_literal] = ACTIONS(1010),
    [anon_sym_L_SQUOTE] = ACTIONS(1010),
    [anon_sym_u_SQUOTE] = ACTIONS(1010),
    [anon_sym_U_SQUOTE] = ACTIONS(1010),
    [anon_sym_u8_SQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_L_DQUOTE] = ACTIONS(1010),
    [anon_sym_u_DQUOTE] = ACTIONS(1010),
    [anon_sym_U_DQUOTE] = ACTIONS(1010),
    [anon_sym_u8_DQUOTE] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [sym_true] = ACTIONS(1008),
    [sym_false] = ACTIONS(1008),
    [sym_null] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token2] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [aux_sym_preproc_else_token1] = ACTIONS(1012),
    [aux_sym_preproc_elif_token1] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_kernel] = ACTIONS(1012),
    [anon_sym___kernel] = ACTIONS(1012),
    [anon_sym_global] = ACTIONS(1012),
    [anon_sym___global] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym___local] = ACTIONS(1012),
    [anon_sym_constant] = ACTIONS(1012),
    [anon_sym___constant] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym___private] = ACTIONS(1012),
    [anon_sym_generic] = ACTIONS(1012),
    [anon_sym___generic] = ACTIONS(1012),
    [anon_sym_read_only] = ACTIONS(1012),
    [anon_sym___read_only] = ACTIONS(1012),
    [anon_sym_write_only] = ACTIONS(1012),
    [anon_sym___write_only] = ACTIONS(1012),
    [anon_sym_read_write] = ACTIONS(1012),
    [anon_sym___read_write] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1014),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_pipe] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_uchar] = ACTIONS(1012),
    [anon_sym_ushort] = ACTIONS(1012),
    [anon_sym_int] = ACTIONS(1012),
    [anon_sym_uint] = ACTIONS(1012),
    [anon_sym_ulong] = ACTIONS(1012),
    [anon_sym_float] = ACTIONS(1012),
    [anon_sym_double] = ACTIONS(1012),
    [anon_sym_half] = ACTIONS(1012),
    [anon_sym_size_t] = ACTIONS(1012),
    [anon_sym_ptrdiff_t] = ACTIONS(1012),
    [anon_sym_intptr_t] = ACTIONS(1012),
    [anon_sym_uintptr_t] = ACTIONS(1012),
    [anon_sym_void] = ACTIONS(1012),
    [sym_vector_type] = ACTIONS(1012),
    [anon_sym_image2d_t] = ACTIONS(1012),
    [anon_sym_image3d_t] = ACTIONS(1012),
    [anon_sym_image2d_array_t] = ACTIONS(1012),
    [anon_sym_image1d_t] = ACTIONS(1012),
    [anon_sym_image1d_buffer_t] = ACTIONS(1012),
    [anon_sym_image1d_array_t] = ACTIONS(1012),
    [anon_sym_image2d_depth_t] = ACTIONS(1012),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1012),
    [anon_sym_sampler_t] = ACTIONS(1012),
    [anon_sym_queue_t] = ACTIONS(1012),
    [anon_sym_ndrange_t] = ACTIONS(1012),
    [anon_sym_clk_event_t] = ACTIONS(1012),
    [anon_sym_reserve_id_t] = ACTIONS(1012),
    [anon_sym_event_t] = ACTIONS(1012),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_identifier] = ACTIONS(1016),
    [aux_sym_preproc_include_token1] = ACTIONS(1016),
    [aux_sym_preproc_def_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token2] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1016),
    [aux_sym_preproc_else_token1] = ACTIONS(1016),
    [aux_sym_preproc_elif_token1] = ACTIONS(1016),
    [sym_preproc_directive] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_typedef] = ACTIONS(1016),
    [anon_sym_kernel] = ACTIONS(1016),
    [anon_sym___kernel] = ACTIONS(1016),
    [anon_sym_global] = ACTIONS(1016),
    [anon_sym___global] = ACTIONS(1016),
    [anon_sym_local] = ACTIONS(1016),
    [anon_sym___local] = ACTIONS(1016),
    [anon_sym_constant] = ACTIONS(1016),
    [anon_sym___constant] = ACTIONS(1016),
    [anon_sym_private] = ACTIONS(1016),
    [anon_sym___private] = ACTIONS(1016),
    [anon_sym_generic] = ACTIONS(1016),
    [anon_sym___generic] = ACTIONS(1016),
    [anon_sym_read_only] = ACTIONS(1016),
    [anon_sym___read_only] = ACTIONS(1016),
    [anon_sym_write_only] = ACTIONS(1016),
    [anon_sym___write_only] = ACTIONS(1016),
    [anon_sym_read_write] = ACTIONS(1016),
    [anon_sym___read_write] = ACTIONS(1016),
    [anon_sym_extern] = ACTIONS(1016),
    [anon_sym___attribute__] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1018),
    [anon_sym___declspec] = ACTIONS(1016),
    [anon_sym___cdecl] = ACTIONS(1016),
    [anon_sym___clrcall] = ACTIONS(1016),
    [anon_sym___stdcall] = ACTIONS(1016),
    [anon_sym___fastcall] = ACTIONS(1016),
    [anon_sym___thiscall] = ACTIONS(1016),
    [anon_sym___vectorcall] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_auto] = ACTIONS(1016),
    [anon_sym_register] = ACTIONS(1016),
    [anon_sym_inline] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_volatile] = ACTIONS(1016),
    [anon_sym_restrict] = ACTIONS(1016),
    [anon_sym__Atomic] = ACTIONS(1016),
    [anon_sym_pipe] = ACTIONS(1016),
    [anon_sym_signed] = ACTIONS(1016),
    [anon_sym_unsigned] = ACTIONS(1016),
    [anon_sym_long] = ACTIONS(1016),
    [anon_sym_short] = ACTIONS(1016),
    [anon_sym_bool] = ACTIONS(1016),
    [anon_sym_char] = ACTIONS(1016),
    [anon_sym_uchar] = ACTIONS(1016),
    [anon_sym_ushort] = ACTIONS(1016),
    [anon_sym_int] = ACTIONS(1016),
    [anon_sym_uint] = ACTIONS(1016),
    [anon_sym_ulong] = ACTIONS(1016),
    [anon_sym_float] = ACTIONS(1016),
    [anon_sym_double] = ACTIONS(1016),
    [anon_sym_half] = ACTIONS(1016),
    [anon_sym_size_t] = ACTIONS(1016),
    [anon_sym_ptrdiff_t] = ACTIONS(1016),
    [anon_sym_intptr_t] = ACTIONS(1016),
    [anon_sym_uintptr_t] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1016),
    [sym_vector_type] = ACTIONS(1016),
    [anon_sym_image2d_t] = ACTIONS(1016),
    [anon_sym_image3d_t] = ACTIONS(1016),
    [anon_sym_image2d_array_t] = ACTIONS(1016),
    [anon_sym_image1d_t] = ACTIONS(1016),
    [anon_sym_image1d_buffer_t] = ACTIONS(1016),
    [anon_sym_image1d_array_t] = ACTIONS(1016),
    [anon_sym_image2d_depth_t] = ACTIONS(1016),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1016),
    [anon_sym_sampler_t] = ACTIONS(1016),
    [anon_sym_queue_t] = ACTIONS(1016),
    [anon_sym_ndrange_t] = ACTIONS(1016),
    [anon_sym_clk_event_t] = ACTIONS(1016),
    [anon_sym_reserve_id_t] = ACTIONS(1016),
    [anon_sym_event_t] = ACTIONS(1016),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_goto] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_sizeof] = ACTIONS(1016),
    [sym_number_literal] = ACTIONS(1018),
    [anon_sym_L_SQUOTE] = ACTIONS(1018),
    [anon_sym_u_SQUOTE] = ACTIONS(1018),
    [anon_sym_U_SQUOTE] = ACTIONS(1018),
    [anon_sym_u8_SQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [anon_sym_L_DQUOTE] = ACTIONS(1018),
    [anon_sym_u_DQUOTE] = ACTIONS(1018),
    [anon_sym_U_DQUOTE] = ACTIONS(1018),
    [anon_sym_u8_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_null] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token2] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [aux_sym_preproc_else_token1] = ACTIONS(1012),
    [aux_sym_preproc_elif_token1] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_kernel] = ACTIONS(1012),
    [anon_sym___kernel] = ACTIONS(1012),
    [anon_sym_global] = ACTIONS(1012),
    [anon_sym___global] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym___local] = ACTIONS(1012),
    [anon_sym_constant] = ACTIONS(1012),
    [anon_sym___constant] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym___private] = ACTIONS(1012),
    [anon_sym_generic] = ACTIONS(1012),
    [anon_sym___generic] = ACTIONS(1012),
    [anon_sym_read_only] = ACTIONS(1012),
    [anon_sym___read_only] = ACTIONS(1012),
    [anon_sym_write_only] = ACTIONS(1012),
    [anon_sym___write_only] = ACTIONS(1012),
    [anon_sym_read_write] = ACTIONS(1012),
    [anon_sym___read_write] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1014),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_pipe] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_uchar] = ACTIONS(1012),
    [anon_sym_ushort] = ACTIONS(1012),
    [anon_sym_int] = ACTIONS(1012),
    [anon_sym_uint] = ACTIONS(1012),
    [anon_sym_ulong] = ACTIONS(1012),
    [anon_sym_float] = ACTIONS(1012),
    [anon_sym_double] = ACTIONS(1012),
    [anon_sym_half] = ACTIONS(1012),
    [anon_sym_size_t] = ACTIONS(1012),
    [anon_sym_ptrdiff_t] = ACTIONS(1012),
    [anon_sym_intptr_t] = ACTIONS(1012),
    [anon_sym_uintptr_t] = ACTIONS(1012),
    [anon_sym_void] = ACTIONS(1012),
    [sym_vector_type] = ACTIONS(1012),
    [anon_sym_image2d_t] = ACTIONS(1012),
    [anon_sym_image3d_t] = ACTIONS(1012),
    [anon_sym_image2d_array_t] = ACTIONS(1012),
    [anon_sym_image1d_t] = ACTIONS(1012),
    [anon_sym_image1d_buffer_t] = ACTIONS(1012),
    [anon_sym_image1d_array_t] = ACTIONS(1012),
    [anon_sym_image2d_depth_t] = ACTIONS(1012),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1012),
    [anon_sym_sampler_t] = ACTIONS(1012),
    [anon_sym_queue_t] = ACTIONS(1012),
    [anon_sym_ndrange_t] = ACTIONS(1012),
    [anon_sym_clk_event_t] = ACTIONS(1012),
    [anon_sym_reserve_id_t] = ACTIONS(1012),
    [anon_sym_event_t] = ACTIONS(1012),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_identifier] = ACTIONS(1020),
    [aux_sym_preproc_include_token1] = ACTIONS(1020),
    [aux_sym_preproc_def_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token2] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1020),
    [aux_sym_preproc_else_token1] = ACTIONS(1020),
    [aux_sym_preproc_elif_token1] = ACTIONS(1020),
    [sym_preproc_directive] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_AMP] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [anon_sym_typedef] = ACTIONS(1020),
    [anon_sym_kernel] = ACTIONS(1020),
    [anon_sym___kernel] = ACTIONS(1020),
    [anon_sym_global] = ACTIONS(1020),
    [anon_sym___global] = ACTIONS(1020),
    [anon_sym_local] = ACTIONS(1020),
    [anon_sym___local] = ACTIONS(1020),
    [anon_sym_constant] = ACTIONS(1020),
    [anon_sym___constant] = ACTIONS(1020),
    [anon_sym_private] = ACTIONS(1020),
    [anon_sym___private] = ACTIONS(1020),
    [anon_sym_generic] = ACTIONS(1020),
    [anon_sym___generic] = ACTIONS(1020),
    [anon_sym_read_only] = ACTIONS(1020),
    [anon_sym___read_only] = ACTIONS(1020),
    [anon_sym_write_only] = ACTIONS(1020),
    [anon_sym___write_only] = ACTIONS(1020),
    [anon_sym_read_write] = ACTIONS(1020),
    [anon_sym___read_write] = ACTIONS(1020),
    [anon_sym_extern] = ACTIONS(1020),
    [anon_sym___attribute__] = ACTIONS(1020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1022),
    [anon_sym___declspec] = ACTIONS(1020),
    [anon_sym___cdecl] = ACTIONS(1020),
    [anon_sym___clrcall] = ACTIONS(1020),
    [anon_sym___stdcall] = ACTIONS(1020),
    [anon_sym___fastcall] = ACTIONS(1020),
    [anon_sym___thiscall] = ACTIONS(1020),
    [anon_sym___vectorcall] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_auto] = ACTIONS(1020),
    [anon_sym_register] = ACTIONS(1020),
    [anon_sym_inline] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_volatile] = ACTIONS(1020),
    [anon_sym_restrict] = ACTIONS(1020),
    [anon_sym__Atomic] = ACTIONS(1020),
    [anon_sym_pipe] = ACTIONS(1020),
    [anon_sym_signed] = ACTIONS(1020),
    [anon_sym_unsigned] = ACTIONS(1020),
    [anon_sym_long] = ACTIONS(1020),
    [anon_sym_short] = ACTIONS(1020),
    [anon_sym_bool] = ACTIONS(1020),
    [anon_sym_char] = ACTIONS(1020),
    [anon_sym_uchar] = ACTIONS(1020),
    [anon_sym_ushort] = ACTIONS(1020),
    [anon_sym_int] = ACTIONS(1020),
    [anon_sym_uint] = ACTIONS(1020),
    [anon_sym_ulong] = ACTIONS(1020),
    [anon_sym_float] = ACTIONS(1020),
    [anon_sym_double] = ACTIONS(1020),
    [anon_sym_half] = ACTIONS(1020),
    [anon_sym_size_t] = ACTIONS(1020),
    [anon_sym_ptrdiff_t] = ACTIONS(1020),
    [anon_sym_intptr_t] = ACTIONS(1020),
    [anon_sym_uintptr_t] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1020),
    [sym_vector_type] = ACTIONS(1020),
    [anon_sym_image2d_t] = ACTIONS(1020),
    [anon_sym_image3d_t] = ACTIONS(1020),
    [anon_sym_image2d_array_t] = ACTIONS(1020),
    [anon_sym_image1d_t] = ACTIONS(1020),
    [anon_sym_image1d_buffer_t] = ACTIONS(1020),
    [anon_sym_image1d_array_t] = ACTIONS(1020),
    [anon_sym_image2d_depth_t] = ACTIONS(1020),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1020),
    [anon_sym_sampler_t] = ACTIONS(1020),
    [anon_sym_queue_t] = ACTIONS(1020),
    [anon_sym_ndrange_t] = ACTIONS(1020),
    [anon_sym_clk_event_t] = ACTIONS(1020),
    [anon_sym_reserve_id_t] = ACTIONS(1020),
    [anon_sym_event_t] = ACTIONS(1020),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_union] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_goto] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [anon_sym_sizeof] = ACTIONS(1020),
    [sym_number_literal] = ACTIONS(1022),
    [anon_sym_L_SQUOTE] = ACTIONS(1022),
    [anon_sym_u_SQUOTE] = ACTIONS(1022),
    [anon_sym_U_SQUOTE] = ACTIONS(1022),
    [anon_sym_u8_SQUOTE] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [anon_sym_L_DQUOTE] = ACTIONS(1022),
    [anon_sym_u_DQUOTE] = ACTIONS(1022),
    [anon_sym_U_DQUOTE] = ACTIONS(1022),
    [anon_sym_u8_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_identifier] = ACTIONS(1024),
    [aux_sym_preproc_include_token1] = ACTIONS(1024),
    [aux_sym_preproc_def_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token2] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1024),
    [aux_sym_preproc_else_token1] = ACTIONS(1024),
    [aux_sym_preproc_elif_token1] = ACTIONS(1024),
    [sym_preproc_directive] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_typedef] = ACTIONS(1024),
    [anon_sym_kernel] = ACTIONS(1024),
    [anon_sym___kernel] = ACTIONS(1024),
    [anon_sym_global] = ACTIONS(1024),
    [anon_sym___global] = ACTIONS(1024),
    [anon_sym_local] = ACTIONS(1024),
    [anon_sym___local] = ACTIONS(1024),
    [anon_sym_constant] = ACTIONS(1024),
    [anon_sym___constant] = ACTIONS(1024),
    [anon_sym_private] = ACTIONS(1024),
    [anon_sym___private] = ACTIONS(1024),
    [anon_sym_generic] = ACTIONS(1024),
    [anon_sym___generic] = ACTIONS(1024),
    [anon_sym_read_only] = ACTIONS(1024),
    [anon_sym___read_only] = ACTIONS(1024),
    [anon_sym_write_only] = ACTIONS(1024),
    [anon_sym___write_only] = ACTIONS(1024),
    [anon_sym_read_write] = ACTIONS(1024),
    [anon_sym___read_write] = ACTIONS(1024),
    [anon_sym_extern] = ACTIONS(1024),
    [anon_sym___attribute__] = ACTIONS(1024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1026),
    [anon_sym___declspec] = ACTIONS(1024),
    [anon_sym___cdecl] = ACTIONS(1024),
    [anon_sym___clrcall] = ACTIONS(1024),
    [anon_sym___stdcall] = ACTIONS(1024),
    [anon_sym___fastcall] = ACTIONS(1024),
    [anon_sym___thiscall] = ACTIONS(1024),
    [anon_sym___vectorcall] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1024),
    [anon_sym_auto] = ACTIONS(1024),
    [anon_sym_register] = ACTIONS(1024),
    [anon_sym_inline] = ACTIONS(1024),
    [anon_sym_const] = ACTIONS(1024),
    [anon_sym_volatile] = ACTIONS(1024),
    [anon_sym_restrict] = ACTIONS(1024),
    [anon_sym__Atomic] = ACTIONS(1024),
    [anon_sym_pipe] = ACTIONS(1024),
    [anon_sym_signed] = ACTIONS(1024),
    [anon_sym_unsigned] = ACTIONS(1024),
    [anon_sym_long] = ACTIONS(1024),
    [anon_sym_short] = ACTIONS(1024),
    [anon_sym_bool] = ACTIONS(1024),
    [anon_sym_char] = ACTIONS(1024),
    [anon_sym_uchar] = ACTIONS(1024),
    [anon_sym_ushort] = ACTIONS(1024),
    [anon_sym_int] = ACTIONS(1024),
    [anon_sym_uint] = ACTIONS(1024),
    [anon_sym_ulong] = ACTIONS(1024),
    [anon_sym_float] = ACTIONS(1024),
    [anon_sym_double] = ACTIONS(1024),
    [anon_sym_half] = ACTIONS(1024),
    [anon_sym_size_t] = ACTIONS(1024),
    [anon_sym_ptrdiff_t] = ACTIONS(1024),
    [anon_sym_intptr_t] = ACTIONS(1024),
    [anon_sym_uintptr_t] = ACTIONS(1024),
    [anon_sym_void] = ACTIONS(1024),
    [sym_vector_type] = ACTIONS(1024),
    [anon_sym_image2d_t] = ACTIONS(1024),
    [anon_sym_image3d_t] = ACTIONS(1024),
    [anon_sym_image2d_array_t] = ACTIONS(1024),
    [anon_sym_image1d_t] = ACTIONS(1024),
    [anon_sym_image1d_buffer_t] = ACTIONS(1024),
    [anon_sym_image1d_array_t] = ACTIONS(1024),
    [anon_sym_image2d_depth_t] = ACTIONS(1024),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1024),
    [anon_sym_sampler_t] = ACTIONS(1024),
    [anon_sym_queue_t] = ACTIONS(1024),
    [anon_sym_ndrange_t] = ACTIONS(1024),
    [anon_sym_clk_event_t] = ACTIONS(1024),
    [anon_sym_reserve_id_t] = ACTIONS(1024),
    [anon_sym_event_t] = ACTIONS(1024),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1024),
    [anon_sym_enum] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_union] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1024),
    [anon_sym_default] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_goto] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_sizeof] = ACTIONS(1024),
    [sym_number_literal] = ACTIONS(1026),
    [anon_sym_L_SQUOTE] = ACTIONS(1026),
    [anon_sym_u_SQUOTE] = ACTIONS(1026),
    [anon_sym_U_SQUOTE] = ACTIONS(1026),
    [anon_sym_u8_SQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1024),
    [sym_false] = ACTIONS(1024),
    [sym_null] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_identifier] = ACTIONS(1028),
    [aux_sym_preproc_include_token1] = ACTIONS(1028),
    [aux_sym_preproc_def_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token2] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1028),
    [aux_sym_preproc_else_token1] = ACTIONS(1028),
    [aux_sym_preproc_elif_token1] = ACTIONS(1028),
    [sym_preproc_directive] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_typedef] = ACTIONS(1028),
    [anon_sym_kernel] = ACTIONS(1028),
    [anon_sym___kernel] = ACTIONS(1028),
    [anon_sym_global] = ACTIONS(1028),
    [anon_sym___global] = ACTIONS(1028),
    [anon_sym_local] = ACTIONS(1028),
    [anon_sym___local] = ACTIONS(1028),
    [anon_sym_constant] = ACTIONS(1028),
    [anon_sym___constant] = ACTIONS(1028),
    [anon_sym_private] = ACTIONS(1028),
    [anon_sym___private] = ACTIONS(1028),
    [anon_sym_generic] = ACTIONS(1028),
    [anon_sym___generic] = ACTIONS(1028),
    [anon_sym_read_only] = ACTIONS(1028),
    [anon_sym___read_only] = ACTIONS(1028),
    [anon_sym_write_only] = ACTIONS(1028),
    [anon_sym___write_only] = ACTIONS(1028),
    [anon_sym_read_write] = ACTIONS(1028),
    [anon_sym___read_write] = ACTIONS(1028),
    [anon_sym_extern] = ACTIONS(1028),
    [anon_sym___attribute__] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1030),
    [anon_sym___declspec] = ACTIONS(1028),
    [anon_sym___cdecl] = ACTIONS(1028),
    [anon_sym___clrcall] = ACTIONS(1028),
    [anon_sym___stdcall] = ACTIONS(1028),
    [anon_sym___fastcall] = ACTIONS(1028),
    [anon_sym___thiscall] = ACTIONS(1028),
    [anon_sym___vectorcall] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1028),
    [anon_sym_auto] = ACTIONS(1028),
    [anon_sym_register] = ACTIONS(1028),
    [anon_sym_inline] = ACTIONS(1028),
    [anon_sym_const] = ACTIONS(1028),
    [anon_sym_volatile] = ACTIONS(1028),
    [anon_sym_restrict] = ACTIONS(1028),
    [anon_sym__Atomic] = ACTIONS(1028),
    [anon_sym_pipe] = ACTIONS(1028),
    [anon_sym_signed] = ACTIONS(1028),
    [anon_sym_unsigned] = ACTIONS(1028),
    [anon_sym_long] = ACTIONS(1028),
    [anon_sym_short] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym_uchar] = ACTIONS(1028),
    [anon_sym_ushort] = ACTIONS(1028),
    [anon_sym_int] = ACTIONS(1028),
    [anon_sym_uint] = ACTIONS(1028),
    [anon_sym_ulong] = ACTIONS(1028),
    [anon_sym_float] = ACTIONS(1028),
    [anon_sym_double] = ACTIONS(1028),
    [anon_sym_half] = ACTIONS(1028),
    [anon_sym_size_t] = ACTIONS(1028),
    [anon_sym_ptrdiff_t] = ACTIONS(1028),
    [anon_sym_intptr_t] = ACTIONS(1028),
    [anon_sym_uintptr_t] = ACTIONS(1028),
    [anon_sym_void] = ACTIONS(1028),
    [sym_vector_type] = ACTIONS(1028),
    [anon_sym_image2d_t] = ACTIONS(1028),
    [anon_sym_image3d_t] = ACTIONS(1028),
    [anon_sym_image2d_array_t] = ACTIONS(1028),
    [anon_sym_image1d_t] = ACTIONS(1028),
    [anon_sym_image1d_buffer_t] = ACTIONS(1028),
    [anon_sym_image1d_array_t] = ACTIONS(1028),
    [anon_sym_image2d_depth_t] = ACTIONS(1028),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1028),
    [anon_sym_sampler_t] = ACTIONS(1028),
    [anon_sym_queue_t] = ACTIONS(1028),
    [anon_sym_ndrange_t] = ACTIONS(1028),
    [anon_sym_clk_event_t] = ACTIONS(1028),
    [anon_sym_reserve_id_t] = ACTIONS(1028),
    [anon_sym_event_t] = ACTIONS(1028),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1028),
    [anon_sym_enum] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_union] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_goto] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_sizeof] = ACTIONS(1028),
    [sym_number_literal] = ACTIONS(1030),
    [anon_sym_L_SQUOTE] = ACTIONS(1030),
    [anon_sym_u_SQUOTE] = ACTIONS(1030),
    [anon_sym_U_SQUOTE] = ACTIONS(1030),
    [anon_sym_u8_SQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [anon_sym_L_DQUOTE] = ACTIONS(1030),
    [anon_sym_u_DQUOTE] = ACTIONS(1030),
    [anon_sym_U_DQUOTE] = ACTIONS(1030),
    [anon_sym_u8_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [sym_true] = ACTIONS(1028),
    [sym_false] = ACTIONS(1028),
    [sym_null] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_identifier] = ACTIONS(1032),
    [aux_sym_preproc_include_token1] = ACTIONS(1032),
    [aux_sym_preproc_def_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token2] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1032),
    [aux_sym_preproc_else_token1] = ACTIONS(1032),
    [aux_sym_preproc_elif_token1] = ACTIONS(1032),
    [sym_preproc_directive] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_typedef] = ACTIONS(1032),
    [anon_sym_kernel] = ACTIONS(1032),
    [anon_sym___kernel] = ACTIONS(1032),
    [anon_sym_global] = ACTIONS(1032),
    [anon_sym___global] = ACTIONS(1032),
    [anon_sym_local] = ACTIONS(1032),
    [anon_sym___local] = ACTIONS(1032),
    [anon_sym_constant] = ACTIONS(1032),
    [anon_sym___constant] = ACTIONS(1032),
    [anon_sym_private] = ACTIONS(1032),
    [anon_sym___private] = ACTIONS(1032),
    [anon_sym_generic] = ACTIONS(1032),
    [anon_sym___generic] = ACTIONS(1032),
    [anon_sym_read_only] = ACTIONS(1032),
    [anon_sym___read_only] = ACTIONS(1032),
    [anon_sym_write_only] = ACTIONS(1032),
    [anon_sym___write_only] = ACTIONS(1032),
    [anon_sym_read_write] = ACTIONS(1032),
    [anon_sym___read_write] = ACTIONS(1032),
    [anon_sym_extern] = ACTIONS(1032),
    [anon_sym___attribute__] = ACTIONS(1032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1034),
    [anon_sym___declspec] = ACTIONS(1032),
    [anon_sym___cdecl] = ACTIONS(1032),
    [anon_sym___clrcall] = ACTIONS(1032),
    [anon_sym___stdcall] = ACTIONS(1032),
    [anon_sym___fastcall] = ACTIONS(1032),
    [anon_sym___thiscall] = ACTIONS(1032),
    [anon_sym___vectorcall] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_auto] = ACTIONS(1032),
    [anon_sym_register] = ACTIONS(1032),
    [anon_sym_inline] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_volatile] = ACTIONS(1032),
    [anon_sym_restrict] = ACTIONS(1032),
    [anon_sym__Atomic] = ACTIONS(1032),
    [anon_sym_pipe] = ACTIONS(1032),
    [anon_sym_signed] = ACTIONS(1032),
    [anon_sym_unsigned] = ACTIONS(1032),
    [anon_sym_long] = ACTIONS(1032),
    [anon_sym_short] = ACTIONS(1032),
    [anon_sym_bool] = ACTIONS(1032),
    [anon_sym_char] = ACTIONS(1032),
    [anon_sym_uchar] = ACTIONS(1032),
    [anon_sym_ushort] = ACTIONS(1032),
    [anon_sym_int] = ACTIONS(1032),
    [anon_sym_uint] = ACTIONS(1032),
    [anon_sym_ulong] = ACTIONS(1032),
    [anon_sym_float] = ACTIONS(1032),
    [anon_sym_double] = ACTIONS(1032),
    [anon_sym_half] = ACTIONS(1032),
    [anon_sym_size_t] = ACTIONS(1032),
    [anon_sym_ptrdiff_t] = ACTIONS(1032),
    [anon_sym_intptr_t] = ACTIONS(1032),
    [anon_sym_uintptr_t] = ACTIONS(1032),
    [anon_sym_void] = ACTIONS(1032),
    [sym_vector_type] = ACTIONS(1032),
    [anon_sym_image2d_t] = ACTIONS(1032),
    [anon_sym_image3d_t] = ACTIONS(1032),
    [anon_sym_image2d_array_t] = ACTIONS(1032),
    [anon_sym_image1d_t] = ACTIONS(1032),
    [anon_sym_image1d_buffer_t] = ACTIONS(1032),
    [anon_sym_image1d_array_t] = ACTIONS(1032),
    [anon_sym_image2d_depth_t] = ACTIONS(1032),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1032),
    [anon_sym_sampler_t] = ACTIONS(1032),
    [anon_sym_queue_t] = ACTIONS(1032),
    [anon_sym_ndrange_t] = ACTIONS(1032),
    [anon_sym_clk_event_t] = ACTIONS(1032),
    [anon_sym_reserve_id_t] = ACTIONS(1032),
    [anon_sym_event_t] = ACTIONS(1032),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_struct] = ACTIONS(1032),
    [anon_sym_union] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_goto] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_sizeof] = ACTIONS(1032),
    [sym_number_literal] = ACTIONS(1034),
    [anon_sym_L_SQUOTE] = ACTIONS(1034),
    [anon_sym_u_SQUOTE] = ACTIONS(1034),
    [anon_sym_U_SQUOTE] = ACTIONS(1034),
    [anon_sym_u8_SQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [anon_sym_L_DQUOTE] = ACTIONS(1034),
    [anon_sym_u_DQUOTE] = ACTIONS(1034),
    [anon_sym_U_DQUOTE] = ACTIONS(1034),
    [anon_sym_u8_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token2] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [aux_sym_preproc_else_token1] = ACTIONS(1036),
    [aux_sym_preproc_elif_token1] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_kernel] = ACTIONS(1036),
    [anon_sym___kernel] = ACTIONS(1036),
    [anon_sym_global] = ACTIONS(1036),
    [anon_sym___global] = ACTIONS(1036),
    [anon_sym_local] = ACTIONS(1036),
    [anon_sym___local] = ACTIONS(1036),
    [anon_sym_constant] = ACTIONS(1036),
    [anon_sym___constant] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym___private] = ACTIONS(1036),
    [anon_sym_generic] = ACTIONS(1036),
    [anon_sym___generic] = ACTIONS(1036),
    [anon_sym_read_only] = ACTIONS(1036),
    [anon_sym___read_only] = ACTIONS(1036),
    [anon_sym_write_only] = ACTIONS(1036),
    [anon_sym___write_only] = ACTIONS(1036),
    [anon_sym_read_write] = ACTIONS(1036),
    [anon_sym___read_write] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1038),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_pipe] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_bool] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_uchar] = ACTIONS(1036),
    [anon_sym_ushort] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_uint] = ACTIONS(1036),
    [anon_sym_ulong] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [anon_sym_half] = ACTIONS(1036),
    [anon_sym_size_t] = ACTIONS(1036),
    [anon_sym_ptrdiff_t] = ACTIONS(1036),
    [anon_sym_intptr_t] = ACTIONS(1036),
    [anon_sym_uintptr_t] = ACTIONS(1036),
    [anon_sym_void] = ACTIONS(1036),
    [sym_vector_type] = ACTIONS(1036),
    [anon_sym_image2d_t] = ACTIONS(1036),
    [anon_sym_image3d_t] = ACTIONS(1036),
    [anon_sym_image2d_array_t] = ACTIONS(1036),
    [anon_sym_image1d_t] = ACTIONS(1036),
    [anon_sym_image1d_buffer_t] = ACTIONS(1036),
    [anon_sym_image1d_array_t] = ACTIONS(1036),
    [anon_sym_image2d_depth_t] = ACTIONS(1036),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1036),
    [anon_sym_sampler_t] = ACTIONS(1036),
    [anon_sym_queue_t] = ACTIONS(1036),
    [anon_sym_ndrange_t] = ACTIONS(1036),
    [anon_sym_clk_event_t] = ACTIONS(1036),
    [anon_sym_reserve_id_t] = ACTIONS(1036),
    [anon_sym_event_t] = ACTIONS(1036),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_identifier] = ACTIONS(1040),
    [aux_sym_preproc_include_token1] = ACTIONS(1040),
    [aux_sym_preproc_def_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token2] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1040),
    [aux_sym_preproc_else_token1] = ACTIONS(1040),
    [aux_sym_preproc_elif_token1] = ACTIONS(1040),
    [sym_preproc_directive] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_typedef] = ACTIONS(1040),
    [anon_sym_kernel] = ACTIONS(1040),
    [anon_sym___kernel] = ACTIONS(1040),
    [anon_sym_global] = ACTIONS(1040),
    [anon_sym___global] = ACTIONS(1040),
    [anon_sym_local] = ACTIONS(1040),
    [anon_sym___local] = ACTIONS(1040),
    [anon_sym_constant] = ACTIONS(1040),
    [anon_sym___constant] = ACTIONS(1040),
    [anon_sym_private] = ACTIONS(1040),
    [anon_sym___private] = ACTIONS(1040),
    [anon_sym_generic] = ACTIONS(1040),
    [anon_sym___generic] = ACTIONS(1040),
    [anon_sym_read_only] = ACTIONS(1040),
    [anon_sym___read_only] = ACTIONS(1040),
    [anon_sym_write_only] = ACTIONS(1040),
    [anon_sym___write_only] = ACTIONS(1040),
    [anon_sym_read_write] = ACTIONS(1040),
    [anon_sym___read_write] = ACTIONS(1040),
    [anon_sym_extern] = ACTIONS(1040),
    [anon_sym___attribute__] = ACTIONS(1040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1042),
    [anon_sym___declspec] = ACTIONS(1040),
    [anon_sym___cdecl] = ACTIONS(1040),
    [anon_sym___clrcall] = ACTIONS(1040),
    [anon_sym___stdcall] = ACTIONS(1040),
    [anon_sym___fastcall] = ACTIONS(1040),
    [anon_sym___thiscall] = ACTIONS(1040),
    [anon_sym___vectorcall] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_auto] = ACTIONS(1040),
    [anon_sym_register] = ACTIONS(1040),
    [anon_sym_inline] = ACTIONS(1040),
    [anon_sym_const] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_restrict] = ACTIONS(1040),
    [anon_sym__Atomic] = ACTIONS(1040),
    [anon_sym_pipe] = ACTIONS(1040),
    [anon_sym_signed] = ACTIONS(1040),
    [anon_sym_unsigned] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [anon_sym_bool] = ACTIONS(1040),
    [anon_sym_char] = ACTIONS(1040),
    [anon_sym_uchar] = ACTIONS(1040),
    [anon_sym_ushort] = ACTIONS(1040),
    [anon_sym_int] = ACTIONS(1040),
    [anon_sym_uint] = ACTIONS(1040),
    [anon_sym_ulong] = ACTIONS(1040),
    [anon_sym_float] = ACTIONS(1040),
    [anon_sym_double] = ACTIONS(1040),
    [anon_sym_half] = ACTIONS(1040),
    [anon_sym_size_t] = ACTIONS(1040),
    [anon_sym_ptrdiff_t] = ACTIONS(1040),
    [anon_sym_intptr_t] = ACTIONS(1040),
    [anon_sym_uintptr_t] = ACTIONS(1040),
    [anon_sym_void] = ACTIONS(1040),
    [sym_vector_type] = ACTIONS(1040),
    [anon_sym_image2d_t] = ACTIONS(1040),
    [anon_sym_image3d_t] = ACTIONS(1040),
    [anon_sym_image2d_array_t] = ACTIONS(1040),
    [anon_sym_image1d_t] = ACTIONS(1040),
    [anon_sym_image1d_buffer_t] = ACTIONS(1040),
    [anon_sym_image1d_array_t] = ACTIONS(1040),
    [anon_sym_image2d_depth_t] = ACTIONS(1040),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1040),
    [anon_sym_sampler_t] = ACTIONS(1040),
    [anon_sym_queue_t] = ACTIONS(1040),
    [anon_sym_ndrange_t] = ACTIONS(1040),
    [anon_sym_clk_event_t] = ACTIONS(1040),
    [anon_sym_reserve_id_t] = ACTIONS(1040),
    [anon_sym_event_t] = ACTIONS(1040),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_union] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_goto] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_sizeof] = ACTIONS(1040),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_L_SQUOTE] = ACTIONS(1042),
    [anon_sym_u_SQUOTE] = ACTIONS(1042),
    [anon_sym_U_SQUOTE] = ACTIONS(1042),
    [anon_sym_u8_SQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [anon_sym_L_DQUOTE] = ACTIONS(1042),
    [anon_sym_u_DQUOTE] = ACTIONS(1042),
    [anon_sym_U_DQUOTE] = ACTIONS(1042),
    [anon_sym_u8_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token2] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [aux_sym_preproc_else_token1] = ACTIONS(1036),
    [aux_sym_preproc_elif_token1] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_kernel] = ACTIONS(1036),
    [anon_sym___kernel] = ACTIONS(1036),
    [anon_sym_global] = ACTIONS(1036),
    [anon_sym___global] = ACTIONS(1036),
    [anon_sym_local] = ACTIONS(1036),
    [anon_sym___local] = ACTIONS(1036),
    [anon_sym_constant] = ACTIONS(1036),
    [anon_sym___constant] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym___private] = ACTIONS(1036),
    [anon_sym_generic] = ACTIONS(1036),
    [anon_sym___generic] = ACTIONS(1036),
    [anon_sym_read_only] = ACTIONS(1036),
    [anon_sym___read_only] = ACTIONS(1036),
    [anon_sym_write_only] = ACTIONS(1036),
    [anon_sym___write_only] = ACTIONS(1036),
    [anon_sym_read_write] = ACTIONS(1036),
    [anon_sym___read_write] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1038),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_pipe] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_bool] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_uchar] = ACTIONS(1036),
    [anon_sym_ushort] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_uint] = ACTIONS(1036),
    [anon_sym_ulong] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [anon_sym_half] = ACTIONS(1036),
    [anon_sym_size_t] = ACTIONS(1036),
    [anon_sym_ptrdiff_t] = ACTIONS(1036),
    [anon_sym_intptr_t] = ACTIONS(1036),
    [anon_sym_uintptr_t] = ACTIONS(1036),
    [anon_sym_void] = ACTIONS(1036),
    [sym_vector_type] = ACTIONS(1036),
    [anon_sym_image2d_t] = ACTIONS(1036),
    [anon_sym_image3d_t] = ACTIONS(1036),
    [anon_sym_image2d_array_t] = ACTIONS(1036),
    [anon_sym_image1d_t] = ACTIONS(1036),
    [anon_sym_image1d_buffer_t] = ACTIONS(1036),
    [anon_sym_image1d_array_t] = ACTIONS(1036),
    [anon_sym_image2d_depth_t] = ACTIONS(1036),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1036),
    [anon_sym_sampler_t] = ACTIONS(1036),
    [anon_sym_queue_t] = ACTIONS(1036),
    [anon_sym_ndrange_t] = ACTIONS(1036),
    [anon_sym_clk_event_t] = ACTIONS(1036),
    [anon_sym_reserve_id_t] = ACTIONS(1036),
    [anon_sym_event_t] = ACTIONS(1036),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_identifier] = ACTIONS(1044),
    [aux_sym_preproc_include_token1] = ACTIONS(1044),
    [aux_sym_preproc_def_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token2] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1044),
    [aux_sym_preproc_else_token1] = ACTIONS(1044),
    [aux_sym_preproc_elif_token1] = ACTIONS(1044),
    [sym_preproc_directive] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1046),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_typedef] = ACTIONS(1044),
    [anon_sym_kernel] = ACTIONS(1044),
    [anon_sym___kernel] = ACTIONS(1044),
    [anon_sym_global] = ACTIONS(1044),
    [anon_sym___global] = ACTIONS(1044),
    [anon_sym_local] = ACTIONS(1044),
    [anon_sym___local] = ACTIONS(1044),
    [anon_sym_constant] = ACTIONS(1044),
    [anon_sym___constant] = ACTIONS(1044),
    [anon_sym_private] = ACTIONS(1044),
    [anon_sym___private] = ACTIONS(1044),
    [anon_sym_generic] = ACTIONS(1044),
    [anon_sym___generic] = ACTIONS(1044),
    [anon_sym_read_only] = ACTIONS(1044),
    [anon_sym___read_only] = ACTIONS(1044),
    [anon_sym_write_only] = ACTIONS(1044),
    [anon_sym___write_only] = ACTIONS(1044),
    [anon_sym_read_write] = ACTIONS(1044),
    [anon_sym___read_write] = ACTIONS(1044),
    [anon_sym_extern] = ACTIONS(1044),
    [anon_sym___attribute__] = ACTIONS(1044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1046),
    [anon_sym___declspec] = ACTIONS(1044),
    [anon_sym___cdecl] = ACTIONS(1044),
    [anon_sym___clrcall] = ACTIONS(1044),
    [anon_sym___stdcall] = ACTIONS(1044),
    [anon_sym___fastcall] = ACTIONS(1044),
    [anon_sym___thiscall] = ACTIONS(1044),
    [anon_sym___vectorcall] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1044),
    [anon_sym_auto] = ACTIONS(1044),
    [anon_sym_register] = ACTIONS(1044),
    [anon_sym_inline] = ACTIONS(1044),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym_pipe] = ACTIONS(1044),
    [anon_sym_signed] = ACTIONS(1044),
    [anon_sym_unsigned] = ACTIONS(1044),
    [anon_sym_long] = ACTIONS(1044),
    [anon_sym_short] = ACTIONS(1044),
    [anon_sym_bool] = ACTIONS(1044),
    [anon_sym_char] = ACTIONS(1044),
    [anon_sym_uchar] = ACTIONS(1044),
    [anon_sym_ushort] = ACTIONS(1044),
    [anon_sym_int] = ACTIONS(1044),
    [anon_sym_uint] = ACTIONS(1044),
    [anon_sym_ulong] = ACTIONS(1044),
    [anon_sym_float] = ACTIONS(1044),
    [anon_sym_double] = ACTIONS(1044),
    [anon_sym_half] = ACTIONS(1044),
    [anon_sym_size_t] = ACTIONS(1044),
    [anon_sym_ptrdiff_t] = ACTIONS(1044),
    [anon_sym_intptr_t] = ACTIONS(1044),
    [anon_sym_uintptr_t] = ACTIONS(1044),
    [anon_sym_void] = ACTIONS(1044),
    [sym_vector_type] = ACTIONS(1044),
    [anon_sym_image2d_t] = ACTIONS(1044),
    [anon_sym_image3d_t] = ACTIONS(1044),
    [anon_sym_image2d_array_t] = ACTIONS(1044),
    [anon_sym_image1d_t] = ACTIONS(1044),
    [anon_sym_image1d_buffer_t] = ACTIONS(1044),
    [anon_sym_image1d_array_t] = ACTIONS(1044),
    [anon_sym_image2d_depth_t] = ACTIONS(1044),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1044),
    [anon_sym_sampler_t] = ACTIONS(1044),
    [anon_sym_queue_t] = ACTIONS(1044),
    [anon_sym_ndrange_t] = ACTIONS(1044),
    [anon_sym_clk_event_t] = ACTIONS(1044),
    [anon_sym_reserve_id_t] = ACTIONS(1044),
    [anon_sym_event_t] = ACTIONS(1044),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1044),
    [anon_sym_enum] = ACTIONS(1044),
    [anon_sym_struct] = ACTIONS(1044),
    [anon_sym_union] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_else] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_goto] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [anon_sym_sizeof] = ACTIONS(1044),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_L_SQUOTE] = ACTIONS(1046),
    [anon_sym_u_SQUOTE] = ACTIONS(1046),
    [anon_sym_U_SQUOTE] = ACTIONS(1046),
    [anon_sym_u8_SQUOTE] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_L_DQUOTE] = ACTIONS(1046),
    [anon_sym_u_DQUOTE] = ACTIONS(1046),
    [anon_sym_U_DQUOTE] = ACTIONS(1046),
    [anon_sym_u8_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_identifier] = ACTIONS(1048),
    [aux_sym_preproc_include_token1] = ACTIONS(1048),
    [aux_sym_preproc_def_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token2] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1048),
    [aux_sym_preproc_else_token1] = ACTIONS(1048),
    [aux_sym_preproc_elif_token1] = ACTIONS(1048),
    [sym_preproc_directive] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_typedef] = ACTIONS(1048),
    [anon_sym_kernel] = ACTIONS(1048),
    [anon_sym___kernel] = ACTIONS(1048),
    [anon_sym_global] = ACTIONS(1048),
    [anon_sym___global] = ACTIONS(1048),
    [anon_sym_local] = ACTIONS(1048),
    [anon_sym___local] = ACTIONS(1048),
    [anon_sym_constant] = ACTIONS(1048),
    [anon_sym___constant] = ACTIONS(1048),
    [anon_sym_private] = ACTIONS(1048),
    [anon_sym___private] = ACTIONS(1048),
    [anon_sym_generic] = ACTIONS(1048),
    [anon_sym___generic] = ACTIONS(1048),
    [anon_sym_read_only] = ACTIONS(1048),
    [anon_sym___read_only] = ACTIONS(1048),
    [anon_sym_write_only] = ACTIONS(1048),
    [anon_sym___write_only] = ACTIONS(1048),
    [anon_sym_read_write] = ACTIONS(1048),
    [anon_sym___read_write] = ACTIONS(1048),
    [anon_sym_extern] = ACTIONS(1048),
    [anon_sym___attribute__] = ACTIONS(1048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1050),
    [anon_sym___declspec] = ACTIONS(1048),
    [anon_sym___cdecl] = ACTIONS(1048),
    [anon_sym___clrcall] = ACTIONS(1048),
    [anon_sym___stdcall] = ACTIONS(1048),
    [anon_sym___fastcall] = ACTIONS(1048),
    [anon_sym___thiscall] = ACTIONS(1048),
    [anon_sym___vectorcall] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1048),
    [anon_sym_auto] = ACTIONS(1048),
    [anon_sym_register] = ACTIONS(1048),
    [anon_sym_inline] = ACTIONS(1048),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_volatile] = ACTIONS(1048),
    [anon_sym_restrict] = ACTIONS(1048),
    [anon_sym__Atomic] = ACTIONS(1048),
    [anon_sym_pipe] = ACTIONS(1048),
    [anon_sym_signed] = ACTIONS(1048),
    [anon_sym_unsigned] = ACTIONS(1048),
    [anon_sym_long] = ACTIONS(1048),
    [anon_sym_short] = ACTIONS(1048),
    [anon_sym_bool] = ACTIONS(1048),
    [anon_sym_char] = ACTIONS(1048),
    [anon_sym_uchar] = ACTIONS(1048),
    [anon_sym_ushort] = ACTIONS(1048),
    [anon_sym_int] = ACTIONS(1048),
    [anon_sym_uint] = ACTIONS(1048),
    [anon_sym_ulong] = ACTIONS(1048),
    [anon_sym_float] = ACTIONS(1048),
    [anon_sym_double] = ACTIONS(1048),
    [anon_sym_half] = ACTIONS(1048),
    [anon_sym_size_t] = ACTIONS(1048),
    [anon_sym_ptrdiff_t] = ACTIONS(1048),
    [anon_sym_intptr_t] = ACTIONS(1048),
    [anon_sym_uintptr_t] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1048),
    [sym_vector_type] = ACTIONS(1048),
    [anon_sym_image2d_t] = ACTIONS(1048),
    [anon_sym_image3d_t] = ACTIONS(1048),
    [anon_sym_image2d_array_t] = ACTIONS(1048),
    [anon_sym_image1d_t] = ACTIONS(1048),
    [anon_sym_image1d_buffer_t] = ACTIONS(1048),
    [anon_sym_image1d_array_t] = ACTIONS(1048),
    [anon_sym_image2d_depth_t] = ACTIONS(1048),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1048),
    [anon_sym_sampler_t] = ACTIONS(1048),
    [anon_sym_queue_t] = ACTIONS(1048),
    [anon_sym_ndrange_t] = ACTIONS(1048),
    [anon_sym_clk_event_t] = ACTIONS(1048),
    [anon_sym_reserve_id_t] = ACTIONS(1048),
    [anon_sym_event_t] = ACTIONS(1048),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1048),
    [anon_sym_enum] = ACTIONS(1048),
    [anon_sym_struct] = ACTIONS(1048),
    [anon_sym_union] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_goto] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_sizeof] = ACTIONS(1048),
    [sym_number_literal] = ACTIONS(1050),
    [anon_sym_L_SQUOTE] = ACTIONS(1050),
    [anon_sym_u_SQUOTE] = ACTIONS(1050),
    [anon_sym_U_SQUOTE] = ACTIONS(1050),
    [anon_sym_u8_SQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_L_DQUOTE] = ACTIONS(1050),
    [anon_sym_u_DQUOTE] = ACTIONS(1050),
    [anon_sym_U_DQUOTE] = ACTIONS(1050),
    [anon_sym_u8_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_identifier] = ACTIONS(1052),
    [aux_sym_preproc_include_token1] = ACTIONS(1052),
    [aux_sym_preproc_def_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token2] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1052),
    [aux_sym_preproc_else_token1] = ACTIONS(1052),
    [aux_sym_preproc_elif_token1] = ACTIONS(1052),
    [sym_preproc_directive] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_AMP] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_typedef] = ACTIONS(1052),
    [anon_sym_kernel] = ACTIONS(1052),
    [anon_sym___kernel] = ACTIONS(1052),
    [anon_sym_global] = ACTIONS(1052),
    [anon_sym___global] = ACTIONS(1052),
    [anon_sym_local] = ACTIONS(1052),
    [anon_sym___local] = ACTIONS(1052),
    [anon_sym_constant] = ACTIONS(1052),
    [anon_sym___constant] = ACTIONS(1052),
    [anon_sym_private] = ACTIONS(1052),
    [anon_sym___private] = ACTIONS(1052),
    [anon_sym_generic] = ACTIONS(1052),
    [anon_sym___generic] = ACTIONS(1052),
    [anon_sym_read_only] = ACTIONS(1052),
    [anon_sym___read_only] = ACTIONS(1052),
    [anon_sym_write_only] = ACTIONS(1052),
    [anon_sym___write_only] = ACTIONS(1052),
    [anon_sym_read_write] = ACTIONS(1052),
    [anon_sym___read_write] = ACTIONS(1052),
    [anon_sym_extern] = ACTIONS(1052),
    [anon_sym___attribute__] = ACTIONS(1052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1054),
    [anon_sym___declspec] = ACTIONS(1052),
    [anon_sym___cdecl] = ACTIONS(1052),
    [anon_sym___clrcall] = ACTIONS(1052),
    [anon_sym___stdcall] = ACTIONS(1052),
    [anon_sym___fastcall] = ACTIONS(1052),
    [anon_sym___thiscall] = ACTIONS(1052),
    [anon_sym___vectorcall] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_auto] = ACTIONS(1052),
    [anon_sym_register] = ACTIONS(1052),
    [anon_sym_inline] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_volatile] = ACTIONS(1052),
    [anon_sym_restrict] = ACTIONS(1052),
    [anon_sym__Atomic] = ACTIONS(1052),
    [anon_sym_pipe] = ACTIONS(1052),
    [anon_sym_signed] = ACTIONS(1052),
    [anon_sym_unsigned] = ACTIONS(1052),
    [anon_sym_long] = ACTIONS(1052),
    [anon_sym_short] = ACTIONS(1052),
    [anon_sym_bool] = ACTIONS(1052),
    [anon_sym_char] = ACTIONS(1052),
    [anon_sym_uchar] = ACTIONS(1052),
    [anon_sym_ushort] = ACTIONS(1052),
    [anon_sym_int] = ACTIONS(1052),
    [anon_sym_uint] = ACTIONS(1052),
    [anon_sym_ulong] = ACTIONS(1052),
    [anon_sym_float] = ACTIONS(1052),
    [anon_sym_double] = ACTIONS(1052),
    [anon_sym_half] = ACTIONS(1052),
    [anon_sym_size_t] = ACTIONS(1052),
    [anon_sym_ptrdiff_t] = ACTIONS(1052),
    [anon_sym_intptr_t] = ACTIONS(1052),
    [anon_sym_uintptr_t] = ACTIONS(1052),
    [anon_sym_void] = ACTIONS(1052),
    [sym_vector_type] = ACTIONS(1052),
    [anon_sym_image2d_t] = ACTIONS(1052),
    [anon_sym_image3d_t] = ACTIONS(1052),
    [anon_sym_image2d_array_t] = ACTIONS(1052),
    [anon_sym_image1d_t] = ACTIONS(1052),
    [anon_sym_image1d_buffer_t] = ACTIONS(1052),
    [anon_sym_image1d_array_t] = ACTIONS(1052),
    [anon_sym_image2d_depth_t] = ACTIONS(1052),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1052),
    [anon_sym_sampler_t] = ACTIONS(1052),
    [anon_sym_queue_t] = ACTIONS(1052),
    [anon_sym_ndrange_t] = ACTIONS(1052),
    [anon_sym_clk_event_t] = ACTIONS(1052),
    [anon_sym_reserve_id_t] = ACTIONS(1052),
    [anon_sym_event_t] = ACTIONS(1052),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_struct] = ACTIONS(1052),
    [anon_sym_union] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_goto] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_sizeof] = ACTIONS(1052),
    [sym_number_literal] = ACTIONS(1054),
    [anon_sym_L_SQUOTE] = ACTIONS(1054),
    [anon_sym_u_SQUOTE] = ACTIONS(1054),
    [anon_sym_U_SQUOTE] = ACTIONS(1054),
    [anon_sym_u8_SQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [anon_sym_L_DQUOTE] = ACTIONS(1054),
    [anon_sym_u_DQUOTE] = ACTIONS(1054),
    [anon_sym_U_DQUOTE] = ACTIONS(1054),
    [anon_sym_u8_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_identifier] = ACTIONS(1056),
    [aux_sym_preproc_include_token1] = ACTIONS(1056),
    [aux_sym_preproc_def_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token2] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1056),
    [aux_sym_preproc_else_token1] = ACTIONS(1056),
    [aux_sym_preproc_elif_token1] = ACTIONS(1056),
    [sym_preproc_directive] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1058),
    [anon_sym_BANG] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_SEMI] = ACTIONS(1058),
    [anon_sym_typedef] = ACTIONS(1056),
    [anon_sym_kernel] = ACTIONS(1056),
    [anon_sym___kernel] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym___global] = ACTIONS(1056),
    [anon_sym_local] = ACTIONS(1056),
    [anon_sym___local] = ACTIONS(1056),
    [anon_sym_constant] = ACTIONS(1056),
    [anon_sym___constant] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym___private] = ACTIONS(1056),
    [anon_sym_generic] = ACTIONS(1056),
    [anon_sym___generic] = ACTIONS(1056),
    [anon_sym_read_only] = ACTIONS(1056),
    [anon_sym___read_only] = ACTIONS(1056),
    [anon_sym_write_only] = ACTIONS(1056),
    [anon_sym___write_only] = ACTIONS(1056),
    [anon_sym_read_write] = ACTIONS(1056),
    [anon_sym___read_write] = ACTIONS(1056),
    [anon_sym_extern] = ACTIONS(1056),
    [anon_sym___attribute__] = ACTIONS(1056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1058),
    [anon_sym___declspec] = ACTIONS(1056),
    [anon_sym___cdecl] = ACTIONS(1056),
    [anon_sym___clrcall] = ACTIONS(1056),
    [anon_sym___stdcall] = ACTIONS(1056),
    [anon_sym___fastcall] = ACTIONS(1056),
    [anon_sym___thiscall] = ACTIONS(1056),
    [anon_sym___vectorcall] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_auto] = ACTIONS(1056),
    [anon_sym_register] = ACTIONS(1056),
    [anon_sym_inline] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_volatile] = ACTIONS(1056),
    [anon_sym_restrict] = ACTIONS(1056),
    [anon_sym__Atomic] = ACTIONS(1056),
    [anon_sym_pipe] = ACTIONS(1056),
    [anon_sym_signed] = ACTIONS(1056),
    [anon_sym_unsigned] = ACTIONS(1056),
    [anon_sym_long] = ACTIONS(1056),
    [anon_sym_short] = ACTIONS(1056),
    [anon_sym_bool] = ACTIONS(1056),
    [anon_sym_char] = ACTIONS(1056),
    [anon_sym_uchar] = ACTIONS(1056),
    [anon_sym_ushort] = ACTIONS(1056),
    [anon_sym_int] = ACTIONS(1056),
    [anon_sym_uint] = ACTIONS(1056),
    [anon_sym_ulong] = ACTIONS(1056),
    [anon_sym_float] = ACTIONS(1056),
    [anon_sym_double] = ACTIONS(1056),
    [anon_sym_half] = ACTIONS(1056),
    [anon_sym_size_t] = ACTIONS(1056),
    [anon_sym_ptrdiff_t] = ACTIONS(1056),
    [anon_sym_intptr_t] = ACTIONS(1056),
    [anon_sym_uintptr_t] = ACTIONS(1056),
    [anon_sym_void] = ACTIONS(1056),
    [sym_vector_type] = ACTIONS(1056),
    [anon_sym_image2d_t] = ACTIONS(1056),
    [anon_sym_image3d_t] = ACTIONS(1056),
    [anon_sym_image2d_array_t] = ACTIONS(1056),
    [anon_sym_image1d_t] = ACTIONS(1056),
    [anon_sym_image1d_buffer_t] = ACTIONS(1056),
    [anon_sym_image1d_array_t] = ACTIONS(1056),
    [anon_sym_image2d_depth_t] = ACTIONS(1056),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1056),
    [anon_sym_sampler_t] = ACTIONS(1056),
    [anon_sym_queue_t] = ACTIONS(1056),
    [anon_sym_ndrange_t] = ACTIONS(1056),
    [anon_sym_clk_event_t] = ACTIONS(1056),
    [anon_sym_reserve_id_t] = ACTIONS(1056),
    [anon_sym_event_t] = ACTIONS(1056),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_struct] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_goto] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1058),
    [anon_sym_PLUS_PLUS] = ACTIONS(1058),
    [anon_sym_sizeof] = ACTIONS(1056),
    [sym_number_literal] = ACTIONS(1058),
    [anon_sym_L_SQUOTE] = ACTIONS(1058),
    [anon_sym_u_SQUOTE] = ACTIONS(1058),
    [anon_sym_U_SQUOTE] = ACTIONS(1058),
    [anon_sym_u8_SQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [anon_sym_L_DQUOTE] = ACTIONS(1058),
    [anon_sym_u_DQUOTE] = ACTIONS(1058),
    [anon_sym_U_DQUOTE] = ACTIONS(1058),
    [anon_sym_u8_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_identifier] = ACTIONS(1060),
    [aux_sym_preproc_include_token1] = ACTIONS(1060),
    [aux_sym_preproc_def_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token2] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1060),
    [aux_sym_preproc_else_token1] = ACTIONS(1060),
    [aux_sym_preproc_elif_token1] = ACTIONS(1060),
    [sym_preproc_directive] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_typedef] = ACTIONS(1060),
    [anon_sym_kernel] = ACTIONS(1060),
    [anon_sym___kernel] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym___global] = ACTIONS(1060),
    [anon_sym_local] = ACTIONS(1060),
    [anon_sym___local] = ACTIONS(1060),
    [anon_sym_constant] = ACTIONS(1060),
    [anon_sym___constant] = ACTIONS(1060),
    [anon_sym_private] = ACTIONS(1060),
    [anon_sym___private] = ACTIONS(1060),
    [anon_sym_generic] = ACTIONS(1060),
    [anon_sym___generic] = ACTIONS(1060),
    [anon_sym_read_only] = ACTIONS(1060),
    [anon_sym___read_only] = ACTIONS(1060),
    [anon_sym_write_only] = ACTIONS(1060),
    [anon_sym___write_only] = ACTIONS(1060),
    [anon_sym_read_write] = ACTIONS(1060),
    [anon_sym___read_write] = ACTIONS(1060),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym___attribute__] = ACTIONS(1060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1062),
    [anon_sym___declspec] = ACTIONS(1060),
    [anon_sym___cdecl] = ACTIONS(1060),
    [anon_sym___clrcall] = ACTIONS(1060),
    [anon_sym___stdcall] = ACTIONS(1060),
    [anon_sym___fastcall] = ACTIONS(1060),
    [anon_sym___thiscall] = ACTIONS(1060),
    [anon_sym___vectorcall] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1060),
    [anon_sym_auto] = ACTIONS(1060),
    [anon_sym_register] = ACTIONS(1060),
    [anon_sym_inline] = ACTIONS(1060),
    [anon_sym_const] = ACTIONS(1060),
    [anon_sym_volatile] = ACTIONS(1060),
    [anon_sym_restrict] = ACTIONS(1060),
    [anon_sym__Atomic] = ACTIONS(1060),
    [anon_sym_pipe] = ACTIONS(1060),
    [anon_sym_signed] = ACTIONS(1060),
    [anon_sym_unsigned] = ACTIONS(1060),
    [anon_sym_long] = ACTIONS(1060),
    [anon_sym_short] = ACTIONS(1060),
    [anon_sym_bool] = ACTIONS(1060),
    [anon_sym_char] = ACTIONS(1060),
    [anon_sym_uchar] = ACTIONS(1060),
    [anon_sym_ushort] = ACTIONS(1060),
    [anon_sym_int] = ACTIONS(1060),
    [anon_sym_uint] = ACTIONS(1060),
    [anon_sym_ulong] = ACTIONS(1060),
    [anon_sym_float] = ACTIONS(1060),
    [anon_sym_double] = ACTIONS(1060),
    [anon_sym_half] = ACTIONS(1060),
    [anon_sym_size_t] = ACTIONS(1060),
    [anon_sym_ptrdiff_t] = ACTIONS(1060),
    [anon_sym_intptr_t] = ACTIONS(1060),
    [anon_sym_uintptr_t] = ACTIONS(1060),
    [anon_sym_void] = ACTIONS(1060),
    [sym_vector_type] = ACTIONS(1060),
    [anon_sym_image2d_t] = ACTIONS(1060),
    [anon_sym_image3d_t] = ACTIONS(1060),
    [anon_sym_image2d_array_t] = ACTIONS(1060),
    [anon_sym_image1d_t] = ACTIONS(1060),
    [anon_sym_image1d_buffer_t] = ACTIONS(1060),
    [anon_sym_image1d_array_t] = ACTIONS(1060),
    [anon_sym_image2d_depth_t] = ACTIONS(1060),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1060),
    [anon_sym_sampler_t] = ACTIONS(1060),
    [anon_sym_queue_t] = ACTIONS(1060),
    [anon_sym_ndrange_t] = ACTIONS(1060),
    [anon_sym_clk_event_t] = ACTIONS(1060),
    [anon_sym_reserve_id_t] = ACTIONS(1060),
    [anon_sym_event_t] = ACTIONS(1060),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1060),
    [anon_sym_enum] = ACTIONS(1060),
    [anon_sym_struct] = ACTIONS(1060),
    [anon_sym_union] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_switch] = ACTIONS(1060),
    [anon_sym_case] = ACTIONS(1060),
    [anon_sym_default] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_goto] = ACTIONS(1060),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_sizeof] = ACTIONS(1060),
    [sym_number_literal] = ACTIONS(1062),
    [anon_sym_L_SQUOTE] = ACTIONS(1062),
    [anon_sym_u_SQUOTE] = ACTIONS(1062),
    [anon_sym_U_SQUOTE] = ACTIONS(1062),
    [anon_sym_u8_SQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [anon_sym_L_DQUOTE] = ACTIONS(1062),
    [anon_sym_u_DQUOTE] = ACTIONS(1062),
    [anon_sym_U_DQUOTE] = ACTIONS(1062),
    [anon_sym_u8_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_null] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_identifier] = ACTIONS(1064),
    [aux_sym_preproc_include_token1] = ACTIONS(1064),
    [aux_sym_preproc_def_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token2] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1064),
    [aux_sym_preproc_else_token1] = ACTIONS(1064),
    [aux_sym_preproc_elif_token1] = ACTIONS(1064),
    [sym_preproc_directive] = ACTIONS(1064),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [anon_sym_typedef] = ACTIONS(1064),
    [anon_sym_kernel] = ACTIONS(1064),
    [anon_sym___kernel] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym___global] = ACTIONS(1064),
    [anon_sym_local] = ACTIONS(1064),
    [anon_sym___local] = ACTIONS(1064),
    [anon_sym_constant] = ACTIONS(1064),
    [anon_sym___constant] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym___private] = ACTIONS(1064),
    [anon_sym_generic] = ACTIONS(1064),
    [anon_sym___generic] = ACTIONS(1064),
    [anon_sym_read_only] = ACTIONS(1064),
    [anon_sym___read_only] = ACTIONS(1064),
    [anon_sym_write_only] = ACTIONS(1064),
    [anon_sym___write_only] = ACTIONS(1064),
    [anon_sym_read_write] = ACTIONS(1064),
    [anon_sym___read_write] = ACTIONS(1064),
    [anon_sym_extern] = ACTIONS(1064),
    [anon_sym___attribute__] = ACTIONS(1064),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1066),
    [anon_sym___declspec] = ACTIONS(1064),
    [anon_sym___cdecl] = ACTIONS(1064),
    [anon_sym___clrcall] = ACTIONS(1064),
    [anon_sym___stdcall] = ACTIONS(1064),
    [anon_sym___fastcall] = ACTIONS(1064),
    [anon_sym___thiscall] = ACTIONS(1064),
    [anon_sym___vectorcall] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_auto] = ACTIONS(1064),
    [anon_sym_register] = ACTIONS(1064),
    [anon_sym_inline] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_volatile] = ACTIONS(1064),
    [anon_sym_restrict] = ACTIONS(1064),
    [anon_sym__Atomic] = ACTIONS(1064),
    [anon_sym_pipe] = ACTIONS(1064),
    [anon_sym_signed] = ACTIONS(1064),
    [anon_sym_unsigned] = ACTIONS(1064),
    [anon_sym_long] = ACTIONS(1064),
    [anon_sym_short] = ACTIONS(1064),
    [anon_sym_bool] = ACTIONS(1064),
    [anon_sym_char] = ACTIONS(1064),
    [anon_sym_uchar] = ACTIONS(1064),
    [anon_sym_ushort] = ACTIONS(1064),
    [anon_sym_int] = ACTIONS(1064),
    [anon_sym_uint] = ACTIONS(1064),
    [anon_sym_ulong] = ACTIONS(1064),
    [anon_sym_float] = ACTIONS(1064),
    [anon_sym_double] = ACTIONS(1064),
    [anon_sym_half] = ACTIONS(1064),
    [anon_sym_size_t] = ACTIONS(1064),
    [anon_sym_ptrdiff_t] = ACTIONS(1064),
    [anon_sym_intptr_t] = ACTIONS(1064),
    [anon_sym_uintptr_t] = ACTIONS(1064),
    [anon_sym_void] = ACTIONS(1064),
    [sym_vector_type] = ACTIONS(1064),
    [anon_sym_image2d_t] = ACTIONS(1064),
    [anon_sym_image3d_t] = ACTIONS(1064),
    [anon_sym_image2d_array_t] = ACTIONS(1064),
    [anon_sym_image1d_t] = ACTIONS(1064),
    [anon_sym_image1d_buffer_t] = ACTIONS(1064),
    [anon_sym_image1d_array_t] = ACTIONS(1064),
    [anon_sym_image2d_depth_t] = ACTIONS(1064),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1064),
    [anon_sym_sampler_t] = ACTIONS(1064),
    [anon_sym_queue_t] = ACTIONS(1064),
    [anon_sym_ndrange_t] = ACTIONS(1064),
    [anon_sym_clk_event_t] = ACTIONS(1064),
    [anon_sym_reserve_id_t] = ACTIONS(1064),
    [anon_sym_event_t] = ACTIONS(1064),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_struct] = ACTIONS(1064),
    [anon_sym_union] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_goto] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1064),
    [sym_number_literal] = ACTIONS(1066),
    [anon_sym_L_SQUOTE] = ACTIONS(1066),
    [anon_sym_u_SQUOTE] = ACTIONS(1066),
    [anon_sym_U_SQUOTE] = ACTIONS(1066),
    [anon_sym_u8_SQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_L_DQUOTE] = ACTIONS(1066),
    [anon_sym_u_DQUOTE] = ACTIONS(1066),
    [anon_sym_U_DQUOTE] = ACTIONS(1066),
    [anon_sym_u8_DQUOTE] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_identifier] = ACTIONS(1068),
    [aux_sym_preproc_include_token1] = ACTIONS(1068),
    [aux_sym_preproc_def_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token2] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1068),
    [aux_sym_preproc_else_token1] = ACTIONS(1068),
    [aux_sym_preproc_elif_token1] = ACTIONS(1068),
    [sym_preproc_directive] = ACTIONS(1068),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_typedef] = ACTIONS(1068),
    [anon_sym_kernel] = ACTIONS(1068),
    [anon_sym___kernel] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym___global] = ACTIONS(1068),
    [anon_sym_local] = ACTIONS(1068),
    [anon_sym___local] = ACTIONS(1068),
    [anon_sym_constant] = ACTIONS(1068),
    [anon_sym___constant] = ACTIONS(1068),
    [anon_sym_private] = ACTIONS(1068),
    [anon_sym___private] = ACTIONS(1068),
    [anon_sym_generic] = ACTIONS(1068),
    [anon_sym___generic] = ACTIONS(1068),
    [anon_sym_read_only] = ACTIONS(1068),
    [anon_sym___read_only] = ACTIONS(1068),
    [anon_sym_write_only] = ACTIONS(1068),
    [anon_sym___write_only] = ACTIONS(1068),
    [anon_sym_read_write] = ACTIONS(1068),
    [anon_sym___read_write] = ACTIONS(1068),
    [anon_sym_extern] = ACTIONS(1068),
    [anon_sym___attribute__] = ACTIONS(1068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1070),
    [anon_sym___declspec] = ACTIONS(1068),
    [anon_sym___cdecl] = ACTIONS(1068),
    [anon_sym___clrcall] = ACTIONS(1068),
    [anon_sym___stdcall] = ACTIONS(1068),
    [anon_sym___fastcall] = ACTIONS(1068),
    [anon_sym___thiscall] = ACTIONS(1068),
    [anon_sym___vectorcall] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1068),
    [anon_sym_auto] = ACTIONS(1068),
    [anon_sym_register] = ACTIONS(1068),
    [anon_sym_inline] = ACTIONS(1068),
    [anon_sym_const] = ACTIONS(1068),
    [anon_sym_volatile] = ACTIONS(1068),
    [anon_sym_restrict] = ACTIONS(1068),
    [anon_sym__Atomic] = ACTIONS(1068),
    [anon_sym_pipe] = ACTIONS(1068),
    [anon_sym_signed] = ACTIONS(1068),
    [anon_sym_unsigned] = ACTIONS(1068),
    [anon_sym_long] = ACTIONS(1068),
    [anon_sym_short] = ACTIONS(1068),
    [anon_sym_bool] = ACTIONS(1068),
    [anon_sym_char] = ACTIONS(1068),
    [anon_sym_uchar] = ACTIONS(1068),
    [anon_sym_ushort] = ACTIONS(1068),
    [anon_sym_int] = ACTIONS(1068),
    [anon_sym_uint] = ACTIONS(1068),
    [anon_sym_ulong] = ACTIONS(1068),
    [anon_sym_float] = ACTIONS(1068),
    [anon_sym_double] = ACTIONS(1068),
    [anon_sym_half] = ACTIONS(1068),
    [anon_sym_size_t] = ACTIONS(1068),
    [anon_sym_ptrdiff_t] = ACTIONS(1068),
    [anon_sym_intptr_t] = ACTIONS(1068),
    [anon_sym_uintptr_t] = ACTIONS(1068),
    [anon_sym_void] = ACTIONS(1068),
    [sym_vector_type] = ACTIONS(1068),
    [anon_sym_image2d_t] = ACTIONS(1068),
    [anon_sym_image3d_t] = ACTIONS(1068),
    [anon_sym_image2d_array_t] = ACTIONS(1068),
    [anon_sym_image1d_t] = ACTIONS(1068),
    [anon_sym_image1d_buffer_t] = ACTIONS(1068),
    [anon_sym_image1d_array_t] = ACTIONS(1068),
    [anon_sym_image2d_depth_t] = ACTIONS(1068),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1068),
    [anon_sym_sampler_t] = ACTIONS(1068),
    [anon_sym_queue_t] = ACTIONS(1068),
    [anon_sym_ndrange_t] = ACTIONS(1068),
    [anon_sym_clk_event_t] = ACTIONS(1068),
    [anon_sym_reserve_id_t] = ACTIONS(1068),
    [anon_sym_event_t] = ACTIONS(1068),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1068),
    [anon_sym_enum] = ACTIONS(1068),
    [anon_sym_struct] = ACTIONS(1068),
    [anon_sym_union] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_case] = ACTIONS(1068),
    [anon_sym_default] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_do] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_goto] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_sizeof] = ACTIONS(1068),
    [sym_number_literal] = ACTIONS(1070),
    [anon_sym_L_SQUOTE] = ACTIONS(1070),
    [anon_sym_u_SQUOTE] = ACTIONS(1070),
    [anon_sym_U_SQUOTE] = ACTIONS(1070),
    [anon_sym_u8_SQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_L_DQUOTE] = ACTIONS(1070),
    [anon_sym_u_DQUOTE] = ACTIONS(1070),
    [anon_sym_U_DQUOTE] = ACTIONS(1070),
    [anon_sym_u8_DQUOTE] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_null] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_include_token1] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token2] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [aux_sym_preproc_else_token1] = ACTIONS(1072),
    [aux_sym_preproc_elif_token1] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_typedef] = ACTIONS(1072),
    [anon_sym_kernel] = ACTIONS(1072),
    [anon_sym___kernel] = ACTIONS(1072),
    [anon_sym_global] = ACTIONS(1072),
    [anon_sym___global] = ACTIONS(1072),
    [anon_sym_local] = ACTIONS(1072),
    [anon_sym___local] = ACTIONS(1072),
    [anon_sym_constant] = ACTIONS(1072),
    [anon_sym___constant] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym___private] = ACTIONS(1072),
    [anon_sym_generic] = ACTIONS(1072),
    [anon_sym___generic] = ACTIONS(1072),
    [anon_sym_read_only] = ACTIONS(1072),
    [anon_sym___read_only] = ACTIONS(1072),
    [anon_sym_write_only] = ACTIONS(1072),
    [anon_sym___write_only] = ACTIONS(1072),
    [anon_sym_read_write] = ACTIONS(1072),
    [anon_sym___read_write] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1074),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym___cdecl] = ACTIONS(1072),
    [anon_sym___clrcall] = ACTIONS(1072),
    [anon_sym___stdcall] = ACTIONS(1072),
    [anon_sym___fastcall] = ACTIONS(1072),
    [anon_sym___thiscall] = ACTIONS(1072),
    [anon_sym___vectorcall] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_pipe] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [anon_sym_bool] = ACTIONS(1072),
    [anon_sym_char] = ACTIONS(1072),
    [anon_sym_uchar] = ACTIONS(1072),
    [anon_sym_ushort] = ACTIONS(1072),
    [anon_sym_int] = ACTIONS(1072),
    [anon_sym_uint] = ACTIONS(1072),
    [anon_sym_ulong] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1072),
    [anon_sym_double] = ACTIONS(1072),
    [anon_sym_half] = ACTIONS(1072),
    [anon_sym_size_t] = ACTIONS(1072),
    [anon_sym_ptrdiff_t] = ACTIONS(1072),
    [anon_sym_intptr_t] = ACTIONS(1072),
    [anon_sym_uintptr_t] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1072),
    [sym_vector_type] = ACTIONS(1072),
    [anon_sym_image2d_t] = ACTIONS(1072),
    [anon_sym_image3d_t] = ACTIONS(1072),
    [anon_sym_image2d_array_t] = ACTIONS(1072),
    [anon_sym_image1d_t] = ACTIONS(1072),
    [anon_sym_image1d_buffer_t] = ACTIONS(1072),
    [anon_sym_image1d_array_t] = ACTIONS(1072),
    [anon_sym_image2d_depth_t] = ACTIONS(1072),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1072),
    [anon_sym_sampler_t] = ACTIONS(1072),
    [anon_sym_queue_t] = ACTIONS(1072),
    [anon_sym_ndrange_t] = ACTIONS(1072),
    [anon_sym_clk_event_t] = ACTIONS(1072),
    [anon_sym_reserve_id_t] = ACTIONS(1072),
    [anon_sym_event_t] = ACTIONS(1072),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_goto] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_sizeof] = ACTIONS(1072),
    [sym_number_literal] = ACTIONS(1074),
    [anon_sym_L_SQUOTE] = ACTIONS(1074),
    [anon_sym_u_SQUOTE] = ACTIONS(1074),
    [anon_sym_U_SQUOTE] = ACTIONS(1074),
    [anon_sym_u8_SQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_L_DQUOTE] = ACTIONS(1074),
    [anon_sym_u_DQUOTE] = ACTIONS(1074),
    [anon_sym_U_DQUOTE] = ACTIONS(1074),
    [anon_sym_u8_DQUOTE] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_include_token1] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token2] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [aux_sym_preproc_else_token1] = ACTIONS(1076),
    [aux_sym_preproc_elif_token1] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [anon_sym_typedef] = ACTIONS(1076),
    [anon_sym_kernel] = ACTIONS(1076),
    [anon_sym___kernel] = ACTIONS(1076),
    [anon_sym_global] = ACTIONS(1076),
    [anon_sym___global] = ACTIONS(1076),
    [anon_sym_local] = ACTIONS(1076),
    [anon_sym___local] = ACTIONS(1076),
    [anon_sym_constant] = ACTIONS(1076),
    [anon_sym___constant] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym___private] = ACTIONS(1076),
    [anon_sym_generic] = ACTIONS(1076),
    [anon_sym___generic] = ACTIONS(1076),
    [anon_sym_read_only] = ACTIONS(1076),
    [anon_sym___read_only] = ACTIONS(1076),
    [anon_sym_write_only] = ACTIONS(1076),
    [anon_sym___write_only] = ACTIONS(1076),
    [anon_sym_read_write] = ACTIONS(1076),
    [anon_sym___read_write] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1078),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym___cdecl] = ACTIONS(1076),
    [anon_sym___clrcall] = ACTIONS(1076),
    [anon_sym___stdcall] = ACTIONS(1076),
    [anon_sym___fastcall] = ACTIONS(1076),
    [anon_sym___thiscall] = ACTIONS(1076),
    [anon_sym___vectorcall] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_pipe] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [anon_sym_bool] = ACTIONS(1076),
    [anon_sym_char] = ACTIONS(1076),
    [anon_sym_uchar] = ACTIONS(1076),
    [anon_sym_ushort] = ACTIONS(1076),
    [anon_sym_int] = ACTIONS(1076),
    [anon_sym_uint] = ACTIONS(1076),
    [anon_sym_ulong] = ACTIONS(1076),
    [anon_sym_float] = ACTIONS(1076),
    [anon_sym_double] = ACTIONS(1076),
    [anon_sym_half] = ACTIONS(1076),
    [anon_sym_size_t] = ACTIONS(1076),
    [anon_sym_ptrdiff_t] = ACTIONS(1076),
    [anon_sym_intptr_t] = ACTIONS(1076),
    [anon_sym_uintptr_t] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1076),
    [sym_vector_type] = ACTIONS(1076),
    [anon_sym_image2d_t] = ACTIONS(1076),
    [anon_sym_image3d_t] = ACTIONS(1076),
    [anon_sym_image2d_array_t] = ACTIONS(1076),
    [anon_sym_image1d_t] = ACTIONS(1076),
    [anon_sym_image1d_buffer_t] = ACTIONS(1076),
    [anon_sym_image1d_array_t] = ACTIONS(1076),
    [anon_sym_image2d_depth_t] = ACTIONS(1076),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1076),
    [anon_sym_sampler_t] = ACTIONS(1076),
    [anon_sym_queue_t] = ACTIONS(1076),
    [anon_sym_ndrange_t] = ACTIONS(1076),
    [anon_sym_clk_event_t] = ACTIONS(1076),
    [anon_sym_reserve_id_t] = ACTIONS(1076),
    [anon_sym_event_t] = ACTIONS(1076),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1076),
    [anon_sym_default] = ACTIONS(1076),
    [anon_sym_while] = ACTIONS(1076),
    [anon_sym_do] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1076),
    [anon_sym_return] = ACTIONS(1076),
    [anon_sym_break] = ACTIONS(1076),
    [anon_sym_continue] = ACTIONS(1076),
    [anon_sym_goto] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [anon_sym_sizeof] = ACTIONS(1076),
    [sym_number_literal] = ACTIONS(1078),
    [anon_sym_L_SQUOTE] = ACTIONS(1078),
    [anon_sym_u_SQUOTE] = ACTIONS(1078),
    [anon_sym_U_SQUOTE] = ACTIONS(1078),
    [anon_sym_u8_SQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_L_DQUOTE] = ACTIONS(1078),
    [anon_sym_u_DQUOTE] = ACTIONS(1078),
    [anon_sym_U_DQUOTE] = ACTIONS(1078),
    [anon_sym_u8_DQUOTE] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_true] = ACTIONS(1076),
    [sym_false] = ACTIONS(1076),
    [sym_null] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_identifier] = ACTIONS(1080),
    [aux_sym_preproc_include_token1] = ACTIONS(1080),
    [aux_sym_preproc_def_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token2] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1080),
    [aux_sym_preproc_else_token1] = ACTIONS(1080),
    [aux_sym_preproc_elif_token1] = ACTIONS(1080),
    [sym_preproc_directive] = ACTIONS(1080),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [anon_sym_typedef] = ACTIONS(1080),
    [anon_sym_kernel] = ACTIONS(1080),
    [anon_sym___kernel] = ACTIONS(1080),
    [anon_sym_global] = ACTIONS(1080),
    [anon_sym___global] = ACTIONS(1080),
    [anon_sym_local] = ACTIONS(1080),
    [anon_sym___local] = ACTIONS(1080),
    [anon_sym_constant] = ACTIONS(1080),
    [anon_sym___constant] = ACTIONS(1080),
    [anon_sym_private] = ACTIONS(1080),
    [anon_sym___private] = ACTIONS(1080),
    [anon_sym_generic] = ACTIONS(1080),
    [anon_sym___generic] = ACTIONS(1080),
    [anon_sym_read_only] = ACTIONS(1080),
    [anon_sym___read_only] = ACTIONS(1080),
    [anon_sym_write_only] = ACTIONS(1080),
    [anon_sym___write_only] = ACTIONS(1080),
    [anon_sym_read_write] = ACTIONS(1080),
    [anon_sym___read_write] = ACTIONS(1080),
    [anon_sym_extern] = ACTIONS(1080),
    [anon_sym___attribute__] = ACTIONS(1080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1082),
    [anon_sym___declspec] = ACTIONS(1080),
    [anon_sym___cdecl] = ACTIONS(1080),
    [anon_sym___clrcall] = ACTIONS(1080),
    [anon_sym___stdcall] = ACTIONS(1080),
    [anon_sym___fastcall] = ACTIONS(1080),
    [anon_sym___thiscall] = ACTIONS(1080),
    [anon_sym___vectorcall] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_static] = ACTIONS(1080),
    [anon_sym_auto] = ACTIONS(1080),
    [anon_sym_register] = ACTIONS(1080),
    [anon_sym_inline] = ACTIONS(1080),
    [anon_sym_const] = ACTIONS(1080),
    [anon_sym_volatile] = ACTIONS(1080),
    [anon_sym_restrict] = ACTIONS(1080),
    [anon_sym__Atomic] = ACTIONS(1080),
    [anon_sym_pipe] = ACTIONS(1080),
    [anon_sym_signed] = ACTIONS(1080),
    [anon_sym_unsigned] = ACTIONS(1080),
    [anon_sym_long] = ACTIONS(1080),
    [anon_sym_short] = ACTIONS(1080),
    [anon_sym_bool] = ACTIONS(1080),
    [anon_sym_char] = ACTIONS(1080),
    [anon_sym_uchar] = ACTIONS(1080),
    [anon_sym_ushort] = ACTIONS(1080),
    [anon_sym_int] = ACTIONS(1080),
    [anon_sym_uint] = ACTIONS(1080),
    [anon_sym_ulong] = ACTIONS(1080),
    [anon_sym_float] = ACTIONS(1080),
    [anon_sym_double] = ACTIONS(1080),
    [anon_sym_half] = ACTIONS(1080),
    [anon_sym_size_t] = ACTIONS(1080),
    [anon_sym_ptrdiff_t] = ACTIONS(1080),
    [anon_sym_intptr_t] = ACTIONS(1080),
    [anon_sym_uintptr_t] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1080),
    [sym_vector_type] = ACTIONS(1080),
    [anon_sym_image2d_t] = ACTIONS(1080),
    [anon_sym_image3d_t] = ACTIONS(1080),
    [anon_sym_image2d_array_t] = ACTIONS(1080),
    [anon_sym_image1d_t] = ACTIONS(1080),
    [anon_sym_image1d_buffer_t] = ACTIONS(1080),
    [anon_sym_image1d_array_t] = ACTIONS(1080),
    [anon_sym_image2d_depth_t] = ACTIONS(1080),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1080),
    [anon_sym_sampler_t] = ACTIONS(1080),
    [anon_sym_queue_t] = ACTIONS(1080),
    [anon_sym_ndrange_t] = ACTIONS(1080),
    [anon_sym_clk_event_t] = ACTIONS(1080),
    [anon_sym_reserve_id_t] = ACTIONS(1080),
    [anon_sym_event_t] = ACTIONS(1080),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1080),
    [anon_sym_enum] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1080),
    [anon_sym_union] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1080),
    [anon_sym_do] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1080),
    [anon_sym_return] = ACTIONS(1080),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_goto] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1082),
    [anon_sym_sizeof] = ACTIONS(1080),
    [sym_number_literal] = ACTIONS(1082),
    [anon_sym_L_SQUOTE] = ACTIONS(1082),
    [anon_sym_u_SQUOTE] = ACTIONS(1082),
    [anon_sym_U_SQUOTE] = ACTIONS(1082),
    [anon_sym_u8_SQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_L_DQUOTE] = ACTIONS(1082),
    [anon_sym_u_DQUOTE] = ACTIONS(1082),
    [anon_sym_U_DQUOTE] = ACTIONS(1082),
    [anon_sym_u8_DQUOTE] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_true] = ACTIONS(1080),
    [sym_false] = ACTIONS(1080),
    [sym_null] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_identifier] = ACTIONS(1084),
    [aux_sym_preproc_include_token1] = ACTIONS(1084),
    [aux_sym_preproc_def_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token2] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1084),
    [aux_sym_preproc_else_token1] = ACTIONS(1084),
    [aux_sym_preproc_elif_token1] = ACTIONS(1084),
    [sym_preproc_directive] = ACTIONS(1084),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_AMP] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_typedef] = ACTIONS(1084),
    [anon_sym_kernel] = ACTIONS(1084),
    [anon_sym___kernel] = ACTIONS(1084),
    [anon_sym_global] = ACTIONS(1084),
    [anon_sym___global] = ACTIONS(1084),
    [anon_sym_local] = ACTIONS(1084),
    [anon_sym___local] = ACTIONS(1084),
    [anon_sym_constant] = ACTIONS(1084),
    [anon_sym___constant] = ACTIONS(1084),
    [anon_sym_private] = ACTIONS(1084),
    [anon_sym___private] = ACTIONS(1084),
    [anon_sym_generic] = ACTIONS(1084),
    [anon_sym___generic] = ACTIONS(1084),
    [anon_sym_read_only] = ACTIONS(1084),
    [anon_sym___read_only] = ACTIONS(1084),
    [anon_sym_write_only] = ACTIONS(1084),
    [anon_sym___write_only] = ACTIONS(1084),
    [anon_sym_read_write] = ACTIONS(1084),
    [anon_sym___read_write] = ACTIONS(1084),
    [anon_sym_extern] = ACTIONS(1084),
    [anon_sym___attribute__] = ACTIONS(1084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1086),
    [anon_sym___declspec] = ACTIONS(1084),
    [anon_sym___cdecl] = ACTIONS(1084),
    [anon_sym___clrcall] = ACTIONS(1084),
    [anon_sym___stdcall] = ACTIONS(1084),
    [anon_sym___fastcall] = ACTIONS(1084),
    [anon_sym___thiscall] = ACTIONS(1084),
    [anon_sym___vectorcall] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1084),
    [anon_sym_auto] = ACTIONS(1084),
    [anon_sym_register] = ACTIONS(1084),
    [anon_sym_inline] = ACTIONS(1084),
    [anon_sym_const] = ACTIONS(1084),
    [anon_sym_volatile] = ACTIONS(1084),
    [anon_sym_restrict] = ACTIONS(1084),
    [anon_sym__Atomic] = ACTIONS(1084),
    [anon_sym_pipe] = ACTIONS(1084),
    [anon_sym_signed] = ACTIONS(1084),
    [anon_sym_unsigned] = ACTIONS(1084),
    [anon_sym_long] = ACTIONS(1084),
    [anon_sym_short] = ACTIONS(1084),
    [anon_sym_bool] = ACTIONS(1084),
    [anon_sym_char] = ACTIONS(1084),
    [anon_sym_uchar] = ACTIONS(1084),
    [anon_sym_ushort] = ACTIONS(1084),
    [anon_sym_int] = ACTIONS(1084),
    [anon_sym_uint] = ACTIONS(1084),
    [anon_sym_ulong] = ACTIONS(1084),
    [anon_sym_float] = ACTIONS(1084),
    [anon_sym_double] = ACTIONS(1084),
    [anon_sym_half] = ACTIONS(1084),
    [anon_sym_size_t] = ACTIONS(1084),
    [anon_sym_ptrdiff_t] = ACTIONS(1084),
    [anon_sym_intptr_t] = ACTIONS(1084),
    [anon_sym_uintptr_t] = ACTIONS(1084),
    [anon_sym_void] = ACTIONS(1084),
    [sym_vector_type] = ACTIONS(1084),
    [anon_sym_image2d_t] = ACTIONS(1084),
    [anon_sym_image3d_t] = ACTIONS(1084),
    [anon_sym_image2d_array_t] = ACTIONS(1084),
    [anon_sym_image1d_t] = ACTIONS(1084),
    [anon_sym_image1d_buffer_t] = ACTIONS(1084),
    [anon_sym_image1d_array_t] = ACTIONS(1084),
    [anon_sym_image2d_depth_t] = ACTIONS(1084),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1084),
    [anon_sym_sampler_t] = ACTIONS(1084),
    [anon_sym_queue_t] = ACTIONS(1084),
    [anon_sym_ndrange_t] = ACTIONS(1084),
    [anon_sym_clk_event_t] = ACTIONS(1084),
    [anon_sym_reserve_id_t] = ACTIONS(1084),
    [anon_sym_event_t] = ACTIONS(1084),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1084),
    [anon_sym_enum] = ACTIONS(1084),
    [anon_sym_struct] = ACTIONS(1084),
    [anon_sym_union] = ACTIONS(1084),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1084),
    [anon_sym_default] = ACTIONS(1084),
    [anon_sym_while] = ACTIONS(1084),
    [anon_sym_do] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1084),
    [anon_sym_return] = ACTIONS(1084),
    [anon_sym_break] = ACTIONS(1084),
    [anon_sym_continue] = ACTIONS(1084),
    [anon_sym_goto] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1084),
    [sym_number_literal] = ACTIONS(1086),
    [anon_sym_L_SQUOTE] = ACTIONS(1086),
    [anon_sym_u_SQUOTE] = ACTIONS(1086),
    [anon_sym_U_SQUOTE] = ACTIONS(1086),
    [anon_sym_u8_SQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_L_DQUOTE] = ACTIONS(1086),
    [anon_sym_u_DQUOTE] = ACTIONS(1086),
    [anon_sym_U_DQUOTE] = ACTIONS(1086),
    [anon_sym_u8_DQUOTE] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [sym_true] = ACTIONS(1084),
    [sym_false] = ACTIONS(1084),
    [sym_null] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_include_token1] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token2] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [aux_sym_preproc_else_token1] = ACTIONS(1088),
    [aux_sym_preproc_elif_token1] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_typedef] = ACTIONS(1088),
    [anon_sym_kernel] = ACTIONS(1088),
    [anon_sym___kernel] = ACTIONS(1088),
    [anon_sym_global] = ACTIONS(1088),
    [anon_sym___global] = ACTIONS(1088),
    [anon_sym_local] = ACTIONS(1088),
    [anon_sym___local] = ACTIONS(1088),
    [anon_sym_constant] = ACTIONS(1088),
    [anon_sym___constant] = ACTIONS(1088),
    [anon_sym_private] = ACTIONS(1088),
    [anon_sym___private] = ACTIONS(1088),
    [anon_sym_generic] = ACTIONS(1088),
    [anon_sym___generic] = ACTIONS(1088),
    [anon_sym_read_only] = ACTIONS(1088),
    [anon_sym___read_only] = ACTIONS(1088),
    [anon_sym_write_only] = ACTIONS(1088),
    [anon_sym___write_only] = ACTIONS(1088),
    [anon_sym_read_write] = ACTIONS(1088),
    [anon_sym___read_write] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1090),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym___cdecl] = ACTIONS(1088),
    [anon_sym___clrcall] = ACTIONS(1088),
    [anon_sym___stdcall] = ACTIONS(1088),
    [anon_sym___fastcall] = ACTIONS(1088),
    [anon_sym___thiscall] = ACTIONS(1088),
    [anon_sym___vectorcall] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_pipe] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [anon_sym_bool] = ACTIONS(1088),
    [anon_sym_char] = ACTIONS(1088),
    [anon_sym_uchar] = ACTIONS(1088),
    [anon_sym_ushort] = ACTIONS(1088),
    [anon_sym_int] = ACTIONS(1088),
    [anon_sym_uint] = ACTIONS(1088),
    [anon_sym_ulong] = ACTIONS(1088),
    [anon_sym_float] = ACTIONS(1088),
    [anon_sym_double] = ACTIONS(1088),
    [anon_sym_half] = ACTIONS(1088),
    [anon_sym_size_t] = ACTIONS(1088),
    [anon_sym_ptrdiff_t] = ACTIONS(1088),
    [anon_sym_intptr_t] = ACTIONS(1088),
    [anon_sym_uintptr_t] = ACTIONS(1088),
    [anon_sym_void] = ACTIONS(1088),
    [sym_vector_type] = ACTIONS(1088),
    [anon_sym_image2d_t] = ACTIONS(1088),
    [anon_sym_image3d_t] = ACTIONS(1088),
    [anon_sym_image2d_array_t] = ACTIONS(1088),
    [anon_sym_image1d_t] = ACTIONS(1088),
    [anon_sym_image1d_buffer_t] = ACTIONS(1088),
    [anon_sym_image1d_array_t] = ACTIONS(1088),
    [anon_sym_image2d_depth_t] = ACTIONS(1088),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1088),
    [anon_sym_sampler_t] = ACTIONS(1088),
    [anon_sym_queue_t] = ACTIONS(1088),
    [anon_sym_ndrange_t] = ACTIONS(1088),
    [anon_sym_clk_event_t] = ACTIONS(1088),
    [anon_sym_reserve_id_t] = ACTIONS(1088),
    [anon_sym_event_t] = ACTIONS(1088),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_goto] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_sizeof] = ACTIONS(1088),
    [sym_number_literal] = ACTIONS(1090),
    [anon_sym_L_SQUOTE] = ACTIONS(1090),
    [anon_sym_u_SQUOTE] = ACTIONS(1090),
    [anon_sym_U_SQUOTE] = ACTIONS(1090),
    [anon_sym_u8_SQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_L_DQUOTE] = ACTIONS(1090),
    [anon_sym_u_DQUOTE] = ACTIONS(1090),
    [anon_sym_U_DQUOTE] = ACTIONS(1090),
    [anon_sym_u8_DQUOTE] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_identifier] = ACTIONS(1092),
    [aux_sym_preproc_include_token1] = ACTIONS(1092),
    [aux_sym_preproc_def_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token2] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1092),
    [aux_sym_preproc_else_token1] = ACTIONS(1092),
    [aux_sym_preproc_elif_token1] = ACTIONS(1092),
    [sym_preproc_directive] = ACTIONS(1092),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_BANG] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [anon_sym_typedef] = ACTIONS(1092),
    [anon_sym_kernel] = ACTIONS(1092),
    [anon_sym___kernel] = ACTIONS(1092),
    [anon_sym_global] = ACTIONS(1092),
    [anon_sym___global] = ACTIONS(1092),
    [anon_sym_local] = ACTIONS(1092),
    [anon_sym___local] = ACTIONS(1092),
    [anon_sym_constant] = ACTIONS(1092),
    [anon_sym___constant] = ACTIONS(1092),
    [anon_sym_private] = ACTIONS(1092),
    [anon_sym___private] = ACTIONS(1092),
    [anon_sym_generic] = ACTIONS(1092),
    [anon_sym___generic] = ACTIONS(1092),
    [anon_sym_read_only] = ACTIONS(1092),
    [anon_sym___read_only] = ACTIONS(1092),
    [anon_sym_write_only] = ACTIONS(1092),
    [anon_sym___write_only] = ACTIONS(1092),
    [anon_sym_read_write] = ACTIONS(1092),
    [anon_sym___read_write] = ACTIONS(1092),
    [anon_sym_extern] = ACTIONS(1092),
    [anon_sym___attribute__] = ACTIONS(1092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1094),
    [anon_sym___declspec] = ACTIONS(1092),
    [anon_sym___cdecl] = ACTIONS(1092),
    [anon_sym___clrcall] = ACTIONS(1092),
    [anon_sym___stdcall] = ACTIONS(1092),
    [anon_sym___fastcall] = ACTIONS(1092),
    [anon_sym___thiscall] = ACTIONS(1092),
    [anon_sym___vectorcall] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_auto] = ACTIONS(1092),
    [anon_sym_register] = ACTIONS(1092),
    [anon_sym_inline] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_volatile] = ACTIONS(1092),
    [anon_sym_restrict] = ACTIONS(1092),
    [anon_sym__Atomic] = ACTIONS(1092),
    [anon_sym_pipe] = ACTIONS(1092),
    [anon_sym_signed] = ACTIONS(1092),
    [anon_sym_unsigned] = ACTIONS(1092),
    [anon_sym_long] = ACTIONS(1092),
    [anon_sym_short] = ACTIONS(1092),
    [anon_sym_bool] = ACTIONS(1092),
    [anon_sym_char] = ACTIONS(1092),
    [anon_sym_uchar] = ACTIONS(1092),
    [anon_sym_ushort] = ACTIONS(1092),
    [anon_sym_int] = ACTIONS(1092),
    [anon_sym_uint] = ACTIONS(1092),
    [anon_sym_ulong] = ACTIONS(1092),
    [anon_sym_float] = ACTIONS(1092),
    [anon_sym_double] = ACTIONS(1092),
    [anon_sym_half] = ACTIONS(1092),
    [anon_sym_size_t] = ACTIONS(1092),
    [anon_sym_ptrdiff_t] = ACTIONS(1092),
    [anon_sym_intptr_t] = ACTIONS(1092),
    [anon_sym_uintptr_t] = ACTIONS(1092),
    [anon_sym_void] = ACTIONS(1092),
    [sym_vector_type] = ACTIONS(1092),
    [anon_sym_image2d_t] = ACTIONS(1092),
    [anon_sym_image3d_t] = ACTIONS(1092),
    [anon_sym_image2d_array_t] = ACTIONS(1092),
    [anon_sym_image1d_t] = ACTIONS(1092),
    [anon_sym_image1d_buffer_t] = ACTIONS(1092),
    [anon_sym_image1d_array_t] = ACTIONS(1092),
    [anon_sym_image2d_depth_t] = ACTIONS(1092),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1092),
    [anon_sym_sampler_t] = ACTIONS(1092),
    [anon_sym_queue_t] = ACTIONS(1092),
    [anon_sym_ndrange_t] = ACTIONS(1092),
    [anon_sym_clk_event_t] = ACTIONS(1092),
    [anon_sym_reserve_id_t] = ACTIONS(1092),
    [anon_sym_event_t] = ACTIONS(1092),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_struct] = ACTIONS(1092),
    [anon_sym_union] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_goto] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_sizeof] = ACTIONS(1092),
    [sym_number_literal] = ACTIONS(1094),
    [anon_sym_L_SQUOTE] = ACTIONS(1094),
    [anon_sym_u_SQUOTE] = ACTIONS(1094),
    [anon_sym_U_SQUOTE] = ACTIONS(1094),
    [anon_sym_u8_SQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_L_DQUOTE] = ACTIONS(1094),
    [anon_sym_u_DQUOTE] = ACTIONS(1094),
    [anon_sym_U_DQUOTE] = ACTIONS(1094),
    [anon_sym_u8_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_include_token1] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token2] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [aux_sym_preproc_else_token1] = ACTIONS(1096),
    [aux_sym_preproc_elif_token1] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_typedef] = ACTIONS(1096),
    [anon_sym_kernel] = ACTIONS(1096),
    [anon_sym___kernel] = ACTIONS(1096),
    [anon_sym_global] = ACTIONS(1096),
    [anon_sym___global] = ACTIONS(1096),
    [anon_sym_local] = ACTIONS(1096),
    [anon_sym___local] = ACTIONS(1096),
    [anon_sym_constant] = ACTIONS(1096),
    [anon_sym___constant] = ACTIONS(1096),
    [anon_sym_private] = ACTIONS(1096),
    [anon_sym___private] = ACTIONS(1096),
    [anon_sym_generic] = ACTIONS(1096),
    [anon_sym___generic] = ACTIONS(1096),
    [anon_sym_read_only] = ACTIONS(1096),
    [anon_sym___read_only] = ACTIONS(1096),
    [anon_sym_write_only] = ACTIONS(1096),
    [anon_sym___write_only] = ACTIONS(1096),
    [anon_sym_read_write] = ACTIONS(1096),
    [anon_sym___read_write] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1098),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym___cdecl] = ACTIONS(1096),
    [anon_sym___clrcall] = ACTIONS(1096),
    [anon_sym___stdcall] = ACTIONS(1096),
    [anon_sym___fastcall] = ACTIONS(1096),
    [anon_sym___thiscall] = ACTIONS(1096),
    [anon_sym___vectorcall] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_pipe] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [anon_sym_bool] = ACTIONS(1096),
    [anon_sym_char] = ACTIONS(1096),
    [anon_sym_uchar] = ACTIONS(1096),
    [anon_sym_ushort] = ACTIONS(1096),
    [anon_sym_int] = ACTIONS(1096),
    [anon_sym_uint] = ACTIONS(1096),
    [anon_sym_ulong] = ACTIONS(1096),
    [anon_sym_float] = ACTIONS(1096),
    [anon_sym_double] = ACTIONS(1096),
    [anon_sym_half] = ACTIONS(1096),
    [anon_sym_size_t] = ACTIONS(1096),
    [anon_sym_ptrdiff_t] = ACTIONS(1096),
    [anon_sym_intptr_t] = ACTIONS(1096),
    [anon_sym_uintptr_t] = ACTIONS(1096),
    [anon_sym_void] = ACTIONS(1096),
    [sym_vector_type] = ACTIONS(1096),
    [anon_sym_image2d_t] = ACTIONS(1096),
    [anon_sym_image3d_t] = ACTIONS(1096),
    [anon_sym_image2d_array_t] = ACTIONS(1096),
    [anon_sym_image1d_t] = ACTIONS(1096),
    [anon_sym_image1d_buffer_t] = ACTIONS(1096),
    [anon_sym_image1d_array_t] = ACTIONS(1096),
    [anon_sym_image2d_depth_t] = ACTIONS(1096),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1096),
    [anon_sym_sampler_t] = ACTIONS(1096),
    [anon_sym_queue_t] = ACTIONS(1096),
    [anon_sym_ndrange_t] = ACTIONS(1096),
    [anon_sym_clk_event_t] = ACTIONS(1096),
    [anon_sym_reserve_id_t] = ACTIONS(1096),
    [anon_sym_event_t] = ACTIONS(1096),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_goto] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_sizeof] = ACTIONS(1096),
    [sym_number_literal] = ACTIONS(1098),
    [anon_sym_L_SQUOTE] = ACTIONS(1098),
    [anon_sym_u_SQUOTE] = ACTIONS(1098),
    [anon_sym_U_SQUOTE] = ACTIONS(1098),
    [anon_sym_u8_SQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_L_DQUOTE] = ACTIONS(1098),
    [anon_sym_u_DQUOTE] = ACTIONS(1098),
    [anon_sym_U_DQUOTE] = ACTIONS(1098),
    [anon_sym_u8_DQUOTE] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_identifier] = ACTIONS(1100),
    [aux_sym_preproc_include_token1] = ACTIONS(1100),
    [aux_sym_preproc_def_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token2] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1100),
    [aux_sym_preproc_else_token1] = ACTIONS(1100),
    [aux_sym_preproc_elif_token1] = ACTIONS(1100),
    [sym_preproc_directive] = ACTIONS(1100),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_typedef] = ACTIONS(1100),
    [anon_sym_kernel] = ACTIONS(1100),
    [anon_sym___kernel] = ACTIONS(1100),
    [anon_sym_global] = ACTIONS(1100),
    [anon_sym___global] = ACTIONS(1100),
    [anon_sym_local] = ACTIONS(1100),
    [anon_sym___local] = ACTIONS(1100),
    [anon_sym_constant] = ACTIONS(1100),
    [anon_sym___constant] = ACTIONS(1100),
    [anon_sym_private] = ACTIONS(1100),
    [anon_sym___private] = ACTIONS(1100),
    [anon_sym_generic] = ACTIONS(1100),
    [anon_sym___generic] = ACTIONS(1100),
    [anon_sym_read_only] = ACTIONS(1100),
    [anon_sym___read_only] = ACTIONS(1100),
    [anon_sym_write_only] = ACTIONS(1100),
    [anon_sym___write_only] = ACTIONS(1100),
    [anon_sym_read_write] = ACTIONS(1100),
    [anon_sym___read_write] = ACTIONS(1100),
    [anon_sym_extern] = ACTIONS(1100),
    [anon_sym___attribute__] = ACTIONS(1100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1102),
    [anon_sym___declspec] = ACTIONS(1100),
    [anon_sym___cdecl] = ACTIONS(1100),
    [anon_sym___clrcall] = ACTIONS(1100),
    [anon_sym___stdcall] = ACTIONS(1100),
    [anon_sym___fastcall] = ACTIONS(1100),
    [anon_sym___thiscall] = ACTIONS(1100),
    [anon_sym___vectorcall] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_auto] = ACTIONS(1100),
    [anon_sym_register] = ACTIONS(1100),
    [anon_sym_inline] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_volatile] = ACTIONS(1100),
    [anon_sym_restrict] = ACTIONS(1100),
    [anon_sym__Atomic] = ACTIONS(1100),
    [anon_sym_pipe] = ACTIONS(1100),
    [anon_sym_signed] = ACTIONS(1100),
    [anon_sym_unsigned] = ACTIONS(1100),
    [anon_sym_long] = ACTIONS(1100),
    [anon_sym_short] = ACTIONS(1100),
    [anon_sym_bool] = ACTIONS(1100),
    [anon_sym_char] = ACTIONS(1100),
    [anon_sym_uchar] = ACTIONS(1100),
    [anon_sym_ushort] = ACTIONS(1100),
    [anon_sym_int] = ACTIONS(1100),
    [anon_sym_uint] = ACTIONS(1100),
    [anon_sym_ulong] = ACTIONS(1100),
    [anon_sym_float] = ACTIONS(1100),
    [anon_sym_double] = ACTIONS(1100),
    [anon_sym_half] = ACTIONS(1100),
    [anon_sym_size_t] = ACTIONS(1100),
    [anon_sym_ptrdiff_t] = ACTIONS(1100),
    [anon_sym_intptr_t] = ACTIONS(1100),
    [anon_sym_uintptr_t] = ACTIONS(1100),
    [anon_sym_void] = ACTIONS(1100),
    [sym_vector_type] = ACTIONS(1100),
    [anon_sym_image2d_t] = ACTIONS(1100),
    [anon_sym_image3d_t] = ACTIONS(1100),
    [anon_sym_image2d_array_t] = ACTIONS(1100),
    [anon_sym_image1d_t] = ACTIONS(1100),
    [anon_sym_image1d_buffer_t] = ACTIONS(1100),
    [anon_sym_image1d_array_t] = ACTIONS(1100),
    [anon_sym_image2d_depth_t] = ACTIONS(1100),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1100),
    [anon_sym_sampler_t] = ACTIONS(1100),
    [anon_sym_queue_t] = ACTIONS(1100),
    [anon_sym_ndrange_t] = ACTIONS(1100),
    [anon_sym_clk_event_t] = ACTIONS(1100),
    [anon_sym_reserve_id_t] = ACTIONS(1100),
    [anon_sym_event_t] = ACTIONS(1100),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [anon_sym_struct] = ACTIONS(1100),
    [anon_sym_union] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_goto] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_sizeof] = ACTIONS(1100),
    [sym_number_literal] = ACTIONS(1102),
    [anon_sym_L_SQUOTE] = ACTIONS(1102),
    [anon_sym_u_SQUOTE] = ACTIONS(1102),
    [anon_sym_U_SQUOTE] = ACTIONS(1102),
    [anon_sym_u8_SQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_L_DQUOTE] = ACTIONS(1102),
    [anon_sym_u_DQUOTE] = ACTIONS(1102),
    [anon_sym_U_DQUOTE] = ACTIONS(1102),
    [anon_sym_u8_DQUOTE] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_identifier] = ACTIONS(1104),
    [aux_sym_preproc_include_token1] = ACTIONS(1104),
    [aux_sym_preproc_def_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token2] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1104),
    [aux_sym_preproc_else_token1] = ACTIONS(1104),
    [aux_sym_preproc_elif_token1] = ACTIONS(1104),
    [sym_preproc_directive] = ACTIONS(1104),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_typedef] = ACTIONS(1104),
    [anon_sym_kernel] = ACTIONS(1104),
    [anon_sym___kernel] = ACTIONS(1104),
    [anon_sym_global] = ACTIONS(1104),
    [anon_sym___global] = ACTIONS(1104),
    [anon_sym_local] = ACTIONS(1104),
    [anon_sym___local] = ACTIONS(1104),
    [anon_sym_constant] = ACTIONS(1104),
    [anon_sym___constant] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym___private] = ACTIONS(1104),
    [anon_sym_generic] = ACTIONS(1104),
    [anon_sym___generic] = ACTIONS(1104),
    [anon_sym_read_only] = ACTIONS(1104),
    [anon_sym___read_only] = ACTIONS(1104),
    [anon_sym_write_only] = ACTIONS(1104),
    [anon_sym___write_only] = ACTIONS(1104),
    [anon_sym_read_write] = ACTIONS(1104),
    [anon_sym___read_write] = ACTIONS(1104),
    [anon_sym_extern] = ACTIONS(1104),
    [anon_sym___attribute__] = ACTIONS(1104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1106),
    [anon_sym___declspec] = ACTIONS(1104),
    [anon_sym___cdecl] = ACTIONS(1104),
    [anon_sym___clrcall] = ACTIONS(1104),
    [anon_sym___stdcall] = ACTIONS(1104),
    [anon_sym___fastcall] = ACTIONS(1104),
    [anon_sym___thiscall] = ACTIONS(1104),
    [anon_sym___vectorcall] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_auto] = ACTIONS(1104),
    [anon_sym_register] = ACTIONS(1104),
    [anon_sym_inline] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_volatile] = ACTIONS(1104),
    [anon_sym_restrict] = ACTIONS(1104),
    [anon_sym__Atomic] = ACTIONS(1104),
    [anon_sym_pipe] = ACTIONS(1104),
    [anon_sym_signed] = ACTIONS(1104),
    [anon_sym_unsigned] = ACTIONS(1104),
    [anon_sym_long] = ACTIONS(1104),
    [anon_sym_short] = ACTIONS(1104),
    [anon_sym_bool] = ACTIONS(1104),
    [anon_sym_char] = ACTIONS(1104),
    [anon_sym_uchar] = ACTIONS(1104),
    [anon_sym_ushort] = ACTIONS(1104),
    [anon_sym_int] = ACTIONS(1104),
    [anon_sym_uint] = ACTIONS(1104),
    [anon_sym_ulong] = ACTIONS(1104),
    [anon_sym_float] = ACTIONS(1104),
    [anon_sym_double] = ACTIONS(1104),
    [anon_sym_half] = ACTIONS(1104),
    [anon_sym_size_t] = ACTIONS(1104),
    [anon_sym_ptrdiff_t] = ACTIONS(1104),
    [anon_sym_intptr_t] = ACTIONS(1104),
    [anon_sym_uintptr_t] = ACTIONS(1104),
    [anon_sym_void] = ACTIONS(1104),
    [sym_vector_type] = ACTIONS(1104),
    [anon_sym_image2d_t] = ACTIONS(1104),
    [anon_sym_image3d_t] = ACTIONS(1104),
    [anon_sym_image2d_array_t] = ACTIONS(1104),
    [anon_sym_image1d_t] = ACTIONS(1104),
    [anon_sym_image1d_buffer_t] = ACTIONS(1104),
    [anon_sym_image1d_array_t] = ACTIONS(1104),
    [anon_sym_image2d_depth_t] = ACTIONS(1104),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1104),
    [anon_sym_sampler_t] = ACTIONS(1104),
    [anon_sym_queue_t] = ACTIONS(1104),
    [anon_sym_ndrange_t] = ACTIONS(1104),
    [anon_sym_clk_event_t] = ACTIONS(1104),
    [anon_sym_reserve_id_t] = ACTIONS(1104),
    [anon_sym_event_t] = ACTIONS(1104),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [anon_sym_struct] = ACTIONS(1104),
    [anon_sym_union] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_goto] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_sizeof] = ACTIONS(1104),
    [sym_number_literal] = ACTIONS(1106),
    [anon_sym_L_SQUOTE] = ACTIONS(1106),
    [anon_sym_u_SQUOTE] = ACTIONS(1106),
    [anon_sym_U_SQUOTE] = ACTIONS(1106),
    [anon_sym_u8_SQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_L_DQUOTE] = ACTIONS(1106),
    [anon_sym_u_DQUOTE] = ACTIONS(1106),
    [anon_sym_U_DQUOTE] = ACTIONS(1106),
    [anon_sym_u8_DQUOTE] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_preproc_include_token1] = ACTIONS(1108),
    [aux_sym_preproc_def_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token2] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1108),
    [aux_sym_preproc_else_token1] = ACTIONS(1108),
    [aux_sym_preproc_elif_token1] = ACTIONS(1108),
    [sym_preproc_directive] = ACTIONS(1108),
    [anon_sym_LPAREN2] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_typedef] = ACTIONS(1108),
    [anon_sym_kernel] = ACTIONS(1108),
    [anon_sym___kernel] = ACTIONS(1108),
    [anon_sym_global] = ACTIONS(1108),
    [anon_sym___global] = ACTIONS(1108),
    [anon_sym_local] = ACTIONS(1108),
    [anon_sym___local] = ACTIONS(1108),
    [anon_sym_constant] = ACTIONS(1108),
    [anon_sym___constant] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym___private] = ACTIONS(1108),
    [anon_sym_generic] = ACTIONS(1108),
    [anon_sym___generic] = ACTIONS(1108),
    [anon_sym_read_only] = ACTIONS(1108),
    [anon_sym___read_only] = ACTIONS(1108),
    [anon_sym_write_only] = ACTIONS(1108),
    [anon_sym___write_only] = ACTIONS(1108),
    [anon_sym_read_write] = ACTIONS(1108),
    [anon_sym___read_write] = ACTIONS(1108),
    [anon_sym_extern] = ACTIONS(1108),
    [anon_sym___attribute__] = ACTIONS(1108),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1110),
    [anon_sym___declspec] = ACTIONS(1108),
    [anon_sym___cdecl] = ACTIONS(1108),
    [anon_sym___clrcall] = ACTIONS(1108),
    [anon_sym___stdcall] = ACTIONS(1108),
    [anon_sym___fastcall] = ACTIONS(1108),
    [anon_sym___thiscall] = ACTIONS(1108),
    [anon_sym___vectorcall] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_auto] = ACTIONS(1108),
    [anon_sym_register] = ACTIONS(1108),
    [anon_sym_inline] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_volatile] = ACTIONS(1108),
    [anon_sym_restrict] = ACTIONS(1108),
    [anon_sym__Atomic] = ACTIONS(1108),
    [anon_sym_pipe] = ACTIONS(1108),
    [anon_sym_signed] = ACTIONS(1108),
    [anon_sym_unsigned] = ACTIONS(1108),
    [anon_sym_long] = ACTIONS(1108),
    [anon_sym_short] = ACTIONS(1108),
    [anon_sym_bool] = ACTIONS(1108),
    [anon_sym_char] = ACTIONS(1108),
    [anon_sym_uchar] = ACTIONS(1108),
    [anon_sym_ushort] = ACTIONS(1108),
    [anon_sym_int] = ACTIONS(1108),
    [anon_sym_uint] = ACTIONS(1108),
    [anon_sym_ulong] = ACTIONS(1108),
    [anon_sym_float] = ACTIONS(1108),
    [anon_sym_double] = ACTIONS(1108),
    [anon_sym_half] = ACTIONS(1108),
    [anon_sym_size_t] = ACTIONS(1108),
    [anon_sym_ptrdiff_t] = ACTIONS(1108),
    [anon_sym_intptr_t] = ACTIONS(1108),
    [anon_sym_uintptr_t] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1108),
    [sym_vector_type] = ACTIONS(1108),
    [anon_sym_image2d_t] = ACTIONS(1108),
    [anon_sym_image3d_t] = ACTIONS(1108),
    [anon_sym_image2d_array_t] = ACTIONS(1108),
    [anon_sym_image1d_t] = ACTIONS(1108),
    [anon_sym_image1d_buffer_t] = ACTIONS(1108),
    [anon_sym_image1d_array_t] = ACTIONS(1108),
    [anon_sym_image2d_depth_t] = ACTIONS(1108),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1108),
    [anon_sym_sampler_t] = ACTIONS(1108),
    [anon_sym_queue_t] = ACTIONS(1108),
    [anon_sym_ndrange_t] = ACTIONS(1108),
    [anon_sym_clk_event_t] = ACTIONS(1108),
    [anon_sym_reserve_id_t] = ACTIONS(1108),
    [anon_sym_event_t] = ACTIONS(1108),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [anon_sym_struct] = ACTIONS(1108),
    [anon_sym_union] = ACTIONS(1108),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_case] = ACTIONS(1108),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_while] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1108),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1108),
    [anon_sym_goto] = ACTIONS(1108),
    [anon_sym_DASH_DASH] = ACTIONS(1110),
    [anon_sym_PLUS_PLUS] = ACTIONS(1110),
    [anon_sym_sizeof] = ACTIONS(1108),
    [sym_number_literal] = ACTIONS(1110),
    [anon_sym_L_SQUOTE] = ACTIONS(1110),
    [anon_sym_u_SQUOTE] = ACTIONS(1110),
    [anon_sym_U_SQUOTE] = ACTIONS(1110),
    [anon_sym_u8_SQUOTE] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1108),
    [sym_false] = ACTIONS(1108),
    [sym_null] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_identifier] = ACTIONS(1112),
    [aux_sym_preproc_include_token1] = ACTIONS(1112),
    [aux_sym_preproc_def_token1] = ACTIONS(1112),
    [aux_sym_preproc_if_token1] = ACTIONS(1112),
    [aux_sym_preproc_if_token2] = ACTIONS(1112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1112),
    [aux_sym_preproc_else_token1] = ACTIONS(1112),
    [aux_sym_preproc_elif_token1] = ACTIONS(1112),
    [sym_preproc_directive] = ACTIONS(1112),
    [anon_sym_LPAREN2] = ACTIONS(1114),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_typedef] = ACTIONS(1112),
    [anon_sym_kernel] = ACTIONS(1112),
    [anon_sym___kernel] = ACTIONS(1112),
    [anon_sym_global] = ACTIONS(1112),
    [anon_sym___global] = ACTIONS(1112),
    [anon_sym_local] = ACTIONS(1112),
    [anon_sym___local] = ACTIONS(1112),
    [anon_sym_constant] = ACTIONS(1112),
    [anon_sym___constant] = ACTIONS(1112),
    [anon_sym_private] = ACTIONS(1112),
    [anon_sym___private] = ACTIONS(1112),
    [anon_sym_generic] = ACTIONS(1112),
    [anon_sym___generic] = ACTIONS(1112),
    [anon_sym_read_only] = ACTIONS(1112),
    [anon_sym___read_only] = ACTIONS(1112),
    [anon_sym_write_only] = ACTIONS(1112),
    [anon_sym___write_only] = ACTIONS(1112),
    [anon_sym_read_write] = ACTIONS(1112),
    [anon_sym___read_write] = ACTIONS(1112),
    [anon_sym_extern] = ACTIONS(1112),
    [anon_sym___attribute__] = ACTIONS(1112),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1114),
    [anon_sym___declspec] = ACTIONS(1112),
    [anon_sym___cdecl] = ACTIONS(1112),
    [anon_sym___clrcall] = ACTIONS(1112),
    [anon_sym___stdcall] = ACTIONS(1112),
    [anon_sym___fastcall] = ACTIONS(1112),
    [anon_sym___thiscall] = ACTIONS(1112),
    [anon_sym___vectorcall] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1112),
    [anon_sym_auto] = ACTIONS(1112),
    [anon_sym_register] = ACTIONS(1112),
    [anon_sym_inline] = ACTIONS(1112),
    [anon_sym_const] = ACTIONS(1112),
    [anon_sym_volatile] = ACTIONS(1112),
    [anon_sym_restrict] = ACTIONS(1112),
    [anon_sym__Atomic] = ACTIONS(1112),
    [anon_sym_pipe] = ACTIONS(1112),
    [anon_sym_signed] = ACTIONS(1112),
    [anon_sym_unsigned] = ACTIONS(1112),
    [anon_sym_long] = ACTIONS(1112),
    [anon_sym_short] = ACTIONS(1112),
    [anon_sym_bool] = ACTIONS(1112),
    [anon_sym_char] = ACTIONS(1112),
    [anon_sym_uchar] = ACTIONS(1112),
    [anon_sym_ushort] = ACTIONS(1112),
    [anon_sym_int] = ACTIONS(1112),
    [anon_sym_uint] = ACTIONS(1112),
    [anon_sym_ulong] = ACTIONS(1112),
    [anon_sym_float] = ACTIONS(1112),
    [anon_sym_double] = ACTIONS(1112),
    [anon_sym_half] = ACTIONS(1112),
    [anon_sym_size_t] = ACTIONS(1112),
    [anon_sym_ptrdiff_t] = ACTIONS(1112),
    [anon_sym_intptr_t] = ACTIONS(1112),
    [anon_sym_uintptr_t] = ACTIONS(1112),
    [anon_sym_void] = ACTIONS(1112),
    [sym_vector_type] = ACTIONS(1112),
    [anon_sym_image2d_t] = ACTIONS(1112),
    [anon_sym_image3d_t] = ACTIONS(1112),
    [anon_sym_image2d_array_t] = ACTIONS(1112),
    [anon_sym_image1d_t] = ACTIONS(1112),
    [anon_sym_image1d_buffer_t] = ACTIONS(1112),
    [anon_sym_image1d_array_t] = ACTIONS(1112),
    [anon_sym_image2d_depth_t] = ACTIONS(1112),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1112),
    [anon_sym_sampler_t] = ACTIONS(1112),
    [anon_sym_queue_t] = ACTIONS(1112),
    [anon_sym_ndrange_t] = ACTIONS(1112),
    [anon_sym_clk_event_t] = ACTIONS(1112),
    [anon_sym_reserve_id_t] = ACTIONS(1112),
    [anon_sym_event_t] = ACTIONS(1112),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1112),
    [anon_sym_enum] = ACTIONS(1112),
    [anon_sym_struct] = ACTIONS(1112),
    [anon_sym_union] = ACTIONS(1112),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_switch] = ACTIONS(1112),
    [anon_sym_case] = ACTIONS(1112),
    [anon_sym_default] = ACTIONS(1112),
    [anon_sym_while] = ACTIONS(1112),
    [anon_sym_do] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1112),
    [anon_sym_return] = ACTIONS(1112),
    [anon_sym_break] = ACTIONS(1112),
    [anon_sym_continue] = ACTIONS(1112),
    [anon_sym_goto] = ACTIONS(1112),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_sizeof] = ACTIONS(1112),
    [sym_number_literal] = ACTIONS(1114),
    [anon_sym_L_SQUOTE] = ACTIONS(1114),
    [anon_sym_u_SQUOTE] = ACTIONS(1114),
    [anon_sym_U_SQUOTE] = ACTIONS(1114),
    [anon_sym_u8_SQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [anon_sym_L_DQUOTE] = ACTIONS(1114),
    [anon_sym_u_DQUOTE] = ACTIONS(1114),
    [anon_sym_U_DQUOTE] = ACTIONS(1114),
    [anon_sym_u8_DQUOTE] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [sym_true] = ACTIONS(1112),
    [sym_false] = ACTIONS(1112),
    [sym_null] = ACTIONS(1112),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_identifier] = ACTIONS(1116),
    [aux_sym_preproc_include_token1] = ACTIONS(1116),
    [aux_sym_preproc_def_token1] = ACTIONS(1116),
    [aux_sym_preproc_if_token1] = ACTIONS(1116),
    [aux_sym_preproc_if_token2] = ACTIONS(1116),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1116),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1116),
    [aux_sym_preproc_else_token1] = ACTIONS(1116),
    [aux_sym_preproc_elif_token1] = ACTIONS(1116),
    [sym_preproc_directive] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(1118),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1118),
    [anon_sym_AMP] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1118),
    [anon_sym_typedef] = ACTIONS(1116),
    [anon_sym_kernel] = ACTIONS(1116),
    [anon_sym___kernel] = ACTIONS(1116),
    [anon_sym_global] = ACTIONS(1116),
    [anon_sym___global] = ACTIONS(1116),
    [anon_sym_local] = ACTIONS(1116),
    [anon_sym___local] = ACTIONS(1116),
    [anon_sym_constant] = ACTIONS(1116),
    [anon_sym___constant] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym___private] = ACTIONS(1116),
    [anon_sym_generic] = ACTIONS(1116),
    [anon_sym___generic] = ACTIONS(1116),
    [anon_sym_read_only] = ACTIONS(1116),
    [anon_sym___read_only] = ACTIONS(1116),
    [anon_sym_write_only] = ACTIONS(1116),
    [anon_sym___write_only] = ACTIONS(1116),
    [anon_sym_read_write] = ACTIONS(1116),
    [anon_sym___read_write] = ACTIONS(1116),
    [anon_sym_extern] = ACTIONS(1116),
    [anon_sym___attribute__] = ACTIONS(1116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1118),
    [anon_sym___declspec] = ACTIONS(1116),
    [anon_sym___cdecl] = ACTIONS(1116),
    [anon_sym___clrcall] = ACTIONS(1116),
    [anon_sym___stdcall] = ACTIONS(1116),
    [anon_sym___fastcall] = ACTIONS(1116),
    [anon_sym___thiscall] = ACTIONS(1116),
    [anon_sym___vectorcall] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_auto] = ACTIONS(1116),
    [anon_sym_register] = ACTIONS(1116),
    [anon_sym_inline] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_volatile] = ACTIONS(1116),
    [anon_sym_restrict] = ACTIONS(1116),
    [anon_sym__Atomic] = ACTIONS(1116),
    [anon_sym_pipe] = ACTIONS(1116),
    [anon_sym_signed] = ACTIONS(1116),
    [anon_sym_unsigned] = ACTIONS(1116),
    [anon_sym_long] = ACTIONS(1116),
    [anon_sym_short] = ACTIONS(1116),
    [anon_sym_bool] = ACTIONS(1116),
    [anon_sym_char] = ACTIONS(1116),
    [anon_sym_uchar] = ACTIONS(1116),
    [anon_sym_ushort] = ACTIONS(1116),
    [anon_sym_int] = ACTIONS(1116),
    [anon_sym_uint] = ACTIONS(1116),
    [anon_sym_ulong] = ACTIONS(1116),
    [anon_sym_float] = ACTIONS(1116),
    [anon_sym_double] = ACTIONS(1116),
    [anon_sym_half] = ACTIONS(1116),
    [anon_sym_size_t] = ACTIONS(1116),
    [anon_sym_ptrdiff_t] = ACTIONS(1116),
    [anon_sym_intptr_t] = ACTIONS(1116),
    [anon_sym_uintptr_t] = ACTIONS(1116),
    [anon_sym_void] = ACTIONS(1116),
    [sym_vector_type] = ACTIONS(1116),
    [anon_sym_image2d_t] = ACTIONS(1116),
    [anon_sym_image3d_t] = ACTIONS(1116),
    [anon_sym_image2d_array_t] = ACTIONS(1116),
    [anon_sym_image1d_t] = ACTIONS(1116),
    [anon_sym_image1d_buffer_t] = ACTIONS(1116),
    [anon_sym_image1d_array_t] = ACTIONS(1116),
    [anon_sym_image2d_depth_t] = ACTIONS(1116),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1116),
    [anon_sym_sampler_t] = ACTIONS(1116),
    [anon_sym_queue_t] = ACTIONS(1116),
    [anon_sym_ndrange_t] = ACTIONS(1116),
    [anon_sym_clk_event_t] = ACTIONS(1116),
    [anon_sym_reserve_id_t] = ACTIONS(1116),
    [anon_sym_event_t] = ACTIONS(1116),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_struct] = ACTIONS(1116),
    [anon_sym_union] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_goto] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1118),
    [anon_sym_PLUS_PLUS] = ACTIONS(1118),
    [anon_sym_sizeof] = ACTIONS(1116),
    [sym_number_literal] = ACTIONS(1118),
    [anon_sym_L_SQUOTE] = ACTIONS(1118),
    [anon_sym_u_SQUOTE] = ACTIONS(1118),
    [anon_sym_U_SQUOTE] = ACTIONS(1118),
    [anon_sym_u8_SQUOTE] = ACTIONS(1118),
    [anon_sym_SQUOTE] = ACTIONS(1118),
    [anon_sym_L_DQUOTE] = ACTIONS(1118),
    [anon_sym_u_DQUOTE] = ACTIONS(1118),
    [anon_sym_U_DQUOTE] = ACTIONS(1118),
    [anon_sym_u8_DQUOTE] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1118),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_identifier] = ACTIONS(1120),
    [aux_sym_preproc_include_token1] = ACTIONS(1120),
    [aux_sym_preproc_def_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token2] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1120),
    [aux_sym_preproc_else_token1] = ACTIONS(1120),
    [aux_sym_preproc_elif_token1] = ACTIONS(1120),
    [sym_preproc_directive] = ACTIONS(1120),
    [anon_sym_LPAREN2] = ACTIONS(1122),
    [anon_sym_BANG] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1122),
    [anon_sym_AMP] = ACTIONS(1122),
    [anon_sym_SEMI] = ACTIONS(1122),
    [anon_sym_typedef] = ACTIONS(1120),
    [anon_sym_kernel] = ACTIONS(1120),
    [anon_sym___kernel] = ACTIONS(1120),
    [anon_sym_global] = ACTIONS(1120),
    [anon_sym___global] = ACTIONS(1120),
    [anon_sym_local] = ACTIONS(1120),
    [anon_sym___local] = ACTIONS(1120),
    [anon_sym_constant] = ACTIONS(1120),
    [anon_sym___constant] = ACTIONS(1120),
    [anon_sym_private] = ACTIONS(1120),
    [anon_sym___private] = ACTIONS(1120),
    [anon_sym_generic] = ACTIONS(1120),
    [anon_sym___generic] = ACTIONS(1120),
    [anon_sym_read_only] = ACTIONS(1120),
    [anon_sym___read_only] = ACTIONS(1120),
    [anon_sym_write_only] = ACTIONS(1120),
    [anon_sym___write_only] = ACTIONS(1120),
    [anon_sym_read_write] = ACTIONS(1120),
    [anon_sym___read_write] = ACTIONS(1120),
    [anon_sym_extern] = ACTIONS(1120),
    [anon_sym___attribute__] = ACTIONS(1120),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1122),
    [anon_sym___declspec] = ACTIONS(1120),
    [anon_sym___cdecl] = ACTIONS(1120),
    [anon_sym___clrcall] = ACTIONS(1120),
    [anon_sym___stdcall] = ACTIONS(1120),
    [anon_sym___fastcall] = ACTIONS(1120),
    [anon_sym___thiscall] = ACTIONS(1120),
    [anon_sym___vectorcall] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_static] = ACTIONS(1120),
    [anon_sym_auto] = ACTIONS(1120),
    [anon_sym_register] = ACTIONS(1120),
    [anon_sym_inline] = ACTIONS(1120),
    [anon_sym_const] = ACTIONS(1120),
    [anon_sym_volatile] = ACTIONS(1120),
    [anon_sym_restrict] = ACTIONS(1120),
    [anon_sym__Atomic] = ACTIONS(1120),
    [anon_sym_pipe] = ACTIONS(1120),
    [anon_sym_signed] = ACTIONS(1120),
    [anon_sym_unsigned] = ACTIONS(1120),
    [anon_sym_long] = ACTIONS(1120),
    [anon_sym_short] = ACTIONS(1120),
    [anon_sym_bool] = ACTIONS(1120),
    [anon_sym_char] = ACTIONS(1120),
    [anon_sym_uchar] = ACTIONS(1120),
    [anon_sym_ushort] = ACTIONS(1120),
    [anon_sym_int] = ACTIONS(1120),
    [anon_sym_uint] = ACTIONS(1120),
    [anon_sym_ulong] = ACTIONS(1120),
    [anon_sym_float] = ACTIONS(1120),
    [anon_sym_double] = ACTIONS(1120),
    [anon_sym_half] = ACTIONS(1120),
    [anon_sym_size_t] = ACTIONS(1120),
    [anon_sym_ptrdiff_t] = ACTIONS(1120),
    [anon_sym_intptr_t] = ACTIONS(1120),
    [anon_sym_uintptr_t] = ACTIONS(1120),
    [anon_sym_void] = ACTIONS(1120),
    [sym_vector_type] = ACTIONS(1120),
    [anon_sym_image2d_t] = ACTIONS(1120),
    [anon_sym_image3d_t] = ACTIONS(1120),
    [anon_sym_image2d_array_t] = ACTIONS(1120),
    [anon_sym_image1d_t] = ACTIONS(1120),
    [anon_sym_image1d_buffer_t] = ACTIONS(1120),
    [anon_sym_image1d_array_t] = ACTIONS(1120),
    [anon_sym_image2d_depth_t] = ACTIONS(1120),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1120),
    [anon_sym_sampler_t] = ACTIONS(1120),
    [anon_sym_queue_t] = ACTIONS(1120),
    [anon_sym_ndrange_t] = ACTIONS(1120),
    [anon_sym_clk_event_t] = ACTIONS(1120),
    [anon_sym_reserve_id_t] = ACTIONS(1120),
    [anon_sym_event_t] = ACTIONS(1120),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1120),
    [anon_sym_enum] = ACTIONS(1120),
    [anon_sym_struct] = ACTIONS(1120),
    [anon_sym_union] = ACTIONS(1120),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(1120),
    [anon_sym_case] = ACTIONS(1120),
    [anon_sym_default] = ACTIONS(1120),
    [anon_sym_while] = ACTIONS(1120),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_for] = ACTIONS(1120),
    [anon_sym_return] = ACTIONS(1120),
    [anon_sym_break] = ACTIONS(1120),
    [anon_sym_continue] = ACTIONS(1120),
    [anon_sym_goto] = ACTIONS(1120),
    [anon_sym_DASH_DASH] = ACTIONS(1122),
    [anon_sym_PLUS_PLUS] = ACTIONS(1122),
    [anon_sym_sizeof] = ACTIONS(1120),
    [sym_number_literal] = ACTIONS(1122),
    [anon_sym_L_SQUOTE] = ACTIONS(1122),
    [anon_sym_u_SQUOTE] = ACTIONS(1122),
    [anon_sym_U_SQUOTE] = ACTIONS(1122),
    [anon_sym_u8_SQUOTE] = ACTIONS(1122),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [anon_sym_L_DQUOTE] = ACTIONS(1122),
    [anon_sym_u_DQUOTE] = ACTIONS(1122),
    [anon_sym_U_DQUOTE] = ACTIONS(1122),
    [anon_sym_u8_DQUOTE] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [sym_true] = ACTIONS(1120),
    [sym_false] = ACTIONS(1120),
    [sym_null] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_identifier] = ACTIONS(1124),
    [aux_sym_preproc_include_token1] = ACTIONS(1124),
    [aux_sym_preproc_def_token1] = ACTIONS(1124),
    [aux_sym_preproc_if_token1] = ACTIONS(1124),
    [aux_sym_preproc_if_token2] = ACTIONS(1124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1124),
    [aux_sym_preproc_else_token1] = ACTIONS(1124),
    [aux_sym_preproc_elif_token1] = ACTIONS(1124),
    [sym_preproc_directive] = ACTIONS(1124),
    [anon_sym_LPAREN2] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_STAR] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1126),
    [anon_sym_typedef] = ACTIONS(1124),
    [anon_sym_kernel] = ACTIONS(1124),
    [anon_sym___kernel] = ACTIONS(1124),
    [anon_sym_global] = ACTIONS(1124),
    [anon_sym___global] = ACTIONS(1124),
    [anon_sym_local] = ACTIONS(1124),
    [anon_sym___local] = ACTIONS(1124),
    [anon_sym_constant] = ACTIONS(1124),
    [anon_sym___constant] = ACTIONS(1124),
    [anon_sym_private] = ACTIONS(1124),
    [anon_sym___private] = ACTIONS(1124),
    [anon_sym_generic] = ACTIONS(1124),
    [anon_sym___generic] = ACTIONS(1124),
    [anon_sym_read_only] = ACTIONS(1124),
    [anon_sym___read_only] = ACTIONS(1124),
    [anon_sym_write_only] = ACTIONS(1124),
    [anon_sym___write_only] = ACTIONS(1124),
    [anon_sym_read_write] = ACTIONS(1124),
    [anon_sym___read_write] = ACTIONS(1124),
    [anon_sym_extern] = ACTIONS(1124),
    [anon_sym___attribute__] = ACTIONS(1124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1126),
    [anon_sym___declspec] = ACTIONS(1124),
    [anon_sym___cdecl] = ACTIONS(1124),
    [anon_sym___clrcall] = ACTIONS(1124),
    [anon_sym___stdcall] = ACTIONS(1124),
    [anon_sym___fastcall] = ACTIONS(1124),
    [anon_sym___thiscall] = ACTIONS(1124),
    [anon_sym___vectorcall] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_static] = ACTIONS(1124),
    [anon_sym_auto] = ACTIONS(1124),
    [anon_sym_register] = ACTIONS(1124),
    [anon_sym_inline] = ACTIONS(1124),
    [anon_sym_const] = ACTIONS(1124),
    [anon_sym_volatile] = ACTIONS(1124),
    [anon_sym_restrict] = ACTIONS(1124),
    [anon_sym__Atomic] = ACTIONS(1124),
    [anon_sym_pipe] = ACTIONS(1124),
    [anon_sym_signed] = ACTIONS(1124),
    [anon_sym_unsigned] = ACTIONS(1124),
    [anon_sym_long] = ACTIONS(1124),
    [anon_sym_short] = ACTIONS(1124),
    [anon_sym_bool] = ACTIONS(1124),
    [anon_sym_char] = ACTIONS(1124),
    [anon_sym_uchar] = ACTIONS(1124),
    [anon_sym_ushort] = ACTIONS(1124),
    [anon_sym_int] = ACTIONS(1124),
    [anon_sym_uint] = ACTIONS(1124),
    [anon_sym_ulong] = ACTIONS(1124),
    [anon_sym_float] = ACTIONS(1124),
    [anon_sym_double] = ACTIONS(1124),
    [anon_sym_half] = ACTIONS(1124),
    [anon_sym_size_t] = ACTIONS(1124),
    [anon_sym_ptrdiff_t] = ACTIONS(1124),
    [anon_sym_intptr_t] = ACTIONS(1124),
    [anon_sym_uintptr_t] = ACTIONS(1124),
    [anon_sym_void] = ACTIONS(1124),
    [sym_vector_type] = ACTIONS(1124),
    [anon_sym_image2d_t] = ACTIONS(1124),
    [anon_sym_image3d_t] = ACTIONS(1124),
    [anon_sym_image2d_array_t] = ACTIONS(1124),
    [anon_sym_image1d_t] = ACTIONS(1124),
    [anon_sym_image1d_buffer_t] = ACTIONS(1124),
    [anon_sym_image1d_array_t] = ACTIONS(1124),
    [anon_sym_image2d_depth_t] = ACTIONS(1124),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1124),
    [anon_sym_sampler_t] = ACTIONS(1124),
    [anon_sym_queue_t] = ACTIONS(1124),
    [anon_sym_ndrange_t] = ACTIONS(1124),
    [anon_sym_clk_event_t] = ACTIONS(1124),
    [anon_sym_reserve_id_t] = ACTIONS(1124),
    [anon_sym_event_t] = ACTIONS(1124),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1124),
    [anon_sym_enum] = ACTIONS(1124),
    [anon_sym_struct] = ACTIONS(1124),
    [anon_sym_union] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_switch] = ACTIONS(1124),
    [anon_sym_case] = ACTIONS(1124),
    [anon_sym_default] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_do] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_continue] = ACTIONS(1124),
    [anon_sym_goto] = ACTIONS(1124),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [anon_sym_sizeof] = ACTIONS(1124),
    [sym_number_literal] = ACTIONS(1126),
    [anon_sym_L_SQUOTE] = ACTIONS(1126),
    [anon_sym_u_SQUOTE] = ACTIONS(1126),
    [anon_sym_U_SQUOTE] = ACTIONS(1126),
    [anon_sym_u8_SQUOTE] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [anon_sym_L_DQUOTE] = ACTIONS(1126),
    [anon_sym_u_DQUOTE] = ACTIONS(1126),
    [anon_sym_U_DQUOTE] = ACTIONS(1126),
    [anon_sym_u8_DQUOTE] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_null] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_identifier] = ACTIONS(1128),
    [aux_sym_preproc_include_token1] = ACTIONS(1128),
    [aux_sym_preproc_def_token1] = ACTIONS(1128),
    [aux_sym_preproc_if_token1] = ACTIONS(1128),
    [aux_sym_preproc_if_token2] = ACTIONS(1128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1128),
    [aux_sym_preproc_else_token1] = ACTIONS(1128),
    [aux_sym_preproc_elif_token1] = ACTIONS(1128),
    [sym_preproc_directive] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(1130),
    [anon_sym_BANG] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_STAR] = ACTIONS(1130),
    [anon_sym_AMP] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1130),
    [anon_sym_typedef] = ACTIONS(1128),
    [anon_sym_kernel] = ACTIONS(1128),
    [anon_sym___kernel] = ACTIONS(1128),
    [anon_sym_global] = ACTIONS(1128),
    [anon_sym___global] = ACTIONS(1128),
    [anon_sym_local] = ACTIONS(1128),
    [anon_sym___local] = ACTIONS(1128),
    [anon_sym_constant] = ACTIONS(1128),
    [anon_sym___constant] = ACTIONS(1128),
    [anon_sym_private] = ACTIONS(1128),
    [anon_sym___private] = ACTIONS(1128),
    [anon_sym_generic] = ACTIONS(1128),
    [anon_sym___generic] = ACTIONS(1128),
    [anon_sym_read_only] = ACTIONS(1128),
    [anon_sym___read_only] = ACTIONS(1128),
    [anon_sym_write_only] = ACTIONS(1128),
    [anon_sym___write_only] = ACTIONS(1128),
    [anon_sym_read_write] = ACTIONS(1128),
    [anon_sym___read_write] = ACTIONS(1128),
    [anon_sym_extern] = ACTIONS(1128),
    [anon_sym___attribute__] = ACTIONS(1128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1130),
    [anon_sym___declspec] = ACTIONS(1128),
    [anon_sym___cdecl] = ACTIONS(1128),
    [anon_sym___clrcall] = ACTIONS(1128),
    [anon_sym___stdcall] = ACTIONS(1128),
    [anon_sym___fastcall] = ACTIONS(1128),
    [anon_sym___thiscall] = ACTIONS(1128),
    [anon_sym___vectorcall] = ACTIONS(1128),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_static] = ACTIONS(1128),
    [anon_sym_auto] = ACTIONS(1128),
    [anon_sym_register] = ACTIONS(1128),
    [anon_sym_inline] = ACTIONS(1128),
    [anon_sym_const] = ACTIONS(1128),
    [anon_sym_volatile] = ACTIONS(1128),
    [anon_sym_restrict] = ACTIONS(1128),
    [anon_sym__Atomic] = ACTIONS(1128),
    [anon_sym_pipe] = ACTIONS(1128),
    [anon_sym_signed] = ACTIONS(1128),
    [anon_sym_unsigned] = ACTIONS(1128),
    [anon_sym_long] = ACTIONS(1128),
    [anon_sym_short] = ACTIONS(1128),
    [anon_sym_bool] = ACTIONS(1128),
    [anon_sym_char] = ACTIONS(1128),
    [anon_sym_uchar] = ACTIONS(1128),
    [anon_sym_ushort] = ACTIONS(1128),
    [anon_sym_int] = ACTIONS(1128),
    [anon_sym_uint] = ACTIONS(1128),
    [anon_sym_ulong] = ACTIONS(1128),
    [anon_sym_float] = ACTIONS(1128),
    [anon_sym_double] = ACTIONS(1128),
    [anon_sym_half] = ACTIONS(1128),
    [anon_sym_size_t] = ACTIONS(1128),
    [anon_sym_ptrdiff_t] = ACTIONS(1128),
    [anon_sym_intptr_t] = ACTIONS(1128),
    [anon_sym_uintptr_t] = ACTIONS(1128),
    [anon_sym_void] = ACTIONS(1128),
    [sym_vector_type] = ACTIONS(1128),
    [anon_sym_image2d_t] = ACTIONS(1128),
    [anon_sym_image3d_t] = ACTIONS(1128),
    [anon_sym_image2d_array_t] = ACTIONS(1128),
    [anon_sym_image1d_t] = ACTIONS(1128),
    [anon_sym_image1d_buffer_t] = ACTIONS(1128),
    [anon_sym_image1d_array_t] = ACTIONS(1128),
    [anon_sym_image2d_depth_t] = ACTIONS(1128),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1128),
    [anon_sym_sampler_t] = ACTIONS(1128),
    [anon_sym_queue_t] = ACTIONS(1128),
    [anon_sym_ndrange_t] = ACTIONS(1128),
    [anon_sym_clk_event_t] = ACTIONS(1128),
    [anon_sym_reserve_id_t] = ACTIONS(1128),
    [anon_sym_event_t] = ACTIONS(1128),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1128),
    [anon_sym_enum] = ACTIONS(1128),
    [anon_sym_struct] = ACTIONS(1128),
    [anon_sym_union] = ACTIONS(1128),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_switch] = ACTIONS(1128),
    [anon_sym_case] = ACTIONS(1128),
    [anon_sym_default] = ACTIONS(1128),
    [anon_sym_while] = ACTIONS(1128),
    [anon_sym_do] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1128),
    [anon_sym_return] = ACTIONS(1128),
    [anon_sym_break] = ACTIONS(1128),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_goto] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1130),
    [anon_sym_PLUS_PLUS] = ACTIONS(1130),
    [anon_sym_sizeof] = ACTIONS(1128),
    [sym_number_literal] = ACTIONS(1130),
    [anon_sym_L_SQUOTE] = ACTIONS(1130),
    [anon_sym_u_SQUOTE] = ACTIONS(1130),
    [anon_sym_U_SQUOTE] = ACTIONS(1130),
    [anon_sym_u8_SQUOTE] = ACTIONS(1130),
    [anon_sym_SQUOTE] = ACTIONS(1130),
    [anon_sym_L_DQUOTE] = ACTIONS(1130),
    [anon_sym_u_DQUOTE] = ACTIONS(1130),
    [anon_sym_U_DQUOTE] = ACTIONS(1130),
    [anon_sym_u8_DQUOTE] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(1130),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_null] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_identifier] = ACTIONS(926),
    [aux_sym_preproc_include_token1] = ACTIONS(926),
    [aux_sym_preproc_def_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(926),
    [sym_preproc_directive] = ACTIONS(926),
    [anon_sym_LPAREN2] = ACTIONS(928),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(926),
    [anon_sym_kernel] = ACTIONS(926),
    [anon_sym___kernel] = ACTIONS(926),
    [anon_sym_global] = ACTIONS(926),
    [anon_sym___global] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym___local] = ACTIONS(926),
    [anon_sym_constant] = ACTIONS(926),
    [anon_sym___constant] = ACTIONS(926),
    [anon_sym_private] = ACTIONS(926),
    [anon_sym___private] = ACTIONS(926),
    [anon_sym_generic] = ACTIONS(926),
    [anon_sym___generic] = ACTIONS(926),
    [anon_sym_read_only] = ACTIONS(926),
    [anon_sym___read_only] = ACTIONS(926),
    [anon_sym_write_only] = ACTIONS(926),
    [anon_sym___write_only] = ACTIONS(926),
    [anon_sym_read_write] = ACTIONS(926),
    [anon_sym___read_write] = ACTIONS(926),
    [anon_sym_extern] = ACTIONS(926),
    [anon_sym___attribute__] = ACTIONS(926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(928),
    [anon_sym___declspec] = ACTIONS(926),
    [anon_sym___cdecl] = ACTIONS(926),
    [anon_sym___clrcall] = ACTIONS(926),
    [anon_sym___stdcall] = ACTIONS(926),
    [anon_sym___fastcall] = ACTIONS(926),
    [anon_sym___thiscall] = ACTIONS(926),
    [anon_sym___vectorcall] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_RBRACE] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_auto] = ACTIONS(926),
    [anon_sym_register] = ACTIONS(926),
    [anon_sym_inline] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_restrict] = ACTIONS(926),
    [anon_sym__Atomic] = ACTIONS(926),
    [anon_sym_pipe] = ACTIONS(926),
    [anon_sym_signed] = ACTIONS(926),
    [anon_sym_unsigned] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [anon_sym_bool] = ACTIONS(926),
    [anon_sym_char] = ACTIONS(926),
    [anon_sym_uchar] = ACTIONS(926),
    [anon_sym_ushort] = ACTIONS(926),
    [anon_sym_int] = ACTIONS(926),
    [anon_sym_uint] = ACTIONS(926),
    [anon_sym_ulong] = ACTIONS(926),
    [anon_sym_float] = ACTIONS(926),
    [anon_sym_double] = ACTIONS(926),
    [anon_sym_half] = ACTIONS(926),
    [anon_sym_size_t] = ACTIONS(926),
    [anon_sym_ptrdiff_t] = ACTIONS(926),
    [anon_sym_intptr_t] = ACTIONS(926),
    [anon_sym_uintptr_t] = ACTIONS(926),
    [anon_sym_void] = ACTIONS(926),
    [sym_vector_type] = ACTIONS(926),
    [anon_sym_image2d_t] = ACTIONS(926),
    [anon_sym_image3d_t] = ACTIONS(926),
    [anon_sym_image2d_array_t] = ACTIONS(926),
    [anon_sym_image1d_t] = ACTIONS(926),
    [anon_sym_image1d_buffer_t] = ACTIONS(926),
    [anon_sym_image1d_array_t] = ACTIONS(926),
    [anon_sym_image2d_depth_t] = ACTIONS(926),
    [anon_sym_image2d_array_depth_t] = ACTIONS(926),
    [anon_sym_sampler_t] = ACTIONS(926),
    [anon_sym_queue_t] = ACTIONS(926),
    [anon_sym_ndrange_t] = ACTIONS(926),
    [anon_sym_clk_event_t] = ACTIONS(926),
    [anon_sym_reserve_id_t] = ACTIONS(926),
    [anon_sym_event_t] = ACTIONS(926),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_struct] = ACTIONS(926),
    [anon_sym_union] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(926),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_goto] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_sizeof] = ACTIONS(926),
    [sym_number_literal] = ACTIONS(928),
    [anon_sym_L_SQUOTE] = ACTIONS(928),
    [anon_sym_u_SQUOTE] = ACTIONS(928),
    [anon_sym_U_SQUOTE] = ACTIONS(928),
    [anon_sym_u8_SQUOTE] = ACTIONS(928),
    [anon_sym_SQUOTE] = ACTIONS(928),
    [anon_sym_L_DQUOTE] = ACTIONS(928),
    [anon_sym_u_DQUOTE] = ACTIONS(928),
    [anon_sym_U_DQUOTE] = ACTIONS(928),
    [anon_sym_u8_DQUOTE] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_null] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(978),
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(976),
    [aux_sym_preproc_def_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(976),
    [sym_preproc_directive] = ACTIONS(976),
    [anon_sym_LPAREN2] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_AMP] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_typedef] = ACTIONS(976),
    [anon_sym_kernel] = ACTIONS(976),
    [anon_sym___kernel] = ACTIONS(976),
    [anon_sym_global] = ACTIONS(976),
    [anon_sym___global] = ACTIONS(976),
    [anon_sym_local] = ACTIONS(976),
    [anon_sym___local] = ACTIONS(976),
    [anon_sym_constant] = ACTIONS(976),
    [anon_sym___constant] = ACTIONS(976),
    [anon_sym_private] = ACTIONS(976),
    [anon_sym___private] = ACTIONS(976),
    [anon_sym_generic] = ACTIONS(976),
    [anon_sym___generic] = ACTIONS(976),
    [anon_sym_read_only] = ACTIONS(976),
    [anon_sym___read_only] = ACTIONS(976),
    [anon_sym_write_only] = ACTIONS(976),
    [anon_sym___write_only] = ACTIONS(976),
    [anon_sym_read_write] = ACTIONS(976),
    [anon_sym___read_write] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym___attribute__] = ACTIONS(976),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(978),
    [anon_sym___declspec] = ACTIONS(976),
    [anon_sym___cdecl] = ACTIONS(976),
    [anon_sym___clrcall] = ACTIONS(976),
    [anon_sym___stdcall] = ACTIONS(976),
    [anon_sym___fastcall] = ACTIONS(976),
    [anon_sym___thiscall] = ACTIONS(976),
    [anon_sym___vectorcall] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_auto] = ACTIONS(976),
    [anon_sym_register] = ACTIONS(976),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_volatile] = ACTIONS(976),
    [anon_sym_restrict] = ACTIONS(976),
    [anon_sym__Atomic] = ACTIONS(976),
    [anon_sym_pipe] = ACTIONS(976),
    [anon_sym_signed] = ACTIONS(976),
    [anon_sym_unsigned] = ACTIONS(976),
    [anon_sym_long] = ACTIONS(976),
    [anon_sym_short] = ACTIONS(976),
    [anon_sym_bool] = ACTIONS(976),
    [anon_sym_char] = ACTIONS(976),
    [anon_sym_uchar] = ACTIONS(976),
    [anon_sym_ushort] = ACTIONS(976),
    [anon_sym_int] = ACTIONS(976),
    [anon_sym_uint] = ACTIONS(976),
    [anon_sym_ulong] = ACTIONS(976),
    [anon_sym_float] = ACTIONS(976),
    [anon_sym_double] = ACTIONS(976),
    [anon_sym_half] = ACTIONS(976),
    [anon_sym_size_t] = ACTIONS(976),
    [anon_sym_ptrdiff_t] = ACTIONS(976),
    [anon_sym_intptr_t] = ACTIONS(976),
    [anon_sym_uintptr_t] = ACTIONS(976),
    [anon_sym_void] = ACTIONS(976),
    [sym_vector_type] = ACTIONS(976),
    [anon_sym_image2d_t] = ACTIONS(976),
    [anon_sym_image3d_t] = ACTIONS(976),
    [anon_sym_image2d_array_t] = ACTIONS(976),
    [anon_sym_image1d_t] = ACTIONS(976),
    [anon_sym_image1d_buffer_t] = ACTIONS(976),
    [anon_sym_image1d_array_t] = ACTIONS(976),
    [anon_sym_image2d_depth_t] = ACTIONS(976),
    [anon_sym_image2d_array_depth_t] = ACTIONS(976),
    [anon_sym_sampler_t] = ACTIONS(976),
    [anon_sym_queue_t] = ACTIONS(976),
    [anon_sym_ndrange_t] = ACTIONS(976),
    [anon_sym_clk_event_t] = ACTIONS(976),
    [anon_sym_reserve_id_t] = ACTIONS(976),
    [anon_sym_event_t] = ACTIONS(976),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_struct] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_goto] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(978),
    [anon_sym_sizeof] = ACTIONS(976),
    [sym_number_literal] = ACTIONS(978),
    [anon_sym_L_SQUOTE] = ACTIONS(978),
    [anon_sym_u_SQUOTE] = ACTIONS(978),
    [anon_sym_U_SQUOTE] = ACTIONS(978),
    [anon_sym_u8_SQUOTE] = ACTIONS(978),
    [anon_sym_SQUOTE] = ACTIONS(978),
    [anon_sym_L_DQUOTE] = ACTIONS(978),
    [anon_sym_u_DQUOTE] = ACTIONS(978),
    [anon_sym_U_DQUOTE] = ACTIONS(978),
    [anon_sym_u8_DQUOTE] = ACTIONS(978),
    [anon_sym_DQUOTE] = ACTIONS(978),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(924),
    [sym_identifier] = ACTIONS(922),
    [aux_sym_preproc_include_token1] = ACTIONS(922),
    [aux_sym_preproc_def_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(922),
    [sym_preproc_directive] = ACTIONS(922),
    [anon_sym_LPAREN2] = ACTIONS(924),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_typedef] = ACTIONS(922),
    [anon_sym_kernel] = ACTIONS(922),
    [anon_sym___kernel] = ACTIONS(922),
    [anon_sym_global] = ACTIONS(922),
    [anon_sym___global] = ACTIONS(922),
    [anon_sym_local] = ACTIONS(922),
    [anon_sym___local] = ACTIONS(922),
    [anon_sym_constant] = ACTIONS(922),
    [anon_sym___constant] = ACTIONS(922),
    [anon_sym_private] = ACTIONS(922),
    [anon_sym___private] = ACTIONS(922),
    [anon_sym_generic] = ACTIONS(922),
    [anon_sym___generic] = ACTIONS(922),
    [anon_sym_read_only] = ACTIONS(922),
    [anon_sym___read_only] = ACTIONS(922),
    [anon_sym_write_only] = ACTIONS(922),
    [anon_sym___write_only] = ACTIONS(922),
    [anon_sym_read_write] = ACTIONS(922),
    [anon_sym___read_write] = ACTIONS(922),
    [anon_sym_extern] = ACTIONS(922),
    [anon_sym___attribute__] = ACTIONS(922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(924),
    [anon_sym___declspec] = ACTIONS(922),
    [anon_sym___cdecl] = ACTIONS(922),
    [anon_sym___clrcall] = ACTIONS(922),
    [anon_sym___stdcall] = ACTIONS(922),
    [anon_sym___fastcall] = ACTIONS(922),
    [anon_sym___thiscall] = ACTIONS(922),
    [anon_sym___vectorcall] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_auto] = ACTIONS(922),
    [anon_sym_register] = ACTIONS(922),
    [anon_sym_inline] = ACTIONS(922),
    [anon_sym_const] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_restrict] = ACTIONS(922),
    [anon_sym__Atomic] = ACTIONS(922),
    [anon_sym_pipe] = ACTIONS(922),
    [anon_sym_signed] = ACTIONS(922),
    [anon_sym_unsigned] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [anon_sym_bool] = ACTIONS(922),
    [anon_sym_char] = ACTIONS(922),
    [anon_sym_uchar] = ACTIONS(922),
    [anon_sym_ushort] = ACTIONS(922),
    [anon_sym_int] = ACTIONS(922),
    [anon_sym_uint] = ACTIONS(922),
    [anon_sym_ulong] = ACTIONS(922),
    [anon_sym_float] = ACTIONS(922),
    [anon_sym_double] = ACTIONS(922),
    [anon_sym_half] = ACTIONS(922),
    [anon_sym_size_t] = ACTIONS(922),
    [anon_sym_ptrdiff_t] = ACTIONS(922),
    [anon_sym_intptr_t] = ACTIONS(922),
    [anon_sym_uintptr_t] = ACTIONS(922),
    [anon_sym_void] = ACTIONS(922),
    [sym_vector_type] = ACTIONS(922),
    [anon_sym_image2d_t] = ACTIONS(922),
    [anon_sym_image3d_t] = ACTIONS(922),
    [anon_sym_image2d_array_t] = ACTIONS(922),
    [anon_sym_image1d_t] = ACTIONS(922),
    [anon_sym_image1d_buffer_t] = ACTIONS(922),
    [anon_sym_image1d_array_t] = ACTIONS(922),
    [anon_sym_image2d_depth_t] = ACTIONS(922),
    [anon_sym_image2d_array_depth_t] = ACTIONS(922),
    [anon_sym_sampler_t] = ACTIONS(922),
    [anon_sym_queue_t] = ACTIONS(922),
    [anon_sym_ndrange_t] = ACTIONS(922),
    [anon_sym_clk_event_t] = ACTIONS(922),
    [anon_sym_reserve_id_t] = ACTIONS(922),
    [anon_sym_event_t] = ACTIONS(922),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_struct] = ACTIONS(922),
    [anon_sym_union] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_goto] = ACTIONS(922),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_sizeof] = ACTIONS(922),
    [sym_number_literal] = ACTIONS(924),
    [anon_sym_L_SQUOTE] = ACTIONS(924),
    [anon_sym_u_SQUOTE] = ACTIONS(924),
    [anon_sym_U_SQUOTE] = ACTIONS(924),
    [anon_sym_u8_SQUOTE] = ACTIONS(924),
    [anon_sym_SQUOTE] = ACTIONS(924),
    [anon_sym_L_DQUOTE] = ACTIONS(924),
    [anon_sym_u_DQUOTE] = ACTIONS(924),
    [anon_sym_U_DQUOTE] = ACTIONS(924),
    [anon_sym_u8_DQUOTE] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(924),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_null] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(966),
    [aux_sym_preproc_include_token1] = ACTIONS(966),
    [aux_sym_preproc_def_token1] = ACTIONS(966),
    [aux_sym_preproc_if_token1] = ACTIONS(966),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(966),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(966),
    [sym_preproc_directive] = ACTIONS(966),
    [anon_sym_LPAREN2] = ACTIONS(968),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_DASH] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(966),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_AMP] = ACTIONS(968),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_typedef] = ACTIONS(966),
    [anon_sym_kernel] = ACTIONS(966),
    [anon_sym___kernel] = ACTIONS(966),
    [anon_sym_global] = ACTIONS(966),
    [anon_sym___global] = ACTIONS(966),
    [anon_sym_local] = ACTIONS(966),
    [anon_sym___local] = ACTIONS(966),
    [anon_sym_constant] = ACTIONS(966),
    [anon_sym___constant] = ACTIONS(966),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym___private] = ACTIONS(966),
    [anon_sym_generic] = ACTIONS(966),
    [anon_sym___generic] = ACTIONS(966),
    [anon_sym_read_only] = ACTIONS(966),
    [anon_sym___read_only] = ACTIONS(966),
    [anon_sym_write_only] = ACTIONS(966),
    [anon_sym___write_only] = ACTIONS(966),
    [anon_sym_read_write] = ACTIONS(966),
    [anon_sym___read_write] = ACTIONS(966),
    [anon_sym_extern] = ACTIONS(966),
    [anon_sym___attribute__] = ACTIONS(966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(968),
    [anon_sym___declspec] = ACTIONS(966),
    [anon_sym___cdecl] = ACTIONS(966),
    [anon_sym___clrcall] = ACTIONS(966),
    [anon_sym___stdcall] = ACTIONS(966),
    [anon_sym___fastcall] = ACTIONS(966),
    [anon_sym___thiscall] = ACTIONS(966),
    [anon_sym___vectorcall] = ACTIONS(966),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(966),
    [anon_sym_auto] = ACTIONS(966),
    [anon_sym_register] = ACTIONS(966),
    [anon_sym_inline] = ACTIONS(966),
    [anon_sym_const] = ACTIONS(966),
    [anon_sym_volatile] = ACTIONS(966),
    [anon_sym_restrict] = ACTIONS(966),
    [anon_sym__Atomic] = ACTIONS(966),
    [anon_sym_pipe] = ACTIONS(966),
    [anon_sym_signed] = ACTIONS(966),
    [anon_sym_unsigned] = ACTIONS(966),
    [anon_sym_long] = ACTIONS(966),
    [anon_sym_short] = ACTIONS(966),
    [anon_sym_bool] = ACTIONS(966),
    [anon_sym_char] = ACTIONS(966),
    [anon_sym_uchar] = ACTIONS(966),
    [anon_sym_ushort] = ACTIONS(966),
    [anon_sym_int] = ACTIONS(966),
    [anon_sym_uint] = ACTIONS(966),
    [anon_sym_ulong] = ACTIONS(966),
    [anon_sym_float] = ACTIONS(966),
    [anon_sym_double] = ACTIONS(966),
    [anon_sym_half] = ACTIONS(966),
    [anon_sym_size_t] = ACTIONS(966),
    [anon_sym_ptrdiff_t] = ACTIONS(966),
    [anon_sym_intptr_t] = ACTIONS(966),
    [anon_sym_uintptr_t] = ACTIONS(966),
    [anon_sym_void] = ACTIONS(966),
    [sym_vector_type] = ACTIONS(966),
    [anon_sym_image2d_t] = ACTIONS(966),
    [anon_sym_image3d_t] = ACTIONS(966),
    [anon_sym_image2d_array_t] = ACTIONS(966),
    [anon_sym_image1d_t] = ACTIONS(966),
    [anon_sym_image1d_buffer_t] = ACTIONS(966),
    [anon_sym_image1d_array_t] = ACTIONS(966),
    [anon_sym_image2d_depth_t] = ACTIONS(966),
    [anon_sym_image2d_array_depth_t] = ACTIONS(966),
    [anon_sym_sampler_t] = ACTIONS(966),
    [anon_sym_queue_t] = ACTIONS(966),
    [anon_sym_ndrange_t] = ACTIONS(966),
    [anon_sym_clk_event_t] = ACTIONS(966),
    [anon_sym_reserve_id_t] = ACTIONS(966),
    [anon_sym_event_t] = ACTIONS(966),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(966),
    [anon_sym_enum] = ACTIONS(966),
    [anon_sym_struct] = ACTIONS(966),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_else] = ACTIONS(1132),
    [anon_sym_switch] = ACTIONS(966),
    [anon_sym_case] = ACTIONS(966),
    [anon_sym_default] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_do] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_goto] = ACTIONS(966),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_sizeof] = ACTIONS(966),
    [sym_number_literal] = ACTIONS(968),
    [anon_sym_L_SQUOTE] = ACTIONS(968),
    [anon_sym_u_SQUOTE] = ACTIONS(968),
    [anon_sym_U_SQUOTE] = ACTIONS(968),
    [anon_sym_u8_SQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [anon_sym_L_DQUOTE] = ACTIONS(968),
    [anon_sym_u_DQUOTE] = ACTIONS(968),
    [anon_sym_U_DQUOTE] = ACTIONS(968),
    [anon_sym_u8_DQUOTE] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_null] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_identifier] = ACTIONS(1040),
    [aux_sym_preproc_include_token1] = ACTIONS(1040),
    [aux_sym_preproc_def_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1040),
    [sym_preproc_directive] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_typedef] = ACTIONS(1040),
    [anon_sym_kernel] = ACTIONS(1040),
    [anon_sym___kernel] = ACTIONS(1040),
    [anon_sym_global] = ACTIONS(1040),
    [anon_sym___global] = ACTIONS(1040),
    [anon_sym_local] = ACTIONS(1040),
    [anon_sym___local] = ACTIONS(1040),
    [anon_sym_constant] = ACTIONS(1040),
    [anon_sym___constant] = ACTIONS(1040),
    [anon_sym_private] = ACTIONS(1040),
    [anon_sym___private] = ACTIONS(1040),
    [anon_sym_generic] = ACTIONS(1040),
    [anon_sym___generic] = ACTIONS(1040),
    [anon_sym_read_only] = ACTIONS(1040),
    [anon_sym___read_only] = ACTIONS(1040),
    [anon_sym_write_only] = ACTIONS(1040),
    [anon_sym___write_only] = ACTIONS(1040),
    [anon_sym_read_write] = ACTIONS(1040),
    [anon_sym___read_write] = ACTIONS(1040),
    [anon_sym_extern] = ACTIONS(1040),
    [anon_sym___attribute__] = ACTIONS(1040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1042),
    [anon_sym___declspec] = ACTIONS(1040),
    [anon_sym___cdecl] = ACTIONS(1040),
    [anon_sym___clrcall] = ACTIONS(1040),
    [anon_sym___stdcall] = ACTIONS(1040),
    [anon_sym___fastcall] = ACTIONS(1040),
    [anon_sym___thiscall] = ACTIONS(1040),
    [anon_sym___vectorcall] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_auto] = ACTIONS(1040),
    [anon_sym_register] = ACTIONS(1040),
    [anon_sym_inline] = ACTIONS(1040),
    [anon_sym_const] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_restrict] = ACTIONS(1040),
    [anon_sym__Atomic] = ACTIONS(1040),
    [anon_sym_pipe] = ACTIONS(1040),
    [anon_sym_signed] = ACTIONS(1040),
    [anon_sym_unsigned] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [anon_sym_bool] = ACTIONS(1040),
    [anon_sym_char] = ACTIONS(1040),
    [anon_sym_uchar] = ACTIONS(1040),
    [anon_sym_ushort] = ACTIONS(1040),
    [anon_sym_int] = ACTIONS(1040),
    [anon_sym_uint] = ACTIONS(1040),
    [anon_sym_ulong] = ACTIONS(1040),
    [anon_sym_float] = ACTIONS(1040),
    [anon_sym_double] = ACTIONS(1040),
    [anon_sym_half] = ACTIONS(1040),
    [anon_sym_size_t] = ACTIONS(1040),
    [anon_sym_ptrdiff_t] = ACTIONS(1040),
    [anon_sym_intptr_t] = ACTIONS(1040),
    [anon_sym_uintptr_t] = ACTIONS(1040),
    [anon_sym_void] = ACTIONS(1040),
    [sym_vector_type] = ACTIONS(1040),
    [anon_sym_image2d_t] = ACTIONS(1040),
    [anon_sym_image3d_t] = ACTIONS(1040),
    [anon_sym_image2d_array_t] = ACTIONS(1040),
    [anon_sym_image1d_t] = ACTIONS(1040),
    [anon_sym_image1d_buffer_t] = ACTIONS(1040),
    [anon_sym_image1d_array_t] = ACTIONS(1040),
    [anon_sym_image2d_depth_t] = ACTIONS(1040),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1040),
    [anon_sym_sampler_t] = ACTIONS(1040),
    [anon_sym_queue_t] = ACTIONS(1040),
    [anon_sym_ndrange_t] = ACTIONS(1040),
    [anon_sym_clk_event_t] = ACTIONS(1040),
    [anon_sym_reserve_id_t] = ACTIONS(1040),
    [anon_sym_event_t] = ACTIONS(1040),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_union] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_goto] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_sizeof] = ACTIONS(1040),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_L_SQUOTE] = ACTIONS(1042),
    [anon_sym_u_SQUOTE] = ACTIONS(1042),
    [anon_sym_U_SQUOTE] = ACTIONS(1042),
    [anon_sym_u8_SQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [anon_sym_L_DQUOTE] = ACTIONS(1042),
    [anon_sym_u_DQUOTE] = ACTIONS(1042),
    [anon_sym_U_DQUOTE] = ACTIONS(1042),
    [anon_sym_u8_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(916),
    [sym_identifier] = ACTIONS(914),
    [aux_sym_preproc_include_token1] = ACTIONS(914),
    [aux_sym_preproc_def_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(914),
    [sym_preproc_directive] = ACTIONS(914),
    [anon_sym_LPAREN2] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(916),
    [anon_sym_AMP] = ACTIONS(916),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_typedef] = ACTIONS(914),
    [anon_sym_kernel] = ACTIONS(914),
    [anon_sym___kernel] = ACTIONS(914),
    [anon_sym_global] = ACTIONS(914),
    [anon_sym___global] = ACTIONS(914),
    [anon_sym_local] = ACTIONS(914),
    [anon_sym___local] = ACTIONS(914),
    [anon_sym_constant] = ACTIONS(914),
    [anon_sym___constant] = ACTIONS(914),
    [anon_sym_private] = ACTIONS(914),
    [anon_sym___private] = ACTIONS(914),
    [anon_sym_generic] = ACTIONS(914),
    [anon_sym___generic] = ACTIONS(914),
    [anon_sym_read_only] = ACTIONS(914),
    [anon_sym___read_only] = ACTIONS(914),
    [anon_sym_write_only] = ACTIONS(914),
    [anon_sym___write_only] = ACTIONS(914),
    [anon_sym_read_write] = ACTIONS(914),
    [anon_sym___read_write] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym___attribute__] = ACTIONS(914),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(916),
    [anon_sym___declspec] = ACTIONS(914),
    [anon_sym___cdecl] = ACTIONS(914),
    [anon_sym___clrcall] = ACTIONS(914),
    [anon_sym___stdcall] = ACTIONS(914),
    [anon_sym___fastcall] = ACTIONS(914),
    [anon_sym___thiscall] = ACTIONS(914),
    [anon_sym___vectorcall] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_auto] = ACTIONS(914),
    [anon_sym_register] = ACTIONS(914),
    [anon_sym_inline] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_restrict] = ACTIONS(914),
    [anon_sym__Atomic] = ACTIONS(914),
    [anon_sym_pipe] = ACTIONS(914),
    [anon_sym_signed] = ACTIONS(914),
    [anon_sym_unsigned] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [anon_sym_bool] = ACTIONS(914),
    [anon_sym_char] = ACTIONS(914),
    [anon_sym_uchar] = ACTIONS(914),
    [anon_sym_ushort] = ACTIONS(914),
    [anon_sym_int] = ACTIONS(914),
    [anon_sym_uint] = ACTIONS(914),
    [anon_sym_ulong] = ACTIONS(914),
    [anon_sym_float] = ACTIONS(914),
    [anon_sym_double] = ACTIONS(914),
    [anon_sym_half] = ACTIONS(914),
    [anon_sym_size_t] = ACTIONS(914),
    [anon_sym_ptrdiff_t] = ACTIONS(914),
    [anon_sym_intptr_t] = ACTIONS(914),
    [anon_sym_uintptr_t] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(914),
    [sym_vector_type] = ACTIONS(914),
    [anon_sym_image2d_t] = ACTIONS(914),
    [anon_sym_image3d_t] = ACTIONS(914),
    [anon_sym_image2d_array_t] = ACTIONS(914),
    [anon_sym_image1d_t] = ACTIONS(914),
    [anon_sym_image1d_buffer_t] = ACTIONS(914),
    [anon_sym_image1d_array_t] = ACTIONS(914),
    [anon_sym_image2d_depth_t] = ACTIONS(914),
    [anon_sym_image2d_array_depth_t] = ACTIONS(914),
    [anon_sym_sampler_t] = ACTIONS(914),
    [anon_sym_queue_t] = ACTIONS(914),
    [anon_sym_ndrange_t] = ACTIONS(914),
    [anon_sym_clk_event_t] = ACTIONS(914),
    [anon_sym_reserve_id_t] = ACTIONS(914),
    [anon_sym_event_t] = ACTIONS(914),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_goto] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_sizeof] = ACTIONS(914),
    [sym_number_literal] = ACTIONS(916),
    [anon_sym_L_SQUOTE] = ACTIONS(916),
    [anon_sym_u_SQUOTE] = ACTIONS(916),
    [anon_sym_U_SQUOTE] = ACTIONS(916),
    [anon_sym_u8_SQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [anon_sym_L_DQUOTE] = ACTIONS(916),
    [anon_sym_u_DQUOTE] = ACTIONS(916),
    [anon_sym_U_DQUOTE] = ACTIONS(916),
    [anon_sym_u8_DQUOTE] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_null] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(960),
    [sym_identifier] = ACTIONS(958),
    [aux_sym_preproc_include_token1] = ACTIONS(958),
    [aux_sym_preproc_def_token1] = ACTIONS(958),
    [aux_sym_preproc_if_token1] = ACTIONS(958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(958),
    [sym_preproc_directive] = ACTIONS(958),
    [anon_sym_LPAREN2] = ACTIONS(960),
    [anon_sym_BANG] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(960),
    [anon_sym_AMP] = ACTIONS(960),
    [anon_sym_SEMI] = ACTIONS(960),
    [anon_sym_typedef] = ACTIONS(958),
    [anon_sym_kernel] = ACTIONS(958),
    [anon_sym___kernel] = ACTIONS(958),
    [anon_sym_global] = ACTIONS(958),
    [anon_sym___global] = ACTIONS(958),
    [anon_sym_local] = ACTIONS(958),
    [anon_sym___local] = ACTIONS(958),
    [anon_sym_constant] = ACTIONS(958),
    [anon_sym___constant] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym___private] = ACTIONS(958),
    [anon_sym_generic] = ACTIONS(958),
    [anon_sym___generic] = ACTIONS(958),
    [anon_sym_read_only] = ACTIONS(958),
    [anon_sym___read_only] = ACTIONS(958),
    [anon_sym_write_only] = ACTIONS(958),
    [anon_sym___write_only] = ACTIONS(958),
    [anon_sym_read_write] = ACTIONS(958),
    [anon_sym___read_write] = ACTIONS(958),
    [anon_sym_extern] = ACTIONS(958),
    [anon_sym___attribute__] = ACTIONS(958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(960),
    [anon_sym___declspec] = ACTIONS(958),
    [anon_sym___cdecl] = ACTIONS(958),
    [anon_sym___clrcall] = ACTIONS(958),
    [anon_sym___stdcall] = ACTIONS(958),
    [anon_sym___fastcall] = ACTIONS(958),
    [anon_sym___thiscall] = ACTIONS(958),
    [anon_sym___vectorcall] = ACTIONS(958),
    [anon_sym_LBRACE] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_auto] = ACTIONS(958),
    [anon_sym_register] = ACTIONS(958),
    [anon_sym_inline] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_volatile] = ACTIONS(958),
    [anon_sym_restrict] = ACTIONS(958),
    [anon_sym__Atomic] = ACTIONS(958),
    [anon_sym_pipe] = ACTIONS(958),
    [anon_sym_signed] = ACTIONS(958),
    [anon_sym_unsigned] = ACTIONS(958),
    [anon_sym_long] = ACTIONS(958),
    [anon_sym_short] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(958),
    [anon_sym_char] = ACTIONS(958),
    [anon_sym_uchar] = ACTIONS(958),
    [anon_sym_ushort] = ACTIONS(958),
    [anon_sym_int] = ACTIONS(958),
    [anon_sym_uint] = ACTIONS(958),
    [anon_sym_ulong] = ACTIONS(958),
    [anon_sym_float] = ACTIONS(958),
    [anon_sym_double] = ACTIONS(958),
    [anon_sym_half] = ACTIONS(958),
    [anon_sym_size_t] = ACTIONS(958),
    [anon_sym_ptrdiff_t] = ACTIONS(958),
    [anon_sym_intptr_t] = ACTIONS(958),
    [anon_sym_uintptr_t] = ACTIONS(958),
    [anon_sym_void] = ACTIONS(958),
    [sym_vector_type] = ACTIONS(958),
    [anon_sym_image2d_t] = ACTIONS(958),
    [anon_sym_image3d_t] = ACTIONS(958),
    [anon_sym_image2d_array_t] = ACTIONS(958),
    [anon_sym_image1d_t] = ACTIONS(958),
    [anon_sym_image1d_buffer_t] = ACTIONS(958),
    [anon_sym_image1d_array_t] = ACTIONS(958),
    [anon_sym_image2d_depth_t] = ACTIONS(958),
    [anon_sym_image2d_array_depth_t] = ACTIONS(958),
    [anon_sym_sampler_t] = ACTIONS(958),
    [anon_sym_queue_t] = ACTIONS(958),
    [anon_sym_ndrange_t] = ACTIONS(958),
    [anon_sym_clk_event_t] = ACTIONS(958),
    [anon_sym_reserve_id_t] = ACTIONS(958),
    [anon_sym_event_t] = ACTIONS(958),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_union] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(958),
    [anon_sym_case] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_do] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_goto] = ACTIONS(958),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_sizeof] = ACTIONS(958),
    [sym_number_literal] = ACTIONS(960),
    [anon_sym_L_SQUOTE] = ACTIONS(960),
    [anon_sym_u_SQUOTE] = ACTIONS(960),
    [anon_sym_U_SQUOTE] = ACTIONS(960),
    [anon_sym_u8_SQUOTE] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(960),
    [anon_sym_L_DQUOTE] = ACTIONS(960),
    [anon_sym_u_DQUOTE] = ACTIONS(960),
    [anon_sym_U_DQUOTE] = ACTIONS(960),
    [anon_sym_u8_DQUOTE] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(960),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(986),
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_kernel] = ACTIONS(984),
    [anon_sym___kernel] = ACTIONS(984),
    [anon_sym_global] = ACTIONS(984),
    [anon_sym___global] = ACTIONS(984),
    [anon_sym_local] = ACTIONS(984),
    [anon_sym___local] = ACTIONS(984),
    [anon_sym_constant] = ACTIONS(984),
    [anon_sym___constant] = ACTIONS(984),
    [anon_sym_private] = ACTIONS(984),
    [anon_sym___private] = ACTIONS(984),
    [anon_sym_generic] = ACTIONS(984),
    [anon_sym___generic] = ACTIONS(984),
    [anon_sym_read_only] = ACTIONS(984),
    [anon_sym___read_only] = ACTIONS(984),
    [anon_sym_write_only] = ACTIONS(984),
    [anon_sym___write_only] = ACTIONS(984),
    [anon_sym_read_write] = ACTIONS(984),
    [anon_sym___read_write] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(986),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_pipe] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [anon_sym_bool] = ACTIONS(984),
    [anon_sym_char] = ACTIONS(984),
    [anon_sym_uchar] = ACTIONS(984),
    [anon_sym_ushort] = ACTIONS(984),
    [anon_sym_int] = ACTIONS(984),
    [anon_sym_uint] = ACTIONS(984),
    [anon_sym_ulong] = ACTIONS(984),
    [anon_sym_float] = ACTIONS(984),
    [anon_sym_double] = ACTIONS(984),
    [anon_sym_half] = ACTIONS(984),
    [anon_sym_size_t] = ACTIONS(984),
    [anon_sym_ptrdiff_t] = ACTIONS(984),
    [anon_sym_intptr_t] = ACTIONS(984),
    [anon_sym_uintptr_t] = ACTIONS(984),
    [anon_sym_void] = ACTIONS(984),
    [sym_vector_type] = ACTIONS(984),
    [anon_sym_image2d_t] = ACTIONS(984),
    [anon_sym_image3d_t] = ACTIONS(984),
    [anon_sym_image2d_array_t] = ACTIONS(984),
    [anon_sym_image1d_t] = ACTIONS(984),
    [anon_sym_image1d_buffer_t] = ACTIONS(984),
    [anon_sym_image1d_array_t] = ACTIONS(984),
    [anon_sym_image2d_depth_t] = ACTIONS(984),
    [anon_sym_image2d_array_depth_t] = ACTIONS(984),
    [anon_sym_sampler_t] = ACTIONS(984),
    [anon_sym_queue_t] = ACTIONS(984),
    [anon_sym_ndrange_t] = ACTIONS(984),
    [anon_sym_clk_event_t] = ACTIONS(984),
    [anon_sym_reserve_id_t] = ACTIONS(984),
    [anon_sym_event_t] = ACTIONS(984),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(990),
    [sym_identifier] = ACTIONS(988),
    [aux_sym_preproc_include_token1] = ACTIONS(988),
    [aux_sym_preproc_def_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(988),
    [sym_preproc_directive] = ACTIONS(988),
    [anon_sym_LPAREN2] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_typedef] = ACTIONS(988),
    [anon_sym_kernel] = ACTIONS(988),
    [anon_sym___kernel] = ACTIONS(988),
    [anon_sym_global] = ACTIONS(988),
    [anon_sym___global] = ACTIONS(988),
    [anon_sym_local] = ACTIONS(988),
    [anon_sym___local] = ACTIONS(988),
    [anon_sym_constant] = ACTIONS(988),
    [anon_sym___constant] = ACTIONS(988),
    [anon_sym_private] = ACTIONS(988),
    [anon_sym___private] = ACTIONS(988),
    [anon_sym_generic] = ACTIONS(988),
    [anon_sym___generic] = ACTIONS(988),
    [anon_sym_read_only] = ACTIONS(988),
    [anon_sym___read_only] = ACTIONS(988),
    [anon_sym_write_only] = ACTIONS(988),
    [anon_sym___write_only] = ACTIONS(988),
    [anon_sym_read_write] = ACTIONS(988),
    [anon_sym___read_write] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym___attribute__] = ACTIONS(988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(990),
    [anon_sym___declspec] = ACTIONS(988),
    [anon_sym___cdecl] = ACTIONS(988),
    [anon_sym___clrcall] = ACTIONS(988),
    [anon_sym___stdcall] = ACTIONS(988),
    [anon_sym___fastcall] = ACTIONS(988),
    [anon_sym___thiscall] = ACTIONS(988),
    [anon_sym___vectorcall] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_auto] = ACTIONS(988),
    [anon_sym_register] = ACTIONS(988),
    [anon_sym_inline] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_volatile] = ACTIONS(988),
    [anon_sym_restrict] = ACTIONS(988),
    [anon_sym__Atomic] = ACTIONS(988),
    [anon_sym_pipe] = ACTIONS(988),
    [anon_sym_signed] = ACTIONS(988),
    [anon_sym_unsigned] = ACTIONS(988),
    [anon_sym_long] = ACTIONS(988),
    [anon_sym_short] = ACTIONS(988),
    [anon_sym_bool] = ACTIONS(988),
    [anon_sym_char] = ACTIONS(988),
    [anon_sym_uchar] = ACTIONS(988),
    [anon_sym_ushort] = ACTIONS(988),
    [anon_sym_int] = ACTIONS(988),
    [anon_sym_uint] = ACTIONS(988),
    [anon_sym_ulong] = ACTIONS(988),
    [anon_sym_float] = ACTIONS(988),
    [anon_sym_double] = ACTIONS(988),
    [anon_sym_half] = ACTIONS(988),
    [anon_sym_size_t] = ACTIONS(988),
    [anon_sym_ptrdiff_t] = ACTIONS(988),
    [anon_sym_intptr_t] = ACTIONS(988),
    [anon_sym_uintptr_t] = ACTIONS(988),
    [anon_sym_void] = ACTIONS(988),
    [sym_vector_type] = ACTIONS(988),
    [anon_sym_image2d_t] = ACTIONS(988),
    [anon_sym_image3d_t] = ACTIONS(988),
    [anon_sym_image2d_array_t] = ACTIONS(988),
    [anon_sym_image1d_t] = ACTIONS(988),
    [anon_sym_image1d_buffer_t] = ACTIONS(988),
    [anon_sym_image1d_array_t] = ACTIONS(988),
    [anon_sym_image2d_depth_t] = ACTIONS(988),
    [anon_sym_image2d_array_depth_t] = ACTIONS(988),
    [anon_sym_sampler_t] = ACTIONS(988),
    [anon_sym_queue_t] = ACTIONS(988),
    [anon_sym_ndrange_t] = ACTIONS(988),
    [anon_sym_clk_event_t] = ACTIONS(988),
    [anon_sym_reserve_id_t] = ACTIONS(988),
    [anon_sym_event_t] = ACTIONS(988),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_struct] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_goto] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(990),
    [anon_sym_PLUS_PLUS] = ACTIONS(990),
    [anon_sym_sizeof] = ACTIONS(988),
    [sym_number_literal] = ACTIONS(990),
    [anon_sym_L_SQUOTE] = ACTIONS(990),
    [anon_sym_u_SQUOTE] = ACTIONS(990),
    [anon_sym_U_SQUOTE] = ACTIONS(990),
    [anon_sym_u8_SQUOTE] = ACTIONS(990),
    [anon_sym_SQUOTE] = ACTIONS(990),
    [anon_sym_L_DQUOTE] = ACTIONS(990),
    [anon_sym_u_DQUOTE] = ACTIONS(990),
    [anon_sym_U_DQUOTE] = ACTIONS(990),
    [anon_sym_u8_DQUOTE] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(1018),
    [sym_identifier] = ACTIONS(1016),
    [aux_sym_preproc_include_token1] = ACTIONS(1016),
    [aux_sym_preproc_def_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1016),
    [sym_preproc_directive] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_typedef] = ACTIONS(1016),
    [anon_sym_kernel] = ACTIONS(1016),
    [anon_sym___kernel] = ACTIONS(1016),
    [anon_sym_global] = ACTIONS(1016),
    [anon_sym___global] = ACTIONS(1016),
    [anon_sym_local] = ACTIONS(1016),
    [anon_sym___local] = ACTIONS(1016),
    [anon_sym_constant] = ACTIONS(1016),
    [anon_sym___constant] = ACTIONS(1016),
    [anon_sym_private] = ACTIONS(1016),
    [anon_sym___private] = ACTIONS(1016),
    [anon_sym_generic] = ACTIONS(1016),
    [anon_sym___generic] = ACTIONS(1016),
    [anon_sym_read_only] = ACTIONS(1016),
    [anon_sym___read_only] = ACTIONS(1016),
    [anon_sym_write_only] = ACTIONS(1016),
    [anon_sym___write_only] = ACTIONS(1016),
    [anon_sym_read_write] = ACTIONS(1016),
    [anon_sym___read_write] = ACTIONS(1016),
    [anon_sym_extern] = ACTIONS(1016),
    [anon_sym___attribute__] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1018),
    [anon_sym___declspec] = ACTIONS(1016),
    [anon_sym___cdecl] = ACTIONS(1016),
    [anon_sym___clrcall] = ACTIONS(1016),
    [anon_sym___stdcall] = ACTIONS(1016),
    [anon_sym___fastcall] = ACTIONS(1016),
    [anon_sym___thiscall] = ACTIONS(1016),
    [anon_sym___vectorcall] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_auto] = ACTIONS(1016),
    [anon_sym_register] = ACTIONS(1016),
    [anon_sym_inline] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_volatile] = ACTIONS(1016),
    [anon_sym_restrict] = ACTIONS(1016),
    [anon_sym__Atomic] = ACTIONS(1016),
    [anon_sym_pipe] = ACTIONS(1016),
    [anon_sym_signed] = ACTIONS(1016),
    [anon_sym_unsigned] = ACTIONS(1016),
    [anon_sym_long] = ACTIONS(1016),
    [anon_sym_short] = ACTIONS(1016),
    [anon_sym_bool] = ACTIONS(1016),
    [anon_sym_char] = ACTIONS(1016),
    [anon_sym_uchar] = ACTIONS(1016),
    [anon_sym_ushort] = ACTIONS(1016),
    [anon_sym_int] = ACTIONS(1016),
    [anon_sym_uint] = ACTIONS(1016),
    [anon_sym_ulong] = ACTIONS(1016),
    [anon_sym_float] = ACTIONS(1016),
    [anon_sym_double] = ACTIONS(1016),
    [anon_sym_half] = ACTIONS(1016),
    [anon_sym_size_t] = ACTIONS(1016),
    [anon_sym_ptrdiff_t] = ACTIONS(1016),
    [anon_sym_intptr_t] = ACTIONS(1016),
    [anon_sym_uintptr_t] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1016),
    [sym_vector_type] = ACTIONS(1016),
    [anon_sym_image2d_t] = ACTIONS(1016),
    [anon_sym_image3d_t] = ACTIONS(1016),
    [anon_sym_image2d_array_t] = ACTIONS(1016),
    [anon_sym_image1d_t] = ACTIONS(1016),
    [anon_sym_image1d_buffer_t] = ACTIONS(1016),
    [anon_sym_image1d_array_t] = ACTIONS(1016),
    [anon_sym_image2d_depth_t] = ACTIONS(1016),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1016),
    [anon_sym_sampler_t] = ACTIONS(1016),
    [anon_sym_queue_t] = ACTIONS(1016),
    [anon_sym_ndrange_t] = ACTIONS(1016),
    [anon_sym_clk_event_t] = ACTIONS(1016),
    [anon_sym_reserve_id_t] = ACTIONS(1016),
    [anon_sym_event_t] = ACTIONS(1016),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_goto] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_sizeof] = ACTIONS(1016),
    [sym_number_literal] = ACTIONS(1018),
    [anon_sym_L_SQUOTE] = ACTIONS(1018),
    [anon_sym_u_SQUOTE] = ACTIONS(1018),
    [anon_sym_U_SQUOTE] = ACTIONS(1018),
    [anon_sym_u8_SQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [anon_sym_L_DQUOTE] = ACTIONS(1018),
    [anon_sym_u_DQUOTE] = ACTIONS(1018),
    [anon_sym_U_DQUOTE] = ACTIONS(1018),
    [anon_sym_u8_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_null] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(1022),
    [sym_identifier] = ACTIONS(1020),
    [aux_sym_preproc_include_token1] = ACTIONS(1020),
    [aux_sym_preproc_def_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1020),
    [sym_preproc_directive] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_AMP] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [anon_sym_typedef] = ACTIONS(1020),
    [anon_sym_kernel] = ACTIONS(1020),
    [anon_sym___kernel] = ACTIONS(1020),
    [anon_sym_global] = ACTIONS(1020),
    [anon_sym___global] = ACTIONS(1020),
    [anon_sym_local] = ACTIONS(1020),
    [anon_sym___local] = ACTIONS(1020),
    [anon_sym_constant] = ACTIONS(1020),
    [anon_sym___constant] = ACTIONS(1020),
    [anon_sym_private] = ACTIONS(1020),
    [anon_sym___private] = ACTIONS(1020),
    [anon_sym_generic] = ACTIONS(1020),
    [anon_sym___generic] = ACTIONS(1020),
    [anon_sym_read_only] = ACTIONS(1020),
    [anon_sym___read_only] = ACTIONS(1020),
    [anon_sym_write_only] = ACTIONS(1020),
    [anon_sym___write_only] = ACTIONS(1020),
    [anon_sym_read_write] = ACTIONS(1020),
    [anon_sym___read_write] = ACTIONS(1020),
    [anon_sym_extern] = ACTIONS(1020),
    [anon_sym___attribute__] = ACTIONS(1020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1022),
    [anon_sym___declspec] = ACTIONS(1020),
    [anon_sym___cdecl] = ACTIONS(1020),
    [anon_sym___clrcall] = ACTIONS(1020),
    [anon_sym___stdcall] = ACTIONS(1020),
    [anon_sym___fastcall] = ACTIONS(1020),
    [anon_sym___thiscall] = ACTIONS(1020),
    [anon_sym___vectorcall] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_auto] = ACTIONS(1020),
    [anon_sym_register] = ACTIONS(1020),
    [anon_sym_inline] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_volatile] = ACTIONS(1020),
    [anon_sym_restrict] = ACTIONS(1020),
    [anon_sym__Atomic] = ACTIONS(1020),
    [anon_sym_pipe] = ACTIONS(1020),
    [anon_sym_signed] = ACTIONS(1020),
    [anon_sym_unsigned] = ACTIONS(1020),
    [anon_sym_long] = ACTIONS(1020),
    [anon_sym_short] = ACTIONS(1020),
    [anon_sym_bool] = ACTIONS(1020),
    [anon_sym_char] = ACTIONS(1020),
    [anon_sym_uchar] = ACTIONS(1020),
    [anon_sym_ushort] = ACTIONS(1020),
    [anon_sym_int] = ACTIONS(1020),
    [anon_sym_uint] = ACTIONS(1020),
    [anon_sym_ulong] = ACTIONS(1020),
    [anon_sym_float] = ACTIONS(1020),
    [anon_sym_double] = ACTIONS(1020),
    [anon_sym_half] = ACTIONS(1020),
    [anon_sym_size_t] = ACTIONS(1020),
    [anon_sym_ptrdiff_t] = ACTIONS(1020),
    [anon_sym_intptr_t] = ACTIONS(1020),
    [anon_sym_uintptr_t] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1020),
    [sym_vector_type] = ACTIONS(1020),
    [anon_sym_image2d_t] = ACTIONS(1020),
    [anon_sym_image3d_t] = ACTIONS(1020),
    [anon_sym_image2d_array_t] = ACTIONS(1020),
    [anon_sym_image1d_t] = ACTIONS(1020),
    [anon_sym_image1d_buffer_t] = ACTIONS(1020),
    [anon_sym_image1d_array_t] = ACTIONS(1020),
    [anon_sym_image2d_depth_t] = ACTIONS(1020),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1020),
    [anon_sym_sampler_t] = ACTIONS(1020),
    [anon_sym_queue_t] = ACTIONS(1020),
    [anon_sym_ndrange_t] = ACTIONS(1020),
    [anon_sym_clk_event_t] = ACTIONS(1020),
    [anon_sym_reserve_id_t] = ACTIONS(1020),
    [anon_sym_event_t] = ACTIONS(1020),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_union] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_goto] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [anon_sym_sizeof] = ACTIONS(1020),
    [sym_number_literal] = ACTIONS(1022),
    [anon_sym_L_SQUOTE] = ACTIONS(1022),
    [anon_sym_u_SQUOTE] = ACTIONS(1022),
    [anon_sym_U_SQUOTE] = ACTIONS(1022),
    [anon_sym_u8_SQUOTE] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [anon_sym_L_DQUOTE] = ACTIONS(1022),
    [anon_sym_u_DQUOTE] = ACTIONS(1022),
    [anon_sym_U_DQUOTE] = ACTIONS(1022),
    [anon_sym_u8_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(956),
    [sym_identifier] = ACTIONS(954),
    [aux_sym_preproc_include_token1] = ACTIONS(954),
    [aux_sym_preproc_def_token1] = ACTIONS(954),
    [aux_sym_preproc_if_token1] = ACTIONS(954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(954),
    [sym_preproc_directive] = ACTIONS(954),
    [anon_sym_LPAREN2] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_STAR] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(956),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_typedef] = ACTIONS(954),
    [anon_sym_kernel] = ACTIONS(954),
    [anon_sym___kernel] = ACTIONS(954),
    [anon_sym_global] = ACTIONS(954),
    [anon_sym___global] = ACTIONS(954),
    [anon_sym_local] = ACTIONS(954),
    [anon_sym___local] = ACTIONS(954),
    [anon_sym_constant] = ACTIONS(954),
    [anon_sym___constant] = ACTIONS(954),
    [anon_sym_private] = ACTIONS(954),
    [anon_sym___private] = ACTIONS(954),
    [anon_sym_generic] = ACTIONS(954),
    [anon_sym___generic] = ACTIONS(954),
    [anon_sym_read_only] = ACTIONS(954),
    [anon_sym___read_only] = ACTIONS(954),
    [anon_sym_write_only] = ACTIONS(954),
    [anon_sym___write_only] = ACTIONS(954),
    [anon_sym_read_write] = ACTIONS(954),
    [anon_sym___read_write] = ACTIONS(954),
    [anon_sym_extern] = ACTIONS(954),
    [anon_sym___attribute__] = ACTIONS(954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(956),
    [anon_sym___declspec] = ACTIONS(954),
    [anon_sym___cdecl] = ACTIONS(954),
    [anon_sym___clrcall] = ACTIONS(954),
    [anon_sym___stdcall] = ACTIONS(954),
    [anon_sym___fastcall] = ACTIONS(954),
    [anon_sym___thiscall] = ACTIONS(954),
    [anon_sym___vectorcall] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(954),
    [anon_sym_auto] = ACTIONS(954),
    [anon_sym_register] = ACTIONS(954),
    [anon_sym_inline] = ACTIONS(954),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym_pipe] = ACTIONS(954),
    [anon_sym_signed] = ACTIONS(954),
    [anon_sym_unsigned] = ACTIONS(954),
    [anon_sym_long] = ACTIONS(954),
    [anon_sym_short] = ACTIONS(954),
    [anon_sym_bool] = ACTIONS(954),
    [anon_sym_char] = ACTIONS(954),
    [anon_sym_uchar] = ACTIONS(954),
    [anon_sym_ushort] = ACTIONS(954),
    [anon_sym_int] = ACTIONS(954),
    [anon_sym_uint] = ACTIONS(954),
    [anon_sym_ulong] = ACTIONS(954),
    [anon_sym_float] = ACTIONS(954),
    [anon_sym_double] = ACTIONS(954),
    [anon_sym_half] = ACTIONS(954),
    [anon_sym_size_t] = ACTIONS(954),
    [anon_sym_ptrdiff_t] = ACTIONS(954),
    [anon_sym_intptr_t] = ACTIONS(954),
    [anon_sym_uintptr_t] = ACTIONS(954),
    [anon_sym_void] = ACTIONS(954),
    [sym_vector_type] = ACTIONS(954),
    [anon_sym_image2d_t] = ACTIONS(954),
    [anon_sym_image3d_t] = ACTIONS(954),
    [anon_sym_image2d_array_t] = ACTIONS(954),
    [anon_sym_image1d_t] = ACTIONS(954),
    [anon_sym_image1d_buffer_t] = ACTIONS(954),
    [anon_sym_image1d_array_t] = ACTIONS(954),
    [anon_sym_image2d_depth_t] = ACTIONS(954),
    [anon_sym_image2d_array_depth_t] = ACTIONS(954),
    [anon_sym_sampler_t] = ACTIONS(954),
    [anon_sym_queue_t] = ACTIONS(954),
    [anon_sym_ndrange_t] = ACTIONS(954),
    [anon_sym_clk_event_t] = ACTIONS(954),
    [anon_sym_reserve_id_t] = ACTIONS(954),
    [anon_sym_event_t] = ACTIONS(954),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(954),
    [anon_sym_enum] = ACTIONS(954),
    [anon_sym_struct] = ACTIONS(954),
    [anon_sym_union] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_else] = ACTIONS(954),
    [anon_sym_switch] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(954),
    [anon_sym_default] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(954),
    [anon_sym_do] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_break] = ACTIONS(954),
    [anon_sym_continue] = ACTIONS(954),
    [anon_sym_goto] = ACTIONS(954),
    [anon_sym_DASH_DASH] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(956),
    [anon_sym_sizeof] = ACTIONS(954),
    [sym_number_literal] = ACTIONS(956),
    [anon_sym_L_SQUOTE] = ACTIONS(956),
    [anon_sym_u_SQUOTE] = ACTIONS(956),
    [anon_sym_U_SQUOTE] = ACTIONS(956),
    [anon_sym_u8_SQUOTE] = ACTIONS(956),
    [anon_sym_SQUOTE] = ACTIONS(956),
    [anon_sym_L_DQUOTE] = ACTIONS(956),
    [anon_sym_u_DQUOTE] = ACTIONS(956),
    [anon_sym_U_DQUOTE] = ACTIONS(956),
    [anon_sym_u8_DQUOTE] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(956),
    [sym_true] = ACTIONS(954),
    [sym_false] = ACTIONS(954),
    [sym_null] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(952),
    [sym_identifier] = ACTIONS(950),
    [aux_sym_preproc_include_token1] = ACTIONS(950),
    [aux_sym_preproc_def_token1] = ACTIONS(950),
    [aux_sym_preproc_if_token1] = ACTIONS(950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(950),
    [sym_preproc_directive] = ACTIONS(950),
    [anon_sym_LPAREN2] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(952),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(952),
    [anon_sym_AMP] = ACTIONS(952),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_typedef] = ACTIONS(950),
    [anon_sym_kernel] = ACTIONS(950),
    [anon_sym___kernel] = ACTIONS(950),
    [anon_sym_global] = ACTIONS(950),
    [anon_sym___global] = ACTIONS(950),
    [anon_sym_local] = ACTIONS(950),
    [anon_sym___local] = ACTIONS(950),
    [anon_sym_constant] = ACTIONS(950),
    [anon_sym___constant] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym___private] = ACTIONS(950),
    [anon_sym_generic] = ACTIONS(950),
    [anon_sym___generic] = ACTIONS(950),
    [anon_sym_read_only] = ACTIONS(950),
    [anon_sym___read_only] = ACTIONS(950),
    [anon_sym_write_only] = ACTIONS(950),
    [anon_sym___write_only] = ACTIONS(950),
    [anon_sym_read_write] = ACTIONS(950),
    [anon_sym___read_write] = ACTIONS(950),
    [anon_sym_extern] = ACTIONS(950),
    [anon_sym___attribute__] = ACTIONS(950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(952),
    [anon_sym___declspec] = ACTIONS(950),
    [anon_sym___cdecl] = ACTIONS(950),
    [anon_sym___clrcall] = ACTIONS(950),
    [anon_sym___stdcall] = ACTIONS(950),
    [anon_sym___fastcall] = ACTIONS(950),
    [anon_sym___thiscall] = ACTIONS(950),
    [anon_sym___vectorcall] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(952),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_auto] = ACTIONS(950),
    [anon_sym_register] = ACTIONS(950),
    [anon_sym_inline] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(950),
    [anon_sym_volatile] = ACTIONS(950),
    [anon_sym_restrict] = ACTIONS(950),
    [anon_sym__Atomic] = ACTIONS(950),
    [anon_sym_pipe] = ACTIONS(950),
    [anon_sym_signed] = ACTIONS(950),
    [anon_sym_unsigned] = ACTIONS(950),
    [anon_sym_long] = ACTIONS(950),
    [anon_sym_short] = ACTIONS(950),
    [anon_sym_bool] = ACTIONS(950),
    [anon_sym_char] = ACTIONS(950),
    [anon_sym_uchar] = ACTIONS(950),
    [anon_sym_ushort] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(950),
    [anon_sym_uint] = ACTIONS(950),
    [anon_sym_ulong] = ACTIONS(950),
    [anon_sym_float] = ACTIONS(950),
    [anon_sym_double] = ACTIONS(950),
    [anon_sym_half] = ACTIONS(950),
    [anon_sym_size_t] = ACTIONS(950),
    [anon_sym_ptrdiff_t] = ACTIONS(950),
    [anon_sym_intptr_t] = ACTIONS(950),
    [anon_sym_uintptr_t] = ACTIONS(950),
    [anon_sym_void] = ACTIONS(950),
    [sym_vector_type] = ACTIONS(950),
    [anon_sym_image2d_t] = ACTIONS(950),
    [anon_sym_image3d_t] = ACTIONS(950),
    [anon_sym_image2d_array_t] = ACTIONS(950),
    [anon_sym_image1d_t] = ACTIONS(950),
    [anon_sym_image1d_buffer_t] = ACTIONS(950),
    [anon_sym_image1d_array_t] = ACTIONS(950),
    [anon_sym_image2d_depth_t] = ACTIONS(950),
    [anon_sym_image2d_array_depth_t] = ACTIONS(950),
    [anon_sym_sampler_t] = ACTIONS(950),
    [anon_sym_queue_t] = ACTIONS(950),
    [anon_sym_ndrange_t] = ACTIONS(950),
    [anon_sym_clk_event_t] = ACTIONS(950),
    [anon_sym_reserve_id_t] = ACTIONS(950),
    [anon_sym_event_t] = ACTIONS(950),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_struct] = ACTIONS(950),
    [anon_sym_union] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(950),
    [anon_sym_else] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(950),
    [anon_sym_case] = ACTIONS(950),
    [anon_sym_default] = ACTIONS(950),
    [anon_sym_while] = ACTIONS(950),
    [anon_sym_do] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(950),
    [anon_sym_return] = ACTIONS(950),
    [anon_sym_break] = ACTIONS(950),
    [anon_sym_continue] = ACTIONS(950),
    [anon_sym_goto] = ACTIONS(950),
    [anon_sym_DASH_DASH] = ACTIONS(952),
    [anon_sym_PLUS_PLUS] = ACTIONS(952),
    [anon_sym_sizeof] = ACTIONS(950),
    [sym_number_literal] = ACTIONS(952),
    [anon_sym_L_SQUOTE] = ACTIONS(952),
    [anon_sym_u_SQUOTE] = ACTIONS(952),
    [anon_sym_U_SQUOTE] = ACTIONS(952),
    [anon_sym_u8_SQUOTE] = ACTIONS(952),
    [anon_sym_SQUOTE] = ACTIONS(952),
    [anon_sym_L_DQUOTE] = ACTIONS(952),
    [anon_sym_u_DQUOTE] = ACTIONS(952),
    [anon_sym_U_DQUOTE] = ACTIONS(952),
    [anon_sym_u8_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(952),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_null] = ACTIONS(950),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(976),
    [aux_sym_preproc_def_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(976),
    [sym_preproc_directive] = ACTIONS(976),
    [anon_sym_LPAREN2] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_AMP] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_typedef] = ACTIONS(976),
    [anon_sym_kernel] = ACTIONS(976),
    [anon_sym___kernel] = ACTIONS(976),
    [anon_sym_global] = ACTIONS(976),
    [anon_sym___global] = ACTIONS(976),
    [anon_sym_local] = ACTIONS(976),
    [anon_sym___local] = ACTIONS(976),
    [anon_sym_constant] = ACTIONS(976),
    [anon_sym___constant] = ACTIONS(976),
    [anon_sym_private] = ACTIONS(976),
    [anon_sym___private] = ACTIONS(976),
    [anon_sym_generic] = ACTIONS(976),
    [anon_sym___generic] = ACTIONS(976),
    [anon_sym_read_only] = ACTIONS(976),
    [anon_sym___read_only] = ACTIONS(976),
    [anon_sym_write_only] = ACTIONS(976),
    [anon_sym___write_only] = ACTIONS(976),
    [anon_sym_read_write] = ACTIONS(976),
    [anon_sym___read_write] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym___attribute__] = ACTIONS(976),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(978),
    [anon_sym___declspec] = ACTIONS(976),
    [anon_sym___cdecl] = ACTIONS(976),
    [anon_sym___clrcall] = ACTIONS(976),
    [anon_sym___stdcall] = ACTIONS(976),
    [anon_sym___fastcall] = ACTIONS(976),
    [anon_sym___thiscall] = ACTIONS(976),
    [anon_sym___vectorcall] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_RBRACE] = ACTIONS(978),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_auto] = ACTIONS(976),
    [anon_sym_register] = ACTIONS(976),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_volatile] = ACTIONS(976),
    [anon_sym_restrict] = ACTIONS(976),
    [anon_sym__Atomic] = ACTIONS(976),
    [anon_sym_pipe] = ACTIONS(976),
    [anon_sym_signed] = ACTIONS(976),
    [anon_sym_unsigned] = ACTIONS(976),
    [anon_sym_long] = ACTIONS(976),
    [anon_sym_short] = ACTIONS(976),
    [anon_sym_bool] = ACTIONS(976),
    [anon_sym_char] = ACTIONS(976),
    [anon_sym_uchar] = ACTIONS(976),
    [anon_sym_ushort] = ACTIONS(976),
    [anon_sym_int] = ACTIONS(976),
    [anon_sym_uint] = ACTIONS(976),
    [anon_sym_ulong] = ACTIONS(976),
    [anon_sym_float] = ACTIONS(976),
    [anon_sym_double] = ACTIONS(976),
    [anon_sym_half] = ACTIONS(976),
    [anon_sym_size_t] = ACTIONS(976),
    [anon_sym_ptrdiff_t] = ACTIONS(976),
    [anon_sym_intptr_t] = ACTIONS(976),
    [anon_sym_uintptr_t] = ACTIONS(976),
    [anon_sym_void] = ACTIONS(976),
    [sym_vector_type] = ACTIONS(976),
    [anon_sym_image2d_t] = ACTIONS(976),
    [anon_sym_image3d_t] = ACTIONS(976),
    [anon_sym_image2d_array_t] = ACTIONS(976),
    [anon_sym_image1d_t] = ACTIONS(976),
    [anon_sym_image1d_buffer_t] = ACTIONS(976),
    [anon_sym_image1d_array_t] = ACTIONS(976),
    [anon_sym_image2d_depth_t] = ACTIONS(976),
    [anon_sym_image2d_array_depth_t] = ACTIONS(976),
    [anon_sym_sampler_t] = ACTIONS(976),
    [anon_sym_queue_t] = ACTIONS(976),
    [anon_sym_ndrange_t] = ACTIONS(976),
    [anon_sym_clk_event_t] = ACTIONS(976),
    [anon_sym_reserve_id_t] = ACTIONS(976),
    [anon_sym_event_t] = ACTIONS(976),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_struct] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_goto] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(978),
    [anon_sym_sizeof] = ACTIONS(976),
    [sym_number_literal] = ACTIONS(978),
    [anon_sym_L_SQUOTE] = ACTIONS(978),
    [anon_sym_u_SQUOTE] = ACTIONS(978),
    [anon_sym_U_SQUOTE] = ACTIONS(978),
    [anon_sym_u8_SQUOTE] = ACTIONS(978),
    [anon_sym_SQUOTE] = ACTIONS(978),
    [anon_sym_L_DQUOTE] = ACTIONS(978),
    [anon_sym_u_DQUOTE] = ACTIONS(978),
    [anon_sym_U_DQUOTE] = ACTIONS(978),
    [anon_sym_u8_DQUOTE] = ACTIONS(978),
    [anon_sym_DQUOTE] = ACTIONS(978),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_identifier] = ACTIONS(1044),
    [aux_sym_preproc_include_token1] = ACTIONS(1044),
    [aux_sym_preproc_def_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1044),
    [sym_preproc_directive] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1046),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_typedef] = ACTIONS(1044),
    [anon_sym_kernel] = ACTIONS(1044),
    [anon_sym___kernel] = ACTIONS(1044),
    [anon_sym_global] = ACTIONS(1044),
    [anon_sym___global] = ACTIONS(1044),
    [anon_sym_local] = ACTIONS(1044),
    [anon_sym___local] = ACTIONS(1044),
    [anon_sym_constant] = ACTIONS(1044),
    [anon_sym___constant] = ACTIONS(1044),
    [anon_sym_private] = ACTIONS(1044),
    [anon_sym___private] = ACTIONS(1044),
    [anon_sym_generic] = ACTIONS(1044),
    [anon_sym___generic] = ACTIONS(1044),
    [anon_sym_read_only] = ACTIONS(1044),
    [anon_sym___read_only] = ACTIONS(1044),
    [anon_sym_write_only] = ACTIONS(1044),
    [anon_sym___write_only] = ACTIONS(1044),
    [anon_sym_read_write] = ACTIONS(1044),
    [anon_sym___read_write] = ACTIONS(1044),
    [anon_sym_extern] = ACTIONS(1044),
    [anon_sym___attribute__] = ACTIONS(1044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1046),
    [anon_sym___declspec] = ACTIONS(1044),
    [anon_sym___cdecl] = ACTIONS(1044),
    [anon_sym___clrcall] = ACTIONS(1044),
    [anon_sym___stdcall] = ACTIONS(1044),
    [anon_sym___fastcall] = ACTIONS(1044),
    [anon_sym___thiscall] = ACTIONS(1044),
    [anon_sym___vectorcall] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1044),
    [anon_sym_auto] = ACTIONS(1044),
    [anon_sym_register] = ACTIONS(1044),
    [anon_sym_inline] = ACTIONS(1044),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym_pipe] = ACTIONS(1044),
    [anon_sym_signed] = ACTIONS(1044),
    [anon_sym_unsigned] = ACTIONS(1044),
    [anon_sym_long] = ACTIONS(1044),
    [anon_sym_short] = ACTIONS(1044),
    [anon_sym_bool] = ACTIONS(1044),
    [anon_sym_char] = ACTIONS(1044),
    [anon_sym_uchar] = ACTIONS(1044),
    [anon_sym_ushort] = ACTIONS(1044),
    [anon_sym_int] = ACTIONS(1044),
    [anon_sym_uint] = ACTIONS(1044),
    [anon_sym_ulong] = ACTIONS(1044),
    [anon_sym_float] = ACTIONS(1044),
    [anon_sym_double] = ACTIONS(1044),
    [anon_sym_half] = ACTIONS(1044),
    [anon_sym_size_t] = ACTIONS(1044),
    [anon_sym_ptrdiff_t] = ACTIONS(1044),
    [anon_sym_intptr_t] = ACTIONS(1044),
    [anon_sym_uintptr_t] = ACTIONS(1044),
    [anon_sym_void] = ACTIONS(1044),
    [sym_vector_type] = ACTIONS(1044),
    [anon_sym_image2d_t] = ACTIONS(1044),
    [anon_sym_image3d_t] = ACTIONS(1044),
    [anon_sym_image2d_array_t] = ACTIONS(1044),
    [anon_sym_image1d_t] = ACTIONS(1044),
    [anon_sym_image1d_buffer_t] = ACTIONS(1044),
    [anon_sym_image1d_array_t] = ACTIONS(1044),
    [anon_sym_image2d_depth_t] = ACTIONS(1044),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1044),
    [anon_sym_sampler_t] = ACTIONS(1044),
    [anon_sym_queue_t] = ACTIONS(1044),
    [anon_sym_ndrange_t] = ACTIONS(1044),
    [anon_sym_clk_event_t] = ACTIONS(1044),
    [anon_sym_reserve_id_t] = ACTIONS(1044),
    [anon_sym_event_t] = ACTIONS(1044),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1044),
    [anon_sym_enum] = ACTIONS(1044),
    [anon_sym_struct] = ACTIONS(1044),
    [anon_sym_union] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_else] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_goto] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [anon_sym_sizeof] = ACTIONS(1044),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_L_SQUOTE] = ACTIONS(1046),
    [anon_sym_u_SQUOTE] = ACTIONS(1046),
    [anon_sym_U_SQUOTE] = ACTIONS(1046),
    [anon_sym_u8_SQUOTE] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_L_DQUOTE] = ACTIONS(1046),
    [anon_sym_u_DQUOTE] = ACTIONS(1046),
    [anon_sym_U_DQUOTE] = ACTIONS(1046),
    [anon_sym_u8_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_identifier] = ACTIONS(1032),
    [aux_sym_preproc_include_token1] = ACTIONS(1032),
    [aux_sym_preproc_def_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1032),
    [sym_preproc_directive] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_typedef] = ACTIONS(1032),
    [anon_sym_kernel] = ACTIONS(1032),
    [anon_sym___kernel] = ACTIONS(1032),
    [anon_sym_global] = ACTIONS(1032),
    [anon_sym___global] = ACTIONS(1032),
    [anon_sym_local] = ACTIONS(1032),
    [anon_sym___local] = ACTIONS(1032),
    [anon_sym_constant] = ACTIONS(1032),
    [anon_sym___constant] = ACTIONS(1032),
    [anon_sym_private] = ACTIONS(1032),
    [anon_sym___private] = ACTIONS(1032),
    [anon_sym_generic] = ACTIONS(1032),
    [anon_sym___generic] = ACTIONS(1032),
    [anon_sym_read_only] = ACTIONS(1032),
    [anon_sym___read_only] = ACTIONS(1032),
    [anon_sym_write_only] = ACTIONS(1032),
    [anon_sym___write_only] = ACTIONS(1032),
    [anon_sym_read_write] = ACTIONS(1032),
    [anon_sym___read_write] = ACTIONS(1032),
    [anon_sym_extern] = ACTIONS(1032),
    [anon_sym___attribute__] = ACTIONS(1032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1034),
    [anon_sym___declspec] = ACTIONS(1032),
    [anon_sym___cdecl] = ACTIONS(1032),
    [anon_sym___clrcall] = ACTIONS(1032),
    [anon_sym___stdcall] = ACTIONS(1032),
    [anon_sym___fastcall] = ACTIONS(1032),
    [anon_sym___thiscall] = ACTIONS(1032),
    [anon_sym___vectorcall] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_RBRACE] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_auto] = ACTIONS(1032),
    [anon_sym_register] = ACTIONS(1032),
    [anon_sym_inline] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_volatile] = ACTIONS(1032),
    [anon_sym_restrict] = ACTIONS(1032),
    [anon_sym__Atomic] = ACTIONS(1032),
    [anon_sym_pipe] = ACTIONS(1032),
    [anon_sym_signed] = ACTIONS(1032),
    [anon_sym_unsigned] = ACTIONS(1032),
    [anon_sym_long] = ACTIONS(1032),
    [anon_sym_short] = ACTIONS(1032),
    [anon_sym_bool] = ACTIONS(1032),
    [anon_sym_char] = ACTIONS(1032),
    [anon_sym_uchar] = ACTIONS(1032),
    [anon_sym_ushort] = ACTIONS(1032),
    [anon_sym_int] = ACTIONS(1032),
    [anon_sym_uint] = ACTIONS(1032),
    [anon_sym_ulong] = ACTIONS(1032),
    [anon_sym_float] = ACTIONS(1032),
    [anon_sym_double] = ACTIONS(1032),
    [anon_sym_half] = ACTIONS(1032),
    [anon_sym_size_t] = ACTIONS(1032),
    [anon_sym_ptrdiff_t] = ACTIONS(1032),
    [anon_sym_intptr_t] = ACTIONS(1032),
    [anon_sym_uintptr_t] = ACTIONS(1032),
    [anon_sym_void] = ACTIONS(1032),
    [sym_vector_type] = ACTIONS(1032),
    [anon_sym_image2d_t] = ACTIONS(1032),
    [anon_sym_image3d_t] = ACTIONS(1032),
    [anon_sym_image2d_array_t] = ACTIONS(1032),
    [anon_sym_image1d_t] = ACTIONS(1032),
    [anon_sym_image1d_buffer_t] = ACTIONS(1032),
    [anon_sym_image1d_array_t] = ACTIONS(1032),
    [anon_sym_image2d_depth_t] = ACTIONS(1032),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1032),
    [anon_sym_sampler_t] = ACTIONS(1032),
    [anon_sym_queue_t] = ACTIONS(1032),
    [anon_sym_ndrange_t] = ACTIONS(1032),
    [anon_sym_clk_event_t] = ACTIONS(1032),
    [anon_sym_reserve_id_t] = ACTIONS(1032),
    [anon_sym_event_t] = ACTIONS(1032),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_struct] = ACTIONS(1032),
    [anon_sym_union] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_goto] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_sizeof] = ACTIONS(1032),
    [sym_number_literal] = ACTIONS(1034),
    [anon_sym_L_SQUOTE] = ACTIONS(1034),
    [anon_sym_u_SQUOTE] = ACTIONS(1034),
    [anon_sym_U_SQUOTE] = ACTIONS(1034),
    [anon_sym_u8_SQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [anon_sym_L_DQUOTE] = ACTIONS(1034),
    [anon_sym_u_DQUOTE] = ACTIONS(1034),
    [anon_sym_U_DQUOTE] = ACTIONS(1034),
    [anon_sym_u8_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_identifier] = ACTIONS(1024),
    [aux_sym_preproc_include_token1] = ACTIONS(1024),
    [aux_sym_preproc_def_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token2] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1024),
    [sym_preproc_directive] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_typedef] = ACTIONS(1024),
    [anon_sym_kernel] = ACTIONS(1024),
    [anon_sym___kernel] = ACTIONS(1024),
    [anon_sym_global] = ACTIONS(1024),
    [anon_sym___global] = ACTIONS(1024),
    [anon_sym_local] = ACTIONS(1024),
    [anon_sym___local] = ACTIONS(1024),
    [anon_sym_constant] = ACTIONS(1024),
    [anon_sym___constant] = ACTIONS(1024),
    [anon_sym_private] = ACTIONS(1024),
    [anon_sym___private] = ACTIONS(1024),
    [anon_sym_generic] = ACTIONS(1024),
    [anon_sym___generic] = ACTIONS(1024),
    [anon_sym_read_only] = ACTIONS(1024),
    [anon_sym___read_only] = ACTIONS(1024),
    [anon_sym_write_only] = ACTIONS(1024),
    [anon_sym___write_only] = ACTIONS(1024),
    [anon_sym_read_write] = ACTIONS(1024),
    [anon_sym___read_write] = ACTIONS(1024),
    [anon_sym_extern] = ACTIONS(1024),
    [anon_sym___attribute__] = ACTIONS(1024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1026),
    [anon_sym___declspec] = ACTIONS(1024),
    [anon_sym___cdecl] = ACTIONS(1024),
    [anon_sym___clrcall] = ACTIONS(1024),
    [anon_sym___stdcall] = ACTIONS(1024),
    [anon_sym___fastcall] = ACTIONS(1024),
    [anon_sym___thiscall] = ACTIONS(1024),
    [anon_sym___vectorcall] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1024),
    [anon_sym_auto] = ACTIONS(1024),
    [anon_sym_register] = ACTIONS(1024),
    [anon_sym_inline] = ACTIONS(1024),
    [anon_sym_const] = ACTIONS(1024),
    [anon_sym_volatile] = ACTIONS(1024),
    [anon_sym_restrict] = ACTIONS(1024),
    [anon_sym__Atomic] = ACTIONS(1024),
    [anon_sym_pipe] = ACTIONS(1024),
    [anon_sym_signed] = ACTIONS(1024),
    [anon_sym_unsigned] = ACTIONS(1024),
    [anon_sym_long] = ACTIONS(1024),
    [anon_sym_short] = ACTIONS(1024),
    [anon_sym_bool] = ACTIONS(1024),
    [anon_sym_char] = ACTIONS(1024),
    [anon_sym_uchar] = ACTIONS(1024),
    [anon_sym_ushort] = ACTIONS(1024),
    [anon_sym_int] = ACTIONS(1024),
    [anon_sym_uint] = ACTIONS(1024),
    [anon_sym_ulong] = ACTIONS(1024),
    [anon_sym_float] = ACTIONS(1024),
    [anon_sym_double] = ACTIONS(1024),
    [anon_sym_half] = ACTIONS(1024),
    [anon_sym_size_t] = ACTIONS(1024),
    [anon_sym_ptrdiff_t] = ACTIONS(1024),
    [anon_sym_intptr_t] = ACTIONS(1024),
    [anon_sym_uintptr_t] = ACTIONS(1024),
    [anon_sym_void] = ACTIONS(1024),
    [sym_vector_type] = ACTIONS(1024),
    [anon_sym_image2d_t] = ACTIONS(1024),
    [anon_sym_image3d_t] = ACTIONS(1024),
    [anon_sym_image2d_array_t] = ACTIONS(1024),
    [anon_sym_image1d_t] = ACTIONS(1024),
    [anon_sym_image1d_buffer_t] = ACTIONS(1024),
    [anon_sym_image1d_array_t] = ACTIONS(1024),
    [anon_sym_image2d_depth_t] = ACTIONS(1024),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1024),
    [anon_sym_sampler_t] = ACTIONS(1024),
    [anon_sym_queue_t] = ACTIONS(1024),
    [anon_sym_ndrange_t] = ACTIONS(1024),
    [anon_sym_clk_event_t] = ACTIONS(1024),
    [anon_sym_reserve_id_t] = ACTIONS(1024),
    [anon_sym_event_t] = ACTIONS(1024),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1024),
    [anon_sym_enum] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_union] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1024),
    [anon_sym_default] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_goto] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_sizeof] = ACTIONS(1024),
    [sym_number_literal] = ACTIONS(1026),
    [anon_sym_L_SQUOTE] = ACTIONS(1026),
    [anon_sym_u_SQUOTE] = ACTIONS(1026),
    [anon_sym_U_SQUOTE] = ACTIONS(1026),
    [anon_sym_u8_SQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1024),
    [sym_false] = ACTIONS(1024),
    [sym_null] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_identifier] = ACTIONS(914),
    [aux_sym_preproc_include_token1] = ACTIONS(914),
    [aux_sym_preproc_def_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token2] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(914),
    [sym_preproc_directive] = ACTIONS(914),
    [anon_sym_LPAREN2] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(916),
    [anon_sym_AMP] = ACTIONS(916),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_typedef] = ACTIONS(914),
    [anon_sym_kernel] = ACTIONS(914),
    [anon_sym___kernel] = ACTIONS(914),
    [anon_sym_global] = ACTIONS(914),
    [anon_sym___global] = ACTIONS(914),
    [anon_sym_local] = ACTIONS(914),
    [anon_sym___local] = ACTIONS(914),
    [anon_sym_constant] = ACTIONS(914),
    [anon_sym___constant] = ACTIONS(914),
    [anon_sym_private] = ACTIONS(914),
    [anon_sym___private] = ACTIONS(914),
    [anon_sym_generic] = ACTIONS(914),
    [anon_sym___generic] = ACTIONS(914),
    [anon_sym_read_only] = ACTIONS(914),
    [anon_sym___read_only] = ACTIONS(914),
    [anon_sym_write_only] = ACTIONS(914),
    [anon_sym___write_only] = ACTIONS(914),
    [anon_sym_read_write] = ACTIONS(914),
    [anon_sym___read_write] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym___attribute__] = ACTIONS(914),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(916),
    [anon_sym___declspec] = ACTIONS(914),
    [anon_sym___cdecl] = ACTIONS(914),
    [anon_sym___clrcall] = ACTIONS(914),
    [anon_sym___stdcall] = ACTIONS(914),
    [anon_sym___fastcall] = ACTIONS(914),
    [anon_sym___thiscall] = ACTIONS(914),
    [anon_sym___vectorcall] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_auto] = ACTIONS(914),
    [anon_sym_register] = ACTIONS(914),
    [anon_sym_inline] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_restrict] = ACTIONS(914),
    [anon_sym__Atomic] = ACTIONS(914),
    [anon_sym_pipe] = ACTIONS(914),
    [anon_sym_signed] = ACTIONS(914),
    [anon_sym_unsigned] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [anon_sym_bool] = ACTIONS(914),
    [anon_sym_char] = ACTIONS(914),
    [anon_sym_uchar] = ACTIONS(914),
    [anon_sym_ushort] = ACTIONS(914),
    [anon_sym_int] = ACTIONS(914),
    [anon_sym_uint] = ACTIONS(914),
    [anon_sym_ulong] = ACTIONS(914),
    [anon_sym_float] = ACTIONS(914),
    [anon_sym_double] = ACTIONS(914),
    [anon_sym_half] = ACTIONS(914),
    [anon_sym_size_t] = ACTIONS(914),
    [anon_sym_ptrdiff_t] = ACTIONS(914),
    [anon_sym_intptr_t] = ACTIONS(914),
    [anon_sym_uintptr_t] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(914),
    [sym_vector_type] = ACTIONS(914),
    [anon_sym_image2d_t] = ACTIONS(914),
    [anon_sym_image3d_t] = ACTIONS(914),
    [anon_sym_image2d_array_t] = ACTIONS(914),
    [anon_sym_image1d_t] = ACTIONS(914),
    [anon_sym_image1d_buffer_t] = ACTIONS(914),
    [anon_sym_image1d_array_t] = ACTIONS(914),
    [anon_sym_image2d_depth_t] = ACTIONS(914),
    [anon_sym_image2d_array_depth_t] = ACTIONS(914),
    [anon_sym_sampler_t] = ACTIONS(914),
    [anon_sym_queue_t] = ACTIONS(914),
    [anon_sym_ndrange_t] = ACTIONS(914),
    [anon_sym_clk_event_t] = ACTIONS(914),
    [anon_sym_reserve_id_t] = ACTIONS(914),
    [anon_sym_event_t] = ACTIONS(914),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_goto] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_sizeof] = ACTIONS(914),
    [sym_number_literal] = ACTIONS(916),
    [anon_sym_L_SQUOTE] = ACTIONS(916),
    [anon_sym_u_SQUOTE] = ACTIONS(916),
    [anon_sym_U_SQUOTE] = ACTIONS(916),
    [anon_sym_u8_SQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [anon_sym_L_DQUOTE] = ACTIONS(916),
    [anon_sym_u_DQUOTE] = ACTIONS(916),
    [anon_sym_U_DQUOTE] = ACTIONS(916),
    [anon_sym_u8_DQUOTE] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_null] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_identifier] = ACTIONS(1028),
    [aux_sym_preproc_include_token1] = ACTIONS(1028),
    [aux_sym_preproc_def_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1028),
    [sym_preproc_directive] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_typedef] = ACTIONS(1028),
    [anon_sym_kernel] = ACTIONS(1028),
    [anon_sym___kernel] = ACTIONS(1028),
    [anon_sym_global] = ACTIONS(1028),
    [anon_sym___global] = ACTIONS(1028),
    [anon_sym_local] = ACTIONS(1028),
    [anon_sym___local] = ACTIONS(1028),
    [anon_sym_constant] = ACTIONS(1028),
    [anon_sym___constant] = ACTIONS(1028),
    [anon_sym_private] = ACTIONS(1028),
    [anon_sym___private] = ACTIONS(1028),
    [anon_sym_generic] = ACTIONS(1028),
    [anon_sym___generic] = ACTIONS(1028),
    [anon_sym_read_only] = ACTIONS(1028),
    [anon_sym___read_only] = ACTIONS(1028),
    [anon_sym_write_only] = ACTIONS(1028),
    [anon_sym___write_only] = ACTIONS(1028),
    [anon_sym_read_write] = ACTIONS(1028),
    [anon_sym___read_write] = ACTIONS(1028),
    [anon_sym_extern] = ACTIONS(1028),
    [anon_sym___attribute__] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1030),
    [anon_sym___declspec] = ACTIONS(1028),
    [anon_sym___cdecl] = ACTIONS(1028),
    [anon_sym___clrcall] = ACTIONS(1028),
    [anon_sym___stdcall] = ACTIONS(1028),
    [anon_sym___fastcall] = ACTIONS(1028),
    [anon_sym___thiscall] = ACTIONS(1028),
    [anon_sym___vectorcall] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_RBRACE] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1028),
    [anon_sym_auto] = ACTIONS(1028),
    [anon_sym_register] = ACTIONS(1028),
    [anon_sym_inline] = ACTIONS(1028),
    [anon_sym_const] = ACTIONS(1028),
    [anon_sym_volatile] = ACTIONS(1028),
    [anon_sym_restrict] = ACTIONS(1028),
    [anon_sym__Atomic] = ACTIONS(1028),
    [anon_sym_pipe] = ACTIONS(1028),
    [anon_sym_signed] = ACTIONS(1028),
    [anon_sym_unsigned] = ACTIONS(1028),
    [anon_sym_long] = ACTIONS(1028),
    [anon_sym_short] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym_uchar] = ACTIONS(1028),
    [anon_sym_ushort] = ACTIONS(1028),
    [anon_sym_int] = ACTIONS(1028),
    [anon_sym_uint] = ACTIONS(1028),
    [anon_sym_ulong] = ACTIONS(1028),
    [anon_sym_float] = ACTIONS(1028),
    [anon_sym_double] = ACTIONS(1028),
    [anon_sym_half] = ACTIONS(1028),
    [anon_sym_size_t] = ACTIONS(1028),
    [anon_sym_ptrdiff_t] = ACTIONS(1028),
    [anon_sym_intptr_t] = ACTIONS(1028),
    [anon_sym_uintptr_t] = ACTIONS(1028),
    [anon_sym_void] = ACTIONS(1028),
    [sym_vector_type] = ACTIONS(1028),
    [anon_sym_image2d_t] = ACTIONS(1028),
    [anon_sym_image3d_t] = ACTIONS(1028),
    [anon_sym_image2d_array_t] = ACTIONS(1028),
    [anon_sym_image1d_t] = ACTIONS(1028),
    [anon_sym_image1d_buffer_t] = ACTIONS(1028),
    [anon_sym_image1d_array_t] = ACTIONS(1028),
    [anon_sym_image2d_depth_t] = ACTIONS(1028),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1028),
    [anon_sym_sampler_t] = ACTIONS(1028),
    [anon_sym_queue_t] = ACTIONS(1028),
    [anon_sym_ndrange_t] = ACTIONS(1028),
    [anon_sym_clk_event_t] = ACTIONS(1028),
    [anon_sym_reserve_id_t] = ACTIONS(1028),
    [anon_sym_event_t] = ACTIONS(1028),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1028),
    [anon_sym_enum] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_union] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_goto] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_sizeof] = ACTIONS(1028),
    [sym_number_literal] = ACTIONS(1030),
    [anon_sym_L_SQUOTE] = ACTIONS(1030),
    [anon_sym_u_SQUOTE] = ACTIONS(1030),
    [anon_sym_U_SQUOTE] = ACTIONS(1030),
    [anon_sym_u8_SQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [anon_sym_L_DQUOTE] = ACTIONS(1030),
    [anon_sym_u_DQUOTE] = ACTIONS(1030),
    [anon_sym_U_DQUOTE] = ACTIONS(1030),
    [anon_sym_u8_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [sym_true] = ACTIONS(1028),
    [sym_false] = ACTIONS(1028),
    [sym_null] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_identifier] = ACTIONS(980),
    [aux_sym_preproc_include_token1] = ACTIONS(980),
    [aux_sym_preproc_def_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token2] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(980),
    [sym_preproc_directive] = ACTIONS(980),
    [anon_sym_LPAREN2] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(982),
    [anon_sym_SEMI] = ACTIONS(982),
    [anon_sym_typedef] = ACTIONS(980),
    [anon_sym_kernel] = ACTIONS(980),
    [anon_sym___kernel] = ACTIONS(980),
    [anon_sym_global] = ACTIONS(980),
    [anon_sym___global] = ACTIONS(980),
    [anon_sym_local] = ACTIONS(980),
    [anon_sym___local] = ACTIONS(980),
    [anon_sym_constant] = ACTIONS(980),
    [anon_sym___constant] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym___private] = ACTIONS(980),
    [anon_sym_generic] = ACTIONS(980),
    [anon_sym___generic] = ACTIONS(980),
    [anon_sym_read_only] = ACTIONS(980),
    [anon_sym___read_only] = ACTIONS(980),
    [anon_sym_write_only] = ACTIONS(980),
    [anon_sym___write_only] = ACTIONS(980),
    [anon_sym_read_write] = ACTIONS(980),
    [anon_sym___read_write] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym___attribute__] = ACTIONS(980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(982),
    [anon_sym___declspec] = ACTIONS(980),
    [anon_sym___cdecl] = ACTIONS(980),
    [anon_sym___clrcall] = ACTIONS(980),
    [anon_sym___stdcall] = ACTIONS(980),
    [anon_sym___fastcall] = ACTIONS(980),
    [anon_sym___thiscall] = ACTIONS(980),
    [anon_sym___vectorcall] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_auto] = ACTIONS(980),
    [anon_sym_register] = ACTIONS(980),
    [anon_sym_inline] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_volatile] = ACTIONS(980),
    [anon_sym_restrict] = ACTIONS(980),
    [anon_sym__Atomic] = ACTIONS(980),
    [anon_sym_pipe] = ACTIONS(980),
    [anon_sym_signed] = ACTIONS(980),
    [anon_sym_unsigned] = ACTIONS(980),
    [anon_sym_long] = ACTIONS(980),
    [anon_sym_short] = ACTIONS(980),
    [anon_sym_bool] = ACTIONS(980),
    [anon_sym_char] = ACTIONS(980),
    [anon_sym_uchar] = ACTIONS(980),
    [anon_sym_ushort] = ACTIONS(980),
    [anon_sym_int] = ACTIONS(980),
    [anon_sym_uint] = ACTIONS(980),
    [anon_sym_ulong] = ACTIONS(980),
    [anon_sym_float] = ACTIONS(980),
    [anon_sym_double] = ACTIONS(980),
    [anon_sym_half] = ACTIONS(980),
    [anon_sym_size_t] = ACTIONS(980),
    [anon_sym_ptrdiff_t] = ACTIONS(980),
    [anon_sym_intptr_t] = ACTIONS(980),
    [anon_sym_uintptr_t] = ACTIONS(980),
    [anon_sym_void] = ACTIONS(980),
    [sym_vector_type] = ACTIONS(980),
    [anon_sym_image2d_t] = ACTIONS(980),
    [anon_sym_image3d_t] = ACTIONS(980),
    [anon_sym_image2d_array_t] = ACTIONS(980),
    [anon_sym_image1d_t] = ACTIONS(980),
    [anon_sym_image1d_buffer_t] = ACTIONS(980),
    [anon_sym_image1d_array_t] = ACTIONS(980),
    [anon_sym_image2d_depth_t] = ACTIONS(980),
    [anon_sym_image2d_array_depth_t] = ACTIONS(980),
    [anon_sym_sampler_t] = ACTIONS(980),
    [anon_sym_queue_t] = ACTIONS(980),
    [anon_sym_ndrange_t] = ACTIONS(980),
    [anon_sym_clk_event_t] = ACTIONS(980),
    [anon_sym_reserve_id_t] = ACTIONS(980),
    [anon_sym_event_t] = ACTIONS(980),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_struct] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(980),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_do] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_goto] = ACTIONS(980),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_sizeof] = ACTIONS(980),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_L_SQUOTE] = ACTIONS(982),
    [anon_sym_u_SQUOTE] = ACTIONS(982),
    [anon_sym_U_SQUOTE] = ACTIONS(982),
    [anon_sym_u8_SQUOTE] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(982),
    [anon_sym_L_DQUOTE] = ACTIONS(982),
    [anon_sym_u_DQUOTE] = ACTIONS(982),
    [anon_sym_U_DQUOTE] = ACTIONS(982),
    [anon_sym_u8_DQUOTE] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_null] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_identifier] = ACTIONS(918),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token2] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(920),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(918),
    [anon_sym_kernel] = ACTIONS(918),
    [anon_sym___kernel] = ACTIONS(918),
    [anon_sym_global] = ACTIONS(918),
    [anon_sym___global] = ACTIONS(918),
    [anon_sym_local] = ACTIONS(918),
    [anon_sym___local] = ACTIONS(918),
    [anon_sym_constant] = ACTIONS(918),
    [anon_sym___constant] = ACTIONS(918),
    [anon_sym_private] = ACTIONS(918),
    [anon_sym___private] = ACTIONS(918),
    [anon_sym_generic] = ACTIONS(918),
    [anon_sym___generic] = ACTIONS(918),
    [anon_sym_read_only] = ACTIONS(918),
    [anon_sym___read_only] = ACTIONS(918),
    [anon_sym_write_only] = ACTIONS(918),
    [anon_sym___write_only] = ACTIONS(918),
    [anon_sym_read_write] = ACTIONS(918),
    [anon_sym___read_write] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym___attribute__] = ACTIONS(918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(920),
    [anon_sym___declspec] = ACTIONS(918),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_auto] = ACTIONS(918),
    [anon_sym_register] = ACTIONS(918),
    [anon_sym_inline] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_restrict] = ACTIONS(918),
    [anon_sym__Atomic] = ACTIONS(918),
    [anon_sym_pipe] = ACTIONS(918),
    [anon_sym_signed] = ACTIONS(918),
    [anon_sym_unsigned] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [anon_sym_bool] = ACTIONS(918),
    [anon_sym_char] = ACTIONS(918),
    [anon_sym_uchar] = ACTIONS(918),
    [anon_sym_ushort] = ACTIONS(918),
    [anon_sym_int] = ACTIONS(918),
    [anon_sym_uint] = ACTIONS(918),
    [anon_sym_ulong] = ACTIONS(918),
    [anon_sym_float] = ACTIONS(918),
    [anon_sym_double] = ACTIONS(918),
    [anon_sym_half] = ACTIONS(918),
    [anon_sym_size_t] = ACTIONS(918),
    [anon_sym_ptrdiff_t] = ACTIONS(918),
    [anon_sym_intptr_t] = ACTIONS(918),
    [anon_sym_uintptr_t] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(918),
    [sym_vector_type] = ACTIONS(918),
    [anon_sym_image2d_t] = ACTIONS(918),
    [anon_sym_image3d_t] = ACTIONS(918),
    [anon_sym_image2d_array_t] = ACTIONS(918),
    [anon_sym_image1d_t] = ACTIONS(918),
    [anon_sym_image1d_buffer_t] = ACTIONS(918),
    [anon_sym_image1d_array_t] = ACTIONS(918),
    [anon_sym_image2d_depth_t] = ACTIONS(918),
    [anon_sym_image2d_array_depth_t] = ACTIONS(918),
    [anon_sym_sampler_t] = ACTIONS(918),
    [anon_sym_queue_t] = ACTIONS(918),
    [anon_sym_ndrange_t] = ACTIONS(918),
    [anon_sym_clk_event_t] = ACTIONS(918),
    [anon_sym_reserve_id_t] = ACTIONS(918),
    [anon_sym_event_t] = ACTIONS(918),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_union] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_sizeof] = ACTIONS(918),
    [sym_number_literal] = ACTIONS(920),
    [anon_sym_L_SQUOTE] = ACTIONS(920),
    [anon_sym_u_SQUOTE] = ACTIONS(920),
    [anon_sym_U_SQUOTE] = ACTIONS(920),
    [anon_sym_u8_SQUOTE] = ACTIONS(920),
    [anon_sym_SQUOTE] = ACTIONS(920),
    [anon_sym_L_DQUOTE] = ACTIONS(920),
    [anon_sym_u_DQUOTE] = ACTIONS(920),
    [anon_sym_U_DQUOTE] = ACTIONS(920),
    [anon_sym_u8_DQUOTE] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_null] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(936),
    [sym_identifier] = ACTIONS(934),
    [aux_sym_preproc_include_token1] = ACTIONS(934),
    [aux_sym_preproc_def_token1] = ACTIONS(934),
    [aux_sym_preproc_if_token1] = ACTIONS(934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(934),
    [sym_preproc_directive] = ACTIONS(934),
    [anon_sym_LPAREN2] = ACTIONS(936),
    [anon_sym_BANG] = ACTIONS(936),
    [anon_sym_TILDE] = ACTIONS(936),
    [anon_sym_DASH] = ACTIONS(934),
    [anon_sym_PLUS] = ACTIONS(934),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_AMP] = ACTIONS(936),
    [anon_sym_SEMI] = ACTIONS(936),
    [anon_sym_typedef] = ACTIONS(934),
    [anon_sym_kernel] = ACTIONS(934),
    [anon_sym___kernel] = ACTIONS(934),
    [anon_sym_global] = ACTIONS(934),
    [anon_sym___global] = ACTIONS(934),
    [anon_sym_local] = ACTIONS(934),
    [anon_sym___local] = ACTIONS(934),
    [anon_sym_constant] = ACTIONS(934),
    [anon_sym___constant] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym___private] = ACTIONS(934),
    [anon_sym_generic] = ACTIONS(934),
    [anon_sym___generic] = ACTIONS(934),
    [anon_sym_read_only] = ACTIONS(934),
    [anon_sym___read_only] = ACTIONS(934),
    [anon_sym_write_only] = ACTIONS(934),
    [anon_sym___write_only] = ACTIONS(934),
    [anon_sym_read_write] = ACTIONS(934),
    [anon_sym___read_write] = ACTIONS(934),
    [anon_sym_extern] = ACTIONS(934),
    [anon_sym___attribute__] = ACTIONS(934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(936),
    [anon_sym___declspec] = ACTIONS(934),
    [anon_sym___cdecl] = ACTIONS(934),
    [anon_sym___clrcall] = ACTIONS(934),
    [anon_sym___stdcall] = ACTIONS(934),
    [anon_sym___fastcall] = ACTIONS(934),
    [anon_sym___thiscall] = ACTIONS(934),
    [anon_sym___vectorcall] = ACTIONS(934),
    [anon_sym_LBRACE] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_auto] = ACTIONS(934),
    [anon_sym_register] = ACTIONS(934),
    [anon_sym_inline] = ACTIONS(934),
    [anon_sym_const] = ACTIONS(934),
    [anon_sym_volatile] = ACTIONS(934),
    [anon_sym_restrict] = ACTIONS(934),
    [anon_sym__Atomic] = ACTIONS(934),
    [anon_sym_pipe] = ACTIONS(934),
    [anon_sym_signed] = ACTIONS(934),
    [anon_sym_unsigned] = ACTIONS(934),
    [anon_sym_long] = ACTIONS(934),
    [anon_sym_short] = ACTIONS(934),
    [anon_sym_bool] = ACTIONS(934),
    [anon_sym_char] = ACTIONS(934),
    [anon_sym_uchar] = ACTIONS(934),
    [anon_sym_ushort] = ACTIONS(934),
    [anon_sym_int] = ACTIONS(934),
    [anon_sym_uint] = ACTIONS(934),
    [anon_sym_ulong] = ACTIONS(934),
    [anon_sym_float] = ACTIONS(934),
    [anon_sym_double] = ACTIONS(934),
    [anon_sym_half] = ACTIONS(934),
    [anon_sym_size_t] = ACTIONS(934),
    [anon_sym_ptrdiff_t] = ACTIONS(934),
    [anon_sym_intptr_t] = ACTIONS(934),
    [anon_sym_uintptr_t] = ACTIONS(934),
    [anon_sym_void] = ACTIONS(934),
    [sym_vector_type] = ACTIONS(934),
    [anon_sym_image2d_t] = ACTIONS(934),
    [anon_sym_image3d_t] = ACTIONS(934),
    [anon_sym_image2d_array_t] = ACTIONS(934),
    [anon_sym_image1d_t] = ACTIONS(934),
    [anon_sym_image1d_buffer_t] = ACTIONS(934),
    [anon_sym_image1d_array_t] = ACTIONS(934),
    [anon_sym_image2d_depth_t] = ACTIONS(934),
    [anon_sym_image2d_array_depth_t] = ACTIONS(934),
    [anon_sym_sampler_t] = ACTIONS(934),
    [anon_sym_queue_t] = ACTIONS(934),
    [anon_sym_ndrange_t] = ACTIONS(934),
    [anon_sym_clk_event_t] = ACTIONS(934),
    [anon_sym_reserve_id_t] = ACTIONS(934),
    [anon_sym_event_t] = ACTIONS(934),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(934),
    [anon_sym_enum] = ACTIONS(934),
    [anon_sym_struct] = ACTIONS(934),
    [anon_sym_union] = ACTIONS(934),
    [anon_sym_if] = ACTIONS(934),
    [anon_sym_else] = ACTIONS(934),
    [anon_sym_switch] = ACTIONS(934),
    [anon_sym_case] = ACTIONS(934),
    [anon_sym_default] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(934),
    [anon_sym_do] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(934),
    [anon_sym_return] = ACTIONS(934),
    [anon_sym_break] = ACTIONS(934),
    [anon_sym_continue] = ACTIONS(934),
    [anon_sym_goto] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(936),
    [anon_sym_PLUS_PLUS] = ACTIONS(936),
    [anon_sym_sizeof] = ACTIONS(934),
    [sym_number_literal] = ACTIONS(936),
    [anon_sym_L_SQUOTE] = ACTIONS(936),
    [anon_sym_u_SQUOTE] = ACTIONS(936),
    [anon_sym_U_SQUOTE] = ACTIONS(936),
    [anon_sym_u8_SQUOTE] = ACTIONS(936),
    [anon_sym_SQUOTE] = ACTIONS(936),
    [anon_sym_L_DQUOTE] = ACTIONS(936),
    [anon_sym_u_DQUOTE] = ACTIONS(936),
    [anon_sym_U_DQUOTE] = ACTIONS(936),
    [anon_sym_u8_DQUOTE] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(936),
    [sym_true] = ACTIONS(934),
    [sym_false] = ACTIONS(934),
    [sym_null] = ACTIONS(934),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_identifier] = ACTIONS(922),
    [aux_sym_preproc_include_token1] = ACTIONS(922),
    [aux_sym_preproc_def_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token2] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(922),
    [sym_preproc_directive] = ACTIONS(922),
    [anon_sym_LPAREN2] = ACTIONS(924),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_typedef] = ACTIONS(922),
    [anon_sym_kernel] = ACTIONS(922),
    [anon_sym___kernel] = ACTIONS(922),
    [anon_sym_global] = ACTIONS(922),
    [anon_sym___global] = ACTIONS(922),
    [anon_sym_local] = ACTIONS(922),
    [anon_sym___local] = ACTIONS(922),
    [anon_sym_constant] = ACTIONS(922),
    [anon_sym___constant] = ACTIONS(922),
    [anon_sym_private] = ACTIONS(922),
    [anon_sym___private] = ACTIONS(922),
    [anon_sym_generic] = ACTIONS(922),
    [anon_sym___generic] = ACTIONS(922),
    [anon_sym_read_only] = ACTIONS(922),
    [anon_sym___read_only] = ACTIONS(922),
    [anon_sym_write_only] = ACTIONS(922),
    [anon_sym___write_only] = ACTIONS(922),
    [anon_sym_read_write] = ACTIONS(922),
    [anon_sym___read_write] = ACTIONS(922),
    [anon_sym_extern] = ACTIONS(922),
    [anon_sym___attribute__] = ACTIONS(922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(924),
    [anon_sym___declspec] = ACTIONS(922),
    [anon_sym___cdecl] = ACTIONS(922),
    [anon_sym___clrcall] = ACTIONS(922),
    [anon_sym___stdcall] = ACTIONS(922),
    [anon_sym___fastcall] = ACTIONS(922),
    [anon_sym___thiscall] = ACTIONS(922),
    [anon_sym___vectorcall] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_auto] = ACTIONS(922),
    [anon_sym_register] = ACTIONS(922),
    [anon_sym_inline] = ACTIONS(922),
    [anon_sym_const] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_restrict] = ACTIONS(922),
    [anon_sym__Atomic] = ACTIONS(922),
    [anon_sym_pipe] = ACTIONS(922),
    [anon_sym_signed] = ACTIONS(922),
    [anon_sym_unsigned] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [anon_sym_bool] = ACTIONS(922),
    [anon_sym_char] = ACTIONS(922),
    [anon_sym_uchar] = ACTIONS(922),
    [anon_sym_ushort] = ACTIONS(922),
    [anon_sym_int] = ACTIONS(922),
    [anon_sym_uint] = ACTIONS(922),
    [anon_sym_ulong] = ACTIONS(922),
    [anon_sym_float] = ACTIONS(922),
    [anon_sym_double] = ACTIONS(922),
    [anon_sym_half] = ACTIONS(922),
    [anon_sym_size_t] = ACTIONS(922),
    [anon_sym_ptrdiff_t] = ACTIONS(922),
    [anon_sym_intptr_t] = ACTIONS(922),
    [anon_sym_uintptr_t] = ACTIONS(922),
    [anon_sym_void] = ACTIONS(922),
    [sym_vector_type] = ACTIONS(922),
    [anon_sym_image2d_t] = ACTIONS(922),
    [anon_sym_image3d_t] = ACTIONS(922),
    [anon_sym_image2d_array_t] = ACTIONS(922),
    [anon_sym_image1d_t] = ACTIONS(922),
    [anon_sym_image1d_buffer_t] = ACTIONS(922),
    [anon_sym_image1d_array_t] = ACTIONS(922),
    [anon_sym_image2d_depth_t] = ACTIONS(922),
    [anon_sym_image2d_array_depth_t] = ACTIONS(922),
    [anon_sym_sampler_t] = ACTIONS(922),
    [anon_sym_queue_t] = ACTIONS(922),
    [anon_sym_ndrange_t] = ACTIONS(922),
    [anon_sym_clk_event_t] = ACTIONS(922),
    [anon_sym_reserve_id_t] = ACTIONS(922),
    [anon_sym_event_t] = ACTIONS(922),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_struct] = ACTIONS(922),
    [anon_sym_union] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_goto] = ACTIONS(922),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_sizeof] = ACTIONS(922),
    [sym_number_literal] = ACTIONS(924),
    [anon_sym_L_SQUOTE] = ACTIONS(924),
    [anon_sym_u_SQUOTE] = ACTIONS(924),
    [anon_sym_U_SQUOTE] = ACTIONS(924),
    [anon_sym_u8_SQUOTE] = ACTIONS(924),
    [anon_sym_SQUOTE] = ACTIONS(924),
    [anon_sym_L_DQUOTE] = ACTIONS(924),
    [anon_sym_u_DQUOTE] = ACTIONS(924),
    [anon_sym_U_DQUOTE] = ACTIONS(924),
    [anon_sym_u8_DQUOTE] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(924),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_null] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_identifier] = ACTIONS(992),
    [aux_sym_preproc_include_token1] = ACTIONS(992),
    [aux_sym_preproc_def_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(992),
    [sym_preproc_directive] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_typedef] = ACTIONS(992),
    [anon_sym_kernel] = ACTIONS(992),
    [anon_sym___kernel] = ACTIONS(992),
    [anon_sym_global] = ACTIONS(992),
    [anon_sym___global] = ACTIONS(992),
    [anon_sym_local] = ACTIONS(992),
    [anon_sym___local] = ACTIONS(992),
    [anon_sym_constant] = ACTIONS(992),
    [anon_sym___constant] = ACTIONS(992),
    [anon_sym_private] = ACTIONS(992),
    [anon_sym___private] = ACTIONS(992),
    [anon_sym_generic] = ACTIONS(992),
    [anon_sym___generic] = ACTIONS(992),
    [anon_sym_read_only] = ACTIONS(992),
    [anon_sym___read_only] = ACTIONS(992),
    [anon_sym_write_only] = ACTIONS(992),
    [anon_sym___write_only] = ACTIONS(992),
    [anon_sym_read_write] = ACTIONS(992),
    [anon_sym___read_write] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym___attribute__] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(994),
    [anon_sym___declspec] = ACTIONS(992),
    [anon_sym___cdecl] = ACTIONS(992),
    [anon_sym___clrcall] = ACTIONS(992),
    [anon_sym___stdcall] = ACTIONS(992),
    [anon_sym___fastcall] = ACTIONS(992),
    [anon_sym___thiscall] = ACTIONS(992),
    [anon_sym___vectorcall] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_RBRACE] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_auto] = ACTIONS(992),
    [anon_sym_register] = ACTIONS(992),
    [anon_sym_inline] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_volatile] = ACTIONS(992),
    [anon_sym_restrict] = ACTIONS(992),
    [anon_sym__Atomic] = ACTIONS(992),
    [anon_sym_pipe] = ACTIONS(992),
    [anon_sym_signed] = ACTIONS(992),
    [anon_sym_unsigned] = ACTIONS(992),
    [anon_sym_long] = ACTIONS(992),
    [anon_sym_short] = ACTIONS(992),
    [anon_sym_bool] = ACTIONS(992),
    [anon_sym_char] = ACTIONS(992),
    [anon_sym_uchar] = ACTIONS(992),
    [anon_sym_ushort] = ACTIONS(992),
    [anon_sym_int] = ACTIONS(992),
    [anon_sym_uint] = ACTIONS(992),
    [anon_sym_ulong] = ACTIONS(992),
    [anon_sym_float] = ACTIONS(992),
    [anon_sym_double] = ACTIONS(992),
    [anon_sym_half] = ACTIONS(992),
    [anon_sym_size_t] = ACTIONS(992),
    [anon_sym_ptrdiff_t] = ACTIONS(992),
    [anon_sym_intptr_t] = ACTIONS(992),
    [anon_sym_uintptr_t] = ACTIONS(992),
    [anon_sym_void] = ACTIONS(992),
    [sym_vector_type] = ACTIONS(992),
    [anon_sym_image2d_t] = ACTIONS(992),
    [anon_sym_image3d_t] = ACTIONS(992),
    [anon_sym_image2d_array_t] = ACTIONS(992),
    [anon_sym_image1d_t] = ACTIONS(992),
    [anon_sym_image1d_buffer_t] = ACTIONS(992),
    [anon_sym_image1d_array_t] = ACTIONS(992),
    [anon_sym_image2d_depth_t] = ACTIONS(992),
    [anon_sym_image2d_array_depth_t] = ACTIONS(992),
    [anon_sym_sampler_t] = ACTIONS(992),
    [anon_sym_queue_t] = ACTIONS(992),
    [anon_sym_ndrange_t] = ACTIONS(992),
    [anon_sym_clk_event_t] = ACTIONS(992),
    [anon_sym_reserve_id_t] = ACTIONS(992),
    [anon_sym_event_t] = ACTIONS(992),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_switch] = ACTIONS(992),
    [anon_sym_case] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_goto] = ACTIONS(992),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_sizeof] = ACTIONS(992),
    [sym_number_literal] = ACTIONS(994),
    [anon_sym_L_SQUOTE] = ACTIONS(994),
    [anon_sym_u_SQUOTE] = ACTIONS(994),
    [anon_sym_U_SQUOTE] = ACTIONS(994),
    [anon_sym_u8_SQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [anon_sym_L_DQUOTE] = ACTIONS(994),
    [anon_sym_u_DQUOTE] = ACTIONS(994),
    [anon_sym_U_DQUOTE] = ACTIONS(994),
    [anon_sym_u8_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_null] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_identifier] = ACTIONS(934),
    [aux_sym_preproc_include_token1] = ACTIONS(934),
    [aux_sym_preproc_def_token1] = ACTIONS(934),
    [aux_sym_preproc_if_token1] = ACTIONS(934),
    [aux_sym_preproc_if_token2] = ACTIONS(934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(934),
    [sym_preproc_directive] = ACTIONS(934),
    [anon_sym_LPAREN2] = ACTIONS(936),
    [anon_sym_BANG] = ACTIONS(936),
    [anon_sym_TILDE] = ACTIONS(936),
    [anon_sym_DASH] = ACTIONS(934),
    [anon_sym_PLUS] = ACTIONS(934),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_AMP] = ACTIONS(936),
    [anon_sym_SEMI] = ACTIONS(936),
    [anon_sym_typedef] = ACTIONS(934),
    [anon_sym_kernel] = ACTIONS(934),
    [anon_sym___kernel] = ACTIONS(934),
    [anon_sym_global] = ACTIONS(934),
    [anon_sym___global] = ACTIONS(934),
    [anon_sym_local] = ACTIONS(934),
    [anon_sym___local] = ACTIONS(934),
    [anon_sym_constant] = ACTIONS(934),
    [anon_sym___constant] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym___private] = ACTIONS(934),
    [anon_sym_generic] = ACTIONS(934),
    [anon_sym___generic] = ACTIONS(934),
    [anon_sym_read_only] = ACTIONS(934),
    [anon_sym___read_only] = ACTIONS(934),
    [anon_sym_write_only] = ACTIONS(934),
    [anon_sym___write_only] = ACTIONS(934),
    [anon_sym_read_write] = ACTIONS(934),
    [anon_sym___read_write] = ACTIONS(934),
    [anon_sym_extern] = ACTIONS(934),
    [anon_sym___attribute__] = ACTIONS(934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(936),
    [anon_sym___declspec] = ACTIONS(934),
    [anon_sym___cdecl] = ACTIONS(934),
    [anon_sym___clrcall] = ACTIONS(934),
    [anon_sym___stdcall] = ACTIONS(934),
    [anon_sym___fastcall] = ACTIONS(934),
    [anon_sym___thiscall] = ACTIONS(934),
    [anon_sym___vectorcall] = ACTIONS(934),
    [anon_sym_LBRACE] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_auto] = ACTIONS(934),
    [anon_sym_register] = ACTIONS(934),
    [anon_sym_inline] = ACTIONS(934),
    [anon_sym_const] = ACTIONS(934),
    [anon_sym_volatile] = ACTIONS(934),
    [anon_sym_restrict] = ACTIONS(934),
    [anon_sym__Atomic] = ACTIONS(934),
    [anon_sym_pipe] = ACTIONS(934),
    [anon_sym_signed] = ACTIONS(934),
    [anon_sym_unsigned] = ACTIONS(934),
    [anon_sym_long] = ACTIONS(934),
    [anon_sym_short] = ACTIONS(934),
    [anon_sym_bool] = ACTIONS(934),
    [anon_sym_char] = ACTIONS(934),
    [anon_sym_uchar] = ACTIONS(934),
    [anon_sym_ushort] = ACTIONS(934),
    [anon_sym_int] = ACTIONS(934),
    [anon_sym_uint] = ACTIONS(934),
    [anon_sym_ulong] = ACTIONS(934),
    [anon_sym_float] = ACTIONS(934),
    [anon_sym_double] = ACTIONS(934),
    [anon_sym_half] = ACTIONS(934),
    [anon_sym_size_t] = ACTIONS(934),
    [anon_sym_ptrdiff_t] = ACTIONS(934),
    [anon_sym_intptr_t] = ACTIONS(934),
    [anon_sym_uintptr_t] = ACTIONS(934),
    [anon_sym_void] = ACTIONS(934),
    [sym_vector_type] = ACTIONS(934),
    [anon_sym_image2d_t] = ACTIONS(934),
    [anon_sym_image3d_t] = ACTIONS(934),
    [anon_sym_image2d_array_t] = ACTIONS(934),
    [anon_sym_image1d_t] = ACTIONS(934),
    [anon_sym_image1d_buffer_t] = ACTIONS(934),
    [anon_sym_image1d_array_t] = ACTIONS(934),
    [anon_sym_image2d_depth_t] = ACTIONS(934),
    [anon_sym_image2d_array_depth_t] = ACTIONS(934),
    [anon_sym_sampler_t] = ACTIONS(934),
    [anon_sym_queue_t] = ACTIONS(934),
    [anon_sym_ndrange_t] = ACTIONS(934),
    [anon_sym_clk_event_t] = ACTIONS(934),
    [anon_sym_reserve_id_t] = ACTIONS(934),
    [anon_sym_event_t] = ACTIONS(934),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(934),
    [anon_sym_enum] = ACTIONS(934),
    [anon_sym_struct] = ACTIONS(934),
    [anon_sym_union] = ACTIONS(934),
    [anon_sym_if] = ACTIONS(934),
    [anon_sym_else] = ACTIONS(934),
    [anon_sym_switch] = ACTIONS(934),
    [anon_sym_case] = ACTIONS(934),
    [anon_sym_default] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(934),
    [anon_sym_do] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(934),
    [anon_sym_return] = ACTIONS(934),
    [anon_sym_break] = ACTIONS(934),
    [anon_sym_continue] = ACTIONS(934),
    [anon_sym_goto] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(936),
    [anon_sym_PLUS_PLUS] = ACTIONS(936),
    [anon_sym_sizeof] = ACTIONS(934),
    [sym_number_literal] = ACTIONS(936),
    [anon_sym_L_SQUOTE] = ACTIONS(936),
    [anon_sym_u_SQUOTE] = ACTIONS(936),
    [anon_sym_U_SQUOTE] = ACTIONS(936),
    [anon_sym_u8_SQUOTE] = ACTIONS(936),
    [anon_sym_SQUOTE] = ACTIONS(936),
    [anon_sym_L_DQUOTE] = ACTIONS(936),
    [anon_sym_u_DQUOTE] = ACTIONS(936),
    [anon_sym_U_DQUOTE] = ACTIONS(936),
    [anon_sym_u8_DQUOTE] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(936),
    [sym_true] = ACTIONS(934),
    [sym_false] = ACTIONS(934),
    [sym_null] = ACTIONS(934),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(948),
    [sym_identifier] = ACTIONS(946),
    [aux_sym_preproc_include_token1] = ACTIONS(946),
    [aux_sym_preproc_def_token1] = ACTIONS(946),
    [aux_sym_preproc_if_token1] = ACTIONS(946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(946),
    [sym_preproc_directive] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(948),
    [anon_sym_AMP] = ACTIONS(948),
    [anon_sym_SEMI] = ACTIONS(948),
    [anon_sym_typedef] = ACTIONS(946),
    [anon_sym_kernel] = ACTIONS(946),
    [anon_sym___kernel] = ACTIONS(946),
    [anon_sym_global] = ACTIONS(946),
    [anon_sym___global] = ACTIONS(946),
    [anon_sym_local] = ACTIONS(946),
    [anon_sym___local] = ACTIONS(946),
    [anon_sym_constant] = ACTIONS(946),
    [anon_sym___constant] = ACTIONS(946),
    [anon_sym_private] = ACTIONS(946),
    [anon_sym___private] = ACTIONS(946),
    [anon_sym_generic] = ACTIONS(946),
    [anon_sym___generic] = ACTIONS(946),
    [anon_sym_read_only] = ACTIONS(946),
    [anon_sym___read_only] = ACTIONS(946),
    [anon_sym_write_only] = ACTIONS(946),
    [anon_sym___write_only] = ACTIONS(946),
    [anon_sym_read_write] = ACTIONS(946),
    [anon_sym___read_write] = ACTIONS(946),
    [anon_sym_extern] = ACTIONS(946),
    [anon_sym___attribute__] = ACTIONS(946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(948),
    [anon_sym___declspec] = ACTIONS(946),
    [anon_sym___cdecl] = ACTIONS(946),
    [anon_sym___clrcall] = ACTIONS(946),
    [anon_sym___stdcall] = ACTIONS(946),
    [anon_sym___fastcall] = ACTIONS(946),
    [anon_sym___thiscall] = ACTIONS(946),
    [anon_sym___vectorcall] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_auto] = ACTIONS(946),
    [anon_sym_register] = ACTIONS(946),
    [anon_sym_inline] = ACTIONS(946),
    [anon_sym_const] = ACTIONS(946),
    [anon_sym_volatile] = ACTIONS(946),
    [anon_sym_restrict] = ACTIONS(946),
    [anon_sym__Atomic] = ACTIONS(946),
    [anon_sym_pipe] = ACTIONS(946),
    [anon_sym_signed] = ACTIONS(946),
    [anon_sym_unsigned] = ACTIONS(946),
    [anon_sym_long] = ACTIONS(946),
    [anon_sym_short] = ACTIONS(946),
    [anon_sym_bool] = ACTIONS(946),
    [anon_sym_char] = ACTIONS(946),
    [anon_sym_uchar] = ACTIONS(946),
    [anon_sym_ushort] = ACTIONS(946),
    [anon_sym_int] = ACTIONS(946),
    [anon_sym_uint] = ACTIONS(946),
    [anon_sym_ulong] = ACTIONS(946),
    [anon_sym_float] = ACTIONS(946),
    [anon_sym_double] = ACTIONS(946),
    [anon_sym_half] = ACTIONS(946),
    [anon_sym_size_t] = ACTIONS(946),
    [anon_sym_ptrdiff_t] = ACTIONS(946),
    [anon_sym_intptr_t] = ACTIONS(946),
    [anon_sym_uintptr_t] = ACTIONS(946),
    [anon_sym_void] = ACTIONS(946),
    [sym_vector_type] = ACTIONS(946),
    [anon_sym_image2d_t] = ACTIONS(946),
    [anon_sym_image3d_t] = ACTIONS(946),
    [anon_sym_image2d_array_t] = ACTIONS(946),
    [anon_sym_image1d_t] = ACTIONS(946),
    [anon_sym_image1d_buffer_t] = ACTIONS(946),
    [anon_sym_image1d_array_t] = ACTIONS(946),
    [anon_sym_image2d_depth_t] = ACTIONS(946),
    [anon_sym_image2d_array_depth_t] = ACTIONS(946),
    [anon_sym_sampler_t] = ACTIONS(946),
    [anon_sym_queue_t] = ACTIONS(946),
    [anon_sym_ndrange_t] = ACTIONS(946),
    [anon_sym_clk_event_t] = ACTIONS(946),
    [anon_sym_reserve_id_t] = ACTIONS(946),
    [anon_sym_event_t] = ACTIONS(946),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_struct] = ACTIONS(946),
    [anon_sym_union] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(946),
    [anon_sym_default] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_break] = ACTIONS(946),
    [anon_sym_continue] = ACTIONS(946),
    [anon_sym_goto] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(948),
    [anon_sym_sizeof] = ACTIONS(946),
    [sym_number_literal] = ACTIONS(948),
    [anon_sym_L_SQUOTE] = ACTIONS(948),
    [anon_sym_u_SQUOTE] = ACTIONS(948),
    [anon_sym_U_SQUOTE] = ACTIONS(948),
    [anon_sym_u8_SQUOTE] = ACTIONS(948),
    [anon_sym_SQUOTE] = ACTIONS(948),
    [anon_sym_L_DQUOTE] = ACTIONS(948),
    [anon_sym_u_DQUOTE] = ACTIONS(948),
    [anon_sym_U_DQUOTE] = ACTIONS(948),
    [anon_sym_u8_DQUOTE] = ACTIONS(948),
    [anon_sym_DQUOTE] = ACTIONS(948),
    [sym_true] = ACTIONS(946),
    [sym_false] = ACTIONS(946),
    [sym_null] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_identifier] = ACTIONS(942),
    [aux_sym_preproc_include_token1] = ACTIONS(942),
    [aux_sym_preproc_def_token1] = ACTIONS(942),
    [aux_sym_preproc_if_token1] = ACTIONS(942),
    [aux_sym_preproc_if_token2] = ACTIONS(942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(942),
    [sym_preproc_directive] = ACTIONS(942),
    [anon_sym_LPAREN2] = ACTIONS(944),
    [anon_sym_BANG] = ACTIONS(944),
    [anon_sym_TILDE] = ACTIONS(944),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_STAR] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_typedef] = ACTIONS(942),
    [anon_sym_kernel] = ACTIONS(942),
    [anon_sym___kernel] = ACTIONS(942),
    [anon_sym_global] = ACTIONS(942),
    [anon_sym___global] = ACTIONS(942),
    [anon_sym_local] = ACTIONS(942),
    [anon_sym___local] = ACTIONS(942),
    [anon_sym_constant] = ACTIONS(942),
    [anon_sym___constant] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym___private] = ACTIONS(942),
    [anon_sym_generic] = ACTIONS(942),
    [anon_sym___generic] = ACTIONS(942),
    [anon_sym_read_only] = ACTIONS(942),
    [anon_sym___read_only] = ACTIONS(942),
    [anon_sym_write_only] = ACTIONS(942),
    [anon_sym___write_only] = ACTIONS(942),
    [anon_sym_read_write] = ACTIONS(942),
    [anon_sym___read_write] = ACTIONS(942),
    [anon_sym_extern] = ACTIONS(942),
    [anon_sym___attribute__] = ACTIONS(942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(944),
    [anon_sym___declspec] = ACTIONS(942),
    [anon_sym___cdecl] = ACTIONS(942),
    [anon_sym___clrcall] = ACTIONS(942),
    [anon_sym___stdcall] = ACTIONS(942),
    [anon_sym___fastcall] = ACTIONS(942),
    [anon_sym___thiscall] = ACTIONS(942),
    [anon_sym___vectorcall] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_auto] = ACTIONS(942),
    [anon_sym_register] = ACTIONS(942),
    [anon_sym_inline] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_volatile] = ACTIONS(942),
    [anon_sym_restrict] = ACTIONS(942),
    [anon_sym__Atomic] = ACTIONS(942),
    [anon_sym_pipe] = ACTIONS(942),
    [anon_sym_signed] = ACTIONS(942),
    [anon_sym_unsigned] = ACTIONS(942),
    [anon_sym_long] = ACTIONS(942),
    [anon_sym_short] = ACTIONS(942),
    [anon_sym_bool] = ACTIONS(942),
    [anon_sym_char] = ACTIONS(942),
    [anon_sym_uchar] = ACTIONS(942),
    [anon_sym_ushort] = ACTIONS(942),
    [anon_sym_int] = ACTIONS(942),
    [anon_sym_uint] = ACTIONS(942),
    [anon_sym_ulong] = ACTIONS(942),
    [anon_sym_float] = ACTIONS(942),
    [anon_sym_double] = ACTIONS(942),
    [anon_sym_half] = ACTIONS(942),
    [anon_sym_size_t] = ACTIONS(942),
    [anon_sym_ptrdiff_t] = ACTIONS(942),
    [anon_sym_intptr_t] = ACTIONS(942),
    [anon_sym_uintptr_t] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(942),
    [sym_vector_type] = ACTIONS(942),
    [anon_sym_image2d_t] = ACTIONS(942),
    [anon_sym_image3d_t] = ACTIONS(942),
    [anon_sym_image2d_array_t] = ACTIONS(942),
    [anon_sym_image1d_t] = ACTIONS(942),
    [anon_sym_image1d_buffer_t] = ACTIONS(942),
    [anon_sym_image1d_array_t] = ACTIONS(942),
    [anon_sym_image2d_depth_t] = ACTIONS(942),
    [anon_sym_image2d_array_depth_t] = ACTIONS(942),
    [anon_sym_sampler_t] = ACTIONS(942),
    [anon_sym_queue_t] = ACTIONS(942),
    [anon_sym_ndrange_t] = ACTIONS(942),
    [anon_sym_clk_event_t] = ACTIONS(942),
    [anon_sym_reserve_id_t] = ACTIONS(942),
    [anon_sym_event_t] = ACTIONS(942),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_struct] = ACTIONS(942),
    [anon_sym_union] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_else] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(942),
    [anon_sym_case] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_do] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_goto] = ACTIONS(942),
    [anon_sym_DASH_DASH] = ACTIONS(944),
    [anon_sym_PLUS_PLUS] = ACTIONS(944),
    [anon_sym_sizeof] = ACTIONS(942),
    [sym_number_literal] = ACTIONS(944),
    [anon_sym_L_SQUOTE] = ACTIONS(944),
    [anon_sym_u_SQUOTE] = ACTIONS(944),
    [anon_sym_U_SQUOTE] = ACTIONS(944),
    [anon_sym_u8_SQUOTE] = ACTIONS(944),
    [anon_sym_SQUOTE] = ACTIONS(944),
    [anon_sym_L_DQUOTE] = ACTIONS(944),
    [anon_sym_u_DQUOTE] = ACTIONS(944),
    [anon_sym_U_DQUOTE] = ACTIONS(944),
    [anon_sym_u8_DQUOTE] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(944),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_null] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(1038),
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_kernel] = ACTIONS(1036),
    [anon_sym___kernel] = ACTIONS(1036),
    [anon_sym_global] = ACTIONS(1036),
    [anon_sym___global] = ACTIONS(1036),
    [anon_sym_local] = ACTIONS(1036),
    [anon_sym___local] = ACTIONS(1036),
    [anon_sym_constant] = ACTIONS(1036),
    [anon_sym___constant] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym___private] = ACTIONS(1036),
    [anon_sym_generic] = ACTIONS(1036),
    [anon_sym___generic] = ACTIONS(1036),
    [anon_sym_read_only] = ACTIONS(1036),
    [anon_sym___read_only] = ACTIONS(1036),
    [anon_sym_write_only] = ACTIONS(1036),
    [anon_sym___write_only] = ACTIONS(1036),
    [anon_sym_read_write] = ACTIONS(1036),
    [anon_sym___read_write] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1038),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_pipe] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_bool] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_uchar] = ACTIONS(1036),
    [anon_sym_ushort] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_uint] = ACTIONS(1036),
    [anon_sym_ulong] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [anon_sym_half] = ACTIONS(1036),
    [anon_sym_size_t] = ACTIONS(1036),
    [anon_sym_ptrdiff_t] = ACTIONS(1036),
    [anon_sym_intptr_t] = ACTIONS(1036),
    [anon_sym_uintptr_t] = ACTIONS(1036),
    [anon_sym_void] = ACTIONS(1036),
    [sym_vector_type] = ACTIONS(1036),
    [anon_sym_image2d_t] = ACTIONS(1036),
    [anon_sym_image3d_t] = ACTIONS(1036),
    [anon_sym_image2d_array_t] = ACTIONS(1036),
    [anon_sym_image1d_t] = ACTIONS(1036),
    [anon_sym_image1d_buffer_t] = ACTIONS(1036),
    [anon_sym_image1d_array_t] = ACTIONS(1036),
    [anon_sym_image2d_depth_t] = ACTIONS(1036),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1036),
    [anon_sym_sampler_t] = ACTIONS(1036),
    [anon_sym_queue_t] = ACTIONS(1036),
    [anon_sym_ndrange_t] = ACTIONS(1036),
    [anon_sym_clk_event_t] = ACTIONS(1036),
    [anon_sym_reserve_id_t] = ACTIONS(1036),
    [anon_sym_event_t] = ACTIONS(1036),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(912),
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_kernel] = ACTIONS(910),
    [anon_sym___kernel] = ACTIONS(910),
    [anon_sym_global] = ACTIONS(910),
    [anon_sym___global] = ACTIONS(910),
    [anon_sym_local] = ACTIONS(910),
    [anon_sym___local] = ACTIONS(910),
    [anon_sym_constant] = ACTIONS(910),
    [anon_sym___constant] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym___private] = ACTIONS(910),
    [anon_sym_generic] = ACTIONS(910),
    [anon_sym___generic] = ACTIONS(910),
    [anon_sym_read_only] = ACTIONS(910),
    [anon_sym___read_only] = ACTIONS(910),
    [anon_sym_write_only] = ACTIONS(910),
    [anon_sym___write_only] = ACTIONS(910),
    [anon_sym_read_write] = ACTIONS(910),
    [anon_sym___read_write] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(912),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_pipe] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [anon_sym_bool] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_uchar] = ACTIONS(910),
    [anon_sym_ushort] = ACTIONS(910),
    [anon_sym_int] = ACTIONS(910),
    [anon_sym_uint] = ACTIONS(910),
    [anon_sym_ulong] = ACTIONS(910),
    [anon_sym_float] = ACTIONS(910),
    [anon_sym_double] = ACTIONS(910),
    [anon_sym_half] = ACTIONS(910),
    [anon_sym_size_t] = ACTIONS(910),
    [anon_sym_ptrdiff_t] = ACTIONS(910),
    [anon_sym_intptr_t] = ACTIONS(910),
    [anon_sym_uintptr_t] = ACTIONS(910),
    [anon_sym_void] = ACTIONS(910),
    [sym_vector_type] = ACTIONS(910),
    [anon_sym_image2d_t] = ACTIONS(910),
    [anon_sym_image3d_t] = ACTIONS(910),
    [anon_sym_image2d_array_t] = ACTIONS(910),
    [anon_sym_image1d_t] = ACTIONS(910),
    [anon_sym_image1d_buffer_t] = ACTIONS(910),
    [anon_sym_image1d_array_t] = ACTIONS(910),
    [anon_sym_image2d_depth_t] = ACTIONS(910),
    [anon_sym_image2d_array_depth_t] = ACTIONS(910),
    [anon_sym_sampler_t] = ACTIONS(910),
    [anon_sym_queue_t] = ACTIONS(910),
    [anon_sym_ndrange_t] = ACTIONS(910),
    [anon_sym_clk_event_t] = ACTIONS(910),
    [anon_sym_reserve_id_t] = ACTIONS(910),
    [anon_sym_event_t] = ACTIONS(910),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_identifier] = ACTIONS(962),
    [aux_sym_preproc_include_token1] = ACTIONS(962),
    [aux_sym_preproc_def_token1] = ACTIONS(962),
    [aux_sym_preproc_if_token1] = ACTIONS(962),
    [aux_sym_preproc_if_token2] = ACTIONS(962),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(962),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(962),
    [sym_preproc_directive] = ACTIONS(962),
    [anon_sym_LPAREN2] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(962),
    [anon_sym_PLUS] = ACTIONS(962),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_AMP] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(964),
    [anon_sym_typedef] = ACTIONS(962),
    [anon_sym_kernel] = ACTIONS(962),
    [anon_sym___kernel] = ACTIONS(962),
    [anon_sym_global] = ACTIONS(962),
    [anon_sym___global] = ACTIONS(962),
    [anon_sym_local] = ACTIONS(962),
    [anon_sym___local] = ACTIONS(962),
    [anon_sym_constant] = ACTIONS(962),
    [anon_sym___constant] = ACTIONS(962),
    [anon_sym_private] = ACTIONS(962),
    [anon_sym___private] = ACTIONS(962),
    [anon_sym_generic] = ACTIONS(962),
    [anon_sym___generic] = ACTIONS(962),
    [anon_sym_read_only] = ACTIONS(962),
    [anon_sym___read_only] = ACTIONS(962),
    [anon_sym_write_only] = ACTIONS(962),
    [anon_sym___write_only] = ACTIONS(962),
    [anon_sym_read_write] = ACTIONS(962),
    [anon_sym___read_write] = ACTIONS(962),
    [anon_sym_extern] = ACTIONS(962),
    [anon_sym___attribute__] = ACTIONS(962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(964),
    [anon_sym___declspec] = ACTIONS(962),
    [anon_sym___cdecl] = ACTIONS(962),
    [anon_sym___clrcall] = ACTIONS(962),
    [anon_sym___stdcall] = ACTIONS(962),
    [anon_sym___fastcall] = ACTIONS(962),
    [anon_sym___thiscall] = ACTIONS(962),
    [anon_sym___vectorcall] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_static] = ACTIONS(962),
    [anon_sym_auto] = ACTIONS(962),
    [anon_sym_register] = ACTIONS(962),
    [anon_sym_inline] = ACTIONS(962),
    [anon_sym_const] = ACTIONS(962),
    [anon_sym_volatile] = ACTIONS(962),
    [anon_sym_restrict] = ACTIONS(962),
    [anon_sym__Atomic] = ACTIONS(962),
    [anon_sym_pipe] = ACTIONS(962),
    [anon_sym_signed] = ACTIONS(962),
    [anon_sym_unsigned] = ACTIONS(962),
    [anon_sym_long] = ACTIONS(962),
    [anon_sym_short] = ACTIONS(962),
    [anon_sym_bool] = ACTIONS(962),
    [anon_sym_char] = ACTIONS(962),
    [anon_sym_uchar] = ACTIONS(962),
    [anon_sym_ushort] = ACTIONS(962),
    [anon_sym_int] = ACTIONS(962),
    [anon_sym_uint] = ACTIONS(962),
    [anon_sym_ulong] = ACTIONS(962),
    [anon_sym_float] = ACTIONS(962),
    [anon_sym_double] = ACTIONS(962),
    [anon_sym_half] = ACTIONS(962),
    [anon_sym_size_t] = ACTIONS(962),
    [anon_sym_ptrdiff_t] = ACTIONS(962),
    [anon_sym_intptr_t] = ACTIONS(962),
    [anon_sym_uintptr_t] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(962),
    [sym_vector_type] = ACTIONS(962),
    [anon_sym_image2d_t] = ACTIONS(962),
    [anon_sym_image3d_t] = ACTIONS(962),
    [anon_sym_image2d_array_t] = ACTIONS(962),
    [anon_sym_image1d_t] = ACTIONS(962),
    [anon_sym_image1d_buffer_t] = ACTIONS(962),
    [anon_sym_image1d_array_t] = ACTIONS(962),
    [anon_sym_image2d_depth_t] = ACTIONS(962),
    [anon_sym_image2d_array_depth_t] = ACTIONS(962),
    [anon_sym_sampler_t] = ACTIONS(962),
    [anon_sym_queue_t] = ACTIONS(962),
    [anon_sym_ndrange_t] = ACTIONS(962),
    [anon_sym_clk_event_t] = ACTIONS(962),
    [anon_sym_reserve_id_t] = ACTIONS(962),
    [anon_sym_event_t] = ACTIONS(962),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(962),
    [anon_sym_enum] = ACTIONS(962),
    [anon_sym_struct] = ACTIONS(962),
    [anon_sym_union] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(962),
    [anon_sym_switch] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(962),
    [anon_sym_default] = ACTIONS(962),
    [anon_sym_while] = ACTIONS(962),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_for] = ACTIONS(962),
    [anon_sym_return] = ACTIONS(962),
    [anon_sym_break] = ACTIONS(962),
    [anon_sym_continue] = ACTIONS(962),
    [anon_sym_goto] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(964),
    [anon_sym_sizeof] = ACTIONS(962),
    [sym_number_literal] = ACTIONS(964),
    [anon_sym_L_SQUOTE] = ACTIONS(964),
    [anon_sym_u_SQUOTE] = ACTIONS(964),
    [anon_sym_U_SQUOTE] = ACTIONS(964),
    [anon_sym_u8_SQUOTE] = ACTIONS(964),
    [anon_sym_SQUOTE] = ACTIONS(964),
    [anon_sym_L_DQUOTE] = ACTIONS(964),
    [anon_sym_u_DQUOTE] = ACTIONS(964),
    [anon_sym_U_DQUOTE] = ACTIONS(964),
    [anon_sym_u8_DQUOTE] = ACTIONS(964),
    [anon_sym_DQUOTE] = ACTIONS(964),
    [sym_true] = ACTIONS(962),
    [sym_false] = ACTIONS(962),
    [sym_null] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [sym_identifier] = ACTIONS(966),
    [aux_sym_preproc_include_token1] = ACTIONS(966),
    [aux_sym_preproc_def_token1] = ACTIONS(966),
    [aux_sym_preproc_if_token1] = ACTIONS(966),
    [aux_sym_preproc_if_token2] = ACTIONS(966),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(966),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(966),
    [sym_preproc_directive] = ACTIONS(966),
    [anon_sym_LPAREN2] = ACTIONS(968),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_DASH] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(966),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_AMP] = ACTIONS(968),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_typedef] = ACTIONS(966),
    [anon_sym_kernel] = ACTIONS(966),
    [anon_sym___kernel] = ACTIONS(966),
    [anon_sym_global] = ACTIONS(966),
    [anon_sym___global] = ACTIONS(966),
    [anon_sym_local] = ACTIONS(966),
    [anon_sym___local] = ACTIONS(966),
    [anon_sym_constant] = ACTIONS(966),
    [anon_sym___constant] = ACTIONS(966),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym___private] = ACTIONS(966),
    [anon_sym_generic] = ACTIONS(966),
    [anon_sym___generic] = ACTIONS(966),
    [anon_sym_read_only] = ACTIONS(966),
    [anon_sym___read_only] = ACTIONS(966),
    [anon_sym_write_only] = ACTIONS(966),
    [anon_sym___write_only] = ACTIONS(966),
    [anon_sym_read_write] = ACTIONS(966),
    [anon_sym___read_write] = ACTIONS(966),
    [anon_sym_extern] = ACTIONS(966),
    [anon_sym___attribute__] = ACTIONS(966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(968),
    [anon_sym___declspec] = ACTIONS(966),
    [anon_sym___cdecl] = ACTIONS(966),
    [anon_sym___clrcall] = ACTIONS(966),
    [anon_sym___stdcall] = ACTIONS(966),
    [anon_sym___fastcall] = ACTIONS(966),
    [anon_sym___thiscall] = ACTIONS(966),
    [anon_sym___vectorcall] = ACTIONS(966),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(966),
    [anon_sym_auto] = ACTIONS(966),
    [anon_sym_register] = ACTIONS(966),
    [anon_sym_inline] = ACTIONS(966),
    [anon_sym_const] = ACTIONS(966),
    [anon_sym_volatile] = ACTIONS(966),
    [anon_sym_restrict] = ACTIONS(966),
    [anon_sym__Atomic] = ACTIONS(966),
    [anon_sym_pipe] = ACTIONS(966),
    [anon_sym_signed] = ACTIONS(966),
    [anon_sym_unsigned] = ACTIONS(966),
    [anon_sym_long] = ACTIONS(966),
    [anon_sym_short] = ACTIONS(966),
    [anon_sym_bool] = ACTIONS(966),
    [anon_sym_char] = ACTIONS(966),
    [anon_sym_uchar] = ACTIONS(966),
    [anon_sym_ushort] = ACTIONS(966),
    [anon_sym_int] = ACTIONS(966),
    [anon_sym_uint] = ACTIONS(966),
    [anon_sym_ulong] = ACTIONS(966),
    [anon_sym_float] = ACTIONS(966),
    [anon_sym_double] = ACTIONS(966),
    [anon_sym_half] = ACTIONS(966),
    [anon_sym_size_t] = ACTIONS(966),
    [anon_sym_ptrdiff_t] = ACTIONS(966),
    [anon_sym_intptr_t] = ACTIONS(966),
    [anon_sym_uintptr_t] = ACTIONS(966),
    [anon_sym_void] = ACTIONS(966),
    [sym_vector_type] = ACTIONS(966),
    [anon_sym_image2d_t] = ACTIONS(966),
    [anon_sym_image3d_t] = ACTIONS(966),
    [anon_sym_image2d_array_t] = ACTIONS(966),
    [anon_sym_image1d_t] = ACTIONS(966),
    [anon_sym_image1d_buffer_t] = ACTIONS(966),
    [anon_sym_image1d_array_t] = ACTIONS(966),
    [anon_sym_image2d_depth_t] = ACTIONS(966),
    [anon_sym_image2d_array_depth_t] = ACTIONS(966),
    [anon_sym_sampler_t] = ACTIONS(966),
    [anon_sym_queue_t] = ACTIONS(966),
    [anon_sym_ndrange_t] = ACTIONS(966),
    [anon_sym_clk_event_t] = ACTIONS(966),
    [anon_sym_reserve_id_t] = ACTIONS(966),
    [anon_sym_event_t] = ACTIONS(966),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(966),
    [anon_sym_enum] = ACTIONS(966),
    [anon_sym_struct] = ACTIONS(966),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_else] = ACTIONS(1134),
    [anon_sym_switch] = ACTIONS(966),
    [anon_sym_case] = ACTIONS(966),
    [anon_sym_default] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_do] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_goto] = ACTIONS(966),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_sizeof] = ACTIONS(966),
    [sym_number_literal] = ACTIONS(968),
    [anon_sym_L_SQUOTE] = ACTIONS(968),
    [anon_sym_u_SQUOTE] = ACTIONS(968),
    [anon_sym_U_SQUOTE] = ACTIONS(968),
    [anon_sym_u8_SQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [anon_sym_L_DQUOTE] = ACTIONS(968),
    [anon_sym_u_DQUOTE] = ACTIONS(968),
    [anon_sym_U_DQUOTE] = ACTIONS(968),
    [anon_sym_u8_DQUOTE] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_null] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(944),
    [sym_identifier] = ACTIONS(942),
    [aux_sym_preproc_include_token1] = ACTIONS(942),
    [aux_sym_preproc_def_token1] = ACTIONS(942),
    [aux_sym_preproc_if_token1] = ACTIONS(942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(942),
    [sym_preproc_directive] = ACTIONS(942),
    [anon_sym_LPAREN2] = ACTIONS(944),
    [anon_sym_BANG] = ACTIONS(944),
    [anon_sym_TILDE] = ACTIONS(944),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_STAR] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_typedef] = ACTIONS(942),
    [anon_sym_kernel] = ACTIONS(942),
    [anon_sym___kernel] = ACTIONS(942),
    [anon_sym_global] = ACTIONS(942),
    [anon_sym___global] = ACTIONS(942),
    [anon_sym_local] = ACTIONS(942),
    [anon_sym___local] = ACTIONS(942),
    [anon_sym_constant] = ACTIONS(942),
    [anon_sym___constant] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym___private] = ACTIONS(942),
    [anon_sym_generic] = ACTIONS(942),
    [anon_sym___generic] = ACTIONS(942),
    [anon_sym_read_only] = ACTIONS(942),
    [anon_sym___read_only] = ACTIONS(942),
    [anon_sym_write_only] = ACTIONS(942),
    [anon_sym___write_only] = ACTIONS(942),
    [anon_sym_read_write] = ACTIONS(942),
    [anon_sym___read_write] = ACTIONS(942),
    [anon_sym_extern] = ACTIONS(942),
    [anon_sym___attribute__] = ACTIONS(942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(944),
    [anon_sym___declspec] = ACTIONS(942),
    [anon_sym___cdecl] = ACTIONS(942),
    [anon_sym___clrcall] = ACTIONS(942),
    [anon_sym___stdcall] = ACTIONS(942),
    [anon_sym___fastcall] = ACTIONS(942),
    [anon_sym___thiscall] = ACTIONS(942),
    [anon_sym___vectorcall] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_auto] = ACTIONS(942),
    [anon_sym_register] = ACTIONS(942),
    [anon_sym_inline] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_volatile] = ACTIONS(942),
    [anon_sym_restrict] = ACTIONS(942),
    [anon_sym__Atomic] = ACTIONS(942),
    [anon_sym_pipe] = ACTIONS(942),
    [anon_sym_signed] = ACTIONS(942),
    [anon_sym_unsigned] = ACTIONS(942),
    [anon_sym_long] = ACTIONS(942),
    [anon_sym_short] = ACTIONS(942),
    [anon_sym_bool] = ACTIONS(942),
    [anon_sym_char] = ACTIONS(942),
    [anon_sym_uchar] = ACTIONS(942),
    [anon_sym_ushort] = ACTIONS(942),
    [anon_sym_int] = ACTIONS(942),
    [anon_sym_uint] = ACTIONS(942),
    [anon_sym_ulong] = ACTIONS(942),
    [anon_sym_float] = ACTIONS(942),
    [anon_sym_double] = ACTIONS(942),
    [anon_sym_half] = ACTIONS(942),
    [anon_sym_size_t] = ACTIONS(942),
    [anon_sym_ptrdiff_t] = ACTIONS(942),
    [anon_sym_intptr_t] = ACTIONS(942),
    [anon_sym_uintptr_t] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(942),
    [sym_vector_type] = ACTIONS(942),
    [anon_sym_image2d_t] = ACTIONS(942),
    [anon_sym_image3d_t] = ACTIONS(942),
    [anon_sym_image2d_array_t] = ACTIONS(942),
    [anon_sym_image1d_t] = ACTIONS(942),
    [anon_sym_image1d_buffer_t] = ACTIONS(942),
    [anon_sym_image1d_array_t] = ACTIONS(942),
    [anon_sym_image2d_depth_t] = ACTIONS(942),
    [anon_sym_image2d_array_depth_t] = ACTIONS(942),
    [anon_sym_sampler_t] = ACTIONS(942),
    [anon_sym_queue_t] = ACTIONS(942),
    [anon_sym_ndrange_t] = ACTIONS(942),
    [anon_sym_clk_event_t] = ACTIONS(942),
    [anon_sym_reserve_id_t] = ACTIONS(942),
    [anon_sym_event_t] = ACTIONS(942),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_struct] = ACTIONS(942),
    [anon_sym_union] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_else] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(942),
    [anon_sym_case] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_do] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_goto] = ACTIONS(942),
    [anon_sym_DASH_DASH] = ACTIONS(944),
    [anon_sym_PLUS_PLUS] = ACTIONS(944),
    [anon_sym_sizeof] = ACTIONS(942),
    [sym_number_literal] = ACTIONS(944),
    [anon_sym_L_SQUOTE] = ACTIONS(944),
    [anon_sym_u_SQUOTE] = ACTIONS(944),
    [anon_sym_U_SQUOTE] = ACTIONS(944),
    [anon_sym_u8_SQUOTE] = ACTIONS(944),
    [anon_sym_SQUOTE] = ACTIONS(944),
    [anon_sym_L_DQUOTE] = ACTIONS(944),
    [anon_sym_u_DQUOTE] = ACTIONS(944),
    [anon_sym_U_DQUOTE] = ACTIONS(944),
    [anon_sym_u8_DQUOTE] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(944),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_null] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(1038),
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_kernel] = ACTIONS(1036),
    [anon_sym___kernel] = ACTIONS(1036),
    [anon_sym_global] = ACTIONS(1036),
    [anon_sym___global] = ACTIONS(1036),
    [anon_sym_local] = ACTIONS(1036),
    [anon_sym___local] = ACTIONS(1036),
    [anon_sym_constant] = ACTIONS(1036),
    [anon_sym___constant] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym___private] = ACTIONS(1036),
    [anon_sym_generic] = ACTIONS(1036),
    [anon_sym___generic] = ACTIONS(1036),
    [anon_sym_read_only] = ACTIONS(1036),
    [anon_sym___read_only] = ACTIONS(1036),
    [anon_sym_write_only] = ACTIONS(1036),
    [anon_sym___write_only] = ACTIONS(1036),
    [anon_sym_read_write] = ACTIONS(1036),
    [anon_sym___read_write] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1038),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_pipe] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_bool] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_uchar] = ACTIONS(1036),
    [anon_sym_ushort] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_uint] = ACTIONS(1036),
    [anon_sym_ulong] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [anon_sym_half] = ACTIONS(1036),
    [anon_sym_size_t] = ACTIONS(1036),
    [anon_sym_ptrdiff_t] = ACTIONS(1036),
    [anon_sym_intptr_t] = ACTIONS(1036),
    [anon_sym_uintptr_t] = ACTIONS(1036),
    [anon_sym_void] = ACTIONS(1036),
    [sym_vector_type] = ACTIONS(1036),
    [anon_sym_image2d_t] = ACTIONS(1036),
    [anon_sym_image3d_t] = ACTIONS(1036),
    [anon_sym_image2d_array_t] = ACTIONS(1036),
    [anon_sym_image1d_t] = ACTIONS(1036),
    [anon_sym_image1d_buffer_t] = ACTIONS(1036),
    [anon_sym_image1d_array_t] = ACTIONS(1036),
    [anon_sym_image2d_depth_t] = ACTIONS(1036),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1036),
    [anon_sym_sampler_t] = ACTIONS(1036),
    [anon_sym_queue_t] = ACTIONS(1036),
    [anon_sym_ndrange_t] = ACTIONS(1036),
    [anon_sym_clk_event_t] = ACTIONS(1036),
    [anon_sym_reserve_id_t] = ACTIONS(1036),
    [anon_sym_event_t] = ACTIONS(1036),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_identifier] = ACTIONS(972),
    [aux_sym_preproc_include_token1] = ACTIONS(972),
    [aux_sym_preproc_def_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token2] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(972),
    [sym_preproc_directive] = ACTIONS(972),
    [anon_sym_LPAREN2] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(972),
    [anon_sym_kernel] = ACTIONS(972),
    [anon_sym___kernel] = ACTIONS(972),
    [anon_sym_global] = ACTIONS(972),
    [anon_sym___global] = ACTIONS(972),
    [anon_sym_local] = ACTIONS(972),
    [anon_sym___local] = ACTIONS(972),
    [anon_sym_constant] = ACTIONS(972),
    [anon_sym___constant] = ACTIONS(972),
    [anon_sym_private] = ACTIONS(972),
    [anon_sym___private] = ACTIONS(972),
    [anon_sym_generic] = ACTIONS(972),
    [anon_sym___generic] = ACTIONS(972),
    [anon_sym_read_only] = ACTIONS(972),
    [anon_sym___read_only] = ACTIONS(972),
    [anon_sym_write_only] = ACTIONS(972),
    [anon_sym___write_only] = ACTIONS(972),
    [anon_sym_read_write] = ACTIONS(972),
    [anon_sym___read_write] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym___attribute__] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(974),
    [anon_sym___declspec] = ACTIONS(972),
    [anon_sym___cdecl] = ACTIONS(972),
    [anon_sym___clrcall] = ACTIONS(972),
    [anon_sym___stdcall] = ACTIONS(972),
    [anon_sym___fastcall] = ACTIONS(972),
    [anon_sym___thiscall] = ACTIONS(972),
    [anon_sym___vectorcall] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_auto] = ACTIONS(972),
    [anon_sym_register] = ACTIONS(972),
    [anon_sym_inline] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_volatile] = ACTIONS(972),
    [anon_sym_restrict] = ACTIONS(972),
    [anon_sym__Atomic] = ACTIONS(972),
    [anon_sym_pipe] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(972),
    [anon_sym_unsigned] = ACTIONS(972),
    [anon_sym_long] = ACTIONS(972),
    [anon_sym_short] = ACTIONS(972),
    [anon_sym_bool] = ACTIONS(972),
    [anon_sym_char] = ACTIONS(972),
    [anon_sym_uchar] = ACTIONS(972),
    [anon_sym_ushort] = ACTIONS(972),
    [anon_sym_int] = ACTIONS(972),
    [anon_sym_uint] = ACTIONS(972),
    [anon_sym_ulong] = ACTIONS(972),
    [anon_sym_float] = ACTIONS(972),
    [anon_sym_double] = ACTIONS(972),
    [anon_sym_half] = ACTIONS(972),
    [anon_sym_size_t] = ACTIONS(972),
    [anon_sym_ptrdiff_t] = ACTIONS(972),
    [anon_sym_intptr_t] = ACTIONS(972),
    [anon_sym_uintptr_t] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(972),
    [sym_vector_type] = ACTIONS(972),
    [anon_sym_image2d_t] = ACTIONS(972),
    [anon_sym_image3d_t] = ACTIONS(972),
    [anon_sym_image2d_array_t] = ACTIONS(972),
    [anon_sym_image1d_t] = ACTIONS(972),
    [anon_sym_image1d_buffer_t] = ACTIONS(972),
    [anon_sym_image1d_array_t] = ACTIONS(972),
    [anon_sym_image2d_depth_t] = ACTIONS(972),
    [anon_sym_image2d_array_depth_t] = ACTIONS(972),
    [anon_sym_sampler_t] = ACTIONS(972),
    [anon_sym_queue_t] = ACTIONS(972),
    [anon_sym_ndrange_t] = ACTIONS(972),
    [anon_sym_clk_event_t] = ACTIONS(972),
    [anon_sym_reserve_id_t] = ACTIONS(972),
    [anon_sym_event_t] = ACTIONS(972),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_goto] = ACTIONS(972),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_sizeof] = ACTIONS(972),
    [sym_number_literal] = ACTIONS(974),
    [anon_sym_L_SQUOTE] = ACTIONS(974),
    [anon_sym_u_SQUOTE] = ACTIONS(974),
    [anon_sym_U_SQUOTE] = ACTIONS(974),
    [anon_sym_u8_SQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [anon_sym_L_DQUOTE] = ACTIONS(974),
    [anon_sym_u_DQUOTE] = ACTIONS(974),
    [anon_sym_U_DQUOTE] = ACTIONS(974),
    [anon_sym_u8_DQUOTE] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_null] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(940),
    [sym_identifier] = ACTIONS(938),
    [aux_sym_preproc_include_token1] = ACTIONS(938),
    [aux_sym_preproc_def_token1] = ACTIONS(938),
    [aux_sym_preproc_if_token1] = ACTIONS(938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(938),
    [sym_preproc_directive] = ACTIONS(938),
    [anon_sym_LPAREN2] = ACTIONS(940),
    [anon_sym_BANG] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_DASH] = ACTIONS(938),
    [anon_sym_PLUS] = ACTIONS(938),
    [anon_sym_STAR] = ACTIONS(940),
    [anon_sym_AMP] = ACTIONS(940),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_typedef] = ACTIONS(938),
    [anon_sym_kernel] = ACTIONS(938),
    [anon_sym___kernel] = ACTIONS(938),
    [anon_sym_global] = ACTIONS(938),
    [anon_sym___global] = ACTIONS(938),
    [anon_sym_local] = ACTIONS(938),
    [anon_sym___local] = ACTIONS(938),
    [anon_sym_constant] = ACTIONS(938),
    [anon_sym___constant] = ACTIONS(938),
    [anon_sym_private] = ACTIONS(938),
    [anon_sym___private] = ACTIONS(938),
    [anon_sym_generic] = ACTIONS(938),
    [anon_sym___generic] = ACTIONS(938),
    [anon_sym_read_only] = ACTIONS(938),
    [anon_sym___read_only] = ACTIONS(938),
    [anon_sym_write_only] = ACTIONS(938),
    [anon_sym___write_only] = ACTIONS(938),
    [anon_sym_read_write] = ACTIONS(938),
    [anon_sym___read_write] = ACTIONS(938),
    [anon_sym_extern] = ACTIONS(938),
    [anon_sym___attribute__] = ACTIONS(938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(940),
    [anon_sym___declspec] = ACTIONS(938),
    [anon_sym___cdecl] = ACTIONS(938),
    [anon_sym___clrcall] = ACTIONS(938),
    [anon_sym___stdcall] = ACTIONS(938),
    [anon_sym___fastcall] = ACTIONS(938),
    [anon_sym___thiscall] = ACTIONS(938),
    [anon_sym___vectorcall] = ACTIONS(938),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_static] = ACTIONS(938),
    [anon_sym_auto] = ACTIONS(938),
    [anon_sym_register] = ACTIONS(938),
    [anon_sym_inline] = ACTIONS(938),
    [anon_sym_const] = ACTIONS(938),
    [anon_sym_volatile] = ACTIONS(938),
    [anon_sym_restrict] = ACTIONS(938),
    [anon_sym__Atomic] = ACTIONS(938),
    [anon_sym_pipe] = ACTIONS(938),
    [anon_sym_signed] = ACTIONS(938),
    [anon_sym_unsigned] = ACTIONS(938),
    [anon_sym_long] = ACTIONS(938),
    [anon_sym_short] = ACTIONS(938),
    [anon_sym_bool] = ACTIONS(938),
    [anon_sym_char] = ACTIONS(938),
    [anon_sym_uchar] = ACTIONS(938),
    [anon_sym_ushort] = ACTIONS(938),
    [anon_sym_int] = ACTIONS(938),
    [anon_sym_uint] = ACTIONS(938),
    [anon_sym_ulong] = ACTIONS(938),
    [anon_sym_float] = ACTIONS(938),
    [anon_sym_double] = ACTIONS(938),
    [anon_sym_half] = ACTIONS(938),
    [anon_sym_size_t] = ACTIONS(938),
    [anon_sym_ptrdiff_t] = ACTIONS(938),
    [anon_sym_intptr_t] = ACTIONS(938),
    [anon_sym_uintptr_t] = ACTIONS(938),
    [anon_sym_void] = ACTIONS(938),
    [sym_vector_type] = ACTIONS(938),
    [anon_sym_image2d_t] = ACTIONS(938),
    [anon_sym_image3d_t] = ACTIONS(938),
    [anon_sym_image2d_array_t] = ACTIONS(938),
    [anon_sym_image1d_t] = ACTIONS(938),
    [anon_sym_image1d_buffer_t] = ACTIONS(938),
    [anon_sym_image1d_array_t] = ACTIONS(938),
    [anon_sym_image2d_depth_t] = ACTIONS(938),
    [anon_sym_image2d_array_depth_t] = ACTIONS(938),
    [anon_sym_sampler_t] = ACTIONS(938),
    [anon_sym_queue_t] = ACTIONS(938),
    [anon_sym_ndrange_t] = ACTIONS(938),
    [anon_sym_clk_event_t] = ACTIONS(938),
    [anon_sym_reserve_id_t] = ACTIONS(938),
    [anon_sym_event_t] = ACTIONS(938),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(938),
    [anon_sym_enum] = ACTIONS(938),
    [anon_sym_struct] = ACTIONS(938),
    [anon_sym_union] = ACTIONS(938),
    [anon_sym_if] = ACTIONS(938),
    [anon_sym_else] = ACTIONS(938),
    [anon_sym_switch] = ACTIONS(938),
    [anon_sym_case] = ACTIONS(938),
    [anon_sym_default] = ACTIONS(938),
    [anon_sym_while] = ACTIONS(938),
    [anon_sym_do] = ACTIONS(938),
    [anon_sym_for] = ACTIONS(938),
    [anon_sym_return] = ACTIONS(938),
    [anon_sym_break] = ACTIONS(938),
    [anon_sym_continue] = ACTIONS(938),
    [anon_sym_goto] = ACTIONS(938),
    [anon_sym_DASH_DASH] = ACTIONS(940),
    [anon_sym_PLUS_PLUS] = ACTIONS(940),
    [anon_sym_sizeof] = ACTIONS(938),
    [sym_number_literal] = ACTIONS(940),
    [anon_sym_L_SQUOTE] = ACTIONS(940),
    [anon_sym_u_SQUOTE] = ACTIONS(940),
    [anon_sym_U_SQUOTE] = ACTIONS(940),
    [anon_sym_u8_SQUOTE] = ACTIONS(940),
    [anon_sym_SQUOTE] = ACTIONS(940),
    [anon_sym_L_DQUOTE] = ACTIONS(940),
    [anon_sym_u_DQUOTE] = ACTIONS(940),
    [anon_sym_U_DQUOTE] = ACTIONS(940),
    [anon_sym_u8_DQUOTE] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(940),
    [sym_true] = ACTIONS(938),
    [sym_false] = ACTIONS(938),
    [sym_null] = ACTIONS(938),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(932),
    [sym_identifier] = ACTIONS(930),
    [aux_sym_preproc_include_token1] = ACTIONS(930),
    [aux_sym_preproc_def_token1] = ACTIONS(930),
    [aux_sym_preproc_if_token1] = ACTIONS(930),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(930),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(930),
    [sym_preproc_directive] = ACTIONS(930),
    [anon_sym_LPAREN2] = ACTIONS(932),
    [anon_sym_BANG] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_STAR] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_typedef] = ACTIONS(930),
    [anon_sym_kernel] = ACTIONS(930),
    [anon_sym___kernel] = ACTIONS(930),
    [anon_sym_global] = ACTIONS(930),
    [anon_sym___global] = ACTIONS(930),
    [anon_sym_local] = ACTIONS(930),
    [anon_sym___local] = ACTIONS(930),
    [anon_sym_constant] = ACTIONS(930),
    [anon_sym___constant] = ACTIONS(930),
    [anon_sym_private] = ACTIONS(930),
    [anon_sym___private] = ACTIONS(930),
    [anon_sym_generic] = ACTIONS(930),
    [anon_sym___generic] = ACTIONS(930),
    [anon_sym_read_only] = ACTIONS(930),
    [anon_sym___read_only] = ACTIONS(930),
    [anon_sym_write_only] = ACTIONS(930),
    [anon_sym___write_only] = ACTIONS(930),
    [anon_sym_read_write] = ACTIONS(930),
    [anon_sym___read_write] = ACTIONS(930),
    [anon_sym_extern] = ACTIONS(930),
    [anon_sym___attribute__] = ACTIONS(930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(932),
    [anon_sym___declspec] = ACTIONS(930),
    [anon_sym___cdecl] = ACTIONS(930),
    [anon_sym___clrcall] = ACTIONS(930),
    [anon_sym___stdcall] = ACTIONS(930),
    [anon_sym___fastcall] = ACTIONS(930),
    [anon_sym___thiscall] = ACTIONS(930),
    [anon_sym___vectorcall] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_static] = ACTIONS(930),
    [anon_sym_auto] = ACTIONS(930),
    [anon_sym_register] = ACTIONS(930),
    [anon_sym_inline] = ACTIONS(930),
    [anon_sym_const] = ACTIONS(930),
    [anon_sym_volatile] = ACTIONS(930),
    [anon_sym_restrict] = ACTIONS(930),
    [anon_sym__Atomic] = ACTIONS(930),
    [anon_sym_pipe] = ACTIONS(930),
    [anon_sym_signed] = ACTIONS(930),
    [anon_sym_unsigned] = ACTIONS(930),
    [anon_sym_long] = ACTIONS(930),
    [anon_sym_short] = ACTIONS(930),
    [anon_sym_bool] = ACTIONS(930),
    [anon_sym_char] = ACTIONS(930),
    [anon_sym_uchar] = ACTIONS(930),
    [anon_sym_ushort] = ACTIONS(930),
    [anon_sym_int] = ACTIONS(930),
    [anon_sym_uint] = ACTIONS(930),
    [anon_sym_ulong] = ACTIONS(930),
    [anon_sym_float] = ACTIONS(930),
    [anon_sym_double] = ACTIONS(930),
    [anon_sym_half] = ACTIONS(930),
    [anon_sym_size_t] = ACTIONS(930),
    [anon_sym_ptrdiff_t] = ACTIONS(930),
    [anon_sym_intptr_t] = ACTIONS(930),
    [anon_sym_uintptr_t] = ACTIONS(930),
    [anon_sym_void] = ACTIONS(930),
    [sym_vector_type] = ACTIONS(930),
    [anon_sym_image2d_t] = ACTIONS(930),
    [anon_sym_image3d_t] = ACTIONS(930),
    [anon_sym_image2d_array_t] = ACTIONS(930),
    [anon_sym_image1d_t] = ACTIONS(930),
    [anon_sym_image1d_buffer_t] = ACTIONS(930),
    [anon_sym_image1d_array_t] = ACTIONS(930),
    [anon_sym_image2d_depth_t] = ACTIONS(930),
    [anon_sym_image2d_array_depth_t] = ACTIONS(930),
    [anon_sym_sampler_t] = ACTIONS(930),
    [anon_sym_queue_t] = ACTIONS(930),
    [anon_sym_ndrange_t] = ACTIONS(930),
    [anon_sym_clk_event_t] = ACTIONS(930),
    [anon_sym_reserve_id_t] = ACTIONS(930),
    [anon_sym_event_t] = ACTIONS(930),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(930),
    [anon_sym_enum] = ACTIONS(930),
    [anon_sym_struct] = ACTIONS(930),
    [anon_sym_union] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_else] = ACTIONS(930),
    [anon_sym_switch] = ACTIONS(930),
    [anon_sym_case] = ACTIONS(930),
    [anon_sym_default] = ACTIONS(930),
    [anon_sym_while] = ACTIONS(930),
    [anon_sym_do] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(930),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_break] = ACTIONS(930),
    [anon_sym_continue] = ACTIONS(930),
    [anon_sym_goto] = ACTIONS(930),
    [anon_sym_DASH_DASH] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_sizeof] = ACTIONS(930),
    [sym_number_literal] = ACTIONS(932),
    [anon_sym_L_SQUOTE] = ACTIONS(932),
    [anon_sym_u_SQUOTE] = ACTIONS(932),
    [anon_sym_U_SQUOTE] = ACTIONS(932),
    [anon_sym_u8_SQUOTE] = ACTIONS(932),
    [anon_sym_SQUOTE] = ACTIONS(932),
    [anon_sym_L_DQUOTE] = ACTIONS(932),
    [anon_sym_u_DQUOTE] = ACTIONS(932),
    [anon_sym_U_DQUOTE] = ACTIONS(932),
    [anon_sym_u8_DQUOTE] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_true] = ACTIONS(930),
    [sym_false] = ACTIONS(930),
    [sym_null] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_identifier] = ACTIONS(996),
    [aux_sym_preproc_include_token1] = ACTIONS(996),
    [aux_sym_preproc_def_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token2] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(996),
    [sym_preproc_directive] = ACTIONS(996),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_typedef] = ACTIONS(996),
    [anon_sym_kernel] = ACTIONS(996),
    [anon_sym___kernel] = ACTIONS(996),
    [anon_sym_global] = ACTIONS(996),
    [anon_sym___global] = ACTIONS(996),
    [anon_sym_local] = ACTIONS(996),
    [anon_sym___local] = ACTIONS(996),
    [anon_sym_constant] = ACTIONS(996),
    [anon_sym___constant] = ACTIONS(996),
    [anon_sym_private] = ACTIONS(996),
    [anon_sym___private] = ACTIONS(996),
    [anon_sym_generic] = ACTIONS(996),
    [anon_sym___generic] = ACTIONS(996),
    [anon_sym_read_only] = ACTIONS(996),
    [anon_sym___read_only] = ACTIONS(996),
    [anon_sym_write_only] = ACTIONS(996),
    [anon_sym___write_only] = ACTIONS(996),
    [anon_sym_read_write] = ACTIONS(996),
    [anon_sym___read_write] = ACTIONS(996),
    [anon_sym_extern] = ACTIONS(996),
    [anon_sym___attribute__] = ACTIONS(996),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(998),
    [anon_sym___declspec] = ACTIONS(996),
    [anon_sym___cdecl] = ACTIONS(996),
    [anon_sym___clrcall] = ACTIONS(996),
    [anon_sym___stdcall] = ACTIONS(996),
    [anon_sym___fastcall] = ACTIONS(996),
    [anon_sym___thiscall] = ACTIONS(996),
    [anon_sym___vectorcall] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_auto] = ACTIONS(996),
    [anon_sym_register] = ACTIONS(996),
    [anon_sym_inline] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_volatile] = ACTIONS(996),
    [anon_sym_restrict] = ACTIONS(996),
    [anon_sym__Atomic] = ACTIONS(996),
    [anon_sym_pipe] = ACTIONS(996),
    [anon_sym_signed] = ACTIONS(996),
    [anon_sym_unsigned] = ACTIONS(996),
    [anon_sym_long] = ACTIONS(996),
    [anon_sym_short] = ACTIONS(996),
    [anon_sym_bool] = ACTIONS(996),
    [anon_sym_char] = ACTIONS(996),
    [anon_sym_uchar] = ACTIONS(996),
    [anon_sym_ushort] = ACTIONS(996),
    [anon_sym_int] = ACTIONS(996),
    [anon_sym_uint] = ACTIONS(996),
    [anon_sym_ulong] = ACTIONS(996),
    [anon_sym_float] = ACTIONS(996),
    [anon_sym_double] = ACTIONS(996),
    [anon_sym_half] = ACTIONS(996),
    [anon_sym_size_t] = ACTIONS(996),
    [anon_sym_ptrdiff_t] = ACTIONS(996),
    [anon_sym_intptr_t] = ACTIONS(996),
    [anon_sym_uintptr_t] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(996),
    [sym_vector_type] = ACTIONS(996),
    [anon_sym_image2d_t] = ACTIONS(996),
    [anon_sym_image3d_t] = ACTIONS(996),
    [anon_sym_image2d_array_t] = ACTIONS(996),
    [anon_sym_image1d_t] = ACTIONS(996),
    [anon_sym_image1d_buffer_t] = ACTIONS(996),
    [anon_sym_image1d_array_t] = ACTIONS(996),
    [anon_sym_image2d_depth_t] = ACTIONS(996),
    [anon_sym_image2d_array_depth_t] = ACTIONS(996),
    [anon_sym_sampler_t] = ACTIONS(996),
    [anon_sym_queue_t] = ACTIONS(996),
    [anon_sym_ndrange_t] = ACTIONS(996),
    [anon_sym_clk_event_t] = ACTIONS(996),
    [anon_sym_reserve_id_t] = ACTIONS(996),
    [anon_sym_event_t] = ACTIONS(996),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_struct] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_goto] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(996),
    [sym_number_literal] = ACTIONS(998),
    [anon_sym_L_SQUOTE] = ACTIONS(998),
    [anon_sym_u_SQUOTE] = ACTIONS(998),
    [anon_sym_U_SQUOTE] = ACTIONS(998),
    [anon_sym_u8_SQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_L_DQUOTE] = ACTIONS(998),
    [anon_sym_u_DQUOTE] = ACTIONS(998),
    [anon_sym_U_DQUOTE] = ACTIONS(998),
    [anon_sym_u8_DQUOTE] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1000),
    [aux_sym_preproc_include_token1] = ACTIONS(1000),
    [aux_sym_preproc_def_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token2] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1000),
    [sym_preproc_directive] = ACTIONS(1000),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_typedef] = ACTIONS(1000),
    [anon_sym_kernel] = ACTIONS(1000),
    [anon_sym___kernel] = ACTIONS(1000),
    [anon_sym_global] = ACTIONS(1000),
    [anon_sym___global] = ACTIONS(1000),
    [anon_sym_local] = ACTIONS(1000),
    [anon_sym___local] = ACTIONS(1000),
    [anon_sym_constant] = ACTIONS(1000),
    [anon_sym___constant] = ACTIONS(1000),
    [anon_sym_private] = ACTIONS(1000),
    [anon_sym___private] = ACTIONS(1000),
    [anon_sym_generic] = ACTIONS(1000),
    [anon_sym___generic] = ACTIONS(1000),
    [anon_sym_read_only] = ACTIONS(1000),
    [anon_sym___read_only] = ACTIONS(1000),
    [anon_sym_write_only] = ACTIONS(1000),
    [anon_sym___write_only] = ACTIONS(1000),
    [anon_sym_read_write] = ACTIONS(1000),
    [anon_sym___read_write] = ACTIONS(1000),
    [anon_sym_extern] = ACTIONS(1000),
    [anon_sym___attribute__] = ACTIONS(1000),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1002),
    [anon_sym___declspec] = ACTIONS(1000),
    [anon_sym___cdecl] = ACTIONS(1000),
    [anon_sym___clrcall] = ACTIONS(1000),
    [anon_sym___stdcall] = ACTIONS(1000),
    [anon_sym___fastcall] = ACTIONS(1000),
    [anon_sym___thiscall] = ACTIONS(1000),
    [anon_sym___vectorcall] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_auto] = ACTIONS(1000),
    [anon_sym_register] = ACTIONS(1000),
    [anon_sym_inline] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_volatile] = ACTIONS(1000),
    [anon_sym_restrict] = ACTIONS(1000),
    [anon_sym__Atomic] = ACTIONS(1000),
    [anon_sym_pipe] = ACTIONS(1000),
    [anon_sym_signed] = ACTIONS(1000),
    [anon_sym_unsigned] = ACTIONS(1000),
    [anon_sym_long] = ACTIONS(1000),
    [anon_sym_short] = ACTIONS(1000),
    [anon_sym_bool] = ACTIONS(1000),
    [anon_sym_char] = ACTIONS(1000),
    [anon_sym_uchar] = ACTIONS(1000),
    [anon_sym_ushort] = ACTIONS(1000),
    [anon_sym_int] = ACTIONS(1000),
    [anon_sym_uint] = ACTIONS(1000),
    [anon_sym_ulong] = ACTIONS(1000),
    [anon_sym_float] = ACTIONS(1000),
    [anon_sym_double] = ACTIONS(1000),
    [anon_sym_half] = ACTIONS(1000),
    [anon_sym_size_t] = ACTIONS(1000),
    [anon_sym_ptrdiff_t] = ACTIONS(1000),
    [anon_sym_intptr_t] = ACTIONS(1000),
    [anon_sym_uintptr_t] = ACTIONS(1000),
    [anon_sym_void] = ACTIONS(1000),
    [sym_vector_type] = ACTIONS(1000),
    [anon_sym_image2d_t] = ACTIONS(1000),
    [anon_sym_image3d_t] = ACTIONS(1000),
    [anon_sym_image2d_array_t] = ACTIONS(1000),
    [anon_sym_image1d_t] = ACTIONS(1000),
    [anon_sym_image1d_buffer_t] = ACTIONS(1000),
    [anon_sym_image1d_array_t] = ACTIONS(1000),
    [anon_sym_image2d_depth_t] = ACTIONS(1000),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1000),
    [anon_sym_sampler_t] = ACTIONS(1000),
    [anon_sym_queue_t] = ACTIONS(1000),
    [anon_sym_ndrange_t] = ACTIONS(1000),
    [anon_sym_clk_event_t] = ACTIONS(1000),
    [anon_sym_reserve_id_t] = ACTIONS(1000),
    [anon_sym_event_t] = ACTIONS(1000),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_struct] = ACTIONS(1000),
    [anon_sym_union] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_goto] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1002),
    [anon_sym_L_SQUOTE] = ACTIONS(1002),
    [anon_sym_u_SQUOTE] = ACTIONS(1002),
    [anon_sym_U_SQUOTE] = ACTIONS(1002),
    [anon_sym_u8_SQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_L_DQUOTE] = ACTIONS(1002),
    [anon_sym_u_DQUOTE] = ACTIONS(1002),
    [anon_sym_U_DQUOTE] = ACTIONS(1002),
    [anon_sym_u8_DQUOTE] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1004),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token2] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1006),
    [anon_sym_AMP] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [anon_sym_typedef] = ACTIONS(1004),
    [anon_sym_kernel] = ACTIONS(1004),
    [anon_sym___kernel] = ACTIONS(1004),
    [anon_sym_global] = ACTIONS(1004),
    [anon_sym___global] = ACTIONS(1004),
    [anon_sym_local] = ACTIONS(1004),
    [anon_sym___local] = ACTIONS(1004),
    [anon_sym_constant] = ACTIONS(1004),
    [anon_sym___constant] = ACTIONS(1004),
    [anon_sym_private] = ACTIONS(1004),
    [anon_sym___private] = ACTIONS(1004),
    [anon_sym_generic] = ACTIONS(1004),
    [anon_sym___generic] = ACTIONS(1004),
    [anon_sym_read_only] = ACTIONS(1004),
    [anon_sym___read_only] = ACTIONS(1004),
    [anon_sym_write_only] = ACTIONS(1004),
    [anon_sym___write_only] = ACTIONS(1004),
    [anon_sym_read_write] = ACTIONS(1004),
    [anon_sym___read_write] = ACTIONS(1004),
    [anon_sym_extern] = ACTIONS(1004),
    [anon_sym___attribute__] = ACTIONS(1004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1006),
    [anon_sym___declspec] = ACTIONS(1004),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_auto] = ACTIONS(1004),
    [anon_sym_register] = ACTIONS(1004),
    [anon_sym_inline] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_volatile] = ACTIONS(1004),
    [anon_sym_restrict] = ACTIONS(1004),
    [anon_sym__Atomic] = ACTIONS(1004),
    [anon_sym_pipe] = ACTIONS(1004),
    [anon_sym_signed] = ACTIONS(1004),
    [anon_sym_unsigned] = ACTIONS(1004),
    [anon_sym_long] = ACTIONS(1004),
    [anon_sym_short] = ACTIONS(1004),
    [anon_sym_bool] = ACTIONS(1004),
    [anon_sym_char] = ACTIONS(1004),
    [anon_sym_uchar] = ACTIONS(1004),
    [anon_sym_ushort] = ACTIONS(1004),
    [anon_sym_int] = ACTIONS(1004),
    [anon_sym_uint] = ACTIONS(1004),
    [anon_sym_ulong] = ACTIONS(1004),
    [anon_sym_float] = ACTIONS(1004),
    [anon_sym_double] = ACTIONS(1004),
    [anon_sym_half] = ACTIONS(1004),
    [anon_sym_size_t] = ACTIONS(1004),
    [anon_sym_ptrdiff_t] = ACTIONS(1004),
    [anon_sym_intptr_t] = ACTIONS(1004),
    [anon_sym_uintptr_t] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(1004),
    [sym_vector_type] = ACTIONS(1004),
    [anon_sym_image2d_t] = ACTIONS(1004),
    [anon_sym_image3d_t] = ACTIONS(1004),
    [anon_sym_image2d_array_t] = ACTIONS(1004),
    [anon_sym_image1d_t] = ACTIONS(1004),
    [anon_sym_image1d_buffer_t] = ACTIONS(1004),
    [anon_sym_image1d_array_t] = ACTIONS(1004),
    [anon_sym_image2d_depth_t] = ACTIONS(1004),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1004),
    [anon_sym_sampler_t] = ACTIONS(1004),
    [anon_sym_queue_t] = ACTIONS(1004),
    [anon_sym_ndrange_t] = ACTIONS(1004),
    [anon_sym_clk_event_t] = ACTIONS(1004),
    [anon_sym_reserve_id_t] = ACTIONS(1004),
    [anon_sym_event_t] = ACTIONS(1004),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1004),
    [anon_sym_enum] = ACTIONS(1004),
    [anon_sym_struct] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1004),
    [anon_sym_do] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_return] = ACTIONS(1004),
    [anon_sym_break] = ACTIONS(1004),
    [anon_sym_continue] = ACTIONS(1004),
    [anon_sym_goto] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_sizeof] = ACTIONS(1004),
    [sym_number_literal] = ACTIONS(1006),
    [anon_sym_L_SQUOTE] = ACTIONS(1006),
    [anon_sym_u_SQUOTE] = ACTIONS(1006),
    [anon_sym_U_SQUOTE] = ACTIONS(1006),
    [anon_sym_u8_SQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_L_DQUOTE] = ACTIONS(1006),
    [anon_sym_u_DQUOTE] = ACTIONS(1006),
    [anon_sym_U_DQUOTE] = ACTIONS(1006),
    [anon_sym_u8_DQUOTE] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1006),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_identifier] = ACTIONS(1008),
    [aux_sym_preproc_include_token1] = ACTIONS(1008),
    [aux_sym_preproc_def_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token2] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1008),
    [sym_preproc_directive] = ACTIONS(1008),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_typedef] = ACTIONS(1008),
    [anon_sym_kernel] = ACTIONS(1008),
    [anon_sym___kernel] = ACTIONS(1008),
    [anon_sym_global] = ACTIONS(1008),
    [anon_sym___global] = ACTIONS(1008),
    [anon_sym_local] = ACTIONS(1008),
    [anon_sym___local] = ACTIONS(1008),
    [anon_sym_constant] = ACTIONS(1008),
    [anon_sym___constant] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym___private] = ACTIONS(1008),
    [anon_sym_generic] = ACTIONS(1008),
    [anon_sym___generic] = ACTIONS(1008),
    [anon_sym_read_only] = ACTIONS(1008),
    [anon_sym___read_only] = ACTIONS(1008),
    [anon_sym_write_only] = ACTIONS(1008),
    [anon_sym___write_only] = ACTIONS(1008),
    [anon_sym_read_write] = ACTIONS(1008),
    [anon_sym___read_write] = ACTIONS(1008),
    [anon_sym_extern] = ACTIONS(1008),
    [anon_sym___attribute__] = ACTIONS(1008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1010),
    [anon_sym___declspec] = ACTIONS(1008),
    [anon_sym___cdecl] = ACTIONS(1008),
    [anon_sym___clrcall] = ACTIONS(1008),
    [anon_sym___stdcall] = ACTIONS(1008),
    [anon_sym___fastcall] = ACTIONS(1008),
    [anon_sym___thiscall] = ACTIONS(1008),
    [anon_sym___vectorcall] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_auto] = ACTIONS(1008),
    [anon_sym_register] = ACTIONS(1008),
    [anon_sym_inline] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_volatile] = ACTIONS(1008),
    [anon_sym_restrict] = ACTIONS(1008),
    [anon_sym__Atomic] = ACTIONS(1008),
    [anon_sym_pipe] = ACTIONS(1008),
    [anon_sym_signed] = ACTIONS(1008),
    [anon_sym_unsigned] = ACTIONS(1008),
    [anon_sym_long] = ACTIONS(1008),
    [anon_sym_short] = ACTIONS(1008),
    [anon_sym_bool] = ACTIONS(1008),
    [anon_sym_char] = ACTIONS(1008),
    [anon_sym_uchar] = ACTIONS(1008),
    [anon_sym_ushort] = ACTIONS(1008),
    [anon_sym_int] = ACTIONS(1008),
    [anon_sym_uint] = ACTIONS(1008),
    [anon_sym_ulong] = ACTIONS(1008),
    [anon_sym_float] = ACTIONS(1008),
    [anon_sym_double] = ACTIONS(1008),
    [anon_sym_half] = ACTIONS(1008),
    [anon_sym_size_t] = ACTIONS(1008),
    [anon_sym_ptrdiff_t] = ACTIONS(1008),
    [anon_sym_intptr_t] = ACTIONS(1008),
    [anon_sym_uintptr_t] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1008),
    [sym_vector_type] = ACTIONS(1008),
    [anon_sym_image2d_t] = ACTIONS(1008),
    [anon_sym_image3d_t] = ACTIONS(1008),
    [anon_sym_image2d_array_t] = ACTIONS(1008),
    [anon_sym_image1d_t] = ACTIONS(1008),
    [anon_sym_image1d_buffer_t] = ACTIONS(1008),
    [anon_sym_image1d_array_t] = ACTIONS(1008),
    [anon_sym_image2d_depth_t] = ACTIONS(1008),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1008),
    [anon_sym_sampler_t] = ACTIONS(1008),
    [anon_sym_queue_t] = ACTIONS(1008),
    [anon_sym_ndrange_t] = ACTIONS(1008),
    [anon_sym_clk_event_t] = ACTIONS(1008),
    [anon_sym_reserve_id_t] = ACTIONS(1008),
    [anon_sym_event_t] = ACTIONS(1008),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_struct] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_goto] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_sizeof] = ACTIONS(1008),
    [sym_number_literal] = ACTIONS(1010),
    [anon_sym_L_SQUOTE] = ACTIONS(1010),
    [anon_sym_u_SQUOTE] = ACTIONS(1010),
    [anon_sym_U_SQUOTE] = ACTIONS(1010),
    [anon_sym_u8_SQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_L_DQUOTE] = ACTIONS(1010),
    [anon_sym_u_DQUOTE] = ACTIONS(1010),
    [anon_sym_U_DQUOTE] = ACTIONS(1010),
    [anon_sym_u8_DQUOTE] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [sym_true] = ACTIONS(1008),
    [sym_false] = ACTIONS(1008),
    [sym_null] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token2] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_kernel] = ACTIONS(1012),
    [anon_sym___kernel] = ACTIONS(1012),
    [anon_sym_global] = ACTIONS(1012),
    [anon_sym___global] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym___local] = ACTIONS(1012),
    [anon_sym_constant] = ACTIONS(1012),
    [anon_sym___constant] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym___private] = ACTIONS(1012),
    [anon_sym_generic] = ACTIONS(1012),
    [anon_sym___generic] = ACTIONS(1012),
    [anon_sym_read_only] = ACTIONS(1012),
    [anon_sym___read_only] = ACTIONS(1012),
    [anon_sym_write_only] = ACTIONS(1012),
    [anon_sym___write_only] = ACTIONS(1012),
    [anon_sym_read_write] = ACTIONS(1012),
    [anon_sym___read_write] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1014),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_pipe] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_uchar] = ACTIONS(1012),
    [anon_sym_ushort] = ACTIONS(1012),
    [anon_sym_int] = ACTIONS(1012),
    [anon_sym_uint] = ACTIONS(1012),
    [anon_sym_ulong] = ACTIONS(1012),
    [anon_sym_float] = ACTIONS(1012),
    [anon_sym_double] = ACTIONS(1012),
    [anon_sym_half] = ACTIONS(1012),
    [anon_sym_size_t] = ACTIONS(1012),
    [anon_sym_ptrdiff_t] = ACTIONS(1012),
    [anon_sym_intptr_t] = ACTIONS(1012),
    [anon_sym_uintptr_t] = ACTIONS(1012),
    [anon_sym_void] = ACTIONS(1012),
    [sym_vector_type] = ACTIONS(1012),
    [anon_sym_image2d_t] = ACTIONS(1012),
    [anon_sym_image3d_t] = ACTIONS(1012),
    [anon_sym_image2d_array_t] = ACTIONS(1012),
    [anon_sym_image1d_t] = ACTIONS(1012),
    [anon_sym_image1d_buffer_t] = ACTIONS(1012),
    [anon_sym_image1d_array_t] = ACTIONS(1012),
    [anon_sym_image2d_depth_t] = ACTIONS(1012),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1012),
    [anon_sym_sampler_t] = ACTIONS(1012),
    [anon_sym_queue_t] = ACTIONS(1012),
    [anon_sym_ndrange_t] = ACTIONS(1012),
    [anon_sym_clk_event_t] = ACTIONS(1012),
    [anon_sym_reserve_id_t] = ACTIONS(1012),
    [anon_sym_event_t] = ACTIONS(1012),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token2] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_kernel] = ACTIONS(1012),
    [anon_sym___kernel] = ACTIONS(1012),
    [anon_sym_global] = ACTIONS(1012),
    [anon_sym___global] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym___local] = ACTIONS(1012),
    [anon_sym_constant] = ACTIONS(1012),
    [anon_sym___constant] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym___private] = ACTIONS(1012),
    [anon_sym_generic] = ACTIONS(1012),
    [anon_sym___generic] = ACTIONS(1012),
    [anon_sym_read_only] = ACTIONS(1012),
    [anon_sym___read_only] = ACTIONS(1012),
    [anon_sym_write_only] = ACTIONS(1012),
    [anon_sym___write_only] = ACTIONS(1012),
    [anon_sym_read_write] = ACTIONS(1012),
    [anon_sym___read_write] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1014),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_pipe] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_uchar] = ACTIONS(1012),
    [anon_sym_ushort] = ACTIONS(1012),
    [anon_sym_int] = ACTIONS(1012),
    [anon_sym_uint] = ACTIONS(1012),
    [anon_sym_ulong] = ACTIONS(1012),
    [anon_sym_float] = ACTIONS(1012),
    [anon_sym_double] = ACTIONS(1012),
    [anon_sym_half] = ACTIONS(1012),
    [anon_sym_size_t] = ACTIONS(1012),
    [anon_sym_ptrdiff_t] = ACTIONS(1012),
    [anon_sym_intptr_t] = ACTIONS(1012),
    [anon_sym_uintptr_t] = ACTIONS(1012),
    [anon_sym_void] = ACTIONS(1012),
    [sym_vector_type] = ACTIONS(1012),
    [anon_sym_image2d_t] = ACTIONS(1012),
    [anon_sym_image3d_t] = ACTIONS(1012),
    [anon_sym_image2d_array_t] = ACTIONS(1012),
    [anon_sym_image1d_t] = ACTIONS(1012),
    [anon_sym_image1d_buffer_t] = ACTIONS(1012),
    [anon_sym_image1d_array_t] = ACTIONS(1012),
    [anon_sym_image2d_depth_t] = ACTIONS(1012),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1012),
    [anon_sym_sampler_t] = ACTIONS(1012),
    [anon_sym_queue_t] = ACTIONS(1012),
    [anon_sym_ndrange_t] = ACTIONS(1012),
    [anon_sym_clk_event_t] = ACTIONS(1012),
    [anon_sym_reserve_id_t] = ACTIONS(1012),
    [anon_sym_event_t] = ACTIONS(1012),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_identifier] = ACTIONS(1040),
    [aux_sym_preproc_include_token1] = ACTIONS(1040),
    [aux_sym_preproc_def_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token2] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1040),
    [sym_preproc_directive] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_typedef] = ACTIONS(1040),
    [anon_sym_kernel] = ACTIONS(1040),
    [anon_sym___kernel] = ACTIONS(1040),
    [anon_sym_global] = ACTIONS(1040),
    [anon_sym___global] = ACTIONS(1040),
    [anon_sym_local] = ACTIONS(1040),
    [anon_sym___local] = ACTIONS(1040),
    [anon_sym_constant] = ACTIONS(1040),
    [anon_sym___constant] = ACTIONS(1040),
    [anon_sym_private] = ACTIONS(1040),
    [anon_sym___private] = ACTIONS(1040),
    [anon_sym_generic] = ACTIONS(1040),
    [anon_sym___generic] = ACTIONS(1040),
    [anon_sym_read_only] = ACTIONS(1040),
    [anon_sym___read_only] = ACTIONS(1040),
    [anon_sym_write_only] = ACTIONS(1040),
    [anon_sym___write_only] = ACTIONS(1040),
    [anon_sym_read_write] = ACTIONS(1040),
    [anon_sym___read_write] = ACTIONS(1040),
    [anon_sym_extern] = ACTIONS(1040),
    [anon_sym___attribute__] = ACTIONS(1040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1042),
    [anon_sym___declspec] = ACTIONS(1040),
    [anon_sym___cdecl] = ACTIONS(1040),
    [anon_sym___clrcall] = ACTIONS(1040),
    [anon_sym___stdcall] = ACTIONS(1040),
    [anon_sym___fastcall] = ACTIONS(1040),
    [anon_sym___thiscall] = ACTIONS(1040),
    [anon_sym___vectorcall] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_auto] = ACTIONS(1040),
    [anon_sym_register] = ACTIONS(1040),
    [anon_sym_inline] = ACTIONS(1040),
    [anon_sym_const] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_restrict] = ACTIONS(1040),
    [anon_sym__Atomic] = ACTIONS(1040),
    [anon_sym_pipe] = ACTIONS(1040),
    [anon_sym_signed] = ACTIONS(1040),
    [anon_sym_unsigned] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [anon_sym_bool] = ACTIONS(1040),
    [anon_sym_char] = ACTIONS(1040),
    [anon_sym_uchar] = ACTIONS(1040),
    [anon_sym_ushort] = ACTIONS(1040),
    [anon_sym_int] = ACTIONS(1040),
    [anon_sym_uint] = ACTIONS(1040),
    [anon_sym_ulong] = ACTIONS(1040),
    [anon_sym_float] = ACTIONS(1040),
    [anon_sym_double] = ACTIONS(1040),
    [anon_sym_half] = ACTIONS(1040),
    [anon_sym_size_t] = ACTIONS(1040),
    [anon_sym_ptrdiff_t] = ACTIONS(1040),
    [anon_sym_intptr_t] = ACTIONS(1040),
    [anon_sym_uintptr_t] = ACTIONS(1040),
    [anon_sym_void] = ACTIONS(1040),
    [sym_vector_type] = ACTIONS(1040),
    [anon_sym_image2d_t] = ACTIONS(1040),
    [anon_sym_image3d_t] = ACTIONS(1040),
    [anon_sym_image2d_array_t] = ACTIONS(1040),
    [anon_sym_image1d_t] = ACTIONS(1040),
    [anon_sym_image1d_buffer_t] = ACTIONS(1040),
    [anon_sym_image1d_array_t] = ACTIONS(1040),
    [anon_sym_image2d_depth_t] = ACTIONS(1040),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1040),
    [anon_sym_sampler_t] = ACTIONS(1040),
    [anon_sym_queue_t] = ACTIONS(1040),
    [anon_sym_ndrange_t] = ACTIONS(1040),
    [anon_sym_clk_event_t] = ACTIONS(1040),
    [anon_sym_reserve_id_t] = ACTIONS(1040),
    [anon_sym_event_t] = ACTIONS(1040),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_union] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_goto] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_sizeof] = ACTIONS(1040),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_L_SQUOTE] = ACTIONS(1042),
    [anon_sym_u_SQUOTE] = ACTIONS(1042),
    [anon_sym_U_SQUOTE] = ACTIONS(1042),
    [anon_sym_u8_SQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [anon_sym_L_DQUOTE] = ACTIONS(1042),
    [anon_sym_u_DQUOTE] = ACTIONS(1042),
    [anon_sym_U_DQUOTE] = ACTIONS(1042),
    [anon_sym_u8_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(928),
    [sym_identifier] = ACTIONS(926),
    [aux_sym_preproc_include_token1] = ACTIONS(926),
    [aux_sym_preproc_def_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(926),
    [sym_preproc_directive] = ACTIONS(926),
    [anon_sym_LPAREN2] = ACTIONS(928),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(926),
    [anon_sym_kernel] = ACTIONS(926),
    [anon_sym___kernel] = ACTIONS(926),
    [anon_sym_global] = ACTIONS(926),
    [anon_sym___global] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym___local] = ACTIONS(926),
    [anon_sym_constant] = ACTIONS(926),
    [anon_sym___constant] = ACTIONS(926),
    [anon_sym_private] = ACTIONS(926),
    [anon_sym___private] = ACTIONS(926),
    [anon_sym_generic] = ACTIONS(926),
    [anon_sym___generic] = ACTIONS(926),
    [anon_sym_read_only] = ACTIONS(926),
    [anon_sym___read_only] = ACTIONS(926),
    [anon_sym_write_only] = ACTIONS(926),
    [anon_sym___write_only] = ACTIONS(926),
    [anon_sym_read_write] = ACTIONS(926),
    [anon_sym___read_write] = ACTIONS(926),
    [anon_sym_extern] = ACTIONS(926),
    [anon_sym___attribute__] = ACTIONS(926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(928),
    [anon_sym___declspec] = ACTIONS(926),
    [anon_sym___cdecl] = ACTIONS(926),
    [anon_sym___clrcall] = ACTIONS(926),
    [anon_sym___stdcall] = ACTIONS(926),
    [anon_sym___fastcall] = ACTIONS(926),
    [anon_sym___thiscall] = ACTIONS(926),
    [anon_sym___vectorcall] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_auto] = ACTIONS(926),
    [anon_sym_register] = ACTIONS(926),
    [anon_sym_inline] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_restrict] = ACTIONS(926),
    [anon_sym__Atomic] = ACTIONS(926),
    [anon_sym_pipe] = ACTIONS(926),
    [anon_sym_signed] = ACTIONS(926),
    [anon_sym_unsigned] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [anon_sym_bool] = ACTIONS(926),
    [anon_sym_char] = ACTIONS(926),
    [anon_sym_uchar] = ACTIONS(926),
    [anon_sym_ushort] = ACTIONS(926),
    [anon_sym_int] = ACTIONS(926),
    [anon_sym_uint] = ACTIONS(926),
    [anon_sym_ulong] = ACTIONS(926),
    [anon_sym_float] = ACTIONS(926),
    [anon_sym_double] = ACTIONS(926),
    [anon_sym_half] = ACTIONS(926),
    [anon_sym_size_t] = ACTIONS(926),
    [anon_sym_ptrdiff_t] = ACTIONS(926),
    [anon_sym_intptr_t] = ACTIONS(926),
    [anon_sym_uintptr_t] = ACTIONS(926),
    [anon_sym_void] = ACTIONS(926),
    [sym_vector_type] = ACTIONS(926),
    [anon_sym_image2d_t] = ACTIONS(926),
    [anon_sym_image3d_t] = ACTIONS(926),
    [anon_sym_image2d_array_t] = ACTIONS(926),
    [anon_sym_image1d_t] = ACTIONS(926),
    [anon_sym_image1d_buffer_t] = ACTIONS(926),
    [anon_sym_image1d_array_t] = ACTIONS(926),
    [anon_sym_image2d_depth_t] = ACTIONS(926),
    [anon_sym_image2d_array_depth_t] = ACTIONS(926),
    [anon_sym_sampler_t] = ACTIONS(926),
    [anon_sym_queue_t] = ACTIONS(926),
    [anon_sym_ndrange_t] = ACTIONS(926),
    [anon_sym_clk_event_t] = ACTIONS(926),
    [anon_sym_reserve_id_t] = ACTIONS(926),
    [anon_sym_event_t] = ACTIONS(926),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_struct] = ACTIONS(926),
    [anon_sym_union] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(926),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_goto] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_sizeof] = ACTIONS(926),
    [sym_number_literal] = ACTIONS(928),
    [anon_sym_L_SQUOTE] = ACTIONS(928),
    [anon_sym_u_SQUOTE] = ACTIONS(928),
    [anon_sym_U_SQUOTE] = ACTIONS(928),
    [anon_sym_u8_SQUOTE] = ACTIONS(928),
    [anon_sym_SQUOTE] = ACTIONS(928),
    [anon_sym_L_DQUOTE] = ACTIONS(928),
    [anon_sym_u_DQUOTE] = ACTIONS(928),
    [anon_sym_U_DQUOTE] = ACTIONS(928),
    [anon_sym_u8_DQUOTE] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_null] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(982),
    [sym_identifier] = ACTIONS(980),
    [aux_sym_preproc_include_token1] = ACTIONS(980),
    [aux_sym_preproc_def_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(980),
    [sym_preproc_directive] = ACTIONS(980),
    [anon_sym_LPAREN2] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(982),
    [anon_sym_SEMI] = ACTIONS(982),
    [anon_sym_typedef] = ACTIONS(980),
    [anon_sym_kernel] = ACTIONS(980),
    [anon_sym___kernel] = ACTIONS(980),
    [anon_sym_global] = ACTIONS(980),
    [anon_sym___global] = ACTIONS(980),
    [anon_sym_local] = ACTIONS(980),
    [anon_sym___local] = ACTIONS(980),
    [anon_sym_constant] = ACTIONS(980),
    [anon_sym___constant] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym___private] = ACTIONS(980),
    [anon_sym_generic] = ACTIONS(980),
    [anon_sym___generic] = ACTIONS(980),
    [anon_sym_read_only] = ACTIONS(980),
    [anon_sym___read_only] = ACTIONS(980),
    [anon_sym_write_only] = ACTIONS(980),
    [anon_sym___write_only] = ACTIONS(980),
    [anon_sym_read_write] = ACTIONS(980),
    [anon_sym___read_write] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym___attribute__] = ACTIONS(980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(982),
    [anon_sym___declspec] = ACTIONS(980),
    [anon_sym___cdecl] = ACTIONS(980),
    [anon_sym___clrcall] = ACTIONS(980),
    [anon_sym___stdcall] = ACTIONS(980),
    [anon_sym___fastcall] = ACTIONS(980),
    [anon_sym___thiscall] = ACTIONS(980),
    [anon_sym___vectorcall] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_auto] = ACTIONS(980),
    [anon_sym_register] = ACTIONS(980),
    [anon_sym_inline] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_volatile] = ACTIONS(980),
    [anon_sym_restrict] = ACTIONS(980),
    [anon_sym__Atomic] = ACTIONS(980),
    [anon_sym_pipe] = ACTIONS(980),
    [anon_sym_signed] = ACTIONS(980),
    [anon_sym_unsigned] = ACTIONS(980),
    [anon_sym_long] = ACTIONS(980),
    [anon_sym_short] = ACTIONS(980),
    [anon_sym_bool] = ACTIONS(980),
    [anon_sym_char] = ACTIONS(980),
    [anon_sym_uchar] = ACTIONS(980),
    [anon_sym_ushort] = ACTIONS(980),
    [anon_sym_int] = ACTIONS(980),
    [anon_sym_uint] = ACTIONS(980),
    [anon_sym_ulong] = ACTIONS(980),
    [anon_sym_float] = ACTIONS(980),
    [anon_sym_double] = ACTIONS(980),
    [anon_sym_half] = ACTIONS(980),
    [anon_sym_size_t] = ACTIONS(980),
    [anon_sym_ptrdiff_t] = ACTIONS(980),
    [anon_sym_intptr_t] = ACTIONS(980),
    [anon_sym_uintptr_t] = ACTIONS(980),
    [anon_sym_void] = ACTIONS(980),
    [sym_vector_type] = ACTIONS(980),
    [anon_sym_image2d_t] = ACTIONS(980),
    [anon_sym_image3d_t] = ACTIONS(980),
    [anon_sym_image2d_array_t] = ACTIONS(980),
    [anon_sym_image1d_t] = ACTIONS(980),
    [anon_sym_image1d_buffer_t] = ACTIONS(980),
    [anon_sym_image1d_array_t] = ACTIONS(980),
    [anon_sym_image2d_depth_t] = ACTIONS(980),
    [anon_sym_image2d_array_depth_t] = ACTIONS(980),
    [anon_sym_sampler_t] = ACTIONS(980),
    [anon_sym_queue_t] = ACTIONS(980),
    [anon_sym_ndrange_t] = ACTIONS(980),
    [anon_sym_clk_event_t] = ACTIONS(980),
    [anon_sym_reserve_id_t] = ACTIONS(980),
    [anon_sym_event_t] = ACTIONS(980),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_struct] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(980),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_do] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_goto] = ACTIONS(980),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_sizeof] = ACTIONS(980),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_L_SQUOTE] = ACTIONS(982),
    [anon_sym_u_SQUOTE] = ACTIONS(982),
    [anon_sym_U_SQUOTE] = ACTIONS(982),
    [anon_sym_u8_SQUOTE] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(982),
    [anon_sym_L_DQUOTE] = ACTIONS(982),
    [anon_sym_u_DQUOTE] = ACTIONS(982),
    [anon_sym_U_DQUOTE] = ACTIONS(982),
    [anon_sym_u8_DQUOTE] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_null] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_identifier] = ACTIONS(930),
    [aux_sym_preproc_include_token1] = ACTIONS(930),
    [aux_sym_preproc_def_token1] = ACTIONS(930),
    [aux_sym_preproc_if_token1] = ACTIONS(930),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(930),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(930),
    [sym_preproc_directive] = ACTIONS(930),
    [anon_sym_LPAREN2] = ACTIONS(932),
    [anon_sym_BANG] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_STAR] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_typedef] = ACTIONS(930),
    [anon_sym_kernel] = ACTIONS(930),
    [anon_sym___kernel] = ACTIONS(930),
    [anon_sym_global] = ACTIONS(930),
    [anon_sym___global] = ACTIONS(930),
    [anon_sym_local] = ACTIONS(930),
    [anon_sym___local] = ACTIONS(930),
    [anon_sym_constant] = ACTIONS(930),
    [anon_sym___constant] = ACTIONS(930),
    [anon_sym_private] = ACTIONS(930),
    [anon_sym___private] = ACTIONS(930),
    [anon_sym_generic] = ACTIONS(930),
    [anon_sym___generic] = ACTIONS(930),
    [anon_sym_read_only] = ACTIONS(930),
    [anon_sym___read_only] = ACTIONS(930),
    [anon_sym_write_only] = ACTIONS(930),
    [anon_sym___write_only] = ACTIONS(930),
    [anon_sym_read_write] = ACTIONS(930),
    [anon_sym___read_write] = ACTIONS(930),
    [anon_sym_extern] = ACTIONS(930),
    [anon_sym___attribute__] = ACTIONS(930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(932),
    [anon_sym___declspec] = ACTIONS(930),
    [anon_sym___cdecl] = ACTIONS(930),
    [anon_sym___clrcall] = ACTIONS(930),
    [anon_sym___stdcall] = ACTIONS(930),
    [anon_sym___fastcall] = ACTIONS(930),
    [anon_sym___thiscall] = ACTIONS(930),
    [anon_sym___vectorcall] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_RBRACE] = ACTIONS(932),
    [anon_sym_static] = ACTIONS(930),
    [anon_sym_auto] = ACTIONS(930),
    [anon_sym_register] = ACTIONS(930),
    [anon_sym_inline] = ACTIONS(930),
    [anon_sym_const] = ACTIONS(930),
    [anon_sym_volatile] = ACTIONS(930),
    [anon_sym_restrict] = ACTIONS(930),
    [anon_sym__Atomic] = ACTIONS(930),
    [anon_sym_pipe] = ACTIONS(930),
    [anon_sym_signed] = ACTIONS(930),
    [anon_sym_unsigned] = ACTIONS(930),
    [anon_sym_long] = ACTIONS(930),
    [anon_sym_short] = ACTIONS(930),
    [anon_sym_bool] = ACTIONS(930),
    [anon_sym_char] = ACTIONS(930),
    [anon_sym_uchar] = ACTIONS(930),
    [anon_sym_ushort] = ACTIONS(930),
    [anon_sym_int] = ACTIONS(930),
    [anon_sym_uint] = ACTIONS(930),
    [anon_sym_ulong] = ACTIONS(930),
    [anon_sym_float] = ACTIONS(930),
    [anon_sym_double] = ACTIONS(930),
    [anon_sym_half] = ACTIONS(930),
    [anon_sym_size_t] = ACTIONS(930),
    [anon_sym_ptrdiff_t] = ACTIONS(930),
    [anon_sym_intptr_t] = ACTIONS(930),
    [anon_sym_uintptr_t] = ACTIONS(930),
    [anon_sym_void] = ACTIONS(930),
    [sym_vector_type] = ACTIONS(930),
    [anon_sym_image2d_t] = ACTIONS(930),
    [anon_sym_image3d_t] = ACTIONS(930),
    [anon_sym_image2d_array_t] = ACTIONS(930),
    [anon_sym_image1d_t] = ACTIONS(930),
    [anon_sym_image1d_buffer_t] = ACTIONS(930),
    [anon_sym_image1d_array_t] = ACTIONS(930),
    [anon_sym_image2d_depth_t] = ACTIONS(930),
    [anon_sym_image2d_array_depth_t] = ACTIONS(930),
    [anon_sym_sampler_t] = ACTIONS(930),
    [anon_sym_queue_t] = ACTIONS(930),
    [anon_sym_ndrange_t] = ACTIONS(930),
    [anon_sym_clk_event_t] = ACTIONS(930),
    [anon_sym_reserve_id_t] = ACTIONS(930),
    [anon_sym_event_t] = ACTIONS(930),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(930),
    [anon_sym_enum] = ACTIONS(930),
    [anon_sym_struct] = ACTIONS(930),
    [anon_sym_union] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_else] = ACTIONS(930),
    [anon_sym_switch] = ACTIONS(930),
    [anon_sym_case] = ACTIONS(930),
    [anon_sym_default] = ACTIONS(930),
    [anon_sym_while] = ACTIONS(930),
    [anon_sym_do] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(930),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_break] = ACTIONS(930),
    [anon_sym_continue] = ACTIONS(930),
    [anon_sym_goto] = ACTIONS(930),
    [anon_sym_DASH_DASH] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_sizeof] = ACTIONS(930),
    [sym_number_literal] = ACTIONS(932),
    [anon_sym_L_SQUOTE] = ACTIONS(932),
    [anon_sym_u_SQUOTE] = ACTIONS(932),
    [anon_sym_U_SQUOTE] = ACTIONS(932),
    [anon_sym_u8_SQUOTE] = ACTIONS(932),
    [anon_sym_SQUOTE] = ACTIONS(932),
    [anon_sym_L_DQUOTE] = ACTIONS(932),
    [anon_sym_u_DQUOTE] = ACTIONS(932),
    [anon_sym_U_DQUOTE] = ACTIONS(932),
    [anon_sym_u8_DQUOTE] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_true] = ACTIONS(930),
    [sym_false] = ACTIONS(930),
    [sym_null] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_identifier] = ACTIONS(938),
    [aux_sym_preproc_include_token1] = ACTIONS(938),
    [aux_sym_preproc_def_token1] = ACTIONS(938),
    [aux_sym_preproc_if_token1] = ACTIONS(938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(938),
    [sym_preproc_directive] = ACTIONS(938),
    [anon_sym_LPAREN2] = ACTIONS(940),
    [anon_sym_BANG] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_DASH] = ACTIONS(938),
    [anon_sym_PLUS] = ACTIONS(938),
    [anon_sym_STAR] = ACTIONS(940),
    [anon_sym_AMP] = ACTIONS(940),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_typedef] = ACTIONS(938),
    [anon_sym_kernel] = ACTIONS(938),
    [anon_sym___kernel] = ACTIONS(938),
    [anon_sym_global] = ACTIONS(938),
    [anon_sym___global] = ACTIONS(938),
    [anon_sym_local] = ACTIONS(938),
    [anon_sym___local] = ACTIONS(938),
    [anon_sym_constant] = ACTIONS(938),
    [anon_sym___constant] = ACTIONS(938),
    [anon_sym_private] = ACTIONS(938),
    [anon_sym___private] = ACTIONS(938),
    [anon_sym_generic] = ACTIONS(938),
    [anon_sym___generic] = ACTIONS(938),
    [anon_sym_read_only] = ACTIONS(938),
    [anon_sym___read_only] = ACTIONS(938),
    [anon_sym_write_only] = ACTIONS(938),
    [anon_sym___write_only] = ACTIONS(938),
    [anon_sym_read_write] = ACTIONS(938),
    [anon_sym___read_write] = ACTIONS(938),
    [anon_sym_extern] = ACTIONS(938),
    [anon_sym___attribute__] = ACTIONS(938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(940),
    [anon_sym___declspec] = ACTIONS(938),
    [anon_sym___cdecl] = ACTIONS(938),
    [anon_sym___clrcall] = ACTIONS(938),
    [anon_sym___stdcall] = ACTIONS(938),
    [anon_sym___fastcall] = ACTIONS(938),
    [anon_sym___thiscall] = ACTIONS(938),
    [anon_sym___vectorcall] = ACTIONS(938),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_static] = ACTIONS(938),
    [anon_sym_auto] = ACTIONS(938),
    [anon_sym_register] = ACTIONS(938),
    [anon_sym_inline] = ACTIONS(938),
    [anon_sym_const] = ACTIONS(938),
    [anon_sym_volatile] = ACTIONS(938),
    [anon_sym_restrict] = ACTIONS(938),
    [anon_sym__Atomic] = ACTIONS(938),
    [anon_sym_pipe] = ACTIONS(938),
    [anon_sym_signed] = ACTIONS(938),
    [anon_sym_unsigned] = ACTIONS(938),
    [anon_sym_long] = ACTIONS(938),
    [anon_sym_short] = ACTIONS(938),
    [anon_sym_bool] = ACTIONS(938),
    [anon_sym_char] = ACTIONS(938),
    [anon_sym_uchar] = ACTIONS(938),
    [anon_sym_ushort] = ACTIONS(938),
    [anon_sym_int] = ACTIONS(938),
    [anon_sym_uint] = ACTIONS(938),
    [anon_sym_ulong] = ACTIONS(938),
    [anon_sym_float] = ACTIONS(938),
    [anon_sym_double] = ACTIONS(938),
    [anon_sym_half] = ACTIONS(938),
    [anon_sym_size_t] = ACTIONS(938),
    [anon_sym_ptrdiff_t] = ACTIONS(938),
    [anon_sym_intptr_t] = ACTIONS(938),
    [anon_sym_uintptr_t] = ACTIONS(938),
    [anon_sym_void] = ACTIONS(938),
    [sym_vector_type] = ACTIONS(938),
    [anon_sym_image2d_t] = ACTIONS(938),
    [anon_sym_image3d_t] = ACTIONS(938),
    [anon_sym_image2d_array_t] = ACTIONS(938),
    [anon_sym_image1d_t] = ACTIONS(938),
    [anon_sym_image1d_buffer_t] = ACTIONS(938),
    [anon_sym_image1d_array_t] = ACTIONS(938),
    [anon_sym_image2d_depth_t] = ACTIONS(938),
    [anon_sym_image2d_array_depth_t] = ACTIONS(938),
    [anon_sym_sampler_t] = ACTIONS(938),
    [anon_sym_queue_t] = ACTIONS(938),
    [anon_sym_ndrange_t] = ACTIONS(938),
    [anon_sym_clk_event_t] = ACTIONS(938),
    [anon_sym_reserve_id_t] = ACTIONS(938),
    [anon_sym_event_t] = ACTIONS(938),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(938),
    [anon_sym_enum] = ACTIONS(938),
    [anon_sym_struct] = ACTIONS(938),
    [anon_sym_union] = ACTIONS(938),
    [anon_sym_if] = ACTIONS(938),
    [anon_sym_else] = ACTIONS(938),
    [anon_sym_switch] = ACTIONS(938),
    [anon_sym_case] = ACTIONS(938),
    [anon_sym_default] = ACTIONS(938),
    [anon_sym_while] = ACTIONS(938),
    [anon_sym_do] = ACTIONS(938),
    [anon_sym_for] = ACTIONS(938),
    [anon_sym_return] = ACTIONS(938),
    [anon_sym_break] = ACTIONS(938),
    [anon_sym_continue] = ACTIONS(938),
    [anon_sym_goto] = ACTIONS(938),
    [anon_sym_DASH_DASH] = ACTIONS(940),
    [anon_sym_PLUS_PLUS] = ACTIONS(940),
    [anon_sym_sizeof] = ACTIONS(938),
    [sym_number_literal] = ACTIONS(940),
    [anon_sym_L_SQUOTE] = ACTIONS(940),
    [anon_sym_u_SQUOTE] = ACTIONS(940),
    [anon_sym_U_SQUOTE] = ACTIONS(940),
    [anon_sym_u8_SQUOTE] = ACTIONS(940),
    [anon_sym_SQUOTE] = ACTIONS(940),
    [anon_sym_L_DQUOTE] = ACTIONS(940),
    [anon_sym_u_DQUOTE] = ACTIONS(940),
    [anon_sym_U_DQUOTE] = ACTIONS(940),
    [anon_sym_u8_DQUOTE] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(940),
    [sym_true] = ACTIONS(938),
    [sym_false] = ACTIONS(938),
    [sym_null] = ACTIONS(938),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(994),
    [sym_identifier] = ACTIONS(992),
    [aux_sym_preproc_include_token1] = ACTIONS(992),
    [aux_sym_preproc_def_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(992),
    [sym_preproc_directive] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_typedef] = ACTIONS(992),
    [anon_sym_kernel] = ACTIONS(992),
    [anon_sym___kernel] = ACTIONS(992),
    [anon_sym_global] = ACTIONS(992),
    [anon_sym___global] = ACTIONS(992),
    [anon_sym_local] = ACTIONS(992),
    [anon_sym___local] = ACTIONS(992),
    [anon_sym_constant] = ACTIONS(992),
    [anon_sym___constant] = ACTIONS(992),
    [anon_sym_private] = ACTIONS(992),
    [anon_sym___private] = ACTIONS(992),
    [anon_sym_generic] = ACTIONS(992),
    [anon_sym___generic] = ACTIONS(992),
    [anon_sym_read_only] = ACTIONS(992),
    [anon_sym___read_only] = ACTIONS(992),
    [anon_sym_write_only] = ACTIONS(992),
    [anon_sym___write_only] = ACTIONS(992),
    [anon_sym_read_write] = ACTIONS(992),
    [anon_sym___read_write] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym___attribute__] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(994),
    [anon_sym___declspec] = ACTIONS(992),
    [anon_sym___cdecl] = ACTIONS(992),
    [anon_sym___clrcall] = ACTIONS(992),
    [anon_sym___stdcall] = ACTIONS(992),
    [anon_sym___fastcall] = ACTIONS(992),
    [anon_sym___thiscall] = ACTIONS(992),
    [anon_sym___vectorcall] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_auto] = ACTIONS(992),
    [anon_sym_register] = ACTIONS(992),
    [anon_sym_inline] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_volatile] = ACTIONS(992),
    [anon_sym_restrict] = ACTIONS(992),
    [anon_sym__Atomic] = ACTIONS(992),
    [anon_sym_pipe] = ACTIONS(992),
    [anon_sym_signed] = ACTIONS(992),
    [anon_sym_unsigned] = ACTIONS(992),
    [anon_sym_long] = ACTIONS(992),
    [anon_sym_short] = ACTIONS(992),
    [anon_sym_bool] = ACTIONS(992),
    [anon_sym_char] = ACTIONS(992),
    [anon_sym_uchar] = ACTIONS(992),
    [anon_sym_ushort] = ACTIONS(992),
    [anon_sym_int] = ACTIONS(992),
    [anon_sym_uint] = ACTIONS(992),
    [anon_sym_ulong] = ACTIONS(992),
    [anon_sym_float] = ACTIONS(992),
    [anon_sym_double] = ACTIONS(992),
    [anon_sym_half] = ACTIONS(992),
    [anon_sym_size_t] = ACTIONS(992),
    [anon_sym_ptrdiff_t] = ACTIONS(992),
    [anon_sym_intptr_t] = ACTIONS(992),
    [anon_sym_uintptr_t] = ACTIONS(992),
    [anon_sym_void] = ACTIONS(992),
    [sym_vector_type] = ACTIONS(992),
    [anon_sym_image2d_t] = ACTIONS(992),
    [anon_sym_image3d_t] = ACTIONS(992),
    [anon_sym_image2d_array_t] = ACTIONS(992),
    [anon_sym_image1d_t] = ACTIONS(992),
    [anon_sym_image1d_buffer_t] = ACTIONS(992),
    [anon_sym_image1d_array_t] = ACTIONS(992),
    [anon_sym_image2d_depth_t] = ACTIONS(992),
    [anon_sym_image2d_array_depth_t] = ACTIONS(992),
    [anon_sym_sampler_t] = ACTIONS(992),
    [anon_sym_queue_t] = ACTIONS(992),
    [anon_sym_ndrange_t] = ACTIONS(992),
    [anon_sym_clk_event_t] = ACTIONS(992),
    [anon_sym_reserve_id_t] = ACTIONS(992),
    [anon_sym_event_t] = ACTIONS(992),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_switch] = ACTIONS(992),
    [anon_sym_case] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_goto] = ACTIONS(992),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_sizeof] = ACTIONS(992),
    [sym_number_literal] = ACTIONS(994),
    [anon_sym_L_SQUOTE] = ACTIONS(994),
    [anon_sym_u_SQUOTE] = ACTIONS(994),
    [anon_sym_U_SQUOTE] = ACTIONS(994),
    [anon_sym_u8_SQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [anon_sym_L_DQUOTE] = ACTIONS(994),
    [anon_sym_u_DQUOTE] = ACTIONS(994),
    [anon_sym_U_DQUOTE] = ACTIONS(994),
    [anon_sym_u8_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_null] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token2] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_kernel] = ACTIONS(1036),
    [anon_sym___kernel] = ACTIONS(1036),
    [anon_sym_global] = ACTIONS(1036),
    [anon_sym___global] = ACTIONS(1036),
    [anon_sym_local] = ACTIONS(1036),
    [anon_sym___local] = ACTIONS(1036),
    [anon_sym_constant] = ACTIONS(1036),
    [anon_sym___constant] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym___private] = ACTIONS(1036),
    [anon_sym_generic] = ACTIONS(1036),
    [anon_sym___generic] = ACTIONS(1036),
    [anon_sym_read_only] = ACTIONS(1036),
    [anon_sym___read_only] = ACTIONS(1036),
    [anon_sym_write_only] = ACTIONS(1036),
    [anon_sym___write_only] = ACTIONS(1036),
    [anon_sym_read_write] = ACTIONS(1036),
    [anon_sym___read_write] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1038),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_pipe] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_bool] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_uchar] = ACTIONS(1036),
    [anon_sym_ushort] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_uint] = ACTIONS(1036),
    [anon_sym_ulong] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [anon_sym_half] = ACTIONS(1036),
    [anon_sym_size_t] = ACTIONS(1036),
    [anon_sym_ptrdiff_t] = ACTIONS(1036),
    [anon_sym_intptr_t] = ACTIONS(1036),
    [anon_sym_uintptr_t] = ACTIONS(1036),
    [anon_sym_void] = ACTIONS(1036),
    [sym_vector_type] = ACTIONS(1036),
    [anon_sym_image2d_t] = ACTIONS(1036),
    [anon_sym_image3d_t] = ACTIONS(1036),
    [anon_sym_image2d_array_t] = ACTIONS(1036),
    [anon_sym_image1d_t] = ACTIONS(1036),
    [anon_sym_image1d_buffer_t] = ACTIONS(1036),
    [anon_sym_image1d_array_t] = ACTIONS(1036),
    [anon_sym_image2d_depth_t] = ACTIONS(1036),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1036),
    [anon_sym_sampler_t] = ACTIONS(1036),
    [anon_sym_queue_t] = ACTIONS(1036),
    [anon_sym_ndrange_t] = ACTIONS(1036),
    [anon_sym_clk_event_t] = ACTIONS(1036),
    [anon_sym_reserve_id_t] = ACTIONS(1036),
    [anon_sym_event_t] = ACTIONS(1036),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token2] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_kernel] = ACTIONS(1036),
    [anon_sym___kernel] = ACTIONS(1036),
    [anon_sym_global] = ACTIONS(1036),
    [anon_sym___global] = ACTIONS(1036),
    [anon_sym_local] = ACTIONS(1036),
    [anon_sym___local] = ACTIONS(1036),
    [anon_sym_constant] = ACTIONS(1036),
    [anon_sym___constant] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym___private] = ACTIONS(1036),
    [anon_sym_generic] = ACTIONS(1036),
    [anon_sym___generic] = ACTIONS(1036),
    [anon_sym_read_only] = ACTIONS(1036),
    [anon_sym___read_only] = ACTIONS(1036),
    [anon_sym_write_only] = ACTIONS(1036),
    [anon_sym___write_only] = ACTIONS(1036),
    [anon_sym_read_write] = ACTIONS(1036),
    [anon_sym___read_write] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1038),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_pipe] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_bool] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_uchar] = ACTIONS(1036),
    [anon_sym_ushort] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_uint] = ACTIONS(1036),
    [anon_sym_ulong] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [anon_sym_half] = ACTIONS(1036),
    [anon_sym_size_t] = ACTIONS(1036),
    [anon_sym_ptrdiff_t] = ACTIONS(1036),
    [anon_sym_intptr_t] = ACTIONS(1036),
    [anon_sym_uintptr_t] = ACTIONS(1036),
    [anon_sym_void] = ACTIONS(1036),
    [sym_vector_type] = ACTIONS(1036),
    [anon_sym_image2d_t] = ACTIONS(1036),
    [anon_sym_image3d_t] = ACTIONS(1036),
    [anon_sym_image2d_array_t] = ACTIONS(1036),
    [anon_sym_image1d_t] = ACTIONS(1036),
    [anon_sym_image1d_buffer_t] = ACTIONS(1036),
    [anon_sym_image1d_array_t] = ACTIONS(1036),
    [anon_sym_image2d_depth_t] = ACTIONS(1036),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1036),
    [anon_sym_sampler_t] = ACTIONS(1036),
    [anon_sym_queue_t] = ACTIONS(1036),
    [anon_sym_ndrange_t] = ACTIONS(1036),
    [anon_sym_clk_event_t] = ACTIONS(1036),
    [anon_sym_reserve_id_t] = ACTIONS(1036),
    [anon_sym_event_t] = ACTIONS(1036),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(1030),
    [sym_identifier] = ACTIONS(1028),
    [aux_sym_preproc_include_token1] = ACTIONS(1028),
    [aux_sym_preproc_def_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1028),
    [sym_preproc_directive] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_typedef] = ACTIONS(1028),
    [anon_sym_kernel] = ACTIONS(1028),
    [anon_sym___kernel] = ACTIONS(1028),
    [anon_sym_global] = ACTIONS(1028),
    [anon_sym___global] = ACTIONS(1028),
    [anon_sym_local] = ACTIONS(1028),
    [anon_sym___local] = ACTIONS(1028),
    [anon_sym_constant] = ACTIONS(1028),
    [anon_sym___constant] = ACTIONS(1028),
    [anon_sym_private] = ACTIONS(1028),
    [anon_sym___private] = ACTIONS(1028),
    [anon_sym_generic] = ACTIONS(1028),
    [anon_sym___generic] = ACTIONS(1028),
    [anon_sym_read_only] = ACTIONS(1028),
    [anon_sym___read_only] = ACTIONS(1028),
    [anon_sym_write_only] = ACTIONS(1028),
    [anon_sym___write_only] = ACTIONS(1028),
    [anon_sym_read_write] = ACTIONS(1028),
    [anon_sym___read_write] = ACTIONS(1028),
    [anon_sym_extern] = ACTIONS(1028),
    [anon_sym___attribute__] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1030),
    [anon_sym___declspec] = ACTIONS(1028),
    [anon_sym___cdecl] = ACTIONS(1028),
    [anon_sym___clrcall] = ACTIONS(1028),
    [anon_sym___stdcall] = ACTIONS(1028),
    [anon_sym___fastcall] = ACTIONS(1028),
    [anon_sym___thiscall] = ACTIONS(1028),
    [anon_sym___vectorcall] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1028),
    [anon_sym_auto] = ACTIONS(1028),
    [anon_sym_register] = ACTIONS(1028),
    [anon_sym_inline] = ACTIONS(1028),
    [anon_sym_const] = ACTIONS(1028),
    [anon_sym_volatile] = ACTIONS(1028),
    [anon_sym_restrict] = ACTIONS(1028),
    [anon_sym__Atomic] = ACTIONS(1028),
    [anon_sym_pipe] = ACTIONS(1028),
    [anon_sym_signed] = ACTIONS(1028),
    [anon_sym_unsigned] = ACTIONS(1028),
    [anon_sym_long] = ACTIONS(1028),
    [anon_sym_short] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym_uchar] = ACTIONS(1028),
    [anon_sym_ushort] = ACTIONS(1028),
    [anon_sym_int] = ACTIONS(1028),
    [anon_sym_uint] = ACTIONS(1028),
    [anon_sym_ulong] = ACTIONS(1028),
    [anon_sym_float] = ACTIONS(1028),
    [anon_sym_double] = ACTIONS(1028),
    [anon_sym_half] = ACTIONS(1028),
    [anon_sym_size_t] = ACTIONS(1028),
    [anon_sym_ptrdiff_t] = ACTIONS(1028),
    [anon_sym_intptr_t] = ACTIONS(1028),
    [anon_sym_uintptr_t] = ACTIONS(1028),
    [anon_sym_void] = ACTIONS(1028),
    [sym_vector_type] = ACTIONS(1028),
    [anon_sym_image2d_t] = ACTIONS(1028),
    [anon_sym_image3d_t] = ACTIONS(1028),
    [anon_sym_image2d_array_t] = ACTIONS(1028),
    [anon_sym_image1d_t] = ACTIONS(1028),
    [anon_sym_image1d_buffer_t] = ACTIONS(1028),
    [anon_sym_image1d_array_t] = ACTIONS(1028),
    [anon_sym_image2d_depth_t] = ACTIONS(1028),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1028),
    [anon_sym_sampler_t] = ACTIONS(1028),
    [anon_sym_queue_t] = ACTIONS(1028),
    [anon_sym_ndrange_t] = ACTIONS(1028),
    [anon_sym_clk_event_t] = ACTIONS(1028),
    [anon_sym_reserve_id_t] = ACTIONS(1028),
    [anon_sym_event_t] = ACTIONS(1028),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1028),
    [anon_sym_enum] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_union] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_goto] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_sizeof] = ACTIONS(1028),
    [sym_number_literal] = ACTIONS(1030),
    [anon_sym_L_SQUOTE] = ACTIONS(1030),
    [anon_sym_u_SQUOTE] = ACTIONS(1030),
    [anon_sym_U_SQUOTE] = ACTIONS(1030),
    [anon_sym_u8_SQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [anon_sym_L_DQUOTE] = ACTIONS(1030),
    [anon_sym_u_DQUOTE] = ACTIONS(1030),
    [anon_sym_U_DQUOTE] = ACTIONS(1030),
    [anon_sym_u8_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [sym_true] = ACTIONS(1028),
    [sym_false] = ACTIONS(1028),
    [sym_null] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(1034),
    [sym_identifier] = ACTIONS(1032),
    [aux_sym_preproc_include_token1] = ACTIONS(1032),
    [aux_sym_preproc_def_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1032),
    [sym_preproc_directive] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_typedef] = ACTIONS(1032),
    [anon_sym_kernel] = ACTIONS(1032),
    [anon_sym___kernel] = ACTIONS(1032),
    [anon_sym_global] = ACTIONS(1032),
    [anon_sym___global] = ACTIONS(1032),
    [anon_sym_local] = ACTIONS(1032),
    [anon_sym___local] = ACTIONS(1032),
    [anon_sym_constant] = ACTIONS(1032),
    [anon_sym___constant] = ACTIONS(1032),
    [anon_sym_private] = ACTIONS(1032),
    [anon_sym___private] = ACTIONS(1032),
    [anon_sym_generic] = ACTIONS(1032),
    [anon_sym___generic] = ACTIONS(1032),
    [anon_sym_read_only] = ACTIONS(1032),
    [anon_sym___read_only] = ACTIONS(1032),
    [anon_sym_write_only] = ACTIONS(1032),
    [anon_sym___write_only] = ACTIONS(1032),
    [anon_sym_read_write] = ACTIONS(1032),
    [anon_sym___read_write] = ACTIONS(1032),
    [anon_sym_extern] = ACTIONS(1032),
    [anon_sym___attribute__] = ACTIONS(1032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1034),
    [anon_sym___declspec] = ACTIONS(1032),
    [anon_sym___cdecl] = ACTIONS(1032),
    [anon_sym___clrcall] = ACTIONS(1032),
    [anon_sym___stdcall] = ACTIONS(1032),
    [anon_sym___fastcall] = ACTIONS(1032),
    [anon_sym___thiscall] = ACTIONS(1032),
    [anon_sym___vectorcall] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_auto] = ACTIONS(1032),
    [anon_sym_register] = ACTIONS(1032),
    [anon_sym_inline] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_volatile] = ACTIONS(1032),
    [anon_sym_restrict] = ACTIONS(1032),
    [anon_sym__Atomic] = ACTIONS(1032),
    [anon_sym_pipe] = ACTIONS(1032),
    [anon_sym_signed] = ACTIONS(1032),
    [anon_sym_unsigned] = ACTIONS(1032),
    [anon_sym_long] = ACTIONS(1032),
    [anon_sym_short] = ACTIONS(1032),
    [anon_sym_bool] = ACTIONS(1032),
    [anon_sym_char] = ACTIONS(1032),
    [anon_sym_uchar] = ACTIONS(1032),
    [anon_sym_ushort] = ACTIONS(1032),
    [anon_sym_int] = ACTIONS(1032),
    [anon_sym_uint] = ACTIONS(1032),
    [anon_sym_ulong] = ACTIONS(1032),
    [anon_sym_float] = ACTIONS(1032),
    [anon_sym_double] = ACTIONS(1032),
    [anon_sym_half] = ACTIONS(1032),
    [anon_sym_size_t] = ACTIONS(1032),
    [anon_sym_ptrdiff_t] = ACTIONS(1032),
    [anon_sym_intptr_t] = ACTIONS(1032),
    [anon_sym_uintptr_t] = ACTIONS(1032),
    [anon_sym_void] = ACTIONS(1032),
    [sym_vector_type] = ACTIONS(1032),
    [anon_sym_image2d_t] = ACTIONS(1032),
    [anon_sym_image3d_t] = ACTIONS(1032),
    [anon_sym_image2d_array_t] = ACTIONS(1032),
    [anon_sym_image1d_t] = ACTIONS(1032),
    [anon_sym_image1d_buffer_t] = ACTIONS(1032),
    [anon_sym_image1d_array_t] = ACTIONS(1032),
    [anon_sym_image2d_depth_t] = ACTIONS(1032),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1032),
    [anon_sym_sampler_t] = ACTIONS(1032),
    [anon_sym_queue_t] = ACTIONS(1032),
    [anon_sym_ndrange_t] = ACTIONS(1032),
    [anon_sym_clk_event_t] = ACTIONS(1032),
    [anon_sym_reserve_id_t] = ACTIONS(1032),
    [anon_sym_event_t] = ACTIONS(1032),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_struct] = ACTIONS(1032),
    [anon_sym_union] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_goto] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_sizeof] = ACTIONS(1032),
    [sym_number_literal] = ACTIONS(1034),
    [anon_sym_L_SQUOTE] = ACTIONS(1034),
    [anon_sym_u_SQUOTE] = ACTIONS(1034),
    [anon_sym_U_SQUOTE] = ACTIONS(1034),
    [anon_sym_u8_SQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [anon_sym_L_DQUOTE] = ACTIONS(1034),
    [anon_sym_u_DQUOTE] = ACTIONS(1034),
    [anon_sym_U_DQUOTE] = ACTIONS(1034),
    [anon_sym_u8_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(1046),
    [sym_identifier] = ACTIONS(1044),
    [aux_sym_preproc_include_token1] = ACTIONS(1044),
    [aux_sym_preproc_def_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1044),
    [sym_preproc_directive] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1046),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_typedef] = ACTIONS(1044),
    [anon_sym_kernel] = ACTIONS(1044),
    [anon_sym___kernel] = ACTIONS(1044),
    [anon_sym_global] = ACTIONS(1044),
    [anon_sym___global] = ACTIONS(1044),
    [anon_sym_local] = ACTIONS(1044),
    [anon_sym___local] = ACTIONS(1044),
    [anon_sym_constant] = ACTIONS(1044),
    [anon_sym___constant] = ACTIONS(1044),
    [anon_sym_private] = ACTIONS(1044),
    [anon_sym___private] = ACTIONS(1044),
    [anon_sym_generic] = ACTIONS(1044),
    [anon_sym___generic] = ACTIONS(1044),
    [anon_sym_read_only] = ACTIONS(1044),
    [anon_sym___read_only] = ACTIONS(1044),
    [anon_sym_write_only] = ACTIONS(1044),
    [anon_sym___write_only] = ACTIONS(1044),
    [anon_sym_read_write] = ACTIONS(1044),
    [anon_sym___read_write] = ACTIONS(1044),
    [anon_sym_extern] = ACTIONS(1044),
    [anon_sym___attribute__] = ACTIONS(1044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1046),
    [anon_sym___declspec] = ACTIONS(1044),
    [anon_sym___cdecl] = ACTIONS(1044),
    [anon_sym___clrcall] = ACTIONS(1044),
    [anon_sym___stdcall] = ACTIONS(1044),
    [anon_sym___fastcall] = ACTIONS(1044),
    [anon_sym___thiscall] = ACTIONS(1044),
    [anon_sym___vectorcall] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1044),
    [anon_sym_auto] = ACTIONS(1044),
    [anon_sym_register] = ACTIONS(1044),
    [anon_sym_inline] = ACTIONS(1044),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym_pipe] = ACTIONS(1044),
    [anon_sym_signed] = ACTIONS(1044),
    [anon_sym_unsigned] = ACTIONS(1044),
    [anon_sym_long] = ACTIONS(1044),
    [anon_sym_short] = ACTIONS(1044),
    [anon_sym_bool] = ACTIONS(1044),
    [anon_sym_char] = ACTIONS(1044),
    [anon_sym_uchar] = ACTIONS(1044),
    [anon_sym_ushort] = ACTIONS(1044),
    [anon_sym_int] = ACTIONS(1044),
    [anon_sym_uint] = ACTIONS(1044),
    [anon_sym_ulong] = ACTIONS(1044),
    [anon_sym_float] = ACTIONS(1044),
    [anon_sym_double] = ACTIONS(1044),
    [anon_sym_half] = ACTIONS(1044),
    [anon_sym_size_t] = ACTIONS(1044),
    [anon_sym_ptrdiff_t] = ACTIONS(1044),
    [anon_sym_intptr_t] = ACTIONS(1044),
    [anon_sym_uintptr_t] = ACTIONS(1044),
    [anon_sym_void] = ACTIONS(1044),
    [sym_vector_type] = ACTIONS(1044),
    [anon_sym_image2d_t] = ACTIONS(1044),
    [anon_sym_image3d_t] = ACTIONS(1044),
    [anon_sym_image2d_array_t] = ACTIONS(1044),
    [anon_sym_image1d_t] = ACTIONS(1044),
    [anon_sym_image1d_buffer_t] = ACTIONS(1044),
    [anon_sym_image1d_array_t] = ACTIONS(1044),
    [anon_sym_image2d_depth_t] = ACTIONS(1044),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1044),
    [anon_sym_sampler_t] = ACTIONS(1044),
    [anon_sym_queue_t] = ACTIONS(1044),
    [anon_sym_ndrange_t] = ACTIONS(1044),
    [anon_sym_clk_event_t] = ACTIONS(1044),
    [anon_sym_reserve_id_t] = ACTIONS(1044),
    [anon_sym_event_t] = ACTIONS(1044),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1044),
    [anon_sym_enum] = ACTIONS(1044),
    [anon_sym_struct] = ACTIONS(1044),
    [anon_sym_union] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_else] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_goto] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [anon_sym_sizeof] = ACTIONS(1044),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_L_SQUOTE] = ACTIONS(1046),
    [anon_sym_u_SQUOTE] = ACTIONS(1046),
    [anon_sym_U_SQUOTE] = ACTIONS(1046),
    [anon_sym_u8_SQUOTE] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_L_DQUOTE] = ACTIONS(1046),
    [anon_sym_u_DQUOTE] = ACTIONS(1046),
    [anon_sym_U_DQUOTE] = ACTIONS(1046),
    [anon_sym_u8_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(920),
    [sym_identifier] = ACTIONS(918),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(920),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(918),
    [anon_sym_kernel] = ACTIONS(918),
    [anon_sym___kernel] = ACTIONS(918),
    [anon_sym_global] = ACTIONS(918),
    [anon_sym___global] = ACTIONS(918),
    [anon_sym_local] = ACTIONS(918),
    [anon_sym___local] = ACTIONS(918),
    [anon_sym_constant] = ACTIONS(918),
    [anon_sym___constant] = ACTIONS(918),
    [anon_sym_private] = ACTIONS(918),
    [anon_sym___private] = ACTIONS(918),
    [anon_sym_generic] = ACTIONS(918),
    [anon_sym___generic] = ACTIONS(918),
    [anon_sym_read_only] = ACTIONS(918),
    [anon_sym___read_only] = ACTIONS(918),
    [anon_sym_write_only] = ACTIONS(918),
    [anon_sym___write_only] = ACTIONS(918),
    [anon_sym_read_write] = ACTIONS(918),
    [anon_sym___read_write] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym___attribute__] = ACTIONS(918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(920),
    [anon_sym___declspec] = ACTIONS(918),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_auto] = ACTIONS(918),
    [anon_sym_register] = ACTIONS(918),
    [anon_sym_inline] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_restrict] = ACTIONS(918),
    [anon_sym__Atomic] = ACTIONS(918),
    [anon_sym_pipe] = ACTIONS(918),
    [anon_sym_signed] = ACTIONS(918),
    [anon_sym_unsigned] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [anon_sym_bool] = ACTIONS(918),
    [anon_sym_char] = ACTIONS(918),
    [anon_sym_uchar] = ACTIONS(918),
    [anon_sym_ushort] = ACTIONS(918),
    [anon_sym_int] = ACTIONS(918),
    [anon_sym_uint] = ACTIONS(918),
    [anon_sym_ulong] = ACTIONS(918),
    [anon_sym_float] = ACTIONS(918),
    [anon_sym_double] = ACTIONS(918),
    [anon_sym_half] = ACTIONS(918),
    [anon_sym_size_t] = ACTIONS(918),
    [anon_sym_ptrdiff_t] = ACTIONS(918),
    [anon_sym_intptr_t] = ACTIONS(918),
    [anon_sym_uintptr_t] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(918),
    [sym_vector_type] = ACTIONS(918),
    [anon_sym_image2d_t] = ACTIONS(918),
    [anon_sym_image3d_t] = ACTIONS(918),
    [anon_sym_image2d_array_t] = ACTIONS(918),
    [anon_sym_image1d_t] = ACTIONS(918),
    [anon_sym_image1d_buffer_t] = ACTIONS(918),
    [anon_sym_image1d_array_t] = ACTIONS(918),
    [anon_sym_image2d_depth_t] = ACTIONS(918),
    [anon_sym_image2d_array_depth_t] = ACTIONS(918),
    [anon_sym_sampler_t] = ACTIONS(918),
    [anon_sym_queue_t] = ACTIONS(918),
    [anon_sym_ndrange_t] = ACTIONS(918),
    [anon_sym_clk_event_t] = ACTIONS(918),
    [anon_sym_reserve_id_t] = ACTIONS(918),
    [anon_sym_event_t] = ACTIONS(918),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_union] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_sizeof] = ACTIONS(918),
    [sym_number_literal] = ACTIONS(920),
    [anon_sym_L_SQUOTE] = ACTIONS(920),
    [anon_sym_u_SQUOTE] = ACTIONS(920),
    [anon_sym_U_SQUOTE] = ACTIONS(920),
    [anon_sym_u8_SQUOTE] = ACTIONS(920),
    [anon_sym_SQUOTE] = ACTIONS(920),
    [anon_sym_L_DQUOTE] = ACTIONS(920),
    [anon_sym_u_DQUOTE] = ACTIONS(920),
    [anon_sym_U_DQUOTE] = ACTIONS(920),
    [anon_sym_u8_DQUOTE] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_null] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [sym_identifier] = ACTIONS(1024),
    [aux_sym_preproc_include_token1] = ACTIONS(1024),
    [aux_sym_preproc_def_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1024),
    [sym_preproc_directive] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_typedef] = ACTIONS(1024),
    [anon_sym_kernel] = ACTIONS(1024),
    [anon_sym___kernel] = ACTIONS(1024),
    [anon_sym_global] = ACTIONS(1024),
    [anon_sym___global] = ACTIONS(1024),
    [anon_sym_local] = ACTIONS(1024),
    [anon_sym___local] = ACTIONS(1024),
    [anon_sym_constant] = ACTIONS(1024),
    [anon_sym___constant] = ACTIONS(1024),
    [anon_sym_private] = ACTIONS(1024),
    [anon_sym___private] = ACTIONS(1024),
    [anon_sym_generic] = ACTIONS(1024),
    [anon_sym___generic] = ACTIONS(1024),
    [anon_sym_read_only] = ACTIONS(1024),
    [anon_sym___read_only] = ACTIONS(1024),
    [anon_sym_write_only] = ACTIONS(1024),
    [anon_sym___write_only] = ACTIONS(1024),
    [anon_sym_read_write] = ACTIONS(1024),
    [anon_sym___read_write] = ACTIONS(1024),
    [anon_sym_extern] = ACTIONS(1024),
    [anon_sym___attribute__] = ACTIONS(1024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1026),
    [anon_sym___declspec] = ACTIONS(1024),
    [anon_sym___cdecl] = ACTIONS(1024),
    [anon_sym___clrcall] = ACTIONS(1024),
    [anon_sym___stdcall] = ACTIONS(1024),
    [anon_sym___fastcall] = ACTIONS(1024),
    [anon_sym___thiscall] = ACTIONS(1024),
    [anon_sym___vectorcall] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_RBRACE] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1024),
    [anon_sym_auto] = ACTIONS(1024),
    [anon_sym_register] = ACTIONS(1024),
    [anon_sym_inline] = ACTIONS(1024),
    [anon_sym_const] = ACTIONS(1024),
    [anon_sym_volatile] = ACTIONS(1024),
    [anon_sym_restrict] = ACTIONS(1024),
    [anon_sym__Atomic] = ACTIONS(1024),
    [anon_sym_pipe] = ACTIONS(1024),
    [anon_sym_signed] = ACTIONS(1024),
    [anon_sym_unsigned] = ACTIONS(1024),
    [anon_sym_long] = ACTIONS(1024),
    [anon_sym_short] = ACTIONS(1024),
    [anon_sym_bool] = ACTIONS(1024),
    [anon_sym_char] = ACTIONS(1024),
    [anon_sym_uchar] = ACTIONS(1024),
    [anon_sym_ushort] = ACTIONS(1024),
    [anon_sym_int] = ACTIONS(1024),
    [anon_sym_uint] = ACTIONS(1024),
    [anon_sym_ulong] = ACTIONS(1024),
    [anon_sym_float] = ACTIONS(1024),
    [anon_sym_double] = ACTIONS(1024),
    [anon_sym_half] = ACTIONS(1024),
    [anon_sym_size_t] = ACTIONS(1024),
    [anon_sym_ptrdiff_t] = ACTIONS(1024),
    [anon_sym_intptr_t] = ACTIONS(1024),
    [anon_sym_uintptr_t] = ACTIONS(1024),
    [anon_sym_void] = ACTIONS(1024),
    [sym_vector_type] = ACTIONS(1024),
    [anon_sym_image2d_t] = ACTIONS(1024),
    [anon_sym_image3d_t] = ACTIONS(1024),
    [anon_sym_image2d_array_t] = ACTIONS(1024),
    [anon_sym_image1d_t] = ACTIONS(1024),
    [anon_sym_image1d_buffer_t] = ACTIONS(1024),
    [anon_sym_image1d_array_t] = ACTIONS(1024),
    [anon_sym_image2d_depth_t] = ACTIONS(1024),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1024),
    [anon_sym_sampler_t] = ACTIONS(1024),
    [anon_sym_queue_t] = ACTIONS(1024),
    [anon_sym_ndrange_t] = ACTIONS(1024),
    [anon_sym_clk_event_t] = ACTIONS(1024),
    [anon_sym_reserve_id_t] = ACTIONS(1024),
    [anon_sym_event_t] = ACTIONS(1024),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1024),
    [anon_sym_enum] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_union] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1024),
    [anon_sym_default] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_goto] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_sizeof] = ACTIONS(1024),
    [sym_number_literal] = ACTIONS(1026),
    [anon_sym_L_SQUOTE] = ACTIONS(1026),
    [anon_sym_u_SQUOTE] = ACTIONS(1026),
    [anon_sym_U_SQUOTE] = ACTIONS(1026),
    [anon_sym_u8_SQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1024),
    [sym_false] = ACTIONS(1024),
    [sym_null] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_kernel] = ACTIONS(910),
    [anon_sym___kernel] = ACTIONS(910),
    [anon_sym_global] = ACTIONS(910),
    [anon_sym___global] = ACTIONS(910),
    [anon_sym_local] = ACTIONS(910),
    [anon_sym___local] = ACTIONS(910),
    [anon_sym_constant] = ACTIONS(910),
    [anon_sym___constant] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym___private] = ACTIONS(910),
    [anon_sym_generic] = ACTIONS(910),
    [anon_sym___generic] = ACTIONS(910),
    [anon_sym_read_only] = ACTIONS(910),
    [anon_sym___read_only] = ACTIONS(910),
    [anon_sym_write_only] = ACTIONS(910),
    [anon_sym___write_only] = ACTIONS(910),
    [anon_sym_read_write] = ACTIONS(910),
    [anon_sym___read_write] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(912),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_pipe] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [anon_sym_bool] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_uchar] = ACTIONS(910),
    [anon_sym_ushort] = ACTIONS(910),
    [anon_sym_int] = ACTIONS(910),
    [anon_sym_uint] = ACTIONS(910),
    [anon_sym_ulong] = ACTIONS(910),
    [anon_sym_float] = ACTIONS(910),
    [anon_sym_double] = ACTIONS(910),
    [anon_sym_half] = ACTIONS(910),
    [anon_sym_size_t] = ACTIONS(910),
    [anon_sym_ptrdiff_t] = ACTIONS(910),
    [anon_sym_intptr_t] = ACTIONS(910),
    [anon_sym_uintptr_t] = ACTIONS(910),
    [anon_sym_void] = ACTIONS(910),
    [sym_vector_type] = ACTIONS(910),
    [anon_sym_image2d_t] = ACTIONS(910),
    [anon_sym_image3d_t] = ACTIONS(910),
    [anon_sym_image2d_array_t] = ACTIONS(910),
    [anon_sym_image1d_t] = ACTIONS(910),
    [anon_sym_image1d_buffer_t] = ACTIONS(910),
    [anon_sym_image1d_array_t] = ACTIONS(910),
    [anon_sym_image2d_depth_t] = ACTIONS(910),
    [anon_sym_image2d_array_depth_t] = ACTIONS(910),
    [anon_sym_sampler_t] = ACTIONS(910),
    [anon_sym_queue_t] = ACTIONS(910),
    [anon_sym_ndrange_t] = ACTIONS(910),
    [anon_sym_clk_event_t] = ACTIONS(910),
    [anon_sym_reserve_id_t] = ACTIONS(910),
    [anon_sym_event_t] = ACTIONS(910),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_identifier] = ACTIONS(1020),
    [aux_sym_preproc_include_token1] = ACTIONS(1020),
    [aux_sym_preproc_def_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token2] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1020),
    [sym_preproc_directive] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_AMP] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [anon_sym_typedef] = ACTIONS(1020),
    [anon_sym_kernel] = ACTIONS(1020),
    [anon_sym___kernel] = ACTIONS(1020),
    [anon_sym_global] = ACTIONS(1020),
    [anon_sym___global] = ACTIONS(1020),
    [anon_sym_local] = ACTIONS(1020),
    [anon_sym___local] = ACTIONS(1020),
    [anon_sym_constant] = ACTIONS(1020),
    [anon_sym___constant] = ACTIONS(1020),
    [anon_sym_private] = ACTIONS(1020),
    [anon_sym___private] = ACTIONS(1020),
    [anon_sym_generic] = ACTIONS(1020),
    [anon_sym___generic] = ACTIONS(1020),
    [anon_sym_read_only] = ACTIONS(1020),
    [anon_sym___read_only] = ACTIONS(1020),
    [anon_sym_write_only] = ACTIONS(1020),
    [anon_sym___write_only] = ACTIONS(1020),
    [anon_sym_read_write] = ACTIONS(1020),
    [anon_sym___read_write] = ACTIONS(1020),
    [anon_sym_extern] = ACTIONS(1020),
    [anon_sym___attribute__] = ACTIONS(1020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1022),
    [anon_sym___declspec] = ACTIONS(1020),
    [anon_sym___cdecl] = ACTIONS(1020),
    [anon_sym___clrcall] = ACTIONS(1020),
    [anon_sym___stdcall] = ACTIONS(1020),
    [anon_sym___fastcall] = ACTIONS(1020),
    [anon_sym___thiscall] = ACTIONS(1020),
    [anon_sym___vectorcall] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_auto] = ACTIONS(1020),
    [anon_sym_register] = ACTIONS(1020),
    [anon_sym_inline] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_volatile] = ACTIONS(1020),
    [anon_sym_restrict] = ACTIONS(1020),
    [anon_sym__Atomic] = ACTIONS(1020),
    [anon_sym_pipe] = ACTIONS(1020),
    [anon_sym_signed] = ACTIONS(1020),
    [anon_sym_unsigned] = ACTIONS(1020),
    [anon_sym_long] = ACTIONS(1020),
    [anon_sym_short] = ACTIONS(1020),
    [anon_sym_bool] = ACTIONS(1020),
    [anon_sym_char] = ACTIONS(1020),
    [anon_sym_uchar] = ACTIONS(1020),
    [anon_sym_ushort] = ACTIONS(1020),
    [anon_sym_int] = ACTIONS(1020),
    [anon_sym_uint] = ACTIONS(1020),
    [anon_sym_ulong] = ACTIONS(1020),
    [anon_sym_float] = ACTIONS(1020),
    [anon_sym_double] = ACTIONS(1020),
    [anon_sym_half] = ACTIONS(1020),
    [anon_sym_size_t] = ACTIONS(1020),
    [anon_sym_ptrdiff_t] = ACTIONS(1020),
    [anon_sym_intptr_t] = ACTIONS(1020),
    [anon_sym_uintptr_t] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1020),
    [sym_vector_type] = ACTIONS(1020),
    [anon_sym_image2d_t] = ACTIONS(1020),
    [anon_sym_image3d_t] = ACTIONS(1020),
    [anon_sym_image2d_array_t] = ACTIONS(1020),
    [anon_sym_image1d_t] = ACTIONS(1020),
    [anon_sym_image1d_buffer_t] = ACTIONS(1020),
    [anon_sym_image1d_array_t] = ACTIONS(1020),
    [anon_sym_image2d_depth_t] = ACTIONS(1020),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1020),
    [anon_sym_sampler_t] = ACTIONS(1020),
    [anon_sym_queue_t] = ACTIONS(1020),
    [anon_sym_ndrange_t] = ACTIONS(1020),
    [anon_sym_clk_event_t] = ACTIONS(1020),
    [anon_sym_reserve_id_t] = ACTIONS(1020),
    [anon_sym_event_t] = ACTIONS(1020),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_union] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_goto] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [anon_sym_sizeof] = ACTIONS(1020),
    [sym_number_literal] = ACTIONS(1022),
    [anon_sym_L_SQUOTE] = ACTIONS(1022),
    [anon_sym_u_SQUOTE] = ACTIONS(1022),
    [anon_sym_U_SQUOTE] = ACTIONS(1022),
    [anon_sym_u8_SQUOTE] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [anon_sym_L_DQUOTE] = ACTIONS(1022),
    [anon_sym_u_DQUOTE] = ACTIONS(1022),
    [anon_sym_U_DQUOTE] = ACTIONS(1022),
    [anon_sym_u8_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_identifier] = ACTIONS(946),
    [aux_sym_preproc_include_token1] = ACTIONS(946),
    [aux_sym_preproc_def_token1] = ACTIONS(946),
    [aux_sym_preproc_if_token1] = ACTIONS(946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(946),
    [sym_preproc_directive] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(948),
    [anon_sym_AMP] = ACTIONS(948),
    [anon_sym_SEMI] = ACTIONS(948),
    [anon_sym_typedef] = ACTIONS(946),
    [anon_sym_kernel] = ACTIONS(946),
    [anon_sym___kernel] = ACTIONS(946),
    [anon_sym_global] = ACTIONS(946),
    [anon_sym___global] = ACTIONS(946),
    [anon_sym_local] = ACTIONS(946),
    [anon_sym___local] = ACTIONS(946),
    [anon_sym_constant] = ACTIONS(946),
    [anon_sym___constant] = ACTIONS(946),
    [anon_sym_private] = ACTIONS(946),
    [anon_sym___private] = ACTIONS(946),
    [anon_sym_generic] = ACTIONS(946),
    [anon_sym___generic] = ACTIONS(946),
    [anon_sym_read_only] = ACTIONS(946),
    [anon_sym___read_only] = ACTIONS(946),
    [anon_sym_write_only] = ACTIONS(946),
    [anon_sym___write_only] = ACTIONS(946),
    [anon_sym_read_write] = ACTIONS(946),
    [anon_sym___read_write] = ACTIONS(946),
    [anon_sym_extern] = ACTIONS(946),
    [anon_sym___attribute__] = ACTIONS(946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(948),
    [anon_sym___declspec] = ACTIONS(946),
    [anon_sym___cdecl] = ACTIONS(946),
    [anon_sym___clrcall] = ACTIONS(946),
    [anon_sym___stdcall] = ACTIONS(946),
    [anon_sym___fastcall] = ACTIONS(946),
    [anon_sym___thiscall] = ACTIONS(946),
    [anon_sym___vectorcall] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_RBRACE] = ACTIONS(948),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_auto] = ACTIONS(946),
    [anon_sym_register] = ACTIONS(946),
    [anon_sym_inline] = ACTIONS(946),
    [anon_sym_const] = ACTIONS(946),
    [anon_sym_volatile] = ACTIONS(946),
    [anon_sym_restrict] = ACTIONS(946),
    [anon_sym__Atomic] = ACTIONS(946),
    [anon_sym_pipe] = ACTIONS(946),
    [anon_sym_signed] = ACTIONS(946),
    [anon_sym_unsigned] = ACTIONS(946),
    [anon_sym_long] = ACTIONS(946),
    [anon_sym_short] = ACTIONS(946),
    [anon_sym_bool] = ACTIONS(946),
    [anon_sym_char] = ACTIONS(946),
    [anon_sym_uchar] = ACTIONS(946),
    [anon_sym_ushort] = ACTIONS(946),
    [anon_sym_int] = ACTIONS(946),
    [anon_sym_uint] = ACTIONS(946),
    [anon_sym_ulong] = ACTIONS(946),
    [anon_sym_float] = ACTIONS(946),
    [anon_sym_double] = ACTIONS(946),
    [anon_sym_half] = ACTIONS(946),
    [anon_sym_size_t] = ACTIONS(946),
    [anon_sym_ptrdiff_t] = ACTIONS(946),
    [anon_sym_intptr_t] = ACTIONS(946),
    [anon_sym_uintptr_t] = ACTIONS(946),
    [anon_sym_void] = ACTIONS(946),
    [sym_vector_type] = ACTIONS(946),
    [anon_sym_image2d_t] = ACTIONS(946),
    [anon_sym_image3d_t] = ACTIONS(946),
    [anon_sym_image2d_array_t] = ACTIONS(946),
    [anon_sym_image1d_t] = ACTIONS(946),
    [anon_sym_image1d_buffer_t] = ACTIONS(946),
    [anon_sym_image1d_array_t] = ACTIONS(946),
    [anon_sym_image2d_depth_t] = ACTIONS(946),
    [anon_sym_image2d_array_depth_t] = ACTIONS(946),
    [anon_sym_sampler_t] = ACTIONS(946),
    [anon_sym_queue_t] = ACTIONS(946),
    [anon_sym_ndrange_t] = ACTIONS(946),
    [anon_sym_clk_event_t] = ACTIONS(946),
    [anon_sym_reserve_id_t] = ACTIONS(946),
    [anon_sym_event_t] = ACTIONS(946),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_struct] = ACTIONS(946),
    [anon_sym_union] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(946),
    [anon_sym_default] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_break] = ACTIONS(946),
    [anon_sym_continue] = ACTIONS(946),
    [anon_sym_goto] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(948),
    [anon_sym_sizeof] = ACTIONS(946),
    [sym_number_literal] = ACTIONS(948),
    [anon_sym_L_SQUOTE] = ACTIONS(948),
    [anon_sym_u_SQUOTE] = ACTIONS(948),
    [anon_sym_U_SQUOTE] = ACTIONS(948),
    [anon_sym_u8_SQUOTE] = ACTIONS(948),
    [anon_sym_SQUOTE] = ACTIONS(948),
    [anon_sym_L_DQUOTE] = ACTIONS(948),
    [anon_sym_u_DQUOTE] = ACTIONS(948),
    [anon_sym_U_DQUOTE] = ACTIONS(948),
    [anon_sym_u8_DQUOTE] = ACTIONS(948),
    [anon_sym_DQUOTE] = ACTIONS(948),
    [sym_true] = ACTIONS(946),
    [sym_false] = ACTIONS(946),
    [sym_null] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_identifier] = ACTIONS(1016),
    [aux_sym_preproc_include_token1] = ACTIONS(1016),
    [aux_sym_preproc_def_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token2] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1016),
    [sym_preproc_directive] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_typedef] = ACTIONS(1016),
    [anon_sym_kernel] = ACTIONS(1016),
    [anon_sym___kernel] = ACTIONS(1016),
    [anon_sym_global] = ACTIONS(1016),
    [anon_sym___global] = ACTIONS(1016),
    [anon_sym_local] = ACTIONS(1016),
    [anon_sym___local] = ACTIONS(1016),
    [anon_sym_constant] = ACTIONS(1016),
    [anon_sym___constant] = ACTIONS(1016),
    [anon_sym_private] = ACTIONS(1016),
    [anon_sym___private] = ACTIONS(1016),
    [anon_sym_generic] = ACTIONS(1016),
    [anon_sym___generic] = ACTIONS(1016),
    [anon_sym_read_only] = ACTIONS(1016),
    [anon_sym___read_only] = ACTIONS(1016),
    [anon_sym_write_only] = ACTIONS(1016),
    [anon_sym___write_only] = ACTIONS(1016),
    [anon_sym_read_write] = ACTIONS(1016),
    [anon_sym___read_write] = ACTIONS(1016),
    [anon_sym_extern] = ACTIONS(1016),
    [anon_sym___attribute__] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1018),
    [anon_sym___declspec] = ACTIONS(1016),
    [anon_sym___cdecl] = ACTIONS(1016),
    [anon_sym___clrcall] = ACTIONS(1016),
    [anon_sym___stdcall] = ACTIONS(1016),
    [anon_sym___fastcall] = ACTIONS(1016),
    [anon_sym___thiscall] = ACTIONS(1016),
    [anon_sym___vectorcall] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_auto] = ACTIONS(1016),
    [anon_sym_register] = ACTIONS(1016),
    [anon_sym_inline] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_volatile] = ACTIONS(1016),
    [anon_sym_restrict] = ACTIONS(1016),
    [anon_sym__Atomic] = ACTIONS(1016),
    [anon_sym_pipe] = ACTIONS(1016),
    [anon_sym_signed] = ACTIONS(1016),
    [anon_sym_unsigned] = ACTIONS(1016),
    [anon_sym_long] = ACTIONS(1016),
    [anon_sym_short] = ACTIONS(1016),
    [anon_sym_bool] = ACTIONS(1016),
    [anon_sym_char] = ACTIONS(1016),
    [anon_sym_uchar] = ACTIONS(1016),
    [anon_sym_ushort] = ACTIONS(1016),
    [anon_sym_int] = ACTIONS(1016),
    [anon_sym_uint] = ACTIONS(1016),
    [anon_sym_ulong] = ACTIONS(1016),
    [anon_sym_float] = ACTIONS(1016),
    [anon_sym_double] = ACTIONS(1016),
    [anon_sym_half] = ACTIONS(1016),
    [anon_sym_size_t] = ACTIONS(1016),
    [anon_sym_ptrdiff_t] = ACTIONS(1016),
    [anon_sym_intptr_t] = ACTIONS(1016),
    [anon_sym_uintptr_t] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1016),
    [sym_vector_type] = ACTIONS(1016),
    [anon_sym_image2d_t] = ACTIONS(1016),
    [anon_sym_image3d_t] = ACTIONS(1016),
    [anon_sym_image2d_array_t] = ACTIONS(1016),
    [anon_sym_image1d_t] = ACTIONS(1016),
    [anon_sym_image1d_buffer_t] = ACTIONS(1016),
    [anon_sym_image1d_array_t] = ACTIONS(1016),
    [anon_sym_image2d_depth_t] = ACTIONS(1016),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1016),
    [anon_sym_sampler_t] = ACTIONS(1016),
    [anon_sym_queue_t] = ACTIONS(1016),
    [anon_sym_ndrange_t] = ACTIONS(1016),
    [anon_sym_clk_event_t] = ACTIONS(1016),
    [anon_sym_reserve_id_t] = ACTIONS(1016),
    [anon_sym_event_t] = ACTIONS(1016),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_goto] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_sizeof] = ACTIONS(1016),
    [sym_number_literal] = ACTIONS(1018),
    [anon_sym_L_SQUOTE] = ACTIONS(1018),
    [anon_sym_u_SQUOTE] = ACTIONS(1018),
    [anon_sym_U_SQUOTE] = ACTIONS(1018),
    [anon_sym_u8_SQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [anon_sym_L_DQUOTE] = ACTIONS(1018),
    [anon_sym_u_DQUOTE] = ACTIONS(1018),
    [anon_sym_U_DQUOTE] = ACTIONS(1018),
    [anon_sym_u8_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_null] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_identifier] = ACTIONS(914),
    [aux_sym_preproc_include_token1] = ACTIONS(914),
    [aux_sym_preproc_def_token1] = ACTIONS(914),
    [aux_sym_preproc_if_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(914),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(914),
    [sym_preproc_directive] = ACTIONS(914),
    [anon_sym_LPAREN2] = ACTIONS(916),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(916),
    [anon_sym_AMP] = ACTIONS(916),
    [anon_sym_SEMI] = ACTIONS(916),
    [anon_sym_typedef] = ACTIONS(914),
    [anon_sym_kernel] = ACTIONS(914),
    [anon_sym___kernel] = ACTIONS(914),
    [anon_sym_global] = ACTIONS(914),
    [anon_sym___global] = ACTIONS(914),
    [anon_sym_local] = ACTIONS(914),
    [anon_sym___local] = ACTIONS(914),
    [anon_sym_constant] = ACTIONS(914),
    [anon_sym___constant] = ACTIONS(914),
    [anon_sym_private] = ACTIONS(914),
    [anon_sym___private] = ACTIONS(914),
    [anon_sym_generic] = ACTIONS(914),
    [anon_sym___generic] = ACTIONS(914),
    [anon_sym_read_only] = ACTIONS(914),
    [anon_sym___read_only] = ACTIONS(914),
    [anon_sym_write_only] = ACTIONS(914),
    [anon_sym___write_only] = ACTIONS(914),
    [anon_sym_read_write] = ACTIONS(914),
    [anon_sym___read_write] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym___attribute__] = ACTIONS(914),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(916),
    [anon_sym___declspec] = ACTIONS(914),
    [anon_sym___cdecl] = ACTIONS(914),
    [anon_sym___clrcall] = ACTIONS(914),
    [anon_sym___stdcall] = ACTIONS(914),
    [anon_sym___fastcall] = ACTIONS(914),
    [anon_sym___thiscall] = ACTIONS(914),
    [anon_sym___vectorcall] = ACTIONS(914),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_RBRACE] = ACTIONS(916),
    [anon_sym_static] = ACTIONS(914),
    [anon_sym_auto] = ACTIONS(914),
    [anon_sym_register] = ACTIONS(914),
    [anon_sym_inline] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_volatile] = ACTIONS(914),
    [anon_sym_restrict] = ACTIONS(914),
    [anon_sym__Atomic] = ACTIONS(914),
    [anon_sym_pipe] = ACTIONS(914),
    [anon_sym_signed] = ACTIONS(914),
    [anon_sym_unsigned] = ACTIONS(914),
    [anon_sym_long] = ACTIONS(914),
    [anon_sym_short] = ACTIONS(914),
    [anon_sym_bool] = ACTIONS(914),
    [anon_sym_char] = ACTIONS(914),
    [anon_sym_uchar] = ACTIONS(914),
    [anon_sym_ushort] = ACTIONS(914),
    [anon_sym_int] = ACTIONS(914),
    [anon_sym_uint] = ACTIONS(914),
    [anon_sym_ulong] = ACTIONS(914),
    [anon_sym_float] = ACTIONS(914),
    [anon_sym_double] = ACTIONS(914),
    [anon_sym_half] = ACTIONS(914),
    [anon_sym_size_t] = ACTIONS(914),
    [anon_sym_ptrdiff_t] = ACTIONS(914),
    [anon_sym_intptr_t] = ACTIONS(914),
    [anon_sym_uintptr_t] = ACTIONS(914),
    [anon_sym_void] = ACTIONS(914),
    [sym_vector_type] = ACTIONS(914),
    [anon_sym_image2d_t] = ACTIONS(914),
    [anon_sym_image3d_t] = ACTIONS(914),
    [anon_sym_image2d_array_t] = ACTIONS(914),
    [anon_sym_image1d_t] = ACTIONS(914),
    [anon_sym_image1d_buffer_t] = ACTIONS(914),
    [anon_sym_image1d_array_t] = ACTIONS(914),
    [anon_sym_image2d_depth_t] = ACTIONS(914),
    [anon_sym_image2d_array_depth_t] = ACTIONS(914),
    [anon_sym_sampler_t] = ACTIONS(914),
    [anon_sym_queue_t] = ACTIONS(914),
    [anon_sym_ndrange_t] = ACTIONS(914),
    [anon_sym_clk_event_t] = ACTIONS(914),
    [anon_sym_reserve_id_t] = ACTIONS(914),
    [anon_sym_event_t] = ACTIONS(914),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_union] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_switch] = ACTIONS(914),
    [anon_sym_case] = ACTIONS(914),
    [anon_sym_default] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_do] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_goto] = ACTIONS(914),
    [anon_sym_DASH_DASH] = ACTIONS(916),
    [anon_sym_PLUS_PLUS] = ACTIONS(916),
    [anon_sym_sizeof] = ACTIONS(914),
    [sym_number_literal] = ACTIONS(916),
    [anon_sym_L_SQUOTE] = ACTIONS(916),
    [anon_sym_u_SQUOTE] = ACTIONS(916),
    [anon_sym_U_SQUOTE] = ACTIONS(916),
    [anon_sym_u8_SQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [anon_sym_L_DQUOTE] = ACTIONS(916),
    [anon_sym_u_DQUOTE] = ACTIONS(916),
    [anon_sym_U_DQUOTE] = ACTIONS(916),
    [anon_sym_u8_DQUOTE] = ACTIONS(916),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_null] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_identifier] = ACTIONS(988),
    [aux_sym_preproc_include_token1] = ACTIONS(988),
    [aux_sym_preproc_def_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token2] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(988),
    [sym_preproc_directive] = ACTIONS(988),
    [anon_sym_LPAREN2] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_typedef] = ACTIONS(988),
    [anon_sym_kernel] = ACTIONS(988),
    [anon_sym___kernel] = ACTIONS(988),
    [anon_sym_global] = ACTIONS(988),
    [anon_sym___global] = ACTIONS(988),
    [anon_sym_local] = ACTIONS(988),
    [anon_sym___local] = ACTIONS(988),
    [anon_sym_constant] = ACTIONS(988),
    [anon_sym___constant] = ACTIONS(988),
    [anon_sym_private] = ACTIONS(988),
    [anon_sym___private] = ACTIONS(988),
    [anon_sym_generic] = ACTIONS(988),
    [anon_sym___generic] = ACTIONS(988),
    [anon_sym_read_only] = ACTIONS(988),
    [anon_sym___read_only] = ACTIONS(988),
    [anon_sym_write_only] = ACTIONS(988),
    [anon_sym___write_only] = ACTIONS(988),
    [anon_sym_read_write] = ACTIONS(988),
    [anon_sym___read_write] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym___attribute__] = ACTIONS(988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(990),
    [anon_sym___declspec] = ACTIONS(988),
    [anon_sym___cdecl] = ACTIONS(988),
    [anon_sym___clrcall] = ACTIONS(988),
    [anon_sym___stdcall] = ACTIONS(988),
    [anon_sym___fastcall] = ACTIONS(988),
    [anon_sym___thiscall] = ACTIONS(988),
    [anon_sym___vectorcall] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_auto] = ACTIONS(988),
    [anon_sym_register] = ACTIONS(988),
    [anon_sym_inline] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_volatile] = ACTIONS(988),
    [anon_sym_restrict] = ACTIONS(988),
    [anon_sym__Atomic] = ACTIONS(988),
    [anon_sym_pipe] = ACTIONS(988),
    [anon_sym_signed] = ACTIONS(988),
    [anon_sym_unsigned] = ACTIONS(988),
    [anon_sym_long] = ACTIONS(988),
    [anon_sym_short] = ACTIONS(988),
    [anon_sym_bool] = ACTIONS(988),
    [anon_sym_char] = ACTIONS(988),
    [anon_sym_uchar] = ACTIONS(988),
    [anon_sym_ushort] = ACTIONS(988),
    [anon_sym_int] = ACTIONS(988),
    [anon_sym_uint] = ACTIONS(988),
    [anon_sym_ulong] = ACTIONS(988),
    [anon_sym_float] = ACTIONS(988),
    [anon_sym_double] = ACTIONS(988),
    [anon_sym_half] = ACTIONS(988),
    [anon_sym_size_t] = ACTIONS(988),
    [anon_sym_ptrdiff_t] = ACTIONS(988),
    [anon_sym_intptr_t] = ACTIONS(988),
    [anon_sym_uintptr_t] = ACTIONS(988),
    [anon_sym_void] = ACTIONS(988),
    [sym_vector_type] = ACTIONS(988),
    [anon_sym_image2d_t] = ACTIONS(988),
    [anon_sym_image3d_t] = ACTIONS(988),
    [anon_sym_image2d_array_t] = ACTIONS(988),
    [anon_sym_image1d_t] = ACTIONS(988),
    [anon_sym_image1d_buffer_t] = ACTIONS(988),
    [anon_sym_image1d_array_t] = ACTIONS(988),
    [anon_sym_image2d_depth_t] = ACTIONS(988),
    [anon_sym_image2d_array_depth_t] = ACTIONS(988),
    [anon_sym_sampler_t] = ACTIONS(988),
    [anon_sym_queue_t] = ACTIONS(988),
    [anon_sym_ndrange_t] = ACTIONS(988),
    [anon_sym_clk_event_t] = ACTIONS(988),
    [anon_sym_reserve_id_t] = ACTIONS(988),
    [anon_sym_event_t] = ACTIONS(988),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_struct] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_goto] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(990),
    [anon_sym_PLUS_PLUS] = ACTIONS(990),
    [anon_sym_sizeof] = ACTIONS(988),
    [sym_number_literal] = ACTIONS(990),
    [anon_sym_L_SQUOTE] = ACTIONS(990),
    [anon_sym_u_SQUOTE] = ACTIONS(990),
    [anon_sym_U_SQUOTE] = ACTIONS(990),
    [anon_sym_u8_SQUOTE] = ACTIONS(990),
    [anon_sym_SQUOTE] = ACTIONS(990),
    [anon_sym_L_DQUOTE] = ACTIONS(990),
    [anon_sym_u_DQUOTE] = ACTIONS(990),
    [anon_sym_U_DQUOTE] = ACTIONS(990),
    [anon_sym_u8_DQUOTE] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_identifier] = ACTIONS(950),
    [aux_sym_preproc_include_token1] = ACTIONS(950),
    [aux_sym_preproc_def_token1] = ACTIONS(950),
    [aux_sym_preproc_if_token1] = ACTIONS(950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(950),
    [sym_preproc_directive] = ACTIONS(950),
    [anon_sym_LPAREN2] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(952),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(952),
    [anon_sym_AMP] = ACTIONS(952),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_typedef] = ACTIONS(950),
    [anon_sym_kernel] = ACTIONS(950),
    [anon_sym___kernel] = ACTIONS(950),
    [anon_sym_global] = ACTIONS(950),
    [anon_sym___global] = ACTIONS(950),
    [anon_sym_local] = ACTIONS(950),
    [anon_sym___local] = ACTIONS(950),
    [anon_sym_constant] = ACTIONS(950),
    [anon_sym___constant] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym___private] = ACTIONS(950),
    [anon_sym_generic] = ACTIONS(950),
    [anon_sym___generic] = ACTIONS(950),
    [anon_sym_read_only] = ACTIONS(950),
    [anon_sym___read_only] = ACTIONS(950),
    [anon_sym_write_only] = ACTIONS(950),
    [anon_sym___write_only] = ACTIONS(950),
    [anon_sym_read_write] = ACTIONS(950),
    [anon_sym___read_write] = ACTIONS(950),
    [anon_sym_extern] = ACTIONS(950),
    [anon_sym___attribute__] = ACTIONS(950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(952),
    [anon_sym___declspec] = ACTIONS(950),
    [anon_sym___cdecl] = ACTIONS(950),
    [anon_sym___clrcall] = ACTIONS(950),
    [anon_sym___stdcall] = ACTIONS(950),
    [anon_sym___fastcall] = ACTIONS(950),
    [anon_sym___thiscall] = ACTIONS(950),
    [anon_sym___vectorcall] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(952),
    [anon_sym_RBRACE] = ACTIONS(952),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_auto] = ACTIONS(950),
    [anon_sym_register] = ACTIONS(950),
    [anon_sym_inline] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(950),
    [anon_sym_volatile] = ACTIONS(950),
    [anon_sym_restrict] = ACTIONS(950),
    [anon_sym__Atomic] = ACTIONS(950),
    [anon_sym_pipe] = ACTIONS(950),
    [anon_sym_signed] = ACTIONS(950),
    [anon_sym_unsigned] = ACTIONS(950),
    [anon_sym_long] = ACTIONS(950),
    [anon_sym_short] = ACTIONS(950),
    [anon_sym_bool] = ACTIONS(950),
    [anon_sym_char] = ACTIONS(950),
    [anon_sym_uchar] = ACTIONS(950),
    [anon_sym_ushort] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(950),
    [anon_sym_uint] = ACTIONS(950),
    [anon_sym_ulong] = ACTIONS(950),
    [anon_sym_float] = ACTIONS(950),
    [anon_sym_double] = ACTIONS(950),
    [anon_sym_half] = ACTIONS(950),
    [anon_sym_size_t] = ACTIONS(950),
    [anon_sym_ptrdiff_t] = ACTIONS(950),
    [anon_sym_intptr_t] = ACTIONS(950),
    [anon_sym_uintptr_t] = ACTIONS(950),
    [anon_sym_void] = ACTIONS(950),
    [sym_vector_type] = ACTIONS(950),
    [anon_sym_image2d_t] = ACTIONS(950),
    [anon_sym_image3d_t] = ACTIONS(950),
    [anon_sym_image2d_array_t] = ACTIONS(950),
    [anon_sym_image1d_t] = ACTIONS(950),
    [anon_sym_image1d_buffer_t] = ACTIONS(950),
    [anon_sym_image1d_array_t] = ACTIONS(950),
    [anon_sym_image2d_depth_t] = ACTIONS(950),
    [anon_sym_image2d_array_depth_t] = ACTIONS(950),
    [anon_sym_sampler_t] = ACTIONS(950),
    [anon_sym_queue_t] = ACTIONS(950),
    [anon_sym_ndrange_t] = ACTIONS(950),
    [anon_sym_clk_event_t] = ACTIONS(950),
    [anon_sym_reserve_id_t] = ACTIONS(950),
    [anon_sym_event_t] = ACTIONS(950),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_struct] = ACTIONS(950),
    [anon_sym_union] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(950),
    [anon_sym_else] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(950),
    [anon_sym_case] = ACTIONS(950),
    [anon_sym_default] = ACTIONS(950),
    [anon_sym_while] = ACTIONS(950),
    [anon_sym_do] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(950),
    [anon_sym_return] = ACTIONS(950),
    [anon_sym_break] = ACTIONS(950),
    [anon_sym_continue] = ACTIONS(950),
    [anon_sym_goto] = ACTIONS(950),
    [anon_sym_DASH_DASH] = ACTIONS(952),
    [anon_sym_PLUS_PLUS] = ACTIONS(952),
    [anon_sym_sizeof] = ACTIONS(950),
    [sym_number_literal] = ACTIONS(952),
    [anon_sym_L_SQUOTE] = ACTIONS(952),
    [anon_sym_u_SQUOTE] = ACTIONS(952),
    [anon_sym_U_SQUOTE] = ACTIONS(952),
    [anon_sym_u8_SQUOTE] = ACTIONS(952),
    [anon_sym_SQUOTE] = ACTIONS(952),
    [anon_sym_L_DQUOTE] = ACTIONS(952),
    [anon_sym_u_DQUOTE] = ACTIONS(952),
    [anon_sym_U_DQUOTE] = ACTIONS(952),
    [anon_sym_u8_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(952),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_null] = ACTIONS(950),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_identifier] = ACTIONS(980),
    [aux_sym_preproc_include_token1] = ACTIONS(980),
    [aux_sym_preproc_def_token1] = ACTIONS(980),
    [aux_sym_preproc_if_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(980),
    [sym_preproc_directive] = ACTIONS(980),
    [anon_sym_LPAREN2] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(982),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(982),
    [anon_sym_SEMI] = ACTIONS(982),
    [anon_sym_typedef] = ACTIONS(980),
    [anon_sym_kernel] = ACTIONS(980),
    [anon_sym___kernel] = ACTIONS(980),
    [anon_sym_global] = ACTIONS(980),
    [anon_sym___global] = ACTIONS(980),
    [anon_sym_local] = ACTIONS(980),
    [anon_sym___local] = ACTIONS(980),
    [anon_sym_constant] = ACTIONS(980),
    [anon_sym___constant] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym___private] = ACTIONS(980),
    [anon_sym_generic] = ACTIONS(980),
    [anon_sym___generic] = ACTIONS(980),
    [anon_sym_read_only] = ACTIONS(980),
    [anon_sym___read_only] = ACTIONS(980),
    [anon_sym_write_only] = ACTIONS(980),
    [anon_sym___write_only] = ACTIONS(980),
    [anon_sym_read_write] = ACTIONS(980),
    [anon_sym___read_write] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym___attribute__] = ACTIONS(980),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(982),
    [anon_sym___declspec] = ACTIONS(980),
    [anon_sym___cdecl] = ACTIONS(980),
    [anon_sym___clrcall] = ACTIONS(980),
    [anon_sym___stdcall] = ACTIONS(980),
    [anon_sym___fastcall] = ACTIONS(980),
    [anon_sym___thiscall] = ACTIONS(980),
    [anon_sym___vectorcall] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_RBRACE] = ACTIONS(982),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_auto] = ACTIONS(980),
    [anon_sym_register] = ACTIONS(980),
    [anon_sym_inline] = ACTIONS(980),
    [anon_sym_const] = ACTIONS(980),
    [anon_sym_volatile] = ACTIONS(980),
    [anon_sym_restrict] = ACTIONS(980),
    [anon_sym__Atomic] = ACTIONS(980),
    [anon_sym_pipe] = ACTIONS(980),
    [anon_sym_signed] = ACTIONS(980),
    [anon_sym_unsigned] = ACTIONS(980),
    [anon_sym_long] = ACTIONS(980),
    [anon_sym_short] = ACTIONS(980),
    [anon_sym_bool] = ACTIONS(980),
    [anon_sym_char] = ACTIONS(980),
    [anon_sym_uchar] = ACTIONS(980),
    [anon_sym_ushort] = ACTIONS(980),
    [anon_sym_int] = ACTIONS(980),
    [anon_sym_uint] = ACTIONS(980),
    [anon_sym_ulong] = ACTIONS(980),
    [anon_sym_float] = ACTIONS(980),
    [anon_sym_double] = ACTIONS(980),
    [anon_sym_half] = ACTIONS(980),
    [anon_sym_size_t] = ACTIONS(980),
    [anon_sym_ptrdiff_t] = ACTIONS(980),
    [anon_sym_intptr_t] = ACTIONS(980),
    [anon_sym_uintptr_t] = ACTIONS(980),
    [anon_sym_void] = ACTIONS(980),
    [sym_vector_type] = ACTIONS(980),
    [anon_sym_image2d_t] = ACTIONS(980),
    [anon_sym_image3d_t] = ACTIONS(980),
    [anon_sym_image2d_array_t] = ACTIONS(980),
    [anon_sym_image1d_t] = ACTIONS(980),
    [anon_sym_image1d_buffer_t] = ACTIONS(980),
    [anon_sym_image1d_array_t] = ACTIONS(980),
    [anon_sym_image2d_depth_t] = ACTIONS(980),
    [anon_sym_image2d_array_depth_t] = ACTIONS(980),
    [anon_sym_sampler_t] = ACTIONS(980),
    [anon_sym_queue_t] = ACTIONS(980),
    [anon_sym_ndrange_t] = ACTIONS(980),
    [anon_sym_clk_event_t] = ACTIONS(980),
    [anon_sym_reserve_id_t] = ACTIONS(980),
    [anon_sym_event_t] = ACTIONS(980),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_struct] = ACTIONS(980),
    [anon_sym_union] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(980),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_do] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_goto] = ACTIONS(980),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_sizeof] = ACTIONS(980),
    [sym_number_literal] = ACTIONS(982),
    [anon_sym_L_SQUOTE] = ACTIONS(982),
    [anon_sym_u_SQUOTE] = ACTIONS(982),
    [anon_sym_U_SQUOTE] = ACTIONS(982),
    [anon_sym_u8_SQUOTE] = ACTIONS(982),
    [anon_sym_SQUOTE] = ACTIONS(982),
    [anon_sym_L_DQUOTE] = ACTIONS(982),
    [anon_sym_u_DQUOTE] = ACTIONS(982),
    [anon_sym_U_DQUOTE] = ACTIONS(982),
    [anon_sym_u8_DQUOTE] = ACTIONS(982),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_null] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token2] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_kernel] = ACTIONS(984),
    [anon_sym___kernel] = ACTIONS(984),
    [anon_sym_global] = ACTIONS(984),
    [anon_sym___global] = ACTIONS(984),
    [anon_sym_local] = ACTIONS(984),
    [anon_sym___local] = ACTIONS(984),
    [anon_sym_constant] = ACTIONS(984),
    [anon_sym___constant] = ACTIONS(984),
    [anon_sym_private] = ACTIONS(984),
    [anon_sym___private] = ACTIONS(984),
    [anon_sym_generic] = ACTIONS(984),
    [anon_sym___generic] = ACTIONS(984),
    [anon_sym_read_only] = ACTIONS(984),
    [anon_sym___read_only] = ACTIONS(984),
    [anon_sym_write_only] = ACTIONS(984),
    [anon_sym___write_only] = ACTIONS(984),
    [anon_sym_read_write] = ACTIONS(984),
    [anon_sym___read_write] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(986),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_pipe] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [anon_sym_bool] = ACTIONS(984),
    [anon_sym_char] = ACTIONS(984),
    [anon_sym_uchar] = ACTIONS(984),
    [anon_sym_ushort] = ACTIONS(984),
    [anon_sym_int] = ACTIONS(984),
    [anon_sym_uint] = ACTIONS(984),
    [anon_sym_ulong] = ACTIONS(984),
    [anon_sym_float] = ACTIONS(984),
    [anon_sym_double] = ACTIONS(984),
    [anon_sym_half] = ACTIONS(984),
    [anon_sym_size_t] = ACTIONS(984),
    [anon_sym_ptrdiff_t] = ACTIONS(984),
    [anon_sym_intptr_t] = ACTIONS(984),
    [anon_sym_uintptr_t] = ACTIONS(984),
    [anon_sym_void] = ACTIONS(984),
    [sym_vector_type] = ACTIONS(984),
    [anon_sym_image2d_t] = ACTIONS(984),
    [anon_sym_image3d_t] = ACTIONS(984),
    [anon_sym_image2d_array_t] = ACTIONS(984),
    [anon_sym_image1d_t] = ACTIONS(984),
    [anon_sym_image1d_buffer_t] = ACTIONS(984),
    [anon_sym_image1d_array_t] = ACTIONS(984),
    [anon_sym_image2d_depth_t] = ACTIONS(984),
    [anon_sym_image2d_array_depth_t] = ACTIONS(984),
    [anon_sym_sampler_t] = ACTIONS(984),
    [anon_sym_queue_t] = ACTIONS(984),
    [anon_sym_ndrange_t] = ACTIONS(984),
    [anon_sym_clk_event_t] = ACTIONS(984),
    [anon_sym_reserve_id_t] = ACTIONS(984),
    [anon_sym_event_t] = ACTIONS(984),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(1042),
    [sym_identifier] = ACTIONS(1040),
    [aux_sym_preproc_include_token1] = ACTIONS(1040),
    [aux_sym_preproc_def_token1] = ACTIONS(1040),
    [aux_sym_preproc_if_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1040),
    [sym_preproc_directive] = ACTIONS(1040),
    [anon_sym_LPAREN2] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_typedef] = ACTIONS(1040),
    [anon_sym_kernel] = ACTIONS(1040),
    [anon_sym___kernel] = ACTIONS(1040),
    [anon_sym_global] = ACTIONS(1040),
    [anon_sym___global] = ACTIONS(1040),
    [anon_sym_local] = ACTIONS(1040),
    [anon_sym___local] = ACTIONS(1040),
    [anon_sym_constant] = ACTIONS(1040),
    [anon_sym___constant] = ACTIONS(1040),
    [anon_sym_private] = ACTIONS(1040),
    [anon_sym___private] = ACTIONS(1040),
    [anon_sym_generic] = ACTIONS(1040),
    [anon_sym___generic] = ACTIONS(1040),
    [anon_sym_read_only] = ACTIONS(1040),
    [anon_sym___read_only] = ACTIONS(1040),
    [anon_sym_write_only] = ACTIONS(1040),
    [anon_sym___write_only] = ACTIONS(1040),
    [anon_sym_read_write] = ACTIONS(1040),
    [anon_sym___read_write] = ACTIONS(1040),
    [anon_sym_extern] = ACTIONS(1040),
    [anon_sym___attribute__] = ACTIONS(1040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1042),
    [anon_sym___declspec] = ACTIONS(1040),
    [anon_sym___cdecl] = ACTIONS(1040),
    [anon_sym___clrcall] = ACTIONS(1040),
    [anon_sym___stdcall] = ACTIONS(1040),
    [anon_sym___fastcall] = ACTIONS(1040),
    [anon_sym___thiscall] = ACTIONS(1040),
    [anon_sym___vectorcall] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_auto] = ACTIONS(1040),
    [anon_sym_register] = ACTIONS(1040),
    [anon_sym_inline] = ACTIONS(1040),
    [anon_sym_const] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_restrict] = ACTIONS(1040),
    [anon_sym__Atomic] = ACTIONS(1040),
    [anon_sym_pipe] = ACTIONS(1040),
    [anon_sym_signed] = ACTIONS(1040),
    [anon_sym_unsigned] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [anon_sym_bool] = ACTIONS(1040),
    [anon_sym_char] = ACTIONS(1040),
    [anon_sym_uchar] = ACTIONS(1040),
    [anon_sym_ushort] = ACTIONS(1040),
    [anon_sym_int] = ACTIONS(1040),
    [anon_sym_uint] = ACTIONS(1040),
    [anon_sym_ulong] = ACTIONS(1040),
    [anon_sym_float] = ACTIONS(1040),
    [anon_sym_double] = ACTIONS(1040),
    [anon_sym_half] = ACTIONS(1040),
    [anon_sym_size_t] = ACTIONS(1040),
    [anon_sym_ptrdiff_t] = ACTIONS(1040),
    [anon_sym_intptr_t] = ACTIONS(1040),
    [anon_sym_uintptr_t] = ACTIONS(1040),
    [anon_sym_void] = ACTIONS(1040),
    [sym_vector_type] = ACTIONS(1040),
    [anon_sym_image2d_t] = ACTIONS(1040),
    [anon_sym_image3d_t] = ACTIONS(1040),
    [anon_sym_image2d_array_t] = ACTIONS(1040),
    [anon_sym_image1d_t] = ACTIONS(1040),
    [anon_sym_image1d_buffer_t] = ACTIONS(1040),
    [anon_sym_image1d_array_t] = ACTIONS(1040),
    [anon_sym_image2d_depth_t] = ACTIONS(1040),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1040),
    [anon_sym_sampler_t] = ACTIONS(1040),
    [anon_sym_queue_t] = ACTIONS(1040),
    [anon_sym_ndrange_t] = ACTIONS(1040),
    [anon_sym_clk_event_t] = ACTIONS(1040),
    [anon_sym_reserve_id_t] = ACTIONS(1040),
    [anon_sym_event_t] = ACTIONS(1040),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_union] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_else] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_while] = ACTIONS(1040),
    [anon_sym_do] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [anon_sym_goto] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_sizeof] = ACTIONS(1040),
    [sym_number_literal] = ACTIONS(1042),
    [anon_sym_L_SQUOTE] = ACTIONS(1042),
    [anon_sym_u_SQUOTE] = ACTIONS(1042),
    [anon_sym_U_SQUOTE] = ACTIONS(1042),
    [anon_sym_u8_SQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [anon_sym_L_DQUOTE] = ACTIONS(1042),
    [anon_sym_u_DQUOTE] = ACTIONS(1042),
    [anon_sym_U_DQUOTE] = ACTIONS(1042),
    [anon_sym_u8_DQUOTE] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym_true] = ACTIONS(1040),
    [sym_false] = ACTIONS(1040),
    [sym_null] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_identifier] = ACTIONS(958),
    [aux_sym_preproc_include_token1] = ACTIONS(958),
    [aux_sym_preproc_def_token1] = ACTIONS(958),
    [aux_sym_preproc_if_token1] = ACTIONS(958),
    [aux_sym_preproc_if_token2] = ACTIONS(958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(958),
    [sym_preproc_directive] = ACTIONS(958),
    [anon_sym_LPAREN2] = ACTIONS(960),
    [anon_sym_BANG] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(960),
    [anon_sym_AMP] = ACTIONS(960),
    [anon_sym_SEMI] = ACTIONS(960),
    [anon_sym_typedef] = ACTIONS(958),
    [anon_sym_kernel] = ACTIONS(958),
    [anon_sym___kernel] = ACTIONS(958),
    [anon_sym_global] = ACTIONS(958),
    [anon_sym___global] = ACTIONS(958),
    [anon_sym_local] = ACTIONS(958),
    [anon_sym___local] = ACTIONS(958),
    [anon_sym_constant] = ACTIONS(958),
    [anon_sym___constant] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym___private] = ACTIONS(958),
    [anon_sym_generic] = ACTIONS(958),
    [anon_sym___generic] = ACTIONS(958),
    [anon_sym_read_only] = ACTIONS(958),
    [anon_sym___read_only] = ACTIONS(958),
    [anon_sym_write_only] = ACTIONS(958),
    [anon_sym___write_only] = ACTIONS(958),
    [anon_sym_read_write] = ACTIONS(958),
    [anon_sym___read_write] = ACTIONS(958),
    [anon_sym_extern] = ACTIONS(958),
    [anon_sym___attribute__] = ACTIONS(958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(960),
    [anon_sym___declspec] = ACTIONS(958),
    [anon_sym___cdecl] = ACTIONS(958),
    [anon_sym___clrcall] = ACTIONS(958),
    [anon_sym___stdcall] = ACTIONS(958),
    [anon_sym___fastcall] = ACTIONS(958),
    [anon_sym___thiscall] = ACTIONS(958),
    [anon_sym___vectorcall] = ACTIONS(958),
    [anon_sym_LBRACE] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_auto] = ACTIONS(958),
    [anon_sym_register] = ACTIONS(958),
    [anon_sym_inline] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_volatile] = ACTIONS(958),
    [anon_sym_restrict] = ACTIONS(958),
    [anon_sym__Atomic] = ACTIONS(958),
    [anon_sym_pipe] = ACTIONS(958),
    [anon_sym_signed] = ACTIONS(958),
    [anon_sym_unsigned] = ACTIONS(958),
    [anon_sym_long] = ACTIONS(958),
    [anon_sym_short] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(958),
    [anon_sym_char] = ACTIONS(958),
    [anon_sym_uchar] = ACTIONS(958),
    [anon_sym_ushort] = ACTIONS(958),
    [anon_sym_int] = ACTIONS(958),
    [anon_sym_uint] = ACTIONS(958),
    [anon_sym_ulong] = ACTIONS(958),
    [anon_sym_float] = ACTIONS(958),
    [anon_sym_double] = ACTIONS(958),
    [anon_sym_half] = ACTIONS(958),
    [anon_sym_size_t] = ACTIONS(958),
    [anon_sym_ptrdiff_t] = ACTIONS(958),
    [anon_sym_intptr_t] = ACTIONS(958),
    [anon_sym_uintptr_t] = ACTIONS(958),
    [anon_sym_void] = ACTIONS(958),
    [sym_vector_type] = ACTIONS(958),
    [anon_sym_image2d_t] = ACTIONS(958),
    [anon_sym_image3d_t] = ACTIONS(958),
    [anon_sym_image2d_array_t] = ACTIONS(958),
    [anon_sym_image1d_t] = ACTIONS(958),
    [anon_sym_image1d_buffer_t] = ACTIONS(958),
    [anon_sym_image1d_array_t] = ACTIONS(958),
    [anon_sym_image2d_depth_t] = ACTIONS(958),
    [anon_sym_image2d_array_depth_t] = ACTIONS(958),
    [anon_sym_sampler_t] = ACTIONS(958),
    [anon_sym_queue_t] = ACTIONS(958),
    [anon_sym_ndrange_t] = ACTIONS(958),
    [anon_sym_clk_event_t] = ACTIONS(958),
    [anon_sym_reserve_id_t] = ACTIONS(958),
    [anon_sym_event_t] = ACTIONS(958),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_union] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(958),
    [anon_sym_case] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_do] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_goto] = ACTIONS(958),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_sizeof] = ACTIONS(958),
    [sym_number_literal] = ACTIONS(960),
    [anon_sym_L_SQUOTE] = ACTIONS(960),
    [anon_sym_u_SQUOTE] = ACTIONS(960),
    [anon_sym_U_SQUOTE] = ACTIONS(960),
    [anon_sym_u8_SQUOTE] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(960),
    [anon_sym_L_DQUOTE] = ACTIONS(960),
    [anon_sym_u_DQUOTE] = ACTIONS(960),
    [anon_sym_U_DQUOTE] = ACTIONS(960),
    [anon_sym_u8_DQUOTE] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(960),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_identifier] = ACTIONS(954),
    [aux_sym_preproc_include_token1] = ACTIONS(954),
    [aux_sym_preproc_def_token1] = ACTIONS(954),
    [aux_sym_preproc_if_token1] = ACTIONS(954),
    [aux_sym_preproc_if_token2] = ACTIONS(954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(954),
    [sym_preproc_directive] = ACTIONS(954),
    [anon_sym_LPAREN2] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_STAR] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(956),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_typedef] = ACTIONS(954),
    [anon_sym_kernel] = ACTIONS(954),
    [anon_sym___kernel] = ACTIONS(954),
    [anon_sym_global] = ACTIONS(954),
    [anon_sym___global] = ACTIONS(954),
    [anon_sym_local] = ACTIONS(954),
    [anon_sym___local] = ACTIONS(954),
    [anon_sym_constant] = ACTIONS(954),
    [anon_sym___constant] = ACTIONS(954),
    [anon_sym_private] = ACTIONS(954),
    [anon_sym___private] = ACTIONS(954),
    [anon_sym_generic] = ACTIONS(954),
    [anon_sym___generic] = ACTIONS(954),
    [anon_sym_read_only] = ACTIONS(954),
    [anon_sym___read_only] = ACTIONS(954),
    [anon_sym_write_only] = ACTIONS(954),
    [anon_sym___write_only] = ACTIONS(954),
    [anon_sym_read_write] = ACTIONS(954),
    [anon_sym___read_write] = ACTIONS(954),
    [anon_sym_extern] = ACTIONS(954),
    [anon_sym___attribute__] = ACTIONS(954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(956),
    [anon_sym___declspec] = ACTIONS(954),
    [anon_sym___cdecl] = ACTIONS(954),
    [anon_sym___clrcall] = ACTIONS(954),
    [anon_sym___stdcall] = ACTIONS(954),
    [anon_sym___fastcall] = ACTIONS(954),
    [anon_sym___thiscall] = ACTIONS(954),
    [anon_sym___vectorcall] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(954),
    [anon_sym_auto] = ACTIONS(954),
    [anon_sym_register] = ACTIONS(954),
    [anon_sym_inline] = ACTIONS(954),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym_pipe] = ACTIONS(954),
    [anon_sym_signed] = ACTIONS(954),
    [anon_sym_unsigned] = ACTIONS(954),
    [anon_sym_long] = ACTIONS(954),
    [anon_sym_short] = ACTIONS(954),
    [anon_sym_bool] = ACTIONS(954),
    [anon_sym_char] = ACTIONS(954),
    [anon_sym_uchar] = ACTIONS(954),
    [anon_sym_ushort] = ACTIONS(954),
    [anon_sym_int] = ACTIONS(954),
    [anon_sym_uint] = ACTIONS(954),
    [anon_sym_ulong] = ACTIONS(954),
    [anon_sym_float] = ACTIONS(954),
    [anon_sym_double] = ACTIONS(954),
    [anon_sym_half] = ACTIONS(954),
    [anon_sym_size_t] = ACTIONS(954),
    [anon_sym_ptrdiff_t] = ACTIONS(954),
    [anon_sym_intptr_t] = ACTIONS(954),
    [anon_sym_uintptr_t] = ACTIONS(954),
    [anon_sym_void] = ACTIONS(954),
    [sym_vector_type] = ACTIONS(954),
    [anon_sym_image2d_t] = ACTIONS(954),
    [anon_sym_image3d_t] = ACTIONS(954),
    [anon_sym_image2d_array_t] = ACTIONS(954),
    [anon_sym_image1d_t] = ACTIONS(954),
    [anon_sym_image1d_buffer_t] = ACTIONS(954),
    [anon_sym_image1d_array_t] = ACTIONS(954),
    [anon_sym_image2d_depth_t] = ACTIONS(954),
    [anon_sym_image2d_array_depth_t] = ACTIONS(954),
    [anon_sym_sampler_t] = ACTIONS(954),
    [anon_sym_queue_t] = ACTIONS(954),
    [anon_sym_ndrange_t] = ACTIONS(954),
    [anon_sym_clk_event_t] = ACTIONS(954),
    [anon_sym_reserve_id_t] = ACTIONS(954),
    [anon_sym_event_t] = ACTIONS(954),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(954),
    [anon_sym_enum] = ACTIONS(954),
    [anon_sym_struct] = ACTIONS(954),
    [anon_sym_union] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_else] = ACTIONS(954),
    [anon_sym_switch] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(954),
    [anon_sym_default] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(954),
    [anon_sym_do] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_break] = ACTIONS(954),
    [anon_sym_continue] = ACTIONS(954),
    [anon_sym_goto] = ACTIONS(954),
    [anon_sym_DASH_DASH] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(956),
    [anon_sym_sizeof] = ACTIONS(954),
    [sym_number_literal] = ACTIONS(956),
    [anon_sym_L_SQUOTE] = ACTIONS(956),
    [anon_sym_u_SQUOTE] = ACTIONS(956),
    [anon_sym_U_SQUOTE] = ACTIONS(956),
    [anon_sym_u8_SQUOTE] = ACTIONS(956),
    [anon_sym_SQUOTE] = ACTIONS(956),
    [anon_sym_L_DQUOTE] = ACTIONS(956),
    [anon_sym_u_DQUOTE] = ACTIONS(956),
    [anon_sym_U_DQUOTE] = ACTIONS(956),
    [anon_sym_u8_DQUOTE] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(956),
    [sym_true] = ACTIONS(954),
    [sym_false] = ACTIONS(954),
    [sym_null] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [sym_identifier] = ACTIONS(918),
    [aux_sym_preproc_include_token1] = ACTIONS(918),
    [aux_sym_preproc_def_token1] = ACTIONS(918),
    [aux_sym_preproc_if_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(918),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(918),
    [sym_preproc_directive] = ACTIONS(918),
    [anon_sym_LPAREN2] = ACTIONS(920),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(920),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(918),
    [anon_sym_kernel] = ACTIONS(918),
    [anon_sym___kernel] = ACTIONS(918),
    [anon_sym_global] = ACTIONS(918),
    [anon_sym___global] = ACTIONS(918),
    [anon_sym_local] = ACTIONS(918),
    [anon_sym___local] = ACTIONS(918),
    [anon_sym_constant] = ACTIONS(918),
    [anon_sym___constant] = ACTIONS(918),
    [anon_sym_private] = ACTIONS(918),
    [anon_sym___private] = ACTIONS(918),
    [anon_sym_generic] = ACTIONS(918),
    [anon_sym___generic] = ACTIONS(918),
    [anon_sym_read_only] = ACTIONS(918),
    [anon_sym___read_only] = ACTIONS(918),
    [anon_sym_write_only] = ACTIONS(918),
    [anon_sym___write_only] = ACTIONS(918),
    [anon_sym_read_write] = ACTIONS(918),
    [anon_sym___read_write] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym___attribute__] = ACTIONS(918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(920),
    [anon_sym___declspec] = ACTIONS(918),
    [anon_sym___cdecl] = ACTIONS(918),
    [anon_sym___clrcall] = ACTIONS(918),
    [anon_sym___stdcall] = ACTIONS(918),
    [anon_sym___fastcall] = ACTIONS(918),
    [anon_sym___thiscall] = ACTIONS(918),
    [anon_sym___vectorcall] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_RBRACE] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_auto] = ACTIONS(918),
    [anon_sym_register] = ACTIONS(918),
    [anon_sym_inline] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_volatile] = ACTIONS(918),
    [anon_sym_restrict] = ACTIONS(918),
    [anon_sym__Atomic] = ACTIONS(918),
    [anon_sym_pipe] = ACTIONS(918),
    [anon_sym_signed] = ACTIONS(918),
    [anon_sym_unsigned] = ACTIONS(918),
    [anon_sym_long] = ACTIONS(918),
    [anon_sym_short] = ACTIONS(918),
    [anon_sym_bool] = ACTIONS(918),
    [anon_sym_char] = ACTIONS(918),
    [anon_sym_uchar] = ACTIONS(918),
    [anon_sym_ushort] = ACTIONS(918),
    [anon_sym_int] = ACTIONS(918),
    [anon_sym_uint] = ACTIONS(918),
    [anon_sym_ulong] = ACTIONS(918),
    [anon_sym_float] = ACTIONS(918),
    [anon_sym_double] = ACTIONS(918),
    [anon_sym_half] = ACTIONS(918),
    [anon_sym_size_t] = ACTIONS(918),
    [anon_sym_ptrdiff_t] = ACTIONS(918),
    [anon_sym_intptr_t] = ACTIONS(918),
    [anon_sym_uintptr_t] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(918),
    [sym_vector_type] = ACTIONS(918),
    [anon_sym_image2d_t] = ACTIONS(918),
    [anon_sym_image3d_t] = ACTIONS(918),
    [anon_sym_image2d_array_t] = ACTIONS(918),
    [anon_sym_image1d_t] = ACTIONS(918),
    [anon_sym_image1d_buffer_t] = ACTIONS(918),
    [anon_sym_image1d_array_t] = ACTIONS(918),
    [anon_sym_image2d_depth_t] = ACTIONS(918),
    [anon_sym_image2d_array_depth_t] = ACTIONS(918),
    [anon_sym_sampler_t] = ACTIONS(918),
    [anon_sym_queue_t] = ACTIONS(918),
    [anon_sym_ndrange_t] = ACTIONS(918),
    [anon_sym_clk_event_t] = ACTIONS(918),
    [anon_sym_reserve_id_t] = ACTIONS(918),
    [anon_sym_event_t] = ACTIONS(918),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_union] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_goto] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_sizeof] = ACTIONS(918),
    [sym_number_literal] = ACTIONS(920),
    [anon_sym_L_SQUOTE] = ACTIONS(920),
    [anon_sym_u_SQUOTE] = ACTIONS(920),
    [anon_sym_U_SQUOTE] = ACTIONS(920),
    [anon_sym_u8_SQUOTE] = ACTIONS(920),
    [anon_sym_SQUOTE] = ACTIONS(920),
    [anon_sym_L_DQUOTE] = ACTIONS(920),
    [anon_sym_u_DQUOTE] = ACTIONS(920),
    [anon_sym_U_DQUOTE] = ACTIONS(920),
    [anon_sym_u8_DQUOTE] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_null] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_identifier] = ACTIONS(950),
    [aux_sym_preproc_include_token1] = ACTIONS(950),
    [aux_sym_preproc_def_token1] = ACTIONS(950),
    [aux_sym_preproc_if_token1] = ACTIONS(950),
    [aux_sym_preproc_if_token2] = ACTIONS(950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(950),
    [sym_preproc_directive] = ACTIONS(950),
    [anon_sym_LPAREN2] = ACTIONS(952),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(952),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(952),
    [anon_sym_AMP] = ACTIONS(952),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_typedef] = ACTIONS(950),
    [anon_sym_kernel] = ACTIONS(950),
    [anon_sym___kernel] = ACTIONS(950),
    [anon_sym_global] = ACTIONS(950),
    [anon_sym___global] = ACTIONS(950),
    [anon_sym_local] = ACTIONS(950),
    [anon_sym___local] = ACTIONS(950),
    [anon_sym_constant] = ACTIONS(950),
    [anon_sym___constant] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym___private] = ACTIONS(950),
    [anon_sym_generic] = ACTIONS(950),
    [anon_sym___generic] = ACTIONS(950),
    [anon_sym_read_only] = ACTIONS(950),
    [anon_sym___read_only] = ACTIONS(950),
    [anon_sym_write_only] = ACTIONS(950),
    [anon_sym___write_only] = ACTIONS(950),
    [anon_sym_read_write] = ACTIONS(950),
    [anon_sym___read_write] = ACTIONS(950),
    [anon_sym_extern] = ACTIONS(950),
    [anon_sym___attribute__] = ACTIONS(950),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(952),
    [anon_sym___declspec] = ACTIONS(950),
    [anon_sym___cdecl] = ACTIONS(950),
    [anon_sym___clrcall] = ACTIONS(950),
    [anon_sym___stdcall] = ACTIONS(950),
    [anon_sym___fastcall] = ACTIONS(950),
    [anon_sym___thiscall] = ACTIONS(950),
    [anon_sym___vectorcall] = ACTIONS(950),
    [anon_sym_LBRACE] = ACTIONS(952),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_auto] = ACTIONS(950),
    [anon_sym_register] = ACTIONS(950),
    [anon_sym_inline] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(950),
    [anon_sym_volatile] = ACTIONS(950),
    [anon_sym_restrict] = ACTIONS(950),
    [anon_sym__Atomic] = ACTIONS(950),
    [anon_sym_pipe] = ACTIONS(950),
    [anon_sym_signed] = ACTIONS(950),
    [anon_sym_unsigned] = ACTIONS(950),
    [anon_sym_long] = ACTIONS(950),
    [anon_sym_short] = ACTIONS(950),
    [anon_sym_bool] = ACTIONS(950),
    [anon_sym_char] = ACTIONS(950),
    [anon_sym_uchar] = ACTIONS(950),
    [anon_sym_ushort] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(950),
    [anon_sym_uint] = ACTIONS(950),
    [anon_sym_ulong] = ACTIONS(950),
    [anon_sym_float] = ACTIONS(950),
    [anon_sym_double] = ACTIONS(950),
    [anon_sym_half] = ACTIONS(950),
    [anon_sym_size_t] = ACTIONS(950),
    [anon_sym_ptrdiff_t] = ACTIONS(950),
    [anon_sym_intptr_t] = ACTIONS(950),
    [anon_sym_uintptr_t] = ACTIONS(950),
    [anon_sym_void] = ACTIONS(950),
    [sym_vector_type] = ACTIONS(950),
    [anon_sym_image2d_t] = ACTIONS(950),
    [anon_sym_image3d_t] = ACTIONS(950),
    [anon_sym_image2d_array_t] = ACTIONS(950),
    [anon_sym_image1d_t] = ACTIONS(950),
    [anon_sym_image1d_buffer_t] = ACTIONS(950),
    [anon_sym_image1d_array_t] = ACTIONS(950),
    [anon_sym_image2d_depth_t] = ACTIONS(950),
    [anon_sym_image2d_array_depth_t] = ACTIONS(950),
    [anon_sym_sampler_t] = ACTIONS(950),
    [anon_sym_queue_t] = ACTIONS(950),
    [anon_sym_ndrange_t] = ACTIONS(950),
    [anon_sym_clk_event_t] = ACTIONS(950),
    [anon_sym_reserve_id_t] = ACTIONS(950),
    [anon_sym_event_t] = ACTIONS(950),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_struct] = ACTIONS(950),
    [anon_sym_union] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(950),
    [anon_sym_else] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(950),
    [anon_sym_case] = ACTIONS(950),
    [anon_sym_default] = ACTIONS(950),
    [anon_sym_while] = ACTIONS(950),
    [anon_sym_do] = ACTIONS(950),
    [anon_sym_for] = ACTIONS(950),
    [anon_sym_return] = ACTIONS(950),
    [anon_sym_break] = ACTIONS(950),
    [anon_sym_continue] = ACTIONS(950),
    [anon_sym_goto] = ACTIONS(950),
    [anon_sym_DASH_DASH] = ACTIONS(952),
    [anon_sym_PLUS_PLUS] = ACTIONS(952),
    [anon_sym_sizeof] = ACTIONS(950),
    [sym_number_literal] = ACTIONS(952),
    [anon_sym_L_SQUOTE] = ACTIONS(952),
    [anon_sym_u_SQUOTE] = ACTIONS(952),
    [anon_sym_U_SQUOTE] = ACTIONS(952),
    [anon_sym_u8_SQUOTE] = ACTIONS(952),
    [anon_sym_SQUOTE] = ACTIONS(952),
    [anon_sym_L_DQUOTE] = ACTIONS(952),
    [anon_sym_u_DQUOTE] = ACTIONS(952),
    [anon_sym_U_DQUOTE] = ACTIONS(952),
    [anon_sym_u8_DQUOTE] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(952),
    [sym_true] = ACTIONS(950),
    [sym_false] = ACTIONS(950),
    [sym_null] = ACTIONS(950),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_identifier] = ACTIONS(946),
    [aux_sym_preproc_include_token1] = ACTIONS(946),
    [aux_sym_preproc_def_token1] = ACTIONS(946),
    [aux_sym_preproc_if_token1] = ACTIONS(946),
    [aux_sym_preproc_if_token2] = ACTIONS(946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(946),
    [sym_preproc_directive] = ACTIONS(946),
    [anon_sym_LPAREN2] = ACTIONS(948),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(948),
    [anon_sym_AMP] = ACTIONS(948),
    [anon_sym_SEMI] = ACTIONS(948),
    [anon_sym_typedef] = ACTIONS(946),
    [anon_sym_kernel] = ACTIONS(946),
    [anon_sym___kernel] = ACTIONS(946),
    [anon_sym_global] = ACTIONS(946),
    [anon_sym___global] = ACTIONS(946),
    [anon_sym_local] = ACTIONS(946),
    [anon_sym___local] = ACTIONS(946),
    [anon_sym_constant] = ACTIONS(946),
    [anon_sym___constant] = ACTIONS(946),
    [anon_sym_private] = ACTIONS(946),
    [anon_sym___private] = ACTIONS(946),
    [anon_sym_generic] = ACTIONS(946),
    [anon_sym___generic] = ACTIONS(946),
    [anon_sym_read_only] = ACTIONS(946),
    [anon_sym___read_only] = ACTIONS(946),
    [anon_sym_write_only] = ACTIONS(946),
    [anon_sym___write_only] = ACTIONS(946),
    [anon_sym_read_write] = ACTIONS(946),
    [anon_sym___read_write] = ACTIONS(946),
    [anon_sym_extern] = ACTIONS(946),
    [anon_sym___attribute__] = ACTIONS(946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(948),
    [anon_sym___declspec] = ACTIONS(946),
    [anon_sym___cdecl] = ACTIONS(946),
    [anon_sym___clrcall] = ACTIONS(946),
    [anon_sym___stdcall] = ACTIONS(946),
    [anon_sym___fastcall] = ACTIONS(946),
    [anon_sym___thiscall] = ACTIONS(946),
    [anon_sym___vectorcall] = ACTIONS(946),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_auto] = ACTIONS(946),
    [anon_sym_register] = ACTIONS(946),
    [anon_sym_inline] = ACTIONS(946),
    [anon_sym_const] = ACTIONS(946),
    [anon_sym_volatile] = ACTIONS(946),
    [anon_sym_restrict] = ACTIONS(946),
    [anon_sym__Atomic] = ACTIONS(946),
    [anon_sym_pipe] = ACTIONS(946),
    [anon_sym_signed] = ACTIONS(946),
    [anon_sym_unsigned] = ACTIONS(946),
    [anon_sym_long] = ACTIONS(946),
    [anon_sym_short] = ACTIONS(946),
    [anon_sym_bool] = ACTIONS(946),
    [anon_sym_char] = ACTIONS(946),
    [anon_sym_uchar] = ACTIONS(946),
    [anon_sym_ushort] = ACTIONS(946),
    [anon_sym_int] = ACTIONS(946),
    [anon_sym_uint] = ACTIONS(946),
    [anon_sym_ulong] = ACTIONS(946),
    [anon_sym_float] = ACTIONS(946),
    [anon_sym_double] = ACTIONS(946),
    [anon_sym_half] = ACTIONS(946),
    [anon_sym_size_t] = ACTIONS(946),
    [anon_sym_ptrdiff_t] = ACTIONS(946),
    [anon_sym_intptr_t] = ACTIONS(946),
    [anon_sym_uintptr_t] = ACTIONS(946),
    [anon_sym_void] = ACTIONS(946),
    [sym_vector_type] = ACTIONS(946),
    [anon_sym_image2d_t] = ACTIONS(946),
    [anon_sym_image3d_t] = ACTIONS(946),
    [anon_sym_image2d_array_t] = ACTIONS(946),
    [anon_sym_image1d_t] = ACTIONS(946),
    [anon_sym_image1d_buffer_t] = ACTIONS(946),
    [anon_sym_image1d_array_t] = ACTIONS(946),
    [anon_sym_image2d_depth_t] = ACTIONS(946),
    [anon_sym_image2d_array_depth_t] = ACTIONS(946),
    [anon_sym_sampler_t] = ACTIONS(946),
    [anon_sym_queue_t] = ACTIONS(946),
    [anon_sym_ndrange_t] = ACTIONS(946),
    [anon_sym_clk_event_t] = ACTIONS(946),
    [anon_sym_reserve_id_t] = ACTIONS(946),
    [anon_sym_event_t] = ACTIONS(946),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_struct] = ACTIONS(946),
    [anon_sym_union] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_else] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(946),
    [anon_sym_default] = ACTIONS(946),
    [anon_sym_while] = ACTIONS(946),
    [anon_sym_do] = ACTIONS(946),
    [anon_sym_for] = ACTIONS(946),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_break] = ACTIONS(946),
    [anon_sym_continue] = ACTIONS(946),
    [anon_sym_goto] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(948),
    [anon_sym_sizeof] = ACTIONS(946),
    [sym_number_literal] = ACTIONS(948),
    [anon_sym_L_SQUOTE] = ACTIONS(948),
    [anon_sym_u_SQUOTE] = ACTIONS(948),
    [anon_sym_U_SQUOTE] = ACTIONS(948),
    [anon_sym_u8_SQUOTE] = ACTIONS(948),
    [anon_sym_SQUOTE] = ACTIONS(948),
    [anon_sym_L_DQUOTE] = ACTIONS(948),
    [anon_sym_u_DQUOTE] = ACTIONS(948),
    [anon_sym_U_DQUOTE] = ACTIONS(948),
    [anon_sym_u8_DQUOTE] = ACTIONS(948),
    [anon_sym_DQUOTE] = ACTIONS(948),
    [sym_true] = ACTIONS(946),
    [sym_false] = ACTIONS(946),
    [sym_null] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_identifier] = ACTIONS(910),
    [aux_sym_preproc_include_token1] = ACTIONS(910),
    [aux_sym_preproc_def_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token1] = ACTIONS(910),
    [aux_sym_preproc_if_token2] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(910),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(910),
    [sym_preproc_directive] = ACTIONS(910),
    [anon_sym_LPAREN2] = ACTIONS(912),
    [anon_sym_BANG] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [anon_sym_typedef] = ACTIONS(910),
    [anon_sym_kernel] = ACTIONS(910),
    [anon_sym___kernel] = ACTIONS(910),
    [anon_sym_global] = ACTIONS(910),
    [anon_sym___global] = ACTIONS(910),
    [anon_sym_local] = ACTIONS(910),
    [anon_sym___local] = ACTIONS(910),
    [anon_sym_constant] = ACTIONS(910),
    [anon_sym___constant] = ACTIONS(910),
    [anon_sym_private] = ACTIONS(910),
    [anon_sym___private] = ACTIONS(910),
    [anon_sym_generic] = ACTIONS(910),
    [anon_sym___generic] = ACTIONS(910),
    [anon_sym_read_only] = ACTIONS(910),
    [anon_sym___read_only] = ACTIONS(910),
    [anon_sym_write_only] = ACTIONS(910),
    [anon_sym___write_only] = ACTIONS(910),
    [anon_sym_read_write] = ACTIONS(910),
    [anon_sym___read_write] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym___attribute__] = ACTIONS(910),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(912),
    [anon_sym___declspec] = ACTIONS(910),
    [anon_sym___cdecl] = ACTIONS(910),
    [anon_sym___clrcall] = ACTIONS(910),
    [anon_sym___stdcall] = ACTIONS(910),
    [anon_sym___fastcall] = ACTIONS(910),
    [anon_sym___thiscall] = ACTIONS(910),
    [anon_sym___vectorcall] = ACTIONS(910),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_static] = ACTIONS(910),
    [anon_sym_auto] = ACTIONS(910),
    [anon_sym_register] = ACTIONS(910),
    [anon_sym_inline] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_volatile] = ACTIONS(910),
    [anon_sym_restrict] = ACTIONS(910),
    [anon_sym__Atomic] = ACTIONS(910),
    [anon_sym_pipe] = ACTIONS(910),
    [anon_sym_signed] = ACTIONS(910),
    [anon_sym_unsigned] = ACTIONS(910),
    [anon_sym_long] = ACTIONS(910),
    [anon_sym_short] = ACTIONS(910),
    [anon_sym_bool] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_uchar] = ACTIONS(910),
    [anon_sym_ushort] = ACTIONS(910),
    [anon_sym_int] = ACTIONS(910),
    [anon_sym_uint] = ACTIONS(910),
    [anon_sym_ulong] = ACTIONS(910),
    [anon_sym_float] = ACTIONS(910),
    [anon_sym_double] = ACTIONS(910),
    [anon_sym_half] = ACTIONS(910),
    [anon_sym_size_t] = ACTIONS(910),
    [anon_sym_ptrdiff_t] = ACTIONS(910),
    [anon_sym_intptr_t] = ACTIONS(910),
    [anon_sym_uintptr_t] = ACTIONS(910),
    [anon_sym_void] = ACTIONS(910),
    [sym_vector_type] = ACTIONS(910),
    [anon_sym_image2d_t] = ACTIONS(910),
    [anon_sym_image3d_t] = ACTIONS(910),
    [anon_sym_image2d_array_t] = ACTIONS(910),
    [anon_sym_image1d_t] = ACTIONS(910),
    [anon_sym_image1d_buffer_t] = ACTIONS(910),
    [anon_sym_image1d_array_t] = ACTIONS(910),
    [anon_sym_image2d_depth_t] = ACTIONS(910),
    [anon_sym_image2d_array_depth_t] = ACTIONS(910),
    [anon_sym_sampler_t] = ACTIONS(910),
    [anon_sym_queue_t] = ACTIONS(910),
    [anon_sym_ndrange_t] = ACTIONS(910),
    [anon_sym_clk_event_t] = ACTIONS(910),
    [anon_sym_reserve_id_t] = ACTIONS(910),
    [anon_sym_event_t] = ACTIONS(910),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_union] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(910),
    [anon_sym_case] = ACTIONS(910),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_do] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym_DASH_DASH] = ACTIONS(912),
    [anon_sym_PLUS_PLUS] = ACTIONS(912),
    [anon_sym_sizeof] = ACTIONS(910),
    [sym_number_literal] = ACTIONS(912),
    [anon_sym_L_SQUOTE] = ACTIONS(912),
    [anon_sym_u_SQUOTE] = ACTIONS(912),
    [anon_sym_U_SQUOTE] = ACTIONS(912),
    [anon_sym_u8_SQUOTE] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(912),
    [anon_sym_L_DQUOTE] = ACTIONS(912),
    [anon_sym_u_DQUOTE] = ACTIONS(912),
    [anon_sym_U_DQUOTE] = ACTIONS(912),
    [anon_sym_u8_DQUOTE] = ACTIONS(912),
    [anon_sym_DQUOTE] = ACTIONS(912),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_null] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_identifier] = ACTIONS(938),
    [aux_sym_preproc_include_token1] = ACTIONS(938),
    [aux_sym_preproc_def_token1] = ACTIONS(938),
    [aux_sym_preproc_if_token1] = ACTIONS(938),
    [aux_sym_preproc_if_token2] = ACTIONS(938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(938),
    [sym_preproc_directive] = ACTIONS(938),
    [anon_sym_LPAREN2] = ACTIONS(940),
    [anon_sym_BANG] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_DASH] = ACTIONS(938),
    [anon_sym_PLUS] = ACTIONS(938),
    [anon_sym_STAR] = ACTIONS(940),
    [anon_sym_AMP] = ACTIONS(940),
    [anon_sym_SEMI] = ACTIONS(940),
    [anon_sym_typedef] = ACTIONS(938),
    [anon_sym_kernel] = ACTIONS(938),
    [anon_sym___kernel] = ACTIONS(938),
    [anon_sym_global] = ACTIONS(938),
    [anon_sym___global] = ACTIONS(938),
    [anon_sym_local] = ACTIONS(938),
    [anon_sym___local] = ACTIONS(938),
    [anon_sym_constant] = ACTIONS(938),
    [anon_sym___constant] = ACTIONS(938),
    [anon_sym_private] = ACTIONS(938),
    [anon_sym___private] = ACTIONS(938),
    [anon_sym_generic] = ACTIONS(938),
    [anon_sym___generic] = ACTIONS(938),
    [anon_sym_read_only] = ACTIONS(938),
    [anon_sym___read_only] = ACTIONS(938),
    [anon_sym_write_only] = ACTIONS(938),
    [anon_sym___write_only] = ACTIONS(938),
    [anon_sym_read_write] = ACTIONS(938),
    [anon_sym___read_write] = ACTIONS(938),
    [anon_sym_extern] = ACTIONS(938),
    [anon_sym___attribute__] = ACTIONS(938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(940),
    [anon_sym___declspec] = ACTIONS(938),
    [anon_sym___cdecl] = ACTIONS(938),
    [anon_sym___clrcall] = ACTIONS(938),
    [anon_sym___stdcall] = ACTIONS(938),
    [anon_sym___fastcall] = ACTIONS(938),
    [anon_sym___thiscall] = ACTIONS(938),
    [anon_sym___vectorcall] = ACTIONS(938),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_static] = ACTIONS(938),
    [anon_sym_auto] = ACTIONS(938),
    [anon_sym_register] = ACTIONS(938),
    [anon_sym_inline] = ACTIONS(938),
    [anon_sym_const] = ACTIONS(938),
    [anon_sym_volatile] = ACTIONS(938),
    [anon_sym_restrict] = ACTIONS(938),
    [anon_sym__Atomic] = ACTIONS(938),
    [anon_sym_pipe] = ACTIONS(938),
    [anon_sym_signed] = ACTIONS(938),
    [anon_sym_unsigned] = ACTIONS(938),
    [anon_sym_long] = ACTIONS(938),
    [anon_sym_short] = ACTIONS(938),
    [anon_sym_bool] = ACTIONS(938),
    [anon_sym_char] = ACTIONS(938),
    [anon_sym_uchar] = ACTIONS(938),
    [anon_sym_ushort] = ACTIONS(938),
    [anon_sym_int] = ACTIONS(938),
    [anon_sym_uint] = ACTIONS(938),
    [anon_sym_ulong] = ACTIONS(938),
    [anon_sym_float] = ACTIONS(938),
    [anon_sym_double] = ACTIONS(938),
    [anon_sym_half] = ACTIONS(938),
    [anon_sym_size_t] = ACTIONS(938),
    [anon_sym_ptrdiff_t] = ACTIONS(938),
    [anon_sym_intptr_t] = ACTIONS(938),
    [anon_sym_uintptr_t] = ACTIONS(938),
    [anon_sym_void] = ACTIONS(938),
    [sym_vector_type] = ACTIONS(938),
    [anon_sym_image2d_t] = ACTIONS(938),
    [anon_sym_image3d_t] = ACTIONS(938),
    [anon_sym_image2d_array_t] = ACTIONS(938),
    [anon_sym_image1d_t] = ACTIONS(938),
    [anon_sym_image1d_buffer_t] = ACTIONS(938),
    [anon_sym_image1d_array_t] = ACTIONS(938),
    [anon_sym_image2d_depth_t] = ACTIONS(938),
    [anon_sym_image2d_array_depth_t] = ACTIONS(938),
    [anon_sym_sampler_t] = ACTIONS(938),
    [anon_sym_queue_t] = ACTIONS(938),
    [anon_sym_ndrange_t] = ACTIONS(938),
    [anon_sym_clk_event_t] = ACTIONS(938),
    [anon_sym_reserve_id_t] = ACTIONS(938),
    [anon_sym_event_t] = ACTIONS(938),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(938),
    [anon_sym_enum] = ACTIONS(938),
    [anon_sym_struct] = ACTIONS(938),
    [anon_sym_union] = ACTIONS(938),
    [anon_sym_if] = ACTIONS(938),
    [anon_sym_else] = ACTIONS(938),
    [anon_sym_switch] = ACTIONS(938),
    [anon_sym_case] = ACTIONS(938),
    [anon_sym_default] = ACTIONS(938),
    [anon_sym_while] = ACTIONS(938),
    [anon_sym_do] = ACTIONS(938),
    [anon_sym_for] = ACTIONS(938),
    [anon_sym_return] = ACTIONS(938),
    [anon_sym_break] = ACTIONS(938),
    [anon_sym_continue] = ACTIONS(938),
    [anon_sym_goto] = ACTIONS(938),
    [anon_sym_DASH_DASH] = ACTIONS(940),
    [anon_sym_PLUS_PLUS] = ACTIONS(940),
    [anon_sym_sizeof] = ACTIONS(938),
    [sym_number_literal] = ACTIONS(940),
    [anon_sym_L_SQUOTE] = ACTIONS(940),
    [anon_sym_u_SQUOTE] = ACTIONS(940),
    [anon_sym_U_SQUOTE] = ACTIONS(940),
    [anon_sym_u8_SQUOTE] = ACTIONS(940),
    [anon_sym_SQUOTE] = ACTIONS(940),
    [anon_sym_L_DQUOTE] = ACTIONS(940),
    [anon_sym_u_DQUOTE] = ACTIONS(940),
    [anon_sym_U_DQUOTE] = ACTIONS(940),
    [anon_sym_u8_DQUOTE] = ACTIONS(940),
    [anon_sym_DQUOTE] = ACTIONS(940),
    [sym_true] = ACTIONS(938),
    [sym_false] = ACTIONS(938),
    [sym_null] = ACTIONS(938),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_identifier] = ACTIONS(930),
    [aux_sym_preproc_include_token1] = ACTIONS(930),
    [aux_sym_preproc_def_token1] = ACTIONS(930),
    [aux_sym_preproc_if_token1] = ACTIONS(930),
    [aux_sym_preproc_if_token2] = ACTIONS(930),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(930),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(930),
    [sym_preproc_directive] = ACTIONS(930),
    [anon_sym_LPAREN2] = ACTIONS(932),
    [anon_sym_BANG] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_STAR] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_typedef] = ACTIONS(930),
    [anon_sym_kernel] = ACTIONS(930),
    [anon_sym___kernel] = ACTIONS(930),
    [anon_sym_global] = ACTIONS(930),
    [anon_sym___global] = ACTIONS(930),
    [anon_sym_local] = ACTIONS(930),
    [anon_sym___local] = ACTIONS(930),
    [anon_sym_constant] = ACTIONS(930),
    [anon_sym___constant] = ACTIONS(930),
    [anon_sym_private] = ACTIONS(930),
    [anon_sym___private] = ACTIONS(930),
    [anon_sym_generic] = ACTIONS(930),
    [anon_sym___generic] = ACTIONS(930),
    [anon_sym_read_only] = ACTIONS(930),
    [anon_sym___read_only] = ACTIONS(930),
    [anon_sym_write_only] = ACTIONS(930),
    [anon_sym___write_only] = ACTIONS(930),
    [anon_sym_read_write] = ACTIONS(930),
    [anon_sym___read_write] = ACTIONS(930),
    [anon_sym_extern] = ACTIONS(930),
    [anon_sym___attribute__] = ACTIONS(930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(932),
    [anon_sym___declspec] = ACTIONS(930),
    [anon_sym___cdecl] = ACTIONS(930),
    [anon_sym___clrcall] = ACTIONS(930),
    [anon_sym___stdcall] = ACTIONS(930),
    [anon_sym___fastcall] = ACTIONS(930),
    [anon_sym___thiscall] = ACTIONS(930),
    [anon_sym___vectorcall] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_static] = ACTIONS(930),
    [anon_sym_auto] = ACTIONS(930),
    [anon_sym_register] = ACTIONS(930),
    [anon_sym_inline] = ACTIONS(930),
    [anon_sym_const] = ACTIONS(930),
    [anon_sym_volatile] = ACTIONS(930),
    [anon_sym_restrict] = ACTIONS(930),
    [anon_sym__Atomic] = ACTIONS(930),
    [anon_sym_pipe] = ACTIONS(930),
    [anon_sym_signed] = ACTIONS(930),
    [anon_sym_unsigned] = ACTIONS(930),
    [anon_sym_long] = ACTIONS(930),
    [anon_sym_short] = ACTIONS(930),
    [anon_sym_bool] = ACTIONS(930),
    [anon_sym_char] = ACTIONS(930),
    [anon_sym_uchar] = ACTIONS(930),
    [anon_sym_ushort] = ACTIONS(930),
    [anon_sym_int] = ACTIONS(930),
    [anon_sym_uint] = ACTIONS(930),
    [anon_sym_ulong] = ACTIONS(930),
    [anon_sym_float] = ACTIONS(930),
    [anon_sym_double] = ACTIONS(930),
    [anon_sym_half] = ACTIONS(930),
    [anon_sym_size_t] = ACTIONS(930),
    [anon_sym_ptrdiff_t] = ACTIONS(930),
    [anon_sym_intptr_t] = ACTIONS(930),
    [anon_sym_uintptr_t] = ACTIONS(930),
    [anon_sym_void] = ACTIONS(930),
    [sym_vector_type] = ACTIONS(930),
    [anon_sym_image2d_t] = ACTIONS(930),
    [anon_sym_image3d_t] = ACTIONS(930),
    [anon_sym_image2d_array_t] = ACTIONS(930),
    [anon_sym_image1d_t] = ACTIONS(930),
    [anon_sym_image1d_buffer_t] = ACTIONS(930),
    [anon_sym_image1d_array_t] = ACTIONS(930),
    [anon_sym_image2d_depth_t] = ACTIONS(930),
    [anon_sym_image2d_array_depth_t] = ACTIONS(930),
    [anon_sym_sampler_t] = ACTIONS(930),
    [anon_sym_queue_t] = ACTIONS(930),
    [anon_sym_ndrange_t] = ACTIONS(930),
    [anon_sym_clk_event_t] = ACTIONS(930),
    [anon_sym_reserve_id_t] = ACTIONS(930),
    [anon_sym_event_t] = ACTIONS(930),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(930),
    [anon_sym_enum] = ACTIONS(930),
    [anon_sym_struct] = ACTIONS(930),
    [anon_sym_union] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_else] = ACTIONS(930),
    [anon_sym_switch] = ACTIONS(930),
    [anon_sym_case] = ACTIONS(930),
    [anon_sym_default] = ACTIONS(930),
    [anon_sym_while] = ACTIONS(930),
    [anon_sym_do] = ACTIONS(930),
    [anon_sym_for] = ACTIONS(930),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_break] = ACTIONS(930),
    [anon_sym_continue] = ACTIONS(930),
    [anon_sym_goto] = ACTIONS(930),
    [anon_sym_DASH_DASH] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(932),
    [anon_sym_sizeof] = ACTIONS(930),
    [sym_number_literal] = ACTIONS(932),
    [anon_sym_L_SQUOTE] = ACTIONS(932),
    [anon_sym_u_SQUOTE] = ACTIONS(932),
    [anon_sym_U_SQUOTE] = ACTIONS(932),
    [anon_sym_u8_SQUOTE] = ACTIONS(932),
    [anon_sym_SQUOTE] = ACTIONS(932),
    [anon_sym_L_DQUOTE] = ACTIONS(932),
    [anon_sym_u_DQUOTE] = ACTIONS(932),
    [anon_sym_U_DQUOTE] = ACTIONS(932),
    [anon_sym_u8_DQUOTE] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_true] = ACTIONS(930),
    [sym_false] = ACTIONS(930),
    [sym_null] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_identifier] = ACTIONS(926),
    [aux_sym_preproc_include_token1] = ACTIONS(926),
    [aux_sym_preproc_def_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token1] = ACTIONS(926),
    [aux_sym_preproc_if_token2] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(926),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(926),
    [sym_preproc_directive] = ACTIONS(926),
    [anon_sym_LPAREN2] = ACTIONS(928),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(928),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(926),
    [anon_sym_kernel] = ACTIONS(926),
    [anon_sym___kernel] = ACTIONS(926),
    [anon_sym_global] = ACTIONS(926),
    [anon_sym___global] = ACTIONS(926),
    [anon_sym_local] = ACTIONS(926),
    [anon_sym___local] = ACTIONS(926),
    [anon_sym_constant] = ACTIONS(926),
    [anon_sym___constant] = ACTIONS(926),
    [anon_sym_private] = ACTIONS(926),
    [anon_sym___private] = ACTIONS(926),
    [anon_sym_generic] = ACTIONS(926),
    [anon_sym___generic] = ACTIONS(926),
    [anon_sym_read_only] = ACTIONS(926),
    [anon_sym___read_only] = ACTIONS(926),
    [anon_sym_write_only] = ACTIONS(926),
    [anon_sym___write_only] = ACTIONS(926),
    [anon_sym_read_write] = ACTIONS(926),
    [anon_sym___read_write] = ACTIONS(926),
    [anon_sym_extern] = ACTIONS(926),
    [anon_sym___attribute__] = ACTIONS(926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(928),
    [anon_sym___declspec] = ACTIONS(926),
    [anon_sym___cdecl] = ACTIONS(926),
    [anon_sym___clrcall] = ACTIONS(926),
    [anon_sym___stdcall] = ACTIONS(926),
    [anon_sym___fastcall] = ACTIONS(926),
    [anon_sym___thiscall] = ACTIONS(926),
    [anon_sym___vectorcall] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(926),
    [anon_sym_auto] = ACTIONS(926),
    [anon_sym_register] = ACTIONS(926),
    [anon_sym_inline] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [anon_sym_volatile] = ACTIONS(926),
    [anon_sym_restrict] = ACTIONS(926),
    [anon_sym__Atomic] = ACTIONS(926),
    [anon_sym_pipe] = ACTIONS(926),
    [anon_sym_signed] = ACTIONS(926),
    [anon_sym_unsigned] = ACTIONS(926),
    [anon_sym_long] = ACTIONS(926),
    [anon_sym_short] = ACTIONS(926),
    [anon_sym_bool] = ACTIONS(926),
    [anon_sym_char] = ACTIONS(926),
    [anon_sym_uchar] = ACTIONS(926),
    [anon_sym_ushort] = ACTIONS(926),
    [anon_sym_int] = ACTIONS(926),
    [anon_sym_uint] = ACTIONS(926),
    [anon_sym_ulong] = ACTIONS(926),
    [anon_sym_float] = ACTIONS(926),
    [anon_sym_double] = ACTIONS(926),
    [anon_sym_half] = ACTIONS(926),
    [anon_sym_size_t] = ACTIONS(926),
    [anon_sym_ptrdiff_t] = ACTIONS(926),
    [anon_sym_intptr_t] = ACTIONS(926),
    [anon_sym_uintptr_t] = ACTIONS(926),
    [anon_sym_void] = ACTIONS(926),
    [sym_vector_type] = ACTIONS(926),
    [anon_sym_image2d_t] = ACTIONS(926),
    [anon_sym_image3d_t] = ACTIONS(926),
    [anon_sym_image2d_array_t] = ACTIONS(926),
    [anon_sym_image1d_t] = ACTIONS(926),
    [anon_sym_image1d_buffer_t] = ACTIONS(926),
    [anon_sym_image1d_array_t] = ACTIONS(926),
    [anon_sym_image2d_depth_t] = ACTIONS(926),
    [anon_sym_image2d_array_depth_t] = ACTIONS(926),
    [anon_sym_sampler_t] = ACTIONS(926),
    [anon_sym_queue_t] = ACTIONS(926),
    [anon_sym_ndrange_t] = ACTIONS(926),
    [anon_sym_clk_event_t] = ACTIONS(926),
    [anon_sym_reserve_id_t] = ACTIONS(926),
    [anon_sym_event_t] = ACTIONS(926),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_struct] = ACTIONS(926),
    [anon_sym_union] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_else] = ACTIONS(926),
    [anon_sym_switch] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(926),
    [anon_sym_default] = ACTIONS(926),
    [anon_sym_while] = ACTIONS(926),
    [anon_sym_do] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_break] = ACTIONS(926),
    [anon_sym_continue] = ACTIONS(926),
    [anon_sym_goto] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(928),
    [anon_sym_sizeof] = ACTIONS(926),
    [sym_number_literal] = ACTIONS(928),
    [anon_sym_L_SQUOTE] = ACTIONS(928),
    [anon_sym_u_SQUOTE] = ACTIONS(928),
    [anon_sym_U_SQUOTE] = ACTIONS(928),
    [anon_sym_u8_SQUOTE] = ACTIONS(928),
    [anon_sym_SQUOTE] = ACTIONS(928),
    [anon_sym_L_DQUOTE] = ACTIONS(928),
    [anon_sym_u_DQUOTE] = ACTIONS(928),
    [anon_sym_U_DQUOTE] = ACTIONS(928),
    [anon_sym_u8_DQUOTE] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [sym_true] = ACTIONS(926),
    [sym_false] = ACTIONS(926),
    [sym_null] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_identifier] = ACTIONS(992),
    [aux_sym_preproc_include_token1] = ACTIONS(992),
    [aux_sym_preproc_def_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token1] = ACTIONS(992),
    [aux_sym_preproc_if_token2] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(992),
    [sym_preproc_directive] = ACTIONS(992),
    [anon_sym_LPAREN2] = ACTIONS(994),
    [anon_sym_BANG] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(994),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(994),
    [anon_sym_AMP] = ACTIONS(994),
    [anon_sym_SEMI] = ACTIONS(994),
    [anon_sym_typedef] = ACTIONS(992),
    [anon_sym_kernel] = ACTIONS(992),
    [anon_sym___kernel] = ACTIONS(992),
    [anon_sym_global] = ACTIONS(992),
    [anon_sym___global] = ACTIONS(992),
    [anon_sym_local] = ACTIONS(992),
    [anon_sym___local] = ACTIONS(992),
    [anon_sym_constant] = ACTIONS(992),
    [anon_sym___constant] = ACTIONS(992),
    [anon_sym_private] = ACTIONS(992),
    [anon_sym___private] = ACTIONS(992),
    [anon_sym_generic] = ACTIONS(992),
    [anon_sym___generic] = ACTIONS(992),
    [anon_sym_read_only] = ACTIONS(992),
    [anon_sym___read_only] = ACTIONS(992),
    [anon_sym_write_only] = ACTIONS(992),
    [anon_sym___write_only] = ACTIONS(992),
    [anon_sym_read_write] = ACTIONS(992),
    [anon_sym___read_write] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym___attribute__] = ACTIONS(992),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(994),
    [anon_sym___declspec] = ACTIONS(992),
    [anon_sym___cdecl] = ACTIONS(992),
    [anon_sym___clrcall] = ACTIONS(992),
    [anon_sym___stdcall] = ACTIONS(992),
    [anon_sym___fastcall] = ACTIONS(992),
    [anon_sym___thiscall] = ACTIONS(992),
    [anon_sym___vectorcall] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(994),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_auto] = ACTIONS(992),
    [anon_sym_register] = ACTIONS(992),
    [anon_sym_inline] = ACTIONS(992),
    [anon_sym_const] = ACTIONS(992),
    [anon_sym_volatile] = ACTIONS(992),
    [anon_sym_restrict] = ACTIONS(992),
    [anon_sym__Atomic] = ACTIONS(992),
    [anon_sym_pipe] = ACTIONS(992),
    [anon_sym_signed] = ACTIONS(992),
    [anon_sym_unsigned] = ACTIONS(992),
    [anon_sym_long] = ACTIONS(992),
    [anon_sym_short] = ACTIONS(992),
    [anon_sym_bool] = ACTIONS(992),
    [anon_sym_char] = ACTIONS(992),
    [anon_sym_uchar] = ACTIONS(992),
    [anon_sym_ushort] = ACTIONS(992),
    [anon_sym_int] = ACTIONS(992),
    [anon_sym_uint] = ACTIONS(992),
    [anon_sym_ulong] = ACTIONS(992),
    [anon_sym_float] = ACTIONS(992),
    [anon_sym_double] = ACTIONS(992),
    [anon_sym_half] = ACTIONS(992),
    [anon_sym_size_t] = ACTIONS(992),
    [anon_sym_ptrdiff_t] = ACTIONS(992),
    [anon_sym_intptr_t] = ACTIONS(992),
    [anon_sym_uintptr_t] = ACTIONS(992),
    [anon_sym_void] = ACTIONS(992),
    [sym_vector_type] = ACTIONS(992),
    [anon_sym_image2d_t] = ACTIONS(992),
    [anon_sym_image3d_t] = ACTIONS(992),
    [anon_sym_image2d_array_t] = ACTIONS(992),
    [anon_sym_image1d_t] = ACTIONS(992),
    [anon_sym_image1d_buffer_t] = ACTIONS(992),
    [anon_sym_image1d_array_t] = ACTIONS(992),
    [anon_sym_image2d_depth_t] = ACTIONS(992),
    [anon_sym_image2d_array_depth_t] = ACTIONS(992),
    [anon_sym_sampler_t] = ACTIONS(992),
    [anon_sym_queue_t] = ACTIONS(992),
    [anon_sym_ndrange_t] = ACTIONS(992),
    [anon_sym_clk_event_t] = ACTIONS(992),
    [anon_sym_reserve_id_t] = ACTIONS(992),
    [anon_sym_event_t] = ACTIONS(992),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_struct] = ACTIONS(992),
    [anon_sym_union] = ACTIONS(992),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_switch] = ACTIONS(992),
    [anon_sym_case] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_goto] = ACTIONS(992),
    [anon_sym_DASH_DASH] = ACTIONS(994),
    [anon_sym_PLUS_PLUS] = ACTIONS(994),
    [anon_sym_sizeof] = ACTIONS(992),
    [sym_number_literal] = ACTIONS(994),
    [anon_sym_L_SQUOTE] = ACTIONS(994),
    [anon_sym_u_SQUOTE] = ACTIONS(994),
    [anon_sym_U_SQUOTE] = ACTIONS(994),
    [anon_sym_u8_SQUOTE] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(994),
    [anon_sym_L_DQUOTE] = ACTIONS(994),
    [anon_sym_u_DQUOTE] = ACTIONS(994),
    [anon_sym_U_DQUOTE] = ACTIONS(994),
    [anon_sym_u8_DQUOTE] = ACTIONS(994),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_true] = ACTIONS(992),
    [sym_false] = ACTIONS(992),
    [sym_null] = ACTIONS(992),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_identifier] = ACTIONS(1028),
    [aux_sym_preproc_include_token1] = ACTIONS(1028),
    [aux_sym_preproc_def_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token1] = ACTIONS(1028),
    [aux_sym_preproc_if_token2] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1028),
    [sym_preproc_directive] = ACTIONS(1028),
    [anon_sym_LPAREN2] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1030),
    [anon_sym_typedef] = ACTIONS(1028),
    [anon_sym_kernel] = ACTIONS(1028),
    [anon_sym___kernel] = ACTIONS(1028),
    [anon_sym_global] = ACTIONS(1028),
    [anon_sym___global] = ACTIONS(1028),
    [anon_sym_local] = ACTIONS(1028),
    [anon_sym___local] = ACTIONS(1028),
    [anon_sym_constant] = ACTIONS(1028),
    [anon_sym___constant] = ACTIONS(1028),
    [anon_sym_private] = ACTIONS(1028),
    [anon_sym___private] = ACTIONS(1028),
    [anon_sym_generic] = ACTIONS(1028),
    [anon_sym___generic] = ACTIONS(1028),
    [anon_sym_read_only] = ACTIONS(1028),
    [anon_sym___read_only] = ACTIONS(1028),
    [anon_sym_write_only] = ACTIONS(1028),
    [anon_sym___write_only] = ACTIONS(1028),
    [anon_sym_read_write] = ACTIONS(1028),
    [anon_sym___read_write] = ACTIONS(1028),
    [anon_sym_extern] = ACTIONS(1028),
    [anon_sym___attribute__] = ACTIONS(1028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1030),
    [anon_sym___declspec] = ACTIONS(1028),
    [anon_sym___cdecl] = ACTIONS(1028),
    [anon_sym___clrcall] = ACTIONS(1028),
    [anon_sym___stdcall] = ACTIONS(1028),
    [anon_sym___fastcall] = ACTIONS(1028),
    [anon_sym___thiscall] = ACTIONS(1028),
    [anon_sym___vectorcall] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1028),
    [anon_sym_auto] = ACTIONS(1028),
    [anon_sym_register] = ACTIONS(1028),
    [anon_sym_inline] = ACTIONS(1028),
    [anon_sym_const] = ACTIONS(1028),
    [anon_sym_volatile] = ACTIONS(1028),
    [anon_sym_restrict] = ACTIONS(1028),
    [anon_sym__Atomic] = ACTIONS(1028),
    [anon_sym_pipe] = ACTIONS(1028),
    [anon_sym_signed] = ACTIONS(1028),
    [anon_sym_unsigned] = ACTIONS(1028),
    [anon_sym_long] = ACTIONS(1028),
    [anon_sym_short] = ACTIONS(1028),
    [anon_sym_bool] = ACTIONS(1028),
    [anon_sym_char] = ACTIONS(1028),
    [anon_sym_uchar] = ACTIONS(1028),
    [anon_sym_ushort] = ACTIONS(1028),
    [anon_sym_int] = ACTIONS(1028),
    [anon_sym_uint] = ACTIONS(1028),
    [anon_sym_ulong] = ACTIONS(1028),
    [anon_sym_float] = ACTIONS(1028),
    [anon_sym_double] = ACTIONS(1028),
    [anon_sym_half] = ACTIONS(1028),
    [anon_sym_size_t] = ACTIONS(1028),
    [anon_sym_ptrdiff_t] = ACTIONS(1028),
    [anon_sym_intptr_t] = ACTIONS(1028),
    [anon_sym_uintptr_t] = ACTIONS(1028),
    [anon_sym_void] = ACTIONS(1028),
    [sym_vector_type] = ACTIONS(1028),
    [anon_sym_image2d_t] = ACTIONS(1028),
    [anon_sym_image3d_t] = ACTIONS(1028),
    [anon_sym_image2d_array_t] = ACTIONS(1028),
    [anon_sym_image1d_t] = ACTIONS(1028),
    [anon_sym_image1d_buffer_t] = ACTIONS(1028),
    [anon_sym_image1d_array_t] = ACTIONS(1028),
    [anon_sym_image2d_depth_t] = ACTIONS(1028),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1028),
    [anon_sym_sampler_t] = ACTIONS(1028),
    [anon_sym_queue_t] = ACTIONS(1028),
    [anon_sym_ndrange_t] = ACTIONS(1028),
    [anon_sym_clk_event_t] = ACTIONS(1028),
    [anon_sym_reserve_id_t] = ACTIONS(1028),
    [anon_sym_event_t] = ACTIONS(1028),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1028),
    [anon_sym_enum] = ACTIONS(1028),
    [anon_sym_struct] = ACTIONS(1028),
    [anon_sym_union] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1028),
    [anon_sym_else] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1028),
    [anon_sym_while] = ACTIONS(1028),
    [anon_sym_do] = ACTIONS(1028),
    [anon_sym_for] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [anon_sym_goto] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [anon_sym_sizeof] = ACTIONS(1028),
    [sym_number_literal] = ACTIONS(1030),
    [anon_sym_L_SQUOTE] = ACTIONS(1030),
    [anon_sym_u_SQUOTE] = ACTIONS(1030),
    [anon_sym_U_SQUOTE] = ACTIONS(1030),
    [anon_sym_u8_SQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [anon_sym_L_DQUOTE] = ACTIONS(1030),
    [anon_sym_u_DQUOTE] = ACTIONS(1030),
    [anon_sym_U_DQUOTE] = ACTIONS(1030),
    [anon_sym_u8_DQUOTE] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [sym_true] = ACTIONS(1028),
    [sym_false] = ACTIONS(1028),
    [sym_null] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_identifier] = ACTIONS(1032),
    [aux_sym_preproc_include_token1] = ACTIONS(1032),
    [aux_sym_preproc_def_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token1] = ACTIONS(1032),
    [aux_sym_preproc_if_token2] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1032),
    [sym_preproc_directive] = ACTIONS(1032),
    [anon_sym_LPAREN2] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1034),
    [anon_sym_typedef] = ACTIONS(1032),
    [anon_sym_kernel] = ACTIONS(1032),
    [anon_sym___kernel] = ACTIONS(1032),
    [anon_sym_global] = ACTIONS(1032),
    [anon_sym___global] = ACTIONS(1032),
    [anon_sym_local] = ACTIONS(1032),
    [anon_sym___local] = ACTIONS(1032),
    [anon_sym_constant] = ACTIONS(1032),
    [anon_sym___constant] = ACTIONS(1032),
    [anon_sym_private] = ACTIONS(1032),
    [anon_sym___private] = ACTIONS(1032),
    [anon_sym_generic] = ACTIONS(1032),
    [anon_sym___generic] = ACTIONS(1032),
    [anon_sym_read_only] = ACTIONS(1032),
    [anon_sym___read_only] = ACTIONS(1032),
    [anon_sym_write_only] = ACTIONS(1032),
    [anon_sym___write_only] = ACTIONS(1032),
    [anon_sym_read_write] = ACTIONS(1032),
    [anon_sym___read_write] = ACTIONS(1032),
    [anon_sym_extern] = ACTIONS(1032),
    [anon_sym___attribute__] = ACTIONS(1032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1034),
    [anon_sym___declspec] = ACTIONS(1032),
    [anon_sym___cdecl] = ACTIONS(1032),
    [anon_sym___clrcall] = ACTIONS(1032),
    [anon_sym___stdcall] = ACTIONS(1032),
    [anon_sym___fastcall] = ACTIONS(1032),
    [anon_sym___thiscall] = ACTIONS(1032),
    [anon_sym___vectorcall] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1032),
    [anon_sym_auto] = ACTIONS(1032),
    [anon_sym_register] = ACTIONS(1032),
    [anon_sym_inline] = ACTIONS(1032),
    [anon_sym_const] = ACTIONS(1032),
    [anon_sym_volatile] = ACTIONS(1032),
    [anon_sym_restrict] = ACTIONS(1032),
    [anon_sym__Atomic] = ACTIONS(1032),
    [anon_sym_pipe] = ACTIONS(1032),
    [anon_sym_signed] = ACTIONS(1032),
    [anon_sym_unsigned] = ACTIONS(1032),
    [anon_sym_long] = ACTIONS(1032),
    [anon_sym_short] = ACTIONS(1032),
    [anon_sym_bool] = ACTIONS(1032),
    [anon_sym_char] = ACTIONS(1032),
    [anon_sym_uchar] = ACTIONS(1032),
    [anon_sym_ushort] = ACTIONS(1032),
    [anon_sym_int] = ACTIONS(1032),
    [anon_sym_uint] = ACTIONS(1032),
    [anon_sym_ulong] = ACTIONS(1032),
    [anon_sym_float] = ACTIONS(1032),
    [anon_sym_double] = ACTIONS(1032),
    [anon_sym_half] = ACTIONS(1032),
    [anon_sym_size_t] = ACTIONS(1032),
    [anon_sym_ptrdiff_t] = ACTIONS(1032),
    [anon_sym_intptr_t] = ACTIONS(1032),
    [anon_sym_uintptr_t] = ACTIONS(1032),
    [anon_sym_void] = ACTIONS(1032),
    [sym_vector_type] = ACTIONS(1032),
    [anon_sym_image2d_t] = ACTIONS(1032),
    [anon_sym_image3d_t] = ACTIONS(1032),
    [anon_sym_image2d_array_t] = ACTIONS(1032),
    [anon_sym_image1d_t] = ACTIONS(1032),
    [anon_sym_image1d_buffer_t] = ACTIONS(1032),
    [anon_sym_image1d_array_t] = ACTIONS(1032),
    [anon_sym_image2d_depth_t] = ACTIONS(1032),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1032),
    [anon_sym_sampler_t] = ACTIONS(1032),
    [anon_sym_queue_t] = ACTIONS(1032),
    [anon_sym_ndrange_t] = ACTIONS(1032),
    [anon_sym_clk_event_t] = ACTIONS(1032),
    [anon_sym_reserve_id_t] = ACTIONS(1032),
    [anon_sym_event_t] = ACTIONS(1032),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1032),
    [anon_sym_enum] = ACTIONS(1032),
    [anon_sym_struct] = ACTIONS(1032),
    [anon_sym_union] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_while] = ACTIONS(1032),
    [anon_sym_do] = ACTIONS(1032),
    [anon_sym_for] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [anon_sym_goto] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [anon_sym_sizeof] = ACTIONS(1032),
    [sym_number_literal] = ACTIONS(1034),
    [anon_sym_L_SQUOTE] = ACTIONS(1034),
    [anon_sym_u_SQUOTE] = ACTIONS(1034),
    [anon_sym_U_SQUOTE] = ACTIONS(1034),
    [anon_sym_u8_SQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [anon_sym_L_DQUOTE] = ACTIONS(1034),
    [anon_sym_u_DQUOTE] = ACTIONS(1034),
    [anon_sym_U_DQUOTE] = ACTIONS(1034),
    [anon_sym_u8_DQUOTE] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [sym_true] = ACTIONS(1032),
    [sym_false] = ACTIONS(1032),
    [sym_null] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [sym_identifier] = ACTIONS(1044),
    [aux_sym_preproc_include_token1] = ACTIONS(1044),
    [aux_sym_preproc_def_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token1] = ACTIONS(1044),
    [aux_sym_preproc_if_token2] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1044),
    [sym_preproc_directive] = ACTIONS(1044),
    [anon_sym_LPAREN2] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_STAR] = ACTIONS(1046),
    [anon_sym_AMP] = ACTIONS(1046),
    [anon_sym_SEMI] = ACTIONS(1046),
    [anon_sym_typedef] = ACTIONS(1044),
    [anon_sym_kernel] = ACTIONS(1044),
    [anon_sym___kernel] = ACTIONS(1044),
    [anon_sym_global] = ACTIONS(1044),
    [anon_sym___global] = ACTIONS(1044),
    [anon_sym_local] = ACTIONS(1044),
    [anon_sym___local] = ACTIONS(1044),
    [anon_sym_constant] = ACTIONS(1044),
    [anon_sym___constant] = ACTIONS(1044),
    [anon_sym_private] = ACTIONS(1044),
    [anon_sym___private] = ACTIONS(1044),
    [anon_sym_generic] = ACTIONS(1044),
    [anon_sym___generic] = ACTIONS(1044),
    [anon_sym_read_only] = ACTIONS(1044),
    [anon_sym___read_only] = ACTIONS(1044),
    [anon_sym_write_only] = ACTIONS(1044),
    [anon_sym___write_only] = ACTIONS(1044),
    [anon_sym_read_write] = ACTIONS(1044),
    [anon_sym___read_write] = ACTIONS(1044),
    [anon_sym_extern] = ACTIONS(1044),
    [anon_sym___attribute__] = ACTIONS(1044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1046),
    [anon_sym___declspec] = ACTIONS(1044),
    [anon_sym___cdecl] = ACTIONS(1044),
    [anon_sym___clrcall] = ACTIONS(1044),
    [anon_sym___stdcall] = ACTIONS(1044),
    [anon_sym___fastcall] = ACTIONS(1044),
    [anon_sym___thiscall] = ACTIONS(1044),
    [anon_sym___vectorcall] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1044),
    [anon_sym_auto] = ACTIONS(1044),
    [anon_sym_register] = ACTIONS(1044),
    [anon_sym_inline] = ACTIONS(1044),
    [anon_sym_const] = ACTIONS(1044),
    [anon_sym_volatile] = ACTIONS(1044),
    [anon_sym_restrict] = ACTIONS(1044),
    [anon_sym__Atomic] = ACTIONS(1044),
    [anon_sym_pipe] = ACTIONS(1044),
    [anon_sym_signed] = ACTIONS(1044),
    [anon_sym_unsigned] = ACTIONS(1044),
    [anon_sym_long] = ACTIONS(1044),
    [anon_sym_short] = ACTIONS(1044),
    [anon_sym_bool] = ACTIONS(1044),
    [anon_sym_char] = ACTIONS(1044),
    [anon_sym_uchar] = ACTIONS(1044),
    [anon_sym_ushort] = ACTIONS(1044),
    [anon_sym_int] = ACTIONS(1044),
    [anon_sym_uint] = ACTIONS(1044),
    [anon_sym_ulong] = ACTIONS(1044),
    [anon_sym_float] = ACTIONS(1044),
    [anon_sym_double] = ACTIONS(1044),
    [anon_sym_half] = ACTIONS(1044),
    [anon_sym_size_t] = ACTIONS(1044),
    [anon_sym_ptrdiff_t] = ACTIONS(1044),
    [anon_sym_intptr_t] = ACTIONS(1044),
    [anon_sym_uintptr_t] = ACTIONS(1044),
    [anon_sym_void] = ACTIONS(1044),
    [sym_vector_type] = ACTIONS(1044),
    [anon_sym_image2d_t] = ACTIONS(1044),
    [anon_sym_image3d_t] = ACTIONS(1044),
    [anon_sym_image2d_array_t] = ACTIONS(1044),
    [anon_sym_image1d_t] = ACTIONS(1044),
    [anon_sym_image1d_buffer_t] = ACTIONS(1044),
    [anon_sym_image1d_array_t] = ACTIONS(1044),
    [anon_sym_image2d_depth_t] = ACTIONS(1044),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1044),
    [anon_sym_sampler_t] = ACTIONS(1044),
    [anon_sym_queue_t] = ACTIONS(1044),
    [anon_sym_ndrange_t] = ACTIONS(1044),
    [anon_sym_clk_event_t] = ACTIONS(1044),
    [anon_sym_reserve_id_t] = ACTIONS(1044),
    [anon_sym_event_t] = ACTIONS(1044),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1044),
    [anon_sym_enum] = ACTIONS(1044),
    [anon_sym_struct] = ACTIONS(1044),
    [anon_sym_union] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_else] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_while] = ACTIONS(1044),
    [anon_sym_do] = ACTIONS(1044),
    [anon_sym_for] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [anon_sym_goto] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [anon_sym_sizeof] = ACTIONS(1044),
    [sym_number_literal] = ACTIONS(1046),
    [anon_sym_L_SQUOTE] = ACTIONS(1046),
    [anon_sym_u_SQUOTE] = ACTIONS(1046),
    [anon_sym_U_SQUOTE] = ACTIONS(1046),
    [anon_sym_u8_SQUOTE] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_L_DQUOTE] = ACTIONS(1046),
    [anon_sym_u_DQUOTE] = ACTIONS(1046),
    [anon_sym_U_DQUOTE] = ACTIONS(1046),
    [anon_sym_u8_DQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_true] = ACTIONS(1044),
    [sym_false] = ACTIONS(1044),
    [sym_null] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [sym_identifier] = ACTIONS(922),
    [aux_sym_preproc_include_token1] = ACTIONS(922),
    [aux_sym_preproc_def_token1] = ACTIONS(922),
    [aux_sym_preproc_if_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(922),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(922),
    [sym_preproc_directive] = ACTIONS(922),
    [anon_sym_LPAREN2] = ACTIONS(924),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(924),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [anon_sym_typedef] = ACTIONS(922),
    [anon_sym_kernel] = ACTIONS(922),
    [anon_sym___kernel] = ACTIONS(922),
    [anon_sym_global] = ACTIONS(922),
    [anon_sym___global] = ACTIONS(922),
    [anon_sym_local] = ACTIONS(922),
    [anon_sym___local] = ACTIONS(922),
    [anon_sym_constant] = ACTIONS(922),
    [anon_sym___constant] = ACTIONS(922),
    [anon_sym_private] = ACTIONS(922),
    [anon_sym___private] = ACTIONS(922),
    [anon_sym_generic] = ACTIONS(922),
    [anon_sym___generic] = ACTIONS(922),
    [anon_sym_read_only] = ACTIONS(922),
    [anon_sym___read_only] = ACTIONS(922),
    [anon_sym_write_only] = ACTIONS(922),
    [anon_sym___write_only] = ACTIONS(922),
    [anon_sym_read_write] = ACTIONS(922),
    [anon_sym___read_write] = ACTIONS(922),
    [anon_sym_extern] = ACTIONS(922),
    [anon_sym___attribute__] = ACTIONS(922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(924),
    [anon_sym___declspec] = ACTIONS(922),
    [anon_sym___cdecl] = ACTIONS(922),
    [anon_sym___clrcall] = ACTIONS(922),
    [anon_sym___stdcall] = ACTIONS(922),
    [anon_sym___fastcall] = ACTIONS(922),
    [anon_sym___thiscall] = ACTIONS(922),
    [anon_sym___vectorcall] = ACTIONS(922),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_RBRACE] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(922),
    [anon_sym_auto] = ACTIONS(922),
    [anon_sym_register] = ACTIONS(922),
    [anon_sym_inline] = ACTIONS(922),
    [anon_sym_const] = ACTIONS(922),
    [anon_sym_volatile] = ACTIONS(922),
    [anon_sym_restrict] = ACTIONS(922),
    [anon_sym__Atomic] = ACTIONS(922),
    [anon_sym_pipe] = ACTIONS(922),
    [anon_sym_signed] = ACTIONS(922),
    [anon_sym_unsigned] = ACTIONS(922),
    [anon_sym_long] = ACTIONS(922),
    [anon_sym_short] = ACTIONS(922),
    [anon_sym_bool] = ACTIONS(922),
    [anon_sym_char] = ACTIONS(922),
    [anon_sym_uchar] = ACTIONS(922),
    [anon_sym_ushort] = ACTIONS(922),
    [anon_sym_int] = ACTIONS(922),
    [anon_sym_uint] = ACTIONS(922),
    [anon_sym_ulong] = ACTIONS(922),
    [anon_sym_float] = ACTIONS(922),
    [anon_sym_double] = ACTIONS(922),
    [anon_sym_half] = ACTIONS(922),
    [anon_sym_size_t] = ACTIONS(922),
    [anon_sym_ptrdiff_t] = ACTIONS(922),
    [anon_sym_intptr_t] = ACTIONS(922),
    [anon_sym_uintptr_t] = ACTIONS(922),
    [anon_sym_void] = ACTIONS(922),
    [sym_vector_type] = ACTIONS(922),
    [anon_sym_image2d_t] = ACTIONS(922),
    [anon_sym_image3d_t] = ACTIONS(922),
    [anon_sym_image2d_array_t] = ACTIONS(922),
    [anon_sym_image1d_t] = ACTIONS(922),
    [anon_sym_image1d_buffer_t] = ACTIONS(922),
    [anon_sym_image1d_array_t] = ACTIONS(922),
    [anon_sym_image2d_depth_t] = ACTIONS(922),
    [anon_sym_image2d_array_depth_t] = ACTIONS(922),
    [anon_sym_sampler_t] = ACTIONS(922),
    [anon_sym_queue_t] = ACTIONS(922),
    [anon_sym_ndrange_t] = ACTIONS(922),
    [anon_sym_clk_event_t] = ACTIONS(922),
    [anon_sym_reserve_id_t] = ACTIONS(922),
    [anon_sym_event_t] = ACTIONS(922),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_struct] = ACTIONS(922),
    [anon_sym_union] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(922),
    [anon_sym_case] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_do] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_goto] = ACTIONS(922),
    [anon_sym_DASH_DASH] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(924),
    [anon_sym_sizeof] = ACTIONS(922),
    [sym_number_literal] = ACTIONS(924),
    [anon_sym_L_SQUOTE] = ACTIONS(924),
    [anon_sym_u_SQUOTE] = ACTIONS(924),
    [anon_sym_U_SQUOTE] = ACTIONS(924),
    [anon_sym_u8_SQUOTE] = ACTIONS(924),
    [anon_sym_SQUOTE] = ACTIONS(924),
    [anon_sym_L_DQUOTE] = ACTIONS(924),
    [anon_sym_u_DQUOTE] = ACTIONS(924),
    [anon_sym_U_DQUOTE] = ACTIONS(924),
    [anon_sym_u8_DQUOTE] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(924),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_null] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym_identifier] = ACTIONS(976),
    [aux_sym_preproc_include_token1] = ACTIONS(976),
    [aux_sym_preproc_def_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token1] = ACTIONS(976),
    [aux_sym_preproc_if_token2] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(976),
    [sym_preproc_directive] = ACTIONS(976),
    [anon_sym_LPAREN2] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(978),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_AMP] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_typedef] = ACTIONS(976),
    [anon_sym_kernel] = ACTIONS(976),
    [anon_sym___kernel] = ACTIONS(976),
    [anon_sym_global] = ACTIONS(976),
    [anon_sym___global] = ACTIONS(976),
    [anon_sym_local] = ACTIONS(976),
    [anon_sym___local] = ACTIONS(976),
    [anon_sym_constant] = ACTIONS(976),
    [anon_sym___constant] = ACTIONS(976),
    [anon_sym_private] = ACTIONS(976),
    [anon_sym___private] = ACTIONS(976),
    [anon_sym_generic] = ACTIONS(976),
    [anon_sym___generic] = ACTIONS(976),
    [anon_sym_read_only] = ACTIONS(976),
    [anon_sym___read_only] = ACTIONS(976),
    [anon_sym_write_only] = ACTIONS(976),
    [anon_sym___write_only] = ACTIONS(976),
    [anon_sym_read_write] = ACTIONS(976),
    [anon_sym___read_write] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym___attribute__] = ACTIONS(976),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(978),
    [anon_sym___declspec] = ACTIONS(976),
    [anon_sym___cdecl] = ACTIONS(976),
    [anon_sym___clrcall] = ACTIONS(976),
    [anon_sym___stdcall] = ACTIONS(976),
    [anon_sym___fastcall] = ACTIONS(976),
    [anon_sym___thiscall] = ACTIONS(976),
    [anon_sym___vectorcall] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_auto] = ACTIONS(976),
    [anon_sym_register] = ACTIONS(976),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym_const] = ACTIONS(976),
    [anon_sym_volatile] = ACTIONS(976),
    [anon_sym_restrict] = ACTIONS(976),
    [anon_sym__Atomic] = ACTIONS(976),
    [anon_sym_pipe] = ACTIONS(976),
    [anon_sym_signed] = ACTIONS(976),
    [anon_sym_unsigned] = ACTIONS(976),
    [anon_sym_long] = ACTIONS(976),
    [anon_sym_short] = ACTIONS(976),
    [anon_sym_bool] = ACTIONS(976),
    [anon_sym_char] = ACTIONS(976),
    [anon_sym_uchar] = ACTIONS(976),
    [anon_sym_ushort] = ACTIONS(976),
    [anon_sym_int] = ACTIONS(976),
    [anon_sym_uint] = ACTIONS(976),
    [anon_sym_ulong] = ACTIONS(976),
    [anon_sym_float] = ACTIONS(976),
    [anon_sym_double] = ACTIONS(976),
    [anon_sym_half] = ACTIONS(976),
    [anon_sym_size_t] = ACTIONS(976),
    [anon_sym_ptrdiff_t] = ACTIONS(976),
    [anon_sym_intptr_t] = ACTIONS(976),
    [anon_sym_uintptr_t] = ACTIONS(976),
    [anon_sym_void] = ACTIONS(976),
    [sym_vector_type] = ACTIONS(976),
    [anon_sym_image2d_t] = ACTIONS(976),
    [anon_sym_image3d_t] = ACTIONS(976),
    [anon_sym_image2d_array_t] = ACTIONS(976),
    [anon_sym_image1d_t] = ACTIONS(976),
    [anon_sym_image1d_buffer_t] = ACTIONS(976),
    [anon_sym_image1d_array_t] = ACTIONS(976),
    [anon_sym_image2d_depth_t] = ACTIONS(976),
    [anon_sym_image2d_array_depth_t] = ACTIONS(976),
    [anon_sym_sampler_t] = ACTIONS(976),
    [anon_sym_queue_t] = ACTIONS(976),
    [anon_sym_ndrange_t] = ACTIONS(976),
    [anon_sym_clk_event_t] = ACTIONS(976),
    [anon_sym_reserve_id_t] = ACTIONS(976),
    [anon_sym_event_t] = ACTIONS(976),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_struct] = ACTIONS(976),
    [anon_sym_union] = ACTIONS(976),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_goto] = ACTIONS(976),
    [anon_sym_DASH_DASH] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(978),
    [anon_sym_sizeof] = ACTIONS(976),
    [sym_number_literal] = ACTIONS(978),
    [anon_sym_L_SQUOTE] = ACTIONS(978),
    [anon_sym_u_SQUOTE] = ACTIONS(978),
    [anon_sym_U_SQUOTE] = ACTIONS(978),
    [anon_sym_u8_SQUOTE] = ACTIONS(978),
    [anon_sym_SQUOTE] = ACTIONS(978),
    [anon_sym_L_DQUOTE] = ACTIONS(978),
    [anon_sym_u_DQUOTE] = ACTIONS(978),
    [anon_sym_U_DQUOTE] = ACTIONS(978),
    [anon_sym_u8_DQUOTE] = ACTIONS(978),
    [anon_sym_DQUOTE] = ACTIONS(978),
    [sym_true] = ACTIONS(976),
    [sym_false] = ACTIONS(976),
    [sym_null] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_identifier] = ACTIONS(954),
    [aux_sym_preproc_include_token1] = ACTIONS(954),
    [aux_sym_preproc_def_token1] = ACTIONS(954),
    [aux_sym_preproc_if_token1] = ACTIONS(954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(954),
    [sym_preproc_directive] = ACTIONS(954),
    [anon_sym_LPAREN2] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_STAR] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(956),
    [anon_sym_SEMI] = ACTIONS(956),
    [anon_sym_typedef] = ACTIONS(954),
    [anon_sym_kernel] = ACTIONS(954),
    [anon_sym___kernel] = ACTIONS(954),
    [anon_sym_global] = ACTIONS(954),
    [anon_sym___global] = ACTIONS(954),
    [anon_sym_local] = ACTIONS(954),
    [anon_sym___local] = ACTIONS(954),
    [anon_sym_constant] = ACTIONS(954),
    [anon_sym___constant] = ACTIONS(954),
    [anon_sym_private] = ACTIONS(954),
    [anon_sym___private] = ACTIONS(954),
    [anon_sym_generic] = ACTIONS(954),
    [anon_sym___generic] = ACTIONS(954),
    [anon_sym_read_only] = ACTIONS(954),
    [anon_sym___read_only] = ACTIONS(954),
    [anon_sym_write_only] = ACTIONS(954),
    [anon_sym___write_only] = ACTIONS(954),
    [anon_sym_read_write] = ACTIONS(954),
    [anon_sym___read_write] = ACTIONS(954),
    [anon_sym_extern] = ACTIONS(954),
    [anon_sym___attribute__] = ACTIONS(954),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(956),
    [anon_sym___declspec] = ACTIONS(954),
    [anon_sym___cdecl] = ACTIONS(954),
    [anon_sym___clrcall] = ACTIONS(954),
    [anon_sym___stdcall] = ACTIONS(954),
    [anon_sym___fastcall] = ACTIONS(954),
    [anon_sym___thiscall] = ACTIONS(954),
    [anon_sym___vectorcall] = ACTIONS(954),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(954),
    [anon_sym_auto] = ACTIONS(954),
    [anon_sym_register] = ACTIONS(954),
    [anon_sym_inline] = ACTIONS(954),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_volatile] = ACTIONS(954),
    [anon_sym_restrict] = ACTIONS(954),
    [anon_sym__Atomic] = ACTIONS(954),
    [anon_sym_pipe] = ACTIONS(954),
    [anon_sym_signed] = ACTIONS(954),
    [anon_sym_unsigned] = ACTIONS(954),
    [anon_sym_long] = ACTIONS(954),
    [anon_sym_short] = ACTIONS(954),
    [anon_sym_bool] = ACTIONS(954),
    [anon_sym_char] = ACTIONS(954),
    [anon_sym_uchar] = ACTIONS(954),
    [anon_sym_ushort] = ACTIONS(954),
    [anon_sym_int] = ACTIONS(954),
    [anon_sym_uint] = ACTIONS(954),
    [anon_sym_ulong] = ACTIONS(954),
    [anon_sym_float] = ACTIONS(954),
    [anon_sym_double] = ACTIONS(954),
    [anon_sym_half] = ACTIONS(954),
    [anon_sym_size_t] = ACTIONS(954),
    [anon_sym_ptrdiff_t] = ACTIONS(954),
    [anon_sym_intptr_t] = ACTIONS(954),
    [anon_sym_uintptr_t] = ACTIONS(954),
    [anon_sym_void] = ACTIONS(954),
    [sym_vector_type] = ACTIONS(954),
    [anon_sym_image2d_t] = ACTIONS(954),
    [anon_sym_image3d_t] = ACTIONS(954),
    [anon_sym_image2d_array_t] = ACTIONS(954),
    [anon_sym_image1d_t] = ACTIONS(954),
    [anon_sym_image1d_buffer_t] = ACTIONS(954),
    [anon_sym_image1d_array_t] = ACTIONS(954),
    [anon_sym_image2d_depth_t] = ACTIONS(954),
    [anon_sym_image2d_array_depth_t] = ACTIONS(954),
    [anon_sym_sampler_t] = ACTIONS(954),
    [anon_sym_queue_t] = ACTIONS(954),
    [anon_sym_ndrange_t] = ACTIONS(954),
    [anon_sym_clk_event_t] = ACTIONS(954),
    [anon_sym_reserve_id_t] = ACTIONS(954),
    [anon_sym_event_t] = ACTIONS(954),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(954),
    [anon_sym_enum] = ACTIONS(954),
    [anon_sym_struct] = ACTIONS(954),
    [anon_sym_union] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_else] = ACTIONS(954),
    [anon_sym_switch] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(954),
    [anon_sym_default] = ACTIONS(954),
    [anon_sym_while] = ACTIONS(954),
    [anon_sym_do] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(954),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_break] = ACTIONS(954),
    [anon_sym_continue] = ACTIONS(954),
    [anon_sym_goto] = ACTIONS(954),
    [anon_sym_DASH_DASH] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(956),
    [anon_sym_sizeof] = ACTIONS(954),
    [sym_number_literal] = ACTIONS(956),
    [anon_sym_L_SQUOTE] = ACTIONS(956),
    [anon_sym_u_SQUOTE] = ACTIONS(956),
    [anon_sym_U_SQUOTE] = ACTIONS(956),
    [anon_sym_u8_SQUOTE] = ACTIONS(956),
    [anon_sym_SQUOTE] = ACTIONS(956),
    [anon_sym_L_DQUOTE] = ACTIONS(956),
    [anon_sym_u_DQUOTE] = ACTIONS(956),
    [anon_sym_U_DQUOTE] = ACTIONS(956),
    [anon_sym_u8_DQUOTE] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(956),
    [sym_true] = ACTIONS(954),
    [sym_false] = ACTIONS(954),
    [sym_null] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_identifier] = ACTIONS(934),
    [aux_sym_preproc_include_token1] = ACTIONS(934),
    [aux_sym_preproc_def_token1] = ACTIONS(934),
    [aux_sym_preproc_if_token1] = ACTIONS(934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(934),
    [sym_preproc_directive] = ACTIONS(934),
    [anon_sym_LPAREN2] = ACTIONS(936),
    [anon_sym_BANG] = ACTIONS(936),
    [anon_sym_TILDE] = ACTIONS(936),
    [anon_sym_DASH] = ACTIONS(934),
    [anon_sym_PLUS] = ACTIONS(934),
    [anon_sym_STAR] = ACTIONS(936),
    [anon_sym_AMP] = ACTIONS(936),
    [anon_sym_SEMI] = ACTIONS(936),
    [anon_sym_typedef] = ACTIONS(934),
    [anon_sym_kernel] = ACTIONS(934),
    [anon_sym___kernel] = ACTIONS(934),
    [anon_sym_global] = ACTIONS(934),
    [anon_sym___global] = ACTIONS(934),
    [anon_sym_local] = ACTIONS(934),
    [anon_sym___local] = ACTIONS(934),
    [anon_sym_constant] = ACTIONS(934),
    [anon_sym___constant] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym___private] = ACTIONS(934),
    [anon_sym_generic] = ACTIONS(934),
    [anon_sym___generic] = ACTIONS(934),
    [anon_sym_read_only] = ACTIONS(934),
    [anon_sym___read_only] = ACTIONS(934),
    [anon_sym_write_only] = ACTIONS(934),
    [anon_sym___write_only] = ACTIONS(934),
    [anon_sym_read_write] = ACTIONS(934),
    [anon_sym___read_write] = ACTIONS(934),
    [anon_sym_extern] = ACTIONS(934),
    [anon_sym___attribute__] = ACTIONS(934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(936),
    [anon_sym___declspec] = ACTIONS(934),
    [anon_sym___cdecl] = ACTIONS(934),
    [anon_sym___clrcall] = ACTIONS(934),
    [anon_sym___stdcall] = ACTIONS(934),
    [anon_sym___fastcall] = ACTIONS(934),
    [anon_sym___thiscall] = ACTIONS(934),
    [anon_sym___vectorcall] = ACTIONS(934),
    [anon_sym_LBRACE] = ACTIONS(936),
    [anon_sym_RBRACE] = ACTIONS(936),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_auto] = ACTIONS(934),
    [anon_sym_register] = ACTIONS(934),
    [anon_sym_inline] = ACTIONS(934),
    [anon_sym_const] = ACTIONS(934),
    [anon_sym_volatile] = ACTIONS(934),
    [anon_sym_restrict] = ACTIONS(934),
    [anon_sym__Atomic] = ACTIONS(934),
    [anon_sym_pipe] = ACTIONS(934),
    [anon_sym_signed] = ACTIONS(934),
    [anon_sym_unsigned] = ACTIONS(934),
    [anon_sym_long] = ACTIONS(934),
    [anon_sym_short] = ACTIONS(934),
    [anon_sym_bool] = ACTIONS(934),
    [anon_sym_char] = ACTIONS(934),
    [anon_sym_uchar] = ACTIONS(934),
    [anon_sym_ushort] = ACTIONS(934),
    [anon_sym_int] = ACTIONS(934),
    [anon_sym_uint] = ACTIONS(934),
    [anon_sym_ulong] = ACTIONS(934),
    [anon_sym_float] = ACTIONS(934),
    [anon_sym_double] = ACTIONS(934),
    [anon_sym_half] = ACTIONS(934),
    [anon_sym_size_t] = ACTIONS(934),
    [anon_sym_ptrdiff_t] = ACTIONS(934),
    [anon_sym_intptr_t] = ACTIONS(934),
    [anon_sym_uintptr_t] = ACTIONS(934),
    [anon_sym_void] = ACTIONS(934),
    [sym_vector_type] = ACTIONS(934),
    [anon_sym_image2d_t] = ACTIONS(934),
    [anon_sym_image3d_t] = ACTIONS(934),
    [anon_sym_image2d_array_t] = ACTIONS(934),
    [anon_sym_image1d_t] = ACTIONS(934),
    [anon_sym_image1d_buffer_t] = ACTIONS(934),
    [anon_sym_image1d_array_t] = ACTIONS(934),
    [anon_sym_image2d_depth_t] = ACTIONS(934),
    [anon_sym_image2d_array_depth_t] = ACTIONS(934),
    [anon_sym_sampler_t] = ACTIONS(934),
    [anon_sym_queue_t] = ACTIONS(934),
    [anon_sym_ndrange_t] = ACTIONS(934),
    [anon_sym_clk_event_t] = ACTIONS(934),
    [anon_sym_reserve_id_t] = ACTIONS(934),
    [anon_sym_event_t] = ACTIONS(934),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(934),
    [anon_sym_enum] = ACTIONS(934),
    [anon_sym_struct] = ACTIONS(934),
    [anon_sym_union] = ACTIONS(934),
    [anon_sym_if] = ACTIONS(934),
    [anon_sym_else] = ACTIONS(934),
    [anon_sym_switch] = ACTIONS(934),
    [anon_sym_case] = ACTIONS(934),
    [anon_sym_default] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(934),
    [anon_sym_do] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(934),
    [anon_sym_return] = ACTIONS(934),
    [anon_sym_break] = ACTIONS(934),
    [anon_sym_continue] = ACTIONS(934),
    [anon_sym_goto] = ACTIONS(934),
    [anon_sym_DASH_DASH] = ACTIONS(936),
    [anon_sym_PLUS_PLUS] = ACTIONS(936),
    [anon_sym_sizeof] = ACTIONS(934),
    [sym_number_literal] = ACTIONS(936),
    [anon_sym_L_SQUOTE] = ACTIONS(936),
    [anon_sym_u_SQUOTE] = ACTIONS(936),
    [anon_sym_U_SQUOTE] = ACTIONS(936),
    [anon_sym_u8_SQUOTE] = ACTIONS(936),
    [anon_sym_SQUOTE] = ACTIONS(936),
    [anon_sym_L_DQUOTE] = ACTIONS(936),
    [anon_sym_u_DQUOTE] = ACTIONS(936),
    [anon_sym_U_DQUOTE] = ACTIONS(936),
    [anon_sym_u8_DQUOTE] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(936),
    [sym_true] = ACTIONS(934),
    [sym_false] = ACTIONS(934),
    [sym_null] = ACTIONS(934),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_identifier] = ACTIONS(942),
    [aux_sym_preproc_include_token1] = ACTIONS(942),
    [aux_sym_preproc_def_token1] = ACTIONS(942),
    [aux_sym_preproc_if_token1] = ACTIONS(942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(942),
    [sym_preproc_directive] = ACTIONS(942),
    [anon_sym_LPAREN2] = ACTIONS(944),
    [anon_sym_BANG] = ACTIONS(944),
    [anon_sym_TILDE] = ACTIONS(944),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_STAR] = ACTIONS(944),
    [anon_sym_AMP] = ACTIONS(944),
    [anon_sym_SEMI] = ACTIONS(944),
    [anon_sym_typedef] = ACTIONS(942),
    [anon_sym_kernel] = ACTIONS(942),
    [anon_sym___kernel] = ACTIONS(942),
    [anon_sym_global] = ACTIONS(942),
    [anon_sym___global] = ACTIONS(942),
    [anon_sym_local] = ACTIONS(942),
    [anon_sym___local] = ACTIONS(942),
    [anon_sym_constant] = ACTIONS(942),
    [anon_sym___constant] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym___private] = ACTIONS(942),
    [anon_sym_generic] = ACTIONS(942),
    [anon_sym___generic] = ACTIONS(942),
    [anon_sym_read_only] = ACTIONS(942),
    [anon_sym___read_only] = ACTIONS(942),
    [anon_sym_write_only] = ACTIONS(942),
    [anon_sym___write_only] = ACTIONS(942),
    [anon_sym_read_write] = ACTIONS(942),
    [anon_sym___read_write] = ACTIONS(942),
    [anon_sym_extern] = ACTIONS(942),
    [anon_sym___attribute__] = ACTIONS(942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(944),
    [anon_sym___declspec] = ACTIONS(942),
    [anon_sym___cdecl] = ACTIONS(942),
    [anon_sym___clrcall] = ACTIONS(942),
    [anon_sym___stdcall] = ACTIONS(942),
    [anon_sym___fastcall] = ACTIONS(942),
    [anon_sym___thiscall] = ACTIONS(942),
    [anon_sym___vectorcall] = ACTIONS(942),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_RBRACE] = ACTIONS(944),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_auto] = ACTIONS(942),
    [anon_sym_register] = ACTIONS(942),
    [anon_sym_inline] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_volatile] = ACTIONS(942),
    [anon_sym_restrict] = ACTIONS(942),
    [anon_sym__Atomic] = ACTIONS(942),
    [anon_sym_pipe] = ACTIONS(942),
    [anon_sym_signed] = ACTIONS(942),
    [anon_sym_unsigned] = ACTIONS(942),
    [anon_sym_long] = ACTIONS(942),
    [anon_sym_short] = ACTIONS(942),
    [anon_sym_bool] = ACTIONS(942),
    [anon_sym_char] = ACTIONS(942),
    [anon_sym_uchar] = ACTIONS(942),
    [anon_sym_ushort] = ACTIONS(942),
    [anon_sym_int] = ACTIONS(942),
    [anon_sym_uint] = ACTIONS(942),
    [anon_sym_ulong] = ACTIONS(942),
    [anon_sym_float] = ACTIONS(942),
    [anon_sym_double] = ACTIONS(942),
    [anon_sym_half] = ACTIONS(942),
    [anon_sym_size_t] = ACTIONS(942),
    [anon_sym_ptrdiff_t] = ACTIONS(942),
    [anon_sym_intptr_t] = ACTIONS(942),
    [anon_sym_uintptr_t] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(942),
    [sym_vector_type] = ACTIONS(942),
    [anon_sym_image2d_t] = ACTIONS(942),
    [anon_sym_image3d_t] = ACTIONS(942),
    [anon_sym_image2d_array_t] = ACTIONS(942),
    [anon_sym_image1d_t] = ACTIONS(942),
    [anon_sym_image1d_buffer_t] = ACTIONS(942),
    [anon_sym_image1d_array_t] = ACTIONS(942),
    [anon_sym_image2d_depth_t] = ACTIONS(942),
    [anon_sym_image2d_array_depth_t] = ACTIONS(942),
    [anon_sym_sampler_t] = ACTIONS(942),
    [anon_sym_queue_t] = ACTIONS(942),
    [anon_sym_ndrange_t] = ACTIONS(942),
    [anon_sym_clk_event_t] = ACTIONS(942),
    [anon_sym_reserve_id_t] = ACTIONS(942),
    [anon_sym_event_t] = ACTIONS(942),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_struct] = ACTIONS(942),
    [anon_sym_union] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_else] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(942),
    [anon_sym_case] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(942),
    [anon_sym_while] = ACTIONS(942),
    [anon_sym_do] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_break] = ACTIONS(942),
    [anon_sym_continue] = ACTIONS(942),
    [anon_sym_goto] = ACTIONS(942),
    [anon_sym_DASH_DASH] = ACTIONS(944),
    [anon_sym_PLUS_PLUS] = ACTIONS(944),
    [anon_sym_sizeof] = ACTIONS(942),
    [sym_number_literal] = ACTIONS(944),
    [anon_sym_L_SQUOTE] = ACTIONS(944),
    [anon_sym_u_SQUOTE] = ACTIONS(944),
    [anon_sym_U_SQUOTE] = ACTIONS(944),
    [anon_sym_u8_SQUOTE] = ACTIONS(944),
    [anon_sym_SQUOTE] = ACTIONS(944),
    [anon_sym_L_DQUOTE] = ACTIONS(944),
    [anon_sym_u_DQUOTE] = ACTIONS(944),
    [anon_sym_U_DQUOTE] = ACTIONS(944),
    [anon_sym_u8_DQUOTE] = ACTIONS(944),
    [anon_sym_DQUOTE] = ACTIONS(944),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_null] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_identifier] = ACTIONS(958),
    [aux_sym_preproc_include_token1] = ACTIONS(958),
    [aux_sym_preproc_def_token1] = ACTIONS(958),
    [aux_sym_preproc_if_token1] = ACTIONS(958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(958),
    [sym_preproc_directive] = ACTIONS(958),
    [anon_sym_LPAREN2] = ACTIONS(960),
    [anon_sym_BANG] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(960),
    [anon_sym_AMP] = ACTIONS(960),
    [anon_sym_SEMI] = ACTIONS(960),
    [anon_sym_typedef] = ACTIONS(958),
    [anon_sym_kernel] = ACTIONS(958),
    [anon_sym___kernel] = ACTIONS(958),
    [anon_sym_global] = ACTIONS(958),
    [anon_sym___global] = ACTIONS(958),
    [anon_sym_local] = ACTIONS(958),
    [anon_sym___local] = ACTIONS(958),
    [anon_sym_constant] = ACTIONS(958),
    [anon_sym___constant] = ACTIONS(958),
    [anon_sym_private] = ACTIONS(958),
    [anon_sym___private] = ACTIONS(958),
    [anon_sym_generic] = ACTIONS(958),
    [anon_sym___generic] = ACTIONS(958),
    [anon_sym_read_only] = ACTIONS(958),
    [anon_sym___read_only] = ACTIONS(958),
    [anon_sym_write_only] = ACTIONS(958),
    [anon_sym___write_only] = ACTIONS(958),
    [anon_sym_read_write] = ACTIONS(958),
    [anon_sym___read_write] = ACTIONS(958),
    [anon_sym_extern] = ACTIONS(958),
    [anon_sym___attribute__] = ACTIONS(958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(960),
    [anon_sym___declspec] = ACTIONS(958),
    [anon_sym___cdecl] = ACTIONS(958),
    [anon_sym___clrcall] = ACTIONS(958),
    [anon_sym___stdcall] = ACTIONS(958),
    [anon_sym___fastcall] = ACTIONS(958),
    [anon_sym___thiscall] = ACTIONS(958),
    [anon_sym___vectorcall] = ACTIONS(958),
    [anon_sym_LBRACE] = ACTIONS(960),
    [anon_sym_RBRACE] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(958),
    [anon_sym_auto] = ACTIONS(958),
    [anon_sym_register] = ACTIONS(958),
    [anon_sym_inline] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_volatile] = ACTIONS(958),
    [anon_sym_restrict] = ACTIONS(958),
    [anon_sym__Atomic] = ACTIONS(958),
    [anon_sym_pipe] = ACTIONS(958),
    [anon_sym_signed] = ACTIONS(958),
    [anon_sym_unsigned] = ACTIONS(958),
    [anon_sym_long] = ACTIONS(958),
    [anon_sym_short] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(958),
    [anon_sym_char] = ACTIONS(958),
    [anon_sym_uchar] = ACTIONS(958),
    [anon_sym_ushort] = ACTIONS(958),
    [anon_sym_int] = ACTIONS(958),
    [anon_sym_uint] = ACTIONS(958),
    [anon_sym_ulong] = ACTIONS(958),
    [anon_sym_float] = ACTIONS(958),
    [anon_sym_double] = ACTIONS(958),
    [anon_sym_half] = ACTIONS(958),
    [anon_sym_size_t] = ACTIONS(958),
    [anon_sym_ptrdiff_t] = ACTIONS(958),
    [anon_sym_intptr_t] = ACTIONS(958),
    [anon_sym_uintptr_t] = ACTIONS(958),
    [anon_sym_void] = ACTIONS(958),
    [sym_vector_type] = ACTIONS(958),
    [anon_sym_image2d_t] = ACTIONS(958),
    [anon_sym_image3d_t] = ACTIONS(958),
    [anon_sym_image2d_array_t] = ACTIONS(958),
    [anon_sym_image1d_t] = ACTIONS(958),
    [anon_sym_image1d_buffer_t] = ACTIONS(958),
    [anon_sym_image1d_array_t] = ACTIONS(958),
    [anon_sym_image2d_depth_t] = ACTIONS(958),
    [anon_sym_image2d_array_depth_t] = ACTIONS(958),
    [anon_sym_sampler_t] = ACTIONS(958),
    [anon_sym_queue_t] = ACTIONS(958),
    [anon_sym_ndrange_t] = ACTIONS(958),
    [anon_sym_clk_event_t] = ACTIONS(958),
    [anon_sym_reserve_id_t] = ACTIONS(958),
    [anon_sym_event_t] = ACTIONS(958),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_union] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_else] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(958),
    [anon_sym_case] = ACTIONS(958),
    [anon_sym_default] = ACTIONS(958),
    [anon_sym_while] = ACTIONS(958),
    [anon_sym_do] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(958),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_break] = ACTIONS(958),
    [anon_sym_continue] = ACTIONS(958),
    [anon_sym_goto] = ACTIONS(958),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_sizeof] = ACTIONS(958),
    [sym_number_literal] = ACTIONS(960),
    [anon_sym_L_SQUOTE] = ACTIONS(960),
    [anon_sym_u_SQUOTE] = ACTIONS(960),
    [anon_sym_U_SQUOTE] = ACTIONS(960),
    [anon_sym_u8_SQUOTE] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(960),
    [anon_sym_L_DQUOTE] = ACTIONS(960),
    [anon_sym_u_DQUOTE] = ACTIONS(960),
    [anon_sym_U_DQUOTE] = ACTIONS(960),
    [anon_sym_u8_DQUOTE] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(960),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_identifier] = ACTIONS(984),
    [aux_sym_preproc_include_token1] = ACTIONS(984),
    [aux_sym_preproc_def_token1] = ACTIONS(984),
    [aux_sym_preproc_if_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(984),
    [sym_preproc_directive] = ACTIONS(984),
    [anon_sym_LPAREN2] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_kernel] = ACTIONS(984),
    [anon_sym___kernel] = ACTIONS(984),
    [anon_sym_global] = ACTIONS(984),
    [anon_sym___global] = ACTIONS(984),
    [anon_sym_local] = ACTIONS(984),
    [anon_sym___local] = ACTIONS(984),
    [anon_sym_constant] = ACTIONS(984),
    [anon_sym___constant] = ACTIONS(984),
    [anon_sym_private] = ACTIONS(984),
    [anon_sym___private] = ACTIONS(984),
    [anon_sym_generic] = ACTIONS(984),
    [anon_sym___generic] = ACTIONS(984),
    [anon_sym_read_only] = ACTIONS(984),
    [anon_sym___read_only] = ACTIONS(984),
    [anon_sym_write_only] = ACTIONS(984),
    [anon_sym___write_only] = ACTIONS(984),
    [anon_sym_read_write] = ACTIONS(984),
    [anon_sym___read_write] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym___attribute__] = ACTIONS(984),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(986),
    [anon_sym___declspec] = ACTIONS(984),
    [anon_sym___cdecl] = ACTIONS(984),
    [anon_sym___clrcall] = ACTIONS(984),
    [anon_sym___stdcall] = ACTIONS(984),
    [anon_sym___fastcall] = ACTIONS(984),
    [anon_sym___thiscall] = ACTIONS(984),
    [anon_sym___vectorcall] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_auto] = ACTIONS(984),
    [anon_sym_register] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_const] = ACTIONS(984),
    [anon_sym_volatile] = ACTIONS(984),
    [anon_sym_restrict] = ACTIONS(984),
    [anon_sym__Atomic] = ACTIONS(984),
    [anon_sym_pipe] = ACTIONS(984),
    [anon_sym_signed] = ACTIONS(984),
    [anon_sym_unsigned] = ACTIONS(984),
    [anon_sym_long] = ACTIONS(984),
    [anon_sym_short] = ACTIONS(984),
    [anon_sym_bool] = ACTIONS(984),
    [anon_sym_char] = ACTIONS(984),
    [anon_sym_uchar] = ACTIONS(984),
    [anon_sym_ushort] = ACTIONS(984),
    [anon_sym_int] = ACTIONS(984),
    [anon_sym_uint] = ACTIONS(984),
    [anon_sym_ulong] = ACTIONS(984),
    [anon_sym_float] = ACTIONS(984),
    [anon_sym_double] = ACTIONS(984),
    [anon_sym_half] = ACTIONS(984),
    [anon_sym_size_t] = ACTIONS(984),
    [anon_sym_ptrdiff_t] = ACTIONS(984),
    [anon_sym_intptr_t] = ACTIONS(984),
    [anon_sym_uintptr_t] = ACTIONS(984),
    [anon_sym_void] = ACTIONS(984),
    [sym_vector_type] = ACTIONS(984),
    [anon_sym_image2d_t] = ACTIONS(984),
    [anon_sym_image3d_t] = ACTIONS(984),
    [anon_sym_image2d_array_t] = ACTIONS(984),
    [anon_sym_image1d_t] = ACTIONS(984),
    [anon_sym_image1d_buffer_t] = ACTIONS(984),
    [anon_sym_image1d_array_t] = ACTIONS(984),
    [anon_sym_image2d_depth_t] = ACTIONS(984),
    [anon_sym_image2d_array_depth_t] = ACTIONS(984),
    [anon_sym_sampler_t] = ACTIONS(984),
    [anon_sym_queue_t] = ACTIONS(984),
    [anon_sym_ndrange_t] = ACTIONS(984),
    [anon_sym_clk_event_t] = ACTIONS(984),
    [anon_sym_reserve_id_t] = ACTIONS(984),
    [anon_sym_event_t] = ACTIONS(984),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_struct] = ACTIONS(984),
    [anon_sym_union] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_goto] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_sizeof] = ACTIONS(984),
    [sym_number_literal] = ACTIONS(986),
    [anon_sym_L_SQUOTE] = ACTIONS(986),
    [anon_sym_u_SQUOTE] = ACTIONS(986),
    [anon_sym_U_SQUOTE] = ACTIONS(986),
    [anon_sym_u8_SQUOTE] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(986),
    [anon_sym_L_DQUOTE] = ACTIONS(986),
    [anon_sym_u_DQUOTE] = ACTIONS(986),
    [anon_sym_U_DQUOTE] = ACTIONS(986),
    [anon_sym_u8_DQUOTE] = ACTIONS(986),
    [anon_sym_DQUOTE] = ACTIONS(986),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_null] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_identifier] = ACTIONS(988),
    [aux_sym_preproc_include_token1] = ACTIONS(988),
    [aux_sym_preproc_def_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(988),
    [sym_preproc_directive] = ACTIONS(988),
    [anon_sym_LPAREN2] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(990),
    [anon_sym_typedef] = ACTIONS(988),
    [anon_sym_kernel] = ACTIONS(988),
    [anon_sym___kernel] = ACTIONS(988),
    [anon_sym_global] = ACTIONS(988),
    [anon_sym___global] = ACTIONS(988),
    [anon_sym_local] = ACTIONS(988),
    [anon_sym___local] = ACTIONS(988),
    [anon_sym_constant] = ACTIONS(988),
    [anon_sym___constant] = ACTIONS(988),
    [anon_sym_private] = ACTIONS(988),
    [anon_sym___private] = ACTIONS(988),
    [anon_sym_generic] = ACTIONS(988),
    [anon_sym___generic] = ACTIONS(988),
    [anon_sym_read_only] = ACTIONS(988),
    [anon_sym___read_only] = ACTIONS(988),
    [anon_sym_write_only] = ACTIONS(988),
    [anon_sym___write_only] = ACTIONS(988),
    [anon_sym_read_write] = ACTIONS(988),
    [anon_sym___read_write] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym___attribute__] = ACTIONS(988),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(990),
    [anon_sym___declspec] = ACTIONS(988),
    [anon_sym___cdecl] = ACTIONS(988),
    [anon_sym___clrcall] = ACTIONS(988),
    [anon_sym___stdcall] = ACTIONS(988),
    [anon_sym___fastcall] = ACTIONS(988),
    [anon_sym___thiscall] = ACTIONS(988),
    [anon_sym___vectorcall] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_RBRACE] = ACTIONS(990),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_auto] = ACTIONS(988),
    [anon_sym_register] = ACTIONS(988),
    [anon_sym_inline] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(988),
    [anon_sym_volatile] = ACTIONS(988),
    [anon_sym_restrict] = ACTIONS(988),
    [anon_sym__Atomic] = ACTIONS(988),
    [anon_sym_pipe] = ACTIONS(988),
    [anon_sym_signed] = ACTIONS(988),
    [anon_sym_unsigned] = ACTIONS(988),
    [anon_sym_long] = ACTIONS(988),
    [anon_sym_short] = ACTIONS(988),
    [anon_sym_bool] = ACTIONS(988),
    [anon_sym_char] = ACTIONS(988),
    [anon_sym_uchar] = ACTIONS(988),
    [anon_sym_ushort] = ACTIONS(988),
    [anon_sym_int] = ACTIONS(988),
    [anon_sym_uint] = ACTIONS(988),
    [anon_sym_ulong] = ACTIONS(988),
    [anon_sym_float] = ACTIONS(988),
    [anon_sym_double] = ACTIONS(988),
    [anon_sym_half] = ACTIONS(988),
    [anon_sym_size_t] = ACTIONS(988),
    [anon_sym_ptrdiff_t] = ACTIONS(988),
    [anon_sym_intptr_t] = ACTIONS(988),
    [anon_sym_uintptr_t] = ACTIONS(988),
    [anon_sym_void] = ACTIONS(988),
    [sym_vector_type] = ACTIONS(988),
    [anon_sym_image2d_t] = ACTIONS(988),
    [anon_sym_image3d_t] = ACTIONS(988),
    [anon_sym_image2d_array_t] = ACTIONS(988),
    [anon_sym_image1d_t] = ACTIONS(988),
    [anon_sym_image1d_buffer_t] = ACTIONS(988),
    [anon_sym_image1d_array_t] = ACTIONS(988),
    [anon_sym_image2d_depth_t] = ACTIONS(988),
    [anon_sym_image2d_array_depth_t] = ACTIONS(988),
    [anon_sym_sampler_t] = ACTIONS(988),
    [anon_sym_queue_t] = ACTIONS(988),
    [anon_sym_ndrange_t] = ACTIONS(988),
    [anon_sym_clk_event_t] = ACTIONS(988),
    [anon_sym_reserve_id_t] = ACTIONS(988),
    [anon_sym_event_t] = ACTIONS(988),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_struct] = ACTIONS(988),
    [anon_sym_union] = ACTIONS(988),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_goto] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(990),
    [anon_sym_PLUS_PLUS] = ACTIONS(990),
    [anon_sym_sizeof] = ACTIONS(988),
    [sym_number_literal] = ACTIONS(990),
    [anon_sym_L_SQUOTE] = ACTIONS(990),
    [anon_sym_u_SQUOTE] = ACTIONS(990),
    [anon_sym_U_SQUOTE] = ACTIONS(990),
    [anon_sym_u8_SQUOTE] = ACTIONS(990),
    [anon_sym_SQUOTE] = ACTIONS(990),
    [anon_sym_L_DQUOTE] = ACTIONS(990),
    [anon_sym_u_DQUOTE] = ACTIONS(990),
    [anon_sym_U_DQUOTE] = ACTIONS(990),
    [anon_sym_u8_DQUOTE] = ACTIONS(990),
    [anon_sym_DQUOTE] = ACTIONS(990),
    [sym_true] = ACTIONS(988),
    [sym_false] = ACTIONS(988),
    [sym_null] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_identifier] = ACTIONS(1016),
    [aux_sym_preproc_include_token1] = ACTIONS(1016),
    [aux_sym_preproc_def_token1] = ACTIONS(1016),
    [aux_sym_preproc_if_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1016),
    [sym_preproc_directive] = ACTIONS(1016),
    [anon_sym_LPAREN2] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1016),
    [anon_sym_PLUS] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [anon_sym_typedef] = ACTIONS(1016),
    [anon_sym_kernel] = ACTIONS(1016),
    [anon_sym___kernel] = ACTIONS(1016),
    [anon_sym_global] = ACTIONS(1016),
    [anon_sym___global] = ACTIONS(1016),
    [anon_sym_local] = ACTIONS(1016),
    [anon_sym___local] = ACTIONS(1016),
    [anon_sym_constant] = ACTIONS(1016),
    [anon_sym___constant] = ACTIONS(1016),
    [anon_sym_private] = ACTIONS(1016),
    [anon_sym___private] = ACTIONS(1016),
    [anon_sym_generic] = ACTIONS(1016),
    [anon_sym___generic] = ACTIONS(1016),
    [anon_sym_read_only] = ACTIONS(1016),
    [anon_sym___read_only] = ACTIONS(1016),
    [anon_sym_write_only] = ACTIONS(1016),
    [anon_sym___write_only] = ACTIONS(1016),
    [anon_sym_read_write] = ACTIONS(1016),
    [anon_sym___read_write] = ACTIONS(1016),
    [anon_sym_extern] = ACTIONS(1016),
    [anon_sym___attribute__] = ACTIONS(1016),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1018),
    [anon_sym___declspec] = ACTIONS(1016),
    [anon_sym___cdecl] = ACTIONS(1016),
    [anon_sym___clrcall] = ACTIONS(1016),
    [anon_sym___stdcall] = ACTIONS(1016),
    [anon_sym___fastcall] = ACTIONS(1016),
    [anon_sym___thiscall] = ACTIONS(1016),
    [anon_sym___vectorcall] = ACTIONS(1016),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1016),
    [anon_sym_auto] = ACTIONS(1016),
    [anon_sym_register] = ACTIONS(1016),
    [anon_sym_inline] = ACTIONS(1016),
    [anon_sym_const] = ACTIONS(1016),
    [anon_sym_volatile] = ACTIONS(1016),
    [anon_sym_restrict] = ACTIONS(1016),
    [anon_sym__Atomic] = ACTIONS(1016),
    [anon_sym_pipe] = ACTIONS(1016),
    [anon_sym_signed] = ACTIONS(1016),
    [anon_sym_unsigned] = ACTIONS(1016),
    [anon_sym_long] = ACTIONS(1016),
    [anon_sym_short] = ACTIONS(1016),
    [anon_sym_bool] = ACTIONS(1016),
    [anon_sym_char] = ACTIONS(1016),
    [anon_sym_uchar] = ACTIONS(1016),
    [anon_sym_ushort] = ACTIONS(1016),
    [anon_sym_int] = ACTIONS(1016),
    [anon_sym_uint] = ACTIONS(1016),
    [anon_sym_ulong] = ACTIONS(1016),
    [anon_sym_float] = ACTIONS(1016),
    [anon_sym_double] = ACTIONS(1016),
    [anon_sym_half] = ACTIONS(1016),
    [anon_sym_size_t] = ACTIONS(1016),
    [anon_sym_ptrdiff_t] = ACTIONS(1016),
    [anon_sym_intptr_t] = ACTIONS(1016),
    [anon_sym_uintptr_t] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1016),
    [sym_vector_type] = ACTIONS(1016),
    [anon_sym_image2d_t] = ACTIONS(1016),
    [anon_sym_image3d_t] = ACTIONS(1016),
    [anon_sym_image2d_array_t] = ACTIONS(1016),
    [anon_sym_image1d_t] = ACTIONS(1016),
    [anon_sym_image1d_buffer_t] = ACTIONS(1016),
    [anon_sym_image1d_array_t] = ACTIONS(1016),
    [anon_sym_image2d_depth_t] = ACTIONS(1016),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1016),
    [anon_sym_sampler_t] = ACTIONS(1016),
    [anon_sym_queue_t] = ACTIONS(1016),
    [anon_sym_ndrange_t] = ACTIONS(1016),
    [anon_sym_clk_event_t] = ACTIONS(1016),
    [anon_sym_reserve_id_t] = ACTIONS(1016),
    [anon_sym_event_t] = ACTIONS(1016),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1016),
    [anon_sym_enum] = ACTIONS(1016),
    [anon_sym_struct] = ACTIONS(1016),
    [anon_sym_union] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_else] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1016),
    [anon_sym_default] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_do] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_goto] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [anon_sym_sizeof] = ACTIONS(1016),
    [sym_number_literal] = ACTIONS(1018),
    [anon_sym_L_SQUOTE] = ACTIONS(1018),
    [anon_sym_u_SQUOTE] = ACTIONS(1018),
    [anon_sym_U_SQUOTE] = ACTIONS(1018),
    [anon_sym_u8_SQUOTE] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [anon_sym_L_DQUOTE] = ACTIONS(1018),
    [anon_sym_u_DQUOTE] = ACTIONS(1018),
    [anon_sym_U_DQUOTE] = ACTIONS(1018),
    [anon_sym_u8_DQUOTE] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_null] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_identifier] = ACTIONS(1020),
    [aux_sym_preproc_include_token1] = ACTIONS(1020),
    [aux_sym_preproc_def_token1] = ACTIONS(1020),
    [aux_sym_preproc_if_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1020),
    [sym_preproc_directive] = ACTIONS(1020),
    [anon_sym_LPAREN2] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1022),
    [anon_sym_AMP] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [anon_sym_typedef] = ACTIONS(1020),
    [anon_sym_kernel] = ACTIONS(1020),
    [anon_sym___kernel] = ACTIONS(1020),
    [anon_sym_global] = ACTIONS(1020),
    [anon_sym___global] = ACTIONS(1020),
    [anon_sym_local] = ACTIONS(1020),
    [anon_sym___local] = ACTIONS(1020),
    [anon_sym_constant] = ACTIONS(1020),
    [anon_sym___constant] = ACTIONS(1020),
    [anon_sym_private] = ACTIONS(1020),
    [anon_sym___private] = ACTIONS(1020),
    [anon_sym_generic] = ACTIONS(1020),
    [anon_sym___generic] = ACTIONS(1020),
    [anon_sym_read_only] = ACTIONS(1020),
    [anon_sym___read_only] = ACTIONS(1020),
    [anon_sym_write_only] = ACTIONS(1020),
    [anon_sym___write_only] = ACTIONS(1020),
    [anon_sym_read_write] = ACTIONS(1020),
    [anon_sym___read_write] = ACTIONS(1020),
    [anon_sym_extern] = ACTIONS(1020),
    [anon_sym___attribute__] = ACTIONS(1020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1022),
    [anon_sym___declspec] = ACTIONS(1020),
    [anon_sym___cdecl] = ACTIONS(1020),
    [anon_sym___clrcall] = ACTIONS(1020),
    [anon_sym___stdcall] = ACTIONS(1020),
    [anon_sym___fastcall] = ACTIONS(1020),
    [anon_sym___thiscall] = ACTIONS(1020),
    [anon_sym___vectorcall] = ACTIONS(1020),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_RBRACE] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1020),
    [anon_sym_auto] = ACTIONS(1020),
    [anon_sym_register] = ACTIONS(1020),
    [anon_sym_inline] = ACTIONS(1020),
    [anon_sym_const] = ACTIONS(1020),
    [anon_sym_volatile] = ACTIONS(1020),
    [anon_sym_restrict] = ACTIONS(1020),
    [anon_sym__Atomic] = ACTIONS(1020),
    [anon_sym_pipe] = ACTIONS(1020),
    [anon_sym_signed] = ACTIONS(1020),
    [anon_sym_unsigned] = ACTIONS(1020),
    [anon_sym_long] = ACTIONS(1020),
    [anon_sym_short] = ACTIONS(1020),
    [anon_sym_bool] = ACTIONS(1020),
    [anon_sym_char] = ACTIONS(1020),
    [anon_sym_uchar] = ACTIONS(1020),
    [anon_sym_ushort] = ACTIONS(1020),
    [anon_sym_int] = ACTIONS(1020),
    [anon_sym_uint] = ACTIONS(1020),
    [anon_sym_ulong] = ACTIONS(1020),
    [anon_sym_float] = ACTIONS(1020),
    [anon_sym_double] = ACTIONS(1020),
    [anon_sym_half] = ACTIONS(1020),
    [anon_sym_size_t] = ACTIONS(1020),
    [anon_sym_ptrdiff_t] = ACTIONS(1020),
    [anon_sym_intptr_t] = ACTIONS(1020),
    [anon_sym_uintptr_t] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1020),
    [sym_vector_type] = ACTIONS(1020),
    [anon_sym_image2d_t] = ACTIONS(1020),
    [anon_sym_image3d_t] = ACTIONS(1020),
    [anon_sym_image2d_array_t] = ACTIONS(1020),
    [anon_sym_image1d_t] = ACTIONS(1020),
    [anon_sym_image1d_buffer_t] = ACTIONS(1020),
    [anon_sym_image1d_array_t] = ACTIONS(1020),
    [anon_sym_image2d_depth_t] = ACTIONS(1020),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1020),
    [anon_sym_sampler_t] = ACTIONS(1020),
    [anon_sym_queue_t] = ACTIONS(1020),
    [anon_sym_ndrange_t] = ACTIONS(1020),
    [anon_sym_clk_event_t] = ACTIONS(1020),
    [anon_sym_reserve_id_t] = ACTIONS(1020),
    [anon_sym_event_t] = ACTIONS(1020),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1020),
    [anon_sym_enum] = ACTIONS(1020),
    [anon_sym_struct] = ACTIONS(1020),
    [anon_sym_union] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1020),
    [anon_sym_else] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1020),
    [anon_sym_default] = ACTIONS(1020),
    [anon_sym_while] = ACTIONS(1020),
    [anon_sym_do] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1020),
    [anon_sym_return] = ACTIONS(1020),
    [anon_sym_break] = ACTIONS(1020),
    [anon_sym_continue] = ACTIONS(1020),
    [anon_sym_goto] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [anon_sym_sizeof] = ACTIONS(1020),
    [sym_number_literal] = ACTIONS(1022),
    [anon_sym_L_SQUOTE] = ACTIONS(1022),
    [anon_sym_u_SQUOTE] = ACTIONS(1022),
    [anon_sym_U_SQUOTE] = ACTIONS(1022),
    [anon_sym_u8_SQUOTE] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [anon_sym_L_DQUOTE] = ACTIONS(1022),
    [anon_sym_u_DQUOTE] = ACTIONS(1022),
    [anon_sym_U_DQUOTE] = ACTIONS(1022),
    [anon_sym_u8_DQUOTE] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [sym_true] = ACTIONS(1020),
    [sym_false] = ACTIONS(1020),
    [sym_null] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_identifier] = ACTIONS(962),
    [aux_sym_preproc_include_token1] = ACTIONS(962),
    [aux_sym_preproc_def_token1] = ACTIONS(962),
    [aux_sym_preproc_if_token1] = ACTIONS(962),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(962),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(962),
    [sym_preproc_directive] = ACTIONS(962),
    [anon_sym_LPAREN2] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(962),
    [anon_sym_PLUS] = ACTIONS(962),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_AMP] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(964),
    [anon_sym_typedef] = ACTIONS(962),
    [anon_sym_kernel] = ACTIONS(962),
    [anon_sym___kernel] = ACTIONS(962),
    [anon_sym_global] = ACTIONS(962),
    [anon_sym___global] = ACTIONS(962),
    [anon_sym_local] = ACTIONS(962),
    [anon_sym___local] = ACTIONS(962),
    [anon_sym_constant] = ACTIONS(962),
    [anon_sym___constant] = ACTIONS(962),
    [anon_sym_private] = ACTIONS(962),
    [anon_sym___private] = ACTIONS(962),
    [anon_sym_generic] = ACTIONS(962),
    [anon_sym___generic] = ACTIONS(962),
    [anon_sym_read_only] = ACTIONS(962),
    [anon_sym___read_only] = ACTIONS(962),
    [anon_sym_write_only] = ACTIONS(962),
    [anon_sym___write_only] = ACTIONS(962),
    [anon_sym_read_write] = ACTIONS(962),
    [anon_sym___read_write] = ACTIONS(962),
    [anon_sym_extern] = ACTIONS(962),
    [anon_sym___attribute__] = ACTIONS(962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(964),
    [anon_sym___declspec] = ACTIONS(962),
    [anon_sym___cdecl] = ACTIONS(962),
    [anon_sym___clrcall] = ACTIONS(962),
    [anon_sym___stdcall] = ACTIONS(962),
    [anon_sym___fastcall] = ACTIONS(962),
    [anon_sym___thiscall] = ACTIONS(962),
    [anon_sym___vectorcall] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_static] = ACTIONS(962),
    [anon_sym_auto] = ACTIONS(962),
    [anon_sym_register] = ACTIONS(962),
    [anon_sym_inline] = ACTIONS(962),
    [anon_sym_const] = ACTIONS(962),
    [anon_sym_volatile] = ACTIONS(962),
    [anon_sym_restrict] = ACTIONS(962),
    [anon_sym__Atomic] = ACTIONS(962),
    [anon_sym_pipe] = ACTIONS(962),
    [anon_sym_signed] = ACTIONS(962),
    [anon_sym_unsigned] = ACTIONS(962),
    [anon_sym_long] = ACTIONS(962),
    [anon_sym_short] = ACTIONS(962),
    [anon_sym_bool] = ACTIONS(962),
    [anon_sym_char] = ACTIONS(962),
    [anon_sym_uchar] = ACTIONS(962),
    [anon_sym_ushort] = ACTIONS(962),
    [anon_sym_int] = ACTIONS(962),
    [anon_sym_uint] = ACTIONS(962),
    [anon_sym_ulong] = ACTIONS(962),
    [anon_sym_float] = ACTIONS(962),
    [anon_sym_double] = ACTIONS(962),
    [anon_sym_half] = ACTIONS(962),
    [anon_sym_size_t] = ACTIONS(962),
    [anon_sym_ptrdiff_t] = ACTIONS(962),
    [anon_sym_intptr_t] = ACTIONS(962),
    [anon_sym_uintptr_t] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(962),
    [sym_vector_type] = ACTIONS(962),
    [anon_sym_image2d_t] = ACTIONS(962),
    [anon_sym_image3d_t] = ACTIONS(962),
    [anon_sym_image2d_array_t] = ACTIONS(962),
    [anon_sym_image1d_t] = ACTIONS(962),
    [anon_sym_image1d_buffer_t] = ACTIONS(962),
    [anon_sym_image1d_array_t] = ACTIONS(962),
    [anon_sym_image2d_depth_t] = ACTIONS(962),
    [anon_sym_image2d_array_depth_t] = ACTIONS(962),
    [anon_sym_sampler_t] = ACTIONS(962),
    [anon_sym_queue_t] = ACTIONS(962),
    [anon_sym_ndrange_t] = ACTIONS(962),
    [anon_sym_clk_event_t] = ACTIONS(962),
    [anon_sym_reserve_id_t] = ACTIONS(962),
    [anon_sym_event_t] = ACTIONS(962),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(962),
    [anon_sym_enum] = ACTIONS(962),
    [anon_sym_struct] = ACTIONS(962),
    [anon_sym_union] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(962),
    [anon_sym_switch] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(962),
    [anon_sym_default] = ACTIONS(962),
    [anon_sym_while] = ACTIONS(962),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_for] = ACTIONS(962),
    [anon_sym_return] = ACTIONS(962),
    [anon_sym_break] = ACTIONS(962),
    [anon_sym_continue] = ACTIONS(962),
    [anon_sym_goto] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(964),
    [anon_sym_sizeof] = ACTIONS(962),
    [sym_number_literal] = ACTIONS(964),
    [anon_sym_L_SQUOTE] = ACTIONS(964),
    [anon_sym_u_SQUOTE] = ACTIONS(964),
    [anon_sym_U_SQUOTE] = ACTIONS(964),
    [anon_sym_u8_SQUOTE] = ACTIONS(964),
    [anon_sym_SQUOTE] = ACTIONS(964),
    [anon_sym_L_DQUOTE] = ACTIONS(964),
    [anon_sym_u_DQUOTE] = ACTIONS(964),
    [anon_sym_U_DQUOTE] = ACTIONS(964),
    [anon_sym_u8_DQUOTE] = ACTIONS(964),
    [anon_sym_DQUOTE] = ACTIONS(964),
    [sym_true] = ACTIONS(962),
    [sym_false] = ACTIONS(962),
    [sym_null] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_kernel] = ACTIONS(1036),
    [anon_sym___kernel] = ACTIONS(1036),
    [anon_sym_global] = ACTIONS(1036),
    [anon_sym___global] = ACTIONS(1036),
    [anon_sym_local] = ACTIONS(1036),
    [anon_sym___local] = ACTIONS(1036),
    [anon_sym_constant] = ACTIONS(1036),
    [anon_sym___constant] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym___private] = ACTIONS(1036),
    [anon_sym_generic] = ACTIONS(1036),
    [anon_sym___generic] = ACTIONS(1036),
    [anon_sym_read_only] = ACTIONS(1036),
    [anon_sym___read_only] = ACTIONS(1036),
    [anon_sym_write_only] = ACTIONS(1036),
    [anon_sym___write_only] = ACTIONS(1036),
    [anon_sym_read_write] = ACTIONS(1036),
    [anon_sym___read_write] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1038),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_pipe] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_bool] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_uchar] = ACTIONS(1036),
    [anon_sym_ushort] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_uint] = ACTIONS(1036),
    [anon_sym_ulong] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [anon_sym_half] = ACTIONS(1036),
    [anon_sym_size_t] = ACTIONS(1036),
    [anon_sym_ptrdiff_t] = ACTIONS(1036),
    [anon_sym_intptr_t] = ACTIONS(1036),
    [anon_sym_uintptr_t] = ACTIONS(1036),
    [anon_sym_void] = ACTIONS(1036),
    [sym_vector_type] = ACTIONS(1036),
    [anon_sym_image2d_t] = ACTIONS(1036),
    [anon_sym_image3d_t] = ACTIONS(1036),
    [anon_sym_image2d_array_t] = ACTIONS(1036),
    [anon_sym_image1d_t] = ACTIONS(1036),
    [anon_sym_image1d_buffer_t] = ACTIONS(1036),
    [anon_sym_image1d_array_t] = ACTIONS(1036),
    [anon_sym_image2d_depth_t] = ACTIONS(1036),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1036),
    [anon_sym_sampler_t] = ACTIONS(1036),
    [anon_sym_queue_t] = ACTIONS(1036),
    [anon_sym_ndrange_t] = ACTIONS(1036),
    [anon_sym_clk_event_t] = ACTIONS(1036),
    [anon_sym_reserve_id_t] = ACTIONS(1036),
    [anon_sym_event_t] = ACTIONS(1036),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_identifier] = ACTIONS(1036),
    [aux_sym_preproc_include_token1] = ACTIONS(1036),
    [aux_sym_preproc_def_token1] = ACTIONS(1036),
    [aux_sym_preproc_if_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1036),
    [sym_preproc_directive] = ACTIONS(1036),
    [anon_sym_LPAREN2] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1036),
    [anon_sym_kernel] = ACTIONS(1036),
    [anon_sym___kernel] = ACTIONS(1036),
    [anon_sym_global] = ACTIONS(1036),
    [anon_sym___global] = ACTIONS(1036),
    [anon_sym_local] = ACTIONS(1036),
    [anon_sym___local] = ACTIONS(1036),
    [anon_sym_constant] = ACTIONS(1036),
    [anon_sym___constant] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym___private] = ACTIONS(1036),
    [anon_sym_generic] = ACTIONS(1036),
    [anon_sym___generic] = ACTIONS(1036),
    [anon_sym_read_only] = ACTIONS(1036),
    [anon_sym___read_only] = ACTIONS(1036),
    [anon_sym_write_only] = ACTIONS(1036),
    [anon_sym___write_only] = ACTIONS(1036),
    [anon_sym_read_write] = ACTIONS(1036),
    [anon_sym___read_write] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1038),
    [anon_sym___declspec] = ACTIONS(1036),
    [anon_sym___cdecl] = ACTIONS(1036),
    [anon_sym___clrcall] = ACTIONS(1036),
    [anon_sym___stdcall] = ACTIONS(1036),
    [anon_sym___fastcall] = ACTIONS(1036),
    [anon_sym___thiscall] = ACTIONS(1036),
    [anon_sym___vectorcall] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_auto] = ACTIONS(1036),
    [anon_sym_register] = ACTIONS(1036),
    [anon_sym_inline] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_restrict] = ACTIONS(1036),
    [anon_sym__Atomic] = ACTIONS(1036),
    [anon_sym_pipe] = ACTIONS(1036),
    [anon_sym_signed] = ACTIONS(1036),
    [anon_sym_unsigned] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_bool] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_uchar] = ACTIONS(1036),
    [anon_sym_ushort] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_uint] = ACTIONS(1036),
    [anon_sym_ulong] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [anon_sym_half] = ACTIONS(1036),
    [anon_sym_size_t] = ACTIONS(1036),
    [anon_sym_ptrdiff_t] = ACTIONS(1036),
    [anon_sym_intptr_t] = ACTIONS(1036),
    [anon_sym_uintptr_t] = ACTIONS(1036),
    [anon_sym_void] = ACTIONS(1036),
    [sym_vector_type] = ACTIONS(1036),
    [anon_sym_image2d_t] = ACTIONS(1036),
    [anon_sym_image3d_t] = ACTIONS(1036),
    [anon_sym_image2d_array_t] = ACTIONS(1036),
    [anon_sym_image1d_t] = ACTIONS(1036),
    [anon_sym_image1d_buffer_t] = ACTIONS(1036),
    [anon_sym_image1d_array_t] = ACTIONS(1036),
    [anon_sym_image2d_depth_t] = ACTIONS(1036),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1036),
    [anon_sym_sampler_t] = ACTIONS(1036),
    [anon_sym_queue_t] = ACTIONS(1036),
    [anon_sym_ndrange_t] = ACTIONS(1036),
    [anon_sym_clk_event_t] = ACTIONS(1036),
    [anon_sym_reserve_id_t] = ACTIONS(1036),
    [anon_sym_event_t] = ACTIONS(1036),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_union] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_else] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_while] = ACTIONS(1036),
    [anon_sym_do] = ACTIONS(1036),
    [anon_sym_for] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [anon_sym_goto] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [anon_sym_sizeof] = ACTIONS(1036),
    [sym_number_literal] = ACTIONS(1038),
    [anon_sym_L_SQUOTE] = ACTIONS(1038),
    [anon_sym_u_SQUOTE] = ACTIONS(1038),
    [anon_sym_U_SQUOTE] = ACTIONS(1038),
    [anon_sym_u8_SQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_L_DQUOTE] = ACTIONS(1038),
    [anon_sym_u_DQUOTE] = ACTIONS(1038),
    [anon_sym_U_DQUOTE] = ACTIONS(1038),
    [anon_sym_u8_DQUOTE] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_true] = ACTIONS(1036),
    [sym_false] = ACTIONS(1036),
    [sym_null] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [ts_builtin_sym_end] = ACTIONS(964),
    [sym_identifier] = ACTIONS(962),
    [aux_sym_preproc_include_token1] = ACTIONS(962),
    [aux_sym_preproc_def_token1] = ACTIONS(962),
    [aux_sym_preproc_if_token1] = ACTIONS(962),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(962),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(962),
    [sym_preproc_directive] = ACTIONS(962),
    [anon_sym_LPAREN2] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(962),
    [anon_sym_PLUS] = ACTIONS(962),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_AMP] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(964),
    [anon_sym_typedef] = ACTIONS(962),
    [anon_sym_kernel] = ACTIONS(962),
    [anon_sym___kernel] = ACTIONS(962),
    [anon_sym_global] = ACTIONS(962),
    [anon_sym___global] = ACTIONS(962),
    [anon_sym_local] = ACTIONS(962),
    [anon_sym___local] = ACTIONS(962),
    [anon_sym_constant] = ACTIONS(962),
    [anon_sym___constant] = ACTIONS(962),
    [anon_sym_private] = ACTIONS(962),
    [anon_sym___private] = ACTIONS(962),
    [anon_sym_generic] = ACTIONS(962),
    [anon_sym___generic] = ACTIONS(962),
    [anon_sym_read_only] = ACTIONS(962),
    [anon_sym___read_only] = ACTIONS(962),
    [anon_sym_write_only] = ACTIONS(962),
    [anon_sym___write_only] = ACTIONS(962),
    [anon_sym_read_write] = ACTIONS(962),
    [anon_sym___read_write] = ACTIONS(962),
    [anon_sym_extern] = ACTIONS(962),
    [anon_sym___attribute__] = ACTIONS(962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(964),
    [anon_sym___declspec] = ACTIONS(962),
    [anon_sym___cdecl] = ACTIONS(962),
    [anon_sym___clrcall] = ACTIONS(962),
    [anon_sym___stdcall] = ACTIONS(962),
    [anon_sym___fastcall] = ACTIONS(962),
    [anon_sym___thiscall] = ACTIONS(962),
    [anon_sym___vectorcall] = ACTIONS(962),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_static] = ACTIONS(962),
    [anon_sym_auto] = ACTIONS(962),
    [anon_sym_register] = ACTIONS(962),
    [anon_sym_inline] = ACTIONS(962),
    [anon_sym_const] = ACTIONS(962),
    [anon_sym_volatile] = ACTIONS(962),
    [anon_sym_restrict] = ACTIONS(962),
    [anon_sym__Atomic] = ACTIONS(962),
    [anon_sym_pipe] = ACTIONS(962),
    [anon_sym_signed] = ACTIONS(962),
    [anon_sym_unsigned] = ACTIONS(962),
    [anon_sym_long] = ACTIONS(962),
    [anon_sym_short] = ACTIONS(962),
    [anon_sym_bool] = ACTIONS(962),
    [anon_sym_char] = ACTIONS(962),
    [anon_sym_uchar] = ACTIONS(962),
    [anon_sym_ushort] = ACTIONS(962),
    [anon_sym_int] = ACTIONS(962),
    [anon_sym_uint] = ACTIONS(962),
    [anon_sym_ulong] = ACTIONS(962),
    [anon_sym_float] = ACTIONS(962),
    [anon_sym_double] = ACTIONS(962),
    [anon_sym_half] = ACTIONS(962),
    [anon_sym_size_t] = ACTIONS(962),
    [anon_sym_ptrdiff_t] = ACTIONS(962),
    [anon_sym_intptr_t] = ACTIONS(962),
    [anon_sym_uintptr_t] = ACTIONS(962),
    [anon_sym_void] = ACTIONS(962),
    [sym_vector_type] = ACTIONS(962),
    [anon_sym_image2d_t] = ACTIONS(962),
    [anon_sym_image3d_t] = ACTIONS(962),
    [anon_sym_image2d_array_t] = ACTIONS(962),
    [anon_sym_image1d_t] = ACTIONS(962),
    [anon_sym_image1d_buffer_t] = ACTIONS(962),
    [anon_sym_image1d_array_t] = ACTIONS(962),
    [anon_sym_image2d_depth_t] = ACTIONS(962),
    [anon_sym_image2d_array_depth_t] = ACTIONS(962),
    [anon_sym_sampler_t] = ACTIONS(962),
    [anon_sym_queue_t] = ACTIONS(962),
    [anon_sym_ndrange_t] = ACTIONS(962),
    [anon_sym_clk_event_t] = ACTIONS(962),
    [anon_sym_reserve_id_t] = ACTIONS(962),
    [anon_sym_event_t] = ACTIONS(962),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(962),
    [anon_sym_enum] = ACTIONS(962),
    [anon_sym_struct] = ACTIONS(962),
    [anon_sym_union] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_else] = ACTIONS(962),
    [anon_sym_switch] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(962),
    [anon_sym_default] = ACTIONS(962),
    [anon_sym_while] = ACTIONS(962),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_for] = ACTIONS(962),
    [anon_sym_return] = ACTIONS(962),
    [anon_sym_break] = ACTIONS(962),
    [anon_sym_continue] = ACTIONS(962),
    [anon_sym_goto] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(964),
    [anon_sym_sizeof] = ACTIONS(962),
    [sym_number_literal] = ACTIONS(964),
    [anon_sym_L_SQUOTE] = ACTIONS(964),
    [anon_sym_u_SQUOTE] = ACTIONS(964),
    [anon_sym_U_SQUOTE] = ACTIONS(964),
    [anon_sym_u8_SQUOTE] = ACTIONS(964),
    [anon_sym_SQUOTE] = ACTIONS(964),
    [anon_sym_L_DQUOTE] = ACTIONS(964),
    [anon_sym_u_DQUOTE] = ACTIONS(964),
    [anon_sym_U_DQUOTE] = ACTIONS(964),
    [anon_sym_u8_DQUOTE] = ACTIONS(964),
    [anon_sym_DQUOTE] = ACTIONS(964),
    [sym_true] = ACTIONS(962),
    [sym_false] = ACTIONS(962),
    [sym_null] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_identifier] = ACTIONS(966),
    [aux_sym_preproc_include_token1] = ACTIONS(966),
    [aux_sym_preproc_def_token1] = ACTIONS(966),
    [aux_sym_preproc_if_token1] = ACTIONS(966),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(966),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(966),
    [sym_preproc_directive] = ACTIONS(966),
    [anon_sym_LPAREN2] = ACTIONS(968),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_DASH] = ACTIONS(966),
    [anon_sym_PLUS] = ACTIONS(966),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_AMP] = ACTIONS(968),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_typedef] = ACTIONS(966),
    [anon_sym_kernel] = ACTIONS(966),
    [anon_sym___kernel] = ACTIONS(966),
    [anon_sym_global] = ACTIONS(966),
    [anon_sym___global] = ACTIONS(966),
    [anon_sym_local] = ACTIONS(966),
    [anon_sym___local] = ACTIONS(966),
    [anon_sym_constant] = ACTIONS(966),
    [anon_sym___constant] = ACTIONS(966),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym___private] = ACTIONS(966),
    [anon_sym_generic] = ACTIONS(966),
    [anon_sym___generic] = ACTIONS(966),
    [anon_sym_read_only] = ACTIONS(966),
    [anon_sym___read_only] = ACTIONS(966),
    [anon_sym_write_only] = ACTIONS(966),
    [anon_sym___write_only] = ACTIONS(966),
    [anon_sym_read_write] = ACTIONS(966),
    [anon_sym___read_write] = ACTIONS(966),
    [anon_sym_extern] = ACTIONS(966),
    [anon_sym___attribute__] = ACTIONS(966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(968),
    [anon_sym___declspec] = ACTIONS(966),
    [anon_sym___cdecl] = ACTIONS(966),
    [anon_sym___clrcall] = ACTIONS(966),
    [anon_sym___stdcall] = ACTIONS(966),
    [anon_sym___fastcall] = ACTIONS(966),
    [anon_sym___thiscall] = ACTIONS(966),
    [anon_sym___vectorcall] = ACTIONS(966),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(966),
    [anon_sym_auto] = ACTIONS(966),
    [anon_sym_register] = ACTIONS(966),
    [anon_sym_inline] = ACTIONS(966),
    [anon_sym_const] = ACTIONS(966),
    [anon_sym_volatile] = ACTIONS(966),
    [anon_sym_restrict] = ACTIONS(966),
    [anon_sym__Atomic] = ACTIONS(966),
    [anon_sym_pipe] = ACTIONS(966),
    [anon_sym_signed] = ACTIONS(966),
    [anon_sym_unsigned] = ACTIONS(966),
    [anon_sym_long] = ACTIONS(966),
    [anon_sym_short] = ACTIONS(966),
    [anon_sym_bool] = ACTIONS(966),
    [anon_sym_char] = ACTIONS(966),
    [anon_sym_uchar] = ACTIONS(966),
    [anon_sym_ushort] = ACTIONS(966),
    [anon_sym_int] = ACTIONS(966),
    [anon_sym_uint] = ACTIONS(966),
    [anon_sym_ulong] = ACTIONS(966),
    [anon_sym_float] = ACTIONS(966),
    [anon_sym_double] = ACTIONS(966),
    [anon_sym_half] = ACTIONS(966),
    [anon_sym_size_t] = ACTIONS(966),
    [anon_sym_ptrdiff_t] = ACTIONS(966),
    [anon_sym_intptr_t] = ACTIONS(966),
    [anon_sym_uintptr_t] = ACTIONS(966),
    [anon_sym_void] = ACTIONS(966),
    [sym_vector_type] = ACTIONS(966),
    [anon_sym_image2d_t] = ACTIONS(966),
    [anon_sym_image3d_t] = ACTIONS(966),
    [anon_sym_image2d_array_t] = ACTIONS(966),
    [anon_sym_image1d_t] = ACTIONS(966),
    [anon_sym_image1d_buffer_t] = ACTIONS(966),
    [anon_sym_image1d_array_t] = ACTIONS(966),
    [anon_sym_image2d_depth_t] = ACTIONS(966),
    [anon_sym_image2d_array_depth_t] = ACTIONS(966),
    [anon_sym_sampler_t] = ACTIONS(966),
    [anon_sym_queue_t] = ACTIONS(966),
    [anon_sym_ndrange_t] = ACTIONS(966),
    [anon_sym_clk_event_t] = ACTIONS(966),
    [anon_sym_reserve_id_t] = ACTIONS(966),
    [anon_sym_event_t] = ACTIONS(966),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(966),
    [anon_sym_enum] = ACTIONS(966),
    [anon_sym_struct] = ACTIONS(966),
    [anon_sym_union] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(966),
    [anon_sym_case] = ACTIONS(966),
    [anon_sym_default] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_do] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_goto] = ACTIONS(966),
    [anon_sym_DASH_DASH] = ACTIONS(968),
    [anon_sym_PLUS_PLUS] = ACTIONS(968),
    [anon_sym_sizeof] = ACTIONS(966),
    [sym_number_literal] = ACTIONS(968),
    [anon_sym_L_SQUOTE] = ACTIONS(968),
    [anon_sym_u_SQUOTE] = ACTIONS(968),
    [anon_sym_U_SQUOTE] = ACTIONS(968),
    [anon_sym_u8_SQUOTE] = ACTIONS(968),
    [anon_sym_SQUOTE] = ACTIONS(968),
    [anon_sym_L_DQUOTE] = ACTIONS(968),
    [anon_sym_u_DQUOTE] = ACTIONS(968),
    [anon_sym_U_DQUOTE] = ACTIONS(968),
    [anon_sym_u8_DQUOTE] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(968),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_null] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [ts_builtin_sym_end] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_kernel] = ACTIONS(1012),
    [anon_sym___kernel] = ACTIONS(1012),
    [anon_sym_global] = ACTIONS(1012),
    [anon_sym___global] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym___local] = ACTIONS(1012),
    [anon_sym_constant] = ACTIONS(1012),
    [anon_sym___constant] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym___private] = ACTIONS(1012),
    [anon_sym_generic] = ACTIONS(1012),
    [anon_sym___generic] = ACTIONS(1012),
    [anon_sym_read_only] = ACTIONS(1012),
    [anon_sym___read_only] = ACTIONS(1012),
    [anon_sym_write_only] = ACTIONS(1012),
    [anon_sym___write_only] = ACTIONS(1012),
    [anon_sym_read_write] = ACTIONS(1012),
    [anon_sym___read_write] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1014),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_pipe] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_uchar] = ACTIONS(1012),
    [anon_sym_ushort] = ACTIONS(1012),
    [anon_sym_int] = ACTIONS(1012),
    [anon_sym_uint] = ACTIONS(1012),
    [anon_sym_ulong] = ACTIONS(1012),
    [anon_sym_float] = ACTIONS(1012),
    [anon_sym_double] = ACTIONS(1012),
    [anon_sym_half] = ACTIONS(1012),
    [anon_sym_size_t] = ACTIONS(1012),
    [anon_sym_ptrdiff_t] = ACTIONS(1012),
    [anon_sym_intptr_t] = ACTIONS(1012),
    [anon_sym_uintptr_t] = ACTIONS(1012),
    [anon_sym_void] = ACTIONS(1012),
    [sym_vector_type] = ACTIONS(1012),
    [anon_sym_image2d_t] = ACTIONS(1012),
    [anon_sym_image3d_t] = ACTIONS(1012),
    [anon_sym_image2d_array_t] = ACTIONS(1012),
    [anon_sym_image1d_t] = ACTIONS(1012),
    [anon_sym_image1d_buffer_t] = ACTIONS(1012),
    [anon_sym_image1d_array_t] = ACTIONS(1012),
    [anon_sym_image2d_depth_t] = ACTIONS(1012),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1012),
    [anon_sym_sampler_t] = ACTIONS(1012),
    [anon_sym_queue_t] = ACTIONS(1012),
    [anon_sym_ndrange_t] = ACTIONS(1012),
    [anon_sym_clk_event_t] = ACTIONS(1012),
    [anon_sym_reserve_id_t] = ACTIONS(1012),
    [anon_sym_event_t] = ACTIONS(1012),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_identifier] = ACTIONS(972),
    [aux_sym_preproc_include_token1] = ACTIONS(972),
    [aux_sym_preproc_def_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(972),
    [sym_preproc_directive] = ACTIONS(972),
    [anon_sym_LPAREN2] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(972),
    [anon_sym_kernel] = ACTIONS(972),
    [anon_sym___kernel] = ACTIONS(972),
    [anon_sym_global] = ACTIONS(972),
    [anon_sym___global] = ACTIONS(972),
    [anon_sym_local] = ACTIONS(972),
    [anon_sym___local] = ACTIONS(972),
    [anon_sym_constant] = ACTIONS(972),
    [anon_sym___constant] = ACTIONS(972),
    [anon_sym_private] = ACTIONS(972),
    [anon_sym___private] = ACTIONS(972),
    [anon_sym_generic] = ACTIONS(972),
    [anon_sym___generic] = ACTIONS(972),
    [anon_sym_read_only] = ACTIONS(972),
    [anon_sym___read_only] = ACTIONS(972),
    [anon_sym_write_only] = ACTIONS(972),
    [anon_sym___write_only] = ACTIONS(972),
    [anon_sym_read_write] = ACTIONS(972),
    [anon_sym___read_write] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym___attribute__] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(974),
    [anon_sym___declspec] = ACTIONS(972),
    [anon_sym___cdecl] = ACTIONS(972),
    [anon_sym___clrcall] = ACTIONS(972),
    [anon_sym___stdcall] = ACTIONS(972),
    [anon_sym___fastcall] = ACTIONS(972),
    [anon_sym___thiscall] = ACTIONS(972),
    [anon_sym___vectorcall] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_auto] = ACTIONS(972),
    [anon_sym_register] = ACTIONS(972),
    [anon_sym_inline] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_volatile] = ACTIONS(972),
    [anon_sym_restrict] = ACTIONS(972),
    [anon_sym__Atomic] = ACTIONS(972),
    [anon_sym_pipe] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(972),
    [anon_sym_unsigned] = ACTIONS(972),
    [anon_sym_long] = ACTIONS(972),
    [anon_sym_short] = ACTIONS(972),
    [anon_sym_bool] = ACTIONS(972),
    [anon_sym_char] = ACTIONS(972),
    [anon_sym_uchar] = ACTIONS(972),
    [anon_sym_ushort] = ACTIONS(972),
    [anon_sym_int] = ACTIONS(972),
    [anon_sym_uint] = ACTIONS(972),
    [anon_sym_ulong] = ACTIONS(972),
    [anon_sym_float] = ACTIONS(972),
    [anon_sym_double] = ACTIONS(972),
    [anon_sym_half] = ACTIONS(972),
    [anon_sym_size_t] = ACTIONS(972),
    [anon_sym_ptrdiff_t] = ACTIONS(972),
    [anon_sym_intptr_t] = ACTIONS(972),
    [anon_sym_uintptr_t] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(972),
    [sym_vector_type] = ACTIONS(972),
    [anon_sym_image2d_t] = ACTIONS(972),
    [anon_sym_image3d_t] = ACTIONS(972),
    [anon_sym_image2d_array_t] = ACTIONS(972),
    [anon_sym_image1d_t] = ACTIONS(972),
    [anon_sym_image1d_buffer_t] = ACTIONS(972),
    [anon_sym_image1d_array_t] = ACTIONS(972),
    [anon_sym_image2d_depth_t] = ACTIONS(972),
    [anon_sym_image2d_array_depth_t] = ACTIONS(972),
    [anon_sym_sampler_t] = ACTIONS(972),
    [anon_sym_queue_t] = ACTIONS(972),
    [anon_sym_ndrange_t] = ACTIONS(972),
    [anon_sym_clk_event_t] = ACTIONS(972),
    [anon_sym_reserve_id_t] = ACTIONS(972),
    [anon_sym_event_t] = ACTIONS(972),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_goto] = ACTIONS(972),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_sizeof] = ACTIONS(972),
    [sym_number_literal] = ACTIONS(974),
    [anon_sym_L_SQUOTE] = ACTIONS(974),
    [anon_sym_u_SQUOTE] = ACTIONS(974),
    [anon_sym_U_SQUOTE] = ACTIONS(974),
    [anon_sym_u8_SQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [anon_sym_L_DQUOTE] = ACTIONS(974),
    [anon_sym_u_DQUOTE] = ACTIONS(974),
    [anon_sym_U_DQUOTE] = ACTIONS(974),
    [anon_sym_u8_DQUOTE] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_null] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_identifier] = ACTIONS(996),
    [aux_sym_preproc_include_token1] = ACTIONS(996),
    [aux_sym_preproc_def_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(996),
    [sym_preproc_directive] = ACTIONS(996),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_typedef] = ACTIONS(996),
    [anon_sym_kernel] = ACTIONS(996),
    [anon_sym___kernel] = ACTIONS(996),
    [anon_sym_global] = ACTIONS(996),
    [anon_sym___global] = ACTIONS(996),
    [anon_sym_local] = ACTIONS(996),
    [anon_sym___local] = ACTIONS(996),
    [anon_sym_constant] = ACTIONS(996),
    [anon_sym___constant] = ACTIONS(996),
    [anon_sym_private] = ACTIONS(996),
    [anon_sym___private] = ACTIONS(996),
    [anon_sym_generic] = ACTIONS(996),
    [anon_sym___generic] = ACTIONS(996),
    [anon_sym_read_only] = ACTIONS(996),
    [anon_sym___read_only] = ACTIONS(996),
    [anon_sym_write_only] = ACTIONS(996),
    [anon_sym___write_only] = ACTIONS(996),
    [anon_sym_read_write] = ACTIONS(996),
    [anon_sym___read_write] = ACTIONS(996),
    [anon_sym_extern] = ACTIONS(996),
    [anon_sym___attribute__] = ACTIONS(996),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(998),
    [anon_sym___declspec] = ACTIONS(996),
    [anon_sym___cdecl] = ACTIONS(996),
    [anon_sym___clrcall] = ACTIONS(996),
    [anon_sym___stdcall] = ACTIONS(996),
    [anon_sym___fastcall] = ACTIONS(996),
    [anon_sym___thiscall] = ACTIONS(996),
    [anon_sym___vectorcall] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_auto] = ACTIONS(996),
    [anon_sym_register] = ACTIONS(996),
    [anon_sym_inline] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_volatile] = ACTIONS(996),
    [anon_sym_restrict] = ACTIONS(996),
    [anon_sym__Atomic] = ACTIONS(996),
    [anon_sym_pipe] = ACTIONS(996),
    [anon_sym_signed] = ACTIONS(996),
    [anon_sym_unsigned] = ACTIONS(996),
    [anon_sym_long] = ACTIONS(996),
    [anon_sym_short] = ACTIONS(996),
    [anon_sym_bool] = ACTIONS(996),
    [anon_sym_char] = ACTIONS(996),
    [anon_sym_uchar] = ACTIONS(996),
    [anon_sym_ushort] = ACTIONS(996),
    [anon_sym_int] = ACTIONS(996),
    [anon_sym_uint] = ACTIONS(996),
    [anon_sym_ulong] = ACTIONS(996),
    [anon_sym_float] = ACTIONS(996),
    [anon_sym_double] = ACTIONS(996),
    [anon_sym_half] = ACTIONS(996),
    [anon_sym_size_t] = ACTIONS(996),
    [anon_sym_ptrdiff_t] = ACTIONS(996),
    [anon_sym_intptr_t] = ACTIONS(996),
    [anon_sym_uintptr_t] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(996),
    [sym_vector_type] = ACTIONS(996),
    [anon_sym_image2d_t] = ACTIONS(996),
    [anon_sym_image3d_t] = ACTIONS(996),
    [anon_sym_image2d_array_t] = ACTIONS(996),
    [anon_sym_image1d_t] = ACTIONS(996),
    [anon_sym_image1d_buffer_t] = ACTIONS(996),
    [anon_sym_image1d_array_t] = ACTIONS(996),
    [anon_sym_image2d_depth_t] = ACTIONS(996),
    [anon_sym_image2d_array_depth_t] = ACTIONS(996),
    [anon_sym_sampler_t] = ACTIONS(996),
    [anon_sym_queue_t] = ACTIONS(996),
    [anon_sym_ndrange_t] = ACTIONS(996),
    [anon_sym_clk_event_t] = ACTIONS(996),
    [anon_sym_reserve_id_t] = ACTIONS(996),
    [anon_sym_event_t] = ACTIONS(996),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_struct] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_goto] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(996),
    [sym_number_literal] = ACTIONS(998),
    [anon_sym_L_SQUOTE] = ACTIONS(998),
    [anon_sym_u_SQUOTE] = ACTIONS(998),
    [anon_sym_U_SQUOTE] = ACTIONS(998),
    [anon_sym_u8_SQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_L_DQUOTE] = ACTIONS(998),
    [anon_sym_u_DQUOTE] = ACTIONS(998),
    [anon_sym_U_DQUOTE] = ACTIONS(998),
    [anon_sym_u8_DQUOTE] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [ts_builtin_sym_end] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_kernel] = ACTIONS(1012),
    [anon_sym___kernel] = ACTIONS(1012),
    [anon_sym_global] = ACTIONS(1012),
    [anon_sym___global] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym___local] = ACTIONS(1012),
    [anon_sym_constant] = ACTIONS(1012),
    [anon_sym___constant] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym___private] = ACTIONS(1012),
    [anon_sym_generic] = ACTIONS(1012),
    [anon_sym___generic] = ACTIONS(1012),
    [anon_sym_read_only] = ACTIONS(1012),
    [anon_sym___read_only] = ACTIONS(1012),
    [anon_sym_write_only] = ACTIONS(1012),
    [anon_sym___write_only] = ACTIONS(1012),
    [anon_sym_read_write] = ACTIONS(1012),
    [anon_sym___read_write] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1014),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_pipe] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_uchar] = ACTIONS(1012),
    [anon_sym_ushort] = ACTIONS(1012),
    [anon_sym_int] = ACTIONS(1012),
    [anon_sym_uint] = ACTIONS(1012),
    [anon_sym_ulong] = ACTIONS(1012),
    [anon_sym_float] = ACTIONS(1012),
    [anon_sym_double] = ACTIONS(1012),
    [anon_sym_half] = ACTIONS(1012),
    [anon_sym_size_t] = ACTIONS(1012),
    [anon_sym_ptrdiff_t] = ACTIONS(1012),
    [anon_sym_intptr_t] = ACTIONS(1012),
    [anon_sym_uintptr_t] = ACTIONS(1012),
    [anon_sym_void] = ACTIONS(1012),
    [sym_vector_type] = ACTIONS(1012),
    [anon_sym_image2d_t] = ACTIONS(1012),
    [anon_sym_image3d_t] = ACTIONS(1012),
    [anon_sym_image2d_array_t] = ACTIONS(1012),
    [anon_sym_image1d_t] = ACTIONS(1012),
    [anon_sym_image1d_buffer_t] = ACTIONS(1012),
    [anon_sym_image1d_array_t] = ACTIONS(1012),
    [anon_sym_image2d_depth_t] = ACTIONS(1012),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1012),
    [anon_sym_sampler_t] = ACTIONS(1012),
    [anon_sym_queue_t] = ACTIONS(1012),
    [anon_sym_ndrange_t] = ACTIONS(1012),
    [anon_sym_clk_event_t] = ACTIONS(1012),
    [anon_sym_reserve_id_t] = ACTIONS(1012),
    [anon_sym_event_t] = ACTIONS(1012),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [ts_builtin_sym_end] = ACTIONS(1026),
    [sym_identifier] = ACTIONS(1024),
    [aux_sym_preproc_include_token1] = ACTIONS(1024),
    [aux_sym_preproc_def_token1] = ACTIONS(1024),
    [aux_sym_preproc_if_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1024),
    [sym_preproc_directive] = ACTIONS(1024),
    [anon_sym_LPAREN2] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_typedef] = ACTIONS(1024),
    [anon_sym_kernel] = ACTIONS(1024),
    [anon_sym___kernel] = ACTIONS(1024),
    [anon_sym_global] = ACTIONS(1024),
    [anon_sym___global] = ACTIONS(1024),
    [anon_sym_local] = ACTIONS(1024),
    [anon_sym___local] = ACTIONS(1024),
    [anon_sym_constant] = ACTIONS(1024),
    [anon_sym___constant] = ACTIONS(1024),
    [anon_sym_private] = ACTIONS(1024),
    [anon_sym___private] = ACTIONS(1024),
    [anon_sym_generic] = ACTIONS(1024),
    [anon_sym___generic] = ACTIONS(1024),
    [anon_sym_read_only] = ACTIONS(1024),
    [anon_sym___read_only] = ACTIONS(1024),
    [anon_sym_write_only] = ACTIONS(1024),
    [anon_sym___write_only] = ACTIONS(1024),
    [anon_sym_read_write] = ACTIONS(1024),
    [anon_sym___read_write] = ACTIONS(1024),
    [anon_sym_extern] = ACTIONS(1024),
    [anon_sym___attribute__] = ACTIONS(1024),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1026),
    [anon_sym___declspec] = ACTIONS(1024),
    [anon_sym___cdecl] = ACTIONS(1024),
    [anon_sym___clrcall] = ACTIONS(1024),
    [anon_sym___stdcall] = ACTIONS(1024),
    [anon_sym___fastcall] = ACTIONS(1024),
    [anon_sym___thiscall] = ACTIONS(1024),
    [anon_sym___vectorcall] = ACTIONS(1024),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1024),
    [anon_sym_auto] = ACTIONS(1024),
    [anon_sym_register] = ACTIONS(1024),
    [anon_sym_inline] = ACTIONS(1024),
    [anon_sym_const] = ACTIONS(1024),
    [anon_sym_volatile] = ACTIONS(1024),
    [anon_sym_restrict] = ACTIONS(1024),
    [anon_sym__Atomic] = ACTIONS(1024),
    [anon_sym_pipe] = ACTIONS(1024),
    [anon_sym_signed] = ACTIONS(1024),
    [anon_sym_unsigned] = ACTIONS(1024),
    [anon_sym_long] = ACTIONS(1024),
    [anon_sym_short] = ACTIONS(1024),
    [anon_sym_bool] = ACTIONS(1024),
    [anon_sym_char] = ACTIONS(1024),
    [anon_sym_uchar] = ACTIONS(1024),
    [anon_sym_ushort] = ACTIONS(1024),
    [anon_sym_int] = ACTIONS(1024),
    [anon_sym_uint] = ACTIONS(1024),
    [anon_sym_ulong] = ACTIONS(1024),
    [anon_sym_float] = ACTIONS(1024),
    [anon_sym_double] = ACTIONS(1024),
    [anon_sym_half] = ACTIONS(1024),
    [anon_sym_size_t] = ACTIONS(1024),
    [anon_sym_ptrdiff_t] = ACTIONS(1024),
    [anon_sym_intptr_t] = ACTIONS(1024),
    [anon_sym_uintptr_t] = ACTIONS(1024),
    [anon_sym_void] = ACTIONS(1024),
    [sym_vector_type] = ACTIONS(1024),
    [anon_sym_image2d_t] = ACTIONS(1024),
    [anon_sym_image3d_t] = ACTIONS(1024),
    [anon_sym_image2d_array_t] = ACTIONS(1024),
    [anon_sym_image1d_t] = ACTIONS(1024),
    [anon_sym_image1d_buffer_t] = ACTIONS(1024),
    [anon_sym_image1d_array_t] = ACTIONS(1024),
    [anon_sym_image2d_depth_t] = ACTIONS(1024),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1024),
    [anon_sym_sampler_t] = ACTIONS(1024),
    [anon_sym_queue_t] = ACTIONS(1024),
    [anon_sym_ndrange_t] = ACTIONS(1024),
    [anon_sym_clk_event_t] = ACTIONS(1024),
    [anon_sym_reserve_id_t] = ACTIONS(1024),
    [anon_sym_event_t] = ACTIONS(1024),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1024),
    [anon_sym_enum] = ACTIONS(1024),
    [anon_sym_struct] = ACTIONS(1024),
    [anon_sym_union] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1024),
    [anon_sym_else] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1024),
    [anon_sym_default] = ACTIONS(1024),
    [anon_sym_while] = ACTIONS(1024),
    [anon_sym_do] = ACTIONS(1024),
    [anon_sym_for] = ACTIONS(1024),
    [anon_sym_return] = ACTIONS(1024),
    [anon_sym_break] = ACTIONS(1024),
    [anon_sym_continue] = ACTIONS(1024),
    [anon_sym_goto] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [anon_sym_sizeof] = ACTIONS(1024),
    [sym_number_literal] = ACTIONS(1026),
    [anon_sym_L_SQUOTE] = ACTIONS(1026),
    [anon_sym_u_SQUOTE] = ACTIONS(1026),
    [anon_sym_U_SQUOTE] = ACTIONS(1026),
    [anon_sym_u8_SQUOTE] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [anon_sym_L_DQUOTE] = ACTIONS(1026),
    [anon_sym_u_DQUOTE] = ACTIONS(1026),
    [anon_sym_U_DQUOTE] = ACTIONS(1026),
    [anon_sym_u8_DQUOTE] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [sym_true] = ACTIONS(1024),
    [sym_false] = ACTIONS(1024),
    [sym_null] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym_identifier] = ACTIONS(1000),
    [aux_sym_preproc_include_token1] = ACTIONS(1000),
    [aux_sym_preproc_def_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1000),
    [sym_preproc_directive] = ACTIONS(1000),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_typedef] = ACTIONS(1000),
    [anon_sym_kernel] = ACTIONS(1000),
    [anon_sym___kernel] = ACTIONS(1000),
    [anon_sym_global] = ACTIONS(1000),
    [anon_sym___global] = ACTIONS(1000),
    [anon_sym_local] = ACTIONS(1000),
    [anon_sym___local] = ACTIONS(1000),
    [anon_sym_constant] = ACTIONS(1000),
    [anon_sym___constant] = ACTIONS(1000),
    [anon_sym_private] = ACTIONS(1000),
    [anon_sym___private] = ACTIONS(1000),
    [anon_sym_generic] = ACTIONS(1000),
    [anon_sym___generic] = ACTIONS(1000),
    [anon_sym_read_only] = ACTIONS(1000),
    [anon_sym___read_only] = ACTIONS(1000),
    [anon_sym_write_only] = ACTIONS(1000),
    [anon_sym___write_only] = ACTIONS(1000),
    [anon_sym_read_write] = ACTIONS(1000),
    [anon_sym___read_write] = ACTIONS(1000),
    [anon_sym_extern] = ACTIONS(1000),
    [anon_sym___attribute__] = ACTIONS(1000),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1002),
    [anon_sym___declspec] = ACTIONS(1000),
    [anon_sym___cdecl] = ACTIONS(1000),
    [anon_sym___clrcall] = ACTIONS(1000),
    [anon_sym___stdcall] = ACTIONS(1000),
    [anon_sym___fastcall] = ACTIONS(1000),
    [anon_sym___thiscall] = ACTIONS(1000),
    [anon_sym___vectorcall] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_RBRACE] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_auto] = ACTIONS(1000),
    [anon_sym_register] = ACTIONS(1000),
    [anon_sym_inline] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_volatile] = ACTIONS(1000),
    [anon_sym_restrict] = ACTIONS(1000),
    [anon_sym__Atomic] = ACTIONS(1000),
    [anon_sym_pipe] = ACTIONS(1000),
    [anon_sym_signed] = ACTIONS(1000),
    [anon_sym_unsigned] = ACTIONS(1000),
    [anon_sym_long] = ACTIONS(1000),
    [anon_sym_short] = ACTIONS(1000),
    [anon_sym_bool] = ACTIONS(1000),
    [anon_sym_char] = ACTIONS(1000),
    [anon_sym_uchar] = ACTIONS(1000),
    [anon_sym_ushort] = ACTIONS(1000),
    [anon_sym_int] = ACTIONS(1000),
    [anon_sym_uint] = ACTIONS(1000),
    [anon_sym_ulong] = ACTIONS(1000),
    [anon_sym_float] = ACTIONS(1000),
    [anon_sym_double] = ACTIONS(1000),
    [anon_sym_half] = ACTIONS(1000),
    [anon_sym_size_t] = ACTIONS(1000),
    [anon_sym_ptrdiff_t] = ACTIONS(1000),
    [anon_sym_intptr_t] = ACTIONS(1000),
    [anon_sym_uintptr_t] = ACTIONS(1000),
    [anon_sym_void] = ACTIONS(1000),
    [sym_vector_type] = ACTIONS(1000),
    [anon_sym_image2d_t] = ACTIONS(1000),
    [anon_sym_image3d_t] = ACTIONS(1000),
    [anon_sym_image2d_array_t] = ACTIONS(1000),
    [anon_sym_image1d_t] = ACTIONS(1000),
    [anon_sym_image1d_buffer_t] = ACTIONS(1000),
    [anon_sym_image1d_array_t] = ACTIONS(1000),
    [anon_sym_image2d_depth_t] = ACTIONS(1000),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1000),
    [anon_sym_sampler_t] = ACTIONS(1000),
    [anon_sym_queue_t] = ACTIONS(1000),
    [anon_sym_ndrange_t] = ACTIONS(1000),
    [anon_sym_clk_event_t] = ACTIONS(1000),
    [anon_sym_reserve_id_t] = ACTIONS(1000),
    [anon_sym_event_t] = ACTIONS(1000),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_struct] = ACTIONS(1000),
    [anon_sym_union] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_goto] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1002),
    [anon_sym_L_SQUOTE] = ACTIONS(1002),
    [anon_sym_u_SQUOTE] = ACTIONS(1002),
    [anon_sym_U_SQUOTE] = ACTIONS(1002),
    [anon_sym_u8_SQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_L_DQUOTE] = ACTIONS(1002),
    [anon_sym_u_DQUOTE] = ACTIONS(1002),
    [anon_sym_U_DQUOTE] = ACTIONS(1002),
    [anon_sym_u8_DQUOTE] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym_identifier] = ACTIONS(1004),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1006),
    [anon_sym_AMP] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [anon_sym_typedef] = ACTIONS(1004),
    [anon_sym_kernel] = ACTIONS(1004),
    [anon_sym___kernel] = ACTIONS(1004),
    [anon_sym_global] = ACTIONS(1004),
    [anon_sym___global] = ACTIONS(1004),
    [anon_sym_local] = ACTIONS(1004),
    [anon_sym___local] = ACTIONS(1004),
    [anon_sym_constant] = ACTIONS(1004),
    [anon_sym___constant] = ACTIONS(1004),
    [anon_sym_private] = ACTIONS(1004),
    [anon_sym___private] = ACTIONS(1004),
    [anon_sym_generic] = ACTIONS(1004),
    [anon_sym___generic] = ACTIONS(1004),
    [anon_sym_read_only] = ACTIONS(1004),
    [anon_sym___read_only] = ACTIONS(1004),
    [anon_sym_write_only] = ACTIONS(1004),
    [anon_sym___write_only] = ACTIONS(1004),
    [anon_sym_read_write] = ACTIONS(1004),
    [anon_sym___read_write] = ACTIONS(1004),
    [anon_sym_extern] = ACTIONS(1004),
    [anon_sym___attribute__] = ACTIONS(1004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1006),
    [anon_sym___declspec] = ACTIONS(1004),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_auto] = ACTIONS(1004),
    [anon_sym_register] = ACTIONS(1004),
    [anon_sym_inline] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_volatile] = ACTIONS(1004),
    [anon_sym_restrict] = ACTIONS(1004),
    [anon_sym__Atomic] = ACTIONS(1004),
    [anon_sym_pipe] = ACTIONS(1004),
    [anon_sym_signed] = ACTIONS(1004),
    [anon_sym_unsigned] = ACTIONS(1004),
    [anon_sym_long] = ACTIONS(1004),
    [anon_sym_short] = ACTIONS(1004),
    [anon_sym_bool] = ACTIONS(1004),
    [anon_sym_char] = ACTIONS(1004),
    [anon_sym_uchar] = ACTIONS(1004),
    [anon_sym_ushort] = ACTIONS(1004),
    [anon_sym_int] = ACTIONS(1004),
    [anon_sym_uint] = ACTIONS(1004),
    [anon_sym_ulong] = ACTIONS(1004),
    [anon_sym_float] = ACTIONS(1004),
    [anon_sym_double] = ACTIONS(1004),
    [anon_sym_half] = ACTIONS(1004),
    [anon_sym_size_t] = ACTIONS(1004),
    [anon_sym_ptrdiff_t] = ACTIONS(1004),
    [anon_sym_intptr_t] = ACTIONS(1004),
    [anon_sym_uintptr_t] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(1004),
    [sym_vector_type] = ACTIONS(1004),
    [anon_sym_image2d_t] = ACTIONS(1004),
    [anon_sym_image3d_t] = ACTIONS(1004),
    [anon_sym_image2d_array_t] = ACTIONS(1004),
    [anon_sym_image1d_t] = ACTIONS(1004),
    [anon_sym_image1d_buffer_t] = ACTIONS(1004),
    [anon_sym_image1d_array_t] = ACTIONS(1004),
    [anon_sym_image2d_depth_t] = ACTIONS(1004),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1004),
    [anon_sym_sampler_t] = ACTIONS(1004),
    [anon_sym_queue_t] = ACTIONS(1004),
    [anon_sym_ndrange_t] = ACTIONS(1004),
    [anon_sym_clk_event_t] = ACTIONS(1004),
    [anon_sym_reserve_id_t] = ACTIONS(1004),
    [anon_sym_event_t] = ACTIONS(1004),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1004),
    [anon_sym_enum] = ACTIONS(1004),
    [anon_sym_struct] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1004),
    [anon_sym_do] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_return] = ACTIONS(1004),
    [anon_sym_break] = ACTIONS(1004),
    [anon_sym_continue] = ACTIONS(1004),
    [anon_sym_goto] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_sizeof] = ACTIONS(1004),
    [sym_number_literal] = ACTIONS(1006),
    [anon_sym_L_SQUOTE] = ACTIONS(1006),
    [anon_sym_u_SQUOTE] = ACTIONS(1006),
    [anon_sym_U_SQUOTE] = ACTIONS(1006),
    [anon_sym_u8_SQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_L_DQUOTE] = ACTIONS(1006),
    [anon_sym_u_DQUOTE] = ACTIONS(1006),
    [anon_sym_U_DQUOTE] = ACTIONS(1006),
    [anon_sym_u8_DQUOTE] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1006),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [ts_builtin_sym_end] = ACTIONS(974),
    [sym_identifier] = ACTIONS(972),
    [aux_sym_preproc_include_token1] = ACTIONS(972),
    [aux_sym_preproc_def_token1] = ACTIONS(972),
    [aux_sym_preproc_if_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(972),
    [sym_preproc_directive] = ACTIONS(972),
    [anon_sym_LPAREN2] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_typedef] = ACTIONS(972),
    [anon_sym_kernel] = ACTIONS(972),
    [anon_sym___kernel] = ACTIONS(972),
    [anon_sym_global] = ACTIONS(972),
    [anon_sym___global] = ACTIONS(972),
    [anon_sym_local] = ACTIONS(972),
    [anon_sym___local] = ACTIONS(972),
    [anon_sym_constant] = ACTIONS(972),
    [anon_sym___constant] = ACTIONS(972),
    [anon_sym_private] = ACTIONS(972),
    [anon_sym___private] = ACTIONS(972),
    [anon_sym_generic] = ACTIONS(972),
    [anon_sym___generic] = ACTIONS(972),
    [anon_sym_read_only] = ACTIONS(972),
    [anon_sym___read_only] = ACTIONS(972),
    [anon_sym_write_only] = ACTIONS(972),
    [anon_sym___write_only] = ACTIONS(972),
    [anon_sym_read_write] = ACTIONS(972),
    [anon_sym___read_write] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym___attribute__] = ACTIONS(972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(974),
    [anon_sym___declspec] = ACTIONS(972),
    [anon_sym___cdecl] = ACTIONS(972),
    [anon_sym___clrcall] = ACTIONS(972),
    [anon_sym___stdcall] = ACTIONS(972),
    [anon_sym___fastcall] = ACTIONS(972),
    [anon_sym___thiscall] = ACTIONS(972),
    [anon_sym___vectorcall] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_auto] = ACTIONS(972),
    [anon_sym_register] = ACTIONS(972),
    [anon_sym_inline] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_volatile] = ACTIONS(972),
    [anon_sym_restrict] = ACTIONS(972),
    [anon_sym__Atomic] = ACTIONS(972),
    [anon_sym_pipe] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(972),
    [anon_sym_unsigned] = ACTIONS(972),
    [anon_sym_long] = ACTIONS(972),
    [anon_sym_short] = ACTIONS(972),
    [anon_sym_bool] = ACTIONS(972),
    [anon_sym_char] = ACTIONS(972),
    [anon_sym_uchar] = ACTIONS(972),
    [anon_sym_ushort] = ACTIONS(972),
    [anon_sym_int] = ACTIONS(972),
    [anon_sym_uint] = ACTIONS(972),
    [anon_sym_ulong] = ACTIONS(972),
    [anon_sym_float] = ACTIONS(972),
    [anon_sym_double] = ACTIONS(972),
    [anon_sym_half] = ACTIONS(972),
    [anon_sym_size_t] = ACTIONS(972),
    [anon_sym_ptrdiff_t] = ACTIONS(972),
    [anon_sym_intptr_t] = ACTIONS(972),
    [anon_sym_uintptr_t] = ACTIONS(972),
    [anon_sym_void] = ACTIONS(972),
    [sym_vector_type] = ACTIONS(972),
    [anon_sym_image2d_t] = ACTIONS(972),
    [anon_sym_image3d_t] = ACTIONS(972),
    [anon_sym_image2d_array_t] = ACTIONS(972),
    [anon_sym_image1d_t] = ACTIONS(972),
    [anon_sym_image1d_buffer_t] = ACTIONS(972),
    [anon_sym_image1d_array_t] = ACTIONS(972),
    [anon_sym_image2d_depth_t] = ACTIONS(972),
    [anon_sym_image2d_array_depth_t] = ACTIONS(972),
    [anon_sym_sampler_t] = ACTIONS(972),
    [anon_sym_queue_t] = ACTIONS(972),
    [anon_sym_ndrange_t] = ACTIONS(972),
    [anon_sym_clk_event_t] = ACTIONS(972),
    [anon_sym_reserve_id_t] = ACTIONS(972),
    [anon_sym_event_t] = ACTIONS(972),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_union] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_case] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_goto] = ACTIONS(972),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_sizeof] = ACTIONS(972),
    [sym_number_literal] = ACTIONS(974),
    [anon_sym_L_SQUOTE] = ACTIONS(974),
    [anon_sym_u_SQUOTE] = ACTIONS(974),
    [anon_sym_U_SQUOTE] = ACTIONS(974),
    [anon_sym_u8_SQUOTE] = ACTIONS(974),
    [anon_sym_SQUOTE] = ACTIONS(974),
    [anon_sym_L_DQUOTE] = ACTIONS(974),
    [anon_sym_u_DQUOTE] = ACTIONS(974),
    [anon_sym_U_DQUOTE] = ACTIONS(974),
    [anon_sym_u8_DQUOTE] = ACTIONS(974),
    [anon_sym_DQUOTE] = ACTIONS(974),
    [sym_true] = ACTIONS(972),
    [sym_false] = ACTIONS(972),
    [sym_null] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_identifier] = ACTIONS(1008),
    [aux_sym_preproc_include_token1] = ACTIONS(1008),
    [aux_sym_preproc_def_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1008),
    [sym_preproc_directive] = ACTIONS(1008),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_typedef] = ACTIONS(1008),
    [anon_sym_kernel] = ACTIONS(1008),
    [anon_sym___kernel] = ACTIONS(1008),
    [anon_sym_global] = ACTIONS(1008),
    [anon_sym___global] = ACTIONS(1008),
    [anon_sym_local] = ACTIONS(1008),
    [anon_sym___local] = ACTIONS(1008),
    [anon_sym_constant] = ACTIONS(1008),
    [anon_sym___constant] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym___private] = ACTIONS(1008),
    [anon_sym_generic] = ACTIONS(1008),
    [anon_sym___generic] = ACTIONS(1008),
    [anon_sym_read_only] = ACTIONS(1008),
    [anon_sym___read_only] = ACTIONS(1008),
    [anon_sym_write_only] = ACTIONS(1008),
    [anon_sym___write_only] = ACTIONS(1008),
    [anon_sym_read_write] = ACTIONS(1008),
    [anon_sym___read_write] = ACTIONS(1008),
    [anon_sym_extern] = ACTIONS(1008),
    [anon_sym___attribute__] = ACTIONS(1008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1010),
    [anon_sym___declspec] = ACTIONS(1008),
    [anon_sym___cdecl] = ACTIONS(1008),
    [anon_sym___clrcall] = ACTIONS(1008),
    [anon_sym___stdcall] = ACTIONS(1008),
    [anon_sym___fastcall] = ACTIONS(1008),
    [anon_sym___thiscall] = ACTIONS(1008),
    [anon_sym___vectorcall] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_RBRACE] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_auto] = ACTIONS(1008),
    [anon_sym_register] = ACTIONS(1008),
    [anon_sym_inline] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_volatile] = ACTIONS(1008),
    [anon_sym_restrict] = ACTIONS(1008),
    [anon_sym__Atomic] = ACTIONS(1008),
    [anon_sym_pipe] = ACTIONS(1008),
    [anon_sym_signed] = ACTIONS(1008),
    [anon_sym_unsigned] = ACTIONS(1008),
    [anon_sym_long] = ACTIONS(1008),
    [anon_sym_short] = ACTIONS(1008),
    [anon_sym_bool] = ACTIONS(1008),
    [anon_sym_char] = ACTIONS(1008),
    [anon_sym_uchar] = ACTIONS(1008),
    [anon_sym_ushort] = ACTIONS(1008),
    [anon_sym_int] = ACTIONS(1008),
    [anon_sym_uint] = ACTIONS(1008),
    [anon_sym_ulong] = ACTIONS(1008),
    [anon_sym_float] = ACTIONS(1008),
    [anon_sym_double] = ACTIONS(1008),
    [anon_sym_half] = ACTIONS(1008),
    [anon_sym_size_t] = ACTIONS(1008),
    [anon_sym_ptrdiff_t] = ACTIONS(1008),
    [anon_sym_intptr_t] = ACTIONS(1008),
    [anon_sym_uintptr_t] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1008),
    [sym_vector_type] = ACTIONS(1008),
    [anon_sym_image2d_t] = ACTIONS(1008),
    [anon_sym_image3d_t] = ACTIONS(1008),
    [anon_sym_image2d_array_t] = ACTIONS(1008),
    [anon_sym_image1d_t] = ACTIONS(1008),
    [anon_sym_image1d_buffer_t] = ACTIONS(1008),
    [anon_sym_image1d_array_t] = ACTIONS(1008),
    [anon_sym_image2d_depth_t] = ACTIONS(1008),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1008),
    [anon_sym_sampler_t] = ACTIONS(1008),
    [anon_sym_queue_t] = ACTIONS(1008),
    [anon_sym_ndrange_t] = ACTIONS(1008),
    [anon_sym_clk_event_t] = ACTIONS(1008),
    [anon_sym_reserve_id_t] = ACTIONS(1008),
    [anon_sym_event_t] = ACTIONS(1008),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_struct] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_goto] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_sizeof] = ACTIONS(1008),
    [sym_number_literal] = ACTIONS(1010),
    [anon_sym_L_SQUOTE] = ACTIONS(1010),
    [anon_sym_u_SQUOTE] = ACTIONS(1010),
    [anon_sym_U_SQUOTE] = ACTIONS(1010),
    [anon_sym_u8_SQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_L_DQUOTE] = ACTIONS(1010),
    [anon_sym_u_DQUOTE] = ACTIONS(1010),
    [anon_sym_U_DQUOTE] = ACTIONS(1010),
    [anon_sym_u8_DQUOTE] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [sym_true] = ACTIONS(1008),
    [sym_false] = ACTIONS(1008),
    [sym_null] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [ts_builtin_sym_end] = ACTIONS(1010),
    [sym_identifier] = ACTIONS(1008),
    [aux_sym_preproc_include_token1] = ACTIONS(1008),
    [aux_sym_preproc_def_token1] = ACTIONS(1008),
    [aux_sym_preproc_if_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1008),
    [sym_preproc_directive] = ACTIONS(1008),
    [anon_sym_LPAREN2] = ACTIONS(1010),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_typedef] = ACTIONS(1008),
    [anon_sym_kernel] = ACTIONS(1008),
    [anon_sym___kernel] = ACTIONS(1008),
    [anon_sym_global] = ACTIONS(1008),
    [anon_sym___global] = ACTIONS(1008),
    [anon_sym_local] = ACTIONS(1008),
    [anon_sym___local] = ACTIONS(1008),
    [anon_sym_constant] = ACTIONS(1008),
    [anon_sym___constant] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym___private] = ACTIONS(1008),
    [anon_sym_generic] = ACTIONS(1008),
    [anon_sym___generic] = ACTIONS(1008),
    [anon_sym_read_only] = ACTIONS(1008),
    [anon_sym___read_only] = ACTIONS(1008),
    [anon_sym_write_only] = ACTIONS(1008),
    [anon_sym___write_only] = ACTIONS(1008),
    [anon_sym_read_write] = ACTIONS(1008),
    [anon_sym___read_write] = ACTIONS(1008),
    [anon_sym_extern] = ACTIONS(1008),
    [anon_sym___attribute__] = ACTIONS(1008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1010),
    [anon_sym___declspec] = ACTIONS(1008),
    [anon_sym___cdecl] = ACTIONS(1008),
    [anon_sym___clrcall] = ACTIONS(1008),
    [anon_sym___stdcall] = ACTIONS(1008),
    [anon_sym___fastcall] = ACTIONS(1008),
    [anon_sym___thiscall] = ACTIONS(1008),
    [anon_sym___vectorcall] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_auto] = ACTIONS(1008),
    [anon_sym_register] = ACTIONS(1008),
    [anon_sym_inline] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [anon_sym_volatile] = ACTIONS(1008),
    [anon_sym_restrict] = ACTIONS(1008),
    [anon_sym__Atomic] = ACTIONS(1008),
    [anon_sym_pipe] = ACTIONS(1008),
    [anon_sym_signed] = ACTIONS(1008),
    [anon_sym_unsigned] = ACTIONS(1008),
    [anon_sym_long] = ACTIONS(1008),
    [anon_sym_short] = ACTIONS(1008),
    [anon_sym_bool] = ACTIONS(1008),
    [anon_sym_char] = ACTIONS(1008),
    [anon_sym_uchar] = ACTIONS(1008),
    [anon_sym_ushort] = ACTIONS(1008),
    [anon_sym_int] = ACTIONS(1008),
    [anon_sym_uint] = ACTIONS(1008),
    [anon_sym_ulong] = ACTIONS(1008),
    [anon_sym_float] = ACTIONS(1008),
    [anon_sym_double] = ACTIONS(1008),
    [anon_sym_half] = ACTIONS(1008),
    [anon_sym_size_t] = ACTIONS(1008),
    [anon_sym_ptrdiff_t] = ACTIONS(1008),
    [anon_sym_intptr_t] = ACTIONS(1008),
    [anon_sym_uintptr_t] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1008),
    [sym_vector_type] = ACTIONS(1008),
    [anon_sym_image2d_t] = ACTIONS(1008),
    [anon_sym_image3d_t] = ACTIONS(1008),
    [anon_sym_image2d_array_t] = ACTIONS(1008),
    [anon_sym_image1d_t] = ACTIONS(1008),
    [anon_sym_image1d_buffer_t] = ACTIONS(1008),
    [anon_sym_image1d_array_t] = ACTIONS(1008),
    [anon_sym_image2d_depth_t] = ACTIONS(1008),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1008),
    [anon_sym_sampler_t] = ACTIONS(1008),
    [anon_sym_queue_t] = ACTIONS(1008),
    [anon_sym_ndrange_t] = ACTIONS(1008),
    [anon_sym_clk_event_t] = ACTIONS(1008),
    [anon_sym_reserve_id_t] = ACTIONS(1008),
    [anon_sym_event_t] = ACTIONS(1008),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_struct] = ACTIONS(1008),
    [anon_sym_union] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1008),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_goto] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_sizeof] = ACTIONS(1008),
    [sym_number_literal] = ACTIONS(1010),
    [anon_sym_L_SQUOTE] = ACTIONS(1010),
    [anon_sym_u_SQUOTE] = ACTIONS(1010),
    [anon_sym_U_SQUOTE] = ACTIONS(1010),
    [anon_sym_u8_SQUOTE] = ACTIONS(1010),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_L_DQUOTE] = ACTIONS(1010),
    [anon_sym_u_DQUOTE] = ACTIONS(1010),
    [anon_sym_U_DQUOTE] = ACTIONS(1010),
    [anon_sym_u8_DQUOTE] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [sym_true] = ACTIONS(1008),
    [sym_false] = ACTIONS(1008),
    [sym_null] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_kernel] = ACTIONS(1012),
    [anon_sym___kernel] = ACTIONS(1012),
    [anon_sym_global] = ACTIONS(1012),
    [anon_sym___global] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym___local] = ACTIONS(1012),
    [anon_sym_constant] = ACTIONS(1012),
    [anon_sym___constant] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym___private] = ACTIONS(1012),
    [anon_sym_generic] = ACTIONS(1012),
    [anon_sym___generic] = ACTIONS(1012),
    [anon_sym_read_only] = ACTIONS(1012),
    [anon_sym___read_only] = ACTIONS(1012),
    [anon_sym_write_only] = ACTIONS(1012),
    [anon_sym___write_only] = ACTIONS(1012),
    [anon_sym_read_write] = ACTIONS(1012),
    [anon_sym___read_write] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1014),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_RBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_pipe] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_uchar] = ACTIONS(1012),
    [anon_sym_ushort] = ACTIONS(1012),
    [anon_sym_int] = ACTIONS(1012),
    [anon_sym_uint] = ACTIONS(1012),
    [anon_sym_ulong] = ACTIONS(1012),
    [anon_sym_float] = ACTIONS(1012),
    [anon_sym_double] = ACTIONS(1012),
    [anon_sym_half] = ACTIONS(1012),
    [anon_sym_size_t] = ACTIONS(1012),
    [anon_sym_ptrdiff_t] = ACTIONS(1012),
    [anon_sym_intptr_t] = ACTIONS(1012),
    [anon_sym_uintptr_t] = ACTIONS(1012),
    [anon_sym_void] = ACTIONS(1012),
    [sym_vector_type] = ACTIONS(1012),
    [anon_sym_image2d_t] = ACTIONS(1012),
    [anon_sym_image3d_t] = ACTIONS(1012),
    [anon_sym_image2d_array_t] = ACTIONS(1012),
    [anon_sym_image1d_t] = ACTIONS(1012),
    [anon_sym_image1d_buffer_t] = ACTIONS(1012),
    [anon_sym_image1d_array_t] = ACTIONS(1012),
    [anon_sym_image2d_depth_t] = ACTIONS(1012),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1012),
    [anon_sym_sampler_t] = ACTIONS(1012),
    [anon_sym_queue_t] = ACTIONS(1012),
    [anon_sym_ndrange_t] = ACTIONS(1012),
    [anon_sym_clk_event_t] = ACTIONS(1012),
    [anon_sym_reserve_id_t] = ACTIONS(1012),
    [anon_sym_event_t] = ACTIONS(1012),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [ts_builtin_sym_end] = ACTIONS(998),
    [sym_identifier] = ACTIONS(996),
    [aux_sym_preproc_include_token1] = ACTIONS(996),
    [aux_sym_preproc_def_token1] = ACTIONS(996),
    [aux_sym_preproc_if_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(996),
    [sym_preproc_directive] = ACTIONS(996),
    [anon_sym_LPAREN2] = ACTIONS(998),
    [anon_sym_BANG] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(998),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_SEMI] = ACTIONS(998),
    [anon_sym_typedef] = ACTIONS(996),
    [anon_sym_kernel] = ACTIONS(996),
    [anon_sym___kernel] = ACTIONS(996),
    [anon_sym_global] = ACTIONS(996),
    [anon_sym___global] = ACTIONS(996),
    [anon_sym_local] = ACTIONS(996),
    [anon_sym___local] = ACTIONS(996),
    [anon_sym_constant] = ACTIONS(996),
    [anon_sym___constant] = ACTIONS(996),
    [anon_sym_private] = ACTIONS(996),
    [anon_sym___private] = ACTIONS(996),
    [anon_sym_generic] = ACTIONS(996),
    [anon_sym___generic] = ACTIONS(996),
    [anon_sym_read_only] = ACTIONS(996),
    [anon_sym___read_only] = ACTIONS(996),
    [anon_sym_write_only] = ACTIONS(996),
    [anon_sym___write_only] = ACTIONS(996),
    [anon_sym_read_write] = ACTIONS(996),
    [anon_sym___read_write] = ACTIONS(996),
    [anon_sym_extern] = ACTIONS(996),
    [anon_sym___attribute__] = ACTIONS(996),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(998),
    [anon_sym___declspec] = ACTIONS(996),
    [anon_sym___cdecl] = ACTIONS(996),
    [anon_sym___clrcall] = ACTIONS(996),
    [anon_sym___stdcall] = ACTIONS(996),
    [anon_sym___fastcall] = ACTIONS(996),
    [anon_sym___thiscall] = ACTIONS(996),
    [anon_sym___vectorcall] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(998),
    [anon_sym_static] = ACTIONS(996),
    [anon_sym_auto] = ACTIONS(996),
    [anon_sym_register] = ACTIONS(996),
    [anon_sym_inline] = ACTIONS(996),
    [anon_sym_const] = ACTIONS(996),
    [anon_sym_volatile] = ACTIONS(996),
    [anon_sym_restrict] = ACTIONS(996),
    [anon_sym__Atomic] = ACTIONS(996),
    [anon_sym_pipe] = ACTIONS(996),
    [anon_sym_signed] = ACTIONS(996),
    [anon_sym_unsigned] = ACTIONS(996),
    [anon_sym_long] = ACTIONS(996),
    [anon_sym_short] = ACTIONS(996),
    [anon_sym_bool] = ACTIONS(996),
    [anon_sym_char] = ACTIONS(996),
    [anon_sym_uchar] = ACTIONS(996),
    [anon_sym_ushort] = ACTIONS(996),
    [anon_sym_int] = ACTIONS(996),
    [anon_sym_uint] = ACTIONS(996),
    [anon_sym_ulong] = ACTIONS(996),
    [anon_sym_float] = ACTIONS(996),
    [anon_sym_double] = ACTIONS(996),
    [anon_sym_half] = ACTIONS(996),
    [anon_sym_size_t] = ACTIONS(996),
    [anon_sym_ptrdiff_t] = ACTIONS(996),
    [anon_sym_intptr_t] = ACTIONS(996),
    [anon_sym_uintptr_t] = ACTIONS(996),
    [anon_sym_void] = ACTIONS(996),
    [sym_vector_type] = ACTIONS(996),
    [anon_sym_image2d_t] = ACTIONS(996),
    [anon_sym_image3d_t] = ACTIONS(996),
    [anon_sym_image2d_array_t] = ACTIONS(996),
    [anon_sym_image1d_t] = ACTIONS(996),
    [anon_sym_image1d_buffer_t] = ACTIONS(996),
    [anon_sym_image1d_array_t] = ACTIONS(996),
    [anon_sym_image2d_depth_t] = ACTIONS(996),
    [anon_sym_image2d_array_depth_t] = ACTIONS(996),
    [anon_sym_sampler_t] = ACTIONS(996),
    [anon_sym_queue_t] = ACTIONS(996),
    [anon_sym_ndrange_t] = ACTIONS(996),
    [anon_sym_clk_event_t] = ACTIONS(996),
    [anon_sym_reserve_id_t] = ACTIONS(996),
    [anon_sym_event_t] = ACTIONS(996),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(996),
    [anon_sym_enum] = ACTIONS(996),
    [anon_sym_struct] = ACTIONS(996),
    [anon_sym_union] = ACTIONS(996),
    [anon_sym_if] = ACTIONS(996),
    [anon_sym_else] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(996),
    [anon_sym_case] = ACTIONS(996),
    [anon_sym_default] = ACTIONS(996),
    [anon_sym_while] = ACTIONS(996),
    [anon_sym_do] = ACTIONS(996),
    [anon_sym_for] = ACTIONS(996),
    [anon_sym_return] = ACTIONS(996),
    [anon_sym_break] = ACTIONS(996),
    [anon_sym_continue] = ACTIONS(996),
    [anon_sym_goto] = ACTIONS(996),
    [anon_sym_DASH_DASH] = ACTIONS(998),
    [anon_sym_PLUS_PLUS] = ACTIONS(998),
    [anon_sym_sizeof] = ACTIONS(996),
    [sym_number_literal] = ACTIONS(998),
    [anon_sym_L_SQUOTE] = ACTIONS(998),
    [anon_sym_u_SQUOTE] = ACTIONS(998),
    [anon_sym_U_SQUOTE] = ACTIONS(998),
    [anon_sym_u8_SQUOTE] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(998),
    [anon_sym_L_DQUOTE] = ACTIONS(998),
    [anon_sym_u_DQUOTE] = ACTIONS(998),
    [anon_sym_U_DQUOTE] = ACTIONS(998),
    [anon_sym_u8_DQUOTE] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(998),
    [sym_true] = ACTIONS(996),
    [sym_false] = ACTIONS(996),
    [sym_null] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_identifier] = ACTIONS(1012),
    [aux_sym_preproc_include_token1] = ACTIONS(1012),
    [aux_sym_preproc_def_token1] = ACTIONS(1012),
    [aux_sym_preproc_if_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1012),
    [sym_preproc_directive] = ACTIONS(1012),
    [anon_sym_LPAREN2] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1012),
    [anon_sym_kernel] = ACTIONS(1012),
    [anon_sym___kernel] = ACTIONS(1012),
    [anon_sym_global] = ACTIONS(1012),
    [anon_sym___global] = ACTIONS(1012),
    [anon_sym_local] = ACTIONS(1012),
    [anon_sym___local] = ACTIONS(1012),
    [anon_sym_constant] = ACTIONS(1012),
    [anon_sym___constant] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym___private] = ACTIONS(1012),
    [anon_sym_generic] = ACTIONS(1012),
    [anon_sym___generic] = ACTIONS(1012),
    [anon_sym_read_only] = ACTIONS(1012),
    [anon_sym___read_only] = ACTIONS(1012),
    [anon_sym_write_only] = ACTIONS(1012),
    [anon_sym___write_only] = ACTIONS(1012),
    [anon_sym_read_write] = ACTIONS(1012),
    [anon_sym___read_write] = ACTIONS(1012),
    [anon_sym_extern] = ACTIONS(1012),
    [anon_sym___attribute__] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1014),
    [anon_sym___declspec] = ACTIONS(1012),
    [anon_sym___cdecl] = ACTIONS(1012),
    [anon_sym___clrcall] = ACTIONS(1012),
    [anon_sym___stdcall] = ACTIONS(1012),
    [anon_sym___fastcall] = ACTIONS(1012),
    [anon_sym___thiscall] = ACTIONS(1012),
    [anon_sym___vectorcall] = ACTIONS(1012),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_RBRACE] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_auto] = ACTIONS(1012),
    [anon_sym_register] = ACTIONS(1012),
    [anon_sym_inline] = ACTIONS(1012),
    [anon_sym_const] = ACTIONS(1012),
    [anon_sym_volatile] = ACTIONS(1012),
    [anon_sym_restrict] = ACTIONS(1012),
    [anon_sym__Atomic] = ACTIONS(1012),
    [anon_sym_pipe] = ACTIONS(1012),
    [anon_sym_signed] = ACTIONS(1012),
    [anon_sym_unsigned] = ACTIONS(1012),
    [anon_sym_long] = ACTIONS(1012),
    [anon_sym_short] = ACTIONS(1012),
    [anon_sym_bool] = ACTIONS(1012),
    [anon_sym_char] = ACTIONS(1012),
    [anon_sym_uchar] = ACTIONS(1012),
    [anon_sym_ushort] = ACTIONS(1012),
    [anon_sym_int] = ACTIONS(1012),
    [anon_sym_uint] = ACTIONS(1012),
    [anon_sym_ulong] = ACTIONS(1012),
    [anon_sym_float] = ACTIONS(1012),
    [anon_sym_double] = ACTIONS(1012),
    [anon_sym_half] = ACTIONS(1012),
    [anon_sym_size_t] = ACTIONS(1012),
    [anon_sym_ptrdiff_t] = ACTIONS(1012),
    [anon_sym_intptr_t] = ACTIONS(1012),
    [anon_sym_uintptr_t] = ACTIONS(1012),
    [anon_sym_void] = ACTIONS(1012),
    [sym_vector_type] = ACTIONS(1012),
    [anon_sym_image2d_t] = ACTIONS(1012),
    [anon_sym_image3d_t] = ACTIONS(1012),
    [anon_sym_image2d_array_t] = ACTIONS(1012),
    [anon_sym_image1d_t] = ACTIONS(1012),
    [anon_sym_image1d_buffer_t] = ACTIONS(1012),
    [anon_sym_image1d_array_t] = ACTIONS(1012),
    [anon_sym_image2d_depth_t] = ACTIONS(1012),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1012),
    [anon_sym_sampler_t] = ACTIONS(1012),
    [anon_sym_queue_t] = ACTIONS(1012),
    [anon_sym_ndrange_t] = ACTIONS(1012),
    [anon_sym_clk_event_t] = ACTIONS(1012),
    [anon_sym_reserve_id_t] = ACTIONS(1012),
    [anon_sym_event_t] = ACTIONS(1012),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1012),
    [anon_sym_enum] = ACTIONS(1012),
    [anon_sym_struct] = ACTIONS(1012),
    [anon_sym_union] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1012),
    [anon_sym_else] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1012),
    [anon_sym_default] = ACTIONS(1012),
    [anon_sym_while] = ACTIONS(1012),
    [anon_sym_do] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1012),
    [anon_sym_return] = ACTIONS(1012),
    [anon_sym_break] = ACTIONS(1012),
    [anon_sym_continue] = ACTIONS(1012),
    [anon_sym_goto] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_sizeof] = ACTIONS(1012),
    [sym_number_literal] = ACTIONS(1014),
    [anon_sym_L_SQUOTE] = ACTIONS(1014),
    [anon_sym_u_SQUOTE] = ACTIONS(1014),
    [anon_sym_U_SQUOTE] = ACTIONS(1014),
    [anon_sym_u8_SQUOTE] = ACTIONS(1014),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_L_DQUOTE] = ACTIONS(1014),
    [anon_sym_u_DQUOTE] = ACTIONS(1014),
    [anon_sym_U_DQUOTE] = ACTIONS(1014),
    [anon_sym_u8_DQUOTE] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_true] = ACTIONS(1012),
    [sym_false] = ACTIONS(1012),
    [sym_null] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [ts_builtin_sym_end] = ACTIONS(1002),
    [sym_identifier] = ACTIONS(1000),
    [aux_sym_preproc_include_token1] = ACTIONS(1000),
    [aux_sym_preproc_def_token1] = ACTIONS(1000),
    [aux_sym_preproc_if_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1000),
    [sym_preproc_directive] = ACTIONS(1000),
    [anon_sym_LPAREN2] = ACTIONS(1002),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_typedef] = ACTIONS(1000),
    [anon_sym_kernel] = ACTIONS(1000),
    [anon_sym___kernel] = ACTIONS(1000),
    [anon_sym_global] = ACTIONS(1000),
    [anon_sym___global] = ACTIONS(1000),
    [anon_sym_local] = ACTIONS(1000),
    [anon_sym___local] = ACTIONS(1000),
    [anon_sym_constant] = ACTIONS(1000),
    [anon_sym___constant] = ACTIONS(1000),
    [anon_sym_private] = ACTIONS(1000),
    [anon_sym___private] = ACTIONS(1000),
    [anon_sym_generic] = ACTIONS(1000),
    [anon_sym___generic] = ACTIONS(1000),
    [anon_sym_read_only] = ACTIONS(1000),
    [anon_sym___read_only] = ACTIONS(1000),
    [anon_sym_write_only] = ACTIONS(1000),
    [anon_sym___write_only] = ACTIONS(1000),
    [anon_sym_read_write] = ACTIONS(1000),
    [anon_sym___read_write] = ACTIONS(1000),
    [anon_sym_extern] = ACTIONS(1000),
    [anon_sym___attribute__] = ACTIONS(1000),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1002),
    [anon_sym___declspec] = ACTIONS(1000),
    [anon_sym___cdecl] = ACTIONS(1000),
    [anon_sym___clrcall] = ACTIONS(1000),
    [anon_sym___stdcall] = ACTIONS(1000),
    [anon_sym___fastcall] = ACTIONS(1000),
    [anon_sym___thiscall] = ACTIONS(1000),
    [anon_sym___vectorcall] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1000),
    [anon_sym_auto] = ACTIONS(1000),
    [anon_sym_register] = ACTIONS(1000),
    [anon_sym_inline] = ACTIONS(1000),
    [anon_sym_const] = ACTIONS(1000),
    [anon_sym_volatile] = ACTIONS(1000),
    [anon_sym_restrict] = ACTIONS(1000),
    [anon_sym__Atomic] = ACTIONS(1000),
    [anon_sym_pipe] = ACTIONS(1000),
    [anon_sym_signed] = ACTIONS(1000),
    [anon_sym_unsigned] = ACTIONS(1000),
    [anon_sym_long] = ACTIONS(1000),
    [anon_sym_short] = ACTIONS(1000),
    [anon_sym_bool] = ACTIONS(1000),
    [anon_sym_char] = ACTIONS(1000),
    [anon_sym_uchar] = ACTIONS(1000),
    [anon_sym_ushort] = ACTIONS(1000),
    [anon_sym_int] = ACTIONS(1000),
    [anon_sym_uint] = ACTIONS(1000),
    [anon_sym_ulong] = ACTIONS(1000),
    [anon_sym_float] = ACTIONS(1000),
    [anon_sym_double] = ACTIONS(1000),
    [anon_sym_half] = ACTIONS(1000),
    [anon_sym_size_t] = ACTIONS(1000),
    [anon_sym_ptrdiff_t] = ACTIONS(1000),
    [anon_sym_intptr_t] = ACTIONS(1000),
    [anon_sym_uintptr_t] = ACTIONS(1000),
    [anon_sym_void] = ACTIONS(1000),
    [sym_vector_type] = ACTIONS(1000),
    [anon_sym_image2d_t] = ACTIONS(1000),
    [anon_sym_image3d_t] = ACTIONS(1000),
    [anon_sym_image2d_array_t] = ACTIONS(1000),
    [anon_sym_image1d_t] = ACTIONS(1000),
    [anon_sym_image1d_buffer_t] = ACTIONS(1000),
    [anon_sym_image1d_array_t] = ACTIONS(1000),
    [anon_sym_image2d_depth_t] = ACTIONS(1000),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1000),
    [anon_sym_sampler_t] = ACTIONS(1000),
    [anon_sym_queue_t] = ACTIONS(1000),
    [anon_sym_ndrange_t] = ACTIONS(1000),
    [anon_sym_clk_event_t] = ACTIONS(1000),
    [anon_sym_reserve_id_t] = ACTIONS(1000),
    [anon_sym_event_t] = ACTIONS(1000),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1000),
    [anon_sym_enum] = ACTIONS(1000),
    [anon_sym_struct] = ACTIONS(1000),
    [anon_sym_union] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1000),
    [anon_sym_else] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1000),
    [anon_sym_default] = ACTIONS(1000),
    [anon_sym_while] = ACTIONS(1000),
    [anon_sym_do] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(1000),
    [anon_sym_return] = ACTIONS(1000),
    [anon_sym_break] = ACTIONS(1000),
    [anon_sym_continue] = ACTIONS(1000),
    [anon_sym_goto] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1002),
    [anon_sym_sizeof] = ACTIONS(1000),
    [sym_number_literal] = ACTIONS(1002),
    [anon_sym_L_SQUOTE] = ACTIONS(1002),
    [anon_sym_u_SQUOTE] = ACTIONS(1002),
    [anon_sym_U_SQUOTE] = ACTIONS(1002),
    [anon_sym_u8_SQUOTE] = ACTIONS(1002),
    [anon_sym_SQUOTE] = ACTIONS(1002),
    [anon_sym_L_DQUOTE] = ACTIONS(1002),
    [anon_sym_u_DQUOTE] = ACTIONS(1002),
    [anon_sym_U_DQUOTE] = ACTIONS(1002),
    [anon_sym_u8_DQUOTE] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_true] = ACTIONS(1000),
    [sym_false] = ACTIONS(1000),
    [sym_null] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1004),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(1006),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1006),
    [anon_sym_AMP] = ACTIONS(1006),
    [anon_sym_SEMI] = ACTIONS(1006),
    [anon_sym_typedef] = ACTIONS(1004),
    [anon_sym_kernel] = ACTIONS(1004),
    [anon_sym___kernel] = ACTIONS(1004),
    [anon_sym_global] = ACTIONS(1004),
    [anon_sym___global] = ACTIONS(1004),
    [anon_sym_local] = ACTIONS(1004),
    [anon_sym___local] = ACTIONS(1004),
    [anon_sym_constant] = ACTIONS(1004),
    [anon_sym___constant] = ACTIONS(1004),
    [anon_sym_private] = ACTIONS(1004),
    [anon_sym___private] = ACTIONS(1004),
    [anon_sym_generic] = ACTIONS(1004),
    [anon_sym___generic] = ACTIONS(1004),
    [anon_sym_read_only] = ACTIONS(1004),
    [anon_sym___read_only] = ACTIONS(1004),
    [anon_sym_write_only] = ACTIONS(1004),
    [anon_sym___write_only] = ACTIONS(1004),
    [anon_sym_read_write] = ACTIONS(1004),
    [anon_sym___read_write] = ACTIONS(1004),
    [anon_sym_extern] = ACTIONS(1004),
    [anon_sym___attribute__] = ACTIONS(1004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1006),
    [anon_sym___declspec] = ACTIONS(1004),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1004),
    [anon_sym_auto] = ACTIONS(1004),
    [anon_sym_register] = ACTIONS(1004),
    [anon_sym_inline] = ACTIONS(1004),
    [anon_sym_const] = ACTIONS(1004),
    [anon_sym_volatile] = ACTIONS(1004),
    [anon_sym_restrict] = ACTIONS(1004),
    [anon_sym__Atomic] = ACTIONS(1004),
    [anon_sym_pipe] = ACTIONS(1004),
    [anon_sym_signed] = ACTIONS(1004),
    [anon_sym_unsigned] = ACTIONS(1004),
    [anon_sym_long] = ACTIONS(1004),
    [anon_sym_short] = ACTIONS(1004),
    [anon_sym_bool] = ACTIONS(1004),
    [anon_sym_char] = ACTIONS(1004),
    [anon_sym_uchar] = ACTIONS(1004),
    [anon_sym_ushort] = ACTIONS(1004),
    [anon_sym_int] = ACTIONS(1004),
    [anon_sym_uint] = ACTIONS(1004),
    [anon_sym_ulong] = ACTIONS(1004),
    [anon_sym_float] = ACTIONS(1004),
    [anon_sym_double] = ACTIONS(1004),
    [anon_sym_half] = ACTIONS(1004),
    [anon_sym_size_t] = ACTIONS(1004),
    [anon_sym_ptrdiff_t] = ACTIONS(1004),
    [anon_sym_intptr_t] = ACTIONS(1004),
    [anon_sym_uintptr_t] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(1004),
    [sym_vector_type] = ACTIONS(1004),
    [anon_sym_image2d_t] = ACTIONS(1004),
    [anon_sym_image3d_t] = ACTIONS(1004),
    [anon_sym_image2d_array_t] = ACTIONS(1004),
    [anon_sym_image1d_t] = ACTIONS(1004),
    [anon_sym_image1d_buffer_t] = ACTIONS(1004),
    [anon_sym_image1d_array_t] = ACTIONS(1004),
    [anon_sym_image2d_depth_t] = ACTIONS(1004),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1004),
    [anon_sym_sampler_t] = ACTIONS(1004),
    [anon_sym_queue_t] = ACTIONS(1004),
    [anon_sym_ndrange_t] = ACTIONS(1004),
    [anon_sym_clk_event_t] = ACTIONS(1004),
    [anon_sym_reserve_id_t] = ACTIONS(1004),
    [anon_sym_event_t] = ACTIONS(1004),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1004),
    [anon_sym_enum] = ACTIONS(1004),
    [anon_sym_struct] = ACTIONS(1004),
    [anon_sym_union] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1004),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(1004),
    [anon_sym_do] = ACTIONS(1004),
    [anon_sym_for] = ACTIONS(1004),
    [anon_sym_return] = ACTIONS(1004),
    [anon_sym_break] = ACTIONS(1004),
    [anon_sym_continue] = ACTIONS(1004),
    [anon_sym_goto] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_sizeof] = ACTIONS(1004),
    [sym_number_literal] = ACTIONS(1006),
    [anon_sym_L_SQUOTE] = ACTIONS(1006),
    [anon_sym_u_SQUOTE] = ACTIONS(1006),
    [anon_sym_U_SQUOTE] = ACTIONS(1006),
    [anon_sym_u8_SQUOTE] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1006),
    [anon_sym_L_DQUOTE] = ACTIONS(1006),
    [anon_sym_u_DQUOTE] = ACTIONS(1006),
    [anon_sym_U_DQUOTE] = ACTIONS(1006),
    [anon_sym_u8_DQUOTE] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1006),
    [sym_true] = ACTIONS(1004),
    [sym_false] = ACTIONS(1004),
    [sym_null] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [ts_builtin_sym_end] = ACTIONS(1098),
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_include_token1] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_typedef] = ACTIONS(1096),
    [anon_sym_kernel] = ACTIONS(1096),
    [anon_sym___kernel] = ACTIONS(1096),
    [anon_sym_global] = ACTIONS(1096),
    [anon_sym___global] = ACTIONS(1096),
    [anon_sym_local] = ACTIONS(1096),
    [anon_sym___local] = ACTIONS(1096),
    [anon_sym_constant] = ACTIONS(1096),
    [anon_sym___constant] = ACTIONS(1096),
    [anon_sym_private] = ACTIONS(1096),
    [anon_sym___private] = ACTIONS(1096),
    [anon_sym_generic] = ACTIONS(1096),
    [anon_sym___generic] = ACTIONS(1096),
    [anon_sym_read_only] = ACTIONS(1096),
    [anon_sym___read_only] = ACTIONS(1096),
    [anon_sym_write_only] = ACTIONS(1096),
    [anon_sym___write_only] = ACTIONS(1096),
    [anon_sym_read_write] = ACTIONS(1096),
    [anon_sym___read_write] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1098),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym___cdecl] = ACTIONS(1096),
    [anon_sym___clrcall] = ACTIONS(1096),
    [anon_sym___stdcall] = ACTIONS(1096),
    [anon_sym___fastcall] = ACTIONS(1096),
    [anon_sym___thiscall] = ACTIONS(1096),
    [anon_sym___vectorcall] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_pipe] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [anon_sym_bool] = ACTIONS(1096),
    [anon_sym_char] = ACTIONS(1096),
    [anon_sym_uchar] = ACTIONS(1096),
    [anon_sym_ushort] = ACTIONS(1096),
    [anon_sym_int] = ACTIONS(1096),
    [anon_sym_uint] = ACTIONS(1096),
    [anon_sym_ulong] = ACTIONS(1096),
    [anon_sym_float] = ACTIONS(1096),
    [anon_sym_double] = ACTIONS(1096),
    [anon_sym_half] = ACTIONS(1096),
    [anon_sym_size_t] = ACTIONS(1096),
    [anon_sym_ptrdiff_t] = ACTIONS(1096),
    [anon_sym_intptr_t] = ACTIONS(1096),
    [anon_sym_uintptr_t] = ACTIONS(1096),
    [anon_sym_void] = ACTIONS(1096),
    [sym_vector_type] = ACTIONS(1096),
    [anon_sym_image2d_t] = ACTIONS(1096),
    [anon_sym_image3d_t] = ACTIONS(1096),
    [anon_sym_image2d_array_t] = ACTIONS(1096),
    [anon_sym_image1d_t] = ACTIONS(1096),
    [anon_sym_image1d_buffer_t] = ACTIONS(1096),
    [anon_sym_image1d_array_t] = ACTIONS(1096),
    [anon_sym_image2d_depth_t] = ACTIONS(1096),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1096),
    [anon_sym_sampler_t] = ACTIONS(1096),
    [anon_sym_queue_t] = ACTIONS(1096),
    [anon_sym_ndrange_t] = ACTIONS(1096),
    [anon_sym_clk_event_t] = ACTIONS(1096),
    [anon_sym_reserve_id_t] = ACTIONS(1096),
    [anon_sym_event_t] = ACTIONS(1096),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_goto] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_sizeof] = ACTIONS(1096),
    [sym_number_literal] = ACTIONS(1098),
    [anon_sym_L_SQUOTE] = ACTIONS(1098),
    [anon_sym_u_SQUOTE] = ACTIONS(1098),
    [anon_sym_U_SQUOTE] = ACTIONS(1098),
    [anon_sym_u8_SQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_L_DQUOTE] = ACTIONS(1098),
    [anon_sym_u_DQUOTE] = ACTIONS(1098),
    [anon_sym_U_DQUOTE] = ACTIONS(1098),
    [anon_sym_u8_DQUOTE] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_include_token1] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token2] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_typedef] = ACTIONS(1088),
    [anon_sym_kernel] = ACTIONS(1088),
    [anon_sym___kernel] = ACTIONS(1088),
    [anon_sym_global] = ACTIONS(1088),
    [anon_sym___global] = ACTIONS(1088),
    [anon_sym_local] = ACTIONS(1088),
    [anon_sym___local] = ACTIONS(1088),
    [anon_sym_constant] = ACTIONS(1088),
    [anon_sym___constant] = ACTIONS(1088),
    [anon_sym_private] = ACTIONS(1088),
    [anon_sym___private] = ACTIONS(1088),
    [anon_sym_generic] = ACTIONS(1088),
    [anon_sym___generic] = ACTIONS(1088),
    [anon_sym_read_only] = ACTIONS(1088),
    [anon_sym___read_only] = ACTIONS(1088),
    [anon_sym_write_only] = ACTIONS(1088),
    [anon_sym___write_only] = ACTIONS(1088),
    [anon_sym_read_write] = ACTIONS(1088),
    [anon_sym___read_write] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1090),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym___cdecl] = ACTIONS(1088),
    [anon_sym___clrcall] = ACTIONS(1088),
    [anon_sym___stdcall] = ACTIONS(1088),
    [anon_sym___fastcall] = ACTIONS(1088),
    [anon_sym___thiscall] = ACTIONS(1088),
    [anon_sym___vectorcall] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_pipe] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [anon_sym_bool] = ACTIONS(1088),
    [anon_sym_char] = ACTIONS(1088),
    [anon_sym_uchar] = ACTIONS(1088),
    [anon_sym_ushort] = ACTIONS(1088),
    [anon_sym_int] = ACTIONS(1088),
    [anon_sym_uint] = ACTIONS(1088),
    [anon_sym_ulong] = ACTIONS(1088),
    [anon_sym_float] = ACTIONS(1088),
    [anon_sym_double] = ACTIONS(1088),
    [anon_sym_half] = ACTIONS(1088),
    [anon_sym_size_t] = ACTIONS(1088),
    [anon_sym_ptrdiff_t] = ACTIONS(1088),
    [anon_sym_intptr_t] = ACTIONS(1088),
    [anon_sym_uintptr_t] = ACTIONS(1088),
    [anon_sym_void] = ACTIONS(1088),
    [sym_vector_type] = ACTIONS(1088),
    [anon_sym_image2d_t] = ACTIONS(1088),
    [anon_sym_image3d_t] = ACTIONS(1088),
    [anon_sym_image2d_array_t] = ACTIONS(1088),
    [anon_sym_image1d_t] = ACTIONS(1088),
    [anon_sym_image1d_buffer_t] = ACTIONS(1088),
    [anon_sym_image1d_array_t] = ACTIONS(1088),
    [anon_sym_image2d_depth_t] = ACTIONS(1088),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1088),
    [anon_sym_sampler_t] = ACTIONS(1088),
    [anon_sym_queue_t] = ACTIONS(1088),
    [anon_sym_ndrange_t] = ACTIONS(1088),
    [anon_sym_clk_event_t] = ACTIONS(1088),
    [anon_sym_reserve_id_t] = ACTIONS(1088),
    [anon_sym_event_t] = ACTIONS(1088),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_goto] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_sizeof] = ACTIONS(1088),
    [sym_number_literal] = ACTIONS(1090),
    [anon_sym_L_SQUOTE] = ACTIONS(1090),
    [anon_sym_u_SQUOTE] = ACTIONS(1090),
    [anon_sym_U_SQUOTE] = ACTIONS(1090),
    [anon_sym_u8_SQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_L_DQUOTE] = ACTIONS(1090),
    [anon_sym_u_DQUOTE] = ACTIONS(1090),
    [anon_sym_U_DQUOTE] = ACTIONS(1090),
    [anon_sym_u8_DQUOTE] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(1054),
    [sym_identifier] = ACTIONS(1052),
    [aux_sym_preproc_include_token1] = ACTIONS(1052),
    [aux_sym_preproc_def_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1052),
    [sym_preproc_directive] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_AMP] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_typedef] = ACTIONS(1052),
    [anon_sym_kernel] = ACTIONS(1052),
    [anon_sym___kernel] = ACTIONS(1052),
    [anon_sym_global] = ACTIONS(1052),
    [anon_sym___global] = ACTIONS(1052),
    [anon_sym_local] = ACTIONS(1052),
    [anon_sym___local] = ACTIONS(1052),
    [anon_sym_constant] = ACTIONS(1052),
    [anon_sym___constant] = ACTIONS(1052),
    [anon_sym_private] = ACTIONS(1052),
    [anon_sym___private] = ACTIONS(1052),
    [anon_sym_generic] = ACTIONS(1052),
    [anon_sym___generic] = ACTIONS(1052),
    [anon_sym_read_only] = ACTIONS(1052),
    [anon_sym___read_only] = ACTIONS(1052),
    [anon_sym_write_only] = ACTIONS(1052),
    [anon_sym___write_only] = ACTIONS(1052),
    [anon_sym_read_write] = ACTIONS(1052),
    [anon_sym___read_write] = ACTIONS(1052),
    [anon_sym_extern] = ACTIONS(1052),
    [anon_sym___attribute__] = ACTIONS(1052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1054),
    [anon_sym___declspec] = ACTIONS(1052),
    [anon_sym___cdecl] = ACTIONS(1052),
    [anon_sym___clrcall] = ACTIONS(1052),
    [anon_sym___stdcall] = ACTIONS(1052),
    [anon_sym___fastcall] = ACTIONS(1052),
    [anon_sym___thiscall] = ACTIONS(1052),
    [anon_sym___vectorcall] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_auto] = ACTIONS(1052),
    [anon_sym_register] = ACTIONS(1052),
    [anon_sym_inline] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_volatile] = ACTIONS(1052),
    [anon_sym_restrict] = ACTIONS(1052),
    [anon_sym__Atomic] = ACTIONS(1052),
    [anon_sym_pipe] = ACTIONS(1052),
    [anon_sym_signed] = ACTIONS(1052),
    [anon_sym_unsigned] = ACTIONS(1052),
    [anon_sym_long] = ACTIONS(1052),
    [anon_sym_short] = ACTIONS(1052),
    [anon_sym_bool] = ACTIONS(1052),
    [anon_sym_char] = ACTIONS(1052),
    [anon_sym_uchar] = ACTIONS(1052),
    [anon_sym_ushort] = ACTIONS(1052),
    [anon_sym_int] = ACTIONS(1052),
    [anon_sym_uint] = ACTIONS(1052),
    [anon_sym_ulong] = ACTIONS(1052),
    [anon_sym_float] = ACTIONS(1052),
    [anon_sym_double] = ACTIONS(1052),
    [anon_sym_half] = ACTIONS(1052),
    [anon_sym_size_t] = ACTIONS(1052),
    [anon_sym_ptrdiff_t] = ACTIONS(1052),
    [anon_sym_intptr_t] = ACTIONS(1052),
    [anon_sym_uintptr_t] = ACTIONS(1052),
    [anon_sym_void] = ACTIONS(1052),
    [sym_vector_type] = ACTIONS(1052),
    [anon_sym_image2d_t] = ACTIONS(1052),
    [anon_sym_image3d_t] = ACTIONS(1052),
    [anon_sym_image2d_array_t] = ACTIONS(1052),
    [anon_sym_image1d_t] = ACTIONS(1052),
    [anon_sym_image1d_buffer_t] = ACTIONS(1052),
    [anon_sym_image1d_array_t] = ACTIONS(1052),
    [anon_sym_image2d_depth_t] = ACTIONS(1052),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1052),
    [anon_sym_sampler_t] = ACTIONS(1052),
    [anon_sym_queue_t] = ACTIONS(1052),
    [anon_sym_ndrange_t] = ACTIONS(1052),
    [anon_sym_clk_event_t] = ACTIONS(1052),
    [anon_sym_reserve_id_t] = ACTIONS(1052),
    [anon_sym_event_t] = ACTIONS(1052),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_struct] = ACTIONS(1052),
    [anon_sym_union] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_goto] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_sizeof] = ACTIONS(1052),
    [sym_number_literal] = ACTIONS(1054),
    [anon_sym_L_SQUOTE] = ACTIONS(1054),
    [anon_sym_u_SQUOTE] = ACTIONS(1054),
    [anon_sym_U_SQUOTE] = ACTIONS(1054),
    [anon_sym_u8_SQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [anon_sym_L_DQUOTE] = ACTIONS(1054),
    [anon_sym_u_DQUOTE] = ACTIONS(1054),
    [anon_sym_U_DQUOTE] = ACTIONS(1054),
    [anon_sym_u8_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_identifier] = ACTIONS(1064),
    [aux_sym_preproc_include_token1] = ACTIONS(1064),
    [aux_sym_preproc_def_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1064),
    [sym_preproc_directive] = ACTIONS(1064),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [anon_sym_typedef] = ACTIONS(1064),
    [anon_sym_kernel] = ACTIONS(1064),
    [anon_sym___kernel] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym___global] = ACTIONS(1064),
    [anon_sym_local] = ACTIONS(1064),
    [anon_sym___local] = ACTIONS(1064),
    [anon_sym_constant] = ACTIONS(1064),
    [anon_sym___constant] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym___private] = ACTIONS(1064),
    [anon_sym_generic] = ACTIONS(1064),
    [anon_sym___generic] = ACTIONS(1064),
    [anon_sym_read_only] = ACTIONS(1064),
    [anon_sym___read_only] = ACTIONS(1064),
    [anon_sym_write_only] = ACTIONS(1064),
    [anon_sym___write_only] = ACTIONS(1064),
    [anon_sym_read_write] = ACTIONS(1064),
    [anon_sym___read_write] = ACTIONS(1064),
    [anon_sym_extern] = ACTIONS(1064),
    [anon_sym___attribute__] = ACTIONS(1064),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1066),
    [anon_sym___declspec] = ACTIONS(1064),
    [anon_sym___cdecl] = ACTIONS(1064),
    [anon_sym___clrcall] = ACTIONS(1064),
    [anon_sym___stdcall] = ACTIONS(1064),
    [anon_sym___fastcall] = ACTIONS(1064),
    [anon_sym___thiscall] = ACTIONS(1064),
    [anon_sym___vectorcall] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_auto] = ACTIONS(1064),
    [anon_sym_register] = ACTIONS(1064),
    [anon_sym_inline] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_volatile] = ACTIONS(1064),
    [anon_sym_restrict] = ACTIONS(1064),
    [anon_sym__Atomic] = ACTIONS(1064),
    [anon_sym_pipe] = ACTIONS(1064),
    [anon_sym_signed] = ACTIONS(1064),
    [anon_sym_unsigned] = ACTIONS(1064),
    [anon_sym_long] = ACTIONS(1064),
    [anon_sym_short] = ACTIONS(1064),
    [anon_sym_bool] = ACTIONS(1064),
    [anon_sym_char] = ACTIONS(1064),
    [anon_sym_uchar] = ACTIONS(1064),
    [anon_sym_ushort] = ACTIONS(1064),
    [anon_sym_int] = ACTIONS(1064),
    [anon_sym_uint] = ACTIONS(1064),
    [anon_sym_ulong] = ACTIONS(1064),
    [anon_sym_float] = ACTIONS(1064),
    [anon_sym_double] = ACTIONS(1064),
    [anon_sym_half] = ACTIONS(1064),
    [anon_sym_size_t] = ACTIONS(1064),
    [anon_sym_ptrdiff_t] = ACTIONS(1064),
    [anon_sym_intptr_t] = ACTIONS(1064),
    [anon_sym_uintptr_t] = ACTIONS(1064),
    [anon_sym_void] = ACTIONS(1064),
    [sym_vector_type] = ACTIONS(1064),
    [anon_sym_image2d_t] = ACTIONS(1064),
    [anon_sym_image3d_t] = ACTIONS(1064),
    [anon_sym_image2d_array_t] = ACTIONS(1064),
    [anon_sym_image1d_t] = ACTIONS(1064),
    [anon_sym_image1d_buffer_t] = ACTIONS(1064),
    [anon_sym_image1d_array_t] = ACTIONS(1064),
    [anon_sym_image2d_depth_t] = ACTIONS(1064),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1064),
    [anon_sym_sampler_t] = ACTIONS(1064),
    [anon_sym_queue_t] = ACTIONS(1064),
    [anon_sym_ndrange_t] = ACTIONS(1064),
    [anon_sym_clk_event_t] = ACTIONS(1064),
    [anon_sym_reserve_id_t] = ACTIONS(1064),
    [anon_sym_event_t] = ACTIONS(1064),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_struct] = ACTIONS(1064),
    [anon_sym_union] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_goto] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1064),
    [sym_number_literal] = ACTIONS(1066),
    [anon_sym_L_SQUOTE] = ACTIONS(1066),
    [anon_sym_u_SQUOTE] = ACTIONS(1066),
    [anon_sym_U_SQUOTE] = ACTIONS(1066),
    [anon_sym_u8_SQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_L_DQUOTE] = ACTIONS(1066),
    [anon_sym_u_DQUOTE] = ACTIONS(1066),
    [anon_sym_U_DQUOTE] = ACTIONS(1066),
    [anon_sym_u8_DQUOTE] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym_identifier] = ACTIONS(1068),
    [aux_sym_preproc_include_token1] = ACTIONS(1068),
    [aux_sym_preproc_def_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1068),
    [sym_preproc_directive] = ACTIONS(1068),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_typedef] = ACTIONS(1068),
    [anon_sym_kernel] = ACTIONS(1068),
    [anon_sym___kernel] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym___global] = ACTIONS(1068),
    [anon_sym_local] = ACTIONS(1068),
    [anon_sym___local] = ACTIONS(1068),
    [anon_sym_constant] = ACTIONS(1068),
    [anon_sym___constant] = ACTIONS(1068),
    [anon_sym_private] = ACTIONS(1068),
    [anon_sym___private] = ACTIONS(1068),
    [anon_sym_generic] = ACTIONS(1068),
    [anon_sym___generic] = ACTIONS(1068),
    [anon_sym_read_only] = ACTIONS(1068),
    [anon_sym___read_only] = ACTIONS(1068),
    [anon_sym_write_only] = ACTIONS(1068),
    [anon_sym___write_only] = ACTIONS(1068),
    [anon_sym_read_write] = ACTIONS(1068),
    [anon_sym___read_write] = ACTIONS(1068),
    [anon_sym_extern] = ACTIONS(1068),
    [anon_sym___attribute__] = ACTIONS(1068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1070),
    [anon_sym___declspec] = ACTIONS(1068),
    [anon_sym___cdecl] = ACTIONS(1068),
    [anon_sym___clrcall] = ACTIONS(1068),
    [anon_sym___stdcall] = ACTIONS(1068),
    [anon_sym___fastcall] = ACTIONS(1068),
    [anon_sym___thiscall] = ACTIONS(1068),
    [anon_sym___vectorcall] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1068),
    [anon_sym_auto] = ACTIONS(1068),
    [anon_sym_register] = ACTIONS(1068),
    [anon_sym_inline] = ACTIONS(1068),
    [anon_sym_const] = ACTIONS(1068),
    [anon_sym_volatile] = ACTIONS(1068),
    [anon_sym_restrict] = ACTIONS(1068),
    [anon_sym__Atomic] = ACTIONS(1068),
    [anon_sym_pipe] = ACTIONS(1068),
    [anon_sym_signed] = ACTIONS(1068),
    [anon_sym_unsigned] = ACTIONS(1068),
    [anon_sym_long] = ACTIONS(1068),
    [anon_sym_short] = ACTIONS(1068),
    [anon_sym_bool] = ACTIONS(1068),
    [anon_sym_char] = ACTIONS(1068),
    [anon_sym_uchar] = ACTIONS(1068),
    [anon_sym_ushort] = ACTIONS(1068),
    [anon_sym_int] = ACTIONS(1068),
    [anon_sym_uint] = ACTIONS(1068),
    [anon_sym_ulong] = ACTIONS(1068),
    [anon_sym_float] = ACTIONS(1068),
    [anon_sym_double] = ACTIONS(1068),
    [anon_sym_half] = ACTIONS(1068),
    [anon_sym_size_t] = ACTIONS(1068),
    [anon_sym_ptrdiff_t] = ACTIONS(1068),
    [anon_sym_intptr_t] = ACTIONS(1068),
    [anon_sym_uintptr_t] = ACTIONS(1068),
    [anon_sym_void] = ACTIONS(1068),
    [sym_vector_type] = ACTIONS(1068),
    [anon_sym_image2d_t] = ACTIONS(1068),
    [anon_sym_image3d_t] = ACTIONS(1068),
    [anon_sym_image2d_array_t] = ACTIONS(1068),
    [anon_sym_image1d_t] = ACTIONS(1068),
    [anon_sym_image1d_buffer_t] = ACTIONS(1068),
    [anon_sym_image1d_array_t] = ACTIONS(1068),
    [anon_sym_image2d_depth_t] = ACTIONS(1068),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1068),
    [anon_sym_sampler_t] = ACTIONS(1068),
    [anon_sym_queue_t] = ACTIONS(1068),
    [anon_sym_ndrange_t] = ACTIONS(1068),
    [anon_sym_clk_event_t] = ACTIONS(1068),
    [anon_sym_reserve_id_t] = ACTIONS(1068),
    [anon_sym_event_t] = ACTIONS(1068),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1068),
    [anon_sym_enum] = ACTIONS(1068),
    [anon_sym_struct] = ACTIONS(1068),
    [anon_sym_union] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_case] = ACTIONS(1068),
    [anon_sym_default] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_do] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_goto] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_sizeof] = ACTIONS(1068),
    [sym_number_literal] = ACTIONS(1070),
    [anon_sym_L_SQUOTE] = ACTIONS(1070),
    [anon_sym_u_SQUOTE] = ACTIONS(1070),
    [anon_sym_U_SQUOTE] = ACTIONS(1070),
    [anon_sym_u8_SQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_L_DQUOTE] = ACTIONS(1070),
    [anon_sym_u_DQUOTE] = ACTIONS(1070),
    [anon_sym_U_DQUOTE] = ACTIONS(1070),
    [anon_sym_u8_DQUOTE] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_null] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym_identifier] = ACTIONS(1056),
    [aux_sym_preproc_include_token1] = ACTIONS(1056),
    [aux_sym_preproc_def_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1056),
    [sym_preproc_directive] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1058),
    [anon_sym_BANG] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_SEMI] = ACTIONS(1058),
    [anon_sym_typedef] = ACTIONS(1056),
    [anon_sym_kernel] = ACTIONS(1056),
    [anon_sym___kernel] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym___global] = ACTIONS(1056),
    [anon_sym_local] = ACTIONS(1056),
    [anon_sym___local] = ACTIONS(1056),
    [anon_sym_constant] = ACTIONS(1056),
    [anon_sym___constant] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym___private] = ACTIONS(1056),
    [anon_sym_generic] = ACTIONS(1056),
    [anon_sym___generic] = ACTIONS(1056),
    [anon_sym_read_only] = ACTIONS(1056),
    [anon_sym___read_only] = ACTIONS(1056),
    [anon_sym_write_only] = ACTIONS(1056),
    [anon_sym___write_only] = ACTIONS(1056),
    [anon_sym_read_write] = ACTIONS(1056),
    [anon_sym___read_write] = ACTIONS(1056),
    [anon_sym_extern] = ACTIONS(1056),
    [anon_sym___attribute__] = ACTIONS(1056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1058),
    [anon_sym___declspec] = ACTIONS(1056),
    [anon_sym___cdecl] = ACTIONS(1056),
    [anon_sym___clrcall] = ACTIONS(1056),
    [anon_sym___stdcall] = ACTIONS(1056),
    [anon_sym___fastcall] = ACTIONS(1056),
    [anon_sym___thiscall] = ACTIONS(1056),
    [anon_sym___vectorcall] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_RBRACE] = ACTIONS(1058),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_auto] = ACTIONS(1056),
    [anon_sym_register] = ACTIONS(1056),
    [anon_sym_inline] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_volatile] = ACTIONS(1056),
    [anon_sym_restrict] = ACTIONS(1056),
    [anon_sym__Atomic] = ACTIONS(1056),
    [anon_sym_pipe] = ACTIONS(1056),
    [anon_sym_signed] = ACTIONS(1056),
    [anon_sym_unsigned] = ACTIONS(1056),
    [anon_sym_long] = ACTIONS(1056),
    [anon_sym_short] = ACTIONS(1056),
    [anon_sym_bool] = ACTIONS(1056),
    [anon_sym_char] = ACTIONS(1056),
    [anon_sym_uchar] = ACTIONS(1056),
    [anon_sym_ushort] = ACTIONS(1056),
    [anon_sym_int] = ACTIONS(1056),
    [anon_sym_uint] = ACTIONS(1056),
    [anon_sym_ulong] = ACTIONS(1056),
    [anon_sym_float] = ACTIONS(1056),
    [anon_sym_double] = ACTIONS(1056),
    [anon_sym_half] = ACTIONS(1056),
    [anon_sym_size_t] = ACTIONS(1056),
    [anon_sym_ptrdiff_t] = ACTIONS(1056),
    [anon_sym_intptr_t] = ACTIONS(1056),
    [anon_sym_uintptr_t] = ACTIONS(1056),
    [anon_sym_void] = ACTIONS(1056),
    [sym_vector_type] = ACTIONS(1056),
    [anon_sym_image2d_t] = ACTIONS(1056),
    [anon_sym_image3d_t] = ACTIONS(1056),
    [anon_sym_image2d_array_t] = ACTIONS(1056),
    [anon_sym_image1d_t] = ACTIONS(1056),
    [anon_sym_image1d_buffer_t] = ACTIONS(1056),
    [anon_sym_image1d_array_t] = ACTIONS(1056),
    [anon_sym_image2d_depth_t] = ACTIONS(1056),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1056),
    [anon_sym_sampler_t] = ACTIONS(1056),
    [anon_sym_queue_t] = ACTIONS(1056),
    [anon_sym_ndrange_t] = ACTIONS(1056),
    [anon_sym_clk_event_t] = ACTIONS(1056),
    [anon_sym_reserve_id_t] = ACTIONS(1056),
    [anon_sym_event_t] = ACTIONS(1056),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_struct] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_goto] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1058),
    [anon_sym_PLUS_PLUS] = ACTIONS(1058),
    [anon_sym_sizeof] = ACTIONS(1056),
    [sym_number_literal] = ACTIONS(1058),
    [anon_sym_L_SQUOTE] = ACTIONS(1058),
    [anon_sym_u_SQUOTE] = ACTIONS(1058),
    [anon_sym_U_SQUOTE] = ACTIONS(1058),
    [anon_sym_u8_SQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [anon_sym_L_DQUOTE] = ACTIONS(1058),
    [anon_sym_u_DQUOTE] = ACTIONS(1058),
    [anon_sym_U_DQUOTE] = ACTIONS(1058),
    [anon_sym_u8_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_include_token1] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_typedef] = ACTIONS(1072),
    [anon_sym_kernel] = ACTIONS(1072),
    [anon_sym___kernel] = ACTIONS(1072),
    [anon_sym_global] = ACTIONS(1072),
    [anon_sym___global] = ACTIONS(1072),
    [anon_sym_local] = ACTIONS(1072),
    [anon_sym___local] = ACTIONS(1072),
    [anon_sym_constant] = ACTIONS(1072),
    [anon_sym___constant] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym___private] = ACTIONS(1072),
    [anon_sym_generic] = ACTIONS(1072),
    [anon_sym___generic] = ACTIONS(1072),
    [anon_sym_read_only] = ACTIONS(1072),
    [anon_sym___read_only] = ACTIONS(1072),
    [anon_sym_write_only] = ACTIONS(1072),
    [anon_sym___write_only] = ACTIONS(1072),
    [anon_sym_read_write] = ACTIONS(1072),
    [anon_sym___read_write] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1074),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym___cdecl] = ACTIONS(1072),
    [anon_sym___clrcall] = ACTIONS(1072),
    [anon_sym___stdcall] = ACTIONS(1072),
    [anon_sym___fastcall] = ACTIONS(1072),
    [anon_sym___thiscall] = ACTIONS(1072),
    [anon_sym___vectorcall] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_pipe] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [anon_sym_bool] = ACTIONS(1072),
    [anon_sym_char] = ACTIONS(1072),
    [anon_sym_uchar] = ACTIONS(1072),
    [anon_sym_ushort] = ACTIONS(1072),
    [anon_sym_int] = ACTIONS(1072),
    [anon_sym_uint] = ACTIONS(1072),
    [anon_sym_ulong] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1072),
    [anon_sym_double] = ACTIONS(1072),
    [anon_sym_half] = ACTIONS(1072),
    [anon_sym_size_t] = ACTIONS(1072),
    [anon_sym_ptrdiff_t] = ACTIONS(1072),
    [anon_sym_intptr_t] = ACTIONS(1072),
    [anon_sym_uintptr_t] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1072),
    [sym_vector_type] = ACTIONS(1072),
    [anon_sym_image2d_t] = ACTIONS(1072),
    [anon_sym_image3d_t] = ACTIONS(1072),
    [anon_sym_image2d_array_t] = ACTIONS(1072),
    [anon_sym_image1d_t] = ACTIONS(1072),
    [anon_sym_image1d_buffer_t] = ACTIONS(1072),
    [anon_sym_image1d_array_t] = ACTIONS(1072),
    [anon_sym_image2d_depth_t] = ACTIONS(1072),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1072),
    [anon_sym_sampler_t] = ACTIONS(1072),
    [anon_sym_queue_t] = ACTIONS(1072),
    [anon_sym_ndrange_t] = ACTIONS(1072),
    [anon_sym_clk_event_t] = ACTIONS(1072),
    [anon_sym_reserve_id_t] = ACTIONS(1072),
    [anon_sym_event_t] = ACTIONS(1072),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_goto] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_sizeof] = ACTIONS(1072),
    [sym_number_literal] = ACTIONS(1074),
    [anon_sym_L_SQUOTE] = ACTIONS(1074),
    [anon_sym_u_SQUOTE] = ACTIONS(1074),
    [anon_sym_U_SQUOTE] = ACTIONS(1074),
    [anon_sym_u8_SQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_L_DQUOTE] = ACTIONS(1074),
    [anon_sym_u_DQUOTE] = ACTIONS(1074),
    [anon_sym_U_DQUOTE] = ACTIONS(1074),
    [anon_sym_u8_DQUOTE] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_preproc_include_token1] = ACTIONS(1108),
    [aux_sym_preproc_def_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1108),
    [sym_preproc_directive] = ACTIONS(1108),
    [anon_sym_LPAREN2] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_typedef] = ACTIONS(1108),
    [anon_sym_kernel] = ACTIONS(1108),
    [anon_sym___kernel] = ACTIONS(1108),
    [anon_sym_global] = ACTIONS(1108),
    [anon_sym___global] = ACTIONS(1108),
    [anon_sym_local] = ACTIONS(1108),
    [anon_sym___local] = ACTIONS(1108),
    [anon_sym_constant] = ACTIONS(1108),
    [anon_sym___constant] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym___private] = ACTIONS(1108),
    [anon_sym_generic] = ACTIONS(1108),
    [anon_sym___generic] = ACTIONS(1108),
    [anon_sym_read_only] = ACTIONS(1108),
    [anon_sym___read_only] = ACTIONS(1108),
    [anon_sym_write_only] = ACTIONS(1108),
    [anon_sym___write_only] = ACTIONS(1108),
    [anon_sym_read_write] = ACTIONS(1108),
    [anon_sym___read_write] = ACTIONS(1108),
    [anon_sym_extern] = ACTIONS(1108),
    [anon_sym___attribute__] = ACTIONS(1108),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1110),
    [anon_sym___declspec] = ACTIONS(1108),
    [anon_sym___cdecl] = ACTIONS(1108),
    [anon_sym___clrcall] = ACTIONS(1108),
    [anon_sym___stdcall] = ACTIONS(1108),
    [anon_sym___fastcall] = ACTIONS(1108),
    [anon_sym___thiscall] = ACTIONS(1108),
    [anon_sym___vectorcall] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_auto] = ACTIONS(1108),
    [anon_sym_register] = ACTIONS(1108),
    [anon_sym_inline] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_volatile] = ACTIONS(1108),
    [anon_sym_restrict] = ACTIONS(1108),
    [anon_sym__Atomic] = ACTIONS(1108),
    [anon_sym_pipe] = ACTIONS(1108),
    [anon_sym_signed] = ACTIONS(1108),
    [anon_sym_unsigned] = ACTIONS(1108),
    [anon_sym_long] = ACTIONS(1108),
    [anon_sym_short] = ACTIONS(1108),
    [anon_sym_bool] = ACTIONS(1108),
    [anon_sym_char] = ACTIONS(1108),
    [anon_sym_uchar] = ACTIONS(1108),
    [anon_sym_ushort] = ACTIONS(1108),
    [anon_sym_int] = ACTIONS(1108),
    [anon_sym_uint] = ACTIONS(1108),
    [anon_sym_ulong] = ACTIONS(1108),
    [anon_sym_float] = ACTIONS(1108),
    [anon_sym_double] = ACTIONS(1108),
    [anon_sym_half] = ACTIONS(1108),
    [anon_sym_size_t] = ACTIONS(1108),
    [anon_sym_ptrdiff_t] = ACTIONS(1108),
    [anon_sym_intptr_t] = ACTIONS(1108),
    [anon_sym_uintptr_t] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1108),
    [sym_vector_type] = ACTIONS(1108),
    [anon_sym_image2d_t] = ACTIONS(1108),
    [anon_sym_image3d_t] = ACTIONS(1108),
    [anon_sym_image2d_array_t] = ACTIONS(1108),
    [anon_sym_image1d_t] = ACTIONS(1108),
    [anon_sym_image1d_buffer_t] = ACTIONS(1108),
    [anon_sym_image1d_array_t] = ACTIONS(1108),
    [anon_sym_image2d_depth_t] = ACTIONS(1108),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1108),
    [anon_sym_sampler_t] = ACTIONS(1108),
    [anon_sym_queue_t] = ACTIONS(1108),
    [anon_sym_ndrange_t] = ACTIONS(1108),
    [anon_sym_clk_event_t] = ACTIONS(1108),
    [anon_sym_reserve_id_t] = ACTIONS(1108),
    [anon_sym_event_t] = ACTIONS(1108),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [anon_sym_struct] = ACTIONS(1108),
    [anon_sym_union] = ACTIONS(1108),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_case] = ACTIONS(1108),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_while] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1108),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1108),
    [anon_sym_goto] = ACTIONS(1108),
    [anon_sym_DASH_DASH] = ACTIONS(1110),
    [anon_sym_PLUS_PLUS] = ACTIONS(1110),
    [anon_sym_sizeof] = ACTIONS(1108),
    [sym_number_literal] = ACTIONS(1110),
    [anon_sym_L_SQUOTE] = ACTIONS(1110),
    [anon_sym_u_SQUOTE] = ACTIONS(1110),
    [anon_sym_U_SQUOTE] = ACTIONS(1110),
    [anon_sym_u8_SQUOTE] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1108),
    [sym_false] = ACTIONS(1108),
    [sym_null] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [ts_builtin_sym_end] = ACTIONS(1122),
    [sym_identifier] = ACTIONS(1120),
    [aux_sym_preproc_include_token1] = ACTIONS(1120),
    [aux_sym_preproc_def_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1120),
    [sym_preproc_directive] = ACTIONS(1120),
    [anon_sym_LPAREN2] = ACTIONS(1122),
    [anon_sym_BANG] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1122),
    [anon_sym_AMP] = ACTIONS(1122),
    [anon_sym_SEMI] = ACTIONS(1122),
    [anon_sym_typedef] = ACTIONS(1120),
    [anon_sym_kernel] = ACTIONS(1120),
    [anon_sym___kernel] = ACTIONS(1120),
    [anon_sym_global] = ACTIONS(1120),
    [anon_sym___global] = ACTIONS(1120),
    [anon_sym_local] = ACTIONS(1120),
    [anon_sym___local] = ACTIONS(1120),
    [anon_sym_constant] = ACTIONS(1120),
    [anon_sym___constant] = ACTIONS(1120),
    [anon_sym_private] = ACTIONS(1120),
    [anon_sym___private] = ACTIONS(1120),
    [anon_sym_generic] = ACTIONS(1120),
    [anon_sym___generic] = ACTIONS(1120),
    [anon_sym_read_only] = ACTIONS(1120),
    [anon_sym___read_only] = ACTIONS(1120),
    [anon_sym_write_only] = ACTIONS(1120),
    [anon_sym___write_only] = ACTIONS(1120),
    [anon_sym_read_write] = ACTIONS(1120),
    [anon_sym___read_write] = ACTIONS(1120),
    [anon_sym_extern] = ACTIONS(1120),
    [anon_sym___attribute__] = ACTIONS(1120),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1122),
    [anon_sym___declspec] = ACTIONS(1120),
    [anon_sym___cdecl] = ACTIONS(1120),
    [anon_sym___clrcall] = ACTIONS(1120),
    [anon_sym___stdcall] = ACTIONS(1120),
    [anon_sym___fastcall] = ACTIONS(1120),
    [anon_sym___thiscall] = ACTIONS(1120),
    [anon_sym___vectorcall] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_static] = ACTIONS(1120),
    [anon_sym_auto] = ACTIONS(1120),
    [anon_sym_register] = ACTIONS(1120),
    [anon_sym_inline] = ACTIONS(1120),
    [anon_sym_const] = ACTIONS(1120),
    [anon_sym_volatile] = ACTIONS(1120),
    [anon_sym_restrict] = ACTIONS(1120),
    [anon_sym__Atomic] = ACTIONS(1120),
    [anon_sym_pipe] = ACTIONS(1120),
    [anon_sym_signed] = ACTIONS(1120),
    [anon_sym_unsigned] = ACTIONS(1120),
    [anon_sym_long] = ACTIONS(1120),
    [anon_sym_short] = ACTIONS(1120),
    [anon_sym_bool] = ACTIONS(1120),
    [anon_sym_char] = ACTIONS(1120),
    [anon_sym_uchar] = ACTIONS(1120),
    [anon_sym_ushort] = ACTIONS(1120),
    [anon_sym_int] = ACTIONS(1120),
    [anon_sym_uint] = ACTIONS(1120),
    [anon_sym_ulong] = ACTIONS(1120),
    [anon_sym_float] = ACTIONS(1120),
    [anon_sym_double] = ACTIONS(1120),
    [anon_sym_half] = ACTIONS(1120),
    [anon_sym_size_t] = ACTIONS(1120),
    [anon_sym_ptrdiff_t] = ACTIONS(1120),
    [anon_sym_intptr_t] = ACTIONS(1120),
    [anon_sym_uintptr_t] = ACTIONS(1120),
    [anon_sym_void] = ACTIONS(1120),
    [sym_vector_type] = ACTIONS(1120),
    [anon_sym_image2d_t] = ACTIONS(1120),
    [anon_sym_image3d_t] = ACTIONS(1120),
    [anon_sym_image2d_array_t] = ACTIONS(1120),
    [anon_sym_image1d_t] = ACTIONS(1120),
    [anon_sym_image1d_buffer_t] = ACTIONS(1120),
    [anon_sym_image1d_array_t] = ACTIONS(1120),
    [anon_sym_image2d_depth_t] = ACTIONS(1120),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1120),
    [anon_sym_sampler_t] = ACTIONS(1120),
    [anon_sym_queue_t] = ACTIONS(1120),
    [anon_sym_ndrange_t] = ACTIONS(1120),
    [anon_sym_clk_event_t] = ACTIONS(1120),
    [anon_sym_reserve_id_t] = ACTIONS(1120),
    [anon_sym_event_t] = ACTIONS(1120),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1120),
    [anon_sym_enum] = ACTIONS(1120),
    [anon_sym_struct] = ACTIONS(1120),
    [anon_sym_union] = ACTIONS(1120),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(1120),
    [anon_sym_case] = ACTIONS(1120),
    [anon_sym_default] = ACTIONS(1120),
    [anon_sym_while] = ACTIONS(1120),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_for] = ACTIONS(1120),
    [anon_sym_return] = ACTIONS(1120),
    [anon_sym_break] = ACTIONS(1120),
    [anon_sym_continue] = ACTIONS(1120),
    [anon_sym_goto] = ACTIONS(1120),
    [anon_sym_DASH_DASH] = ACTIONS(1122),
    [anon_sym_PLUS_PLUS] = ACTIONS(1122),
    [anon_sym_sizeof] = ACTIONS(1120),
    [sym_number_literal] = ACTIONS(1122),
    [anon_sym_L_SQUOTE] = ACTIONS(1122),
    [anon_sym_u_SQUOTE] = ACTIONS(1122),
    [anon_sym_U_SQUOTE] = ACTIONS(1122),
    [anon_sym_u8_SQUOTE] = ACTIONS(1122),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [anon_sym_L_DQUOTE] = ACTIONS(1122),
    [anon_sym_u_DQUOTE] = ACTIONS(1122),
    [anon_sym_U_DQUOTE] = ACTIONS(1122),
    [anon_sym_u8_DQUOTE] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [sym_true] = ACTIONS(1120),
    [sym_false] = ACTIONS(1120),
    [sym_null] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_identifier] = ACTIONS(1116),
    [aux_sym_preproc_include_token1] = ACTIONS(1116),
    [aux_sym_preproc_def_token1] = ACTIONS(1116),
    [aux_sym_preproc_if_token1] = ACTIONS(1116),
    [aux_sym_preproc_if_token2] = ACTIONS(1116),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1116),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1116),
    [sym_preproc_directive] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(1118),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1118),
    [anon_sym_AMP] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1118),
    [anon_sym_typedef] = ACTIONS(1116),
    [anon_sym_kernel] = ACTIONS(1116),
    [anon_sym___kernel] = ACTIONS(1116),
    [anon_sym_global] = ACTIONS(1116),
    [anon_sym___global] = ACTIONS(1116),
    [anon_sym_local] = ACTIONS(1116),
    [anon_sym___local] = ACTIONS(1116),
    [anon_sym_constant] = ACTIONS(1116),
    [anon_sym___constant] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym___private] = ACTIONS(1116),
    [anon_sym_generic] = ACTIONS(1116),
    [anon_sym___generic] = ACTIONS(1116),
    [anon_sym_read_only] = ACTIONS(1116),
    [anon_sym___read_only] = ACTIONS(1116),
    [anon_sym_write_only] = ACTIONS(1116),
    [anon_sym___write_only] = ACTIONS(1116),
    [anon_sym_read_write] = ACTIONS(1116),
    [anon_sym___read_write] = ACTIONS(1116),
    [anon_sym_extern] = ACTIONS(1116),
    [anon_sym___attribute__] = ACTIONS(1116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1118),
    [anon_sym___declspec] = ACTIONS(1116),
    [anon_sym___cdecl] = ACTIONS(1116),
    [anon_sym___clrcall] = ACTIONS(1116),
    [anon_sym___stdcall] = ACTIONS(1116),
    [anon_sym___fastcall] = ACTIONS(1116),
    [anon_sym___thiscall] = ACTIONS(1116),
    [anon_sym___vectorcall] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_auto] = ACTIONS(1116),
    [anon_sym_register] = ACTIONS(1116),
    [anon_sym_inline] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_volatile] = ACTIONS(1116),
    [anon_sym_restrict] = ACTIONS(1116),
    [anon_sym__Atomic] = ACTIONS(1116),
    [anon_sym_pipe] = ACTIONS(1116),
    [anon_sym_signed] = ACTIONS(1116),
    [anon_sym_unsigned] = ACTIONS(1116),
    [anon_sym_long] = ACTIONS(1116),
    [anon_sym_short] = ACTIONS(1116),
    [anon_sym_bool] = ACTIONS(1116),
    [anon_sym_char] = ACTIONS(1116),
    [anon_sym_uchar] = ACTIONS(1116),
    [anon_sym_ushort] = ACTIONS(1116),
    [anon_sym_int] = ACTIONS(1116),
    [anon_sym_uint] = ACTIONS(1116),
    [anon_sym_ulong] = ACTIONS(1116),
    [anon_sym_float] = ACTIONS(1116),
    [anon_sym_double] = ACTIONS(1116),
    [anon_sym_half] = ACTIONS(1116),
    [anon_sym_size_t] = ACTIONS(1116),
    [anon_sym_ptrdiff_t] = ACTIONS(1116),
    [anon_sym_intptr_t] = ACTIONS(1116),
    [anon_sym_uintptr_t] = ACTIONS(1116),
    [anon_sym_void] = ACTIONS(1116),
    [sym_vector_type] = ACTIONS(1116),
    [anon_sym_image2d_t] = ACTIONS(1116),
    [anon_sym_image3d_t] = ACTIONS(1116),
    [anon_sym_image2d_array_t] = ACTIONS(1116),
    [anon_sym_image1d_t] = ACTIONS(1116),
    [anon_sym_image1d_buffer_t] = ACTIONS(1116),
    [anon_sym_image1d_array_t] = ACTIONS(1116),
    [anon_sym_image2d_depth_t] = ACTIONS(1116),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1116),
    [anon_sym_sampler_t] = ACTIONS(1116),
    [anon_sym_queue_t] = ACTIONS(1116),
    [anon_sym_ndrange_t] = ACTIONS(1116),
    [anon_sym_clk_event_t] = ACTIONS(1116),
    [anon_sym_reserve_id_t] = ACTIONS(1116),
    [anon_sym_event_t] = ACTIONS(1116),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_struct] = ACTIONS(1116),
    [anon_sym_union] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_goto] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1118),
    [anon_sym_PLUS_PLUS] = ACTIONS(1118),
    [anon_sym_sizeof] = ACTIONS(1116),
    [sym_number_literal] = ACTIONS(1118),
    [anon_sym_L_SQUOTE] = ACTIONS(1118),
    [anon_sym_u_SQUOTE] = ACTIONS(1118),
    [anon_sym_U_SQUOTE] = ACTIONS(1118),
    [anon_sym_u8_SQUOTE] = ACTIONS(1118),
    [anon_sym_SQUOTE] = ACTIONS(1118),
    [anon_sym_L_DQUOTE] = ACTIONS(1118),
    [anon_sym_u_DQUOTE] = ACTIONS(1118),
    [anon_sym_U_DQUOTE] = ACTIONS(1118),
    [anon_sym_u8_DQUOTE] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1118),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym_identifier] = ACTIONS(1116),
    [aux_sym_preproc_include_token1] = ACTIONS(1116),
    [aux_sym_preproc_def_token1] = ACTIONS(1116),
    [aux_sym_preproc_if_token1] = ACTIONS(1116),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1116),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1116),
    [sym_preproc_directive] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(1118),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1118),
    [anon_sym_AMP] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1118),
    [anon_sym_typedef] = ACTIONS(1116),
    [anon_sym_kernel] = ACTIONS(1116),
    [anon_sym___kernel] = ACTIONS(1116),
    [anon_sym_global] = ACTIONS(1116),
    [anon_sym___global] = ACTIONS(1116),
    [anon_sym_local] = ACTIONS(1116),
    [anon_sym___local] = ACTIONS(1116),
    [anon_sym_constant] = ACTIONS(1116),
    [anon_sym___constant] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym___private] = ACTIONS(1116),
    [anon_sym_generic] = ACTIONS(1116),
    [anon_sym___generic] = ACTIONS(1116),
    [anon_sym_read_only] = ACTIONS(1116),
    [anon_sym___read_only] = ACTIONS(1116),
    [anon_sym_write_only] = ACTIONS(1116),
    [anon_sym___write_only] = ACTIONS(1116),
    [anon_sym_read_write] = ACTIONS(1116),
    [anon_sym___read_write] = ACTIONS(1116),
    [anon_sym_extern] = ACTIONS(1116),
    [anon_sym___attribute__] = ACTIONS(1116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1118),
    [anon_sym___declspec] = ACTIONS(1116),
    [anon_sym___cdecl] = ACTIONS(1116),
    [anon_sym___clrcall] = ACTIONS(1116),
    [anon_sym___stdcall] = ACTIONS(1116),
    [anon_sym___fastcall] = ACTIONS(1116),
    [anon_sym___thiscall] = ACTIONS(1116),
    [anon_sym___vectorcall] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_RBRACE] = ACTIONS(1118),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_auto] = ACTIONS(1116),
    [anon_sym_register] = ACTIONS(1116),
    [anon_sym_inline] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_volatile] = ACTIONS(1116),
    [anon_sym_restrict] = ACTIONS(1116),
    [anon_sym__Atomic] = ACTIONS(1116),
    [anon_sym_pipe] = ACTIONS(1116),
    [anon_sym_signed] = ACTIONS(1116),
    [anon_sym_unsigned] = ACTIONS(1116),
    [anon_sym_long] = ACTIONS(1116),
    [anon_sym_short] = ACTIONS(1116),
    [anon_sym_bool] = ACTIONS(1116),
    [anon_sym_char] = ACTIONS(1116),
    [anon_sym_uchar] = ACTIONS(1116),
    [anon_sym_ushort] = ACTIONS(1116),
    [anon_sym_int] = ACTIONS(1116),
    [anon_sym_uint] = ACTIONS(1116),
    [anon_sym_ulong] = ACTIONS(1116),
    [anon_sym_float] = ACTIONS(1116),
    [anon_sym_double] = ACTIONS(1116),
    [anon_sym_half] = ACTIONS(1116),
    [anon_sym_size_t] = ACTIONS(1116),
    [anon_sym_ptrdiff_t] = ACTIONS(1116),
    [anon_sym_intptr_t] = ACTIONS(1116),
    [anon_sym_uintptr_t] = ACTIONS(1116),
    [anon_sym_void] = ACTIONS(1116),
    [sym_vector_type] = ACTIONS(1116),
    [anon_sym_image2d_t] = ACTIONS(1116),
    [anon_sym_image3d_t] = ACTIONS(1116),
    [anon_sym_image2d_array_t] = ACTIONS(1116),
    [anon_sym_image1d_t] = ACTIONS(1116),
    [anon_sym_image1d_buffer_t] = ACTIONS(1116),
    [anon_sym_image1d_array_t] = ACTIONS(1116),
    [anon_sym_image2d_depth_t] = ACTIONS(1116),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1116),
    [anon_sym_sampler_t] = ACTIONS(1116),
    [anon_sym_queue_t] = ACTIONS(1116),
    [anon_sym_ndrange_t] = ACTIONS(1116),
    [anon_sym_clk_event_t] = ACTIONS(1116),
    [anon_sym_reserve_id_t] = ACTIONS(1116),
    [anon_sym_event_t] = ACTIONS(1116),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_struct] = ACTIONS(1116),
    [anon_sym_union] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_goto] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1118),
    [anon_sym_PLUS_PLUS] = ACTIONS(1118),
    [anon_sym_sizeof] = ACTIONS(1116),
    [sym_number_literal] = ACTIONS(1118),
    [anon_sym_L_SQUOTE] = ACTIONS(1118),
    [anon_sym_u_SQUOTE] = ACTIONS(1118),
    [anon_sym_U_SQUOTE] = ACTIONS(1118),
    [anon_sym_u8_SQUOTE] = ACTIONS(1118),
    [anon_sym_SQUOTE] = ACTIONS(1118),
    [anon_sym_L_DQUOTE] = ACTIONS(1118),
    [anon_sym_u_DQUOTE] = ACTIONS(1118),
    [anon_sym_U_DQUOTE] = ACTIONS(1118),
    [anon_sym_u8_DQUOTE] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1118),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym_identifier] = ACTIONS(1056),
    [aux_sym_preproc_include_token1] = ACTIONS(1056),
    [aux_sym_preproc_def_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token2] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1056),
    [sym_preproc_directive] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1058),
    [anon_sym_BANG] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_SEMI] = ACTIONS(1058),
    [anon_sym_typedef] = ACTIONS(1056),
    [anon_sym_kernel] = ACTIONS(1056),
    [anon_sym___kernel] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym___global] = ACTIONS(1056),
    [anon_sym_local] = ACTIONS(1056),
    [anon_sym___local] = ACTIONS(1056),
    [anon_sym_constant] = ACTIONS(1056),
    [anon_sym___constant] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym___private] = ACTIONS(1056),
    [anon_sym_generic] = ACTIONS(1056),
    [anon_sym___generic] = ACTIONS(1056),
    [anon_sym_read_only] = ACTIONS(1056),
    [anon_sym___read_only] = ACTIONS(1056),
    [anon_sym_write_only] = ACTIONS(1056),
    [anon_sym___write_only] = ACTIONS(1056),
    [anon_sym_read_write] = ACTIONS(1056),
    [anon_sym___read_write] = ACTIONS(1056),
    [anon_sym_extern] = ACTIONS(1056),
    [anon_sym___attribute__] = ACTIONS(1056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1058),
    [anon_sym___declspec] = ACTIONS(1056),
    [anon_sym___cdecl] = ACTIONS(1056),
    [anon_sym___clrcall] = ACTIONS(1056),
    [anon_sym___stdcall] = ACTIONS(1056),
    [anon_sym___fastcall] = ACTIONS(1056),
    [anon_sym___thiscall] = ACTIONS(1056),
    [anon_sym___vectorcall] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_auto] = ACTIONS(1056),
    [anon_sym_register] = ACTIONS(1056),
    [anon_sym_inline] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_volatile] = ACTIONS(1056),
    [anon_sym_restrict] = ACTIONS(1056),
    [anon_sym__Atomic] = ACTIONS(1056),
    [anon_sym_pipe] = ACTIONS(1056),
    [anon_sym_signed] = ACTIONS(1056),
    [anon_sym_unsigned] = ACTIONS(1056),
    [anon_sym_long] = ACTIONS(1056),
    [anon_sym_short] = ACTIONS(1056),
    [anon_sym_bool] = ACTIONS(1056),
    [anon_sym_char] = ACTIONS(1056),
    [anon_sym_uchar] = ACTIONS(1056),
    [anon_sym_ushort] = ACTIONS(1056),
    [anon_sym_int] = ACTIONS(1056),
    [anon_sym_uint] = ACTIONS(1056),
    [anon_sym_ulong] = ACTIONS(1056),
    [anon_sym_float] = ACTIONS(1056),
    [anon_sym_double] = ACTIONS(1056),
    [anon_sym_half] = ACTIONS(1056),
    [anon_sym_size_t] = ACTIONS(1056),
    [anon_sym_ptrdiff_t] = ACTIONS(1056),
    [anon_sym_intptr_t] = ACTIONS(1056),
    [anon_sym_uintptr_t] = ACTIONS(1056),
    [anon_sym_void] = ACTIONS(1056),
    [sym_vector_type] = ACTIONS(1056),
    [anon_sym_image2d_t] = ACTIONS(1056),
    [anon_sym_image3d_t] = ACTIONS(1056),
    [anon_sym_image2d_array_t] = ACTIONS(1056),
    [anon_sym_image1d_t] = ACTIONS(1056),
    [anon_sym_image1d_buffer_t] = ACTIONS(1056),
    [anon_sym_image1d_array_t] = ACTIONS(1056),
    [anon_sym_image2d_depth_t] = ACTIONS(1056),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1056),
    [anon_sym_sampler_t] = ACTIONS(1056),
    [anon_sym_queue_t] = ACTIONS(1056),
    [anon_sym_ndrange_t] = ACTIONS(1056),
    [anon_sym_clk_event_t] = ACTIONS(1056),
    [anon_sym_reserve_id_t] = ACTIONS(1056),
    [anon_sym_event_t] = ACTIONS(1056),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_struct] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_goto] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1058),
    [anon_sym_PLUS_PLUS] = ACTIONS(1058),
    [anon_sym_sizeof] = ACTIONS(1056),
    [sym_number_literal] = ACTIONS(1058),
    [anon_sym_L_SQUOTE] = ACTIONS(1058),
    [anon_sym_u_SQUOTE] = ACTIONS(1058),
    [anon_sym_U_SQUOTE] = ACTIONS(1058),
    [anon_sym_u8_SQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [anon_sym_L_DQUOTE] = ACTIONS(1058),
    [anon_sym_u_DQUOTE] = ACTIONS(1058),
    [anon_sym_U_DQUOTE] = ACTIONS(1058),
    [anon_sym_u8_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_identifier] = ACTIONS(1060),
    [aux_sym_preproc_include_token1] = ACTIONS(1060),
    [aux_sym_preproc_def_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token2] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1060),
    [sym_preproc_directive] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_typedef] = ACTIONS(1060),
    [anon_sym_kernel] = ACTIONS(1060),
    [anon_sym___kernel] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym___global] = ACTIONS(1060),
    [anon_sym_local] = ACTIONS(1060),
    [anon_sym___local] = ACTIONS(1060),
    [anon_sym_constant] = ACTIONS(1060),
    [anon_sym___constant] = ACTIONS(1060),
    [anon_sym_private] = ACTIONS(1060),
    [anon_sym___private] = ACTIONS(1060),
    [anon_sym_generic] = ACTIONS(1060),
    [anon_sym___generic] = ACTIONS(1060),
    [anon_sym_read_only] = ACTIONS(1060),
    [anon_sym___read_only] = ACTIONS(1060),
    [anon_sym_write_only] = ACTIONS(1060),
    [anon_sym___write_only] = ACTIONS(1060),
    [anon_sym_read_write] = ACTIONS(1060),
    [anon_sym___read_write] = ACTIONS(1060),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym___attribute__] = ACTIONS(1060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1062),
    [anon_sym___declspec] = ACTIONS(1060),
    [anon_sym___cdecl] = ACTIONS(1060),
    [anon_sym___clrcall] = ACTIONS(1060),
    [anon_sym___stdcall] = ACTIONS(1060),
    [anon_sym___fastcall] = ACTIONS(1060),
    [anon_sym___thiscall] = ACTIONS(1060),
    [anon_sym___vectorcall] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1060),
    [anon_sym_auto] = ACTIONS(1060),
    [anon_sym_register] = ACTIONS(1060),
    [anon_sym_inline] = ACTIONS(1060),
    [anon_sym_const] = ACTIONS(1060),
    [anon_sym_volatile] = ACTIONS(1060),
    [anon_sym_restrict] = ACTIONS(1060),
    [anon_sym__Atomic] = ACTIONS(1060),
    [anon_sym_pipe] = ACTIONS(1060),
    [anon_sym_signed] = ACTIONS(1060),
    [anon_sym_unsigned] = ACTIONS(1060),
    [anon_sym_long] = ACTIONS(1060),
    [anon_sym_short] = ACTIONS(1060),
    [anon_sym_bool] = ACTIONS(1060),
    [anon_sym_char] = ACTIONS(1060),
    [anon_sym_uchar] = ACTIONS(1060),
    [anon_sym_ushort] = ACTIONS(1060),
    [anon_sym_int] = ACTIONS(1060),
    [anon_sym_uint] = ACTIONS(1060),
    [anon_sym_ulong] = ACTIONS(1060),
    [anon_sym_float] = ACTIONS(1060),
    [anon_sym_double] = ACTIONS(1060),
    [anon_sym_half] = ACTIONS(1060),
    [anon_sym_size_t] = ACTIONS(1060),
    [anon_sym_ptrdiff_t] = ACTIONS(1060),
    [anon_sym_intptr_t] = ACTIONS(1060),
    [anon_sym_uintptr_t] = ACTIONS(1060),
    [anon_sym_void] = ACTIONS(1060),
    [sym_vector_type] = ACTIONS(1060),
    [anon_sym_image2d_t] = ACTIONS(1060),
    [anon_sym_image3d_t] = ACTIONS(1060),
    [anon_sym_image2d_array_t] = ACTIONS(1060),
    [anon_sym_image1d_t] = ACTIONS(1060),
    [anon_sym_image1d_buffer_t] = ACTIONS(1060),
    [anon_sym_image1d_array_t] = ACTIONS(1060),
    [anon_sym_image2d_depth_t] = ACTIONS(1060),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1060),
    [anon_sym_sampler_t] = ACTIONS(1060),
    [anon_sym_queue_t] = ACTIONS(1060),
    [anon_sym_ndrange_t] = ACTIONS(1060),
    [anon_sym_clk_event_t] = ACTIONS(1060),
    [anon_sym_reserve_id_t] = ACTIONS(1060),
    [anon_sym_event_t] = ACTIONS(1060),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1060),
    [anon_sym_enum] = ACTIONS(1060),
    [anon_sym_struct] = ACTIONS(1060),
    [anon_sym_union] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_switch] = ACTIONS(1060),
    [anon_sym_case] = ACTIONS(1060),
    [anon_sym_default] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_goto] = ACTIONS(1060),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_sizeof] = ACTIONS(1060),
    [sym_number_literal] = ACTIONS(1062),
    [anon_sym_L_SQUOTE] = ACTIONS(1062),
    [anon_sym_u_SQUOTE] = ACTIONS(1062),
    [anon_sym_U_SQUOTE] = ACTIONS(1062),
    [anon_sym_u8_SQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [anon_sym_L_DQUOTE] = ACTIONS(1062),
    [anon_sym_u_DQUOTE] = ACTIONS(1062),
    [anon_sym_U_DQUOTE] = ACTIONS(1062),
    [anon_sym_u8_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_null] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_identifier] = ACTIONS(1064),
    [aux_sym_preproc_include_token1] = ACTIONS(1064),
    [aux_sym_preproc_def_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token2] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1064),
    [sym_preproc_directive] = ACTIONS(1064),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [anon_sym_typedef] = ACTIONS(1064),
    [anon_sym_kernel] = ACTIONS(1064),
    [anon_sym___kernel] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym___global] = ACTIONS(1064),
    [anon_sym_local] = ACTIONS(1064),
    [anon_sym___local] = ACTIONS(1064),
    [anon_sym_constant] = ACTIONS(1064),
    [anon_sym___constant] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym___private] = ACTIONS(1064),
    [anon_sym_generic] = ACTIONS(1064),
    [anon_sym___generic] = ACTIONS(1064),
    [anon_sym_read_only] = ACTIONS(1064),
    [anon_sym___read_only] = ACTIONS(1064),
    [anon_sym_write_only] = ACTIONS(1064),
    [anon_sym___write_only] = ACTIONS(1064),
    [anon_sym_read_write] = ACTIONS(1064),
    [anon_sym___read_write] = ACTIONS(1064),
    [anon_sym_extern] = ACTIONS(1064),
    [anon_sym___attribute__] = ACTIONS(1064),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1066),
    [anon_sym___declspec] = ACTIONS(1064),
    [anon_sym___cdecl] = ACTIONS(1064),
    [anon_sym___clrcall] = ACTIONS(1064),
    [anon_sym___stdcall] = ACTIONS(1064),
    [anon_sym___fastcall] = ACTIONS(1064),
    [anon_sym___thiscall] = ACTIONS(1064),
    [anon_sym___vectorcall] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_auto] = ACTIONS(1064),
    [anon_sym_register] = ACTIONS(1064),
    [anon_sym_inline] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_volatile] = ACTIONS(1064),
    [anon_sym_restrict] = ACTIONS(1064),
    [anon_sym__Atomic] = ACTIONS(1064),
    [anon_sym_pipe] = ACTIONS(1064),
    [anon_sym_signed] = ACTIONS(1064),
    [anon_sym_unsigned] = ACTIONS(1064),
    [anon_sym_long] = ACTIONS(1064),
    [anon_sym_short] = ACTIONS(1064),
    [anon_sym_bool] = ACTIONS(1064),
    [anon_sym_char] = ACTIONS(1064),
    [anon_sym_uchar] = ACTIONS(1064),
    [anon_sym_ushort] = ACTIONS(1064),
    [anon_sym_int] = ACTIONS(1064),
    [anon_sym_uint] = ACTIONS(1064),
    [anon_sym_ulong] = ACTIONS(1064),
    [anon_sym_float] = ACTIONS(1064),
    [anon_sym_double] = ACTIONS(1064),
    [anon_sym_half] = ACTIONS(1064),
    [anon_sym_size_t] = ACTIONS(1064),
    [anon_sym_ptrdiff_t] = ACTIONS(1064),
    [anon_sym_intptr_t] = ACTIONS(1064),
    [anon_sym_uintptr_t] = ACTIONS(1064),
    [anon_sym_void] = ACTIONS(1064),
    [sym_vector_type] = ACTIONS(1064),
    [anon_sym_image2d_t] = ACTIONS(1064),
    [anon_sym_image3d_t] = ACTIONS(1064),
    [anon_sym_image2d_array_t] = ACTIONS(1064),
    [anon_sym_image1d_t] = ACTIONS(1064),
    [anon_sym_image1d_buffer_t] = ACTIONS(1064),
    [anon_sym_image1d_array_t] = ACTIONS(1064),
    [anon_sym_image2d_depth_t] = ACTIONS(1064),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1064),
    [anon_sym_sampler_t] = ACTIONS(1064),
    [anon_sym_queue_t] = ACTIONS(1064),
    [anon_sym_ndrange_t] = ACTIONS(1064),
    [anon_sym_clk_event_t] = ACTIONS(1064),
    [anon_sym_reserve_id_t] = ACTIONS(1064),
    [anon_sym_event_t] = ACTIONS(1064),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_struct] = ACTIONS(1064),
    [anon_sym_union] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_goto] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1064),
    [sym_number_literal] = ACTIONS(1066),
    [anon_sym_L_SQUOTE] = ACTIONS(1066),
    [anon_sym_u_SQUOTE] = ACTIONS(1066),
    [anon_sym_U_SQUOTE] = ACTIONS(1066),
    [anon_sym_u8_SQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_L_DQUOTE] = ACTIONS(1066),
    [anon_sym_u_DQUOTE] = ACTIONS(1066),
    [anon_sym_U_DQUOTE] = ACTIONS(1066),
    [anon_sym_u8_DQUOTE] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym_identifier] = ACTIONS(1068),
    [aux_sym_preproc_include_token1] = ACTIONS(1068),
    [aux_sym_preproc_def_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token2] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1068),
    [sym_preproc_directive] = ACTIONS(1068),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_typedef] = ACTIONS(1068),
    [anon_sym_kernel] = ACTIONS(1068),
    [anon_sym___kernel] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym___global] = ACTIONS(1068),
    [anon_sym_local] = ACTIONS(1068),
    [anon_sym___local] = ACTIONS(1068),
    [anon_sym_constant] = ACTIONS(1068),
    [anon_sym___constant] = ACTIONS(1068),
    [anon_sym_private] = ACTIONS(1068),
    [anon_sym___private] = ACTIONS(1068),
    [anon_sym_generic] = ACTIONS(1068),
    [anon_sym___generic] = ACTIONS(1068),
    [anon_sym_read_only] = ACTIONS(1068),
    [anon_sym___read_only] = ACTIONS(1068),
    [anon_sym_write_only] = ACTIONS(1068),
    [anon_sym___write_only] = ACTIONS(1068),
    [anon_sym_read_write] = ACTIONS(1068),
    [anon_sym___read_write] = ACTIONS(1068),
    [anon_sym_extern] = ACTIONS(1068),
    [anon_sym___attribute__] = ACTIONS(1068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1070),
    [anon_sym___declspec] = ACTIONS(1068),
    [anon_sym___cdecl] = ACTIONS(1068),
    [anon_sym___clrcall] = ACTIONS(1068),
    [anon_sym___stdcall] = ACTIONS(1068),
    [anon_sym___fastcall] = ACTIONS(1068),
    [anon_sym___thiscall] = ACTIONS(1068),
    [anon_sym___vectorcall] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1068),
    [anon_sym_auto] = ACTIONS(1068),
    [anon_sym_register] = ACTIONS(1068),
    [anon_sym_inline] = ACTIONS(1068),
    [anon_sym_const] = ACTIONS(1068),
    [anon_sym_volatile] = ACTIONS(1068),
    [anon_sym_restrict] = ACTIONS(1068),
    [anon_sym__Atomic] = ACTIONS(1068),
    [anon_sym_pipe] = ACTIONS(1068),
    [anon_sym_signed] = ACTIONS(1068),
    [anon_sym_unsigned] = ACTIONS(1068),
    [anon_sym_long] = ACTIONS(1068),
    [anon_sym_short] = ACTIONS(1068),
    [anon_sym_bool] = ACTIONS(1068),
    [anon_sym_char] = ACTIONS(1068),
    [anon_sym_uchar] = ACTIONS(1068),
    [anon_sym_ushort] = ACTIONS(1068),
    [anon_sym_int] = ACTIONS(1068),
    [anon_sym_uint] = ACTIONS(1068),
    [anon_sym_ulong] = ACTIONS(1068),
    [anon_sym_float] = ACTIONS(1068),
    [anon_sym_double] = ACTIONS(1068),
    [anon_sym_half] = ACTIONS(1068),
    [anon_sym_size_t] = ACTIONS(1068),
    [anon_sym_ptrdiff_t] = ACTIONS(1068),
    [anon_sym_intptr_t] = ACTIONS(1068),
    [anon_sym_uintptr_t] = ACTIONS(1068),
    [anon_sym_void] = ACTIONS(1068),
    [sym_vector_type] = ACTIONS(1068),
    [anon_sym_image2d_t] = ACTIONS(1068),
    [anon_sym_image3d_t] = ACTIONS(1068),
    [anon_sym_image2d_array_t] = ACTIONS(1068),
    [anon_sym_image1d_t] = ACTIONS(1068),
    [anon_sym_image1d_buffer_t] = ACTIONS(1068),
    [anon_sym_image1d_array_t] = ACTIONS(1068),
    [anon_sym_image2d_depth_t] = ACTIONS(1068),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1068),
    [anon_sym_sampler_t] = ACTIONS(1068),
    [anon_sym_queue_t] = ACTIONS(1068),
    [anon_sym_ndrange_t] = ACTIONS(1068),
    [anon_sym_clk_event_t] = ACTIONS(1068),
    [anon_sym_reserve_id_t] = ACTIONS(1068),
    [anon_sym_event_t] = ACTIONS(1068),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1068),
    [anon_sym_enum] = ACTIONS(1068),
    [anon_sym_struct] = ACTIONS(1068),
    [anon_sym_union] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_case] = ACTIONS(1068),
    [anon_sym_default] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_do] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_goto] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_sizeof] = ACTIONS(1068),
    [sym_number_literal] = ACTIONS(1070),
    [anon_sym_L_SQUOTE] = ACTIONS(1070),
    [anon_sym_u_SQUOTE] = ACTIONS(1070),
    [anon_sym_U_SQUOTE] = ACTIONS(1070),
    [anon_sym_u8_SQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_L_DQUOTE] = ACTIONS(1070),
    [anon_sym_u_DQUOTE] = ACTIONS(1070),
    [anon_sym_U_DQUOTE] = ACTIONS(1070),
    [anon_sym_u8_DQUOTE] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_null] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [sym_identifier] = ACTIONS(1084),
    [aux_sym_preproc_include_token1] = ACTIONS(1084),
    [aux_sym_preproc_def_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token2] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1084),
    [sym_preproc_directive] = ACTIONS(1084),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_AMP] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_typedef] = ACTIONS(1084),
    [anon_sym_kernel] = ACTIONS(1084),
    [anon_sym___kernel] = ACTIONS(1084),
    [anon_sym_global] = ACTIONS(1084),
    [anon_sym___global] = ACTIONS(1084),
    [anon_sym_local] = ACTIONS(1084),
    [anon_sym___local] = ACTIONS(1084),
    [anon_sym_constant] = ACTIONS(1084),
    [anon_sym___constant] = ACTIONS(1084),
    [anon_sym_private] = ACTIONS(1084),
    [anon_sym___private] = ACTIONS(1084),
    [anon_sym_generic] = ACTIONS(1084),
    [anon_sym___generic] = ACTIONS(1084),
    [anon_sym_read_only] = ACTIONS(1084),
    [anon_sym___read_only] = ACTIONS(1084),
    [anon_sym_write_only] = ACTIONS(1084),
    [anon_sym___write_only] = ACTIONS(1084),
    [anon_sym_read_write] = ACTIONS(1084),
    [anon_sym___read_write] = ACTIONS(1084),
    [anon_sym_extern] = ACTIONS(1084),
    [anon_sym___attribute__] = ACTIONS(1084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1086),
    [anon_sym___declspec] = ACTIONS(1084),
    [anon_sym___cdecl] = ACTIONS(1084),
    [anon_sym___clrcall] = ACTIONS(1084),
    [anon_sym___stdcall] = ACTIONS(1084),
    [anon_sym___fastcall] = ACTIONS(1084),
    [anon_sym___thiscall] = ACTIONS(1084),
    [anon_sym___vectorcall] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1084),
    [anon_sym_auto] = ACTIONS(1084),
    [anon_sym_register] = ACTIONS(1084),
    [anon_sym_inline] = ACTIONS(1084),
    [anon_sym_const] = ACTIONS(1084),
    [anon_sym_volatile] = ACTIONS(1084),
    [anon_sym_restrict] = ACTIONS(1084),
    [anon_sym__Atomic] = ACTIONS(1084),
    [anon_sym_pipe] = ACTIONS(1084),
    [anon_sym_signed] = ACTIONS(1084),
    [anon_sym_unsigned] = ACTIONS(1084),
    [anon_sym_long] = ACTIONS(1084),
    [anon_sym_short] = ACTIONS(1084),
    [anon_sym_bool] = ACTIONS(1084),
    [anon_sym_char] = ACTIONS(1084),
    [anon_sym_uchar] = ACTIONS(1084),
    [anon_sym_ushort] = ACTIONS(1084),
    [anon_sym_int] = ACTIONS(1084),
    [anon_sym_uint] = ACTIONS(1084),
    [anon_sym_ulong] = ACTIONS(1084),
    [anon_sym_float] = ACTIONS(1084),
    [anon_sym_double] = ACTIONS(1084),
    [anon_sym_half] = ACTIONS(1084),
    [anon_sym_size_t] = ACTIONS(1084),
    [anon_sym_ptrdiff_t] = ACTIONS(1084),
    [anon_sym_intptr_t] = ACTIONS(1084),
    [anon_sym_uintptr_t] = ACTIONS(1084),
    [anon_sym_void] = ACTIONS(1084),
    [sym_vector_type] = ACTIONS(1084),
    [anon_sym_image2d_t] = ACTIONS(1084),
    [anon_sym_image3d_t] = ACTIONS(1084),
    [anon_sym_image2d_array_t] = ACTIONS(1084),
    [anon_sym_image1d_t] = ACTIONS(1084),
    [anon_sym_image1d_buffer_t] = ACTIONS(1084),
    [anon_sym_image1d_array_t] = ACTIONS(1084),
    [anon_sym_image2d_depth_t] = ACTIONS(1084),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1084),
    [anon_sym_sampler_t] = ACTIONS(1084),
    [anon_sym_queue_t] = ACTIONS(1084),
    [anon_sym_ndrange_t] = ACTIONS(1084),
    [anon_sym_clk_event_t] = ACTIONS(1084),
    [anon_sym_reserve_id_t] = ACTIONS(1084),
    [anon_sym_event_t] = ACTIONS(1084),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1084),
    [anon_sym_enum] = ACTIONS(1084),
    [anon_sym_struct] = ACTIONS(1084),
    [anon_sym_union] = ACTIONS(1084),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1084),
    [anon_sym_default] = ACTIONS(1084),
    [anon_sym_while] = ACTIONS(1084),
    [anon_sym_do] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1084),
    [anon_sym_return] = ACTIONS(1084),
    [anon_sym_break] = ACTIONS(1084),
    [anon_sym_continue] = ACTIONS(1084),
    [anon_sym_goto] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1084),
    [sym_number_literal] = ACTIONS(1086),
    [anon_sym_L_SQUOTE] = ACTIONS(1086),
    [anon_sym_u_SQUOTE] = ACTIONS(1086),
    [anon_sym_U_SQUOTE] = ACTIONS(1086),
    [anon_sym_u8_SQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_L_DQUOTE] = ACTIONS(1086),
    [anon_sym_u_DQUOTE] = ACTIONS(1086),
    [anon_sym_U_DQUOTE] = ACTIONS(1086),
    [anon_sym_u8_DQUOTE] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [sym_true] = ACTIONS(1084),
    [sym_false] = ACTIONS(1084),
    [sym_null] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym_identifier] = ACTIONS(1092),
    [aux_sym_preproc_include_token1] = ACTIONS(1092),
    [aux_sym_preproc_def_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token2] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1092),
    [sym_preproc_directive] = ACTIONS(1092),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_BANG] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [anon_sym_typedef] = ACTIONS(1092),
    [anon_sym_kernel] = ACTIONS(1092),
    [anon_sym___kernel] = ACTIONS(1092),
    [anon_sym_global] = ACTIONS(1092),
    [anon_sym___global] = ACTIONS(1092),
    [anon_sym_local] = ACTIONS(1092),
    [anon_sym___local] = ACTIONS(1092),
    [anon_sym_constant] = ACTIONS(1092),
    [anon_sym___constant] = ACTIONS(1092),
    [anon_sym_private] = ACTIONS(1092),
    [anon_sym___private] = ACTIONS(1092),
    [anon_sym_generic] = ACTIONS(1092),
    [anon_sym___generic] = ACTIONS(1092),
    [anon_sym_read_only] = ACTIONS(1092),
    [anon_sym___read_only] = ACTIONS(1092),
    [anon_sym_write_only] = ACTIONS(1092),
    [anon_sym___write_only] = ACTIONS(1092),
    [anon_sym_read_write] = ACTIONS(1092),
    [anon_sym___read_write] = ACTIONS(1092),
    [anon_sym_extern] = ACTIONS(1092),
    [anon_sym___attribute__] = ACTIONS(1092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1094),
    [anon_sym___declspec] = ACTIONS(1092),
    [anon_sym___cdecl] = ACTIONS(1092),
    [anon_sym___clrcall] = ACTIONS(1092),
    [anon_sym___stdcall] = ACTIONS(1092),
    [anon_sym___fastcall] = ACTIONS(1092),
    [anon_sym___thiscall] = ACTIONS(1092),
    [anon_sym___vectorcall] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_auto] = ACTIONS(1092),
    [anon_sym_register] = ACTIONS(1092),
    [anon_sym_inline] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_volatile] = ACTIONS(1092),
    [anon_sym_restrict] = ACTIONS(1092),
    [anon_sym__Atomic] = ACTIONS(1092),
    [anon_sym_pipe] = ACTIONS(1092),
    [anon_sym_signed] = ACTIONS(1092),
    [anon_sym_unsigned] = ACTIONS(1092),
    [anon_sym_long] = ACTIONS(1092),
    [anon_sym_short] = ACTIONS(1092),
    [anon_sym_bool] = ACTIONS(1092),
    [anon_sym_char] = ACTIONS(1092),
    [anon_sym_uchar] = ACTIONS(1092),
    [anon_sym_ushort] = ACTIONS(1092),
    [anon_sym_int] = ACTIONS(1092),
    [anon_sym_uint] = ACTIONS(1092),
    [anon_sym_ulong] = ACTIONS(1092),
    [anon_sym_float] = ACTIONS(1092),
    [anon_sym_double] = ACTIONS(1092),
    [anon_sym_half] = ACTIONS(1092),
    [anon_sym_size_t] = ACTIONS(1092),
    [anon_sym_ptrdiff_t] = ACTIONS(1092),
    [anon_sym_intptr_t] = ACTIONS(1092),
    [anon_sym_uintptr_t] = ACTIONS(1092),
    [anon_sym_void] = ACTIONS(1092),
    [sym_vector_type] = ACTIONS(1092),
    [anon_sym_image2d_t] = ACTIONS(1092),
    [anon_sym_image3d_t] = ACTIONS(1092),
    [anon_sym_image2d_array_t] = ACTIONS(1092),
    [anon_sym_image1d_t] = ACTIONS(1092),
    [anon_sym_image1d_buffer_t] = ACTIONS(1092),
    [anon_sym_image1d_array_t] = ACTIONS(1092),
    [anon_sym_image2d_depth_t] = ACTIONS(1092),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1092),
    [anon_sym_sampler_t] = ACTIONS(1092),
    [anon_sym_queue_t] = ACTIONS(1092),
    [anon_sym_ndrange_t] = ACTIONS(1092),
    [anon_sym_clk_event_t] = ACTIONS(1092),
    [anon_sym_reserve_id_t] = ACTIONS(1092),
    [anon_sym_event_t] = ACTIONS(1092),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_struct] = ACTIONS(1092),
    [anon_sym_union] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_goto] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_sizeof] = ACTIONS(1092),
    [sym_number_literal] = ACTIONS(1094),
    [anon_sym_L_SQUOTE] = ACTIONS(1094),
    [anon_sym_u_SQUOTE] = ACTIONS(1094),
    [anon_sym_U_SQUOTE] = ACTIONS(1094),
    [anon_sym_u8_SQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_L_DQUOTE] = ACTIONS(1094),
    [anon_sym_u_DQUOTE] = ACTIONS(1094),
    [anon_sym_U_DQUOTE] = ACTIONS(1094),
    [anon_sym_u8_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_identifier] = ACTIONS(1048),
    [aux_sym_preproc_include_token1] = ACTIONS(1048),
    [aux_sym_preproc_def_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token2] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1048),
    [sym_preproc_directive] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_typedef] = ACTIONS(1048),
    [anon_sym_kernel] = ACTIONS(1048),
    [anon_sym___kernel] = ACTIONS(1048),
    [anon_sym_global] = ACTIONS(1048),
    [anon_sym___global] = ACTIONS(1048),
    [anon_sym_local] = ACTIONS(1048),
    [anon_sym___local] = ACTIONS(1048),
    [anon_sym_constant] = ACTIONS(1048),
    [anon_sym___constant] = ACTIONS(1048),
    [anon_sym_private] = ACTIONS(1048),
    [anon_sym___private] = ACTIONS(1048),
    [anon_sym_generic] = ACTIONS(1048),
    [anon_sym___generic] = ACTIONS(1048),
    [anon_sym_read_only] = ACTIONS(1048),
    [anon_sym___read_only] = ACTIONS(1048),
    [anon_sym_write_only] = ACTIONS(1048),
    [anon_sym___write_only] = ACTIONS(1048),
    [anon_sym_read_write] = ACTIONS(1048),
    [anon_sym___read_write] = ACTIONS(1048),
    [anon_sym_extern] = ACTIONS(1048),
    [anon_sym___attribute__] = ACTIONS(1048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1050),
    [anon_sym___declspec] = ACTIONS(1048),
    [anon_sym___cdecl] = ACTIONS(1048),
    [anon_sym___clrcall] = ACTIONS(1048),
    [anon_sym___stdcall] = ACTIONS(1048),
    [anon_sym___fastcall] = ACTIONS(1048),
    [anon_sym___thiscall] = ACTIONS(1048),
    [anon_sym___vectorcall] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1048),
    [anon_sym_auto] = ACTIONS(1048),
    [anon_sym_register] = ACTIONS(1048),
    [anon_sym_inline] = ACTIONS(1048),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_volatile] = ACTIONS(1048),
    [anon_sym_restrict] = ACTIONS(1048),
    [anon_sym__Atomic] = ACTIONS(1048),
    [anon_sym_pipe] = ACTIONS(1048),
    [anon_sym_signed] = ACTIONS(1048),
    [anon_sym_unsigned] = ACTIONS(1048),
    [anon_sym_long] = ACTIONS(1048),
    [anon_sym_short] = ACTIONS(1048),
    [anon_sym_bool] = ACTIONS(1048),
    [anon_sym_char] = ACTIONS(1048),
    [anon_sym_uchar] = ACTIONS(1048),
    [anon_sym_ushort] = ACTIONS(1048),
    [anon_sym_int] = ACTIONS(1048),
    [anon_sym_uint] = ACTIONS(1048),
    [anon_sym_ulong] = ACTIONS(1048),
    [anon_sym_float] = ACTIONS(1048),
    [anon_sym_double] = ACTIONS(1048),
    [anon_sym_half] = ACTIONS(1048),
    [anon_sym_size_t] = ACTIONS(1048),
    [anon_sym_ptrdiff_t] = ACTIONS(1048),
    [anon_sym_intptr_t] = ACTIONS(1048),
    [anon_sym_uintptr_t] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1048),
    [sym_vector_type] = ACTIONS(1048),
    [anon_sym_image2d_t] = ACTIONS(1048),
    [anon_sym_image3d_t] = ACTIONS(1048),
    [anon_sym_image2d_array_t] = ACTIONS(1048),
    [anon_sym_image1d_t] = ACTIONS(1048),
    [anon_sym_image1d_buffer_t] = ACTIONS(1048),
    [anon_sym_image1d_array_t] = ACTIONS(1048),
    [anon_sym_image2d_depth_t] = ACTIONS(1048),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1048),
    [anon_sym_sampler_t] = ACTIONS(1048),
    [anon_sym_queue_t] = ACTIONS(1048),
    [anon_sym_ndrange_t] = ACTIONS(1048),
    [anon_sym_clk_event_t] = ACTIONS(1048),
    [anon_sym_reserve_id_t] = ACTIONS(1048),
    [anon_sym_event_t] = ACTIONS(1048),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1048),
    [anon_sym_enum] = ACTIONS(1048),
    [anon_sym_struct] = ACTIONS(1048),
    [anon_sym_union] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_goto] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_sizeof] = ACTIONS(1048),
    [sym_number_literal] = ACTIONS(1050),
    [anon_sym_L_SQUOTE] = ACTIONS(1050),
    [anon_sym_u_SQUOTE] = ACTIONS(1050),
    [anon_sym_U_SQUOTE] = ACTIONS(1050),
    [anon_sym_u8_SQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_L_DQUOTE] = ACTIONS(1050),
    [anon_sym_u_DQUOTE] = ACTIONS(1050),
    [anon_sym_U_DQUOTE] = ACTIONS(1050),
    [anon_sym_u8_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [sym_identifier] = ACTIONS(1100),
    [aux_sym_preproc_include_token1] = ACTIONS(1100),
    [aux_sym_preproc_def_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token2] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1100),
    [sym_preproc_directive] = ACTIONS(1100),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_typedef] = ACTIONS(1100),
    [anon_sym_kernel] = ACTIONS(1100),
    [anon_sym___kernel] = ACTIONS(1100),
    [anon_sym_global] = ACTIONS(1100),
    [anon_sym___global] = ACTIONS(1100),
    [anon_sym_local] = ACTIONS(1100),
    [anon_sym___local] = ACTIONS(1100),
    [anon_sym_constant] = ACTIONS(1100),
    [anon_sym___constant] = ACTIONS(1100),
    [anon_sym_private] = ACTIONS(1100),
    [anon_sym___private] = ACTIONS(1100),
    [anon_sym_generic] = ACTIONS(1100),
    [anon_sym___generic] = ACTIONS(1100),
    [anon_sym_read_only] = ACTIONS(1100),
    [anon_sym___read_only] = ACTIONS(1100),
    [anon_sym_write_only] = ACTIONS(1100),
    [anon_sym___write_only] = ACTIONS(1100),
    [anon_sym_read_write] = ACTIONS(1100),
    [anon_sym___read_write] = ACTIONS(1100),
    [anon_sym_extern] = ACTIONS(1100),
    [anon_sym___attribute__] = ACTIONS(1100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1102),
    [anon_sym___declspec] = ACTIONS(1100),
    [anon_sym___cdecl] = ACTIONS(1100),
    [anon_sym___clrcall] = ACTIONS(1100),
    [anon_sym___stdcall] = ACTIONS(1100),
    [anon_sym___fastcall] = ACTIONS(1100),
    [anon_sym___thiscall] = ACTIONS(1100),
    [anon_sym___vectorcall] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_auto] = ACTIONS(1100),
    [anon_sym_register] = ACTIONS(1100),
    [anon_sym_inline] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_volatile] = ACTIONS(1100),
    [anon_sym_restrict] = ACTIONS(1100),
    [anon_sym__Atomic] = ACTIONS(1100),
    [anon_sym_pipe] = ACTIONS(1100),
    [anon_sym_signed] = ACTIONS(1100),
    [anon_sym_unsigned] = ACTIONS(1100),
    [anon_sym_long] = ACTIONS(1100),
    [anon_sym_short] = ACTIONS(1100),
    [anon_sym_bool] = ACTIONS(1100),
    [anon_sym_char] = ACTIONS(1100),
    [anon_sym_uchar] = ACTIONS(1100),
    [anon_sym_ushort] = ACTIONS(1100),
    [anon_sym_int] = ACTIONS(1100),
    [anon_sym_uint] = ACTIONS(1100),
    [anon_sym_ulong] = ACTIONS(1100),
    [anon_sym_float] = ACTIONS(1100),
    [anon_sym_double] = ACTIONS(1100),
    [anon_sym_half] = ACTIONS(1100),
    [anon_sym_size_t] = ACTIONS(1100),
    [anon_sym_ptrdiff_t] = ACTIONS(1100),
    [anon_sym_intptr_t] = ACTIONS(1100),
    [anon_sym_uintptr_t] = ACTIONS(1100),
    [anon_sym_void] = ACTIONS(1100),
    [sym_vector_type] = ACTIONS(1100),
    [anon_sym_image2d_t] = ACTIONS(1100),
    [anon_sym_image3d_t] = ACTIONS(1100),
    [anon_sym_image2d_array_t] = ACTIONS(1100),
    [anon_sym_image1d_t] = ACTIONS(1100),
    [anon_sym_image1d_buffer_t] = ACTIONS(1100),
    [anon_sym_image1d_array_t] = ACTIONS(1100),
    [anon_sym_image2d_depth_t] = ACTIONS(1100),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1100),
    [anon_sym_sampler_t] = ACTIONS(1100),
    [anon_sym_queue_t] = ACTIONS(1100),
    [anon_sym_ndrange_t] = ACTIONS(1100),
    [anon_sym_clk_event_t] = ACTIONS(1100),
    [anon_sym_reserve_id_t] = ACTIONS(1100),
    [anon_sym_event_t] = ACTIONS(1100),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [anon_sym_struct] = ACTIONS(1100),
    [anon_sym_union] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_goto] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_sizeof] = ACTIONS(1100),
    [sym_number_literal] = ACTIONS(1102),
    [anon_sym_L_SQUOTE] = ACTIONS(1102),
    [anon_sym_u_SQUOTE] = ACTIONS(1102),
    [anon_sym_U_SQUOTE] = ACTIONS(1102),
    [anon_sym_u8_SQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_L_DQUOTE] = ACTIONS(1102),
    [anon_sym_u_DQUOTE] = ACTIONS(1102),
    [anon_sym_U_DQUOTE] = ACTIONS(1102),
    [anon_sym_u8_DQUOTE] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(1106),
    [sym_identifier] = ACTIONS(1104),
    [aux_sym_preproc_include_token1] = ACTIONS(1104),
    [aux_sym_preproc_def_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1104),
    [sym_preproc_directive] = ACTIONS(1104),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_typedef] = ACTIONS(1104),
    [anon_sym_kernel] = ACTIONS(1104),
    [anon_sym___kernel] = ACTIONS(1104),
    [anon_sym_global] = ACTIONS(1104),
    [anon_sym___global] = ACTIONS(1104),
    [anon_sym_local] = ACTIONS(1104),
    [anon_sym___local] = ACTIONS(1104),
    [anon_sym_constant] = ACTIONS(1104),
    [anon_sym___constant] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym___private] = ACTIONS(1104),
    [anon_sym_generic] = ACTIONS(1104),
    [anon_sym___generic] = ACTIONS(1104),
    [anon_sym_read_only] = ACTIONS(1104),
    [anon_sym___read_only] = ACTIONS(1104),
    [anon_sym_write_only] = ACTIONS(1104),
    [anon_sym___write_only] = ACTIONS(1104),
    [anon_sym_read_write] = ACTIONS(1104),
    [anon_sym___read_write] = ACTIONS(1104),
    [anon_sym_extern] = ACTIONS(1104),
    [anon_sym___attribute__] = ACTIONS(1104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1106),
    [anon_sym___declspec] = ACTIONS(1104),
    [anon_sym___cdecl] = ACTIONS(1104),
    [anon_sym___clrcall] = ACTIONS(1104),
    [anon_sym___stdcall] = ACTIONS(1104),
    [anon_sym___fastcall] = ACTIONS(1104),
    [anon_sym___thiscall] = ACTIONS(1104),
    [anon_sym___vectorcall] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_auto] = ACTIONS(1104),
    [anon_sym_register] = ACTIONS(1104),
    [anon_sym_inline] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_volatile] = ACTIONS(1104),
    [anon_sym_restrict] = ACTIONS(1104),
    [anon_sym__Atomic] = ACTIONS(1104),
    [anon_sym_pipe] = ACTIONS(1104),
    [anon_sym_signed] = ACTIONS(1104),
    [anon_sym_unsigned] = ACTIONS(1104),
    [anon_sym_long] = ACTIONS(1104),
    [anon_sym_short] = ACTIONS(1104),
    [anon_sym_bool] = ACTIONS(1104),
    [anon_sym_char] = ACTIONS(1104),
    [anon_sym_uchar] = ACTIONS(1104),
    [anon_sym_ushort] = ACTIONS(1104),
    [anon_sym_int] = ACTIONS(1104),
    [anon_sym_uint] = ACTIONS(1104),
    [anon_sym_ulong] = ACTIONS(1104),
    [anon_sym_float] = ACTIONS(1104),
    [anon_sym_double] = ACTIONS(1104),
    [anon_sym_half] = ACTIONS(1104),
    [anon_sym_size_t] = ACTIONS(1104),
    [anon_sym_ptrdiff_t] = ACTIONS(1104),
    [anon_sym_intptr_t] = ACTIONS(1104),
    [anon_sym_uintptr_t] = ACTIONS(1104),
    [anon_sym_void] = ACTIONS(1104),
    [sym_vector_type] = ACTIONS(1104),
    [anon_sym_image2d_t] = ACTIONS(1104),
    [anon_sym_image3d_t] = ACTIONS(1104),
    [anon_sym_image2d_array_t] = ACTIONS(1104),
    [anon_sym_image1d_t] = ACTIONS(1104),
    [anon_sym_image1d_buffer_t] = ACTIONS(1104),
    [anon_sym_image1d_array_t] = ACTIONS(1104),
    [anon_sym_image2d_depth_t] = ACTIONS(1104),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1104),
    [anon_sym_sampler_t] = ACTIONS(1104),
    [anon_sym_queue_t] = ACTIONS(1104),
    [anon_sym_ndrange_t] = ACTIONS(1104),
    [anon_sym_clk_event_t] = ACTIONS(1104),
    [anon_sym_reserve_id_t] = ACTIONS(1104),
    [anon_sym_event_t] = ACTIONS(1104),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [anon_sym_struct] = ACTIONS(1104),
    [anon_sym_union] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_goto] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_sizeof] = ACTIONS(1104),
    [sym_number_literal] = ACTIONS(1106),
    [anon_sym_L_SQUOTE] = ACTIONS(1106),
    [anon_sym_u_SQUOTE] = ACTIONS(1106),
    [anon_sym_U_SQUOTE] = ACTIONS(1106),
    [anon_sym_u8_SQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_L_DQUOTE] = ACTIONS(1106),
    [anon_sym_u_DQUOTE] = ACTIONS(1106),
    [anon_sym_U_DQUOTE] = ACTIONS(1106),
    [anon_sym_u8_DQUOTE] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [ts_builtin_sym_end] = ACTIONS(1086),
    [sym_identifier] = ACTIONS(1084),
    [aux_sym_preproc_include_token1] = ACTIONS(1084),
    [aux_sym_preproc_def_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1084),
    [sym_preproc_directive] = ACTIONS(1084),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_AMP] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_typedef] = ACTIONS(1084),
    [anon_sym_kernel] = ACTIONS(1084),
    [anon_sym___kernel] = ACTIONS(1084),
    [anon_sym_global] = ACTIONS(1084),
    [anon_sym___global] = ACTIONS(1084),
    [anon_sym_local] = ACTIONS(1084),
    [anon_sym___local] = ACTIONS(1084),
    [anon_sym_constant] = ACTIONS(1084),
    [anon_sym___constant] = ACTIONS(1084),
    [anon_sym_private] = ACTIONS(1084),
    [anon_sym___private] = ACTIONS(1084),
    [anon_sym_generic] = ACTIONS(1084),
    [anon_sym___generic] = ACTIONS(1084),
    [anon_sym_read_only] = ACTIONS(1084),
    [anon_sym___read_only] = ACTIONS(1084),
    [anon_sym_write_only] = ACTIONS(1084),
    [anon_sym___write_only] = ACTIONS(1084),
    [anon_sym_read_write] = ACTIONS(1084),
    [anon_sym___read_write] = ACTIONS(1084),
    [anon_sym_extern] = ACTIONS(1084),
    [anon_sym___attribute__] = ACTIONS(1084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1086),
    [anon_sym___declspec] = ACTIONS(1084),
    [anon_sym___cdecl] = ACTIONS(1084),
    [anon_sym___clrcall] = ACTIONS(1084),
    [anon_sym___stdcall] = ACTIONS(1084),
    [anon_sym___fastcall] = ACTIONS(1084),
    [anon_sym___thiscall] = ACTIONS(1084),
    [anon_sym___vectorcall] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1084),
    [anon_sym_auto] = ACTIONS(1084),
    [anon_sym_register] = ACTIONS(1084),
    [anon_sym_inline] = ACTIONS(1084),
    [anon_sym_const] = ACTIONS(1084),
    [anon_sym_volatile] = ACTIONS(1084),
    [anon_sym_restrict] = ACTIONS(1084),
    [anon_sym__Atomic] = ACTIONS(1084),
    [anon_sym_pipe] = ACTIONS(1084),
    [anon_sym_signed] = ACTIONS(1084),
    [anon_sym_unsigned] = ACTIONS(1084),
    [anon_sym_long] = ACTIONS(1084),
    [anon_sym_short] = ACTIONS(1084),
    [anon_sym_bool] = ACTIONS(1084),
    [anon_sym_char] = ACTIONS(1084),
    [anon_sym_uchar] = ACTIONS(1084),
    [anon_sym_ushort] = ACTIONS(1084),
    [anon_sym_int] = ACTIONS(1084),
    [anon_sym_uint] = ACTIONS(1084),
    [anon_sym_ulong] = ACTIONS(1084),
    [anon_sym_float] = ACTIONS(1084),
    [anon_sym_double] = ACTIONS(1084),
    [anon_sym_half] = ACTIONS(1084),
    [anon_sym_size_t] = ACTIONS(1084),
    [anon_sym_ptrdiff_t] = ACTIONS(1084),
    [anon_sym_intptr_t] = ACTIONS(1084),
    [anon_sym_uintptr_t] = ACTIONS(1084),
    [anon_sym_void] = ACTIONS(1084),
    [sym_vector_type] = ACTIONS(1084),
    [anon_sym_image2d_t] = ACTIONS(1084),
    [anon_sym_image3d_t] = ACTIONS(1084),
    [anon_sym_image2d_array_t] = ACTIONS(1084),
    [anon_sym_image1d_t] = ACTIONS(1084),
    [anon_sym_image1d_buffer_t] = ACTIONS(1084),
    [anon_sym_image1d_array_t] = ACTIONS(1084),
    [anon_sym_image2d_depth_t] = ACTIONS(1084),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1084),
    [anon_sym_sampler_t] = ACTIONS(1084),
    [anon_sym_queue_t] = ACTIONS(1084),
    [anon_sym_ndrange_t] = ACTIONS(1084),
    [anon_sym_clk_event_t] = ACTIONS(1084),
    [anon_sym_reserve_id_t] = ACTIONS(1084),
    [anon_sym_event_t] = ACTIONS(1084),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1084),
    [anon_sym_enum] = ACTIONS(1084),
    [anon_sym_struct] = ACTIONS(1084),
    [anon_sym_union] = ACTIONS(1084),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1084),
    [anon_sym_default] = ACTIONS(1084),
    [anon_sym_while] = ACTIONS(1084),
    [anon_sym_do] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1084),
    [anon_sym_return] = ACTIONS(1084),
    [anon_sym_break] = ACTIONS(1084),
    [anon_sym_continue] = ACTIONS(1084),
    [anon_sym_goto] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1084),
    [sym_number_literal] = ACTIONS(1086),
    [anon_sym_L_SQUOTE] = ACTIONS(1086),
    [anon_sym_u_SQUOTE] = ACTIONS(1086),
    [anon_sym_U_SQUOTE] = ACTIONS(1086),
    [anon_sym_u8_SQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_L_DQUOTE] = ACTIONS(1086),
    [anon_sym_u_DQUOTE] = ACTIONS(1086),
    [anon_sym_U_DQUOTE] = ACTIONS(1086),
    [anon_sym_u8_DQUOTE] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [sym_true] = ACTIONS(1084),
    [sym_false] = ACTIONS(1084),
    [sym_null] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [sym_identifier] = ACTIONS(1080),
    [aux_sym_preproc_include_token1] = ACTIONS(1080),
    [aux_sym_preproc_def_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token2] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1080),
    [sym_preproc_directive] = ACTIONS(1080),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [anon_sym_typedef] = ACTIONS(1080),
    [anon_sym_kernel] = ACTIONS(1080),
    [anon_sym___kernel] = ACTIONS(1080),
    [anon_sym_global] = ACTIONS(1080),
    [anon_sym___global] = ACTIONS(1080),
    [anon_sym_local] = ACTIONS(1080),
    [anon_sym___local] = ACTIONS(1080),
    [anon_sym_constant] = ACTIONS(1080),
    [anon_sym___constant] = ACTIONS(1080),
    [anon_sym_private] = ACTIONS(1080),
    [anon_sym___private] = ACTIONS(1080),
    [anon_sym_generic] = ACTIONS(1080),
    [anon_sym___generic] = ACTIONS(1080),
    [anon_sym_read_only] = ACTIONS(1080),
    [anon_sym___read_only] = ACTIONS(1080),
    [anon_sym_write_only] = ACTIONS(1080),
    [anon_sym___write_only] = ACTIONS(1080),
    [anon_sym_read_write] = ACTIONS(1080),
    [anon_sym___read_write] = ACTIONS(1080),
    [anon_sym_extern] = ACTIONS(1080),
    [anon_sym___attribute__] = ACTIONS(1080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1082),
    [anon_sym___declspec] = ACTIONS(1080),
    [anon_sym___cdecl] = ACTIONS(1080),
    [anon_sym___clrcall] = ACTIONS(1080),
    [anon_sym___stdcall] = ACTIONS(1080),
    [anon_sym___fastcall] = ACTIONS(1080),
    [anon_sym___thiscall] = ACTIONS(1080),
    [anon_sym___vectorcall] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_static] = ACTIONS(1080),
    [anon_sym_auto] = ACTIONS(1080),
    [anon_sym_register] = ACTIONS(1080),
    [anon_sym_inline] = ACTIONS(1080),
    [anon_sym_const] = ACTIONS(1080),
    [anon_sym_volatile] = ACTIONS(1080),
    [anon_sym_restrict] = ACTIONS(1080),
    [anon_sym__Atomic] = ACTIONS(1080),
    [anon_sym_pipe] = ACTIONS(1080),
    [anon_sym_signed] = ACTIONS(1080),
    [anon_sym_unsigned] = ACTIONS(1080),
    [anon_sym_long] = ACTIONS(1080),
    [anon_sym_short] = ACTIONS(1080),
    [anon_sym_bool] = ACTIONS(1080),
    [anon_sym_char] = ACTIONS(1080),
    [anon_sym_uchar] = ACTIONS(1080),
    [anon_sym_ushort] = ACTIONS(1080),
    [anon_sym_int] = ACTIONS(1080),
    [anon_sym_uint] = ACTIONS(1080),
    [anon_sym_ulong] = ACTIONS(1080),
    [anon_sym_float] = ACTIONS(1080),
    [anon_sym_double] = ACTIONS(1080),
    [anon_sym_half] = ACTIONS(1080),
    [anon_sym_size_t] = ACTIONS(1080),
    [anon_sym_ptrdiff_t] = ACTIONS(1080),
    [anon_sym_intptr_t] = ACTIONS(1080),
    [anon_sym_uintptr_t] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1080),
    [sym_vector_type] = ACTIONS(1080),
    [anon_sym_image2d_t] = ACTIONS(1080),
    [anon_sym_image3d_t] = ACTIONS(1080),
    [anon_sym_image2d_array_t] = ACTIONS(1080),
    [anon_sym_image1d_t] = ACTIONS(1080),
    [anon_sym_image1d_buffer_t] = ACTIONS(1080),
    [anon_sym_image1d_array_t] = ACTIONS(1080),
    [anon_sym_image2d_depth_t] = ACTIONS(1080),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1080),
    [anon_sym_sampler_t] = ACTIONS(1080),
    [anon_sym_queue_t] = ACTIONS(1080),
    [anon_sym_ndrange_t] = ACTIONS(1080),
    [anon_sym_clk_event_t] = ACTIONS(1080),
    [anon_sym_reserve_id_t] = ACTIONS(1080),
    [anon_sym_event_t] = ACTIONS(1080),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1080),
    [anon_sym_enum] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1080),
    [anon_sym_union] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1080),
    [anon_sym_do] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1080),
    [anon_sym_return] = ACTIONS(1080),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_goto] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1082),
    [anon_sym_sizeof] = ACTIONS(1080),
    [sym_number_literal] = ACTIONS(1082),
    [anon_sym_L_SQUOTE] = ACTIONS(1082),
    [anon_sym_u_SQUOTE] = ACTIONS(1082),
    [anon_sym_U_SQUOTE] = ACTIONS(1082),
    [anon_sym_u8_SQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_L_DQUOTE] = ACTIONS(1082),
    [anon_sym_u_DQUOTE] = ACTIONS(1082),
    [anon_sym_U_DQUOTE] = ACTIONS(1082),
    [anon_sym_u8_DQUOTE] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_true] = ACTIONS(1080),
    [sym_false] = ACTIONS(1080),
    [sym_null] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [sym_identifier] = ACTIONS(1084),
    [aux_sym_preproc_include_token1] = ACTIONS(1084),
    [aux_sym_preproc_def_token1] = ACTIONS(1084),
    [aux_sym_preproc_if_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1084),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1084),
    [sym_preproc_directive] = ACTIONS(1084),
    [anon_sym_LPAREN2] = ACTIONS(1086),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_AMP] = ACTIONS(1086),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_typedef] = ACTIONS(1084),
    [anon_sym_kernel] = ACTIONS(1084),
    [anon_sym___kernel] = ACTIONS(1084),
    [anon_sym_global] = ACTIONS(1084),
    [anon_sym___global] = ACTIONS(1084),
    [anon_sym_local] = ACTIONS(1084),
    [anon_sym___local] = ACTIONS(1084),
    [anon_sym_constant] = ACTIONS(1084),
    [anon_sym___constant] = ACTIONS(1084),
    [anon_sym_private] = ACTIONS(1084),
    [anon_sym___private] = ACTIONS(1084),
    [anon_sym_generic] = ACTIONS(1084),
    [anon_sym___generic] = ACTIONS(1084),
    [anon_sym_read_only] = ACTIONS(1084),
    [anon_sym___read_only] = ACTIONS(1084),
    [anon_sym_write_only] = ACTIONS(1084),
    [anon_sym___write_only] = ACTIONS(1084),
    [anon_sym_read_write] = ACTIONS(1084),
    [anon_sym___read_write] = ACTIONS(1084),
    [anon_sym_extern] = ACTIONS(1084),
    [anon_sym___attribute__] = ACTIONS(1084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1086),
    [anon_sym___declspec] = ACTIONS(1084),
    [anon_sym___cdecl] = ACTIONS(1084),
    [anon_sym___clrcall] = ACTIONS(1084),
    [anon_sym___stdcall] = ACTIONS(1084),
    [anon_sym___fastcall] = ACTIONS(1084),
    [anon_sym___thiscall] = ACTIONS(1084),
    [anon_sym___vectorcall] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1086),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1084),
    [anon_sym_auto] = ACTIONS(1084),
    [anon_sym_register] = ACTIONS(1084),
    [anon_sym_inline] = ACTIONS(1084),
    [anon_sym_const] = ACTIONS(1084),
    [anon_sym_volatile] = ACTIONS(1084),
    [anon_sym_restrict] = ACTIONS(1084),
    [anon_sym__Atomic] = ACTIONS(1084),
    [anon_sym_pipe] = ACTIONS(1084),
    [anon_sym_signed] = ACTIONS(1084),
    [anon_sym_unsigned] = ACTIONS(1084),
    [anon_sym_long] = ACTIONS(1084),
    [anon_sym_short] = ACTIONS(1084),
    [anon_sym_bool] = ACTIONS(1084),
    [anon_sym_char] = ACTIONS(1084),
    [anon_sym_uchar] = ACTIONS(1084),
    [anon_sym_ushort] = ACTIONS(1084),
    [anon_sym_int] = ACTIONS(1084),
    [anon_sym_uint] = ACTIONS(1084),
    [anon_sym_ulong] = ACTIONS(1084),
    [anon_sym_float] = ACTIONS(1084),
    [anon_sym_double] = ACTIONS(1084),
    [anon_sym_half] = ACTIONS(1084),
    [anon_sym_size_t] = ACTIONS(1084),
    [anon_sym_ptrdiff_t] = ACTIONS(1084),
    [anon_sym_intptr_t] = ACTIONS(1084),
    [anon_sym_uintptr_t] = ACTIONS(1084),
    [anon_sym_void] = ACTIONS(1084),
    [sym_vector_type] = ACTIONS(1084),
    [anon_sym_image2d_t] = ACTIONS(1084),
    [anon_sym_image3d_t] = ACTIONS(1084),
    [anon_sym_image2d_array_t] = ACTIONS(1084),
    [anon_sym_image1d_t] = ACTIONS(1084),
    [anon_sym_image1d_buffer_t] = ACTIONS(1084),
    [anon_sym_image1d_array_t] = ACTIONS(1084),
    [anon_sym_image2d_depth_t] = ACTIONS(1084),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1084),
    [anon_sym_sampler_t] = ACTIONS(1084),
    [anon_sym_queue_t] = ACTIONS(1084),
    [anon_sym_ndrange_t] = ACTIONS(1084),
    [anon_sym_clk_event_t] = ACTIONS(1084),
    [anon_sym_reserve_id_t] = ACTIONS(1084),
    [anon_sym_event_t] = ACTIONS(1084),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1084),
    [anon_sym_enum] = ACTIONS(1084),
    [anon_sym_struct] = ACTIONS(1084),
    [anon_sym_union] = ACTIONS(1084),
    [anon_sym_if] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1084),
    [anon_sym_default] = ACTIONS(1084),
    [anon_sym_while] = ACTIONS(1084),
    [anon_sym_do] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1084),
    [anon_sym_return] = ACTIONS(1084),
    [anon_sym_break] = ACTIONS(1084),
    [anon_sym_continue] = ACTIONS(1084),
    [anon_sym_goto] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1086),
    [anon_sym_sizeof] = ACTIONS(1084),
    [sym_number_literal] = ACTIONS(1086),
    [anon_sym_L_SQUOTE] = ACTIONS(1086),
    [anon_sym_u_SQUOTE] = ACTIONS(1086),
    [anon_sym_U_SQUOTE] = ACTIONS(1086),
    [anon_sym_u8_SQUOTE] = ACTIONS(1086),
    [anon_sym_SQUOTE] = ACTIONS(1086),
    [anon_sym_L_DQUOTE] = ACTIONS(1086),
    [anon_sym_u_DQUOTE] = ACTIONS(1086),
    [anon_sym_U_DQUOTE] = ACTIONS(1086),
    [anon_sym_u8_DQUOTE] = ACTIONS(1086),
    [anon_sym_DQUOTE] = ACTIONS(1086),
    [sym_true] = ACTIONS(1084),
    [sym_false] = ACTIONS(1084),
    [sym_null] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_include_token1] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_typedef] = ACTIONS(1088),
    [anon_sym_kernel] = ACTIONS(1088),
    [anon_sym___kernel] = ACTIONS(1088),
    [anon_sym_global] = ACTIONS(1088),
    [anon_sym___global] = ACTIONS(1088),
    [anon_sym_local] = ACTIONS(1088),
    [anon_sym___local] = ACTIONS(1088),
    [anon_sym_constant] = ACTIONS(1088),
    [anon_sym___constant] = ACTIONS(1088),
    [anon_sym_private] = ACTIONS(1088),
    [anon_sym___private] = ACTIONS(1088),
    [anon_sym_generic] = ACTIONS(1088),
    [anon_sym___generic] = ACTIONS(1088),
    [anon_sym_read_only] = ACTIONS(1088),
    [anon_sym___read_only] = ACTIONS(1088),
    [anon_sym_write_only] = ACTIONS(1088),
    [anon_sym___write_only] = ACTIONS(1088),
    [anon_sym_read_write] = ACTIONS(1088),
    [anon_sym___read_write] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1090),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym___cdecl] = ACTIONS(1088),
    [anon_sym___clrcall] = ACTIONS(1088),
    [anon_sym___stdcall] = ACTIONS(1088),
    [anon_sym___fastcall] = ACTIONS(1088),
    [anon_sym___thiscall] = ACTIONS(1088),
    [anon_sym___vectorcall] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_pipe] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [anon_sym_bool] = ACTIONS(1088),
    [anon_sym_char] = ACTIONS(1088),
    [anon_sym_uchar] = ACTIONS(1088),
    [anon_sym_ushort] = ACTIONS(1088),
    [anon_sym_int] = ACTIONS(1088),
    [anon_sym_uint] = ACTIONS(1088),
    [anon_sym_ulong] = ACTIONS(1088),
    [anon_sym_float] = ACTIONS(1088),
    [anon_sym_double] = ACTIONS(1088),
    [anon_sym_half] = ACTIONS(1088),
    [anon_sym_size_t] = ACTIONS(1088),
    [anon_sym_ptrdiff_t] = ACTIONS(1088),
    [anon_sym_intptr_t] = ACTIONS(1088),
    [anon_sym_uintptr_t] = ACTIONS(1088),
    [anon_sym_void] = ACTIONS(1088),
    [sym_vector_type] = ACTIONS(1088),
    [anon_sym_image2d_t] = ACTIONS(1088),
    [anon_sym_image3d_t] = ACTIONS(1088),
    [anon_sym_image2d_array_t] = ACTIONS(1088),
    [anon_sym_image1d_t] = ACTIONS(1088),
    [anon_sym_image1d_buffer_t] = ACTIONS(1088),
    [anon_sym_image1d_array_t] = ACTIONS(1088),
    [anon_sym_image2d_depth_t] = ACTIONS(1088),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1088),
    [anon_sym_sampler_t] = ACTIONS(1088),
    [anon_sym_queue_t] = ACTIONS(1088),
    [anon_sym_ndrange_t] = ACTIONS(1088),
    [anon_sym_clk_event_t] = ACTIONS(1088),
    [anon_sym_reserve_id_t] = ACTIONS(1088),
    [anon_sym_event_t] = ACTIONS(1088),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_goto] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_sizeof] = ACTIONS(1088),
    [sym_number_literal] = ACTIONS(1090),
    [anon_sym_L_SQUOTE] = ACTIONS(1090),
    [anon_sym_u_SQUOTE] = ACTIONS(1090),
    [anon_sym_U_SQUOTE] = ACTIONS(1090),
    [anon_sym_u8_SQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_L_DQUOTE] = ACTIONS(1090),
    [anon_sym_u_DQUOTE] = ACTIONS(1090),
    [anon_sym_U_DQUOTE] = ACTIONS(1090),
    [anon_sym_u8_DQUOTE] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym_identifier] = ACTIONS(1092),
    [aux_sym_preproc_include_token1] = ACTIONS(1092),
    [aux_sym_preproc_def_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1092),
    [sym_preproc_directive] = ACTIONS(1092),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_BANG] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [anon_sym_typedef] = ACTIONS(1092),
    [anon_sym_kernel] = ACTIONS(1092),
    [anon_sym___kernel] = ACTIONS(1092),
    [anon_sym_global] = ACTIONS(1092),
    [anon_sym___global] = ACTIONS(1092),
    [anon_sym_local] = ACTIONS(1092),
    [anon_sym___local] = ACTIONS(1092),
    [anon_sym_constant] = ACTIONS(1092),
    [anon_sym___constant] = ACTIONS(1092),
    [anon_sym_private] = ACTIONS(1092),
    [anon_sym___private] = ACTIONS(1092),
    [anon_sym_generic] = ACTIONS(1092),
    [anon_sym___generic] = ACTIONS(1092),
    [anon_sym_read_only] = ACTIONS(1092),
    [anon_sym___read_only] = ACTIONS(1092),
    [anon_sym_write_only] = ACTIONS(1092),
    [anon_sym___write_only] = ACTIONS(1092),
    [anon_sym_read_write] = ACTIONS(1092),
    [anon_sym___read_write] = ACTIONS(1092),
    [anon_sym_extern] = ACTIONS(1092),
    [anon_sym___attribute__] = ACTIONS(1092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1094),
    [anon_sym___declspec] = ACTIONS(1092),
    [anon_sym___cdecl] = ACTIONS(1092),
    [anon_sym___clrcall] = ACTIONS(1092),
    [anon_sym___stdcall] = ACTIONS(1092),
    [anon_sym___fastcall] = ACTIONS(1092),
    [anon_sym___thiscall] = ACTIONS(1092),
    [anon_sym___vectorcall] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_RBRACE] = ACTIONS(1094),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_auto] = ACTIONS(1092),
    [anon_sym_register] = ACTIONS(1092),
    [anon_sym_inline] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_volatile] = ACTIONS(1092),
    [anon_sym_restrict] = ACTIONS(1092),
    [anon_sym__Atomic] = ACTIONS(1092),
    [anon_sym_pipe] = ACTIONS(1092),
    [anon_sym_signed] = ACTIONS(1092),
    [anon_sym_unsigned] = ACTIONS(1092),
    [anon_sym_long] = ACTIONS(1092),
    [anon_sym_short] = ACTIONS(1092),
    [anon_sym_bool] = ACTIONS(1092),
    [anon_sym_char] = ACTIONS(1092),
    [anon_sym_uchar] = ACTIONS(1092),
    [anon_sym_ushort] = ACTIONS(1092),
    [anon_sym_int] = ACTIONS(1092),
    [anon_sym_uint] = ACTIONS(1092),
    [anon_sym_ulong] = ACTIONS(1092),
    [anon_sym_float] = ACTIONS(1092),
    [anon_sym_double] = ACTIONS(1092),
    [anon_sym_half] = ACTIONS(1092),
    [anon_sym_size_t] = ACTIONS(1092),
    [anon_sym_ptrdiff_t] = ACTIONS(1092),
    [anon_sym_intptr_t] = ACTIONS(1092),
    [anon_sym_uintptr_t] = ACTIONS(1092),
    [anon_sym_void] = ACTIONS(1092),
    [sym_vector_type] = ACTIONS(1092),
    [anon_sym_image2d_t] = ACTIONS(1092),
    [anon_sym_image3d_t] = ACTIONS(1092),
    [anon_sym_image2d_array_t] = ACTIONS(1092),
    [anon_sym_image1d_t] = ACTIONS(1092),
    [anon_sym_image1d_buffer_t] = ACTIONS(1092),
    [anon_sym_image1d_array_t] = ACTIONS(1092),
    [anon_sym_image2d_depth_t] = ACTIONS(1092),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1092),
    [anon_sym_sampler_t] = ACTIONS(1092),
    [anon_sym_queue_t] = ACTIONS(1092),
    [anon_sym_ndrange_t] = ACTIONS(1092),
    [anon_sym_clk_event_t] = ACTIONS(1092),
    [anon_sym_reserve_id_t] = ACTIONS(1092),
    [anon_sym_event_t] = ACTIONS(1092),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_struct] = ACTIONS(1092),
    [anon_sym_union] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_goto] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_sizeof] = ACTIONS(1092),
    [sym_number_literal] = ACTIONS(1094),
    [anon_sym_L_SQUOTE] = ACTIONS(1094),
    [anon_sym_u_SQUOTE] = ACTIONS(1094),
    [anon_sym_U_SQUOTE] = ACTIONS(1094),
    [anon_sym_u8_SQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_L_DQUOTE] = ACTIONS(1094),
    [anon_sym_u_DQUOTE] = ACTIONS(1094),
    [anon_sym_U_DQUOTE] = ACTIONS(1094),
    [anon_sym_u8_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_identifier] = ACTIONS(1104),
    [aux_sym_preproc_include_token1] = ACTIONS(1104),
    [aux_sym_preproc_def_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token2] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1104),
    [sym_preproc_directive] = ACTIONS(1104),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_typedef] = ACTIONS(1104),
    [anon_sym_kernel] = ACTIONS(1104),
    [anon_sym___kernel] = ACTIONS(1104),
    [anon_sym_global] = ACTIONS(1104),
    [anon_sym___global] = ACTIONS(1104),
    [anon_sym_local] = ACTIONS(1104),
    [anon_sym___local] = ACTIONS(1104),
    [anon_sym_constant] = ACTIONS(1104),
    [anon_sym___constant] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym___private] = ACTIONS(1104),
    [anon_sym_generic] = ACTIONS(1104),
    [anon_sym___generic] = ACTIONS(1104),
    [anon_sym_read_only] = ACTIONS(1104),
    [anon_sym___read_only] = ACTIONS(1104),
    [anon_sym_write_only] = ACTIONS(1104),
    [anon_sym___write_only] = ACTIONS(1104),
    [anon_sym_read_write] = ACTIONS(1104),
    [anon_sym___read_write] = ACTIONS(1104),
    [anon_sym_extern] = ACTIONS(1104),
    [anon_sym___attribute__] = ACTIONS(1104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1106),
    [anon_sym___declspec] = ACTIONS(1104),
    [anon_sym___cdecl] = ACTIONS(1104),
    [anon_sym___clrcall] = ACTIONS(1104),
    [anon_sym___stdcall] = ACTIONS(1104),
    [anon_sym___fastcall] = ACTIONS(1104),
    [anon_sym___thiscall] = ACTIONS(1104),
    [anon_sym___vectorcall] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_auto] = ACTIONS(1104),
    [anon_sym_register] = ACTIONS(1104),
    [anon_sym_inline] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_volatile] = ACTIONS(1104),
    [anon_sym_restrict] = ACTIONS(1104),
    [anon_sym__Atomic] = ACTIONS(1104),
    [anon_sym_pipe] = ACTIONS(1104),
    [anon_sym_signed] = ACTIONS(1104),
    [anon_sym_unsigned] = ACTIONS(1104),
    [anon_sym_long] = ACTIONS(1104),
    [anon_sym_short] = ACTIONS(1104),
    [anon_sym_bool] = ACTIONS(1104),
    [anon_sym_char] = ACTIONS(1104),
    [anon_sym_uchar] = ACTIONS(1104),
    [anon_sym_ushort] = ACTIONS(1104),
    [anon_sym_int] = ACTIONS(1104),
    [anon_sym_uint] = ACTIONS(1104),
    [anon_sym_ulong] = ACTIONS(1104),
    [anon_sym_float] = ACTIONS(1104),
    [anon_sym_double] = ACTIONS(1104),
    [anon_sym_half] = ACTIONS(1104),
    [anon_sym_size_t] = ACTIONS(1104),
    [anon_sym_ptrdiff_t] = ACTIONS(1104),
    [anon_sym_intptr_t] = ACTIONS(1104),
    [anon_sym_uintptr_t] = ACTIONS(1104),
    [anon_sym_void] = ACTIONS(1104),
    [sym_vector_type] = ACTIONS(1104),
    [anon_sym_image2d_t] = ACTIONS(1104),
    [anon_sym_image3d_t] = ACTIONS(1104),
    [anon_sym_image2d_array_t] = ACTIONS(1104),
    [anon_sym_image1d_t] = ACTIONS(1104),
    [anon_sym_image1d_buffer_t] = ACTIONS(1104),
    [anon_sym_image1d_array_t] = ACTIONS(1104),
    [anon_sym_image2d_depth_t] = ACTIONS(1104),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1104),
    [anon_sym_sampler_t] = ACTIONS(1104),
    [anon_sym_queue_t] = ACTIONS(1104),
    [anon_sym_ndrange_t] = ACTIONS(1104),
    [anon_sym_clk_event_t] = ACTIONS(1104),
    [anon_sym_reserve_id_t] = ACTIONS(1104),
    [anon_sym_event_t] = ACTIONS(1104),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [anon_sym_struct] = ACTIONS(1104),
    [anon_sym_union] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_goto] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_sizeof] = ACTIONS(1104),
    [sym_number_literal] = ACTIONS(1106),
    [anon_sym_L_SQUOTE] = ACTIONS(1106),
    [anon_sym_u_SQUOTE] = ACTIONS(1106),
    [anon_sym_U_SQUOTE] = ACTIONS(1106),
    [anon_sym_u8_SQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_L_DQUOTE] = ACTIONS(1106),
    [anon_sym_u_DQUOTE] = ACTIONS(1106),
    [anon_sym_U_DQUOTE] = ACTIONS(1106),
    [anon_sym_u8_DQUOTE] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_identifier] = ACTIONS(1112),
    [aux_sym_preproc_include_token1] = ACTIONS(1112),
    [aux_sym_preproc_def_token1] = ACTIONS(1112),
    [aux_sym_preproc_if_token1] = ACTIONS(1112),
    [aux_sym_preproc_if_token2] = ACTIONS(1112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1112),
    [sym_preproc_directive] = ACTIONS(1112),
    [anon_sym_LPAREN2] = ACTIONS(1114),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_typedef] = ACTIONS(1112),
    [anon_sym_kernel] = ACTIONS(1112),
    [anon_sym___kernel] = ACTIONS(1112),
    [anon_sym_global] = ACTIONS(1112),
    [anon_sym___global] = ACTIONS(1112),
    [anon_sym_local] = ACTIONS(1112),
    [anon_sym___local] = ACTIONS(1112),
    [anon_sym_constant] = ACTIONS(1112),
    [anon_sym___constant] = ACTIONS(1112),
    [anon_sym_private] = ACTIONS(1112),
    [anon_sym___private] = ACTIONS(1112),
    [anon_sym_generic] = ACTIONS(1112),
    [anon_sym___generic] = ACTIONS(1112),
    [anon_sym_read_only] = ACTIONS(1112),
    [anon_sym___read_only] = ACTIONS(1112),
    [anon_sym_write_only] = ACTIONS(1112),
    [anon_sym___write_only] = ACTIONS(1112),
    [anon_sym_read_write] = ACTIONS(1112),
    [anon_sym___read_write] = ACTIONS(1112),
    [anon_sym_extern] = ACTIONS(1112),
    [anon_sym___attribute__] = ACTIONS(1112),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1114),
    [anon_sym___declspec] = ACTIONS(1112),
    [anon_sym___cdecl] = ACTIONS(1112),
    [anon_sym___clrcall] = ACTIONS(1112),
    [anon_sym___stdcall] = ACTIONS(1112),
    [anon_sym___fastcall] = ACTIONS(1112),
    [anon_sym___thiscall] = ACTIONS(1112),
    [anon_sym___vectorcall] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1112),
    [anon_sym_auto] = ACTIONS(1112),
    [anon_sym_register] = ACTIONS(1112),
    [anon_sym_inline] = ACTIONS(1112),
    [anon_sym_const] = ACTIONS(1112),
    [anon_sym_volatile] = ACTIONS(1112),
    [anon_sym_restrict] = ACTIONS(1112),
    [anon_sym__Atomic] = ACTIONS(1112),
    [anon_sym_pipe] = ACTIONS(1112),
    [anon_sym_signed] = ACTIONS(1112),
    [anon_sym_unsigned] = ACTIONS(1112),
    [anon_sym_long] = ACTIONS(1112),
    [anon_sym_short] = ACTIONS(1112),
    [anon_sym_bool] = ACTIONS(1112),
    [anon_sym_char] = ACTIONS(1112),
    [anon_sym_uchar] = ACTIONS(1112),
    [anon_sym_ushort] = ACTIONS(1112),
    [anon_sym_int] = ACTIONS(1112),
    [anon_sym_uint] = ACTIONS(1112),
    [anon_sym_ulong] = ACTIONS(1112),
    [anon_sym_float] = ACTIONS(1112),
    [anon_sym_double] = ACTIONS(1112),
    [anon_sym_half] = ACTIONS(1112),
    [anon_sym_size_t] = ACTIONS(1112),
    [anon_sym_ptrdiff_t] = ACTIONS(1112),
    [anon_sym_intptr_t] = ACTIONS(1112),
    [anon_sym_uintptr_t] = ACTIONS(1112),
    [anon_sym_void] = ACTIONS(1112),
    [sym_vector_type] = ACTIONS(1112),
    [anon_sym_image2d_t] = ACTIONS(1112),
    [anon_sym_image3d_t] = ACTIONS(1112),
    [anon_sym_image2d_array_t] = ACTIONS(1112),
    [anon_sym_image1d_t] = ACTIONS(1112),
    [anon_sym_image1d_buffer_t] = ACTIONS(1112),
    [anon_sym_image1d_array_t] = ACTIONS(1112),
    [anon_sym_image2d_depth_t] = ACTIONS(1112),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1112),
    [anon_sym_sampler_t] = ACTIONS(1112),
    [anon_sym_queue_t] = ACTIONS(1112),
    [anon_sym_ndrange_t] = ACTIONS(1112),
    [anon_sym_clk_event_t] = ACTIONS(1112),
    [anon_sym_reserve_id_t] = ACTIONS(1112),
    [anon_sym_event_t] = ACTIONS(1112),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1112),
    [anon_sym_enum] = ACTIONS(1112),
    [anon_sym_struct] = ACTIONS(1112),
    [anon_sym_union] = ACTIONS(1112),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_switch] = ACTIONS(1112),
    [anon_sym_case] = ACTIONS(1112),
    [anon_sym_default] = ACTIONS(1112),
    [anon_sym_while] = ACTIONS(1112),
    [anon_sym_do] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1112),
    [anon_sym_return] = ACTIONS(1112),
    [anon_sym_break] = ACTIONS(1112),
    [anon_sym_continue] = ACTIONS(1112),
    [anon_sym_goto] = ACTIONS(1112),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_sizeof] = ACTIONS(1112),
    [sym_number_literal] = ACTIONS(1114),
    [anon_sym_L_SQUOTE] = ACTIONS(1114),
    [anon_sym_u_SQUOTE] = ACTIONS(1114),
    [anon_sym_U_SQUOTE] = ACTIONS(1114),
    [anon_sym_u8_SQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [anon_sym_L_DQUOTE] = ACTIONS(1114),
    [anon_sym_u_DQUOTE] = ACTIONS(1114),
    [anon_sym_U_DQUOTE] = ACTIONS(1114),
    [anon_sym_u8_DQUOTE] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [sym_true] = ACTIONS(1112),
    [sym_false] = ACTIONS(1112),
    [sym_null] = ACTIONS(1112),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_identifier] = ACTIONS(1052),
    [aux_sym_preproc_include_token1] = ACTIONS(1052),
    [aux_sym_preproc_def_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token2] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1052),
    [sym_preproc_directive] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_AMP] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_typedef] = ACTIONS(1052),
    [anon_sym_kernel] = ACTIONS(1052),
    [anon_sym___kernel] = ACTIONS(1052),
    [anon_sym_global] = ACTIONS(1052),
    [anon_sym___global] = ACTIONS(1052),
    [anon_sym_local] = ACTIONS(1052),
    [anon_sym___local] = ACTIONS(1052),
    [anon_sym_constant] = ACTIONS(1052),
    [anon_sym___constant] = ACTIONS(1052),
    [anon_sym_private] = ACTIONS(1052),
    [anon_sym___private] = ACTIONS(1052),
    [anon_sym_generic] = ACTIONS(1052),
    [anon_sym___generic] = ACTIONS(1052),
    [anon_sym_read_only] = ACTIONS(1052),
    [anon_sym___read_only] = ACTIONS(1052),
    [anon_sym_write_only] = ACTIONS(1052),
    [anon_sym___write_only] = ACTIONS(1052),
    [anon_sym_read_write] = ACTIONS(1052),
    [anon_sym___read_write] = ACTIONS(1052),
    [anon_sym_extern] = ACTIONS(1052),
    [anon_sym___attribute__] = ACTIONS(1052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1054),
    [anon_sym___declspec] = ACTIONS(1052),
    [anon_sym___cdecl] = ACTIONS(1052),
    [anon_sym___clrcall] = ACTIONS(1052),
    [anon_sym___stdcall] = ACTIONS(1052),
    [anon_sym___fastcall] = ACTIONS(1052),
    [anon_sym___thiscall] = ACTIONS(1052),
    [anon_sym___vectorcall] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_auto] = ACTIONS(1052),
    [anon_sym_register] = ACTIONS(1052),
    [anon_sym_inline] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_volatile] = ACTIONS(1052),
    [anon_sym_restrict] = ACTIONS(1052),
    [anon_sym__Atomic] = ACTIONS(1052),
    [anon_sym_pipe] = ACTIONS(1052),
    [anon_sym_signed] = ACTIONS(1052),
    [anon_sym_unsigned] = ACTIONS(1052),
    [anon_sym_long] = ACTIONS(1052),
    [anon_sym_short] = ACTIONS(1052),
    [anon_sym_bool] = ACTIONS(1052),
    [anon_sym_char] = ACTIONS(1052),
    [anon_sym_uchar] = ACTIONS(1052),
    [anon_sym_ushort] = ACTIONS(1052),
    [anon_sym_int] = ACTIONS(1052),
    [anon_sym_uint] = ACTIONS(1052),
    [anon_sym_ulong] = ACTIONS(1052),
    [anon_sym_float] = ACTIONS(1052),
    [anon_sym_double] = ACTIONS(1052),
    [anon_sym_half] = ACTIONS(1052),
    [anon_sym_size_t] = ACTIONS(1052),
    [anon_sym_ptrdiff_t] = ACTIONS(1052),
    [anon_sym_intptr_t] = ACTIONS(1052),
    [anon_sym_uintptr_t] = ACTIONS(1052),
    [anon_sym_void] = ACTIONS(1052),
    [sym_vector_type] = ACTIONS(1052),
    [anon_sym_image2d_t] = ACTIONS(1052),
    [anon_sym_image3d_t] = ACTIONS(1052),
    [anon_sym_image2d_array_t] = ACTIONS(1052),
    [anon_sym_image1d_t] = ACTIONS(1052),
    [anon_sym_image1d_buffer_t] = ACTIONS(1052),
    [anon_sym_image1d_array_t] = ACTIONS(1052),
    [anon_sym_image2d_depth_t] = ACTIONS(1052),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1052),
    [anon_sym_sampler_t] = ACTIONS(1052),
    [anon_sym_queue_t] = ACTIONS(1052),
    [anon_sym_ndrange_t] = ACTIONS(1052),
    [anon_sym_clk_event_t] = ACTIONS(1052),
    [anon_sym_reserve_id_t] = ACTIONS(1052),
    [anon_sym_event_t] = ACTIONS(1052),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_struct] = ACTIONS(1052),
    [anon_sym_union] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_goto] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_sizeof] = ACTIONS(1052),
    [sym_number_literal] = ACTIONS(1054),
    [anon_sym_L_SQUOTE] = ACTIONS(1054),
    [anon_sym_u_SQUOTE] = ACTIONS(1054),
    [anon_sym_U_SQUOTE] = ACTIONS(1054),
    [anon_sym_u8_SQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [anon_sym_L_DQUOTE] = ACTIONS(1054),
    [anon_sym_u_DQUOTE] = ACTIONS(1054),
    [anon_sym_U_DQUOTE] = ACTIONS(1054),
    [anon_sym_u8_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym_identifier] = ACTIONS(1048),
    [aux_sym_preproc_include_token1] = ACTIONS(1048),
    [aux_sym_preproc_def_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1048),
    [sym_preproc_directive] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_typedef] = ACTIONS(1048),
    [anon_sym_kernel] = ACTIONS(1048),
    [anon_sym___kernel] = ACTIONS(1048),
    [anon_sym_global] = ACTIONS(1048),
    [anon_sym___global] = ACTIONS(1048),
    [anon_sym_local] = ACTIONS(1048),
    [anon_sym___local] = ACTIONS(1048),
    [anon_sym_constant] = ACTIONS(1048),
    [anon_sym___constant] = ACTIONS(1048),
    [anon_sym_private] = ACTIONS(1048),
    [anon_sym___private] = ACTIONS(1048),
    [anon_sym_generic] = ACTIONS(1048),
    [anon_sym___generic] = ACTIONS(1048),
    [anon_sym_read_only] = ACTIONS(1048),
    [anon_sym___read_only] = ACTIONS(1048),
    [anon_sym_write_only] = ACTIONS(1048),
    [anon_sym___write_only] = ACTIONS(1048),
    [anon_sym_read_write] = ACTIONS(1048),
    [anon_sym___read_write] = ACTIONS(1048),
    [anon_sym_extern] = ACTIONS(1048),
    [anon_sym___attribute__] = ACTIONS(1048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1050),
    [anon_sym___declspec] = ACTIONS(1048),
    [anon_sym___cdecl] = ACTIONS(1048),
    [anon_sym___clrcall] = ACTIONS(1048),
    [anon_sym___stdcall] = ACTIONS(1048),
    [anon_sym___fastcall] = ACTIONS(1048),
    [anon_sym___thiscall] = ACTIONS(1048),
    [anon_sym___vectorcall] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1048),
    [anon_sym_auto] = ACTIONS(1048),
    [anon_sym_register] = ACTIONS(1048),
    [anon_sym_inline] = ACTIONS(1048),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_volatile] = ACTIONS(1048),
    [anon_sym_restrict] = ACTIONS(1048),
    [anon_sym__Atomic] = ACTIONS(1048),
    [anon_sym_pipe] = ACTIONS(1048),
    [anon_sym_signed] = ACTIONS(1048),
    [anon_sym_unsigned] = ACTIONS(1048),
    [anon_sym_long] = ACTIONS(1048),
    [anon_sym_short] = ACTIONS(1048),
    [anon_sym_bool] = ACTIONS(1048),
    [anon_sym_char] = ACTIONS(1048),
    [anon_sym_uchar] = ACTIONS(1048),
    [anon_sym_ushort] = ACTIONS(1048),
    [anon_sym_int] = ACTIONS(1048),
    [anon_sym_uint] = ACTIONS(1048),
    [anon_sym_ulong] = ACTIONS(1048),
    [anon_sym_float] = ACTIONS(1048),
    [anon_sym_double] = ACTIONS(1048),
    [anon_sym_half] = ACTIONS(1048),
    [anon_sym_size_t] = ACTIONS(1048),
    [anon_sym_ptrdiff_t] = ACTIONS(1048),
    [anon_sym_intptr_t] = ACTIONS(1048),
    [anon_sym_uintptr_t] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1048),
    [sym_vector_type] = ACTIONS(1048),
    [anon_sym_image2d_t] = ACTIONS(1048),
    [anon_sym_image3d_t] = ACTIONS(1048),
    [anon_sym_image2d_array_t] = ACTIONS(1048),
    [anon_sym_image1d_t] = ACTIONS(1048),
    [anon_sym_image1d_buffer_t] = ACTIONS(1048),
    [anon_sym_image1d_array_t] = ACTIONS(1048),
    [anon_sym_image2d_depth_t] = ACTIONS(1048),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1048),
    [anon_sym_sampler_t] = ACTIONS(1048),
    [anon_sym_queue_t] = ACTIONS(1048),
    [anon_sym_ndrange_t] = ACTIONS(1048),
    [anon_sym_clk_event_t] = ACTIONS(1048),
    [anon_sym_reserve_id_t] = ACTIONS(1048),
    [anon_sym_event_t] = ACTIONS(1048),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1048),
    [anon_sym_enum] = ACTIONS(1048),
    [anon_sym_struct] = ACTIONS(1048),
    [anon_sym_union] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_goto] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_sizeof] = ACTIONS(1048),
    [sym_number_literal] = ACTIONS(1050),
    [anon_sym_L_SQUOTE] = ACTIONS(1050),
    [anon_sym_u_SQUOTE] = ACTIONS(1050),
    [anon_sym_U_SQUOTE] = ACTIONS(1050),
    [anon_sym_u8_SQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_L_DQUOTE] = ACTIONS(1050),
    [anon_sym_u_DQUOTE] = ACTIONS(1050),
    [anon_sym_U_DQUOTE] = ACTIONS(1050),
    [anon_sym_u8_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_identifier] = ACTIONS(1060),
    [aux_sym_preproc_include_token1] = ACTIONS(1060),
    [aux_sym_preproc_def_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1060),
    [sym_preproc_directive] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_typedef] = ACTIONS(1060),
    [anon_sym_kernel] = ACTIONS(1060),
    [anon_sym___kernel] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym___global] = ACTIONS(1060),
    [anon_sym_local] = ACTIONS(1060),
    [anon_sym___local] = ACTIONS(1060),
    [anon_sym_constant] = ACTIONS(1060),
    [anon_sym___constant] = ACTIONS(1060),
    [anon_sym_private] = ACTIONS(1060),
    [anon_sym___private] = ACTIONS(1060),
    [anon_sym_generic] = ACTIONS(1060),
    [anon_sym___generic] = ACTIONS(1060),
    [anon_sym_read_only] = ACTIONS(1060),
    [anon_sym___read_only] = ACTIONS(1060),
    [anon_sym_write_only] = ACTIONS(1060),
    [anon_sym___write_only] = ACTIONS(1060),
    [anon_sym_read_write] = ACTIONS(1060),
    [anon_sym___read_write] = ACTIONS(1060),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym___attribute__] = ACTIONS(1060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1062),
    [anon_sym___declspec] = ACTIONS(1060),
    [anon_sym___cdecl] = ACTIONS(1060),
    [anon_sym___clrcall] = ACTIONS(1060),
    [anon_sym___stdcall] = ACTIONS(1060),
    [anon_sym___fastcall] = ACTIONS(1060),
    [anon_sym___thiscall] = ACTIONS(1060),
    [anon_sym___vectorcall] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1060),
    [anon_sym_auto] = ACTIONS(1060),
    [anon_sym_register] = ACTIONS(1060),
    [anon_sym_inline] = ACTIONS(1060),
    [anon_sym_const] = ACTIONS(1060),
    [anon_sym_volatile] = ACTIONS(1060),
    [anon_sym_restrict] = ACTIONS(1060),
    [anon_sym__Atomic] = ACTIONS(1060),
    [anon_sym_pipe] = ACTIONS(1060),
    [anon_sym_signed] = ACTIONS(1060),
    [anon_sym_unsigned] = ACTIONS(1060),
    [anon_sym_long] = ACTIONS(1060),
    [anon_sym_short] = ACTIONS(1060),
    [anon_sym_bool] = ACTIONS(1060),
    [anon_sym_char] = ACTIONS(1060),
    [anon_sym_uchar] = ACTIONS(1060),
    [anon_sym_ushort] = ACTIONS(1060),
    [anon_sym_int] = ACTIONS(1060),
    [anon_sym_uint] = ACTIONS(1060),
    [anon_sym_ulong] = ACTIONS(1060),
    [anon_sym_float] = ACTIONS(1060),
    [anon_sym_double] = ACTIONS(1060),
    [anon_sym_half] = ACTIONS(1060),
    [anon_sym_size_t] = ACTIONS(1060),
    [anon_sym_ptrdiff_t] = ACTIONS(1060),
    [anon_sym_intptr_t] = ACTIONS(1060),
    [anon_sym_uintptr_t] = ACTIONS(1060),
    [anon_sym_void] = ACTIONS(1060),
    [sym_vector_type] = ACTIONS(1060),
    [anon_sym_image2d_t] = ACTIONS(1060),
    [anon_sym_image3d_t] = ACTIONS(1060),
    [anon_sym_image2d_array_t] = ACTIONS(1060),
    [anon_sym_image1d_t] = ACTIONS(1060),
    [anon_sym_image1d_buffer_t] = ACTIONS(1060),
    [anon_sym_image1d_array_t] = ACTIONS(1060),
    [anon_sym_image2d_depth_t] = ACTIONS(1060),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1060),
    [anon_sym_sampler_t] = ACTIONS(1060),
    [anon_sym_queue_t] = ACTIONS(1060),
    [anon_sym_ndrange_t] = ACTIONS(1060),
    [anon_sym_clk_event_t] = ACTIONS(1060),
    [anon_sym_reserve_id_t] = ACTIONS(1060),
    [anon_sym_event_t] = ACTIONS(1060),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1060),
    [anon_sym_enum] = ACTIONS(1060),
    [anon_sym_struct] = ACTIONS(1060),
    [anon_sym_union] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_switch] = ACTIONS(1060),
    [anon_sym_case] = ACTIONS(1060),
    [anon_sym_default] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_goto] = ACTIONS(1060),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_sizeof] = ACTIONS(1060),
    [sym_number_literal] = ACTIONS(1062),
    [anon_sym_L_SQUOTE] = ACTIONS(1062),
    [anon_sym_u_SQUOTE] = ACTIONS(1062),
    [anon_sym_U_SQUOTE] = ACTIONS(1062),
    [anon_sym_u8_SQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [anon_sym_L_DQUOTE] = ACTIONS(1062),
    [anon_sym_u_DQUOTE] = ACTIONS(1062),
    [anon_sym_U_DQUOTE] = ACTIONS(1062),
    [anon_sym_u8_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_null] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1068),
    [aux_sym_preproc_include_token1] = ACTIONS(1068),
    [aux_sym_preproc_def_token1] = ACTIONS(1068),
    [aux_sym_preproc_if_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1068),
    [sym_preproc_directive] = ACTIONS(1068),
    [anon_sym_LPAREN2] = ACTIONS(1070),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(1070),
    [anon_sym_SEMI] = ACTIONS(1070),
    [anon_sym_typedef] = ACTIONS(1068),
    [anon_sym_kernel] = ACTIONS(1068),
    [anon_sym___kernel] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym___global] = ACTIONS(1068),
    [anon_sym_local] = ACTIONS(1068),
    [anon_sym___local] = ACTIONS(1068),
    [anon_sym_constant] = ACTIONS(1068),
    [anon_sym___constant] = ACTIONS(1068),
    [anon_sym_private] = ACTIONS(1068),
    [anon_sym___private] = ACTIONS(1068),
    [anon_sym_generic] = ACTIONS(1068),
    [anon_sym___generic] = ACTIONS(1068),
    [anon_sym_read_only] = ACTIONS(1068),
    [anon_sym___read_only] = ACTIONS(1068),
    [anon_sym_write_only] = ACTIONS(1068),
    [anon_sym___write_only] = ACTIONS(1068),
    [anon_sym_read_write] = ACTIONS(1068),
    [anon_sym___read_write] = ACTIONS(1068),
    [anon_sym_extern] = ACTIONS(1068),
    [anon_sym___attribute__] = ACTIONS(1068),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1070),
    [anon_sym___declspec] = ACTIONS(1068),
    [anon_sym___cdecl] = ACTIONS(1068),
    [anon_sym___clrcall] = ACTIONS(1068),
    [anon_sym___stdcall] = ACTIONS(1068),
    [anon_sym___fastcall] = ACTIONS(1068),
    [anon_sym___thiscall] = ACTIONS(1068),
    [anon_sym___vectorcall] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1068),
    [anon_sym_auto] = ACTIONS(1068),
    [anon_sym_register] = ACTIONS(1068),
    [anon_sym_inline] = ACTIONS(1068),
    [anon_sym_const] = ACTIONS(1068),
    [anon_sym_volatile] = ACTIONS(1068),
    [anon_sym_restrict] = ACTIONS(1068),
    [anon_sym__Atomic] = ACTIONS(1068),
    [anon_sym_pipe] = ACTIONS(1068),
    [anon_sym_signed] = ACTIONS(1068),
    [anon_sym_unsigned] = ACTIONS(1068),
    [anon_sym_long] = ACTIONS(1068),
    [anon_sym_short] = ACTIONS(1068),
    [anon_sym_bool] = ACTIONS(1068),
    [anon_sym_char] = ACTIONS(1068),
    [anon_sym_uchar] = ACTIONS(1068),
    [anon_sym_ushort] = ACTIONS(1068),
    [anon_sym_int] = ACTIONS(1068),
    [anon_sym_uint] = ACTIONS(1068),
    [anon_sym_ulong] = ACTIONS(1068),
    [anon_sym_float] = ACTIONS(1068),
    [anon_sym_double] = ACTIONS(1068),
    [anon_sym_half] = ACTIONS(1068),
    [anon_sym_size_t] = ACTIONS(1068),
    [anon_sym_ptrdiff_t] = ACTIONS(1068),
    [anon_sym_intptr_t] = ACTIONS(1068),
    [anon_sym_uintptr_t] = ACTIONS(1068),
    [anon_sym_void] = ACTIONS(1068),
    [sym_vector_type] = ACTIONS(1068),
    [anon_sym_image2d_t] = ACTIONS(1068),
    [anon_sym_image3d_t] = ACTIONS(1068),
    [anon_sym_image2d_array_t] = ACTIONS(1068),
    [anon_sym_image1d_t] = ACTIONS(1068),
    [anon_sym_image1d_buffer_t] = ACTIONS(1068),
    [anon_sym_image1d_array_t] = ACTIONS(1068),
    [anon_sym_image2d_depth_t] = ACTIONS(1068),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1068),
    [anon_sym_sampler_t] = ACTIONS(1068),
    [anon_sym_queue_t] = ACTIONS(1068),
    [anon_sym_ndrange_t] = ACTIONS(1068),
    [anon_sym_clk_event_t] = ACTIONS(1068),
    [anon_sym_reserve_id_t] = ACTIONS(1068),
    [anon_sym_event_t] = ACTIONS(1068),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1068),
    [anon_sym_enum] = ACTIONS(1068),
    [anon_sym_struct] = ACTIONS(1068),
    [anon_sym_union] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_case] = ACTIONS(1068),
    [anon_sym_default] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_do] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_goto] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1070),
    [anon_sym_PLUS_PLUS] = ACTIONS(1070),
    [anon_sym_sizeof] = ACTIONS(1068),
    [sym_number_literal] = ACTIONS(1070),
    [anon_sym_L_SQUOTE] = ACTIONS(1070),
    [anon_sym_u_SQUOTE] = ACTIONS(1070),
    [anon_sym_U_SQUOTE] = ACTIONS(1070),
    [anon_sym_u8_SQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [anon_sym_L_DQUOTE] = ACTIONS(1070),
    [anon_sym_u_DQUOTE] = ACTIONS(1070),
    [anon_sym_U_DQUOTE] = ACTIONS(1070),
    [anon_sym_u8_DQUOTE] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_null] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_identifier] = ACTIONS(1100),
    [aux_sym_preproc_include_token1] = ACTIONS(1100),
    [aux_sym_preproc_def_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1100),
    [sym_preproc_directive] = ACTIONS(1100),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_typedef] = ACTIONS(1100),
    [anon_sym_kernel] = ACTIONS(1100),
    [anon_sym___kernel] = ACTIONS(1100),
    [anon_sym_global] = ACTIONS(1100),
    [anon_sym___global] = ACTIONS(1100),
    [anon_sym_local] = ACTIONS(1100),
    [anon_sym___local] = ACTIONS(1100),
    [anon_sym_constant] = ACTIONS(1100),
    [anon_sym___constant] = ACTIONS(1100),
    [anon_sym_private] = ACTIONS(1100),
    [anon_sym___private] = ACTIONS(1100),
    [anon_sym_generic] = ACTIONS(1100),
    [anon_sym___generic] = ACTIONS(1100),
    [anon_sym_read_only] = ACTIONS(1100),
    [anon_sym___read_only] = ACTIONS(1100),
    [anon_sym_write_only] = ACTIONS(1100),
    [anon_sym___write_only] = ACTIONS(1100),
    [anon_sym_read_write] = ACTIONS(1100),
    [anon_sym___read_write] = ACTIONS(1100),
    [anon_sym_extern] = ACTIONS(1100),
    [anon_sym___attribute__] = ACTIONS(1100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1102),
    [anon_sym___declspec] = ACTIONS(1100),
    [anon_sym___cdecl] = ACTIONS(1100),
    [anon_sym___clrcall] = ACTIONS(1100),
    [anon_sym___stdcall] = ACTIONS(1100),
    [anon_sym___fastcall] = ACTIONS(1100),
    [anon_sym___thiscall] = ACTIONS(1100),
    [anon_sym___vectorcall] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_auto] = ACTIONS(1100),
    [anon_sym_register] = ACTIONS(1100),
    [anon_sym_inline] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_volatile] = ACTIONS(1100),
    [anon_sym_restrict] = ACTIONS(1100),
    [anon_sym__Atomic] = ACTIONS(1100),
    [anon_sym_pipe] = ACTIONS(1100),
    [anon_sym_signed] = ACTIONS(1100),
    [anon_sym_unsigned] = ACTIONS(1100),
    [anon_sym_long] = ACTIONS(1100),
    [anon_sym_short] = ACTIONS(1100),
    [anon_sym_bool] = ACTIONS(1100),
    [anon_sym_char] = ACTIONS(1100),
    [anon_sym_uchar] = ACTIONS(1100),
    [anon_sym_ushort] = ACTIONS(1100),
    [anon_sym_int] = ACTIONS(1100),
    [anon_sym_uint] = ACTIONS(1100),
    [anon_sym_ulong] = ACTIONS(1100),
    [anon_sym_float] = ACTIONS(1100),
    [anon_sym_double] = ACTIONS(1100),
    [anon_sym_half] = ACTIONS(1100),
    [anon_sym_size_t] = ACTIONS(1100),
    [anon_sym_ptrdiff_t] = ACTIONS(1100),
    [anon_sym_intptr_t] = ACTIONS(1100),
    [anon_sym_uintptr_t] = ACTIONS(1100),
    [anon_sym_void] = ACTIONS(1100),
    [sym_vector_type] = ACTIONS(1100),
    [anon_sym_image2d_t] = ACTIONS(1100),
    [anon_sym_image3d_t] = ACTIONS(1100),
    [anon_sym_image2d_array_t] = ACTIONS(1100),
    [anon_sym_image1d_t] = ACTIONS(1100),
    [anon_sym_image1d_buffer_t] = ACTIONS(1100),
    [anon_sym_image1d_array_t] = ACTIONS(1100),
    [anon_sym_image2d_depth_t] = ACTIONS(1100),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1100),
    [anon_sym_sampler_t] = ACTIONS(1100),
    [anon_sym_queue_t] = ACTIONS(1100),
    [anon_sym_ndrange_t] = ACTIONS(1100),
    [anon_sym_clk_event_t] = ACTIONS(1100),
    [anon_sym_reserve_id_t] = ACTIONS(1100),
    [anon_sym_event_t] = ACTIONS(1100),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [anon_sym_struct] = ACTIONS(1100),
    [anon_sym_union] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_goto] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_sizeof] = ACTIONS(1100),
    [sym_number_literal] = ACTIONS(1102),
    [anon_sym_L_SQUOTE] = ACTIONS(1102),
    [anon_sym_u_SQUOTE] = ACTIONS(1102),
    [anon_sym_U_SQUOTE] = ACTIONS(1102),
    [anon_sym_u8_SQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_L_DQUOTE] = ACTIONS(1102),
    [anon_sym_u_DQUOTE] = ACTIONS(1102),
    [anon_sym_U_DQUOTE] = ACTIONS(1102),
    [anon_sym_u8_DQUOTE] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_identifier] = ACTIONS(1080),
    [aux_sym_preproc_include_token1] = ACTIONS(1080),
    [aux_sym_preproc_def_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1080),
    [sym_preproc_directive] = ACTIONS(1080),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [anon_sym_typedef] = ACTIONS(1080),
    [anon_sym_kernel] = ACTIONS(1080),
    [anon_sym___kernel] = ACTIONS(1080),
    [anon_sym_global] = ACTIONS(1080),
    [anon_sym___global] = ACTIONS(1080),
    [anon_sym_local] = ACTIONS(1080),
    [anon_sym___local] = ACTIONS(1080),
    [anon_sym_constant] = ACTIONS(1080),
    [anon_sym___constant] = ACTIONS(1080),
    [anon_sym_private] = ACTIONS(1080),
    [anon_sym___private] = ACTIONS(1080),
    [anon_sym_generic] = ACTIONS(1080),
    [anon_sym___generic] = ACTIONS(1080),
    [anon_sym_read_only] = ACTIONS(1080),
    [anon_sym___read_only] = ACTIONS(1080),
    [anon_sym_write_only] = ACTIONS(1080),
    [anon_sym___write_only] = ACTIONS(1080),
    [anon_sym_read_write] = ACTIONS(1080),
    [anon_sym___read_write] = ACTIONS(1080),
    [anon_sym_extern] = ACTIONS(1080),
    [anon_sym___attribute__] = ACTIONS(1080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1082),
    [anon_sym___declspec] = ACTIONS(1080),
    [anon_sym___cdecl] = ACTIONS(1080),
    [anon_sym___clrcall] = ACTIONS(1080),
    [anon_sym___stdcall] = ACTIONS(1080),
    [anon_sym___fastcall] = ACTIONS(1080),
    [anon_sym___thiscall] = ACTIONS(1080),
    [anon_sym___vectorcall] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_RBRACE] = ACTIONS(1082),
    [anon_sym_static] = ACTIONS(1080),
    [anon_sym_auto] = ACTIONS(1080),
    [anon_sym_register] = ACTIONS(1080),
    [anon_sym_inline] = ACTIONS(1080),
    [anon_sym_const] = ACTIONS(1080),
    [anon_sym_volatile] = ACTIONS(1080),
    [anon_sym_restrict] = ACTIONS(1080),
    [anon_sym__Atomic] = ACTIONS(1080),
    [anon_sym_pipe] = ACTIONS(1080),
    [anon_sym_signed] = ACTIONS(1080),
    [anon_sym_unsigned] = ACTIONS(1080),
    [anon_sym_long] = ACTIONS(1080),
    [anon_sym_short] = ACTIONS(1080),
    [anon_sym_bool] = ACTIONS(1080),
    [anon_sym_char] = ACTIONS(1080),
    [anon_sym_uchar] = ACTIONS(1080),
    [anon_sym_ushort] = ACTIONS(1080),
    [anon_sym_int] = ACTIONS(1080),
    [anon_sym_uint] = ACTIONS(1080),
    [anon_sym_ulong] = ACTIONS(1080),
    [anon_sym_float] = ACTIONS(1080),
    [anon_sym_double] = ACTIONS(1080),
    [anon_sym_half] = ACTIONS(1080),
    [anon_sym_size_t] = ACTIONS(1080),
    [anon_sym_ptrdiff_t] = ACTIONS(1080),
    [anon_sym_intptr_t] = ACTIONS(1080),
    [anon_sym_uintptr_t] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1080),
    [sym_vector_type] = ACTIONS(1080),
    [anon_sym_image2d_t] = ACTIONS(1080),
    [anon_sym_image3d_t] = ACTIONS(1080),
    [anon_sym_image2d_array_t] = ACTIONS(1080),
    [anon_sym_image1d_t] = ACTIONS(1080),
    [anon_sym_image1d_buffer_t] = ACTIONS(1080),
    [anon_sym_image1d_array_t] = ACTIONS(1080),
    [anon_sym_image2d_depth_t] = ACTIONS(1080),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1080),
    [anon_sym_sampler_t] = ACTIONS(1080),
    [anon_sym_queue_t] = ACTIONS(1080),
    [anon_sym_ndrange_t] = ACTIONS(1080),
    [anon_sym_clk_event_t] = ACTIONS(1080),
    [anon_sym_reserve_id_t] = ACTIONS(1080),
    [anon_sym_event_t] = ACTIONS(1080),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1080),
    [anon_sym_enum] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1080),
    [anon_sym_union] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1080),
    [anon_sym_do] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1080),
    [anon_sym_return] = ACTIONS(1080),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_goto] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1082),
    [anon_sym_sizeof] = ACTIONS(1080),
    [sym_number_literal] = ACTIONS(1082),
    [anon_sym_L_SQUOTE] = ACTIONS(1082),
    [anon_sym_u_SQUOTE] = ACTIONS(1082),
    [anon_sym_U_SQUOTE] = ACTIONS(1082),
    [anon_sym_u8_SQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_L_DQUOTE] = ACTIONS(1082),
    [anon_sym_u_DQUOTE] = ACTIONS(1082),
    [anon_sym_U_DQUOTE] = ACTIONS(1082),
    [anon_sym_u8_DQUOTE] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_true] = ACTIONS(1080),
    [sym_false] = ACTIONS(1080),
    [sym_null] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(1118),
    [sym_identifier] = ACTIONS(1116),
    [aux_sym_preproc_include_token1] = ACTIONS(1116),
    [aux_sym_preproc_def_token1] = ACTIONS(1116),
    [aux_sym_preproc_if_token1] = ACTIONS(1116),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1116),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1116),
    [sym_preproc_directive] = ACTIONS(1116),
    [anon_sym_LPAREN2] = ACTIONS(1118),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_STAR] = ACTIONS(1118),
    [anon_sym_AMP] = ACTIONS(1118),
    [anon_sym_SEMI] = ACTIONS(1118),
    [anon_sym_typedef] = ACTIONS(1116),
    [anon_sym_kernel] = ACTIONS(1116),
    [anon_sym___kernel] = ACTIONS(1116),
    [anon_sym_global] = ACTIONS(1116),
    [anon_sym___global] = ACTIONS(1116),
    [anon_sym_local] = ACTIONS(1116),
    [anon_sym___local] = ACTIONS(1116),
    [anon_sym_constant] = ACTIONS(1116),
    [anon_sym___constant] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym___private] = ACTIONS(1116),
    [anon_sym_generic] = ACTIONS(1116),
    [anon_sym___generic] = ACTIONS(1116),
    [anon_sym_read_only] = ACTIONS(1116),
    [anon_sym___read_only] = ACTIONS(1116),
    [anon_sym_write_only] = ACTIONS(1116),
    [anon_sym___write_only] = ACTIONS(1116),
    [anon_sym_read_write] = ACTIONS(1116),
    [anon_sym___read_write] = ACTIONS(1116),
    [anon_sym_extern] = ACTIONS(1116),
    [anon_sym___attribute__] = ACTIONS(1116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1118),
    [anon_sym___declspec] = ACTIONS(1116),
    [anon_sym___cdecl] = ACTIONS(1116),
    [anon_sym___clrcall] = ACTIONS(1116),
    [anon_sym___stdcall] = ACTIONS(1116),
    [anon_sym___fastcall] = ACTIONS(1116),
    [anon_sym___thiscall] = ACTIONS(1116),
    [anon_sym___vectorcall] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_auto] = ACTIONS(1116),
    [anon_sym_register] = ACTIONS(1116),
    [anon_sym_inline] = ACTIONS(1116),
    [anon_sym_const] = ACTIONS(1116),
    [anon_sym_volatile] = ACTIONS(1116),
    [anon_sym_restrict] = ACTIONS(1116),
    [anon_sym__Atomic] = ACTIONS(1116),
    [anon_sym_pipe] = ACTIONS(1116),
    [anon_sym_signed] = ACTIONS(1116),
    [anon_sym_unsigned] = ACTIONS(1116),
    [anon_sym_long] = ACTIONS(1116),
    [anon_sym_short] = ACTIONS(1116),
    [anon_sym_bool] = ACTIONS(1116),
    [anon_sym_char] = ACTIONS(1116),
    [anon_sym_uchar] = ACTIONS(1116),
    [anon_sym_ushort] = ACTIONS(1116),
    [anon_sym_int] = ACTIONS(1116),
    [anon_sym_uint] = ACTIONS(1116),
    [anon_sym_ulong] = ACTIONS(1116),
    [anon_sym_float] = ACTIONS(1116),
    [anon_sym_double] = ACTIONS(1116),
    [anon_sym_half] = ACTIONS(1116),
    [anon_sym_size_t] = ACTIONS(1116),
    [anon_sym_ptrdiff_t] = ACTIONS(1116),
    [anon_sym_intptr_t] = ACTIONS(1116),
    [anon_sym_uintptr_t] = ACTIONS(1116),
    [anon_sym_void] = ACTIONS(1116),
    [sym_vector_type] = ACTIONS(1116),
    [anon_sym_image2d_t] = ACTIONS(1116),
    [anon_sym_image3d_t] = ACTIONS(1116),
    [anon_sym_image2d_array_t] = ACTIONS(1116),
    [anon_sym_image1d_t] = ACTIONS(1116),
    [anon_sym_image1d_buffer_t] = ACTIONS(1116),
    [anon_sym_image1d_array_t] = ACTIONS(1116),
    [anon_sym_image2d_depth_t] = ACTIONS(1116),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1116),
    [anon_sym_sampler_t] = ACTIONS(1116),
    [anon_sym_queue_t] = ACTIONS(1116),
    [anon_sym_ndrange_t] = ACTIONS(1116),
    [anon_sym_clk_event_t] = ACTIONS(1116),
    [anon_sym_reserve_id_t] = ACTIONS(1116),
    [anon_sym_event_t] = ACTIONS(1116),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_struct] = ACTIONS(1116),
    [anon_sym_union] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_goto] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1118),
    [anon_sym_PLUS_PLUS] = ACTIONS(1118),
    [anon_sym_sizeof] = ACTIONS(1116),
    [sym_number_literal] = ACTIONS(1118),
    [anon_sym_L_SQUOTE] = ACTIONS(1118),
    [anon_sym_u_SQUOTE] = ACTIONS(1118),
    [anon_sym_U_SQUOTE] = ACTIONS(1118),
    [anon_sym_u8_SQUOTE] = ACTIONS(1118),
    [anon_sym_SQUOTE] = ACTIONS(1118),
    [anon_sym_L_DQUOTE] = ACTIONS(1118),
    [anon_sym_u_DQUOTE] = ACTIONS(1118),
    [anon_sym_U_DQUOTE] = ACTIONS(1118),
    [anon_sym_u8_DQUOTE] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1118),
    [sym_true] = ACTIONS(1116),
    [sym_false] = ACTIONS(1116),
    [sym_null] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_include_token1] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_typedef] = ACTIONS(1096),
    [anon_sym_kernel] = ACTIONS(1096),
    [anon_sym___kernel] = ACTIONS(1096),
    [anon_sym_global] = ACTIONS(1096),
    [anon_sym___global] = ACTIONS(1096),
    [anon_sym_local] = ACTIONS(1096),
    [anon_sym___local] = ACTIONS(1096),
    [anon_sym_constant] = ACTIONS(1096),
    [anon_sym___constant] = ACTIONS(1096),
    [anon_sym_private] = ACTIONS(1096),
    [anon_sym___private] = ACTIONS(1096),
    [anon_sym_generic] = ACTIONS(1096),
    [anon_sym___generic] = ACTIONS(1096),
    [anon_sym_read_only] = ACTIONS(1096),
    [anon_sym___read_only] = ACTIONS(1096),
    [anon_sym_write_only] = ACTIONS(1096),
    [anon_sym___write_only] = ACTIONS(1096),
    [anon_sym_read_write] = ACTIONS(1096),
    [anon_sym___read_write] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1098),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym___cdecl] = ACTIONS(1096),
    [anon_sym___clrcall] = ACTIONS(1096),
    [anon_sym___stdcall] = ACTIONS(1096),
    [anon_sym___fastcall] = ACTIONS(1096),
    [anon_sym___thiscall] = ACTIONS(1096),
    [anon_sym___vectorcall] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_pipe] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [anon_sym_bool] = ACTIONS(1096),
    [anon_sym_char] = ACTIONS(1096),
    [anon_sym_uchar] = ACTIONS(1096),
    [anon_sym_ushort] = ACTIONS(1096),
    [anon_sym_int] = ACTIONS(1096),
    [anon_sym_uint] = ACTIONS(1096),
    [anon_sym_ulong] = ACTIONS(1096),
    [anon_sym_float] = ACTIONS(1096),
    [anon_sym_double] = ACTIONS(1096),
    [anon_sym_half] = ACTIONS(1096),
    [anon_sym_size_t] = ACTIONS(1096),
    [anon_sym_ptrdiff_t] = ACTIONS(1096),
    [anon_sym_intptr_t] = ACTIONS(1096),
    [anon_sym_uintptr_t] = ACTIONS(1096),
    [anon_sym_void] = ACTIONS(1096),
    [sym_vector_type] = ACTIONS(1096),
    [anon_sym_image2d_t] = ACTIONS(1096),
    [anon_sym_image3d_t] = ACTIONS(1096),
    [anon_sym_image2d_array_t] = ACTIONS(1096),
    [anon_sym_image1d_t] = ACTIONS(1096),
    [anon_sym_image1d_buffer_t] = ACTIONS(1096),
    [anon_sym_image1d_array_t] = ACTIONS(1096),
    [anon_sym_image2d_depth_t] = ACTIONS(1096),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1096),
    [anon_sym_sampler_t] = ACTIONS(1096),
    [anon_sym_queue_t] = ACTIONS(1096),
    [anon_sym_ndrange_t] = ACTIONS(1096),
    [anon_sym_clk_event_t] = ACTIONS(1096),
    [anon_sym_reserve_id_t] = ACTIONS(1096),
    [anon_sym_event_t] = ACTIONS(1096),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_goto] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_sizeof] = ACTIONS(1096),
    [sym_number_literal] = ACTIONS(1098),
    [anon_sym_L_SQUOTE] = ACTIONS(1098),
    [anon_sym_u_SQUOTE] = ACTIONS(1098),
    [anon_sym_U_SQUOTE] = ACTIONS(1098),
    [anon_sym_u8_SQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_L_DQUOTE] = ACTIONS(1098),
    [anon_sym_u_DQUOTE] = ACTIONS(1098),
    [anon_sym_U_DQUOTE] = ACTIONS(1098),
    [anon_sym_u8_DQUOTE] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_identifier] = ACTIONS(1104),
    [aux_sym_preproc_include_token1] = ACTIONS(1104),
    [aux_sym_preproc_def_token1] = ACTIONS(1104),
    [aux_sym_preproc_if_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1104),
    [sym_preproc_directive] = ACTIONS(1104),
    [anon_sym_LPAREN2] = ACTIONS(1106),
    [anon_sym_BANG] = ACTIONS(1106),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1106),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_typedef] = ACTIONS(1104),
    [anon_sym_kernel] = ACTIONS(1104),
    [anon_sym___kernel] = ACTIONS(1104),
    [anon_sym_global] = ACTIONS(1104),
    [anon_sym___global] = ACTIONS(1104),
    [anon_sym_local] = ACTIONS(1104),
    [anon_sym___local] = ACTIONS(1104),
    [anon_sym_constant] = ACTIONS(1104),
    [anon_sym___constant] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym___private] = ACTIONS(1104),
    [anon_sym_generic] = ACTIONS(1104),
    [anon_sym___generic] = ACTIONS(1104),
    [anon_sym_read_only] = ACTIONS(1104),
    [anon_sym___read_only] = ACTIONS(1104),
    [anon_sym_write_only] = ACTIONS(1104),
    [anon_sym___write_only] = ACTIONS(1104),
    [anon_sym_read_write] = ACTIONS(1104),
    [anon_sym___read_write] = ACTIONS(1104),
    [anon_sym_extern] = ACTIONS(1104),
    [anon_sym___attribute__] = ACTIONS(1104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1106),
    [anon_sym___declspec] = ACTIONS(1104),
    [anon_sym___cdecl] = ACTIONS(1104),
    [anon_sym___clrcall] = ACTIONS(1104),
    [anon_sym___stdcall] = ACTIONS(1104),
    [anon_sym___fastcall] = ACTIONS(1104),
    [anon_sym___thiscall] = ACTIONS(1104),
    [anon_sym___vectorcall] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_RBRACE] = ACTIONS(1106),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_auto] = ACTIONS(1104),
    [anon_sym_register] = ACTIONS(1104),
    [anon_sym_inline] = ACTIONS(1104),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_volatile] = ACTIONS(1104),
    [anon_sym_restrict] = ACTIONS(1104),
    [anon_sym__Atomic] = ACTIONS(1104),
    [anon_sym_pipe] = ACTIONS(1104),
    [anon_sym_signed] = ACTIONS(1104),
    [anon_sym_unsigned] = ACTIONS(1104),
    [anon_sym_long] = ACTIONS(1104),
    [anon_sym_short] = ACTIONS(1104),
    [anon_sym_bool] = ACTIONS(1104),
    [anon_sym_char] = ACTIONS(1104),
    [anon_sym_uchar] = ACTIONS(1104),
    [anon_sym_ushort] = ACTIONS(1104),
    [anon_sym_int] = ACTIONS(1104),
    [anon_sym_uint] = ACTIONS(1104),
    [anon_sym_ulong] = ACTIONS(1104),
    [anon_sym_float] = ACTIONS(1104),
    [anon_sym_double] = ACTIONS(1104),
    [anon_sym_half] = ACTIONS(1104),
    [anon_sym_size_t] = ACTIONS(1104),
    [anon_sym_ptrdiff_t] = ACTIONS(1104),
    [anon_sym_intptr_t] = ACTIONS(1104),
    [anon_sym_uintptr_t] = ACTIONS(1104),
    [anon_sym_void] = ACTIONS(1104),
    [sym_vector_type] = ACTIONS(1104),
    [anon_sym_image2d_t] = ACTIONS(1104),
    [anon_sym_image3d_t] = ACTIONS(1104),
    [anon_sym_image2d_array_t] = ACTIONS(1104),
    [anon_sym_image1d_t] = ACTIONS(1104),
    [anon_sym_image1d_buffer_t] = ACTIONS(1104),
    [anon_sym_image1d_array_t] = ACTIONS(1104),
    [anon_sym_image2d_depth_t] = ACTIONS(1104),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1104),
    [anon_sym_sampler_t] = ACTIONS(1104),
    [anon_sym_queue_t] = ACTIONS(1104),
    [anon_sym_ndrange_t] = ACTIONS(1104),
    [anon_sym_clk_event_t] = ACTIONS(1104),
    [anon_sym_reserve_id_t] = ACTIONS(1104),
    [anon_sym_event_t] = ACTIONS(1104),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [anon_sym_struct] = ACTIONS(1104),
    [anon_sym_union] = ACTIONS(1104),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_goto] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_sizeof] = ACTIONS(1104),
    [sym_number_literal] = ACTIONS(1106),
    [anon_sym_L_SQUOTE] = ACTIONS(1106),
    [anon_sym_u_SQUOTE] = ACTIONS(1106),
    [anon_sym_U_SQUOTE] = ACTIONS(1106),
    [anon_sym_u8_SQUOTE] = ACTIONS(1106),
    [anon_sym_SQUOTE] = ACTIONS(1106),
    [anon_sym_L_DQUOTE] = ACTIONS(1106),
    [anon_sym_u_DQUOTE] = ACTIONS(1106),
    [anon_sym_U_DQUOTE] = ACTIONS(1106),
    [anon_sym_u8_DQUOTE] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_true] = ACTIONS(1104),
    [sym_false] = ACTIONS(1104),
    [sym_null] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym_identifier] = ACTIONS(1112),
    [aux_sym_preproc_include_token1] = ACTIONS(1112),
    [aux_sym_preproc_def_token1] = ACTIONS(1112),
    [aux_sym_preproc_if_token1] = ACTIONS(1112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1112),
    [sym_preproc_directive] = ACTIONS(1112),
    [anon_sym_LPAREN2] = ACTIONS(1114),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_typedef] = ACTIONS(1112),
    [anon_sym_kernel] = ACTIONS(1112),
    [anon_sym___kernel] = ACTIONS(1112),
    [anon_sym_global] = ACTIONS(1112),
    [anon_sym___global] = ACTIONS(1112),
    [anon_sym_local] = ACTIONS(1112),
    [anon_sym___local] = ACTIONS(1112),
    [anon_sym_constant] = ACTIONS(1112),
    [anon_sym___constant] = ACTIONS(1112),
    [anon_sym_private] = ACTIONS(1112),
    [anon_sym___private] = ACTIONS(1112),
    [anon_sym_generic] = ACTIONS(1112),
    [anon_sym___generic] = ACTIONS(1112),
    [anon_sym_read_only] = ACTIONS(1112),
    [anon_sym___read_only] = ACTIONS(1112),
    [anon_sym_write_only] = ACTIONS(1112),
    [anon_sym___write_only] = ACTIONS(1112),
    [anon_sym_read_write] = ACTIONS(1112),
    [anon_sym___read_write] = ACTIONS(1112),
    [anon_sym_extern] = ACTIONS(1112),
    [anon_sym___attribute__] = ACTIONS(1112),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1114),
    [anon_sym___declspec] = ACTIONS(1112),
    [anon_sym___cdecl] = ACTIONS(1112),
    [anon_sym___clrcall] = ACTIONS(1112),
    [anon_sym___stdcall] = ACTIONS(1112),
    [anon_sym___fastcall] = ACTIONS(1112),
    [anon_sym___thiscall] = ACTIONS(1112),
    [anon_sym___vectorcall] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1112),
    [anon_sym_auto] = ACTIONS(1112),
    [anon_sym_register] = ACTIONS(1112),
    [anon_sym_inline] = ACTIONS(1112),
    [anon_sym_const] = ACTIONS(1112),
    [anon_sym_volatile] = ACTIONS(1112),
    [anon_sym_restrict] = ACTIONS(1112),
    [anon_sym__Atomic] = ACTIONS(1112),
    [anon_sym_pipe] = ACTIONS(1112),
    [anon_sym_signed] = ACTIONS(1112),
    [anon_sym_unsigned] = ACTIONS(1112),
    [anon_sym_long] = ACTIONS(1112),
    [anon_sym_short] = ACTIONS(1112),
    [anon_sym_bool] = ACTIONS(1112),
    [anon_sym_char] = ACTIONS(1112),
    [anon_sym_uchar] = ACTIONS(1112),
    [anon_sym_ushort] = ACTIONS(1112),
    [anon_sym_int] = ACTIONS(1112),
    [anon_sym_uint] = ACTIONS(1112),
    [anon_sym_ulong] = ACTIONS(1112),
    [anon_sym_float] = ACTIONS(1112),
    [anon_sym_double] = ACTIONS(1112),
    [anon_sym_half] = ACTIONS(1112),
    [anon_sym_size_t] = ACTIONS(1112),
    [anon_sym_ptrdiff_t] = ACTIONS(1112),
    [anon_sym_intptr_t] = ACTIONS(1112),
    [anon_sym_uintptr_t] = ACTIONS(1112),
    [anon_sym_void] = ACTIONS(1112),
    [sym_vector_type] = ACTIONS(1112),
    [anon_sym_image2d_t] = ACTIONS(1112),
    [anon_sym_image3d_t] = ACTIONS(1112),
    [anon_sym_image2d_array_t] = ACTIONS(1112),
    [anon_sym_image1d_t] = ACTIONS(1112),
    [anon_sym_image1d_buffer_t] = ACTIONS(1112),
    [anon_sym_image1d_array_t] = ACTIONS(1112),
    [anon_sym_image2d_depth_t] = ACTIONS(1112),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1112),
    [anon_sym_sampler_t] = ACTIONS(1112),
    [anon_sym_queue_t] = ACTIONS(1112),
    [anon_sym_ndrange_t] = ACTIONS(1112),
    [anon_sym_clk_event_t] = ACTIONS(1112),
    [anon_sym_reserve_id_t] = ACTIONS(1112),
    [anon_sym_event_t] = ACTIONS(1112),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1112),
    [anon_sym_enum] = ACTIONS(1112),
    [anon_sym_struct] = ACTIONS(1112),
    [anon_sym_union] = ACTIONS(1112),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_switch] = ACTIONS(1112),
    [anon_sym_case] = ACTIONS(1112),
    [anon_sym_default] = ACTIONS(1112),
    [anon_sym_while] = ACTIONS(1112),
    [anon_sym_do] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1112),
    [anon_sym_return] = ACTIONS(1112),
    [anon_sym_break] = ACTIONS(1112),
    [anon_sym_continue] = ACTIONS(1112),
    [anon_sym_goto] = ACTIONS(1112),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_sizeof] = ACTIONS(1112),
    [sym_number_literal] = ACTIONS(1114),
    [anon_sym_L_SQUOTE] = ACTIONS(1114),
    [anon_sym_u_SQUOTE] = ACTIONS(1114),
    [anon_sym_U_SQUOTE] = ACTIONS(1114),
    [anon_sym_u8_SQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [anon_sym_L_DQUOTE] = ACTIONS(1114),
    [anon_sym_u_DQUOTE] = ACTIONS(1114),
    [anon_sym_U_DQUOTE] = ACTIONS(1114),
    [anon_sym_u8_DQUOTE] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [sym_true] = ACTIONS(1112),
    [sym_false] = ACTIONS(1112),
    [sym_null] = ACTIONS(1112),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(1090),
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_include_token1] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_LPAREN2] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_DASH] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1088),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_typedef] = ACTIONS(1088),
    [anon_sym_kernel] = ACTIONS(1088),
    [anon_sym___kernel] = ACTIONS(1088),
    [anon_sym_global] = ACTIONS(1088),
    [anon_sym___global] = ACTIONS(1088),
    [anon_sym_local] = ACTIONS(1088),
    [anon_sym___local] = ACTIONS(1088),
    [anon_sym_constant] = ACTIONS(1088),
    [anon_sym___constant] = ACTIONS(1088),
    [anon_sym_private] = ACTIONS(1088),
    [anon_sym___private] = ACTIONS(1088),
    [anon_sym_generic] = ACTIONS(1088),
    [anon_sym___generic] = ACTIONS(1088),
    [anon_sym_read_only] = ACTIONS(1088),
    [anon_sym___read_only] = ACTIONS(1088),
    [anon_sym_write_only] = ACTIONS(1088),
    [anon_sym___write_only] = ACTIONS(1088),
    [anon_sym_read_write] = ACTIONS(1088),
    [anon_sym___read_write] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1090),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym___cdecl] = ACTIONS(1088),
    [anon_sym___clrcall] = ACTIONS(1088),
    [anon_sym___stdcall] = ACTIONS(1088),
    [anon_sym___fastcall] = ACTIONS(1088),
    [anon_sym___thiscall] = ACTIONS(1088),
    [anon_sym___vectorcall] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_pipe] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [anon_sym_bool] = ACTIONS(1088),
    [anon_sym_char] = ACTIONS(1088),
    [anon_sym_uchar] = ACTIONS(1088),
    [anon_sym_ushort] = ACTIONS(1088),
    [anon_sym_int] = ACTIONS(1088),
    [anon_sym_uint] = ACTIONS(1088),
    [anon_sym_ulong] = ACTIONS(1088),
    [anon_sym_float] = ACTIONS(1088),
    [anon_sym_double] = ACTIONS(1088),
    [anon_sym_half] = ACTIONS(1088),
    [anon_sym_size_t] = ACTIONS(1088),
    [anon_sym_ptrdiff_t] = ACTIONS(1088),
    [anon_sym_intptr_t] = ACTIONS(1088),
    [anon_sym_uintptr_t] = ACTIONS(1088),
    [anon_sym_void] = ACTIONS(1088),
    [sym_vector_type] = ACTIONS(1088),
    [anon_sym_image2d_t] = ACTIONS(1088),
    [anon_sym_image3d_t] = ACTIONS(1088),
    [anon_sym_image2d_array_t] = ACTIONS(1088),
    [anon_sym_image1d_t] = ACTIONS(1088),
    [anon_sym_image1d_buffer_t] = ACTIONS(1088),
    [anon_sym_image1d_array_t] = ACTIONS(1088),
    [anon_sym_image2d_depth_t] = ACTIONS(1088),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1088),
    [anon_sym_sampler_t] = ACTIONS(1088),
    [anon_sym_queue_t] = ACTIONS(1088),
    [anon_sym_ndrange_t] = ACTIONS(1088),
    [anon_sym_clk_event_t] = ACTIONS(1088),
    [anon_sym_reserve_id_t] = ACTIONS(1088),
    [anon_sym_event_t] = ACTIONS(1088),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_case] = ACTIONS(1088),
    [anon_sym_default] = ACTIONS(1088),
    [anon_sym_while] = ACTIONS(1088),
    [anon_sym_do] = ACTIONS(1088),
    [anon_sym_for] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [anon_sym_goto] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [anon_sym_sizeof] = ACTIONS(1088),
    [sym_number_literal] = ACTIONS(1090),
    [anon_sym_L_SQUOTE] = ACTIONS(1090),
    [anon_sym_u_SQUOTE] = ACTIONS(1090),
    [anon_sym_U_SQUOTE] = ACTIONS(1090),
    [anon_sym_u8_SQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_L_DQUOTE] = ACTIONS(1090),
    [anon_sym_u_DQUOTE] = ACTIONS(1090),
    [anon_sym_U_DQUOTE] = ACTIONS(1090),
    [anon_sym_u8_DQUOTE] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [sym_true] = ACTIONS(1088),
    [sym_false] = ACTIONS(1088),
    [sym_null] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [ts_builtin_sym_end] = ACTIONS(1094),
    [sym_identifier] = ACTIONS(1092),
    [aux_sym_preproc_include_token1] = ACTIONS(1092),
    [aux_sym_preproc_def_token1] = ACTIONS(1092),
    [aux_sym_preproc_if_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1092),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1092),
    [sym_preproc_directive] = ACTIONS(1092),
    [anon_sym_LPAREN2] = ACTIONS(1094),
    [anon_sym_BANG] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_AMP] = ACTIONS(1094),
    [anon_sym_SEMI] = ACTIONS(1094),
    [anon_sym_typedef] = ACTIONS(1092),
    [anon_sym_kernel] = ACTIONS(1092),
    [anon_sym___kernel] = ACTIONS(1092),
    [anon_sym_global] = ACTIONS(1092),
    [anon_sym___global] = ACTIONS(1092),
    [anon_sym_local] = ACTIONS(1092),
    [anon_sym___local] = ACTIONS(1092),
    [anon_sym_constant] = ACTIONS(1092),
    [anon_sym___constant] = ACTIONS(1092),
    [anon_sym_private] = ACTIONS(1092),
    [anon_sym___private] = ACTIONS(1092),
    [anon_sym_generic] = ACTIONS(1092),
    [anon_sym___generic] = ACTIONS(1092),
    [anon_sym_read_only] = ACTIONS(1092),
    [anon_sym___read_only] = ACTIONS(1092),
    [anon_sym_write_only] = ACTIONS(1092),
    [anon_sym___write_only] = ACTIONS(1092),
    [anon_sym_read_write] = ACTIONS(1092),
    [anon_sym___read_write] = ACTIONS(1092),
    [anon_sym_extern] = ACTIONS(1092),
    [anon_sym___attribute__] = ACTIONS(1092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1094),
    [anon_sym___declspec] = ACTIONS(1092),
    [anon_sym___cdecl] = ACTIONS(1092),
    [anon_sym___clrcall] = ACTIONS(1092),
    [anon_sym___stdcall] = ACTIONS(1092),
    [anon_sym___fastcall] = ACTIONS(1092),
    [anon_sym___thiscall] = ACTIONS(1092),
    [anon_sym___vectorcall] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_auto] = ACTIONS(1092),
    [anon_sym_register] = ACTIONS(1092),
    [anon_sym_inline] = ACTIONS(1092),
    [anon_sym_const] = ACTIONS(1092),
    [anon_sym_volatile] = ACTIONS(1092),
    [anon_sym_restrict] = ACTIONS(1092),
    [anon_sym__Atomic] = ACTIONS(1092),
    [anon_sym_pipe] = ACTIONS(1092),
    [anon_sym_signed] = ACTIONS(1092),
    [anon_sym_unsigned] = ACTIONS(1092),
    [anon_sym_long] = ACTIONS(1092),
    [anon_sym_short] = ACTIONS(1092),
    [anon_sym_bool] = ACTIONS(1092),
    [anon_sym_char] = ACTIONS(1092),
    [anon_sym_uchar] = ACTIONS(1092),
    [anon_sym_ushort] = ACTIONS(1092),
    [anon_sym_int] = ACTIONS(1092),
    [anon_sym_uint] = ACTIONS(1092),
    [anon_sym_ulong] = ACTIONS(1092),
    [anon_sym_float] = ACTIONS(1092),
    [anon_sym_double] = ACTIONS(1092),
    [anon_sym_half] = ACTIONS(1092),
    [anon_sym_size_t] = ACTIONS(1092),
    [anon_sym_ptrdiff_t] = ACTIONS(1092),
    [anon_sym_intptr_t] = ACTIONS(1092),
    [anon_sym_uintptr_t] = ACTIONS(1092),
    [anon_sym_void] = ACTIONS(1092),
    [sym_vector_type] = ACTIONS(1092),
    [anon_sym_image2d_t] = ACTIONS(1092),
    [anon_sym_image3d_t] = ACTIONS(1092),
    [anon_sym_image2d_array_t] = ACTIONS(1092),
    [anon_sym_image1d_t] = ACTIONS(1092),
    [anon_sym_image1d_buffer_t] = ACTIONS(1092),
    [anon_sym_image1d_array_t] = ACTIONS(1092),
    [anon_sym_image2d_depth_t] = ACTIONS(1092),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1092),
    [anon_sym_sampler_t] = ACTIONS(1092),
    [anon_sym_queue_t] = ACTIONS(1092),
    [anon_sym_ndrange_t] = ACTIONS(1092),
    [anon_sym_clk_event_t] = ACTIONS(1092),
    [anon_sym_reserve_id_t] = ACTIONS(1092),
    [anon_sym_event_t] = ACTIONS(1092),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1092),
    [anon_sym_enum] = ACTIONS(1092),
    [anon_sym_struct] = ACTIONS(1092),
    [anon_sym_union] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1092),
    [anon_sym_switch] = ACTIONS(1092),
    [anon_sym_case] = ACTIONS(1092),
    [anon_sym_default] = ACTIONS(1092),
    [anon_sym_while] = ACTIONS(1092),
    [anon_sym_do] = ACTIONS(1092),
    [anon_sym_for] = ACTIONS(1092),
    [anon_sym_return] = ACTIONS(1092),
    [anon_sym_break] = ACTIONS(1092),
    [anon_sym_continue] = ACTIONS(1092),
    [anon_sym_goto] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_sizeof] = ACTIONS(1092),
    [sym_number_literal] = ACTIONS(1094),
    [anon_sym_L_SQUOTE] = ACTIONS(1094),
    [anon_sym_u_SQUOTE] = ACTIONS(1094),
    [anon_sym_U_SQUOTE] = ACTIONS(1094),
    [anon_sym_u8_SQUOTE] = ACTIONS(1094),
    [anon_sym_SQUOTE] = ACTIONS(1094),
    [anon_sym_L_DQUOTE] = ACTIONS(1094),
    [anon_sym_u_DQUOTE] = ACTIONS(1094),
    [anon_sym_U_DQUOTE] = ACTIONS(1094),
    [anon_sym_u8_DQUOTE] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [sym_true] = ACTIONS(1092),
    [sym_false] = ACTIONS(1092),
    [sym_null] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_identifier] = ACTIONS(1124),
    [aux_sym_preproc_include_token1] = ACTIONS(1124),
    [aux_sym_preproc_def_token1] = ACTIONS(1124),
    [aux_sym_preproc_if_token1] = ACTIONS(1124),
    [aux_sym_preproc_if_token2] = ACTIONS(1124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1124),
    [sym_preproc_directive] = ACTIONS(1124),
    [anon_sym_LPAREN2] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_STAR] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1126),
    [anon_sym_typedef] = ACTIONS(1124),
    [anon_sym_kernel] = ACTIONS(1124),
    [anon_sym___kernel] = ACTIONS(1124),
    [anon_sym_global] = ACTIONS(1124),
    [anon_sym___global] = ACTIONS(1124),
    [anon_sym_local] = ACTIONS(1124),
    [anon_sym___local] = ACTIONS(1124),
    [anon_sym_constant] = ACTIONS(1124),
    [anon_sym___constant] = ACTIONS(1124),
    [anon_sym_private] = ACTIONS(1124),
    [anon_sym___private] = ACTIONS(1124),
    [anon_sym_generic] = ACTIONS(1124),
    [anon_sym___generic] = ACTIONS(1124),
    [anon_sym_read_only] = ACTIONS(1124),
    [anon_sym___read_only] = ACTIONS(1124),
    [anon_sym_write_only] = ACTIONS(1124),
    [anon_sym___write_only] = ACTIONS(1124),
    [anon_sym_read_write] = ACTIONS(1124),
    [anon_sym___read_write] = ACTIONS(1124),
    [anon_sym_extern] = ACTIONS(1124),
    [anon_sym___attribute__] = ACTIONS(1124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1126),
    [anon_sym___declspec] = ACTIONS(1124),
    [anon_sym___cdecl] = ACTIONS(1124),
    [anon_sym___clrcall] = ACTIONS(1124),
    [anon_sym___stdcall] = ACTIONS(1124),
    [anon_sym___fastcall] = ACTIONS(1124),
    [anon_sym___thiscall] = ACTIONS(1124),
    [anon_sym___vectorcall] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_static] = ACTIONS(1124),
    [anon_sym_auto] = ACTIONS(1124),
    [anon_sym_register] = ACTIONS(1124),
    [anon_sym_inline] = ACTIONS(1124),
    [anon_sym_const] = ACTIONS(1124),
    [anon_sym_volatile] = ACTIONS(1124),
    [anon_sym_restrict] = ACTIONS(1124),
    [anon_sym__Atomic] = ACTIONS(1124),
    [anon_sym_pipe] = ACTIONS(1124),
    [anon_sym_signed] = ACTIONS(1124),
    [anon_sym_unsigned] = ACTIONS(1124),
    [anon_sym_long] = ACTIONS(1124),
    [anon_sym_short] = ACTIONS(1124),
    [anon_sym_bool] = ACTIONS(1124),
    [anon_sym_char] = ACTIONS(1124),
    [anon_sym_uchar] = ACTIONS(1124),
    [anon_sym_ushort] = ACTIONS(1124),
    [anon_sym_int] = ACTIONS(1124),
    [anon_sym_uint] = ACTIONS(1124),
    [anon_sym_ulong] = ACTIONS(1124),
    [anon_sym_float] = ACTIONS(1124),
    [anon_sym_double] = ACTIONS(1124),
    [anon_sym_half] = ACTIONS(1124),
    [anon_sym_size_t] = ACTIONS(1124),
    [anon_sym_ptrdiff_t] = ACTIONS(1124),
    [anon_sym_intptr_t] = ACTIONS(1124),
    [anon_sym_uintptr_t] = ACTIONS(1124),
    [anon_sym_void] = ACTIONS(1124),
    [sym_vector_type] = ACTIONS(1124),
    [anon_sym_image2d_t] = ACTIONS(1124),
    [anon_sym_image3d_t] = ACTIONS(1124),
    [anon_sym_image2d_array_t] = ACTIONS(1124),
    [anon_sym_image1d_t] = ACTIONS(1124),
    [anon_sym_image1d_buffer_t] = ACTIONS(1124),
    [anon_sym_image1d_array_t] = ACTIONS(1124),
    [anon_sym_image2d_depth_t] = ACTIONS(1124),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1124),
    [anon_sym_sampler_t] = ACTIONS(1124),
    [anon_sym_queue_t] = ACTIONS(1124),
    [anon_sym_ndrange_t] = ACTIONS(1124),
    [anon_sym_clk_event_t] = ACTIONS(1124),
    [anon_sym_reserve_id_t] = ACTIONS(1124),
    [anon_sym_event_t] = ACTIONS(1124),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1124),
    [anon_sym_enum] = ACTIONS(1124),
    [anon_sym_struct] = ACTIONS(1124),
    [anon_sym_union] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_switch] = ACTIONS(1124),
    [anon_sym_case] = ACTIONS(1124),
    [anon_sym_default] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_do] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_continue] = ACTIONS(1124),
    [anon_sym_goto] = ACTIONS(1124),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [anon_sym_sizeof] = ACTIONS(1124),
    [sym_number_literal] = ACTIONS(1126),
    [anon_sym_L_SQUOTE] = ACTIONS(1126),
    [anon_sym_u_SQUOTE] = ACTIONS(1126),
    [anon_sym_U_SQUOTE] = ACTIONS(1126),
    [anon_sym_u8_SQUOTE] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [anon_sym_L_DQUOTE] = ACTIONS(1126),
    [anon_sym_u_DQUOTE] = ACTIONS(1126),
    [anon_sym_U_DQUOTE] = ACTIONS(1126),
    [anon_sym_u8_DQUOTE] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_null] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(1050),
    [sym_identifier] = ACTIONS(1048),
    [aux_sym_preproc_include_token1] = ACTIONS(1048),
    [aux_sym_preproc_def_token1] = ACTIONS(1048),
    [aux_sym_preproc_if_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1048),
    [sym_preproc_directive] = ACTIONS(1048),
    [anon_sym_LPAREN2] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1050),
    [anon_sym_typedef] = ACTIONS(1048),
    [anon_sym_kernel] = ACTIONS(1048),
    [anon_sym___kernel] = ACTIONS(1048),
    [anon_sym_global] = ACTIONS(1048),
    [anon_sym___global] = ACTIONS(1048),
    [anon_sym_local] = ACTIONS(1048),
    [anon_sym___local] = ACTIONS(1048),
    [anon_sym_constant] = ACTIONS(1048),
    [anon_sym___constant] = ACTIONS(1048),
    [anon_sym_private] = ACTIONS(1048),
    [anon_sym___private] = ACTIONS(1048),
    [anon_sym_generic] = ACTIONS(1048),
    [anon_sym___generic] = ACTIONS(1048),
    [anon_sym_read_only] = ACTIONS(1048),
    [anon_sym___read_only] = ACTIONS(1048),
    [anon_sym_write_only] = ACTIONS(1048),
    [anon_sym___write_only] = ACTIONS(1048),
    [anon_sym_read_write] = ACTIONS(1048),
    [anon_sym___read_write] = ACTIONS(1048),
    [anon_sym_extern] = ACTIONS(1048),
    [anon_sym___attribute__] = ACTIONS(1048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1050),
    [anon_sym___declspec] = ACTIONS(1048),
    [anon_sym___cdecl] = ACTIONS(1048),
    [anon_sym___clrcall] = ACTIONS(1048),
    [anon_sym___stdcall] = ACTIONS(1048),
    [anon_sym___fastcall] = ACTIONS(1048),
    [anon_sym___thiscall] = ACTIONS(1048),
    [anon_sym___vectorcall] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1048),
    [anon_sym_auto] = ACTIONS(1048),
    [anon_sym_register] = ACTIONS(1048),
    [anon_sym_inline] = ACTIONS(1048),
    [anon_sym_const] = ACTIONS(1048),
    [anon_sym_volatile] = ACTIONS(1048),
    [anon_sym_restrict] = ACTIONS(1048),
    [anon_sym__Atomic] = ACTIONS(1048),
    [anon_sym_pipe] = ACTIONS(1048),
    [anon_sym_signed] = ACTIONS(1048),
    [anon_sym_unsigned] = ACTIONS(1048),
    [anon_sym_long] = ACTIONS(1048),
    [anon_sym_short] = ACTIONS(1048),
    [anon_sym_bool] = ACTIONS(1048),
    [anon_sym_char] = ACTIONS(1048),
    [anon_sym_uchar] = ACTIONS(1048),
    [anon_sym_ushort] = ACTIONS(1048),
    [anon_sym_int] = ACTIONS(1048),
    [anon_sym_uint] = ACTIONS(1048),
    [anon_sym_ulong] = ACTIONS(1048),
    [anon_sym_float] = ACTIONS(1048),
    [anon_sym_double] = ACTIONS(1048),
    [anon_sym_half] = ACTIONS(1048),
    [anon_sym_size_t] = ACTIONS(1048),
    [anon_sym_ptrdiff_t] = ACTIONS(1048),
    [anon_sym_intptr_t] = ACTIONS(1048),
    [anon_sym_uintptr_t] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1048),
    [sym_vector_type] = ACTIONS(1048),
    [anon_sym_image2d_t] = ACTIONS(1048),
    [anon_sym_image3d_t] = ACTIONS(1048),
    [anon_sym_image2d_array_t] = ACTIONS(1048),
    [anon_sym_image1d_t] = ACTIONS(1048),
    [anon_sym_image1d_buffer_t] = ACTIONS(1048),
    [anon_sym_image1d_array_t] = ACTIONS(1048),
    [anon_sym_image2d_depth_t] = ACTIONS(1048),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1048),
    [anon_sym_sampler_t] = ACTIONS(1048),
    [anon_sym_queue_t] = ACTIONS(1048),
    [anon_sym_ndrange_t] = ACTIONS(1048),
    [anon_sym_clk_event_t] = ACTIONS(1048),
    [anon_sym_reserve_id_t] = ACTIONS(1048),
    [anon_sym_event_t] = ACTIONS(1048),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1048),
    [anon_sym_enum] = ACTIONS(1048),
    [anon_sym_struct] = ACTIONS(1048),
    [anon_sym_union] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_while] = ACTIONS(1048),
    [anon_sym_do] = ACTIONS(1048),
    [anon_sym_for] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [anon_sym_goto] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [anon_sym_sizeof] = ACTIONS(1048),
    [sym_number_literal] = ACTIONS(1050),
    [anon_sym_L_SQUOTE] = ACTIONS(1050),
    [anon_sym_u_SQUOTE] = ACTIONS(1050),
    [anon_sym_U_SQUOTE] = ACTIONS(1050),
    [anon_sym_u8_SQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_L_DQUOTE] = ACTIONS(1050),
    [anon_sym_u_DQUOTE] = ACTIONS(1050),
    [anon_sym_U_DQUOTE] = ACTIONS(1050),
    [anon_sym_u8_DQUOTE] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [sym_true] = ACTIONS(1048),
    [sym_false] = ACTIONS(1048),
    [sym_null] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_identifier] = ACTIONS(1124),
    [aux_sym_preproc_include_token1] = ACTIONS(1124),
    [aux_sym_preproc_def_token1] = ACTIONS(1124),
    [aux_sym_preproc_if_token1] = ACTIONS(1124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1124),
    [sym_preproc_directive] = ACTIONS(1124),
    [anon_sym_LPAREN2] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_STAR] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1126),
    [anon_sym_typedef] = ACTIONS(1124),
    [anon_sym_kernel] = ACTIONS(1124),
    [anon_sym___kernel] = ACTIONS(1124),
    [anon_sym_global] = ACTIONS(1124),
    [anon_sym___global] = ACTIONS(1124),
    [anon_sym_local] = ACTIONS(1124),
    [anon_sym___local] = ACTIONS(1124),
    [anon_sym_constant] = ACTIONS(1124),
    [anon_sym___constant] = ACTIONS(1124),
    [anon_sym_private] = ACTIONS(1124),
    [anon_sym___private] = ACTIONS(1124),
    [anon_sym_generic] = ACTIONS(1124),
    [anon_sym___generic] = ACTIONS(1124),
    [anon_sym_read_only] = ACTIONS(1124),
    [anon_sym___read_only] = ACTIONS(1124),
    [anon_sym_write_only] = ACTIONS(1124),
    [anon_sym___write_only] = ACTIONS(1124),
    [anon_sym_read_write] = ACTIONS(1124),
    [anon_sym___read_write] = ACTIONS(1124),
    [anon_sym_extern] = ACTIONS(1124),
    [anon_sym___attribute__] = ACTIONS(1124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1126),
    [anon_sym___declspec] = ACTIONS(1124),
    [anon_sym___cdecl] = ACTIONS(1124),
    [anon_sym___clrcall] = ACTIONS(1124),
    [anon_sym___stdcall] = ACTIONS(1124),
    [anon_sym___fastcall] = ACTIONS(1124),
    [anon_sym___thiscall] = ACTIONS(1124),
    [anon_sym___vectorcall] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [anon_sym_static] = ACTIONS(1124),
    [anon_sym_auto] = ACTIONS(1124),
    [anon_sym_register] = ACTIONS(1124),
    [anon_sym_inline] = ACTIONS(1124),
    [anon_sym_const] = ACTIONS(1124),
    [anon_sym_volatile] = ACTIONS(1124),
    [anon_sym_restrict] = ACTIONS(1124),
    [anon_sym__Atomic] = ACTIONS(1124),
    [anon_sym_pipe] = ACTIONS(1124),
    [anon_sym_signed] = ACTIONS(1124),
    [anon_sym_unsigned] = ACTIONS(1124),
    [anon_sym_long] = ACTIONS(1124),
    [anon_sym_short] = ACTIONS(1124),
    [anon_sym_bool] = ACTIONS(1124),
    [anon_sym_char] = ACTIONS(1124),
    [anon_sym_uchar] = ACTIONS(1124),
    [anon_sym_ushort] = ACTIONS(1124),
    [anon_sym_int] = ACTIONS(1124),
    [anon_sym_uint] = ACTIONS(1124),
    [anon_sym_ulong] = ACTIONS(1124),
    [anon_sym_float] = ACTIONS(1124),
    [anon_sym_double] = ACTIONS(1124),
    [anon_sym_half] = ACTIONS(1124),
    [anon_sym_size_t] = ACTIONS(1124),
    [anon_sym_ptrdiff_t] = ACTIONS(1124),
    [anon_sym_intptr_t] = ACTIONS(1124),
    [anon_sym_uintptr_t] = ACTIONS(1124),
    [anon_sym_void] = ACTIONS(1124),
    [sym_vector_type] = ACTIONS(1124),
    [anon_sym_image2d_t] = ACTIONS(1124),
    [anon_sym_image3d_t] = ACTIONS(1124),
    [anon_sym_image2d_array_t] = ACTIONS(1124),
    [anon_sym_image1d_t] = ACTIONS(1124),
    [anon_sym_image1d_buffer_t] = ACTIONS(1124),
    [anon_sym_image1d_array_t] = ACTIONS(1124),
    [anon_sym_image2d_depth_t] = ACTIONS(1124),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1124),
    [anon_sym_sampler_t] = ACTIONS(1124),
    [anon_sym_queue_t] = ACTIONS(1124),
    [anon_sym_ndrange_t] = ACTIONS(1124),
    [anon_sym_clk_event_t] = ACTIONS(1124),
    [anon_sym_reserve_id_t] = ACTIONS(1124),
    [anon_sym_event_t] = ACTIONS(1124),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1124),
    [anon_sym_enum] = ACTIONS(1124),
    [anon_sym_struct] = ACTIONS(1124),
    [anon_sym_union] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_switch] = ACTIONS(1124),
    [anon_sym_case] = ACTIONS(1124),
    [anon_sym_default] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_do] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_continue] = ACTIONS(1124),
    [anon_sym_goto] = ACTIONS(1124),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [anon_sym_sizeof] = ACTIONS(1124),
    [sym_number_literal] = ACTIONS(1126),
    [anon_sym_L_SQUOTE] = ACTIONS(1126),
    [anon_sym_u_SQUOTE] = ACTIONS(1126),
    [anon_sym_U_SQUOTE] = ACTIONS(1126),
    [anon_sym_u8_SQUOTE] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [anon_sym_L_DQUOTE] = ACTIONS(1126),
    [anon_sym_u_DQUOTE] = ACTIONS(1126),
    [anon_sym_U_DQUOTE] = ACTIONS(1126),
    [anon_sym_u8_DQUOTE] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_null] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1100),
    [aux_sym_preproc_include_token1] = ACTIONS(1100),
    [aux_sym_preproc_def_token1] = ACTIONS(1100),
    [aux_sym_preproc_if_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1100),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1100),
    [sym_preproc_directive] = ACTIONS(1100),
    [anon_sym_LPAREN2] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1102),
    [anon_sym_typedef] = ACTIONS(1100),
    [anon_sym_kernel] = ACTIONS(1100),
    [anon_sym___kernel] = ACTIONS(1100),
    [anon_sym_global] = ACTIONS(1100),
    [anon_sym___global] = ACTIONS(1100),
    [anon_sym_local] = ACTIONS(1100),
    [anon_sym___local] = ACTIONS(1100),
    [anon_sym_constant] = ACTIONS(1100),
    [anon_sym___constant] = ACTIONS(1100),
    [anon_sym_private] = ACTIONS(1100),
    [anon_sym___private] = ACTIONS(1100),
    [anon_sym_generic] = ACTIONS(1100),
    [anon_sym___generic] = ACTIONS(1100),
    [anon_sym_read_only] = ACTIONS(1100),
    [anon_sym___read_only] = ACTIONS(1100),
    [anon_sym_write_only] = ACTIONS(1100),
    [anon_sym___write_only] = ACTIONS(1100),
    [anon_sym_read_write] = ACTIONS(1100),
    [anon_sym___read_write] = ACTIONS(1100),
    [anon_sym_extern] = ACTIONS(1100),
    [anon_sym___attribute__] = ACTIONS(1100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1102),
    [anon_sym___declspec] = ACTIONS(1100),
    [anon_sym___cdecl] = ACTIONS(1100),
    [anon_sym___clrcall] = ACTIONS(1100),
    [anon_sym___stdcall] = ACTIONS(1100),
    [anon_sym___fastcall] = ACTIONS(1100),
    [anon_sym___thiscall] = ACTIONS(1100),
    [anon_sym___vectorcall] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_auto] = ACTIONS(1100),
    [anon_sym_register] = ACTIONS(1100),
    [anon_sym_inline] = ACTIONS(1100),
    [anon_sym_const] = ACTIONS(1100),
    [anon_sym_volatile] = ACTIONS(1100),
    [anon_sym_restrict] = ACTIONS(1100),
    [anon_sym__Atomic] = ACTIONS(1100),
    [anon_sym_pipe] = ACTIONS(1100),
    [anon_sym_signed] = ACTIONS(1100),
    [anon_sym_unsigned] = ACTIONS(1100),
    [anon_sym_long] = ACTIONS(1100),
    [anon_sym_short] = ACTIONS(1100),
    [anon_sym_bool] = ACTIONS(1100),
    [anon_sym_char] = ACTIONS(1100),
    [anon_sym_uchar] = ACTIONS(1100),
    [anon_sym_ushort] = ACTIONS(1100),
    [anon_sym_int] = ACTIONS(1100),
    [anon_sym_uint] = ACTIONS(1100),
    [anon_sym_ulong] = ACTIONS(1100),
    [anon_sym_float] = ACTIONS(1100),
    [anon_sym_double] = ACTIONS(1100),
    [anon_sym_half] = ACTIONS(1100),
    [anon_sym_size_t] = ACTIONS(1100),
    [anon_sym_ptrdiff_t] = ACTIONS(1100),
    [anon_sym_intptr_t] = ACTIONS(1100),
    [anon_sym_uintptr_t] = ACTIONS(1100),
    [anon_sym_void] = ACTIONS(1100),
    [sym_vector_type] = ACTIONS(1100),
    [anon_sym_image2d_t] = ACTIONS(1100),
    [anon_sym_image3d_t] = ACTIONS(1100),
    [anon_sym_image2d_array_t] = ACTIONS(1100),
    [anon_sym_image1d_t] = ACTIONS(1100),
    [anon_sym_image1d_buffer_t] = ACTIONS(1100),
    [anon_sym_image1d_array_t] = ACTIONS(1100),
    [anon_sym_image2d_depth_t] = ACTIONS(1100),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1100),
    [anon_sym_sampler_t] = ACTIONS(1100),
    [anon_sym_queue_t] = ACTIONS(1100),
    [anon_sym_ndrange_t] = ACTIONS(1100),
    [anon_sym_clk_event_t] = ACTIONS(1100),
    [anon_sym_reserve_id_t] = ACTIONS(1100),
    [anon_sym_event_t] = ACTIONS(1100),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [anon_sym_struct] = ACTIONS(1100),
    [anon_sym_union] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_goto] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_sizeof] = ACTIONS(1100),
    [sym_number_literal] = ACTIONS(1102),
    [anon_sym_L_SQUOTE] = ACTIONS(1102),
    [anon_sym_u_SQUOTE] = ACTIONS(1102),
    [anon_sym_U_SQUOTE] = ACTIONS(1102),
    [anon_sym_u8_SQUOTE] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_L_DQUOTE] = ACTIONS(1102),
    [anon_sym_u_DQUOTE] = ACTIONS(1102),
    [anon_sym_U_DQUOTE] = ACTIONS(1102),
    [anon_sym_u8_DQUOTE] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_null] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_identifier] = ACTIONS(1128),
    [aux_sym_preproc_include_token1] = ACTIONS(1128),
    [aux_sym_preproc_def_token1] = ACTIONS(1128),
    [aux_sym_preproc_if_token1] = ACTIONS(1128),
    [aux_sym_preproc_if_token2] = ACTIONS(1128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1128),
    [sym_preproc_directive] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(1130),
    [anon_sym_BANG] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_STAR] = ACTIONS(1130),
    [anon_sym_AMP] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1130),
    [anon_sym_typedef] = ACTIONS(1128),
    [anon_sym_kernel] = ACTIONS(1128),
    [anon_sym___kernel] = ACTIONS(1128),
    [anon_sym_global] = ACTIONS(1128),
    [anon_sym___global] = ACTIONS(1128),
    [anon_sym_local] = ACTIONS(1128),
    [anon_sym___local] = ACTIONS(1128),
    [anon_sym_constant] = ACTIONS(1128),
    [anon_sym___constant] = ACTIONS(1128),
    [anon_sym_private] = ACTIONS(1128),
    [anon_sym___private] = ACTIONS(1128),
    [anon_sym_generic] = ACTIONS(1128),
    [anon_sym___generic] = ACTIONS(1128),
    [anon_sym_read_only] = ACTIONS(1128),
    [anon_sym___read_only] = ACTIONS(1128),
    [anon_sym_write_only] = ACTIONS(1128),
    [anon_sym___write_only] = ACTIONS(1128),
    [anon_sym_read_write] = ACTIONS(1128),
    [anon_sym___read_write] = ACTIONS(1128),
    [anon_sym_extern] = ACTIONS(1128),
    [anon_sym___attribute__] = ACTIONS(1128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1130),
    [anon_sym___declspec] = ACTIONS(1128),
    [anon_sym___cdecl] = ACTIONS(1128),
    [anon_sym___clrcall] = ACTIONS(1128),
    [anon_sym___stdcall] = ACTIONS(1128),
    [anon_sym___fastcall] = ACTIONS(1128),
    [anon_sym___thiscall] = ACTIONS(1128),
    [anon_sym___vectorcall] = ACTIONS(1128),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_static] = ACTIONS(1128),
    [anon_sym_auto] = ACTIONS(1128),
    [anon_sym_register] = ACTIONS(1128),
    [anon_sym_inline] = ACTIONS(1128),
    [anon_sym_const] = ACTIONS(1128),
    [anon_sym_volatile] = ACTIONS(1128),
    [anon_sym_restrict] = ACTIONS(1128),
    [anon_sym__Atomic] = ACTIONS(1128),
    [anon_sym_pipe] = ACTIONS(1128),
    [anon_sym_signed] = ACTIONS(1128),
    [anon_sym_unsigned] = ACTIONS(1128),
    [anon_sym_long] = ACTIONS(1128),
    [anon_sym_short] = ACTIONS(1128),
    [anon_sym_bool] = ACTIONS(1128),
    [anon_sym_char] = ACTIONS(1128),
    [anon_sym_uchar] = ACTIONS(1128),
    [anon_sym_ushort] = ACTIONS(1128),
    [anon_sym_int] = ACTIONS(1128),
    [anon_sym_uint] = ACTIONS(1128),
    [anon_sym_ulong] = ACTIONS(1128),
    [anon_sym_float] = ACTIONS(1128),
    [anon_sym_double] = ACTIONS(1128),
    [anon_sym_half] = ACTIONS(1128),
    [anon_sym_size_t] = ACTIONS(1128),
    [anon_sym_ptrdiff_t] = ACTIONS(1128),
    [anon_sym_intptr_t] = ACTIONS(1128),
    [anon_sym_uintptr_t] = ACTIONS(1128),
    [anon_sym_void] = ACTIONS(1128),
    [sym_vector_type] = ACTIONS(1128),
    [anon_sym_image2d_t] = ACTIONS(1128),
    [anon_sym_image3d_t] = ACTIONS(1128),
    [anon_sym_image2d_array_t] = ACTIONS(1128),
    [anon_sym_image1d_t] = ACTIONS(1128),
    [anon_sym_image1d_buffer_t] = ACTIONS(1128),
    [anon_sym_image1d_array_t] = ACTIONS(1128),
    [anon_sym_image2d_depth_t] = ACTIONS(1128),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1128),
    [anon_sym_sampler_t] = ACTIONS(1128),
    [anon_sym_queue_t] = ACTIONS(1128),
    [anon_sym_ndrange_t] = ACTIONS(1128),
    [anon_sym_clk_event_t] = ACTIONS(1128),
    [anon_sym_reserve_id_t] = ACTIONS(1128),
    [anon_sym_event_t] = ACTIONS(1128),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1128),
    [anon_sym_enum] = ACTIONS(1128),
    [anon_sym_struct] = ACTIONS(1128),
    [anon_sym_union] = ACTIONS(1128),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_switch] = ACTIONS(1128),
    [anon_sym_case] = ACTIONS(1128),
    [anon_sym_default] = ACTIONS(1128),
    [anon_sym_while] = ACTIONS(1128),
    [anon_sym_do] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1128),
    [anon_sym_return] = ACTIONS(1128),
    [anon_sym_break] = ACTIONS(1128),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_goto] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1130),
    [anon_sym_PLUS_PLUS] = ACTIONS(1130),
    [anon_sym_sizeof] = ACTIONS(1128),
    [sym_number_literal] = ACTIONS(1130),
    [anon_sym_L_SQUOTE] = ACTIONS(1130),
    [anon_sym_u_SQUOTE] = ACTIONS(1130),
    [anon_sym_U_SQUOTE] = ACTIONS(1130),
    [anon_sym_u8_SQUOTE] = ACTIONS(1130),
    [anon_sym_SQUOTE] = ACTIONS(1130),
    [anon_sym_L_DQUOTE] = ACTIONS(1130),
    [anon_sym_u_DQUOTE] = ACTIONS(1130),
    [anon_sym_U_DQUOTE] = ACTIONS(1130),
    [anon_sym_u8_DQUOTE] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(1130),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_null] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(1130),
    [sym_identifier] = ACTIONS(1128),
    [aux_sym_preproc_include_token1] = ACTIONS(1128),
    [aux_sym_preproc_def_token1] = ACTIONS(1128),
    [aux_sym_preproc_if_token1] = ACTIONS(1128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1128),
    [sym_preproc_directive] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(1130),
    [anon_sym_BANG] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_STAR] = ACTIONS(1130),
    [anon_sym_AMP] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1130),
    [anon_sym_typedef] = ACTIONS(1128),
    [anon_sym_kernel] = ACTIONS(1128),
    [anon_sym___kernel] = ACTIONS(1128),
    [anon_sym_global] = ACTIONS(1128),
    [anon_sym___global] = ACTIONS(1128),
    [anon_sym_local] = ACTIONS(1128),
    [anon_sym___local] = ACTIONS(1128),
    [anon_sym_constant] = ACTIONS(1128),
    [anon_sym___constant] = ACTIONS(1128),
    [anon_sym_private] = ACTIONS(1128),
    [anon_sym___private] = ACTIONS(1128),
    [anon_sym_generic] = ACTIONS(1128),
    [anon_sym___generic] = ACTIONS(1128),
    [anon_sym_read_only] = ACTIONS(1128),
    [anon_sym___read_only] = ACTIONS(1128),
    [anon_sym_write_only] = ACTIONS(1128),
    [anon_sym___write_only] = ACTIONS(1128),
    [anon_sym_read_write] = ACTIONS(1128),
    [anon_sym___read_write] = ACTIONS(1128),
    [anon_sym_extern] = ACTIONS(1128),
    [anon_sym___attribute__] = ACTIONS(1128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1130),
    [anon_sym___declspec] = ACTIONS(1128),
    [anon_sym___cdecl] = ACTIONS(1128),
    [anon_sym___clrcall] = ACTIONS(1128),
    [anon_sym___stdcall] = ACTIONS(1128),
    [anon_sym___fastcall] = ACTIONS(1128),
    [anon_sym___thiscall] = ACTIONS(1128),
    [anon_sym___vectorcall] = ACTIONS(1128),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_static] = ACTIONS(1128),
    [anon_sym_auto] = ACTIONS(1128),
    [anon_sym_register] = ACTIONS(1128),
    [anon_sym_inline] = ACTIONS(1128),
    [anon_sym_const] = ACTIONS(1128),
    [anon_sym_volatile] = ACTIONS(1128),
    [anon_sym_restrict] = ACTIONS(1128),
    [anon_sym__Atomic] = ACTIONS(1128),
    [anon_sym_pipe] = ACTIONS(1128),
    [anon_sym_signed] = ACTIONS(1128),
    [anon_sym_unsigned] = ACTIONS(1128),
    [anon_sym_long] = ACTIONS(1128),
    [anon_sym_short] = ACTIONS(1128),
    [anon_sym_bool] = ACTIONS(1128),
    [anon_sym_char] = ACTIONS(1128),
    [anon_sym_uchar] = ACTIONS(1128),
    [anon_sym_ushort] = ACTIONS(1128),
    [anon_sym_int] = ACTIONS(1128),
    [anon_sym_uint] = ACTIONS(1128),
    [anon_sym_ulong] = ACTIONS(1128),
    [anon_sym_float] = ACTIONS(1128),
    [anon_sym_double] = ACTIONS(1128),
    [anon_sym_half] = ACTIONS(1128),
    [anon_sym_size_t] = ACTIONS(1128),
    [anon_sym_ptrdiff_t] = ACTIONS(1128),
    [anon_sym_intptr_t] = ACTIONS(1128),
    [anon_sym_uintptr_t] = ACTIONS(1128),
    [anon_sym_void] = ACTIONS(1128),
    [sym_vector_type] = ACTIONS(1128),
    [anon_sym_image2d_t] = ACTIONS(1128),
    [anon_sym_image3d_t] = ACTIONS(1128),
    [anon_sym_image2d_array_t] = ACTIONS(1128),
    [anon_sym_image1d_t] = ACTIONS(1128),
    [anon_sym_image1d_buffer_t] = ACTIONS(1128),
    [anon_sym_image1d_array_t] = ACTIONS(1128),
    [anon_sym_image2d_depth_t] = ACTIONS(1128),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1128),
    [anon_sym_sampler_t] = ACTIONS(1128),
    [anon_sym_queue_t] = ACTIONS(1128),
    [anon_sym_ndrange_t] = ACTIONS(1128),
    [anon_sym_clk_event_t] = ACTIONS(1128),
    [anon_sym_reserve_id_t] = ACTIONS(1128),
    [anon_sym_event_t] = ACTIONS(1128),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1128),
    [anon_sym_enum] = ACTIONS(1128),
    [anon_sym_struct] = ACTIONS(1128),
    [anon_sym_union] = ACTIONS(1128),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_switch] = ACTIONS(1128),
    [anon_sym_case] = ACTIONS(1128),
    [anon_sym_default] = ACTIONS(1128),
    [anon_sym_while] = ACTIONS(1128),
    [anon_sym_do] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1128),
    [anon_sym_return] = ACTIONS(1128),
    [anon_sym_break] = ACTIONS(1128),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_goto] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1130),
    [anon_sym_PLUS_PLUS] = ACTIONS(1130),
    [anon_sym_sizeof] = ACTIONS(1128),
    [sym_number_literal] = ACTIONS(1130),
    [anon_sym_L_SQUOTE] = ACTIONS(1130),
    [anon_sym_u_SQUOTE] = ACTIONS(1130),
    [anon_sym_U_SQUOTE] = ACTIONS(1130),
    [anon_sym_u8_SQUOTE] = ACTIONS(1130),
    [anon_sym_SQUOTE] = ACTIONS(1130),
    [anon_sym_L_DQUOTE] = ACTIONS(1130),
    [anon_sym_u_DQUOTE] = ACTIONS(1130),
    [anon_sym_U_DQUOTE] = ACTIONS(1130),
    [anon_sym_u8_DQUOTE] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(1130),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_null] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym_identifier] = ACTIONS(1120),
    [aux_sym_preproc_include_token1] = ACTIONS(1120),
    [aux_sym_preproc_def_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1120),
    [sym_preproc_directive] = ACTIONS(1120),
    [anon_sym_LPAREN2] = ACTIONS(1122),
    [anon_sym_BANG] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1122),
    [anon_sym_AMP] = ACTIONS(1122),
    [anon_sym_SEMI] = ACTIONS(1122),
    [anon_sym_typedef] = ACTIONS(1120),
    [anon_sym_kernel] = ACTIONS(1120),
    [anon_sym___kernel] = ACTIONS(1120),
    [anon_sym_global] = ACTIONS(1120),
    [anon_sym___global] = ACTIONS(1120),
    [anon_sym_local] = ACTIONS(1120),
    [anon_sym___local] = ACTIONS(1120),
    [anon_sym_constant] = ACTIONS(1120),
    [anon_sym___constant] = ACTIONS(1120),
    [anon_sym_private] = ACTIONS(1120),
    [anon_sym___private] = ACTIONS(1120),
    [anon_sym_generic] = ACTIONS(1120),
    [anon_sym___generic] = ACTIONS(1120),
    [anon_sym_read_only] = ACTIONS(1120),
    [anon_sym___read_only] = ACTIONS(1120),
    [anon_sym_write_only] = ACTIONS(1120),
    [anon_sym___write_only] = ACTIONS(1120),
    [anon_sym_read_write] = ACTIONS(1120),
    [anon_sym___read_write] = ACTIONS(1120),
    [anon_sym_extern] = ACTIONS(1120),
    [anon_sym___attribute__] = ACTIONS(1120),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1122),
    [anon_sym___declspec] = ACTIONS(1120),
    [anon_sym___cdecl] = ACTIONS(1120),
    [anon_sym___clrcall] = ACTIONS(1120),
    [anon_sym___stdcall] = ACTIONS(1120),
    [anon_sym___fastcall] = ACTIONS(1120),
    [anon_sym___thiscall] = ACTIONS(1120),
    [anon_sym___vectorcall] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_RBRACE] = ACTIONS(1122),
    [anon_sym_static] = ACTIONS(1120),
    [anon_sym_auto] = ACTIONS(1120),
    [anon_sym_register] = ACTIONS(1120),
    [anon_sym_inline] = ACTIONS(1120),
    [anon_sym_const] = ACTIONS(1120),
    [anon_sym_volatile] = ACTIONS(1120),
    [anon_sym_restrict] = ACTIONS(1120),
    [anon_sym__Atomic] = ACTIONS(1120),
    [anon_sym_pipe] = ACTIONS(1120),
    [anon_sym_signed] = ACTIONS(1120),
    [anon_sym_unsigned] = ACTIONS(1120),
    [anon_sym_long] = ACTIONS(1120),
    [anon_sym_short] = ACTIONS(1120),
    [anon_sym_bool] = ACTIONS(1120),
    [anon_sym_char] = ACTIONS(1120),
    [anon_sym_uchar] = ACTIONS(1120),
    [anon_sym_ushort] = ACTIONS(1120),
    [anon_sym_int] = ACTIONS(1120),
    [anon_sym_uint] = ACTIONS(1120),
    [anon_sym_ulong] = ACTIONS(1120),
    [anon_sym_float] = ACTIONS(1120),
    [anon_sym_double] = ACTIONS(1120),
    [anon_sym_half] = ACTIONS(1120),
    [anon_sym_size_t] = ACTIONS(1120),
    [anon_sym_ptrdiff_t] = ACTIONS(1120),
    [anon_sym_intptr_t] = ACTIONS(1120),
    [anon_sym_uintptr_t] = ACTIONS(1120),
    [anon_sym_void] = ACTIONS(1120),
    [sym_vector_type] = ACTIONS(1120),
    [anon_sym_image2d_t] = ACTIONS(1120),
    [anon_sym_image3d_t] = ACTIONS(1120),
    [anon_sym_image2d_array_t] = ACTIONS(1120),
    [anon_sym_image1d_t] = ACTIONS(1120),
    [anon_sym_image1d_buffer_t] = ACTIONS(1120),
    [anon_sym_image1d_array_t] = ACTIONS(1120),
    [anon_sym_image2d_depth_t] = ACTIONS(1120),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1120),
    [anon_sym_sampler_t] = ACTIONS(1120),
    [anon_sym_queue_t] = ACTIONS(1120),
    [anon_sym_ndrange_t] = ACTIONS(1120),
    [anon_sym_clk_event_t] = ACTIONS(1120),
    [anon_sym_reserve_id_t] = ACTIONS(1120),
    [anon_sym_event_t] = ACTIONS(1120),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1120),
    [anon_sym_enum] = ACTIONS(1120),
    [anon_sym_struct] = ACTIONS(1120),
    [anon_sym_union] = ACTIONS(1120),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(1120),
    [anon_sym_case] = ACTIONS(1120),
    [anon_sym_default] = ACTIONS(1120),
    [anon_sym_while] = ACTIONS(1120),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_for] = ACTIONS(1120),
    [anon_sym_return] = ACTIONS(1120),
    [anon_sym_break] = ACTIONS(1120),
    [anon_sym_continue] = ACTIONS(1120),
    [anon_sym_goto] = ACTIONS(1120),
    [anon_sym_DASH_DASH] = ACTIONS(1122),
    [anon_sym_PLUS_PLUS] = ACTIONS(1122),
    [anon_sym_sizeof] = ACTIONS(1120),
    [sym_number_literal] = ACTIONS(1122),
    [anon_sym_L_SQUOTE] = ACTIONS(1122),
    [anon_sym_u_SQUOTE] = ACTIONS(1122),
    [anon_sym_U_SQUOTE] = ACTIONS(1122),
    [anon_sym_u8_SQUOTE] = ACTIONS(1122),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [anon_sym_L_DQUOTE] = ACTIONS(1122),
    [anon_sym_u_DQUOTE] = ACTIONS(1122),
    [anon_sym_U_DQUOTE] = ACTIONS(1122),
    [anon_sym_u8_DQUOTE] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [sym_true] = ACTIONS(1120),
    [sym_false] = ACTIONS(1120),
    [sym_null] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1112),
    [aux_sym_preproc_include_token1] = ACTIONS(1112),
    [aux_sym_preproc_def_token1] = ACTIONS(1112),
    [aux_sym_preproc_if_token1] = ACTIONS(1112),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1112),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1112),
    [sym_preproc_directive] = ACTIONS(1112),
    [anon_sym_LPAREN2] = ACTIONS(1114),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_STAR] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_SEMI] = ACTIONS(1114),
    [anon_sym_typedef] = ACTIONS(1112),
    [anon_sym_kernel] = ACTIONS(1112),
    [anon_sym___kernel] = ACTIONS(1112),
    [anon_sym_global] = ACTIONS(1112),
    [anon_sym___global] = ACTIONS(1112),
    [anon_sym_local] = ACTIONS(1112),
    [anon_sym___local] = ACTIONS(1112),
    [anon_sym_constant] = ACTIONS(1112),
    [anon_sym___constant] = ACTIONS(1112),
    [anon_sym_private] = ACTIONS(1112),
    [anon_sym___private] = ACTIONS(1112),
    [anon_sym_generic] = ACTIONS(1112),
    [anon_sym___generic] = ACTIONS(1112),
    [anon_sym_read_only] = ACTIONS(1112),
    [anon_sym___read_only] = ACTIONS(1112),
    [anon_sym_write_only] = ACTIONS(1112),
    [anon_sym___write_only] = ACTIONS(1112),
    [anon_sym_read_write] = ACTIONS(1112),
    [anon_sym___read_write] = ACTIONS(1112),
    [anon_sym_extern] = ACTIONS(1112),
    [anon_sym___attribute__] = ACTIONS(1112),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1114),
    [anon_sym___declspec] = ACTIONS(1112),
    [anon_sym___cdecl] = ACTIONS(1112),
    [anon_sym___clrcall] = ACTIONS(1112),
    [anon_sym___stdcall] = ACTIONS(1112),
    [anon_sym___fastcall] = ACTIONS(1112),
    [anon_sym___thiscall] = ACTIONS(1112),
    [anon_sym___vectorcall] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_static] = ACTIONS(1112),
    [anon_sym_auto] = ACTIONS(1112),
    [anon_sym_register] = ACTIONS(1112),
    [anon_sym_inline] = ACTIONS(1112),
    [anon_sym_const] = ACTIONS(1112),
    [anon_sym_volatile] = ACTIONS(1112),
    [anon_sym_restrict] = ACTIONS(1112),
    [anon_sym__Atomic] = ACTIONS(1112),
    [anon_sym_pipe] = ACTIONS(1112),
    [anon_sym_signed] = ACTIONS(1112),
    [anon_sym_unsigned] = ACTIONS(1112),
    [anon_sym_long] = ACTIONS(1112),
    [anon_sym_short] = ACTIONS(1112),
    [anon_sym_bool] = ACTIONS(1112),
    [anon_sym_char] = ACTIONS(1112),
    [anon_sym_uchar] = ACTIONS(1112),
    [anon_sym_ushort] = ACTIONS(1112),
    [anon_sym_int] = ACTIONS(1112),
    [anon_sym_uint] = ACTIONS(1112),
    [anon_sym_ulong] = ACTIONS(1112),
    [anon_sym_float] = ACTIONS(1112),
    [anon_sym_double] = ACTIONS(1112),
    [anon_sym_half] = ACTIONS(1112),
    [anon_sym_size_t] = ACTIONS(1112),
    [anon_sym_ptrdiff_t] = ACTIONS(1112),
    [anon_sym_intptr_t] = ACTIONS(1112),
    [anon_sym_uintptr_t] = ACTIONS(1112),
    [anon_sym_void] = ACTIONS(1112),
    [sym_vector_type] = ACTIONS(1112),
    [anon_sym_image2d_t] = ACTIONS(1112),
    [anon_sym_image3d_t] = ACTIONS(1112),
    [anon_sym_image2d_array_t] = ACTIONS(1112),
    [anon_sym_image1d_t] = ACTIONS(1112),
    [anon_sym_image1d_buffer_t] = ACTIONS(1112),
    [anon_sym_image1d_array_t] = ACTIONS(1112),
    [anon_sym_image2d_depth_t] = ACTIONS(1112),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1112),
    [anon_sym_sampler_t] = ACTIONS(1112),
    [anon_sym_queue_t] = ACTIONS(1112),
    [anon_sym_ndrange_t] = ACTIONS(1112),
    [anon_sym_clk_event_t] = ACTIONS(1112),
    [anon_sym_reserve_id_t] = ACTIONS(1112),
    [anon_sym_event_t] = ACTIONS(1112),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1112),
    [anon_sym_enum] = ACTIONS(1112),
    [anon_sym_struct] = ACTIONS(1112),
    [anon_sym_union] = ACTIONS(1112),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_switch] = ACTIONS(1112),
    [anon_sym_case] = ACTIONS(1112),
    [anon_sym_default] = ACTIONS(1112),
    [anon_sym_while] = ACTIONS(1112),
    [anon_sym_do] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1112),
    [anon_sym_return] = ACTIONS(1112),
    [anon_sym_break] = ACTIONS(1112),
    [anon_sym_continue] = ACTIONS(1112),
    [anon_sym_goto] = ACTIONS(1112),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_sizeof] = ACTIONS(1112),
    [sym_number_literal] = ACTIONS(1114),
    [anon_sym_L_SQUOTE] = ACTIONS(1114),
    [anon_sym_u_SQUOTE] = ACTIONS(1114),
    [anon_sym_U_SQUOTE] = ACTIONS(1114),
    [anon_sym_u8_SQUOTE] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [anon_sym_L_DQUOTE] = ACTIONS(1114),
    [anon_sym_u_DQUOTE] = ACTIONS(1114),
    [anon_sym_U_DQUOTE] = ACTIONS(1114),
    [anon_sym_u8_DQUOTE] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [sym_true] = ACTIONS(1112),
    [sym_false] = ACTIONS(1112),
    [sym_null] = ACTIONS(1112),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym_identifier] = ACTIONS(1052),
    [aux_sym_preproc_include_token1] = ACTIONS(1052),
    [aux_sym_preproc_def_token1] = ACTIONS(1052),
    [aux_sym_preproc_if_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1052),
    [sym_preproc_directive] = ACTIONS(1052),
    [anon_sym_LPAREN2] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_AMP] = ACTIONS(1054),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_typedef] = ACTIONS(1052),
    [anon_sym_kernel] = ACTIONS(1052),
    [anon_sym___kernel] = ACTIONS(1052),
    [anon_sym_global] = ACTIONS(1052),
    [anon_sym___global] = ACTIONS(1052),
    [anon_sym_local] = ACTIONS(1052),
    [anon_sym___local] = ACTIONS(1052),
    [anon_sym_constant] = ACTIONS(1052),
    [anon_sym___constant] = ACTIONS(1052),
    [anon_sym_private] = ACTIONS(1052),
    [anon_sym___private] = ACTIONS(1052),
    [anon_sym_generic] = ACTIONS(1052),
    [anon_sym___generic] = ACTIONS(1052),
    [anon_sym_read_only] = ACTIONS(1052),
    [anon_sym___read_only] = ACTIONS(1052),
    [anon_sym_write_only] = ACTIONS(1052),
    [anon_sym___write_only] = ACTIONS(1052),
    [anon_sym_read_write] = ACTIONS(1052),
    [anon_sym___read_write] = ACTIONS(1052),
    [anon_sym_extern] = ACTIONS(1052),
    [anon_sym___attribute__] = ACTIONS(1052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1054),
    [anon_sym___declspec] = ACTIONS(1052),
    [anon_sym___cdecl] = ACTIONS(1052),
    [anon_sym___clrcall] = ACTIONS(1052),
    [anon_sym___stdcall] = ACTIONS(1052),
    [anon_sym___fastcall] = ACTIONS(1052),
    [anon_sym___thiscall] = ACTIONS(1052),
    [anon_sym___vectorcall] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_RBRACE] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1052),
    [anon_sym_auto] = ACTIONS(1052),
    [anon_sym_register] = ACTIONS(1052),
    [anon_sym_inline] = ACTIONS(1052),
    [anon_sym_const] = ACTIONS(1052),
    [anon_sym_volatile] = ACTIONS(1052),
    [anon_sym_restrict] = ACTIONS(1052),
    [anon_sym__Atomic] = ACTIONS(1052),
    [anon_sym_pipe] = ACTIONS(1052),
    [anon_sym_signed] = ACTIONS(1052),
    [anon_sym_unsigned] = ACTIONS(1052),
    [anon_sym_long] = ACTIONS(1052),
    [anon_sym_short] = ACTIONS(1052),
    [anon_sym_bool] = ACTIONS(1052),
    [anon_sym_char] = ACTIONS(1052),
    [anon_sym_uchar] = ACTIONS(1052),
    [anon_sym_ushort] = ACTIONS(1052),
    [anon_sym_int] = ACTIONS(1052),
    [anon_sym_uint] = ACTIONS(1052),
    [anon_sym_ulong] = ACTIONS(1052),
    [anon_sym_float] = ACTIONS(1052),
    [anon_sym_double] = ACTIONS(1052),
    [anon_sym_half] = ACTIONS(1052),
    [anon_sym_size_t] = ACTIONS(1052),
    [anon_sym_ptrdiff_t] = ACTIONS(1052),
    [anon_sym_intptr_t] = ACTIONS(1052),
    [anon_sym_uintptr_t] = ACTIONS(1052),
    [anon_sym_void] = ACTIONS(1052),
    [sym_vector_type] = ACTIONS(1052),
    [anon_sym_image2d_t] = ACTIONS(1052),
    [anon_sym_image3d_t] = ACTIONS(1052),
    [anon_sym_image2d_array_t] = ACTIONS(1052),
    [anon_sym_image1d_t] = ACTIONS(1052),
    [anon_sym_image1d_buffer_t] = ACTIONS(1052),
    [anon_sym_image1d_array_t] = ACTIONS(1052),
    [anon_sym_image2d_depth_t] = ACTIONS(1052),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1052),
    [anon_sym_sampler_t] = ACTIONS(1052),
    [anon_sym_queue_t] = ACTIONS(1052),
    [anon_sym_ndrange_t] = ACTIONS(1052),
    [anon_sym_clk_event_t] = ACTIONS(1052),
    [anon_sym_reserve_id_t] = ACTIONS(1052),
    [anon_sym_event_t] = ACTIONS(1052),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1052),
    [anon_sym_enum] = ACTIONS(1052),
    [anon_sym_struct] = ACTIONS(1052),
    [anon_sym_union] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_while] = ACTIONS(1052),
    [anon_sym_do] = ACTIONS(1052),
    [anon_sym_for] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [anon_sym_goto] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [anon_sym_sizeof] = ACTIONS(1052),
    [sym_number_literal] = ACTIONS(1054),
    [anon_sym_L_SQUOTE] = ACTIONS(1054),
    [anon_sym_u_SQUOTE] = ACTIONS(1054),
    [anon_sym_U_SQUOTE] = ACTIONS(1054),
    [anon_sym_u8_SQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [anon_sym_L_DQUOTE] = ACTIONS(1054),
    [anon_sym_u_DQUOTE] = ACTIONS(1054),
    [anon_sym_U_DQUOTE] = ACTIONS(1054),
    [anon_sym_u8_DQUOTE] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [sym_true] = ACTIONS(1052),
    [sym_false] = ACTIONS(1052),
    [sym_null] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_identifier] = ACTIONS(1124),
    [aux_sym_preproc_include_token1] = ACTIONS(1124),
    [aux_sym_preproc_def_token1] = ACTIONS(1124),
    [aux_sym_preproc_if_token1] = ACTIONS(1124),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1124),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1124),
    [sym_preproc_directive] = ACTIONS(1124),
    [anon_sym_LPAREN2] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_STAR] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1126),
    [anon_sym_typedef] = ACTIONS(1124),
    [anon_sym_kernel] = ACTIONS(1124),
    [anon_sym___kernel] = ACTIONS(1124),
    [anon_sym_global] = ACTIONS(1124),
    [anon_sym___global] = ACTIONS(1124),
    [anon_sym_local] = ACTIONS(1124),
    [anon_sym___local] = ACTIONS(1124),
    [anon_sym_constant] = ACTIONS(1124),
    [anon_sym___constant] = ACTIONS(1124),
    [anon_sym_private] = ACTIONS(1124),
    [anon_sym___private] = ACTIONS(1124),
    [anon_sym_generic] = ACTIONS(1124),
    [anon_sym___generic] = ACTIONS(1124),
    [anon_sym_read_only] = ACTIONS(1124),
    [anon_sym___read_only] = ACTIONS(1124),
    [anon_sym_write_only] = ACTIONS(1124),
    [anon_sym___write_only] = ACTIONS(1124),
    [anon_sym_read_write] = ACTIONS(1124),
    [anon_sym___read_write] = ACTIONS(1124),
    [anon_sym_extern] = ACTIONS(1124),
    [anon_sym___attribute__] = ACTIONS(1124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1126),
    [anon_sym___declspec] = ACTIONS(1124),
    [anon_sym___cdecl] = ACTIONS(1124),
    [anon_sym___clrcall] = ACTIONS(1124),
    [anon_sym___stdcall] = ACTIONS(1124),
    [anon_sym___fastcall] = ACTIONS(1124),
    [anon_sym___thiscall] = ACTIONS(1124),
    [anon_sym___vectorcall] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_static] = ACTIONS(1124),
    [anon_sym_auto] = ACTIONS(1124),
    [anon_sym_register] = ACTIONS(1124),
    [anon_sym_inline] = ACTIONS(1124),
    [anon_sym_const] = ACTIONS(1124),
    [anon_sym_volatile] = ACTIONS(1124),
    [anon_sym_restrict] = ACTIONS(1124),
    [anon_sym__Atomic] = ACTIONS(1124),
    [anon_sym_pipe] = ACTIONS(1124),
    [anon_sym_signed] = ACTIONS(1124),
    [anon_sym_unsigned] = ACTIONS(1124),
    [anon_sym_long] = ACTIONS(1124),
    [anon_sym_short] = ACTIONS(1124),
    [anon_sym_bool] = ACTIONS(1124),
    [anon_sym_char] = ACTIONS(1124),
    [anon_sym_uchar] = ACTIONS(1124),
    [anon_sym_ushort] = ACTIONS(1124),
    [anon_sym_int] = ACTIONS(1124),
    [anon_sym_uint] = ACTIONS(1124),
    [anon_sym_ulong] = ACTIONS(1124),
    [anon_sym_float] = ACTIONS(1124),
    [anon_sym_double] = ACTIONS(1124),
    [anon_sym_half] = ACTIONS(1124),
    [anon_sym_size_t] = ACTIONS(1124),
    [anon_sym_ptrdiff_t] = ACTIONS(1124),
    [anon_sym_intptr_t] = ACTIONS(1124),
    [anon_sym_uintptr_t] = ACTIONS(1124),
    [anon_sym_void] = ACTIONS(1124),
    [sym_vector_type] = ACTIONS(1124),
    [anon_sym_image2d_t] = ACTIONS(1124),
    [anon_sym_image3d_t] = ACTIONS(1124),
    [anon_sym_image2d_array_t] = ACTIONS(1124),
    [anon_sym_image1d_t] = ACTIONS(1124),
    [anon_sym_image1d_buffer_t] = ACTIONS(1124),
    [anon_sym_image1d_array_t] = ACTIONS(1124),
    [anon_sym_image2d_depth_t] = ACTIONS(1124),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1124),
    [anon_sym_sampler_t] = ACTIONS(1124),
    [anon_sym_queue_t] = ACTIONS(1124),
    [anon_sym_ndrange_t] = ACTIONS(1124),
    [anon_sym_clk_event_t] = ACTIONS(1124),
    [anon_sym_reserve_id_t] = ACTIONS(1124),
    [anon_sym_event_t] = ACTIONS(1124),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1124),
    [anon_sym_enum] = ACTIONS(1124),
    [anon_sym_struct] = ACTIONS(1124),
    [anon_sym_union] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_switch] = ACTIONS(1124),
    [anon_sym_case] = ACTIONS(1124),
    [anon_sym_default] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_do] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_continue] = ACTIONS(1124),
    [anon_sym_goto] = ACTIONS(1124),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [anon_sym_sizeof] = ACTIONS(1124),
    [sym_number_literal] = ACTIONS(1126),
    [anon_sym_L_SQUOTE] = ACTIONS(1126),
    [anon_sym_u_SQUOTE] = ACTIONS(1126),
    [anon_sym_U_SQUOTE] = ACTIONS(1126),
    [anon_sym_u8_SQUOTE] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [anon_sym_L_DQUOTE] = ACTIONS(1126),
    [anon_sym_u_DQUOTE] = ACTIONS(1126),
    [anon_sym_U_DQUOTE] = ACTIONS(1126),
    [anon_sym_u8_DQUOTE] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_null] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(1078),
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_include_token1] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [anon_sym_typedef] = ACTIONS(1076),
    [anon_sym_kernel] = ACTIONS(1076),
    [anon_sym___kernel] = ACTIONS(1076),
    [anon_sym_global] = ACTIONS(1076),
    [anon_sym___global] = ACTIONS(1076),
    [anon_sym_local] = ACTIONS(1076),
    [anon_sym___local] = ACTIONS(1076),
    [anon_sym_constant] = ACTIONS(1076),
    [anon_sym___constant] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym___private] = ACTIONS(1076),
    [anon_sym_generic] = ACTIONS(1076),
    [anon_sym___generic] = ACTIONS(1076),
    [anon_sym_read_only] = ACTIONS(1076),
    [anon_sym___read_only] = ACTIONS(1076),
    [anon_sym_write_only] = ACTIONS(1076),
    [anon_sym___write_only] = ACTIONS(1076),
    [anon_sym_read_write] = ACTIONS(1076),
    [anon_sym___read_write] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1078),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym___cdecl] = ACTIONS(1076),
    [anon_sym___clrcall] = ACTIONS(1076),
    [anon_sym___stdcall] = ACTIONS(1076),
    [anon_sym___fastcall] = ACTIONS(1076),
    [anon_sym___thiscall] = ACTIONS(1076),
    [anon_sym___vectorcall] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_pipe] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [anon_sym_bool] = ACTIONS(1076),
    [anon_sym_char] = ACTIONS(1076),
    [anon_sym_uchar] = ACTIONS(1076),
    [anon_sym_ushort] = ACTIONS(1076),
    [anon_sym_int] = ACTIONS(1076),
    [anon_sym_uint] = ACTIONS(1076),
    [anon_sym_ulong] = ACTIONS(1076),
    [anon_sym_float] = ACTIONS(1076),
    [anon_sym_double] = ACTIONS(1076),
    [anon_sym_half] = ACTIONS(1076),
    [anon_sym_size_t] = ACTIONS(1076),
    [anon_sym_ptrdiff_t] = ACTIONS(1076),
    [anon_sym_intptr_t] = ACTIONS(1076),
    [anon_sym_uintptr_t] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1076),
    [sym_vector_type] = ACTIONS(1076),
    [anon_sym_image2d_t] = ACTIONS(1076),
    [anon_sym_image3d_t] = ACTIONS(1076),
    [anon_sym_image2d_array_t] = ACTIONS(1076),
    [anon_sym_image1d_t] = ACTIONS(1076),
    [anon_sym_image1d_buffer_t] = ACTIONS(1076),
    [anon_sym_image1d_array_t] = ACTIONS(1076),
    [anon_sym_image2d_depth_t] = ACTIONS(1076),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1076),
    [anon_sym_sampler_t] = ACTIONS(1076),
    [anon_sym_queue_t] = ACTIONS(1076),
    [anon_sym_ndrange_t] = ACTIONS(1076),
    [anon_sym_clk_event_t] = ACTIONS(1076),
    [anon_sym_reserve_id_t] = ACTIONS(1076),
    [anon_sym_event_t] = ACTIONS(1076),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1076),
    [anon_sym_default] = ACTIONS(1076),
    [anon_sym_while] = ACTIONS(1076),
    [anon_sym_do] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1076),
    [anon_sym_return] = ACTIONS(1076),
    [anon_sym_break] = ACTIONS(1076),
    [anon_sym_continue] = ACTIONS(1076),
    [anon_sym_goto] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [anon_sym_sizeof] = ACTIONS(1076),
    [sym_number_literal] = ACTIONS(1078),
    [anon_sym_L_SQUOTE] = ACTIONS(1078),
    [anon_sym_u_SQUOTE] = ACTIONS(1078),
    [anon_sym_U_SQUOTE] = ACTIONS(1078),
    [anon_sym_u8_SQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_L_DQUOTE] = ACTIONS(1078),
    [anon_sym_u_DQUOTE] = ACTIONS(1078),
    [anon_sym_U_DQUOTE] = ACTIONS(1078),
    [anon_sym_u8_DQUOTE] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_true] = ACTIONS(1076),
    [sym_false] = ACTIONS(1076),
    [sym_null] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(1066),
    [sym_identifier] = ACTIONS(1064),
    [aux_sym_preproc_include_token1] = ACTIONS(1064),
    [aux_sym_preproc_def_token1] = ACTIONS(1064),
    [aux_sym_preproc_if_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1064),
    [sym_preproc_directive] = ACTIONS(1064),
    [anon_sym_LPAREN2] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1066),
    [anon_sym_typedef] = ACTIONS(1064),
    [anon_sym_kernel] = ACTIONS(1064),
    [anon_sym___kernel] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym___global] = ACTIONS(1064),
    [anon_sym_local] = ACTIONS(1064),
    [anon_sym___local] = ACTIONS(1064),
    [anon_sym_constant] = ACTIONS(1064),
    [anon_sym___constant] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1064),
    [anon_sym___private] = ACTIONS(1064),
    [anon_sym_generic] = ACTIONS(1064),
    [anon_sym___generic] = ACTIONS(1064),
    [anon_sym_read_only] = ACTIONS(1064),
    [anon_sym___read_only] = ACTIONS(1064),
    [anon_sym_write_only] = ACTIONS(1064),
    [anon_sym___write_only] = ACTIONS(1064),
    [anon_sym_read_write] = ACTIONS(1064),
    [anon_sym___read_write] = ACTIONS(1064),
    [anon_sym_extern] = ACTIONS(1064),
    [anon_sym___attribute__] = ACTIONS(1064),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1066),
    [anon_sym___declspec] = ACTIONS(1064),
    [anon_sym___cdecl] = ACTIONS(1064),
    [anon_sym___clrcall] = ACTIONS(1064),
    [anon_sym___stdcall] = ACTIONS(1064),
    [anon_sym___fastcall] = ACTIONS(1064),
    [anon_sym___thiscall] = ACTIONS(1064),
    [anon_sym___vectorcall] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_auto] = ACTIONS(1064),
    [anon_sym_register] = ACTIONS(1064),
    [anon_sym_inline] = ACTIONS(1064),
    [anon_sym_const] = ACTIONS(1064),
    [anon_sym_volatile] = ACTIONS(1064),
    [anon_sym_restrict] = ACTIONS(1064),
    [anon_sym__Atomic] = ACTIONS(1064),
    [anon_sym_pipe] = ACTIONS(1064),
    [anon_sym_signed] = ACTIONS(1064),
    [anon_sym_unsigned] = ACTIONS(1064),
    [anon_sym_long] = ACTIONS(1064),
    [anon_sym_short] = ACTIONS(1064),
    [anon_sym_bool] = ACTIONS(1064),
    [anon_sym_char] = ACTIONS(1064),
    [anon_sym_uchar] = ACTIONS(1064),
    [anon_sym_ushort] = ACTIONS(1064),
    [anon_sym_int] = ACTIONS(1064),
    [anon_sym_uint] = ACTIONS(1064),
    [anon_sym_ulong] = ACTIONS(1064),
    [anon_sym_float] = ACTIONS(1064),
    [anon_sym_double] = ACTIONS(1064),
    [anon_sym_half] = ACTIONS(1064),
    [anon_sym_size_t] = ACTIONS(1064),
    [anon_sym_ptrdiff_t] = ACTIONS(1064),
    [anon_sym_intptr_t] = ACTIONS(1064),
    [anon_sym_uintptr_t] = ACTIONS(1064),
    [anon_sym_void] = ACTIONS(1064),
    [sym_vector_type] = ACTIONS(1064),
    [anon_sym_image2d_t] = ACTIONS(1064),
    [anon_sym_image3d_t] = ACTIONS(1064),
    [anon_sym_image2d_array_t] = ACTIONS(1064),
    [anon_sym_image1d_t] = ACTIONS(1064),
    [anon_sym_image1d_buffer_t] = ACTIONS(1064),
    [anon_sym_image1d_array_t] = ACTIONS(1064),
    [anon_sym_image2d_depth_t] = ACTIONS(1064),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1064),
    [anon_sym_sampler_t] = ACTIONS(1064),
    [anon_sym_queue_t] = ACTIONS(1064),
    [anon_sym_ndrange_t] = ACTIONS(1064),
    [anon_sym_clk_event_t] = ACTIONS(1064),
    [anon_sym_reserve_id_t] = ACTIONS(1064),
    [anon_sym_event_t] = ACTIONS(1064),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1064),
    [anon_sym_enum] = ACTIONS(1064),
    [anon_sym_struct] = ACTIONS(1064),
    [anon_sym_union] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_do] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_goto] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1064),
    [sym_number_literal] = ACTIONS(1066),
    [anon_sym_L_SQUOTE] = ACTIONS(1066),
    [anon_sym_u_SQUOTE] = ACTIONS(1066),
    [anon_sym_U_SQUOTE] = ACTIONS(1066),
    [anon_sym_u8_SQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_L_DQUOTE] = ACTIONS(1066),
    [anon_sym_u_DQUOTE] = ACTIONS(1066),
    [anon_sym_U_DQUOTE] = ACTIONS(1066),
    [anon_sym_u8_DQUOTE] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_null] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1060),
    [aux_sym_preproc_include_token1] = ACTIONS(1060),
    [aux_sym_preproc_def_token1] = ACTIONS(1060),
    [aux_sym_preproc_if_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1060),
    [sym_preproc_directive] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_AMP] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [anon_sym_typedef] = ACTIONS(1060),
    [anon_sym_kernel] = ACTIONS(1060),
    [anon_sym___kernel] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym___global] = ACTIONS(1060),
    [anon_sym_local] = ACTIONS(1060),
    [anon_sym___local] = ACTIONS(1060),
    [anon_sym_constant] = ACTIONS(1060),
    [anon_sym___constant] = ACTIONS(1060),
    [anon_sym_private] = ACTIONS(1060),
    [anon_sym___private] = ACTIONS(1060),
    [anon_sym_generic] = ACTIONS(1060),
    [anon_sym___generic] = ACTIONS(1060),
    [anon_sym_read_only] = ACTIONS(1060),
    [anon_sym___read_only] = ACTIONS(1060),
    [anon_sym_write_only] = ACTIONS(1060),
    [anon_sym___write_only] = ACTIONS(1060),
    [anon_sym_read_write] = ACTIONS(1060),
    [anon_sym___read_write] = ACTIONS(1060),
    [anon_sym_extern] = ACTIONS(1060),
    [anon_sym___attribute__] = ACTIONS(1060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1062),
    [anon_sym___declspec] = ACTIONS(1060),
    [anon_sym___cdecl] = ACTIONS(1060),
    [anon_sym___clrcall] = ACTIONS(1060),
    [anon_sym___stdcall] = ACTIONS(1060),
    [anon_sym___fastcall] = ACTIONS(1060),
    [anon_sym___thiscall] = ACTIONS(1060),
    [anon_sym___vectorcall] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1060),
    [anon_sym_auto] = ACTIONS(1060),
    [anon_sym_register] = ACTIONS(1060),
    [anon_sym_inline] = ACTIONS(1060),
    [anon_sym_const] = ACTIONS(1060),
    [anon_sym_volatile] = ACTIONS(1060),
    [anon_sym_restrict] = ACTIONS(1060),
    [anon_sym__Atomic] = ACTIONS(1060),
    [anon_sym_pipe] = ACTIONS(1060),
    [anon_sym_signed] = ACTIONS(1060),
    [anon_sym_unsigned] = ACTIONS(1060),
    [anon_sym_long] = ACTIONS(1060),
    [anon_sym_short] = ACTIONS(1060),
    [anon_sym_bool] = ACTIONS(1060),
    [anon_sym_char] = ACTIONS(1060),
    [anon_sym_uchar] = ACTIONS(1060),
    [anon_sym_ushort] = ACTIONS(1060),
    [anon_sym_int] = ACTIONS(1060),
    [anon_sym_uint] = ACTIONS(1060),
    [anon_sym_ulong] = ACTIONS(1060),
    [anon_sym_float] = ACTIONS(1060),
    [anon_sym_double] = ACTIONS(1060),
    [anon_sym_half] = ACTIONS(1060),
    [anon_sym_size_t] = ACTIONS(1060),
    [anon_sym_ptrdiff_t] = ACTIONS(1060),
    [anon_sym_intptr_t] = ACTIONS(1060),
    [anon_sym_uintptr_t] = ACTIONS(1060),
    [anon_sym_void] = ACTIONS(1060),
    [sym_vector_type] = ACTIONS(1060),
    [anon_sym_image2d_t] = ACTIONS(1060),
    [anon_sym_image3d_t] = ACTIONS(1060),
    [anon_sym_image2d_array_t] = ACTIONS(1060),
    [anon_sym_image1d_t] = ACTIONS(1060),
    [anon_sym_image1d_buffer_t] = ACTIONS(1060),
    [anon_sym_image1d_array_t] = ACTIONS(1060),
    [anon_sym_image2d_depth_t] = ACTIONS(1060),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1060),
    [anon_sym_sampler_t] = ACTIONS(1060),
    [anon_sym_queue_t] = ACTIONS(1060),
    [anon_sym_ndrange_t] = ACTIONS(1060),
    [anon_sym_clk_event_t] = ACTIONS(1060),
    [anon_sym_reserve_id_t] = ACTIONS(1060),
    [anon_sym_event_t] = ACTIONS(1060),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1060),
    [anon_sym_enum] = ACTIONS(1060),
    [anon_sym_struct] = ACTIONS(1060),
    [anon_sym_union] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_switch] = ACTIONS(1060),
    [anon_sym_case] = ACTIONS(1060),
    [anon_sym_default] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_do] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_goto] = ACTIONS(1060),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [anon_sym_sizeof] = ACTIONS(1060),
    [sym_number_literal] = ACTIONS(1062),
    [anon_sym_L_SQUOTE] = ACTIONS(1062),
    [anon_sym_u_SQUOTE] = ACTIONS(1062),
    [anon_sym_U_SQUOTE] = ACTIONS(1062),
    [anon_sym_u8_SQUOTE] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [anon_sym_L_DQUOTE] = ACTIONS(1062),
    [anon_sym_u_DQUOTE] = ACTIONS(1062),
    [anon_sym_U_DQUOTE] = ACTIONS(1062),
    [anon_sym_u8_DQUOTE] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_null] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_include_token1] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token2] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [anon_sym_typedef] = ACTIONS(1076),
    [anon_sym_kernel] = ACTIONS(1076),
    [anon_sym___kernel] = ACTIONS(1076),
    [anon_sym_global] = ACTIONS(1076),
    [anon_sym___global] = ACTIONS(1076),
    [anon_sym_local] = ACTIONS(1076),
    [anon_sym___local] = ACTIONS(1076),
    [anon_sym_constant] = ACTIONS(1076),
    [anon_sym___constant] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym___private] = ACTIONS(1076),
    [anon_sym_generic] = ACTIONS(1076),
    [anon_sym___generic] = ACTIONS(1076),
    [anon_sym_read_only] = ACTIONS(1076),
    [anon_sym___read_only] = ACTIONS(1076),
    [anon_sym_write_only] = ACTIONS(1076),
    [anon_sym___write_only] = ACTIONS(1076),
    [anon_sym_read_write] = ACTIONS(1076),
    [anon_sym___read_write] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1078),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym___cdecl] = ACTIONS(1076),
    [anon_sym___clrcall] = ACTIONS(1076),
    [anon_sym___stdcall] = ACTIONS(1076),
    [anon_sym___fastcall] = ACTIONS(1076),
    [anon_sym___thiscall] = ACTIONS(1076),
    [anon_sym___vectorcall] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_pipe] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [anon_sym_bool] = ACTIONS(1076),
    [anon_sym_char] = ACTIONS(1076),
    [anon_sym_uchar] = ACTIONS(1076),
    [anon_sym_ushort] = ACTIONS(1076),
    [anon_sym_int] = ACTIONS(1076),
    [anon_sym_uint] = ACTIONS(1076),
    [anon_sym_ulong] = ACTIONS(1076),
    [anon_sym_float] = ACTIONS(1076),
    [anon_sym_double] = ACTIONS(1076),
    [anon_sym_half] = ACTIONS(1076),
    [anon_sym_size_t] = ACTIONS(1076),
    [anon_sym_ptrdiff_t] = ACTIONS(1076),
    [anon_sym_intptr_t] = ACTIONS(1076),
    [anon_sym_uintptr_t] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1076),
    [sym_vector_type] = ACTIONS(1076),
    [anon_sym_image2d_t] = ACTIONS(1076),
    [anon_sym_image3d_t] = ACTIONS(1076),
    [anon_sym_image2d_array_t] = ACTIONS(1076),
    [anon_sym_image1d_t] = ACTIONS(1076),
    [anon_sym_image1d_buffer_t] = ACTIONS(1076),
    [anon_sym_image1d_array_t] = ACTIONS(1076),
    [anon_sym_image2d_depth_t] = ACTIONS(1076),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1076),
    [anon_sym_sampler_t] = ACTIONS(1076),
    [anon_sym_queue_t] = ACTIONS(1076),
    [anon_sym_ndrange_t] = ACTIONS(1076),
    [anon_sym_clk_event_t] = ACTIONS(1076),
    [anon_sym_reserve_id_t] = ACTIONS(1076),
    [anon_sym_event_t] = ACTIONS(1076),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1076),
    [anon_sym_default] = ACTIONS(1076),
    [anon_sym_while] = ACTIONS(1076),
    [anon_sym_do] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1076),
    [anon_sym_return] = ACTIONS(1076),
    [anon_sym_break] = ACTIONS(1076),
    [anon_sym_continue] = ACTIONS(1076),
    [anon_sym_goto] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [anon_sym_sizeof] = ACTIONS(1076),
    [sym_number_literal] = ACTIONS(1078),
    [anon_sym_L_SQUOTE] = ACTIONS(1078),
    [anon_sym_u_SQUOTE] = ACTIONS(1078),
    [anon_sym_U_SQUOTE] = ACTIONS(1078),
    [anon_sym_u8_SQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_L_DQUOTE] = ACTIONS(1078),
    [anon_sym_u_DQUOTE] = ACTIONS(1078),
    [anon_sym_U_DQUOTE] = ACTIONS(1078),
    [anon_sym_u8_DQUOTE] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_true] = ACTIONS(1076),
    [sym_false] = ACTIONS(1076),
    [sym_null] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_identifier] = ACTIONS(1128),
    [aux_sym_preproc_include_token1] = ACTIONS(1128),
    [aux_sym_preproc_def_token1] = ACTIONS(1128),
    [aux_sym_preproc_if_token1] = ACTIONS(1128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1128),
    [sym_preproc_directive] = ACTIONS(1128),
    [anon_sym_LPAREN2] = ACTIONS(1130),
    [anon_sym_BANG] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_STAR] = ACTIONS(1130),
    [anon_sym_AMP] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1130),
    [anon_sym_typedef] = ACTIONS(1128),
    [anon_sym_kernel] = ACTIONS(1128),
    [anon_sym___kernel] = ACTIONS(1128),
    [anon_sym_global] = ACTIONS(1128),
    [anon_sym___global] = ACTIONS(1128),
    [anon_sym_local] = ACTIONS(1128),
    [anon_sym___local] = ACTIONS(1128),
    [anon_sym_constant] = ACTIONS(1128),
    [anon_sym___constant] = ACTIONS(1128),
    [anon_sym_private] = ACTIONS(1128),
    [anon_sym___private] = ACTIONS(1128),
    [anon_sym_generic] = ACTIONS(1128),
    [anon_sym___generic] = ACTIONS(1128),
    [anon_sym_read_only] = ACTIONS(1128),
    [anon_sym___read_only] = ACTIONS(1128),
    [anon_sym_write_only] = ACTIONS(1128),
    [anon_sym___write_only] = ACTIONS(1128),
    [anon_sym_read_write] = ACTIONS(1128),
    [anon_sym___read_write] = ACTIONS(1128),
    [anon_sym_extern] = ACTIONS(1128),
    [anon_sym___attribute__] = ACTIONS(1128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1130),
    [anon_sym___declspec] = ACTIONS(1128),
    [anon_sym___cdecl] = ACTIONS(1128),
    [anon_sym___clrcall] = ACTIONS(1128),
    [anon_sym___stdcall] = ACTIONS(1128),
    [anon_sym___fastcall] = ACTIONS(1128),
    [anon_sym___thiscall] = ACTIONS(1128),
    [anon_sym___vectorcall] = ACTIONS(1128),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_RBRACE] = ACTIONS(1130),
    [anon_sym_static] = ACTIONS(1128),
    [anon_sym_auto] = ACTIONS(1128),
    [anon_sym_register] = ACTIONS(1128),
    [anon_sym_inline] = ACTIONS(1128),
    [anon_sym_const] = ACTIONS(1128),
    [anon_sym_volatile] = ACTIONS(1128),
    [anon_sym_restrict] = ACTIONS(1128),
    [anon_sym__Atomic] = ACTIONS(1128),
    [anon_sym_pipe] = ACTIONS(1128),
    [anon_sym_signed] = ACTIONS(1128),
    [anon_sym_unsigned] = ACTIONS(1128),
    [anon_sym_long] = ACTIONS(1128),
    [anon_sym_short] = ACTIONS(1128),
    [anon_sym_bool] = ACTIONS(1128),
    [anon_sym_char] = ACTIONS(1128),
    [anon_sym_uchar] = ACTIONS(1128),
    [anon_sym_ushort] = ACTIONS(1128),
    [anon_sym_int] = ACTIONS(1128),
    [anon_sym_uint] = ACTIONS(1128),
    [anon_sym_ulong] = ACTIONS(1128),
    [anon_sym_float] = ACTIONS(1128),
    [anon_sym_double] = ACTIONS(1128),
    [anon_sym_half] = ACTIONS(1128),
    [anon_sym_size_t] = ACTIONS(1128),
    [anon_sym_ptrdiff_t] = ACTIONS(1128),
    [anon_sym_intptr_t] = ACTIONS(1128),
    [anon_sym_uintptr_t] = ACTIONS(1128),
    [anon_sym_void] = ACTIONS(1128),
    [sym_vector_type] = ACTIONS(1128),
    [anon_sym_image2d_t] = ACTIONS(1128),
    [anon_sym_image3d_t] = ACTIONS(1128),
    [anon_sym_image2d_array_t] = ACTIONS(1128),
    [anon_sym_image1d_t] = ACTIONS(1128),
    [anon_sym_image1d_buffer_t] = ACTIONS(1128),
    [anon_sym_image1d_array_t] = ACTIONS(1128),
    [anon_sym_image2d_depth_t] = ACTIONS(1128),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1128),
    [anon_sym_sampler_t] = ACTIONS(1128),
    [anon_sym_queue_t] = ACTIONS(1128),
    [anon_sym_ndrange_t] = ACTIONS(1128),
    [anon_sym_clk_event_t] = ACTIONS(1128),
    [anon_sym_reserve_id_t] = ACTIONS(1128),
    [anon_sym_event_t] = ACTIONS(1128),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1128),
    [anon_sym_enum] = ACTIONS(1128),
    [anon_sym_struct] = ACTIONS(1128),
    [anon_sym_union] = ACTIONS(1128),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_switch] = ACTIONS(1128),
    [anon_sym_case] = ACTIONS(1128),
    [anon_sym_default] = ACTIONS(1128),
    [anon_sym_while] = ACTIONS(1128),
    [anon_sym_do] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1128),
    [anon_sym_return] = ACTIONS(1128),
    [anon_sym_break] = ACTIONS(1128),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_goto] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1130),
    [anon_sym_PLUS_PLUS] = ACTIONS(1130),
    [anon_sym_sizeof] = ACTIONS(1128),
    [sym_number_literal] = ACTIONS(1130),
    [anon_sym_L_SQUOTE] = ACTIONS(1130),
    [anon_sym_u_SQUOTE] = ACTIONS(1130),
    [anon_sym_U_SQUOTE] = ACTIONS(1130),
    [anon_sym_u8_SQUOTE] = ACTIONS(1130),
    [anon_sym_SQUOTE] = ACTIONS(1130),
    [anon_sym_L_DQUOTE] = ACTIONS(1130),
    [anon_sym_u_DQUOTE] = ACTIONS(1130),
    [anon_sym_U_DQUOTE] = ACTIONS(1130),
    [anon_sym_u8_DQUOTE] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(1130),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_null] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_identifier] = ACTIONS(1120),
    [aux_sym_preproc_include_token1] = ACTIONS(1120),
    [aux_sym_preproc_def_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token2] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1120),
    [sym_preproc_directive] = ACTIONS(1120),
    [anon_sym_LPAREN2] = ACTIONS(1122),
    [anon_sym_BANG] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1122),
    [anon_sym_AMP] = ACTIONS(1122),
    [anon_sym_SEMI] = ACTIONS(1122),
    [anon_sym_typedef] = ACTIONS(1120),
    [anon_sym_kernel] = ACTIONS(1120),
    [anon_sym___kernel] = ACTIONS(1120),
    [anon_sym_global] = ACTIONS(1120),
    [anon_sym___global] = ACTIONS(1120),
    [anon_sym_local] = ACTIONS(1120),
    [anon_sym___local] = ACTIONS(1120),
    [anon_sym_constant] = ACTIONS(1120),
    [anon_sym___constant] = ACTIONS(1120),
    [anon_sym_private] = ACTIONS(1120),
    [anon_sym___private] = ACTIONS(1120),
    [anon_sym_generic] = ACTIONS(1120),
    [anon_sym___generic] = ACTIONS(1120),
    [anon_sym_read_only] = ACTIONS(1120),
    [anon_sym___read_only] = ACTIONS(1120),
    [anon_sym_write_only] = ACTIONS(1120),
    [anon_sym___write_only] = ACTIONS(1120),
    [anon_sym_read_write] = ACTIONS(1120),
    [anon_sym___read_write] = ACTIONS(1120),
    [anon_sym_extern] = ACTIONS(1120),
    [anon_sym___attribute__] = ACTIONS(1120),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1122),
    [anon_sym___declspec] = ACTIONS(1120),
    [anon_sym___cdecl] = ACTIONS(1120),
    [anon_sym___clrcall] = ACTIONS(1120),
    [anon_sym___stdcall] = ACTIONS(1120),
    [anon_sym___fastcall] = ACTIONS(1120),
    [anon_sym___thiscall] = ACTIONS(1120),
    [anon_sym___vectorcall] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_static] = ACTIONS(1120),
    [anon_sym_auto] = ACTIONS(1120),
    [anon_sym_register] = ACTIONS(1120),
    [anon_sym_inline] = ACTIONS(1120),
    [anon_sym_const] = ACTIONS(1120),
    [anon_sym_volatile] = ACTIONS(1120),
    [anon_sym_restrict] = ACTIONS(1120),
    [anon_sym__Atomic] = ACTIONS(1120),
    [anon_sym_pipe] = ACTIONS(1120),
    [anon_sym_signed] = ACTIONS(1120),
    [anon_sym_unsigned] = ACTIONS(1120),
    [anon_sym_long] = ACTIONS(1120),
    [anon_sym_short] = ACTIONS(1120),
    [anon_sym_bool] = ACTIONS(1120),
    [anon_sym_char] = ACTIONS(1120),
    [anon_sym_uchar] = ACTIONS(1120),
    [anon_sym_ushort] = ACTIONS(1120),
    [anon_sym_int] = ACTIONS(1120),
    [anon_sym_uint] = ACTIONS(1120),
    [anon_sym_ulong] = ACTIONS(1120),
    [anon_sym_float] = ACTIONS(1120),
    [anon_sym_double] = ACTIONS(1120),
    [anon_sym_half] = ACTIONS(1120),
    [anon_sym_size_t] = ACTIONS(1120),
    [anon_sym_ptrdiff_t] = ACTIONS(1120),
    [anon_sym_intptr_t] = ACTIONS(1120),
    [anon_sym_uintptr_t] = ACTIONS(1120),
    [anon_sym_void] = ACTIONS(1120),
    [sym_vector_type] = ACTIONS(1120),
    [anon_sym_image2d_t] = ACTIONS(1120),
    [anon_sym_image3d_t] = ACTIONS(1120),
    [anon_sym_image2d_array_t] = ACTIONS(1120),
    [anon_sym_image1d_t] = ACTIONS(1120),
    [anon_sym_image1d_buffer_t] = ACTIONS(1120),
    [anon_sym_image1d_array_t] = ACTIONS(1120),
    [anon_sym_image2d_depth_t] = ACTIONS(1120),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1120),
    [anon_sym_sampler_t] = ACTIONS(1120),
    [anon_sym_queue_t] = ACTIONS(1120),
    [anon_sym_ndrange_t] = ACTIONS(1120),
    [anon_sym_clk_event_t] = ACTIONS(1120),
    [anon_sym_reserve_id_t] = ACTIONS(1120),
    [anon_sym_event_t] = ACTIONS(1120),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1120),
    [anon_sym_enum] = ACTIONS(1120),
    [anon_sym_struct] = ACTIONS(1120),
    [anon_sym_union] = ACTIONS(1120),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_switch] = ACTIONS(1120),
    [anon_sym_case] = ACTIONS(1120),
    [anon_sym_default] = ACTIONS(1120),
    [anon_sym_while] = ACTIONS(1120),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_for] = ACTIONS(1120),
    [anon_sym_return] = ACTIONS(1120),
    [anon_sym_break] = ACTIONS(1120),
    [anon_sym_continue] = ACTIONS(1120),
    [anon_sym_goto] = ACTIONS(1120),
    [anon_sym_DASH_DASH] = ACTIONS(1122),
    [anon_sym_PLUS_PLUS] = ACTIONS(1122),
    [anon_sym_sizeof] = ACTIONS(1120),
    [sym_number_literal] = ACTIONS(1122),
    [anon_sym_L_SQUOTE] = ACTIONS(1122),
    [anon_sym_u_SQUOTE] = ACTIONS(1122),
    [anon_sym_U_SQUOTE] = ACTIONS(1122),
    [anon_sym_u8_SQUOTE] = ACTIONS(1122),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [anon_sym_L_DQUOTE] = ACTIONS(1122),
    [anon_sym_u_DQUOTE] = ACTIONS(1122),
    [anon_sym_U_DQUOTE] = ACTIONS(1122),
    [anon_sym_u8_DQUOTE] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1122),
    [sym_true] = ACTIONS(1120),
    [sym_false] = ACTIONS(1120),
    [sym_null] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_include_token1] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token2] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_LPAREN2] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1098),
    [anon_sym_SEMI] = ACTIONS(1098),
    [anon_sym_typedef] = ACTIONS(1096),
    [anon_sym_kernel] = ACTIONS(1096),
    [anon_sym___kernel] = ACTIONS(1096),
    [anon_sym_global] = ACTIONS(1096),
    [anon_sym___global] = ACTIONS(1096),
    [anon_sym_local] = ACTIONS(1096),
    [anon_sym___local] = ACTIONS(1096),
    [anon_sym_constant] = ACTIONS(1096),
    [anon_sym___constant] = ACTIONS(1096),
    [anon_sym_private] = ACTIONS(1096),
    [anon_sym___private] = ACTIONS(1096),
    [anon_sym_generic] = ACTIONS(1096),
    [anon_sym___generic] = ACTIONS(1096),
    [anon_sym_read_only] = ACTIONS(1096),
    [anon_sym___read_only] = ACTIONS(1096),
    [anon_sym_write_only] = ACTIONS(1096),
    [anon_sym___write_only] = ACTIONS(1096),
    [anon_sym_read_write] = ACTIONS(1096),
    [anon_sym___read_write] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1098),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym___cdecl] = ACTIONS(1096),
    [anon_sym___clrcall] = ACTIONS(1096),
    [anon_sym___stdcall] = ACTIONS(1096),
    [anon_sym___fastcall] = ACTIONS(1096),
    [anon_sym___thiscall] = ACTIONS(1096),
    [anon_sym___vectorcall] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_pipe] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [anon_sym_bool] = ACTIONS(1096),
    [anon_sym_char] = ACTIONS(1096),
    [anon_sym_uchar] = ACTIONS(1096),
    [anon_sym_ushort] = ACTIONS(1096),
    [anon_sym_int] = ACTIONS(1096),
    [anon_sym_uint] = ACTIONS(1096),
    [anon_sym_ulong] = ACTIONS(1096),
    [anon_sym_float] = ACTIONS(1096),
    [anon_sym_double] = ACTIONS(1096),
    [anon_sym_half] = ACTIONS(1096),
    [anon_sym_size_t] = ACTIONS(1096),
    [anon_sym_ptrdiff_t] = ACTIONS(1096),
    [anon_sym_intptr_t] = ACTIONS(1096),
    [anon_sym_uintptr_t] = ACTIONS(1096),
    [anon_sym_void] = ACTIONS(1096),
    [sym_vector_type] = ACTIONS(1096),
    [anon_sym_image2d_t] = ACTIONS(1096),
    [anon_sym_image3d_t] = ACTIONS(1096),
    [anon_sym_image2d_array_t] = ACTIONS(1096),
    [anon_sym_image1d_t] = ACTIONS(1096),
    [anon_sym_image1d_buffer_t] = ACTIONS(1096),
    [anon_sym_image1d_array_t] = ACTIONS(1096),
    [anon_sym_image2d_depth_t] = ACTIONS(1096),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1096),
    [anon_sym_sampler_t] = ACTIONS(1096),
    [anon_sym_queue_t] = ACTIONS(1096),
    [anon_sym_ndrange_t] = ACTIONS(1096),
    [anon_sym_clk_event_t] = ACTIONS(1096),
    [anon_sym_reserve_id_t] = ACTIONS(1096),
    [anon_sym_event_t] = ACTIONS(1096),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_goto] = ACTIONS(1096),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_sizeof] = ACTIONS(1096),
    [sym_number_literal] = ACTIONS(1098),
    [anon_sym_L_SQUOTE] = ACTIONS(1098),
    [anon_sym_u_SQUOTE] = ACTIONS(1098),
    [anon_sym_U_SQUOTE] = ACTIONS(1098),
    [anon_sym_u8_SQUOTE] = ACTIONS(1098),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [anon_sym_L_DQUOTE] = ACTIONS(1098),
    [anon_sym_u_DQUOTE] = ACTIONS(1098),
    [anon_sym_U_DQUOTE] = ACTIONS(1098),
    [anon_sym_u8_DQUOTE] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_null] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_preproc_include_token1] = ACTIONS(1108),
    [aux_sym_preproc_def_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token2] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1108),
    [sym_preproc_directive] = ACTIONS(1108),
    [anon_sym_LPAREN2] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_typedef] = ACTIONS(1108),
    [anon_sym_kernel] = ACTIONS(1108),
    [anon_sym___kernel] = ACTIONS(1108),
    [anon_sym_global] = ACTIONS(1108),
    [anon_sym___global] = ACTIONS(1108),
    [anon_sym_local] = ACTIONS(1108),
    [anon_sym___local] = ACTIONS(1108),
    [anon_sym_constant] = ACTIONS(1108),
    [anon_sym___constant] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym___private] = ACTIONS(1108),
    [anon_sym_generic] = ACTIONS(1108),
    [anon_sym___generic] = ACTIONS(1108),
    [anon_sym_read_only] = ACTIONS(1108),
    [anon_sym___read_only] = ACTIONS(1108),
    [anon_sym_write_only] = ACTIONS(1108),
    [anon_sym___write_only] = ACTIONS(1108),
    [anon_sym_read_write] = ACTIONS(1108),
    [anon_sym___read_write] = ACTIONS(1108),
    [anon_sym_extern] = ACTIONS(1108),
    [anon_sym___attribute__] = ACTIONS(1108),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1110),
    [anon_sym___declspec] = ACTIONS(1108),
    [anon_sym___cdecl] = ACTIONS(1108),
    [anon_sym___clrcall] = ACTIONS(1108),
    [anon_sym___stdcall] = ACTIONS(1108),
    [anon_sym___fastcall] = ACTIONS(1108),
    [anon_sym___thiscall] = ACTIONS(1108),
    [anon_sym___vectorcall] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_auto] = ACTIONS(1108),
    [anon_sym_register] = ACTIONS(1108),
    [anon_sym_inline] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_volatile] = ACTIONS(1108),
    [anon_sym_restrict] = ACTIONS(1108),
    [anon_sym__Atomic] = ACTIONS(1108),
    [anon_sym_pipe] = ACTIONS(1108),
    [anon_sym_signed] = ACTIONS(1108),
    [anon_sym_unsigned] = ACTIONS(1108),
    [anon_sym_long] = ACTIONS(1108),
    [anon_sym_short] = ACTIONS(1108),
    [anon_sym_bool] = ACTIONS(1108),
    [anon_sym_char] = ACTIONS(1108),
    [anon_sym_uchar] = ACTIONS(1108),
    [anon_sym_ushort] = ACTIONS(1108),
    [anon_sym_int] = ACTIONS(1108),
    [anon_sym_uint] = ACTIONS(1108),
    [anon_sym_ulong] = ACTIONS(1108),
    [anon_sym_float] = ACTIONS(1108),
    [anon_sym_double] = ACTIONS(1108),
    [anon_sym_half] = ACTIONS(1108),
    [anon_sym_size_t] = ACTIONS(1108),
    [anon_sym_ptrdiff_t] = ACTIONS(1108),
    [anon_sym_intptr_t] = ACTIONS(1108),
    [anon_sym_uintptr_t] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1108),
    [sym_vector_type] = ACTIONS(1108),
    [anon_sym_image2d_t] = ACTIONS(1108),
    [anon_sym_image3d_t] = ACTIONS(1108),
    [anon_sym_image2d_array_t] = ACTIONS(1108),
    [anon_sym_image1d_t] = ACTIONS(1108),
    [anon_sym_image1d_buffer_t] = ACTIONS(1108),
    [anon_sym_image1d_array_t] = ACTIONS(1108),
    [anon_sym_image2d_depth_t] = ACTIONS(1108),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1108),
    [anon_sym_sampler_t] = ACTIONS(1108),
    [anon_sym_queue_t] = ACTIONS(1108),
    [anon_sym_ndrange_t] = ACTIONS(1108),
    [anon_sym_clk_event_t] = ACTIONS(1108),
    [anon_sym_reserve_id_t] = ACTIONS(1108),
    [anon_sym_event_t] = ACTIONS(1108),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [anon_sym_struct] = ACTIONS(1108),
    [anon_sym_union] = ACTIONS(1108),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_case] = ACTIONS(1108),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_while] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1108),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1108),
    [anon_sym_goto] = ACTIONS(1108),
    [anon_sym_DASH_DASH] = ACTIONS(1110),
    [anon_sym_PLUS_PLUS] = ACTIONS(1110),
    [anon_sym_sizeof] = ACTIONS(1108),
    [sym_number_literal] = ACTIONS(1110),
    [anon_sym_L_SQUOTE] = ACTIONS(1110),
    [anon_sym_u_SQUOTE] = ACTIONS(1110),
    [anon_sym_U_SQUOTE] = ACTIONS(1110),
    [anon_sym_u8_SQUOTE] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1108),
    [sym_false] = ACTIONS(1108),
    [sym_null] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_include_token1] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_LPAREN2] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1078),
    [anon_sym_typedef] = ACTIONS(1076),
    [anon_sym_kernel] = ACTIONS(1076),
    [anon_sym___kernel] = ACTIONS(1076),
    [anon_sym_global] = ACTIONS(1076),
    [anon_sym___global] = ACTIONS(1076),
    [anon_sym_local] = ACTIONS(1076),
    [anon_sym___local] = ACTIONS(1076),
    [anon_sym_constant] = ACTIONS(1076),
    [anon_sym___constant] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym___private] = ACTIONS(1076),
    [anon_sym_generic] = ACTIONS(1076),
    [anon_sym___generic] = ACTIONS(1076),
    [anon_sym_read_only] = ACTIONS(1076),
    [anon_sym___read_only] = ACTIONS(1076),
    [anon_sym_write_only] = ACTIONS(1076),
    [anon_sym___write_only] = ACTIONS(1076),
    [anon_sym_read_write] = ACTIONS(1076),
    [anon_sym___read_write] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1078),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym___cdecl] = ACTIONS(1076),
    [anon_sym___clrcall] = ACTIONS(1076),
    [anon_sym___stdcall] = ACTIONS(1076),
    [anon_sym___fastcall] = ACTIONS(1076),
    [anon_sym___thiscall] = ACTIONS(1076),
    [anon_sym___vectorcall] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_pipe] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [anon_sym_bool] = ACTIONS(1076),
    [anon_sym_char] = ACTIONS(1076),
    [anon_sym_uchar] = ACTIONS(1076),
    [anon_sym_ushort] = ACTIONS(1076),
    [anon_sym_int] = ACTIONS(1076),
    [anon_sym_uint] = ACTIONS(1076),
    [anon_sym_ulong] = ACTIONS(1076),
    [anon_sym_float] = ACTIONS(1076),
    [anon_sym_double] = ACTIONS(1076),
    [anon_sym_half] = ACTIONS(1076),
    [anon_sym_size_t] = ACTIONS(1076),
    [anon_sym_ptrdiff_t] = ACTIONS(1076),
    [anon_sym_intptr_t] = ACTIONS(1076),
    [anon_sym_uintptr_t] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1076),
    [sym_vector_type] = ACTIONS(1076),
    [anon_sym_image2d_t] = ACTIONS(1076),
    [anon_sym_image3d_t] = ACTIONS(1076),
    [anon_sym_image2d_array_t] = ACTIONS(1076),
    [anon_sym_image1d_t] = ACTIONS(1076),
    [anon_sym_image1d_buffer_t] = ACTIONS(1076),
    [anon_sym_image1d_array_t] = ACTIONS(1076),
    [anon_sym_image2d_depth_t] = ACTIONS(1076),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1076),
    [anon_sym_sampler_t] = ACTIONS(1076),
    [anon_sym_queue_t] = ACTIONS(1076),
    [anon_sym_ndrange_t] = ACTIONS(1076),
    [anon_sym_clk_event_t] = ACTIONS(1076),
    [anon_sym_reserve_id_t] = ACTIONS(1076),
    [anon_sym_event_t] = ACTIONS(1076),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1076),
    [anon_sym_default] = ACTIONS(1076),
    [anon_sym_while] = ACTIONS(1076),
    [anon_sym_do] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1076),
    [anon_sym_return] = ACTIONS(1076),
    [anon_sym_break] = ACTIONS(1076),
    [anon_sym_continue] = ACTIONS(1076),
    [anon_sym_goto] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [anon_sym_sizeof] = ACTIONS(1076),
    [sym_number_literal] = ACTIONS(1078),
    [anon_sym_L_SQUOTE] = ACTIONS(1078),
    [anon_sym_u_SQUOTE] = ACTIONS(1078),
    [anon_sym_U_SQUOTE] = ACTIONS(1078),
    [anon_sym_u8_SQUOTE] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_L_DQUOTE] = ACTIONS(1078),
    [anon_sym_u_DQUOTE] = ACTIONS(1078),
    [anon_sym_U_DQUOTE] = ACTIONS(1078),
    [anon_sym_u8_DQUOTE] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [sym_true] = ACTIONS(1076),
    [sym_false] = ACTIONS(1076),
    [sym_null] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_include_token1] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token2] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_typedef] = ACTIONS(1072),
    [anon_sym_kernel] = ACTIONS(1072),
    [anon_sym___kernel] = ACTIONS(1072),
    [anon_sym_global] = ACTIONS(1072),
    [anon_sym___global] = ACTIONS(1072),
    [anon_sym_local] = ACTIONS(1072),
    [anon_sym___local] = ACTIONS(1072),
    [anon_sym_constant] = ACTIONS(1072),
    [anon_sym___constant] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym___private] = ACTIONS(1072),
    [anon_sym_generic] = ACTIONS(1072),
    [anon_sym___generic] = ACTIONS(1072),
    [anon_sym_read_only] = ACTIONS(1072),
    [anon_sym___read_only] = ACTIONS(1072),
    [anon_sym_write_only] = ACTIONS(1072),
    [anon_sym___write_only] = ACTIONS(1072),
    [anon_sym_read_write] = ACTIONS(1072),
    [anon_sym___read_write] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1074),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym___cdecl] = ACTIONS(1072),
    [anon_sym___clrcall] = ACTIONS(1072),
    [anon_sym___stdcall] = ACTIONS(1072),
    [anon_sym___fastcall] = ACTIONS(1072),
    [anon_sym___thiscall] = ACTIONS(1072),
    [anon_sym___vectorcall] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_pipe] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [anon_sym_bool] = ACTIONS(1072),
    [anon_sym_char] = ACTIONS(1072),
    [anon_sym_uchar] = ACTIONS(1072),
    [anon_sym_ushort] = ACTIONS(1072),
    [anon_sym_int] = ACTIONS(1072),
    [anon_sym_uint] = ACTIONS(1072),
    [anon_sym_ulong] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1072),
    [anon_sym_double] = ACTIONS(1072),
    [anon_sym_half] = ACTIONS(1072),
    [anon_sym_size_t] = ACTIONS(1072),
    [anon_sym_ptrdiff_t] = ACTIONS(1072),
    [anon_sym_intptr_t] = ACTIONS(1072),
    [anon_sym_uintptr_t] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1072),
    [sym_vector_type] = ACTIONS(1072),
    [anon_sym_image2d_t] = ACTIONS(1072),
    [anon_sym_image3d_t] = ACTIONS(1072),
    [anon_sym_image2d_array_t] = ACTIONS(1072),
    [anon_sym_image1d_t] = ACTIONS(1072),
    [anon_sym_image1d_buffer_t] = ACTIONS(1072),
    [anon_sym_image1d_array_t] = ACTIONS(1072),
    [anon_sym_image2d_depth_t] = ACTIONS(1072),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1072),
    [anon_sym_sampler_t] = ACTIONS(1072),
    [anon_sym_queue_t] = ACTIONS(1072),
    [anon_sym_ndrange_t] = ACTIONS(1072),
    [anon_sym_clk_event_t] = ACTIONS(1072),
    [anon_sym_reserve_id_t] = ACTIONS(1072),
    [anon_sym_event_t] = ACTIONS(1072),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_goto] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_sizeof] = ACTIONS(1072),
    [sym_number_literal] = ACTIONS(1074),
    [anon_sym_L_SQUOTE] = ACTIONS(1074),
    [anon_sym_u_SQUOTE] = ACTIONS(1074),
    [anon_sym_U_SQUOTE] = ACTIONS(1074),
    [anon_sym_u8_SQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_L_DQUOTE] = ACTIONS(1074),
    [anon_sym_u_DQUOTE] = ACTIONS(1074),
    [anon_sym_U_DQUOTE] = ACTIONS(1074),
    [anon_sym_u8_DQUOTE] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [ts_builtin_sym_end] = ACTIONS(1082),
    [sym_identifier] = ACTIONS(1080),
    [aux_sym_preproc_include_token1] = ACTIONS(1080),
    [aux_sym_preproc_def_token1] = ACTIONS(1080),
    [aux_sym_preproc_if_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1080),
    [sym_preproc_directive] = ACTIONS(1080),
    [anon_sym_LPAREN2] = ACTIONS(1082),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1082),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_SEMI] = ACTIONS(1082),
    [anon_sym_typedef] = ACTIONS(1080),
    [anon_sym_kernel] = ACTIONS(1080),
    [anon_sym___kernel] = ACTIONS(1080),
    [anon_sym_global] = ACTIONS(1080),
    [anon_sym___global] = ACTIONS(1080),
    [anon_sym_local] = ACTIONS(1080),
    [anon_sym___local] = ACTIONS(1080),
    [anon_sym_constant] = ACTIONS(1080),
    [anon_sym___constant] = ACTIONS(1080),
    [anon_sym_private] = ACTIONS(1080),
    [anon_sym___private] = ACTIONS(1080),
    [anon_sym_generic] = ACTIONS(1080),
    [anon_sym___generic] = ACTIONS(1080),
    [anon_sym_read_only] = ACTIONS(1080),
    [anon_sym___read_only] = ACTIONS(1080),
    [anon_sym_write_only] = ACTIONS(1080),
    [anon_sym___write_only] = ACTIONS(1080),
    [anon_sym_read_write] = ACTIONS(1080),
    [anon_sym___read_write] = ACTIONS(1080),
    [anon_sym_extern] = ACTIONS(1080),
    [anon_sym___attribute__] = ACTIONS(1080),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1082),
    [anon_sym___declspec] = ACTIONS(1080),
    [anon_sym___cdecl] = ACTIONS(1080),
    [anon_sym___clrcall] = ACTIONS(1080),
    [anon_sym___stdcall] = ACTIONS(1080),
    [anon_sym___fastcall] = ACTIONS(1080),
    [anon_sym___thiscall] = ACTIONS(1080),
    [anon_sym___vectorcall] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1082),
    [anon_sym_static] = ACTIONS(1080),
    [anon_sym_auto] = ACTIONS(1080),
    [anon_sym_register] = ACTIONS(1080),
    [anon_sym_inline] = ACTIONS(1080),
    [anon_sym_const] = ACTIONS(1080),
    [anon_sym_volatile] = ACTIONS(1080),
    [anon_sym_restrict] = ACTIONS(1080),
    [anon_sym__Atomic] = ACTIONS(1080),
    [anon_sym_pipe] = ACTIONS(1080),
    [anon_sym_signed] = ACTIONS(1080),
    [anon_sym_unsigned] = ACTIONS(1080),
    [anon_sym_long] = ACTIONS(1080),
    [anon_sym_short] = ACTIONS(1080),
    [anon_sym_bool] = ACTIONS(1080),
    [anon_sym_char] = ACTIONS(1080),
    [anon_sym_uchar] = ACTIONS(1080),
    [anon_sym_ushort] = ACTIONS(1080),
    [anon_sym_int] = ACTIONS(1080),
    [anon_sym_uint] = ACTIONS(1080),
    [anon_sym_ulong] = ACTIONS(1080),
    [anon_sym_float] = ACTIONS(1080),
    [anon_sym_double] = ACTIONS(1080),
    [anon_sym_half] = ACTIONS(1080),
    [anon_sym_size_t] = ACTIONS(1080),
    [anon_sym_ptrdiff_t] = ACTIONS(1080),
    [anon_sym_intptr_t] = ACTIONS(1080),
    [anon_sym_uintptr_t] = ACTIONS(1080),
    [anon_sym_void] = ACTIONS(1080),
    [sym_vector_type] = ACTIONS(1080),
    [anon_sym_image2d_t] = ACTIONS(1080),
    [anon_sym_image3d_t] = ACTIONS(1080),
    [anon_sym_image2d_array_t] = ACTIONS(1080),
    [anon_sym_image1d_t] = ACTIONS(1080),
    [anon_sym_image1d_buffer_t] = ACTIONS(1080),
    [anon_sym_image1d_array_t] = ACTIONS(1080),
    [anon_sym_image2d_depth_t] = ACTIONS(1080),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1080),
    [anon_sym_sampler_t] = ACTIONS(1080),
    [anon_sym_queue_t] = ACTIONS(1080),
    [anon_sym_ndrange_t] = ACTIONS(1080),
    [anon_sym_clk_event_t] = ACTIONS(1080),
    [anon_sym_reserve_id_t] = ACTIONS(1080),
    [anon_sym_event_t] = ACTIONS(1080),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1080),
    [anon_sym_enum] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1080),
    [anon_sym_union] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1080),
    [anon_sym_default] = ACTIONS(1080),
    [anon_sym_while] = ACTIONS(1080),
    [anon_sym_do] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1080),
    [anon_sym_return] = ACTIONS(1080),
    [anon_sym_break] = ACTIONS(1080),
    [anon_sym_continue] = ACTIONS(1080),
    [anon_sym_goto] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1082),
    [anon_sym_sizeof] = ACTIONS(1080),
    [sym_number_literal] = ACTIONS(1082),
    [anon_sym_L_SQUOTE] = ACTIONS(1082),
    [anon_sym_u_SQUOTE] = ACTIONS(1082),
    [anon_sym_U_SQUOTE] = ACTIONS(1082),
    [anon_sym_u8_SQUOTE] = ACTIONS(1082),
    [anon_sym_SQUOTE] = ACTIONS(1082),
    [anon_sym_L_DQUOTE] = ACTIONS(1082),
    [anon_sym_u_DQUOTE] = ACTIONS(1082),
    [anon_sym_U_DQUOTE] = ACTIONS(1082),
    [anon_sym_u8_DQUOTE] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_true] = ACTIONS(1080),
    [sym_false] = ACTIONS(1080),
    [sym_null] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [ts_builtin_sym_end] = ACTIONS(1058),
    [sym_identifier] = ACTIONS(1056),
    [aux_sym_preproc_include_token1] = ACTIONS(1056),
    [aux_sym_preproc_def_token1] = ACTIONS(1056),
    [aux_sym_preproc_if_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1056),
    [sym_preproc_directive] = ACTIONS(1056),
    [anon_sym_LPAREN2] = ACTIONS(1058),
    [anon_sym_BANG] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_SEMI] = ACTIONS(1058),
    [anon_sym_typedef] = ACTIONS(1056),
    [anon_sym_kernel] = ACTIONS(1056),
    [anon_sym___kernel] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym___global] = ACTIONS(1056),
    [anon_sym_local] = ACTIONS(1056),
    [anon_sym___local] = ACTIONS(1056),
    [anon_sym_constant] = ACTIONS(1056),
    [anon_sym___constant] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym___private] = ACTIONS(1056),
    [anon_sym_generic] = ACTIONS(1056),
    [anon_sym___generic] = ACTIONS(1056),
    [anon_sym_read_only] = ACTIONS(1056),
    [anon_sym___read_only] = ACTIONS(1056),
    [anon_sym_write_only] = ACTIONS(1056),
    [anon_sym___write_only] = ACTIONS(1056),
    [anon_sym_read_write] = ACTIONS(1056),
    [anon_sym___read_write] = ACTIONS(1056),
    [anon_sym_extern] = ACTIONS(1056),
    [anon_sym___attribute__] = ACTIONS(1056),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1058),
    [anon_sym___declspec] = ACTIONS(1056),
    [anon_sym___cdecl] = ACTIONS(1056),
    [anon_sym___clrcall] = ACTIONS(1056),
    [anon_sym___stdcall] = ACTIONS(1056),
    [anon_sym___fastcall] = ACTIONS(1056),
    [anon_sym___thiscall] = ACTIONS(1056),
    [anon_sym___vectorcall] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_auto] = ACTIONS(1056),
    [anon_sym_register] = ACTIONS(1056),
    [anon_sym_inline] = ACTIONS(1056),
    [anon_sym_const] = ACTIONS(1056),
    [anon_sym_volatile] = ACTIONS(1056),
    [anon_sym_restrict] = ACTIONS(1056),
    [anon_sym__Atomic] = ACTIONS(1056),
    [anon_sym_pipe] = ACTIONS(1056),
    [anon_sym_signed] = ACTIONS(1056),
    [anon_sym_unsigned] = ACTIONS(1056),
    [anon_sym_long] = ACTIONS(1056),
    [anon_sym_short] = ACTIONS(1056),
    [anon_sym_bool] = ACTIONS(1056),
    [anon_sym_char] = ACTIONS(1056),
    [anon_sym_uchar] = ACTIONS(1056),
    [anon_sym_ushort] = ACTIONS(1056),
    [anon_sym_int] = ACTIONS(1056),
    [anon_sym_uint] = ACTIONS(1056),
    [anon_sym_ulong] = ACTIONS(1056),
    [anon_sym_float] = ACTIONS(1056),
    [anon_sym_double] = ACTIONS(1056),
    [anon_sym_half] = ACTIONS(1056),
    [anon_sym_size_t] = ACTIONS(1056),
    [anon_sym_ptrdiff_t] = ACTIONS(1056),
    [anon_sym_intptr_t] = ACTIONS(1056),
    [anon_sym_uintptr_t] = ACTIONS(1056),
    [anon_sym_void] = ACTIONS(1056),
    [sym_vector_type] = ACTIONS(1056),
    [anon_sym_image2d_t] = ACTIONS(1056),
    [anon_sym_image3d_t] = ACTIONS(1056),
    [anon_sym_image2d_array_t] = ACTIONS(1056),
    [anon_sym_image1d_t] = ACTIONS(1056),
    [anon_sym_image1d_buffer_t] = ACTIONS(1056),
    [anon_sym_image1d_array_t] = ACTIONS(1056),
    [anon_sym_image2d_depth_t] = ACTIONS(1056),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1056),
    [anon_sym_sampler_t] = ACTIONS(1056),
    [anon_sym_queue_t] = ACTIONS(1056),
    [anon_sym_ndrange_t] = ACTIONS(1056),
    [anon_sym_clk_event_t] = ACTIONS(1056),
    [anon_sym_reserve_id_t] = ACTIONS(1056),
    [anon_sym_event_t] = ACTIONS(1056),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1056),
    [anon_sym_enum] = ACTIONS(1056),
    [anon_sym_struct] = ACTIONS(1056),
    [anon_sym_union] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_default] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_do] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_goto] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1058),
    [anon_sym_PLUS_PLUS] = ACTIONS(1058),
    [anon_sym_sizeof] = ACTIONS(1056),
    [sym_number_literal] = ACTIONS(1058),
    [anon_sym_L_SQUOTE] = ACTIONS(1058),
    [anon_sym_u_SQUOTE] = ACTIONS(1058),
    [anon_sym_U_SQUOTE] = ACTIONS(1058),
    [anon_sym_u8_SQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [anon_sym_L_DQUOTE] = ACTIONS(1058),
    [anon_sym_u_DQUOTE] = ACTIONS(1058),
    [anon_sym_U_DQUOTE] = ACTIONS(1058),
    [anon_sym_u8_DQUOTE] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_null] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(1074),
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_include_token1] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_LPAREN2] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [anon_sym_typedef] = ACTIONS(1072),
    [anon_sym_kernel] = ACTIONS(1072),
    [anon_sym___kernel] = ACTIONS(1072),
    [anon_sym_global] = ACTIONS(1072),
    [anon_sym___global] = ACTIONS(1072),
    [anon_sym_local] = ACTIONS(1072),
    [anon_sym___local] = ACTIONS(1072),
    [anon_sym_constant] = ACTIONS(1072),
    [anon_sym___constant] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym___private] = ACTIONS(1072),
    [anon_sym_generic] = ACTIONS(1072),
    [anon_sym___generic] = ACTIONS(1072),
    [anon_sym_read_only] = ACTIONS(1072),
    [anon_sym___read_only] = ACTIONS(1072),
    [anon_sym_write_only] = ACTIONS(1072),
    [anon_sym___write_only] = ACTIONS(1072),
    [anon_sym_read_write] = ACTIONS(1072),
    [anon_sym___read_write] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1074),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym___cdecl] = ACTIONS(1072),
    [anon_sym___clrcall] = ACTIONS(1072),
    [anon_sym___stdcall] = ACTIONS(1072),
    [anon_sym___fastcall] = ACTIONS(1072),
    [anon_sym___thiscall] = ACTIONS(1072),
    [anon_sym___vectorcall] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_pipe] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [anon_sym_bool] = ACTIONS(1072),
    [anon_sym_char] = ACTIONS(1072),
    [anon_sym_uchar] = ACTIONS(1072),
    [anon_sym_ushort] = ACTIONS(1072),
    [anon_sym_int] = ACTIONS(1072),
    [anon_sym_uint] = ACTIONS(1072),
    [anon_sym_ulong] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1072),
    [anon_sym_double] = ACTIONS(1072),
    [anon_sym_half] = ACTIONS(1072),
    [anon_sym_size_t] = ACTIONS(1072),
    [anon_sym_ptrdiff_t] = ACTIONS(1072),
    [anon_sym_intptr_t] = ACTIONS(1072),
    [anon_sym_uintptr_t] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1072),
    [sym_vector_type] = ACTIONS(1072),
    [anon_sym_image2d_t] = ACTIONS(1072),
    [anon_sym_image3d_t] = ACTIONS(1072),
    [anon_sym_image2d_array_t] = ACTIONS(1072),
    [anon_sym_image1d_t] = ACTIONS(1072),
    [anon_sym_image1d_buffer_t] = ACTIONS(1072),
    [anon_sym_image1d_array_t] = ACTIONS(1072),
    [anon_sym_image2d_depth_t] = ACTIONS(1072),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1072),
    [anon_sym_sampler_t] = ACTIONS(1072),
    [anon_sym_queue_t] = ACTIONS(1072),
    [anon_sym_ndrange_t] = ACTIONS(1072),
    [anon_sym_clk_event_t] = ACTIONS(1072),
    [anon_sym_reserve_id_t] = ACTIONS(1072),
    [anon_sym_event_t] = ACTIONS(1072),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1072),
    [anon_sym_default] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_do] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_goto] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_sizeof] = ACTIONS(1072),
    [sym_number_literal] = ACTIONS(1074),
    [anon_sym_L_SQUOTE] = ACTIONS(1074),
    [anon_sym_u_SQUOTE] = ACTIONS(1074),
    [anon_sym_U_SQUOTE] = ACTIONS(1074),
    [anon_sym_u8_SQUOTE] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_L_DQUOTE] = ACTIONS(1074),
    [anon_sym_u_DQUOTE] = ACTIONS(1074),
    [anon_sym_U_DQUOTE] = ACTIONS(1074),
    [anon_sym_u8_DQUOTE] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_null] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_preproc_include_token1] = ACTIONS(1108),
    [aux_sym_preproc_def_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1108),
    [sym_preproc_directive] = ACTIONS(1108),
    [anon_sym_LPAREN2] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_AMP] = ACTIONS(1110),
    [anon_sym_SEMI] = ACTIONS(1110),
    [anon_sym_typedef] = ACTIONS(1108),
    [anon_sym_kernel] = ACTIONS(1108),
    [anon_sym___kernel] = ACTIONS(1108),
    [anon_sym_global] = ACTIONS(1108),
    [anon_sym___global] = ACTIONS(1108),
    [anon_sym_local] = ACTIONS(1108),
    [anon_sym___local] = ACTIONS(1108),
    [anon_sym_constant] = ACTIONS(1108),
    [anon_sym___constant] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym___private] = ACTIONS(1108),
    [anon_sym_generic] = ACTIONS(1108),
    [anon_sym___generic] = ACTIONS(1108),
    [anon_sym_read_only] = ACTIONS(1108),
    [anon_sym___read_only] = ACTIONS(1108),
    [anon_sym_write_only] = ACTIONS(1108),
    [anon_sym___write_only] = ACTIONS(1108),
    [anon_sym_read_write] = ACTIONS(1108),
    [anon_sym___read_write] = ACTIONS(1108),
    [anon_sym_extern] = ACTIONS(1108),
    [anon_sym___attribute__] = ACTIONS(1108),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1110),
    [anon_sym___declspec] = ACTIONS(1108),
    [anon_sym___cdecl] = ACTIONS(1108),
    [anon_sym___clrcall] = ACTIONS(1108),
    [anon_sym___stdcall] = ACTIONS(1108),
    [anon_sym___fastcall] = ACTIONS(1108),
    [anon_sym___thiscall] = ACTIONS(1108),
    [anon_sym___vectorcall] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_auto] = ACTIONS(1108),
    [anon_sym_register] = ACTIONS(1108),
    [anon_sym_inline] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_volatile] = ACTIONS(1108),
    [anon_sym_restrict] = ACTIONS(1108),
    [anon_sym__Atomic] = ACTIONS(1108),
    [anon_sym_pipe] = ACTIONS(1108),
    [anon_sym_signed] = ACTIONS(1108),
    [anon_sym_unsigned] = ACTIONS(1108),
    [anon_sym_long] = ACTIONS(1108),
    [anon_sym_short] = ACTIONS(1108),
    [anon_sym_bool] = ACTIONS(1108),
    [anon_sym_char] = ACTIONS(1108),
    [anon_sym_uchar] = ACTIONS(1108),
    [anon_sym_ushort] = ACTIONS(1108),
    [anon_sym_int] = ACTIONS(1108),
    [anon_sym_uint] = ACTIONS(1108),
    [anon_sym_ulong] = ACTIONS(1108),
    [anon_sym_float] = ACTIONS(1108),
    [anon_sym_double] = ACTIONS(1108),
    [anon_sym_half] = ACTIONS(1108),
    [anon_sym_size_t] = ACTIONS(1108),
    [anon_sym_ptrdiff_t] = ACTIONS(1108),
    [anon_sym_intptr_t] = ACTIONS(1108),
    [anon_sym_uintptr_t] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1108),
    [sym_vector_type] = ACTIONS(1108),
    [anon_sym_image2d_t] = ACTIONS(1108),
    [anon_sym_image3d_t] = ACTIONS(1108),
    [anon_sym_image2d_array_t] = ACTIONS(1108),
    [anon_sym_image1d_t] = ACTIONS(1108),
    [anon_sym_image1d_buffer_t] = ACTIONS(1108),
    [anon_sym_image1d_array_t] = ACTIONS(1108),
    [anon_sym_image2d_depth_t] = ACTIONS(1108),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1108),
    [anon_sym_sampler_t] = ACTIONS(1108),
    [anon_sym_queue_t] = ACTIONS(1108),
    [anon_sym_ndrange_t] = ACTIONS(1108),
    [anon_sym_clk_event_t] = ACTIONS(1108),
    [anon_sym_reserve_id_t] = ACTIONS(1108),
    [anon_sym_event_t] = ACTIONS(1108),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [anon_sym_struct] = ACTIONS(1108),
    [anon_sym_union] = ACTIONS(1108),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_case] = ACTIONS(1108),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_while] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1108),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1108),
    [anon_sym_goto] = ACTIONS(1108),
    [anon_sym_DASH_DASH] = ACTIONS(1110),
    [anon_sym_PLUS_PLUS] = ACTIONS(1110),
    [anon_sym_sizeof] = ACTIONS(1108),
    [sym_number_literal] = ACTIONS(1110),
    [anon_sym_L_SQUOTE] = ACTIONS(1110),
    [anon_sym_u_SQUOTE] = ACTIONS(1110),
    [anon_sym_U_SQUOTE] = ACTIONS(1110),
    [anon_sym_u8_SQUOTE] = ACTIONS(1110),
    [anon_sym_SQUOTE] = ACTIONS(1110),
    [anon_sym_L_DQUOTE] = ACTIONS(1110),
    [anon_sym_u_DQUOTE] = ACTIONS(1110),
    [anon_sym_U_DQUOTE] = ACTIONS(1110),
    [anon_sym_u8_DQUOTE] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1110),
    [sym_true] = ACTIONS(1108),
    [sym_false] = ACTIONS(1108),
    [sym_null] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_identifier] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(1140),
    [anon_sym_RPAREN] = ACTIONS(1140),
    [anon_sym_LPAREN2] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1138),
    [anon_sym_PLUS] = ACTIONS(1138),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_AMP] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_kernel] = ACTIONS(1138),
    [anon_sym___kernel] = ACTIONS(1138),
    [anon_sym_global] = ACTIONS(1138),
    [anon_sym___global] = ACTIONS(1138),
    [anon_sym_local] = ACTIONS(1138),
    [anon_sym___local] = ACTIONS(1138),
    [anon_sym_constant] = ACTIONS(1138),
    [anon_sym___constant] = ACTIONS(1138),
    [anon_sym_private] = ACTIONS(1138),
    [anon_sym___private] = ACTIONS(1138),
    [anon_sym_generic] = ACTIONS(1138),
    [anon_sym___generic] = ACTIONS(1138),
    [anon_sym_read_only] = ACTIONS(1138),
    [anon_sym___read_only] = ACTIONS(1138),
    [anon_sym_write_only] = ACTIONS(1138),
    [anon_sym___write_only] = ACTIONS(1138),
    [anon_sym_read_write] = ACTIONS(1138),
    [anon_sym___read_write] = ACTIONS(1138),
    [anon_sym_extern] = ACTIONS(1138),
    [anon_sym___attribute__] = ACTIONS(1138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1140),
    [anon_sym___declspec] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_EQ] = ACTIONS(1140),
    [anon_sym_static] = ACTIONS(1138),
    [anon_sym_auto] = ACTIONS(1138),
    [anon_sym_register] = ACTIONS(1138),
    [anon_sym_inline] = ACTIONS(1138),
    [anon_sym_const] = ACTIONS(1138),
    [anon_sym_volatile] = ACTIONS(1138),
    [anon_sym_restrict] = ACTIONS(1138),
    [anon_sym__Atomic] = ACTIONS(1138),
    [anon_sym_pipe] = ACTIONS(1138),
    [anon_sym_signed] = ACTIONS(1138),
    [anon_sym_unsigned] = ACTIONS(1138),
    [anon_sym_long] = ACTIONS(1138),
    [anon_sym_short] = ACTIONS(1138),
    [anon_sym_bool] = ACTIONS(1138),
    [anon_sym_char] = ACTIONS(1138),
    [anon_sym_uchar] = ACTIONS(1138),
    [anon_sym_ushort] = ACTIONS(1138),
    [anon_sym_int] = ACTIONS(1138),
    [anon_sym_uint] = ACTIONS(1138),
    [anon_sym_ulong] = ACTIONS(1138),
    [anon_sym_float] = ACTIONS(1138),
    [anon_sym_double] = ACTIONS(1138),
    [anon_sym_half] = ACTIONS(1138),
    [anon_sym_size_t] = ACTIONS(1138),
    [anon_sym_ptrdiff_t] = ACTIONS(1138),
    [anon_sym_intptr_t] = ACTIONS(1138),
    [anon_sym_uintptr_t] = ACTIONS(1138),
    [anon_sym_void] = ACTIONS(1138),
    [sym_vector_type] = ACTIONS(1138),
    [anon_sym_image2d_t] = ACTIONS(1138),
    [anon_sym_image3d_t] = ACTIONS(1138),
    [anon_sym_image2d_array_t] = ACTIONS(1138),
    [anon_sym_image1d_t] = ACTIONS(1138),
    [anon_sym_image1d_buffer_t] = ACTIONS(1138),
    [anon_sym_image1d_array_t] = ACTIONS(1138),
    [anon_sym_image2d_depth_t] = ACTIONS(1138),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1138),
    [anon_sym_sampler_t] = ACTIONS(1138),
    [anon_sym_queue_t] = ACTIONS(1138),
    [anon_sym_ndrange_t] = ACTIONS(1138),
    [anon_sym_clk_event_t] = ACTIONS(1138),
    [anon_sym_reserve_id_t] = ACTIONS(1138),
    [anon_sym_event_t] = ACTIONS(1138),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1138),
    [anon_sym_enum] = ACTIONS(1138),
    [anon_sym_struct] = ACTIONS(1138),
    [anon_sym_union] = ACTIONS(1138),
    [anon_sym_COLON] = ACTIONS(1140),
    [anon_sym_if] = ACTIONS(1138),
    [anon_sym_switch] = ACTIONS(1138),
    [anon_sym_case] = ACTIONS(1138),
    [anon_sym_default] = ACTIONS(1138),
    [anon_sym_while] = ACTIONS(1138),
    [anon_sym_do] = ACTIONS(1138),
    [anon_sym_for] = ACTIONS(1138),
    [anon_sym_return] = ACTIONS(1138),
    [anon_sym_break] = ACTIONS(1138),
    [anon_sym_continue] = ACTIONS(1138),
    [anon_sym_goto] = ACTIONS(1138),
    [anon_sym_DASH_DASH] = ACTIONS(1140),
    [anon_sym_PLUS_PLUS] = ACTIONS(1140),
    [anon_sym_sizeof] = ACTIONS(1138),
    [sym_number_literal] = ACTIONS(1140),
    [anon_sym_L_SQUOTE] = ACTIONS(1140),
    [anon_sym_u_SQUOTE] = ACTIONS(1140),
    [anon_sym_U_SQUOTE] = ACTIONS(1140),
    [anon_sym_u8_SQUOTE] = ACTIONS(1140),
    [anon_sym_SQUOTE] = ACTIONS(1140),
    [anon_sym_L_DQUOTE] = ACTIONS(1140),
    [anon_sym_u_DQUOTE] = ACTIONS(1140),
    [anon_sym_U_DQUOTE] = ACTIONS(1140),
    [anon_sym_u8_DQUOTE] = ACTIONS(1140),
    [anon_sym_DQUOTE] = ACTIONS(1140),
    [sym_true] = ACTIONS(1138),
    [sym_false] = ACTIONS(1138),
    [sym_null] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_identifier] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1144),
    [anon_sym_RPAREN] = ACTIONS(1144),
    [anon_sym_LPAREN2] = ACTIONS(1144),
    [anon_sym_BANG] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1142),
    [anon_sym_PLUS] = ACTIONS(1142),
    [anon_sym_STAR] = ACTIONS(1144),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1144),
    [anon_sym_kernel] = ACTIONS(1142),
    [anon_sym___kernel] = ACTIONS(1142),
    [anon_sym_global] = ACTIONS(1142),
    [anon_sym___global] = ACTIONS(1142),
    [anon_sym_local] = ACTIONS(1142),
    [anon_sym___local] = ACTIONS(1142),
    [anon_sym_constant] = ACTIONS(1142),
    [anon_sym___constant] = ACTIONS(1142),
    [anon_sym_private] = ACTIONS(1142),
    [anon_sym___private] = ACTIONS(1142),
    [anon_sym_generic] = ACTIONS(1142),
    [anon_sym___generic] = ACTIONS(1142),
    [anon_sym_read_only] = ACTIONS(1142),
    [anon_sym___read_only] = ACTIONS(1142),
    [anon_sym_write_only] = ACTIONS(1142),
    [anon_sym___write_only] = ACTIONS(1142),
    [anon_sym_read_write] = ACTIONS(1142),
    [anon_sym___read_write] = ACTIONS(1142),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym___attribute__] = ACTIONS(1142),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1144),
    [anon_sym___declspec] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_auto] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_pipe] = ACTIONS(1142),
    [anon_sym_signed] = ACTIONS(1142),
    [anon_sym_unsigned] = ACTIONS(1142),
    [anon_sym_long] = ACTIONS(1142),
    [anon_sym_short] = ACTIONS(1142),
    [anon_sym_bool] = ACTIONS(1142),
    [anon_sym_char] = ACTIONS(1142),
    [anon_sym_uchar] = ACTIONS(1142),
    [anon_sym_ushort] = ACTIONS(1142),
    [anon_sym_int] = ACTIONS(1142),
    [anon_sym_uint] = ACTIONS(1142),
    [anon_sym_ulong] = ACTIONS(1142),
    [anon_sym_float] = ACTIONS(1142),
    [anon_sym_double] = ACTIONS(1142),
    [anon_sym_half] = ACTIONS(1142),
    [anon_sym_size_t] = ACTIONS(1142),
    [anon_sym_ptrdiff_t] = ACTIONS(1142),
    [anon_sym_intptr_t] = ACTIONS(1142),
    [anon_sym_uintptr_t] = ACTIONS(1142),
    [anon_sym_void] = ACTIONS(1142),
    [sym_vector_type] = ACTIONS(1142),
    [anon_sym_image2d_t] = ACTIONS(1142),
    [anon_sym_image3d_t] = ACTIONS(1142),
    [anon_sym_image2d_array_t] = ACTIONS(1142),
    [anon_sym_image1d_t] = ACTIONS(1142),
    [anon_sym_image1d_buffer_t] = ACTIONS(1142),
    [anon_sym_image1d_array_t] = ACTIONS(1142),
    [anon_sym_image2d_depth_t] = ACTIONS(1142),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1142),
    [anon_sym_sampler_t] = ACTIONS(1142),
    [anon_sym_queue_t] = ACTIONS(1142),
    [anon_sym_ndrange_t] = ACTIONS(1142),
    [anon_sym_clk_event_t] = ACTIONS(1142),
    [anon_sym_reserve_id_t] = ACTIONS(1142),
    [anon_sym_event_t] = ACTIONS(1142),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1142),
    [anon_sym_enum] = ACTIONS(1142),
    [anon_sym_struct] = ACTIONS(1142),
    [anon_sym_union] = ACTIONS(1142),
    [anon_sym_COLON] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(1142),
    [anon_sym_default] = ACTIONS(1142),
    [anon_sym_while] = ACTIONS(1142),
    [anon_sym_do] = ACTIONS(1142),
    [anon_sym_for] = ACTIONS(1142),
    [anon_sym_return] = ACTIONS(1142),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_continue] = ACTIONS(1142),
    [anon_sym_goto] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1144),
    [anon_sym_sizeof] = ACTIONS(1142),
    [sym_number_literal] = ACTIONS(1144),
    [anon_sym_L_SQUOTE] = ACTIONS(1144),
    [anon_sym_u_SQUOTE] = ACTIONS(1144),
    [anon_sym_U_SQUOTE] = ACTIONS(1144),
    [anon_sym_u8_SQUOTE] = ACTIONS(1144),
    [anon_sym_SQUOTE] = ACTIONS(1144),
    [anon_sym_L_DQUOTE] = ACTIONS(1144),
    [anon_sym_u_DQUOTE] = ACTIONS(1144),
    [anon_sym_U_DQUOTE] = ACTIONS(1144),
    [anon_sym_u8_DQUOTE] = ACTIONS(1144),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [sym_true] = ACTIONS(1142),
    [sym_false] = ACTIONS(1142),
    [sym_null] = ACTIONS(1142),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(906),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_based_modifier] = STATE(1382),
    [sym__declarator] = STATE(1130),
    [sym__abstract_declarator] = STATE(1179),
    [sym_parenthesized_declarator] = STATE(1117),
    [sym_abstract_parenthesized_declarator] = STATE(1160),
    [sym_attributed_declarator] = STATE(1117),
    [sym_pointer_declarator] = STATE(1117),
    [sym_abstract_pointer_declarator] = STATE(1160),
    [sym_function_declarator] = STATE(1117),
    [sym_abstract_function_declarator] = STATE(1160),
    [sym_array_declarator] = STATE(1117),
    [sym_abstract_array_declarator] = STATE(1160),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_variadic_parameter] = STATE(1209),
    [sym_parameter_list] = STATE(1162),
    [sym_parameter_declaration] = STATE(1209),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1148),
    [anon_sym_RPAREN] = ACTIONS(1150),
    [anon_sym_LPAREN2] = ACTIONS(1152),
    [anon_sym_STAR] = ACTIONS(1154),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___based] = ACTIONS(1156),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_preproc_def] = STATE(305),
    [sym_preproc_function_def] = STATE(305),
    [sym_preproc_call] = STATE(305),
    [sym_preproc_if_in_field_declaration_list] = STATE(305),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(305),
    [sym_preproc_else_in_field_declaration_list] = STATE(1454),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1454),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(305),
    [sym_field_declaration] = STATE(305),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(305),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1166),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_preproc_def] = STATE(302),
    [sym_preproc_function_def] = STATE(302),
    [sym_preproc_call] = STATE(302),
    [sym_preproc_if_in_field_declaration_list] = STATE(302),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(302),
    [sym_preproc_else_in_field_declaration_list] = STATE(1351),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1351),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(302),
    [sym_field_declaration] = STATE(302),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(302),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_preproc_def] = STATE(301),
    [sym_preproc_function_def] = STATE(301),
    [sym_preproc_call] = STATE(301),
    [sym_preproc_if_in_field_declaration_list] = STATE(301),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(301),
    [sym_preproc_else_in_field_declaration_list] = STATE(1430),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1430),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(301),
    [sym_field_declaration] = STATE(301),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(301),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1178),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_preproc_def] = STATE(313),
    [sym_preproc_function_def] = STATE(313),
    [sym_preproc_call] = STATE(313),
    [sym_preproc_if_in_field_declaration_list] = STATE(313),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(313),
    [sym_preproc_else_in_field_declaration_list] = STATE(1322),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1322),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(313),
    [sym_field_declaration] = STATE(313),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(313),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1180),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_preproc_def] = STATE(313),
    [sym_preproc_function_def] = STATE(313),
    [sym_preproc_call] = STATE(313),
    [sym_preproc_if_in_field_declaration_list] = STATE(313),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(313),
    [sym_preproc_else_in_field_declaration_list] = STATE(1370),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1370),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(313),
    [sym_field_declaration] = STATE(313),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(313),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1182),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_preproc_def] = STATE(306),
    [sym_preproc_function_def] = STATE(306),
    [sym_preproc_call] = STATE(306),
    [sym_preproc_if_in_field_declaration_list] = STATE(306),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(306),
    [sym_preproc_else_in_field_declaration_list] = STATE(1444),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1444),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(306),
    [sym_field_declaration] = STATE(306),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(306),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1184),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [sym_preproc_def] = STATE(313),
    [sym_preproc_function_def] = STATE(313),
    [sym_preproc_call] = STATE(313),
    [sym_preproc_if_in_field_declaration_list] = STATE(313),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(313),
    [sym_preproc_else_in_field_declaration_list] = STATE(1319),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1319),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(313),
    [sym_field_declaration] = STATE(313),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(313),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1186),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_preproc_def] = STATE(313),
    [sym_preproc_function_def] = STATE(313),
    [sym_preproc_call] = STATE(313),
    [sym_preproc_if_in_field_declaration_list] = STATE(313),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(313),
    [sym_preproc_else_in_field_declaration_list] = STATE(1441),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1441),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(313),
    [sym_field_declaration] = STATE(313),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(313),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1188),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_preproc_def] = STATE(313),
    [sym_preproc_function_def] = STATE(313),
    [sym_preproc_call] = STATE(313),
    [sym_preproc_if_in_field_declaration_list] = STATE(313),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(313),
    [sym_preproc_else_in_field_declaration_list] = STATE(1432),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1432),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(313),
    [sym_field_declaration] = STATE(313),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(313),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1190),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym_preproc_def] = STATE(311),
    [sym_preproc_function_def] = STATE(311),
    [sym_preproc_call] = STATE(311),
    [sym_preproc_if_in_field_declaration_list] = STATE(311),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(311),
    [sym_preproc_else_in_field_declaration_list] = STATE(1402),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1402),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(311),
    [sym_field_declaration] = STATE(311),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(311),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1192),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym_preproc_def] = STATE(313),
    [sym_preproc_function_def] = STATE(313),
    [sym_preproc_call] = STATE(313),
    [sym_preproc_if_in_field_declaration_list] = STATE(313),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(313),
    [sym_preproc_else_in_field_declaration_list] = STATE(1372),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1372),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(313),
    [sym_field_declaration] = STATE(313),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(313),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1194),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_preproc_def] = STATE(304),
    [sym_preproc_function_def] = STATE(304),
    [sym_preproc_call] = STATE(304),
    [sym_preproc_if_in_field_declaration_list] = STATE(304),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(304),
    [sym_preproc_else_in_field_declaration_list] = STATE(1374),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1374),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(304),
    [sym_field_declaration] = STATE(304),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(304),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1196),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_preproc_def] = STATE(308),
    [sym_preproc_function_def] = STATE(308),
    [sym_preproc_call] = STATE(308),
    [sym_preproc_if_in_field_declaration_list] = STATE(308),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(308),
    [sym_preproc_else_in_field_declaration_list] = STATE(1379),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1379),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(308),
    [sym_field_declaration] = STATE(308),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(308),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_preproc_def] = STATE(313),
    [sym_preproc_function_def] = STATE(313),
    [sym_preproc_call] = STATE(313),
    [sym_preproc_if_in_field_declaration_list] = STATE(313),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(313),
    [sym_preproc_else_in_field_declaration_list] = STATE(1407),
    [sym_preproc_elif_in_field_declaration_list] = STATE(1407),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(313),
    [sym_field_declaration] = STATE(313),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(313),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1162),
    [aux_sym_preproc_if_token1] = ACTIONS(1164),
    [aux_sym_preproc_if_token2] = ACTIONS(1200),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1168),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1168),
    [aux_sym_preproc_else_token1] = ACTIONS(1170),
    [aux_sym_preproc_elif_token1] = ACTIONS(1172),
    [sym_preproc_directive] = ACTIONS(1174),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_LPAREN2] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1205),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_kernel] = ACTIONS(1209),
    [anon_sym___kernel] = ACTIONS(1209),
    [anon_sym_global] = ACTIONS(1209),
    [anon_sym___global] = ACTIONS(1209),
    [anon_sym_local] = ACTIONS(1209),
    [anon_sym___local] = ACTIONS(1209),
    [anon_sym_constant] = ACTIONS(1209),
    [anon_sym___constant] = ACTIONS(1209),
    [anon_sym_private] = ACTIONS(1209),
    [anon_sym___private] = ACTIONS(1209),
    [anon_sym_generic] = ACTIONS(1209),
    [anon_sym___generic] = ACTIONS(1209),
    [anon_sym_read_only] = ACTIONS(1209),
    [anon_sym___read_only] = ACTIONS(1209),
    [anon_sym_write_only] = ACTIONS(1209),
    [anon_sym___write_only] = ACTIONS(1209),
    [anon_sym_read_write] = ACTIONS(1209),
    [anon_sym___read_write] = ACTIONS(1209),
    [anon_sym_extern] = ACTIONS(1209),
    [anon_sym___attribute__] = ACTIONS(1209),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1211),
    [anon_sym___declspec] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_static] = ACTIONS(1209),
    [anon_sym_auto] = ACTIONS(1209),
    [anon_sym_register] = ACTIONS(1209),
    [anon_sym_inline] = ACTIONS(1209),
    [anon_sym_const] = ACTIONS(1209),
    [anon_sym_volatile] = ACTIONS(1209),
    [anon_sym_restrict] = ACTIONS(1209),
    [anon_sym__Atomic] = ACTIONS(1209),
    [anon_sym_pipe] = ACTIONS(1209),
    [anon_sym_signed] = ACTIONS(1209),
    [anon_sym_unsigned] = ACTIONS(1209),
    [anon_sym_long] = ACTIONS(1209),
    [anon_sym_short] = ACTIONS(1209),
    [anon_sym_bool] = ACTIONS(1209),
    [anon_sym_char] = ACTIONS(1209),
    [anon_sym_uchar] = ACTIONS(1209),
    [anon_sym_ushort] = ACTIONS(1209),
    [anon_sym_int] = ACTIONS(1209),
    [anon_sym_uint] = ACTIONS(1209),
    [anon_sym_ulong] = ACTIONS(1209),
    [anon_sym_float] = ACTIONS(1209),
    [anon_sym_double] = ACTIONS(1209),
    [anon_sym_half] = ACTIONS(1209),
    [anon_sym_size_t] = ACTIONS(1209),
    [anon_sym_ptrdiff_t] = ACTIONS(1209),
    [anon_sym_intptr_t] = ACTIONS(1209),
    [anon_sym_uintptr_t] = ACTIONS(1209),
    [anon_sym_void] = ACTIONS(1209),
    [sym_vector_type] = ACTIONS(1209),
    [anon_sym_image2d_t] = ACTIONS(1209),
    [anon_sym_image3d_t] = ACTIONS(1209),
    [anon_sym_image2d_array_t] = ACTIONS(1209),
    [anon_sym_image1d_t] = ACTIONS(1209),
    [anon_sym_image1d_buffer_t] = ACTIONS(1209),
    [anon_sym_image1d_array_t] = ACTIONS(1209),
    [anon_sym_image2d_depth_t] = ACTIONS(1209),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1209),
    [anon_sym_sampler_t] = ACTIONS(1209),
    [anon_sym_queue_t] = ACTIONS(1209),
    [anon_sym_ndrange_t] = ACTIONS(1209),
    [anon_sym_clk_event_t] = ACTIONS(1209),
    [anon_sym_reserve_id_t] = ACTIONS(1209),
    [anon_sym_event_t] = ACTIONS(1209),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1209),
    [anon_sym_enum] = ACTIONS(1209),
    [anon_sym_struct] = ACTIONS(1209),
    [anon_sym_union] = ACTIONS(1209),
    [anon_sym_if] = ACTIONS(1207),
    [anon_sym_switch] = ACTIONS(1207),
    [anon_sym_case] = ACTIONS(1207),
    [anon_sym_default] = ACTIONS(1207),
    [anon_sym_while] = ACTIONS(1207),
    [anon_sym_do] = ACTIONS(1207),
    [anon_sym_for] = ACTIONS(1207),
    [anon_sym_return] = ACTIONS(1207),
    [anon_sym_break] = ACTIONS(1207),
    [anon_sym_continue] = ACTIONS(1207),
    [anon_sym_goto] = ACTIONS(1207),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_sizeof] = ACTIONS(1207),
    [sym_number_literal] = ACTIONS(1205),
    [anon_sym_L_SQUOTE] = ACTIONS(1205),
    [anon_sym_u_SQUOTE] = ACTIONS(1205),
    [anon_sym_U_SQUOTE] = ACTIONS(1205),
    [anon_sym_u8_SQUOTE] = ACTIONS(1205),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [anon_sym_L_DQUOTE] = ACTIONS(1205),
    [anon_sym_u_DQUOTE] = ACTIONS(1205),
    [anon_sym_U_DQUOTE] = ACTIONS(1205),
    [anon_sym_u8_DQUOTE] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [sym_true] = ACTIONS(1207),
    [sym_false] = ACTIONS(1207),
    [sym_null] = ACTIONS(1207),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_preproc_def] = STATE(313),
    [sym_preproc_function_def] = STATE(313),
    [sym_preproc_call] = STATE(313),
    [sym_preproc_if_in_field_declaration_list] = STATE(313),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(313),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1007),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(313),
    [sym_field_declaration] = STATE(313),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(313),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1214),
    [aux_sym_preproc_def_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token1] = ACTIONS(1220),
    [aux_sym_preproc_if_token2] = ACTIONS(1223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1225),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1225),
    [aux_sym_preproc_else_token1] = ACTIONS(1223),
    [aux_sym_preproc_elif_token1] = ACTIONS(1223),
    [sym_preproc_directive] = ACTIONS(1228),
    [anon_sym_kernel] = ACTIONS(1231),
    [anon_sym___kernel] = ACTIONS(1231),
    [anon_sym_global] = ACTIONS(1234),
    [anon_sym___global] = ACTIONS(1234),
    [anon_sym_local] = ACTIONS(1234),
    [anon_sym___local] = ACTIONS(1234),
    [anon_sym_constant] = ACTIONS(1234),
    [anon_sym___constant] = ACTIONS(1234),
    [anon_sym_private] = ACTIONS(1234),
    [anon_sym___private] = ACTIONS(1234),
    [anon_sym_generic] = ACTIONS(1234),
    [anon_sym___generic] = ACTIONS(1234),
    [anon_sym_read_only] = ACTIONS(1237),
    [anon_sym___read_only] = ACTIONS(1237),
    [anon_sym_write_only] = ACTIONS(1237),
    [anon_sym___write_only] = ACTIONS(1237),
    [anon_sym_read_write] = ACTIONS(1237),
    [anon_sym___read_write] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1240),
    [anon_sym___attribute__] = ACTIONS(1243),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1246),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1240),
    [anon_sym_auto] = ACTIONS(1240),
    [anon_sym_register] = ACTIONS(1240),
    [anon_sym_inline] = ACTIONS(1240),
    [anon_sym_const] = ACTIONS(1252),
    [anon_sym_volatile] = ACTIONS(1252),
    [anon_sym_restrict] = ACTIONS(1252),
    [anon_sym__Atomic] = ACTIONS(1252),
    [anon_sym_pipe] = ACTIONS(1252),
    [anon_sym_signed] = ACTIONS(1255),
    [anon_sym_unsigned] = ACTIONS(1255),
    [anon_sym_long] = ACTIONS(1255),
    [anon_sym_short] = ACTIONS(1255),
    [anon_sym_bool] = ACTIONS(1258),
    [anon_sym_char] = ACTIONS(1258),
    [anon_sym_uchar] = ACTIONS(1258),
    [anon_sym_ushort] = ACTIONS(1258),
    [anon_sym_int] = ACTIONS(1258),
    [anon_sym_uint] = ACTIONS(1258),
    [anon_sym_ulong] = ACTIONS(1258),
    [anon_sym_float] = ACTIONS(1258),
    [anon_sym_double] = ACTIONS(1258),
    [anon_sym_half] = ACTIONS(1258),
    [anon_sym_size_t] = ACTIONS(1258),
    [anon_sym_ptrdiff_t] = ACTIONS(1258),
    [anon_sym_intptr_t] = ACTIONS(1258),
    [anon_sym_uintptr_t] = ACTIONS(1258),
    [anon_sym_void] = ACTIONS(1258),
    [sym_vector_type] = ACTIONS(1261),
    [anon_sym_image2d_t] = ACTIONS(1264),
    [anon_sym_image3d_t] = ACTIONS(1264),
    [anon_sym_image2d_array_t] = ACTIONS(1264),
    [anon_sym_image1d_t] = ACTIONS(1264),
    [anon_sym_image1d_buffer_t] = ACTIONS(1264),
    [anon_sym_image1d_array_t] = ACTIONS(1264),
    [anon_sym_image2d_depth_t] = ACTIONS(1264),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1264),
    [anon_sym_sampler_t] = ACTIONS(1264),
    [anon_sym_queue_t] = ACTIONS(1264),
    [anon_sym_ndrange_t] = ACTIONS(1264),
    [anon_sym_clk_event_t] = ACTIONS(1264),
    [anon_sym_reserve_id_t] = ACTIONS(1264),
    [anon_sym_event_t] = ACTIONS(1264),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1264),
    [anon_sym_enum] = ACTIONS(1267),
    [anon_sym_struct] = ACTIONS(1270),
    [anon_sym_union] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_preproc_def] = STATE(320),
    [sym_preproc_function_def] = STATE(320),
    [sym_preproc_call] = STATE(320),
    [sym_preproc_if_in_field_declaration_list] = STATE(320),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(320),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1006),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(320),
    [sym_field_declaration] = STATE(320),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(320),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1276),
    [aux_sym_preproc_if_token1] = ACTIONS(1278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1280),
    [sym_preproc_directive] = ACTIONS(1282),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym_preproc_def] = STATE(319),
    [sym_preproc_function_def] = STATE(319),
    [sym_preproc_call] = STATE(319),
    [sym_preproc_if_in_field_declaration_list] = STATE(319),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(319),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1005),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(319),
    [sym_field_declaration] = STATE(319),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(319),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1286),
    [aux_sym_preproc_if_token1] = ACTIONS(1288),
    [aux_sym_preproc_if_token2] = ACTIONS(1290),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1294),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [sym_preproc_def] = STATE(315),
    [sym_preproc_function_def] = STATE(315),
    [sym_preproc_call] = STATE(315),
    [sym_preproc_if_in_field_declaration_list] = STATE(315),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(315),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1005),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(315),
    [sym_field_declaration] = STATE(315),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(315),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1286),
    [aux_sym_preproc_if_token1] = ACTIONS(1288),
    [aux_sym_preproc_if_token2] = ACTIONS(1296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1294),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_preproc_def] = STATE(317),
    [sym_preproc_function_def] = STATE(317),
    [sym_preproc_call] = STATE(317),
    [sym_preproc_if_in_field_declaration_list] = STATE(317),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(317),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1006),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(317),
    [sym_field_declaration] = STATE(317),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(317),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1214),
    [aux_sym_preproc_def_token1] = ACTIONS(1298),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1304),
    [sym_preproc_directive] = ACTIONS(1307),
    [anon_sym_kernel] = ACTIONS(1231),
    [anon_sym___kernel] = ACTIONS(1231),
    [anon_sym_global] = ACTIONS(1234),
    [anon_sym___global] = ACTIONS(1234),
    [anon_sym_local] = ACTIONS(1234),
    [anon_sym___local] = ACTIONS(1234),
    [anon_sym_constant] = ACTIONS(1234),
    [anon_sym___constant] = ACTIONS(1234),
    [anon_sym_private] = ACTIONS(1234),
    [anon_sym___private] = ACTIONS(1234),
    [anon_sym_generic] = ACTIONS(1234),
    [anon_sym___generic] = ACTIONS(1234),
    [anon_sym_read_only] = ACTIONS(1237),
    [anon_sym___read_only] = ACTIONS(1237),
    [anon_sym_write_only] = ACTIONS(1237),
    [anon_sym___write_only] = ACTIONS(1237),
    [anon_sym_read_write] = ACTIONS(1237),
    [anon_sym___read_write] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1240),
    [anon_sym___attribute__] = ACTIONS(1243),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1246),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1240),
    [anon_sym_auto] = ACTIONS(1240),
    [anon_sym_register] = ACTIONS(1240),
    [anon_sym_inline] = ACTIONS(1240),
    [anon_sym_const] = ACTIONS(1252),
    [anon_sym_volatile] = ACTIONS(1252),
    [anon_sym_restrict] = ACTIONS(1252),
    [anon_sym__Atomic] = ACTIONS(1252),
    [anon_sym_pipe] = ACTIONS(1252),
    [anon_sym_signed] = ACTIONS(1255),
    [anon_sym_unsigned] = ACTIONS(1255),
    [anon_sym_long] = ACTIONS(1255),
    [anon_sym_short] = ACTIONS(1255),
    [anon_sym_bool] = ACTIONS(1258),
    [anon_sym_char] = ACTIONS(1258),
    [anon_sym_uchar] = ACTIONS(1258),
    [anon_sym_ushort] = ACTIONS(1258),
    [anon_sym_int] = ACTIONS(1258),
    [anon_sym_uint] = ACTIONS(1258),
    [anon_sym_ulong] = ACTIONS(1258),
    [anon_sym_float] = ACTIONS(1258),
    [anon_sym_double] = ACTIONS(1258),
    [anon_sym_half] = ACTIONS(1258),
    [anon_sym_size_t] = ACTIONS(1258),
    [anon_sym_ptrdiff_t] = ACTIONS(1258),
    [anon_sym_intptr_t] = ACTIONS(1258),
    [anon_sym_uintptr_t] = ACTIONS(1258),
    [anon_sym_void] = ACTIONS(1258),
    [sym_vector_type] = ACTIONS(1261),
    [anon_sym_image2d_t] = ACTIONS(1264),
    [anon_sym_image3d_t] = ACTIONS(1264),
    [anon_sym_image2d_array_t] = ACTIONS(1264),
    [anon_sym_image1d_t] = ACTIONS(1264),
    [anon_sym_image1d_buffer_t] = ACTIONS(1264),
    [anon_sym_image1d_array_t] = ACTIONS(1264),
    [anon_sym_image2d_depth_t] = ACTIONS(1264),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1264),
    [anon_sym_sampler_t] = ACTIONS(1264),
    [anon_sym_queue_t] = ACTIONS(1264),
    [anon_sym_ndrange_t] = ACTIONS(1264),
    [anon_sym_clk_event_t] = ACTIONS(1264),
    [anon_sym_reserve_id_t] = ACTIONS(1264),
    [anon_sym_event_t] = ACTIONS(1264),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1264),
    [anon_sym_enum] = ACTIONS(1267),
    [anon_sym_struct] = ACTIONS(1270),
    [anon_sym_union] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [sym_preproc_def] = STATE(317),
    [sym_preproc_function_def] = STATE(317),
    [sym_preproc_call] = STATE(317),
    [sym_preproc_if_in_field_declaration_list] = STATE(317),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(317),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1006),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(317),
    [sym_field_declaration] = STATE(317),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(317),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1276),
    [aux_sym_preproc_if_token1] = ACTIONS(1278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1280),
    [sym_preproc_directive] = ACTIONS(1282),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(1312),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym_preproc_def] = STATE(319),
    [sym_preproc_function_def] = STATE(319),
    [sym_preproc_call] = STATE(319),
    [sym_preproc_if_in_field_declaration_list] = STATE(319),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(319),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1005),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(319),
    [sym_field_declaration] = STATE(319),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(319),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1214),
    [aux_sym_preproc_def_token1] = ACTIONS(1314),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token2] = ACTIONS(1223),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1323),
    [anon_sym_kernel] = ACTIONS(1231),
    [anon_sym___kernel] = ACTIONS(1231),
    [anon_sym_global] = ACTIONS(1234),
    [anon_sym___global] = ACTIONS(1234),
    [anon_sym_local] = ACTIONS(1234),
    [anon_sym___local] = ACTIONS(1234),
    [anon_sym_constant] = ACTIONS(1234),
    [anon_sym___constant] = ACTIONS(1234),
    [anon_sym_private] = ACTIONS(1234),
    [anon_sym___private] = ACTIONS(1234),
    [anon_sym_generic] = ACTIONS(1234),
    [anon_sym___generic] = ACTIONS(1234),
    [anon_sym_read_only] = ACTIONS(1237),
    [anon_sym___read_only] = ACTIONS(1237),
    [anon_sym_write_only] = ACTIONS(1237),
    [anon_sym___write_only] = ACTIONS(1237),
    [anon_sym_read_write] = ACTIONS(1237),
    [anon_sym___read_write] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1240),
    [anon_sym___attribute__] = ACTIONS(1243),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1246),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1240),
    [anon_sym_auto] = ACTIONS(1240),
    [anon_sym_register] = ACTIONS(1240),
    [anon_sym_inline] = ACTIONS(1240),
    [anon_sym_const] = ACTIONS(1252),
    [anon_sym_volatile] = ACTIONS(1252),
    [anon_sym_restrict] = ACTIONS(1252),
    [anon_sym__Atomic] = ACTIONS(1252),
    [anon_sym_pipe] = ACTIONS(1252),
    [anon_sym_signed] = ACTIONS(1255),
    [anon_sym_unsigned] = ACTIONS(1255),
    [anon_sym_long] = ACTIONS(1255),
    [anon_sym_short] = ACTIONS(1255),
    [anon_sym_bool] = ACTIONS(1258),
    [anon_sym_char] = ACTIONS(1258),
    [anon_sym_uchar] = ACTIONS(1258),
    [anon_sym_ushort] = ACTIONS(1258),
    [anon_sym_int] = ACTIONS(1258),
    [anon_sym_uint] = ACTIONS(1258),
    [anon_sym_ulong] = ACTIONS(1258),
    [anon_sym_float] = ACTIONS(1258),
    [anon_sym_double] = ACTIONS(1258),
    [anon_sym_half] = ACTIONS(1258),
    [anon_sym_size_t] = ACTIONS(1258),
    [anon_sym_ptrdiff_t] = ACTIONS(1258),
    [anon_sym_intptr_t] = ACTIONS(1258),
    [anon_sym_uintptr_t] = ACTIONS(1258),
    [anon_sym_void] = ACTIONS(1258),
    [sym_vector_type] = ACTIONS(1261),
    [anon_sym_image2d_t] = ACTIONS(1264),
    [anon_sym_image3d_t] = ACTIONS(1264),
    [anon_sym_image2d_array_t] = ACTIONS(1264),
    [anon_sym_image1d_t] = ACTIONS(1264),
    [anon_sym_image1d_buffer_t] = ACTIONS(1264),
    [anon_sym_image1d_array_t] = ACTIONS(1264),
    [anon_sym_image2d_depth_t] = ACTIONS(1264),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1264),
    [anon_sym_sampler_t] = ACTIONS(1264),
    [anon_sym_queue_t] = ACTIONS(1264),
    [anon_sym_ndrange_t] = ACTIONS(1264),
    [anon_sym_clk_event_t] = ACTIONS(1264),
    [anon_sym_reserve_id_t] = ACTIONS(1264),
    [anon_sym_event_t] = ACTIONS(1264),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1264),
    [anon_sym_enum] = ACTIONS(1267),
    [anon_sym_struct] = ACTIONS(1270),
    [anon_sym_union] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_preproc_def] = STATE(317),
    [sym_preproc_function_def] = STATE(317),
    [sym_preproc_call] = STATE(317),
    [sym_preproc_if_in_field_declaration_list] = STATE(317),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(317),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1006),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(317),
    [sym_field_declaration] = STATE(317),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(317),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1276),
    [aux_sym_preproc_if_token1] = ACTIONS(1278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1280),
    [sym_preproc_directive] = ACTIONS(1282),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(1326),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [sym_preproc_def] = STATE(318),
    [sym_preproc_function_def] = STATE(318),
    [sym_preproc_call] = STATE(318),
    [sym_preproc_if_in_field_declaration_list] = STATE(318),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(318),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1006),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym__field_declaration_list_item] = STATE(318),
    [sym_field_declaration] = STATE(318),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(318),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [aux_sym_preproc_def_token1] = ACTIONS(1276),
    [aux_sym_preproc_if_token1] = ACTIONS(1278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1280),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1280),
    [sym_preproc_directive] = ACTIONS(1282),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(1328),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(906),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym__abstract_declarator] = STATE(1179),
    [sym_abstract_parenthesized_declarator] = STATE(1160),
    [sym_abstract_pointer_declarator] = STATE(1160),
    [sym_abstract_function_declarator] = STATE(1160),
    [sym_abstract_array_declarator] = STATE(1160),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_variadic_parameter] = STATE(1209),
    [sym_parameter_list] = STATE(1162),
    [sym_parameter_declaration] = STATE(1209),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1148),
    [anon_sym_RPAREN] = ACTIONS(1150),
    [anon_sym_LPAREN2] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_function_definition] = STATE(291),
    [sym_declaration] = STATE(291),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1022),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(338),
    [sym_declaration_list] = STATE(291),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym_function_definition] = STATE(264),
    [sym_declaration] = STATE(264),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1011),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(340),
    [sym_declaration_list] = STATE(264),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [sym_function_definition] = STATE(253),
    [sym_declaration] = STATE(253),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1014),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(337),
    [sym_declaration_list] = STATE(253),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_function_definition] = STATE(111),
    [sym_declaration] = STATE(111),
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1018),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_ms_call_modifier] = STATE(339),
    [sym_declaration_list] = STATE(111),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [327] = {
    [sym_type_qualifier] = STATE(516),
    [sym__type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(1088),
    [sym_scalar_type] = STATE(1088),
    [sym_other_builtin_type] = STATE(1088),
    [sym_enum_specifier] = STATE(1088),
    [sym_struct_specifier] = STATE(1088),
    [sym_union_specifier] = STATE(1088),
    [sym__expression] = STATE(815),
    [sym_comma_expression] = STATE(1418),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_type_descriptor] = STATE(1417),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(1088),
    [aux_sym_type_definition_repeat1] = STATE(516),
    [aux_sym_sized_type_specifier_repeat1] = STATE(785),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(1344),
    [anon_sym_volatile] = ACTIONS(1344),
    [anon_sym_restrict] = ACTIONS(1344),
    [anon_sym__Atomic] = ACTIONS(1344),
    [anon_sym_pipe] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_bool] = ACTIONS(1348),
    [anon_sym_char] = ACTIONS(1348),
    [anon_sym_uchar] = ACTIONS(1348),
    [anon_sym_ushort] = ACTIONS(1348),
    [anon_sym_int] = ACTIONS(1348),
    [anon_sym_uint] = ACTIONS(1348),
    [anon_sym_ulong] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1348),
    [anon_sym_double] = ACTIONS(1348),
    [anon_sym_half] = ACTIONS(1348),
    [anon_sym_size_t] = ACTIONS(1348),
    [anon_sym_ptrdiff_t] = ACTIONS(1348),
    [anon_sym_intptr_t] = ACTIONS(1348),
    [anon_sym_uintptr_t] = ACTIONS(1348),
    [anon_sym_void] = ACTIONS(1348),
    [sym_vector_type] = ACTIONS(1350),
    [anon_sym_image2d_t] = ACTIONS(1352),
    [anon_sym_image3d_t] = ACTIONS(1352),
    [anon_sym_image2d_array_t] = ACTIONS(1352),
    [anon_sym_image1d_t] = ACTIONS(1352),
    [anon_sym_image1d_buffer_t] = ACTIONS(1352),
    [anon_sym_image1d_array_t] = ACTIONS(1352),
    [anon_sym_image2d_depth_t] = ACTIONS(1352),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1352),
    [anon_sym_sampler_t] = ACTIONS(1352),
    [anon_sym_queue_t] = ACTIONS(1352),
    [anon_sym_ndrange_t] = ACTIONS(1352),
    [anon_sym_clk_event_t] = ACTIONS(1352),
    [anon_sym_reserve_id_t] = ACTIONS(1352),
    [anon_sym_event_t] = ACTIONS(1352),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1354),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_type_qualifier] = STATE(516),
    [sym__type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(1088),
    [sym_scalar_type] = STATE(1088),
    [sym_other_builtin_type] = STATE(1088),
    [sym_enum_specifier] = STATE(1088),
    [sym_struct_specifier] = STATE(1088),
    [sym_union_specifier] = STATE(1088),
    [sym__expression] = STATE(815),
    [sym_comma_expression] = STATE(1418),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_type_descriptor] = STATE(1482),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(1088),
    [aux_sym_type_definition_repeat1] = STATE(516),
    [aux_sym_sized_type_specifier_repeat1] = STATE(785),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(1344),
    [anon_sym_volatile] = ACTIONS(1344),
    [anon_sym_restrict] = ACTIONS(1344),
    [anon_sym__Atomic] = ACTIONS(1344),
    [anon_sym_pipe] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_bool] = ACTIONS(1348),
    [anon_sym_char] = ACTIONS(1348),
    [anon_sym_uchar] = ACTIONS(1348),
    [anon_sym_ushort] = ACTIONS(1348),
    [anon_sym_int] = ACTIONS(1348),
    [anon_sym_uint] = ACTIONS(1348),
    [anon_sym_ulong] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1348),
    [anon_sym_double] = ACTIONS(1348),
    [anon_sym_half] = ACTIONS(1348),
    [anon_sym_size_t] = ACTIONS(1348),
    [anon_sym_ptrdiff_t] = ACTIONS(1348),
    [anon_sym_intptr_t] = ACTIONS(1348),
    [anon_sym_uintptr_t] = ACTIONS(1348),
    [anon_sym_void] = ACTIONS(1348),
    [sym_vector_type] = ACTIONS(1350),
    [anon_sym_image2d_t] = ACTIONS(1352),
    [anon_sym_image3d_t] = ACTIONS(1352),
    [anon_sym_image2d_array_t] = ACTIONS(1352),
    [anon_sym_image1d_t] = ACTIONS(1352),
    [anon_sym_image1d_buffer_t] = ACTIONS(1352),
    [anon_sym_image1d_array_t] = ACTIONS(1352),
    [anon_sym_image2d_depth_t] = ACTIONS(1352),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1352),
    [anon_sym_sampler_t] = ACTIONS(1352),
    [anon_sym_queue_t] = ACTIONS(1352),
    [anon_sym_ndrange_t] = ACTIONS(1352),
    [anon_sym_clk_event_t] = ACTIONS(1352),
    [anon_sym_reserve_id_t] = ACTIONS(1352),
    [anon_sym_event_t] = ACTIONS(1352),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1354),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [sym_type_qualifier] = STATE(516),
    [sym__type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(1088),
    [sym_scalar_type] = STATE(1088),
    [sym_other_builtin_type] = STATE(1088),
    [sym_enum_specifier] = STATE(1088),
    [sym_struct_specifier] = STATE(1088),
    [sym_union_specifier] = STATE(1088),
    [sym__expression] = STATE(815),
    [sym_comma_expression] = STATE(1418),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_type_descriptor] = STATE(1416),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(1088),
    [aux_sym_type_definition_repeat1] = STATE(516),
    [aux_sym_sized_type_specifier_repeat1] = STATE(785),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(1344),
    [anon_sym_volatile] = ACTIONS(1344),
    [anon_sym_restrict] = ACTIONS(1344),
    [anon_sym__Atomic] = ACTIONS(1344),
    [anon_sym_pipe] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_bool] = ACTIONS(1348),
    [anon_sym_char] = ACTIONS(1348),
    [anon_sym_uchar] = ACTIONS(1348),
    [anon_sym_ushort] = ACTIONS(1348),
    [anon_sym_int] = ACTIONS(1348),
    [anon_sym_uint] = ACTIONS(1348),
    [anon_sym_ulong] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1348),
    [anon_sym_double] = ACTIONS(1348),
    [anon_sym_half] = ACTIONS(1348),
    [anon_sym_size_t] = ACTIONS(1348),
    [anon_sym_ptrdiff_t] = ACTIONS(1348),
    [anon_sym_intptr_t] = ACTIONS(1348),
    [anon_sym_uintptr_t] = ACTIONS(1348),
    [anon_sym_void] = ACTIONS(1348),
    [sym_vector_type] = ACTIONS(1350),
    [anon_sym_image2d_t] = ACTIONS(1352),
    [anon_sym_image3d_t] = ACTIONS(1352),
    [anon_sym_image2d_array_t] = ACTIONS(1352),
    [anon_sym_image1d_t] = ACTIONS(1352),
    [anon_sym_image1d_buffer_t] = ACTIONS(1352),
    [anon_sym_image1d_array_t] = ACTIONS(1352),
    [anon_sym_image2d_depth_t] = ACTIONS(1352),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1352),
    [anon_sym_sampler_t] = ACTIONS(1352),
    [anon_sym_queue_t] = ACTIONS(1352),
    [anon_sym_ndrange_t] = ACTIONS(1352),
    [anon_sym_clk_event_t] = ACTIONS(1352),
    [anon_sym_reserve_id_t] = ACTIONS(1352),
    [anon_sym_event_t] = ACTIONS(1352),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1354),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [330] = {
    [sym_type_qualifier] = STATE(516),
    [sym__type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(1088),
    [sym_scalar_type] = STATE(1088),
    [sym_other_builtin_type] = STATE(1088),
    [sym_enum_specifier] = STATE(1088),
    [sym_struct_specifier] = STATE(1088),
    [sym_union_specifier] = STATE(1088),
    [sym__expression] = STATE(815),
    [sym_comma_expression] = STATE(1418),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_type_descriptor] = STATE(1393),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(1088),
    [aux_sym_type_definition_repeat1] = STATE(516),
    [aux_sym_sized_type_specifier_repeat1] = STATE(785),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(1344),
    [anon_sym_volatile] = ACTIONS(1344),
    [anon_sym_restrict] = ACTIONS(1344),
    [anon_sym__Atomic] = ACTIONS(1344),
    [anon_sym_pipe] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_bool] = ACTIONS(1348),
    [anon_sym_char] = ACTIONS(1348),
    [anon_sym_uchar] = ACTIONS(1348),
    [anon_sym_ushort] = ACTIONS(1348),
    [anon_sym_int] = ACTIONS(1348),
    [anon_sym_uint] = ACTIONS(1348),
    [anon_sym_ulong] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1348),
    [anon_sym_double] = ACTIONS(1348),
    [anon_sym_half] = ACTIONS(1348),
    [anon_sym_size_t] = ACTIONS(1348),
    [anon_sym_ptrdiff_t] = ACTIONS(1348),
    [anon_sym_intptr_t] = ACTIONS(1348),
    [anon_sym_uintptr_t] = ACTIONS(1348),
    [anon_sym_void] = ACTIONS(1348),
    [sym_vector_type] = ACTIONS(1350),
    [anon_sym_image2d_t] = ACTIONS(1352),
    [anon_sym_image3d_t] = ACTIONS(1352),
    [anon_sym_image2d_array_t] = ACTIONS(1352),
    [anon_sym_image1d_t] = ACTIONS(1352),
    [anon_sym_image1d_buffer_t] = ACTIONS(1352),
    [anon_sym_image1d_array_t] = ACTIONS(1352),
    [anon_sym_image2d_depth_t] = ACTIONS(1352),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1352),
    [anon_sym_sampler_t] = ACTIONS(1352),
    [anon_sym_queue_t] = ACTIONS(1352),
    [anon_sym_ndrange_t] = ACTIONS(1352),
    [anon_sym_clk_event_t] = ACTIONS(1352),
    [anon_sym_reserve_id_t] = ACTIONS(1352),
    [anon_sym_event_t] = ACTIONS(1352),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1354),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [331] = {
    [sym_type_qualifier] = STATE(516),
    [sym__type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(1088),
    [sym_scalar_type] = STATE(1088),
    [sym_other_builtin_type] = STATE(1088),
    [sym_enum_specifier] = STATE(1088),
    [sym_struct_specifier] = STATE(1088),
    [sym_union_specifier] = STATE(1088),
    [sym__expression] = STATE(815),
    [sym_comma_expression] = STATE(1418),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_type_descriptor] = STATE(1442),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(1088),
    [aux_sym_type_definition_repeat1] = STATE(516),
    [aux_sym_sized_type_specifier_repeat1] = STATE(785),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(1344),
    [anon_sym_volatile] = ACTIONS(1344),
    [anon_sym_restrict] = ACTIONS(1344),
    [anon_sym__Atomic] = ACTIONS(1344),
    [anon_sym_pipe] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_bool] = ACTIONS(1348),
    [anon_sym_char] = ACTIONS(1348),
    [anon_sym_uchar] = ACTIONS(1348),
    [anon_sym_ushort] = ACTIONS(1348),
    [anon_sym_int] = ACTIONS(1348),
    [anon_sym_uint] = ACTIONS(1348),
    [anon_sym_ulong] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1348),
    [anon_sym_double] = ACTIONS(1348),
    [anon_sym_half] = ACTIONS(1348),
    [anon_sym_size_t] = ACTIONS(1348),
    [anon_sym_ptrdiff_t] = ACTIONS(1348),
    [anon_sym_intptr_t] = ACTIONS(1348),
    [anon_sym_uintptr_t] = ACTIONS(1348),
    [anon_sym_void] = ACTIONS(1348),
    [sym_vector_type] = ACTIONS(1350),
    [anon_sym_image2d_t] = ACTIONS(1352),
    [anon_sym_image3d_t] = ACTIONS(1352),
    [anon_sym_image2d_array_t] = ACTIONS(1352),
    [anon_sym_image1d_t] = ACTIONS(1352),
    [anon_sym_image1d_buffer_t] = ACTIONS(1352),
    [anon_sym_image1d_array_t] = ACTIONS(1352),
    [anon_sym_image2d_depth_t] = ACTIONS(1352),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1352),
    [anon_sym_sampler_t] = ACTIONS(1352),
    [anon_sym_queue_t] = ACTIONS(1352),
    [anon_sym_ndrange_t] = ACTIONS(1352),
    [anon_sym_clk_event_t] = ACTIONS(1352),
    [anon_sym_reserve_id_t] = ACTIONS(1352),
    [anon_sym_event_t] = ACTIONS(1352),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1354),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_type_qualifier] = STATE(516),
    [sym__type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(1088),
    [sym_scalar_type] = STATE(1088),
    [sym_other_builtin_type] = STATE(1088),
    [sym_enum_specifier] = STATE(1088),
    [sym_struct_specifier] = STATE(1088),
    [sym_union_specifier] = STATE(1088),
    [sym__expression] = STATE(815),
    [sym_comma_expression] = STATE(1418),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_type_descriptor] = STATE(1491),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(1088),
    [aux_sym_type_definition_repeat1] = STATE(516),
    [aux_sym_sized_type_specifier_repeat1] = STATE(785),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(1344),
    [anon_sym_volatile] = ACTIONS(1344),
    [anon_sym_restrict] = ACTIONS(1344),
    [anon_sym__Atomic] = ACTIONS(1344),
    [anon_sym_pipe] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_bool] = ACTIONS(1348),
    [anon_sym_char] = ACTIONS(1348),
    [anon_sym_uchar] = ACTIONS(1348),
    [anon_sym_ushort] = ACTIONS(1348),
    [anon_sym_int] = ACTIONS(1348),
    [anon_sym_uint] = ACTIONS(1348),
    [anon_sym_ulong] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1348),
    [anon_sym_double] = ACTIONS(1348),
    [anon_sym_half] = ACTIONS(1348),
    [anon_sym_size_t] = ACTIONS(1348),
    [anon_sym_ptrdiff_t] = ACTIONS(1348),
    [anon_sym_intptr_t] = ACTIONS(1348),
    [anon_sym_uintptr_t] = ACTIONS(1348),
    [anon_sym_void] = ACTIONS(1348),
    [sym_vector_type] = ACTIONS(1350),
    [anon_sym_image2d_t] = ACTIONS(1352),
    [anon_sym_image3d_t] = ACTIONS(1352),
    [anon_sym_image2d_array_t] = ACTIONS(1352),
    [anon_sym_image1d_t] = ACTIONS(1352),
    [anon_sym_image1d_buffer_t] = ACTIONS(1352),
    [anon_sym_image1d_array_t] = ACTIONS(1352),
    [anon_sym_image2d_depth_t] = ACTIONS(1352),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1352),
    [anon_sym_sampler_t] = ACTIONS(1352),
    [anon_sym_queue_t] = ACTIONS(1352),
    [anon_sym_ndrange_t] = ACTIONS(1352),
    [anon_sym_clk_event_t] = ACTIONS(1352),
    [anon_sym_reserve_id_t] = ACTIONS(1352),
    [anon_sym_event_t] = ACTIONS(1352),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1354),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [333] = {
    [sym_type_qualifier] = STATE(516),
    [sym__type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(1088),
    [sym_scalar_type] = STATE(1088),
    [sym_other_builtin_type] = STATE(1088),
    [sym_enum_specifier] = STATE(1088),
    [sym_struct_specifier] = STATE(1088),
    [sym_union_specifier] = STATE(1088),
    [sym__expression] = STATE(815),
    [sym_comma_expression] = STATE(1418),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_type_descriptor] = STATE(1396),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(1088),
    [aux_sym_type_definition_repeat1] = STATE(516),
    [aux_sym_sized_type_specifier_repeat1] = STATE(785),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(1344),
    [anon_sym_volatile] = ACTIONS(1344),
    [anon_sym_restrict] = ACTIONS(1344),
    [anon_sym__Atomic] = ACTIONS(1344),
    [anon_sym_pipe] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_bool] = ACTIONS(1348),
    [anon_sym_char] = ACTIONS(1348),
    [anon_sym_uchar] = ACTIONS(1348),
    [anon_sym_ushort] = ACTIONS(1348),
    [anon_sym_int] = ACTIONS(1348),
    [anon_sym_uint] = ACTIONS(1348),
    [anon_sym_ulong] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1348),
    [anon_sym_double] = ACTIONS(1348),
    [anon_sym_half] = ACTIONS(1348),
    [anon_sym_size_t] = ACTIONS(1348),
    [anon_sym_ptrdiff_t] = ACTIONS(1348),
    [anon_sym_intptr_t] = ACTIONS(1348),
    [anon_sym_uintptr_t] = ACTIONS(1348),
    [anon_sym_void] = ACTIONS(1348),
    [sym_vector_type] = ACTIONS(1350),
    [anon_sym_image2d_t] = ACTIONS(1352),
    [anon_sym_image3d_t] = ACTIONS(1352),
    [anon_sym_image2d_array_t] = ACTIONS(1352),
    [anon_sym_image1d_t] = ACTIONS(1352),
    [anon_sym_image1d_buffer_t] = ACTIONS(1352),
    [anon_sym_image1d_array_t] = ACTIONS(1352),
    [anon_sym_image2d_depth_t] = ACTIONS(1352),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1352),
    [anon_sym_sampler_t] = ACTIONS(1352),
    [anon_sym_queue_t] = ACTIONS(1352),
    [anon_sym_ndrange_t] = ACTIONS(1352),
    [anon_sym_clk_event_t] = ACTIONS(1352),
    [anon_sym_reserve_id_t] = ACTIONS(1352),
    [anon_sym_event_t] = ACTIONS(1352),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1354),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [334] = {
    [sym_type_qualifier] = STATE(516),
    [sym__type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(1088),
    [sym_scalar_type] = STATE(1088),
    [sym_other_builtin_type] = STATE(1088),
    [sym_enum_specifier] = STATE(1088),
    [sym_struct_specifier] = STATE(1088),
    [sym_union_specifier] = STATE(1088),
    [sym__expression] = STATE(815),
    [sym_comma_expression] = STATE(1418),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_type_descriptor] = STATE(1474),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_macro_type_specifier] = STATE(1088),
    [aux_sym_type_definition_repeat1] = STATE(516),
    [aux_sym_sized_type_specifier_repeat1] = STATE(785),
    [sym_identifier] = ACTIONS(1342),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(1344),
    [anon_sym_volatile] = ACTIONS(1344),
    [anon_sym_restrict] = ACTIONS(1344),
    [anon_sym__Atomic] = ACTIONS(1344),
    [anon_sym_pipe] = ACTIONS(1344),
    [anon_sym_signed] = ACTIONS(1346),
    [anon_sym_unsigned] = ACTIONS(1346),
    [anon_sym_long] = ACTIONS(1346),
    [anon_sym_short] = ACTIONS(1346),
    [anon_sym_bool] = ACTIONS(1348),
    [anon_sym_char] = ACTIONS(1348),
    [anon_sym_uchar] = ACTIONS(1348),
    [anon_sym_ushort] = ACTIONS(1348),
    [anon_sym_int] = ACTIONS(1348),
    [anon_sym_uint] = ACTIONS(1348),
    [anon_sym_ulong] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1348),
    [anon_sym_double] = ACTIONS(1348),
    [anon_sym_half] = ACTIONS(1348),
    [anon_sym_size_t] = ACTIONS(1348),
    [anon_sym_ptrdiff_t] = ACTIONS(1348),
    [anon_sym_intptr_t] = ACTIONS(1348),
    [anon_sym_uintptr_t] = ACTIONS(1348),
    [anon_sym_void] = ACTIONS(1348),
    [sym_vector_type] = ACTIONS(1350),
    [anon_sym_image2d_t] = ACTIONS(1352),
    [anon_sym_image3d_t] = ACTIONS(1352),
    [anon_sym_image2d_array_t] = ACTIONS(1352),
    [anon_sym_image1d_t] = ACTIONS(1352),
    [anon_sym_image1d_buffer_t] = ACTIONS(1352),
    [anon_sym_image1d_array_t] = ACTIONS(1352),
    [anon_sym_image2d_depth_t] = ACTIONS(1352),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1352),
    [anon_sym_sampler_t] = ACTIONS(1352),
    [anon_sym_queue_t] = ACTIONS(1352),
    [anon_sym_ndrange_t] = ACTIONS(1352),
    [anon_sym_clk_event_t] = ACTIONS(1352),
    [anon_sym_reserve_id_t] = ACTIONS(1352),
    [anon_sym_event_t] = ACTIONS(1352),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1354),
    [anon_sym_struct] = ACTIONS(1356),
    [anon_sym_union] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(906),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_variadic_parameter] = STATE(1209),
    [sym_parameter_declaration] = STATE(1209),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1148),
    [anon_sym_RPAREN] = ACTIONS(1150),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(906),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_variadic_parameter] = STATE(1284),
    [sym_parameter_declaration] = STATE(1284),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1148),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [337] = {
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1031),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1053),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [339] = {
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1043),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [sym_function_qualifier] = STATE(341),
    [sym_address_space_qualifier] = STATE(341),
    [sym_access_qualifier] = STATE(341),
    [sym__declaration_modifiers] = STATE(341),
    [sym__declaration_specifiers] = STATE(1051),
    [sym_attribute_specifier] = STATE(341),
    [sym_attribute_declaration] = STATE(341),
    [sym_ms_declspec_modifier] = STATE(341),
    [sym_storage_class_specifier] = STATE(341),
    [sym_type_qualifier] = STATE(341),
    [sym__type_specifier] = STATE(538),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(341),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [sym_function_qualifier] = STATE(342),
    [sym_address_space_qualifier] = STATE(342),
    [sym_access_qualifier] = STATE(342),
    [sym__declaration_modifiers] = STATE(342),
    [sym_attribute_specifier] = STATE(342),
    [sym_attribute_declaration] = STATE(342),
    [sym_ms_declspec_modifier] = STATE(342),
    [sym_storage_class_specifier] = STATE(342),
    [sym_type_qualifier] = STATE(342),
    [sym__type_specifier] = STATE(526),
    [sym_sized_type_specifier] = STATE(729),
    [sym_scalar_type] = STATE(729),
    [sym_other_builtin_type] = STATE(729),
    [sym_enum_specifier] = STATE(729),
    [sym_struct_specifier] = STATE(729),
    [sym_union_specifier] = STATE(729),
    [sym_macro_type_specifier] = STATE(729),
    [aux_sym__declaration_specifiers_repeat1] = STATE(342),
    [aux_sym_sized_type_specifier_repeat1] = STATE(508),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_kernel] = ACTIONS(31),
    [anon_sym___kernel] = ACTIONS(31),
    [anon_sym_global] = ACTIONS(33),
    [anon_sym___global] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym___local] = ACTIONS(33),
    [anon_sym_constant] = ACTIONS(33),
    [anon_sym___constant] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym___private] = ACTIONS(33),
    [anon_sym_generic] = ACTIONS(33),
    [anon_sym___generic] = ACTIONS(33),
    [anon_sym_read_only] = ACTIONS(35),
    [anon_sym___read_only] = ACTIONS(35),
    [anon_sym_write_only] = ACTIONS(35),
    [anon_sym___write_only] = ACTIONS(35),
    [anon_sym_read_write] = ACTIONS(35),
    [anon_sym___read_write] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(49),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(902),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_static] = ACTIONS(49),
    [anon_sym_auto] = ACTIONS(49),
    [anon_sym_register] = ACTIONS(49),
    [anon_sym_inline] = ACTIONS(49),
    [anon_sym_const] = ACTIONS(51),
    [anon_sym_volatile] = ACTIONS(51),
    [anon_sym_restrict] = ACTIONS(51),
    [anon_sym__Atomic] = ACTIONS(51),
    [anon_sym_pipe] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(53),
    [anon_sym_unsigned] = ACTIONS(53),
    [anon_sym_long] = ACTIONS(53),
    [anon_sym_short] = ACTIONS(53),
    [anon_sym_bool] = ACTIONS(55),
    [anon_sym_char] = ACTIONS(55),
    [anon_sym_uchar] = ACTIONS(55),
    [anon_sym_ushort] = ACTIONS(55),
    [anon_sym_int] = ACTIONS(55),
    [anon_sym_uint] = ACTIONS(55),
    [anon_sym_ulong] = ACTIONS(55),
    [anon_sym_float] = ACTIONS(55),
    [anon_sym_double] = ACTIONS(55),
    [anon_sym_half] = ACTIONS(55),
    [anon_sym_size_t] = ACTIONS(55),
    [anon_sym_ptrdiff_t] = ACTIONS(55),
    [anon_sym_intptr_t] = ACTIONS(55),
    [anon_sym_uintptr_t] = ACTIONS(55),
    [anon_sym_void] = ACTIONS(55),
    [sym_vector_type] = ACTIONS(57),
    [anon_sym_image2d_t] = ACTIONS(59),
    [anon_sym_image3d_t] = ACTIONS(59),
    [anon_sym_image2d_array_t] = ACTIONS(59),
    [anon_sym_image1d_t] = ACTIONS(59),
    [anon_sym_image1d_buffer_t] = ACTIONS(59),
    [anon_sym_image1d_array_t] = ACTIONS(59),
    [anon_sym_image2d_depth_t] = ACTIONS(59),
    [anon_sym_image2d_array_depth_t] = ACTIONS(59),
    [anon_sym_sampler_t] = ACTIONS(59),
    [anon_sym_queue_t] = ACTIONS(59),
    [anon_sym_ndrange_t] = ACTIONS(59),
    [anon_sym_clk_event_t] = ACTIONS(59),
    [anon_sym_reserve_id_t] = ACTIONS(59),
    [anon_sym_event_t] = ACTIONS(59),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_struct] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [sym_function_qualifier] = STATE(342),
    [sym_address_space_qualifier] = STATE(342),
    [sym_access_qualifier] = STATE(342),
    [sym__declaration_modifiers] = STATE(342),
    [sym_attribute_specifier] = STATE(342),
    [sym_attribute_declaration] = STATE(342),
    [sym_ms_declspec_modifier] = STATE(342),
    [sym_storage_class_specifier] = STATE(342),
    [sym_type_qualifier] = STATE(342),
    [aux_sym__declaration_specifiers_repeat1] = STATE(342),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_COMMA] = ACTIONS(1362),
    [anon_sym_RPAREN] = ACTIONS(1362),
    [anon_sym_LPAREN2] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_SEMI] = ACTIONS(1362),
    [anon_sym_kernel] = ACTIONS(1364),
    [anon_sym___kernel] = ACTIONS(1364),
    [anon_sym_global] = ACTIONS(1367),
    [anon_sym___global] = ACTIONS(1367),
    [anon_sym_local] = ACTIONS(1367),
    [anon_sym___local] = ACTIONS(1367),
    [anon_sym_constant] = ACTIONS(1367),
    [anon_sym___constant] = ACTIONS(1367),
    [anon_sym_private] = ACTIONS(1367),
    [anon_sym___private] = ACTIONS(1367),
    [anon_sym_generic] = ACTIONS(1367),
    [anon_sym___generic] = ACTIONS(1367),
    [anon_sym_read_only] = ACTIONS(1370),
    [anon_sym___read_only] = ACTIONS(1370),
    [anon_sym_write_only] = ACTIONS(1370),
    [anon_sym___write_only] = ACTIONS(1370),
    [anon_sym_read_write] = ACTIONS(1370),
    [anon_sym___read_write] = ACTIONS(1370),
    [anon_sym_extern] = ACTIONS(1373),
    [anon_sym___attribute__] = ACTIONS(1376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1379),
    [anon_sym___declspec] = ACTIONS(1382),
    [anon_sym___based] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_auto] = ACTIONS(1373),
    [anon_sym_register] = ACTIONS(1373),
    [anon_sym_inline] = ACTIONS(1373),
    [anon_sym_const] = ACTIONS(1385),
    [anon_sym_volatile] = ACTIONS(1385),
    [anon_sym_restrict] = ACTIONS(1385),
    [anon_sym__Atomic] = ACTIONS(1385),
    [anon_sym_pipe] = ACTIONS(1385),
    [anon_sym_signed] = ACTIONS(1360),
    [anon_sym_unsigned] = ACTIONS(1360),
    [anon_sym_long] = ACTIONS(1360),
    [anon_sym_short] = ACTIONS(1360),
    [anon_sym_bool] = ACTIONS(1360),
    [anon_sym_char] = ACTIONS(1360),
    [anon_sym_uchar] = ACTIONS(1360),
    [anon_sym_ushort] = ACTIONS(1360),
    [anon_sym_int] = ACTIONS(1360),
    [anon_sym_uint] = ACTIONS(1360),
    [anon_sym_ulong] = ACTIONS(1360),
    [anon_sym_float] = ACTIONS(1360),
    [anon_sym_double] = ACTIONS(1360),
    [anon_sym_half] = ACTIONS(1360),
    [anon_sym_size_t] = ACTIONS(1360),
    [anon_sym_ptrdiff_t] = ACTIONS(1360),
    [anon_sym_intptr_t] = ACTIONS(1360),
    [anon_sym_uintptr_t] = ACTIONS(1360),
    [anon_sym_void] = ACTIONS(1360),
    [sym_vector_type] = ACTIONS(1360),
    [anon_sym_image2d_t] = ACTIONS(1360),
    [anon_sym_image3d_t] = ACTIONS(1360),
    [anon_sym_image2d_array_t] = ACTIONS(1360),
    [anon_sym_image1d_t] = ACTIONS(1360),
    [anon_sym_image1d_buffer_t] = ACTIONS(1360),
    [anon_sym_image1d_array_t] = ACTIONS(1360),
    [anon_sym_image2d_depth_t] = ACTIONS(1360),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1360),
    [anon_sym_sampler_t] = ACTIONS(1360),
    [anon_sym_queue_t] = ACTIONS(1360),
    [anon_sym_ndrange_t] = ACTIONS(1360),
    [anon_sym_clk_event_t] = ACTIONS(1360),
    [anon_sym_reserve_id_t] = ACTIONS(1360),
    [anon_sym_event_t] = ACTIONS(1360),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1360),
    [anon_sym_enum] = ACTIONS(1360),
    [anon_sym_struct] = ACTIONS(1360),
    [anon_sym_union] = ACTIONS(1360),
    [anon_sym_COLON] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_COMMA] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_LPAREN2] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_kernel] = ACTIONS(1388),
    [anon_sym___kernel] = ACTIONS(1388),
    [anon_sym_global] = ACTIONS(1388),
    [anon_sym___global] = ACTIONS(1388),
    [anon_sym_local] = ACTIONS(1388),
    [anon_sym___local] = ACTIONS(1388),
    [anon_sym_constant] = ACTIONS(1388),
    [anon_sym___constant] = ACTIONS(1388),
    [anon_sym_private] = ACTIONS(1388),
    [anon_sym___private] = ACTIONS(1388),
    [anon_sym_generic] = ACTIONS(1388),
    [anon_sym___generic] = ACTIONS(1388),
    [anon_sym_read_only] = ACTIONS(1388),
    [anon_sym___read_only] = ACTIONS(1388),
    [anon_sym_write_only] = ACTIONS(1388),
    [anon_sym___write_only] = ACTIONS(1388),
    [anon_sym_read_write] = ACTIONS(1388),
    [anon_sym___read_write] = ACTIONS(1388),
    [anon_sym_extern] = ACTIONS(1388),
    [anon_sym___attribute__] = ACTIONS(1388),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1390),
    [anon_sym___declspec] = ACTIONS(1388),
    [anon_sym___based] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_static] = ACTIONS(1388),
    [anon_sym_auto] = ACTIONS(1388),
    [anon_sym_register] = ACTIONS(1388),
    [anon_sym_inline] = ACTIONS(1388),
    [anon_sym_const] = ACTIONS(1388),
    [anon_sym_volatile] = ACTIONS(1388),
    [anon_sym_restrict] = ACTIONS(1388),
    [anon_sym__Atomic] = ACTIONS(1388),
    [anon_sym_pipe] = ACTIONS(1388),
    [anon_sym_signed] = ACTIONS(1388),
    [anon_sym_unsigned] = ACTIONS(1388),
    [anon_sym_long] = ACTIONS(1388),
    [anon_sym_short] = ACTIONS(1388),
    [anon_sym_bool] = ACTIONS(1388),
    [anon_sym_char] = ACTIONS(1388),
    [anon_sym_uchar] = ACTIONS(1388),
    [anon_sym_ushort] = ACTIONS(1388),
    [anon_sym_int] = ACTIONS(1388),
    [anon_sym_uint] = ACTIONS(1388),
    [anon_sym_ulong] = ACTIONS(1388),
    [anon_sym_float] = ACTIONS(1388),
    [anon_sym_double] = ACTIONS(1388),
    [anon_sym_half] = ACTIONS(1388),
    [anon_sym_size_t] = ACTIONS(1388),
    [anon_sym_ptrdiff_t] = ACTIONS(1388),
    [anon_sym_intptr_t] = ACTIONS(1388),
    [anon_sym_uintptr_t] = ACTIONS(1388),
    [anon_sym_void] = ACTIONS(1388),
    [sym_vector_type] = ACTIONS(1388),
    [anon_sym_image2d_t] = ACTIONS(1388),
    [anon_sym_image3d_t] = ACTIONS(1388),
    [anon_sym_image2d_array_t] = ACTIONS(1388),
    [anon_sym_image1d_t] = ACTIONS(1388),
    [anon_sym_image1d_buffer_t] = ACTIONS(1388),
    [anon_sym_image1d_array_t] = ACTIONS(1388),
    [anon_sym_image2d_depth_t] = ACTIONS(1388),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1388),
    [anon_sym_sampler_t] = ACTIONS(1388),
    [anon_sym_queue_t] = ACTIONS(1388),
    [anon_sym_ndrange_t] = ACTIONS(1388),
    [anon_sym_clk_event_t] = ACTIONS(1388),
    [anon_sym_reserve_id_t] = ACTIONS(1388),
    [anon_sym_event_t] = ACTIONS(1388),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1388),
    [anon_sym_struct] = ACTIONS(1388),
    [anon_sym_union] = ACTIONS(1388),
    [anon_sym_COLON] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_RPAREN] = ACTIONS(1394),
    [anon_sym_LPAREN2] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1394),
    [anon_sym_SEMI] = ACTIONS(1394),
    [anon_sym_kernel] = ACTIONS(1392),
    [anon_sym___kernel] = ACTIONS(1392),
    [anon_sym_global] = ACTIONS(1392),
    [anon_sym___global] = ACTIONS(1392),
    [anon_sym_local] = ACTIONS(1392),
    [anon_sym___local] = ACTIONS(1392),
    [anon_sym_constant] = ACTIONS(1392),
    [anon_sym___constant] = ACTIONS(1392),
    [anon_sym_private] = ACTIONS(1392),
    [anon_sym___private] = ACTIONS(1392),
    [anon_sym_generic] = ACTIONS(1392),
    [anon_sym___generic] = ACTIONS(1392),
    [anon_sym_read_only] = ACTIONS(1392),
    [anon_sym___read_only] = ACTIONS(1392),
    [anon_sym_write_only] = ACTIONS(1392),
    [anon_sym___write_only] = ACTIONS(1392),
    [anon_sym_read_write] = ACTIONS(1392),
    [anon_sym___read_write] = ACTIONS(1392),
    [anon_sym_extern] = ACTIONS(1392),
    [anon_sym___attribute__] = ACTIONS(1392),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1394),
    [anon_sym___declspec] = ACTIONS(1392),
    [anon_sym___based] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_LBRACK] = ACTIONS(1392),
    [anon_sym_static] = ACTIONS(1392),
    [anon_sym_auto] = ACTIONS(1392),
    [anon_sym_register] = ACTIONS(1392),
    [anon_sym_inline] = ACTIONS(1392),
    [anon_sym_const] = ACTIONS(1392),
    [anon_sym_volatile] = ACTIONS(1392),
    [anon_sym_restrict] = ACTIONS(1392),
    [anon_sym__Atomic] = ACTIONS(1392),
    [anon_sym_pipe] = ACTIONS(1392),
    [anon_sym_signed] = ACTIONS(1392),
    [anon_sym_unsigned] = ACTIONS(1392),
    [anon_sym_long] = ACTIONS(1392),
    [anon_sym_short] = ACTIONS(1392),
    [anon_sym_bool] = ACTIONS(1392),
    [anon_sym_char] = ACTIONS(1392),
    [anon_sym_uchar] = ACTIONS(1392),
    [anon_sym_ushort] = ACTIONS(1392),
    [anon_sym_int] = ACTIONS(1392),
    [anon_sym_uint] = ACTIONS(1392),
    [anon_sym_ulong] = ACTIONS(1392),
    [anon_sym_float] = ACTIONS(1392),
    [anon_sym_double] = ACTIONS(1392),
    [anon_sym_half] = ACTIONS(1392),
    [anon_sym_size_t] = ACTIONS(1392),
    [anon_sym_ptrdiff_t] = ACTIONS(1392),
    [anon_sym_intptr_t] = ACTIONS(1392),
    [anon_sym_uintptr_t] = ACTIONS(1392),
    [anon_sym_void] = ACTIONS(1392),
    [sym_vector_type] = ACTIONS(1392),
    [anon_sym_image2d_t] = ACTIONS(1392),
    [anon_sym_image3d_t] = ACTIONS(1392),
    [anon_sym_image2d_array_t] = ACTIONS(1392),
    [anon_sym_image1d_t] = ACTIONS(1392),
    [anon_sym_image1d_buffer_t] = ACTIONS(1392),
    [anon_sym_image1d_array_t] = ACTIONS(1392),
    [anon_sym_image2d_depth_t] = ACTIONS(1392),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1392),
    [anon_sym_sampler_t] = ACTIONS(1392),
    [anon_sym_queue_t] = ACTIONS(1392),
    [anon_sym_ndrange_t] = ACTIONS(1392),
    [anon_sym_clk_event_t] = ACTIONS(1392),
    [anon_sym_reserve_id_t] = ACTIONS(1392),
    [anon_sym_event_t] = ACTIONS(1392),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1392),
    [anon_sym_enum] = ACTIONS(1392),
    [anon_sym_struct] = ACTIONS(1392),
    [anon_sym_union] = ACTIONS(1392),
    [anon_sym_COLON] = ACTIONS(1394),
    [sym_comment] = ACTIONS(3),
  },
  [345] = {
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_COMMA] = ACTIONS(1398),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_LPAREN2] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_kernel] = ACTIONS(1396),
    [anon_sym___kernel] = ACTIONS(1396),
    [anon_sym_global] = ACTIONS(1396),
    [anon_sym___global] = ACTIONS(1396),
    [anon_sym_local] = ACTIONS(1396),
    [anon_sym___local] = ACTIONS(1396),
    [anon_sym_constant] = ACTIONS(1396),
    [anon_sym___constant] = ACTIONS(1396),
    [anon_sym_private] = ACTIONS(1396),
    [anon_sym___private] = ACTIONS(1396),
    [anon_sym_generic] = ACTIONS(1396),
    [anon_sym___generic] = ACTIONS(1396),
    [anon_sym_read_only] = ACTIONS(1396),
    [anon_sym___read_only] = ACTIONS(1396),
    [anon_sym_write_only] = ACTIONS(1396),
    [anon_sym___write_only] = ACTIONS(1396),
    [anon_sym_read_write] = ACTIONS(1396),
    [anon_sym___read_write] = ACTIONS(1396),
    [anon_sym_extern] = ACTIONS(1396),
    [anon_sym___attribute__] = ACTIONS(1396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1398),
    [anon_sym___declspec] = ACTIONS(1396),
    [anon_sym___based] = ACTIONS(1396),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1396),
    [anon_sym_auto] = ACTIONS(1396),
    [anon_sym_register] = ACTIONS(1396),
    [anon_sym_inline] = ACTIONS(1396),
    [anon_sym_const] = ACTIONS(1396),
    [anon_sym_volatile] = ACTIONS(1396),
    [anon_sym_restrict] = ACTIONS(1396),
    [anon_sym__Atomic] = ACTIONS(1396),
    [anon_sym_pipe] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1396),
    [anon_sym_unsigned] = ACTIONS(1396),
    [anon_sym_long] = ACTIONS(1396),
    [anon_sym_short] = ACTIONS(1396),
    [anon_sym_bool] = ACTIONS(1396),
    [anon_sym_char] = ACTIONS(1396),
    [anon_sym_uchar] = ACTIONS(1396),
    [anon_sym_ushort] = ACTIONS(1396),
    [anon_sym_int] = ACTIONS(1396),
    [anon_sym_uint] = ACTIONS(1396),
    [anon_sym_ulong] = ACTIONS(1396),
    [anon_sym_float] = ACTIONS(1396),
    [anon_sym_double] = ACTIONS(1396),
    [anon_sym_half] = ACTIONS(1396),
    [anon_sym_size_t] = ACTIONS(1396),
    [anon_sym_ptrdiff_t] = ACTIONS(1396),
    [anon_sym_intptr_t] = ACTIONS(1396),
    [anon_sym_uintptr_t] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1396),
    [sym_vector_type] = ACTIONS(1396),
    [anon_sym_image2d_t] = ACTIONS(1396),
    [anon_sym_image3d_t] = ACTIONS(1396),
    [anon_sym_image2d_array_t] = ACTIONS(1396),
    [anon_sym_image1d_t] = ACTIONS(1396),
    [anon_sym_image1d_buffer_t] = ACTIONS(1396),
    [anon_sym_image1d_array_t] = ACTIONS(1396),
    [anon_sym_image2d_depth_t] = ACTIONS(1396),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1396),
    [anon_sym_sampler_t] = ACTIONS(1396),
    [anon_sym_queue_t] = ACTIONS(1396),
    [anon_sym_ndrange_t] = ACTIONS(1396),
    [anon_sym_clk_event_t] = ACTIONS(1396),
    [anon_sym_reserve_id_t] = ACTIONS(1396),
    [anon_sym_event_t] = ACTIONS(1396),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1396),
    [anon_sym_enum] = ACTIONS(1396),
    [anon_sym_struct] = ACTIONS(1396),
    [anon_sym_union] = ACTIONS(1396),
    [anon_sym_COLON] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_COMMA] = ACTIONS(1402),
    [anon_sym_RPAREN] = ACTIONS(1402),
    [anon_sym_LPAREN2] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1402),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_kernel] = ACTIONS(1400),
    [anon_sym___kernel] = ACTIONS(1400),
    [anon_sym_global] = ACTIONS(1400),
    [anon_sym___global] = ACTIONS(1400),
    [anon_sym_local] = ACTIONS(1400),
    [anon_sym___local] = ACTIONS(1400),
    [anon_sym_constant] = ACTIONS(1400),
    [anon_sym___constant] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym___private] = ACTIONS(1400),
    [anon_sym_generic] = ACTIONS(1400),
    [anon_sym___generic] = ACTIONS(1400),
    [anon_sym_read_only] = ACTIONS(1400),
    [anon_sym___read_only] = ACTIONS(1400),
    [anon_sym_write_only] = ACTIONS(1400),
    [anon_sym___write_only] = ACTIONS(1400),
    [anon_sym_read_write] = ACTIONS(1400),
    [anon_sym___read_write] = ACTIONS(1400),
    [anon_sym_extern] = ACTIONS(1400),
    [anon_sym___attribute__] = ACTIONS(1400),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1402),
    [anon_sym___declspec] = ACTIONS(1400),
    [anon_sym___based] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1400),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_auto] = ACTIONS(1400),
    [anon_sym_register] = ACTIONS(1400),
    [anon_sym_inline] = ACTIONS(1400),
    [anon_sym_const] = ACTIONS(1400),
    [anon_sym_volatile] = ACTIONS(1400),
    [anon_sym_restrict] = ACTIONS(1400),
    [anon_sym__Atomic] = ACTIONS(1400),
    [anon_sym_pipe] = ACTIONS(1400),
    [anon_sym_signed] = ACTIONS(1400),
    [anon_sym_unsigned] = ACTIONS(1400),
    [anon_sym_long] = ACTIONS(1400),
    [anon_sym_short] = ACTIONS(1400),
    [anon_sym_bool] = ACTIONS(1400),
    [anon_sym_char] = ACTIONS(1400),
    [anon_sym_uchar] = ACTIONS(1400),
    [anon_sym_ushort] = ACTIONS(1400),
    [anon_sym_int] = ACTIONS(1400),
    [anon_sym_uint] = ACTIONS(1400),
    [anon_sym_ulong] = ACTIONS(1400),
    [anon_sym_float] = ACTIONS(1400),
    [anon_sym_double] = ACTIONS(1400),
    [anon_sym_half] = ACTIONS(1400),
    [anon_sym_size_t] = ACTIONS(1400),
    [anon_sym_ptrdiff_t] = ACTIONS(1400),
    [anon_sym_intptr_t] = ACTIONS(1400),
    [anon_sym_uintptr_t] = ACTIONS(1400),
    [anon_sym_void] = ACTIONS(1400),
    [sym_vector_type] = ACTIONS(1400),
    [anon_sym_image2d_t] = ACTIONS(1400),
    [anon_sym_image3d_t] = ACTIONS(1400),
    [anon_sym_image2d_array_t] = ACTIONS(1400),
    [anon_sym_image1d_t] = ACTIONS(1400),
    [anon_sym_image1d_buffer_t] = ACTIONS(1400),
    [anon_sym_image1d_array_t] = ACTIONS(1400),
    [anon_sym_image2d_depth_t] = ACTIONS(1400),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1400),
    [anon_sym_sampler_t] = ACTIONS(1400),
    [anon_sym_queue_t] = ACTIONS(1400),
    [anon_sym_ndrange_t] = ACTIONS(1400),
    [anon_sym_clk_event_t] = ACTIONS(1400),
    [anon_sym_reserve_id_t] = ACTIONS(1400),
    [anon_sym_event_t] = ACTIONS(1400),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
    [anon_sym_struct] = ACTIONS(1400),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_COLON] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [sym_identifier] = ACTIONS(1404),
    [aux_sym_preproc_def_token1] = ACTIONS(1404),
    [aux_sym_preproc_if_token1] = ACTIONS(1404),
    [aux_sym_preproc_if_token2] = ACTIONS(1404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1404),
    [aux_sym_preproc_else_token1] = ACTIONS(1404),
    [aux_sym_preproc_elif_token1] = ACTIONS(1404),
    [sym_preproc_directive] = ACTIONS(1404),
    [anon_sym_kernel] = ACTIONS(1404),
    [anon_sym___kernel] = ACTIONS(1404),
    [anon_sym_global] = ACTIONS(1404),
    [anon_sym___global] = ACTIONS(1404),
    [anon_sym_local] = ACTIONS(1404),
    [anon_sym___local] = ACTIONS(1404),
    [anon_sym_constant] = ACTIONS(1404),
    [anon_sym___constant] = ACTIONS(1404),
    [anon_sym_private] = ACTIONS(1404),
    [anon_sym___private] = ACTIONS(1404),
    [anon_sym_generic] = ACTIONS(1404),
    [anon_sym___generic] = ACTIONS(1404),
    [anon_sym_read_only] = ACTIONS(1404),
    [anon_sym___read_only] = ACTIONS(1404),
    [anon_sym_write_only] = ACTIONS(1404),
    [anon_sym___write_only] = ACTIONS(1404),
    [anon_sym_read_write] = ACTIONS(1404),
    [anon_sym___read_write] = ACTIONS(1404),
    [anon_sym_extern] = ACTIONS(1404),
    [anon_sym___attribute__] = ACTIONS(1404),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1406),
    [anon_sym___declspec] = ACTIONS(1404),
    [anon_sym_static] = ACTIONS(1404),
    [anon_sym_auto] = ACTIONS(1404),
    [anon_sym_register] = ACTIONS(1404),
    [anon_sym_inline] = ACTIONS(1404),
    [anon_sym_const] = ACTIONS(1404),
    [anon_sym_volatile] = ACTIONS(1404),
    [anon_sym_restrict] = ACTIONS(1404),
    [anon_sym__Atomic] = ACTIONS(1404),
    [anon_sym_pipe] = ACTIONS(1404),
    [anon_sym_signed] = ACTIONS(1404),
    [anon_sym_unsigned] = ACTIONS(1404),
    [anon_sym_long] = ACTIONS(1404),
    [anon_sym_short] = ACTIONS(1404),
    [anon_sym_bool] = ACTIONS(1404),
    [anon_sym_char] = ACTIONS(1404),
    [anon_sym_uchar] = ACTIONS(1404),
    [anon_sym_ushort] = ACTIONS(1404),
    [anon_sym_int] = ACTIONS(1404),
    [anon_sym_uint] = ACTIONS(1404),
    [anon_sym_ulong] = ACTIONS(1404),
    [anon_sym_float] = ACTIONS(1404),
    [anon_sym_double] = ACTIONS(1404),
    [anon_sym_half] = ACTIONS(1404),
    [anon_sym_size_t] = ACTIONS(1404),
    [anon_sym_ptrdiff_t] = ACTIONS(1404),
    [anon_sym_intptr_t] = ACTIONS(1404),
    [anon_sym_uintptr_t] = ACTIONS(1404),
    [anon_sym_void] = ACTIONS(1404),
    [sym_vector_type] = ACTIONS(1404),
    [anon_sym_image2d_t] = ACTIONS(1404),
    [anon_sym_image3d_t] = ACTIONS(1404),
    [anon_sym_image2d_array_t] = ACTIONS(1404),
    [anon_sym_image1d_t] = ACTIONS(1404),
    [anon_sym_image1d_buffer_t] = ACTIONS(1404),
    [anon_sym_image1d_array_t] = ACTIONS(1404),
    [anon_sym_image2d_depth_t] = ACTIONS(1404),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1404),
    [anon_sym_sampler_t] = ACTIONS(1404),
    [anon_sym_queue_t] = ACTIONS(1404),
    [anon_sym_ndrange_t] = ACTIONS(1404),
    [anon_sym_clk_event_t] = ACTIONS(1404),
    [anon_sym_reserve_id_t] = ACTIONS(1404),
    [anon_sym_event_t] = ACTIONS(1404),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [anon_sym_struct] = ACTIONS(1404),
    [anon_sym_union] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [sym_identifier] = ACTIONS(1408),
    [aux_sym_preproc_def_token1] = ACTIONS(1408),
    [aux_sym_preproc_if_token1] = ACTIONS(1408),
    [aux_sym_preproc_if_token2] = ACTIONS(1408),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1408),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1408),
    [aux_sym_preproc_else_token1] = ACTIONS(1408),
    [aux_sym_preproc_elif_token1] = ACTIONS(1408),
    [sym_preproc_directive] = ACTIONS(1408),
    [anon_sym_kernel] = ACTIONS(1408),
    [anon_sym___kernel] = ACTIONS(1408),
    [anon_sym_global] = ACTIONS(1408),
    [anon_sym___global] = ACTIONS(1408),
    [anon_sym_local] = ACTIONS(1408),
    [anon_sym___local] = ACTIONS(1408),
    [anon_sym_constant] = ACTIONS(1408),
    [anon_sym___constant] = ACTIONS(1408),
    [anon_sym_private] = ACTIONS(1408),
    [anon_sym___private] = ACTIONS(1408),
    [anon_sym_generic] = ACTIONS(1408),
    [anon_sym___generic] = ACTIONS(1408),
    [anon_sym_read_only] = ACTIONS(1408),
    [anon_sym___read_only] = ACTIONS(1408),
    [anon_sym_write_only] = ACTIONS(1408),
    [anon_sym___write_only] = ACTIONS(1408),
    [anon_sym_read_write] = ACTIONS(1408),
    [anon_sym___read_write] = ACTIONS(1408),
    [anon_sym_extern] = ACTIONS(1408),
    [anon_sym___attribute__] = ACTIONS(1408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1410),
    [anon_sym___declspec] = ACTIONS(1408),
    [anon_sym_static] = ACTIONS(1408),
    [anon_sym_auto] = ACTIONS(1408),
    [anon_sym_register] = ACTIONS(1408),
    [anon_sym_inline] = ACTIONS(1408),
    [anon_sym_const] = ACTIONS(1408),
    [anon_sym_volatile] = ACTIONS(1408),
    [anon_sym_restrict] = ACTIONS(1408),
    [anon_sym__Atomic] = ACTIONS(1408),
    [anon_sym_pipe] = ACTIONS(1408),
    [anon_sym_signed] = ACTIONS(1408),
    [anon_sym_unsigned] = ACTIONS(1408),
    [anon_sym_long] = ACTIONS(1408),
    [anon_sym_short] = ACTIONS(1408),
    [anon_sym_bool] = ACTIONS(1408),
    [anon_sym_char] = ACTIONS(1408),
    [anon_sym_uchar] = ACTIONS(1408),
    [anon_sym_ushort] = ACTIONS(1408),
    [anon_sym_int] = ACTIONS(1408),
    [anon_sym_uint] = ACTIONS(1408),
    [anon_sym_ulong] = ACTIONS(1408),
    [anon_sym_float] = ACTIONS(1408),
    [anon_sym_double] = ACTIONS(1408),
    [anon_sym_half] = ACTIONS(1408),
    [anon_sym_size_t] = ACTIONS(1408),
    [anon_sym_ptrdiff_t] = ACTIONS(1408),
    [anon_sym_intptr_t] = ACTIONS(1408),
    [anon_sym_uintptr_t] = ACTIONS(1408),
    [anon_sym_void] = ACTIONS(1408),
    [sym_vector_type] = ACTIONS(1408),
    [anon_sym_image2d_t] = ACTIONS(1408),
    [anon_sym_image3d_t] = ACTIONS(1408),
    [anon_sym_image2d_array_t] = ACTIONS(1408),
    [anon_sym_image1d_t] = ACTIONS(1408),
    [anon_sym_image1d_buffer_t] = ACTIONS(1408),
    [anon_sym_image1d_array_t] = ACTIONS(1408),
    [anon_sym_image2d_depth_t] = ACTIONS(1408),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1408),
    [anon_sym_sampler_t] = ACTIONS(1408),
    [anon_sym_queue_t] = ACTIONS(1408),
    [anon_sym_ndrange_t] = ACTIONS(1408),
    [anon_sym_clk_event_t] = ACTIONS(1408),
    [anon_sym_reserve_id_t] = ACTIONS(1408),
    [anon_sym_event_t] = ACTIONS(1408),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1408),
    [anon_sym_enum] = ACTIONS(1408),
    [anon_sym_struct] = ACTIONS(1408),
    [anon_sym_union] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym__expression] = STATE(703),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(644),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(644),
    [sym_call_expression] = STATE(644),
    [sym_field_expression] = STATE(644),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(644),
    [sym_initializer_list] = STATE(684),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_COMMA] = ACTIONS(1414),
    [anon_sym_RPAREN] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1424),
    [anon_sym_PERCENT] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1414),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_CARET] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_EQ_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ] = ACTIONS(1414),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1414),
    [anon_sym_LT_EQ] = ACTIONS(1414),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1424),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1414),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_COLON] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1414),
    [anon_sym_STAR_EQ] = ACTIONS(1414),
    [anon_sym_SLASH_EQ] = ACTIONS(1414),
    [anon_sym_PERCENT_EQ] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(1414),
    [anon_sym_DASH_EQ] = ACTIONS(1414),
    [anon_sym_LT_LT_EQ] = ACTIONS(1414),
    [anon_sym_GT_GT_EQ] = ACTIONS(1414),
    [anon_sym_AMP_EQ] = ACTIONS(1414),
    [anon_sym_CARET_EQ] = ACTIONS(1414),
    [anon_sym_PIPE_EQ] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_sizeof] = ACTIONS(1430),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token2] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [aux_sym_preproc_else_token1] = ACTIONS(1096),
    [aux_sym_preproc_elif_token1] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_kernel] = ACTIONS(1096),
    [anon_sym___kernel] = ACTIONS(1096),
    [anon_sym_global] = ACTIONS(1096),
    [anon_sym___global] = ACTIONS(1096),
    [anon_sym_local] = ACTIONS(1096),
    [anon_sym___local] = ACTIONS(1096),
    [anon_sym_constant] = ACTIONS(1096),
    [anon_sym___constant] = ACTIONS(1096),
    [anon_sym_private] = ACTIONS(1096),
    [anon_sym___private] = ACTIONS(1096),
    [anon_sym_generic] = ACTIONS(1096),
    [anon_sym___generic] = ACTIONS(1096),
    [anon_sym_read_only] = ACTIONS(1096),
    [anon_sym___read_only] = ACTIONS(1096),
    [anon_sym_write_only] = ACTIONS(1096),
    [anon_sym___write_only] = ACTIONS(1096),
    [anon_sym_read_write] = ACTIONS(1096),
    [anon_sym___read_write] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1098),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_pipe] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [anon_sym_bool] = ACTIONS(1096),
    [anon_sym_char] = ACTIONS(1096),
    [anon_sym_uchar] = ACTIONS(1096),
    [anon_sym_ushort] = ACTIONS(1096),
    [anon_sym_int] = ACTIONS(1096),
    [anon_sym_uint] = ACTIONS(1096),
    [anon_sym_ulong] = ACTIONS(1096),
    [anon_sym_float] = ACTIONS(1096),
    [anon_sym_double] = ACTIONS(1096),
    [anon_sym_half] = ACTIONS(1096),
    [anon_sym_size_t] = ACTIONS(1096),
    [anon_sym_ptrdiff_t] = ACTIONS(1096),
    [anon_sym_intptr_t] = ACTIONS(1096),
    [anon_sym_uintptr_t] = ACTIONS(1096),
    [anon_sym_void] = ACTIONS(1096),
    [sym_vector_type] = ACTIONS(1096),
    [anon_sym_image2d_t] = ACTIONS(1096),
    [anon_sym_image3d_t] = ACTIONS(1096),
    [anon_sym_image2d_array_t] = ACTIONS(1096),
    [anon_sym_image1d_t] = ACTIONS(1096),
    [anon_sym_image1d_buffer_t] = ACTIONS(1096),
    [anon_sym_image1d_array_t] = ACTIONS(1096),
    [anon_sym_image2d_depth_t] = ACTIONS(1096),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1096),
    [anon_sym_sampler_t] = ACTIONS(1096),
    [anon_sym_queue_t] = ACTIONS(1096),
    [anon_sym_ndrange_t] = ACTIONS(1096),
    [anon_sym_clk_event_t] = ACTIONS(1096),
    [anon_sym_reserve_id_t] = ACTIONS(1096),
    [anon_sym_event_t] = ACTIONS(1096),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_COMMA] = ACTIONS(1434),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_LPAREN2] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1434),
    [anon_sym_kernel] = ACTIONS(1432),
    [anon_sym___kernel] = ACTIONS(1432),
    [anon_sym_global] = ACTIONS(1432),
    [anon_sym___global] = ACTIONS(1432),
    [anon_sym_local] = ACTIONS(1432),
    [anon_sym___local] = ACTIONS(1432),
    [anon_sym_constant] = ACTIONS(1432),
    [anon_sym___constant] = ACTIONS(1432),
    [anon_sym_private] = ACTIONS(1432),
    [anon_sym___private] = ACTIONS(1432),
    [anon_sym_generic] = ACTIONS(1432),
    [anon_sym___generic] = ACTIONS(1432),
    [anon_sym_read_only] = ACTIONS(1432),
    [anon_sym___read_only] = ACTIONS(1432),
    [anon_sym_write_only] = ACTIONS(1432),
    [anon_sym___write_only] = ACTIONS(1432),
    [anon_sym_read_write] = ACTIONS(1432),
    [anon_sym___read_write] = ACTIONS(1432),
    [anon_sym_extern] = ACTIONS(1432),
    [anon_sym___attribute__] = ACTIONS(1432),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1434),
    [anon_sym___declspec] = ACTIONS(1432),
    [anon_sym___based] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_auto] = ACTIONS(1432),
    [anon_sym_register] = ACTIONS(1432),
    [anon_sym_inline] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_volatile] = ACTIONS(1432),
    [anon_sym_restrict] = ACTIONS(1432),
    [anon_sym__Atomic] = ACTIONS(1432),
    [anon_sym_pipe] = ACTIONS(1432),
    [anon_sym_signed] = ACTIONS(1432),
    [anon_sym_unsigned] = ACTIONS(1432),
    [anon_sym_long] = ACTIONS(1432),
    [anon_sym_short] = ACTIONS(1432),
    [anon_sym_bool] = ACTIONS(1432),
    [anon_sym_char] = ACTIONS(1432),
    [anon_sym_uchar] = ACTIONS(1432),
    [anon_sym_ushort] = ACTIONS(1432),
    [anon_sym_int] = ACTIONS(1432),
    [anon_sym_uint] = ACTIONS(1432),
    [anon_sym_ulong] = ACTIONS(1432),
    [anon_sym_float] = ACTIONS(1432),
    [anon_sym_double] = ACTIONS(1432),
    [anon_sym_half] = ACTIONS(1432),
    [anon_sym_size_t] = ACTIONS(1432),
    [anon_sym_ptrdiff_t] = ACTIONS(1432),
    [anon_sym_intptr_t] = ACTIONS(1432),
    [anon_sym_uintptr_t] = ACTIONS(1432),
    [anon_sym_void] = ACTIONS(1432),
    [sym_vector_type] = ACTIONS(1432),
    [anon_sym_image2d_t] = ACTIONS(1432),
    [anon_sym_image3d_t] = ACTIONS(1432),
    [anon_sym_image2d_array_t] = ACTIONS(1432),
    [anon_sym_image1d_t] = ACTIONS(1432),
    [anon_sym_image1d_buffer_t] = ACTIONS(1432),
    [anon_sym_image1d_array_t] = ACTIONS(1432),
    [anon_sym_image2d_depth_t] = ACTIONS(1432),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1432),
    [anon_sym_sampler_t] = ACTIONS(1432),
    [anon_sym_queue_t] = ACTIONS(1432),
    [anon_sym_ndrange_t] = ACTIONS(1432),
    [anon_sym_clk_event_t] = ACTIONS(1432),
    [anon_sym_reserve_id_t] = ACTIONS(1432),
    [anon_sym_event_t] = ACTIONS(1432),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1432),
    [anon_sym_enum] = ACTIONS(1432),
    [anon_sym_struct] = ACTIONS(1432),
    [anon_sym_union] = ACTIONS(1432),
    [anon_sym_COLON] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [sym_identifier] = ACTIONS(1436),
    [aux_sym_preproc_def_token1] = ACTIONS(1436),
    [aux_sym_preproc_if_token1] = ACTIONS(1436),
    [aux_sym_preproc_if_token2] = ACTIONS(1436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1436),
    [aux_sym_preproc_else_token1] = ACTIONS(1436),
    [aux_sym_preproc_elif_token1] = ACTIONS(1436),
    [sym_preproc_directive] = ACTIONS(1436),
    [anon_sym_kernel] = ACTIONS(1436),
    [anon_sym___kernel] = ACTIONS(1436),
    [anon_sym_global] = ACTIONS(1436),
    [anon_sym___global] = ACTIONS(1436),
    [anon_sym_local] = ACTIONS(1436),
    [anon_sym___local] = ACTIONS(1436),
    [anon_sym_constant] = ACTIONS(1436),
    [anon_sym___constant] = ACTIONS(1436),
    [anon_sym_private] = ACTIONS(1436),
    [anon_sym___private] = ACTIONS(1436),
    [anon_sym_generic] = ACTIONS(1436),
    [anon_sym___generic] = ACTIONS(1436),
    [anon_sym_read_only] = ACTIONS(1436),
    [anon_sym___read_only] = ACTIONS(1436),
    [anon_sym_write_only] = ACTIONS(1436),
    [anon_sym___write_only] = ACTIONS(1436),
    [anon_sym_read_write] = ACTIONS(1436),
    [anon_sym___read_write] = ACTIONS(1436),
    [anon_sym_extern] = ACTIONS(1436),
    [anon_sym___attribute__] = ACTIONS(1436),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1438),
    [anon_sym___declspec] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1436),
    [anon_sym_auto] = ACTIONS(1436),
    [anon_sym_register] = ACTIONS(1436),
    [anon_sym_inline] = ACTIONS(1436),
    [anon_sym_const] = ACTIONS(1436),
    [anon_sym_volatile] = ACTIONS(1436),
    [anon_sym_restrict] = ACTIONS(1436),
    [anon_sym__Atomic] = ACTIONS(1436),
    [anon_sym_pipe] = ACTIONS(1436),
    [anon_sym_signed] = ACTIONS(1436),
    [anon_sym_unsigned] = ACTIONS(1436),
    [anon_sym_long] = ACTIONS(1436),
    [anon_sym_short] = ACTIONS(1436),
    [anon_sym_bool] = ACTIONS(1436),
    [anon_sym_char] = ACTIONS(1436),
    [anon_sym_uchar] = ACTIONS(1436),
    [anon_sym_ushort] = ACTIONS(1436),
    [anon_sym_int] = ACTIONS(1436),
    [anon_sym_uint] = ACTIONS(1436),
    [anon_sym_ulong] = ACTIONS(1436),
    [anon_sym_float] = ACTIONS(1436),
    [anon_sym_double] = ACTIONS(1436),
    [anon_sym_half] = ACTIONS(1436),
    [anon_sym_size_t] = ACTIONS(1436),
    [anon_sym_ptrdiff_t] = ACTIONS(1436),
    [anon_sym_intptr_t] = ACTIONS(1436),
    [anon_sym_uintptr_t] = ACTIONS(1436),
    [anon_sym_void] = ACTIONS(1436),
    [sym_vector_type] = ACTIONS(1436),
    [anon_sym_image2d_t] = ACTIONS(1436),
    [anon_sym_image3d_t] = ACTIONS(1436),
    [anon_sym_image2d_array_t] = ACTIONS(1436),
    [anon_sym_image1d_t] = ACTIONS(1436),
    [anon_sym_image1d_buffer_t] = ACTIONS(1436),
    [anon_sym_image1d_array_t] = ACTIONS(1436),
    [anon_sym_image2d_depth_t] = ACTIONS(1436),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1436),
    [anon_sym_sampler_t] = ACTIONS(1436),
    [anon_sym_queue_t] = ACTIONS(1436),
    [anon_sym_ndrange_t] = ACTIONS(1436),
    [anon_sym_clk_event_t] = ACTIONS(1436),
    [anon_sym_reserve_id_t] = ACTIONS(1436),
    [anon_sym_event_t] = ACTIONS(1436),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1436),
    [anon_sym_enum] = ACTIONS(1436),
    [anon_sym_struct] = ACTIONS(1436),
    [anon_sym_union] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [sym_identifier] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1144),
    [anon_sym_RPAREN] = ACTIONS(1144),
    [anon_sym_LPAREN2] = ACTIONS(1144),
    [anon_sym_STAR] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1144),
    [anon_sym_kernel] = ACTIONS(1142),
    [anon_sym___kernel] = ACTIONS(1142),
    [anon_sym_global] = ACTIONS(1142),
    [anon_sym___global] = ACTIONS(1142),
    [anon_sym_local] = ACTIONS(1142),
    [anon_sym___local] = ACTIONS(1142),
    [anon_sym_constant] = ACTIONS(1142),
    [anon_sym___constant] = ACTIONS(1142),
    [anon_sym_private] = ACTIONS(1142),
    [anon_sym___private] = ACTIONS(1142),
    [anon_sym_generic] = ACTIONS(1142),
    [anon_sym___generic] = ACTIONS(1142),
    [anon_sym_read_only] = ACTIONS(1142),
    [anon_sym___read_only] = ACTIONS(1142),
    [anon_sym_write_only] = ACTIONS(1142),
    [anon_sym___write_only] = ACTIONS(1142),
    [anon_sym_read_write] = ACTIONS(1142),
    [anon_sym___read_write] = ACTIONS(1142),
    [anon_sym_extern] = ACTIONS(1142),
    [anon_sym___attribute__] = ACTIONS(1142),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1144),
    [anon_sym___declspec] = ACTIONS(1142),
    [anon_sym___based] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_static] = ACTIONS(1142),
    [anon_sym_auto] = ACTIONS(1142),
    [anon_sym_register] = ACTIONS(1142),
    [anon_sym_inline] = ACTIONS(1142),
    [anon_sym_const] = ACTIONS(1142),
    [anon_sym_volatile] = ACTIONS(1142),
    [anon_sym_restrict] = ACTIONS(1142),
    [anon_sym__Atomic] = ACTIONS(1142),
    [anon_sym_pipe] = ACTIONS(1142),
    [anon_sym_signed] = ACTIONS(1142),
    [anon_sym_unsigned] = ACTIONS(1142),
    [anon_sym_long] = ACTIONS(1142),
    [anon_sym_short] = ACTIONS(1142),
    [anon_sym_bool] = ACTIONS(1142),
    [anon_sym_char] = ACTIONS(1142),
    [anon_sym_uchar] = ACTIONS(1142),
    [anon_sym_ushort] = ACTIONS(1142),
    [anon_sym_int] = ACTIONS(1142),
    [anon_sym_uint] = ACTIONS(1142),
    [anon_sym_ulong] = ACTIONS(1142),
    [anon_sym_float] = ACTIONS(1142),
    [anon_sym_double] = ACTIONS(1142),
    [anon_sym_half] = ACTIONS(1142),
    [anon_sym_size_t] = ACTIONS(1142),
    [anon_sym_ptrdiff_t] = ACTIONS(1142),
    [anon_sym_intptr_t] = ACTIONS(1142),
    [anon_sym_uintptr_t] = ACTIONS(1142),
    [anon_sym_void] = ACTIONS(1142),
    [sym_vector_type] = ACTIONS(1142),
    [anon_sym_image2d_t] = ACTIONS(1142),
    [anon_sym_image3d_t] = ACTIONS(1142),
    [anon_sym_image2d_array_t] = ACTIONS(1142),
    [anon_sym_image1d_t] = ACTIONS(1142),
    [anon_sym_image1d_buffer_t] = ACTIONS(1142),
    [anon_sym_image1d_array_t] = ACTIONS(1142),
    [anon_sym_image2d_depth_t] = ACTIONS(1142),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1142),
    [anon_sym_sampler_t] = ACTIONS(1142),
    [anon_sym_queue_t] = ACTIONS(1142),
    [anon_sym_ndrange_t] = ACTIONS(1142),
    [anon_sym_clk_event_t] = ACTIONS(1142),
    [anon_sym_reserve_id_t] = ACTIONS(1142),
    [anon_sym_event_t] = ACTIONS(1142),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1142),
    [anon_sym_enum] = ACTIONS(1142),
    [anon_sym_struct] = ACTIONS(1142),
    [anon_sym_union] = ACTIONS(1142),
    [anon_sym_COLON] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token2] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [aux_sym_preproc_else_token1] = ACTIONS(1072),
    [aux_sym_preproc_elif_token1] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_kernel] = ACTIONS(1072),
    [anon_sym___kernel] = ACTIONS(1072),
    [anon_sym_global] = ACTIONS(1072),
    [anon_sym___global] = ACTIONS(1072),
    [anon_sym_local] = ACTIONS(1072),
    [anon_sym___local] = ACTIONS(1072),
    [anon_sym_constant] = ACTIONS(1072),
    [anon_sym___constant] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym___private] = ACTIONS(1072),
    [anon_sym_generic] = ACTIONS(1072),
    [anon_sym___generic] = ACTIONS(1072),
    [anon_sym_read_only] = ACTIONS(1072),
    [anon_sym___read_only] = ACTIONS(1072),
    [anon_sym_write_only] = ACTIONS(1072),
    [anon_sym___write_only] = ACTIONS(1072),
    [anon_sym_read_write] = ACTIONS(1072),
    [anon_sym___read_write] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1074),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_pipe] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [anon_sym_bool] = ACTIONS(1072),
    [anon_sym_char] = ACTIONS(1072),
    [anon_sym_uchar] = ACTIONS(1072),
    [anon_sym_ushort] = ACTIONS(1072),
    [anon_sym_int] = ACTIONS(1072),
    [anon_sym_uint] = ACTIONS(1072),
    [anon_sym_ulong] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1072),
    [anon_sym_double] = ACTIONS(1072),
    [anon_sym_half] = ACTIONS(1072),
    [anon_sym_size_t] = ACTIONS(1072),
    [anon_sym_ptrdiff_t] = ACTIONS(1072),
    [anon_sym_intptr_t] = ACTIONS(1072),
    [anon_sym_uintptr_t] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1072),
    [sym_vector_type] = ACTIONS(1072),
    [anon_sym_image2d_t] = ACTIONS(1072),
    [anon_sym_image3d_t] = ACTIONS(1072),
    [anon_sym_image2d_array_t] = ACTIONS(1072),
    [anon_sym_image1d_t] = ACTIONS(1072),
    [anon_sym_image1d_buffer_t] = ACTIONS(1072),
    [anon_sym_image1d_array_t] = ACTIONS(1072),
    [anon_sym_image2d_depth_t] = ACTIONS(1072),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1072),
    [anon_sym_sampler_t] = ACTIONS(1072),
    [anon_sym_queue_t] = ACTIONS(1072),
    [anon_sym_ndrange_t] = ACTIONS(1072),
    [anon_sym_clk_event_t] = ACTIONS(1072),
    [anon_sym_reserve_id_t] = ACTIONS(1072),
    [anon_sym_event_t] = ACTIONS(1072),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token2] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [aux_sym_preproc_else_token1] = ACTIONS(1088),
    [aux_sym_preproc_elif_token1] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_kernel] = ACTIONS(1088),
    [anon_sym___kernel] = ACTIONS(1088),
    [anon_sym_global] = ACTIONS(1088),
    [anon_sym___global] = ACTIONS(1088),
    [anon_sym_local] = ACTIONS(1088),
    [anon_sym___local] = ACTIONS(1088),
    [anon_sym_constant] = ACTIONS(1088),
    [anon_sym___constant] = ACTIONS(1088),
    [anon_sym_private] = ACTIONS(1088),
    [anon_sym___private] = ACTIONS(1088),
    [anon_sym_generic] = ACTIONS(1088),
    [anon_sym___generic] = ACTIONS(1088),
    [anon_sym_read_only] = ACTIONS(1088),
    [anon_sym___read_only] = ACTIONS(1088),
    [anon_sym_write_only] = ACTIONS(1088),
    [anon_sym___write_only] = ACTIONS(1088),
    [anon_sym_read_write] = ACTIONS(1088),
    [anon_sym___read_write] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1090),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_pipe] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [anon_sym_bool] = ACTIONS(1088),
    [anon_sym_char] = ACTIONS(1088),
    [anon_sym_uchar] = ACTIONS(1088),
    [anon_sym_ushort] = ACTIONS(1088),
    [anon_sym_int] = ACTIONS(1088),
    [anon_sym_uint] = ACTIONS(1088),
    [anon_sym_ulong] = ACTIONS(1088),
    [anon_sym_float] = ACTIONS(1088),
    [anon_sym_double] = ACTIONS(1088),
    [anon_sym_half] = ACTIONS(1088),
    [anon_sym_size_t] = ACTIONS(1088),
    [anon_sym_ptrdiff_t] = ACTIONS(1088),
    [anon_sym_intptr_t] = ACTIONS(1088),
    [anon_sym_uintptr_t] = ACTIONS(1088),
    [anon_sym_void] = ACTIONS(1088),
    [sym_vector_type] = ACTIONS(1088),
    [anon_sym_image2d_t] = ACTIONS(1088),
    [anon_sym_image3d_t] = ACTIONS(1088),
    [anon_sym_image2d_array_t] = ACTIONS(1088),
    [anon_sym_image1d_t] = ACTIONS(1088),
    [anon_sym_image1d_buffer_t] = ACTIONS(1088),
    [anon_sym_image1d_array_t] = ACTIONS(1088),
    [anon_sym_image2d_depth_t] = ACTIONS(1088),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1088),
    [anon_sym_sampler_t] = ACTIONS(1088),
    [anon_sym_queue_t] = ACTIONS(1088),
    [anon_sym_ndrange_t] = ACTIONS(1088),
    [anon_sym_clk_event_t] = ACTIONS(1088),
    [anon_sym_reserve_id_t] = ACTIONS(1088),
    [anon_sym_event_t] = ACTIONS(1088),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_preproc_def_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token2] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1108),
    [aux_sym_preproc_else_token1] = ACTIONS(1108),
    [aux_sym_preproc_elif_token1] = ACTIONS(1108),
    [sym_preproc_directive] = ACTIONS(1108),
    [anon_sym_kernel] = ACTIONS(1108),
    [anon_sym___kernel] = ACTIONS(1108),
    [anon_sym_global] = ACTIONS(1108),
    [anon_sym___global] = ACTIONS(1108),
    [anon_sym_local] = ACTIONS(1108),
    [anon_sym___local] = ACTIONS(1108),
    [anon_sym_constant] = ACTIONS(1108),
    [anon_sym___constant] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym___private] = ACTIONS(1108),
    [anon_sym_generic] = ACTIONS(1108),
    [anon_sym___generic] = ACTIONS(1108),
    [anon_sym_read_only] = ACTIONS(1108),
    [anon_sym___read_only] = ACTIONS(1108),
    [anon_sym_write_only] = ACTIONS(1108),
    [anon_sym___write_only] = ACTIONS(1108),
    [anon_sym_read_write] = ACTIONS(1108),
    [anon_sym___read_write] = ACTIONS(1108),
    [anon_sym_extern] = ACTIONS(1108),
    [anon_sym___attribute__] = ACTIONS(1108),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1110),
    [anon_sym___declspec] = ACTIONS(1108),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_auto] = ACTIONS(1108),
    [anon_sym_register] = ACTIONS(1108),
    [anon_sym_inline] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_volatile] = ACTIONS(1108),
    [anon_sym_restrict] = ACTIONS(1108),
    [anon_sym__Atomic] = ACTIONS(1108),
    [anon_sym_pipe] = ACTIONS(1108),
    [anon_sym_signed] = ACTIONS(1108),
    [anon_sym_unsigned] = ACTIONS(1108),
    [anon_sym_long] = ACTIONS(1108),
    [anon_sym_short] = ACTIONS(1108),
    [anon_sym_bool] = ACTIONS(1108),
    [anon_sym_char] = ACTIONS(1108),
    [anon_sym_uchar] = ACTIONS(1108),
    [anon_sym_ushort] = ACTIONS(1108),
    [anon_sym_int] = ACTIONS(1108),
    [anon_sym_uint] = ACTIONS(1108),
    [anon_sym_ulong] = ACTIONS(1108),
    [anon_sym_float] = ACTIONS(1108),
    [anon_sym_double] = ACTIONS(1108),
    [anon_sym_half] = ACTIONS(1108),
    [anon_sym_size_t] = ACTIONS(1108),
    [anon_sym_ptrdiff_t] = ACTIONS(1108),
    [anon_sym_intptr_t] = ACTIONS(1108),
    [anon_sym_uintptr_t] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1108),
    [sym_vector_type] = ACTIONS(1108),
    [anon_sym_image2d_t] = ACTIONS(1108),
    [anon_sym_image3d_t] = ACTIONS(1108),
    [anon_sym_image2d_array_t] = ACTIONS(1108),
    [anon_sym_image1d_t] = ACTIONS(1108),
    [anon_sym_image1d_buffer_t] = ACTIONS(1108),
    [anon_sym_image1d_array_t] = ACTIONS(1108),
    [anon_sym_image2d_depth_t] = ACTIONS(1108),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1108),
    [anon_sym_sampler_t] = ACTIONS(1108),
    [anon_sym_queue_t] = ACTIONS(1108),
    [anon_sym_ndrange_t] = ACTIONS(1108),
    [anon_sym_clk_event_t] = ACTIONS(1108),
    [anon_sym_reserve_id_t] = ACTIONS(1108),
    [anon_sym_event_t] = ACTIONS(1108),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [anon_sym_struct] = ACTIONS(1108),
    [anon_sym_union] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [sym_identifier] = ACTIONS(1120),
    [aux_sym_preproc_def_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token2] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1120),
    [aux_sym_preproc_else_token1] = ACTIONS(1120),
    [aux_sym_preproc_elif_token1] = ACTIONS(1120),
    [sym_preproc_directive] = ACTIONS(1120),
    [anon_sym_kernel] = ACTIONS(1120),
    [anon_sym___kernel] = ACTIONS(1120),
    [anon_sym_global] = ACTIONS(1120),
    [anon_sym___global] = ACTIONS(1120),
    [anon_sym_local] = ACTIONS(1120),
    [anon_sym___local] = ACTIONS(1120),
    [anon_sym_constant] = ACTIONS(1120),
    [anon_sym___constant] = ACTIONS(1120),
    [anon_sym_private] = ACTIONS(1120),
    [anon_sym___private] = ACTIONS(1120),
    [anon_sym_generic] = ACTIONS(1120),
    [anon_sym___generic] = ACTIONS(1120),
    [anon_sym_read_only] = ACTIONS(1120),
    [anon_sym___read_only] = ACTIONS(1120),
    [anon_sym_write_only] = ACTIONS(1120),
    [anon_sym___write_only] = ACTIONS(1120),
    [anon_sym_read_write] = ACTIONS(1120),
    [anon_sym___read_write] = ACTIONS(1120),
    [anon_sym_extern] = ACTIONS(1120),
    [anon_sym___attribute__] = ACTIONS(1120),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1122),
    [anon_sym___declspec] = ACTIONS(1120),
    [anon_sym_static] = ACTIONS(1120),
    [anon_sym_auto] = ACTIONS(1120),
    [anon_sym_register] = ACTIONS(1120),
    [anon_sym_inline] = ACTIONS(1120),
    [anon_sym_const] = ACTIONS(1120),
    [anon_sym_volatile] = ACTIONS(1120),
    [anon_sym_restrict] = ACTIONS(1120),
    [anon_sym__Atomic] = ACTIONS(1120),
    [anon_sym_pipe] = ACTIONS(1120),
    [anon_sym_signed] = ACTIONS(1120),
    [anon_sym_unsigned] = ACTIONS(1120),
    [anon_sym_long] = ACTIONS(1120),
    [anon_sym_short] = ACTIONS(1120),
    [anon_sym_bool] = ACTIONS(1120),
    [anon_sym_char] = ACTIONS(1120),
    [anon_sym_uchar] = ACTIONS(1120),
    [anon_sym_ushort] = ACTIONS(1120),
    [anon_sym_int] = ACTIONS(1120),
    [anon_sym_uint] = ACTIONS(1120),
    [anon_sym_ulong] = ACTIONS(1120),
    [anon_sym_float] = ACTIONS(1120),
    [anon_sym_double] = ACTIONS(1120),
    [anon_sym_half] = ACTIONS(1120),
    [anon_sym_size_t] = ACTIONS(1120),
    [anon_sym_ptrdiff_t] = ACTIONS(1120),
    [anon_sym_intptr_t] = ACTIONS(1120),
    [anon_sym_uintptr_t] = ACTIONS(1120),
    [anon_sym_void] = ACTIONS(1120),
    [sym_vector_type] = ACTIONS(1120),
    [anon_sym_image2d_t] = ACTIONS(1120),
    [anon_sym_image3d_t] = ACTIONS(1120),
    [anon_sym_image2d_array_t] = ACTIONS(1120),
    [anon_sym_image1d_t] = ACTIONS(1120),
    [anon_sym_image1d_buffer_t] = ACTIONS(1120),
    [anon_sym_image1d_array_t] = ACTIONS(1120),
    [anon_sym_image2d_depth_t] = ACTIONS(1120),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1120),
    [anon_sym_sampler_t] = ACTIONS(1120),
    [anon_sym_queue_t] = ACTIONS(1120),
    [anon_sym_ndrange_t] = ACTIONS(1120),
    [anon_sym_clk_event_t] = ACTIONS(1120),
    [anon_sym_reserve_id_t] = ACTIONS(1120),
    [anon_sym_event_t] = ACTIONS(1120),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1120),
    [anon_sym_enum] = ACTIONS(1120),
    [anon_sym_struct] = ACTIONS(1120),
    [anon_sym_union] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [sym_identifier] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(1140),
    [anon_sym_RPAREN] = ACTIONS(1140),
    [anon_sym_LPAREN2] = ACTIONS(1140),
    [anon_sym_STAR] = ACTIONS(1140),
    [anon_sym_SEMI] = ACTIONS(1140),
    [anon_sym_kernel] = ACTIONS(1138),
    [anon_sym___kernel] = ACTIONS(1138),
    [anon_sym_global] = ACTIONS(1138),
    [anon_sym___global] = ACTIONS(1138),
    [anon_sym_local] = ACTIONS(1138),
    [anon_sym___local] = ACTIONS(1138),
    [anon_sym_constant] = ACTIONS(1138),
    [anon_sym___constant] = ACTIONS(1138),
    [anon_sym_private] = ACTIONS(1138),
    [anon_sym___private] = ACTIONS(1138),
    [anon_sym_generic] = ACTIONS(1138),
    [anon_sym___generic] = ACTIONS(1138),
    [anon_sym_read_only] = ACTIONS(1138),
    [anon_sym___read_only] = ACTIONS(1138),
    [anon_sym_write_only] = ACTIONS(1138),
    [anon_sym___write_only] = ACTIONS(1138),
    [anon_sym_read_write] = ACTIONS(1138),
    [anon_sym___read_write] = ACTIONS(1138),
    [anon_sym_extern] = ACTIONS(1138),
    [anon_sym___attribute__] = ACTIONS(1138),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1140),
    [anon_sym___declspec] = ACTIONS(1138),
    [anon_sym___based] = ACTIONS(1138),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_static] = ACTIONS(1138),
    [anon_sym_auto] = ACTIONS(1138),
    [anon_sym_register] = ACTIONS(1138),
    [anon_sym_inline] = ACTIONS(1138),
    [anon_sym_const] = ACTIONS(1138),
    [anon_sym_volatile] = ACTIONS(1138),
    [anon_sym_restrict] = ACTIONS(1138),
    [anon_sym__Atomic] = ACTIONS(1138),
    [anon_sym_pipe] = ACTIONS(1138),
    [anon_sym_signed] = ACTIONS(1138),
    [anon_sym_unsigned] = ACTIONS(1138),
    [anon_sym_long] = ACTIONS(1138),
    [anon_sym_short] = ACTIONS(1138),
    [anon_sym_bool] = ACTIONS(1138),
    [anon_sym_char] = ACTIONS(1138),
    [anon_sym_uchar] = ACTIONS(1138),
    [anon_sym_ushort] = ACTIONS(1138),
    [anon_sym_int] = ACTIONS(1138),
    [anon_sym_uint] = ACTIONS(1138),
    [anon_sym_ulong] = ACTIONS(1138),
    [anon_sym_float] = ACTIONS(1138),
    [anon_sym_double] = ACTIONS(1138),
    [anon_sym_half] = ACTIONS(1138),
    [anon_sym_size_t] = ACTIONS(1138),
    [anon_sym_ptrdiff_t] = ACTIONS(1138),
    [anon_sym_intptr_t] = ACTIONS(1138),
    [anon_sym_uintptr_t] = ACTIONS(1138),
    [anon_sym_void] = ACTIONS(1138),
    [sym_vector_type] = ACTIONS(1138),
    [anon_sym_image2d_t] = ACTIONS(1138),
    [anon_sym_image3d_t] = ACTIONS(1138),
    [anon_sym_image2d_array_t] = ACTIONS(1138),
    [anon_sym_image1d_t] = ACTIONS(1138),
    [anon_sym_image1d_buffer_t] = ACTIONS(1138),
    [anon_sym_image1d_array_t] = ACTIONS(1138),
    [anon_sym_image2d_depth_t] = ACTIONS(1138),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1138),
    [anon_sym_sampler_t] = ACTIONS(1138),
    [anon_sym_queue_t] = ACTIONS(1138),
    [anon_sym_ndrange_t] = ACTIONS(1138),
    [anon_sym_clk_event_t] = ACTIONS(1138),
    [anon_sym_reserve_id_t] = ACTIONS(1138),
    [anon_sym_event_t] = ACTIONS(1138),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1138),
    [anon_sym_enum] = ACTIONS(1138),
    [anon_sym_struct] = ACTIONS(1138),
    [anon_sym_union] = ACTIONS(1138),
    [anon_sym_COLON] = ACTIONS(1140),
    [sym_comment] = ACTIONS(3),
  },
  [359] = {
    [sym_identifier] = ACTIONS(1440),
    [aux_sym_preproc_def_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token2] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1440),
    [aux_sym_preproc_else_token1] = ACTIONS(1440),
    [aux_sym_preproc_elif_token1] = ACTIONS(1440),
    [sym_preproc_directive] = ACTIONS(1440),
    [anon_sym_kernel] = ACTIONS(1440),
    [anon_sym___kernel] = ACTIONS(1440),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym___global] = ACTIONS(1440),
    [anon_sym_local] = ACTIONS(1440),
    [anon_sym___local] = ACTIONS(1440),
    [anon_sym_constant] = ACTIONS(1440),
    [anon_sym___constant] = ACTIONS(1440),
    [anon_sym_private] = ACTIONS(1440),
    [anon_sym___private] = ACTIONS(1440),
    [anon_sym_generic] = ACTIONS(1440),
    [anon_sym___generic] = ACTIONS(1440),
    [anon_sym_read_only] = ACTIONS(1440),
    [anon_sym___read_only] = ACTIONS(1440),
    [anon_sym_write_only] = ACTIONS(1440),
    [anon_sym___write_only] = ACTIONS(1440),
    [anon_sym_read_write] = ACTIONS(1440),
    [anon_sym___read_write] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym___attribute__] = ACTIONS(1440),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1442),
    [anon_sym___declspec] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_auto] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym_pipe] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(1440),
    [anon_sym_unsigned] = ACTIONS(1440),
    [anon_sym_long] = ACTIONS(1440),
    [anon_sym_short] = ACTIONS(1440),
    [anon_sym_bool] = ACTIONS(1440),
    [anon_sym_char] = ACTIONS(1440),
    [anon_sym_uchar] = ACTIONS(1440),
    [anon_sym_ushort] = ACTIONS(1440),
    [anon_sym_int] = ACTIONS(1440),
    [anon_sym_uint] = ACTIONS(1440),
    [anon_sym_ulong] = ACTIONS(1440),
    [anon_sym_float] = ACTIONS(1440),
    [anon_sym_double] = ACTIONS(1440),
    [anon_sym_half] = ACTIONS(1440),
    [anon_sym_size_t] = ACTIONS(1440),
    [anon_sym_ptrdiff_t] = ACTIONS(1440),
    [anon_sym_intptr_t] = ACTIONS(1440),
    [anon_sym_uintptr_t] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(1440),
    [sym_vector_type] = ACTIONS(1440),
    [anon_sym_image2d_t] = ACTIONS(1440),
    [anon_sym_image3d_t] = ACTIONS(1440),
    [anon_sym_image2d_array_t] = ACTIONS(1440),
    [anon_sym_image1d_t] = ACTIONS(1440),
    [anon_sym_image1d_buffer_t] = ACTIONS(1440),
    [anon_sym_image1d_array_t] = ACTIONS(1440),
    [anon_sym_image2d_depth_t] = ACTIONS(1440),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1440),
    [anon_sym_sampler_t] = ACTIONS(1440),
    [anon_sym_queue_t] = ACTIONS(1440),
    [anon_sym_ndrange_t] = ACTIONS(1440),
    [anon_sym_clk_event_t] = ACTIONS(1440),
    [anon_sym_reserve_id_t] = ACTIONS(1440),
    [anon_sym_event_t] = ACTIONS(1440),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [sym_identifier] = ACTIONS(1444),
    [aux_sym_preproc_def_token1] = ACTIONS(1444),
    [aux_sym_preproc_if_token1] = ACTIONS(1444),
    [aux_sym_preproc_if_token2] = ACTIONS(1444),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1444),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1444),
    [aux_sym_preproc_else_token1] = ACTIONS(1444),
    [aux_sym_preproc_elif_token1] = ACTIONS(1444),
    [sym_preproc_directive] = ACTIONS(1444),
    [anon_sym_kernel] = ACTIONS(1444),
    [anon_sym___kernel] = ACTIONS(1444),
    [anon_sym_global] = ACTIONS(1444),
    [anon_sym___global] = ACTIONS(1444),
    [anon_sym_local] = ACTIONS(1444),
    [anon_sym___local] = ACTIONS(1444),
    [anon_sym_constant] = ACTIONS(1444),
    [anon_sym___constant] = ACTIONS(1444),
    [anon_sym_private] = ACTIONS(1444),
    [anon_sym___private] = ACTIONS(1444),
    [anon_sym_generic] = ACTIONS(1444),
    [anon_sym___generic] = ACTIONS(1444),
    [anon_sym_read_only] = ACTIONS(1444),
    [anon_sym___read_only] = ACTIONS(1444),
    [anon_sym_write_only] = ACTIONS(1444),
    [anon_sym___write_only] = ACTIONS(1444),
    [anon_sym_read_write] = ACTIONS(1444),
    [anon_sym___read_write] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym___attribute__] = ACTIONS(1444),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1446),
    [anon_sym___declspec] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_auto] = ACTIONS(1444),
    [anon_sym_register] = ACTIONS(1444),
    [anon_sym_inline] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_volatile] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1444),
    [anon_sym__Atomic] = ACTIONS(1444),
    [anon_sym_pipe] = ACTIONS(1444),
    [anon_sym_signed] = ACTIONS(1444),
    [anon_sym_unsigned] = ACTIONS(1444),
    [anon_sym_long] = ACTIONS(1444),
    [anon_sym_short] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_uchar] = ACTIONS(1444),
    [anon_sym_ushort] = ACTIONS(1444),
    [anon_sym_int] = ACTIONS(1444),
    [anon_sym_uint] = ACTIONS(1444),
    [anon_sym_ulong] = ACTIONS(1444),
    [anon_sym_float] = ACTIONS(1444),
    [anon_sym_double] = ACTIONS(1444),
    [anon_sym_half] = ACTIONS(1444),
    [anon_sym_size_t] = ACTIONS(1444),
    [anon_sym_ptrdiff_t] = ACTIONS(1444),
    [anon_sym_intptr_t] = ACTIONS(1444),
    [anon_sym_uintptr_t] = ACTIONS(1444),
    [anon_sym_void] = ACTIONS(1444),
    [sym_vector_type] = ACTIONS(1444),
    [anon_sym_image2d_t] = ACTIONS(1444),
    [anon_sym_image3d_t] = ACTIONS(1444),
    [anon_sym_image2d_array_t] = ACTIONS(1444),
    [anon_sym_image1d_t] = ACTIONS(1444),
    [anon_sym_image1d_buffer_t] = ACTIONS(1444),
    [anon_sym_image1d_array_t] = ACTIONS(1444),
    [anon_sym_image2d_depth_t] = ACTIONS(1444),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1444),
    [anon_sym_sampler_t] = ACTIONS(1444),
    [anon_sym_queue_t] = ACTIONS(1444),
    [anon_sym_ndrange_t] = ACTIONS(1444),
    [anon_sym_clk_event_t] = ACTIONS(1444),
    [anon_sym_reserve_id_t] = ACTIONS(1444),
    [anon_sym_event_t] = ACTIONS(1444),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_struct] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [sym_identifier] = ACTIONS(1448),
    [aux_sym_preproc_def_token1] = ACTIONS(1448),
    [aux_sym_preproc_if_token1] = ACTIONS(1448),
    [aux_sym_preproc_if_token2] = ACTIONS(1448),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1448),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1448),
    [aux_sym_preproc_else_token1] = ACTIONS(1448),
    [aux_sym_preproc_elif_token1] = ACTIONS(1448),
    [sym_preproc_directive] = ACTIONS(1448),
    [anon_sym_kernel] = ACTIONS(1448),
    [anon_sym___kernel] = ACTIONS(1448),
    [anon_sym_global] = ACTIONS(1448),
    [anon_sym___global] = ACTIONS(1448),
    [anon_sym_local] = ACTIONS(1448),
    [anon_sym___local] = ACTIONS(1448),
    [anon_sym_constant] = ACTIONS(1448),
    [anon_sym___constant] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym___private] = ACTIONS(1448),
    [anon_sym_generic] = ACTIONS(1448),
    [anon_sym___generic] = ACTIONS(1448),
    [anon_sym_read_only] = ACTIONS(1448),
    [anon_sym___read_only] = ACTIONS(1448),
    [anon_sym_write_only] = ACTIONS(1448),
    [anon_sym___write_only] = ACTIONS(1448),
    [anon_sym_read_write] = ACTIONS(1448),
    [anon_sym___read_write] = ACTIONS(1448),
    [anon_sym_extern] = ACTIONS(1448),
    [anon_sym___attribute__] = ACTIONS(1448),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1450),
    [anon_sym___declspec] = ACTIONS(1448),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_auto] = ACTIONS(1448),
    [anon_sym_register] = ACTIONS(1448),
    [anon_sym_inline] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_volatile] = ACTIONS(1448),
    [anon_sym_restrict] = ACTIONS(1448),
    [anon_sym__Atomic] = ACTIONS(1448),
    [anon_sym_pipe] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1448),
    [anon_sym_unsigned] = ACTIONS(1448),
    [anon_sym_long] = ACTIONS(1448),
    [anon_sym_short] = ACTIONS(1448),
    [anon_sym_bool] = ACTIONS(1448),
    [anon_sym_char] = ACTIONS(1448),
    [anon_sym_uchar] = ACTIONS(1448),
    [anon_sym_ushort] = ACTIONS(1448),
    [anon_sym_int] = ACTIONS(1448),
    [anon_sym_uint] = ACTIONS(1448),
    [anon_sym_ulong] = ACTIONS(1448),
    [anon_sym_float] = ACTIONS(1448),
    [anon_sym_double] = ACTIONS(1448),
    [anon_sym_half] = ACTIONS(1448),
    [anon_sym_size_t] = ACTIONS(1448),
    [anon_sym_ptrdiff_t] = ACTIONS(1448),
    [anon_sym_intptr_t] = ACTIONS(1448),
    [anon_sym_uintptr_t] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1448),
    [sym_vector_type] = ACTIONS(1448),
    [anon_sym_image2d_t] = ACTIONS(1448),
    [anon_sym_image3d_t] = ACTIONS(1448),
    [anon_sym_image2d_array_t] = ACTIONS(1448),
    [anon_sym_image1d_t] = ACTIONS(1448),
    [anon_sym_image1d_buffer_t] = ACTIONS(1448),
    [anon_sym_image1d_array_t] = ACTIONS(1448),
    [anon_sym_image2d_depth_t] = ACTIONS(1448),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1448),
    [anon_sym_sampler_t] = ACTIONS(1448),
    [anon_sym_queue_t] = ACTIONS(1448),
    [anon_sym_ndrange_t] = ACTIONS(1448),
    [anon_sym_clk_event_t] = ACTIONS(1448),
    [anon_sym_reserve_id_t] = ACTIONS(1448),
    [anon_sym_event_t] = ACTIONS(1448),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1448),
    [anon_sym_enum] = ACTIONS(1448),
    [anon_sym_struct] = ACTIONS(1448),
    [anon_sym_union] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym_identifier] = ACTIONS(1452),
    [aux_sym_preproc_def_token1] = ACTIONS(1452),
    [aux_sym_preproc_if_token1] = ACTIONS(1452),
    [aux_sym_preproc_if_token2] = ACTIONS(1452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1452),
    [aux_sym_preproc_else_token1] = ACTIONS(1452),
    [aux_sym_preproc_elif_token1] = ACTIONS(1452),
    [sym_preproc_directive] = ACTIONS(1452),
    [anon_sym_kernel] = ACTIONS(1452),
    [anon_sym___kernel] = ACTIONS(1452),
    [anon_sym_global] = ACTIONS(1452),
    [anon_sym___global] = ACTIONS(1452),
    [anon_sym_local] = ACTIONS(1452),
    [anon_sym___local] = ACTIONS(1452),
    [anon_sym_constant] = ACTIONS(1452),
    [anon_sym___constant] = ACTIONS(1452),
    [anon_sym_private] = ACTIONS(1452),
    [anon_sym___private] = ACTIONS(1452),
    [anon_sym_generic] = ACTIONS(1452),
    [anon_sym___generic] = ACTIONS(1452),
    [anon_sym_read_only] = ACTIONS(1452),
    [anon_sym___read_only] = ACTIONS(1452),
    [anon_sym_write_only] = ACTIONS(1452),
    [anon_sym___write_only] = ACTIONS(1452),
    [anon_sym_read_write] = ACTIONS(1452),
    [anon_sym___read_write] = ACTIONS(1452),
    [anon_sym_extern] = ACTIONS(1452),
    [anon_sym___attribute__] = ACTIONS(1452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1454),
    [anon_sym___declspec] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_auto] = ACTIONS(1452),
    [anon_sym_register] = ACTIONS(1452),
    [anon_sym_inline] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_volatile] = ACTIONS(1452),
    [anon_sym_restrict] = ACTIONS(1452),
    [anon_sym__Atomic] = ACTIONS(1452),
    [anon_sym_pipe] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1452),
    [anon_sym_unsigned] = ACTIONS(1452),
    [anon_sym_long] = ACTIONS(1452),
    [anon_sym_short] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_uchar] = ACTIONS(1452),
    [anon_sym_ushort] = ACTIONS(1452),
    [anon_sym_int] = ACTIONS(1452),
    [anon_sym_uint] = ACTIONS(1452),
    [anon_sym_ulong] = ACTIONS(1452),
    [anon_sym_float] = ACTIONS(1452),
    [anon_sym_double] = ACTIONS(1452),
    [anon_sym_half] = ACTIONS(1452),
    [anon_sym_size_t] = ACTIONS(1452),
    [anon_sym_ptrdiff_t] = ACTIONS(1452),
    [anon_sym_intptr_t] = ACTIONS(1452),
    [anon_sym_uintptr_t] = ACTIONS(1452),
    [anon_sym_void] = ACTIONS(1452),
    [sym_vector_type] = ACTIONS(1452),
    [anon_sym_image2d_t] = ACTIONS(1452),
    [anon_sym_image3d_t] = ACTIONS(1452),
    [anon_sym_image2d_array_t] = ACTIONS(1452),
    [anon_sym_image1d_t] = ACTIONS(1452),
    [anon_sym_image1d_buffer_t] = ACTIONS(1452),
    [anon_sym_image1d_array_t] = ACTIONS(1452),
    [anon_sym_image2d_depth_t] = ACTIONS(1452),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1452),
    [anon_sym_sampler_t] = ACTIONS(1452),
    [anon_sym_queue_t] = ACTIONS(1452),
    [anon_sym_ndrange_t] = ACTIONS(1452),
    [anon_sym_clk_event_t] = ACTIONS(1452),
    [anon_sym_reserve_id_t] = ACTIONS(1452),
    [anon_sym_event_t] = ACTIONS(1452),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_struct] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [sym_identifier] = ACTIONS(1456),
    [aux_sym_preproc_def_token1] = ACTIONS(1456),
    [aux_sym_preproc_if_token1] = ACTIONS(1456),
    [aux_sym_preproc_if_token2] = ACTIONS(1456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1456),
    [aux_sym_preproc_else_token1] = ACTIONS(1456),
    [aux_sym_preproc_elif_token1] = ACTIONS(1456),
    [sym_preproc_directive] = ACTIONS(1456),
    [anon_sym_kernel] = ACTIONS(1456),
    [anon_sym___kernel] = ACTIONS(1456),
    [anon_sym_global] = ACTIONS(1456),
    [anon_sym___global] = ACTIONS(1456),
    [anon_sym_local] = ACTIONS(1456),
    [anon_sym___local] = ACTIONS(1456),
    [anon_sym_constant] = ACTIONS(1456),
    [anon_sym___constant] = ACTIONS(1456),
    [anon_sym_private] = ACTIONS(1456),
    [anon_sym___private] = ACTIONS(1456),
    [anon_sym_generic] = ACTIONS(1456),
    [anon_sym___generic] = ACTIONS(1456),
    [anon_sym_read_only] = ACTIONS(1456),
    [anon_sym___read_only] = ACTIONS(1456),
    [anon_sym_write_only] = ACTIONS(1456),
    [anon_sym___write_only] = ACTIONS(1456),
    [anon_sym_read_write] = ACTIONS(1456),
    [anon_sym___read_write] = ACTIONS(1456),
    [anon_sym_extern] = ACTIONS(1456),
    [anon_sym___attribute__] = ACTIONS(1456),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1458),
    [anon_sym___declspec] = ACTIONS(1456),
    [anon_sym_static] = ACTIONS(1456),
    [anon_sym_auto] = ACTIONS(1456),
    [anon_sym_register] = ACTIONS(1456),
    [anon_sym_inline] = ACTIONS(1456),
    [anon_sym_const] = ACTIONS(1456),
    [anon_sym_volatile] = ACTIONS(1456),
    [anon_sym_restrict] = ACTIONS(1456),
    [anon_sym__Atomic] = ACTIONS(1456),
    [anon_sym_pipe] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1456),
    [anon_sym_unsigned] = ACTIONS(1456),
    [anon_sym_long] = ACTIONS(1456),
    [anon_sym_short] = ACTIONS(1456),
    [anon_sym_bool] = ACTIONS(1456),
    [anon_sym_char] = ACTIONS(1456),
    [anon_sym_uchar] = ACTIONS(1456),
    [anon_sym_ushort] = ACTIONS(1456),
    [anon_sym_int] = ACTIONS(1456),
    [anon_sym_uint] = ACTIONS(1456),
    [anon_sym_ulong] = ACTIONS(1456),
    [anon_sym_float] = ACTIONS(1456),
    [anon_sym_double] = ACTIONS(1456),
    [anon_sym_half] = ACTIONS(1456),
    [anon_sym_size_t] = ACTIONS(1456),
    [anon_sym_ptrdiff_t] = ACTIONS(1456),
    [anon_sym_intptr_t] = ACTIONS(1456),
    [anon_sym_uintptr_t] = ACTIONS(1456),
    [anon_sym_void] = ACTIONS(1456),
    [sym_vector_type] = ACTIONS(1456),
    [anon_sym_image2d_t] = ACTIONS(1456),
    [anon_sym_image3d_t] = ACTIONS(1456),
    [anon_sym_image2d_array_t] = ACTIONS(1456),
    [anon_sym_image1d_t] = ACTIONS(1456),
    [anon_sym_image1d_buffer_t] = ACTIONS(1456),
    [anon_sym_image1d_array_t] = ACTIONS(1456),
    [anon_sym_image2d_depth_t] = ACTIONS(1456),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1456),
    [anon_sym_sampler_t] = ACTIONS(1456),
    [anon_sym_queue_t] = ACTIONS(1456),
    [anon_sym_ndrange_t] = ACTIONS(1456),
    [anon_sym_clk_event_t] = ACTIONS(1456),
    [anon_sym_reserve_id_t] = ACTIONS(1456),
    [anon_sym_event_t] = ACTIONS(1456),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1456),
    [anon_sym_enum] = ACTIONS(1456),
    [anon_sym_struct] = ACTIONS(1456),
    [anon_sym_union] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [sym_identifier] = ACTIONS(1460),
    [anon_sym_COMMA] = ACTIONS(1462),
    [anon_sym_RPAREN] = ACTIONS(1462),
    [anon_sym_LPAREN2] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [anon_sym_kernel] = ACTIONS(1460),
    [anon_sym___kernel] = ACTIONS(1460),
    [anon_sym_global] = ACTIONS(1460),
    [anon_sym___global] = ACTIONS(1460),
    [anon_sym_local] = ACTIONS(1460),
    [anon_sym___local] = ACTIONS(1460),
    [anon_sym_constant] = ACTIONS(1460),
    [anon_sym___constant] = ACTIONS(1460),
    [anon_sym_private] = ACTIONS(1460),
    [anon_sym___private] = ACTIONS(1460),
    [anon_sym_generic] = ACTIONS(1460),
    [anon_sym___generic] = ACTIONS(1460),
    [anon_sym_read_only] = ACTIONS(1460),
    [anon_sym___read_only] = ACTIONS(1460),
    [anon_sym_write_only] = ACTIONS(1460),
    [anon_sym___write_only] = ACTIONS(1460),
    [anon_sym_read_write] = ACTIONS(1460),
    [anon_sym___read_write] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym___attribute__] = ACTIONS(1460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1462),
    [anon_sym___declspec] = ACTIONS(1460),
    [anon_sym___based] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_auto] = ACTIONS(1460),
    [anon_sym_register] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym_const] = ACTIONS(1460),
    [anon_sym_volatile] = ACTIONS(1460),
    [anon_sym_restrict] = ACTIONS(1460),
    [anon_sym__Atomic] = ACTIONS(1460),
    [anon_sym_pipe] = ACTIONS(1460),
    [anon_sym_signed] = ACTIONS(1460),
    [anon_sym_unsigned] = ACTIONS(1460),
    [anon_sym_long] = ACTIONS(1460),
    [anon_sym_short] = ACTIONS(1460),
    [anon_sym_bool] = ACTIONS(1460),
    [anon_sym_char] = ACTIONS(1460),
    [anon_sym_uchar] = ACTIONS(1460),
    [anon_sym_ushort] = ACTIONS(1460),
    [anon_sym_int] = ACTIONS(1460),
    [anon_sym_uint] = ACTIONS(1460),
    [anon_sym_ulong] = ACTIONS(1460),
    [anon_sym_float] = ACTIONS(1460),
    [anon_sym_double] = ACTIONS(1460),
    [anon_sym_half] = ACTIONS(1460),
    [anon_sym_size_t] = ACTIONS(1460),
    [anon_sym_ptrdiff_t] = ACTIONS(1460),
    [anon_sym_intptr_t] = ACTIONS(1460),
    [anon_sym_uintptr_t] = ACTIONS(1460),
    [anon_sym_void] = ACTIONS(1460),
    [sym_vector_type] = ACTIONS(1460),
    [anon_sym_image2d_t] = ACTIONS(1460),
    [anon_sym_image3d_t] = ACTIONS(1460),
    [anon_sym_image2d_array_t] = ACTIONS(1460),
    [anon_sym_image1d_t] = ACTIONS(1460),
    [anon_sym_image1d_buffer_t] = ACTIONS(1460),
    [anon_sym_image1d_array_t] = ACTIONS(1460),
    [anon_sym_image2d_depth_t] = ACTIONS(1460),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1460),
    [anon_sym_sampler_t] = ACTIONS(1460),
    [anon_sym_queue_t] = ACTIONS(1460),
    [anon_sym_ndrange_t] = ACTIONS(1460),
    [anon_sym_clk_event_t] = ACTIONS(1460),
    [anon_sym_reserve_id_t] = ACTIONS(1460),
    [anon_sym_event_t] = ACTIONS(1460),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_struct] = ACTIONS(1460),
    [anon_sym_union] = ACTIONS(1460),
    [anon_sym_COLON] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [sym_identifier] = ACTIONS(1464),
    [aux_sym_preproc_def_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token2] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1464),
    [aux_sym_preproc_else_token1] = ACTIONS(1464),
    [aux_sym_preproc_elif_token1] = ACTIONS(1464),
    [sym_preproc_directive] = ACTIONS(1464),
    [anon_sym_kernel] = ACTIONS(1464),
    [anon_sym___kernel] = ACTIONS(1464),
    [anon_sym_global] = ACTIONS(1464),
    [anon_sym___global] = ACTIONS(1464),
    [anon_sym_local] = ACTIONS(1464),
    [anon_sym___local] = ACTIONS(1464),
    [anon_sym_constant] = ACTIONS(1464),
    [anon_sym___constant] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym___private] = ACTIONS(1464),
    [anon_sym_generic] = ACTIONS(1464),
    [anon_sym___generic] = ACTIONS(1464),
    [anon_sym_read_only] = ACTIONS(1464),
    [anon_sym___read_only] = ACTIONS(1464),
    [anon_sym_write_only] = ACTIONS(1464),
    [anon_sym___write_only] = ACTIONS(1464),
    [anon_sym_read_write] = ACTIONS(1464),
    [anon_sym___read_write] = ACTIONS(1464),
    [anon_sym_extern] = ACTIONS(1464),
    [anon_sym___attribute__] = ACTIONS(1464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1466),
    [anon_sym___declspec] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_auto] = ACTIONS(1464),
    [anon_sym_register] = ACTIONS(1464),
    [anon_sym_inline] = ACTIONS(1464),
    [anon_sym_const] = ACTIONS(1464),
    [anon_sym_volatile] = ACTIONS(1464),
    [anon_sym_restrict] = ACTIONS(1464),
    [anon_sym__Atomic] = ACTIONS(1464),
    [anon_sym_pipe] = ACTIONS(1464),
    [anon_sym_signed] = ACTIONS(1464),
    [anon_sym_unsigned] = ACTIONS(1464),
    [anon_sym_long] = ACTIONS(1464),
    [anon_sym_short] = ACTIONS(1464),
    [anon_sym_bool] = ACTIONS(1464),
    [anon_sym_char] = ACTIONS(1464),
    [anon_sym_uchar] = ACTIONS(1464),
    [anon_sym_ushort] = ACTIONS(1464),
    [anon_sym_int] = ACTIONS(1464),
    [anon_sym_uint] = ACTIONS(1464),
    [anon_sym_ulong] = ACTIONS(1464),
    [anon_sym_float] = ACTIONS(1464),
    [anon_sym_double] = ACTIONS(1464),
    [anon_sym_half] = ACTIONS(1464),
    [anon_sym_size_t] = ACTIONS(1464),
    [anon_sym_ptrdiff_t] = ACTIONS(1464),
    [anon_sym_intptr_t] = ACTIONS(1464),
    [anon_sym_uintptr_t] = ACTIONS(1464),
    [anon_sym_void] = ACTIONS(1464),
    [sym_vector_type] = ACTIONS(1464),
    [anon_sym_image2d_t] = ACTIONS(1464),
    [anon_sym_image3d_t] = ACTIONS(1464),
    [anon_sym_image2d_array_t] = ACTIONS(1464),
    [anon_sym_image1d_t] = ACTIONS(1464),
    [anon_sym_image1d_buffer_t] = ACTIONS(1464),
    [anon_sym_image1d_array_t] = ACTIONS(1464),
    [anon_sym_image2d_depth_t] = ACTIONS(1464),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1464),
    [anon_sym_sampler_t] = ACTIONS(1464),
    [anon_sym_queue_t] = ACTIONS(1464),
    [anon_sym_ndrange_t] = ACTIONS(1464),
    [anon_sym_clk_event_t] = ACTIONS(1464),
    [anon_sym_reserve_id_t] = ACTIONS(1464),
    [anon_sym_event_t] = ACTIONS(1464),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1464),
    [anon_sym_enum] = ACTIONS(1464),
    [anon_sym_struct] = ACTIONS(1464),
    [anon_sym_union] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [sym_identifier] = ACTIONS(1468),
    [aux_sym_preproc_def_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token2] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1468),
    [aux_sym_preproc_else_token1] = ACTIONS(1468),
    [aux_sym_preproc_elif_token1] = ACTIONS(1468),
    [sym_preproc_directive] = ACTIONS(1468),
    [anon_sym_kernel] = ACTIONS(1468),
    [anon_sym___kernel] = ACTIONS(1468),
    [anon_sym_global] = ACTIONS(1468),
    [anon_sym___global] = ACTIONS(1468),
    [anon_sym_local] = ACTIONS(1468),
    [anon_sym___local] = ACTIONS(1468),
    [anon_sym_constant] = ACTIONS(1468),
    [anon_sym___constant] = ACTIONS(1468),
    [anon_sym_private] = ACTIONS(1468),
    [anon_sym___private] = ACTIONS(1468),
    [anon_sym_generic] = ACTIONS(1468),
    [anon_sym___generic] = ACTIONS(1468),
    [anon_sym_read_only] = ACTIONS(1468),
    [anon_sym___read_only] = ACTIONS(1468),
    [anon_sym_write_only] = ACTIONS(1468),
    [anon_sym___write_only] = ACTIONS(1468),
    [anon_sym_read_write] = ACTIONS(1468),
    [anon_sym___read_write] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1468),
    [anon_sym___attribute__] = ACTIONS(1468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1470),
    [anon_sym___declspec] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_auto] = ACTIONS(1468),
    [anon_sym_register] = ACTIONS(1468),
    [anon_sym_inline] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_volatile] = ACTIONS(1468),
    [anon_sym_restrict] = ACTIONS(1468),
    [anon_sym__Atomic] = ACTIONS(1468),
    [anon_sym_pipe] = ACTIONS(1468),
    [anon_sym_signed] = ACTIONS(1468),
    [anon_sym_unsigned] = ACTIONS(1468),
    [anon_sym_long] = ACTIONS(1468),
    [anon_sym_short] = ACTIONS(1468),
    [anon_sym_bool] = ACTIONS(1468),
    [anon_sym_char] = ACTIONS(1468),
    [anon_sym_uchar] = ACTIONS(1468),
    [anon_sym_ushort] = ACTIONS(1468),
    [anon_sym_int] = ACTIONS(1468),
    [anon_sym_uint] = ACTIONS(1468),
    [anon_sym_ulong] = ACTIONS(1468),
    [anon_sym_float] = ACTIONS(1468),
    [anon_sym_double] = ACTIONS(1468),
    [anon_sym_half] = ACTIONS(1468),
    [anon_sym_size_t] = ACTIONS(1468),
    [anon_sym_ptrdiff_t] = ACTIONS(1468),
    [anon_sym_intptr_t] = ACTIONS(1468),
    [anon_sym_uintptr_t] = ACTIONS(1468),
    [anon_sym_void] = ACTIONS(1468),
    [sym_vector_type] = ACTIONS(1468),
    [anon_sym_image2d_t] = ACTIONS(1468),
    [anon_sym_image3d_t] = ACTIONS(1468),
    [anon_sym_image2d_array_t] = ACTIONS(1468),
    [anon_sym_image1d_t] = ACTIONS(1468),
    [anon_sym_image1d_buffer_t] = ACTIONS(1468),
    [anon_sym_image1d_array_t] = ACTIONS(1468),
    [anon_sym_image2d_depth_t] = ACTIONS(1468),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1468),
    [anon_sym_sampler_t] = ACTIONS(1468),
    [anon_sym_queue_t] = ACTIONS(1468),
    [anon_sym_ndrange_t] = ACTIONS(1468),
    [anon_sym_clk_event_t] = ACTIONS(1468),
    [anon_sym_reserve_id_t] = ACTIONS(1468),
    [anon_sym_event_t] = ACTIONS(1468),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [anon_sym_struct] = ACTIONS(1468),
    [anon_sym_union] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_COMMA] = ACTIONS(1474),
    [anon_sym_RPAREN] = ACTIONS(1474),
    [anon_sym_LPAREN2] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1474),
    [anon_sym_kernel] = ACTIONS(1472),
    [anon_sym___kernel] = ACTIONS(1472),
    [anon_sym_global] = ACTIONS(1472),
    [anon_sym___global] = ACTIONS(1472),
    [anon_sym_local] = ACTIONS(1472),
    [anon_sym___local] = ACTIONS(1472),
    [anon_sym_constant] = ACTIONS(1472),
    [anon_sym___constant] = ACTIONS(1472),
    [anon_sym_private] = ACTIONS(1472),
    [anon_sym___private] = ACTIONS(1472),
    [anon_sym_generic] = ACTIONS(1472),
    [anon_sym___generic] = ACTIONS(1472),
    [anon_sym_read_only] = ACTIONS(1472),
    [anon_sym___read_only] = ACTIONS(1472),
    [anon_sym_write_only] = ACTIONS(1472),
    [anon_sym___write_only] = ACTIONS(1472),
    [anon_sym_read_write] = ACTIONS(1472),
    [anon_sym___read_write] = ACTIONS(1472),
    [anon_sym_extern] = ACTIONS(1472),
    [anon_sym___attribute__] = ACTIONS(1472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1474),
    [anon_sym___declspec] = ACTIONS(1472),
    [anon_sym___based] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_auto] = ACTIONS(1472),
    [anon_sym_register] = ACTIONS(1472),
    [anon_sym_inline] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_volatile] = ACTIONS(1472),
    [anon_sym_restrict] = ACTIONS(1472),
    [anon_sym__Atomic] = ACTIONS(1472),
    [anon_sym_pipe] = ACTIONS(1472),
    [anon_sym_signed] = ACTIONS(1472),
    [anon_sym_unsigned] = ACTIONS(1472),
    [anon_sym_long] = ACTIONS(1472),
    [anon_sym_short] = ACTIONS(1472),
    [anon_sym_bool] = ACTIONS(1472),
    [anon_sym_char] = ACTIONS(1472),
    [anon_sym_uchar] = ACTIONS(1472),
    [anon_sym_ushort] = ACTIONS(1472),
    [anon_sym_int] = ACTIONS(1472),
    [anon_sym_uint] = ACTIONS(1472),
    [anon_sym_ulong] = ACTIONS(1472),
    [anon_sym_float] = ACTIONS(1472),
    [anon_sym_double] = ACTIONS(1472),
    [anon_sym_half] = ACTIONS(1472),
    [anon_sym_size_t] = ACTIONS(1472),
    [anon_sym_ptrdiff_t] = ACTIONS(1472),
    [anon_sym_intptr_t] = ACTIONS(1472),
    [anon_sym_uintptr_t] = ACTIONS(1472),
    [anon_sym_void] = ACTIONS(1472),
    [sym_vector_type] = ACTIONS(1472),
    [anon_sym_image2d_t] = ACTIONS(1472),
    [anon_sym_image3d_t] = ACTIONS(1472),
    [anon_sym_image2d_array_t] = ACTIONS(1472),
    [anon_sym_image1d_t] = ACTIONS(1472),
    [anon_sym_image1d_buffer_t] = ACTIONS(1472),
    [anon_sym_image1d_array_t] = ACTIONS(1472),
    [anon_sym_image2d_depth_t] = ACTIONS(1472),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1472),
    [anon_sym_sampler_t] = ACTIONS(1472),
    [anon_sym_queue_t] = ACTIONS(1472),
    [anon_sym_ndrange_t] = ACTIONS(1472),
    [anon_sym_clk_event_t] = ACTIONS(1472),
    [anon_sym_reserve_id_t] = ACTIONS(1472),
    [anon_sym_event_t] = ACTIONS(1472),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [anon_sym_struct] = ACTIONS(1472),
    [anon_sym_union] = ACTIONS(1472),
    [anon_sym_COLON] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [sym_identifier] = ACTIONS(1476),
    [aux_sym_preproc_def_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token2] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1476),
    [aux_sym_preproc_else_token1] = ACTIONS(1476),
    [aux_sym_preproc_elif_token1] = ACTIONS(1476),
    [sym_preproc_directive] = ACTIONS(1476),
    [anon_sym_kernel] = ACTIONS(1476),
    [anon_sym___kernel] = ACTIONS(1476),
    [anon_sym_global] = ACTIONS(1476),
    [anon_sym___global] = ACTIONS(1476),
    [anon_sym_local] = ACTIONS(1476),
    [anon_sym___local] = ACTIONS(1476),
    [anon_sym_constant] = ACTIONS(1476),
    [anon_sym___constant] = ACTIONS(1476),
    [anon_sym_private] = ACTIONS(1476),
    [anon_sym___private] = ACTIONS(1476),
    [anon_sym_generic] = ACTIONS(1476),
    [anon_sym___generic] = ACTIONS(1476),
    [anon_sym_read_only] = ACTIONS(1476),
    [anon_sym___read_only] = ACTIONS(1476),
    [anon_sym_write_only] = ACTIONS(1476),
    [anon_sym___write_only] = ACTIONS(1476),
    [anon_sym_read_write] = ACTIONS(1476),
    [anon_sym___read_write] = ACTIONS(1476),
    [anon_sym_extern] = ACTIONS(1476),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1478),
    [anon_sym___declspec] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1476),
    [anon_sym_auto] = ACTIONS(1476),
    [anon_sym_register] = ACTIONS(1476),
    [anon_sym_inline] = ACTIONS(1476),
    [anon_sym_const] = ACTIONS(1476),
    [anon_sym_volatile] = ACTIONS(1476),
    [anon_sym_restrict] = ACTIONS(1476),
    [anon_sym__Atomic] = ACTIONS(1476),
    [anon_sym_pipe] = ACTIONS(1476),
    [anon_sym_signed] = ACTIONS(1476),
    [anon_sym_unsigned] = ACTIONS(1476),
    [anon_sym_long] = ACTIONS(1476),
    [anon_sym_short] = ACTIONS(1476),
    [anon_sym_bool] = ACTIONS(1476),
    [anon_sym_char] = ACTIONS(1476),
    [anon_sym_uchar] = ACTIONS(1476),
    [anon_sym_ushort] = ACTIONS(1476),
    [anon_sym_int] = ACTIONS(1476),
    [anon_sym_uint] = ACTIONS(1476),
    [anon_sym_ulong] = ACTIONS(1476),
    [anon_sym_float] = ACTIONS(1476),
    [anon_sym_double] = ACTIONS(1476),
    [anon_sym_half] = ACTIONS(1476),
    [anon_sym_size_t] = ACTIONS(1476),
    [anon_sym_ptrdiff_t] = ACTIONS(1476),
    [anon_sym_intptr_t] = ACTIONS(1476),
    [anon_sym_uintptr_t] = ACTIONS(1476),
    [anon_sym_void] = ACTIONS(1476),
    [sym_vector_type] = ACTIONS(1476),
    [anon_sym_image2d_t] = ACTIONS(1476),
    [anon_sym_image3d_t] = ACTIONS(1476),
    [anon_sym_image2d_array_t] = ACTIONS(1476),
    [anon_sym_image1d_t] = ACTIONS(1476),
    [anon_sym_image1d_buffer_t] = ACTIONS(1476),
    [anon_sym_image1d_array_t] = ACTIONS(1476),
    [anon_sym_image2d_depth_t] = ACTIONS(1476),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1476),
    [anon_sym_sampler_t] = ACTIONS(1476),
    [anon_sym_queue_t] = ACTIONS(1476),
    [anon_sym_ndrange_t] = ACTIONS(1476),
    [anon_sym_clk_event_t] = ACTIONS(1476),
    [anon_sym_reserve_id_t] = ACTIONS(1476),
    [anon_sym_event_t] = ACTIONS(1476),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1476),
    [anon_sym_enum] = ACTIONS(1476),
    [anon_sym_struct] = ACTIONS(1476),
    [anon_sym_union] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [sym_identifier] = ACTIONS(1480),
    [aux_sym_preproc_def_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token2] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1480),
    [aux_sym_preproc_else_token1] = ACTIONS(1480),
    [aux_sym_preproc_elif_token1] = ACTIONS(1480),
    [sym_preproc_directive] = ACTIONS(1480),
    [anon_sym_kernel] = ACTIONS(1480),
    [anon_sym___kernel] = ACTIONS(1480),
    [anon_sym_global] = ACTIONS(1480),
    [anon_sym___global] = ACTIONS(1480),
    [anon_sym_local] = ACTIONS(1480),
    [anon_sym___local] = ACTIONS(1480),
    [anon_sym_constant] = ACTIONS(1480),
    [anon_sym___constant] = ACTIONS(1480),
    [anon_sym_private] = ACTIONS(1480),
    [anon_sym___private] = ACTIONS(1480),
    [anon_sym_generic] = ACTIONS(1480),
    [anon_sym___generic] = ACTIONS(1480),
    [anon_sym_read_only] = ACTIONS(1480),
    [anon_sym___read_only] = ACTIONS(1480),
    [anon_sym_write_only] = ACTIONS(1480),
    [anon_sym___write_only] = ACTIONS(1480),
    [anon_sym_read_write] = ACTIONS(1480),
    [anon_sym___read_write] = ACTIONS(1480),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym___attribute__] = ACTIONS(1480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1480),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_auto] = ACTIONS(1480),
    [anon_sym_register] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym_const] = ACTIONS(1480),
    [anon_sym_volatile] = ACTIONS(1480),
    [anon_sym_restrict] = ACTIONS(1480),
    [anon_sym__Atomic] = ACTIONS(1480),
    [anon_sym_pipe] = ACTIONS(1480),
    [anon_sym_signed] = ACTIONS(1480),
    [anon_sym_unsigned] = ACTIONS(1480),
    [anon_sym_long] = ACTIONS(1480),
    [anon_sym_short] = ACTIONS(1480),
    [anon_sym_bool] = ACTIONS(1480),
    [anon_sym_char] = ACTIONS(1480),
    [anon_sym_uchar] = ACTIONS(1480),
    [anon_sym_ushort] = ACTIONS(1480),
    [anon_sym_int] = ACTIONS(1480),
    [anon_sym_uint] = ACTIONS(1480),
    [anon_sym_ulong] = ACTIONS(1480),
    [anon_sym_float] = ACTIONS(1480),
    [anon_sym_double] = ACTIONS(1480),
    [anon_sym_half] = ACTIONS(1480),
    [anon_sym_size_t] = ACTIONS(1480),
    [anon_sym_ptrdiff_t] = ACTIONS(1480),
    [anon_sym_intptr_t] = ACTIONS(1480),
    [anon_sym_uintptr_t] = ACTIONS(1480),
    [anon_sym_void] = ACTIONS(1480),
    [sym_vector_type] = ACTIONS(1480),
    [anon_sym_image2d_t] = ACTIONS(1480),
    [anon_sym_image3d_t] = ACTIONS(1480),
    [anon_sym_image2d_array_t] = ACTIONS(1480),
    [anon_sym_image1d_t] = ACTIONS(1480),
    [anon_sym_image1d_buffer_t] = ACTIONS(1480),
    [anon_sym_image1d_array_t] = ACTIONS(1480),
    [anon_sym_image2d_depth_t] = ACTIONS(1480),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1480),
    [anon_sym_sampler_t] = ACTIONS(1480),
    [anon_sym_queue_t] = ACTIONS(1480),
    [anon_sym_ndrange_t] = ACTIONS(1480),
    [anon_sym_clk_event_t] = ACTIONS(1480),
    [anon_sym_reserve_id_t] = ACTIONS(1480),
    [anon_sym_event_t] = ACTIONS(1480),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_struct] = ACTIONS(1480),
    [anon_sym_union] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token2] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [aux_sym_preproc_else_token1] = ACTIONS(1076),
    [aux_sym_preproc_elif_token1] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_kernel] = ACTIONS(1076),
    [anon_sym___kernel] = ACTIONS(1076),
    [anon_sym_global] = ACTIONS(1076),
    [anon_sym___global] = ACTIONS(1076),
    [anon_sym_local] = ACTIONS(1076),
    [anon_sym___local] = ACTIONS(1076),
    [anon_sym_constant] = ACTIONS(1076),
    [anon_sym___constant] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym___private] = ACTIONS(1076),
    [anon_sym_generic] = ACTIONS(1076),
    [anon_sym___generic] = ACTIONS(1076),
    [anon_sym_read_only] = ACTIONS(1076),
    [anon_sym___read_only] = ACTIONS(1076),
    [anon_sym_write_only] = ACTIONS(1076),
    [anon_sym___write_only] = ACTIONS(1076),
    [anon_sym_read_write] = ACTIONS(1076),
    [anon_sym___read_write] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1078),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_pipe] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [anon_sym_bool] = ACTIONS(1076),
    [anon_sym_char] = ACTIONS(1076),
    [anon_sym_uchar] = ACTIONS(1076),
    [anon_sym_ushort] = ACTIONS(1076),
    [anon_sym_int] = ACTIONS(1076),
    [anon_sym_uint] = ACTIONS(1076),
    [anon_sym_ulong] = ACTIONS(1076),
    [anon_sym_float] = ACTIONS(1076),
    [anon_sym_double] = ACTIONS(1076),
    [anon_sym_half] = ACTIONS(1076),
    [anon_sym_size_t] = ACTIONS(1076),
    [anon_sym_ptrdiff_t] = ACTIONS(1076),
    [anon_sym_intptr_t] = ACTIONS(1076),
    [anon_sym_uintptr_t] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1076),
    [sym_vector_type] = ACTIONS(1076),
    [anon_sym_image2d_t] = ACTIONS(1076),
    [anon_sym_image3d_t] = ACTIONS(1076),
    [anon_sym_image2d_array_t] = ACTIONS(1076),
    [anon_sym_image1d_t] = ACTIONS(1076),
    [anon_sym_image1d_buffer_t] = ACTIONS(1076),
    [anon_sym_image1d_array_t] = ACTIONS(1076),
    [anon_sym_image2d_depth_t] = ACTIONS(1076),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1076),
    [anon_sym_sampler_t] = ACTIONS(1076),
    [anon_sym_queue_t] = ACTIONS(1076),
    [anon_sym_ndrange_t] = ACTIONS(1076),
    [anon_sym_clk_event_t] = ACTIONS(1076),
    [anon_sym_reserve_id_t] = ACTIONS(1076),
    [anon_sym_event_t] = ACTIONS(1076),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [sym_identifier] = ACTIONS(1484),
    [aux_sym_preproc_def_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token2] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1484),
    [aux_sym_preproc_else_token1] = ACTIONS(1484),
    [aux_sym_preproc_elif_token1] = ACTIONS(1484),
    [sym_preproc_directive] = ACTIONS(1484),
    [anon_sym_kernel] = ACTIONS(1484),
    [anon_sym___kernel] = ACTIONS(1484),
    [anon_sym_global] = ACTIONS(1484),
    [anon_sym___global] = ACTIONS(1484),
    [anon_sym_local] = ACTIONS(1484),
    [anon_sym___local] = ACTIONS(1484),
    [anon_sym_constant] = ACTIONS(1484),
    [anon_sym___constant] = ACTIONS(1484),
    [anon_sym_private] = ACTIONS(1484),
    [anon_sym___private] = ACTIONS(1484),
    [anon_sym_generic] = ACTIONS(1484),
    [anon_sym___generic] = ACTIONS(1484),
    [anon_sym_read_only] = ACTIONS(1484),
    [anon_sym___read_only] = ACTIONS(1484),
    [anon_sym_write_only] = ACTIONS(1484),
    [anon_sym___write_only] = ACTIONS(1484),
    [anon_sym_read_write] = ACTIONS(1484),
    [anon_sym___read_write] = ACTIONS(1484),
    [anon_sym_extern] = ACTIONS(1484),
    [anon_sym___attribute__] = ACTIONS(1484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1486),
    [anon_sym___declspec] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_auto] = ACTIONS(1484),
    [anon_sym_register] = ACTIONS(1484),
    [anon_sym_inline] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_volatile] = ACTIONS(1484),
    [anon_sym_restrict] = ACTIONS(1484),
    [anon_sym__Atomic] = ACTIONS(1484),
    [anon_sym_pipe] = ACTIONS(1484),
    [anon_sym_signed] = ACTIONS(1484),
    [anon_sym_unsigned] = ACTIONS(1484),
    [anon_sym_long] = ACTIONS(1484),
    [anon_sym_short] = ACTIONS(1484),
    [anon_sym_bool] = ACTIONS(1484),
    [anon_sym_char] = ACTIONS(1484),
    [anon_sym_uchar] = ACTIONS(1484),
    [anon_sym_ushort] = ACTIONS(1484),
    [anon_sym_int] = ACTIONS(1484),
    [anon_sym_uint] = ACTIONS(1484),
    [anon_sym_ulong] = ACTIONS(1484),
    [anon_sym_float] = ACTIONS(1484),
    [anon_sym_double] = ACTIONS(1484),
    [anon_sym_half] = ACTIONS(1484),
    [anon_sym_size_t] = ACTIONS(1484),
    [anon_sym_ptrdiff_t] = ACTIONS(1484),
    [anon_sym_intptr_t] = ACTIONS(1484),
    [anon_sym_uintptr_t] = ACTIONS(1484),
    [anon_sym_void] = ACTIONS(1484),
    [sym_vector_type] = ACTIONS(1484),
    [anon_sym_image2d_t] = ACTIONS(1484),
    [anon_sym_image3d_t] = ACTIONS(1484),
    [anon_sym_image2d_array_t] = ACTIONS(1484),
    [anon_sym_image1d_t] = ACTIONS(1484),
    [anon_sym_image1d_buffer_t] = ACTIONS(1484),
    [anon_sym_image1d_array_t] = ACTIONS(1484),
    [anon_sym_image2d_depth_t] = ACTIONS(1484),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1484),
    [anon_sym_sampler_t] = ACTIONS(1484),
    [anon_sym_queue_t] = ACTIONS(1484),
    [anon_sym_ndrange_t] = ACTIONS(1484),
    [anon_sym_clk_event_t] = ACTIONS(1484),
    [anon_sym_reserve_id_t] = ACTIONS(1484),
    [anon_sym_event_t] = ACTIONS(1484),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [anon_sym_struct] = ACTIONS(1484),
    [anon_sym_union] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [sym_identifier] = ACTIONS(1488),
    [aux_sym_preproc_def_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token2] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1488),
    [aux_sym_preproc_else_token1] = ACTIONS(1488),
    [aux_sym_preproc_elif_token1] = ACTIONS(1488),
    [sym_preproc_directive] = ACTIONS(1488),
    [anon_sym_kernel] = ACTIONS(1488),
    [anon_sym___kernel] = ACTIONS(1488),
    [anon_sym_global] = ACTIONS(1488),
    [anon_sym___global] = ACTIONS(1488),
    [anon_sym_local] = ACTIONS(1488),
    [anon_sym___local] = ACTIONS(1488),
    [anon_sym_constant] = ACTIONS(1488),
    [anon_sym___constant] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym___private] = ACTIONS(1488),
    [anon_sym_generic] = ACTIONS(1488),
    [anon_sym___generic] = ACTIONS(1488),
    [anon_sym_read_only] = ACTIONS(1488),
    [anon_sym___read_only] = ACTIONS(1488),
    [anon_sym_write_only] = ACTIONS(1488),
    [anon_sym___write_only] = ACTIONS(1488),
    [anon_sym_read_write] = ACTIONS(1488),
    [anon_sym___read_write] = ACTIONS(1488),
    [anon_sym_extern] = ACTIONS(1488),
    [anon_sym___attribute__] = ACTIONS(1488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1490),
    [anon_sym___declspec] = ACTIONS(1488),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_auto] = ACTIONS(1488),
    [anon_sym_register] = ACTIONS(1488),
    [anon_sym_inline] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_volatile] = ACTIONS(1488),
    [anon_sym_restrict] = ACTIONS(1488),
    [anon_sym__Atomic] = ACTIONS(1488),
    [anon_sym_pipe] = ACTIONS(1488),
    [anon_sym_signed] = ACTIONS(1488),
    [anon_sym_unsigned] = ACTIONS(1488),
    [anon_sym_long] = ACTIONS(1488),
    [anon_sym_short] = ACTIONS(1488),
    [anon_sym_bool] = ACTIONS(1488),
    [anon_sym_char] = ACTIONS(1488),
    [anon_sym_uchar] = ACTIONS(1488),
    [anon_sym_ushort] = ACTIONS(1488),
    [anon_sym_int] = ACTIONS(1488),
    [anon_sym_uint] = ACTIONS(1488),
    [anon_sym_ulong] = ACTIONS(1488),
    [anon_sym_float] = ACTIONS(1488),
    [anon_sym_double] = ACTIONS(1488),
    [anon_sym_half] = ACTIONS(1488),
    [anon_sym_size_t] = ACTIONS(1488),
    [anon_sym_ptrdiff_t] = ACTIONS(1488),
    [anon_sym_intptr_t] = ACTIONS(1488),
    [anon_sym_uintptr_t] = ACTIONS(1488),
    [anon_sym_void] = ACTIONS(1488),
    [sym_vector_type] = ACTIONS(1488),
    [anon_sym_image2d_t] = ACTIONS(1488),
    [anon_sym_image3d_t] = ACTIONS(1488),
    [anon_sym_image2d_array_t] = ACTIONS(1488),
    [anon_sym_image1d_t] = ACTIONS(1488),
    [anon_sym_image1d_buffer_t] = ACTIONS(1488),
    [anon_sym_image1d_array_t] = ACTIONS(1488),
    [anon_sym_image2d_depth_t] = ACTIONS(1488),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1488),
    [anon_sym_sampler_t] = ACTIONS(1488),
    [anon_sym_queue_t] = ACTIONS(1488),
    [anon_sym_ndrange_t] = ACTIONS(1488),
    [anon_sym_clk_event_t] = ACTIONS(1488),
    [anon_sym_reserve_id_t] = ACTIONS(1488),
    [anon_sym_event_t] = ACTIONS(1488),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_struct] = ACTIONS(1488),
    [anon_sym_union] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_kernel] = ACTIONS(1492),
    [anon_sym___kernel] = ACTIONS(1492),
    [anon_sym_global] = ACTIONS(1492),
    [anon_sym___global] = ACTIONS(1492),
    [anon_sym_local] = ACTIONS(1492),
    [anon_sym___local] = ACTIONS(1492),
    [anon_sym_constant] = ACTIONS(1492),
    [anon_sym___constant] = ACTIONS(1492),
    [anon_sym_private] = ACTIONS(1492),
    [anon_sym___private] = ACTIONS(1492),
    [anon_sym_generic] = ACTIONS(1492),
    [anon_sym___generic] = ACTIONS(1492),
    [anon_sym_read_only] = ACTIONS(1492),
    [anon_sym___read_only] = ACTIONS(1492),
    [anon_sym_write_only] = ACTIONS(1492),
    [anon_sym___write_only] = ACTIONS(1492),
    [anon_sym_read_write] = ACTIONS(1492),
    [anon_sym___read_write] = ACTIONS(1492),
    [anon_sym_extern] = ACTIONS(1492),
    [anon_sym___attribute__] = ACTIONS(1492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1494),
    [anon_sym___declspec] = ACTIONS(1492),
    [anon_sym___cdecl] = ACTIONS(1492),
    [anon_sym___clrcall] = ACTIONS(1492),
    [anon_sym___stdcall] = ACTIONS(1492),
    [anon_sym___fastcall] = ACTIONS(1492),
    [anon_sym___thiscall] = ACTIONS(1492),
    [anon_sym___vectorcall] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_auto] = ACTIONS(1492),
    [anon_sym_register] = ACTIONS(1492),
    [anon_sym_inline] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_volatile] = ACTIONS(1492),
    [anon_sym_restrict] = ACTIONS(1492),
    [anon_sym__Atomic] = ACTIONS(1492),
    [anon_sym_pipe] = ACTIONS(1492),
    [anon_sym_signed] = ACTIONS(1492),
    [anon_sym_unsigned] = ACTIONS(1492),
    [anon_sym_long] = ACTIONS(1492),
    [anon_sym_short] = ACTIONS(1492),
    [anon_sym_bool] = ACTIONS(1492),
    [anon_sym_char] = ACTIONS(1492),
    [anon_sym_uchar] = ACTIONS(1492),
    [anon_sym_ushort] = ACTIONS(1492),
    [anon_sym_int] = ACTIONS(1492),
    [anon_sym_uint] = ACTIONS(1492),
    [anon_sym_ulong] = ACTIONS(1492),
    [anon_sym_float] = ACTIONS(1492),
    [anon_sym_double] = ACTIONS(1492),
    [anon_sym_half] = ACTIONS(1492),
    [anon_sym_size_t] = ACTIONS(1492),
    [anon_sym_ptrdiff_t] = ACTIONS(1492),
    [anon_sym_intptr_t] = ACTIONS(1492),
    [anon_sym_uintptr_t] = ACTIONS(1492),
    [anon_sym_void] = ACTIONS(1492),
    [sym_vector_type] = ACTIONS(1492),
    [anon_sym_image2d_t] = ACTIONS(1492),
    [anon_sym_image3d_t] = ACTIONS(1492),
    [anon_sym_image2d_array_t] = ACTIONS(1492),
    [anon_sym_image1d_t] = ACTIONS(1492),
    [anon_sym_image1d_buffer_t] = ACTIONS(1492),
    [anon_sym_image1d_array_t] = ACTIONS(1492),
    [anon_sym_image2d_depth_t] = ACTIONS(1492),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1492),
    [anon_sym_sampler_t] = ACTIONS(1492),
    [anon_sym_queue_t] = ACTIONS(1492),
    [anon_sym_ndrange_t] = ACTIONS(1492),
    [anon_sym_clk_event_t] = ACTIONS(1492),
    [anon_sym_reserve_id_t] = ACTIONS(1492),
    [anon_sym_event_t] = ACTIONS(1492),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [anon_sym_struct] = ACTIONS(1492),
    [anon_sym_union] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [sym_identifier] = ACTIONS(1496),
    [anon_sym_kernel] = ACTIONS(1496),
    [anon_sym___kernel] = ACTIONS(1496),
    [anon_sym_global] = ACTIONS(1496),
    [anon_sym___global] = ACTIONS(1496),
    [anon_sym_local] = ACTIONS(1496),
    [anon_sym___local] = ACTIONS(1496),
    [anon_sym_constant] = ACTIONS(1496),
    [anon_sym___constant] = ACTIONS(1496),
    [anon_sym_private] = ACTIONS(1496),
    [anon_sym___private] = ACTIONS(1496),
    [anon_sym_generic] = ACTIONS(1496),
    [anon_sym___generic] = ACTIONS(1496),
    [anon_sym_read_only] = ACTIONS(1496),
    [anon_sym___read_only] = ACTIONS(1496),
    [anon_sym_write_only] = ACTIONS(1496),
    [anon_sym___write_only] = ACTIONS(1496),
    [anon_sym_read_write] = ACTIONS(1496),
    [anon_sym___read_write] = ACTIONS(1496),
    [anon_sym_extern] = ACTIONS(1496),
    [anon_sym___attribute__] = ACTIONS(1496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1498),
    [anon_sym___declspec] = ACTIONS(1496),
    [anon_sym___cdecl] = ACTIONS(1496),
    [anon_sym___clrcall] = ACTIONS(1496),
    [anon_sym___stdcall] = ACTIONS(1496),
    [anon_sym___fastcall] = ACTIONS(1496),
    [anon_sym___thiscall] = ACTIONS(1496),
    [anon_sym___vectorcall] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_auto] = ACTIONS(1496),
    [anon_sym_register] = ACTIONS(1496),
    [anon_sym_inline] = ACTIONS(1496),
    [anon_sym_const] = ACTIONS(1496),
    [anon_sym_volatile] = ACTIONS(1496),
    [anon_sym_restrict] = ACTIONS(1496),
    [anon_sym__Atomic] = ACTIONS(1496),
    [anon_sym_pipe] = ACTIONS(1496),
    [anon_sym_signed] = ACTIONS(1496),
    [anon_sym_unsigned] = ACTIONS(1496),
    [anon_sym_long] = ACTIONS(1496),
    [anon_sym_short] = ACTIONS(1496),
    [anon_sym_bool] = ACTIONS(1496),
    [anon_sym_char] = ACTIONS(1496),
    [anon_sym_uchar] = ACTIONS(1496),
    [anon_sym_ushort] = ACTIONS(1496),
    [anon_sym_int] = ACTIONS(1496),
    [anon_sym_uint] = ACTIONS(1496),
    [anon_sym_ulong] = ACTIONS(1496),
    [anon_sym_float] = ACTIONS(1496),
    [anon_sym_double] = ACTIONS(1496),
    [anon_sym_half] = ACTIONS(1496),
    [anon_sym_size_t] = ACTIONS(1496),
    [anon_sym_ptrdiff_t] = ACTIONS(1496),
    [anon_sym_intptr_t] = ACTIONS(1496),
    [anon_sym_uintptr_t] = ACTIONS(1496),
    [anon_sym_void] = ACTIONS(1496),
    [sym_vector_type] = ACTIONS(1496),
    [anon_sym_image2d_t] = ACTIONS(1496),
    [anon_sym_image3d_t] = ACTIONS(1496),
    [anon_sym_image2d_array_t] = ACTIONS(1496),
    [anon_sym_image1d_t] = ACTIONS(1496),
    [anon_sym_image1d_buffer_t] = ACTIONS(1496),
    [anon_sym_image1d_array_t] = ACTIONS(1496),
    [anon_sym_image2d_depth_t] = ACTIONS(1496),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1496),
    [anon_sym_sampler_t] = ACTIONS(1496),
    [anon_sym_queue_t] = ACTIONS(1496),
    [anon_sym_ndrange_t] = ACTIONS(1496),
    [anon_sym_clk_event_t] = ACTIONS(1496),
    [anon_sym_reserve_id_t] = ACTIONS(1496),
    [anon_sym_event_t] = ACTIONS(1496),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
    [anon_sym_struct] = ACTIONS(1496),
    [anon_sym_union] = ACTIONS(1496),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [sym_identifier] = ACTIONS(1452),
    [aux_sym_preproc_def_token1] = ACTIONS(1452),
    [aux_sym_preproc_if_token1] = ACTIONS(1452),
    [aux_sym_preproc_if_token2] = ACTIONS(1452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1452),
    [sym_preproc_directive] = ACTIONS(1452),
    [anon_sym_kernel] = ACTIONS(1452),
    [anon_sym___kernel] = ACTIONS(1452),
    [anon_sym_global] = ACTIONS(1452),
    [anon_sym___global] = ACTIONS(1452),
    [anon_sym_local] = ACTIONS(1452),
    [anon_sym___local] = ACTIONS(1452),
    [anon_sym_constant] = ACTIONS(1452),
    [anon_sym___constant] = ACTIONS(1452),
    [anon_sym_private] = ACTIONS(1452),
    [anon_sym___private] = ACTIONS(1452),
    [anon_sym_generic] = ACTIONS(1452),
    [anon_sym___generic] = ACTIONS(1452),
    [anon_sym_read_only] = ACTIONS(1452),
    [anon_sym___read_only] = ACTIONS(1452),
    [anon_sym_write_only] = ACTIONS(1452),
    [anon_sym___write_only] = ACTIONS(1452),
    [anon_sym_read_write] = ACTIONS(1452),
    [anon_sym___read_write] = ACTIONS(1452),
    [anon_sym_extern] = ACTIONS(1452),
    [anon_sym___attribute__] = ACTIONS(1452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1454),
    [anon_sym___declspec] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_auto] = ACTIONS(1452),
    [anon_sym_register] = ACTIONS(1452),
    [anon_sym_inline] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_volatile] = ACTIONS(1452),
    [anon_sym_restrict] = ACTIONS(1452),
    [anon_sym__Atomic] = ACTIONS(1452),
    [anon_sym_pipe] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1452),
    [anon_sym_unsigned] = ACTIONS(1452),
    [anon_sym_long] = ACTIONS(1452),
    [anon_sym_short] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_uchar] = ACTIONS(1452),
    [anon_sym_ushort] = ACTIONS(1452),
    [anon_sym_int] = ACTIONS(1452),
    [anon_sym_uint] = ACTIONS(1452),
    [anon_sym_ulong] = ACTIONS(1452),
    [anon_sym_float] = ACTIONS(1452),
    [anon_sym_double] = ACTIONS(1452),
    [anon_sym_half] = ACTIONS(1452),
    [anon_sym_size_t] = ACTIONS(1452),
    [anon_sym_ptrdiff_t] = ACTIONS(1452),
    [anon_sym_intptr_t] = ACTIONS(1452),
    [anon_sym_uintptr_t] = ACTIONS(1452),
    [anon_sym_void] = ACTIONS(1452),
    [sym_vector_type] = ACTIONS(1452),
    [anon_sym_image2d_t] = ACTIONS(1452),
    [anon_sym_image3d_t] = ACTIONS(1452),
    [anon_sym_image2d_array_t] = ACTIONS(1452),
    [anon_sym_image1d_t] = ACTIONS(1452),
    [anon_sym_image1d_buffer_t] = ACTIONS(1452),
    [anon_sym_image1d_array_t] = ACTIONS(1452),
    [anon_sym_image2d_depth_t] = ACTIONS(1452),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1452),
    [anon_sym_sampler_t] = ACTIONS(1452),
    [anon_sym_queue_t] = ACTIONS(1452),
    [anon_sym_ndrange_t] = ACTIONS(1452),
    [anon_sym_clk_event_t] = ACTIONS(1452),
    [anon_sym_reserve_id_t] = ACTIONS(1452),
    [anon_sym_event_t] = ACTIONS(1452),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_struct] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [sym_identifier] = ACTIONS(1488),
    [aux_sym_preproc_def_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1488),
    [sym_preproc_directive] = ACTIONS(1488),
    [anon_sym_kernel] = ACTIONS(1488),
    [anon_sym___kernel] = ACTIONS(1488),
    [anon_sym_global] = ACTIONS(1488),
    [anon_sym___global] = ACTIONS(1488),
    [anon_sym_local] = ACTIONS(1488),
    [anon_sym___local] = ACTIONS(1488),
    [anon_sym_constant] = ACTIONS(1488),
    [anon_sym___constant] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym___private] = ACTIONS(1488),
    [anon_sym_generic] = ACTIONS(1488),
    [anon_sym___generic] = ACTIONS(1488),
    [anon_sym_read_only] = ACTIONS(1488),
    [anon_sym___read_only] = ACTIONS(1488),
    [anon_sym_write_only] = ACTIONS(1488),
    [anon_sym___write_only] = ACTIONS(1488),
    [anon_sym_read_write] = ACTIONS(1488),
    [anon_sym___read_write] = ACTIONS(1488),
    [anon_sym_extern] = ACTIONS(1488),
    [anon_sym___attribute__] = ACTIONS(1488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1490),
    [anon_sym___declspec] = ACTIONS(1488),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_auto] = ACTIONS(1488),
    [anon_sym_register] = ACTIONS(1488),
    [anon_sym_inline] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_volatile] = ACTIONS(1488),
    [anon_sym_restrict] = ACTIONS(1488),
    [anon_sym__Atomic] = ACTIONS(1488),
    [anon_sym_pipe] = ACTIONS(1488),
    [anon_sym_signed] = ACTIONS(1488),
    [anon_sym_unsigned] = ACTIONS(1488),
    [anon_sym_long] = ACTIONS(1488),
    [anon_sym_short] = ACTIONS(1488),
    [anon_sym_bool] = ACTIONS(1488),
    [anon_sym_char] = ACTIONS(1488),
    [anon_sym_uchar] = ACTIONS(1488),
    [anon_sym_ushort] = ACTIONS(1488),
    [anon_sym_int] = ACTIONS(1488),
    [anon_sym_uint] = ACTIONS(1488),
    [anon_sym_ulong] = ACTIONS(1488),
    [anon_sym_float] = ACTIONS(1488),
    [anon_sym_double] = ACTIONS(1488),
    [anon_sym_half] = ACTIONS(1488),
    [anon_sym_size_t] = ACTIONS(1488),
    [anon_sym_ptrdiff_t] = ACTIONS(1488),
    [anon_sym_intptr_t] = ACTIONS(1488),
    [anon_sym_uintptr_t] = ACTIONS(1488),
    [anon_sym_void] = ACTIONS(1488),
    [sym_vector_type] = ACTIONS(1488),
    [anon_sym_image2d_t] = ACTIONS(1488),
    [anon_sym_image3d_t] = ACTIONS(1488),
    [anon_sym_image2d_array_t] = ACTIONS(1488),
    [anon_sym_image1d_t] = ACTIONS(1488),
    [anon_sym_image1d_buffer_t] = ACTIONS(1488),
    [anon_sym_image1d_array_t] = ACTIONS(1488),
    [anon_sym_image2d_depth_t] = ACTIONS(1488),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1488),
    [anon_sym_sampler_t] = ACTIONS(1488),
    [anon_sym_queue_t] = ACTIONS(1488),
    [anon_sym_ndrange_t] = ACTIONS(1488),
    [anon_sym_clk_event_t] = ACTIONS(1488),
    [anon_sym_reserve_id_t] = ACTIONS(1488),
    [anon_sym_event_t] = ACTIONS(1488),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_struct] = ACTIONS(1488),
    [anon_sym_union] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [sym_identifier] = ACTIONS(1484),
    [aux_sym_preproc_def_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1484),
    [sym_preproc_directive] = ACTIONS(1484),
    [anon_sym_kernel] = ACTIONS(1484),
    [anon_sym___kernel] = ACTIONS(1484),
    [anon_sym_global] = ACTIONS(1484),
    [anon_sym___global] = ACTIONS(1484),
    [anon_sym_local] = ACTIONS(1484),
    [anon_sym___local] = ACTIONS(1484),
    [anon_sym_constant] = ACTIONS(1484),
    [anon_sym___constant] = ACTIONS(1484),
    [anon_sym_private] = ACTIONS(1484),
    [anon_sym___private] = ACTIONS(1484),
    [anon_sym_generic] = ACTIONS(1484),
    [anon_sym___generic] = ACTIONS(1484),
    [anon_sym_read_only] = ACTIONS(1484),
    [anon_sym___read_only] = ACTIONS(1484),
    [anon_sym_write_only] = ACTIONS(1484),
    [anon_sym___write_only] = ACTIONS(1484),
    [anon_sym_read_write] = ACTIONS(1484),
    [anon_sym___read_write] = ACTIONS(1484),
    [anon_sym_extern] = ACTIONS(1484),
    [anon_sym___attribute__] = ACTIONS(1484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1486),
    [anon_sym___declspec] = ACTIONS(1484),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_auto] = ACTIONS(1484),
    [anon_sym_register] = ACTIONS(1484),
    [anon_sym_inline] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_volatile] = ACTIONS(1484),
    [anon_sym_restrict] = ACTIONS(1484),
    [anon_sym__Atomic] = ACTIONS(1484),
    [anon_sym_pipe] = ACTIONS(1484),
    [anon_sym_signed] = ACTIONS(1484),
    [anon_sym_unsigned] = ACTIONS(1484),
    [anon_sym_long] = ACTIONS(1484),
    [anon_sym_short] = ACTIONS(1484),
    [anon_sym_bool] = ACTIONS(1484),
    [anon_sym_char] = ACTIONS(1484),
    [anon_sym_uchar] = ACTIONS(1484),
    [anon_sym_ushort] = ACTIONS(1484),
    [anon_sym_int] = ACTIONS(1484),
    [anon_sym_uint] = ACTIONS(1484),
    [anon_sym_ulong] = ACTIONS(1484),
    [anon_sym_float] = ACTIONS(1484),
    [anon_sym_double] = ACTIONS(1484),
    [anon_sym_half] = ACTIONS(1484),
    [anon_sym_size_t] = ACTIONS(1484),
    [anon_sym_ptrdiff_t] = ACTIONS(1484),
    [anon_sym_intptr_t] = ACTIONS(1484),
    [anon_sym_uintptr_t] = ACTIONS(1484),
    [anon_sym_void] = ACTIONS(1484),
    [sym_vector_type] = ACTIONS(1484),
    [anon_sym_image2d_t] = ACTIONS(1484),
    [anon_sym_image3d_t] = ACTIONS(1484),
    [anon_sym_image2d_array_t] = ACTIONS(1484),
    [anon_sym_image1d_t] = ACTIONS(1484),
    [anon_sym_image1d_buffer_t] = ACTIONS(1484),
    [anon_sym_image1d_array_t] = ACTIONS(1484),
    [anon_sym_image2d_depth_t] = ACTIONS(1484),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1484),
    [anon_sym_sampler_t] = ACTIONS(1484),
    [anon_sym_queue_t] = ACTIONS(1484),
    [anon_sym_ndrange_t] = ACTIONS(1484),
    [anon_sym_clk_event_t] = ACTIONS(1484),
    [anon_sym_reserve_id_t] = ACTIONS(1484),
    [anon_sym_event_t] = ACTIONS(1484),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [anon_sym_struct] = ACTIONS(1484),
    [anon_sym_union] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym_string_literal] = STATE(325),
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_kernel] = ACTIONS(1396),
    [anon_sym___kernel] = ACTIONS(1396),
    [anon_sym_global] = ACTIONS(1396),
    [anon_sym___global] = ACTIONS(1396),
    [anon_sym_local] = ACTIONS(1396),
    [anon_sym___local] = ACTIONS(1396),
    [anon_sym_constant] = ACTIONS(1396),
    [anon_sym___constant] = ACTIONS(1396),
    [anon_sym_private] = ACTIONS(1396),
    [anon_sym___private] = ACTIONS(1396),
    [anon_sym_generic] = ACTIONS(1396),
    [anon_sym___generic] = ACTIONS(1396),
    [anon_sym_read_only] = ACTIONS(1396),
    [anon_sym___read_only] = ACTIONS(1396),
    [anon_sym_write_only] = ACTIONS(1396),
    [anon_sym___write_only] = ACTIONS(1396),
    [anon_sym_read_write] = ACTIONS(1396),
    [anon_sym___read_write] = ACTIONS(1396),
    [anon_sym_extern] = ACTIONS(1396),
    [anon_sym___attribute__] = ACTIONS(1396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1398),
    [anon_sym___declspec] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1396),
    [anon_sym_auto] = ACTIONS(1396),
    [anon_sym_register] = ACTIONS(1396),
    [anon_sym_inline] = ACTIONS(1396),
    [anon_sym_const] = ACTIONS(1396),
    [anon_sym_volatile] = ACTIONS(1396),
    [anon_sym_restrict] = ACTIONS(1396),
    [anon_sym__Atomic] = ACTIONS(1396),
    [anon_sym_pipe] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1396),
    [anon_sym_unsigned] = ACTIONS(1396),
    [anon_sym_long] = ACTIONS(1396),
    [anon_sym_short] = ACTIONS(1396),
    [anon_sym_bool] = ACTIONS(1396),
    [anon_sym_char] = ACTIONS(1396),
    [anon_sym_uchar] = ACTIONS(1396),
    [anon_sym_ushort] = ACTIONS(1396),
    [anon_sym_int] = ACTIONS(1396),
    [anon_sym_uint] = ACTIONS(1396),
    [anon_sym_ulong] = ACTIONS(1396),
    [anon_sym_float] = ACTIONS(1396),
    [anon_sym_double] = ACTIONS(1396),
    [anon_sym_half] = ACTIONS(1396),
    [anon_sym_size_t] = ACTIONS(1396),
    [anon_sym_ptrdiff_t] = ACTIONS(1396),
    [anon_sym_intptr_t] = ACTIONS(1396),
    [anon_sym_uintptr_t] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1396),
    [sym_vector_type] = ACTIONS(1396),
    [anon_sym_image2d_t] = ACTIONS(1396),
    [anon_sym_image3d_t] = ACTIONS(1396),
    [anon_sym_image2d_array_t] = ACTIONS(1396),
    [anon_sym_image1d_t] = ACTIONS(1396),
    [anon_sym_image1d_buffer_t] = ACTIONS(1396),
    [anon_sym_image1d_array_t] = ACTIONS(1396),
    [anon_sym_image2d_depth_t] = ACTIONS(1396),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1396),
    [anon_sym_sampler_t] = ACTIONS(1396),
    [anon_sym_queue_t] = ACTIONS(1396),
    [anon_sym_ndrange_t] = ACTIONS(1396),
    [anon_sym_clk_event_t] = ACTIONS(1396),
    [anon_sym_reserve_id_t] = ACTIONS(1396),
    [anon_sym_event_t] = ACTIONS(1396),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1396),
    [anon_sym_enum] = ACTIONS(1396),
    [anon_sym_struct] = ACTIONS(1396),
    [anon_sym_union] = ACTIONS(1396),
    [anon_sym_L_DQUOTE] = ACTIONS(1500),
    [anon_sym_u_DQUOTE] = ACTIONS(1500),
    [anon_sym_U_DQUOTE] = ACTIONS(1500),
    [anon_sym_u8_DQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [sym_identifier] = ACTIONS(1480),
    [aux_sym_preproc_def_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1480),
    [sym_preproc_directive] = ACTIONS(1480),
    [anon_sym_kernel] = ACTIONS(1480),
    [anon_sym___kernel] = ACTIONS(1480),
    [anon_sym_global] = ACTIONS(1480),
    [anon_sym___global] = ACTIONS(1480),
    [anon_sym_local] = ACTIONS(1480),
    [anon_sym___local] = ACTIONS(1480),
    [anon_sym_constant] = ACTIONS(1480),
    [anon_sym___constant] = ACTIONS(1480),
    [anon_sym_private] = ACTIONS(1480),
    [anon_sym___private] = ACTIONS(1480),
    [anon_sym_generic] = ACTIONS(1480),
    [anon_sym___generic] = ACTIONS(1480),
    [anon_sym_read_only] = ACTIONS(1480),
    [anon_sym___read_only] = ACTIONS(1480),
    [anon_sym_write_only] = ACTIONS(1480),
    [anon_sym___write_only] = ACTIONS(1480),
    [anon_sym_read_write] = ACTIONS(1480),
    [anon_sym___read_write] = ACTIONS(1480),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym___attribute__] = ACTIONS(1480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1480),
    [anon_sym_RBRACE] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_auto] = ACTIONS(1480),
    [anon_sym_register] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym_const] = ACTIONS(1480),
    [anon_sym_volatile] = ACTIONS(1480),
    [anon_sym_restrict] = ACTIONS(1480),
    [anon_sym__Atomic] = ACTIONS(1480),
    [anon_sym_pipe] = ACTIONS(1480),
    [anon_sym_signed] = ACTIONS(1480),
    [anon_sym_unsigned] = ACTIONS(1480),
    [anon_sym_long] = ACTIONS(1480),
    [anon_sym_short] = ACTIONS(1480),
    [anon_sym_bool] = ACTIONS(1480),
    [anon_sym_char] = ACTIONS(1480),
    [anon_sym_uchar] = ACTIONS(1480),
    [anon_sym_ushort] = ACTIONS(1480),
    [anon_sym_int] = ACTIONS(1480),
    [anon_sym_uint] = ACTIONS(1480),
    [anon_sym_ulong] = ACTIONS(1480),
    [anon_sym_float] = ACTIONS(1480),
    [anon_sym_double] = ACTIONS(1480),
    [anon_sym_half] = ACTIONS(1480),
    [anon_sym_size_t] = ACTIONS(1480),
    [anon_sym_ptrdiff_t] = ACTIONS(1480),
    [anon_sym_intptr_t] = ACTIONS(1480),
    [anon_sym_uintptr_t] = ACTIONS(1480),
    [anon_sym_void] = ACTIONS(1480),
    [sym_vector_type] = ACTIONS(1480),
    [anon_sym_image2d_t] = ACTIONS(1480),
    [anon_sym_image3d_t] = ACTIONS(1480),
    [anon_sym_image2d_array_t] = ACTIONS(1480),
    [anon_sym_image1d_t] = ACTIONS(1480),
    [anon_sym_image1d_buffer_t] = ACTIONS(1480),
    [anon_sym_image1d_array_t] = ACTIONS(1480),
    [anon_sym_image2d_depth_t] = ACTIONS(1480),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1480),
    [anon_sym_sampler_t] = ACTIONS(1480),
    [anon_sym_queue_t] = ACTIONS(1480),
    [anon_sym_ndrange_t] = ACTIONS(1480),
    [anon_sym_clk_event_t] = ACTIONS(1480),
    [anon_sym_reserve_id_t] = ACTIONS(1480),
    [anon_sym_event_t] = ACTIONS(1480),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_struct] = ACTIONS(1480),
    [anon_sym_union] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
  },
  [380] = {
    [sym_identifier] = ACTIONS(1476),
    [aux_sym_preproc_def_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1476),
    [sym_preproc_directive] = ACTIONS(1476),
    [anon_sym_kernel] = ACTIONS(1476),
    [anon_sym___kernel] = ACTIONS(1476),
    [anon_sym_global] = ACTIONS(1476),
    [anon_sym___global] = ACTIONS(1476),
    [anon_sym_local] = ACTIONS(1476),
    [anon_sym___local] = ACTIONS(1476),
    [anon_sym_constant] = ACTIONS(1476),
    [anon_sym___constant] = ACTIONS(1476),
    [anon_sym_private] = ACTIONS(1476),
    [anon_sym___private] = ACTIONS(1476),
    [anon_sym_generic] = ACTIONS(1476),
    [anon_sym___generic] = ACTIONS(1476),
    [anon_sym_read_only] = ACTIONS(1476),
    [anon_sym___read_only] = ACTIONS(1476),
    [anon_sym_write_only] = ACTIONS(1476),
    [anon_sym___write_only] = ACTIONS(1476),
    [anon_sym_read_write] = ACTIONS(1476),
    [anon_sym___read_write] = ACTIONS(1476),
    [anon_sym_extern] = ACTIONS(1476),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1478),
    [anon_sym___declspec] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1478),
    [anon_sym_static] = ACTIONS(1476),
    [anon_sym_auto] = ACTIONS(1476),
    [anon_sym_register] = ACTIONS(1476),
    [anon_sym_inline] = ACTIONS(1476),
    [anon_sym_const] = ACTIONS(1476),
    [anon_sym_volatile] = ACTIONS(1476),
    [anon_sym_restrict] = ACTIONS(1476),
    [anon_sym__Atomic] = ACTIONS(1476),
    [anon_sym_pipe] = ACTIONS(1476),
    [anon_sym_signed] = ACTIONS(1476),
    [anon_sym_unsigned] = ACTIONS(1476),
    [anon_sym_long] = ACTIONS(1476),
    [anon_sym_short] = ACTIONS(1476),
    [anon_sym_bool] = ACTIONS(1476),
    [anon_sym_char] = ACTIONS(1476),
    [anon_sym_uchar] = ACTIONS(1476),
    [anon_sym_ushort] = ACTIONS(1476),
    [anon_sym_int] = ACTIONS(1476),
    [anon_sym_uint] = ACTIONS(1476),
    [anon_sym_ulong] = ACTIONS(1476),
    [anon_sym_float] = ACTIONS(1476),
    [anon_sym_double] = ACTIONS(1476),
    [anon_sym_half] = ACTIONS(1476),
    [anon_sym_size_t] = ACTIONS(1476),
    [anon_sym_ptrdiff_t] = ACTIONS(1476),
    [anon_sym_intptr_t] = ACTIONS(1476),
    [anon_sym_uintptr_t] = ACTIONS(1476),
    [anon_sym_void] = ACTIONS(1476),
    [sym_vector_type] = ACTIONS(1476),
    [anon_sym_image2d_t] = ACTIONS(1476),
    [anon_sym_image3d_t] = ACTIONS(1476),
    [anon_sym_image2d_array_t] = ACTIONS(1476),
    [anon_sym_image1d_t] = ACTIONS(1476),
    [anon_sym_image1d_buffer_t] = ACTIONS(1476),
    [anon_sym_image1d_array_t] = ACTIONS(1476),
    [anon_sym_image2d_depth_t] = ACTIONS(1476),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1476),
    [anon_sym_sampler_t] = ACTIONS(1476),
    [anon_sym_queue_t] = ACTIONS(1476),
    [anon_sym_ndrange_t] = ACTIONS(1476),
    [anon_sym_clk_event_t] = ACTIONS(1476),
    [anon_sym_reserve_id_t] = ACTIONS(1476),
    [anon_sym_event_t] = ACTIONS(1476),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1476),
    [anon_sym_enum] = ACTIONS(1476),
    [anon_sym_struct] = ACTIONS(1476),
    [anon_sym_union] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
  },
  [381] = {
    [sym_string_literal] = STATE(326),
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_kernel] = ACTIONS(1396),
    [anon_sym___kernel] = ACTIONS(1396),
    [anon_sym_global] = ACTIONS(1396),
    [anon_sym___global] = ACTIONS(1396),
    [anon_sym_local] = ACTIONS(1396),
    [anon_sym___local] = ACTIONS(1396),
    [anon_sym_constant] = ACTIONS(1396),
    [anon_sym___constant] = ACTIONS(1396),
    [anon_sym_private] = ACTIONS(1396),
    [anon_sym___private] = ACTIONS(1396),
    [anon_sym_generic] = ACTIONS(1396),
    [anon_sym___generic] = ACTIONS(1396),
    [anon_sym_read_only] = ACTIONS(1396),
    [anon_sym___read_only] = ACTIONS(1396),
    [anon_sym_write_only] = ACTIONS(1396),
    [anon_sym___write_only] = ACTIONS(1396),
    [anon_sym_read_write] = ACTIONS(1396),
    [anon_sym___read_write] = ACTIONS(1396),
    [anon_sym_extern] = ACTIONS(1396),
    [anon_sym___attribute__] = ACTIONS(1396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1398),
    [anon_sym___declspec] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1396),
    [anon_sym_auto] = ACTIONS(1396),
    [anon_sym_register] = ACTIONS(1396),
    [anon_sym_inline] = ACTIONS(1396),
    [anon_sym_const] = ACTIONS(1396),
    [anon_sym_volatile] = ACTIONS(1396),
    [anon_sym_restrict] = ACTIONS(1396),
    [anon_sym__Atomic] = ACTIONS(1396),
    [anon_sym_pipe] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1396),
    [anon_sym_unsigned] = ACTIONS(1396),
    [anon_sym_long] = ACTIONS(1396),
    [anon_sym_short] = ACTIONS(1396),
    [anon_sym_bool] = ACTIONS(1396),
    [anon_sym_char] = ACTIONS(1396),
    [anon_sym_uchar] = ACTIONS(1396),
    [anon_sym_ushort] = ACTIONS(1396),
    [anon_sym_int] = ACTIONS(1396),
    [anon_sym_uint] = ACTIONS(1396),
    [anon_sym_ulong] = ACTIONS(1396),
    [anon_sym_float] = ACTIONS(1396),
    [anon_sym_double] = ACTIONS(1396),
    [anon_sym_half] = ACTIONS(1396),
    [anon_sym_size_t] = ACTIONS(1396),
    [anon_sym_ptrdiff_t] = ACTIONS(1396),
    [anon_sym_intptr_t] = ACTIONS(1396),
    [anon_sym_uintptr_t] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1396),
    [sym_vector_type] = ACTIONS(1396),
    [anon_sym_image2d_t] = ACTIONS(1396),
    [anon_sym_image3d_t] = ACTIONS(1396),
    [anon_sym_image2d_array_t] = ACTIONS(1396),
    [anon_sym_image1d_t] = ACTIONS(1396),
    [anon_sym_image1d_buffer_t] = ACTIONS(1396),
    [anon_sym_image1d_array_t] = ACTIONS(1396),
    [anon_sym_image2d_depth_t] = ACTIONS(1396),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1396),
    [anon_sym_sampler_t] = ACTIONS(1396),
    [anon_sym_queue_t] = ACTIONS(1396),
    [anon_sym_ndrange_t] = ACTIONS(1396),
    [anon_sym_clk_event_t] = ACTIONS(1396),
    [anon_sym_reserve_id_t] = ACTIONS(1396),
    [anon_sym_event_t] = ACTIONS(1396),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1396),
    [anon_sym_enum] = ACTIONS(1396),
    [anon_sym_struct] = ACTIONS(1396),
    [anon_sym_union] = ACTIONS(1396),
    [anon_sym_L_DQUOTE] = ACTIONS(1500),
    [anon_sym_u_DQUOTE] = ACTIONS(1500),
    [anon_sym_U_DQUOTE] = ACTIONS(1500),
    [anon_sym_u8_DQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
  },
  [382] = {
    [sym_identifier] = ACTIONS(1464),
    [aux_sym_preproc_def_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1464),
    [sym_preproc_directive] = ACTIONS(1464),
    [anon_sym_kernel] = ACTIONS(1464),
    [anon_sym___kernel] = ACTIONS(1464),
    [anon_sym_global] = ACTIONS(1464),
    [anon_sym___global] = ACTIONS(1464),
    [anon_sym_local] = ACTIONS(1464),
    [anon_sym___local] = ACTIONS(1464),
    [anon_sym_constant] = ACTIONS(1464),
    [anon_sym___constant] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym___private] = ACTIONS(1464),
    [anon_sym_generic] = ACTIONS(1464),
    [anon_sym___generic] = ACTIONS(1464),
    [anon_sym_read_only] = ACTIONS(1464),
    [anon_sym___read_only] = ACTIONS(1464),
    [anon_sym_write_only] = ACTIONS(1464),
    [anon_sym___write_only] = ACTIONS(1464),
    [anon_sym_read_write] = ACTIONS(1464),
    [anon_sym___read_write] = ACTIONS(1464),
    [anon_sym_extern] = ACTIONS(1464),
    [anon_sym___attribute__] = ACTIONS(1464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1466),
    [anon_sym___declspec] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_auto] = ACTIONS(1464),
    [anon_sym_register] = ACTIONS(1464),
    [anon_sym_inline] = ACTIONS(1464),
    [anon_sym_const] = ACTIONS(1464),
    [anon_sym_volatile] = ACTIONS(1464),
    [anon_sym_restrict] = ACTIONS(1464),
    [anon_sym__Atomic] = ACTIONS(1464),
    [anon_sym_pipe] = ACTIONS(1464),
    [anon_sym_signed] = ACTIONS(1464),
    [anon_sym_unsigned] = ACTIONS(1464),
    [anon_sym_long] = ACTIONS(1464),
    [anon_sym_short] = ACTIONS(1464),
    [anon_sym_bool] = ACTIONS(1464),
    [anon_sym_char] = ACTIONS(1464),
    [anon_sym_uchar] = ACTIONS(1464),
    [anon_sym_ushort] = ACTIONS(1464),
    [anon_sym_int] = ACTIONS(1464),
    [anon_sym_uint] = ACTIONS(1464),
    [anon_sym_ulong] = ACTIONS(1464),
    [anon_sym_float] = ACTIONS(1464),
    [anon_sym_double] = ACTIONS(1464),
    [anon_sym_half] = ACTIONS(1464),
    [anon_sym_size_t] = ACTIONS(1464),
    [anon_sym_ptrdiff_t] = ACTIONS(1464),
    [anon_sym_intptr_t] = ACTIONS(1464),
    [anon_sym_uintptr_t] = ACTIONS(1464),
    [anon_sym_void] = ACTIONS(1464),
    [sym_vector_type] = ACTIONS(1464),
    [anon_sym_image2d_t] = ACTIONS(1464),
    [anon_sym_image3d_t] = ACTIONS(1464),
    [anon_sym_image2d_array_t] = ACTIONS(1464),
    [anon_sym_image1d_t] = ACTIONS(1464),
    [anon_sym_image1d_buffer_t] = ACTIONS(1464),
    [anon_sym_image1d_array_t] = ACTIONS(1464),
    [anon_sym_image2d_depth_t] = ACTIONS(1464),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1464),
    [anon_sym_sampler_t] = ACTIONS(1464),
    [anon_sym_queue_t] = ACTIONS(1464),
    [anon_sym_ndrange_t] = ACTIONS(1464),
    [anon_sym_clk_event_t] = ACTIONS(1464),
    [anon_sym_reserve_id_t] = ACTIONS(1464),
    [anon_sym_event_t] = ACTIONS(1464),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1464),
    [anon_sym_enum] = ACTIONS(1464),
    [anon_sym_struct] = ACTIONS(1464),
    [anon_sym_union] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_kernel] = ACTIONS(1088),
    [anon_sym___kernel] = ACTIONS(1088),
    [anon_sym_global] = ACTIONS(1088),
    [anon_sym___global] = ACTIONS(1088),
    [anon_sym_local] = ACTIONS(1088),
    [anon_sym___local] = ACTIONS(1088),
    [anon_sym_constant] = ACTIONS(1088),
    [anon_sym___constant] = ACTIONS(1088),
    [anon_sym_private] = ACTIONS(1088),
    [anon_sym___private] = ACTIONS(1088),
    [anon_sym_generic] = ACTIONS(1088),
    [anon_sym___generic] = ACTIONS(1088),
    [anon_sym_read_only] = ACTIONS(1088),
    [anon_sym___read_only] = ACTIONS(1088),
    [anon_sym_write_only] = ACTIONS(1088),
    [anon_sym___write_only] = ACTIONS(1088),
    [anon_sym_read_write] = ACTIONS(1088),
    [anon_sym___read_write] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1090),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_pipe] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [anon_sym_bool] = ACTIONS(1088),
    [anon_sym_char] = ACTIONS(1088),
    [anon_sym_uchar] = ACTIONS(1088),
    [anon_sym_ushort] = ACTIONS(1088),
    [anon_sym_int] = ACTIONS(1088),
    [anon_sym_uint] = ACTIONS(1088),
    [anon_sym_ulong] = ACTIONS(1088),
    [anon_sym_float] = ACTIONS(1088),
    [anon_sym_double] = ACTIONS(1088),
    [anon_sym_half] = ACTIONS(1088),
    [anon_sym_size_t] = ACTIONS(1088),
    [anon_sym_ptrdiff_t] = ACTIONS(1088),
    [anon_sym_intptr_t] = ACTIONS(1088),
    [anon_sym_uintptr_t] = ACTIONS(1088),
    [anon_sym_void] = ACTIONS(1088),
    [sym_vector_type] = ACTIONS(1088),
    [anon_sym_image2d_t] = ACTIONS(1088),
    [anon_sym_image3d_t] = ACTIONS(1088),
    [anon_sym_image2d_array_t] = ACTIONS(1088),
    [anon_sym_image1d_t] = ACTIONS(1088),
    [anon_sym_image1d_buffer_t] = ACTIONS(1088),
    [anon_sym_image1d_array_t] = ACTIONS(1088),
    [anon_sym_image2d_depth_t] = ACTIONS(1088),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1088),
    [anon_sym_sampler_t] = ACTIONS(1088),
    [anon_sym_queue_t] = ACTIONS(1088),
    [anon_sym_ndrange_t] = ACTIONS(1088),
    [anon_sym_clk_event_t] = ACTIONS(1088),
    [anon_sym_reserve_id_t] = ACTIONS(1088),
    [anon_sym_event_t] = ACTIONS(1088),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [384] = {
    [sym_string_literal] = STATE(323),
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_kernel] = ACTIONS(1396),
    [anon_sym___kernel] = ACTIONS(1396),
    [anon_sym_global] = ACTIONS(1396),
    [anon_sym___global] = ACTIONS(1396),
    [anon_sym_local] = ACTIONS(1396),
    [anon_sym___local] = ACTIONS(1396),
    [anon_sym_constant] = ACTIONS(1396),
    [anon_sym___constant] = ACTIONS(1396),
    [anon_sym_private] = ACTIONS(1396),
    [anon_sym___private] = ACTIONS(1396),
    [anon_sym_generic] = ACTIONS(1396),
    [anon_sym___generic] = ACTIONS(1396),
    [anon_sym_read_only] = ACTIONS(1396),
    [anon_sym___read_only] = ACTIONS(1396),
    [anon_sym_write_only] = ACTIONS(1396),
    [anon_sym___write_only] = ACTIONS(1396),
    [anon_sym_read_write] = ACTIONS(1396),
    [anon_sym___read_write] = ACTIONS(1396),
    [anon_sym_extern] = ACTIONS(1396),
    [anon_sym___attribute__] = ACTIONS(1396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1398),
    [anon_sym___declspec] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1396),
    [anon_sym_auto] = ACTIONS(1396),
    [anon_sym_register] = ACTIONS(1396),
    [anon_sym_inline] = ACTIONS(1396),
    [anon_sym_const] = ACTIONS(1396),
    [anon_sym_volatile] = ACTIONS(1396),
    [anon_sym_restrict] = ACTIONS(1396),
    [anon_sym__Atomic] = ACTIONS(1396),
    [anon_sym_pipe] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1396),
    [anon_sym_unsigned] = ACTIONS(1396),
    [anon_sym_long] = ACTIONS(1396),
    [anon_sym_short] = ACTIONS(1396),
    [anon_sym_bool] = ACTIONS(1396),
    [anon_sym_char] = ACTIONS(1396),
    [anon_sym_uchar] = ACTIONS(1396),
    [anon_sym_ushort] = ACTIONS(1396),
    [anon_sym_int] = ACTIONS(1396),
    [anon_sym_uint] = ACTIONS(1396),
    [anon_sym_ulong] = ACTIONS(1396),
    [anon_sym_float] = ACTIONS(1396),
    [anon_sym_double] = ACTIONS(1396),
    [anon_sym_half] = ACTIONS(1396),
    [anon_sym_size_t] = ACTIONS(1396),
    [anon_sym_ptrdiff_t] = ACTIONS(1396),
    [anon_sym_intptr_t] = ACTIONS(1396),
    [anon_sym_uintptr_t] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1396),
    [sym_vector_type] = ACTIONS(1396),
    [anon_sym_image2d_t] = ACTIONS(1396),
    [anon_sym_image3d_t] = ACTIONS(1396),
    [anon_sym_image2d_array_t] = ACTIONS(1396),
    [anon_sym_image1d_t] = ACTIONS(1396),
    [anon_sym_image1d_buffer_t] = ACTIONS(1396),
    [anon_sym_image1d_array_t] = ACTIONS(1396),
    [anon_sym_image2d_depth_t] = ACTIONS(1396),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1396),
    [anon_sym_sampler_t] = ACTIONS(1396),
    [anon_sym_queue_t] = ACTIONS(1396),
    [anon_sym_ndrange_t] = ACTIONS(1396),
    [anon_sym_clk_event_t] = ACTIONS(1396),
    [anon_sym_reserve_id_t] = ACTIONS(1396),
    [anon_sym_event_t] = ACTIONS(1396),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1396),
    [anon_sym_enum] = ACTIONS(1396),
    [anon_sym_struct] = ACTIONS(1396),
    [anon_sym_union] = ACTIONS(1396),
    [anon_sym_L_DQUOTE] = ACTIONS(1500),
    [anon_sym_u_DQUOTE] = ACTIONS(1500),
    [anon_sym_U_DQUOTE] = ACTIONS(1500),
    [anon_sym_u8_DQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
  },
  [385] = {
    [sym_identifier] = ACTIONS(1456),
    [aux_sym_preproc_def_token1] = ACTIONS(1456),
    [aux_sym_preproc_if_token1] = ACTIONS(1456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1456),
    [sym_preproc_directive] = ACTIONS(1456),
    [anon_sym_kernel] = ACTIONS(1456),
    [anon_sym___kernel] = ACTIONS(1456),
    [anon_sym_global] = ACTIONS(1456),
    [anon_sym___global] = ACTIONS(1456),
    [anon_sym_local] = ACTIONS(1456),
    [anon_sym___local] = ACTIONS(1456),
    [anon_sym_constant] = ACTIONS(1456),
    [anon_sym___constant] = ACTIONS(1456),
    [anon_sym_private] = ACTIONS(1456),
    [anon_sym___private] = ACTIONS(1456),
    [anon_sym_generic] = ACTIONS(1456),
    [anon_sym___generic] = ACTIONS(1456),
    [anon_sym_read_only] = ACTIONS(1456),
    [anon_sym___read_only] = ACTIONS(1456),
    [anon_sym_write_only] = ACTIONS(1456),
    [anon_sym___write_only] = ACTIONS(1456),
    [anon_sym_read_write] = ACTIONS(1456),
    [anon_sym___read_write] = ACTIONS(1456),
    [anon_sym_extern] = ACTIONS(1456),
    [anon_sym___attribute__] = ACTIONS(1456),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1458),
    [anon_sym___declspec] = ACTIONS(1456),
    [anon_sym_RBRACE] = ACTIONS(1458),
    [anon_sym_static] = ACTIONS(1456),
    [anon_sym_auto] = ACTIONS(1456),
    [anon_sym_register] = ACTIONS(1456),
    [anon_sym_inline] = ACTIONS(1456),
    [anon_sym_const] = ACTIONS(1456),
    [anon_sym_volatile] = ACTIONS(1456),
    [anon_sym_restrict] = ACTIONS(1456),
    [anon_sym__Atomic] = ACTIONS(1456),
    [anon_sym_pipe] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1456),
    [anon_sym_unsigned] = ACTIONS(1456),
    [anon_sym_long] = ACTIONS(1456),
    [anon_sym_short] = ACTIONS(1456),
    [anon_sym_bool] = ACTIONS(1456),
    [anon_sym_char] = ACTIONS(1456),
    [anon_sym_uchar] = ACTIONS(1456),
    [anon_sym_ushort] = ACTIONS(1456),
    [anon_sym_int] = ACTIONS(1456),
    [anon_sym_uint] = ACTIONS(1456),
    [anon_sym_ulong] = ACTIONS(1456),
    [anon_sym_float] = ACTIONS(1456),
    [anon_sym_double] = ACTIONS(1456),
    [anon_sym_half] = ACTIONS(1456),
    [anon_sym_size_t] = ACTIONS(1456),
    [anon_sym_ptrdiff_t] = ACTIONS(1456),
    [anon_sym_intptr_t] = ACTIONS(1456),
    [anon_sym_uintptr_t] = ACTIONS(1456),
    [anon_sym_void] = ACTIONS(1456),
    [sym_vector_type] = ACTIONS(1456),
    [anon_sym_image2d_t] = ACTIONS(1456),
    [anon_sym_image3d_t] = ACTIONS(1456),
    [anon_sym_image2d_array_t] = ACTIONS(1456),
    [anon_sym_image1d_t] = ACTIONS(1456),
    [anon_sym_image1d_buffer_t] = ACTIONS(1456),
    [anon_sym_image1d_array_t] = ACTIONS(1456),
    [anon_sym_image2d_depth_t] = ACTIONS(1456),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1456),
    [anon_sym_sampler_t] = ACTIONS(1456),
    [anon_sym_queue_t] = ACTIONS(1456),
    [anon_sym_ndrange_t] = ACTIONS(1456),
    [anon_sym_clk_event_t] = ACTIONS(1456),
    [anon_sym_reserve_id_t] = ACTIONS(1456),
    [anon_sym_event_t] = ACTIONS(1456),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1456),
    [anon_sym_enum] = ACTIONS(1456),
    [anon_sym_struct] = ACTIONS(1456),
    [anon_sym_union] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
  },
  [386] = {
    [sym_identifier] = ACTIONS(1436),
    [aux_sym_preproc_def_token1] = ACTIONS(1436),
    [aux_sym_preproc_if_token1] = ACTIONS(1436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1436),
    [sym_preproc_directive] = ACTIONS(1436),
    [anon_sym_kernel] = ACTIONS(1436),
    [anon_sym___kernel] = ACTIONS(1436),
    [anon_sym_global] = ACTIONS(1436),
    [anon_sym___global] = ACTIONS(1436),
    [anon_sym_local] = ACTIONS(1436),
    [anon_sym___local] = ACTIONS(1436),
    [anon_sym_constant] = ACTIONS(1436),
    [anon_sym___constant] = ACTIONS(1436),
    [anon_sym_private] = ACTIONS(1436),
    [anon_sym___private] = ACTIONS(1436),
    [anon_sym_generic] = ACTIONS(1436),
    [anon_sym___generic] = ACTIONS(1436),
    [anon_sym_read_only] = ACTIONS(1436),
    [anon_sym___read_only] = ACTIONS(1436),
    [anon_sym_write_only] = ACTIONS(1436),
    [anon_sym___write_only] = ACTIONS(1436),
    [anon_sym_read_write] = ACTIONS(1436),
    [anon_sym___read_write] = ACTIONS(1436),
    [anon_sym_extern] = ACTIONS(1436),
    [anon_sym___attribute__] = ACTIONS(1436),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1438),
    [anon_sym___declspec] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [anon_sym_static] = ACTIONS(1436),
    [anon_sym_auto] = ACTIONS(1436),
    [anon_sym_register] = ACTIONS(1436),
    [anon_sym_inline] = ACTIONS(1436),
    [anon_sym_const] = ACTIONS(1436),
    [anon_sym_volatile] = ACTIONS(1436),
    [anon_sym_restrict] = ACTIONS(1436),
    [anon_sym__Atomic] = ACTIONS(1436),
    [anon_sym_pipe] = ACTIONS(1436),
    [anon_sym_signed] = ACTIONS(1436),
    [anon_sym_unsigned] = ACTIONS(1436),
    [anon_sym_long] = ACTIONS(1436),
    [anon_sym_short] = ACTIONS(1436),
    [anon_sym_bool] = ACTIONS(1436),
    [anon_sym_char] = ACTIONS(1436),
    [anon_sym_uchar] = ACTIONS(1436),
    [anon_sym_ushort] = ACTIONS(1436),
    [anon_sym_int] = ACTIONS(1436),
    [anon_sym_uint] = ACTIONS(1436),
    [anon_sym_ulong] = ACTIONS(1436),
    [anon_sym_float] = ACTIONS(1436),
    [anon_sym_double] = ACTIONS(1436),
    [anon_sym_half] = ACTIONS(1436),
    [anon_sym_size_t] = ACTIONS(1436),
    [anon_sym_ptrdiff_t] = ACTIONS(1436),
    [anon_sym_intptr_t] = ACTIONS(1436),
    [anon_sym_uintptr_t] = ACTIONS(1436),
    [anon_sym_void] = ACTIONS(1436),
    [sym_vector_type] = ACTIONS(1436),
    [anon_sym_image2d_t] = ACTIONS(1436),
    [anon_sym_image3d_t] = ACTIONS(1436),
    [anon_sym_image2d_array_t] = ACTIONS(1436),
    [anon_sym_image1d_t] = ACTIONS(1436),
    [anon_sym_image1d_buffer_t] = ACTIONS(1436),
    [anon_sym_image1d_array_t] = ACTIONS(1436),
    [anon_sym_image2d_depth_t] = ACTIONS(1436),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1436),
    [anon_sym_sampler_t] = ACTIONS(1436),
    [anon_sym_queue_t] = ACTIONS(1436),
    [anon_sym_ndrange_t] = ACTIONS(1436),
    [anon_sym_clk_event_t] = ACTIONS(1436),
    [anon_sym_reserve_id_t] = ACTIONS(1436),
    [anon_sym_event_t] = ACTIONS(1436),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1436),
    [anon_sym_enum] = ACTIONS(1436),
    [anon_sym_struct] = ACTIONS(1436),
    [anon_sym_union] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
  },
  [387] = {
    [sym_identifier] = ACTIONS(1452),
    [aux_sym_preproc_def_token1] = ACTIONS(1452),
    [aux_sym_preproc_if_token1] = ACTIONS(1452),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1452),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1452),
    [sym_preproc_directive] = ACTIONS(1452),
    [anon_sym_kernel] = ACTIONS(1452),
    [anon_sym___kernel] = ACTIONS(1452),
    [anon_sym_global] = ACTIONS(1452),
    [anon_sym___global] = ACTIONS(1452),
    [anon_sym_local] = ACTIONS(1452),
    [anon_sym___local] = ACTIONS(1452),
    [anon_sym_constant] = ACTIONS(1452),
    [anon_sym___constant] = ACTIONS(1452),
    [anon_sym_private] = ACTIONS(1452),
    [anon_sym___private] = ACTIONS(1452),
    [anon_sym_generic] = ACTIONS(1452),
    [anon_sym___generic] = ACTIONS(1452),
    [anon_sym_read_only] = ACTIONS(1452),
    [anon_sym___read_only] = ACTIONS(1452),
    [anon_sym_write_only] = ACTIONS(1452),
    [anon_sym___write_only] = ACTIONS(1452),
    [anon_sym_read_write] = ACTIONS(1452),
    [anon_sym___read_write] = ACTIONS(1452),
    [anon_sym_extern] = ACTIONS(1452),
    [anon_sym___attribute__] = ACTIONS(1452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1454),
    [anon_sym___declspec] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_auto] = ACTIONS(1452),
    [anon_sym_register] = ACTIONS(1452),
    [anon_sym_inline] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_volatile] = ACTIONS(1452),
    [anon_sym_restrict] = ACTIONS(1452),
    [anon_sym__Atomic] = ACTIONS(1452),
    [anon_sym_pipe] = ACTIONS(1452),
    [anon_sym_signed] = ACTIONS(1452),
    [anon_sym_unsigned] = ACTIONS(1452),
    [anon_sym_long] = ACTIONS(1452),
    [anon_sym_short] = ACTIONS(1452),
    [anon_sym_bool] = ACTIONS(1452),
    [anon_sym_char] = ACTIONS(1452),
    [anon_sym_uchar] = ACTIONS(1452),
    [anon_sym_ushort] = ACTIONS(1452),
    [anon_sym_int] = ACTIONS(1452),
    [anon_sym_uint] = ACTIONS(1452),
    [anon_sym_ulong] = ACTIONS(1452),
    [anon_sym_float] = ACTIONS(1452),
    [anon_sym_double] = ACTIONS(1452),
    [anon_sym_half] = ACTIONS(1452),
    [anon_sym_size_t] = ACTIONS(1452),
    [anon_sym_ptrdiff_t] = ACTIONS(1452),
    [anon_sym_intptr_t] = ACTIONS(1452),
    [anon_sym_uintptr_t] = ACTIONS(1452),
    [anon_sym_void] = ACTIONS(1452),
    [sym_vector_type] = ACTIONS(1452),
    [anon_sym_image2d_t] = ACTIONS(1452),
    [anon_sym_image3d_t] = ACTIONS(1452),
    [anon_sym_image2d_array_t] = ACTIONS(1452),
    [anon_sym_image1d_t] = ACTIONS(1452),
    [anon_sym_image1d_buffer_t] = ACTIONS(1452),
    [anon_sym_image1d_array_t] = ACTIONS(1452),
    [anon_sym_image2d_depth_t] = ACTIONS(1452),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1452),
    [anon_sym_sampler_t] = ACTIONS(1452),
    [anon_sym_queue_t] = ACTIONS(1452),
    [anon_sym_ndrange_t] = ACTIONS(1452),
    [anon_sym_clk_event_t] = ACTIONS(1452),
    [anon_sym_reserve_id_t] = ACTIONS(1452),
    [anon_sym_event_t] = ACTIONS(1452),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_struct] = ACTIONS(1452),
    [anon_sym_union] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
  },
  [388] = {
    [sym_identifier] = ACTIONS(1444),
    [aux_sym_preproc_def_token1] = ACTIONS(1444),
    [aux_sym_preproc_if_token1] = ACTIONS(1444),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1444),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1444),
    [sym_preproc_directive] = ACTIONS(1444),
    [anon_sym_kernel] = ACTIONS(1444),
    [anon_sym___kernel] = ACTIONS(1444),
    [anon_sym_global] = ACTIONS(1444),
    [anon_sym___global] = ACTIONS(1444),
    [anon_sym_local] = ACTIONS(1444),
    [anon_sym___local] = ACTIONS(1444),
    [anon_sym_constant] = ACTIONS(1444),
    [anon_sym___constant] = ACTIONS(1444),
    [anon_sym_private] = ACTIONS(1444),
    [anon_sym___private] = ACTIONS(1444),
    [anon_sym_generic] = ACTIONS(1444),
    [anon_sym___generic] = ACTIONS(1444),
    [anon_sym_read_only] = ACTIONS(1444),
    [anon_sym___read_only] = ACTIONS(1444),
    [anon_sym_write_only] = ACTIONS(1444),
    [anon_sym___write_only] = ACTIONS(1444),
    [anon_sym_read_write] = ACTIONS(1444),
    [anon_sym___read_write] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym___attribute__] = ACTIONS(1444),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1446),
    [anon_sym___declspec] = ACTIONS(1444),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_auto] = ACTIONS(1444),
    [anon_sym_register] = ACTIONS(1444),
    [anon_sym_inline] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_volatile] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1444),
    [anon_sym__Atomic] = ACTIONS(1444),
    [anon_sym_pipe] = ACTIONS(1444),
    [anon_sym_signed] = ACTIONS(1444),
    [anon_sym_unsigned] = ACTIONS(1444),
    [anon_sym_long] = ACTIONS(1444),
    [anon_sym_short] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_uchar] = ACTIONS(1444),
    [anon_sym_ushort] = ACTIONS(1444),
    [anon_sym_int] = ACTIONS(1444),
    [anon_sym_uint] = ACTIONS(1444),
    [anon_sym_ulong] = ACTIONS(1444),
    [anon_sym_float] = ACTIONS(1444),
    [anon_sym_double] = ACTIONS(1444),
    [anon_sym_half] = ACTIONS(1444),
    [anon_sym_size_t] = ACTIONS(1444),
    [anon_sym_ptrdiff_t] = ACTIONS(1444),
    [anon_sym_intptr_t] = ACTIONS(1444),
    [anon_sym_uintptr_t] = ACTIONS(1444),
    [anon_sym_void] = ACTIONS(1444),
    [sym_vector_type] = ACTIONS(1444),
    [anon_sym_image2d_t] = ACTIONS(1444),
    [anon_sym_image3d_t] = ACTIONS(1444),
    [anon_sym_image2d_array_t] = ACTIONS(1444),
    [anon_sym_image1d_t] = ACTIONS(1444),
    [anon_sym_image1d_buffer_t] = ACTIONS(1444),
    [anon_sym_image1d_array_t] = ACTIONS(1444),
    [anon_sym_image2d_depth_t] = ACTIONS(1444),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1444),
    [anon_sym_sampler_t] = ACTIONS(1444),
    [anon_sym_queue_t] = ACTIONS(1444),
    [anon_sym_ndrange_t] = ACTIONS(1444),
    [anon_sym_clk_event_t] = ACTIONS(1444),
    [anon_sym_reserve_id_t] = ACTIONS(1444),
    [anon_sym_event_t] = ACTIONS(1444),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_struct] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
  },
  [389] = {
    [sym_identifier] = ACTIONS(1488),
    [aux_sym_preproc_def_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token1] = ACTIONS(1488),
    [aux_sym_preproc_if_token2] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1488),
    [sym_preproc_directive] = ACTIONS(1488),
    [anon_sym_kernel] = ACTIONS(1488),
    [anon_sym___kernel] = ACTIONS(1488),
    [anon_sym_global] = ACTIONS(1488),
    [anon_sym___global] = ACTIONS(1488),
    [anon_sym_local] = ACTIONS(1488),
    [anon_sym___local] = ACTIONS(1488),
    [anon_sym_constant] = ACTIONS(1488),
    [anon_sym___constant] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym___private] = ACTIONS(1488),
    [anon_sym_generic] = ACTIONS(1488),
    [anon_sym___generic] = ACTIONS(1488),
    [anon_sym_read_only] = ACTIONS(1488),
    [anon_sym___read_only] = ACTIONS(1488),
    [anon_sym_write_only] = ACTIONS(1488),
    [anon_sym___write_only] = ACTIONS(1488),
    [anon_sym_read_write] = ACTIONS(1488),
    [anon_sym___read_write] = ACTIONS(1488),
    [anon_sym_extern] = ACTIONS(1488),
    [anon_sym___attribute__] = ACTIONS(1488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1490),
    [anon_sym___declspec] = ACTIONS(1488),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_auto] = ACTIONS(1488),
    [anon_sym_register] = ACTIONS(1488),
    [anon_sym_inline] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_volatile] = ACTIONS(1488),
    [anon_sym_restrict] = ACTIONS(1488),
    [anon_sym__Atomic] = ACTIONS(1488),
    [anon_sym_pipe] = ACTIONS(1488),
    [anon_sym_signed] = ACTIONS(1488),
    [anon_sym_unsigned] = ACTIONS(1488),
    [anon_sym_long] = ACTIONS(1488),
    [anon_sym_short] = ACTIONS(1488),
    [anon_sym_bool] = ACTIONS(1488),
    [anon_sym_char] = ACTIONS(1488),
    [anon_sym_uchar] = ACTIONS(1488),
    [anon_sym_ushort] = ACTIONS(1488),
    [anon_sym_int] = ACTIONS(1488),
    [anon_sym_uint] = ACTIONS(1488),
    [anon_sym_ulong] = ACTIONS(1488),
    [anon_sym_float] = ACTIONS(1488),
    [anon_sym_double] = ACTIONS(1488),
    [anon_sym_half] = ACTIONS(1488),
    [anon_sym_size_t] = ACTIONS(1488),
    [anon_sym_ptrdiff_t] = ACTIONS(1488),
    [anon_sym_intptr_t] = ACTIONS(1488),
    [anon_sym_uintptr_t] = ACTIONS(1488),
    [anon_sym_void] = ACTIONS(1488),
    [sym_vector_type] = ACTIONS(1488),
    [anon_sym_image2d_t] = ACTIONS(1488),
    [anon_sym_image3d_t] = ACTIONS(1488),
    [anon_sym_image2d_array_t] = ACTIONS(1488),
    [anon_sym_image1d_t] = ACTIONS(1488),
    [anon_sym_image1d_buffer_t] = ACTIONS(1488),
    [anon_sym_image1d_array_t] = ACTIONS(1488),
    [anon_sym_image2d_depth_t] = ACTIONS(1488),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1488),
    [anon_sym_sampler_t] = ACTIONS(1488),
    [anon_sym_queue_t] = ACTIONS(1488),
    [anon_sym_ndrange_t] = ACTIONS(1488),
    [anon_sym_clk_event_t] = ACTIONS(1488),
    [anon_sym_reserve_id_t] = ACTIONS(1488),
    [anon_sym_event_t] = ACTIONS(1488),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_struct] = ACTIONS(1488),
    [anon_sym_union] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
  },
  [390] = {
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_kernel] = ACTIONS(1072),
    [anon_sym___kernel] = ACTIONS(1072),
    [anon_sym_global] = ACTIONS(1072),
    [anon_sym___global] = ACTIONS(1072),
    [anon_sym_local] = ACTIONS(1072),
    [anon_sym___local] = ACTIONS(1072),
    [anon_sym_constant] = ACTIONS(1072),
    [anon_sym___constant] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym___private] = ACTIONS(1072),
    [anon_sym_generic] = ACTIONS(1072),
    [anon_sym___generic] = ACTIONS(1072),
    [anon_sym_read_only] = ACTIONS(1072),
    [anon_sym___read_only] = ACTIONS(1072),
    [anon_sym_write_only] = ACTIONS(1072),
    [anon_sym___write_only] = ACTIONS(1072),
    [anon_sym_read_write] = ACTIONS(1072),
    [anon_sym___read_write] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1074),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_pipe] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [anon_sym_bool] = ACTIONS(1072),
    [anon_sym_char] = ACTIONS(1072),
    [anon_sym_uchar] = ACTIONS(1072),
    [anon_sym_ushort] = ACTIONS(1072),
    [anon_sym_int] = ACTIONS(1072),
    [anon_sym_uint] = ACTIONS(1072),
    [anon_sym_ulong] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1072),
    [anon_sym_double] = ACTIONS(1072),
    [anon_sym_half] = ACTIONS(1072),
    [anon_sym_size_t] = ACTIONS(1072),
    [anon_sym_ptrdiff_t] = ACTIONS(1072),
    [anon_sym_intptr_t] = ACTIONS(1072),
    [anon_sym_uintptr_t] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1072),
    [sym_vector_type] = ACTIONS(1072),
    [anon_sym_image2d_t] = ACTIONS(1072),
    [anon_sym_image3d_t] = ACTIONS(1072),
    [anon_sym_image2d_array_t] = ACTIONS(1072),
    [anon_sym_image1d_t] = ACTIONS(1072),
    [anon_sym_image1d_buffer_t] = ACTIONS(1072),
    [anon_sym_image1d_array_t] = ACTIONS(1072),
    [anon_sym_image2d_depth_t] = ACTIONS(1072),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1072),
    [anon_sym_sampler_t] = ACTIONS(1072),
    [anon_sym_queue_t] = ACTIONS(1072),
    [anon_sym_ndrange_t] = ACTIONS(1072),
    [anon_sym_clk_event_t] = ACTIONS(1072),
    [anon_sym_reserve_id_t] = ACTIONS(1072),
    [anon_sym_event_t] = ACTIONS(1072),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [391] = {
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_preproc_def_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1108),
    [sym_preproc_directive] = ACTIONS(1108),
    [anon_sym_kernel] = ACTIONS(1108),
    [anon_sym___kernel] = ACTIONS(1108),
    [anon_sym_global] = ACTIONS(1108),
    [anon_sym___global] = ACTIONS(1108),
    [anon_sym_local] = ACTIONS(1108),
    [anon_sym___local] = ACTIONS(1108),
    [anon_sym_constant] = ACTIONS(1108),
    [anon_sym___constant] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym___private] = ACTIONS(1108),
    [anon_sym_generic] = ACTIONS(1108),
    [anon_sym___generic] = ACTIONS(1108),
    [anon_sym_read_only] = ACTIONS(1108),
    [anon_sym___read_only] = ACTIONS(1108),
    [anon_sym_write_only] = ACTIONS(1108),
    [anon_sym___write_only] = ACTIONS(1108),
    [anon_sym_read_write] = ACTIONS(1108),
    [anon_sym___read_write] = ACTIONS(1108),
    [anon_sym_extern] = ACTIONS(1108),
    [anon_sym___attribute__] = ACTIONS(1108),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1110),
    [anon_sym___declspec] = ACTIONS(1108),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_auto] = ACTIONS(1108),
    [anon_sym_register] = ACTIONS(1108),
    [anon_sym_inline] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_volatile] = ACTIONS(1108),
    [anon_sym_restrict] = ACTIONS(1108),
    [anon_sym__Atomic] = ACTIONS(1108),
    [anon_sym_pipe] = ACTIONS(1108),
    [anon_sym_signed] = ACTIONS(1108),
    [anon_sym_unsigned] = ACTIONS(1108),
    [anon_sym_long] = ACTIONS(1108),
    [anon_sym_short] = ACTIONS(1108),
    [anon_sym_bool] = ACTIONS(1108),
    [anon_sym_char] = ACTIONS(1108),
    [anon_sym_uchar] = ACTIONS(1108),
    [anon_sym_ushort] = ACTIONS(1108),
    [anon_sym_int] = ACTIONS(1108),
    [anon_sym_uint] = ACTIONS(1108),
    [anon_sym_ulong] = ACTIONS(1108),
    [anon_sym_float] = ACTIONS(1108),
    [anon_sym_double] = ACTIONS(1108),
    [anon_sym_half] = ACTIONS(1108),
    [anon_sym_size_t] = ACTIONS(1108),
    [anon_sym_ptrdiff_t] = ACTIONS(1108),
    [anon_sym_intptr_t] = ACTIONS(1108),
    [anon_sym_uintptr_t] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1108),
    [sym_vector_type] = ACTIONS(1108),
    [anon_sym_image2d_t] = ACTIONS(1108),
    [anon_sym_image3d_t] = ACTIONS(1108),
    [anon_sym_image2d_array_t] = ACTIONS(1108),
    [anon_sym_image1d_t] = ACTIONS(1108),
    [anon_sym_image1d_buffer_t] = ACTIONS(1108),
    [anon_sym_image1d_array_t] = ACTIONS(1108),
    [anon_sym_image2d_depth_t] = ACTIONS(1108),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1108),
    [anon_sym_sampler_t] = ACTIONS(1108),
    [anon_sym_queue_t] = ACTIONS(1108),
    [anon_sym_ndrange_t] = ACTIONS(1108),
    [anon_sym_clk_event_t] = ACTIONS(1108),
    [anon_sym_reserve_id_t] = ACTIONS(1108),
    [anon_sym_event_t] = ACTIONS(1108),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [anon_sym_struct] = ACTIONS(1108),
    [anon_sym_union] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [sym_identifier] = ACTIONS(1440),
    [aux_sym_preproc_def_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token2] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1440),
    [sym_preproc_directive] = ACTIONS(1440),
    [anon_sym_kernel] = ACTIONS(1440),
    [anon_sym___kernel] = ACTIONS(1440),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym___global] = ACTIONS(1440),
    [anon_sym_local] = ACTIONS(1440),
    [anon_sym___local] = ACTIONS(1440),
    [anon_sym_constant] = ACTIONS(1440),
    [anon_sym___constant] = ACTIONS(1440),
    [anon_sym_private] = ACTIONS(1440),
    [anon_sym___private] = ACTIONS(1440),
    [anon_sym_generic] = ACTIONS(1440),
    [anon_sym___generic] = ACTIONS(1440),
    [anon_sym_read_only] = ACTIONS(1440),
    [anon_sym___read_only] = ACTIONS(1440),
    [anon_sym_write_only] = ACTIONS(1440),
    [anon_sym___write_only] = ACTIONS(1440),
    [anon_sym_read_write] = ACTIONS(1440),
    [anon_sym___read_write] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym___attribute__] = ACTIONS(1440),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1442),
    [anon_sym___declspec] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_auto] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym_pipe] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(1440),
    [anon_sym_unsigned] = ACTIONS(1440),
    [anon_sym_long] = ACTIONS(1440),
    [anon_sym_short] = ACTIONS(1440),
    [anon_sym_bool] = ACTIONS(1440),
    [anon_sym_char] = ACTIONS(1440),
    [anon_sym_uchar] = ACTIONS(1440),
    [anon_sym_ushort] = ACTIONS(1440),
    [anon_sym_int] = ACTIONS(1440),
    [anon_sym_uint] = ACTIONS(1440),
    [anon_sym_ulong] = ACTIONS(1440),
    [anon_sym_float] = ACTIONS(1440),
    [anon_sym_double] = ACTIONS(1440),
    [anon_sym_half] = ACTIONS(1440),
    [anon_sym_size_t] = ACTIONS(1440),
    [anon_sym_ptrdiff_t] = ACTIONS(1440),
    [anon_sym_intptr_t] = ACTIONS(1440),
    [anon_sym_uintptr_t] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(1440),
    [sym_vector_type] = ACTIONS(1440),
    [anon_sym_image2d_t] = ACTIONS(1440),
    [anon_sym_image3d_t] = ACTIONS(1440),
    [anon_sym_image2d_array_t] = ACTIONS(1440),
    [anon_sym_image1d_t] = ACTIONS(1440),
    [anon_sym_image1d_buffer_t] = ACTIONS(1440),
    [anon_sym_image1d_array_t] = ACTIONS(1440),
    [anon_sym_image2d_depth_t] = ACTIONS(1440),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1440),
    [anon_sym_sampler_t] = ACTIONS(1440),
    [anon_sym_queue_t] = ACTIONS(1440),
    [anon_sym_ndrange_t] = ACTIONS(1440),
    [anon_sym_clk_event_t] = ACTIONS(1440),
    [anon_sym_reserve_id_t] = ACTIONS(1440),
    [anon_sym_event_t] = ACTIONS(1440),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [sym_identifier] = ACTIONS(1448),
    [aux_sym_preproc_def_token1] = ACTIONS(1448),
    [aux_sym_preproc_if_token1] = ACTIONS(1448),
    [aux_sym_preproc_if_token2] = ACTIONS(1448),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1448),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1448),
    [sym_preproc_directive] = ACTIONS(1448),
    [anon_sym_kernel] = ACTIONS(1448),
    [anon_sym___kernel] = ACTIONS(1448),
    [anon_sym_global] = ACTIONS(1448),
    [anon_sym___global] = ACTIONS(1448),
    [anon_sym_local] = ACTIONS(1448),
    [anon_sym___local] = ACTIONS(1448),
    [anon_sym_constant] = ACTIONS(1448),
    [anon_sym___constant] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym___private] = ACTIONS(1448),
    [anon_sym_generic] = ACTIONS(1448),
    [anon_sym___generic] = ACTIONS(1448),
    [anon_sym_read_only] = ACTIONS(1448),
    [anon_sym___read_only] = ACTIONS(1448),
    [anon_sym_write_only] = ACTIONS(1448),
    [anon_sym___write_only] = ACTIONS(1448),
    [anon_sym_read_write] = ACTIONS(1448),
    [anon_sym___read_write] = ACTIONS(1448),
    [anon_sym_extern] = ACTIONS(1448),
    [anon_sym___attribute__] = ACTIONS(1448),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1450),
    [anon_sym___declspec] = ACTIONS(1448),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_auto] = ACTIONS(1448),
    [anon_sym_register] = ACTIONS(1448),
    [anon_sym_inline] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_volatile] = ACTIONS(1448),
    [anon_sym_restrict] = ACTIONS(1448),
    [anon_sym__Atomic] = ACTIONS(1448),
    [anon_sym_pipe] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1448),
    [anon_sym_unsigned] = ACTIONS(1448),
    [anon_sym_long] = ACTIONS(1448),
    [anon_sym_short] = ACTIONS(1448),
    [anon_sym_bool] = ACTIONS(1448),
    [anon_sym_char] = ACTIONS(1448),
    [anon_sym_uchar] = ACTIONS(1448),
    [anon_sym_ushort] = ACTIONS(1448),
    [anon_sym_int] = ACTIONS(1448),
    [anon_sym_uint] = ACTIONS(1448),
    [anon_sym_ulong] = ACTIONS(1448),
    [anon_sym_float] = ACTIONS(1448),
    [anon_sym_double] = ACTIONS(1448),
    [anon_sym_half] = ACTIONS(1448),
    [anon_sym_size_t] = ACTIONS(1448),
    [anon_sym_ptrdiff_t] = ACTIONS(1448),
    [anon_sym_intptr_t] = ACTIONS(1448),
    [anon_sym_uintptr_t] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1448),
    [sym_vector_type] = ACTIONS(1448),
    [anon_sym_image2d_t] = ACTIONS(1448),
    [anon_sym_image3d_t] = ACTIONS(1448),
    [anon_sym_image2d_array_t] = ACTIONS(1448),
    [anon_sym_image1d_t] = ACTIONS(1448),
    [anon_sym_image1d_buffer_t] = ACTIONS(1448),
    [anon_sym_image1d_array_t] = ACTIONS(1448),
    [anon_sym_image2d_depth_t] = ACTIONS(1448),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1448),
    [anon_sym_sampler_t] = ACTIONS(1448),
    [anon_sym_queue_t] = ACTIONS(1448),
    [anon_sym_ndrange_t] = ACTIONS(1448),
    [anon_sym_clk_event_t] = ACTIONS(1448),
    [anon_sym_reserve_id_t] = ACTIONS(1448),
    [anon_sym_event_t] = ACTIONS(1448),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1448),
    [anon_sym_enum] = ACTIONS(1448),
    [anon_sym_struct] = ACTIONS(1448),
    [anon_sym_union] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
  },
  [394] = {
    [sym_string_literal] = STATE(324),
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_kernel] = ACTIONS(1396),
    [anon_sym___kernel] = ACTIONS(1396),
    [anon_sym_global] = ACTIONS(1396),
    [anon_sym___global] = ACTIONS(1396),
    [anon_sym_local] = ACTIONS(1396),
    [anon_sym___local] = ACTIONS(1396),
    [anon_sym_constant] = ACTIONS(1396),
    [anon_sym___constant] = ACTIONS(1396),
    [anon_sym_private] = ACTIONS(1396),
    [anon_sym___private] = ACTIONS(1396),
    [anon_sym_generic] = ACTIONS(1396),
    [anon_sym___generic] = ACTIONS(1396),
    [anon_sym_read_only] = ACTIONS(1396),
    [anon_sym___read_only] = ACTIONS(1396),
    [anon_sym_write_only] = ACTIONS(1396),
    [anon_sym___write_only] = ACTIONS(1396),
    [anon_sym_read_write] = ACTIONS(1396),
    [anon_sym___read_write] = ACTIONS(1396),
    [anon_sym_extern] = ACTIONS(1396),
    [anon_sym___attribute__] = ACTIONS(1396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1398),
    [anon_sym___declspec] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1396),
    [anon_sym_auto] = ACTIONS(1396),
    [anon_sym_register] = ACTIONS(1396),
    [anon_sym_inline] = ACTIONS(1396),
    [anon_sym_const] = ACTIONS(1396),
    [anon_sym_volatile] = ACTIONS(1396),
    [anon_sym_restrict] = ACTIONS(1396),
    [anon_sym__Atomic] = ACTIONS(1396),
    [anon_sym_pipe] = ACTIONS(1396),
    [anon_sym_signed] = ACTIONS(1396),
    [anon_sym_unsigned] = ACTIONS(1396),
    [anon_sym_long] = ACTIONS(1396),
    [anon_sym_short] = ACTIONS(1396),
    [anon_sym_bool] = ACTIONS(1396),
    [anon_sym_char] = ACTIONS(1396),
    [anon_sym_uchar] = ACTIONS(1396),
    [anon_sym_ushort] = ACTIONS(1396),
    [anon_sym_int] = ACTIONS(1396),
    [anon_sym_uint] = ACTIONS(1396),
    [anon_sym_ulong] = ACTIONS(1396),
    [anon_sym_float] = ACTIONS(1396),
    [anon_sym_double] = ACTIONS(1396),
    [anon_sym_half] = ACTIONS(1396),
    [anon_sym_size_t] = ACTIONS(1396),
    [anon_sym_ptrdiff_t] = ACTIONS(1396),
    [anon_sym_intptr_t] = ACTIONS(1396),
    [anon_sym_uintptr_t] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1396),
    [sym_vector_type] = ACTIONS(1396),
    [anon_sym_image2d_t] = ACTIONS(1396),
    [anon_sym_image3d_t] = ACTIONS(1396),
    [anon_sym_image2d_array_t] = ACTIONS(1396),
    [anon_sym_image1d_t] = ACTIONS(1396),
    [anon_sym_image1d_buffer_t] = ACTIONS(1396),
    [anon_sym_image1d_array_t] = ACTIONS(1396),
    [anon_sym_image2d_depth_t] = ACTIONS(1396),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1396),
    [anon_sym_sampler_t] = ACTIONS(1396),
    [anon_sym_queue_t] = ACTIONS(1396),
    [anon_sym_ndrange_t] = ACTIONS(1396),
    [anon_sym_clk_event_t] = ACTIONS(1396),
    [anon_sym_reserve_id_t] = ACTIONS(1396),
    [anon_sym_event_t] = ACTIONS(1396),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1396),
    [anon_sym_enum] = ACTIONS(1396),
    [anon_sym_struct] = ACTIONS(1396),
    [anon_sym_union] = ACTIONS(1396),
    [anon_sym_L_DQUOTE] = ACTIONS(1500),
    [anon_sym_u_DQUOTE] = ACTIONS(1500),
    [anon_sym_U_DQUOTE] = ACTIONS(1500),
    [anon_sym_u8_DQUOTE] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [sym_identifier] = ACTIONS(1404),
    [aux_sym_preproc_def_token1] = ACTIONS(1404),
    [aux_sym_preproc_if_token1] = ACTIONS(1404),
    [aux_sym_preproc_if_token2] = ACTIONS(1404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1404),
    [sym_preproc_directive] = ACTIONS(1404),
    [anon_sym_kernel] = ACTIONS(1404),
    [anon_sym___kernel] = ACTIONS(1404),
    [anon_sym_global] = ACTIONS(1404),
    [anon_sym___global] = ACTIONS(1404),
    [anon_sym_local] = ACTIONS(1404),
    [anon_sym___local] = ACTIONS(1404),
    [anon_sym_constant] = ACTIONS(1404),
    [anon_sym___constant] = ACTIONS(1404),
    [anon_sym_private] = ACTIONS(1404),
    [anon_sym___private] = ACTIONS(1404),
    [anon_sym_generic] = ACTIONS(1404),
    [anon_sym___generic] = ACTIONS(1404),
    [anon_sym_read_only] = ACTIONS(1404),
    [anon_sym___read_only] = ACTIONS(1404),
    [anon_sym_write_only] = ACTIONS(1404),
    [anon_sym___write_only] = ACTIONS(1404),
    [anon_sym_read_write] = ACTIONS(1404),
    [anon_sym___read_write] = ACTIONS(1404),
    [anon_sym_extern] = ACTIONS(1404),
    [anon_sym___attribute__] = ACTIONS(1404),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1406),
    [anon_sym___declspec] = ACTIONS(1404),
    [anon_sym_static] = ACTIONS(1404),
    [anon_sym_auto] = ACTIONS(1404),
    [anon_sym_register] = ACTIONS(1404),
    [anon_sym_inline] = ACTIONS(1404),
    [anon_sym_const] = ACTIONS(1404),
    [anon_sym_volatile] = ACTIONS(1404),
    [anon_sym_restrict] = ACTIONS(1404),
    [anon_sym__Atomic] = ACTIONS(1404),
    [anon_sym_pipe] = ACTIONS(1404),
    [anon_sym_signed] = ACTIONS(1404),
    [anon_sym_unsigned] = ACTIONS(1404),
    [anon_sym_long] = ACTIONS(1404),
    [anon_sym_short] = ACTIONS(1404),
    [anon_sym_bool] = ACTIONS(1404),
    [anon_sym_char] = ACTIONS(1404),
    [anon_sym_uchar] = ACTIONS(1404),
    [anon_sym_ushort] = ACTIONS(1404),
    [anon_sym_int] = ACTIONS(1404),
    [anon_sym_uint] = ACTIONS(1404),
    [anon_sym_ulong] = ACTIONS(1404),
    [anon_sym_float] = ACTIONS(1404),
    [anon_sym_double] = ACTIONS(1404),
    [anon_sym_half] = ACTIONS(1404),
    [anon_sym_size_t] = ACTIONS(1404),
    [anon_sym_ptrdiff_t] = ACTIONS(1404),
    [anon_sym_intptr_t] = ACTIONS(1404),
    [anon_sym_uintptr_t] = ACTIONS(1404),
    [anon_sym_void] = ACTIONS(1404),
    [sym_vector_type] = ACTIONS(1404),
    [anon_sym_image2d_t] = ACTIONS(1404),
    [anon_sym_image3d_t] = ACTIONS(1404),
    [anon_sym_image2d_array_t] = ACTIONS(1404),
    [anon_sym_image1d_t] = ACTIONS(1404),
    [anon_sym_image1d_buffer_t] = ACTIONS(1404),
    [anon_sym_image1d_array_t] = ACTIONS(1404),
    [anon_sym_image2d_depth_t] = ACTIONS(1404),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1404),
    [anon_sym_sampler_t] = ACTIONS(1404),
    [anon_sym_queue_t] = ACTIONS(1404),
    [anon_sym_ndrange_t] = ACTIONS(1404),
    [anon_sym_clk_event_t] = ACTIONS(1404),
    [anon_sym_reserve_id_t] = ACTIONS(1404),
    [anon_sym_event_t] = ACTIONS(1404),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [anon_sym_struct] = ACTIONS(1404),
    [anon_sym_union] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
  },
  [396] = {
    [sym_identifier] = ACTIONS(1408),
    [aux_sym_preproc_def_token1] = ACTIONS(1408),
    [aux_sym_preproc_if_token1] = ACTIONS(1408),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1408),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1408),
    [sym_preproc_directive] = ACTIONS(1408),
    [anon_sym_kernel] = ACTIONS(1408),
    [anon_sym___kernel] = ACTIONS(1408),
    [anon_sym_global] = ACTIONS(1408),
    [anon_sym___global] = ACTIONS(1408),
    [anon_sym_local] = ACTIONS(1408),
    [anon_sym___local] = ACTIONS(1408),
    [anon_sym_constant] = ACTIONS(1408),
    [anon_sym___constant] = ACTIONS(1408),
    [anon_sym_private] = ACTIONS(1408),
    [anon_sym___private] = ACTIONS(1408),
    [anon_sym_generic] = ACTIONS(1408),
    [anon_sym___generic] = ACTIONS(1408),
    [anon_sym_read_only] = ACTIONS(1408),
    [anon_sym___read_only] = ACTIONS(1408),
    [anon_sym_write_only] = ACTIONS(1408),
    [anon_sym___write_only] = ACTIONS(1408),
    [anon_sym_read_write] = ACTIONS(1408),
    [anon_sym___read_write] = ACTIONS(1408),
    [anon_sym_extern] = ACTIONS(1408),
    [anon_sym___attribute__] = ACTIONS(1408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1410),
    [anon_sym___declspec] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1410),
    [anon_sym_static] = ACTIONS(1408),
    [anon_sym_auto] = ACTIONS(1408),
    [anon_sym_register] = ACTIONS(1408),
    [anon_sym_inline] = ACTIONS(1408),
    [anon_sym_const] = ACTIONS(1408),
    [anon_sym_volatile] = ACTIONS(1408),
    [anon_sym_restrict] = ACTIONS(1408),
    [anon_sym__Atomic] = ACTIONS(1408),
    [anon_sym_pipe] = ACTIONS(1408),
    [anon_sym_signed] = ACTIONS(1408),
    [anon_sym_unsigned] = ACTIONS(1408),
    [anon_sym_long] = ACTIONS(1408),
    [anon_sym_short] = ACTIONS(1408),
    [anon_sym_bool] = ACTIONS(1408),
    [anon_sym_char] = ACTIONS(1408),
    [anon_sym_uchar] = ACTIONS(1408),
    [anon_sym_ushort] = ACTIONS(1408),
    [anon_sym_int] = ACTIONS(1408),
    [anon_sym_uint] = ACTIONS(1408),
    [anon_sym_ulong] = ACTIONS(1408),
    [anon_sym_float] = ACTIONS(1408),
    [anon_sym_double] = ACTIONS(1408),
    [anon_sym_half] = ACTIONS(1408),
    [anon_sym_size_t] = ACTIONS(1408),
    [anon_sym_ptrdiff_t] = ACTIONS(1408),
    [anon_sym_intptr_t] = ACTIONS(1408),
    [anon_sym_uintptr_t] = ACTIONS(1408),
    [anon_sym_void] = ACTIONS(1408),
    [sym_vector_type] = ACTIONS(1408),
    [anon_sym_image2d_t] = ACTIONS(1408),
    [anon_sym_image3d_t] = ACTIONS(1408),
    [anon_sym_image2d_array_t] = ACTIONS(1408),
    [anon_sym_image1d_t] = ACTIONS(1408),
    [anon_sym_image1d_buffer_t] = ACTIONS(1408),
    [anon_sym_image1d_array_t] = ACTIONS(1408),
    [anon_sym_image2d_depth_t] = ACTIONS(1408),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1408),
    [anon_sym_sampler_t] = ACTIONS(1408),
    [anon_sym_queue_t] = ACTIONS(1408),
    [anon_sym_ndrange_t] = ACTIONS(1408),
    [anon_sym_clk_event_t] = ACTIONS(1408),
    [anon_sym_reserve_id_t] = ACTIONS(1408),
    [anon_sym_event_t] = ACTIONS(1408),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1408),
    [anon_sym_enum] = ACTIONS(1408),
    [anon_sym_struct] = ACTIONS(1408),
    [anon_sym_union] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
  },
  [397] = {
    [sym_identifier] = ACTIONS(1404),
    [aux_sym_preproc_def_token1] = ACTIONS(1404),
    [aux_sym_preproc_if_token1] = ACTIONS(1404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1404),
    [sym_preproc_directive] = ACTIONS(1404),
    [anon_sym_kernel] = ACTIONS(1404),
    [anon_sym___kernel] = ACTIONS(1404),
    [anon_sym_global] = ACTIONS(1404),
    [anon_sym___global] = ACTIONS(1404),
    [anon_sym_local] = ACTIONS(1404),
    [anon_sym___local] = ACTIONS(1404),
    [anon_sym_constant] = ACTIONS(1404),
    [anon_sym___constant] = ACTIONS(1404),
    [anon_sym_private] = ACTIONS(1404),
    [anon_sym___private] = ACTIONS(1404),
    [anon_sym_generic] = ACTIONS(1404),
    [anon_sym___generic] = ACTIONS(1404),
    [anon_sym_read_only] = ACTIONS(1404),
    [anon_sym___read_only] = ACTIONS(1404),
    [anon_sym_write_only] = ACTIONS(1404),
    [anon_sym___write_only] = ACTIONS(1404),
    [anon_sym_read_write] = ACTIONS(1404),
    [anon_sym___read_write] = ACTIONS(1404),
    [anon_sym_extern] = ACTIONS(1404),
    [anon_sym___attribute__] = ACTIONS(1404),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1406),
    [anon_sym___declspec] = ACTIONS(1404),
    [anon_sym_RBRACE] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1404),
    [anon_sym_auto] = ACTIONS(1404),
    [anon_sym_register] = ACTIONS(1404),
    [anon_sym_inline] = ACTIONS(1404),
    [anon_sym_const] = ACTIONS(1404),
    [anon_sym_volatile] = ACTIONS(1404),
    [anon_sym_restrict] = ACTIONS(1404),
    [anon_sym__Atomic] = ACTIONS(1404),
    [anon_sym_pipe] = ACTIONS(1404),
    [anon_sym_signed] = ACTIONS(1404),
    [anon_sym_unsigned] = ACTIONS(1404),
    [anon_sym_long] = ACTIONS(1404),
    [anon_sym_short] = ACTIONS(1404),
    [anon_sym_bool] = ACTIONS(1404),
    [anon_sym_char] = ACTIONS(1404),
    [anon_sym_uchar] = ACTIONS(1404),
    [anon_sym_ushort] = ACTIONS(1404),
    [anon_sym_int] = ACTIONS(1404),
    [anon_sym_uint] = ACTIONS(1404),
    [anon_sym_ulong] = ACTIONS(1404),
    [anon_sym_float] = ACTIONS(1404),
    [anon_sym_double] = ACTIONS(1404),
    [anon_sym_half] = ACTIONS(1404),
    [anon_sym_size_t] = ACTIONS(1404),
    [anon_sym_ptrdiff_t] = ACTIONS(1404),
    [anon_sym_intptr_t] = ACTIONS(1404),
    [anon_sym_uintptr_t] = ACTIONS(1404),
    [anon_sym_void] = ACTIONS(1404),
    [sym_vector_type] = ACTIONS(1404),
    [anon_sym_image2d_t] = ACTIONS(1404),
    [anon_sym_image3d_t] = ACTIONS(1404),
    [anon_sym_image2d_array_t] = ACTIONS(1404),
    [anon_sym_image1d_t] = ACTIONS(1404),
    [anon_sym_image1d_buffer_t] = ACTIONS(1404),
    [anon_sym_image1d_array_t] = ACTIONS(1404),
    [anon_sym_image2d_depth_t] = ACTIONS(1404),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1404),
    [anon_sym_sampler_t] = ACTIONS(1404),
    [anon_sym_queue_t] = ACTIONS(1404),
    [anon_sym_ndrange_t] = ACTIONS(1404),
    [anon_sym_clk_event_t] = ACTIONS(1404),
    [anon_sym_reserve_id_t] = ACTIONS(1404),
    [anon_sym_event_t] = ACTIONS(1404),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [anon_sym_struct] = ACTIONS(1404),
    [anon_sym_union] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
  },
  [398] = {
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token2] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_kernel] = ACTIONS(1096),
    [anon_sym___kernel] = ACTIONS(1096),
    [anon_sym_global] = ACTIONS(1096),
    [anon_sym___global] = ACTIONS(1096),
    [anon_sym_local] = ACTIONS(1096),
    [anon_sym___local] = ACTIONS(1096),
    [anon_sym_constant] = ACTIONS(1096),
    [anon_sym___constant] = ACTIONS(1096),
    [anon_sym_private] = ACTIONS(1096),
    [anon_sym___private] = ACTIONS(1096),
    [anon_sym_generic] = ACTIONS(1096),
    [anon_sym___generic] = ACTIONS(1096),
    [anon_sym_read_only] = ACTIONS(1096),
    [anon_sym___read_only] = ACTIONS(1096),
    [anon_sym_write_only] = ACTIONS(1096),
    [anon_sym___write_only] = ACTIONS(1096),
    [anon_sym_read_write] = ACTIONS(1096),
    [anon_sym___read_write] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1098),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_pipe] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [anon_sym_bool] = ACTIONS(1096),
    [anon_sym_char] = ACTIONS(1096),
    [anon_sym_uchar] = ACTIONS(1096),
    [anon_sym_ushort] = ACTIONS(1096),
    [anon_sym_int] = ACTIONS(1096),
    [anon_sym_uint] = ACTIONS(1096),
    [anon_sym_ulong] = ACTIONS(1096),
    [anon_sym_float] = ACTIONS(1096),
    [anon_sym_double] = ACTIONS(1096),
    [anon_sym_half] = ACTIONS(1096),
    [anon_sym_size_t] = ACTIONS(1096),
    [anon_sym_ptrdiff_t] = ACTIONS(1096),
    [anon_sym_intptr_t] = ACTIONS(1096),
    [anon_sym_uintptr_t] = ACTIONS(1096),
    [anon_sym_void] = ACTIONS(1096),
    [sym_vector_type] = ACTIONS(1096),
    [anon_sym_image2d_t] = ACTIONS(1096),
    [anon_sym_image3d_t] = ACTIONS(1096),
    [anon_sym_image2d_array_t] = ACTIONS(1096),
    [anon_sym_image1d_t] = ACTIONS(1096),
    [anon_sym_image1d_buffer_t] = ACTIONS(1096),
    [anon_sym_image1d_array_t] = ACTIONS(1096),
    [anon_sym_image2d_depth_t] = ACTIONS(1096),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1096),
    [anon_sym_sampler_t] = ACTIONS(1096),
    [anon_sym_queue_t] = ACTIONS(1096),
    [anon_sym_ndrange_t] = ACTIONS(1096),
    [anon_sym_clk_event_t] = ACTIONS(1096),
    [anon_sym_reserve_id_t] = ACTIONS(1096),
    [anon_sym_event_t] = ACTIONS(1096),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [399] = {
    [sym_identifier] = ACTIONS(1444),
    [aux_sym_preproc_def_token1] = ACTIONS(1444),
    [aux_sym_preproc_if_token1] = ACTIONS(1444),
    [aux_sym_preproc_if_token2] = ACTIONS(1444),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1444),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1444),
    [sym_preproc_directive] = ACTIONS(1444),
    [anon_sym_kernel] = ACTIONS(1444),
    [anon_sym___kernel] = ACTIONS(1444),
    [anon_sym_global] = ACTIONS(1444),
    [anon_sym___global] = ACTIONS(1444),
    [anon_sym_local] = ACTIONS(1444),
    [anon_sym___local] = ACTIONS(1444),
    [anon_sym_constant] = ACTIONS(1444),
    [anon_sym___constant] = ACTIONS(1444),
    [anon_sym_private] = ACTIONS(1444),
    [anon_sym___private] = ACTIONS(1444),
    [anon_sym_generic] = ACTIONS(1444),
    [anon_sym___generic] = ACTIONS(1444),
    [anon_sym_read_only] = ACTIONS(1444),
    [anon_sym___read_only] = ACTIONS(1444),
    [anon_sym_write_only] = ACTIONS(1444),
    [anon_sym___write_only] = ACTIONS(1444),
    [anon_sym_read_write] = ACTIONS(1444),
    [anon_sym___read_write] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym___attribute__] = ACTIONS(1444),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1446),
    [anon_sym___declspec] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_auto] = ACTIONS(1444),
    [anon_sym_register] = ACTIONS(1444),
    [anon_sym_inline] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [anon_sym_volatile] = ACTIONS(1444),
    [anon_sym_restrict] = ACTIONS(1444),
    [anon_sym__Atomic] = ACTIONS(1444),
    [anon_sym_pipe] = ACTIONS(1444),
    [anon_sym_signed] = ACTIONS(1444),
    [anon_sym_unsigned] = ACTIONS(1444),
    [anon_sym_long] = ACTIONS(1444),
    [anon_sym_short] = ACTIONS(1444),
    [anon_sym_bool] = ACTIONS(1444),
    [anon_sym_char] = ACTIONS(1444),
    [anon_sym_uchar] = ACTIONS(1444),
    [anon_sym_ushort] = ACTIONS(1444),
    [anon_sym_int] = ACTIONS(1444),
    [anon_sym_uint] = ACTIONS(1444),
    [anon_sym_ulong] = ACTIONS(1444),
    [anon_sym_float] = ACTIONS(1444),
    [anon_sym_double] = ACTIONS(1444),
    [anon_sym_half] = ACTIONS(1444),
    [anon_sym_size_t] = ACTIONS(1444),
    [anon_sym_ptrdiff_t] = ACTIONS(1444),
    [anon_sym_intptr_t] = ACTIONS(1444),
    [anon_sym_uintptr_t] = ACTIONS(1444),
    [anon_sym_void] = ACTIONS(1444),
    [sym_vector_type] = ACTIONS(1444),
    [anon_sym_image2d_t] = ACTIONS(1444),
    [anon_sym_image3d_t] = ACTIONS(1444),
    [anon_sym_image2d_array_t] = ACTIONS(1444),
    [anon_sym_image1d_t] = ACTIONS(1444),
    [anon_sym_image1d_buffer_t] = ACTIONS(1444),
    [anon_sym_image1d_array_t] = ACTIONS(1444),
    [anon_sym_image2d_depth_t] = ACTIONS(1444),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1444),
    [anon_sym_sampler_t] = ACTIONS(1444),
    [anon_sym_queue_t] = ACTIONS(1444),
    [anon_sym_ndrange_t] = ACTIONS(1444),
    [anon_sym_clk_event_t] = ACTIONS(1444),
    [anon_sym_reserve_id_t] = ACTIONS(1444),
    [anon_sym_event_t] = ACTIONS(1444),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_struct] = ACTIONS(1444),
    [anon_sym_union] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
  },
  [400] = {
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_kernel] = ACTIONS(1076),
    [anon_sym___kernel] = ACTIONS(1076),
    [anon_sym_global] = ACTIONS(1076),
    [anon_sym___global] = ACTIONS(1076),
    [anon_sym_local] = ACTIONS(1076),
    [anon_sym___local] = ACTIONS(1076),
    [anon_sym_constant] = ACTIONS(1076),
    [anon_sym___constant] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym___private] = ACTIONS(1076),
    [anon_sym_generic] = ACTIONS(1076),
    [anon_sym___generic] = ACTIONS(1076),
    [anon_sym_read_only] = ACTIONS(1076),
    [anon_sym___read_only] = ACTIONS(1076),
    [anon_sym_write_only] = ACTIONS(1076),
    [anon_sym___write_only] = ACTIONS(1076),
    [anon_sym_read_write] = ACTIONS(1076),
    [anon_sym___read_write] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1078),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym_RBRACE] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_pipe] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [anon_sym_bool] = ACTIONS(1076),
    [anon_sym_char] = ACTIONS(1076),
    [anon_sym_uchar] = ACTIONS(1076),
    [anon_sym_ushort] = ACTIONS(1076),
    [anon_sym_int] = ACTIONS(1076),
    [anon_sym_uint] = ACTIONS(1076),
    [anon_sym_ulong] = ACTIONS(1076),
    [anon_sym_float] = ACTIONS(1076),
    [anon_sym_double] = ACTIONS(1076),
    [anon_sym_half] = ACTIONS(1076),
    [anon_sym_size_t] = ACTIONS(1076),
    [anon_sym_ptrdiff_t] = ACTIONS(1076),
    [anon_sym_intptr_t] = ACTIONS(1076),
    [anon_sym_uintptr_t] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1076),
    [sym_vector_type] = ACTIONS(1076),
    [anon_sym_image2d_t] = ACTIONS(1076),
    [anon_sym_image3d_t] = ACTIONS(1076),
    [anon_sym_image2d_array_t] = ACTIONS(1076),
    [anon_sym_image1d_t] = ACTIONS(1076),
    [anon_sym_image1d_buffer_t] = ACTIONS(1076),
    [anon_sym_image1d_array_t] = ACTIONS(1076),
    [anon_sym_image2d_depth_t] = ACTIONS(1076),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1076),
    [anon_sym_sampler_t] = ACTIONS(1076),
    [anon_sym_queue_t] = ACTIONS(1076),
    [anon_sym_ndrange_t] = ACTIONS(1076),
    [anon_sym_clk_event_t] = ACTIONS(1076),
    [anon_sym_reserve_id_t] = ACTIONS(1076),
    [anon_sym_event_t] = ACTIONS(1076),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [401] = {
    [sym_identifier] = ACTIONS(1436),
    [aux_sym_preproc_def_token1] = ACTIONS(1436),
    [aux_sym_preproc_if_token1] = ACTIONS(1436),
    [aux_sym_preproc_if_token2] = ACTIONS(1436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1436),
    [sym_preproc_directive] = ACTIONS(1436),
    [anon_sym_kernel] = ACTIONS(1436),
    [anon_sym___kernel] = ACTIONS(1436),
    [anon_sym_global] = ACTIONS(1436),
    [anon_sym___global] = ACTIONS(1436),
    [anon_sym_local] = ACTIONS(1436),
    [anon_sym___local] = ACTIONS(1436),
    [anon_sym_constant] = ACTIONS(1436),
    [anon_sym___constant] = ACTIONS(1436),
    [anon_sym_private] = ACTIONS(1436),
    [anon_sym___private] = ACTIONS(1436),
    [anon_sym_generic] = ACTIONS(1436),
    [anon_sym___generic] = ACTIONS(1436),
    [anon_sym_read_only] = ACTIONS(1436),
    [anon_sym___read_only] = ACTIONS(1436),
    [anon_sym_write_only] = ACTIONS(1436),
    [anon_sym___write_only] = ACTIONS(1436),
    [anon_sym_read_write] = ACTIONS(1436),
    [anon_sym___read_write] = ACTIONS(1436),
    [anon_sym_extern] = ACTIONS(1436),
    [anon_sym___attribute__] = ACTIONS(1436),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1438),
    [anon_sym___declspec] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1436),
    [anon_sym_auto] = ACTIONS(1436),
    [anon_sym_register] = ACTIONS(1436),
    [anon_sym_inline] = ACTIONS(1436),
    [anon_sym_const] = ACTIONS(1436),
    [anon_sym_volatile] = ACTIONS(1436),
    [anon_sym_restrict] = ACTIONS(1436),
    [anon_sym__Atomic] = ACTIONS(1436),
    [anon_sym_pipe] = ACTIONS(1436),
    [anon_sym_signed] = ACTIONS(1436),
    [anon_sym_unsigned] = ACTIONS(1436),
    [anon_sym_long] = ACTIONS(1436),
    [anon_sym_short] = ACTIONS(1436),
    [anon_sym_bool] = ACTIONS(1436),
    [anon_sym_char] = ACTIONS(1436),
    [anon_sym_uchar] = ACTIONS(1436),
    [anon_sym_ushort] = ACTIONS(1436),
    [anon_sym_int] = ACTIONS(1436),
    [anon_sym_uint] = ACTIONS(1436),
    [anon_sym_ulong] = ACTIONS(1436),
    [anon_sym_float] = ACTIONS(1436),
    [anon_sym_double] = ACTIONS(1436),
    [anon_sym_half] = ACTIONS(1436),
    [anon_sym_size_t] = ACTIONS(1436),
    [anon_sym_ptrdiff_t] = ACTIONS(1436),
    [anon_sym_intptr_t] = ACTIONS(1436),
    [anon_sym_uintptr_t] = ACTIONS(1436),
    [anon_sym_void] = ACTIONS(1436),
    [sym_vector_type] = ACTIONS(1436),
    [anon_sym_image2d_t] = ACTIONS(1436),
    [anon_sym_image3d_t] = ACTIONS(1436),
    [anon_sym_image2d_array_t] = ACTIONS(1436),
    [anon_sym_image1d_t] = ACTIONS(1436),
    [anon_sym_image1d_buffer_t] = ACTIONS(1436),
    [anon_sym_image1d_array_t] = ACTIONS(1436),
    [anon_sym_image2d_depth_t] = ACTIONS(1436),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1436),
    [anon_sym_sampler_t] = ACTIONS(1436),
    [anon_sym_queue_t] = ACTIONS(1436),
    [anon_sym_ndrange_t] = ACTIONS(1436),
    [anon_sym_clk_event_t] = ACTIONS(1436),
    [anon_sym_reserve_id_t] = ACTIONS(1436),
    [anon_sym_event_t] = ACTIONS(1436),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1436),
    [anon_sym_enum] = ACTIONS(1436),
    [anon_sym_struct] = ACTIONS(1436),
    [anon_sym_union] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
  },
  [402] = {
    [sym_identifier] = ACTIONS(1456),
    [aux_sym_preproc_def_token1] = ACTIONS(1456),
    [aux_sym_preproc_if_token1] = ACTIONS(1456),
    [aux_sym_preproc_if_token2] = ACTIONS(1456),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1456),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1456),
    [sym_preproc_directive] = ACTIONS(1456),
    [anon_sym_kernel] = ACTIONS(1456),
    [anon_sym___kernel] = ACTIONS(1456),
    [anon_sym_global] = ACTIONS(1456),
    [anon_sym___global] = ACTIONS(1456),
    [anon_sym_local] = ACTIONS(1456),
    [anon_sym___local] = ACTIONS(1456),
    [anon_sym_constant] = ACTIONS(1456),
    [anon_sym___constant] = ACTIONS(1456),
    [anon_sym_private] = ACTIONS(1456),
    [anon_sym___private] = ACTIONS(1456),
    [anon_sym_generic] = ACTIONS(1456),
    [anon_sym___generic] = ACTIONS(1456),
    [anon_sym_read_only] = ACTIONS(1456),
    [anon_sym___read_only] = ACTIONS(1456),
    [anon_sym_write_only] = ACTIONS(1456),
    [anon_sym___write_only] = ACTIONS(1456),
    [anon_sym_read_write] = ACTIONS(1456),
    [anon_sym___read_write] = ACTIONS(1456),
    [anon_sym_extern] = ACTIONS(1456),
    [anon_sym___attribute__] = ACTIONS(1456),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1458),
    [anon_sym___declspec] = ACTIONS(1456),
    [anon_sym_static] = ACTIONS(1456),
    [anon_sym_auto] = ACTIONS(1456),
    [anon_sym_register] = ACTIONS(1456),
    [anon_sym_inline] = ACTIONS(1456),
    [anon_sym_const] = ACTIONS(1456),
    [anon_sym_volatile] = ACTIONS(1456),
    [anon_sym_restrict] = ACTIONS(1456),
    [anon_sym__Atomic] = ACTIONS(1456),
    [anon_sym_pipe] = ACTIONS(1456),
    [anon_sym_signed] = ACTIONS(1456),
    [anon_sym_unsigned] = ACTIONS(1456),
    [anon_sym_long] = ACTIONS(1456),
    [anon_sym_short] = ACTIONS(1456),
    [anon_sym_bool] = ACTIONS(1456),
    [anon_sym_char] = ACTIONS(1456),
    [anon_sym_uchar] = ACTIONS(1456),
    [anon_sym_ushort] = ACTIONS(1456),
    [anon_sym_int] = ACTIONS(1456),
    [anon_sym_uint] = ACTIONS(1456),
    [anon_sym_ulong] = ACTIONS(1456),
    [anon_sym_float] = ACTIONS(1456),
    [anon_sym_double] = ACTIONS(1456),
    [anon_sym_half] = ACTIONS(1456),
    [anon_sym_size_t] = ACTIONS(1456),
    [anon_sym_ptrdiff_t] = ACTIONS(1456),
    [anon_sym_intptr_t] = ACTIONS(1456),
    [anon_sym_uintptr_t] = ACTIONS(1456),
    [anon_sym_void] = ACTIONS(1456),
    [sym_vector_type] = ACTIONS(1456),
    [anon_sym_image2d_t] = ACTIONS(1456),
    [anon_sym_image3d_t] = ACTIONS(1456),
    [anon_sym_image2d_array_t] = ACTIONS(1456),
    [anon_sym_image1d_t] = ACTIONS(1456),
    [anon_sym_image1d_buffer_t] = ACTIONS(1456),
    [anon_sym_image1d_array_t] = ACTIONS(1456),
    [anon_sym_image2d_depth_t] = ACTIONS(1456),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1456),
    [anon_sym_sampler_t] = ACTIONS(1456),
    [anon_sym_queue_t] = ACTIONS(1456),
    [anon_sym_ndrange_t] = ACTIONS(1456),
    [anon_sym_clk_event_t] = ACTIONS(1456),
    [anon_sym_reserve_id_t] = ACTIONS(1456),
    [anon_sym_event_t] = ACTIONS(1456),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1456),
    [anon_sym_enum] = ACTIONS(1456),
    [anon_sym_struct] = ACTIONS(1456),
    [anon_sym_union] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
  },
  [403] = {
    [sym_identifier] = ACTIONS(1448),
    [aux_sym_preproc_def_token1] = ACTIONS(1448),
    [aux_sym_preproc_if_token1] = ACTIONS(1448),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1448),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1448),
    [sym_preproc_directive] = ACTIONS(1448),
    [anon_sym_kernel] = ACTIONS(1448),
    [anon_sym___kernel] = ACTIONS(1448),
    [anon_sym_global] = ACTIONS(1448),
    [anon_sym___global] = ACTIONS(1448),
    [anon_sym_local] = ACTIONS(1448),
    [anon_sym___local] = ACTIONS(1448),
    [anon_sym_constant] = ACTIONS(1448),
    [anon_sym___constant] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym___private] = ACTIONS(1448),
    [anon_sym_generic] = ACTIONS(1448),
    [anon_sym___generic] = ACTIONS(1448),
    [anon_sym_read_only] = ACTIONS(1448),
    [anon_sym___read_only] = ACTIONS(1448),
    [anon_sym_write_only] = ACTIONS(1448),
    [anon_sym___write_only] = ACTIONS(1448),
    [anon_sym_read_write] = ACTIONS(1448),
    [anon_sym___read_write] = ACTIONS(1448),
    [anon_sym_extern] = ACTIONS(1448),
    [anon_sym___attribute__] = ACTIONS(1448),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1450),
    [anon_sym___declspec] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_auto] = ACTIONS(1448),
    [anon_sym_register] = ACTIONS(1448),
    [anon_sym_inline] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_volatile] = ACTIONS(1448),
    [anon_sym_restrict] = ACTIONS(1448),
    [anon_sym__Atomic] = ACTIONS(1448),
    [anon_sym_pipe] = ACTIONS(1448),
    [anon_sym_signed] = ACTIONS(1448),
    [anon_sym_unsigned] = ACTIONS(1448),
    [anon_sym_long] = ACTIONS(1448),
    [anon_sym_short] = ACTIONS(1448),
    [anon_sym_bool] = ACTIONS(1448),
    [anon_sym_char] = ACTIONS(1448),
    [anon_sym_uchar] = ACTIONS(1448),
    [anon_sym_ushort] = ACTIONS(1448),
    [anon_sym_int] = ACTIONS(1448),
    [anon_sym_uint] = ACTIONS(1448),
    [anon_sym_ulong] = ACTIONS(1448),
    [anon_sym_float] = ACTIONS(1448),
    [anon_sym_double] = ACTIONS(1448),
    [anon_sym_half] = ACTIONS(1448),
    [anon_sym_size_t] = ACTIONS(1448),
    [anon_sym_ptrdiff_t] = ACTIONS(1448),
    [anon_sym_intptr_t] = ACTIONS(1448),
    [anon_sym_uintptr_t] = ACTIONS(1448),
    [anon_sym_void] = ACTIONS(1448),
    [sym_vector_type] = ACTIONS(1448),
    [anon_sym_image2d_t] = ACTIONS(1448),
    [anon_sym_image3d_t] = ACTIONS(1448),
    [anon_sym_image2d_array_t] = ACTIONS(1448),
    [anon_sym_image1d_t] = ACTIONS(1448),
    [anon_sym_image1d_buffer_t] = ACTIONS(1448),
    [anon_sym_image1d_array_t] = ACTIONS(1448),
    [anon_sym_image2d_depth_t] = ACTIONS(1448),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1448),
    [anon_sym_sampler_t] = ACTIONS(1448),
    [anon_sym_queue_t] = ACTIONS(1448),
    [anon_sym_ndrange_t] = ACTIONS(1448),
    [anon_sym_clk_event_t] = ACTIONS(1448),
    [anon_sym_reserve_id_t] = ACTIONS(1448),
    [anon_sym_event_t] = ACTIONS(1448),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1448),
    [anon_sym_enum] = ACTIONS(1448),
    [anon_sym_struct] = ACTIONS(1448),
    [anon_sym_union] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
  },
  [404] = {
    [sym_identifier] = ACTIONS(1464),
    [aux_sym_preproc_def_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token1] = ACTIONS(1464),
    [aux_sym_preproc_if_token2] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1464),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1464),
    [sym_preproc_directive] = ACTIONS(1464),
    [anon_sym_kernel] = ACTIONS(1464),
    [anon_sym___kernel] = ACTIONS(1464),
    [anon_sym_global] = ACTIONS(1464),
    [anon_sym___global] = ACTIONS(1464),
    [anon_sym_local] = ACTIONS(1464),
    [anon_sym___local] = ACTIONS(1464),
    [anon_sym_constant] = ACTIONS(1464),
    [anon_sym___constant] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym___private] = ACTIONS(1464),
    [anon_sym_generic] = ACTIONS(1464),
    [anon_sym___generic] = ACTIONS(1464),
    [anon_sym_read_only] = ACTIONS(1464),
    [anon_sym___read_only] = ACTIONS(1464),
    [anon_sym_write_only] = ACTIONS(1464),
    [anon_sym___write_only] = ACTIONS(1464),
    [anon_sym_read_write] = ACTIONS(1464),
    [anon_sym___read_write] = ACTIONS(1464),
    [anon_sym_extern] = ACTIONS(1464),
    [anon_sym___attribute__] = ACTIONS(1464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1466),
    [anon_sym___declspec] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_auto] = ACTIONS(1464),
    [anon_sym_register] = ACTIONS(1464),
    [anon_sym_inline] = ACTIONS(1464),
    [anon_sym_const] = ACTIONS(1464),
    [anon_sym_volatile] = ACTIONS(1464),
    [anon_sym_restrict] = ACTIONS(1464),
    [anon_sym__Atomic] = ACTIONS(1464),
    [anon_sym_pipe] = ACTIONS(1464),
    [anon_sym_signed] = ACTIONS(1464),
    [anon_sym_unsigned] = ACTIONS(1464),
    [anon_sym_long] = ACTIONS(1464),
    [anon_sym_short] = ACTIONS(1464),
    [anon_sym_bool] = ACTIONS(1464),
    [anon_sym_char] = ACTIONS(1464),
    [anon_sym_uchar] = ACTIONS(1464),
    [anon_sym_ushort] = ACTIONS(1464),
    [anon_sym_int] = ACTIONS(1464),
    [anon_sym_uint] = ACTIONS(1464),
    [anon_sym_ulong] = ACTIONS(1464),
    [anon_sym_float] = ACTIONS(1464),
    [anon_sym_double] = ACTIONS(1464),
    [anon_sym_half] = ACTIONS(1464),
    [anon_sym_size_t] = ACTIONS(1464),
    [anon_sym_ptrdiff_t] = ACTIONS(1464),
    [anon_sym_intptr_t] = ACTIONS(1464),
    [anon_sym_uintptr_t] = ACTIONS(1464),
    [anon_sym_void] = ACTIONS(1464),
    [sym_vector_type] = ACTIONS(1464),
    [anon_sym_image2d_t] = ACTIONS(1464),
    [anon_sym_image3d_t] = ACTIONS(1464),
    [anon_sym_image2d_array_t] = ACTIONS(1464),
    [anon_sym_image1d_t] = ACTIONS(1464),
    [anon_sym_image1d_buffer_t] = ACTIONS(1464),
    [anon_sym_image1d_array_t] = ACTIONS(1464),
    [anon_sym_image2d_depth_t] = ACTIONS(1464),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1464),
    [anon_sym_sampler_t] = ACTIONS(1464),
    [anon_sym_queue_t] = ACTIONS(1464),
    [anon_sym_ndrange_t] = ACTIONS(1464),
    [anon_sym_clk_event_t] = ACTIONS(1464),
    [anon_sym_reserve_id_t] = ACTIONS(1464),
    [anon_sym_event_t] = ACTIONS(1464),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1464),
    [anon_sym_enum] = ACTIONS(1464),
    [anon_sym_struct] = ACTIONS(1464),
    [anon_sym_union] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
  },
  [405] = {
    [sym_identifier] = ACTIONS(1476),
    [aux_sym_preproc_def_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token1] = ACTIONS(1476),
    [aux_sym_preproc_if_token2] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1476),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1476),
    [sym_preproc_directive] = ACTIONS(1476),
    [anon_sym_kernel] = ACTIONS(1476),
    [anon_sym___kernel] = ACTIONS(1476),
    [anon_sym_global] = ACTIONS(1476),
    [anon_sym___global] = ACTIONS(1476),
    [anon_sym_local] = ACTIONS(1476),
    [anon_sym___local] = ACTIONS(1476),
    [anon_sym_constant] = ACTIONS(1476),
    [anon_sym___constant] = ACTIONS(1476),
    [anon_sym_private] = ACTIONS(1476),
    [anon_sym___private] = ACTIONS(1476),
    [anon_sym_generic] = ACTIONS(1476),
    [anon_sym___generic] = ACTIONS(1476),
    [anon_sym_read_only] = ACTIONS(1476),
    [anon_sym___read_only] = ACTIONS(1476),
    [anon_sym_write_only] = ACTIONS(1476),
    [anon_sym___write_only] = ACTIONS(1476),
    [anon_sym_read_write] = ACTIONS(1476),
    [anon_sym___read_write] = ACTIONS(1476),
    [anon_sym_extern] = ACTIONS(1476),
    [anon_sym___attribute__] = ACTIONS(1476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1478),
    [anon_sym___declspec] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1476),
    [anon_sym_auto] = ACTIONS(1476),
    [anon_sym_register] = ACTIONS(1476),
    [anon_sym_inline] = ACTIONS(1476),
    [anon_sym_const] = ACTIONS(1476),
    [anon_sym_volatile] = ACTIONS(1476),
    [anon_sym_restrict] = ACTIONS(1476),
    [anon_sym__Atomic] = ACTIONS(1476),
    [anon_sym_pipe] = ACTIONS(1476),
    [anon_sym_signed] = ACTIONS(1476),
    [anon_sym_unsigned] = ACTIONS(1476),
    [anon_sym_long] = ACTIONS(1476),
    [anon_sym_short] = ACTIONS(1476),
    [anon_sym_bool] = ACTIONS(1476),
    [anon_sym_char] = ACTIONS(1476),
    [anon_sym_uchar] = ACTIONS(1476),
    [anon_sym_ushort] = ACTIONS(1476),
    [anon_sym_int] = ACTIONS(1476),
    [anon_sym_uint] = ACTIONS(1476),
    [anon_sym_ulong] = ACTIONS(1476),
    [anon_sym_float] = ACTIONS(1476),
    [anon_sym_double] = ACTIONS(1476),
    [anon_sym_half] = ACTIONS(1476),
    [anon_sym_size_t] = ACTIONS(1476),
    [anon_sym_ptrdiff_t] = ACTIONS(1476),
    [anon_sym_intptr_t] = ACTIONS(1476),
    [anon_sym_uintptr_t] = ACTIONS(1476),
    [anon_sym_void] = ACTIONS(1476),
    [sym_vector_type] = ACTIONS(1476),
    [anon_sym_image2d_t] = ACTIONS(1476),
    [anon_sym_image3d_t] = ACTIONS(1476),
    [anon_sym_image2d_array_t] = ACTIONS(1476),
    [anon_sym_image1d_t] = ACTIONS(1476),
    [anon_sym_image1d_buffer_t] = ACTIONS(1476),
    [anon_sym_image1d_array_t] = ACTIONS(1476),
    [anon_sym_image2d_depth_t] = ACTIONS(1476),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1476),
    [anon_sym_sampler_t] = ACTIONS(1476),
    [anon_sym_queue_t] = ACTIONS(1476),
    [anon_sym_ndrange_t] = ACTIONS(1476),
    [anon_sym_clk_event_t] = ACTIONS(1476),
    [anon_sym_reserve_id_t] = ACTIONS(1476),
    [anon_sym_event_t] = ACTIONS(1476),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1476),
    [anon_sym_enum] = ACTIONS(1476),
    [anon_sym_struct] = ACTIONS(1476),
    [anon_sym_union] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [sym_identifier] = ACTIONS(1440),
    [aux_sym_preproc_def_token1] = ACTIONS(1440),
    [aux_sym_preproc_if_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1440),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1440),
    [sym_preproc_directive] = ACTIONS(1440),
    [anon_sym_kernel] = ACTIONS(1440),
    [anon_sym___kernel] = ACTIONS(1440),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym___global] = ACTIONS(1440),
    [anon_sym_local] = ACTIONS(1440),
    [anon_sym___local] = ACTIONS(1440),
    [anon_sym_constant] = ACTIONS(1440),
    [anon_sym___constant] = ACTIONS(1440),
    [anon_sym_private] = ACTIONS(1440),
    [anon_sym___private] = ACTIONS(1440),
    [anon_sym_generic] = ACTIONS(1440),
    [anon_sym___generic] = ACTIONS(1440),
    [anon_sym_read_only] = ACTIONS(1440),
    [anon_sym___read_only] = ACTIONS(1440),
    [anon_sym_write_only] = ACTIONS(1440),
    [anon_sym___write_only] = ACTIONS(1440),
    [anon_sym_read_write] = ACTIONS(1440),
    [anon_sym___read_write] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym___attribute__] = ACTIONS(1440),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1442),
    [anon_sym___declspec] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_auto] = ACTIONS(1440),
    [anon_sym_register] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym_const] = ACTIONS(1440),
    [anon_sym_volatile] = ACTIONS(1440),
    [anon_sym_restrict] = ACTIONS(1440),
    [anon_sym__Atomic] = ACTIONS(1440),
    [anon_sym_pipe] = ACTIONS(1440),
    [anon_sym_signed] = ACTIONS(1440),
    [anon_sym_unsigned] = ACTIONS(1440),
    [anon_sym_long] = ACTIONS(1440),
    [anon_sym_short] = ACTIONS(1440),
    [anon_sym_bool] = ACTIONS(1440),
    [anon_sym_char] = ACTIONS(1440),
    [anon_sym_uchar] = ACTIONS(1440),
    [anon_sym_ushort] = ACTIONS(1440),
    [anon_sym_int] = ACTIONS(1440),
    [anon_sym_uint] = ACTIONS(1440),
    [anon_sym_ulong] = ACTIONS(1440),
    [anon_sym_float] = ACTIONS(1440),
    [anon_sym_double] = ACTIONS(1440),
    [anon_sym_half] = ACTIONS(1440),
    [anon_sym_size_t] = ACTIONS(1440),
    [anon_sym_ptrdiff_t] = ACTIONS(1440),
    [anon_sym_intptr_t] = ACTIONS(1440),
    [anon_sym_uintptr_t] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(1440),
    [sym_vector_type] = ACTIONS(1440),
    [anon_sym_image2d_t] = ACTIONS(1440),
    [anon_sym_image3d_t] = ACTIONS(1440),
    [anon_sym_image2d_array_t] = ACTIONS(1440),
    [anon_sym_image1d_t] = ACTIONS(1440),
    [anon_sym_image1d_buffer_t] = ACTIONS(1440),
    [anon_sym_image1d_array_t] = ACTIONS(1440),
    [anon_sym_image2d_depth_t] = ACTIONS(1440),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1440),
    [anon_sym_sampler_t] = ACTIONS(1440),
    [anon_sym_queue_t] = ACTIONS(1440),
    [anon_sym_ndrange_t] = ACTIONS(1440),
    [anon_sym_clk_event_t] = ACTIONS(1440),
    [anon_sym_reserve_id_t] = ACTIONS(1440),
    [anon_sym_event_t] = ACTIONS(1440),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_struct] = ACTIONS(1440),
    [anon_sym_union] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
  },
  [407] = {
    [sym_identifier] = ACTIONS(1480),
    [aux_sym_preproc_def_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token1] = ACTIONS(1480),
    [aux_sym_preproc_if_token2] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1480),
    [sym_preproc_directive] = ACTIONS(1480),
    [anon_sym_kernel] = ACTIONS(1480),
    [anon_sym___kernel] = ACTIONS(1480),
    [anon_sym_global] = ACTIONS(1480),
    [anon_sym___global] = ACTIONS(1480),
    [anon_sym_local] = ACTIONS(1480),
    [anon_sym___local] = ACTIONS(1480),
    [anon_sym_constant] = ACTIONS(1480),
    [anon_sym___constant] = ACTIONS(1480),
    [anon_sym_private] = ACTIONS(1480),
    [anon_sym___private] = ACTIONS(1480),
    [anon_sym_generic] = ACTIONS(1480),
    [anon_sym___generic] = ACTIONS(1480),
    [anon_sym_read_only] = ACTIONS(1480),
    [anon_sym___read_only] = ACTIONS(1480),
    [anon_sym_write_only] = ACTIONS(1480),
    [anon_sym___write_only] = ACTIONS(1480),
    [anon_sym_read_write] = ACTIONS(1480),
    [anon_sym___read_write] = ACTIONS(1480),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym___attribute__] = ACTIONS(1480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1482),
    [anon_sym___declspec] = ACTIONS(1480),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_auto] = ACTIONS(1480),
    [anon_sym_register] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym_const] = ACTIONS(1480),
    [anon_sym_volatile] = ACTIONS(1480),
    [anon_sym_restrict] = ACTIONS(1480),
    [anon_sym__Atomic] = ACTIONS(1480),
    [anon_sym_pipe] = ACTIONS(1480),
    [anon_sym_signed] = ACTIONS(1480),
    [anon_sym_unsigned] = ACTIONS(1480),
    [anon_sym_long] = ACTIONS(1480),
    [anon_sym_short] = ACTIONS(1480),
    [anon_sym_bool] = ACTIONS(1480),
    [anon_sym_char] = ACTIONS(1480),
    [anon_sym_uchar] = ACTIONS(1480),
    [anon_sym_ushort] = ACTIONS(1480),
    [anon_sym_int] = ACTIONS(1480),
    [anon_sym_uint] = ACTIONS(1480),
    [anon_sym_ulong] = ACTIONS(1480),
    [anon_sym_float] = ACTIONS(1480),
    [anon_sym_double] = ACTIONS(1480),
    [anon_sym_half] = ACTIONS(1480),
    [anon_sym_size_t] = ACTIONS(1480),
    [anon_sym_ptrdiff_t] = ACTIONS(1480),
    [anon_sym_intptr_t] = ACTIONS(1480),
    [anon_sym_uintptr_t] = ACTIONS(1480),
    [anon_sym_void] = ACTIONS(1480),
    [sym_vector_type] = ACTIONS(1480),
    [anon_sym_image2d_t] = ACTIONS(1480),
    [anon_sym_image3d_t] = ACTIONS(1480),
    [anon_sym_image2d_array_t] = ACTIONS(1480),
    [anon_sym_image1d_t] = ACTIONS(1480),
    [anon_sym_image1d_buffer_t] = ACTIONS(1480),
    [anon_sym_image1d_array_t] = ACTIONS(1480),
    [anon_sym_image2d_depth_t] = ACTIONS(1480),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1480),
    [anon_sym_sampler_t] = ACTIONS(1480),
    [anon_sym_queue_t] = ACTIONS(1480),
    [anon_sym_ndrange_t] = ACTIONS(1480),
    [anon_sym_clk_event_t] = ACTIONS(1480),
    [anon_sym_reserve_id_t] = ACTIONS(1480),
    [anon_sym_event_t] = ACTIONS(1480),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_struct] = ACTIONS(1480),
    [anon_sym_union] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
  },
  [408] = {
    [sym_identifier] = ACTIONS(1484),
    [aux_sym_preproc_def_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token1] = ACTIONS(1484),
    [aux_sym_preproc_if_token2] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1484),
    [sym_preproc_directive] = ACTIONS(1484),
    [anon_sym_kernel] = ACTIONS(1484),
    [anon_sym___kernel] = ACTIONS(1484),
    [anon_sym_global] = ACTIONS(1484),
    [anon_sym___global] = ACTIONS(1484),
    [anon_sym_local] = ACTIONS(1484),
    [anon_sym___local] = ACTIONS(1484),
    [anon_sym_constant] = ACTIONS(1484),
    [anon_sym___constant] = ACTIONS(1484),
    [anon_sym_private] = ACTIONS(1484),
    [anon_sym___private] = ACTIONS(1484),
    [anon_sym_generic] = ACTIONS(1484),
    [anon_sym___generic] = ACTIONS(1484),
    [anon_sym_read_only] = ACTIONS(1484),
    [anon_sym___read_only] = ACTIONS(1484),
    [anon_sym_write_only] = ACTIONS(1484),
    [anon_sym___write_only] = ACTIONS(1484),
    [anon_sym_read_write] = ACTIONS(1484),
    [anon_sym___read_write] = ACTIONS(1484),
    [anon_sym_extern] = ACTIONS(1484),
    [anon_sym___attribute__] = ACTIONS(1484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1486),
    [anon_sym___declspec] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_auto] = ACTIONS(1484),
    [anon_sym_register] = ACTIONS(1484),
    [anon_sym_inline] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_volatile] = ACTIONS(1484),
    [anon_sym_restrict] = ACTIONS(1484),
    [anon_sym__Atomic] = ACTIONS(1484),
    [anon_sym_pipe] = ACTIONS(1484),
    [anon_sym_signed] = ACTIONS(1484),
    [anon_sym_unsigned] = ACTIONS(1484),
    [anon_sym_long] = ACTIONS(1484),
    [anon_sym_short] = ACTIONS(1484),
    [anon_sym_bool] = ACTIONS(1484),
    [anon_sym_char] = ACTIONS(1484),
    [anon_sym_uchar] = ACTIONS(1484),
    [anon_sym_ushort] = ACTIONS(1484),
    [anon_sym_int] = ACTIONS(1484),
    [anon_sym_uint] = ACTIONS(1484),
    [anon_sym_ulong] = ACTIONS(1484),
    [anon_sym_float] = ACTIONS(1484),
    [anon_sym_double] = ACTIONS(1484),
    [anon_sym_half] = ACTIONS(1484),
    [anon_sym_size_t] = ACTIONS(1484),
    [anon_sym_ptrdiff_t] = ACTIONS(1484),
    [anon_sym_intptr_t] = ACTIONS(1484),
    [anon_sym_uintptr_t] = ACTIONS(1484),
    [anon_sym_void] = ACTIONS(1484),
    [sym_vector_type] = ACTIONS(1484),
    [anon_sym_image2d_t] = ACTIONS(1484),
    [anon_sym_image3d_t] = ACTIONS(1484),
    [anon_sym_image2d_array_t] = ACTIONS(1484),
    [anon_sym_image1d_t] = ACTIONS(1484),
    [anon_sym_image1d_buffer_t] = ACTIONS(1484),
    [anon_sym_image1d_array_t] = ACTIONS(1484),
    [anon_sym_image2d_depth_t] = ACTIONS(1484),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1484),
    [anon_sym_sampler_t] = ACTIONS(1484),
    [anon_sym_queue_t] = ACTIONS(1484),
    [anon_sym_ndrange_t] = ACTIONS(1484),
    [anon_sym_clk_event_t] = ACTIONS(1484),
    [anon_sym_reserve_id_t] = ACTIONS(1484),
    [anon_sym_event_t] = ACTIONS(1484),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [anon_sym_struct] = ACTIONS(1484),
    [anon_sym_union] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
  },
  [409] = {
    [sym_identifier] = ACTIONS(1088),
    [aux_sym_preproc_def_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token1] = ACTIONS(1088),
    [aux_sym_preproc_if_token2] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1088),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1088),
    [sym_preproc_directive] = ACTIONS(1088),
    [anon_sym_kernel] = ACTIONS(1088),
    [anon_sym___kernel] = ACTIONS(1088),
    [anon_sym_global] = ACTIONS(1088),
    [anon_sym___global] = ACTIONS(1088),
    [anon_sym_local] = ACTIONS(1088),
    [anon_sym___local] = ACTIONS(1088),
    [anon_sym_constant] = ACTIONS(1088),
    [anon_sym___constant] = ACTIONS(1088),
    [anon_sym_private] = ACTIONS(1088),
    [anon_sym___private] = ACTIONS(1088),
    [anon_sym_generic] = ACTIONS(1088),
    [anon_sym___generic] = ACTIONS(1088),
    [anon_sym_read_only] = ACTIONS(1088),
    [anon_sym___read_only] = ACTIONS(1088),
    [anon_sym_write_only] = ACTIONS(1088),
    [anon_sym___write_only] = ACTIONS(1088),
    [anon_sym_read_write] = ACTIONS(1088),
    [anon_sym___read_write] = ACTIONS(1088),
    [anon_sym_extern] = ACTIONS(1088),
    [anon_sym___attribute__] = ACTIONS(1088),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1090),
    [anon_sym___declspec] = ACTIONS(1088),
    [anon_sym_static] = ACTIONS(1088),
    [anon_sym_auto] = ACTIONS(1088),
    [anon_sym_register] = ACTIONS(1088),
    [anon_sym_inline] = ACTIONS(1088),
    [anon_sym_const] = ACTIONS(1088),
    [anon_sym_volatile] = ACTIONS(1088),
    [anon_sym_restrict] = ACTIONS(1088),
    [anon_sym__Atomic] = ACTIONS(1088),
    [anon_sym_pipe] = ACTIONS(1088),
    [anon_sym_signed] = ACTIONS(1088),
    [anon_sym_unsigned] = ACTIONS(1088),
    [anon_sym_long] = ACTIONS(1088),
    [anon_sym_short] = ACTIONS(1088),
    [anon_sym_bool] = ACTIONS(1088),
    [anon_sym_char] = ACTIONS(1088),
    [anon_sym_uchar] = ACTIONS(1088),
    [anon_sym_ushort] = ACTIONS(1088),
    [anon_sym_int] = ACTIONS(1088),
    [anon_sym_uint] = ACTIONS(1088),
    [anon_sym_ulong] = ACTIONS(1088),
    [anon_sym_float] = ACTIONS(1088),
    [anon_sym_double] = ACTIONS(1088),
    [anon_sym_half] = ACTIONS(1088),
    [anon_sym_size_t] = ACTIONS(1088),
    [anon_sym_ptrdiff_t] = ACTIONS(1088),
    [anon_sym_intptr_t] = ACTIONS(1088),
    [anon_sym_uintptr_t] = ACTIONS(1088),
    [anon_sym_void] = ACTIONS(1088),
    [sym_vector_type] = ACTIONS(1088),
    [anon_sym_image2d_t] = ACTIONS(1088),
    [anon_sym_image3d_t] = ACTIONS(1088),
    [anon_sym_image2d_array_t] = ACTIONS(1088),
    [anon_sym_image1d_t] = ACTIONS(1088),
    [anon_sym_image1d_buffer_t] = ACTIONS(1088),
    [anon_sym_image1d_array_t] = ACTIONS(1088),
    [anon_sym_image2d_depth_t] = ACTIONS(1088),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1088),
    [anon_sym_sampler_t] = ACTIONS(1088),
    [anon_sym_queue_t] = ACTIONS(1088),
    [anon_sym_ndrange_t] = ACTIONS(1088),
    [anon_sym_clk_event_t] = ACTIONS(1088),
    [anon_sym_reserve_id_t] = ACTIONS(1088),
    [anon_sym_event_t] = ACTIONS(1088),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1088),
    [anon_sym_enum] = ACTIONS(1088),
    [anon_sym_struct] = ACTIONS(1088),
    [anon_sym_union] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [sym_identifier] = ACTIONS(1408),
    [aux_sym_preproc_def_token1] = ACTIONS(1408),
    [aux_sym_preproc_if_token1] = ACTIONS(1408),
    [aux_sym_preproc_if_token2] = ACTIONS(1408),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1408),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1408),
    [sym_preproc_directive] = ACTIONS(1408),
    [anon_sym_kernel] = ACTIONS(1408),
    [anon_sym___kernel] = ACTIONS(1408),
    [anon_sym_global] = ACTIONS(1408),
    [anon_sym___global] = ACTIONS(1408),
    [anon_sym_local] = ACTIONS(1408),
    [anon_sym___local] = ACTIONS(1408),
    [anon_sym_constant] = ACTIONS(1408),
    [anon_sym___constant] = ACTIONS(1408),
    [anon_sym_private] = ACTIONS(1408),
    [anon_sym___private] = ACTIONS(1408),
    [anon_sym_generic] = ACTIONS(1408),
    [anon_sym___generic] = ACTIONS(1408),
    [anon_sym_read_only] = ACTIONS(1408),
    [anon_sym___read_only] = ACTIONS(1408),
    [anon_sym_write_only] = ACTIONS(1408),
    [anon_sym___write_only] = ACTIONS(1408),
    [anon_sym_read_write] = ACTIONS(1408),
    [anon_sym___read_write] = ACTIONS(1408),
    [anon_sym_extern] = ACTIONS(1408),
    [anon_sym___attribute__] = ACTIONS(1408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1410),
    [anon_sym___declspec] = ACTIONS(1408),
    [anon_sym_static] = ACTIONS(1408),
    [anon_sym_auto] = ACTIONS(1408),
    [anon_sym_register] = ACTIONS(1408),
    [anon_sym_inline] = ACTIONS(1408),
    [anon_sym_const] = ACTIONS(1408),
    [anon_sym_volatile] = ACTIONS(1408),
    [anon_sym_restrict] = ACTIONS(1408),
    [anon_sym__Atomic] = ACTIONS(1408),
    [anon_sym_pipe] = ACTIONS(1408),
    [anon_sym_signed] = ACTIONS(1408),
    [anon_sym_unsigned] = ACTIONS(1408),
    [anon_sym_long] = ACTIONS(1408),
    [anon_sym_short] = ACTIONS(1408),
    [anon_sym_bool] = ACTIONS(1408),
    [anon_sym_char] = ACTIONS(1408),
    [anon_sym_uchar] = ACTIONS(1408),
    [anon_sym_ushort] = ACTIONS(1408),
    [anon_sym_int] = ACTIONS(1408),
    [anon_sym_uint] = ACTIONS(1408),
    [anon_sym_ulong] = ACTIONS(1408),
    [anon_sym_float] = ACTIONS(1408),
    [anon_sym_double] = ACTIONS(1408),
    [anon_sym_half] = ACTIONS(1408),
    [anon_sym_size_t] = ACTIONS(1408),
    [anon_sym_ptrdiff_t] = ACTIONS(1408),
    [anon_sym_intptr_t] = ACTIONS(1408),
    [anon_sym_uintptr_t] = ACTIONS(1408),
    [anon_sym_void] = ACTIONS(1408),
    [sym_vector_type] = ACTIONS(1408),
    [anon_sym_image2d_t] = ACTIONS(1408),
    [anon_sym_image3d_t] = ACTIONS(1408),
    [anon_sym_image2d_array_t] = ACTIONS(1408),
    [anon_sym_image1d_t] = ACTIONS(1408),
    [anon_sym_image1d_buffer_t] = ACTIONS(1408),
    [anon_sym_image1d_array_t] = ACTIONS(1408),
    [anon_sym_image2d_depth_t] = ACTIONS(1408),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1408),
    [anon_sym_sampler_t] = ACTIONS(1408),
    [anon_sym_queue_t] = ACTIONS(1408),
    [anon_sym_ndrange_t] = ACTIONS(1408),
    [anon_sym_clk_event_t] = ACTIONS(1408),
    [anon_sym_reserve_id_t] = ACTIONS(1408),
    [anon_sym_event_t] = ACTIONS(1408),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1408),
    [anon_sym_enum] = ACTIONS(1408),
    [anon_sym_struct] = ACTIONS(1408),
    [anon_sym_union] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_identifier] = ACTIONS(1072),
    [aux_sym_preproc_def_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token1] = ACTIONS(1072),
    [aux_sym_preproc_if_token2] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1072),
    [sym_preproc_directive] = ACTIONS(1072),
    [anon_sym_kernel] = ACTIONS(1072),
    [anon_sym___kernel] = ACTIONS(1072),
    [anon_sym_global] = ACTIONS(1072),
    [anon_sym___global] = ACTIONS(1072),
    [anon_sym_local] = ACTIONS(1072),
    [anon_sym___local] = ACTIONS(1072),
    [anon_sym_constant] = ACTIONS(1072),
    [anon_sym___constant] = ACTIONS(1072),
    [anon_sym_private] = ACTIONS(1072),
    [anon_sym___private] = ACTIONS(1072),
    [anon_sym_generic] = ACTIONS(1072),
    [anon_sym___generic] = ACTIONS(1072),
    [anon_sym_read_only] = ACTIONS(1072),
    [anon_sym___read_only] = ACTIONS(1072),
    [anon_sym_write_only] = ACTIONS(1072),
    [anon_sym___write_only] = ACTIONS(1072),
    [anon_sym_read_write] = ACTIONS(1072),
    [anon_sym___read_write] = ACTIONS(1072),
    [anon_sym_extern] = ACTIONS(1072),
    [anon_sym___attribute__] = ACTIONS(1072),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1074),
    [anon_sym___declspec] = ACTIONS(1072),
    [anon_sym_static] = ACTIONS(1072),
    [anon_sym_auto] = ACTIONS(1072),
    [anon_sym_register] = ACTIONS(1072),
    [anon_sym_inline] = ACTIONS(1072),
    [anon_sym_const] = ACTIONS(1072),
    [anon_sym_volatile] = ACTIONS(1072),
    [anon_sym_restrict] = ACTIONS(1072),
    [anon_sym__Atomic] = ACTIONS(1072),
    [anon_sym_pipe] = ACTIONS(1072),
    [anon_sym_signed] = ACTIONS(1072),
    [anon_sym_unsigned] = ACTIONS(1072),
    [anon_sym_long] = ACTIONS(1072),
    [anon_sym_short] = ACTIONS(1072),
    [anon_sym_bool] = ACTIONS(1072),
    [anon_sym_char] = ACTIONS(1072),
    [anon_sym_uchar] = ACTIONS(1072),
    [anon_sym_ushort] = ACTIONS(1072),
    [anon_sym_int] = ACTIONS(1072),
    [anon_sym_uint] = ACTIONS(1072),
    [anon_sym_ulong] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1072),
    [anon_sym_double] = ACTIONS(1072),
    [anon_sym_half] = ACTIONS(1072),
    [anon_sym_size_t] = ACTIONS(1072),
    [anon_sym_ptrdiff_t] = ACTIONS(1072),
    [anon_sym_intptr_t] = ACTIONS(1072),
    [anon_sym_uintptr_t] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1072),
    [sym_vector_type] = ACTIONS(1072),
    [anon_sym_image2d_t] = ACTIONS(1072),
    [anon_sym_image3d_t] = ACTIONS(1072),
    [anon_sym_image2d_array_t] = ACTIONS(1072),
    [anon_sym_image1d_t] = ACTIONS(1072),
    [anon_sym_image1d_buffer_t] = ACTIONS(1072),
    [anon_sym_image1d_array_t] = ACTIONS(1072),
    [anon_sym_image2d_depth_t] = ACTIONS(1072),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1072),
    [anon_sym_sampler_t] = ACTIONS(1072),
    [anon_sym_queue_t] = ACTIONS(1072),
    [anon_sym_ndrange_t] = ACTIONS(1072),
    [anon_sym_clk_event_t] = ACTIONS(1072),
    [anon_sym_reserve_id_t] = ACTIONS(1072),
    [anon_sym_event_t] = ACTIONS(1072),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1072),
    [anon_sym_enum] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1072),
    [anon_sym_union] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
  },
  [412] = {
    [sym_identifier] = ACTIONS(1468),
    [aux_sym_preproc_def_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1468),
    [sym_preproc_directive] = ACTIONS(1468),
    [anon_sym_kernel] = ACTIONS(1468),
    [anon_sym___kernel] = ACTIONS(1468),
    [anon_sym_global] = ACTIONS(1468),
    [anon_sym___global] = ACTIONS(1468),
    [anon_sym_local] = ACTIONS(1468),
    [anon_sym___local] = ACTIONS(1468),
    [anon_sym_constant] = ACTIONS(1468),
    [anon_sym___constant] = ACTIONS(1468),
    [anon_sym_private] = ACTIONS(1468),
    [anon_sym___private] = ACTIONS(1468),
    [anon_sym_generic] = ACTIONS(1468),
    [anon_sym___generic] = ACTIONS(1468),
    [anon_sym_read_only] = ACTIONS(1468),
    [anon_sym___read_only] = ACTIONS(1468),
    [anon_sym_write_only] = ACTIONS(1468),
    [anon_sym___write_only] = ACTIONS(1468),
    [anon_sym_read_write] = ACTIONS(1468),
    [anon_sym___read_write] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1468),
    [anon_sym___attribute__] = ACTIONS(1468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1470),
    [anon_sym___declspec] = ACTIONS(1468),
    [anon_sym_RBRACE] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_auto] = ACTIONS(1468),
    [anon_sym_register] = ACTIONS(1468),
    [anon_sym_inline] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_volatile] = ACTIONS(1468),
    [anon_sym_restrict] = ACTIONS(1468),
    [anon_sym__Atomic] = ACTIONS(1468),
    [anon_sym_pipe] = ACTIONS(1468),
    [anon_sym_signed] = ACTIONS(1468),
    [anon_sym_unsigned] = ACTIONS(1468),
    [anon_sym_long] = ACTIONS(1468),
    [anon_sym_short] = ACTIONS(1468),
    [anon_sym_bool] = ACTIONS(1468),
    [anon_sym_char] = ACTIONS(1468),
    [anon_sym_uchar] = ACTIONS(1468),
    [anon_sym_ushort] = ACTIONS(1468),
    [anon_sym_int] = ACTIONS(1468),
    [anon_sym_uint] = ACTIONS(1468),
    [anon_sym_ulong] = ACTIONS(1468),
    [anon_sym_float] = ACTIONS(1468),
    [anon_sym_double] = ACTIONS(1468),
    [anon_sym_half] = ACTIONS(1468),
    [anon_sym_size_t] = ACTIONS(1468),
    [anon_sym_ptrdiff_t] = ACTIONS(1468),
    [anon_sym_intptr_t] = ACTIONS(1468),
    [anon_sym_uintptr_t] = ACTIONS(1468),
    [anon_sym_void] = ACTIONS(1468),
    [sym_vector_type] = ACTIONS(1468),
    [anon_sym_image2d_t] = ACTIONS(1468),
    [anon_sym_image3d_t] = ACTIONS(1468),
    [anon_sym_image2d_array_t] = ACTIONS(1468),
    [anon_sym_image1d_t] = ACTIONS(1468),
    [anon_sym_image1d_buffer_t] = ACTIONS(1468),
    [anon_sym_image1d_array_t] = ACTIONS(1468),
    [anon_sym_image2d_depth_t] = ACTIONS(1468),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1468),
    [anon_sym_sampler_t] = ACTIONS(1468),
    [anon_sym_queue_t] = ACTIONS(1468),
    [anon_sym_ndrange_t] = ACTIONS(1468),
    [anon_sym_clk_event_t] = ACTIONS(1468),
    [anon_sym_reserve_id_t] = ACTIONS(1468),
    [anon_sym_event_t] = ACTIONS(1468),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [anon_sym_struct] = ACTIONS(1468),
    [anon_sym_union] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
  },
  [413] = {
    [sym_identifier] = ACTIONS(1108),
    [aux_sym_preproc_def_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token1] = ACTIONS(1108),
    [aux_sym_preproc_if_token2] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1108),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1108),
    [sym_preproc_directive] = ACTIONS(1108),
    [anon_sym_kernel] = ACTIONS(1108),
    [anon_sym___kernel] = ACTIONS(1108),
    [anon_sym_global] = ACTIONS(1108),
    [anon_sym___global] = ACTIONS(1108),
    [anon_sym_local] = ACTIONS(1108),
    [anon_sym___local] = ACTIONS(1108),
    [anon_sym_constant] = ACTIONS(1108),
    [anon_sym___constant] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym___private] = ACTIONS(1108),
    [anon_sym_generic] = ACTIONS(1108),
    [anon_sym___generic] = ACTIONS(1108),
    [anon_sym_read_only] = ACTIONS(1108),
    [anon_sym___read_only] = ACTIONS(1108),
    [anon_sym_write_only] = ACTIONS(1108),
    [anon_sym___write_only] = ACTIONS(1108),
    [anon_sym_read_write] = ACTIONS(1108),
    [anon_sym___read_write] = ACTIONS(1108),
    [anon_sym_extern] = ACTIONS(1108),
    [anon_sym___attribute__] = ACTIONS(1108),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1110),
    [anon_sym___declspec] = ACTIONS(1108),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_auto] = ACTIONS(1108),
    [anon_sym_register] = ACTIONS(1108),
    [anon_sym_inline] = ACTIONS(1108),
    [anon_sym_const] = ACTIONS(1108),
    [anon_sym_volatile] = ACTIONS(1108),
    [anon_sym_restrict] = ACTIONS(1108),
    [anon_sym__Atomic] = ACTIONS(1108),
    [anon_sym_pipe] = ACTIONS(1108),
    [anon_sym_signed] = ACTIONS(1108),
    [anon_sym_unsigned] = ACTIONS(1108),
    [anon_sym_long] = ACTIONS(1108),
    [anon_sym_short] = ACTIONS(1108),
    [anon_sym_bool] = ACTIONS(1108),
    [anon_sym_char] = ACTIONS(1108),
    [anon_sym_uchar] = ACTIONS(1108),
    [anon_sym_ushort] = ACTIONS(1108),
    [anon_sym_int] = ACTIONS(1108),
    [anon_sym_uint] = ACTIONS(1108),
    [anon_sym_ulong] = ACTIONS(1108),
    [anon_sym_float] = ACTIONS(1108),
    [anon_sym_double] = ACTIONS(1108),
    [anon_sym_half] = ACTIONS(1108),
    [anon_sym_size_t] = ACTIONS(1108),
    [anon_sym_ptrdiff_t] = ACTIONS(1108),
    [anon_sym_intptr_t] = ACTIONS(1108),
    [anon_sym_uintptr_t] = ACTIONS(1108),
    [anon_sym_void] = ACTIONS(1108),
    [sym_vector_type] = ACTIONS(1108),
    [anon_sym_image2d_t] = ACTIONS(1108),
    [anon_sym_image3d_t] = ACTIONS(1108),
    [anon_sym_image2d_array_t] = ACTIONS(1108),
    [anon_sym_image1d_t] = ACTIONS(1108),
    [anon_sym_image1d_buffer_t] = ACTIONS(1108),
    [anon_sym_image1d_array_t] = ACTIONS(1108),
    [anon_sym_image2d_depth_t] = ACTIONS(1108),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1108),
    [anon_sym_sampler_t] = ACTIONS(1108),
    [anon_sym_queue_t] = ACTIONS(1108),
    [anon_sym_ndrange_t] = ACTIONS(1108),
    [anon_sym_clk_event_t] = ACTIONS(1108),
    [anon_sym_reserve_id_t] = ACTIONS(1108),
    [anon_sym_event_t] = ACTIONS(1108),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [anon_sym_struct] = ACTIONS(1108),
    [anon_sym_union] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
  },
  [414] = {
    [sym_identifier] = ACTIONS(1096),
    [aux_sym_preproc_def_token1] = ACTIONS(1096),
    [aux_sym_preproc_if_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1096),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1096),
    [sym_preproc_directive] = ACTIONS(1096),
    [anon_sym_kernel] = ACTIONS(1096),
    [anon_sym___kernel] = ACTIONS(1096),
    [anon_sym_global] = ACTIONS(1096),
    [anon_sym___global] = ACTIONS(1096),
    [anon_sym_local] = ACTIONS(1096),
    [anon_sym___local] = ACTIONS(1096),
    [anon_sym_constant] = ACTIONS(1096),
    [anon_sym___constant] = ACTIONS(1096),
    [anon_sym_private] = ACTIONS(1096),
    [anon_sym___private] = ACTIONS(1096),
    [anon_sym_generic] = ACTIONS(1096),
    [anon_sym___generic] = ACTIONS(1096),
    [anon_sym_read_only] = ACTIONS(1096),
    [anon_sym___read_only] = ACTIONS(1096),
    [anon_sym_write_only] = ACTIONS(1096),
    [anon_sym___write_only] = ACTIONS(1096),
    [anon_sym_read_write] = ACTIONS(1096),
    [anon_sym___read_write] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1098),
    [anon_sym___declspec] = ACTIONS(1096),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_auto] = ACTIONS(1096),
    [anon_sym_register] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_const] = ACTIONS(1096),
    [anon_sym_volatile] = ACTIONS(1096),
    [anon_sym_restrict] = ACTIONS(1096),
    [anon_sym__Atomic] = ACTIONS(1096),
    [anon_sym_pipe] = ACTIONS(1096),
    [anon_sym_signed] = ACTIONS(1096),
    [anon_sym_unsigned] = ACTIONS(1096),
    [anon_sym_long] = ACTIONS(1096),
    [anon_sym_short] = ACTIONS(1096),
    [anon_sym_bool] = ACTIONS(1096),
    [anon_sym_char] = ACTIONS(1096),
    [anon_sym_uchar] = ACTIONS(1096),
    [anon_sym_ushort] = ACTIONS(1096),
    [anon_sym_int] = ACTIONS(1096),
    [anon_sym_uint] = ACTIONS(1096),
    [anon_sym_ulong] = ACTIONS(1096),
    [anon_sym_float] = ACTIONS(1096),
    [anon_sym_double] = ACTIONS(1096),
    [anon_sym_half] = ACTIONS(1096),
    [anon_sym_size_t] = ACTIONS(1096),
    [anon_sym_ptrdiff_t] = ACTIONS(1096),
    [anon_sym_intptr_t] = ACTIONS(1096),
    [anon_sym_uintptr_t] = ACTIONS(1096),
    [anon_sym_void] = ACTIONS(1096),
    [sym_vector_type] = ACTIONS(1096),
    [anon_sym_image2d_t] = ACTIONS(1096),
    [anon_sym_image3d_t] = ACTIONS(1096),
    [anon_sym_image2d_array_t] = ACTIONS(1096),
    [anon_sym_image1d_t] = ACTIONS(1096),
    [anon_sym_image1d_buffer_t] = ACTIONS(1096),
    [anon_sym_image1d_array_t] = ACTIONS(1096),
    [anon_sym_image2d_depth_t] = ACTIONS(1096),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1096),
    [anon_sym_sampler_t] = ACTIONS(1096),
    [anon_sym_queue_t] = ACTIONS(1096),
    [anon_sym_ndrange_t] = ACTIONS(1096),
    [anon_sym_clk_event_t] = ACTIONS(1096),
    [anon_sym_reserve_id_t] = ACTIONS(1096),
    [anon_sym_event_t] = ACTIONS(1096),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_struct] = ACTIONS(1096),
    [anon_sym_union] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_identifier] = ACTIONS(1120),
    [aux_sym_preproc_def_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token2] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1120),
    [sym_preproc_directive] = ACTIONS(1120),
    [anon_sym_kernel] = ACTIONS(1120),
    [anon_sym___kernel] = ACTIONS(1120),
    [anon_sym_global] = ACTIONS(1120),
    [anon_sym___global] = ACTIONS(1120),
    [anon_sym_local] = ACTIONS(1120),
    [anon_sym___local] = ACTIONS(1120),
    [anon_sym_constant] = ACTIONS(1120),
    [anon_sym___constant] = ACTIONS(1120),
    [anon_sym_private] = ACTIONS(1120),
    [anon_sym___private] = ACTIONS(1120),
    [anon_sym_generic] = ACTIONS(1120),
    [anon_sym___generic] = ACTIONS(1120),
    [anon_sym_read_only] = ACTIONS(1120),
    [anon_sym___read_only] = ACTIONS(1120),
    [anon_sym_write_only] = ACTIONS(1120),
    [anon_sym___write_only] = ACTIONS(1120),
    [anon_sym_read_write] = ACTIONS(1120),
    [anon_sym___read_write] = ACTIONS(1120),
    [anon_sym_extern] = ACTIONS(1120),
    [anon_sym___attribute__] = ACTIONS(1120),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1122),
    [anon_sym___declspec] = ACTIONS(1120),
    [anon_sym_static] = ACTIONS(1120),
    [anon_sym_auto] = ACTIONS(1120),
    [anon_sym_register] = ACTIONS(1120),
    [anon_sym_inline] = ACTIONS(1120),
    [anon_sym_const] = ACTIONS(1120),
    [anon_sym_volatile] = ACTIONS(1120),
    [anon_sym_restrict] = ACTIONS(1120),
    [anon_sym__Atomic] = ACTIONS(1120),
    [anon_sym_pipe] = ACTIONS(1120),
    [anon_sym_signed] = ACTIONS(1120),
    [anon_sym_unsigned] = ACTIONS(1120),
    [anon_sym_long] = ACTIONS(1120),
    [anon_sym_short] = ACTIONS(1120),
    [anon_sym_bool] = ACTIONS(1120),
    [anon_sym_char] = ACTIONS(1120),
    [anon_sym_uchar] = ACTIONS(1120),
    [anon_sym_ushort] = ACTIONS(1120),
    [anon_sym_int] = ACTIONS(1120),
    [anon_sym_uint] = ACTIONS(1120),
    [anon_sym_ulong] = ACTIONS(1120),
    [anon_sym_float] = ACTIONS(1120),
    [anon_sym_double] = ACTIONS(1120),
    [anon_sym_half] = ACTIONS(1120),
    [anon_sym_size_t] = ACTIONS(1120),
    [anon_sym_ptrdiff_t] = ACTIONS(1120),
    [anon_sym_intptr_t] = ACTIONS(1120),
    [anon_sym_uintptr_t] = ACTIONS(1120),
    [anon_sym_void] = ACTIONS(1120),
    [sym_vector_type] = ACTIONS(1120),
    [anon_sym_image2d_t] = ACTIONS(1120),
    [anon_sym_image3d_t] = ACTIONS(1120),
    [anon_sym_image2d_array_t] = ACTIONS(1120),
    [anon_sym_image1d_t] = ACTIONS(1120),
    [anon_sym_image1d_buffer_t] = ACTIONS(1120),
    [anon_sym_image1d_array_t] = ACTIONS(1120),
    [anon_sym_image2d_depth_t] = ACTIONS(1120),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1120),
    [anon_sym_sampler_t] = ACTIONS(1120),
    [anon_sym_queue_t] = ACTIONS(1120),
    [anon_sym_ndrange_t] = ACTIONS(1120),
    [anon_sym_clk_event_t] = ACTIONS(1120),
    [anon_sym_reserve_id_t] = ACTIONS(1120),
    [anon_sym_event_t] = ACTIONS(1120),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1120),
    [anon_sym_enum] = ACTIONS(1120),
    [anon_sym_struct] = ACTIONS(1120),
    [anon_sym_union] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
  },
  [416] = {
    [sym_identifier] = ACTIONS(1120),
    [aux_sym_preproc_def_token1] = ACTIONS(1120),
    [aux_sym_preproc_if_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1120),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1120),
    [sym_preproc_directive] = ACTIONS(1120),
    [anon_sym_kernel] = ACTIONS(1120),
    [anon_sym___kernel] = ACTIONS(1120),
    [anon_sym_global] = ACTIONS(1120),
    [anon_sym___global] = ACTIONS(1120),
    [anon_sym_local] = ACTIONS(1120),
    [anon_sym___local] = ACTIONS(1120),
    [anon_sym_constant] = ACTIONS(1120),
    [anon_sym___constant] = ACTIONS(1120),
    [anon_sym_private] = ACTIONS(1120),
    [anon_sym___private] = ACTIONS(1120),
    [anon_sym_generic] = ACTIONS(1120),
    [anon_sym___generic] = ACTIONS(1120),
    [anon_sym_read_only] = ACTIONS(1120),
    [anon_sym___read_only] = ACTIONS(1120),
    [anon_sym_write_only] = ACTIONS(1120),
    [anon_sym___write_only] = ACTIONS(1120),
    [anon_sym_read_write] = ACTIONS(1120),
    [anon_sym___read_write] = ACTIONS(1120),
    [anon_sym_extern] = ACTIONS(1120),
    [anon_sym___attribute__] = ACTIONS(1120),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1122),
    [anon_sym___declspec] = ACTIONS(1120),
    [anon_sym_RBRACE] = ACTIONS(1122),
    [anon_sym_static] = ACTIONS(1120),
    [anon_sym_auto] = ACTIONS(1120),
    [anon_sym_register] = ACTIONS(1120),
    [anon_sym_inline] = ACTIONS(1120),
    [anon_sym_const] = ACTIONS(1120),
    [anon_sym_volatile] = ACTIONS(1120),
    [anon_sym_restrict] = ACTIONS(1120),
    [anon_sym__Atomic] = ACTIONS(1120),
    [anon_sym_pipe] = ACTIONS(1120),
    [anon_sym_signed] = ACTIONS(1120),
    [anon_sym_unsigned] = ACTIONS(1120),
    [anon_sym_long] = ACTIONS(1120),
    [anon_sym_short] = ACTIONS(1120),
    [anon_sym_bool] = ACTIONS(1120),
    [anon_sym_char] = ACTIONS(1120),
    [anon_sym_uchar] = ACTIONS(1120),
    [anon_sym_ushort] = ACTIONS(1120),
    [anon_sym_int] = ACTIONS(1120),
    [anon_sym_uint] = ACTIONS(1120),
    [anon_sym_ulong] = ACTIONS(1120),
    [anon_sym_float] = ACTIONS(1120),
    [anon_sym_double] = ACTIONS(1120),
    [anon_sym_half] = ACTIONS(1120),
    [anon_sym_size_t] = ACTIONS(1120),
    [anon_sym_ptrdiff_t] = ACTIONS(1120),
    [anon_sym_intptr_t] = ACTIONS(1120),
    [anon_sym_uintptr_t] = ACTIONS(1120),
    [anon_sym_void] = ACTIONS(1120),
    [sym_vector_type] = ACTIONS(1120),
    [anon_sym_image2d_t] = ACTIONS(1120),
    [anon_sym_image3d_t] = ACTIONS(1120),
    [anon_sym_image2d_array_t] = ACTIONS(1120),
    [anon_sym_image1d_t] = ACTIONS(1120),
    [anon_sym_image1d_buffer_t] = ACTIONS(1120),
    [anon_sym_image1d_array_t] = ACTIONS(1120),
    [anon_sym_image2d_depth_t] = ACTIONS(1120),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1120),
    [anon_sym_sampler_t] = ACTIONS(1120),
    [anon_sym_queue_t] = ACTIONS(1120),
    [anon_sym_ndrange_t] = ACTIONS(1120),
    [anon_sym_clk_event_t] = ACTIONS(1120),
    [anon_sym_reserve_id_t] = ACTIONS(1120),
    [anon_sym_event_t] = ACTIONS(1120),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1120),
    [anon_sym_enum] = ACTIONS(1120),
    [anon_sym_struct] = ACTIONS(1120),
    [anon_sym_union] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
  },
  [417] = {
    [sym_identifier] = ACTIONS(1076),
    [aux_sym_preproc_def_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token1] = ACTIONS(1076),
    [aux_sym_preproc_if_token2] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1076),
    [sym_preproc_directive] = ACTIONS(1076),
    [anon_sym_kernel] = ACTIONS(1076),
    [anon_sym___kernel] = ACTIONS(1076),
    [anon_sym_global] = ACTIONS(1076),
    [anon_sym___global] = ACTIONS(1076),
    [anon_sym_local] = ACTIONS(1076),
    [anon_sym___local] = ACTIONS(1076),
    [anon_sym_constant] = ACTIONS(1076),
    [anon_sym___constant] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym___private] = ACTIONS(1076),
    [anon_sym_generic] = ACTIONS(1076),
    [anon_sym___generic] = ACTIONS(1076),
    [anon_sym_read_only] = ACTIONS(1076),
    [anon_sym___read_only] = ACTIONS(1076),
    [anon_sym_write_only] = ACTIONS(1076),
    [anon_sym___write_only] = ACTIONS(1076),
    [anon_sym_read_write] = ACTIONS(1076),
    [anon_sym___read_write] = ACTIONS(1076),
    [anon_sym_extern] = ACTIONS(1076),
    [anon_sym___attribute__] = ACTIONS(1076),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1078),
    [anon_sym___declspec] = ACTIONS(1076),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_auto] = ACTIONS(1076),
    [anon_sym_register] = ACTIONS(1076),
    [anon_sym_inline] = ACTIONS(1076),
    [anon_sym_const] = ACTIONS(1076),
    [anon_sym_volatile] = ACTIONS(1076),
    [anon_sym_restrict] = ACTIONS(1076),
    [anon_sym__Atomic] = ACTIONS(1076),
    [anon_sym_pipe] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(1076),
    [anon_sym_unsigned] = ACTIONS(1076),
    [anon_sym_long] = ACTIONS(1076),
    [anon_sym_short] = ACTIONS(1076),
    [anon_sym_bool] = ACTIONS(1076),
    [anon_sym_char] = ACTIONS(1076),
    [anon_sym_uchar] = ACTIONS(1076),
    [anon_sym_ushort] = ACTIONS(1076),
    [anon_sym_int] = ACTIONS(1076),
    [anon_sym_uint] = ACTIONS(1076),
    [anon_sym_ulong] = ACTIONS(1076),
    [anon_sym_float] = ACTIONS(1076),
    [anon_sym_double] = ACTIONS(1076),
    [anon_sym_half] = ACTIONS(1076),
    [anon_sym_size_t] = ACTIONS(1076),
    [anon_sym_ptrdiff_t] = ACTIONS(1076),
    [anon_sym_intptr_t] = ACTIONS(1076),
    [anon_sym_uintptr_t] = ACTIONS(1076),
    [anon_sym_void] = ACTIONS(1076),
    [sym_vector_type] = ACTIONS(1076),
    [anon_sym_image2d_t] = ACTIONS(1076),
    [anon_sym_image3d_t] = ACTIONS(1076),
    [anon_sym_image2d_array_t] = ACTIONS(1076),
    [anon_sym_image1d_t] = ACTIONS(1076),
    [anon_sym_image1d_buffer_t] = ACTIONS(1076),
    [anon_sym_image1d_array_t] = ACTIONS(1076),
    [anon_sym_image2d_depth_t] = ACTIONS(1076),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1076),
    [anon_sym_sampler_t] = ACTIONS(1076),
    [anon_sym_queue_t] = ACTIONS(1076),
    [anon_sym_ndrange_t] = ACTIONS(1076),
    [anon_sym_clk_event_t] = ACTIONS(1076),
    [anon_sym_reserve_id_t] = ACTIONS(1076),
    [anon_sym_event_t] = ACTIONS(1076),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1076),
    [anon_sym_enum] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1076),
    [anon_sym_union] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [418] = {
    [sym_identifier] = ACTIONS(1468),
    [aux_sym_preproc_def_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token1] = ACTIONS(1468),
    [aux_sym_preproc_if_token2] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1468),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1468),
    [sym_preproc_directive] = ACTIONS(1468),
    [anon_sym_kernel] = ACTIONS(1468),
    [anon_sym___kernel] = ACTIONS(1468),
    [anon_sym_global] = ACTIONS(1468),
    [anon_sym___global] = ACTIONS(1468),
    [anon_sym_local] = ACTIONS(1468),
    [anon_sym___local] = ACTIONS(1468),
    [anon_sym_constant] = ACTIONS(1468),
    [anon_sym___constant] = ACTIONS(1468),
    [anon_sym_private] = ACTIONS(1468),
    [anon_sym___private] = ACTIONS(1468),
    [anon_sym_generic] = ACTIONS(1468),
    [anon_sym___generic] = ACTIONS(1468),
    [anon_sym_read_only] = ACTIONS(1468),
    [anon_sym___read_only] = ACTIONS(1468),
    [anon_sym_write_only] = ACTIONS(1468),
    [anon_sym___write_only] = ACTIONS(1468),
    [anon_sym_read_write] = ACTIONS(1468),
    [anon_sym___read_write] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1468),
    [anon_sym___attribute__] = ACTIONS(1468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1470),
    [anon_sym___declspec] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_auto] = ACTIONS(1468),
    [anon_sym_register] = ACTIONS(1468),
    [anon_sym_inline] = ACTIONS(1468),
    [anon_sym_const] = ACTIONS(1468),
    [anon_sym_volatile] = ACTIONS(1468),
    [anon_sym_restrict] = ACTIONS(1468),
    [anon_sym__Atomic] = ACTIONS(1468),
    [anon_sym_pipe] = ACTIONS(1468),
    [anon_sym_signed] = ACTIONS(1468),
    [anon_sym_unsigned] = ACTIONS(1468),
    [anon_sym_long] = ACTIONS(1468),
    [anon_sym_short] = ACTIONS(1468),
    [anon_sym_bool] = ACTIONS(1468),
    [anon_sym_char] = ACTIONS(1468),
    [anon_sym_uchar] = ACTIONS(1468),
    [anon_sym_ushort] = ACTIONS(1468),
    [anon_sym_int] = ACTIONS(1468),
    [anon_sym_uint] = ACTIONS(1468),
    [anon_sym_ulong] = ACTIONS(1468),
    [anon_sym_float] = ACTIONS(1468),
    [anon_sym_double] = ACTIONS(1468),
    [anon_sym_half] = ACTIONS(1468),
    [anon_sym_size_t] = ACTIONS(1468),
    [anon_sym_ptrdiff_t] = ACTIONS(1468),
    [anon_sym_intptr_t] = ACTIONS(1468),
    [anon_sym_uintptr_t] = ACTIONS(1468),
    [anon_sym_void] = ACTIONS(1468),
    [sym_vector_type] = ACTIONS(1468),
    [anon_sym_image2d_t] = ACTIONS(1468),
    [anon_sym_image3d_t] = ACTIONS(1468),
    [anon_sym_image2d_array_t] = ACTIONS(1468),
    [anon_sym_image1d_t] = ACTIONS(1468),
    [anon_sym_image1d_buffer_t] = ACTIONS(1468),
    [anon_sym_image1d_array_t] = ACTIONS(1468),
    [anon_sym_image2d_depth_t] = ACTIONS(1468),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1468),
    [anon_sym_sampler_t] = ACTIONS(1468),
    [anon_sym_queue_t] = ACTIONS(1468),
    [anon_sym_ndrange_t] = ACTIONS(1468),
    [anon_sym_clk_event_t] = ACTIONS(1468),
    [anon_sym_reserve_id_t] = ACTIONS(1468),
    [anon_sym_event_t] = ACTIONS(1468),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [anon_sym_struct] = ACTIONS(1468),
    [anon_sym_union] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
  },
  [419] = {
    [sym__expression] = STATE(767),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(644),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(644),
    [sym_call_expression] = STATE(644),
    [sym_field_expression] = STATE(644),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(644),
    [sym_initializer_list] = STATE(684),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_LPAREN2] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1424),
    [anon_sym_PERCENT] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1414),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_CARET] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_EQ_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ] = ACTIONS(1414),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1414),
    [anon_sym_LT_EQ] = ACTIONS(1414),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1424),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_RBRACK] = ACTIONS(1414),
    [anon_sym_EQ] = ACTIONS(1424),
    [anon_sym_QMARK] = ACTIONS(1414),
    [anon_sym_STAR_EQ] = ACTIONS(1414),
    [anon_sym_SLASH_EQ] = ACTIONS(1414),
    [anon_sym_PERCENT_EQ] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(1414),
    [anon_sym_DASH_EQ] = ACTIONS(1414),
    [anon_sym_LT_LT_EQ] = ACTIONS(1414),
    [anon_sym_GT_GT_EQ] = ACTIONS(1414),
    [anon_sym_AMP_EQ] = ACTIONS(1414),
    [anon_sym_CARET_EQ] = ACTIONS(1414),
    [anon_sym_PIPE_EQ] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1510),
    [anon_sym_PLUS_PLUS] = ACTIONS(1510),
    [anon_sym_sizeof] = ACTIONS(1512),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [420] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(193),
    [sym_attributed_statement] = STATE(193),
    [sym_labeled_statement] = STATE(193),
    [sym_expression_statement] = STATE(193),
    [sym_if_statement] = STATE(193),
    [sym_switch_statement] = STATE(193),
    [sym_case_statement] = STATE(193),
    [sym_while_statement] = STATE(193),
    [sym_do_statement] = STATE(193),
    [sym_for_statement] = STATE(193),
    [sym_return_statement] = STATE(193),
    [sym_break_statement] = STATE(193),
    [sym_continue_statement] = STATE(193),
    [sym_goto_statement] = STATE(193),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [421] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(204),
    [sym_attributed_statement] = STATE(204),
    [sym_labeled_statement] = STATE(204),
    [sym_expression_statement] = STATE(204),
    [sym_if_statement] = STATE(204),
    [sym_switch_statement] = STATE(204),
    [sym_case_statement] = STATE(204),
    [sym_while_statement] = STATE(204),
    [sym_do_statement] = STATE(204),
    [sym_for_statement] = STATE(204),
    [sym_return_statement] = STATE(204),
    [sym_break_statement] = STATE(204),
    [sym_continue_statement] = STATE(204),
    [sym_goto_statement] = STATE(204),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(184),
    [sym_attributed_statement] = STATE(184),
    [sym_labeled_statement] = STATE(184),
    [sym_expression_statement] = STATE(184),
    [sym_if_statement] = STATE(184),
    [sym_switch_statement] = STATE(184),
    [sym_case_statement] = STATE(184),
    [sym_while_statement] = STATE(184),
    [sym_do_statement] = STATE(184),
    [sym_for_statement] = STATE(184),
    [sym_return_statement] = STATE(184),
    [sym_break_statement] = STATE(184),
    [sym_continue_statement] = STATE(184),
    [sym_goto_statement] = STATE(184),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [423] = {
    [sym_attribute_declaration] = STATE(423),
    [sym_compound_statement] = STATE(150),
    [sym_attributed_statement] = STATE(150),
    [sym_labeled_statement] = STATE(150),
    [sym_expression_statement] = STATE(150),
    [sym_if_statement] = STATE(150),
    [sym_switch_statement] = STATE(150),
    [sym_case_statement] = STATE(150),
    [sym_while_statement] = STATE(150),
    [sym_do_statement] = STATE(150),
    [sym_for_statement] = STATE(150),
    [sym_return_statement] = STATE(150),
    [sym_break_statement] = STATE(150),
    [sym_continue_statement] = STATE(150),
    [sym_goto_statement] = STATE(150),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(1520),
    [anon_sym_LPAREN2] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_switch] = ACTIONS(1547),
    [anon_sym_case] = ACTIONS(1550),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1556),
    [anon_sym_do] = ACTIONS(1559),
    [anon_sym_for] = ACTIONS(1562),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1568),
    [anon_sym_continue] = ACTIONS(1571),
    [anon_sym_goto] = ACTIONS(1574),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_sizeof] = ACTIONS(1580),
    [sym_number_literal] = ACTIONS(1583),
    [anon_sym_L_SQUOTE] = ACTIONS(1586),
    [anon_sym_u_SQUOTE] = ACTIONS(1586),
    [anon_sym_U_SQUOTE] = ACTIONS(1586),
    [anon_sym_u8_SQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [anon_sym_L_DQUOTE] = ACTIONS(1589),
    [anon_sym_u_DQUOTE] = ACTIONS(1589),
    [anon_sym_U_DQUOTE] = ACTIONS(1589),
    [anon_sym_u8_DQUOTE] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(201),
    [sym_attributed_statement] = STATE(201),
    [sym_labeled_statement] = STATE(201),
    [sym_expression_statement] = STATE(201),
    [sym_if_statement] = STATE(201),
    [sym_switch_statement] = STATE(201),
    [sym_case_statement] = STATE(201),
    [sym_while_statement] = STATE(201),
    [sym_do_statement] = STATE(201),
    [sym_for_statement] = STATE(201),
    [sym_return_statement] = STATE(201),
    [sym_break_statement] = STATE(201),
    [sym_continue_statement] = STATE(201),
    [sym_goto_statement] = STATE(201),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [425] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(91),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_case_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [426] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(159),
    [sym_attributed_statement] = STATE(159),
    [sym_labeled_statement] = STATE(159),
    [sym_expression_statement] = STATE(159),
    [sym_if_statement] = STATE(159),
    [sym_switch_statement] = STATE(159),
    [sym_case_statement] = STATE(159),
    [sym_while_statement] = STATE(159),
    [sym_do_statement] = STATE(159),
    [sym_for_statement] = STATE(159),
    [sym_return_statement] = STATE(159),
    [sym_break_statement] = STATE(159),
    [sym_continue_statement] = STATE(159),
    [sym_goto_statement] = STATE(159),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(190),
    [sym_attributed_statement] = STATE(190),
    [sym_labeled_statement] = STATE(190),
    [sym_expression_statement] = STATE(190),
    [sym_if_statement] = STATE(190),
    [sym_switch_statement] = STATE(190),
    [sym_case_statement] = STATE(190),
    [sym_while_statement] = STATE(190),
    [sym_do_statement] = STATE(190),
    [sym_for_statement] = STATE(190),
    [sym_return_statement] = STATE(190),
    [sym_break_statement] = STATE(190),
    [sym_continue_statement] = STATE(190),
    [sym_goto_statement] = STATE(190),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(192),
    [sym_attributed_statement] = STATE(192),
    [sym_labeled_statement] = STATE(192),
    [sym_expression_statement] = STATE(192),
    [sym_if_statement] = STATE(192),
    [sym_switch_statement] = STATE(192),
    [sym_case_statement] = STATE(192),
    [sym_while_statement] = STATE(192),
    [sym_do_statement] = STATE(192),
    [sym_for_statement] = STATE(192),
    [sym_return_statement] = STATE(192),
    [sym_break_statement] = STATE(192),
    [sym_continue_statement] = STATE(192),
    [sym_goto_statement] = STATE(192),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(219),
    [sym_attributed_statement] = STATE(219),
    [sym_labeled_statement] = STATE(219),
    [sym_expression_statement] = STATE(219),
    [sym_if_statement] = STATE(219),
    [sym_switch_statement] = STATE(219),
    [sym_case_statement] = STATE(219),
    [sym_while_statement] = STATE(219),
    [sym_do_statement] = STATE(219),
    [sym_for_statement] = STATE(219),
    [sym_return_statement] = STATE(219),
    [sym_break_statement] = STATE(219),
    [sym_continue_statement] = STATE(219),
    [sym_goto_statement] = STATE(219),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(216),
    [sym_attributed_statement] = STATE(216),
    [sym_labeled_statement] = STATE(216),
    [sym_expression_statement] = STATE(216),
    [sym_if_statement] = STATE(216),
    [sym_switch_statement] = STATE(216),
    [sym_case_statement] = STATE(216),
    [sym_while_statement] = STATE(216),
    [sym_do_statement] = STATE(216),
    [sym_for_statement] = STATE(216),
    [sym_return_statement] = STATE(216),
    [sym_break_statement] = STATE(216),
    [sym_continue_statement] = STATE(216),
    [sym_goto_statement] = STATE(216),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(1484),
    [sym_attributed_statement] = STATE(1484),
    [sym_labeled_statement] = STATE(1484),
    [sym_expression_statement] = STATE(1484),
    [sym_if_statement] = STATE(1484),
    [sym_switch_statement] = STATE(1484),
    [sym_case_statement] = STATE(1484),
    [sym_while_statement] = STATE(1484),
    [sym_do_statement] = STATE(1484),
    [sym_for_statement] = STATE(1484),
    [sym_return_statement] = STATE(1484),
    [sym_break_statement] = STATE(1484),
    [sym_continue_statement] = STATE(1484),
    [sym_goto_statement] = STATE(1484),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [432] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(181),
    [sym_attributed_statement] = STATE(181),
    [sym_labeled_statement] = STATE(181),
    [sym_expression_statement] = STATE(181),
    [sym_if_statement] = STATE(181),
    [sym_switch_statement] = STATE(181),
    [sym_case_statement] = STATE(181),
    [sym_while_statement] = STATE(181),
    [sym_do_statement] = STATE(181),
    [sym_for_statement] = STATE(181),
    [sym_return_statement] = STATE(181),
    [sym_break_statement] = STATE(181),
    [sym_continue_statement] = STATE(181),
    [sym_goto_statement] = STATE(181),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(209),
    [sym_attributed_statement] = STATE(209),
    [sym_labeled_statement] = STATE(209),
    [sym_expression_statement] = STATE(209),
    [sym_if_statement] = STATE(209),
    [sym_switch_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_do_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_return_statement] = STATE(209),
    [sym_break_statement] = STATE(209),
    [sym_continue_statement] = STATE(209),
    [sym_goto_statement] = STATE(209),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(163),
    [sym_attributed_statement] = STATE(163),
    [sym_labeled_statement] = STATE(163),
    [sym_expression_statement] = STATE(163),
    [sym_if_statement] = STATE(163),
    [sym_switch_statement] = STATE(163),
    [sym_case_statement] = STATE(163),
    [sym_while_statement] = STATE(163),
    [sym_do_statement] = STATE(163),
    [sym_for_statement] = STATE(163),
    [sym_return_statement] = STATE(163),
    [sym_break_statement] = STATE(163),
    [sym_continue_statement] = STATE(163),
    [sym_goto_statement] = STATE(163),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [435] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(179),
    [sym_attributed_statement] = STATE(179),
    [sym_labeled_statement] = STATE(179),
    [sym_expression_statement] = STATE(179),
    [sym_if_statement] = STATE(179),
    [sym_switch_statement] = STATE(179),
    [sym_case_statement] = STATE(179),
    [sym_while_statement] = STATE(179),
    [sym_do_statement] = STATE(179),
    [sym_for_statement] = STATE(179),
    [sym_return_statement] = STATE(179),
    [sym_break_statement] = STATE(179),
    [sym_continue_statement] = STATE(179),
    [sym_goto_statement] = STATE(179),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [436] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(170),
    [sym_attributed_statement] = STATE(170),
    [sym_labeled_statement] = STATE(170),
    [sym_expression_statement] = STATE(170),
    [sym_if_statement] = STATE(170),
    [sym_switch_statement] = STATE(170),
    [sym_case_statement] = STATE(170),
    [sym_while_statement] = STATE(170),
    [sym_do_statement] = STATE(170),
    [sym_for_statement] = STATE(170),
    [sym_return_statement] = STATE(170),
    [sym_break_statement] = STATE(170),
    [sym_continue_statement] = STATE(170),
    [sym_goto_statement] = STATE(170),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [437] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(169),
    [sym_attributed_statement] = STATE(169),
    [sym_labeled_statement] = STATE(169),
    [sym_expression_statement] = STATE(169),
    [sym_if_statement] = STATE(169),
    [sym_switch_statement] = STATE(169),
    [sym_case_statement] = STATE(169),
    [sym_while_statement] = STATE(169),
    [sym_do_statement] = STATE(169),
    [sym_for_statement] = STATE(169),
    [sym_return_statement] = STATE(169),
    [sym_break_statement] = STATE(169),
    [sym_continue_statement] = STATE(169),
    [sym_goto_statement] = STATE(169),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [438] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(124),
    [sym_attributed_statement] = STATE(124),
    [sym_labeled_statement] = STATE(124),
    [sym_expression_statement] = STATE(124),
    [sym_if_statement] = STATE(124),
    [sym_switch_statement] = STATE(124),
    [sym_case_statement] = STATE(124),
    [sym_while_statement] = STATE(124),
    [sym_do_statement] = STATE(124),
    [sym_for_statement] = STATE(124),
    [sym_return_statement] = STATE(124),
    [sym_break_statement] = STATE(124),
    [sym_continue_statement] = STATE(124),
    [sym_goto_statement] = STATE(124),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [439] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [440] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(158),
    [sym_attributed_statement] = STATE(158),
    [sym_labeled_statement] = STATE(158),
    [sym_expression_statement] = STATE(158),
    [sym_if_statement] = STATE(158),
    [sym_switch_statement] = STATE(158),
    [sym_case_statement] = STATE(158),
    [sym_while_statement] = STATE(158),
    [sym_do_statement] = STATE(158),
    [sym_for_statement] = STATE(158),
    [sym_return_statement] = STATE(158),
    [sym_break_statement] = STATE(158),
    [sym_continue_statement] = STATE(158),
    [sym_goto_statement] = STATE(158),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [441] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(154),
    [sym_attributed_statement] = STATE(154),
    [sym_labeled_statement] = STATE(154),
    [sym_expression_statement] = STATE(154),
    [sym_if_statement] = STATE(154),
    [sym_switch_statement] = STATE(154),
    [sym_case_statement] = STATE(154),
    [sym_while_statement] = STATE(154),
    [sym_do_statement] = STATE(154),
    [sym_for_statement] = STATE(154),
    [sym_return_statement] = STATE(154),
    [sym_break_statement] = STATE(154),
    [sym_continue_statement] = STATE(154),
    [sym_goto_statement] = STATE(154),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [442] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(152),
    [sym_attributed_statement] = STATE(152),
    [sym_labeled_statement] = STATE(152),
    [sym_expression_statement] = STATE(152),
    [sym_if_statement] = STATE(152),
    [sym_switch_statement] = STATE(152),
    [sym_case_statement] = STATE(152),
    [sym_while_statement] = STATE(152),
    [sym_do_statement] = STATE(152),
    [sym_for_statement] = STATE(152),
    [sym_return_statement] = STATE(152),
    [sym_break_statement] = STATE(152),
    [sym_continue_statement] = STATE(152),
    [sym_goto_statement] = STATE(152),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [443] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(137),
    [sym_attributed_statement] = STATE(137),
    [sym_labeled_statement] = STATE(137),
    [sym_expression_statement] = STATE(137),
    [sym_if_statement] = STATE(137),
    [sym_switch_statement] = STATE(137),
    [sym_case_statement] = STATE(137),
    [sym_while_statement] = STATE(137),
    [sym_do_statement] = STATE(137),
    [sym_for_statement] = STATE(137),
    [sym_return_statement] = STATE(137),
    [sym_break_statement] = STATE(137),
    [sym_continue_statement] = STATE(137),
    [sym_goto_statement] = STATE(137),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [444] = {
    [sym_attribute_declaration] = STATE(423),
    [sym_compound_statement] = STATE(150),
    [sym_attributed_statement] = STATE(150),
    [sym_labeled_statement] = STATE(150),
    [sym_expression_statement] = STATE(150),
    [sym_if_statement] = STATE(150),
    [sym_switch_statement] = STATE(150),
    [sym_case_statement] = STATE(150),
    [sym_while_statement] = STATE(150),
    [sym_do_statement] = STATE(150),
    [sym_for_statement] = STATE(150),
    [sym_return_statement] = STATE(150),
    [sym_break_statement] = STATE(150),
    [sym_continue_statement] = STATE(150),
    [sym_goto_statement] = STATE(150),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [445] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(149),
    [sym_attributed_statement] = STATE(149),
    [sym_labeled_statement] = STATE(149),
    [sym_expression_statement] = STATE(149),
    [sym_if_statement] = STATE(149),
    [sym_switch_statement] = STATE(149),
    [sym_case_statement] = STATE(149),
    [sym_while_statement] = STATE(149),
    [sym_do_statement] = STATE(149),
    [sym_for_statement] = STATE(149),
    [sym_return_statement] = STATE(149),
    [sym_break_statement] = STATE(149),
    [sym_continue_statement] = STATE(149),
    [sym_goto_statement] = STATE(149),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [446] = {
    [sym_attribute_declaration] = STATE(446),
    [sym_compound_statement] = STATE(75),
    [sym_attributed_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_case_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(446),
    [sym_identifier] = ACTIONS(1599),
    [anon_sym_LPAREN2] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1602),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(1608),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1614),
    [anon_sym_default] = ACTIONS(1617),
    [anon_sym_while] = ACTIONS(1620),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1626),
    [anon_sym_return] = ACTIONS(1629),
    [anon_sym_break] = ACTIONS(1632),
    [anon_sym_continue] = ACTIONS(1635),
    [anon_sym_goto] = ACTIONS(1638),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_sizeof] = ACTIONS(1580),
    [sym_number_literal] = ACTIONS(1583),
    [anon_sym_L_SQUOTE] = ACTIONS(1586),
    [anon_sym_u_SQUOTE] = ACTIONS(1586),
    [anon_sym_U_SQUOTE] = ACTIONS(1586),
    [anon_sym_u8_SQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [anon_sym_L_DQUOTE] = ACTIONS(1589),
    [anon_sym_u_DQUOTE] = ACTIONS(1589),
    [anon_sym_U_DQUOTE] = ACTIONS(1589),
    [anon_sym_u8_DQUOTE] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [sym_comment] = ACTIONS(3),
  },
  [447] = {
    [sym_attribute_declaration] = STATE(471),
    [sym_compound_statement] = STATE(206),
    [sym_attributed_statement] = STATE(206),
    [sym_labeled_statement] = STATE(206),
    [sym_expression_statement] = STATE(206),
    [sym_if_statement] = STATE(206),
    [sym_switch_statement] = STATE(206),
    [sym_case_statement] = STATE(206),
    [sym_while_statement] = STATE(206),
    [sym_do_statement] = STATE(206),
    [sym_for_statement] = STATE(206),
    [sym_return_statement] = STATE(206),
    [sym_break_statement] = STATE(206),
    [sym_continue_statement] = STATE(206),
    [sym_goto_statement] = STATE(206),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(471),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [448] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(132),
    [sym_attributed_statement] = STATE(132),
    [sym_labeled_statement] = STATE(132),
    [sym_expression_statement] = STATE(132),
    [sym_if_statement] = STATE(132),
    [sym_switch_statement] = STATE(132),
    [sym_case_statement] = STATE(132),
    [sym_while_statement] = STATE(132),
    [sym_do_statement] = STATE(132),
    [sym_for_statement] = STATE(132),
    [sym_return_statement] = STATE(132),
    [sym_break_statement] = STATE(132),
    [sym_continue_statement] = STATE(132),
    [sym_goto_statement] = STATE(132),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [449] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(83),
    [sym_attributed_statement] = STATE(83),
    [sym_labeled_statement] = STATE(83),
    [sym_expression_statement] = STATE(83),
    [sym_if_statement] = STATE(83),
    [sym_switch_statement] = STATE(83),
    [sym_case_statement] = STATE(83),
    [sym_while_statement] = STATE(83),
    [sym_do_statement] = STATE(83),
    [sym_for_statement] = STATE(83),
    [sym_return_statement] = STATE(83),
    [sym_break_statement] = STATE(83),
    [sym_continue_statement] = STATE(83),
    [sym_goto_statement] = STATE(83),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [450] = {
    [sym_attribute_declaration] = STATE(446),
    [sym_compound_statement] = STATE(75),
    [sym_attributed_statement] = STATE(75),
    [sym_labeled_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_switch_statement] = STATE(75),
    [sym_case_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(446),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [451] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(198),
    [sym_attributed_statement] = STATE(198),
    [sym_labeled_statement] = STATE(198),
    [sym_expression_statement] = STATE(198),
    [sym_if_statement] = STATE(198),
    [sym_switch_statement] = STATE(198),
    [sym_case_statement] = STATE(198),
    [sym_while_statement] = STATE(198),
    [sym_do_statement] = STATE(198),
    [sym_for_statement] = STATE(198),
    [sym_return_statement] = STATE(198),
    [sym_break_statement] = STATE(198),
    [sym_continue_statement] = STATE(198),
    [sym_goto_statement] = STATE(198),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [452] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(147),
    [sym_attributed_statement] = STATE(147),
    [sym_labeled_statement] = STATE(147),
    [sym_expression_statement] = STATE(147),
    [sym_if_statement] = STATE(147),
    [sym_switch_statement] = STATE(147),
    [sym_case_statement] = STATE(147),
    [sym_while_statement] = STATE(147),
    [sym_do_statement] = STATE(147),
    [sym_for_statement] = STATE(147),
    [sym_return_statement] = STATE(147),
    [sym_break_statement] = STATE(147),
    [sym_continue_statement] = STATE(147),
    [sym_goto_statement] = STATE(147),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [453] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(125),
    [sym_attributed_statement] = STATE(125),
    [sym_labeled_statement] = STATE(125),
    [sym_expression_statement] = STATE(125),
    [sym_if_statement] = STATE(125),
    [sym_switch_statement] = STATE(125),
    [sym_case_statement] = STATE(125),
    [sym_while_statement] = STATE(125),
    [sym_do_statement] = STATE(125),
    [sym_for_statement] = STATE(125),
    [sym_return_statement] = STATE(125),
    [sym_break_statement] = STATE(125),
    [sym_continue_statement] = STATE(125),
    [sym_goto_statement] = STATE(125),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [454] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(102),
    [sym_attributed_statement] = STATE(102),
    [sym_labeled_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym_if_statement] = STATE(102),
    [sym_switch_statement] = STATE(102),
    [sym_case_statement] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_do_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_break_statement] = STATE(102),
    [sym_continue_statement] = STATE(102),
    [sym_goto_statement] = STATE(102),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(98),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_case_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [456] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(127),
    [sym_attributed_statement] = STATE(127),
    [sym_labeled_statement] = STATE(127),
    [sym_expression_statement] = STATE(127),
    [sym_if_statement] = STATE(127),
    [sym_switch_statement] = STATE(127),
    [sym_case_statement] = STATE(127),
    [sym_while_statement] = STATE(127),
    [sym_do_statement] = STATE(127),
    [sym_for_statement] = STATE(127),
    [sym_return_statement] = STATE(127),
    [sym_break_statement] = STATE(127),
    [sym_continue_statement] = STATE(127),
    [sym_goto_statement] = STATE(127),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [457] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(228),
    [sym_attributed_statement] = STATE(228),
    [sym_labeled_statement] = STATE(228),
    [sym_expression_statement] = STATE(228),
    [sym_if_statement] = STATE(228),
    [sym_switch_statement] = STATE(228),
    [sym_case_statement] = STATE(228),
    [sym_while_statement] = STATE(228),
    [sym_do_statement] = STATE(228),
    [sym_for_statement] = STATE(228),
    [sym_return_statement] = STATE(228),
    [sym_break_statement] = STATE(228),
    [sym_continue_statement] = STATE(228),
    [sym_goto_statement] = STATE(228),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(97),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_case_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [459] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(203),
    [sym_attributed_statement] = STATE(203),
    [sym_labeled_statement] = STATE(203),
    [sym_expression_statement] = STATE(203),
    [sym_if_statement] = STATE(203),
    [sym_switch_statement] = STATE(203),
    [sym_case_statement] = STATE(203),
    [sym_while_statement] = STATE(203),
    [sym_do_statement] = STATE(203),
    [sym_for_statement] = STATE(203),
    [sym_return_statement] = STATE(203),
    [sym_break_statement] = STATE(203),
    [sym_continue_statement] = STATE(203),
    [sym_goto_statement] = STATE(203),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [460] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(86),
    [sym_attributed_statement] = STATE(86),
    [sym_labeled_statement] = STATE(86),
    [sym_expression_statement] = STATE(86),
    [sym_if_statement] = STATE(86),
    [sym_switch_statement] = STATE(86),
    [sym_case_statement] = STATE(86),
    [sym_while_statement] = STATE(86),
    [sym_do_statement] = STATE(86),
    [sym_for_statement] = STATE(86),
    [sym_return_statement] = STATE(86),
    [sym_break_statement] = STATE(86),
    [sym_continue_statement] = STATE(86),
    [sym_goto_statement] = STATE(86),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [461] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(142),
    [sym_attributed_statement] = STATE(142),
    [sym_labeled_statement] = STATE(142),
    [sym_expression_statement] = STATE(142),
    [sym_if_statement] = STATE(142),
    [sym_switch_statement] = STATE(142),
    [sym_case_statement] = STATE(142),
    [sym_while_statement] = STATE(142),
    [sym_do_statement] = STATE(142),
    [sym_for_statement] = STATE(142),
    [sym_return_statement] = STATE(142),
    [sym_break_statement] = STATE(142),
    [sym_continue_statement] = STATE(142),
    [sym_goto_statement] = STATE(142),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [462] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(81),
    [sym_attributed_statement] = STATE(81),
    [sym_labeled_statement] = STATE(81),
    [sym_expression_statement] = STATE(81),
    [sym_if_statement] = STATE(81),
    [sym_switch_statement] = STATE(81),
    [sym_case_statement] = STATE(81),
    [sym_while_statement] = STATE(81),
    [sym_do_statement] = STATE(81),
    [sym_for_statement] = STATE(81),
    [sym_return_statement] = STATE(81),
    [sym_break_statement] = STATE(81),
    [sym_continue_statement] = STATE(81),
    [sym_goto_statement] = STATE(81),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [463] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(226),
    [sym_attributed_statement] = STATE(226),
    [sym_labeled_statement] = STATE(226),
    [sym_expression_statement] = STATE(226),
    [sym_if_statement] = STATE(226),
    [sym_switch_statement] = STATE(226),
    [sym_case_statement] = STATE(226),
    [sym_while_statement] = STATE(226),
    [sym_do_statement] = STATE(226),
    [sym_for_statement] = STATE(226),
    [sym_return_statement] = STATE(226),
    [sym_break_statement] = STATE(226),
    [sym_continue_statement] = STATE(226),
    [sym_goto_statement] = STATE(226),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [464] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(87),
    [sym_attributed_statement] = STATE(87),
    [sym_labeled_statement] = STATE(87),
    [sym_expression_statement] = STATE(87),
    [sym_if_statement] = STATE(87),
    [sym_switch_statement] = STATE(87),
    [sym_case_statement] = STATE(87),
    [sym_while_statement] = STATE(87),
    [sym_do_statement] = STATE(87),
    [sym_for_statement] = STATE(87),
    [sym_return_statement] = STATE(87),
    [sym_break_statement] = STATE(87),
    [sym_continue_statement] = STATE(87),
    [sym_goto_statement] = STATE(87),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [465] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(194),
    [sym_attributed_statement] = STATE(194),
    [sym_labeled_statement] = STATE(194),
    [sym_expression_statement] = STATE(194),
    [sym_if_statement] = STATE(194),
    [sym_switch_statement] = STATE(194),
    [sym_case_statement] = STATE(194),
    [sym_while_statement] = STATE(194),
    [sym_do_statement] = STATE(194),
    [sym_for_statement] = STATE(194),
    [sym_return_statement] = STATE(194),
    [sym_break_statement] = STATE(194),
    [sym_continue_statement] = STATE(194),
    [sym_goto_statement] = STATE(194),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [466] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(1495),
    [sym_attributed_statement] = STATE(1495),
    [sym_labeled_statement] = STATE(1495),
    [sym_expression_statement] = STATE(1495),
    [sym_if_statement] = STATE(1495),
    [sym_switch_statement] = STATE(1495),
    [sym_case_statement] = STATE(1495),
    [sym_while_statement] = STATE(1495),
    [sym_do_statement] = STATE(1495),
    [sym_for_statement] = STATE(1495),
    [sym_return_statement] = STATE(1495),
    [sym_break_statement] = STATE(1495),
    [sym_continue_statement] = STATE(1495),
    [sym_goto_statement] = STATE(1495),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [467] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(200),
    [sym_attributed_statement] = STATE(200),
    [sym_labeled_statement] = STATE(200),
    [sym_expression_statement] = STATE(200),
    [sym_if_statement] = STATE(200),
    [sym_switch_statement] = STATE(200),
    [sym_case_statement] = STATE(200),
    [sym_while_statement] = STATE(200),
    [sym_do_statement] = STATE(200),
    [sym_for_statement] = STATE(200),
    [sym_return_statement] = STATE(200),
    [sym_break_statement] = STATE(200),
    [sym_continue_statement] = STATE(200),
    [sym_goto_statement] = STATE(200),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [468] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(88),
    [sym_attributed_statement] = STATE(88),
    [sym_labeled_statement] = STATE(88),
    [sym_expression_statement] = STATE(88),
    [sym_if_statement] = STATE(88),
    [sym_switch_statement] = STATE(88),
    [sym_case_statement] = STATE(88),
    [sym_while_statement] = STATE(88),
    [sym_do_statement] = STATE(88),
    [sym_for_statement] = STATE(88),
    [sym_return_statement] = STATE(88),
    [sym_break_statement] = STATE(88),
    [sym_continue_statement] = STATE(88),
    [sym_goto_statement] = STATE(88),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [469] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(225),
    [sym_attributed_statement] = STATE(225),
    [sym_labeled_statement] = STATE(225),
    [sym_expression_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_switch_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_do_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_return_statement] = STATE(225),
    [sym_break_statement] = STATE(225),
    [sym_continue_statement] = STATE(225),
    [sym_goto_statement] = STATE(225),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [sym_attribute_declaration] = STATE(484),
    [sym_compound_statement] = STATE(155),
    [sym_attributed_statement] = STATE(155),
    [sym_labeled_statement] = STATE(155),
    [sym_expression_statement] = STATE(155),
    [sym_if_statement] = STATE(155),
    [sym_switch_statement] = STATE(155),
    [sym_case_statement] = STATE(155),
    [sym_while_statement] = STATE(155),
    [sym_do_statement] = STATE(155),
    [sym_for_statement] = STATE(155),
    [sym_return_statement] = STATE(155),
    [sym_break_statement] = STATE(155),
    [sym_continue_statement] = STATE(155),
    [sym_goto_statement] = STATE(155),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(484),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [471] = {
    [sym_attribute_declaration] = STATE(471),
    [sym_compound_statement] = STATE(206),
    [sym_attributed_statement] = STATE(206),
    [sym_labeled_statement] = STATE(206),
    [sym_expression_statement] = STATE(206),
    [sym_if_statement] = STATE(206),
    [sym_switch_statement] = STATE(206),
    [sym_case_statement] = STATE(206),
    [sym_while_statement] = STATE(206),
    [sym_do_statement] = STATE(206),
    [sym_for_statement] = STATE(206),
    [sym_return_statement] = STATE(206),
    [sym_break_statement] = STATE(206),
    [sym_continue_statement] = STATE(206),
    [sym_goto_statement] = STATE(206),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(471),
    [sym_identifier] = ACTIONS(1641),
    [anon_sym_LPAREN2] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(1647),
    [anon_sym_if] = ACTIONS(1650),
    [anon_sym_switch] = ACTIONS(1653),
    [anon_sym_case] = ACTIONS(1656),
    [anon_sym_default] = ACTIONS(1659),
    [anon_sym_while] = ACTIONS(1662),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_for] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1671),
    [anon_sym_break] = ACTIONS(1674),
    [anon_sym_continue] = ACTIONS(1677),
    [anon_sym_goto] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_sizeof] = ACTIONS(1580),
    [sym_number_literal] = ACTIONS(1583),
    [anon_sym_L_SQUOTE] = ACTIONS(1586),
    [anon_sym_u_SQUOTE] = ACTIONS(1586),
    [anon_sym_U_SQUOTE] = ACTIONS(1586),
    [anon_sym_u8_SQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [anon_sym_L_DQUOTE] = ACTIONS(1589),
    [anon_sym_u_DQUOTE] = ACTIONS(1589),
    [anon_sym_U_DQUOTE] = ACTIONS(1589),
    [anon_sym_u8_DQUOTE] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [sym_comment] = ACTIONS(3),
  },
  [472] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(195),
    [sym_attributed_statement] = STATE(195),
    [sym_labeled_statement] = STATE(195),
    [sym_expression_statement] = STATE(195),
    [sym_if_statement] = STATE(195),
    [sym_switch_statement] = STATE(195),
    [sym_case_statement] = STATE(195),
    [sym_while_statement] = STATE(195),
    [sym_do_statement] = STATE(195),
    [sym_for_statement] = STATE(195),
    [sym_return_statement] = STATE(195),
    [sym_break_statement] = STATE(195),
    [sym_continue_statement] = STATE(195),
    [sym_goto_statement] = STATE(195),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(138),
    [sym_attributed_statement] = STATE(138),
    [sym_labeled_statement] = STATE(138),
    [sym_expression_statement] = STATE(138),
    [sym_if_statement] = STATE(138),
    [sym_switch_statement] = STATE(138),
    [sym_case_statement] = STATE(138),
    [sym_while_statement] = STATE(138),
    [sym_do_statement] = STATE(138),
    [sym_for_statement] = STATE(138),
    [sym_return_statement] = STATE(138),
    [sym_break_statement] = STATE(138),
    [sym_continue_statement] = STATE(138),
    [sym_goto_statement] = STATE(138),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(196),
    [sym_attributed_statement] = STATE(196),
    [sym_labeled_statement] = STATE(196),
    [sym_expression_statement] = STATE(196),
    [sym_if_statement] = STATE(196),
    [sym_switch_statement] = STATE(196),
    [sym_case_statement] = STATE(196),
    [sym_while_statement] = STATE(196),
    [sym_do_statement] = STATE(196),
    [sym_for_statement] = STATE(196),
    [sym_return_statement] = STATE(196),
    [sym_break_statement] = STATE(196),
    [sym_continue_statement] = STATE(196),
    [sym_goto_statement] = STATE(196),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(167),
    [sym_attributed_statement] = STATE(167),
    [sym_labeled_statement] = STATE(167),
    [sym_expression_statement] = STATE(167),
    [sym_if_statement] = STATE(167),
    [sym_switch_statement] = STATE(167),
    [sym_case_statement] = STATE(167),
    [sym_while_statement] = STATE(167),
    [sym_do_statement] = STATE(167),
    [sym_for_statement] = STATE(167),
    [sym_return_statement] = STATE(167),
    [sym_break_statement] = STATE(167),
    [sym_continue_statement] = STATE(167),
    [sym_goto_statement] = STATE(167),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(71),
    [sym_attributed_statement] = STATE(71),
    [sym_labeled_statement] = STATE(71),
    [sym_expression_statement] = STATE(71),
    [sym_if_statement] = STATE(71),
    [sym_switch_statement] = STATE(71),
    [sym_case_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_do_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_return_statement] = STATE(71),
    [sym_break_statement] = STATE(71),
    [sym_continue_statement] = STATE(71),
    [sym_goto_statement] = STATE(71),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(197),
    [sym_attributed_statement] = STATE(197),
    [sym_labeled_statement] = STATE(197),
    [sym_expression_statement] = STATE(197),
    [sym_if_statement] = STATE(197),
    [sym_switch_statement] = STATE(197),
    [sym_case_statement] = STATE(197),
    [sym_while_statement] = STATE(197),
    [sym_do_statement] = STATE(197),
    [sym_for_statement] = STATE(197),
    [sym_return_statement] = STATE(197),
    [sym_break_statement] = STATE(197),
    [sym_continue_statement] = STATE(197),
    [sym_goto_statement] = STATE(197),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [478] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(72),
    [sym_attributed_statement] = STATE(72),
    [sym_labeled_statement] = STATE(72),
    [sym_expression_statement] = STATE(72),
    [sym_if_statement] = STATE(72),
    [sym_switch_statement] = STATE(72),
    [sym_case_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_do_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_return_statement] = STATE(72),
    [sym_break_statement] = STATE(72),
    [sym_continue_statement] = STATE(72),
    [sym_goto_statement] = STATE(72),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(74),
    [sym_attributed_statement] = STATE(74),
    [sym_labeled_statement] = STATE(74),
    [sym_expression_statement] = STATE(74),
    [sym_if_statement] = STATE(74),
    [sym_switch_statement] = STATE(74),
    [sym_case_statement] = STATE(74),
    [sym_while_statement] = STATE(74),
    [sym_do_statement] = STATE(74),
    [sym_for_statement] = STATE(74),
    [sym_return_statement] = STATE(74),
    [sym_break_statement] = STATE(74),
    [sym_continue_statement] = STATE(74),
    [sym_goto_statement] = STATE(74),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(139),
    [sym_attributed_statement] = STATE(139),
    [sym_labeled_statement] = STATE(139),
    [sym_expression_statement] = STATE(139),
    [sym_if_statement] = STATE(139),
    [sym_switch_statement] = STATE(139),
    [sym_case_statement] = STATE(139),
    [sym_while_statement] = STATE(139),
    [sym_do_statement] = STATE(139),
    [sym_for_statement] = STATE(139),
    [sym_return_statement] = STATE(139),
    [sym_break_statement] = STATE(139),
    [sym_continue_statement] = STATE(139),
    [sym_goto_statement] = STATE(139),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(67),
    [sym_attributed_statement] = STATE(67),
    [sym_labeled_statement] = STATE(67),
    [sym_expression_statement] = STATE(67),
    [sym_if_statement] = STATE(67),
    [sym_switch_statement] = STATE(67),
    [sym_case_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_do_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_return_statement] = STATE(67),
    [sym_break_statement] = STATE(67),
    [sym_continue_statement] = STATE(67),
    [sym_goto_statement] = STATE(67),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(76),
    [sym_attributed_statement] = STATE(76),
    [sym_labeled_statement] = STATE(76),
    [sym_expression_statement] = STATE(76),
    [sym_if_statement] = STATE(76),
    [sym_switch_statement] = STATE(76),
    [sym_case_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_do_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_return_statement] = STATE(76),
    [sym_break_statement] = STATE(76),
    [sym_continue_statement] = STATE(76),
    [sym_goto_statement] = STATE(76),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(176),
    [sym_attributed_statement] = STATE(176),
    [sym_labeled_statement] = STATE(176),
    [sym_expression_statement] = STATE(176),
    [sym_if_statement] = STATE(176),
    [sym_switch_statement] = STATE(176),
    [sym_case_statement] = STATE(176),
    [sym_while_statement] = STATE(176),
    [sym_do_statement] = STATE(176),
    [sym_for_statement] = STATE(176),
    [sym_return_statement] = STATE(176),
    [sym_break_statement] = STATE(176),
    [sym_continue_statement] = STATE(176),
    [sym_goto_statement] = STATE(176),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [sym_attribute_declaration] = STATE(484),
    [sym_compound_statement] = STATE(155),
    [sym_attributed_statement] = STATE(155),
    [sym_labeled_statement] = STATE(155),
    [sym_expression_statement] = STATE(155),
    [sym_if_statement] = STATE(155),
    [sym_switch_statement] = STATE(155),
    [sym_case_statement] = STATE(155),
    [sym_while_statement] = STATE(155),
    [sym_do_statement] = STATE(155),
    [sym_for_statement] = STATE(155),
    [sym_return_statement] = STATE(155),
    [sym_break_statement] = STATE(155),
    [sym_continue_statement] = STATE(155),
    [sym_goto_statement] = STATE(155),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(484),
    [sym_identifier] = ACTIONS(1683),
    [anon_sym_LPAREN2] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(1689),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_switch] = ACTIONS(1695),
    [anon_sym_case] = ACTIONS(1698),
    [anon_sym_default] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1704),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_for] = ACTIONS(1710),
    [anon_sym_return] = ACTIONS(1713),
    [anon_sym_break] = ACTIONS(1716),
    [anon_sym_continue] = ACTIONS(1719),
    [anon_sym_goto] = ACTIONS(1722),
    [anon_sym_DASH_DASH] = ACTIONS(1577),
    [anon_sym_PLUS_PLUS] = ACTIONS(1577),
    [anon_sym_sizeof] = ACTIONS(1580),
    [sym_number_literal] = ACTIONS(1583),
    [anon_sym_L_SQUOTE] = ACTIONS(1586),
    [anon_sym_u_SQUOTE] = ACTIONS(1586),
    [anon_sym_U_SQUOTE] = ACTIONS(1586),
    [anon_sym_u8_SQUOTE] = ACTIONS(1586),
    [anon_sym_SQUOTE] = ACTIONS(1586),
    [anon_sym_L_DQUOTE] = ACTIONS(1589),
    [anon_sym_u_DQUOTE] = ACTIONS(1589),
    [anon_sym_U_DQUOTE] = ACTIONS(1589),
    [anon_sym_u8_DQUOTE] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [sym_true] = ACTIONS(1592),
    [sym_false] = ACTIONS(1592),
    [sym_null] = ACTIONS(1592),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [sym_attribute_declaration] = STATE(444),
    [sym_compound_statement] = STATE(199),
    [sym_attributed_statement] = STATE(199),
    [sym_labeled_statement] = STATE(199),
    [sym_expression_statement] = STATE(199),
    [sym_if_statement] = STATE(199),
    [sym_switch_statement] = STATE(199),
    [sym_case_statement] = STATE(199),
    [sym_while_statement] = STATE(199),
    [sym_do_statement] = STATE(199),
    [sym_for_statement] = STATE(199),
    [sym_return_statement] = STATE(199),
    [sym_break_statement] = STATE(199),
    [sym_continue_statement] = STATE(199),
    [sym_goto_statement] = STATE(199),
    [sym__expression] = STATE(840),
    [sym_comma_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(444),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_goto] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(1403),
    [sym_attributed_statement] = STATE(1403),
    [sym_labeled_statement] = STATE(1403),
    [sym_expression_statement] = STATE(1403),
    [sym_if_statement] = STATE(1403),
    [sym_switch_statement] = STATE(1403),
    [sym_case_statement] = STATE(1403),
    [sym_while_statement] = STATE(1403),
    [sym_do_statement] = STATE(1403),
    [sym_for_statement] = STATE(1403),
    [sym_return_statement] = STATE(1403),
    [sym_break_statement] = STATE(1403),
    [sym_continue_statement] = STATE(1403),
    [sym_goto_statement] = STATE(1403),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(78),
    [sym_attributed_statement] = STATE(78),
    [sym_labeled_statement] = STATE(78),
    [sym_expression_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_switch_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_do_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_return_statement] = STATE(78),
    [sym_break_statement] = STATE(78),
    [sym_continue_statement] = STATE(78),
    [sym_goto_statement] = STATE(78),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [sym_attribute_declaration] = STATE(450),
    [sym_compound_statement] = STATE(77),
    [sym_attributed_statement] = STATE(77),
    [sym_labeled_statement] = STATE(77),
    [sym_expression_statement] = STATE(77),
    [sym_if_statement] = STATE(77),
    [sym_switch_statement] = STATE(77),
    [sym_case_statement] = STATE(77),
    [sym_while_statement] = STATE(77),
    [sym_do_statement] = STATE(77),
    [sym_for_statement] = STATE(77),
    [sym_return_statement] = STATE(77),
    [sym_break_statement] = STATE(77),
    [sym_continue_statement] = STATE(77),
    [sym_goto_statement] = STATE(77),
    [sym__expression] = STATE(797),
    [sym_comma_expression] = STATE(1423),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(450),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(127),
    [anon_sym_switch] = ACTIONS(129),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_do] = ACTIONS(137),
    [anon_sym_for] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(143),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_goto] = ACTIONS(147),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [sym_attribute_declaration] = STATE(447),
    [sym_compound_statement] = STATE(185),
    [sym_attributed_statement] = STATE(185),
    [sym_labeled_statement] = STATE(185),
    [sym_expression_statement] = STATE(185),
    [sym_if_statement] = STATE(185),
    [sym_switch_statement] = STATE(185),
    [sym_case_statement] = STATE(185),
    [sym_while_statement] = STATE(185),
    [sym_do_statement] = STATE(185),
    [sym_for_statement] = STATE(185),
    [sym_return_statement] = STATE(185),
    [sym_break_statement] = STATE(185),
    [sym_continue_statement] = STATE(185),
    [sym_goto_statement] = STATE(185),
    [sym__expression] = STATE(812),
    [sym_comma_expression] = STATE(1497),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(447),
    [sym_identifier] = ACTIONS(1518),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_default] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_goto] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(136),
    [sym_attributed_statement] = STATE(136),
    [sym_labeled_statement] = STATE(136),
    [sym_expression_statement] = STATE(136),
    [sym_if_statement] = STATE(136),
    [sym_switch_statement] = STATE(136),
    [sym_case_statement] = STATE(136),
    [sym_while_statement] = STATE(136),
    [sym_do_statement] = STATE(136),
    [sym_for_statement] = STATE(136),
    [sym_return_statement] = STATE(136),
    [sym_break_statement] = STATE(136),
    [sym_continue_statement] = STATE(136),
    [sym_goto_statement] = STATE(136),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(175),
    [sym_attributed_statement] = STATE(175),
    [sym_labeled_statement] = STATE(175),
    [sym_expression_statement] = STATE(175),
    [sym_if_statement] = STATE(175),
    [sym_switch_statement] = STATE(175),
    [sym_case_statement] = STATE(175),
    [sym_while_statement] = STATE(175),
    [sym_do_statement] = STATE(175),
    [sym_for_statement] = STATE(175),
    [sym_return_statement] = STATE(175),
    [sym_break_statement] = STATE(175),
    [sym_continue_statement] = STATE(175),
    [sym_goto_statement] = STATE(175),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(1504),
    [sym_attributed_statement] = STATE(1504),
    [sym_labeled_statement] = STATE(1504),
    [sym_expression_statement] = STATE(1504),
    [sym_if_statement] = STATE(1504),
    [sym_switch_statement] = STATE(1504),
    [sym_case_statement] = STATE(1504),
    [sym_while_statement] = STATE(1504),
    [sym_do_statement] = STATE(1504),
    [sym_for_statement] = STATE(1504),
    [sym_return_statement] = STATE(1504),
    [sym_break_statement] = STATE(1504),
    [sym_continue_statement] = STATE(1504),
    [sym_goto_statement] = STATE(1504),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(135),
    [sym_attributed_statement] = STATE(135),
    [sym_labeled_statement] = STATE(135),
    [sym_expression_statement] = STATE(135),
    [sym_if_statement] = STATE(135),
    [sym_switch_statement] = STATE(135),
    [sym_case_statement] = STATE(135),
    [sym_while_statement] = STATE(135),
    [sym_do_statement] = STATE(135),
    [sym_for_statement] = STATE(135),
    [sym_return_statement] = STATE(135),
    [sym_break_statement] = STATE(135),
    [sym_continue_statement] = STATE(135),
    [sym_goto_statement] = STATE(135),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(174),
    [sym_attributed_statement] = STATE(174),
    [sym_labeled_statement] = STATE(174),
    [sym_expression_statement] = STATE(174),
    [sym_if_statement] = STATE(174),
    [sym_switch_statement] = STATE(174),
    [sym_case_statement] = STATE(174),
    [sym_while_statement] = STATE(174),
    [sym_do_statement] = STATE(174),
    [sym_for_statement] = STATE(174),
    [sym_return_statement] = STATE(174),
    [sym_break_statement] = STATE(174),
    [sym_continue_statement] = STATE(174),
    [sym_goto_statement] = STATE(174),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [sym_attribute_declaration] = STATE(470),
    [sym_compound_statement] = STATE(171),
    [sym_attributed_statement] = STATE(171),
    [sym_labeled_statement] = STATE(171),
    [sym_expression_statement] = STATE(171),
    [sym_if_statement] = STATE(171),
    [sym_switch_statement] = STATE(171),
    [sym_case_statement] = STATE(171),
    [sym_while_statement] = STATE(171),
    [sym_do_statement] = STATE(171),
    [sym_for_statement] = STATE(171),
    [sym_return_statement] = STATE(171),
    [sym_break_statement] = STATE(171),
    [sym_continue_statement] = STATE(171),
    [sym_goto_statement] = STATE(171),
    [sym__expression] = STATE(826),
    [sym_comma_expression] = STATE(1463),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [aux_sym_attributed_declarator_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1597),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_switch] = ACTIONS(69),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_default] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_return] = ACTIONS(81),
    [anon_sym_break] = ACTIONS(83),
    [anon_sym_continue] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_LPAREN2] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_kernel] = ACTIONS(1725),
    [anon_sym___kernel] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(1725),
    [anon_sym___global] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym___local] = ACTIONS(1725),
    [anon_sym_constant] = ACTIONS(1725),
    [anon_sym___constant] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym___private] = ACTIONS(1725),
    [anon_sym_generic] = ACTIONS(1725),
    [anon_sym___generic] = ACTIONS(1725),
    [anon_sym_read_only] = ACTIONS(1725),
    [anon_sym___read_only] = ACTIONS(1725),
    [anon_sym_write_only] = ACTIONS(1725),
    [anon_sym___write_only] = ACTIONS(1725),
    [anon_sym_read_write] = ACTIONS(1725),
    [anon_sym___read_write] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym___attribute__] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1741),
    [anon_sym___declspec] = ACTIONS(1725),
    [anon_sym___based] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_auto] = ACTIONS(1725),
    [anon_sym_register] = ACTIONS(1725),
    [anon_sym_inline] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_volatile] = ACTIONS(1725),
    [anon_sym_restrict] = ACTIONS(1725),
    [anon_sym__Atomic] = ACTIONS(1725),
    [anon_sym_pipe] = ACTIONS(1725),
    [anon_sym_COLON] = ACTIONS(1745),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1747),
    [anon_sym_SLASH_EQ] = ACTIONS(1747),
    [anon_sym_PERCENT_EQ] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1747),
    [anon_sym_DASH_EQ] = ACTIONS(1747),
    [anon_sym_LT_LT_EQ] = ACTIONS(1747),
    [anon_sym_GT_GT_EQ] = ACTIONS(1747),
    [anon_sym_AMP_EQ] = ACTIONS(1747),
    [anon_sym_CARET_EQ] = ACTIONS(1747),
    [anon_sym_PIPE_EQ] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_DASH_GT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_LPAREN2] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_kernel] = ACTIONS(1725),
    [anon_sym___kernel] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(1725),
    [anon_sym___global] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym___local] = ACTIONS(1725),
    [anon_sym_constant] = ACTIONS(1725),
    [anon_sym___constant] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym___private] = ACTIONS(1725),
    [anon_sym_generic] = ACTIONS(1725),
    [anon_sym___generic] = ACTIONS(1725),
    [anon_sym_read_only] = ACTIONS(1725),
    [anon_sym___read_only] = ACTIONS(1725),
    [anon_sym_write_only] = ACTIONS(1725),
    [anon_sym___write_only] = ACTIONS(1725),
    [anon_sym_read_write] = ACTIONS(1725),
    [anon_sym___read_write] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym___attribute__] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1741),
    [anon_sym___declspec] = ACTIONS(1725),
    [anon_sym___based] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_auto] = ACTIONS(1725),
    [anon_sym_register] = ACTIONS(1725),
    [anon_sym_inline] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_volatile] = ACTIONS(1725),
    [anon_sym_restrict] = ACTIONS(1725),
    [anon_sym__Atomic] = ACTIONS(1725),
    [anon_sym_pipe] = ACTIONS(1725),
    [anon_sym_COLON] = ACTIONS(1749),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1747),
    [anon_sym_SLASH_EQ] = ACTIONS(1747),
    [anon_sym_PERCENT_EQ] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1747),
    [anon_sym_DASH_EQ] = ACTIONS(1747),
    [anon_sym_LT_LT_EQ] = ACTIONS(1747),
    [anon_sym_GT_GT_EQ] = ACTIONS(1747),
    [anon_sym_AMP_EQ] = ACTIONS(1747),
    [anon_sym_CARET_EQ] = ACTIONS(1747),
    [anon_sym_PIPE_EQ] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_DASH_GT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_LPAREN2] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_kernel] = ACTIONS(1725),
    [anon_sym___kernel] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(1725),
    [anon_sym___global] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym___local] = ACTIONS(1725),
    [anon_sym_constant] = ACTIONS(1725),
    [anon_sym___constant] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym___private] = ACTIONS(1725),
    [anon_sym_generic] = ACTIONS(1725),
    [anon_sym___generic] = ACTIONS(1725),
    [anon_sym_read_only] = ACTIONS(1725),
    [anon_sym___read_only] = ACTIONS(1725),
    [anon_sym_write_only] = ACTIONS(1725),
    [anon_sym___write_only] = ACTIONS(1725),
    [anon_sym_read_write] = ACTIONS(1725),
    [anon_sym___read_write] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym___attribute__] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1741),
    [anon_sym___declspec] = ACTIONS(1725),
    [anon_sym___based] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_auto] = ACTIONS(1725),
    [anon_sym_register] = ACTIONS(1725),
    [anon_sym_inline] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_volatile] = ACTIONS(1725),
    [anon_sym_restrict] = ACTIONS(1725),
    [anon_sym__Atomic] = ACTIONS(1725),
    [anon_sym_pipe] = ACTIONS(1725),
    [anon_sym_COLON] = ACTIONS(1751),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1747),
    [anon_sym_SLASH_EQ] = ACTIONS(1747),
    [anon_sym_PERCENT_EQ] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1747),
    [anon_sym_DASH_EQ] = ACTIONS(1747),
    [anon_sym_LT_LT_EQ] = ACTIONS(1747),
    [anon_sym_GT_GT_EQ] = ACTIONS(1747),
    [anon_sym_AMP_EQ] = ACTIONS(1747),
    [anon_sym_CARET_EQ] = ACTIONS(1747),
    [anon_sym_PIPE_EQ] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_DASH_GT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_LPAREN2] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_kernel] = ACTIONS(1725),
    [anon_sym___kernel] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(1725),
    [anon_sym___global] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym___local] = ACTIONS(1725),
    [anon_sym_constant] = ACTIONS(1725),
    [anon_sym___constant] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym___private] = ACTIONS(1725),
    [anon_sym_generic] = ACTIONS(1725),
    [anon_sym___generic] = ACTIONS(1725),
    [anon_sym_read_only] = ACTIONS(1725),
    [anon_sym___read_only] = ACTIONS(1725),
    [anon_sym_write_only] = ACTIONS(1725),
    [anon_sym___write_only] = ACTIONS(1725),
    [anon_sym_read_write] = ACTIONS(1725),
    [anon_sym___read_write] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym___attribute__] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1741),
    [anon_sym___declspec] = ACTIONS(1725),
    [anon_sym___based] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_auto] = ACTIONS(1725),
    [anon_sym_register] = ACTIONS(1725),
    [anon_sym_inline] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_volatile] = ACTIONS(1725),
    [anon_sym_restrict] = ACTIONS(1725),
    [anon_sym__Atomic] = ACTIONS(1725),
    [anon_sym_pipe] = ACTIONS(1725),
    [anon_sym_COLON] = ACTIONS(1749),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1747),
    [anon_sym_SLASH_EQ] = ACTIONS(1747),
    [anon_sym_PERCENT_EQ] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1747),
    [anon_sym_DASH_EQ] = ACTIONS(1747),
    [anon_sym_LT_LT_EQ] = ACTIONS(1747),
    [anon_sym_GT_GT_EQ] = ACTIONS(1747),
    [anon_sym_AMP_EQ] = ACTIONS(1747),
    [anon_sym_CARET_EQ] = ACTIONS(1747),
    [anon_sym_PIPE_EQ] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_DASH_GT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_LPAREN2] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_kernel] = ACTIONS(1725),
    [anon_sym___kernel] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(1725),
    [anon_sym___global] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym___local] = ACTIONS(1725),
    [anon_sym_constant] = ACTIONS(1725),
    [anon_sym___constant] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym___private] = ACTIONS(1725),
    [anon_sym_generic] = ACTIONS(1725),
    [anon_sym___generic] = ACTIONS(1725),
    [anon_sym_read_only] = ACTIONS(1725),
    [anon_sym___read_only] = ACTIONS(1725),
    [anon_sym_write_only] = ACTIONS(1725),
    [anon_sym___write_only] = ACTIONS(1725),
    [anon_sym_read_write] = ACTIONS(1725),
    [anon_sym___read_write] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym___attribute__] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1741),
    [anon_sym___declspec] = ACTIONS(1725),
    [anon_sym___based] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_auto] = ACTIONS(1725),
    [anon_sym_register] = ACTIONS(1725),
    [anon_sym_inline] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_volatile] = ACTIONS(1725),
    [anon_sym_restrict] = ACTIONS(1725),
    [anon_sym__Atomic] = ACTIONS(1725),
    [anon_sym_pipe] = ACTIONS(1725),
    [anon_sym_COLON] = ACTIONS(1751),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1747),
    [anon_sym_SLASH_EQ] = ACTIONS(1747),
    [anon_sym_PERCENT_EQ] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1747),
    [anon_sym_DASH_EQ] = ACTIONS(1747),
    [anon_sym_LT_LT_EQ] = ACTIONS(1747),
    [anon_sym_GT_GT_EQ] = ACTIONS(1747),
    [anon_sym_AMP_EQ] = ACTIONS(1747),
    [anon_sym_CARET_EQ] = ACTIONS(1747),
    [anon_sym_PIPE_EQ] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_DASH_GT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_LPAREN2] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_kernel] = ACTIONS(1725),
    [anon_sym___kernel] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(1725),
    [anon_sym___global] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym___local] = ACTIONS(1725),
    [anon_sym_constant] = ACTIONS(1725),
    [anon_sym___constant] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym___private] = ACTIONS(1725),
    [anon_sym_generic] = ACTIONS(1725),
    [anon_sym___generic] = ACTIONS(1725),
    [anon_sym_read_only] = ACTIONS(1725),
    [anon_sym___read_only] = ACTIONS(1725),
    [anon_sym_write_only] = ACTIONS(1725),
    [anon_sym___write_only] = ACTIONS(1725),
    [anon_sym_read_write] = ACTIONS(1725),
    [anon_sym___read_write] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym___attribute__] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1741),
    [anon_sym___declspec] = ACTIONS(1725),
    [anon_sym___based] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_auto] = ACTIONS(1725),
    [anon_sym_register] = ACTIONS(1725),
    [anon_sym_inline] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_volatile] = ACTIONS(1725),
    [anon_sym_restrict] = ACTIONS(1725),
    [anon_sym__Atomic] = ACTIONS(1725),
    [anon_sym_pipe] = ACTIONS(1725),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1747),
    [anon_sym_SLASH_EQ] = ACTIONS(1747),
    [anon_sym_PERCENT_EQ] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1747),
    [anon_sym_DASH_EQ] = ACTIONS(1747),
    [anon_sym_LT_LT_EQ] = ACTIONS(1747),
    [anon_sym_GT_GT_EQ] = ACTIONS(1747),
    [anon_sym_AMP_EQ] = ACTIONS(1747),
    [anon_sym_CARET_EQ] = ACTIONS(1747),
    [anon_sym_PIPE_EQ] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_DASH_GT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [502] = {
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_LPAREN2] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_kernel] = ACTIONS(1725),
    [anon_sym___kernel] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(1725),
    [anon_sym___global] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym___local] = ACTIONS(1725),
    [anon_sym_constant] = ACTIONS(1725),
    [anon_sym___constant] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym___private] = ACTIONS(1725),
    [anon_sym_generic] = ACTIONS(1725),
    [anon_sym___generic] = ACTIONS(1725),
    [anon_sym_read_only] = ACTIONS(1725),
    [anon_sym___read_only] = ACTIONS(1725),
    [anon_sym_write_only] = ACTIONS(1725),
    [anon_sym___write_only] = ACTIONS(1725),
    [anon_sym_read_write] = ACTIONS(1725),
    [anon_sym___read_write] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym___attribute__] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1741),
    [anon_sym___declspec] = ACTIONS(1725),
    [anon_sym___based] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_auto] = ACTIONS(1725),
    [anon_sym_register] = ACTIONS(1725),
    [anon_sym_inline] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_volatile] = ACTIONS(1725),
    [anon_sym_restrict] = ACTIONS(1725),
    [anon_sym__Atomic] = ACTIONS(1725),
    [anon_sym_pipe] = ACTIONS(1725),
    [anon_sym_COLON] = ACTIONS(1745),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1747),
    [anon_sym_SLASH_EQ] = ACTIONS(1747),
    [anon_sym_PERCENT_EQ] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1747),
    [anon_sym_DASH_EQ] = ACTIONS(1747),
    [anon_sym_LT_LT_EQ] = ACTIONS(1747),
    [anon_sym_GT_GT_EQ] = ACTIONS(1747),
    [anon_sym_AMP_EQ] = ACTIONS(1747),
    [anon_sym_CARET_EQ] = ACTIONS(1747),
    [anon_sym_PIPE_EQ] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_DASH_GT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_LPAREN2] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_kernel] = ACTIONS(1725),
    [anon_sym___kernel] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(1725),
    [anon_sym___global] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym___local] = ACTIONS(1725),
    [anon_sym_constant] = ACTIONS(1725),
    [anon_sym___constant] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym___private] = ACTIONS(1725),
    [anon_sym_generic] = ACTIONS(1725),
    [anon_sym___generic] = ACTIONS(1725),
    [anon_sym_read_only] = ACTIONS(1725),
    [anon_sym___read_only] = ACTIONS(1725),
    [anon_sym_write_only] = ACTIONS(1725),
    [anon_sym___write_only] = ACTIONS(1725),
    [anon_sym_read_write] = ACTIONS(1725),
    [anon_sym___read_write] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym___attribute__] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1741),
    [anon_sym___declspec] = ACTIONS(1725),
    [anon_sym___based] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_auto] = ACTIONS(1725),
    [anon_sym_register] = ACTIONS(1725),
    [anon_sym_inline] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_volatile] = ACTIONS(1725),
    [anon_sym_restrict] = ACTIONS(1725),
    [anon_sym__Atomic] = ACTIONS(1725),
    [anon_sym_pipe] = ACTIONS(1725),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1747),
    [anon_sym_SLASH_EQ] = ACTIONS(1747),
    [anon_sym_PERCENT_EQ] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1747),
    [anon_sym_DASH_EQ] = ACTIONS(1747),
    [anon_sym_LT_LT_EQ] = ACTIONS(1747),
    [anon_sym_GT_GT_EQ] = ACTIONS(1747),
    [anon_sym_AMP_EQ] = ACTIONS(1747),
    [anon_sym_CARET_EQ] = ACTIONS(1747),
    [anon_sym_PIPE_EQ] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_DASH_GT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_LPAREN2] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1733),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_EQ_EQ] = ACTIONS(1727),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1727),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_kernel] = ACTIONS(1725),
    [anon_sym___kernel] = ACTIONS(1725),
    [anon_sym_global] = ACTIONS(1725),
    [anon_sym___global] = ACTIONS(1725),
    [anon_sym_local] = ACTIONS(1725),
    [anon_sym___local] = ACTIONS(1725),
    [anon_sym_constant] = ACTIONS(1725),
    [anon_sym___constant] = ACTIONS(1725),
    [anon_sym_private] = ACTIONS(1725),
    [anon_sym___private] = ACTIONS(1725),
    [anon_sym_generic] = ACTIONS(1725),
    [anon_sym___generic] = ACTIONS(1725),
    [anon_sym_read_only] = ACTIONS(1725),
    [anon_sym___read_only] = ACTIONS(1725),
    [anon_sym_write_only] = ACTIONS(1725),
    [anon_sym___write_only] = ACTIONS(1725),
    [anon_sym_read_write] = ACTIONS(1725),
    [anon_sym___read_write] = ACTIONS(1725),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym___attribute__] = ACTIONS(1725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1741),
    [anon_sym___declspec] = ACTIONS(1725),
    [anon_sym___based] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1733),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_auto] = ACTIONS(1725),
    [anon_sym_register] = ACTIONS(1725),
    [anon_sym_inline] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_volatile] = ACTIONS(1725),
    [anon_sym_restrict] = ACTIONS(1725),
    [anon_sym__Atomic] = ACTIONS(1725),
    [anon_sym_pipe] = ACTIONS(1725),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1747),
    [anon_sym_SLASH_EQ] = ACTIONS(1747),
    [anon_sym_PERCENT_EQ] = ACTIONS(1747),
    [anon_sym_PLUS_EQ] = ACTIONS(1747),
    [anon_sym_DASH_EQ] = ACTIONS(1747),
    [anon_sym_LT_LT_EQ] = ACTIONS(1747),
    [anon_sym_GT_GT_EQ] = ACTIONS(1747),
    [anon_sym_AMP_EQ] = ACTIONS(1747),
    [anon_sym_CARET_EQ] = ACTIONS(1747),
    [anon_sym_PIPE_EQ] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_DASH_GT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_kernel] = ACTIONS(1755),
    [anon_sym___kernel] = ACTIONS(1755),
    [anon_sym_global] = ACTIONS(1755),
    [anon_sym___global] = ACTIONS(1755),
    [anon_sym_local] = ACTIONS(1755),
    [anon_sym___local] = ACTIONS(1755),
    [anon_sym_constant] = ACTIONS(1755),
    [anon_sym___constant] = ACTIONS(1755),
    [anon_sym_private] = ACTIONS(1755),
    [anon_sym___private] = ACTIONS(1755),
    [anon_sym_generic] = ACTIONS(1755),
    [anon_sym___generic] = ACTIONS(1755),
    [anon_sym_read_only] = ACTIONS(1755),
    [anon_sym___read_only] = ACTIONS(1755),
    [anon_sym_write_only] = ACTIONS(1755),
    [anon_sym___write_only] = ACTIONS(1755),
    [anon_sym_read_write] = ACTIONS(1755),
    [anon_sym___read_write] = ACTIONS(1755),
    [anon_sym_extern] = ACTIONS(1755),
    [anon_sym___attribute__] = ACTIONS(1755),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1757),
    [anon_sym___declspec] = ACTIONS(1755),
    [anon_sym_static] = ACTIONS(1755),
    [anon_sym_auto] = ACTIONS(1755),
    [anon_sym_register] = ACTIONS(1755),
    [anon_sym_inline] = ACTIONS(1755),
    [anon_sym_const] = ACTIONS(1755),
    [anon_sym_volatile] = ACTIONS(1755),
    [anon_sym_restrict] = ACTIONS(1755),
    [anon_sym__Atomic] = ACTIONS(1755),
    [anon_sym_pipe] = ACTIONS(1755),
    [anon_sym_signed] = ACTIONS(1755),
    [anon_sym_unsigned] = ACTIONS(1755),
    [anon_sym_long] = ACTIONS(1755),
    [anon_sym_short] = ACTIONS(1755),
    [anon_sym_bool] = ACTIONS(1755),
    [anon_sym_char] = ACTIONS(1755),
    [anon_sym_uchar] = ACTIONS(1755),
    [anon_sym_ushort] = ACTIONS(1755),
    [anon_sym_int] = ACTIONS(1755),
    [anon_sym_uint] = ACTIONS(1755),
    [anon_sym_ulong] = ACTIONS(1755),
    [anon_sym_float] = ACTIONS(1755),
    [anon_sym_double] = ACTIONS(1755),
    [anon_sym_half] = ACTIONS(1755),
    [anon_sym_size_t] = ACTIONS(1755),
    [anon_sym_ptrdiff_t] = ACTIONS(1755),
    [anon_sym_intptr_t] = ACTIONS(1755),
    [anon_sym_uintptr_t] = ACTIONS(1755),
    [anon_sym_void] = ACTIONS(1755),
    [sym_vector_type] = ACTIONS(1755),
    [anon_sym_image2d_t] = ACTIONS(1755),
    [anon_sym_image3d_t] = ACTIONS(1755),
    [anon_sym_image2d_array_t] = ACTIONS(1755),
    [anon_sym_image1d_t] = ACTIONS(1755),
    [anon_sym_image1d_buffer_t] = ACTIONS(1755),
    [anon_sym_image1d_array_t] = ACTIONS(1755),
    [anon_sym_image2d_depth_t] = ACTIONS(1755),
    [anon_sym_image2d_array_depth_t] = ACTIONS(1755),
    [anon_sym_sampler_t] = ACTIONS(1755),
    [anon_sym_queue_t] = ACTIONS(1755),
    [anon_sym_ndrange_t] = ACTIONS(1755),
    [anon_sym_clk_event_t] = ACTIONS(1755),
    [anon_sym_reserve_id_t] = ACTIONS(1755),
    [anon_sym_event_t] = ACTIONS(1755),
    [anon_sym_cl_mem_fence_flags] = ACTIONS(1755),
    [anon_sym_enum] = ACTIONS(1755),
    [anon_sym_struct] = ACTIONS(1755),
    [anon_sym_union] = ACTIONS(1755),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [sym__expression] = STATE(703),
    [sym_conditional_expression] = STATE(638),
    [sym_assignment_expression] = STATE(638),
    [sym_pointer_expression] = STATE(723),
    [sym_unary_expression] = STATE(638),
    [sym_binary_expression] = STATE(638),
    [sym_update_expression] = STATE(638),
    [sym_cast_expression] = STATE(638),
    [sym_sizeof_expression] = STATE(638),
    [sym_subscript_expression] = STATE(723),
    [sym_call_expression] = STATE(723),
    [sym_field_expression] = STATE(723),
    [sym_compound_literal_expression] = STATE(638),
    [sym_parenthesized_expression] = STATE(723),
    [sym_initializer_list] = STATE(684),
    [sym_char_literal] = STATE(638),
    [sym_concatenated_string] = STATE(638),
    [sym_string_literal] = STATE(542),
    [sym_identifier] = ACTIONS(1759),
    [anon_sym_COMMA] = ACTIONS(1414),
    [anon_sym_RPAREN] = ACTIONS(1414),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(1424),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_PIPE_PIPE] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1414),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_CARET] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_EQ_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ] = ACTIONS(1414),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1414),
    [anon_sym_LT_EQ] = ACTIONS(1414),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_GT_GT] = ACTIONS(1414),
    [anon_sym_SEMI] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1414),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_COLON] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_sizeof] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_DASH_GT] = ACTIONS(1414),
    [sym_number_literal] = ACTIONS(93),
    [anon_sym_L_SQUOTE] = ACTIONS(95),
    [anon_sym_u_SQUOTE] = ACTIONS(95),
    [anon_sym_U_SQUOTE] = ACTIONS(95),
    [anon_sym_u8_SQUOTE] = ACTIONS(95),
    [anon_sym_SQUOTE] = ACTIONS(95),
    [anon_sym_L_DQUOTE] = ACTIONS(97),
    [anon_sym_u_DQUOTE] = ACTIONS(97),
    [anon_sym_U_DQUOTE] = ACTIONS(97),
    [anon_sym_u8_DQUOTE] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1508), 1,
      anon_sym_AMP,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1767), 1,
      anon_sym_TILDE,
    ACTIONS(1769), 1,
      anon_sym_STAR,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(684), 1,
      sym_initializer_list,
    STATE(767), 1,
      sym__expression,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(1765), 3,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1424), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_DOT,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
    ACTIONS(1414), 14,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
  [107] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1775), 1,
      sym_identifier,
    STATE(509), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(746), 1,
      sym_scalar_type,
    ACTIONS(1782), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1778), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(55), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(1780), 32,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(509), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1788), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1786), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(1784), 48,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
      sym_identifier,
  [258] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      sym_vector_type,
    ACTIONS(1354), 1,
      anon_sym_enum,
    ACTIONS(1356), 1,
      anon_sym_struct,
    ACTIONS(1358), 1,
      anon_sym_union,
    ACTIONS(1791), 1,
      sym_identifier,
    STATE(785), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1000), 1,
      sym__type_specifier,
    STATE(1385), 1,
      sym_type_descriptor,
    STATE(516), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1088), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(1348), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(1352), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [346] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      sym_vector_type,
    ACTIONS(1354), 1,
      anon_sym_enum,
    ACTIONS(1356), 1,
      anon_sym_struct,
    ACTIONS(1358), 1,
      anon_sym_union,
    ACTIONS(1791), 1,
      sym_identifier,
    STATE(785), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1000), 1,
      sym__type_specifier,
    STATE(1469), 1,
      sym_type_descriptor,
    STATE(516), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1088), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(1348), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(1352), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [434] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_vector_type,
    ACTIONS(61), 1,
      anon_sym_enum,
    ACTIONS(63), 1,
      anon_sym_struct,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(508), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1032), 1,
      sym__type_specifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(729), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(55), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(59), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [519] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_vector_type,
    ACTIONS(61), 1,
      anon_sym_enum,
    ACTIONS(63), 1,
      anon_sym_struct,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(508), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1041), 1,
      sym__type_specifier,
    STATE(520), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(729), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(55), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(59), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [604] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_vector_type,
    ACTIONS(61), 1,
      anon_sym_enum,
    ACTIONS(63), 1,
      anon_sym_struct,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(508), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1038), 1,
      sym__type_specifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(729), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(55), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(59), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [689] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_vector_type,
    ACTIONS(61), 1,
      anon_sym_enum,
    ACTIONS(63), 1,
      anon_sym_struct,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(508), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1049), 1,
      sym__type_specifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(729), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(55), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(59), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [774] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      sym_vector_type,
    ACTIONS(1354), 1,
      anon_sym_enum,
    ACTIONS(1356), 1,
      anon_sym_struct,
    ACTIONS(1358), 1,
      anon_sym_union,
    ACTIONS(1791), 1,
      sym_identifier,
    STATE(785), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(998), 1,
      sym__type_specifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1088), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(1348), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(1352), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [859] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_vector_type,
    ACTIONS(61), 1,
      anon_sym_enum,
    ACTIONS(63), 1,
      anon_sym_struct,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(508), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1028), 1,
      sym__type_specifier,
    STATE(512), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(729), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(55), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(59), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [944] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_vector_type,
    ACTIONS(61), 1,
      anon_sym_enum,
    ACTIONS(63), 1,
      anon_sym_struct,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(508), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1047), 1,
      sym__type_specifier,
    STATE(514), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(729), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(55), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(59), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [1029] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_vector_type,
    ACTIONS(61), 1,
      anon_sym_enum,
    ACTIONS(63), 1,
      anon_sym_struct,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(508), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1030), 1,
      sym__type_specifier,
    STATE(515), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(729), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(55), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(59), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [1114] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_vector_type,
    ACTIONS(61), 1,
      anon_sym_enum,
    ACTIONS(63), 1,
      anon_sym_struct,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(1160), 1,
      sym_identifier,
    STATE(508), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1046), 1,
      sym__type_specifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(53), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(729), 7,
      sym_sized_type_specifier,
      sym_scalar_type,
      sym_other_builtin_type,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(55), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
    ACTIONS(59), 15,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
  [1199] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1793), 1,
      anon_sym_COMMA,
    ACTIONS(1795), 1,
      anon_sym_RBRACE,
    ACTIONS(1797), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_DOT,
    STATE(542), 1,
      sym_string_literal,
    STATE(795), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(1251), 2,
      sym_initializer_list,
      sym_initializer_pair,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    STATE(1143), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [1299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1803), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(1805), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(1801), 40,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
      sym_vector_type,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [1363] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1797), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_DOT,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    STATE(542), 1,
      sym_string_literal,
    STATE(837), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(1259), 2,
      sym_initializer_list,
      sym_initializer_pair,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    STATE(1143), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [1460] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1797), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_DOT,
    ACTIONS(1810), 1,
      anon_sym_RBRACE,
    STATE(542), 1,
      sym_string_literal,
    STATE(837), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(1259), 2,
      sym_initializer_list,
      sym_initializer_pair,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    STATE(1143), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [1557] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1812), 1,
      anon_sym_STAR,
    ACTIONS(1814), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(855), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(533), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [1649] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(902), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(31), 2,
      anon_sym_kernel,
      anon_sym___kernel,
    ACTIONS(1818), 3,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(49), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    ACTIONS(51), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(35), 6,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
    ACTIONS(1820), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(33), 10,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
    STATE(531), 10,
      sym_function_qualifier,
      sym_address_space_qualifier,
      sym_access_qualifier,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [1725] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1822), 1,
      anon_sym_STAR,
    ACTIONS(1824), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(876), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(777), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [1817] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1826), 1,
      anon_sym_STAR,
    ACTIONS(1828), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(860), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(534), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [1909] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1830), 1,
      anon_sym_STAR,
    ACTIONS(1832), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(883), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(537), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2001] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1834), 1,
      anon_sym_STAR,
    ACTIONS(1836), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(861), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(527), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2093] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(902), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(31), 2,
      anon_sym_kernel,
      anon_sym___kernel,
    ACTIONS(1838), 3,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(49), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    ACTIONS(51), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(35), 6,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
    ACTIONS(1840), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(33), 10,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
    STATE(342), 10,
      sym_function_qualifier,
      sym_address_space_qualifier,
      sym_access_qualifier,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [2169] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1842), 1,
      anon_sym_STAR,
    ACTIONS(1844), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(880), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(535), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2261] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1846), 1,
      anon_sym_STAR,
    ACTIONS(1848), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(857), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(777), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2353] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1850), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(872), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(777), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2445] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1854), 1,
      anon_sym_STAR,
    ACTIONS(1856), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(874), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(777), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1402), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(1400), 45,
      anon_sym___based,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
      sym_vector_type,
      anon_sym_image2d_t,
      anon_sym_image3d_t,
      anon_sym_image2d_array_t,
      anon_sym_image1d_t,
      anon_sym_image1d_buffer_t,
      anon_sym_image1d_array_t,
      anon_sym_image2d_depth_t,
      anon_sym_image2d_array_depth_t,
      anon_sym_sampler_t,
      anon_sym_queue_t,
      anon_sym_ndrange_t,
      anon_sym_clk_event_t,
      anon_sym_reserve_id_t,
      anon_sym_event_t,
      anon_sym_cl_mem_fence_flags,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [2595] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1769), 1,
      anon_sym_AMP,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(1858), 1,
      anon_sym_STAR,
    ACTIONS(1860), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(864), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(777), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1816), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2687] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(902), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(31), 2,
      anon_sym_kernel,
      anon_sym___kernel,
    ACTIONS(1862), 3,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(49), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    ACTIONS(51), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(35), 6,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
    ACTIONS(1864), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(33), 10,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
    STATE(539), 10,
      sym_function_qualifier,
      sym_address_space_qualifier,
      sym_access_qualifier,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [2763] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(902), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(31), 2,
      anon_sym_kernel,
      anon_sym___kernel,
    ACTIONS(1866), 3,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(49), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    ACTIONS(51), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(35), 6,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
    ACTIONS(1868), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(33), 10,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
    STATE(342), 10,
      sym_function_qualifier,
      sym_address_space_qualifier,
      sym_access_qualifier,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [2839] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1797), 1,
      anon_sym_LBRACK,
    ACTIONS(1799), 1,
      anon_sym_DOT,
    STATE(542), 1,
      sym_string_literal,
    STATE(837), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    STATE(1259), 2,
      sym_initializer_list,
      sym_initializer_pair,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    STATE(1143), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [2933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(541), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1874), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1872), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1870), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [2994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(543), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1733), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1727), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [3055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(541), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(1879), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1877), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [3116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1494), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [3171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1498), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [3226] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(902), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1881), 1,
      anon_sym_SEMI,
    ACTIONS(31), 2,
      anon_sym_kernel,
      anon_sym___kernel,
    ACTIONS(1862), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(1864), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(49), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    ACTIONS(51), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(35), 6,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
    ACTIONS(33), 10,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
    STATE(539), 10,
      sym_function_qualifier,
      sym_address_space_qualifier,
      sym_access_qualifier,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [3300] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(902), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1883), 1,
      anon_sym_SEMI,
    ACTIONS(31), 2,
      anon_sym_kernel,
      anon_sym___kernel,
    ACTIONS(1862), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(1864), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(49), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    ACTIONS(51), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(35), 6,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
    ACTIONS(33), 10,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
    STATE(539), 10,
      sym_function_qualifier,
      sym_address_space_qualifier,
      sym_access_qualifier,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [3374] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(902), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1885), 1,
      anon_sym_SEMI,
    ACTIONS(31), 2,
      anon_sym_kernel,
      anon_sym___kernel,
    ACTIONS(1862), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(1864), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(49), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    ACTIONS(51), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(35), 6,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
    ACTIONS(33), 10,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
    STATE(539), 10,
      sym_function_qualifier,
      sym_address_space_qualifier,
      sym_access_qualifier,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [3448] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(902), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1887), 1,
      anon_sym_SEMI,
    ACTIONS(31), 2,
      anon_sym_kernel,
      anon_sym___kernel,
    ACTIONS(1862), 2,
      anon_sym___based,
      sym_identifier,
    ACTIONS(1864), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(49), 5,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
    ACTIONS(51), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(35), 6,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
    ACTIONS(33), 10,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
    STATE(539), 10,
      sym_function_qualifier,
      sym_address_space_qualifier,
      sym_access_qualifier,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
  [3522] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(684), 1,
      sym_initializer_list,
    STATE(703), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3604] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(808), 1,
      sym__expression,
    STATE(1445), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3686] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1891), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(845), 1,
      sym__expression,
    STATE(1334), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3768] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(684), 1,
      sym_initializer_list,
    STATE(767), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3850] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1893), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(822), 1,
      sym__expression,
    STATE(1399), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [3932] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(684), 1,
      sym_initializer_list,
    STATE(767), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4014] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1895), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(821), 1,
      sym__expression,
    STATE(1401), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4096] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1897), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(819), 1,
      sym__expression,
    STATE(1405), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4178] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1899), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(841), 1,
      sym__expression,
    STATE(1466), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4260] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1901), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(838), 1,
      sym__expression,
    STATE(1375), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4342] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1903), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(827), 1,
      sym__expression,
    STATE(1376), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4424] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1905), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(844), 1,
      sym__expression,
    STATE(1359), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4506] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1907), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(804), 1,
      sym__expression,
    STATE(1431), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4588] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1909), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(814), 1,
      sym__expression,
    STATE(1408), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4670] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1911), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(830), 1,
      sym__expression,
    STATE(1369), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4752] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1913), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(843), 1,
      sym__expression,
    STATE(1337), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4834] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1915), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(803), 1,
      sym__expression,
    STATE(1434), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4916] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1917), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(817), 1,
      sym__expression,
    STATE(1398), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [4998] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1919), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(850), 1,
      sym__expression,
    STATE(1323), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5080] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(798), 1,
      sym__expression,
    STATE(1397), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5162] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(833), 1,
      sym__expression,
    STATE(1366), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5244] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1925), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(802), 1,
      sym__expression,
    STATE(1436), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5326] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1927), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(801), 1,
      sym__expression,
    STATE(1439), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5408] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1929), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(842), 1,
      sym__expression,
    STATE(1326), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5490] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1931), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(800), 1,
      sym__expression,
    STATE(1449), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5572] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1933), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(799), 1,
      sym__expression,
    STATE(1452), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5654] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1935), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(813), 1,
      sym__expression,
    STATE(1411), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5736] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1937), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(831), 1,
      sym__expression,
    STATE(1367), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5818] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1939), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(849), 1,
      sym__expression,
    STATE(1330), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5900] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1941), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(818), 1,
      sym__expression,
    STATE(1467), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [5982] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1943), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(829), 1,
      sym__expression,
    STATE(1470), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6064] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1945), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(847), 1,
      sym__expression,
    STATE(1332), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6146] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(832), 1,
      sym__expression,
    STATE(1262), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6228] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(684), 1,
      sym_initializer_list,
    STATE(703), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6310] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1947), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(824), 1,
      sym__expression,
    STATE(1465), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6392] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1949), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(823), 1,
      sym__expression,
    STATE(1400), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6474] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1951), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(825), 1,
      sym__expression,
    STATE(1377), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6556] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1953), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(806), 1,
      sym__expression,
    STATE(1448), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6638] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1955), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(851), 1,
      sym__expression,
    STATE(1490), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6720] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1957), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(820), 1,
      sym__expression,
    STATE(1395), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6802] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1426), 1,
      anon_sym_LBRACE,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(834), 1,
      sym__expression,
    STATE(1288), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6884] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1959), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(835), 1,
      sym__expression,
    STATE(1345), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [6966] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1961), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(839), 1,
      sym__expression,
    STATE(1362), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7048] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1963), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_string_literal,
    STATE(809), 1,
      sym__expression,
    STATE(1443), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7130] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1965), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(846), 1,
      sym__expression,
    STATE(1336), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7212] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1967), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(848), 1,
      sym__expression,
    STATE(1333), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1969), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [7345] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1973), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7424] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1975), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7503] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(815), 1,
      sym__expression,
    STATE(1418), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7582] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1977), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7661] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(796), 1,
      sym__expression,
    STATE(1293), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7740] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(793), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7819] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(1981), 1,
      anon_sym_RPAREN,
    STATE(542), 1,
      sym_string_literal,
    STATE(794), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7898] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(811), 1,
      sym__expression,
    STATE(1493), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [7977] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 1,
      anon_sym_STAR,
    ACTIONS(1743), 1,
      anon_sym_EQ,
    ACTIONS(1983), 1,
      anon_sym_LPAREN2,
    ACTIONS(1738), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(1741), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(1747), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1733), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1727), 12,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [8040] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1987), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8119] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1989), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8198] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1991), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8277] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1993), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8356] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1995), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8435] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1997), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8514] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(1999), 1,
      anon_sym_RBRACK,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8593] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(788), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8669] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(720), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    STATE(733), 1,
      sym_field_declaration_list,
    ACTIONS(2003), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2001), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [8799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      anon_sym_LBRACE,
    STATE(727), 1,
      sym_enumerator_list,
    ACTIONS(2009), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2007), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [8853] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(762), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [8929] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(759), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9005] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(875), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9081] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(761), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9157] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(862), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9233] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(865), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9309] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(881), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9385] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(863), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9461] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(859), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9537] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(878), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9613] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(763), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2013), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [9739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    STATE(735), 1,
      sym_field_declaration_list,
    ACTIONS(2019), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2017), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [9793] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(884), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9869] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(854), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [9945] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(758), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10021] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(764), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10097] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(756), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10173] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(789), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10249] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(686), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10325] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(780), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1727), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [10451] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(786), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10527] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    ACTIONS(2021), 1,
      anon_sym_LPAREN2,
    STATE(542), 1,
      sym_string_literal,
    STATE(783), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10603] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(648), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10679] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(778), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10755] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(779), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(1727), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [10881] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(873), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [10957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2023), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [11007] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(787), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11083] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2031), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2027), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [11143] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(760), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11219] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(754), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11295] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(784), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11371] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(791), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11447] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(765), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11523] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    ACTIONS(2039), 1,
      anon_sym_LPAREN2,
    STATE(542), 1,
      sym_string_literal,
    STATE(885), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11599] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(867), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11675] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(858), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11751] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(852), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [11827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2043), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2041), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [11877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2047), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2045), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [11927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2049), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [11977] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(882), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2055), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2053), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [12103] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2057), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [12167] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(782), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2067), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2065), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [12293] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(697), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12369] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(686), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12445] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(694), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12521] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(693), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12597] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(691), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12673] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(690), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12749] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(687), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12825] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(685), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12901] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(681), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [12977] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(663), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13053] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(856), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13129] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(807), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2069), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [13255] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(828), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    STATE(739), 1,
      sym_field_declaration_list,
    ACTIONS(2075), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2073), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [13385] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2057), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13451] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(648), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13527] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    ACTIONS(2079), 1,
      anon_sym_LPAREN2,
    STATE(542), 1,
      sym_string_literal,
    STATE(696), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [13603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2083), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2081), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [13653] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2085), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2087), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2057), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13723] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2063), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2057), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13783] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2085), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2087), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2057), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2093), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2091), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [13905] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2097), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2101), 1,
      anon_sym_PIPE,
    ACTIONS(2103), 1,
      anon_sym_CARET,
    ACTIONS(2105), 1,
      anon_sym_AMP,
    ACTIONS(2107), 1,
      anon_sym_EQ,
    ACTIONS(2109), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2085), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2087), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2095), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [13989] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2105), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2085), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2087), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2057), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14063] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2103), 1,
      anon_sym_CARET,
    ACTIONS(2105), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2063), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2085), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2087), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2057), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14139] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(869), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14215] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2063), 1,
      anon_sym_EQ,
    ACTIONS(2101), 1,
      anon_sym_PIPE,
    ACTIONS(2103), 1,
      anon_sym_CARET,
    ACTIONS(2105), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2085), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2087), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2057), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14293] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2063), 1,
      anon_sym_EQ,
    ACTIONS(2099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2101), 1,
      anon_sym_PIPE,
    ACTIONS(2103), 1,
      anon_sym_CARET,
    ACTIONS(2105), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2085), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2087), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2057), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14373] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(870), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14449] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2111), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14515] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2057), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    STATE(743), 1,
      sym_field_declaration_list,
    ACTIONS(2117), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2115), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [14631] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(877), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14707] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(763), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14783] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(766), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14859] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(871), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [14935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2121), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2119), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [14995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2125), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2123), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15045] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(757), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15121] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(868), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15197] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2097), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2099), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2101), 1,
      anon_sym_PIPE,
    ACTIONS(2103), 1,
      anon_sym_CARET,
    ACTIONS(2105), 1,
      anon_sym_AMP,
    ACTIONS(2129), 1,
      anon_sym_EQ,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2059), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2077), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2085), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2087), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2061), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2127), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [15279] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    ACTIONS(2131), 1,
      anon_sym_LPAREN2,
    STATE(542), 1,
      sym_string_literal,
    STATE(755), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15355] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(689), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15431] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(754), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15507] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(771), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15583] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2135), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2133), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [15643] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(770), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15719] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1502), 1,
      anon_sym_LPAREN2,
    ACTIONS(1512), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(764), 1,
      sym__expression,
    ACTIONS(1504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1506), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1510), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2137), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [15845] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(790), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15921] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(866), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [15997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2141), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [16047] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1761), 1,
      sym_identifier,
    ACTIONS(1763), 1,
      anon_sym_LPAREN2,
    ACTIONS(1773), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(853), 1,
      sym__expression,
    ACTIONS(1765), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1767), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1769), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1771), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(773), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [16123] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2147), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2145), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [16181] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1412), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_LPAREN2,
    ACTIONS(1430), 1,
      anon_sym_sizeof,
    STATE(542), 1,
      sym_string_literal,
    STATE(712), 1,
      sym__expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(1418), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1420), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(1428), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(644), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [16257] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(91), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      sym_number_literal,
    ACTIONS(1759), 1,
      sym_identifier,
    STATE(542), 1,
      sym_string_literal,
    STATE(720), 1,
      sym__expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(89), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(99), 3,
      sym_true,
      sym_false,
      sym_null,
    ACTIONS(95), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(97), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(723), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(638), 10,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
  [16333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_EQ,
    ACTIONS(1747), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1733), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1727), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [16386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2149), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2155), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2153), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2157), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2163), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2161), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2167), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2165), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2171), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2169), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2173), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2179), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2177), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2181), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2185), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2189), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2193), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [16962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_LPAREN2,
    ACTIONS(1741), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(1725), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2200), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2204), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2208), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2212), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2216), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2220), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2224), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2228), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2232), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2236), 33,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [17492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_sizeof,
      sym_true,
      sym_false,
      sym_null,
      sym_identifier,
    ACTIONS(1144), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [17539] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_EQ,
    ACTIONS(1749), 1,
      anon_sym_COLON,
    ACTIONS(1747), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1733), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1727), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_EQ,
    ACTIONS(1745), 1,
      anon_sym_COLON,
    ACTIONS(1747), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1733), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1727), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_sizeof,
      sym_true,
      sym_false,
      sym_null,
      sym_identifier,
    ACTIONS(1969), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [17692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1138), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_sizeof,
      sym_true,
      sym_false,
      sym_null,
      sym_identifier,
    ACTIONS(1140), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [17739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_EQ,
    ACTIONS(1751), 1,
      anon_sym_COLON,
    ACTIONS(1747), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1733), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1727), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17792] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_EQ,
    ACTIONS(1753), 1,
      anon_sym_COLON,
    ACTIONS(1747), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1733), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1727), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [17845] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2031), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2027), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17901] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2113), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2111), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [17963] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2135), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2133), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18019] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2107), 1,
      anon_sym_EQ,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2252), 1,
      anon_sym_PIPE,
    ACTIONS(2254), 1,
      anon_sym_CARET,
    ACTIONS(2256), 1,
      anon_sym_AMP,
    ACTIONS(2264), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2258), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2095), 11,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18099] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2057), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18159] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2057), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18221] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2057), 16,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18287] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2258), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2057), 14,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18355] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2256), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2258), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2063), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2057), 14,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18425] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2063), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2057), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2147), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2145), 20,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [18535] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2254), 1,
      anon_sym_CARET,
    ACTIONS(2256), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2063), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2258), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2057), 14,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18607] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2063), 1,
      anon_sym_EQ,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2252), 1,
      anon_sym_PIPE,
    ACTIONS(2254), 1,
      anon_sym_CARET,
    ACTIONS(2256), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2258), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2057), 14,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18681] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2121), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2119), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18737] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 1,
      anon_sym_LPAREN2,
    ACTIONS(2273), 1,
      anon_sym_LBRACK,
    ACTIONS(1741), 2,
      anon_sym_COMMA,
      anon_sym_STAR,
    ACTIONS(2266), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1725), 32,
      anon_sym_kernel,
      anon_sym___kernel,
      anon_sym_global,
      anon_sym___global,
      anon_sym_local,
      anon_sym___local,
      anon_sym_constant,
      anon_sym___constant,
      anon_sym_private,
      anon_sym___private,
      anon_sym_generic,
      anon_sym___generic,
      anon_sym_read_only,
      anon_sym___read_only,
      anon_sym_write_only,
      anon_sym___write_only,
      anon_sym_read_write,
      anon_sym___read_write,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [18789] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2129), 1,
      anon_sym_EQ,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2248), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2252), 1,
      anon_sym_PIPE,
    ACTIONS(2254), 1,
      anon_sym_CARET,
    ACTIONS(2256), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2258), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2127), 12,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18867] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2063), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2057), 18,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [18925] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2063), 1,
      anon_sym_EQ,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2252), 1,
      anon_sym_PIPE,
    ACTIONS(2254), 1,
      anon_sym_CARET,
    ACTIONS(2256), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2258), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2244), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2057), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [19001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2069), 24,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_EQ,
    ACTIONS(2278), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1733), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1727), 14,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2093), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2091), 24,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2137), 24,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [19185] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 1,
      anon_sym_LPAREN2,
    ACTIONS(1154), 1,
      anon_sym_STAR,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2288), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1027), 1,
      sym__declarator,
    STATE(1149), 1,
      sym__abstract_declarator,
    STATE(1162), 1,
      sym_parameter_list,
    STATE(1382), 1,
      sym_ms_based_modifier,
    ACTIONS(2282), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(879), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(891), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1160), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [19260] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(777), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2290), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(1801), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      sym_true,
      sym_false,
      sym_null,
      sym_identifier,
    ACTIONS(1803), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [19305] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2063), 1,
      anon_sym_PIPE,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [19372] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2063), 1,
      anon_sym_PIPE,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [19437] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [19506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      anon_sym_sizeof,
      sym_true,
      sym_false,
      sym_null,
      sym_identifier,
    ACTIONS(1402), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [19545] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2095), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [19618] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2113), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2111), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [19675] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2063), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2057), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [19732] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 1,
      sym_identifier,
    STATE(792), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1079), 1,
      sym_scalar_type,
    ACTIONS(1778), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(2321), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1780), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    ACTIONS(1348), 15,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
  [19781] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [19848] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2063), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [19911] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2063), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [19972] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2063), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2057), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [20025] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2127), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [20096] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2063), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2057), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [20151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(792), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(1786), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(2323), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(1784), 21,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      anon_sym_bool,
      anon_sym_char,
      anon_sym_uchar,
      anon_sym_ushort,
      anon_sym_int,
      anon_sym_uint,
      anon_sym_ulong,
      anon_sym_float,
      anon_sym_double,
      anon_sym_half,
      anon_sym_size_t,
      anon_sym_ptrdiff_t,
      anon_sym_intptr_t,
      anon_sym_uintptr_t,
      anon_sym_void,
      sym_identifier,
  [20193] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2326), 1,
      anon_sym_COMMA,
    ACTIONS(2328), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    STATE(1199), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20268] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2326), 1,
      anon_sym_COMMA,
    ACTIONS(2330), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    STATE(1240), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20343] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2332), 1,
      anon_sym_COMMA,
    ACTIONS(2334), 1,
      anon_sym_RBRACE,
    STATE(662), 1,
      sym_argument_list,
    STATE(1223), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20418] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2338), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [20491] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2340), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20563] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2342), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20635] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2344), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20707] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2346), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20779] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2348), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20851] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2350), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20923] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2352), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [20995] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2354), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21067] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2356), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21139] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2358), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21211] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2360), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [21281] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2362), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21353] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2364), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21425] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2366), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21497] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2368), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21569] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2370), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21641] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2372), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21713] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2374), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21785] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2376), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21857] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2378), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [21929] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2380), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22001] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2382), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22073] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2384), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22145] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2386), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22217] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2388), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22289] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2390), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22361] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2392), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22433] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2394), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22505] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2396), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22577] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2398), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22649] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2400), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22721] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2402), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [22791] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2404), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22863] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2406), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [22935] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2408), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23007] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2410), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [23077] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2412), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23149] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2414), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [23219] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2416), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23291] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2418), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23363] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2420), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [23433] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23505] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2424), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23577] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2426), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23649] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2428), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23721] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2430), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23793] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2432), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23865] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2434), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [23937] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24009] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2438), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24081] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2440), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24153] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2442), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24225] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2444), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24297] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2446), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24369] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      anon_sym_COMMA,
    ACTIONS(2448), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24441] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2450), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24510] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2095), 1,
      anon_sym_RBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24579] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [24642] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24711] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2478), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24780] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24849] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2480), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [24918] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2063), 1,
      anon_sym_PIPE,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [24981] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25050] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25119] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2063), 1,
      anon_sym_PIPE,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [25180] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2063), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [25239] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25308] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2063), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [25365] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2063), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2057), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [25418] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    ACTIONS(2482), 1,
      anon_sym_RBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25487] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2063), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2057), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [25538] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2484), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25607] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2486), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25676] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2488), 1,
      anon_sym_SEMI,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25745] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25814] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    ACTIONS(2490), 1,
      anon_sym_RBRACK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25883] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [25952] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2492), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [26021] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1973), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [26090] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2494), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [26159] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2057), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [26224] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 1,
      anon_sym_LPAREN2,
    ACTIONS(1154), 1,
      anon_sym_STAR,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2288), 1,
      anon_sym_LBRACK,
    STATE(1044), 1,
      sym__declarator,
    STATE(1152), 1,
      sym__abstract_declarator,
    STATE(1162), 1,
      sym_parameter_list,
    STATE(1382), 1,
      sym_ms_based_modifier,
    ACTIONS(2496), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1160), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [26283] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [26352] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2297), 1,
      anon_sym_SLASH,
    ACTIONS(2299), 1,
      anon_sym_CARET,
    ACTIONS(2301), 1,
      anon_sym_AMP,
    ACTIONS(2311), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2313), 1,
      anon_sym_PIPE,
    ACTIONS(2315), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2498), 1,
      anon_sym_COLON,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2293), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2295), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2303), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2305), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2307), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [26421] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2127), 2,
      anon_sym_RBRACK,
      anon_sym_QMARK,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [26488] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_RBRACK,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    ACTIONS(2458), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2460), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 1,
      anon_sym_CARET,
    ACTIONS(2466), 1,
      anon_sym_AMP,
    ACTIONS(2476), 1,
      anon_sym_QMARK,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2470), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2472), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [26557] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2063), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2057), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [26606] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_LPAREN2,
    ACTIONS(2456), 1,
      anon_sym_SLASH,
    STATE(662), 1,
      sym_argument_list,
    ACTIONS(2035), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2037), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2452), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2474), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2113), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2111), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [26659] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1097), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(888), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(993), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [26715] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1097), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(993), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1003), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [26771] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1089), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(995), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1003), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [26827] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1024), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(991), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1003), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [26883] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1027), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(891), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(997), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [26939] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1044), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(994), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1003), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [26995] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1100), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(887), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(989), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [27051] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1063), 1,
      sym__field_declarator,
    STATE(1486), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(996), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1003), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [27107] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1044), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(889), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(994), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [27163] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1063), 1,
      sym__field_declarator,
    STATE(1486), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(897), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(996), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [27219] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1059), 1,
      sym__field_declarator,
    STATE(1486), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(893), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(990), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [27275] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1066), 1,
      sym__field_declarator,
    STATE(1486), 1,
      sym_ms_based_modifier,
    ACTIONS(2286), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(992), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1003), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2284), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [27331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 1,
      anon_sym_LPAREN2,
    STATE(922), 1,
      sym_preproc_argument_list,
    ACTIONS(2520), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2516), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27365] = 5,
    ACTIONS(2516), 1,
      anon_sym_LF,
    ACTIONS(2522), 1,
      anon_sym_LPAREN2,
    ACTIONS(2524), 1,
      sym_comment,
    STATE(970), 1,
      sym_preproc_argument_list,
    ACTIONS(2520), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27398] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2528), 1,
      anon_sym_RPAREN,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2538), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(903), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27441] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2542), 1,
      anon_sym_RPAREN,
    ACTIONS(2544), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(902), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27484] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_COMMA,
    ACTIONS(2548), 1,
      anon_sym_RPAREN,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2556), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2558), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2560), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_CARET,
    ACTIONS(2564), 1,
      anon_sym_AMP,
    STATE(1206), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27539] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_COMMA,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2556), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2558), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2560), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_CARET,
    ACTIONS(2564), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_RPAREN,
    STATE(1237), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27594] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2586), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(983), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2590), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27662] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1152), 1,
      anon_sym_LPAREN2,
    ACTIONS(1154), 1,
      anon_sym_STAR,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2288), 1,
      anon_sym_LBRACK,
    STATE(1120), 1,
      sym__declarator,
    STATE(1148), 1,
      sym__abstract_declarator,
    STATE(1162), 1,
      sym_parameter_list,
    STATE(1382), 1,
      sym_ms_based_modifier,
    ACTIONS(2594), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1160), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [27710] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2596), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(961), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27750] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2598), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(986), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2600), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2604), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27846] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2608), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(974), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27886] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2610), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(980), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27926] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2612), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(925), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [27966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2616), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2614), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [27998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2614), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28026] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2618), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(968), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28066] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2620), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(984), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28106] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2558), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2560), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_CARET,
    ACTIONS(2564), 1,
      anon_sym_AMP,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [28154] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2622), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(963), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28194] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2556), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2558), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2560), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_CARET,
    ACTIONS(2564), 1,
      anon_sym_AMP,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2624), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [28244] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2626), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(979), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2628), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2634), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2632), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28340] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2560), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_CARET,
    ACTIONS(2564), 1,
      anon_sym_AMP,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [28386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2638), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2636), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28414] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2640), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(969), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28454] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2642), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(959), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28494] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2616), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2614), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [28528] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2644), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(914), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28568] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2646), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(915), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28608] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2648), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(973), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28648] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2650), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(918), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28688] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2652), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(924), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28728] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2654), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(943), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28768] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2656), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(938), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28808] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2658), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(951), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28848] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2616), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2614), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28884] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2564), 1,
      anon_sym_AMP,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [28928] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2660), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(987), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [28968] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2662), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(946), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29008] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2664), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(937), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29048] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2666), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(928), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29088] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2562), 1,
      anon_sym_CARET,
    ACTIONS(2564), 1,
      anon_sym_AMP,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2614), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [29134] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2668), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(985), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2670), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29202] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2616), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2614), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [29242] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2674), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(981), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29282] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2676), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(977), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29322] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      sym_identifier,
    ACTIONS(2530), 1,
      anon_sym_LPAREN2,
    ACTIONS(2532), 1,
      anon_sym_defined,
    ACTIONS(2678), 1,
      sym_number_literal,
    ACTIONS(2534), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2540), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(920), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29362] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2680), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(976), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29402] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2616), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2614), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [29444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2141), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29472] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2682), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(972), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29512] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2684), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(971), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2688), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2686), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29580] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2690), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(988), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29620] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2692), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(978), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29660] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_identifier,
    ACTIONS(2578), 1,
      anon_sym_LPAREN2,
    ACTIONS(2580), 1,
      anon_sym_defined,
    ACTIONS(2694), 1,
      sym_number_literal,
    ACTIONS(2582), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2584), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2588), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(975), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [29700] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2556), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2558), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2560), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_CARET,
    ACTIONS(2564), 1,
      anon_sym_AMP,
    ACTIONS(2696), 1,
      anon_sym_RPAREN,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29749] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_LF,
    ACTIONS(2592), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29776] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2698), 1,
      anon_sym_LF,
    ACTIONS(2704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [29821] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2686), 1,
      anon_sym_LF,
    ACTIONS(2688), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29848] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2636), 1,
      anon_sym_LF,
    ACTIONS(2638), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29875] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_LF,
    ACTIONS(2672), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29902] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2604), 1,
      anon_sym_LF,
    ACTIONS(2606), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29929] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2600), 1,
      anon_sym_LF,
    ACTIONS(2602), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29956] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_LF,
    ACTIONS(2634), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [29983] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2720), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30028] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2722), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30073] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LF,
    ACTIONS(2630), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30100] = 11,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2616), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30143] = 10,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2616), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30184] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2724), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30229] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2726), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30274] = 4,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2616), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30303] = 9,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2616), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30342] = 8,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(2616), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [30379] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2616), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30406] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_SLASH,
    ACTIONS(2556), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2558), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2560), 1,
      anon_sym_PIPE,
    ACTIONS(2562), 1,
      anon_sym_CARET,
    ACTIONS(2564), 1,
      anon_sym_AMP,
    ACTIONS(2728), 1,
      anon_sym_RPAREN,
    ACTIONS(2550), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2552), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2566), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2568), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2570), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30455] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2730), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30500] = 7,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(2616), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [30535] = 3,
    ACTIONS(2141), 1,
      anon_sym_LF,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2143), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30562] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2732), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30607] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2734), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30652] = 6,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2616), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30685] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2736), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30730] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2616), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [30761] = 12,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2616), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2708), 1,
      anon_sym_PIPE,
    ACTIONS(2710), 1,
      anon_sym_CARET,
    ACTIONS(2712), 1,
      anon_sym_AMP,
    ACTIONS(2700), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2718), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2702), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2716), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [30806] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1097), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [30846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    STATE(1063), 1,
      sym__field_declarator,
    STATE(1486), 1,
      sym_ms_based_modifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [30886] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1039), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [30926] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    STATE(1067), 1,
      sym__field_declarator,
    STATE(1486), 1,
      sym_ms_based_modifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [30966] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1089), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [31006] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1024), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31046] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1109), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [31086] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    STATE(1066), 1,
      sym__field_declarator,
    STATE(1486), 1,
      sym_ms_based_modifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [31126] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1044), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(1344), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31166] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      anon_sym_LPAREN2,
    ACTIONS(1332), 1,
      anon_sym_STAR,
    ACTIONS(2288), 1,
      anon_sym_LBRACK,
    ACTIONS(2738), 1,
      anon_sym_RPAREN,
    STATE(1162), 1,
      sym_parameter_list,
    STATE(1166), 1,
      sym__abstract_declarator,
    STATE(1002), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1160), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(2740), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [31205] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      anon_sym_LPAREN2,
    ACTIONS(1332), 1,
      anon_sym_STAR,
    ACTIONS(2288), 1,
      anon_sym_LBRACK,
    ACTIONS(2742), 1,
      anon_sym_RPAREN,
    STATE(1158), 1,
      sym__abstract_declarator,
    STATE(1162), 1,
      sym_parameter_list,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1160), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(2740), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [31244] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      anon_sym_LPAREN2,
    ACTIONS(1332), 1,
      anon_sym_STAR,
    ACTIONS(2288), 1,
      anon_sym_LBRACK,
    ACTIONS(2744), 1,
      anon_sym_RPAREN,
    STATE(1159), 1,
      sym__abstract_declarator,
    STATE(1162), 1,
      sym_parameter_list,
    STATE(999), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1160), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(2740), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [31283] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      anon_sym_LPAREN2,
    ACTIONS(1332), 1,
      anon_sym_STAR,
    ACTIONS(2282), 1,
      anon_sym_RPAREN,
    ACTIONS(2288), 1,
      anon_sym_LBRACK,
    STATE(1149), 1,
      sym__abstract_declarator,
    STATE(1162), 1,
      sym_parameter_list,
    STATE(1004), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1160), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(2740), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [31322] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      anon_sym_LPAREN2,
    ACTIONS(1332), 1,
      anon_sym_STAR,
    ACTIONS(2288), 1,
      anon_sym_LBRACK,
    ACTIONS(2746), 1,
      anon_sym_RPAREN,
    STATE(1156), 1,
      sym__abstract_declarator,
    STATE(1162), 1,
      sym_parameter_list,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1160), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(2740), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [31361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1008), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(2750), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(2755), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1003), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(2752), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(2748), 7,
      anon_sym___based,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [31394] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 1,
      anon_sym_LPAREN2,
    ACTIONS(1332), 1,
      anon_sym_STAR,
    ACTIONS(2288), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_RPAREN,
    STATE(1152), 1,
      sym__abstract_declarator,
    STATE(1162), 1,
      sym_parameter_list,
    STATE(522), 2,
      sym_type_qualifier,
      aux_sym_type_definition_repeat1,
    STATE(1160), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(2740), 5,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [31433] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    ACTIONS(2758), 1,
      anon_sym_SEMI,
    ACTIONS(2760), 1,
      anon_sym_COLON,
    STATE(1050), 1,
      sym__field_declarator,
    STATE(1384), 1,
      sym_bitfield_clause,
    STATE(1486), 1,
      sym_ms_based_modifier,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [31471] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    ACTIONS(2760), 1,
      anon_sym_COLON,
    ACTIONS(2762), 1,
      anon_sym_SEMI,
    STATE(1048), 1,
      sym__field_declarator,
    STATE(1475), 1,
      sym_bitfield_clause,
    STATE(1486), 1,
      sym_ms_based_modifier,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [31509] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    ACTIONS(2760), 1,
      anon_sym_COLON,
    ACTIONS(2764), 1,
      anon_sym_SEMI,
    STATE(1023), 1,
      sym__field_declarator,
    STATE(1458), 1,
      sym_bitfield_clause,
    STATE(1486), 1,
      sym_ms_based_modifier,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [31547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2768), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(2766), 12,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [31569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(2770), 12,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
      sym_identifier,
  [31591] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1057), 1,
      sym__declarator,
    STATE(1244), 1,
      sym_init_declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31623] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1019), 1,
      sym__declarator,
    STATE(1203), 1,
      sym_init_declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31655] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1056), 1,
      sym__declarator,
    STATE(1226), 1,
      sym_init_declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31687] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(411), 1,
      anon_sym_LBRACE,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2778), 1,
      anon_sym_SEMI,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    STATE(241), 1,
      sym_compound_statement,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1214), 1,
      aux_sym_declaration_repeat1,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [31725] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1013), 1,
      sym__declarator,
    STATE(1226), 1,
      sym_init_declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31757] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    ACTIONS(2784), 1,
      anon_sym_SEMI,
    STATE(265), 1,
      sym_compound_statement,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1198), 1,
      aux_sym_declaration_repeat1,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [31795] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1061), 1,
      sym__declarator,
    STATE(1216), 1,
      sym_init_declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31827] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(125), 1,
      anon_sym_LBRACE,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    ACTIONS(2786), 1,
      anon_sym_SEMI,
    STATE(120), 1,
      sym_compound_statement,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1190), 1,
      aux_sym_declaration_repeat1,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [31865] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1017), 1,
      sym__declarator,
    STATE(1216), 1,
      sym_init_declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31897] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(518), 1,
      anon_sym_LBRACE,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    ACTIONS(2788), 1,
      anon_sym_SEMI,
    STATE(242), 1,
      sym_compound_statement,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1249), 1,
      aux_sym_declaration_repeat1,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [31935] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1106), 1,
      sym__declarator,
    STATE(1260), 1,
      sym_init_declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31967] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1060), 1,
      sym__declarator,
    STATE(1203), 1,
      sym_init_declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [31999] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1015), 1,
      sym__declarator,
    STATE(1244), 1,
      sym_init_declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [32031] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2760), 1,
      anon_sym_COLON,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2790), 1,
      anon_sym_COMMA,
    ACTIONS(2792), 1,
      anon_sym_SEMI,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    STATE(1126), 1,
      sym_parameter_list,
    STATE(1150), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1453), 1,
      sym_bitfield_clause,
    STATE(1075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [32066] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2796), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [32093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym___attribute__,
    ACTIONS(2803), 1,
      anon_sym_LBRACK,
    STATE(1025), 2,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(2798), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [32116] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    STATE(1123), 1,
      sym__field_declarator,
    STATE(1486), 1,
      sym_ms_based_modifier,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [32145] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2805), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [32172] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1095), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LBRACE,
    STATE(1108), 1,
      sym_field_declaration_list,
    ACTIONS(2019), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [32222] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1099), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32251] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1119), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [32280] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1087), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LBRACE,
    STATE(1068), 1,
      sym_field_declaration_list,
    ACTIONS(2117), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [32330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LBRACE,
    STATE(1098), 1,
      sym_field_declaration_list,
    ACTIONS(2075), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [32351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2811), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2814), 1,
      anon_sym_LBRACK,
    STATE(1035), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2809), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [32374] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1130), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [32403] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2510), 1,
      sym_identifier,
    ACTIONS(2512), 1,
      anon_sym_LPAREN2,
    ACTIONS(2514), 1,
      anon_sym_STAR,
    STATE(1073), 1,
      sym__field_declarator,
    STATE(1486), 1,
      sym_ms_based_modifier,
    STATE(1131), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [32432] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1094), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32461] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2816), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [32488] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym___attribute__,
    ACTIONS(2822), 1,
      anon_sym_LBRACK,
    STATE(1025), 2,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(2818), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [32511] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1093), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32540] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1127), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32569] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1114), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [32598] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2824), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [32625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    STATE(1102), 1,
      sym_enumerator_list,
    ACTIONS(2009), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [32646] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1074), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32675] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1072), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32704] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2760), 1,
      anon_sym_COLON,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2790), 1,
      anon_sym_COMMA,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    ACTIONS(2828), 1,
      anon_sym_SEMI,
    STATE(1126), 1,
      sym_parameter_list,
    STATE(1146), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1413), 1,
      sym_bitfield_clause,
    STATE(1075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [32739] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1086), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32768] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2760), 1,
      anon_sym_COLON,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2790), 1,
      anon_sym_COMMA,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    ACTIONS(2830), 1,
      anon_sym_SEMI,
    STATE(1126), 1,
      sym_parameter_list,
    STATE(1151), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1378), 1,
      sym_bitfield_clause,
    STATE(1075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [32803] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1121), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [32832] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2500), 1,
      sym_identifier,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    ACTIONS(2504), 1,
      anon_sym_STAR,
    STATE(1118), 1,
      sym__type_declarator,
    STATE(1380), 1,
      sym_ms_based_modifier,
    STATE(1134), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [32861] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1156), 1,
      anon_sym___based,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2506), 1,
      anon_sym_LPAREN2,
    ACTIONS(2508), 1,
      anon_sym_STAR,
    STATE(1111), 1,
      sym__declarator,
    STATE(1382), 1,
      sym_ms_based_modifier,
    STATE(1117), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [32890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LBRACE,
    STATE(1077), 1,
      sym_field_declaration_list,
    ACTIONS(2003), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [32911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym___attribute__,
    ACTIONS(2834), 1,
      anon_sym_LBRACK,
    STATE(1040), 2,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(2832), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [32934] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2778), 1,
      anon_sym_SEMI,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1214), 1,
      aux_sym_declaration_repeat1,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [32966] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    ACTIONS(2784), 1,
      anon_sym_SEMI,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1198), 1,
      aux_sym_declaration_repeat1,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [32998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2838), 1,
      anon_sym_LBRACK,
    STATE(1035), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2836), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [33020] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    STATE(1126), 1,
      sym_parameter_list,
    STATE(1075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2840), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [33046] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    ACTIONS(2788), 1,
      anon_sym_SEMI,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1249), 1,
      aux_sym_declaration_repeat1,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33078] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    ACTIONS(2786), 1,
      anon_sym_SEMI,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1190), 1,
      aux_sym_declaration_repeat1,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_LBRACK,
    ACTIONS(2842), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [33128] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    STATE(1126), 1,
      sym_parameter_list,
    STATE(1075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2846), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [33154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_LBRACK,
    ACTIONS(2848), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [33172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 1,
      anon_sym_LBRACK,
    ACTIONS(2852), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [33190] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    STATE(1126), 1,
      sym_parameter_list,
    STATE(1075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2856), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [33216] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    STATE(1126), 1,
      sym_parameter_list,
    STATE(1075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2858), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [33242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2226), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2234), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33302] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(2862), 1,
      anon_sym_SEMI,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1235), 1,
      aux_sym_type_definition_repeat2,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33331] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    STATE(1126), 1,
      sym_parameter_list,
    STATE(1075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2866), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [33356] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    ACTIONS(2868), 1,
      anon_sym_SEMI,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1218), 1,
      aux_sym_type_definition_repeat2,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2872), 1,
      anon_sym_LBRACK,
    STATE(1035), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2870), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [33406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(2878), 1,
      sym_system_lib_string,
    STATE(1344), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(2876), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2167), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 1,
      sym_identifier,
    ACTIONS(2882), 1,
      sym_system_lib_string,
    STATE(1420), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(2876), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      sym_identifier,
    ACTIONS(2886), 1,
      sym_system_lib_string,
    STATE(1462), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(2876), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33574] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    ACTIONS(2888), 1,
      anon_sym_SEMI,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1243), 1,
      aux_sym_type_definition_repeat2,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33603] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    ACTIONS(2890), 1,
      anon_sym_SEMI,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1196), 1,
      aux_sym_type_definition_repeat2,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2171), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33647] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2892), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2206), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33717] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    ACTIONS(2894), 1,
      anon_sym_SEMI,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1192), 1,
      aux_sym_type_definition_repeat2,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33746] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    ACTIONS(2896), 1,
      anon_sym_SEMI,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1245), 1,
      aux_sym_type_definition_repeat2,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33775] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    ACTIONS(2898), 1,
      anon_sym_SEMI,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1201), 1,
      aux_sym_type_definition_repeat2,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 1,
      sym_identifier,
    ACTIONS(2902), 1,
      sym_system_lib_string,
    STATE(1496), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(2876), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2904), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33865] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    ACTIONS(2906), 1,
      anon_sym_SEMI,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1246), 1,
      aux_sym_type_definition_repeat2,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [33894] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2908), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [33919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2218), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2163), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2179), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_LPAREN2,
    ACTIONS(1741), 8,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [33996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    STATE(1055), 1,
      sym_parameter_list,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2155), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [34038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym__Atomic,
      anon_sym_pipe,
  [34053] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2915), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [34078] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2919), 1,
      anon_sym_LBRACK,
    STATE(1035), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(2917), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
  [34098] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    STATE(252), 1,
      sym_compound_statement,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_LBRACK,
    ACTIONS(2921), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 1,
      anon_sym_LBRACK,
    ACTIONS(2925), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34156] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(125), 1,
      anon_sym_LBRACE,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    STATE(112), 1,
      sym_compound_statement,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 1,
      anon_sym_LBRACK,
    ACTIONS(2933), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 1,
      anon_sym_LBRACK,
    ACTIONS(2937), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34230] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    STATE(1142), 1,
      sym_parameter_list,
    ACTIONS(2941), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34254] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(411), 1,
      anon_sym_LBRACE,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    STATE(247), 1,
      sym_compound_statement,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34280] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    STATE(1055), 1,
      sym_parameter_list,
    ACTIONS(2943), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34304] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(518), 1,
      anon_sym_LBRACE,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    STATE(254), 1,
      sym_compound_statement,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 1,
      anon_sym_LBRACK,
    ACTIONS(2945), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [34346] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2794), 1,
      anon_sym_LBRACK,
    ACTIONS(2949), 1,
      anon_sym_RPAREN,
    STATE(1126), 1,
      sym_parameter_list,
    STATE(1075), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_LBRACK,
    ACTIONS(2951), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [34384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [34399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      anon_sym_LBRACK,
    ACTIONS(2959), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [34414] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2864), 1,
      anon_sym_LBRACK,
    ACTIONS(2963), 1,
      anon_sym_RPAREN,
    STATE(1142), 1,
      sym_parameter_list,
    STATE(1110), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_LBRACK,
    ACTIONS(2965), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [34452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      anon_sym_LBRACK,
    ACTIONS(2969), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [34467] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(2780), 1,
      anon_sym_LBRACK,
    ACTIONS(2973), 1,
      anon_sym_RPAREN,
    STATE(1055), 1,
      sym_parameter_list,
    STATE(1058), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [34490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_LBRACK,
    ACTIONS(2975), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [34505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 1,
      anon_sym_LBRACK,
    ACTIONS(2979), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [34520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 1,
      anon_sym_LBRACK,
    ACTIONS(2983), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [34535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 1,
      anon_sym_LBRACK,
    ACTIONS(2987), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [34549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_LBRACK,
    ACTIONS(2991), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [34563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(2995), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [34577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3001), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [34591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_LBRACK,
    ACTIONS(3003), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [34605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3007), 1,
      anon_sym_LBRACK,
    ACTIONS(3010), 1,
      anon_sym_EQ,
    ACTIONS(3012), 1,
      anon_sym_DOT,
    STATE(1139), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [34623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_LBRACK,
    ACTIONS(3015), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [34637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3019), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [34651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3025), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [34665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 1,
      anon_sym_LBRACK,
    ACTIONS(3027), 1,
      anon_sym_EQ,
    ACTIONS(3029), 1,
      anon_sym_DOT,
    STATE(1139), 3,
      sym_subscript_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [34683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(2807), 1,
      anon_sym_LBRACE,
    ACTIONS(3031), 1,
      sym_identifier,
    STATE(1092), 1,
      sym_field_declaration_list,
    STATE(1222), 1,
      sym_ms_declspec_modifier,
  [34702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    ACTIONS(3035), 1,
      anon_sym_COLON_COLON,
    STATE(1294), 1,
      sym_argument_list,
    ACTIONS(3033), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [34719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_COLON,
    ACTIONS(2790), 1,
      anon_sym_COMMA,
    ACTIONS(3037), 1,
      anon_sym_SEMI,
    STATE(1186), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1329), 1,
      sym_bitfield_clause,
  [34738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    ACTIONS(3039), 1,
      sym_identifier,
    STATE(726), 1,
      sym_field_declaration_list,
    STATE(1213), 1,
      sym_ms_declspec_modifier,
  [34757] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    STATE(1157), 1,
      sym_parameter_list,
    ACTIONS(2943), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [34774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    STATE(1157), 1,
      sym_parameter_list,
    ACTIONS(3043), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [34791] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_COLON,
    ACTIONS(2790), 1,
      anon_sym_COMMA,
    ACTIONS(3045), 1,
      anon_sym_SEMI,
    STATE(1186), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1440), 1,
      sym_bitfield_clause,
  [34810] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_COLON,
    ACTIONS(2790), 1,
      anon_sym_COMMA,
    ACTIONS(3047), 1,
      anon_sym_SEMI,
    STATE(1186), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1371), 1,
      sym_bitfield_clause,
  [34829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    STATE(1157), 1,
      sym_parameter_list,
    ACTIONS(3049), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [34846] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    ACTIONS(3051), 1,
      sym_identifier,
    STATE(737), 1,
      sym_field_declaration_list,
    STATE(1212), 1,
      sym_ms_declspec_modifier,
  [34865] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(2807), 1,
      anon_sym_LBRACE,
    ACTIONS(3053), 1,
      sym_identifier,
    STATE(1071), 1,
      sym_field_declaration_list,
    STATE(1220), 1,
      sym_ms_declspec_modifier,
  [34884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3055), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [34894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3057), 1,
      anon_sym_RPAREN,
    STATE(1157), 1,
      sym_parameter_list,
  [34910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [34920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3061), 1,
      anon_sym_RPAREN,
    STATE(1157), 1,
      sym_parameter_list,
  [34936] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3063), 1,
      anon_sym_RPAREN,
    STATE(1157), 1,
      sym_parameter_list,
  [34952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [34962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3067), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [34972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [34982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3071), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [34992] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3073), 1,
      anon_sym_LF,
    ACTIONS(3075), 1,
      anon_sym_LPAREN,
    ACTIONS(3077), 1,
      sym_preproc_arg,
    STATE(1317), 1,
      sym_preproc_params,
  [35008] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3079), 1,
      anon_sym_DQUOTE,
    ACTIONS(3081), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3084), 1,
      sym_escape_sequence,
    STATE(1165), 1,
      aux_sym_string_literal_repeat1,
  [35024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_RPAREN,
    STATE(1157), 1,
      sym_parameter_list,
  [35040] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3093), 1,
      sym_escape_sequence,
    STATE(1187), 1,
      aux_sym_string_literal_repeat1,
  [35056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3095), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35076] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3075), 1,
      anon_sym_LPAREN,
    ACTIONS(3099), 1,
      anon_sym_LF,
    ACTIONS(3101), 1,
      sym_preproc_arg,
    STATE(1292), 1,
      sym_preproc_params,
  [35092] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3075), 1,
      anon_sym_LPAREN,
    ACTIONS(3103), 1,
      anon_sym_LF,
    ACTIONS(3105), 1,
      sym_preproc_arg,
    STATE(1275), 1,
      sym_preproc_params,
  [35108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3107), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      sym_identifier,
    ACTIONS(3111), 1,
      anon_sym_COMMA,
    ACTIONS(3113), 1,
      anon_sym_RBRACE,
    STATE(1200), 1,
      sym_enumerator,
  [35134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35144] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_DQUOTE,
    ACTIONS(3119), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3121), 1,
      sym_escape_sequence,
    STATE(1165), 1,
      aux_sym_string_literal_repeat1,
  [35160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3125), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [35180] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3075), 1,
      anon_sym_LPAREN,
    ACTIONS(3127), 1,
      anon_sym_LF,
    ACTIONS(3129), 1,
      sym_preproc_arg,
    STATE(1279), 1,
      sym_preproc_params,
  [35196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LPAREN2,
    ACTIONS(3041), 1,
      anon_sym_LBRACK,
    ACTIONS(3131), 1,
      anon_sym_RPAREN,
    STATE(1157), 1,
      sym_parameter_list,
  [35212] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3075), 1,
      anon_sym_LPAREN,
    ACTIONS(3133), 1,
      anon_sym_LF,
    ACTIONS(3135), 1,
      sym_preproc_arg,
    STATE(1303), 1,
      sym_preproc_params,
  [35228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(1264), 1,
      sym_argument_list,
    ACTIONS(3137), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [35242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      sym_identifier,
    ACTIONS(3139), 1,
      anon_sym_COMMA,
    ACTIONS(3141), 1,
      anon_sym_RBRACE,
    STATE(1248), 1,
      sym_enumerator,
  [35258] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3143), 1,
      anon_sym_DQUOTE,
    ACTIONS(3145), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3147), 1,
      sym_escape_sequence,
    STATE(1175), 1,
      aux_sym_string_literal_repeat1,
  [35274] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3149), 1,
      anon_sym_DQUOTE,
    ACTIONS(3151), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3153), 1,
      sym_escape_sequence,
    STATE(1188), 1,
      aux_sym_string_literal_repeat1,
  [35290] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3075), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_LF,
    ACTIONS(3157), 1,
      sym_preproc_arg,
    STATE(1289), 1,
      sym_preproc_params,
  [35306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3159), 1,
      anon_sym_COMMA,
    STATE(1186), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(3162), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [35320] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3119), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3121), 1,
      sym_escape_sequence,
    ACTIONS(3164), 1,
      anon_sym_DQUOTE,
    STATE(1165), 1,
      aux_sym_string_literal_repeat1,
  [35336] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3119), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3121), 1,
      sym_escape_sequence,
    ACTIONS(3166), 1,
      anon_sym_DQUOTE,
    STATE(1165), 1,
      aux_sym_string_literal_repeat1,
  [35352] = 5,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3075), 1,
      anon_sym_LPAREN,
    ACTIONS(3168), 1,
      anon_sym_LF,
    ACTIONS(3170), 1,
      sym_preproc_arg,
    STATE(1287), 1,
      sym_preproc_params,
  [35368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3172), 1,
      anon_sym_SEMI,
    STATE(1250), 1,
      aux_sym_declaration_repeat1,
  [35381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2402), 1,
      anon_sym_RPAREN,
    ACTIONS(3174), 1,
      anon_sym_COMMA,
    STATE(1191), 1,
      aux_sym_argument_list_repeat1,
  [35394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(3177), 1,
      anon_sym_SEMI,
    STATE(1247), 1,
      aux_sym_type_definition_repeat2,
  [35407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3181), 1,
      anon_sym_RPAREN,
    STATE(1236), 1,
      aux_sym_preproc_params_repeat1,
  [35420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      sym_identifier,
    ACTIONS(3183), 1,
      anon_sym_RBRACE,
    STATE(1265), 1,
      sym_enumerator,
  [35433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3185), 1,
      anon_sym_RPAREN,
    STATE(1193), 1,
      aux_sym_preproc_params_repeat1,
  [35446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      anon_sym_SEMI,
    STATE(1247), 1,
      aux_sym_type_definition_repeat2,
  [35459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3183), 1,
      anon_sym_RBRACE,
    ACTIONS(3189), 1,
      anon_sym_COMMA,
    STATE(1233), 1,
      aux_sym_enumerator_list_repeat1,
  [35472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3191), 1,
      anon_sym_SEMI,
    STATE(1250), 1,
      aux_sym_declaration_repeat1,
  [35485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 1,
      anon_sym_COMMA,
    ACTIONS(3193), 1,
      anon_sym_RPAREN,
    STATE(1191), 1,
      aux_sym_argument_list_repeat1,
  [35498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3195), 1,
      anon_sym_COMMA,
    ACTIONS(3197), 1,
      anon_sym_RBRACE,
    STATE(1211), 1,
      aux_sym_enumerator_list_repeat1,
  [35511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(3199), 1,
      anon_sym_SEMI,
    STATE(1247), 1,
      aux_sym_type_definition_repeat2,
  [35524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3201), 1,
      anon_sym_SEMI,
    STATE(1250), 1,
      aux_sym_declaration_repeat1,
  [35537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3203), 1,
      anon_sym_SEMI,
    STATE(1252), 1,
      aux_sym_declaration_repeat1,
  [35550] = 4,
    ACTIONS(2522), 1,
      anon_sym_LPAREN2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3205), 1,
      anon_sym_LF,
    STATE(970), 1,
      sym_preproc_argument_list,
  [35563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3209), 1,
      anon_sym_EQ,
    ACTIONS(3207), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [35574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_COMMA,
    ACTIONS(3211), 1,
      anon_sym_RPAREN,
    STATE(1242), 1,
      aux_sym_preproc_argument_list_repeat1,
  [35587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_COMMA,
    ACTIONS(3215), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1224), 1,
      aux_sym_attribute_declaration_repeat1,
  [35600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_COMMA,
    ACTIONS(3217), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1219), 1,
      aux_sym_attribute_declaration_repeat1,
  [35613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_COMMA,
    ACTIONS(3221), 1,
      anon_sym_RPAREN,
    STATE(1227), 1,
      aux_sym_parameter_list_repeat1,
  [35626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3223), 1,
      anon_sym_SEMI,
    STATE(1250), 1,
      aux_sym_declaration_repeat1,
  [35639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3225), 1,
      anon_sym_COMMA,
    ACTIONS(3227), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      aux_sym_enumerator_list_repeat1,
  [35652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    ACTIONS(3229), 1,
      sym_identifier,
    STATE(744), 1,
      sym_field_declaration_list,
  [35665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2005), 1,
      anon_sym_LBRACE,
    ACTIONS(3231), 1,
      sym_identifier,
    STATE(740), 1,
      sym_field_declaration_list,
  [35678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3233), 1,
      anon_sym_SEMI,
    STATE(1250), 1,
      aux_sym_declaration_repeat1,
  [35691] = 4,
    ACTIONS(2522), 1,
      anon_sym_LPAREN2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3235), 1,
      anon_sym_LF,
    STATE(970), 1,
      sym_preproc_argument_list,
  [35704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3237), 1,
      anon_sym_SEMI,
    STATE(1229), 1,
      aux_sym_declaration_repeat1,
  [35717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_RBRACE,
    STATE(1265), 1,
      sym_enumerator,
  [35730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(3239), 1,
      anon_sym_SEMI,
    STATE(1247), 1,
      aux_sym_type_definition_repeat2,
  [35743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_COMMA,
    ACTIONS(3241), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1230), 1,
      aux_sym_attribute_declaration_repeat1,
  [35756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LBRACE,
    ACTIONS(3243), 1,
      sym_identifier,
    STATE(1081), 1,
      sym_field_declaration_list,
  [35769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      sym_identifier,
    ACTIONS(3245), 1,
      anon_sym_RBRACE,
    STATE(1265), 1,
      sym_enumerator,
  [35782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 1,
      anon_sym_LBRACE,
    ACTIONS(3247), 1,
      sym_identifier,
    STATE(1083), 1,
      sym_field_declaration_list,
  [35795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1808), 1,
      anon_sym_RBRACE,
    ACTIONS(3249), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym_initializer_list_repeat1,
  [35808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_COMMA,
    ACTIONS(3251), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1230), 1,
      aux_sym_attribute_declaration_repeat1,
  [35821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3253), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [35830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3255), 1,
      anon_sym_SEMI,
    STATE(1210), 1,
      aux_sym_declaration_repeat1,
  [35843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_COMMA,
    ACTIONS(3257), 1,
      anon_sym_RPAREN,
    STATE(1228), 1,
      aux_sym_parameter_list_repeat1,
  [35856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 1,
      anon_sym_COMMA,
    ACTIONS(3262), 1,
      anon_sym_RPAREN,
    STATE(1228), 1,
      aux_sym_parameter_list_repeat1,
  [35869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3264), 1,
      anon_sym_SEMI,
    STATE(1250), 1,
      aux_sym_declaration_repeat1,
  [35882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      anon_sym_COMMA,
    ACTIONS(3269), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1230), 1,
      aux_sym_attribute_declaration_repeat1,
  [35895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_COMMA,
    ACTIONS(3271), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1232), 1,
      aux_sym_attribute_declaration_repeat1,
  [35908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      anon_sym_COMMA,
    ACTIONS(3273), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1230), 1,
      aux_sym_attribute_declaration_repeat1,
  [35921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 1,
      anon_sym_COMMA,
    ACTIONS(3278), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      aux_sym_enumerator_list_repeat1,
  [35934] = 4,
    ACTIONS(2522), 1,
      anon_sym_LPAREN2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_LF,
    STATE(970), 1,
      sym_preproc_argument_list,
  [35947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(3282), 1,
      anon_sym_SEMI,
    STATE(1247), 1,
      aux_sym_type_definition_repeat2,
  [35960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_COMMA,
    ACTIONS(3287), 1,
      anon_sym_RPAREN,
    STATE(1236), 1,
      aux_sym_preproc_params_repeat1,
  [35973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_COMMA,
    ACTIONS(3289), 1,
      anon_sym_RPAREN,
    STATE(1242), 1,
      aux_sym_preproc_argument_list_repeat1,
  [35986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      sym_identifier,
    ACTIONS(3291), 1,
      anon_sym_RBRACE,
    STATE(1265), 1,
      sym_enumerator,
  [35999] = 4,
    ACTIONS(2522), 1,
      anon_sym_LPAREN2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3293), 1,
      anon_sym_LF,
    STATE(970), 1,
      sym_preproc_argument_list,
  [36012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 1,
      anon_sym_COMMA,
    ACTIONS(3295), 1,
      anon_sym_RPAREN,
    STATE(1191), 1,
      aux_sym_argument_list_repeat1,
  [36025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(3297), 1,
      sym_identifier,
    STATE(1105), 1,
      sym_enumerator_list,
  [36038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_RPAREN,
    ACTIONS(3299), 1,
      anon_sym_COMMA,
    STATE(1242), 1,
      aux_sym_preproc_argument_list_repeat1,
  [36051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(3302), 1,
      anon_sym_SEMI,
    STATE(1247), 1,
      aux_sym_type_definition_repeat2,
  [36064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3304), 1,
      anon_sym_SEMI,
    STATE(1202), 1,
      aux_sym_declaration_repeat1,
  [36077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_SEMI,
    STATE(1247), 1,
      aux_sym_type_definition_repeat2,
  [36090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COMMA,
    ACTIONS(3308), 1,
      anon_sym_SEMI,
    STATE(1247), 1,
      aux_sym_type_definition_repeat2,
  [36103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3310), 1,
      anon_sym_COMMA,
    ACTIONS(3313), 1,
      anon_sym_SEMI,
    STATE(1247), 1,
      aux_sym_type_definition_repeat2,
  [36116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_COMMA,
    ACTIONS(3317), 1,
      anon_sym_RBRACE,
    STATE(1197), 1,
      aux_sym_enumerator_list_repeat1,
  [36129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3319), 1,
      anon_sym_SEMI,
    STATE(1250), 1,
      aux_sym_declaration_repeat1,
  [36142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_COMMA,
    ACTIONS(3324), 1,
      anon_sym_SEMI,
    STATE(1250), 1,
      aux_sym_declaration_repeat1,
  [36155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_COMMA,
    ACTIONS(2334), 1,
      anon_sym_RBRACE,
    STATE(1223), 1,
      aux_sym_initializer_list_repeat1,
  [36168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_COMMA,
    ACTIONS(3326), 1,
      anon_sym_SEMI,
    STATE(1250), 1,
      aux_sym_declaration_repeat1,
  [36181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3328), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [36190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 1,
      anon_sym_LBRACE,
    ACTIONS(3330), 1,
      sym_identifier,
    STATE(734), 1,
      sym_enumerator_list,
  [36203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3334), 1,
      anon_sym_RPAREN,
    ACTIONS(3332), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [36214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_RBRACE,
    ACTIONS(3336), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym_initializer_list_repeat1,
  [36227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [36235] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3341), 2,
      anon_sym_LF,
      sym_preproc_arg,
  [36243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [36251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [36259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_LPAREN2,
    STATE(429), 1,
      sym_parenthesized_expression,
  [36269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [36277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 1,
      anon_sym_LPAREN2,
    STATE(1468), 1,
      sym_parenthesized_expression,
  [36287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [36295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3278), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [36303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3287), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [36311] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3349), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [36319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_LPAREN2,
    STATE(456), 1,
      sym_parenthesized_expression,
  [36329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 1,
      anon_sym_LPAREN2,
    STATE(1297), 1,
      sym_parenthesized_expression,
  [36339] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3351), 2,
      anon_sym_LF,
      sym_preproc_arg,
  [36347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 1,
      sym_identifier,
    STATE(1231), 1,
      sym_attribute,
  [36357] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_LF,
    ACTIONS(3357), 1,
      sym_preproc_arg,
  [36367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 1,
      anon_sym_LPAREN2,
    STATE(1383), 1,
      sym_parenthesized_expression,
  [36377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_LPAREN2,
    STATE(441), 1,
      sym_parenthesized_expression,
  [36387] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_LF,
    ACTIONS(3361), 1,
      sym_preproc_arg,
  [36397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_LPAREN2,
    STATE(439), 1,
      sym_parenthesized_expression,
  [36407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(1502), 1,
      sym_argument_list,
  [36417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 1,
      sym_identifier,
    ACTIONS(3365), 1,
      anon_sym_LPAREN2,
  [36427] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3367), 1,
      anon_sym_LF,
    ACTIONS(3369), 1,
      sym_preproc_arg,
  [36437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3371), 1,
      sym_identifier,
    ACTIONS(3373), 1,
      anon_sym_LPAREN2,
  [36447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 1,
      anon_sym_LPAREN2,
    STATE(1348), 1,
      sym_parenthesized_expression,
  [36457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 1,
      anon_sym_LPAREN2,
    STATE(1298), 1,
      sym_parenthesized_expression,
  [36467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3269), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [36475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3262), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [36483] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_LF,
    ACTIONS(3377), 1,
      sym_preproc_arg,
  [36493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(411), 1,
      anon_sym_LBRACE,
    STATE(157), 1,
      sym_compound_statement,
  [36503] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3379), 1,
      anon_sym_LF,
    ACTIONS(3381), 1,
      sym_preproc_arg,
  [36513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2414), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [36521] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_LF,
    ACTIONS(3385), 1,
      sym_preproc_arg,
  [36531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 1,
      anon_sym_LPAREN2,
    STATE(1286), 1,
      sym_parenthesized_expression,
  [36541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 1,
      anon_sym_LPAREN2,
    STATE(1457), 1,
      sym_parenthesized_expression,
  [36551] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_LF,
    ACTIONS(3389), 1,
      sym_preproc_arg,
  [36561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2338), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [36569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [36577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 1,
      sym_identifier,
    STATE(1283), 1,
      sym_attribute,
  [36587] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3393), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [36595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(518), 1,
      anon_sym_LBRACE,
    STATE(218), 1,
      sym_compound_statement,
  [36605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(224), 1,
      sym_compound_statement,
  [36615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_LPAREN2,
    STATE(457), 1,
      sym_parenthesized_expression,
  [36625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      anon_sym_LBRACE,
    STATE(82), 1,
      sym_compound_statement,
  [36635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      anon_sym_LPAREN2,
    STATE(1354), 1,
      sym_argument_list,
  [36645] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3395), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [36653] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_LF,
    ACTIONS(3399), 1,
      sym_preproc_arg,
  [36663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 1,
      sym_identifier,
    STATE(1207), 1,
      sym_attribute,
  [36673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      sym_identifier,
    STATE(1265), 1,
      sym_enumerator,
  [36683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_LPAREN2,
    STATE(468), 1,
      sym_parenthesized_expression,
  [36693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 1,
      anon_sym_LPAREN2,
    STATE(1300), 1,
      sym_parenthesized_expression,
  [36703] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3401), 2,
      anon_sym_LF,
      sym_preproc_arg,
  [36711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 1,
      sym_identifier,
    STATE(1208), 1,
      sym_attribute,
  [36721] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_LF,
    ACTIONS(3405), 1,
      sym_preproc_arg,
  [36731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_LPAREN2,
    STATE(462), 1,
      sym_parenthesized_expression,
  [36741] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3407), 1,
      anon_sym_LF,
    ACTIONS(3409), 1,
      sym_preproc_arg,
  [36751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [36759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_LPAREN2,
    STATE(430), 1,
      sym_parenthesized_expression,
  [36769] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LF,
    ACTIONS(3415), 1,
      sym_preproc_arg,
  [36779] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3417), 1,
      anon_sym_LF,
    ACTIONS(3419), 1,
      sym_preproc_arg,
  [36789] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_LF,
    ACTIONS(3423), 1,
      sym_preproc_arg,
  [36799] = 3,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3425), 1,
      anon_sym_LF,
    ACTIONS(3427), 1,
      sym_preproc_arg,
  [36809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      aux_sym_preproc_if_token2,
  [36816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      aux_sym_preproc_if_token2,
  [36823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 1,
      aux_sym_preproc_if_token2,
  [36830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      aux_sym_preproc_if_token2,
  [36837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_RPAREN,
  [36844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2426), 1,
      anon_sym_SEMI,
  [36851] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_LF,
  [36858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_RPAREN,
  [36865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      aux_sym_preproc_if_token2,
  [36872] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3441), 1,
      anon_sym_LF,
  [36879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3443), 1,
      anon_sym_SEMI,
  [36886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 1,
      anon_sym_RPAREN,
  [36893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 1,
      aux_sym_preproc_if_token2,
  [36900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_RPAREN,
  [36907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 1,
      anon_sym_RPAREN,
  [36914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_RPAREN,
  [36921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      sym_identifier,
  [36928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 1,
      anon_sym_RPAREN,
  [36935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 1,
      anon_sym_RPAREN,
  [36942] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3449), 1,
      anon_sym_LF,
  [36949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      aux_sym_preproc_if_token2,
  [36956] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3453), 1,
      anon_sym_LF,
  [36963] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3455), 1,
      anon_sym_LF,
  [36970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 1,
      aux_sym_preproc_if_token2,
  [36977] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3459), 1,
      anon_sym_LF,
  [36984] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_LF,
  [36991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_SEMI,
  [36998] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_LF,
  [37005] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3463), 1,
      anon_sym_LF,
  [37012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 1,
      anon_sym_SEMI,
  [37019] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3467), 1,
      anon_sym_LF,
  [37026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3469), 1,
      anon_sym_SEMI,
  [37033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 1,
      aux_sym_preproc_if_token2,
  [37040] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3473), 1,
      anon_sym_LF,
  [37047] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_LF,
  [37054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3477), 1,
      anon_sym_RPAREN,
  [37061] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LF,
  [37068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_SEMI,
  [37075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3483), 1,
      sym_identifier,
  [37082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 1,
      sym_identifier,
  [37089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_RPAREN,
  [37096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_SEMI,
  [37103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 1,
      anon_sym_COLON,
  [37110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_RPAREN,
  [37117] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_LF,
  [37124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 1,
      sym_identifier,
  [37131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 1,
      aux_sym_preproc_if_token2,
  [37138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2412), 1,
      anon_sym_RPAREN,
  [37145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_RPAREN,
  [37152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3497), 1,
      aux_sym_preproc_if_token2,
  [37159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_RPAREN,
  [37166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      aux_sym_preproc_if_token2,
  [37173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_SEMI,
  [37180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      aux_sym_preproc_if_token2,
  [37187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3505), 1,
      sym_identifier,
  [37194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 1,
      aux_sym_preproc_if_token2,
  [37201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_SEMI,
  [37208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_RPAREN,
  [37215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_RPAREN,
  [37222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3509), 1,
      anon_sym_SEMI,
  [37229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 1,
      aux_sym_preproc_if_token2,
  [37236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3513), 1,
      anon_sym_STAR,
  [37243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      aux_sym_preproc_if_token2,
  [37250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_STAR,
  [37257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 1,
      anon_sym_SEMI,
  [37264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_SEMI,
  [37271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_RPAREN,
  [37278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3525), 1,
      aux_sym_preproc_if_token2,
  [37285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      sym_identifier,
  [37292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3529), 1,
      anon_sym_SQUOTE,
  [37299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 1,
      sym_identifier,
  [37306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 1,
      aux_sym_preproc_if_token2,
  [37313] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3535), 1,
      anon_sym_LF,
  [37320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
  [37327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 1,
      anon_sym_RPAREN,
  [37334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_SEMI,
  [37341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 1,
      anon_sym_SEMI,
  [37348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3543), 1,
      anon_sym_RPAREN,
  [37355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 1,
      anon_sym_SEMI,
  [37362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 1,
      anon_sym_RPAREN,
  [37369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 1,
      anon_sym_SEMI,
  [37376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2392), 1,
      anon_sym_RPAREN,
  [37383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2388), 1,
      anon_sym_SEMI,
  [37390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 1,
      aux_sym_preproc_if_token2,
  [37397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_while,
  [37404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 1,
      aux_sym_preproc_if_token2,
  [37411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2384), 1,
      anon_sym_SEMI,
  [37418] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_LF,
  [37425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 1,
      aux_sym_preproc_if_token2,
  [37432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_RPAREN,
  [37439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3555), 1,
      anon_sym_SQUOTE,
  [37446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 1,
      anon_sym_SEMI,
  [37453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2372), 1,
      anon_sym_SEMI,
  [37460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3559), 1,
      sym_identifier,
  [37467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_SEMI,
  [37474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 1,
      anon_sym_RPAREN,
  [37481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3197), 1,
      anon_sym_RBRACE,
  [37488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_RPAREN,
  [37495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 1,
      anon_sym_RPAREN,
  [37502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2376), 1,
      anon_sym_RPAREN,
  [37509] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_LF,
  [37516] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3205), 1,
      anon_sym_LF,
  [37523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 1,
      sym_identifier,
  [37530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 1,
      sym_identifier,
  [37537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2340), 1,
      anon_sym_SEMI,
  [37544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_SEMI,
  [37551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 1,
      anon_sym_SEMI,
  [37558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 1,
      sym_identifier,
  [37565] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_LF,
  [37572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3583), 1,
      sym_identifier,
  [37579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_COLON,
  [37586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 1,
      aux_sym_preproc_if_token2,
  [37593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2354), 1,
      anon_sym_RPAREN,
  [37600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 1,
      aux_sym_preproc_if_token2,
  [37607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 1,
      anon_sym_SEMI,
  [37614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      anon_sym_RPAREN,
  [37621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3591), 1,
      sym_identifier,
  [37628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_RPAREN,
  [37635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      sym_identifier,
  [37642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_RBRACE,
  [37649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2348), 1,
      anon_sym_RPAREN,
  [37656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3595), 1,
      anon_sym_SEMI,
  [37663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3597), 1,
      aux_sym_preproc_if_token2,
  [37670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_RPAREN,
  [37677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_SEMI,
  [37684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3601), 1,
      aux_sym_preproc_if_token2,
  [37691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_SEMI,
  [37698] = 2,
    ACTIONS(1498), 1,
      anon_sym_LF,
    ACTIONS(2524), 1,
      sym_comment,
  [37705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      aux_sym_preproc_if_token2,
  [37712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2358), 1,
      anon_sym_SEMI,
  [37719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 1,
      anon_sym_RPAREN,
  [37726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 1,
      sym_identifier,
  [37733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      sym_identifier,
  [37740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2344), 1,
      anon_sym_RPAREN,
  [37747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_SEMI,
  [37754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 1,
      aux_sym_preproc_if_token2,
  [37761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3613), 1,
      sym_identifier,
  [37768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      aux_sym_preproc_if_token2,
  [37775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3617), 1,
      anon_sym_SEMI,
  [37782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_SEMI,
  [37789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 1,
      aux_sym_preproc_if_token2,
  [37796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3623), 1,
      aux_sym_preproc_if_token2,
  [37803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3625), 1,
      anon_sym_RPAREN,
  [37810] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3235), 1,
      anon_sym_LF,
  [37817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_SEMI,
  [37824] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3627), 1,
      anon_sym_LF,
  [37831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 1,
      anon_sym_SEMI,
  [37838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_SEMI,
  [37845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 1,
      anon_sym_SEMI,
  [37852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3629), 1,
      anon_sym_SEMI,
  [37859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3631), 1,
      anon_sym_RPAREN,
  [37866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 1,
      anon_sym_SEMI,
  [37873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3633), 1,
      sym_identifier,
  [37880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3635), 1,
      sym_identifier,
  [37887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3637), 1,
      sym_identifier,
  [37894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3639), 1,
      anon_sym_RPAREN,
  [37901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3641), 1,
      anon_sym_SEMI,
  [37908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      ts_builtin_sym_end,
  [37915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_RBRACE,
  [37922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3645), 1,
      aux_sym_preproc_if_token2,
  [37929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3647), 1,
      sym_identifier,
  [37936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 1,
      anon_sym_SEMI,
  [37943] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3651), 1,
      anon_sym_LF,
  [37950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_RPAREN,
  [37957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3655), 1,
      anon_sym_SEMI,
  [37964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3657), 1,
      anon_sym_while,
  [37971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym_LPAREN2,
  [37978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3661), 1,
      anon_sym_STAR,
  [37985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_SQUOTE,
  [37992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      anon_sym_SEMI,
  [37999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      anon_sym_SEMI,
  [38006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 1,
      anon_sym_SEMI,
  [38013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_RPAREN,
  [38020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3669), 1,
      anon_sym_COLON,
  [38027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2368), 1,
      anon_sym_RPAREN,
  [38034] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3671), 1,
      anon_sym_LF,
  [38041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 1,
      anon_sym_while,
  [38048] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3293), 1,
      anon_sym_LF,
  [38055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2370), 1,
      anon_sym_SEMI,
  [38062] = 2,
    ACTIONS(1494), 1,
      anon_sym_LF,
    ACTIONS(2524), 1,
      sym_comment,
  [38069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2378), 1,
      anon_sym_SEMI,
  [38076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3675), 1,
      anon_sym_SEMI,
  [38083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3677), 1,
      anon_sym_SEMI,
  [38090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3679), 1,
      anon_sym_STAR,
  [38097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3681), 1,
      anon_sym_LPAREN2,
  [38104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 1,
      anon_sym_while,
  [38111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3685), 1,
      anon_sym_COLON,
  [38118] = 2,
    ACTIONS(2524), 1,
      sym_comment,
    ACTIONS(3687), 1,
      anon_sym_LF,
  [38125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2366), 1,
      anon_sym_SEMI,
  [38132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3689), 1,
      anon_sym_LPAREN2,
  [38139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_RPAREN,
  [38146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_LPAREN2,
  [38153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3695), 1,
      sym_identifier,
  [38160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3697), 1,
      aux_sym_preproc_if_token2,
  [38167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3699), 1,
      anon_sym_LPAREN2,
  [38174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 1,
      sym_identifier,
  [38181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3703), 1,
      anon_sym_LPAREN2,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(507)] = 0,
  [SMALL_STATE(508)] = 107,
  [SMALL_STATE(509)] = 186,
  [SMALL_STATE(510)] = 258,
  [SMALL_STATE(511)] = 346,
  [SMALL_STATE(512)] = 434,
  [SMALL_STATE(513)] = 519,
  [SMALL_STATE(514)] = 604,
  [SMALL_STATE(515)] = 689,
  [SMALL_STATE(516)] = 774,
  [SMALL_STATE(517)] = 859,
  [SMALL_STATE(518)] = 944,
  [SMALL_STATE(519)] = 1029,
  [SMALL_STATE(520)] = 1114,
  [SMALL_STATE(521)] = 1199,
  [SMALL_STATE(522)] = 1299,
  [SMALL_STATE(523)] = 1363,
  [SMALL_STATE(524)] = 1460,
  [SMALL_STATE(525)] = 1557,
  [SMALL_STATE(526)] = 1649,
  [SMALL_STATE(527)] = 1725,
  [SMALL_STATE(528)] = 1817,
  [SMALL_STATE(529)] = 1909,
  [SMALL_STATE(530)] = 2001,
  [SMALL_STATE(531)] = 2093,
  [SMALL_STATE(532)] = 2169,
  [SMALL_STATE(533)] = 2261,
  [SMALL_STATE(534)] = 2353,
  [SMALL_STATE(535)] = 2445,
  [SMALL_STATE(536)] = 2537,
  [SMALL_STATE(537)] = 2595,
  [SMALL_STATE(538)] = 2687,
  [SMALL_STATE(539)] = 2763,
  [SMALL_STATE(540)] = 2839,
  [SMALL_STATE(541)] = 2933,
  [SMALL_STATE(542)] = 2994,
  [SMALL_STATE(543)] = 3055,
  [SMALL_STATE(544)] = 3116,
  [SMALL_STATE(545)] = 3171,
  [SMALL_STATE(546)] = 3226,
  [SMALL_STATE(547)] = 3300,
  [SMALL_STATE(548)] = 3374,
  [SMALL_STATE(549)] = 3448,
  [SMALL_STATE(550)] = 3522,
  [SMALL_STATE(551)] = 3604,
  [SMALL_STATE(552)] = 3686,
  [SMALL_STATE(553)] = 3768,
  [SMALL_STATE(554)] = 3850,
  [SMALL_STATE(555)] = 3932,
  [SMALL_STATE(556)] = 4014,
  [SMALL_STATE(557)] = 4096,
  [SMALL_STATE(558)] = 4178,
  [SMALL_STATE(559)] = 4260,
  [SMALL_STATE(560)] = 4342,
  [SMALL_STATE(561)] = 4424,
  [SMALL_STATE(562)] = 4506,
  [SMALL_STATE(563)] = 4588,
  [SMALL_STATE(564)] = 4670,
  [SMALL_STATE(565)] = 4752,
  [SMALL_STATE(566)] = 4834,
  [SMALL_STATE(567)] = 4916,
  [SMALL_STATE(568)] = 4998,
  [SMALL_STATE(569)] = 5080,
  [SMALL_STATE(570)] = 5162,
  [SMALL_STATE(571)] = 5244,
  [SMALL_STATE(572)] = 5326,
  [SMALL_STATE(573)] = 5408,
  [SMALL_STATE(574)] = 5490,
  [SMALL_STATE(575)] = 5572,
  [SMALL_STATE(576)] = 5654,
  [SMALL_STATE(577)] = 5736,
  [SMALL_STATE(578)] = 5818,
  [SMALL_STATE(579)] = 5900,
  [SMALL_STATE(580)] = 5982,
  [SMALL_STATE(581)] = 6064,
  [SMALL_STATE(582)] = 6146,
  [SMALL_STATE(583)] = 6228,
  [SMALL_STATE(584)] = 6310,
  [SMALL_STATE(585)] = 6392,
  [SMALL_STATE(586)] = 6474,
  [SMALL_STATE(587)] = 6556,
  [SMALL_STATE(588)] = 6638,
  [SMALL_STATE(589)] = 6720,
  [SMALL_STATE(590)] = 6802,
  [SMALL_STATE(591)] = 6884,
  [SMALL_STATE(592)] = 6966,
  [SMALL_STATE(593)] = 7048,
  [SMALL_STATE(594)] = 7130,
  [SMALL_STATE(595)] = 7212,
  [SMALL_STATE(596)] = 7294,
  [SMALL_STATE(597)] = 7345,
  [SMALL_STATE(598)] = 7424,
  [SMALL_STATE(599)] = 7503,
  [SMALL_STATE(600)] = 7582,
  [SMALL_STATE(601)] = 7661,
  [SMALL_STATE(602)] = 7740,
  [SMALL_STATE(603)] = 7819,
  [SMALL_STATE(604)] = 7898,
  [SMALL_STATE(605)] = 7977,
  [SMALL_STATE(606)] = 8040,
  [SMALL_STATE(607)] = 8119,
  [SMALL_STATE(608)] = 8198,
  [SMALL_STATE(609)] = 8277,
  [SMALL_STATE(610)] = 8356,
  [SMALL_STATE(611)] = 8435,
  [SMALL_STATE(612)] = 8514,
  [SMALL_STATE(613)] = 8593,
  [SMALL_STATE(614)] = 8669,
  [SMALL_STATE(615)] = 8745,
  [SMALL_STATE(616)] = 8799,
  [SMALL_STATE(617)] = 8853,
  [SMALL_STATE(618)] = 8929,
  [SMALL_STATE(619)] = 9005,
  [SMALL_STATE(620)] = 9081,
  [SMALL_STATE(621)] = 9157,
  [SMALL_STATE(622)] = 9233,
  [SMALL_STATE(623)] = 9309,
  [SMALL_STATE(624)] = 9385,
  [SMALL_STATE(625)] = 9461,
  [SMALL_STATE(626)] = 9537,
  [SMALL_STATE(627)] = 9613,
  [SMALL_STATE(628)] = 9689,
  [SMALL_STATE(629)] = 9739,
  [SMALL_STATE(630)] = 9793,
  [SMALL_STATE(631)] = 9869,
  [SMALL_STATE(632)] = 9945,
  [SMALL_STATE(633)] = 10021,
  [SMALL_STATE(634)] = 10097,
  [SMALL_STATE(635)] = 10173,
  [SMALL_STATE(636)] = 10249,
  [SMALL_STATE(637)] = 10325,
  [SMALL_STATE(638)] = 10401,
  [SMALL_STATE(639)] = 10451,
  [SMALL_STATE(640)] = 10527,
  [SMALL_STATE(641)] = 10603,
  [SMALL_STATE(642)] = 10679,
  [SMALL_STATE(643)] = 10755,
  [SMALL_STATE(644)] = 10831,
  [SMALL_STATE(645)] = 10881,
  [SMALL_STATE(646)] = 10957,
  [SMALL_STATE(647)] = 11007,
  [SMALL_STATE(648)] = 11083,
  [SMALL_STATE(649)] = 11143,
  [SMALL_STATE(650)] = 11219,
  [SMALL_STATE(651)] = 11295,
  [SMALL_STATE(652)] = 11371,
  [SMALL_STATE(653)] = 11447,
  [SMALL_STATE(654)] = 11523,
  [SMALL_STATE(655)] = 11599,
  [SMALL_STATE(656)] = 11675,
  [SMALL_STATE(657)] = 11751,
  [SMALL_STATE(658)] = 11827,
  [SMALL_STATE(659)] = 11877,
  [SMALL_STATE(660)] = 11927,
  [SMALL_STATE(661)] = 11977,
  [SMALL_STATE(662)] = 12053,
  [SMALL_STATE(663)] = 12103,
  [SMALL_STATE(664)] = 12167,
  [SMALL_STATE(665)] = 12243,
  [SMALL_STATE(666)] = 12293,
  [SMALL_STATE(667)] = 12369,
  [SMALL_STATE(668)] = 12445,
  [SMALL_STATE(669)] = 12521,
  [SMALL_STATE(670)] = 12597,
  [SMALL_STATE(671)] = 12673,
  [SMALL_STATE(672)] = 12749,
  [SMALL_STATE(673)] = 12825,
  [SMALL_STATE(674)] = 12901,
  [SMALL_STATE(675)] = 12977,
  [SMALL_STATE(676)] = 13053,
  [SMALL_STATE(677)] = 13129,
  [SMALL_STATE(678)] = 13205,
  [SMALL_STATE(679)] = 13255,
  [SMALL_STATE(680)] = 13331,
  [SMALL_STATE(681)] = 13385,
  [SMALL_STATE(682)] = 13451,
  [SMALL_STATE(683)] = 13527,
  [SMALL_STATE(684)] = 13603,
  [SMALL_STATE(685)] = 13653,
  [SMALL_STATE(686)] = 13723,
  [SMALL_STATE(687)] = 13783,
  [SMALL_STATE(688)] = 13855,
  [SMALL_STATE(689)] = 13905,
  [SMALL_STATE(690)] = 13989,
  [SMALL_STATE(691)] = 14063,
  [SMALL_STATE(692)] = 14139,
  [SMALL_STATE(693)] = 14215,
  [SMALL_STATE(694)] = 14293,
  [SMALL_STATE(695)] = 14373,
  [SMALL_STATE(696)] = 14449,
  [SMALL_STATE(697)] = 14515,
  [SMALL_STATE(698)] = 14577,
  [SMALL_STATE(699)] = 14631,
  [SMALL_STATE(700)] = 14707,
  [SMALL_STATE(701)] = 14783,
  [SMALL_STATE(702)] = 14859,
  [SMALL_STATE(703)] = 14935,
  [SMALL_STATE(704)] = 14995,
  [SMALL_STATE(705)] = 15045,
  [SMALL_STATE(706)] = 15121,
  [SMALL_STATE(707)] = 15197,
  [SMALL_STATE(708)] = 15279,
  [SMALL_STATE(709)] = 15355,
  [SMALL_STATE(710)] = 15431,
  [SMALL_STATE(711)] = 15507,
  [SMALL_STATE(712)] = 15583,
  [SMALL_STATE(713)] = 15643,
  [SMALL_STATE(714)] = 15719,
  [SMALL_STATE(715)] = 15795,
  [SMALL_STATE(716)] = 15845,
  [SMALL_STATE(717)] = 15921,
  [SMALL_STATE(718)] = 15997,
  [SMALL_STATE(719)] = 16047,
  [SMALL_STATE(720)] = 16123,
  [SMALL_STATE(721)] = 16181,
  [SMALL_STATE(722)] = 16257,
  [SMALL_STATE(723)] = 16333,
  [SMALL_STATE(724)] = 16386,
  [SMALL_STATE(725)] = 16434,
  [SMALL_STATE(726)] = 16482,
  [SMALL_STATE(727)] = 16530,
  [SMALL_STATE(728)] = 16578,
  [SMALL_STATE(729)] = 16626,
  [SMALL_STATE(730)] = 16674,
  [SMALL_STATE(731)] = 16722,
  [SMALL_STATE(732)] = 16770,
  [SMALL_STATE(733)] = 16818,
  [SMALL_STATE(734)] = 16866,
  [SMALL_STATE(735)] = 16914,
  [SMALL_STATE(736)] = 16962,
  [SMALL_STATE(737)] = 17012,
  [SMALL_STATE(738)] = 17060,
  [SMALL_STATE(739)] = 17108,
  [SMALL_STATE(740)] = 17156,
  [SMALL_STATE(741)] = 17204,
  [SMALL_STATE(742)] = 17252,
  [SMALL_STATE(743)] = 17300,
  [SMALL_STATE(744)] = 17348,
  [SMALL_STATE(745)] = 17396,
  [SMALL_STATE(746)] = 17444,
  [SMALL_STATE(747)] = 17492,
  [SMALL_STATE(748)] = 17539,
  [SMALL_STATE(749)] = 17592,
  [SMALL_STATE(750)] = 17645,
  [SMALL_STATE(751)] = 17692,
  [SMALL_STATE(752)] = 17739,
  [SMALL_STATE(753)] = 17792,
  [SMALL_STATE(754)] = 17845,
  [SMALL_STATE(755)] = 17901,
  [SMALL_STATE(756)] = 17963,
  [SMALL_STATE(757)] = 18019,
  [SMALL_STATE(758)] = 18099,
  [SMALL_STATE(759)] = 18159,
  [SMALL_STATE(760)] = 18221,
  [SMALL_STATE(761)] = 18287,
  [SMALL_STATE(762)] = 18355,
  [SMALL_STATE(763)] = 18425,
  [SMALL_STATE(764)] = 18481,
  [SMALL_STATE(765)] = 18535,
  [SMALL_STATE(766)] = 18607,
  [SMALL_STATE(767)] = 18681,
  [SMALL_STATE(768)] = 18737,
  [SMALL_STATE(769)] = 18789,
  [SMALL_STATE(770)] = 18867,
  [SMALL_STATE(771)] = 18925,
  [SMALL_STATE(772)] = 19001,
  [SMALL_STATE(773)] = 19046,
  [SMALL_STATE(774)] = 19095,
  [SMALL_STATE(775)] = 19140,
  [SMALL_STATE(776)] = 19185,
  [SMALL_STATE(777)] = 19260,
  [SMALL_STATE(778)] = 19305,
  [SMALL_STATE(779)] = 19372,
  [SMALL_STATE(780)] = 19437,
  [SMALL_STATE(781)] = 19506,
  [SMALL_STATE(782)] = 19545,
  [SMALL_STATE(783)] = 19618,
  [SMALL_STATE(784)] = 19675,
  [SMALL_STATE(785)] = 19732,
  [SMALL_STATE(786)] = 19781,
  [SMALL_STATE(787)] = 19848,
  [SMALL_STATE(788)] = 19911,
  [SMALL_STATE(789)] = 19972,
  [SMALL_STATE(790)] = 20025,
  [SMALL_STATE(791)] = 20096,
  [SMALL_STATE(792)] = 20151,
  [SMALL_STATE(793)] = 20193,
  [SMALL_STATE(794)] = 20268,
  [SMALL_STATE(795)] = 20343,
  [SMALL_STATE(796)] = 20418,
  [SMALL_STATE(797)] = 20491,
  [SMALL_STATE(798)] = 20563,
  [SMALL_STATE(799)] = 20635,
  [SMALL_STATE(800)] = 20707,
  [SMALL_STATE(801)] = 20779,
  [SMALL_STATE(802)] = 20851,
  [SMALL_STATE(803)] = 20923,
  [SMALL_STATE(804)] = 20995,
  [SMALL_STATE(805)] = 21067,
  [SMALL_STATE(806)] = 21139,
  [SMALL_STATE(807)] = 21211,
  [SMALL_STATE(808)] = 21281,
  [SMALL_STATE(809)] = 21353,
  [SMALL_STATE(810)] = 21425,
  [SMALL_STATE(811)] = 21497,
  [SMALL_STATE(812)] = 21569,
  [SMALL_STATE(813)] = 21641,
  [SMALL_STATE(814)] = 21713,
  [SMALL_STATE(815)] = 21785,
  [SMALL_STATE(816)] = 21857,
  [SMALL_STATE(817)] = 21929,
  [SMALL_STATE(818)] = 22001,
  [SMALL_STATE(819)] = 22073,
  [SMALL_STATE(820)] = 22145,
  [SMALL_STATE(821)] = 22217,
  [SMALL_STATE(822)] = 22289,
  [SMALL_STATE(823)] = 22361,
  [SMALL_STATE(824)] = 22433,
  [SMALL_STATE(825)] = 22505,
  [SMALL_STATE(826)] = 22577,
  [SMALL_STATE(827)] = 22649,
  [SMALL_STATE(828)] = 22721,
  [SMALL_STATE(829)] = 22791,
  [SMALL_STATE(830)] = 22863,
  [SMALL_STATE(831)] = 22935,
  [SMALL_STATE(832)] = 23007,
  [SMALL_STATE(833)] = 23077,
  [SMALL_STATE(834)] = 23149,
  [SMALL_STATE(835)] = 23219,
  [SMALL_STATE(836)] = 23291,
  [SMALL_STATE(837)] = 23363,
  [SMALL_STATE(838)] = 23433,
  [SMALL_STATE(839)] = 23505,
  [SMALL_STATE(840)] = 23577,
  [SMALL_STATE(841)] = 23649,
  [SMALL_STATE(842)] = 23721,
  [SMALL_STATE(843)] = 23793,
  [SMALL_STATE(844)] = 23865,
  [SMALL_STATE(845)] = 23937,
  [SMALL_STATE(846)] = 24009,
  [SMALL_STATE(847)] = 24081,
  [SMALL_STATE(848)] = 24153,
  [SMALL_STATE(849)] = 24225,
  [SMALL_STATE(850)] = 24297,
  [SMALL_STATE(851)] = 24369,
  [SMALL_STATE(852)] = 24441,
  [SMALL_STATE(853)] = 24510,
  [SMALL_STATE(854)] = 24579,
  [SMALL_STATE(855)] = 24642,
  [SMALL_STATE(856)] = 24711,
  [SMALL_STATE(857)] = 24780,
  [SMALL_STATE(858)] = 24849,
  [SMALL_STATE(859)] = 24918,
  [SMALL_STATE(860)] = 24981,
  [SMALL_STATE(861)] = 25050,
  [SMALL_STATE(862)] = 25119,
  [SMALL_STATE(863)] = 25180,
  [SMALL_STATE(864)] = 25239,
  [SMALL_STATE(865)] = 25308,
  [SMALL_STATE(866)] = 25365,
  [SMALL_STATE(867)] = 25418,
  [SMALL_STATE(868)] = 25487,
  [SMALL_STATE(869)] = 25538,
  [SMALL_STATE(870)] = 25607,
  [SMALL_STATE(871)] = 25676,
  [SMALL_STATE(872)] = 25745,
  [SMALL_STATE(873)] = 25814,
  [SMALL_STATE(874)] = 25883,
  [SMALL_STATE(875)] = 25952,
  [SMALL_STATE(876)] = 26021,
  [SMALL_STATE(877)] = 26090,
  [SMALL_STATE(878)] = 26159,
  [SMALL_STATE(879)] = 26224,
  [SMALL_STATE(880)] = 26283,
  [SMALL_STATE(881)] = 26352,
  [SMALL_STATE(882)] = 26421,
  [SMALL_STATE(883)] = 26488,
  [SMALL_STATE(884)] = 26557,
  [SMALL_STATE(885)] = 26606,
  [SMALL_STATE(886)] = 26659,
  [SMALL_STATE(887)] = 26715,
  [SMALL_STATE(888)] = 26771,
  [SMALL_STATE(889)] = 26827,
  [SMALL_STATE(890)] = 26883,
  [SMALL_STATE(891)] = 26939,
  [SMALL_STATE(892)] = 26995,
  [SMALL_STATE(893)] = 27051,
  [SMALL_STATE(894)] = 27107,
  [SMALL_STATE(895)] = 27163,
  [SMALL_STATE(896)] = 27219,
  [SMALL_STATE(897)] = 27275,
  [SMALL_STATE(898)] = 27331,
  [SMALL_STATE(899)] = 27365,
  [SMALL_STATE(900)] = 27398,
  [SMALL_STATE(901)] = 27441,
  [SMALL_STATE(902)] = 27484,
  [SMALL_STATE(903)] = 27539,
  [SMALL_STATE(904)] = 27594,
  [SMALL_STATE(905)] = 27634,
  [SMALL_STATE(906)] = 27662,
  [SMALL_STATE(907)] = 27710,
  [SMALL_STATE(908)] = 27750,
  [SMALL_STATE(909)] = 27790,
  [SMALL_STATE(910)] = 27818,
  [SMALL_STATE(911)] = 27846,
  [SMALL_STATE(912)] = 27886,
  [SMALL_STATE(913)] = 27926,
  [SMALL_STATE(914)] = 27966,
  [SMALL_STATE(915)] = 27998,
  [SMALL_STATE(916)] = 28026,
  [SMALL_STATE(917)] = 28066,
  [SMALL_STATE(918)] = 28106,
  [SMALL_STATE(919)] = 28154,
  [SMALL_STATE(920)] = 28194,
  [SMALL_STATE(921)] = 28244,
  [SMALL_STATE(922)] = 28284,
  [SMALL_STATE(923)] = 28312,
  [SMALL_STATE(924)] = 28340,
  [SMALL_STATE(925)] = 28386,
  [SMALL_STATE(926)] = 28414,
  [SMALL_STATE(927)] = 28454,
  [SMALL_STATE(928)] = 28494,
  [SMALL_STATE(929)] = 28528,
  [SMALL_STATE(930)] = 28568,
  [SMALL_STATE(931)] = 28608,
  [SMALL_STATE(932)] = 28648,
  [SMALL_STATE(933)] = 28688,
  [SMALL_STATE(934)] = 28728,
  [SMALL_STATE(935)] = 28768,
  [SMALL_STATE(936)] = 28808,
  [SMALL_STATE(937)] = 28848,
  [SMALL_STATE(938)] = 28884,
  [SMALL_STATE(939)] = 28928,
  [SMALL_STATE(940)] = 28968,
  [SMALL_STATE(941)] = 29008,
  [SMALL_STATE(942)] = 29048,
  [SMALL_STATE(943)] = 29088,
  [SMALL_STATE(944)] = 29134,
  [SMALL_STATE(945)] = 29174,
  [SMALL_STATE(946)] = 29202,
  [SMALL_STATE(947)] = 29242,
  [SMALL_STATE(948)] = 29282,
  [SMALL_STATE(949)] = 29322,
  [SMALL_STATE(950)] = 29362,
  [SMALL_STATE(951)] = 29402,
  [SMALL_STATE(952)] = 29444,
  [SMALL_STATE(953)] = 29472,
  [SMALL_STATE(954)] = 29512,
  [SMALL_STATE(955)] = 29552,
  [SMALL_STATE(956)] = 29580,
  [SMALL_STATE(957)] = 29620,
  [SMALL_STATE(958)] = 29660,
  [SMALL_STATE(959)] = 29700,
  [SMALL_STATE(960)] = 29749,
  [SMALL_STATE(961)] = 29776,
  [SMALL_STATE(962)] = 29821,
  [SMALL_STATE(963)] = 29848,
  [SMALL_STATE(964)] = 29875,
  [SMALL_STATE(965)] = 29902,
  [SMALL_STATE(966)] = 29929,
  [SMALL_STATE(967)] = 29956,
  [SMALL_STATE(968)] = 29983,
  [SMALL_STATE(969)] = 30028,
  [SMALL_STATE(970)] = 30073,
  [SMALL_STATE(971)] = 30100,
  [SMALL_STATE(972)] = 30143,
  [SMALL_STATE(973)] = 30184,
  [SMALL_STATE(974)] = 30229,
  [SMALL_STATE(975)] = 30274,
  [SMALL_STATE(976)] = 30303,
  [SMALL_STATE(977)] = 30342,
  [SMALL_STATE(978)] = 30379,
  [SMALL_STATE(979)] = 30406,
  [SMALL_STATE(980)] = 30455,
  [SMALL_STATE(981)] = 30500,
  [SMALL_STATE(982)] = 30535,
  [SMALL_STATE(983)] = 30562,
  [SMALL_STATE(984)] = 30607,
  [SMALL_STATE(985)] = 30652,
  [SMALL_STATE(986)] = 30685,
  [SMALL_STATE(987)] = 30730,
  [SMALL_STATE(988)] = 30761,
  [SMALL_STATE(989)] = 30806,
  [SMALL_STATE(990)] = 30846,
  [SMALL_STATE(991)] = 30886,
  [SMALL_STATE(992)] = 30926,
  [SMALL_STATE(993)] = 30966,
  [SMALL_STATE(994)] = 31006,
  [SMALL_STATE(995)] = 31046,
  [SMALL_STATE(996)] = 31086,
  [SMALL_STATE(997)] = 31126,
  [SMALL_STATE(998)] = 31166,
  [SMALL_STATE(999)] = 31205,
  [SMALL_STATE(1000)] = 31244,
  [SMALL_STATE(1001)] = 31283,
  [SMALL_STATE(1002)] = 31322,
  [SMALL_STATE(1003)] = 31361,
  [SMALL_STATE(1004)] = 31394,
  [SMALL_STATE(1005)] = 31433,
  [SMALL_STATE(1006)] = 31471,
  [SMALL_STATE(1007)] = 31509,
  [SMALL_STATE(1008)] = 31547,
  [SMALL_STATE(1009)] = 31569,
  [SMALL_STATE(1010)] = 31591,
  [SMALL_STATE(1011)] = 31623,
  [SMALL_STATE(1012)] = 31655,
  [SMALL_STATE(1013)] = 31687,
  [SMALL_STATE(1014)] = 31725,
  [SMALL_STATE(1015)] = 31757,
  [SMALL_STATE(1016)] = 31795,
  [SMALL_STATE(1017)] = 31827,
  [SMALL_STATE(1018)] = 31865,
  [SMALL_STATE(1019)] = 31897,
  [SMALL_STATE(1020)] = 31935,
  [SMALL_STATE(1021)] = 31967,
  [SMALL_STATE(1022)] = 31999,
  [SMALL_STATE(1023)] = 32031,
  [SMALL_STATE(1024)] = 32066,
  [SMALL_STATE(1025)] = 32093,
  [SMALL_STATE(1026)] = 32116,
  [SMALL_STATE(1027)] = 32145,
  [SMALL_STATE(1028)] = 32172,
  [SMALL_STATE(1029)] = 32201,
  [SMALL_STATE(1030)] = 32222,
  [SMALL_STATE(1031)] = 32251,
  [SMALL_STATE(1032)] = 32280,
  [SMALL_STATE(1033)] = 32309,
  [SMALL_STATE(1034)] = 32330,
  [SMALL_STATE(1035)] = 32351,
  [SMALL_STATE(1036)] = 32374,
  [SMALL_STATE(1037)] = 32403,
  [SMALL_STATE(1038)] = 32432,
  [SMALL_STATE(1039)] = 32461,
  [SMALL_STATE(1040)] = 32488,
  [SMALL_STATE(1041)] = 32511,
  [SMALL_STATE(1042)] = 32540,
  [SMALL_STATE(1043)] = 32569,
  [SMALL_STATE(1044)] = 32598,
  [SMALL_STATE(1045)] = 32625,
  [SMALL_STATE(1046)] = 32646,
  [SMALL_STATE(1047)] = 32675,
  [SMALL_STATE(1048)] = 32704,
  [SMALL_STATE(1049)] = 32739,
  [SMALL_STATE(1050)] = 32768,
  [SMALL_STATE(1051)] = 32803,
  [SMALL_STATE(1052)] = 32832,
  [SMALL_STATE(1053)] = 32861,
  [SMALL_STATE(1054)] = 32890,
  [SMALL_STATE(1055)] = 32911,
  [SMALL_STATE(1056)] = 32934,
  [SMALL_STATE(1057)] = 32966,
  [SMALL_STATE(1058)] = 32998,
  [SMALL_STATE(1059)] = 33020,
  [SMALL_STATE(1060)] = 33046,
  [SMALL_STATE(1061)] = 33078,
  [SMALL_STATE(1062)] = 33110,
  [SMALL_STATE(1063)] = 33128,
  [SMALL_STATE(1064)] = 33154,
  [SMALL_STATE(1065)] = 33172,
  [SMALL_STATE(1066)] = 33190,
  [SMALL_STATE(1067)] = 33216,
  [SMALL_STATE(1068)] = 33242,
  [SMALL_STATE(1069)] = 33257,
  [SMALL_STATE(1070)] = 33272,
  [SMALL_STATE(1071)] = 33287,
  [SMALL_STATE(1072)] = 33302,
  [SMALL_STATE(1073)] = 33331,
  [SMALL_STATE(1074)] = 33356,
  [SMALL_STATE(1075)] = 33385,
  [SMALL_STATE(1076)] = 33406,
  [SMALL_STATE(1077)] = 33421,
  [SMALL_STATE(1078)] = 33436,
  [SMALL_STATE(1079)] = 33451,
  [SMALL_STATE(1080)] = 33466,
  [SMALL_STATE(1081)] = 33487,
  [SMALL_STATE(1082)] = 33502,
  [SMALL_STATE(1083)] = 33517,
  [SMALL_STATE(1084)] = 33532,
  [SMALL_STATE(1085)] = 33553,
  [SMALL_STATE(1086)] = 33574,
  [SMALL_STATE(1087)] = 33603,
  [SMALL_STATE(1088)] = 33632,
  [SMALL_STATE(1089)] = 33647,
  [SMALL_STATE(1090)] = 33672,
  [SMALL_STATE(1091)] = 33687,
  [SMALL_STATE(1092)] = 33702,
  [SMALL_STATE(1093)] = 33717,
  [SMALL_STATE(1094)] = 33746,
  [SMALL_STATE(1095)] = 33775,
  [SMALL_STATE(1096)] = 33804,
  [SMALL_STATE(1097)] = 33825,
  [SMALL_STATE(1098)] = 33850,
  [SMALL_STATE(1099)] = 33865,
  [SMALL_STATE(1100)] = 33894,
  [SMALL_STATE(1101)] = 33919,
  [SMALL_STATE(1102)] = 33934,
  [SMALL_STATE(1103)] = 33949,
  [SMALL_STATE(1104)] = 33964,
  [SMALL_STATE(1105)] = 33981,
  [SMALL_STATE(1106)] = 33996,
  [SMALL_STATE(1107)] = 34023,
  [SMALL_STATE(1108)] = 34038,
  [SMALL_STATE(1109)] = 34053,
  [SMALL_STATE(1110)] = 34078,
  [SMALL_STATE(1111)] = 34098,
  [SMALL_STATE(1112)] = 34124,
  [SMALL_STATE(1113)] = 34140,
  [SMALL_STATE(1114)] = 34156,
  [SMALL_STATE(1115)] = 34182,
  [SMALL_STATE(1116)] = 34198,
  [SMALL_STATE(1117)] = 34214,
  [SMALL_STATE(1118)] = 34230,
  [SMALL_STATE(1119)] = 34254,
  [SMALL_STATE(1120)] = 34280,
  [SMALL_STATE(1121)] = 34304,
  [SMALL_STATE(1122)] = 34330,
  [SMALL_STATE(1123)] = 34346,
  [SMALL_STATE(1124)] = 34369,
  [SMALL_STATE(1125)] = 34384,
  [SMALL_STATE(1126)] = 34399,
  [SMALL_STATE(1127)] = 34414,
  [SMALL_STATE(1128)] = 34437,
  [SMALL_STATE(1129)] = 34452,
  [SMALL_STATE(1130)] = 34467,
  [SMALL_STATE(1131)] = 34490,
  [SMALL_STATE(1132)] = 34505,
  [SMALL_STATE(1133)] = 34520,
  [SMALL_STATE(1134)] = 34535,
  [SMALL_STATE(1135)] = 34549,
  [SMALL_STATE(1136)] = 34563,
  [SMALL_STATE(1137)] = 34577,
  [SMALL_STATE(1138)] = 34591,
  [SMALL_STATE(1139)] = 34605,
  [SMALL_STATE(1140)] = 34623,
  [SMALL_STATE(1141)] = 34637,
  [SMALL_STATE(1142)] = 34651,
  [SMALL_STATE(1143)] = 34665,
  [SMALL_STATE(1144)] = 34683,
  [SMALL_STATE(1145)] = 34702,
  [SMALL_STATE(1146)] = 34719,
  [SMALL_STATE(1147)] = 34738,
  [SMALL_STATE(1148)] = 34757,
  [SMALL_STATE(1149)] = 34774,
  [SMALL_STATE(1150)] = 34791,
  [SMALL_STATE(1151)] = 34810,
  [SMALL_STATE(1152)] = 34829,
  [SMALL_STATE(1153)] = 34846,
  [SMALL_STATE(1154)] = 34865,
  [SMALL_STATE(1155)] = 34884,
  [SMALL_STATE(1156)] = 34894,
  [SMALL_STATE(1157)] = 34910,
  [SMALL_STATE(1158)] = 34920,
  [SMALL_STATE(1159)] = 34936,
  [SMALL_STATE(1160)] = 34952,
  [SMALL_STATE(1161)] = 34962,
  [SMALL_STATE(1162)] = 34972,
  [SMALL_STATE(1163)] = 34982,
  [SMALL_STATE(1164)] = 34992,
  [SMALL_STATE(1165)] = 35008,
  [SMALL_STATE(1166)] = 35024,
  [SMALL_STATE(1167)] = 35040,
  [SMALL_STATE(1168)] = 35056,
  [SMALL_STATE(1169)] = 35066,
  [SMALL_STATE(1170)] = 35076,
  [SMALL_STATE(1171)] = 35092,
  [SMALL_STATE(1172)] = 35108,
  [SMALL_STATE(1173)] = 35118,
  [SMALL_STATE(1174)] = 35134,
  [SMALL_STATE(1175)] = 35144,
  [SMALL_STATE(1176)] = 35160,
  [SMALL_STATE(1177)] = 35170,
  [SMALL_STATE(1178)] = 35180,
  [SMALL_STATE(1179)] = 35196,
  [SMALL_STATE(1180)] = 35212,
  [SMALL_STATE(1181)] = 35228,
  [SMALL_STATE(1182)] = 35242,
  [SMALL_STATE(1183)] = 35258,
  [SMALL_STATE(1184)] = 35274,
  [SMALL_STATE(1185)] = 35290,
  [SMALL_STATE(1186)] = 35306,
  [SMALL_STATE(1187)] = 35320,
  [SMALL_STATE(1188)] = 35336,
  [SMALL_STATE(1189)] = 35352,
  [SMALL_STATE(1190)] = 35368,
  [SMALL_STATE(1191)] = 35381,
  [SMALL_STATE(1192)] = 35394,
  [SMALL_STATE(1193)] = 35407,
  [SMALL_STATE(1194)] = 35420,
  [SMALL_STATE(1195)] = 35433,
  [SMALL_STATE(1196)] = 35446,
  [SMALL_STATE(1197)] = 35459,
  [SMALL_STATE(1198)] = 35472,
  [SMALL_STATE(1199)] = 35485,
  [SMALL_STATE(1200)] = 35498,
  [SMALL_STATE(1201)] = 35511,
  [SMALL_STATE(1202)] = 35524,
  [SMALL_STATE(1203)] = 35537,
  [SMALL_STATE(1204)] = 35550,
  [SMALL_STATE(1205)] = 35563,
  [SMALL_STATE(1206)] = 35574,
  [SMALL_STATE(1207)] = 35587,
  [SMALL_STATE(1208)] = 35600,
  [SMALL_STATE(1209)] = 35613,
  [SMALL_STATE(1210)] = 35626,
  [SMALL_STATE(1211)] = 35639,
  [SMALL_STATE(1212)] = 35652,
  [SMALL_STATE(1213)] = 35665,
  [SMALL_STATE(1214)] = 35678,
  [SMALL_STATE(1215)] = 35691,
  [SMALL_STATE(1216)] = 35704,
  [SMALL_STATE(1217)] = 35717,
  [SMALL_STATE(1218)] = 35730,
  [SMALL_STATE(1219)] = 35743,
  [SMALL_STATE(1220)] = 35756,
  [SMALL_STATE(1221)] = 35769,
  [SMALL_STATE(1222)] = 35782,
  [SMALL_STATE(1223)] = 35795,
  [SMALL_STATE(1224)] = 35808,
  [SMALL_STATE(1225)] = 35821,
  [SMALL_STATE(1226)] = 35830,
  [SMALL_STATE(1227)] = 35843,
  [SMALL_STATE(1228)] = 35856,
  [SMALL_STATE(1229)] = 35869,
  [SMALL_STATE(1230)] = 35882,
  [SMALL_STATE(1231)] = 35895,
  [SMALL_STATE(1232)] = 35908,
  [SMALL_STATE(1233)] = 35921,
  [SMALL_STATE(1234)] = 35934,
  [SMALL_STATE(1235)] = 35947,
  [SMALL_STATE(1236)] = 35960,
  [SMALL_STATE(1237)] = 35973,
  [SMALL_STATE(1238)] = 35986,
  [SMALL_STATE(1239)] = 35999,
  [SMALL_STATE(1240)] = 36012,
  [SMALL_STATE(1241)] = 36025,
  [SMALL_STATE(1242)] = 36038,
  [SMALL_STATE(1243)] = 36051,
  [SMALL_STATE(1244)] = 36064,
  [SMALL_STATE(1245)] = 36077,
  [SMALL_STATE(1246)] = 36090,
  [SMALL_STATE(1247)] = 36103,
  [SMALL_STATE(1248)] = 36116,
  [SMALL_STATE(1249)] = 36129,
  [SMALL_STATE(1250)] = 36142,
  [SMALL_STATE(1251)] = 36155,
  [SMALL_STATE(1252)] = 36168,
  [SMALL_STATE(1253)] = 36181,
  [SMALL_STATE(1254)] = 36190,
  [SMALL_STATE(1255)] = 36203,
  [SMALL_STATE(1256)] = 36214,
  [SMALL_STATE(1257)] = 36227,
  [SMALL_STATE(1258)] = 36235,
  [SMALL_STATE(1259)] = 36243,
  [SMALL_STATE(1260)] = 36251,
  [SMALL_STATE(1261)] = 36259,
  [SMALL_STATE(1262)] = 36269,
  [SMALL_STATE(1263)] = 36277,
  [SMALL_STATE(1264)] = 36287,
  [SMALL_STATE(1265)] = 36295,
  [SMALL_STATE(1266)] = 36303,
  [SMALL_STATE(1267)] = 36311,
  [SMALL_STATE(1268)] = 36319,
  [SMALL_STATE(1269)] = 36329,
  [SMALL_STATE(1270)] = 36339,
  [SMALL_STATE(1271)] = 36347,
  [SMALL_STATE(1272)] = 36357,
  [SMALL_STATE(1273)] = 36367,
  [SMALL_STATE(1274)] = 36377,
  [SMALL_STATE(1275)] = 36387,
  [SMALL_STATE(1276)] = 36397,
  [SMALL_STATE(1277)] = 36407,
  [SMALL_STATE(1278)] = 36417,
  [SMALL_STATE(1279)] = 36427,
  [SMALL_STATE(1280)] = 36437,
  [SMALL_STATE(1281)] = 36447,
  [SMALL_STATE(1282)] = 36457,
  [SMALL_STATE(1283)] = 36467,
  [SMALL_STATE(1284)] = 36475,
  [SMALL_STATE(1285)] = 36483,
  [SMALL_STATE(1286)] = 36493,
  [SMALL_STATE(1287)] = 36503,
  [SMALL_STATE(1288)] = 36513,
  [SMALL_STATE(1289)] = 36521,
  [SMALL_STATE(1290)] = 36531,
  [SMALL_STATE(1291)] = 36541,
  [SMALL_STATE(1292)] = 36551,
  [SMALL_STATE(1293)] = 36561,
  [SMALL_STATE(1294)] = 36569,
  [SMALL_STATE(1295)] = 36577,
  [SMALL_STATE(1296)] = 36587,
  [SMALL_STATE(1297)] = 36595,
  [SMALL_STATE(1298)] = 36605,
  [SMALL_STATE(1299)] = 36615,
  [SMALL_STATE(1300)] = 36625,
  [SMALL_STATE(1301)] = 36635,
  [SMALL_STATE(1302)] = 36645,
  [SMALL_STATE(1303)] = 36653,
  [SMALL_STATE(1304)] = 36663,
  [SMALL_STATE(1305)] = 36673,
  [SMALL_STATE(1306)] = 36683,
  [SMALL_STATE(1307)] = 36693,
  [SMALL_STATE(1308)] = 36703,
  [SMALL_STATE(1309)] = 36711,
  [SMALL_STATE(1310)] = 36721,
  [SMALL_STATE(1311)] = 36731,
  [SMALL_STATE(1312)] = 36741,
  [SMALL_STATE(1313)] = 36751,
  [SMALL_STATE(1314)] = 36759,
  [SMALL_STATE(1315)] = 36769,
  [SMALL_STATE(1316)] = 36779,
  [SMALL_STATE(1317)] = 36789,
  [SMALL_STATE(1318)] = 36799,
  [SMALL_STATE(1319)] = 36809,
  [SMALL_STATE(1320)] = 36816,
  [SMALL_STATE(1321)] = 36823,
  [SMALL_STATE(1322)] = 36830,
  [SMALL_STATE(1323)] = 36837,
  [SMALL_STATE(1324)] = 36844,
  [SMALL_STATE(1325)] = 36851,
  [SMALL_STATE(1326)] = 36858,
  [SMALL_STATE(1327)] = 36865,
  [SMALL_STATE(1328)] = 36872,
  [SMALL_STATE(1329)] = 36879,
  [SMALL_STATE(1330)] = 36886,
  [SMALL_STATE(1331)] = 36893,
  [SMALL_STATE(1332)] = 36900,
  [SMALL_STATE(1333)] = 36907,
  [SMALL_STATE(1334)] = 36914,
  [SMALL_STATE(1335)] = 36921,
  [SMALL_STATE(1336)] = 36928,
  [SMALL_STATE(1337)] = 36935,
  [SMALL_STATE(1338)] = 36942,
  [SMALL_STATE(1339)] = 36949,
  [SMALL_STATE(1340)] = 36956,
  [SMALL_STATE(1341)] = 36963,
  [SMALL_STATE(1342)] = 36970,
  [SMALL_STATE(1343)] = 36977,
  [SMALL_STATE(1344)] = 36984,
  [SMALL_STATE(1345)] = 36991,
  [SMALL_STATE(1346)] = 36998,
  [SMALL_STATE(1347)] = 37005,
  [SMALL_STATE(1348)] = 37012,
  [SMALL_STATE(1349)] = 37019,
  [SMALL_STATE(1350)] = 37026,
  [SMALL_STATE(1351)] = 37033,
  [SMALL_STATE(1352)] = 37040,
  [SMALL_STATE(1353)] = 37047,
  [SMALL_STATE(1354)] = 37054,
  [SMALL_STATE(1355)] = 37061,
  [SMALL_STATE(1356)] = 37068,
  [SMALL_STATE(1357)] = 37075,
  [SMALL_STATE(1358)] = 37082,
  [SMALL_STATE(1359)] = 37089,
  [SMALL_STATE(1360)] = 37096,
  [SMALL_STATE(1361)] = 37103,
  [SMALL_STATE(1362)] = 37110,
  [SMALL_STATE(1363)] = 37117,
  [SMALL_STATE(1364)] = 37124,
  [SMALL_STATE(1365)] = 37131,
  [SMALL_STATE(1366)] = 37138,
  [SMALL_STATE(1367)] = 37145,
  [SMALL_STATE(1368)] = 37152,
  [SMALL_STATE(1369)] = 37159,
  [SMALL_STATE(1370)] = 37166,
  [SMALL_STATE(1371)] = 37173,
  [SMALL_STATE(1372)] = 37180,
  [SMALL_STATE(1373)] = 37187,
  [SMALL_STATE(1374)] = 37194,
  [SMALL_STATE(1375)] = 37201,
  [SMALL_STATE(1376)] = 37208,
  [SMALL_STATE(1377)] = 37215,
  [SMALL_STATE(1378)] = 37222,
  [SMALL_STATE(1379)] = 37229,
  [SMALL_STATE(1380)] = 37236,
  [SMALL_STATE(1381)] = 37243,
  [SMALL_STATE(1382)] = 37250,
  [SMALL_STATE(1383)] = 37257,
  [SMALL_STATE(1384)] = 37264,
  [SMALL_STATE(1385)] = 37271,
  [SMALL_STATE(1386)] = 37278,
  [SMALL_STATE(1387)] = 37285,
  [SMALL_STATE(1388)] = 37292,
  [SMALL_STATE(1389)] = 37299,
  [SMALL_STATE(1390)] = 37306,
  [SMALL_STATE(1391)] = 37313,
  [SMALL_STATE(1392)] = 37320,
  [SMALL_STATE(1393)] = 37327,
  [SMALL_STATE(1394)] = 37334,
  [SMALL_STATE(1395)] = 37341,
  [SMALL_STATE(1396)] = 37348,
  [SMALL_STATE(1397)] = 37355,
  [SMALL_STATE(1398)] = 37362,
  [SMALL_STATE(1399)] = 37369,
  [SMALL_STATE(1400)] = 37376,
  [SMALL_STATE(1401)] = 37383,
  [SMALL_STATE(1402)] = 37390,
  [SMALL_STATE(1403)] = 37397,
  [SMALL_STATE(1404)] = 37404,
  [SMALL_STATE(1405)] = 37411,
  [SMALL_STATE(1406)] = 37418,
  [SMALL_STATE(1407)] = 37425,
  [SMALL_STATE(1408)] = 37432,
  [SMALL_STATE(1409)] = 37439,
  [SMALL_STATE(1410)] = 37446,
  [SMALL_STATE(1411)] = 37453,
  [SMALL_STATE(1412)] = 37460,
  [SMALL_STATE(1413)] = 37467,
  [SMALL_STATE(1414)] = 37474,
  [SMALL_STATE(1415)] = 37481,
  [SMALL_STATE(1416)] = 37488,
  [SMALL_STATE(1417)] = 37495,
  [SMALL_STATE(1418)] = 37502,
  [SMALL_STATE(1419)] = 37509,
  [SMALL_STATE(1420)] = 37516,
  [SMALL_STATE(1421)] = 37523,
  [SMALL_STATE(1422)] = 37530,
  [SMALL_STATE(1423)] = 37537,
  [SMALL_STATE(1424)] = 37544,
  [SMALL_STATE(1425)] = 37551,
  [SMALL_STATE(1426)] = 37558,
  [SMALL_STATE(1427)] = 37565,
  [SMALL_STATE(1428)] = 37572,
  [SMALL_STATE(1429)] = 37579,
  [SMALL_STATE(1430)] = 37586,
  [SMALL_STATE(1431)] = 37593,
  [SMALL_STATE(1432)] = 37600,
  [SMALL_STATE(1433)] = 37607,
  [SMALL_STATE(1434)] = 37614,
  [SMALL_STATE(1435)] = 37621,
  [SMALL_STATE(1436)] = 37628,
  [SMALL_STATE(1437)] = 37635,
  [SMALL_STATE(1438)] = 37642,
  [SMALL_STATE(1439)] = 37649,
  [SMALL_STATE(1440)] = 37656,
  [SMALL_STATE(1441)] = 37663,
  [SMALL_STATE(1442)] = 37670,
  [SMALL_STATE(1443)] = 37677,
  [SMALL_STATE(1444)] = 37684,
  [SMALL_STATE(1445)] = 37691,
  [SMALL_STATE(1446)] = 37698,
  [SMALL_STATE(1447)] = 37705,
  [SMALL_STATE(1448)] = 37712,
  [SMALL_STATE(1449)] = 37719,
  [SMALL_STATE(1450)] = 37726,
  [SMALL_STATE(1451)] = 37733,
  [SMALL_STATE(1452)] = 37740,
  [SMALL_STATE(1453)] = 37747,
  [SMALL_STATE(1454)] = 37754,
  [SMALL_STATE(1455)] = 37761,
  [SMALL_STATE(1456)] = 37768,
  [SMALL_STATE(1457)] = 37775,
  [SMALL_STATE(1458)] = 37782,
  [SMALL_STATE(1459)] = 37789,
  [SMALL_STATE(1460)] = 37796,
  [SMALL_STATE(1461)] = 37803,
  [SMALL_STATE(1462)] = 37810,
  [SMALL_STATE(1463)] = 37817,
  [SMALL_STATE(1464)] = 37824,
  [SMALL_STATE(1465)] = 37831,
  [SMALL_STATE(1466)] = 37838,
  [SMALL_STATE(1467)] = 37845,
  [SMALL_STATE(1468)] = 37852,
  [SMALL_STATE(1469)] = 37859,
  [SMALL_STATE(1470)] = 37866,
  [SMALL_STATE(1471)] = 37873,
  [SMALL_STATE(1472)] = 37880,
  [SMALL_STATE(1473)] = 37887,
  [SMALL_STATE(1474)] = 37894,
  [SMALL_STATE(1475)] = 37901,
  [SMALL_STATE(1476)] = 37908,
  [SMALL_STATE(1477)] = 37915,
  [SMALL_STATE(1478)] = 37922,
  [SMALL_STATE(1479)] = 37929,
  [SMALL_STATE(1480)] = 37936,
  [SMALL_STATE(1481)] = 37943,
  [SMALL_STATE(1482)] = 37950,
  [SMALL_STATE(1483)] = 37957,
  [SMALL_STATE(1484)] = 37964,
  [SMALL_STATE(1485)] = 37971,
  [SMALL_STATE(1486)] = 37978,
  [SMALL_STATE(1487)] = 37985,
  [SMALL_STATE(1488)] = 37992,
  [SMALL_STATE(1489)] = 37999,
  [SMALL_STATE(1490)] = 38006,
  [SMALL_STATE(1491)] = 38013,
  [SMALL_STATE(1492)] = 38020,
  [SMALL_STATE(1493)] = 38027,
  [SMALL_STATE(1494)] = 38034,
  [SMALL_STATE(1495)] = 38041,
  [SMALL_STATE(1496)] = 38048,
  [SMALL_STATE(1497)] = 38055,
  [SMALL_STATE(1498)] = 38062,
  [SMALL_STATE(1499)] = 38069,
  [SMALL_STATE(1500)] = 38076,
  [SMALL_STATE(1501)] = 38083,
  [SMALL_STATE(1502)] = 38090,
  [SMALL_STATE(1503)] = 38097,
  [SMALL_STATE(1504)] = 38104,
  [SMALL_STATE(1505)] = 38111,
  [SMALL_STATE(1506)] = 38118,
  [SMALL_STATE(1507)] = 38125,
  [SMALL_STATE(1508)] = 38132,
  [SMALL_STATE(1509)] = 38139,
  [SMALL_STATE(1510)] = 38146,
  [SMALL_STATE(1511)] = 38153,
  [SMALL_STATE(1512)] = 38160,
  [SMALL_STATE(1513)] = 38167,
  [SMALL_STATE(1514)] = 38174,
  [SMALL_STATE(1515)] = 38181,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, .production_id = 35),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, .production_id = 35),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(500),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1084),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1421),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(912),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1422),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1316),
  [203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(327),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(722),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(722),
  [212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(721),
  [215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(96),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(518),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(367),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(364),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(351),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(381),
  [233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1508),
  [236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1309),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1503),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(505),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(38),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(345),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(346),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(508),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(728),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(729),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(732),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1254),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1153),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1147),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1311),
  [278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1307),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(695),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1429),
  [287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1306),
  [290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(466),
  [293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1513),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(576),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1425),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1424),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1428),
  [308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(641),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(640),
  [314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(638),
  [317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1302),
  [320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1183),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(638),
  [326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2),
  [328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(503),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1085),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1514),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(911),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1511),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1310),
  [346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(221),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(519),
  [352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(384),
  [355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(27),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1268),
  [361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1282),
  [364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(676),
  [367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1492),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1299),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(486),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1485),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(589),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1483),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1480),
  [388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1479),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(496),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1080),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1471),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(907),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1451),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1312),
  [455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(140),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(517),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(378),
  [464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(34),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1274),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1290),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(619),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1361),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1276),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(492),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1515),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(591),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1360),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1356),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1455),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(497),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1096),
  [556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1357),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(926),
  [562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1358),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1285),
  [568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(178),
  [571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(513),
  [574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(394),
  [577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(40),
  [580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1314),
  [583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1269),
  [586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(699),
  [589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1505),
  [592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1261),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(431),
  [598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1510),
  [601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(588),
  [604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1501),
  [607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1500),
  [610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2), SHIFT_REPEAT(1364),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2),
  [643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(498),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(327),
  [651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(722),
  [654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(722),
  [657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(721),
  [660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(96),
  [663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(518),
  [666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(367),
  [669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(364),
  [672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(351),
  [675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(345),
  [678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1508),
  [681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1309),
  [684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1503),
  [687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(38),
  [690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(346),
  [693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(508),
  [696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(728),
  [699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(729),
  [702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(732),
  [705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1254),
  [708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1153),
  [711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1147),
  [714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1311),
  [717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1307),
  [720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1306),
  [723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(466),
  [726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1513),
  [729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(576),
  [732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1425),
  [735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1424),
  [738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1428),
  [741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(641),
  [744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(640),
  [747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(638),
  [750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1302),
  [753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1183),
  [756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(638),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, .production_id = 8),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, .production_id = 8),
  [763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(501),
  [772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(221),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(519),
  [778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(27),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1268),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1282),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1299),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(486),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1485),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(589),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1483),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1480),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1479),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(502),
  [815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(140),
  [818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(517),
  [821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(34),
  [824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1274),
  [827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1290),
  [830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1276),
  [833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(492),
  [836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1515),
  [839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(591),
  [842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1360),
  [845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1356),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1455),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, .production_id = 8),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, .production_id = 8),
  [859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(499),
  [862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(178),
  [865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(513),
  [868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(40),
  [871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1314),
  [874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1269),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1261),
  [880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(431),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1510),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(588),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1501),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1500),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1364),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 76),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 76),
  [914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 79),
  [928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 79),
  [930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 78),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 78),
  [934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 77),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 77),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 75),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 75),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 71),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 71),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 70),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 70),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, .production_id = 69),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, .production_id = 69),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 22),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 22),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 23),
  [974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 23),
  [976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 84),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 84),
  [980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 62),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 62),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 61),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 61),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 80),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 80),
  [996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 23),
  [998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 23),
  [1000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, .production_id = 24),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, .production_id = 24),
  [1008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 26),
  [1010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 26),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, .production_id = 28),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, .production_id = 28),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 59),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 59),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, .production_id = 58),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, .production_id = 58),
  [1024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [1028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 81),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 81),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 82),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 82),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, .production_id = 49),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, .production_id = 49),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, .production_id = 40),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, .production_id = 40),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 83),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 83),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 35),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 35),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, .production_id = 13),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, .production_id = 13),
  [1056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, .production_id = 35),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, .production_id = 35),
  [1060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 36),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 36),
  [1064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 14),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, .production_id = 14),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [1072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, .production_id = 34),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, .production_id = 34),
  [1076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, .production_id = 3),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, .production_id = 3),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, .production_id = 18),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, .production_id = 18),
  [1084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 51),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 51),
  [1088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, .production_id = 53),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, .production_id = 53),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, .production_id = 54),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, .production_id = 54),
  [1096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, .production_id = 15),
  [1098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, .production_id = 15),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 55),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, .production_id = 55),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 14),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, .production_id = 14),
  [1108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, .production_id = 33),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, .production_id = 33),
  [1112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, .production_id = 29),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, .production_id = 29),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, .production_id = 14),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, .production_id = 14),
  [1124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, .production_id = 66),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, .production_id = 66),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2),
  [1130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [1138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3),
  [1140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3),
  [1142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4),
  [1144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [1158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [1160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [1170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [1176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [1184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [1186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, .production_id = 35),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 35),
  [1202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1), REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1),
  [1211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1), REDUCE(aux_sym_attributed_declarator_repeat1, 1),
  [1214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(736),
  [1217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1472),
  [1220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(917),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [1225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1392),
  [1228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1315),
  [1231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(367),
  [1234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(364),
  [1237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(351),
  [1240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(345),
  [1243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1508),
  [1246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1304),
  [1249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1503),
  [1252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(346),
  [1255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(508),
  [1258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(728),
  [1261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(729),
  [1264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(732),
  [1267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1254),
  [1270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1153),
  [1273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1147),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2),
  [1292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1),
  [1298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1450),
  [1301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(908),
  [1304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1426),
  [1307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1272),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1473),
  [1317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(931),
  [1320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1437),
  [1323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1318),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [1358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2),
  [1364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(367),
  [1367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(364),
  [1370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(351),
  [1373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(345),
  [1376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(1508),
  [1379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(1304),
  [1382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(1503),
  [1385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2), SHIFT_REPEAT(346),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 37),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 37),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, .production_id = 49),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, .production_id = 49),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, .production_id = 44),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, .production_id = 44),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_qualifier, 1),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_qualifier, 1),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 14),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 14),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 14),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, .production_id = 14),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 35),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, .production_id = 35),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 28),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 28),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 36),
  [1454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, .production_id = 36),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 28),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 28),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_address_space_qualifier, 1),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_address_space_qualifier, 1),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 49),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 49),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 66),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, .production_id = 66),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_qualifier, 1),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_qualifier, 1),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 54),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 54),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 35),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, .production_id = 35),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 55),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, .production_id = 55),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 37),
  [1490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 37),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(749),
  [1523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(327),
  [1526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(722),
  [1529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(722),
  [1532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(721),
  [1535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(140),
  [1538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1271),
  [1541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(34),
  [1544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1274),
  [1547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1290),
  [1550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(619),
  [1553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1361),
  [1556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1276),
  [1559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(492),
  [1562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1515),
  [1565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(591),
  [1568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1360),
  [1571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1356),
  [1574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1455),
  [1577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(641),
  [1580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(640),
  [1583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(638),
  [1586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1302),
  [1589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1183),
  [1592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(638),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [1599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(752),
  [1602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(96),
  [1605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(38),
  [1608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1311),
  [1611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1307),
  [1614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(695),
  [1617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1429),
  [1620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1306),
  [1623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(466),
  [1626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1513),
  [1629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(576),
  [1632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1425),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1424),
  [1638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1428),
  [1641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(748),
  [1644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(178),
  [1647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(40),
  [1650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1314),
  [1653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1269),
  [1656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(699),
  [1659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1505),
  [1662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1261),
  [1665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(431),
  [1668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1510),
  [1671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(588),
  [1674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1501),
  [1677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1500),
  [1680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1364),
  [1683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(753),
  [1686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(221),
  [1689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(27),
  [1692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1268),
  [1695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1282),
  [1698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(676),
  [1701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1492),
  [1704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1299),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(486),
  [1710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1485),
  [1713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(589),
  [1716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1483),
  [1719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1480),
  [1722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT(1479),
  [1725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [1727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1729] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression, 1), SHIFT(510),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression, 1),
  [1738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression, 1),
  [1741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [1775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1), SHIFT(724),
  [1778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1),
  [1780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [1786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2),
  [1788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(509),
  [1791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [1801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [1803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2),
  [1805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(536),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [1818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 11),
  [1820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 11),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [1838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 11),
  [1840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, .production_id = 11),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [1862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 2),
  [1864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, .production_id = 2),
  [1866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 2),
  [1868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, .production_id = 2),
  [1870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1183),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1983] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), REDUCE(sym__expression, 1), SHIFT(511),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 20),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 20),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 6),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 6),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5),
  [2017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 20),
  [2019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 20),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2),
  [2025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2),
  [2027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 4),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 4),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 32),
  [2043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 32),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 9),
  [2047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 9),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4),
  [2051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4),
  [2053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 25),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 25),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 52),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 52),
  [2069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [2071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [2073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, .production_id = 6),
  [2075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, .production_id = 6),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 39),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, .production_id = 39),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [2093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [2095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 65),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 65),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, .production_id = 8),
  [2113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, .production_id = 8),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, .production_id = 6),
  [2117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, .production_id = 6),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 39),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 39),
  [2123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 25),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 25),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, .production_id = 4),
  [2135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, .production_id = 4),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3),
  [2143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [2147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 12),
  [2151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .dynamic_precedence = -1, .production_id = 12),
  [2153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4),
  [2155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4),
  [2157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, .production_id = 7),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, .production_id = 7),
  [2161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, .production_id = 19),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, .production_id = 19),
  [2165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scalar_type, 1),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scalar_type, 1),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_specifier, 1),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_specifier, 1),
  [2173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [2175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [2177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2),
  [2179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_other_builtin_type, 1),
  [2183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_other_builtin_type, 1),
  [2185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, .production_id = 43),
  [2187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, .production_id = 43),
  [2189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, .production_id = 7),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, .production_id = 7),
  [2193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, .production_id = 43),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, .production_id = 43),
  [2197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(510),
  [2200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, .production_id = 7),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, .production_id = 7),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3),
  [2208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 19),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 19),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 21),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 21),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1, .production_id = 45),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_type_specifier, 4, .dynamic_precedence = -1, .production_id = 45),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, .production_id = 19),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, .production_id = 19),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, .production_id = 21),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, .production_id = 21),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 5),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 5),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 11),
  [2238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, .production_id = 11),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1),
  [2269] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(510),
  [2273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1), REDUCE(sym__type_specifier, 1, .production_id = 1),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, .dynamic_precedence = 1),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2), SHIFT_REPEAT(781),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [2321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [2323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2), SHIFT_REPEAT(792),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, .production_id = 31),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, .production_id = 60),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, .production_id = 48),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, .production_id = 74),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1),
  [2522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [2590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4),
  [2592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4),
  [2594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 37),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2),
  [2602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2),
  [2604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [2606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 25),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 25),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 10),
  [2630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, .production_id = 10),
  [2632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2),
  [2634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2),
  [2636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 4),
  [2638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 4),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4),
  [2672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3),
  [2688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 11),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 2),
  [2744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, .production_id = 2),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 11),
  [2748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [2750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2),
  [2752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(1008),
  [2755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2), SHIFT_REPEAT(1009),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [2766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [2796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, .dynamic_precedence = 1, .production_id = 63),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 2),
  [2800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 2), SHIFT_REPEAT(1508),
  [2803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2),
  [2805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 27),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2),
  [2811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2), SHIFT_REPEAT(1309),
  [2814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2),
  [2816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, .dynamic_precedence = 1, .production_id = 72),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 3, .production_id = 30),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [2822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 3, .production_id = 30),
  [2824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 46),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, .production_id = 30),
  [2834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, .production_id = 30),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2),
  [2838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2),
  [2840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, .dynamic_precedence = 1, .production_id = 27),
  [2842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [2844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4),
  [2846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, .dynamic_precedence = 1, .production_id = 46),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [2850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2),
  [2852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [2854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3),
  [2856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, .dynamic_precedence = 1, .production_id = 63),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, .dynamic_precedence = 1, .production_id = 72),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [2866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 27),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2),
  [2872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, .dynamic_precedence = 1, .production_id = 63),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [2904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, .dynamic_precedence = 1, .production_id = 46),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, .dynamic_precedence = 1, .production_id = 27),
  [2910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_specifier, 1, .production_id = 1), SHIFT(511),
  [2913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 27),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, .dynamic_precedence = 1, .production_id = 72),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2),
  [2919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 64),
  [2923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, .production_id = 64),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, .production_id = 47),
  [2927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, .production_id = 47),
  [2929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, .production_id = 47),
  [2931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, .production_id = 47),
  [2933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, .production_id = 73),
  [2935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, .production_id = 73),
  [2937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1),
  [2939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1),
  [2941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat2, 2, .production_id = 27),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 28),
  [2945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, .dynamic_precedence = -10),
  [2947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, .dynamic_precedence = -10),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, .dynamic_precedence = -10),
  [2953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, .dynamic_precedence = -10),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, .production_id = 42),
  [2957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, .production_id = 42),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, .production_id = 30),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, .production_id = 30),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [2965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 47),
  [2967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, .production_id = 47),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, .production_id = 64),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, .production_id = 64),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, .production_id = 73),
  [2981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, .production_id = 73),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, .production_id = 47),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, .production_id = 47),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1),
  [2989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, .production_id = 73),
  [2993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, .production_id = 73),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 47),
  [2997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, .production_id = 47),
  [2999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, .production_id = 47),
  [3001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, .production_id = 47),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, .production_id = 64),
  [3005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, .production_id = 64),
  [3007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(645),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2),
  [3012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2), SHIFT_REPEAT(1435),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, .production_id = 1),
  [3017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, .production_id = 1),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, .dynamic_precedence = -10),
  [3021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, .dynamic_precedence = -10),
  [3023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, .production_id = 30),
  [3025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, .production_id = 30),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [3031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [3033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, .production_id = 5),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [3039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, .dynamic_precedence = 1, .production_id = 27),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, .dynamic_precedence = 1, .production_id = 46),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [3055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 64),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, .production_id = 57),
  [3059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, .production_id = 30),
  [3061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 38),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, .production_id = 16),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 47),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, .production_id = 17),
  [3071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, .production_id = 73),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [3081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1165),
  [3084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1165),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, .production_id = 40),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, .production_id = 56),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 67),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, .production_id = 47),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [3123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [3135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 41),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [3149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [3153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [3159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 50), SHIFT_REPEAT(1037),
  [3162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 50),
  [3164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [3166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [3168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [3174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(679),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [3207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, .production_id = 5),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, .production_id = 68),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [3259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(336),
  [3262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [3266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2), SHIFT_REPEAT(1295),
  [3269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [3275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2), SHIFT_REPEAT(1305),
  [3278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [3284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2), SHIFT_REPEAT(1257),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [3297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [3299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2), SHIFT_REPEAT(949),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [3310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat2, 2, .production_id = 50), SHIFT_REPEAT(1052),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat2, 2, .production_id = 50),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [3321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 50), SHIFT_REPEAT(1020),
  [3324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, .production_id = 50),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [3328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [3336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2), SHIFT_REPEAT(540),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [3341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [3347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, .production_id = 41),
  [3349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [3357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [3359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [3361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [3363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [3369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [3375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [3377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [3379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [3381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [3383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [3385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [3387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [3389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 5),
  [3393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [3401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2),
  [3403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [3405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [3407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [3409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [3411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 1),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [3415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [3417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [3419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [3421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [3423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [3425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [3439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, .production_id = 54),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, .production_id = 66),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [3509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, .production_id = 54),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, .production_id = 66),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3643] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_opencl(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
